from __future__ import print_function

def order(rk,tol=1.e-13): # pragma: no cover
    from numpy import dot,zeros,all,sum,abs
    coneq = zeros((40000))
    A=rk.A
    b=rk.b
    c=rk.c
    coneq[0]=sum(b)-1.
    if any(abs(coneq)>tol):
        return 0
    # order 2 conditions:
    coneq[0]=dot(b,c)-1/2.
    if any(abs(coneq)>tol):
        return 1
    # order 3 conditions:
    coneq[0]=dot(b,dot(A,c))-1/6.
    coneq[1]=dot(b,c*c)-1/3.
    if any(abs(coneq)>tol):
        return 2
    # order 4 conditions:
    coneq[0]=dot(b,dot(A,c**2))-1/12.
    coneq[1]=dot(b,dot(A,dot(A,c)))-1/24.
    coneq[2]=dot(b,dot(A,c)*c)-1/8.
    coneq[3]=dot(b,c**3)-1/4.
    if any(abs(coneq)>tol):
        return 3
    # order 5 conditions:
    coneq[0]=dot(b,dot(A,c**3))-1/20.
    coneq[1]=dot(b,dot(A,dot(A,c**2)))-1/60.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c))))-1/120.
    coneq[3]=dot(b,dot(A,c*dot(A,c)))-1/40.
    coneq[4]=dot(b,dot(A,c**2)*c)-1/15.
    coneq[5]=dot(b,dot(A,dot(A,c))*c)-1/30.
    coneq[6]=dot(b,dot(A,c)*c*c)-1/10.
    coneq[7]=dot(b,dot(A,c)*dot(A,c))-1/20.
    coneq[8]=dot(b,c**4)-1/5.
    if any(abs(coneq)>tol):
        return 4
    # order 6 conditions:
    coneq[0]=dot(b,dot(A,c**4))-1/30.
    coneq[1]=dot(b,dot(A,dot(A,c**3)))-1/120.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**2))))-1/360.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))))-1/720.
    coneq[4]=dot(b,dot(A,dot(A,c*dot(A,c))))-1/240.
    coneq[5]=dot(b,dot(A,c*dot(A,c**2)))-1/90.
    coneq[6]=dot(b,dot(A,c*dot(A,dot(A,c))))-1/180.
    coneq[7]=dot(b,dot(A,c**2*dot(A,c)))-1/60.
    coneq[8]=dot(b,dot(A,dot(A,c)*dot(A,c)))-1/120.
    coneq[9]=dot(b,dot(A,c**3)*c)-1/24.
    coneq[10]=dot(b,dot(A,dot(A,c**2))*c)-1/72.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,c)))*c)-1/144.
    coneq[12]=dot(b,dot(A,c*dot(A,c))*c)-1/48.
    coneq[13]=dot(b,dot(A,c**2)*c*c)-1/18.
    coneq[14]=dot(b,dot(A,dot(A,c))*c*c)-1/36.
    coneq[15]=dot(b,dot(A,c)*c**3)-1/12.
    coneq[16]=dot(b,dot(A,c**2)*dot(A,c))-1/36.
    coneq[17]=dot(b,dot(A,dot(A,c))*dot(A,c))-1/72.
    coneq[18]=dot(b,dot(A,c)*dot(A,c)*c)-1/24.
    coneq[19]=dot(b,c**5)-1/6.
    if any(abs(coneq)>tol):
        return 5
    # order 7 conditions:
    coneq[0]=dot(b,dot(A,c**5))-1/42.
    coneq[1]=dot(b,dot(A,dot(A,c**4)))-1/210.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**3))))-1/840.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))))-1/2520.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/5040.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1680.
    coneq[6]=dot(b,dot(A,dot(A,c*dot(A,c**2))))-1/630.
    coneq[7]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))))-1/1260.
    coneq[8]=dot(b,dot(A,dot(A,c**2*dot(A,c))))-1/420.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))))-1/840.
    coneq[10]=dot(b,dot(A,c*dot(A,c**3)))-1/168.
    coneq[11]=dot(b,dot(A,c*dot(A,dot(A,c**2))))-1/504.
    coneq[12]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1008.
    coneq[13]=dot(b,dot(A,c*dot(A,c*dot(A,c))))-1/336.
    coneq[14]=dot(b,dot(A,c**2*dot(A,c**2)))-1/126.
    coneq[15]=dot(b,dot(A,c**2*dot(A,dot(A,c))))-1/252.
    coneq[16]=dot(b,dot(A,c**3*dot(A,c)))-1/84.
    coneq[17]=dot(b,dot(A,dot(A,c)*dot(A,c**2)))-1/252.
    coneq[18]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))))-1/504.
    coneq[19]=dot(b,dot(A,c*dot(A,c)*dot(A,c)))-1/168.
    coneq[20]=dot(b,dot(A,c**4)*c)-1/35.
    coneq[21]=dot(b,dot(A,dot(A,c**3))*c)-1/140.
    coneq[22]=dot(b,dot(A,dot(A,dot(A,c**2)))*c)-1/420.
    coneq[23]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c)-1/840.
    coneq[24]=dot(b,dot(A,dot(A,c*dot(A,c)))*c)-1/280.
    coneq[25]=dot(b,dot(A,c*dot(A,c**2))*c)-1/105.
    coneq[26]=dot(b,dot(A,c*dot(A,dot(A,c)))*c)-1/210.
    coneq[27]=dot(b,dot(A,c**2*dot(A,c))*c)-1/70.
    coneq[28]=dot(b,dot(A,dot(A,c)*dot(A,c))*c)-1/140.
    coneq[29]=dot(b,dot(A,c**3)*c*c)-1/28.
    coneq[30]=dot(b,dot(A,dot(A,c**2))*c*c)-1/84.
    coneq[31]=dot(b,dot(A,dot(A,dot(A,c)))*c*c)-1/168.
    coneq[32]=dot(b,dot(A,c*dot(A,c))*c*c)-1/56.
    coneq[33]=dot(b,dot(A,c**2)*c**3)-1/21.
    coneq[34]=dot(b,dot(A,dot(A,c))*c**3)-1/42.
    coneq[35]=dot(b,dot(A,c)*c**4)-1/14.
    coneq[36]=dot(b,dot(A,c**2)*dot(A,c**2))-1/63.
    coneq[37]=dot(b,dot(A,dot(A,c))*dot(A,c**2))-1/126.
    coneq[38]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c)))-1/252.
    coneq[39]=dot(b,dot(A,c**3)*dot(A,c))-1/56.
    coneq[40]=dot(b,dot(A,dot(A,c**2))*dot(A,c))-1/168.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c))-1/336.
    coneq[42]=dot(b,dot(A,c*dot(A,c))*dot(A,c))-1/112.
    coneq[43]=dot(b,dot(A,c**2)*dot(A,c)*c)-1/42.
    coneq[44]=dot(b,dot(A,dot(A,c))*dot(A,c)*c)-1/84.
    coneq[45]=dot(b,dot(A,c)*dot(A,c)*c*c)-1/28.
    coneq[46]=dot(b,dot(A,c)*dot(A,c)*dot(A,c))-1/56.
    coneq[47]=dot(b,c**6)-1/7.
    if any(abs(coneq)>tol):
        return 6
    # order 8 conditions:
    coneq[0]=dot(b,dot(A,c**6))-1/56.
    coneq[1]=dot(b,dot(A,dot(A,c**5)))-1/336.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**4))))-1/1680.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))))-1/6720.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))-1/20160.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/40320.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))-1/13440.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))))-1/5040.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))-1/10080.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))))-1/3360.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/6720.
    coneq[11]=dot(b,dot(A,dot(A,c*dot(A,c**3))))-1/1344.
    coneq[12]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))))-1/4032.
    coneq[13]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))-1/8064.
    coneq[14]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))))-1/2688.
    coneq[15]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))))-1/1008.
    coneq[16]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)))))-1/2016.
    coneq[17]=dot(b,dot(A,dot(A,c**3*dot(A,c))))-1/672.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2))))-1/2016.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/4032.
    coneq[20]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c))))-1/1344.
    coneq[21]=dot(b,dot(A,c*dot(A,c**4)))-1/280.
    coneq[22]=dot(b,dot(A,c*dot(A,dot(A,c**3))))-1/1120.
    coneq[23]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))))-1/3360.
    coneq[24]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))-1/6720.
    coneq[25]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))))-1/2240.
    coneq[26]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))))-1/840.
    coneq[27]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))))-1/1680.
    coneq[28]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))))-1/560.
    coneq[29]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))))-1/1120.
    coneq[30]=dot(b,dot(A,c**2*dot(A,c**3)))-1/224.
    coneq[31]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))))-1/672.
    coneq[32]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))))-1/1344.
    coneq[33]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))))-1/448.
    coneq[34]=dot(b,dot(A,c**3*dot(A,c**2)))-1/168.
    coneq[35]=dot(b,dot(A,c**3*dot(A,dot(A,c))))-1/336.
    coneq[36]=dot(b,dot(A,c**4*dot(A,c)))-1/112.
    coneq[37]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)))-1/504.
    coneq[38]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))))-1/1008.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))-1/2016.
    coneq[40]=dot(b,dot(A,dot(A,c)*dot(A,c**3)))-1/448.
    coneq[41]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))))-1/1344.
    coneq[42]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/2688.
    coneq[43]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))))-1/896.
    coneq[44]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)))-1/336.
    coneq[45]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))))-1/672.
    coneq[46]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)))-1/224.
    coneq[47]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))-1/448.
    coneq[48]=dot(b,dot(A,c**5)*c)-1/48.
    coneq[49]=dot(b,dot(A,dot(A,c**4))*c)-1/240.
    coneq[50]=dot(b,dot(A,dot(A,dot(A,c**3)))*c)-1/960.
    coneq[51]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/2880.
    coneq[52]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/5760.
    coneq[53]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/1920.
    coneq[54]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c)-1/720.
    coneq[55]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/1440.
    coneq[56]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c)-1/480.
    coneq[57]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/960.
    coneq[58]=dot(b,dot(A,c*dot(A,c**3))*c)-1/192.
    coneq[59]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c)-1/576.
    coneq[60]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/1152.
    coneq[61]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c)-1/384.
    coneq[62]=dot(b,dot(A,c**2*dot(A,c**2))*c)-1/144.
    coneq[63]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c)-1/288.
    coneq[64]=dot(b,dot(A,c**3*dot(A,c))*c)-1/96.
    coneq[65]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c)-1/288.
    coneq[66]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c)-1/576.
    coneq[67]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c)-1/192.
    coneq[68]=dot(b,dot(A,c**4)*c*c)-1/40.
    coneq[69]=dot(b,dot(A,dot(A,c**3))*c*c)-1/160.
    coneq[70]=dot(b,dot(A,dot(A,dot(A,c**2)))*c*c)-1/480.
    coneq[71]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/960.
    coneq[72]=dot(b,dot(A,dot(A,c*dot(A,c)))*c*c)-1/320.
    coneq[73]=dot(b,dot(A,c*dot(A,c**2))*c*c)-1/120.
    coneq[74]=dot(b,dot(A,c*dot(A,dot(A,c)))*c*c)-1/240.
    coneq[75]=dot(b,dot(A,c**2*dot(A,c))*c*c)-1/80.
    coneq[76]=dot(b,dot(A,dot(A,c)*dot(A,c))*c*c)-1/160.
    coneq[77]=dot(b,dot(A,c**3)*c**3)-1/32.
    coneq[78]=dot(b,dot(A,dot(A,c**2))*c**3)-1/96.
    coneq[79]=dot(b,dot(A,dot(A,dot(A,c)))*c**3)-1/192.
    coneq[80]=dot(b,dot(A,c*dot(A,c))*c**3)-1/64.
    coneq[81]=dot(b,dot(A,c**2)*c**4)-1/24.
    coneq[82]=dot(b,dot(A,dot(A,c))*c**4)-1/48.
    coneq[83]=dot(b,dot(A,c)*c**5)-1/16.
    coneq[84]=dot(b,dot(A,c**3)*dot(A,c**2))-1/96.
    coneq[85]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2))-1/288.
    coneq[86]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/576.
    coneq[87]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2))-1/192.
    coneq[88]=dot(b,dot(A,c**3)*dot(A,dot(A,c)))-1/192.
    coneq[89]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/576.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/1152.
    coneq[91]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/384.
    coneq[92]=dot(b,dot(A,c**4)*dot(A,c))-1/80.
    coneq[93]=dot(b,dot(A,dot(A,c**3))*dot(A,c))-1/320.
    coneq[94]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/960.
    coneq[95]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/1920.
    coneq[96]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/640.
    coneq[97]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c))-1/240.
    coneq[98]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/480.
    coneq[99]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c))-1/160.
    coneq[100]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/320.
    coneq[101]=dot(b,dot(A,c**2)*dot(A,c**2)*c)-1/72.
    coneq[102]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c)-1/144.
    coneq[103]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/288.
    coneq[104]=dot(b,dot(A,c**3)*dot(A,c)*c)-1/64.
    coneq[105]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c)-1/192.
    coneq[106]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/384.
    coneq[107]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c)-1/128.
    coneq[108]=dot(b,dot(A,c**2)*dot(A,c)*c*c)-1/48.
    coneq[109]=dot(b,dot(A,dot(A,c))*dot(A,c)*c*c)-1/96.
    coneq[110]=dot(b,dot(A,c)*dot(A,c)*c**3)-1/32.
    coneq[111]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c))-1/96.
    coneq[112]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/192.
    coneq[113]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c)-1/64.
    coneq[114]=dot(b,c**7)-1/8.
    if any(abs(coneq)>tol):
        return 7
    # order 9 conditions:
    coneq[0]=dot(b,dot(A,c**7))-1/72.
    coneq[1]=dot(b,dot(A,dot(A,c**6)))-1/504.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**5))))-1/3024.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)))))-1/15120.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))-1/60480.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/181440.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/362880.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/120960.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/45360.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/90720.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/30240.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/60480.
    coneq[12]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)))))-1/12096.
    coneq[13]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/36288.
    coneq[14]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/72576.
    coneq[15]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/24192.
    coneq[16]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))-1/9072.
    coneq[17]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/18144.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)))))-1/6048.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/18144.
    coneq[20]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/36288.
    coneq[21]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/12096.
    coneq[22]=dot(b,dot(A,dot(A,c*dot(A,c**4))))-1/2520.
    coneq[23]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)))))-1/10080.
    coneq[24]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/30240.
    coneq[25]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/60480.
    coneq[26]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/20160.
    coneq[27]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))-1/7560.
    coneq[28]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/15120.
    coneq[29]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))-1/5040.
    coneq[30]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/10080.
    coneq[31]=dot(b,dot(A,dot(A,c**2*dot(A,c**3))))-1/2016.
    coneq[32]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))-1/6048.
    coneq[33]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/12096.
    coneq[34]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))-1/4032.
    coneq[35]=dot(b,dot(A,dot(A,c**3*dot(A,c**2))))-1/1512.
    coneq[36]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)))))-1/3024.
    coneq[37]=dot(b,dot(A,dot(A,c**4*dot(A,c))))-1/1008.
    coneq[38]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))-1/4536.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/9072.
    coneq[40]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/18144.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3))))-1/4032.
    coneq[42]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/12096.
    coneq[43]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/24192.
    coneq[44]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/8064.
    coneq[45]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))-1/3024.
    coneq[46]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/6048.
    coneq[47]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))-1/2016.
    coneq[48]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/4032.
    coneq[49]=dot(b,dot(A,c*dot(A,c**5)))-1/432.
    coneq[50]=dot(b,dot(A,c*dot(A,dot(A,c**4))))-1/2160.
    coneq[51]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)))))-1/8640.
    coneq[52]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/25920.
    coneq[53]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/51840.
    coneq[54]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/17280.
    coneq[55]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))-1/6480.
    coneq[56]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/12960.
    coneq[57]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))-1/4320.
    coneq[58]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/8640.
    coneq[59]=dot(b,dot(A,c*dot(A,c*dot(A,c**3))))-1/1728.
    coneq[60]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))-1/5184.
    coneq[61]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/10368.
    coneq[62]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))-1/3456.
    coneq[63]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2))))-1/1296.
    coneq[64]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))-1/2592.
    coneq[65]=dot(b,dot(A,c*dot(A,c**3*dot(A,c))))-1/864.
    coneq[66]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))-1/2592.
    coneq[67]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/5184.
    coneq[68]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))-1/1728.
    coneq[69]=dot(b,dot(A,c**2*dot(A,c**4)))-1/360.
    coneq[70]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))))-1/1440.
    coneq[71]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))-1/4320.
    coneq[72]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))-1/8640.
    coneq[73]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))-1/2880.
    coneq[74]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2))))-1/1080.
    coneq[75]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))-1/2160.
    coneq[76]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c))))-1/720.
    coneq[77]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))-1/1440.
    coneq[78]=dot(b,dot(A,c**3*dot(A,c**3)))-1/288.
    coneq[79]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))))-1/864.
    coneq[80]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))))-1/1728.
    coneq[81]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))))-1/576.
    coneq[82]=dot(b,dot(A,c**4*dot(A,c**2)))-1/216.
    coneq[83]=dot(b,dot(A,c**4*dot(A,dot(A,c))))-1/432.
    coneq[84]=dot(b,dot(A,c**5*dot(A,c)))-1/144.
    coneq[85]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)))-1/864.
    coneq[86]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))-1/2592.
    coneq[87]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/5184.
    coneq[88]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))-1/1728.
    coneq[89]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)))-1/1728.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/5184.
    coneq[91]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/10368.
    coneq[92]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/3456.
    coneq[93]=dot(b,dot(A,dot(A,c)*dot(A,c**4)))-1/720.
    coneq[94]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))))-1/2880.
    coneq[95]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/8640.
    coneq[96]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/17280.
    coneq[97]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/5760.
    coneq[98]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))-1/2160.
    coneq[99]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/4320.
    coneq[100]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))-1/1440.
    coneq[101]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/2880.
    coneq[102]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)))-1/648.
    coneq[103]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))-1/1296.
    coneq[104]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/2592.
    coneq[105]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)))-1/576.
    coneq[106]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))-1/1728.
    coneq[107]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/3456.
    coneq[108]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))-1/1152.
    coneq[109]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)))-1/432.
    coneq[110]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))-1/864.
    coneq[111]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)))-1/288.
    coneq[112]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))-1/864.
    coneq[113]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/1728.
    coneq[114]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))-1/576.
    coneq[115]=dot(b,dot(A,c**6)*c)-1/63.
    coneq[116]=dot(b,dot(A,dot(A,c**5))*c)-1/378.
    coneq[117]=dot(b,dot(A,dot(A,dot(A,c**4)))*c)-1/1890.
    coneq[118]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*c)-1/7560.
    coneq[119]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/22680.
    coneq[120]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/45360.
    coneq[121]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/15120.
    coneq[122]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*c)-1/5670.
    coneq[123]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/11340.
    coneq[124]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*c)-1/3780.
    coneq[125]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/7560.
    coneq[126]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*c)-1/1512.
    coneq[127]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*c)-1/4536.
    coneq[128]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/9072.
    coneq[129]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*c)-1/3024.
    coneq[130]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*c)-1/1134.
    coneq[131]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*c)-1/2268.
    coneq[132]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*c)-1/756.
    coneq[133]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*c)-1/2268.
    coneq[134]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/4536.
    coneq[135]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*c)-1/1512.
    coneq[136]=dot(b,dot(A,c*dot(A,c**4))*c)-1/315.
    coneq[137]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*c)-1/1260.
    coneq[138]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*c)-1/3780.
    coneq[139]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/7560.
    coneq[140]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*c)-1/2520.
    coneq[141]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*c)-1/945.
    coneq[142]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*c)-1/1890.
    coneq[143]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*c)-1/630.
    coneq[144]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*c)-1/1260.
    coneq[145]=dot(b,dot(A,c**2*dot(A,c**3))*c)-1/252.
    coneq[146]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*c)-1/756.
    coneq[147]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*c)-1/1512.
    coneq[148]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*c)-1/504.
    coneq[149]=dot(b,dot(A,c**3*dot(A,c**2))*c)-1/189.
    coneq[150]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*c)-1/378.
    coneq[151]=dot(b,dot(A,c**4*dot(A,c))*c)-1/126.
    coneq[152]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*c)-1/567.
    coneq[153]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*c)-1/1134.
    coneq[154]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/2268.
    coneq[155]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*c)-1/504.
    coneq[156]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*c)-1/1512.
    coneq[157]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/3024.
    coneq[158]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*c)-1/1008.
    coneq[159]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*c)-1/378.
    coneq[160]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*c)-1/756.
    coneq[161]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*c)-1/252.
    coneq[162]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*c)-1/504.
    coneq[163]=dot(b,dot(A,c**5)*c*c)-1/54.
    coneq[164]=dot(b,dot(A,dot(A,c**4))*c*c)-1/270.
    coneq[165]=dot(b,dot(A,dot(A,dot(A,c**3)))*c*c)-1/1080.
    coneq[166]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c*c)-1/3240.
    coneq[167]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/6480.
    coneq[168]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c*c)-1/2160.
    coneq[169]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c*c)-1/810.
    coneq[170]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c*c)-1/1620.
    coneq[171]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c*c)-1/540.
    coneq[172]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c*c)-1/1080.
    coneq[173]=dot(b,dot(A,c*dot(A,c**3))*c*c)-1/216.
    coneq[174]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c*c)-1/648.
    coneq[175]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c*c)-1/1296.
    coneq[176]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c*c)-1/432.
    coneq[177]=dot(b,dot(A,c**2*dot(A,c**2))*c*c)-1/162.
    coneq[178]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c*c)-1/324.
    coneq[179]=dot(b,dot(A,c**3*dot(A,c))*c*c)-1/108.
    coneq[180]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c*c)-1/324.
    coneq[181]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c*c)-1/648.
    coneq[182]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c*c)-1/216.
    coneq[183]=dot(b,dot(A,c**4)*c**3)-1/45.
    coneq[184]=dot(b,dot(A,dot(A,c**3))*c**3)-1/180.
    coneq[185]=dot(b,dot(A,dot(A,dot(A,c**2)))*c**3)-1/540.
    coneq[186]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/1080.
    coneq[187]=dot(b,dot(A,dot(A,c*dot(A,c)))*c**3)-1/360.
    coneq[188]=dot(b,dot(A,c*dot(A,c**2))*c**3)-1/135.
    coneq[189]=dot(b,dot(A,c*dot(A,dot(A,c)))*c**3)-1/270.
    coneq[190]=dot(b,dot(A,c**2*dot(A,c))*c**3)-1/90.
    coneq[191]=dot(b,dot(A,dot(A,c)*dot(A,c))*c**3)-1/180.
    coneq[192]=dot(b,dot(A,c**3)*c**4)-1/36.
    coneq[193]=dot(b,dot(A,dot(A,c**2))*c**4)-1/108.
    coneq[194]=dot(b,dot(A,dot(A,dot(A,c)))*c**4)-1/216.
    coneq[195]=dot(b,dot(A,c*dot(A,c))*c**4)-1/72.
    coneq[196]=dot(b,dot(A,c**2)*c**5)-1/27.
    coneq[197]=dot(b,dot(A,dot(A,c))*c**5)-1/54.
    coneq[198]=dot(b,dot(A,c)*c**6)-1/18.
    coneq[199]=dot(b,dot(A,c**3)*dot(A,c**3))-1/144.
    coneq[200]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3))-1/432.
    coneq[201]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/864.
    coneq[202]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3))-1/288.
    coneq[203]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/1296.
    coneq[204]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/2592.
    coneq[205]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/864.
    coneq[206]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/5184.
    coneq[207]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/1728.
    coneq[208]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/576.
    coneq[209]=dot(b,dot(A,c**4)*dot(A,c**2))-1/135.
    coneq[210]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2))-1/540.
    coneq[211]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/1620.
    coneq[212]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/3240.
    coneq[213]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2))-1/1080.
    coneq[214]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2))-1/405.
    coneq[215]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2))-1/810.
    coneq[216]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2))-1/270.
    coneq[217]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2))-1/540.
    coneq[218]=dot(b,dot(A,c**4)*dot(A,dot(A,c)))-1/270.
    coneq[219]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/1080.
    coneq[220]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/3240.
    coneq[221]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/6480.
    coneq[222]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/2160.
    coneq[223]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)))-1/810.
    coneq[224]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/1620.
    coneq[225]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)))-1/540.
    coneq[226]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/1080.
    coneq[227]=dot(b,dot(A,c**5)*dot(A,c))-1/108.
    coneq[228]=dot(b,dot(A,dot(A,c**4))*dot(A,c))-1/540.
    coneq[229]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c))-1/2160.
    coneq[230]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/6480.
    coneq[231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/12960.
    coneq[232]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/4320.
    coneq[233]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c))-1/1620.
    coneq[234]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/3240.
    coneq[235]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c))-1/1080.
    coneq[236]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/2160.
    coneq[237]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c))-1/432.
    coneq[238]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c))-1/1296.
    coneq[239]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/2592.
    coneq[240]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c))-1/864.
    coneq[241]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c))-1/324.
    coneq[242]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c))-1/648.
    coneq[243]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c))-1/216.
    coneq[244]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c))-1/648.
    coneq[245]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/1296.
    coneq[246]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c))-1/432.
    coneq[247]=dot(b,dot(A,c**3)*dot(A,c**2)*c)-1/108.
    coneq[248]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/324.
    coneq[249]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/648.
    coneq[250]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/216.
    coneq[251]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*c)-1/216.
    coneq[252]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/648.
    coneq[253]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/1296.
    coneq[254]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/432.
    coneq[255]=dot(b,dot(A,c**4)*dot(A,c)*c)-1/90.
    coneq[256]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*c)-1/360.
    coneq[257]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/1080.
    coneq[258]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/2160.
    coneq[259]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c)-1/720.
    coneq[260]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*c)-1/270.
    coneq[261]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c)-1/540.
    coneq[262]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*c)-1/180.
    coneq[263]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c)-1/360.
    coneq[264]=dot(b,dot(A,c**2)*dot(A,c**2)*c*c)-1/81.
    coneq[265]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/162.
    coneq[266]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/324.
    coneq[267]=dot(b,dot(A,c**3)*dot(A,c)*c*c)-1/72.
    coneq[268]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/216.
    coneq[269]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/432.
    coneq[270]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/144.
    coneq[271]=dot(b,dot(A,c**2)*dot(A,c)*c**3)-1/54.
    coneq[272]=dot(b,dot(A,dot(A,c))*dot(A,c)*c**3)-1/108.
    coneq[273]=dot(b,dot(A,c)*dot(A,c)*c**4)-1/36.
    coneq[274]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c))-1/144.
    coneq[275]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/432.
    coneq[276]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/864.
    coneq[277]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/288.
    coneq[278]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/162.
    coneq[279]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/324.
    coneq[280]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/648.
    coneq[281]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/108.
    coneq[282]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/216.
    coneq[283]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/72.
    coneq[284]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))-1/144.
    coneq[285]=dot(b,c**8)-1/9.
    if any(abs(coneq)>tol):
        return 8
    # order 10 conditions:
    coneq[0]=dot(b,dot(A,c**8))-1/90.
    coneq[1]=dot(b,dot(A,dot(A,c**7)))-1/720.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**6))))-1/5040.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5)))))-1/30240.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))-1/151200.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/604800.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/1814400.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/3628800.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/1209600.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/453600.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/907200.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/302400.
    coneq[12]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/604800.
    coneq[13]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/120960.
    coneq[14]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/362880.
    coneq[15]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/725760.
    coneq[16]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/241920.
    coneq[17]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/90720.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/181440.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/60480.
    coneq[20]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/181440.
    coneq[21]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/362880.
    coneq[22]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/120960.
    coneq[23]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4)))))-1/25200.
    coneq[24]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/100800.
    coneq[25]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/302400.
    coneq[26]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/604800.
    coneq[27]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/201600.
    coneq[28]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/75600.
    coneq[29]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/151200.
    coneq[30]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/50400.
    coneq[31]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/100800.
    coneq[32]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))-1/20160.
    coneq[33]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/60480.
    coneq[34]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/120960.
    coneq[35]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/40320.
    coneq[36]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))-1/15120.
    coneq[37]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/30240.
    coneq[38]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)))))-1/10080.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/45360.
    coneq[40]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/90720.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/181440.
    coneq[42]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/40320.
    coneq[43]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/120960.
    coneq[44]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/241920.
    coneq[45]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/80640.
    coneq[46]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/30240.
    coneq[47]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/60480.
    coneq[48]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/20160.
    coneq[49]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/40320.
    coneq[50]=dot(b,dot(A,dot(A,c*dot(A,c**5))))-1/4320.
    coneq[51]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4)))))-1/21600.
    coneq[52]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/86400.
    coneq[53]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/259200.
    coneq[54]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/518400.
    coneq[55]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/172800.
    coneq[56]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/64800.
    coneq[57]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/129600.
    coneq[58]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/43200.
    coneq[59]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/86400.
    coneq[60]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))-1/17280.
    coneq[61]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/51840.
    coneq[62]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/103680.
    coneq[63]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/34560.
    coneq[64]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/12960.
    coneq[65]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/25920.
    coneq[66]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))-1/8640.
    coneq[67]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/25920.
    coneq[68]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/51840.
    coneq[69]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/17280.
    coneq[70]=dot(b,dot(A,dot(A,c**2*dot(A,c**4))))-1/3600.
    coneq[71]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))-1/14400.
    coneq[72]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/43200.
    coneq[73]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/86400.
    coneq[74]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/28800.
    coneq[75]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/10800.
    coneq[76]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/21600.
    coneq[77]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/7200.
    coneq[78]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/14400.
    coneq[79]=dot(b,dot(A,dot(A,c**3*dot(A,c**3))))-1/2880.
    coneq[80]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))-1/8640.
    coneq[81]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/17280.
    coneq[82]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))-1/5760.
    coneq[83]=dot(b,dot(A,dot(A,c**4*dot(A,c**2))))-1/2160.
    coneq[84]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)))))-1/4320.
    coneq[85]=dot(b,dot(A,dot(A,c**5*dot(A,c))))-1/1440.
    coneq[86]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))-1/8640.
    coneq[87]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/25920.
    coneq[88]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/51840.
    coneq[89]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/17280.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/17280.
    coneq[91]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/51840.
    coneq[92]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/103680.
    coneq[93]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/34560.
    coneq[94]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4))))-1/7200.
    coneq[95]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/28800.
    coneq[96]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/86400.
    coneq[97]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/172800.
    coneq[98]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/57600.
    coneq[99]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/21600.
    coneq[100]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/43200.
    coneq[101]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/14400.
    coneq[102]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/28800.
    coneq[103]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/6480.
    coneq[104]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/12960.
    coneq[105]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/25920.
    coneq[106]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))-1/5760.
    coneq[107]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/17280.
    coneq[108]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/34560.
    coneq[109]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/11520.
    coneq[110]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/4320.
    coneq[111]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/8640.
    coneq[112]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))-1/2880.
    coneq[113]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/8640.
    coneq[114]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/17280.
    coneq[115]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/5760.
    coneq[116]=dot(b,dot(A,c*dot(A,c**6)))-1/630.
    coneq[117]=dot(b,dot(A,c*dot(A,dot(A,c**5))))-1/3780.
    coneq[118]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4)))))-1/18900.
    coneq[119]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/75600.
    coneq[120]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/226800.
    coneq[121]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/453600.
    coneq[122]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/151200.
    coneq[123]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/56700.
    coneq[124]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/113400.
    coneq[125]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/37800.
    coneq[126]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/75600.
    coneq[127]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))-1/15120.
    coneq[128]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/45360.
    coneq[129]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/90720.
    coneq[130]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/30240.
    coneq[131]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))-1/11340.
    coneq[132]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/22680.
    coneq[133]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))-1/7560.
    coneq[134]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/22680.
    coneq[135]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/45360.
    coneq[136]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/15120.
    coneq[137]=dot(b,dot(A,c*dot(A,c*dot(A,c**4))))-1/3150.
    coneq[138]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))-1/12600.
    coneq[139]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/37800.
    coneq[140]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/75600.
    coneq[141]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/25200.
    coneq[142]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))-1/9450.
    coneq[143]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/18900.
    coneq[144]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))-1/6300.
    coneq[145]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/12600.
    coneq[146]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3))))-1/2520.
    coneq[147]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))-1/7560.
    coneq[148]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/15120.
    coneq[149]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))-1/5040.
    coneq[150]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2))))-1/1890.
    coneq[151]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))-1/3780.
    coneq[152]=dot(b,dot(A,c*dot(A,c**4*dot(A,c))))-1/1260.
    coneq[153]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))-1/5670.
    coneq[154]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/11340.
    coneq[155]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/22680.
    coneq[156]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))-1/5040.
    coneq[157]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/15120.
    coneq[158]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/30240.
    coneq[159]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/10080.
    coneq[160]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))-1/3780.
    coneq[161]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/7560.
    coneq[162]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))-1/2520.
    coneq[163]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/5040.
    coneq[164]=dot(b,dot(A,c**2*dot(A,c**5)))-1/540.
    coneq[165]=dot(b,dot(A,c**2*dot(A,dot(A,c**4))))-1/2700.
    coneq[166]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))-1/10800.
    coneq[167]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/32400.
    coneq[168]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/64800.
    coneq[169]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/21600.
    coneq[170]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))-1/8100.
    coneq[171]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/16200.
    coneq[172]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))-1/5400.
    coneq[173]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/10800.
    coneq[174]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3))))-1/2160.
    coneq[175]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))-1/6480.
    coneq[176]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/12960.
    coneq[177]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))-1/4320.
    coneq[178]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2))))-1/1620.
    coneq[179]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))-1/3240.
    coneq[180]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c))))-1/1080.
    coneq[181]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))-1/3240.
    coneq[182]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/6480.
    coneq[183]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))-1/2160.
    coneq[184]=dot(b,dot(A,c**3*dot(A,c**4)))-1/450.
    coneq[185]=dot(b,dot(A,c**3*dot(A,dot(A,c**3))))-1/1800.
    coneq[186]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))-1/5400.
    coneq[187]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))-1/10800.
    coneq[188]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))-1/3600.
    coneq[189]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2))))-1/1350.
    coneq[190]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))-1/2700.
    coneq[191]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c))))-1/900.
    coneq[192]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))-1/1800.
    coneq[193]=dot(b,dot(A,c**4*dot(A,c**3)))-1/360.
    coneq[194]=dot(b,dot(A,c**4*dot(A,dot(A,c**2))))-1/1080.
    coneq[195]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)))))-1/2160.
    coneq[196]=dot(b,dot(A,c**4*dot(A,c*dot(A,c))))-1/720.
    coneq[197]=dot(b,dot(A,c**5*dot(A,c**2)))-1/270.
    coneq[198]=dot(b,dot(A,c**5*dot(A,dot(A,c))))-1/540.
    coneq[199]=dot(b,dot(A,c**6*dot(A,c)))-1/180.
    coneq[200]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3)))-1/1440.
    coneq[201]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))-1/4320.
    coneq[202]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/8640.
    coneq[203]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))-1/2880.
    coneq[204]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/12960.
    coneq[205]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/25920.
    coneq[206]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/8640.
    coneq[207]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/51840.
    coneq[208]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/17280.
    coneq[209]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/5760.
    coneq[210]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4)))-1/1350.
    coneq[211]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))-1/5400.
    coneq[212]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/16200.
    coneq[213]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/32400.
    coneq[214]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/10800.
    coneq[215]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/4050.
    coneq[216]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/8100.
    coneq[217]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/2700.
    coneq[218]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/5400.
    coneq[219]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4)))-1/2700.
    coneq[220]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/10800.
    coneq[221]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/32400.
    coneq[222]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/64800.
    coneq[223]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/21600.
    coneq[224]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/8100.
    coneq[225]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/16200.
    coneq[226]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/5400.
    coneq[227]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/10800.
    coneq[228]=dot(b,dot(A,dot(A,c)*dot(A,c**5)))-1/1080.
    coneq[229]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4))))-1/5400.
    coneq[230]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/21600.
    coneq[231]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/64800.
    coneq[232]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/129600.
    coneq[233]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/43200.
    coneq[234]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/16200.
    coneq[235]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/32400.
    coneq[236]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/10800.
    coneq[237]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/21600.
    coneq[238]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))-1/4320.
    coneq[239]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/12960.
    coneq[240]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/25920.
    coneq[241]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/8640.
    coneq[242]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/3240.
    coneq[243]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/6480.
    coneq[244]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))-1/2160.
    coneq[245]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/6480.
    coneq[246]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/12960.
    coneq[247]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/4320.
    coneq[248]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3)))-1/1080.
    coneq[249]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))-1/3240.
    coneq[250]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/6480.
    coneq[251]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))-1/2160.
    coneq[252]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))-1/2160.
    coneq[253]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/6480.
    coneq[254]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/12960.
    coneq[255]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/4320.
    coneq[256]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4)))-1/900.
    coneq[257]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))-1/3600.
    coneq[258]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/10800.
    coneq[259]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/21600.
    coneq[260]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/7200.
    coneq[261]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))-1/2700.
    coneq[262]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/5400.
    coneq[263]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))-1/1800.
    coneq[264]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/3600.
    coneq[265]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))-1/810.
    coneq[266]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))-1/1620.
    coneq[267]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/3240.
    coneq[268]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3)))-1/720.
    coneq[269]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))-1/2160.
    coneq[270]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/4320.
    coneq[271]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))-1/1440.
    coneq[272]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)))-1/540.
    coneq[273]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))-1/1080.
    coneq[274]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)))-1/360.
    coneq[275]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))-1/1440.
    coneq[276]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/4320.
    coneq[277]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/8640.
    coneq[278]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/2880.
    coneq[279]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/1620.
    coneq[280]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/3240.
    coneq[281]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/6480.
    coneq[282]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/1080.
    coneq[283]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/2160.
    coneq[284]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))-1/720.
    coneq[285]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))-1/1440.
    coneq[286]=dot(b,dot(A,c**7)*c)-1/80.
    coneq[287]=dot(b,dot(A,dot(A,c**6))*c)-1/560.
    coneq[288]=dot(b,dot(A,dot(A,dot(A,c**5)))*c)-1/3360.
    coneq[289]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*c)-1/16800.
    coneq[290]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/67200.
    coneq[291]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/201600.
    coneq[292]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/403200.
    coneq[293]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/134400.
    coneq[294]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/50400.
    coneq[295]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/100800.
    coneq[296]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/33600.
    coneq[297]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/67200.
    coneq[298]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*c)-1/13440.
    coneq[299]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/40320.
    coneq[300]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/80640.
    coneq[301]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/26880.
    coneq[302]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/10080.
    coneq[303]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/20160.
    coneq[304]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*c)-1/6720.
    coneq[305]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/20160.
    coneq[306]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/40320.
    coneq[307]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/13440.
    coneq[308]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*c)-1/2800.
    coneq[309]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*c)-1/11200.
    coneq[310]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/33600.
    coneq[311]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/67200.
    coneq[312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/22400.
    coneq[313]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/8400.
    coneq[314]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/16800.
    coneq[315]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/5600.
    coneq[316]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/11200.
    coneq[317]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*c)-1/2240.
    coneq[318]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/6720.
    coneq[319]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/13440.
    coneq[320]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/4480.
    coneq[321]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*c)-1/1680.
    coneq[322]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*c)-1/3360.
    coneq[323]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*c)-1/1120.
    coneq[324]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/5040.
    coneq[325]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/10080.
    coneq[326]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/20160.
    coneq[327]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*c)-1/4480.
    coneq[328]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/13440.
    coneq[329]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/26880.
    coneq[330]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/8960.
    coneq[331]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/3360.
    coneq[332]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/6720.
    coneq[333]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/2240.
    coneq[334]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/4480.
    coneq[335]=dot(b,dot(A,c*dot(A,c**5))*c)-1/480.
    coneq[336]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*c)-1/2400.
    coneq[337]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*c)-1/9600.
    coneq[338]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/28800.
    coneq[339]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/57600.
    coneq[340]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/19200.
    coneq[341]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*c)-1/7200.
    coneq[342]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/14400.
    coneq[343]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*c)-1/4800.
    coneq[344]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/9600.
    coneq[345]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*c)-1/1920.
    coneq[346]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*c)-1/5760.
    coneq[347]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/11520.
    coneq[348]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*c)-1/3840.
    coneq[349]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*c)-1/1440.
    coneq[350]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*c)-1/2880.
    coneq[351]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*c)-1/960.
    coneq[352]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/2880.
    coneq[353]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/5760.
    coneq[354]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/1920.
    coneq[355]=dot(b,dot(A,c**2*dot(A,c**4))*c)-1/400.
    coneq[356]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*c)-1/1600.
    coneq[357]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*c)-1/4800.
    coneq[358]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/9600.
    coneq[359]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*c)-1/3200.
    coneq[360]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*c)-1/1200.
    coneq[361]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*c)-1/2400.
    coneq[362]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*c)-1/800.
    coneq[363]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*c)-1/1600.
    coneq[364]=dot(b,dot(A,c**3*dot(A,c**3))*c)-1/320.
    coneq[365]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*c)-1/960.
    coneq[366]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*c)-1/1920.
    coneq[367]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*c)-1/640.
    coneq[368]=dot(b,dot(A,c**4*dot(A,c**2))*c)-1/240.
    coneq[369]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*c)-1/480.
    coneq[370]=dot(b,dot(A,c**5*dot(A,c))*c)-1/160.
    coneq[371]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*c)-1/960.
    coneq[372]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/2880.
    coneq[373]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/5760.
    coneq[374]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/1920.
    coneq[375]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*c)-1/1920.
    coneq[376]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/5760.
    coneq[377]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/11520.
    coneq[378]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/3840.
    coneq[379]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*c)-1/800.
    coneq[380]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*c)-1/3200.
    coneq[381]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/9600.
    coneq[382]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/19200.
    coneq[383]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/6400.
    coneq[384]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/2400.
    coneq[385]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/4800.
    coneq[386]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/1600.
    coneq[387]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/3200.
    coneq[388]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*c)-1/720.
    coneq[389]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/1440.
    coneq[390]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/2880.
    coneq[391]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*c)-1/640.
    coneq[392]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/1920.
    coneq[393]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/3840.
    coneq[394]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/1280.
    coneq[395]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*c)-1/480.
    coneq[396]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*c)-1/960.
    coneq[397]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*c)-1/320.
    coneq[398]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/960.
    coneq[399]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/1920.
    coneq[400]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/640.
    coneq[401]=dot(b,dot(A,c**6)*c*c)-1/70.
    coneq[402]=dot(b,dot(A,dot(A,c**5))*c*c)-1/420.
    coneq[403]=dot(b,dot(A,dot(A,dot(A,c**4)))*c*c)-1/2100.
    coneq[404]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*c*c)-1/8400.
    coneq[405]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/25200.
    coneq[406]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/50400.
    coneq[407]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/16800.
    coneq[408]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/6300.
    coneq[409]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/12600.
    coneq[410]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/4200.
    coneq[411]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/8400.
    coneq[412]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*c*c)-1/1680.
    coneq[413]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/5040.
    coneq[414]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/10080.
    coneq[415]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/3360.
    coneq[416]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*c*c)-1/1260.
    coneq[417]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/2520.
    coneq[418]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*c*c)-1/840.
    coneq[419]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/2520.
    coneq[420]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/5040.
    coneq[421]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/1680.
    coneq[422]=dot(b,dot(A,c*dot(A,c**4))*c*c)-1/350.
    coneq[423]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*c*c)-1/1400.
    coneq[424]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*c*c)-1/4200.
    coneq[425]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/8400.
    coneq[426]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*c*c)-1/2800.
    coneq[427]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*c*c)-1/1050.
    coneq[428]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*c*c)-1/2100.
    coneq[429]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*c*c)-1/700.
    coneq[430]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/1400.
    coneq[431]=dot(b,dot(A,c**2*dot(A,c**3))*c*c)-1/280.
    coneq[432]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*c*c)-1/840.
    coneq[433]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*c*c)-1/1680.
    coneq[434]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*c*c)-1/560.
    coneq[435]=dot(b,dot(A,c**3*dot(A,c**2))*c*c)-1/210.
    coneq[436]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*c*c)-1/420.
    coneq[437]=dot(b,dot(A,c**4*dot(A,c))*c*c)-1/140.
    coneq[438]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*c*c)-1/630.
    coneq[439]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/1260.
    coneq[440]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/2520.
    coneq[441]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*c*c)-1/560.
    coneq[442]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/1680.
    coneq[443]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/3360.
    coneq[444]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/1120.
    coneq[445]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*c*c)-1/420.
    coneq[446]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/840.
    coneq[447]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*c*c)-1/280.
    coneq[448]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/560.
    coneq[449]=dot(b,dot(A,c**5)*c**3)-1/60.
    coneq[450]=dot(b,dot(A,dot(A,c**4))*c**3)-1/300.
    coneq[451]=dot(b,dot(A,dot(A,dot(A,c**3)))*c**3)-1/1200.
    coneq[452]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c**3)-1/3600.
    coneq[453]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/7200.
    coneq[454]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c**3)-1/2400.
    coneq[455]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c**3)-1/900.
    coneq[456]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c**3)-1/1800.
    coneq[457]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c**3)-1/600.
    coneq[458]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c**3)-1/1200.
    coneq[459]=dot(b,dot(A,c*dot(A,c**3))*c**3)-1/240.
    coneq[460]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c**3)-1/720.
    coneq[461]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c**3)-1/1440.
    coneq[462]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c**3)-1/480.
    coneq[463]=dot(b,dot(A,c**2*dot(A,c**2))*c**3)-1/180.
    coneq[464]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c**3)-1/360.
    coneq[465]=dot(b,dot(A,c**3*dot(A,c))*c**3)-1/120.
    coneq[466]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c**3)-1/360.
    coneq[467]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c**3)-1/720.
    coneq[468]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c**3)-1/240.
    coneq[469]=dot(b,dot(A,c**4)*c**4)-1/50.
    coneq[470]=dot(b,dot(A,dot(A,c**3))*c**4)-1/200.
    coneq[471]=dot(b,dot(A,dot(A,dot(A,c**2)))*c**4)-1/600.
    coneq[472]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c**4)-1/1200.
    coneq[473]=dot(b,dot(A,dot(A,c*dot(A,c)))*c**4)-1/400.
    coneq[474]=dot(b,dot(A,c*dot(A,c**2))*c**4)-1/150.
    coneq[475]=dot(b,dot(A,c*dot(A,dot(A,c)))*c**4)-1/300.
    coneq[476]=dot(b,dot(A,c**2*dot(A,c))*c**4)-1/100.
    coneq[477]=dot(b,dot(A,dot(A,c)*dot(A,c))*c**4)-1/200.
    coneq[478]=dot(b,dot(A,c**3)*c**5)-1/40.
    coneq[479]=dot(b,dot(A,dot(A,c**2))*c**5)-1/120.
    coneq[480]=dot(b,dot(A,dot(A,dot(A,c)))*c**5)-1/240.
    coneq[481]=dot(b,dot(A,c*dot(A,c))*c**5)-1/80.
    coneq[482]=dot(b,dot(A,c**2)*c**6)-1/30.
    coneq[483]=dot(b,dot(A,dot(A,c))*c**6)-1/60.
    coneq[484]=dot(b,dot(A,c)*c**7)-1/20.
    coneq[485]=dot(b,dot(A,c**4)*dot(A,c**3))-1/200.
    coneq[486]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3))-1/800.
    coneq[487]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3))-1/2400.
    coneq[488]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/4800.
    coneq[489]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3))-1/1600.
    coneq[490]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3))-1/600.
    coneq[491]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3))-1/1200.
    coneq[492]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3))-1/400.
    coneq[493]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3))-1/800.
    coneq[494]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2)))-1/600.
    coneq[495]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2)))-1/2400.
    coneq[496]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/7200.
    coneq[497]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/14400.
    coneq[498]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/4800.
    coneq[499]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2)))-1/1800.
    coneq[500]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/3600.
    coneq[501]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2)))-1/1200.
    coneq[502]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/2400.
    coneq[503]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c))))-1/1200.
    coneq[504]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/4800.
    coneq[505]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/14400.
    coneq[506]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/28800.
    coneq[507]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/9600.
    coneq[508]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/3600.
    coneq[509]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/7200.
    coneq[510]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/2400.
    coneq[511]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/4800.
    coneq[512]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c)))-1/400.
    coneq[513]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c)))-1/1600.
    coneq[514]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/4800.
    coneq[515]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/9600.
    coneq[516]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/3200.
    coneq[517]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)))-1/1200.
    coneq[518]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/2400.
    coneq[519]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)))-1/800.
    coneq[520]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/1600.
    coneq[521]=dot(b,dot(A,c**5)*dot(A,c**2))-1/180.
    coneq[522]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2))-1/900.
    coneq[523]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2))-1/3600.
    coneq[524]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/10800.
    coneq[525]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/21600.
    coneq[526]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/7200.
    coneq[527]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/2700.
    coneq[528]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/5400.
    coneq[529]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/1800.
    coneq[530]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/3600.
    coneq[531]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2))-1/720.
    coneq[532]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2))-1/2160.
    coneq[533]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/4320.
    coneq[534]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2))-1/1440.
    coneq[535]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2))-1/540.
    coneq[536]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2))-1/1080.
    coneq[537]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2))-1/360.
    coneq[538]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/1080.
    coneq[539]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/2160.
    coneq[540]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2))-1/720.
    coneq[541]=dot(b,dot(A,c**5)*dot(A,dot(A,c)))-1/360.
    coneq[542]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c)))-1/1800.
    coneq[543]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/7200.
    coneq[544]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/21600.
    coneq[545]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/43200.
    coneq[546]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/14400.
    coneq[547]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/5400.
    coneq[548]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/10800.
    coneq[549]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/3600.
    coneq[550]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/7200.
    coneq[551]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)))-1/1440.
    coneq[552]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/4320.
    coneq[553]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/8640.
    coneq[554]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/2880.
    coneq[555]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)))-1/1080.
    coneq[556]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/2160.
    coneq[557]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)))-1/720.
    coneq[558]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/2160.
    coneq[559]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/4320.
    coneq[560]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/1440.
    coneq[561]=dot(b,dot(A,c**6)*dot(A,c))-1/140.
    coneq[562]=dot(b,dot(A,dot(A,c**5))*dot(A,c))-1/840.
    coneq[563]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c))-1/4200.
    coneq[564]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/16800.
    coneq[565]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/50400.
    coneq[566]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/100800.
    coneq[567]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/33600.
    coneq[568]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/12600.
    coneq[569]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/25200.
    coneq[570]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/8400.
    coneq[571]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/16800.
    coneq[572]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c))-1/3360.
    coneq[573]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/10080.
    coneq[574]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/20160.
    coneq[575]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/6720.
    coneq[576]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/2520.
    coneq[577]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/5040.
    coneq[578]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c))-1/1680.
    coneq[579]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/5040.
    coneq[580]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/10080.
    coneq[581]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/3360.
    coneq[582]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c))-1/700.
    coneq[583]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c))-1/2800.
    coneq[584]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/8400.
    coneq[585]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/16800.
    coneq[586]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/5600.
    coneq[587]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c))-1/2100.
    coneq[588]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/4200.
    coneq[589]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c))-1/1400.
    coneq[590]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/2800.
    coneq[591]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c))-1/560.
    coneq[592]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c))-1/1680.
    coneq[593]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/3360.
    coneq[594]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c))-1/1120.
    coneq[595]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c))-1/420.
    coneq[596]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c))-1/840.
    coneq[597]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c))-1/280.
    coneq[598]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/1260.
    coneq[599]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/2520.
    coneq[600]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/5040.
    coneq[601]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c))-1/1120.
    coneq[602]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/3360.
    coneq[603]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/6720.
    coneq[604]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/2240.
    coneq[605]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c))-1/840.
    coneq[606]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/1680.
    coneq[607]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c))-1/560.
    coneq[608]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/1120.
    coneq[609]=dot(b,dot(A,c**3)*dot(A,c**3)*c)-1/160.
    coneq[610]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*c)-1/480.
    coneq[611]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c)-1/960.
    coneq[612]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*c)-1/320.
    coneq[613]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/1440.
    coneq[614]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/2880.
    coneq[615]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*c)-1/960.
    coneq[616]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/5760.
    coneq[617]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/1920.
    coneq[618]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*c)-1/640.
    coneq[619]=dot(b,dot(A,c**4)*dot(A,c**2)*c)-1/150.
    coneq[620]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*c)-1/600.
    coneq[621]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/1800.
    coneq[622]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/3600.
    coneq[623]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/1200.
    coneq[624]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*c)-1/450.
    coneq[625]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/900.
    coneq[626]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*c)-1/300.
    coneq[627]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/600.
    coneq[628]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*c)-1/300.
    coneq[629]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*c)-1/1200.
    coneq[630]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/3600.
    coneq[631]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/7200.
    coneq[632]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/2400.
    coneq[633]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*c)-1/900.
    coneq[634]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/1800.
    coneq[635]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*c)-1/600.
    coneq[636]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/1200.
    coneq[637]=dot(b,dot(A,c**5)*dot(A,c)*c)-1/120.
    coneq[638]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*c)-1/600.
    coneq[639]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*c)-1/2400.
    coneq[640]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/7200.
    coneq[641]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/14400.
    coneq[642]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/4800.
    coneq[643]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/1800.
    coneq[644]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/3600.
    coneq[645]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/1200.
    coneq[646]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/2400.
    coneq[647]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*c)-1/480.
    coneq[648]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/1440.
    coneq[649]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/2880.
    coneq[650]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/960.
    coneq[651]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*c)-1/360.
    coneq[652]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*c)-1/720.
    coneq[653]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*c)-1/240.
    coneq[654]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/720.
    coneq[655]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/1440.
    coneq[656]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/480.
    coneq[657]=dot(b,dot(A,c**3)*dot(A,c**2)*c*c)-1/120.
    coneq[658]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*c*c)-1/360.
    coneq[659]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/720.
    coneq[660]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*c*c)-1/240.
    coneq[661]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*c*c)-1/240.
    coneq[662]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/720.
    coneq[663]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/1440.
    coneq[664]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*c*c)-1/480.
    coneq[665]=dot(b,dot(A,c**4)*dot(A,c)*c*c)-1/100.
    coneq[666]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*c*c)-1/400.
    coneq[667]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/1200.
    coneq[668]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/2400.
    coneq[669]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/800.
    coneq[670]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*c*c)-1/300.
    coneq[671]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/600.
    coneq[672]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*c*c)-1/200.
    coneq[673]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/400.
    coneq[674]=dot(b,dot(A,c**2)*dot(A,c**2)*c**3)-1/90.
    coneq[675]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c**3)-1/180.
    coneq[676]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c**3)-1/360.
    coneq[677]=dot(b,dot(A,c**3)*dot(A,c)*c**3)-1/80.
    coneq[678]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c**3)-1/240.
    coneq[679]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c**3)-1/480.
    coneq[680]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c**3)-1/160.
    coneq[681]=dot(b,dot(A,c**2)*dot(A,c)*c**4)-1/60.
    coneq[682]=dot(b,dot(A,dot(A,c))*dot(A,c)*c**4)-1/120.
    coneq[683]=dot(b,dot(A,c)*dot(A,c)*c**5)-1/40.
    coneq[684]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c))-1/200.
    coneq[685]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c))-1/800.
    coneq[686]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/2400.
    coneq[687]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/4800.
    coneq[688]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/1600.
    coneq[689]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c))-1/600.
    coneq[690]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/1200.
    coneq[691]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c))-1/400.
    coneq[692]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/800.
    coneq[693]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c))-1/240.
    coneq[694]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/720.
    coneq[695]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/1440.
    coneq[696]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c))-1/480.
    coneq[697]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c))-1/480.
    coneq[698]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/1440.
    coneq[699]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/2880.
    coneq[700]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/960.
    coneq[701]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/270.
    coneq[702]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/540.
    coneq[703]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/1080.
    coneq[704]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/2160.
    coneq[705]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*c)-1/160.
    coneq[706]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/480.
    coneq[707]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/960.
    coneq[708]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/320.
    coneq[709]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/180.
    coneq[710]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/360.
    coneq[711]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/720.
    coneq[712]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/120.
    coneq[713]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/240.
    coneq[714]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/80.
    coneq[715]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*dot(A,c))-1/240.
    coneq[716]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/480.
    coneq[717]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/160.
    coneq[718]=dot(b,c**9)-1/10.
    if any(abs(coneq)>tol):
        return 9
    # order 11 conditions:
    coneq[0]=dot(b,dot(A,c**9))-1/110.
    coneq[1]=dot(b,dot(A,dot(A,c**8)))-1/990.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**7))))-1/7920.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6)))))-1/55440.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))-1/332640.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/1663200.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/6652800.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/19958400.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/39916800.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/13305600.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/4989600.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/9979200.
    coneq[12]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/3326400.
    coneq[13]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/6652800.
    coneq[14]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/1330560.
    coneq[15]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/3991680.
    coneq[16]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/7983360.
    coneq[17]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/2661120.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/997920.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/1995840.
    coneq[20]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/665280.
    coneq[21]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/1995840.
    coneq[22]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/3991680.
    coneq[23]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/1330560.
    coneq[24]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/277200.
    coneq[25]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1108800.
    coneq[26]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/3326400.
    coneq[27]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/6652800.
    coneq[28]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/2217600.
    coneq[29]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/831600.
    coneq[30]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/1663200.
    coneq[31]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/554400.
    coneq[32]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1108800.
    coneq[33]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/221760.
    coneq[34]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/665280.
    coneq[35]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/1330560.
    coneq[36]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/443520.
    coneq[37]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/166320.
    coneq[38]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/332640.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/110880.
    coneq[40]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/498960.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/997920.
    coneq[42]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/1995840.
    coneq[43]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/443520.
    coneq[44]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/1330560.
    coneq[45]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/2661120.
    coneq[46]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/887040.
    coneq[47]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/332640.
    coneq[48]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/665280.
    coneq[49]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/221760.
    coneq[50]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/443520.
    coneq[51]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5)))))-1/47520.
    coneq[52]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/237600.
    coneq[53]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/950400.
    coneq[54]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/2851200.
    coneq[55]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/5702400.
    coneq[56]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/1900800.
    coneq[57]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/712800.
    coneq[58]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1425600.
    coneq[59]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/475200.
    coneq[60]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/950400.
    coneq[61]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/190080.
    coneq[62]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/570240.
    coneq[63]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1140480.
    coneq[64]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/380160.
    coneq[65]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/142560.
    coneq[66]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/285120.
    coneq[67]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/95040.
    coneq[68]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/285120.
    coneq[69]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/570240.
    coneq[70]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/190080.
    coneq[71]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))-1/39600.
    coneq[72]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/158400.
    coneq[73]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/475200.
    coneq[74]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/950400.
    coneq[75]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/316800.
    coneq[76]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/118800.
    coneq[77]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/237600.
    coneq[78]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/79200.
    coneq[79]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/158400.
    coneq[80]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))-1/31680.
    coneq[81]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/95040.
    coneq[82]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/190080.
    coneq[83]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/63360.
    coneq[84]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))-1/23760.
    coneq[85]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/47520.
    coneq[86]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c)))))-1/15840.
    coneq[87]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/95040.
    coneq[88]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/285120.
    coneq[89]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/570240.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/190080.
    coneq[91]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/190080.
    coneq[92]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/570240.
    coneq[93]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1140480.
    coneq[94]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/380160.
    coneq[95]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/79200.
    coneq[96]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/316800.
    coneq[97]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/950400.
    coneq[98]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1900800.
    coneq[99]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/633600.
    coneq[100]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/237600.
    coneq[101]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/475200.
    coneq[102]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/158400.
    coneq[103]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/316800.
    coneq[104]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/71280.
    coneq[105]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/142560.
    coneq[106]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/285120.
    coneq[107]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/63360.
    coneq[108]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/190080.
    coneq[109]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/380160.
    coneq[110]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/126720.
    coneq[111]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/47520.
    coneq[112]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/95040.
    coneq[113]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/31680.
    coneq[114]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/95040.
    coneq[115]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/190080.
    coneq[116]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/63360.
    coneq[117]=dot(b,dot(A,dot(A,c*dot(A,c**6))))-1/6930.
    coneq[118]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5)))))-1/41580.
    coneq[119]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/207900.
    coneq[120]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/831600.
    coneq[121]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/2494800.
    coneq[122]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/4989600.
    coneq[123]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/1663200.
    coneq[124]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/623700.
    coneq[125]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1247400.
    coneq[126]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/415800.
    coneq[127]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/831600.
    coneq[128]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/166320.
    coneq[129]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/498960.
    coneq[130]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/997920.
    coneq[131]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/332640.
    coneq[132]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/124740.
    coneq[133]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/249480.
    coneq[134]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/83160.
    coneq[135]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/249480.
    coneq[136]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/498960.
    coneq[137]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/166320.
    coneq[138]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))-1/34650.
    coneq[139]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/138600.
    coneq[140]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/415800.
    coneq[141]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/831600.
    coneq[142]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/277200.
    coneq[143]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/103950.
    coneq[144]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/207900.
    coneq[145]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/69300.
    coneq[146]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/138600.
    coneq[147]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/27720.
    coneq[148]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/83160.
    coneq[149]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/166320.
    coneq[150]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/55440.
    coneq[151]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/20790.
    coneq[152]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/41580.
    coneq[153]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))-1/13860.
    coneq[154]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/62370.
    coneq[155]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/124740.
    coneq[156]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/249480.
    coneq[157]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/55440.
    coneq[158]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/166320.
    coneq[159]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/332640.
    coneq[160]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/110880.
    coneq[161]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/41580.
    coneq[162]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/83160.
    coneq[163]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/27720.
    coneq[164]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/55440.
    coneq[165]=dot(b,dot(A,dot(A,c**2*dot(A,c**5))))-1/5940.
    coneq[166]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))-1/29700.
    coneq[167]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/118800.
    coneq[168]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/356400.
    coneq[169]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/712800.
    coneq[170]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/237600.
    coneq[171]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/89100.
    coneq[172]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/178200.
    coneq[173]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/59400.
    coneq[174]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/118800.
    coneq[175]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/23760.
    coneq[176]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/71280.
    coneq[177]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/142560.
    coneq[178]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/47520.
    coneq[179]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/17820.
    coneq[180]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/35640.
    coneq[181]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/11880.
    coneq[182]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/35640.
    coneq[183]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/71280.
    coneq[184]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/23760.
    coneq[185]=dot(b,dot(A,dot(A,c**3*dot(A,c**4))))-1/4950.
    coneq[186]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))-1/19800.
    coneq[187]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/59400.
    coneq[188]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/118800.
    coneq[189]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/39600.
    coneq[190]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/14850.
    coneq[191]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/29700.
    coneq[192]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/9900.
    coneq[193]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/19800.
    coneq[194]=dot(b,dot(A,dot(A,c**4*dot(A,c**3))))-1/3960.
    coneq[195]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))-1/11880.
    coneq[196]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/23760.
    coneq[197]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))-1/7920.
    coneq[198]=dot(b,dot(A,dot(A,c**5*dot(A,c**2))))-1/2970.
    coneq[199]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c)))))-1/5940.
    coneq[200]=dot(b,dot(A,dot(A,c**6*dot(A,c))))-1/1980.
    coneq[201]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))-1/15840.
    coneq[202]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/47520.
    coneq[203]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/95040.
    coneq[204]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/31680.
    coneq[205]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/142560.
    coneq[206]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/285120.
    coneq[207]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/95040.
    coneq[208]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/570240.
    coneq[209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/190080.
    coneq[210]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/63360.
    coneq[211]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))-1/14850.
    coneq[212]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/59400.
    coneq[213]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/178200.
    coneq[214]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/356400.
    coneq[215]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/118800.
    coneq[216]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/44550.
    coneq[217]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/89100.
    coneq[218]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/29700.
    coneq[219]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/59400.
    coneq[220]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/29700.
    coneq[221]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/118800.
    coneq[222]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/356400.
    coneq[223]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/712800.
    coneq[224]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/237600.
    coneq[225]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/89100.
    coneq[226]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/178200.
    coneq[227]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/59400.
    coneq[228]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/118800.
    coneq[229]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5))))-1/11880.
    coneq[230]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/59400.
    coneq[231]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/237600.
    coneq[232]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/712800.
    coneq[233]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1425600.
    coneq[234]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/475200.
    coneq[235]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/178200.
    coneq[236]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/356400.
    coneq[237]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/118800.
    coneq[238]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/237600.
    coneq[239]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/47520.
    coneq[240]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/142560.
    coneq[241]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/285120.
    coneq[242]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/95040.
    coneq[243]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/35640.
    coneq[244]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/71280.
    coneq[245]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/23760.
    coneq[246]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/71280.
    coneq[247]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/142560.
    coneq[248]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/47520.
    coneq[249]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/11880.
    coneq[250]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/35640.
    coneq[251]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/71280.
    coneq[252]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/23760.
    coneq[253]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/23760.
    coneq[254]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/71280.
    coneq[255]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/142560.
    coneq[256]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/47520.
    coneq[257]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))-1/9900.
    coneq[258]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/39600.
    coneq[259]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/118800.
    coneq[260]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/237600.
    coneq[261]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/79200.
    coneq[262]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/29700.
    coneq[263]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/59400.
    coneq[264]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/19800.
    coneq[265]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/39600.
    coneq[266]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/8910.
    coneq[267]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/17820.
    coneq[268]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/35640.
    coneq[269]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/7920.
    coneq[270]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/23760.
    coneq[271]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/47520.
    coneq[272]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/15840.
    coneq[273]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/5940.
    coneq[274]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/11880.
    coneq[275]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))-1/3960.
    coneq[276]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/15840.
    coneq[277]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/47520.
    coneq[278]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/95040.
    coneq[279]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/31680.
    coneq[280]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/17820.
    coneq[281]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/35640.
    coneq[282]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/71280.
    coneq[283]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/11880.
    coneq[284]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/23760.
    coneq[285]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/7920.
    coneq[286]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/15840.
    coneq[287]=dot(b,dot(A,c*dot(A,c**7)))-1/880.
    coneq[288]=dot(b,dot(A,c*dot(A,dot(A,c**6))))-1/6160.
    coneq[289]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5)))))-1/36960.
    coneq[290]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/184800.
    coneq[291]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/739200.
    coneq[292]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/2217600.
    coneq[293]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/4435200.
    coneq[294]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/1478400.
    coneq[295]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/554400.
    coneq[296]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1108800.
    coneq[297]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/369600.
    coneq[298]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/739200.
    coneq[299]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/147840.
    coneq[300]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/443520.
    coneq[301]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/887040.
    coneq[302]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/295680.
    coneq[303]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/110880.
    coneq[304]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/221760.
    coneq[305]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/73920.
    coneq[306]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/221760.
    coneq[307]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/443520.
    coneq[308]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/147840.
    coneq[309]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))-1/30800.
    coneq[310]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/123200.
    coneq[311]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/369600.
    coneq[312]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/739200.
    coneq[313]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/246400.
    coneq[314]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/92400.
    coneq[315]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/184800.
    coneq[316]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/61600.
    coneq[317]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/123200.
    coneq[318]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))-1/24640.
    coneq[319]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/73920.
    coneq[320]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/147840.
    coneq[321]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/49280.
    coneq[322]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))-1/18480.
    coneq[323]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/36960.
    coneq[324]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))-1/12320.
    coneq[325]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/55440.
    coneq[326]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/110880.
    coneq[327]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/221760.
    coneq[328]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/49280.
    coneq[329]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/147840.
    coneq[330]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/295680.
    coneq[331]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/98560.
    coneq[332]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/36960.
    coneq[333]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/73920.
    coneq[334]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/24640.
    coneq[335]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/49280.
    coneq[336]=dot(b,dot(A,c*dot(A,c*dot(A,c**5))))-1/5280.
    coneq[337]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))-1/26400.
    coneq[338]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/105600.
    coneq[339]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/316800.
    coneq[340]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/633600.
    coneq[341]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/211200.
    coneq[342]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/79200.
    coneq[343]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/158400.
    coneq[344]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/52800.
    coneq[345]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/105600.
    coneq[346]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))-1/21120.
    coneq[347]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/63360.
    coneq[348]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/126720.
    coneq[349]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/42240.
    coneq[350]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/15840.
    coneq[351]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/31680.
    coneq[352]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))-1/10560.
    coneq[353]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/31680.
    coneq[354]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/63360.
    coneq[355]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/21120.
    coneq[356]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4))))-1/4400.
    coneq[357]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))-1/17600.
    coneq[358]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/52800.
    coneq[359]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/105600.
    coneq[360]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/35200.
    coneq[361]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/13200.
    coneq[362]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/26400.
    coneq[363]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/8800.
    coneq[364]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/17600.
    coneq[365]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3))))-1/3520.
    coneq[366]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))-1/10560.
    coneq[367]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/21120.
    coneq[368]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))-1/7040.
    coneq[369]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2))))-1/2640.
    coneq[370]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))-1/5280.
    coneq[371]=dot(b,dot(A,c*dot(A,c**5*dot(A,c))))-1/1760.
    coneq[372]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))-1/10560.
    coneq[373]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/31680.
    coneq[374]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/63360.
    coneq[375]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/21120.
    coneq[376]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/21120.
    coneq[377]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/63360.
    coneq[378]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/126720.
    coneq[379]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/42240.
    coneq[380]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))-1/8800.
    coneq[381]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/35200.
    coneq[382]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/105600.
    coneq[383]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/211200.
    coneq[384]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/70400.
    coneq[385]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/26400.
    coneq[386]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/52800.
    coneq[387]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/17600.
    coneq[388]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/35200.
    coneq[389]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/7920.
    coneq[390]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/15840.
    coneq[391]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/31680.
    coneq[392]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))-1/7040.
    coneq[393]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/21120.
    coneq[394]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/42240.
    coneq[395]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/14080.
    coneq[396]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/5280.
    coneq[397]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/10560.
    coneq[398]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))-1/3520.
    coneq[399]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/10560.
    coneq[400]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/21120.
    coneq[401]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/7040.
    coneq[402]=dot(b,dot(A,c**2*dot(A,c**6)))-1/770.
    coneq[403]=dot(b,dot(A,c**2*dot(A,dot(A,c**5))))-1/4620.
    coneq[404]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))-1/23100.
    coneq[405]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/92400.
    coneq[406]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/277200.
    coneq[407]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/554400.
    coneq[408]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/184800.
    coneq[409]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/69300.
    coneq[410]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/138600.
    coneq[411]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/46200.
    coneq[412]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/92400.
    coneq[413]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))-1/18480.
    coneq[414]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/55440.
    coneq[415]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/110880.
    coneq[416]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/36960.
    coneq[417]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))-1/13860.
    coneq[418]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/27720.
    coneq[419]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))-1/9240.
    coneq[420]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/27720.
    coneq[421]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/55440.
    coneq[422]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/18480.
    coneq[423]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4))))-1/3850.
    coneq[424]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))-1/15400.
    coneq[425]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/46200.
    coneq[426]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/92400.
    coneq[427]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/30800.
    coneq[428]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))-1/11550.
    coneq[429]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/23100.
    coneq[430]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))-1/7700.
    coneq[431]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/15400.
    coneq[432]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3))))-1/3080.
    coneq[433]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))-1/9240.
    coneq[434]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/18480.
    coneq[435]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))-1/6160.
    coneq[436]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2))))-1/2310.
    coneq[437]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))-1/4620.
    coneq[438]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c))))-1/1540.
    coneq[439]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))-1/6930.
    coneq[440]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/13860.
    coneq[441]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/27720.
    coneq[442]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))-1/6160.
    coneq[443]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/18480.
    coneq[444]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/36960.
    coneq[445]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/12320.
    coneq[446]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))-1/4620.
    coneq[447]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/9240.
    coneq[448]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))-1/3080.
    coneq[449]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/6160.
    coneq[450]=dot(b,dot(A,c**3*dot(A,c**5)))-1/660.
    coneq[451]=dot(b,dot(A,c**3*dot(A,dot(A,c**4))))-1/3300.
    coneq[452]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))-1/13200.
    coneq[453]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/39600.
    coneq[454]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/79200.
    coneq[455]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/26400.
    coneq[456]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))-1/9900.
    coneq[457]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/19800.
    coneq[458]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))-1/6600.
    coneq[459]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/13200.
    coneq[460]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3))))-1/2640.
    coneq[461]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))-1/7920.
    coneq[462]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/15840.
    coneq[463]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))-1/5280.
    coneq[464]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2))))-1/1980.
    coneq[465]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))-1/3960.
    coneq[466]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c))))-1/1320.
    coneq[467]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))-1/3960.
    coneq[468]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/7920.
    coneq[469]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))-1/2640.
    coneq[470]=dot(b,dot(A,c**4*dot(A,c**4)))-1/550.
    coneq[471]=dot(b,dot(A,c**4*dot(A,dot(A,c**3))))-1/2200.
    coneq[472]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))-1/6600.
    coneq[473]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))-1/13200.
    coneq[474]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))-1/4400.
    coneq[475]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2))))-1/1650.
    coneq[476]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))-1/3300.
    coneq[477]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c))))-1/1100.
    coneq[478]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))-1/2200.
    coneq[479]=dot(b,dot(A,c**5*dot(A,c**3)))-1/440.
    coneq[480]=dot(b,dot(A,c**5*dot(A,dot(A,c**2))))-1/1320.
    coneq[481]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c)))))-1/2640.
    coneq[482]=dot(b,dot(A,c**5*dot(A,c*dot(A,c))))-1/880.
    coneq[483]=dot(b,dot(A,c**6*dot(A,c**2)))-1/330.
    coneq[484]=dot(b,dot(A,c**6*dot(A,dot(A,c))))-1/660.
    coneq[485]=dot(b,dot(A,c**7*dot(A,c)))-1/220.
    coneq[486]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4)))-1/2200.
    coneq[487]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))-1/8800.
    coneq[488]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/26400.
    coneq[489]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/52800.
    coneq[490]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/17600.
    coneq[491]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/6600.
    coneq[492]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/13200.
    coneq[493]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/4400.
    coneq[494]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/8800.
    coneq[495]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))-1/6600.
    coneq[496]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/26400.
    coneq[497]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/79200.
    coneq[498]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/158400.
    coneq[499]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/52800.
    coneq[500]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/19800.
    coneq[501]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/39600.
    coneq[502]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/13200.
    coneq[503]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/26400.
    coneq[504]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/13200.
    coneq[505]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/52800.
    coneq[506]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/158400.
    coneq[507]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/316800.
    coneq[508]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/105600.
    coneq[509]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/39600.
    coneq[510]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/79200.
    coneq[511]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/26400.
    coneq[512]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/52800.
    coneq[513]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))-1/4400.
    coneq[514]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/17600.
    coneq[515]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/52800.
    coneq[516]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/105600.
    coneq[517]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/35200.
    coneq[518]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/13200.
    coneq[519]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/26400.
    coneq[520]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/8800.
    coneq[521]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/17600.
    coneq[522]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5)))-1/1980.
    coneq[523]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))-1/9900.
    coneq[524]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/39600.
    coneq[525]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/118800.
    coneq[526]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/237600.
    coneq[527]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/79200.
    coneq[528]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/29700.
    coneq[529]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/59400.
    coneq[530]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/19800.
    coneq[531]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/39600.
    coneq[532]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/7920.
    coneq[533]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/23760.
    coneq[534]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/47520.
    coneq[535]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/15840.
    coneq[536]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/5940.
    coneq[537]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/11880.
    coneq[538]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/3960.
    coneq[539]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/11880.
    coneq[540]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/23760.
    coneq[541]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/7920.
    coneq[542]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5)))-1/3960.
    coneq[543]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/19800.
    coneq[544]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/79200.
    coneq[545]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/237600.
    coneq[546]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/475200.
    coneq[547]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/158400.
    coneq[548]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/59400.
    coneq[549]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/118800.
    coneq[550]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/39600.
    coneq[551]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/79200.
    coneq[552]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/15840.
    coneq[553]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/47520.
    coneq[554]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/95040.
    coneq[555]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/31680.
    coneq[556]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/11880.
    coneq[557]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/23760.
    coneq[558]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/7920.
    coneq[559]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/23760.
    coneq[560]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/47520.
    coneq[561]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/15840.
    coneq[562]=dot(b,dot(A,dot(A,c)*dot(A,c**6)))-1/1540.
    coneq[563]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5))))-1/9240.
    coneq[564]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))-1/46200.
    coneq[565]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/184800.
    coneq[566]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/554400.
    coneq[567]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1108800.
    coneq[568]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/369600.
    coneq[569]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/138600.
    coneq[570]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/277200.
    coneq[571]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/92400.
    coneq[572]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/184800.
    coneq[573]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))-1/36960.
    coneq[574]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/110880.
    coneq[575]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/221760.
    coneq[576]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/73920.
    coneq[577]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/27720.
    coneq[578]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/55440.
    coneq[579]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))-1/18480.
    coneq[580]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/55440.
    coneq[581]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/110880.
    coneq[582]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/36960.
    coneq[583]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))-1/7700.
    coneq[584]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))-1/30800.
    coneq[585]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/92400.
    coneq[586]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/184800.
    coneq[587]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/61600.
    coneq[588]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/23100.
    coneq[589]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/46200.
    coneq[590]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/15400.
    coneq[591]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/30800.
    coneq[592]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))-1/6160.
    coneq[593]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/18480.
    coneq[594]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/36960.
    coneq[595]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/12320.
    coneq[596]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))-1/4620.
    coneq[597]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))-1/9240.
    coneq[598]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))-1/3080.
    coneq[599]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/13860.
    coneq[600]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/27720.
    coneq[601]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/55440.
    coneq[602]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))-1/12320.
    coneq[603]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/36960.
    coneq[604]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/73920.
    coneq[605]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/24640.
    coneq[606]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/9240.
    coneq[607]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/18480.
    coneq[608]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/6160.
    coneq[609]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/12320.
    coneq[610]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3)))-1/1760.
    coneq[611]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))-1/5280.
    coneq[612]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/10560.
    coneq[613]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))-1/3520.
    coneq[614]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/15840.
    coneq[615]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/31680.
    coneq[616]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/10560.
    coneq[617]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/63360.
    coneq[618]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/21120.
    coneq[619]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/7040.
    coneq[620]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4)))-1/1650.
    coneq[621]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))-1/6600.
    coneq[622]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/19800.
    coneq[623]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/39600.
    coneq[624]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/13200.
    coneq[625]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/4950.
    coneq[626]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/9900.
    coneq[627]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/3300.
    coneq[628]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/6600.
    coneq[629]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))-1/3300.
    coneq[630]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/13200.
    coneq[631]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/39600.
    coneq[632]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/79200.
    coneq[633]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/26400.
    coneq[634]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/9900.
    coneq[635]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/19800.
    coneq[636]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/6600.
    coneq[637]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/13200.
    coneq[638]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5)))-1/1320.
    coneq[639]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))-1/6600.
    coneq[640]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/26400.
    coneq[641]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/79200.
    coneq[642]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/158400.
    coneq[643]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/52800.
    coneq[644]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/19800.
    coneq[645]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/39600.
    coneq[646]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/13200.
    coneq[647]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/26400.
    coneq[648]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))-1/5280.
    coneq[649]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/15840.
    coneq[650]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/31680.
    coneq[651]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/10560.
    coneq[652]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/3960.
    coneq[653]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/7920.
    coneq[654]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))-1/2640.
    coneq[655]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/7920.
    coneq[656]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/15840.
    coneq[657]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/5280.
    coneq[658]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3)))-1/1320.
    coneq[659]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))-1/3960.
    coneq[660]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/7920.
    coneq[661]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))-1/2640.
    coneq[662]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))-1/2640.
    coneq[663]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/7920.
    coneq[664]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/15840.
    coneq[665]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/5280.
    coneq[666]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4)))-1/1100.
    coneq[667]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))-1/4400.
    coneq[668]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/13200.
    coneq[669]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/26400.
    coneq[670]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/8800.
    coneq[671]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))-1/3300.
    coneq[672]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/6600.
    coneq[673]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))-1/2200.
    coneq[674]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/4400.
    coneq[675]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2)))-1/990.
    coneq[676]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))-1/1980.
    coneq[677]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/3960.
    coneq[678]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3)))-1/880.
    coneq[679]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))-1/2640.
    coneq[680]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/5280.
    coneq[681]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))-1/1760.
    coneq[682]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2)))-1/660.
    coneq[683]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))-1/1320.
    coneq[684]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c)))-1/440.
    coneq[685]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))-1/2200.
    coneq[686]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))-1/8800.
    coneq[687]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/26400.
    coneq[688]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/52800.
    coneq[689]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/17600.
    coneq[690]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))-1/6600.
    coneq[691]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/13200.
    coneq[692]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))-1/4400.
    coneq[693]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/8800.
    coneq[694]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))-1/2640.
    coneq[695]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/7920.
    coneq[696]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/15840.
    coneq[697]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/5280.
    coneq[698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))-1/5280.
    coneq[699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/15840.
    coneq[700]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/31680.
    coneq[701]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/10560.
    coneq[702]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/2970.
    coneq[703]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/5940.
    coneq[704]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/11880.
    coneq[705]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/23760.
    coneq[706]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/1760.
    coneq[707]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/5280.
    coneq[708]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/10560.
    coneq[709]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/3520.
    coneq[710]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/1980.
    coneq[711]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/3960.
    coneq[712]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/7920.
    coneq[713]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/1320.
    coneq[714]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/2640.
    coneq[715]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))-1/880.
    coneq[716]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/2640.
    coneq[717]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/5280.
    coneq[718]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))-1/1760.
    coneq[719]=dot(b,dot(A,c**8)*c)-1/99.
    coneq[720]=dot(b,dot(A,dot(A,c**7))*c)-1/792.
    coneq[721]=dot(b,dot(A,dot(A,dot(A,c**6)))*c)-1/5544.
    coneq[722]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*c)-1/33264.
    coneq[723]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/166320.
    coneq[724]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/665280.
    coneq[725]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/1995840.
    coneq[726]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/3991680.
    coneq[727]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/1330560.
    coneq[728]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/498960.
    coneq[729]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/997920.
    coneq[730]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/332640.
    coneq[731]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/665280.
    coneq[732]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/133056.
    coneq[733]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/399168.
    coneq[734]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/798336.
    coneq[735]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/266112.
    coneq[736]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/99792.
    coneq[737]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/199584.
    coneq[738]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/66528.
    coneq[739]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/199584.
    coneq[740]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/399168.
    coneq[741]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/133056.
    coneq[742]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*c)-1/27720.
    coneq[743]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/110880.
    coneq[744]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/332640.
    coneq[745]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/665280.
    coneq[746]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/221760.
    coneq[747]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/83160.
    coneq[748]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/166320.
    coneq[749]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/55440.
    coneq[750]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/110880.
    coneq[751]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/22176.
    coneq[752]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/66528.
    coneq[753]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/133056.
    coneq[754]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/44352.
    coneq[755]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/16632.
    coneq[756]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/33264.
    coneq[757]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*c)-1/11088.
    coneq[758]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/49896.
    coneq[759]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/99792.
    coneq[760]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/199584.
    coneq[761]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/44352.
    coneq[762]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/133056.
    coneq[763]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/266112.
    coneq[764]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/88704.
    coneq[765]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/33264.
    coneq[766]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/66528.
    coneq[767]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/22176.
    coneq[768]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/44352.
    coneq[769]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*c)-1/4752.
    coneq[770]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*c)-1/23760.
    coneq[771]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/95040.
    coneq[772]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/285120.
    coneq[773]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/570240.
    coneq[774]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/190080.
    coneq[775]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/71280.
    coneq[776]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/142560.
    coneq[777]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/47520.
    coneq[778]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/95040.
    coneq[779]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/19008.
    coneq[780]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/57024.
    coneq[781]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/114048.
    coneq[782]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/38016.
    coneq[783]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/14256.
    coneq[784]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/28512.
    coneq[785]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/9504.
    coneq[786]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/28512.
    coneq[787]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/57024.
    coneq[788]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/19008.
    coneq[789]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*c)-1/3960.
    coneq[790]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/15840.
    coneq[791]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/47520.
    coneq[792]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/95040.
    coneq[793]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/31680.
    coneq[794]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/11880.
    coneq[795]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/23760.
    coneq[796]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/7920.
    coneq[797]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/15840.
    coneq[798]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*c)-1/3168.
    coneq[799]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/9504.
    coneq[800]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/19008.
    coneq[801]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/6336.
    coneq[802]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*c)-1/2376.
    coneq[803]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*c)-1/4752.
    coneq[804]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*c)-1/1584.
    coneq[805]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/9504.
    coneq[806]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/28512.
    coneq[807]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/57024.
    coneq[808]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/19008.
    coneq[809]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/19008.
    coneq[810]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/57024.
    coneq[811]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/114048.
    coneq[812]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/38016.
    coneq[813]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*c)-1/7920.
    coneq[814]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/31680.
    coneq[815]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/95040.
    coneq[816]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/190080.
    coneq[817]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/63360.
    coneq[818]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/23760.
    coneq[819]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/47520.
    coneq[820]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/15840.
    coneq[821]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/31680.
    coneq[822]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/7128.
    coneq[823]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/14256.
    coneq[824]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/28512.
    coneq[825]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/6336.
    coneq[826]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/19008.
    coneq[827]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/38016.
    coneq[828]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/12672.
    coneq[829]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/4752.
    coneq[830]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/9504.
    coneq[831]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/3168.
    coneq[832]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/9504.
    coneq[833]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/19008.
    coneq[834]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/6336.
    coneq[835]=dot(b,dot(A,c*dot(A,c**6))*c)-1/693.
    coneq[836]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*c)-1/4158.
    coneq[837]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*c)-1/20790.
    coneq[838]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/83160.
    coneq[839]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/249480.
    coneq[840]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/498960.
    coneq[841]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/166320.
    coneq[842]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/62370.
    coneq[843]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/124740.
    coneq[844]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/41580.
    coneq[845]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/83160.
    coneq[846]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*c)-1/16632.
    coneq[847]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/49896.
    coneq[848]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/99792.
    coneq[849]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/33264.
    coneq[850]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/12474.
    coneq[851]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/24948.
    coneq[852]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*c)-1/8316.
    coneq[853]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/24948.
    coneq[854]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/49896.
    coneq[855]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/16632.
    coneq[856]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*c)-1/3465.
    coneq[857]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*c)-1/13860.
    coneq[858]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/41580.
    coneq[859]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/83160.
    coneq[860]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/27720.
    coneq[861]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/10395.
    coneq[862]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/20790.
    coneq[863]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/6930.
    coneq[864]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/13860.
    coneq[865]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*c)-1/2772.
    coneq[866]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/8316.
    coneq[867]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/16632.
    coneq[868]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/5544.
    coneq[869]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*c)-1/2079.
    coneq[870]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*c)-1/4158.
    coneq[871]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*c)-1/1386.
    coneq[872]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/6237.
    coneq[873]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/12474.
    coneq[874]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/24948.
    coneq[875]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/5544.
    coneq[876]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/16632.
    coneq[877]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/33264.
    coneq[878]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/11088.
    coneq[879]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/4158.
    coneq[880]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/8316.
    coneq[881]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/2772.
    coneq[882]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/5544.
    coneq[883]=dot(b,dot(A,c**2*dot(A,c**5))*c)-1/594.
    coneq[884]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*c)-1/2970.
    coneq[885]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*c)-1/11880.
    coneq[886]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/35640.
    coneq[887]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/71280.
    coneq[888]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/23760.
    coneq[889]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*c)-1/8910.
    coneq[890]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/17820.
    coneq[891]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*c)-1/5940.
    coneq[892]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/11880.
    coneq[893]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*c)-1/2376.
    coneq[894]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*c)-1/7128.
    coneq[895]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/14256.
    coneq[896]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*c)-1/4752.
    coneq[897]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*c)-1/1782.
    coneq[898]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*c)-1/3564.
    coneq[899]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*c)-1/1188.
    coneq[900]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/3564.
    coneq[901]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/7128.
    coneq[902]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/2376.
    coneq[903]=dot(b,dot(A,c**3*dot(A,c**4))*c)-1/495.
    coneq[904]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*c)-1/1980.
    coneq[905]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*c)-1/5940.
    coneq[906]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/11880.
    coneq[907]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*c)-1/3960.
    coneq[908]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*c)-1/1485.
    coneq[909]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*c)-1/2970.
    coneq[910]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*c)-1/990.
    coneq[911]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*c)-1/1980.
    coneq[912]=dot(b,dot(A,c**4*dot(A,c**3))*c)-1/396.
    coneq[913]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*c)-1/1188.
    coneq[914]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*c)-1/2376.
    coneq[915]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*c)-1/792.
    coneq[916]=dot(b,dot(A,c**5*dot(A,c**2))*c)-1/297.
    coneq[917]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*c)-1/594.
    coneq[918]=dot(b,dot(A,c**6*dot(A,c))*c)-1/198.
    coneq[919]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*c)-1/1584.
    coneq[920]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/4752.
    coneq[921]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/9504.
    coneq[922]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/3168.
    coneq[923]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/14256.
    coneq[924]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/28512.
    coneq[925]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/9504.
    coneq[926]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/57024.
    coneq[927]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/19008.
    coneq[928]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/6336.
    coneq[929]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*c)-1/1485.
    coneq[930]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/5940.
    coneq[931]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/17820.
    coneq[932]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/35640.
    coneq[933]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/11880.
    coneq[934]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/4455.
    coneq[935]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/8910.
    coneq[936]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/2970.
    coneq[937]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/5940.
    coneq[938]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*c)-1/2970.
    coneq[939]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/11880.
    coneq[940]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/35640.
    coneq[941]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/71280.
    coneq[942]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/23760.
    coneq[943]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/8910.
    coneq[944]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/17820.
    coneq[945]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/5940.
    coneq[946]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/11880.
    coneq[947]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*c)-1/1188.
    coneq[948]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*c)-1/5940.
    coneq[949]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c)-1/23760.
    coneq[950]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/71280.
    coneq[951]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/142560.
    coneq[952]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/47520.
    coneq[953]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/17820.
    coneq[954]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/35640.
    coneq[955]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/11880.
    coneq[956]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/23760.
    coneq[957]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*c)-1/4752.
    coneq[958]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/14256.
    coneq[959]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/28512.
    coneq[960]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/9504.
    coneq[961]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*c)-1/3564.
    coneq[962]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/7128.
    coneq[963]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*c)-1/2376.
    coneq[964]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/7128.
    coneq[965]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/14256.
    coneq[966]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/4752.
    coneq[967]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*c)-1/1188.
    coneq[968]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/3564.
    coneq[969]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/7128.
    coneq[970]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/2376.
    coneq[971]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*c)-1/2376.
    coneq[972]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/7128.
    coneq[973]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/14256.
    coneq[974]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/4752.
    coneq[975]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*c)-1/990.
    coneq[976]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/3960.
    coneq[977]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/11880.
    coneq[978]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/23760.
    coneq[979]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/7920.
    coneq[980]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/2970.
    coneq[981]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/5940.
    coneq[982]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/1980.
    coneq[983]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/3960.
    coneq[984]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*c)-1/891.
    coneq[985]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/1782.
    coneq[986]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/3564.
    coneq[987]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*c)-1/792.
    coneq[988]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/2376.
    coneq[989]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/4752.
    coneq[990]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/1584.
    coneq[991]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*c)-1/594.
    coneq[992]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*c)-1/1188.
    coneq[993]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*c)-1/396.
    coneq[994]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*c)-1/1584.
    coneq[995]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/4752.
    coneq[996]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/9504.
    coneq[997]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/3168.
    coneq[998]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*c)-1/1782.
    coneq[999]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/3564.
    coneq[1000]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/7128.
    coneq[1001]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/1188.
    coneq[1002]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/2376.
    coneq[1003]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/792.
    coneq[1004]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/1584.
    coneq[1005]=dot(b,dot(A,c**7)*c*c)-1/88.
    coneq[1006]=dot(b,dot(A,dot(A,c**6))*c*c)-1/616.
    coneq[1007]=dot(b,dot(A,dot(A,dot(A,c**5)))*c*c)-1/3696.
    coneq[1008]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*c*c)-1/18480.
    coneq[1009]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/73920.
    coneq[1010]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/221760.
    coneq[1011]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/443520.
    coneq[1012]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/147840.
    coneq[1013]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/55440.
    coneq[1014]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/110880.
    coneq[1015]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/36960.
    coneq[1016]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/73920.
    coneq[1017]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/14784.
    coneq[1018]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/44352.
    coneq[1019]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/88704.
    coneq[1020]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/29568.
    coneq[1021]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/11088.
    coneq[1022]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/22176.
    coneq[1023]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/7392.
    coneq[1024]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/22176.
    coneq[1025]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/44352.
    coneq[1026]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/14784.
    coneq[1027]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*c*c)-1/3080.
    coneq[1028]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/12320.
    coneq[1029]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/36960.
    coneq[1030]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/73920.
    coneq[1031]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/24640.
    coneq[1032]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/9240.
    coneq[1033]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/18480.
    coneq[1034]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/6160.
    coneq[1035]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/12320.
    coneq[1036]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*c*c)-1/2464.
    coneq[1037]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/7392.
    coneq[1038]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/14784.
    coneq[1039]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/4928.
    coneq[1040]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*c*c)-1/1848.
    coneq[1041]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/3696.
    coneq[1042]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*c*c)-1/1232.
    coneq[1043]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/5544.
    coneq[1044]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/11088.
    coneq[1045]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[1046]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/4928.
    coneq[1047]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/14784.
    coneq[1048]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/29568.
    coneq[1049]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/9856.
    coneq[1050]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/3696.
    coneq[1051]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/7392.
    coneq[1052]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/2464.
    coneq[1053]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/4928.
    coneq[1054]=dot(b,dot(A,c*dot(A,c**5))*c*c)-1/528.
    coneq[1055]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*c*c)-1/2640.
    coneq[1056]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*c*c)-1/10560.
    coneq[1057]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/31680.
    coneq[1058]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/63360.
    coneq[1059]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/21120.
    coneq[1060]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/7920.
    coneq[1061]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/15840.
    coneq[1062]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/5280.
    coneq[1063]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/10560.
    coneq[1064]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*c*c)-1/2112.
    coneq[1065]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/6336.
    coneq[1066]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/12672.
    coneq[1067]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/4224.
    coneq[1068]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*c*c)-1/1584.
    coneq[1069]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/3168.
    coneq[1070]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*c*c)-1/1056.
    coneq[1071]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/3168.
    coneq[1072]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/6336.
    coneq[1073]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/2112.
    coneq[1074]=dot(b,dot(A,c**2*dot(A,c**4))*c*c)-1/440.
    coneq[1075]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*c*c)-1/1760.
    coneq[1076]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*c*c)-1/5280.
    coneq[1077]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/10560.
    coneq[1078]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*c*c)-1/3520.
    coneq[1079]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*c*c)-1/1320.
    coneq[1080]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*c*c)-1/2640.
    coneq[1081]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*c*c)-1/880.
    coneq[1082]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/1760.
    coneq[1083]=dot(b,dot(A,c**3*dot(A,c**3))*c*c)-1/352.
    coneq[1084]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*c*c)-1/1056.
    coneq[1085]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*c*c)-1/2112.
    coneq[1086]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*c*c)-1/704.
    coneq[1087]=dot(b,dot(A,c**4*dot(A,c**2))*c*c)-1/264.
    coneq[1088]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*c*c)-1/528.
    coneq[1089]=dot(b,dot(A,c**5*dot(A,c))*c*c)-1/176.
    coneq[1090]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*c*c)-1/1056.
    coneq[1091]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/3168.
    coneq[1092]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/6336.
    coneq[1093]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/2112.
    coneq[1094]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/2112.
    coneq[1095]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/6336.
    coneq[1096]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/12672.
    coneq[1097]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/4224.
    coneq[1098]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*c*c)-1/880.
    coneq[1099]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*c*c)-1/3520.
    coneq[1100]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/10560.
    coneq[1101]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/21120.
    coneq[1102]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/7040.
    coneq[1103]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*c*c)-1/2640.
    coneq[1104]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/5280.
    coneq[1105]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*c*c)-1/1760.
    coneq[1106]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/3520.
    coneq[1107]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*c*c)-1/792.
    coneq[1108]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/1584.
    coneq[1109]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/3168.
    coneq[1110]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*c*c)-1/704.
    coneq[1111]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/2112.
    coneq[1112]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/4224.
    coneq[1113]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/1408.
    coneq[1114]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*c*c)-1/528.
    coneq[1115]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/1056.
    coneq[1116]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*c*c)-1/352.
    coneq[1117]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*c*c)-1/1056.
    coneq[1118]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/2112.
    coneq[1119]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/704.
    coneq[1120]=dot(b,dot(A,c**6)*c**3)-1/77.
    coneq[1121]=dot(b,dot(A,dot(A,c**5))*c**3)-1/462.
    coneq[1122]=dot(b,dot(A,dot(A,dot(A,c**4)))*c**3)-1/2310.
    coneq[1123]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*c**3)-1/9240.
    coneq[1124]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/27720.
    coneq[1125]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/55440.
    coneq[1126]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/18480.
    coneq[1127]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/6930.
    coneq[1128]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/13860.
    coneq[1129]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/4620.
    coneq[1130]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/9240.
    coneq[1131]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*c**3)-1/1848.
    coneq[1132]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/5544.
    coneq[1133]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/11088.
    coneq[1134]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/3696.
    coneq[1135]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*c**3)-1/1386.
    coneq[1136]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/2772.
    coneq[1137]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*c**3)-1/924.
    coneq[1138]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/2772.
    coneq[1139]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/5544.
    coneq[1140]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/1848.
    coneq[1141]=dot(b,dot(A,c*dot(A,c**4))*c**3)-1/385.
    coneq[1142]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*c**3)-1/1540.
    coneq[1143]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*c**3)-1/4620.
    coneq[1144]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/9240.
    coneq[1145]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*c**3)-1/3080.
    coneq[1146]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*c**3)-1/1155.
    coneq[1147]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*c**3)-1/2310.
    coneq[1148]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*c**3)-1/770.
    coneq[1149]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/1540.
    coneq[1150]=dot(b,dot(A,c**2*dot(A,c**3))*c**3)-1/308.
    coneq[1151]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*c**3)-1/924.
    coneq[1152]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*c**3)-1/1848.
    coneq[1153]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*c**3)-1/616.
    coneq[1154]=dot(b,dot(A,c**3*dot(A,c**2))*c**3)-1/231.
    coneq[1155]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*c**3)-1/462.
    coneq[1156]=dot(b,dot(A,c**4*dot(A,c))*c**3)-1/154.
    coneq[1157]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*c**3)-1/693.
    coneq[1158]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/1386.
    coneq[1159]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/2772.
    coneq[1160]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*c**3)-1/616.
    coneq[1161]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*c**3)-1/1848.
    coneq[1162]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*c**3)-1/3696.
    coneq[1163]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*c**3)-1/1232.
    coneq[1164]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*c**3)-1/462.
    coneq[1165]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/924.
    coneq[1166]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*c**3)-1/308.
    coneq[1167]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*c**3)-1/616.
    coneq[1168]=dot(b,dot(A,c**5)*c**4)-1/66.
    coneq[1169]=dot(b,dot(A,dot(A,c**4))*c**4)-1/330.
    coneq[1170]=dot(b,dot(A,dot(A,dot(A,c**3)))*c**4)-1/1320.
    coneq[1171]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c**4)-1/3960.
    coneq[1172]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/7920.
    coneq[1173]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c**4)-1/2640.
    coneq[1174]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c**4)-1/990.
    coneq[1175]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c**4)-1/1980.
    coneq[1176]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c**4)-1/660.
    coneq[1177]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c**4)-1/1320.
    coneq[1178]=dot(b,dot(A,c*dot(A,c**3))*c**4)-1/264.
    coneq[1179]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c**4)-1/792.
    coneq[1180]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c**4)-1/1584.
    coneq[1181]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c**4)-1/528.
    coneq[1182]=dot(b,dot(A,c**2*dot(A,c**2))*c**4)-1/198.
    coneq[1183]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c**4)-1/396.
    coneq[1184]=dot(b,dot(A,c**3*dot(A,c))*c**4)-1/132.
    coneq[1185]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c**4)-1/396.
    coneq[1186]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c**4)-1/792.
    coneq[1187]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c**4)-1/264.
    coneq[1188]=dot(b,dot(A,c**4)*c**5)-1/55.
    coneq[1189]=dot(b,dot(A,dot(A,c**3))*c**5)-1/220.
    coneq[1190]=dot(b,dot(A,dot(A,dot(A,c**2)))*c**5)-1/660.
    coneq[1191]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c**5)-1/1320.
    coneq[1192]=dot(b,dot(A,dot(A,c*dot(A,c)))*c**5)-1/440.
    coneq[1193]=dot(b,dot(A,c*dot(A,c**2))*c**5)-1/165.
    coneq[1194]=dot(b,dot(A,c*dot(A,dot(A,c)))*c**5)-1/330.
    coneq[1195]=dot(b,dot(A,c**2*dot(A,c))*c**5)-1/110.
    coneq[1196]=dot(b,dot(A,dot(A,c)*dot(A,c))*c**5)-1/220.
    coneq[1197]=dot(b,dot(A,c**3)*c**6)-1/44.
    coneq[1198]=dot(b,dot(A,dot(A,c**2))*c**6)-1/132.
    coneq[1199]=dot(b,dot(A,dot(A,dot(A,c)))*c**6)-1/264.
    coneq[1200]=dot(b,dot(A,c*dot(A,c))*c**6)-1/88.
    coneq[1201]=dot(b,dot(A,c**2)*c**7)-1/33.
    coneq[1202]=dot(b,dot(A,dot(A,c))*c**7)-1/66.
    coneq[1203]=dot(b,dot(A,c)*c**8)-1/22.
    coneq[1204]=dot(b,dot(A,c**4)*dot(A,c**4))-1/275.
    coneq[1205]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4))-1/1100.
    coneq[1206]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4))-1/3300.
    coneq[1207]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/6600.
    coneq[1208]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4))-1/2200.
    coneq[1209]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4))-1/825.
    coneq[1210]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4))-1/1650.
    coneq[1211]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4))-1/550.
    coneq[1212]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4))-1/1100.
    coneq[1213]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))-1/4400.
    coneq[1214]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/13200.
    coneq[1215]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/26400.
    coneq[1216]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/8800.
    coneq[1217]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3)))-1/3300.
    coneq[1218]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/6600.
    coneq[1219]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3)))-1/2200.
    coneq[1220]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3)))-1/4400.
    coneq[1221]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/39600.
    coneq[1222]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/79200.
    coneq[1223]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/26400.
    coneq[1224]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/9900.
    coneq[1225]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/19800.
    coneq[1226]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/6600.
    coneq[1227]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/13200.
    coneq[1228]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/158400.
    coneq[1229]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/52800.
    coneq[1230]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/19800.
    coneq[1231]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/39600.
    coneq[1232]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/13200.
    coneq[1233]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/26400.
    coneq[1234]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/17600.
    coneq[1235]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/6600.
    coneq[1236]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/13200.
    coneq[1237]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/4400.
    coneq[1238]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/8800.
    coneq[1239]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/2475.
    coneq[1240]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/4950.
    coneq[1241]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2)))-1/1650.
    coneq[1242]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2)))-1/3300.
    coneq[1243]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/9900.
    coneq[1244]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/3300.
    coneq[1245]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/6600.
    coneq[1246]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))-1/1100.
    coneq[1247]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)))-1/2200.
    coneq[1248]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/4400.
    coneq[1249]=dot(b,dot(A,c**5)*dot(A,c**3))-1/264.
    coneq[1250]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3))-1/1320.
    coneq[1251]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3))-1/5280.
    coneq[1252]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/15840.
    coneq[1253]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/31680.
    coneq[1254]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/10560.
    coneq[1255]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/3960.
    coneq[1256]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/7920.
    coneq[1257]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/2640.
    coneq[1258]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/5280.
    coneq[1259]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3))-1/1056.
    coneq[1260]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3))-1/3168.
    coneq[1261]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/6336.
    coneq[1262]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3))-1/2112.
    coneq[1263]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3))-1/792.
    coneq[1264]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3))-1/1584.
    coneq[1265]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3))-1/528.
    coneq[1266]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3))-1/1584.
    coneq[1267]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3))-1/3168.
    coneq[1268]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3))-1/1056.
    coneq[1269]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2)))-1/792.
    coneq[1270]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2)))-1/3960.
    coneq[1271]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/15840.
    coneq[1272]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/47520.
    coneq[1273]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/95040.
    coneq[1274]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/31680.
    coneq[1275]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/11880.
    coneq[1276]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/23760.
    coneq[1277]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/7920.
    coneq[1278]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/15840.
    coneq[1279]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2)))-1/3168.
    coneq[1280]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/9504.
    coneq[1281]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/19008.
    coneq[1282]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/6336.
    coneq[1283]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2)))-1/2376.
    coneq[1284]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/4752.
    coneq[1285]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2)))-1/1584.
    coneq[1286]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/4752.
    coneq[1287]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/9504.
    coneq[1288]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/3168.
    coneq[1289]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c))))-1/1584.
    coneq[1290]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/7920.
    coneq[1291]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/31680.
    coneq[1292]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/95040.
    coneq[1293]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/190080.
    coneq[1294]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/63360.
    coneq[1295]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/23760.
    coneq[1296]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/47520.
    coneq[1297]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/15840.
    coneq[1298]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/31680.
    coneq[1299]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/6336.
    coneq[1300]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/19008.
    coneq[1301]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/38016.
    coneq[1302]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/12672.
    coneq[1303]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/4752.
    coneq[1304]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/9504.
    coneq[1305]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/3168.
    coneq[1306]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/9504.
    coneq[1307]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/19008.
    coneq[1308]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/6336.
    coneq[1309]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c)))-1/528.
    coneq[1310]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c)))-1/2640.
    coneq[1311]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/10560.
    coneq[1312]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/31680.
    coneq[1313]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/63360.
    coneq[1314]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/21120.
    coneq[1315]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/7920.
    coneq[1316]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/15840.
    coneq[1317]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/5280.
    coneq[1318]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/10560.
    coneq[1319]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c)))-1/2112.
    coneq[1320]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/6336.
    coneq[1321]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/12672.
    coneq[1322]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/4224.
    coneq[1323]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c)))-1/1584.
    coneq[1324]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/3168.
    coneq[1325]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c)))-1/1056.
    coneq[1326]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/3168.
    coneq[1327]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/6336.
    coneq[1328]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/2112.
    coneq[1329]=dot(b,dot(A,c**6)*dot(A,c**2))-1/231.
    coneq[1330]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2))-1/1386.
    coneq[1331]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2))-1/6930.
    coneq[1332]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/27720.
    coneq[1333]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/83160.
    coneq[1334]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/166320.
    coneq[1335]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/55440.
    coneq[1336]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/20790.
    coneq[1337]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/41580.
    coneq[1338]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/13860.
    coneq[1339]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/27720.
    coneq[1340]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/5544.
    coneq[1341]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/16632.
    coneq[1342]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/33264.
    coneq[1343]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/11088.
    coneq[1344]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/4158.
    coneq[1345]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/8316.
    coneq[1346]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/2772.
    coneq[1347]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/8316.
    coneq[1348]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/16632.
    coneq[1349]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/5544.
    coneq[1350]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2))-1/1155.
    coneq[1351]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2))-1/4620.
    coneq[1352]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/13860.
    coneq[1353]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/27720.
    coneq[1354]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/9240.
    coneq[1355]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/3465.
    coneq[1356]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/6930.
    coneq[1357]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/2310.
    coneq[1358]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/4620.
    coneq[1359]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2))-1/924.
    coneq[1360]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2))-1/2772.
    coneq[1361]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/5544.
    coneq[1362]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2))-1/1848.
    coneq[1363]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2))-1/693.
    coneq[1364]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2))-1/1386.
    coneq[1365]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2))-1/462.
    coneq[1366]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/2079.
    coneq[1367]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/4158.
    coneq[1368]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/8316.
    coneq[1369]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2))-1/1848.
    coneq[1370]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/5544.
    coneq[1371]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/11088.
    coneq[1372]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/3696.
    coneq[1373]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/1386.
    coneq[1374]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/2772.
    coneq[1375]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2))-1/924.
    coneq[1376]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2))-1/1848.
    coneq[1377]=dot(b,dot(A,c**6)*dot(A,dot(A,c)))-1/462.
    coneq[1378]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c)))-1/2772.
    coneq[1379]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/13860.
    coneq[1380]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/55440.
    coneq[1381]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/166320.
    coneq[1382]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/332640.
    coneq[1383]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/110880.
    coneq[1384]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/41580.
    coneq[1385]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/83160.
    coneq[1386]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/27720.
    coneq[1387]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/55440.
    coneq[1388]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/11088.
    coneq[1389]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/33264.
    coneq[1390]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/66528.
    coneq[1391]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/22176.
    coneq[1392]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/8316.
    coneq[1393]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/16632.
    coneq[1394]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/5544.
    coneq[1395]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/16632.
    coneq[1396]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/33264.
    coneq[1397]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/11088.
    coneq[1398]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c)))-1/2310.
    coneq[1399]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/9240.
    coneq[1400]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/27720.
    coneq[1401]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/55440.
    coneq[1402]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/18480.
    coneq[1403]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/6930.
    coneq[1404]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/13860.
    coneq[1405]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/4620.
    coneq[1406]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/9240.
    coneq[1407]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c)))-1/1848.
    coneq[1408]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/5544.
    coneq[1409]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/11088.
    coneq[1410]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/3696.
    coneq[1411]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c)))-1/1386.
    coneq[1412]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/2772.
    coneq[1413]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c)))-1/924.
    coneq[1414]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/4158.
    coneq[1415]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/8316.
    coneq[1416]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/16632.
    coneq[1417]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)))-1/3696.
    coneq[1418]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/11088.
    coneq[1419]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/22176.
    coneq[1420]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/7392.
    coneq[1421]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/2772.
    coneq[1422]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/5544.
    coneq[1423]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/1848.
    coneq[1424]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/3696.
    coneq[1425]=dot(b,dot(A,c**7)*dot(A,c))-1/176.
    coneq[1426]=dot(b,dot(A,dot(A,c**6))*dot(A,c))-1/1232.
    coneq[1427]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c))-1/7392.
    coneq[1428]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/36960.
    coneq[1429]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/147840.
    coneq[1430]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/443520.
    coneq[1431]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/887040.
    coneq[1432]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/295680.
    coneq[1433]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/110880.
    coneq[1434]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/221760.
    coneq[1435]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/73920.
    coneq[1436]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/147840.
    coneq[1437]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/29568.
    coneq[1438]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/88704.
    coneq[1439]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/177408.
    coneq[1440]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/59136.
    coneq[1441]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/22176.
    coneq[1442]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/44352.
    coneq[1443]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/14784.
    coneq[1444]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/44352.
    coneq[1445]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/88704.
    coneq[1446]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/29568.
    coneq[1447]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c))-1/6160.
    coneq[1448]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/24640.
    coneq[1449]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/73920.
    coneq[1450]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/147840.
    coneq[1451]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/49280.
    coneq[1452]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/18480.
    coneq[1453]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/36960.
    coneq[1454]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/12320.
    coneq[1455]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/24640.
    coneq[1456]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/4928.
    coneq[1457]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/14784.
    coneq[1458]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/29568.
    coneq[1459]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/9856.
    coneq[1460]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/3696.
    coneq[1461]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/7392.
    coneq[1462]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c))-1/2464.
    coneq[1463]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/11088.
    coneq[1464]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/22176.
    coneq[1465]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[1466]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/9856.
    coneq[1467]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/29568.
    coneq[1468]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/59136.
    coneq[1469]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/19712.
    coneq[1470]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/7392.
    coneq[1471]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/14784.
    coneq[1472]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/4928.
    coneq[1473]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/9856.
    coneq[1474]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c))-1/1056.
    coneq[1475]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c))-1/5280.
    coneq[1476]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/21120.
    coneq[1477]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/63360.
    coneq[1478]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/126720.
    coneq[1479]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/42240.
    coneq[1480]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/15840.
    coneq[1481]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/31680.
    coneq[1482]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/10560.
    coneq[1483]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/21120.
    coneq[1484]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c))-1/4224.
    coneq[1485]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/12672.
    coneq[1486]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/25344.
    coneq[1487]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/8448.
    coneq[1488]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/3168.
    coneq[1489]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/6336.
    coneq[1490]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c))-1/2112.
    coneq[1491]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/6336.
    coneq[1492]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/12672.
    coneq[1493]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/4224.
    coneq[1494]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c))-1/880.
    coneq[1495]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c))-1/3520.
    coneq[1496]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/10560.
    coneq[1497]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/21120.
    coneq[1498]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/7040.
    coneq[1499]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c))-1/2640.
    coneq[1500]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/5280.
    coneq[1501]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c))-1/1760.
    coneq[1502]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/3520.
    coneq[1503]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c))-1/704.
    coneq[1504]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c))-1/2112.
    coneq[1505]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/4224.
    coneq[1506]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c))-1/1408.
    coneq[1507]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c))-1/528.
    coneq[1508]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c))-1/1056.
    coneq[1509]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c))-1/352.
    coneq[1510]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/2112.
    coneq[1511]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/6336.
    coneq[1512]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/12672.
    coneq[1513]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/4224.
    coneq[1514]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/4224.
    coneq[1515]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/12672.
    coneq[1516]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/25344.
    coneq[1517]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/8448.
    coneq[1518]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c))-1/1760.
    coneq[1519]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c))-1/7040.
    coneq[1520]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/21120.
    coneq[1521]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/42240.
    coneq[1522]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/14080.
    coneq[1523]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/5280.
    coneq[1524]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/10560.
    coneq[1525]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/3520.
    coneq[1526]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/7040.
    coneq[1527]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/1584.
    coneq[1528]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/3168.
    coneq[1529]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/6336.
    coneq[1530]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c))-1/1408.
    coneq[1531]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/4224.
    coneq[1532]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/8448.
    coneq[1533]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/2816.
    coneq[1534]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c))-1/1056.
    coneq[1535]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/2112.
    coneq[1536]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c))-1/704.
    coneq[1537]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c))-1/2112.
    coneq[1538]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/4224.
    coneq[1539]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/1408.
    coneq[1540]=dot(b,dot(A,c**4)*dot(A,c**3)*c)-1/220.
    coneq[1541]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*c)-1/880.
    coneq[1542]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/2640.
    coneq[1543]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/5280.
    coneq[1544]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/1760.
    coneq[1545]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*c)-1/660.
    coneq[1546]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/1320.
    coneq[1547]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*c)-1/440.
    coneq[1548]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*c)-1/880.
    coneq[1549]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*c)-1/660.
    coneq[1550]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/2640.
    coneq[1551]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/7920.
    coneq[1552]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/15840.
    coneq[1553]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/5280.
    coneq[1554]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/1980.
    coneq[1555]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/3960.
    coneq[1556]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*c)-1/1320.
    coneq[1557]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c)-1/2640.
    coneq[1558]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*c)-1/1320.
    coneq[1559]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/5280.
    coneq[1560]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/15840.
    coneq[1561]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/31680.
    coneq[1562]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/10560.
    coneq[1563]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/3960.
    coneq[1564]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/7920.
    coneq[1565]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/2640.
    coneq[1566]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/5280.
    coneq[1567]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*c)-1/440.
    coneq[1568]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/1760.
    coneq[1569]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/5280.
    coneq[1570]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/10560.
    coneq[1571]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/3520.
    coneq[1572]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/1320.
    coneq[1573]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/2640.
    coneq[1574]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*c)-1/880.
    coneq[1575]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c)-1/1760.
    coneq[1576]=dot(b,dot(A,c**5)*dot(A,c**2)*c)-1/198.
    coneq[1577]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*c)-1/990.
    coneq[1578]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/3960.
    coneq[1579]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/11880.
    coneq[1580]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/23760.
    coneq[1581]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/7920.
    coneq[1582]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/2970.
    coneq[1583]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/5940.
    coneq[1584]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/1980.
    coneq[1585]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/3960.
    coneq[1586]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*c)-1/792.
    coneq[1587]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/2376.
    coneq[1588]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/4752.
    coneq[1589]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/1584.
    coneq[1590]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*c)-1/594.
    coneq[1591]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/1188.
    coneq[1592]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*c)-1/396.
    coneq[1593]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*c)-1/1188.
    coneq[1594]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/2376.
    coneq[1595]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/792.
    coneq[1596]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*c)-1/396.
    coneq[1597]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*c)-1/1980.
    coneq[1598]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/7920.
    coneq[1599]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/23760.
    coneq[1600]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/47520.
    coneq[1601]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/15840.
    coneq[1602]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/5940.
    coneq[1603]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/11880.
    coneq[1604]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/3960.
    coneq[1605]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/7920.
    coneq[1606]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*c)-1/1584.
    coneq[1607]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/4752.
    coneq[1608]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/9504.
    coneq[1609]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/3168.
    coneq[1610]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*c)-1/1188.
    coneq[1611]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/2376.
    coneq[1612]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*c)-1/792.
    coneq[1613]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/2376.
    coneq[1614]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/4752.
    coneq[1615]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/1584.
    coneq[1616]=dot(b,dot(A,c**6)*dot(A,c)*c)-1/154.
    coneq[1617]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*c)-1/924.
    coneq[1618]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*c)-1/4620.
    coneq[1619]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/18480.
    coneq[1620]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/55440.
    coneq[1621]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/110880.
    coneq[1622]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/36960.
    coneq[1623]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/13860.
    coneq[1624]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/27720.
    coneq[1625]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/9240.
    coneq[1626]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/18480.
    coneq[1627]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/3696.
    coneq[1628]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/11088.
    coneq[1629]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/22176.
    coneq[1630]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/7392.
    coneq[1631]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/2772.
    coneq[1632]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/5544.
    coneq[1633]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/1848.
    coneq[1634]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/5544.
    coneq[1635]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/11088.
    coneq[1636]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/3696.
    coneq[1637]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*c)-1/770.
    coneq[1638]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/3080.
    coneq[1639]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/9240.
    coneq[1640]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/18480.
    coneq[1641]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/6160.
    coneq[1642]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/2310.
    coneq[1643]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/4620.
    coneq[1644]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/1540.
    coneq[1645]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/3080.
    coneq[1646]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*c)-1/616.
    coneq[1647]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/1848.
    coneq[1648]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/3696.
    coneq[1649]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/1232.
    coneq[1650]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*c)-1/462.
    coneq[1651]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*c)-1/924.
    coneq[1652]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*c)-1/308.
    coneq[1653]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/1386.
    coneq[1654]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/2772.
    coneq[1655]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/5544.
    coneq[1656]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*c)-1/1232.
    coneq[1657]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/3696.
    coneq[1658]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/7392.
    coneq[1659]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/2464.
    coneq[1660]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/924.
    coneq[1661]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/1848.
    coneq[1662]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/616.
    coneq[1663]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/1232.
    coneq[1664]=dot(b,dot(A,c**3)*dot(A,c**3)*c*c)-1/176.
    coneq[1665]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*c*c)-1/528.
    coneq[1666]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/1056.
    coneq[1667]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*c*c)-1/352.
    coneq[1668]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/1584.
    coneq[1669]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/3168.
    coneq[1670]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/1056.
    coneq[1671]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/6336.
    coneq[1672]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/2112.
    coneq[1673]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/704.
    coneq[1674]=dot(b,dot(A,c**4)*dot(A,c**2)*c*c)-1/165.
    coneq[1675]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*c*c)-1/660.
    coneq[1676]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/1980.
    coneq[1677]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/3960.
    coneq[1678]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/1320.
    coneq[1679]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*c*c)-1/495.
    coneq[1680]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/990.
    coneq[1681]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*c*c)-1/330.
    coneq[1682]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*c*c)-1/660.
    coneq[1683]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*c*c)-1/330.
    coneq[1684]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/1320.
    coneq[1685]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/3960.
    coneq[1686]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/7920.
    coneq[1687]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/2640.
    coneq[1688]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/990.
    coneq[1689]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/1980.
    coneq[1690]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*c*c)-1/660.
    coneq[1691]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c*c)-1/1320.
    coneq[1692]=dot(b,dot(A,c**5)*dot(A,c)*c*c)-1/132.
    coneq[1693]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*c*c)-1/660.
    coneq[1694]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/2640.
    coneq[1695]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/7920.
    coneq[1696]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/15840.
    coneq[1697]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/5280.
    coneq[1698]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/1980.
    coneq[1699]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/3960.
    coneq[1700]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/1320.
    coneq[1701]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/2640.
    coneq[1702]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*c*c)-1/528.
    coneq[1703]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/1584.
    coneq[1704]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/3168.
    coneq[1705]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/1056.
    coneq[1706]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*c*c)-1/396.
    coneq[1707]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/792.
    coneq[1708]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*c*c)-1/264.
    coneq[1709]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*c*c)-1/792.
    coneq[1710]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/1584.
    coneq[1711]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/528.
    coneq[1712]=dot(b,dot(A,c**3)*dot(A,c**2)*c**3)-1/132.
    coneq[1713]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*c**3)-1/396.
    coneq[1714]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/792.
    coneq[1715]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*c**3)-1/264.
    coneq[1716]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*c**3)-1/264.
    coneq[1717]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/792.
    coneq[1718]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/1584.
    coneq[1719]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*c**3)-1/528.
    coneq[1720]=dot(b,dot(A,c**4)*dot(A,c)*c**3)-1/110.
    coneq[1721]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*c**3)-1/440.
    coneq[1722]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/1320.
    coneq[1723]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/2640.
    coneq[1724]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/880.
    coneq[1725]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*c**3)-1/330.
    coneq[1726]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/660.
    coneq[1727]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*c**3)-1/220.
    coneq[1728]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c**3)-1/440.
    coneq[1729]=dot(b,dot(A,c**2)*dot(A,c**2)*c**4)-1/99.
    coneq[1730]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c**4)-1/198.
    coneq[1731]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c**4)-1/396.
    coneq[1732]=dot(b,dot(A,c**3)*dot(A,c)*c**4)-1/88.
    coneq[1733]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c**4)-1/264.
    coneq[1734]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c**4)-1/528.
    coneq[1735]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c**4)-1/176.
    coneq[1736]=dot(b,dot(A,c**2)*dot(A,c)*c**5)-1/66.
    coneq[1737]=dot(b,dot(A,dot(A,c))*dot(A,c)*c**5)-1/132.
    coneq[1738]=dot(b,dot(A,c)*dot(A,c)*c**6)-1/44.
    coneq[1739]=dot(b,dot(A,c**5)*dot(A,c)*dot(A,c))-1/264.
    coneq[1740]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*dot(A,c))-1/1320.
    coneq[1741]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/5280.
    coneq[1742]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/15840.
    coneq[1743]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/31680.
    coneq[1744]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/10560.
    coneq[1745]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/3960.
    coneq[1746]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/7920.
    coneq[1747]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/2640.
    coneq[1748]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/5280.
    coneq[1749]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*dot(A,c))-1/1056.
    coneq[1750]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/3168.
    coneq[1751]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/6336.
    coneq[1752]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/2112.
    coneq[1753]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*dot(A,c))-1/792.
    coneq[1754]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/1584.
    coneq[1755]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*dot(A,c))-1/528.
    coneq[1756]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/1584.
    coneq[1757]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/3168.
    coneq[1758]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/1056.
    coneq[1759]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c))-1/330.
    coneq[1760]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/1320.
    coneq[1761]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/3960.
    coneq[1762]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/7920.
    coneq[1763]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/2640.
    coneq[1764]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/990.
    coneq[1765]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/1980.
    coneq[1766]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c))-1/660.
    coneq[1767]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c))-1/1320.
    coneq[1768]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c))-1/660.
    coneq[1769]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/2640.
    coneq[1770]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/7920.
    coneq[1771]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/15840.
    coneq[1772]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/5280.
    coneq[1773]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/1980.
    coneq[1774]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/3960.
    coneq[1775]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/1320.
    coneq[1776]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/2640.
    coneq[1777]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2))-1/396.
    coneq[1778]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/1188.
    coneq[1779]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/2376.
    coneq[1780]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/792.
    coneq[1781]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2))-1/792.
    coneq[1782]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/2376.
    coneq[1783]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/4752.
    coneq[1784]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/1584.
    coneq[1785]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/1584.
    coneq[1786]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/4752.
    coneq[1787]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/9504.
    coneq[1788]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/3168.
    coneq[1789]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c))-1/352.
    coneq[1790]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/1056.
    coneq[1791]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/2112.
    coneq[1792]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c))-1/704.
    coneq[1793]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/3168.
    coneq[1794]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/6336.
    coneq[1795]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/2112.
    coneq[1796]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/12672.
    coneq[1797]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/4224.
    coneq[1798]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/1408.
    coneq[1799]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*c)-1/220.
    coneq[1800]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/880.
    coneq[1801]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/2640.
    coneq[1802]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/5280.
    coneq[1803]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/1760.
    coneq[1804]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/660.
    coneq[1805]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/1320.
    coneq[1806]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/440.
    coneq[1807]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/880.
    coneq[1808]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*c)-1/264.
    coneq[1809]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/792.
    coneq[1810]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/1584.
    coneq[1811]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/528.
    coneq[1812]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*c)-1/528.
    coneq[1813]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/1584.
    coneq[1814]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/3168.
    coneq[1815]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/1056.
    coneq[1816]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*c)-1/297.
    coneq[1817]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/594.
    coneq[1818]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/1188.
    coneq[1819]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/2376.
    coneq[1820]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*c*c)-1/176.
    coneq[1821]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/528.
    coneq[1822]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/1056.
    coneq[1823]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/352.
    coneq[1824]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*c*c)-1/198.
    coneq[1825]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/396.
    coneq[1826]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/792.
    coneq[1827]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*c**3)-1/132.
    coneq[1828]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/264.
    coneq[1829]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c**4)-1/88.
    coneq[1830]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*dot(A,c))-1/352.
    coneq[1831]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/1056.
    coneq[1832]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/2112.
    coneq[1833]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/704.
    coneq[1834]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*dot(A,c))-1/396.
    coneq[1835]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/792.
    coneq[1836]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/792.
    coneq[1837]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/1584.
    coneq[1838]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/264.
    coneq[1839]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/528.
    coneq[1840]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/176.
    coneq[1841]=dot(b,c**10)-1/11.
    if any(abs(coneq)>tol):
        return 10
    # order 12 conditions:
    coneq[0]=dot(b,dot(A,c**10))-1/132.
    coneq[1]=dot(b,dot(A,dot(A,c**9)))-1/1320.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**8))))-1/11880.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**7)))))-1/95040.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**6))))))-1/665280.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/3991680.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/19958400.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/79833600.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/239500800.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/479001600.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/159667200.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/59875200.
    coneq[12]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/119750400.
    coneq[13]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/39916800.
    coneq[14]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/79833600.
    coneq[15]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/15966720.
    coneq[16]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/47900160.
    coneq[17]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/95800320.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/31933440.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/11975040.
    coneq[20]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/23950080.
    coneq[21]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/7983360.
    coneq[22]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/23950080.
    coneq[23]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/47900160.
    coneq[24]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/15966720.
    coneq[25]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/3326400.
    coneq[26]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/13305600.
    coneq[27]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/39916800.
    coneq[28]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/79833600.
    coneq[29]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/26611200.
    coneq[30]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/9979200.
    coneq[31]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/19958400.
    coneq[32]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/6652800.
    coneq[33]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/13305600.
    coneq[34]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/2661120.
    coneq[35]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/7983360.
    coneq[36]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/15966720.
    coneq[37]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/5322240.
    coneq[38]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/1995840.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/3991680.
    coneq[40]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/1330560.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/5987520.
    coneq[42]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/11975040.
    coneq[43]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/23950080.
    coneq[44]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/5322240.
    coneq[45]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/15966720.
    coneq[46]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/31933440.
    coneq[47]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/10644480.
    coneq[48]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/3991680.
    coneq[49]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/7983360.
    coneq[50]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/2661120.
    coneq[51]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/5322240.
    coneq[52]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5))))))-1/570240.
    coneq[53]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/2851200.
    coneq[54]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/11404800.
    coneq[55]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/34214400.
    coneq[56]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/68428800.
    coneq[57]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/22809600.
    coneq[58]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/8553600.
    coneq[59]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/17107200.
    coneq[60]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/5702400.
    coneq[61]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/11404800.
    coneq[62]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/2280960.
    coneq[63]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/6842880.
    coneq[64]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/13685760.
    coneq[65]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/4561920.
    coneq[66]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/1710720.
    coneq[67]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/3421440.
    coneq[68]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1140480.
    coneq[69]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/3421440.
    coneq[70]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/6842880.
    coneq[71]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/2280960.
    coneq[72]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))))-1/475200.
    coneq[73]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/1900800.
    coneq[74]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/5702400.
    coneq[75]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11404800.
    coneq[76]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/3801600.
    coneq[77]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/1425600.
    coneq[78]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/2851200.
    coneq[79]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/950400.
    coneq[80]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/1900800.
    coneq[81]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))))-1/380160.
    coneq[82]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1140480.
    coneq[83]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/2280960.
    coneq[84]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/760320.
    coneq[85]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))))-1/285120.
    coneq[86]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/570240.
    coneq[87]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c))))))-1/190080.
    coneq[88]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1140480.
    coneq[89]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/3421440.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/6842880.
    coneq[91]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/2280960.
    coneq[92]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/2280960.
    coneq[93]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/6842880.
    coneq[94]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/13685760.
    coneq[95]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/4561920.
    coneq[96]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/950400.
    coneq[97]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/3801600.
    coneq[98]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/11404800.
    coneq[99]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/22809600.
    coneq[100]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/7603200.
    coneq[101]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/2851200.
    coneq[102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/5702400.
    coneq[103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/1900800.
    coneq[104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/3801600.
    coneq[105]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/855360.
    coneq[106]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/1710720.
    coneq[107]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3421440.
    coneq[108]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/760320.
    coneq[109]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/2280960.
    coneq[110]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/4561920.
    coneq[111]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/1520640.
    coneq[112]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/570240.
    coneq[113]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1140480.
    coneq[114]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/380160.
    coneq[115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1140480.
    coneq[116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/2280960.
    coneq[117]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/760320.
    coneq[118]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**6)))))-1/83160.
    coneq[119]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5))))))-1/498960.
    coneq[120]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/2494800.
    coneq[121]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/9979200.
    coneq[122]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/29937600.
    coneq[123]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/59875200.
    coneq[124]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/19958400.
    coneq[125]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/7484400.
    coneq[126]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/14968800.
    coneq[127]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/4989600.
    coneq[128]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/9979200.
    coneq[129]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/1995840.
    coneq[130]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/5987520.
    coneq[131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/11975040.
    coneq[132]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/3991680.
    coneq[133]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1496880.
    coneq[134]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/2993760.
    coneq[135]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/997920.
    coneq[136]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/2993760.
    coneq[137]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/5987520.
    coneq[138]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/1995840.
    coneq[139]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))))-1/415800.
    coneq[140]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/1663200.
    coneq[141]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/4989600.
    coneq[142]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/9979200.
    coneq[143]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/3326400.
    coneq[144]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1247400.
    coneq[145]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2494800.
    coneq[146]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/831600.
    coneq[147]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1663200.
    coneq[148]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/332640.
    coneq[149]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/997920.
    coneq[150]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/1995840.
    coneq[151]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/665280.
    coneq[152]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/249480.
    coneq[153]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/498960.
    coneq[154]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))))-1/166320.
    coneq[155]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/748440.
    coneq[156]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1496880.
    coneq[157]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/2993760.
    coneq[158]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/665280.
    coneq[159]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/1995840.
    coneq[160]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/3991680.
    coneq[161]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1330560.
    coneq[162]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/498960.
    coneq[163]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/997920.
    coneq[164]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/332640.
    coneq[165]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/665280.
    coneq[166]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**5)))))-1/71280.
    coneq[167]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))))-1/356400.
    coneq[168]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/1425600.
    coneq[169]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4276800.
    coneq[170]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/8553600.
    coneq[171]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2851200.
    coneq[172]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/1069200.
    coneq[173]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2138400.
    coneq[174]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/712800.
    coneq[175]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1425600.
    coneq[176]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/285120.
    coneq[177]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/855360.
    coneq[178]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1710720.
    coneq[179]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/570240.
    coneq[180]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/213840.
    coneq[181]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/427680.
    coneq[182]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/142560.
    coneq[183]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/427680.
    coneq[184]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/855360.
    coneq[185]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/285120.
    coneq[186]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**4)))))-1/59400.
    coneq[187]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))))-1/237600.
    coneq[188]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/712800.
    coneq[189]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1425600.
    coneq[190]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/475200.
    coneq[191]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/178200.
    coneq[192]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/356400.
    coneq[193]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/118800.
    coneq[194]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/237600.
    coneq[195]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**3)))))-1/47520.
    coneq[196]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))))-1/142560.
    coneq[197]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/285120.
    coneq[198]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))))-1/95040.
    coneq[199]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**2)))))-1/35640.
    coneq[200]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c))))))-1/71280.
    coneq[201]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c)))))-1/23760.
    coneq[202]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))))-1/190080.
    coneq[203]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/570240.
    coneq[204]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1140480.
    coneq[205]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/380160.
    coneq[206]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/1710720.
    coneq[207]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/3421440.
    coneq[208]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1140480.
    coneq[209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/6842880.
    coneq[210]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/2280960.
    coneq[211]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/760320.
    coneq[212]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))))-1/178200.
    coneq[213]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/712800.
    coneq[214]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/2138400.
    coneq[215]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4276800.
    coneq[216]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/1425600.
    coneq[217]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/534600.
    coneq[218]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1069200.
    coneq[219]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/356400.
    coneq[220]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/712800.
    coneq[221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/356400.
    coneq[222]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/1425600.
    coneq[223]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/4276800.
    coneq[224]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8553600.
    coneq[225]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/2851200.
    coneq[226]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1069200.
    coneq[227]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/2138400.
    coneq[228]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/712800.
    coneq[229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/1425600.
    coneq[230]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5)))))-1/142560.
    coneq[231]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/712800.
    coneq[232]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/2851200.
    coneq[233]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/8553600.
    coneq[234]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/17107200.
    coneq[235]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5702400.
    coneq[236]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/2138400.
    coneq[237]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4276800.
    coneq[238]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/1425600.
    coneq[239]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2851200.
    coneq[240]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/570240.
    coneq[241]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/1710720.
    coneq[242]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3421440.
    coneq[243]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1140480.
    coneq[244]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/427680.
    coneq[245]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/855360.
    coneq[246]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/285120.
    coneq[247]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/855360.
    coneq[248]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1710720.
    coneq[249]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/570240.
    coneq[250]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/142560.
    coneq[251]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/427680.
    coneq[252]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/855360.
    coneq[253]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/285120.
    coneq[254]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/285120.
    coneq[255]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/855360.
    coneq[256]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1710720.
    coneq[257]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/570240.
    coneq[258]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))))-1/118800.
    coneq[259]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/475200.
    coneq[260]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1425600.
    coneq[261]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2851200.
    coneq[262]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/950400.
    coneq[263]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/356400.
    coneq[264]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/712800.
    coneq[265]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/237600.
    coneq[266]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/475200.
    coneq[267]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/106920.
    coneq[268]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/213840.
    coneq[269]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/427680.
    coneq[270]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/95040.
    coneq[271]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/285120.
    coneq[272]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/570240.
    coneq[273]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/190080.
    coneq[274]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/71280.
    coneq[275]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/142560.
    coneq[276]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))))-1/47520.
    coneq[277]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/190080.
    coneq[278]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/570240.
    coneq[279]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1140480.
    coneq[280]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/380160.
    coneq[281]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/213840.
    coneq[282]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/427680.
    coneq[283]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/855360.
    coneq[284]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/142560.
    coneq[285]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/285120.
    coneq[286]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/95040.
    coneq[287]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/190080.
    coneq[288]=dot(b,dot(A,dot(A,c*dot(A,c**7))))-1/10560.
    coneq[289]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**6)))))-1/73920.
    coneq[290]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5))))))-1/443520.
    coneq[291]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/2217600.
    coneq[292]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/8870400.
    coneq[293]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/26611200.
    coneq[294]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/53222400.
    coneq[295]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/17740800.
    coneq[296]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/6652800.
    coneq[297]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/13305600.
    coneq[298]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/4435200.
    coneq[299]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/8870400.
    coneq[300]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/1774080.
    coneq[301]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/5322240.
    coneq[302]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/10644480.
    coneq[303]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/3548160.
    coneq[304]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1330560.
    coneq[305]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/2661120.
    coneq[306]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/887040.
    coneq[307]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/2661120.
    coneq[308]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/5322240.
    coneq[309]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/1774080.
    coneq[310]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))))-1/369600.
    coneq[311]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1478400.
    coneq[312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/4435200.
    coneq[313]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/8870400.
    coneq[314]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/2956800.
    coneq[315]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1108800.
    coneq[316]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2217600.
    coneq[317]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/739200.
    coneq[318]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1478400.
    coneq[319]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))))-1/295680.
    coneq[320]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/887040.
    coneq[321]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/1774080.
    coneq[322]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/591360.
    coneq[323]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))))-1/221760.
    coneq[324]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/443520.
    coneq[325]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))))-1/147840.
    coneq[326]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/665280.
    coneq[327]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1330560.
    coneq[328]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/2661120.
    coneq[329]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/591360.
    coneq[330]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/1774080.
    coneq[331]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/3548160.
    coneq[332]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1182720.
    coneq[333]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/443520.
    coneq[334]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/887040.
    coneq[335]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/295680.
    coneq[336]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/591360.
    coneq[337]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**5)))))-1/63360.
    coneq[338]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))))-1/316800.
    coneq[339]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1267200.
    coneq[340]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3801600.
    coneq[341]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/7603200.
    coneq[342]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2534400.
    coneq[343]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/950400.
    coneq[344]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1900800.
    coneq[345]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/633600.
    coneq[346]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1267200.
    coneq[347]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))))-1/253440.
    coneq[348]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/760320.
    coneq[349]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1520640.
    coneq[350]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/506880.
    coneq[351]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/190080.
    coneq[352]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/380160.
    coneq[353]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))))-1/126720.
    coneq[354]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/380160.
    coneq[355]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/760320.
    coneq[356]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/253440.
    coneq[357]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4)))))-1/52800.
    coneq[358]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))))-1/211200.
    coneq[359]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/633600.
    coneq[360]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1267200.
    coneq[361]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/422400.
    coneq[362]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/158400.
    coneq[363]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/316800.
    coneq[364]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/105600.
    coneq[365]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/211200.
    coneq[366]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3)))))-1/42240.
    coneq[367]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))))-1/126720.
    coneq[368]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/253440.
    coneq[369]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))))-1/84480.
    coneq[370]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2)))))-1/31680.
    coneq[371]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))))-1/63360.
    coneq[372]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c)))))-1/21120.
    coneq[373]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/126720.
    coneq[374]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/380160.
    coneq[375]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/760320.
    coneq[376]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/253440.
    coneq[377]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/253440.
    coneq[378]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/760320.
    coneq[379]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1520640.
    coneq[380]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/506880.
    coneq[381]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))))-1/105600.
    coneq[382]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/422400.
    coneq[383]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1267200.
    coneq[384]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2534400.
    coneq[385]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/844800.
    coneq[386]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/316800.
    coneq[387]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/633600.
    coneq[388]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/211200.
    coneq[389]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/422400.
    coneq[390]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/95040.
    coneq[391]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/190080.
    coneq[392]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/380160.
    coneq[393]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/84480.
    coneq[394]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/253440.
    coneq[395]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/506880.
    coneq[396]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/168960.
    coneq[397]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/63360.
    coneq[398]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/126720.
    coneq[399]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/42240.
    coneq[400]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/126720.
    coneq[401]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/253440.
    coneq[402]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/84480.
    coneq[403]=dot(b,dot(A,dot(A,c**2*dot(A,c**6))))-1/9240.
    coneq[404]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**5)))))-1/55440.
    coneq[405]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))))-1/277200.
    coneq[406]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1108800.
    coneq[407]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3326400.
    coneq[408]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/6652800.
    coneq[409]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2217600.
    coneq[410]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/831600.
    coneq[411]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1663200.
    coneq[412]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/554400.
    coneq[413]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1108800.
    coneq[414]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))))-1/221760.
    coneq[415]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/665280.
    coneq[416]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1330560.
    coneq[417]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/443520.
    coneq[418]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))))-1/166320.
    coneq[419]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/332640.
    coneq[420]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))))-1/110880.
    coneq[421]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/332640.
    coneq[422]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/665280.
    coneq[423]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/221760.
    coneq[424]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4)))))-1/46200.
    coneq[425]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))))-1/184800.
    coneq[426]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/554400.
    coneq[427]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1108800.
    coneq[428]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/369600.
    coneq[429]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))))-1/138600.
    coneq[430]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/277200.
    coneq[431]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))))-1/92400.
    coneq[432]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/184800.
    coneq[433]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3)))))-1/36960.
    coneq[434]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))))-1/110880.
    coneq[435]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/221760.
    coneq[436]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))))-1/73920.
    coneq[437]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2)))))-1/27720.
    coneq[438]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))))-1/55440.
    coneq[439]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c)))))-1/18480.
    coneq[440]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/83160.
    coneq[441]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/166320.
    coneq[442]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/332640.
    coneq[443]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))))-1/73920.
    coneq[444]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/221760.
    coneq[445]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/443520.
    coneq[446]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/147840.
    coneq[447]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/55440.
    coneq[448]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/110880.
    coneq[449]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/36960.
    coneq[450]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/73920.
    coneq[451]=dot(b,dot(A,dot(A,c**3*dot(A,c**5))))-1/7920.
    coneq[452]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**4)))))-1/39600.
    coneq[453]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))))-1/158400.
    coneq[454]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/475200.
    coneq[455]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/950400.
    coneq[456]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/316800.
    coneq[457]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))))-1/118800.
    coneq[458]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/237600.
    coneq[459]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))))-1/79200.
    coneq[460]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/158400.
    coneq[461]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3)))))-1/31680.
    coneq[462]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))))-1/95040.
    coneq[463]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/190080.
    coneq[464]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))))-1/63360.
    coneq[465]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2)))))-1/23760.
    coneq[466]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))))-1/47520.
    coneq[467]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c)))))-1/15840.
    coneq[468]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))))-1/47520.
    coneq[469]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/95040.
    coneq[470]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))))-1/31680.
    coneq[471]=dot(b,dot(A,dot(A,c**4*dot(A,c**4))))-1/6600.
    coneq[472]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**3)))))-1/26400.
    coneq[473]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))))-1/79200.
    coneq[474]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))))-1/158400.
    coneq[475]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))))-1/52800.
    coneq[476]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2)))))-1/19800.
    coneq[477]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))))-1/39600.
    coneq[478]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c)))))-1/13200.
    coneq[479]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))))-1/26400.
    coneq[480]=dot(b,dot(A,dot(A,c**5*dot(A,c**3))))-1/5280.
    coneq[481]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**2)))))-1/15840.
    coneq[482]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c))))))-1/31680.
    coneq[483]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c)))))-1/10560.
    coneq[484]=dot(b,dot(A,dot(A,c**6*dot(A,c**2))))-1/3960.
    coneq[485]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c)))))-1/7920.
    coneq[486]=dot(b,dot(A,dot(A,c**7*dot(A,c))))-1/2640.
    coneq[487]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**4))))-1/26400.
    coneq[488]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))))-1/105600.
    coneq[489]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/316800.
    coneq[490]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/633600.
    coneq[491]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/211200.
    coneq[492]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/79200.
    coneq[493]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/158400.
    coneq[494]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/52800.
    coneq[495]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/105600.
    coneq[496]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))))-1/79200.
    coneq[497]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/316800.
    coneq[498]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/950400.
    coneq[499]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1900800.
    coneq[500]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/633600.
    coneq[501]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/237600.
    coneq[502]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/475200.
    coneq[503]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/158400.
    coneq[504]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/316800.
    coneq[505]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/158400.
    coneq[506]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/633600.
    coneq[507]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/1900800.
    coneq[508]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3801600.
    coneq[509]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/1267200.
    coneq[510]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/475200.
    coneq[511]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/950400.
    coneq[512]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/316800.
    coneq[513]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/633600.
    coneq[514]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))))-1/52800.
    coneq[515]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/211200.
    coneq[516]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/633600.
    coneq[517]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1267200.
    coneq[518]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/422400.
    coneq[519]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/158400.
    coneq[520]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/316800.
    coneq[521]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/105600.
    coneq[522]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/211200.
    coneq[523]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**5))))-1/23760.
    coneq[524]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))))-1/118800.
    coneq[525]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/475200.
    coneq[526]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1425600.
    coneq[527]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2851200.
    coneq[528]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/950400.
    coneq[529]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/356400.
    coneq[530]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/712800.
    coneq[531]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/237600.
    coneq[532]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/475200.
    coneq[533]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/95040.
    coneq[534]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/285120.
    coneq[535]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/570240.
    coneq[536]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/190080.
    coneq[537]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/71280.
    coneq[538]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/142560.
    coneq[539]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/47520.
    coneq[540]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/142560.
    coneq[541]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/285120.
    coneq[542]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/95040.
    coneq[543]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5))))-1/47520.
    coneq[544]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/237600.
    coneq[545]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/950400.
    coneq[546]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2851200.
    coneq[547]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5702400.
    coneq[548]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1900800.
    coneq[549]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/712800.
    coneq[550]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1425600.
    coneq[551]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/475200.
    coneq[552]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/950400.
    coneq[553]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/190080.
    coneq[554]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/570240.
    coneq[555]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1140480.
    coneq[556]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/380160.
    coneq[557]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/142560.
    coneq[558]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/285120.
    coneq[559]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/95040.
    coneq[560]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/285120.
    coneq[561]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/570240.
    coneq[562]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/190080.
    coneq[563]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**6))))-1/18480.
    coneq[564]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5)))))-1/110880.
    coneq[565]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/554400.
    coneq[566]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2217600.
    coneq[567]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/6652800.
    coneq[568]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/13305600.
    coneq[569]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4435200.
    coneq[570]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1663200.
    coneq[571]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3326400.
    coneq[572]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1108800.
    coneq[573]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2217600.
    coneq[574]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/443520.
    coneq[575]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1330560.
    coneq[576]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2661120.
    coneq[577]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/887040.
    coneq[578]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/332640.
    coneq[579]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/665280.
    coneq[580]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/221760.
    coneq[581]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/665280.
    coneq[582]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1330560.
    coneq[583]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/443520.
    coneq[584]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))))-1/92400.
    coneq[585]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/369600.
    coneq[586]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1108800.
    coneq[587]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2217600.
    coneq[588]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/739200.
    coneq[589]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/277200.
    coneq[590]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/554400.
    coneq[591]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/184800.
    coneq[592]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/369600.
    coneq[593]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/73920.
    coneq[594]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/221760.
    coneq[595]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/443520.
    coneq[596]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/147840.
    coneq[597]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/55440.
    coneq[598]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/110880.
    coneq[599]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))))-1/36960.
    coneq[600]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/166320.
    coneq[601]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/332640.
    coneq[602]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/665280.
    coneq[603]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/147840.
    coneq[604]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/443520.
    coneq[605]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/887040.
    coneq[606]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/295680.
    coneq[607]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/110880.
    coneq[608]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/221760.
    coneq[609]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/73920.
    coneq[610]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/147840.
    coneq[611]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3))))-1/21120.
    coneq[612]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/63360.
    coneq[613]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/126720.
    coneq[614]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/42240.
    coneq[615]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/190080.
    coneq[616]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/380160.
    coneq[617]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/126720.
    coneq[618]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/760320.
    coneq[619]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/253440.
    coneq[620]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/84480.
    coneq[621]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4))))-1/19800.
    coneq[622]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/79200.
    coneq[623]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/237600.
    coneq[624]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/475200.
    coneq[625]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/158400.
    coneq[626]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/59400.
    coneq[627]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/118800.
    coneq[628]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/39600.
    coneq[629]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/79200.
    coneq[630]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))))-1/39600.
    coneq[631]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/158400.
    coneq[632]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/475200.
    coneq[633]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/950400.
    coneq[634]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/316800.
    coneq[635]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/118800.
    coneq[636]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/237600.
    coneq[637]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/79200.
    coneq[638]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/158400.
    coneq[639]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**5))))-1/15840.
    coneq[640]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))))-1/79200.
    coneq[641]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/316800.
    coneq[642]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/950400.
    coneq[643]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1900800.
    coneq[644]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/633600.
    coneq[645]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/237600.
    coneq[646]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/475200.
    coneq[647]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/158400.
    coneq[648]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/316800.
    coneq[649]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/63360.
    coneq[650]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/190080.
    coneq[651]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/380160.
    coneq[652]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/126720.
    coneq[653]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/47520.
    coneq[654]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/95040.
    coneq[655]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/31680.
    coneq[656]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/95040.
    coneq[657]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/190080.
    coneq[658]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/63360.
    coneq[659]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3))))-1/15840.
    coneq[660]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/47520.
    coneq[661]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/95040.
    coneq[662]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/31680.
    coneq[663]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))))-1/31680.
    coneq[664]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/95040.
    coneq[665]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/190080.
    coneq[666]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/63360.
    coneq[667]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4))))-1/13200.
    coneq[668]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))))-1/52800.
    coneq[669]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/158400.
    coneq[670]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/316800.
    coneq[671]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/105600.
    coneq[672]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/39600.
    coneq[673]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/79200.
    coneq[674]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/26400.
    coneq[675]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/52800.
    coneq[676]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2))))-1/11880.
    coneq[677]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))))-1/23760.
    coneq[678]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/47520.
    coneq[679]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3))))-1/10560.
    coneq[680]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))))-1/31680.
    coneq[681]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/63360.
    coneq[682]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))))-1/21120.
    coneq[683]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2))))-1/7920.
    coneq[684]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))))-1/15840.
    coneq[685]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c))))-1/5280.
    coneq[686]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))))-1/26400.
    coneq[687]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/105600.
    coneq[688]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/316800.
    coneq[689]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/633600.
    coneq[690]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/211200.
    coneq[691]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/79200.
    coneq[692]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/158400.
    coneq[693]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/52800.
    coneq[694]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/105600.
    coneq[695]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/31680.
    coneq[696]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/95040.
    coneq[697]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/190080.
    coneq[698]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/63360.
    coneq[699]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/63360.
    coneq[700]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/190080.
    coneq[701]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/380160.
    coneq[702]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/126720.
    coneq[703]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/35640.
    coneq[704]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/71280.
    coneq[705]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/142560.
    coneq[706]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/285120.
    coneq[707]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/21120.
    coneq[708]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/63360.
    coneq[709]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/126720.
    coneq[710]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/42240.
    coneq[711]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/23760.
    coneq[712]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/47520.
    coneq[713]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/95040.
    coneq[714]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/15840.
    coneq[715]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/31680.
    coneq[716]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))))-1/10560.
    coneq[717]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/31680.
    coneq[718]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/63360.
    coneq[719]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/21120.
    coneq[720]=dot(b,dot(A,c*dot(A,c**8)))-1/1188.
    coneq[721]=dot(b,dot(A,c*dot(A,dot(A,c**7))))-1/9504.
    coneq[722]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**6)))))-1/66528.
    coneq[723]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/399168.
    coneq[724]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/1995840.
    coneq[725]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/7983360.
    coneq[726]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/23950080.
    coneq[727]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/47900160.
    coneq[728]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/15966720.
    coneq[729]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/5987520.
    coneq[730]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/11975040.
    coneq[731]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/3991680.
    coneq[732]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/7983360.
    coneq[733]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/1596672.
    coneq[734]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/4790016.
    coneq[735]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/9580032.
    coneq[736]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/3193344.
    coneq[737]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1197504.
    coneq[738]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/2395008.
    coneq[739]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/798336.
    coneq[740]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/2395008.
    coneq[741]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/4790016.
    coneq[742]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/1596672.
    coneq[743]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/332640.
    coneq[744]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1330560.
    coneq[745]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/3991680.
    coneq[746]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/7983360.
    coneq[747]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/2661120.
    coneq[748]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/997920.
    coneq[749]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/1995840.
    coneq[750]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/665280.
    coneq[751]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1330560.
    coneq[752]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/266112.
    coneq[753]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/798336.
    coneq[754]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/1596672.
    coneq[755]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/532224.
    coneq[756]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/199584.
    coneq[757]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/399168.
    coneq[758]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/133056.
    coneq[759]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/598752.
    coneq[760]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1197504.
    coneq[761]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/2395008.
    coneq[762]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/532224.
    coneq[763]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/1596672.
    coneq[764]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/3193344.
    coneq[765]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1064448.
    coneq[766]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/399168.
    coneq[767]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/798336.
    coneq[768]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/266112.
    coneq[769]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/532224.
    coneq[770]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**5)))))-1/57024.
    coneq[771]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/285120.
    coneq[772]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1140480.
    coneq[773]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3421440.
    coneq[774]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/6842880.
    coneq[775]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2280960.
    coneq[776]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/855360.
    coneq[777]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1710720.
    coneq[778]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/570240.
    coneq[779]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1140480.
    coneq[780]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/228096.
    coneq[781]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/684288.
    coneq[782]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1368576.
    coneq[783]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/456192.
    coneq[784]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/171072.
    coneq[785]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/342144.
    coneq[786]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/114048.
    coneq[787]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/342144.
    coneq[788]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/684288.
    coneq[789]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/228096.
    coneq[790]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4)))))-1/47520.
    coneq[791]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/190080.
    coneq[792]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/570240.
    coneq[793]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1140480.
    coneq[794]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/380160.
    coneq[795]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/142560.
    coneq[796]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/285120.
    coneq[797]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/95040.
    coneq[798]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/190080.
    coneq[799]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3)))))-1/38016.
    coneq[800]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/114048.
    coneq[801]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/228096.
    coneq[802]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/76032.
    coneq[803]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2)))))-1/28512.
    coneq[804]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/57024.
    coneq[805]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c)))))-1/19008.
    coneq[806]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/114048.
    coneq[807]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/342144.
    coneq[808]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/684288.
    coneq[809]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/228096.
    coneq[810]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/228096.
    coneq[811]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/684288.
    coneq[812]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1368576.
    coneq[813]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/456192.
    coneq[814]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/95040.
    coneq[815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/380160.
    coneq[816]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1140480.
    coneq[817]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2280960.
    coneq[818]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/760320.
    coneq[819]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/285120.
    coneq[820]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/570240.
    coneq[821]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/190080.
    coneq[822]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/380160.
    coneq[823]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/85536.
    coneq[824]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/171072.
    coneq[825]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/342144.
    coneq[826]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/76032.
    coneq[827]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/228096.
    coneq[828]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/456192.
    coneq[829]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/152064.
    coneq[830]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/57024.
    coneq[831]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/114048.
    coneq[832]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/38016.
    coneq[833]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/114048.
    coneq[834]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/228096.
    coneq[835]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/76032.
    coneq[836]=dot(b,dot(A,c*dot(A,c*dot(A,c**6))))-1/8316.
    coneq[837]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**5)))))-1/49896.
    coneq[838]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/249480.
    coneq[839]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/997920.
    coneq[840]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/2993760.
    coneq[841]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/5987520.
    coneq[842]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/1995840.
    coneq[843]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/748440.
    coneq[844]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1496880.
    coneq[845]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/498960.
    coneq[846]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/997920.
    coneq[847]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/199584.
    coneq[848]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/598752.
    coneq[849]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1197504.
    coneq[850]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/399168.
    coneq[851]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/149688.
    coneq[852]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/299376.
    coneq[853]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/99792.
    coneq[854]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/299376.
    coneq[855]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/598752.
    coneq[856]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/199584.
    coneq[857]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4)))))-1/41580.
    coneq[858]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/166320.
    coneq[859]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/498960.
    coneq[860]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/997920.
    coneq[861]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/332640.
    coneq[862]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/124740.
    coneq[863]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/249480.
    coneq[864]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/83160.
    coneq[865]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/166320.
    coneq[866]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/33264.
    coneq[867]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/99792.
    coneq[868]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/199584.
    coneq[869]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/66528.
    coneq[870]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/24948.
    coneq[871]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/49896.
    coneq[872]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c)))))-1/16632.
    coneq[873]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/74844.
    coneq[874]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/149688.
    coneq[875]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/299376.
    coneq[876]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/66528.
    coneq[877]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/199584.
    coneq[878]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/399168.
    coneq[879]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/133056.
    coneq[880]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/49896.
    coneq[881]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/99792.
    coneq[882]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/33264.
    coneq[883]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/66528.
    coneq[884]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**5))))-1/7128.
    coneq[885]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4)))))-1/35640.
    coneq[886]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/142560.
    coneq[887]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/427680.
    coneq[888]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/855360.
    coneq[889]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/285120.
    coneq[890]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/106920.
    coneq[891]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/213840.
    coneq[892]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/71280.
    coneq[893]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/142560.
    coneq[894]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/28512.
    coneq[895]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/85536.
    coneq[896]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/171072.
    coneq[897]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/57024.
    coneq[898]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/21384.
    coneq[899]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/42768.
    coneq[900]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/14256.
    coneq[901]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/42768.
    coneq[902]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/85536.
    coneq[903]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/28512.
    coneq[904]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**4))))-1/5940.
    coneq[905]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3)))))-1/23760.
    coneq[906]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/71280.
    coneq[907]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/142560.
    coneq[908]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/47520.
    coneq[909]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/17820.
    coneq[910]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/35640.
    coneq[911]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/11880.
    coneq[912]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/23760.
    coneq[913]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**3))))-1/4752.
    coneq[914]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2)))))-1/14256.
    coneq[915]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/28512.
    coneq[916]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c)))))-1/9504.
    coneq[917]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**2))))-1/3564.
    coneq[918]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c)))))-1/7128.
    coneq[919]=dot(b,dot(A,c*dot(A,c**6*dot(A,c))))-1/2376.
    coneq[920]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3))))-1/19008.
    coneq[921]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/57024.
    coneq[922]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/114048.
    coneq[923]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/38016.
    coneq[924]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/171072.
    coneq[925]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/342144.
    coneq[926]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/114048.
    coneq[927]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/684288.
    coneq[928]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/228096.
    coneq[929]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/76032.
    coneq[930]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4))))-1/17820.
    coneq[931]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/71280.
    coneq[932]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/213840.
    coneq[933]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/427680.
    coneq[934]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/142560.
    coneq[935]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/53460.
    coneq[936]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/106920.
    coneq[937]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/35640.
    coneq[938]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/71280.
    coneq[939]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/35640.
    coneq[940]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/142560.
    coneq[941]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/427680.
    coneq[942]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/855360.
    coneq[943]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/285120.
    coneq[944]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/106920.
    coneq[945]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/213840.
    coneq[946]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/71280.
    coneq[947]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/142560.
    coneq[948]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**5))))-1/14256.
    coneq[949]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/71280.
    coneq[950]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/285120.
    coneq[951]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/855360.
    coneq[952]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1710720.
    coneq[953]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/570240.
    coneq[954]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/213840.
    coneq[955]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/427680.
    coneq[956]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/142560.
    coneq[957]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/285120.
    coneq[958]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/57024.
    coneq[959]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/171072.
    coneq[960]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/342144.
    coneq[961]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/114048.
    coneq[962]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/42768.
    coneq[963]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/85536.
    coneq[964]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/28512.
    coneq[965]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/85536.
    coneq[966]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/171072.
    coneq[967]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/57024.
    coneq[968]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/14256.
    coneq[969]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/42768.
    coneq[970]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/85536.
    coneq[971]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/28512.
    coneq[972]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/28512.
    coneq[973]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/85536.
    coneq[974]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/171072.
    coneq[975]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/57024.
    coneq[976]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4))))-1/11880.
    coneq[977]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/47520.
    coneq[978]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/142560.
    coneq[979]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/285120.
    coneq[980]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/95040.
    coneq[981]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/35640.
    coneq[982]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/71280.
    coneq[983]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/23760.
    coneq[984]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/47520.
    coneq[985]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/10692.
    coneq[986]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/21384.
    coneq[987]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/42768.
    coneq[988]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/9504.
    coneq[989]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/28512.
    coneq[990]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/57024.
    coneq[991]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/19008.
    coneq[992]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/7128.
    coneq[993]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/14256.
    coneq[994]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c))))-1/4752.
    coneq[995]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/19008.
    coneq[996]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/57024.
    coneq[997]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/114048.
    coneq[998]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/38016.
    coneq[999]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/21384.
    coneq[1000]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/42768.
    coneq[1001]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/85536.
    coneq[1002]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/14256.
    coneq[1003]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/28512.
    coneq[1004]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/9504.
    coneq[1005]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/19008.
    coneq[1006]=dot(b,dot(A,c**2*dot(A,c**7)))-1/1056.
    coneq[1007]=dot(b,dot(A,c**2*dot(A,dot(A,c**6))))-1/7392.
    coneq[1008]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**5)))))-1/44352.
    coneq[1009]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/221760.
    coneq[1010]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/887040.
    coneq[1011]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/2661120.
    coneq[1012]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/5322240.
    coneq[1013]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/1774080.
    coneq[1014]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/665280.
    coneq[1015]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1330560.
    coneq[1016]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/443520.
    coneq[1017]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/887040.
    coneq[1018]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/177408.
    coneq[1019]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/532224.
    coneq[1020]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1064448.
    coneq[1021]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/354816.
    coneq[1022]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/133056.
    coneq[1023]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/266112.
    coneq[1024]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/88704.
    coneq[1025]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/266112.
    coneq[1026]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/532224.
    coneq[1027]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/177408.
    coneq[1028]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4)))))-1/36960.
    coneq[1029]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/147840.
    coneq[1030]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/443520.
    coneq[1031]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/887040.
    coneq[1032]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/295680.
    coneq[1033]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/110880.
    coneq[1034]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/221760.
    coneq[1035]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/73920.
    coneq[1036]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/147840.
    coneq[1037]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3)))))-1/29568.
    coneq[1038]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/88704.
    coneq[1039]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/177408.
    coneq[1040]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/59136.
    coneq[1041]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2)))))-1/22176.
    coneq[1042]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/44352.
    coneq[1043]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c)))))-1/14784.
    coneq[1044]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/66528.
    coneq[1045]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/133056.
    coneq[1046]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/266112.
    coneq[1047]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/59136.
    coneq[1048]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/177408.
    coneq[1049]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/354816.
    coneq[1050]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/118272.
    coneq[1051]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/44352.
    coneq[1052]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/88704.
    coneq[1053]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/29568.
    coneq[1054]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/59136.
    coneq[1055]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**5))))-1/6336.
    coneq[1056]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4)))))-1/31680.
    coneq[1057]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/126720.
    coneq[1058]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/380160.
    coneq[1059]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/760320.
    coneq[1060]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/253440.
    coneq[1061]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/95040.
    coneq[1062]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/190080.
    coneq[1063]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/63360.
    coneq[1064]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/126720.
    coneq[1065]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3)))))-1/25344.
    coneq[1066]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/76032.
    coneq[1067]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/152064.
    coneq[1068]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/50688.
    coneq[1069]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/19008.
    coneq[1070]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/38016.
    coneq[1071]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c)))))-1/12672.
    coneq[1072]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/38016.
    coneq[1073]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/76032.
    coneq[1074]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/25344.
    coneq[1075]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**4))))-1/5280.
    coneq[1076]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3)))))-1/21120.
    coneq[1077]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/63360.
    coneq[1078]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/126720.
    coneq[1079]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/42240.
    coneq[1080]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/15840.
    coneq[1081]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/31680.
    coneq[1082]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/10560.
    coneq[1083]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/21120.
    coneq[1084]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**3))))-1/4224.
    coneq[1085]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2)))))-1/12672.
    coneq[1086]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/25344.
    coneq[1087]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c)))))-1/8448.
    coneq[1088]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**2))))-1/3168.
    coneq[1089]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c)))))-1/6336.
    coneq[1090]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c))))-1/2112.
    coneq[1091]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3))))-1/12672.
    coneq[1092]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/38016.
    coneq[1093]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/76032.
    coneq[1094]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/25344.
    coneq[1095]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/25344.
    coneq[1096]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/76032.
    coneq[1097]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/152064.
    coneq[1098]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/50688.
    coneq[1099]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4))))-1/10560.
    coneq[1100]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/42240.
    coneq[1101]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/126720.
    coneq[1102]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/253440.
    coneq[1103]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/84480.
    coneq[1104]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/31680.
    coneq[1105]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/63360.
    coneq[1106]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/21120.
    coneq[1107]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/42240.
    coneq[1108]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/9504.
    coneq[1109]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/19008.
    coneq[1110]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/38016.
    coneq[1111]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3))))-1/8448.
    coneq[1112]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/25344.
    coneq[1113]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/50688.
    coneq[1114]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/16896.
    coneq[1115]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/6336.
    coneq[1116]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/12672.
    coneq[1117]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c))))-1/4224.
    coneq[1118]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/12672.
    coneq[1119]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/25344.
    coneq[1120]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/8448.
    coneq[1121]=dot(b,dot(A,c**3*dot(A,c**6)))-1/924.
    coneq[1122]=dot(b,dot(A,c**3*dot(A,dot(A,c**5))))-1/5544.
    coneq[1123]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**4)))))-1/27720.
    coneq[1124]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/110880.
    coneq[1125]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/332640.
    coneq[1126]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/665280.
    coneq[1127]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/221760.
    coneq[1128]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/83160.
    coneq[1129]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/166320.
    coneq[1130]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/55440.
    coneq[1131]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/110880.
    coneq[1132]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3)))))-1/22176.
    coneq[1133]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/66528.
    coneq[1134]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/133056.
    coneq[1135]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/44352.
    coneq[1136]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2)))))-1/16632.
    coneq[1137]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/33264.
    coneq[1138]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c)))))-1/11088.
    coneq[1139]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/33264.
    coneq[1140]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/66528.
    coneq[1141]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/22176.
    coneq[1142]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**4))))-1/4620.
    coneq[1143]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3)))))-1/18480.
    coneq[1144]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/55440.
    coneq[1145]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/110880.
    coneq[1146]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/36960.
    coneq[1147]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2)))))-1/13860.
    coneq[1148]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/27720.
    coneq[1149]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c)))))-1/9240.
    coneq[1150]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/18480.
    coneq[1151]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**3))))-1/3696.
    coneq[1152]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2)))))-1/11088.
    coneq[1153]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/22176.
    coneq[1154]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c)))))-1/7392.
    coneq[1155]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**2))))-1/2772.
    coneq[1156]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c)))))-1/5544.
    coneq[1157]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c))))-1/1848.
    coneq[1158]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2))))-1/8316.
    coneq[1159]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/16632.
    coneq[1160]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/33264.
    coneq[1161]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3))))-1/7392.
    coneq[1162]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/22176.
    coneq[1163]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/44352.
    coneq[1164]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/14784.
    coneq[1165]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2))))-1/5544.
    coneq[1166]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/11088.
    coneq[1167]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c))))-1/3696.
    coneq[1168]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/7392.
    coneq[1169]=dot(b,dot(A,c**4*dot(A,c**5)))-1/792.
    coneq[1170]=dot(b,dot(A,c**4*dot(A,dot(A,c**4))))-1/3960.
    coneq[1171]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**3)))))-1/15840.
    coneq[1172]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/47520.
    coneq[1173]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/95040.
    coneq[1174]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/31680.
    coneq[1175]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2)))))-1/11880.
    coneq[1176]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/23760.
    coneq[1177]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c)))))-1/7920.
    coneq[1178]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/15840.
    coneq[1179]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**3))))-1/3168.
    coneq[1180]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2)))))-1/9504.
    coneq[1181]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/19008.
    coneq[1182]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c)))))-1/6336.
    coneq[1183]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**2))))-1/2376.
    coneq[1184]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c)))))-1/4752.
    coneq[1185]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c))))-1/1584.
    coneq[1186]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2))))-1/4752.
    coneq[1187]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/9504.
    coneq[1188]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c))))-1/3168.
    coneq[1189]=dot(b,dot(A,c**5*dot(A,c**4)))-1/660.
    coneq[1190]=dot(b,dot(A,c**5*dot(A,dot(A,c**3))))-1/2640.
    coneq[1191]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**2)))))-1/7920.
    coneq[1192]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c))))))-1/15840.
    coneq[1193]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c)))))-1/5280.
    coneq[1194]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**2))))-1/1980.
    coneq[1195]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c)))))-1/3960.
    coneq[1196]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c))))-1/1320.
    coneq[1197]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c))))-1/2640.
    coneq[1198]=dot(b,dot(A,c**6*dot(A,c**3)))-1/528.
    coneq[1199]=dot(b,dot(A,c**6*dot(A,dot(A,c**2))))-1/1584.
    coneq[1200]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c)))))-1/3168.
    coneq[1201]=dot(b,dot(A,c**6*dot(A,c*dot(A,c))))-1/1056.
    coneq[1202]=dot(b,dot(A,c**7*dot(A,c**2)))-1/396.
    coneq[1203]=dot(b,dot(A,c**7*dot(A,dot(A,c))))-1/792.
    coneq[1204]=dot(b,dot(A,c**8*dot(A,c)))-1/264.
    coneq[1205]=dot(b,dot(A,dot(A,c**4)*dot(A,c**4)))-1/3300.
    coneq[1206]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**3))))-1/13200.
    coneq[1207]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2)))))-1/39600.
    coneq[1208]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c))))))-1/79200.
    coneq[1209]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c)))))-1/26400.
    coneq[1210]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2))))-1/9900.
    coneq[1211]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c)))))-1/19800.
    coneq[1212]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c))))-1/6600.
    coneq[1213]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c))))-1/13200.
    coneq[1214]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))))-1/52800.
    coneq[1215]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))))-1/158400.
    coneq[1216]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))))-1/316800.
    coneq[1217]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))))-1/105600.
    coneq[1218]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2))))-1/39600.
    coneq[1219]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))))-1/79200.
    coneq[1220]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c))))-1/26400.
    coneq[1221]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))))-1/52800.
    coneq[1222]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))))-1/475200.
    coneq[1223]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/950400.
    coneq[1224]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))))-1/316800.
    coneq[1225]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))))-1/118800.
    coneq[1226]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))))-1/237600.
    coneq[1227]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))))-1/79200.
    coneq[1228]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))))-1/158400.
    coneq[1229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1900800.
    coneq[1230]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))))-1/633600.
    coneq[1231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))))-1/237600.
    coneq[1232]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))))-1/475200.
    coneq[1233]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))))-1/158400.
    coneq[1234]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))))-1/316800.
    coneq[1235]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/211200.
    coneq[1236]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))))-1/79200.
    coneq[1237]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/158400.
    coneq[1238]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))))-1/52800.
    coneq[1239]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/105600.
    coneq[1240]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/29700.
    coneq[1241]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/59400.
    coneq[1242]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/19800.
    coneq[1243]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/39600.
    coneq[1244]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/118800.
    coneq[1245]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/39600.
    coneq[1246]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/79200.
    coneq[1247]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))))-1/13200.
    coneq[1248]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/26400.
    coneq[1249]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/52800.
    coneq[1250]=dot(b,dot(A,dot(A,c**3)*dot(A,c**5)))-1/3168.
    coneq[1251]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**4))))-1/15840.
    coneq[1252]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3)))))-1/63360.
    coneq[1253]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/190080.
    coneq[1254]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/380160.
    coneq[1255]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/126720.
    coneq[1256]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2)))))-1/47520.
    coneq[1257]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/95040.
    coneq[1258]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)))))-1/31680.
    coneq[1259]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/63360.
    coneq[1260]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3))))-1/12672.
    coneq[1261]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2)))))-1/38016.
    coneq[1262]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/76032.
    coneq[1263]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)))))-1/25344.
    coneq[1264]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2))))-1/9504.
    coneq[1265]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)))))-1/19008.
    coneq[1266]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c))))-1/6336.
    coneq[1267]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2))))-1/19008.
    coneq[1268]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/38016.
    coneq[1269]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c))))-1/12672.
    coneq[1270]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**5)))-1/9504.
    coneq[1271]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4))))-1/47520.
    coneq[1272]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))-1/190080.
    coneq[1273]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/570240.
    coneq[1274]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1140480.
    coneq[1275]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/380160.
    coneq[1276]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))-1/142560.
    coneq[1277]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/285120.
    coneq[1278]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))-1/95040.
    coneq[1279]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/190080.
    coneq[1280]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3))))-1/38016.
    coneq[1281]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))-1/114048.
    coneq[1282]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/228096.
    coneq[1283]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))-1/76032.
    coneq[1284]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/28512.
    coneq[1285]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/57024.
    coneq[1286]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/19008.
    coneq[1287]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/57024.
    coneq[1288]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/114048.
    coneq[1289]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/38016.
    coneq[1290]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5)))-1/19008.
    coneq[1291]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4))))-1/95040.
    coneq[1292]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/380160.
    coneq[1293]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1140480.
    coneq[1294]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2280960.
    coneq[1295]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/760320.
    coneq[1296]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/285120.
    coneq[1297]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/570240.
    coneq[1298]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/190080.
    coneq[1299]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/380160.
    coneq[1300]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))-1/76032.
    coneq[1301]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/228096.
    coneq[1302]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/456192.
    coneq[1303]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/152064.
    coneq[1304]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/57024.
    coneq[1305]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/114048.
    coneq[1306]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/38016.
    coneq[1307]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/114048.
    coneq[1308]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/228096.
    coneq[1309]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/76032.
    coneq[1310]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**5)))-1/6336.
    coneq[1311]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4))))-1/31680.
    coneq[1312]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/126720.
    coneq[1313]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/380160.
    coneq[1314]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/760320.
    coneq[1315]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/253440.
    coneq[1316]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/95040.
    coneq[1317]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/190080.
    coneq[1318]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/63360.
    coneq[1319]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/126720.
    coneq[1320]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3))))-1/25344.
    coneq[1321]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/76032.
    coneq[1322]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/152064.
    coneq[1323]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/50688.
    coneq[1324]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/19008.
    coneq[1325]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/38016.
    coneq[1326]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c))))-1/12672.
    coneq[1327]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/38016.
    coneq[1328]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/76032.
    coneq[1329]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/25344.
    coneq[1330]=dot(b,dot(A,dot(A,c**2)*dot(A,c**6)))-1/2772.
    coneq[1331]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**5))))-1/16632.
    coneq[1332]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4)))))-1/83160.
    coneq[1333]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/332640.
    coneq[1334]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/997920.
    coneq[1335]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1995840.
    coneq[1336]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/665280.
    coneq[1337]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/249480.
    coneq[1338]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/498960.
    coneq[1339]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/166320.
    coneq[1340]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/332640.
    coneq[1341]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3)))))-1/66528.
    coneq[1342]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/199584.
    coneq[1343]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/399168.
    coneq[1344]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/133056.
    coneq[1345]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/49896.
    coneq[1346]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/99792.
    coneq[1347]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)))))-1/33264.
    coneq[1348]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/99792.
    coneq[1349]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/199584.
    coneq[1350]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/66528.
    coneq[1351]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4))))-1/13860.
    coneq[1352]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3)))))-1/55440.
    coneq[1353]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/166320.
    coneq[1354]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/332640.
    coneq[1355]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/110880.
    coneq[1356]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/41580.
    coneq[1357]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/83160.
    coneq[1358]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/27720.
    coneq[1359]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/55440.
    coneq[1360]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3))))-1/11088.
    coneq[1361]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/33264.
    coneq[1362]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/66528.
    coneq[1363]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/22176.
    coneq[1364]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2))))-1/8316.
    coneq[1365]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)))))-1/16632.
    coneq[1366]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c))))-1/5544.
    coneq[1367]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/24948.
    coneq[1368]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/49896.
    coneq[1369]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/99792.
    coneq[1370]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3))))-1/22176.
    coneq[1371]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/66528.
    coneq[1372]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/133056.
    coneq[1373]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/44352.
    coneq[1374]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/16632.
    coneq[1375]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/33264.
    coneq[1376]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/11088.
    coneq[1377]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/22176.
    coneq[1378]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**6)))-1/5544.
    coneq[1379]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5))))-1/33264.
    coneq[1380]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/166320.
    coneq[1381]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/665280.
    coneq[1382]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1995840.
    coneq[1383]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3991680.
    coneq[1384]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1330560.
    coneq[1385]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/498960.
    coneq[1386]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/997920.
    coneq[1387]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/332640.
    coneq[1388]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/665280.
    coneq[1389]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/133056.
    coneq[1390]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/399168.
    coneq[1391]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/798336.
    coneq[1392]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/266112.
    coneq[1393]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/99792.
    coneq[1394]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/199584.
    coneq[1395]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/66528.
    coneq[1396]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/199584.
    coneq[1397]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/399168.
    coneq[1398]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/133056.
    coneq[1399]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4))))-1/27720.
    coneq[1400]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/110880.
    coneq[1401]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/332640.
    coneq[1402]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/665280.
    coneq[1403]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/221760.
    coneq[1404]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/83160.
    coneq[1405]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/166320.
    coneq[1406]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/55440.
    coneq[1407]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/110880.
    coneq[1408]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/22176.
    coneq[1409]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/66528.
    coneq[1410]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/133056.
    coneq[1411]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/44352.
    coneq[1412]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/16632.
    coneq[1413]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/33264.
    coneq[1414]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c))))-1/11088.
    coneq[1415]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/49896.
    coneq[1416]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/99792.
    coneq[1417]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/199584.
    coneq[1418]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/44352.
    coneq[1419]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/133056.
    coneq[1420]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/266112.
    coneq[1421]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/88704.
    coneq[1422]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/33264.
    coneq[1423]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/66528.
    coneq[1424]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/22176.
    coneq[1425]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/44352.
    coneq[1426]=dot(b,dot(A,dot(A,c)*dot(A,c**7)))-1/2112.
    coneq[1427]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**6))))-1/14784.
    coneq[1428]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5)))))-1/88704.
    coneq[1429]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/443520.
    coneq[1430]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1774080.
    coneq[1431]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5322240.
    coneq[1432]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/10644480.
    coneq[1433]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3548160.
    coneq[1434]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1330560.
    coneq[1435]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2661120.
    coneq[1436]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/887040.
    coneq[1437]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1774080.
    coneq[1438]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/354816.
    coneq[1439]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1064448.
    coneq[1440]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2128896.
    coneq[1441]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/709632.
    coneq[1442]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/266112.
    coneq[1443]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/532224.
    coneq[1444]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/177408.
    coneq[1445]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/532224.
    coneq[1446]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1064448.
    coneq[1447]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/354816.
    coneq[1448]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4)))))-1/73920.
    coneq[1449]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/295680.
    coneq[1450]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/887040.
    coneq[1451]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1774080.
    coneq[1452]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/591360.
    coneq[1453]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/221760.
    coneq[1454]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/443520.
    coneq[1455]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/147840.
    coneq[1456]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/295680.
    coneq[1457]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/59136.
    coneq[1458]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/177408.
    coneq[1459]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/354816.
    coneq[1460]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/118272.
    coneq[1461]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/44352.
    coneq[1462]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/88704.
    coneq[1463]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c)))))-1/29568.
    coneq[1464]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/133056.
    coneq[1465]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/266112.
    coneq[1466]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/532224.
    coneq[1467]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/118272.
    coneq[1468]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/354816.
    coneq[1469]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/709632.
    coneq[1470]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/236544.
    coneq[1471]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/88704.
    coneq[1472]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/177408.
    coneq[1473]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/59136.
    coneq[1474]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/118272.
    coneq[1475]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**5))))-1/12672.
    coneq[1476]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4)))))-1/63360.
    coneq[1477]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/253440.
    coneq[1478]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/760320.
    coneq[1479]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1520640.
    coneq[1480]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/506880.
    coneq[1481]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/190080.
    coneq[1482]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/380160.
    coneq[1483]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/126720.
    coneq[1484]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/253440.
    coneq[1485]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/50688.
    coneq[1486]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/152064.
    coneq[1487]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/304128.
    coneq[1488]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/101376.
    coneq[1489]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/38016.
    coneq[1490]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/76032.
    coneq[1491]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/25344.
    coneq[1492]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/76032.
    coneq[1493]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/152064.
    coneq[1494]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/50688.
    coneq[1495]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4))))-1/10560.
    coneq[1496]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/42240.
    coneq[1497]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/126720.
    coneq[1498]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/253440.
    coneq[1499]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/84480.
    coneq[1500]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/31680.
    coneq[1501]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/63360.
    coneq[1502]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/21120.
    coneq[1503]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/42240.
    coneq[1504]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3))))-1/8448.
    coneq[1505]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/25344.
    coneq[1506]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/50688.
    coneq[1507]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/16896.
    coneq[1508]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2))))-1/6336.
    coneq[1509]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c)))))-1/12672.
    coneq[1510]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c))))-1/4224.
    coneq[1511]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/25344.
    coneq[1512]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/76032.
    coneq[1513]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/152064.
    coneq[1514]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/50688.
    coneq[1515]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/50688.
    coneq[1516]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/152064.
    coneq[1517]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/304128.
    coneq[1518]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/101376.
    coneq[1519]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4))))-1/21120.
    coneq[1520]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/84480.
    coneq[1521]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/253440.
    coneq[1522]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/506880.
    coneq[1523]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/168960.
    coneq[1524]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/63360.
    coneq[1525]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/126720.
    coneq[1526]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/42240.
    coneq[1527]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/84480.
    coneq[1528]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/19008.
    coneq[1529]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/38016.
    coneq[1530]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/76032.
    coneq[1531]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/16896.
    coneq[1532]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/50688.
    coneq[1533]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/101376.
    coneq[1534]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/33792.
    coneq[1535]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/12672.
    coneq[1536]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/25344.
    coneq[1537]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/8448.
    coneq[1538]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/25344.
    coneq[1539]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/50688.
    coneq[1540]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/16896.
    coneq[1541]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**4)))-1/2640.
    coneq[1542]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3))))-1/10560.
    coneq[1543]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/31680.
    coneq[1544]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/63360.
    coneq[1545]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/21120.
    coneq[1546]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/7920.
    coneq[1547]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/15840.
    coneq[1548]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/5280.
    coneq[1549]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/10560.
    coneq[1550]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4)))-1/7920.
    coneq[1551]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/31680.
    coneq[1552]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/95040.
    coneq[1553]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/190080.
    coneq[1554]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/63360.
    coneq[1555]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/23760.
    coneq[1556]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/47520.
    coneq[1557]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/15840.
    coneq[1558]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/31680.
    coneq[1559]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/15840.
    coneq[1560]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/63360.
    coneq[1561]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/190080.
    coneq[1562]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/380160.
    coneq[1563]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/126720.
    coneq[1564]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/47520.
    coneq[1565]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/95040.
    coneq[1566]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/31680.
    coneq[1567]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/63360.
    coneq[1568]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4)))-1/5280.
    coneq[1569]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/21120.
    coneq[1570]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/63360.
    coneq[1571]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/126720.
    coneq[1572]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/42240.
    coneq[1573]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/15840.
    coneq[1574]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/31680.
    coneq[1575]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/10560.
    coneq[1576]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/21120.
    coneq[1577]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**5)))-1/2376.
    coneq[1578]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4))))-1/11880.
    coneq[1579]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/47520.
    coneq[1580]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/142560.
    coneq[1581]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/285120.
    coneq[1582]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/95040.
    coneq[1583]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/35640.
    coneq[1584]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/71280.
    coneq[1585]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/23760.
    coneq[1586]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/47520.
    coneq[1587]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/9504.
    coneq[1588]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/28512.
    coneq[1589]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/57024.
    coneq[1590]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/19008.
    coneq[1591]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/7128.
    coneq[1592]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/14256.
    coneq[1593]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/4752.
    coneq[1594]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/14256.
    coneq[1595]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/28512.
    coneq[1596]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/9504.
    coneq[1597]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**5)))-1/4752.
    coneq[1598]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/23760.
    coneq[1599]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/95040.
    coneq[1600]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/285120.
    coneq[1601]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/570240.
    coneq[1602]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/190080.
    coneq[1603]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/71280.
    coneq[1604]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/142560.
    coneq[1605]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/47520.
    coneq[1606]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/95040.
    coneq[1607]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/19008.
    coneq[1608]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/57024.
    coneq[1609]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/114048.
    coneq[1610]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/38016.
    coneq[1611]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/14256.
    coneq[1612]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/28512.
    coneq[1613]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/9504.
    coneq[1614]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/28512.
    coneq[1615]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/57024.
    coneq[1616]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/19008.
    coneq[1617]=dot(b,dot(A,c*dot(A,c)*dot(A,c**6)))-1/1848.
    coneq[1618]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**5))))-1/11088.
    coneq[1619]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))-1/55440.
    coneq[1620]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/221760.
    coneq[1621]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/665280.
    coneq[1622]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1330560.
    coneq[1623]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/443520.
    coneq[1624]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/166320.
    coneq[1625]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/332640.
    coneq[1626]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/110880.
    coneq[1627]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/221760.
    coneq[1628]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))-1/44352.
    coneq[1629]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/133056.
    coneq[1630]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/266112.
    coneq[1631]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/88704.
    coneq[1632]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/33264.
    coneq[1633]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/66528.
    coneq[1634]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))-1/22176.
    coneq[1635]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/66528.
    coneq[1636]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/133056.
    coneq[1637]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/44352.
    coneq[1638]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4))))-1/9240.
    coneq[1639]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))-1/36960.
    coneq[1640]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/110880.
    coneq[1641]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/221760.
    coneq[1642]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/73920.
    coneq[1643]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/27720.
    coneq[1644]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/55440.
    coneq[1645]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/18480.
    coneq[1646]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/36960.
    coneq[1647]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3))))-1/7392.
    coneq[1648]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/22176.
    coneq[1649]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/44352.
    coneq[1650]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/14784.
    coneq[1651]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2))))-1/5544.
    coneq[1652]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))-1/11088.
    coneq[1653]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c))))-1/3696.
    coneq[1654]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/16632.
    coneq[1655]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/33264.
    coneq[1656]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/66528.
    coneq[1657]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))-1/14784.
    coneq[1658]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/44352.
    coneq[1659]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/88704.
    coneq[1660]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/29568.
    coneq[1661]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/11088.
    coneq[1662]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/22176.
    coneq[1663]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/7392.
    coneq[1664]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/14784.
    coneq[1665]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**3)))-1/2112.
    coneq[1666]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2))))-1/6336.
    coneq[1667]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/12672.
    coneq[1668]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c))))-1/4224.
    coneq[1669]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/19008.
    coneq[1670]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/38016.
    coneq[1671]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/12672.
    coneq[1672]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/76032.
    coneq[1673]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/25344.
    coneq[1674]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/8448.
    coneq[1675]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**4)))-1/1980.
    coneq[1676]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3))))-1/7920.
    coneq[1677]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/23760.
    coneq[1678]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/47520.
    coneq[1679]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/15840.
    coneq[1680]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/5940.
    coneq[1681]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/11880.
    coneq[1682]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/3960.
    coneq[1683]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/7920.
    coneq[1684]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4)))-1/3960.
    coneq[1685]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/15840.
    coneq[1686]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/47520.
    coneq[1687]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/95040.
    coneq[1688]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/31680.
    coneq[1689]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/11880.
    coneq[1690]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/23760.
    coneq[1691]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/7920.
    coneq[1692]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/15840.
    coneq[1693]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**5)))-1/1584.
    coneq[1694]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4))))-1/7920.
    coneq[1695]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/31680.
    coneq[1696]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/95040.
    coneq[1697]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/190080.
    coneq[1698]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/63360.
    coneq[1699]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/23760.
    coneq[1700]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/47520.
    coneq[1701]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/15840.
    coneq[1702]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/31680.
    coneq[1703]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3))))-1/6336.
    coneq[1704]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/19008.
    coneq[1705]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/38016.
    coneq[1706]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/12672.
    coneq[1707]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/4752.
    coneq[1708]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/9504.
    coneq[1709]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c))))-1/3168.
    coneq[1710]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/9504.
    coneq[1711]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/19008.
    coneq[1712]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/6336.
    coneq[1713]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**3)))-1/1584.
    coneq[1714]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2))))-1/4752.
    coneq[1715]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/9504.
    coneq[1716]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c))))-1/3168.
    coneq[1717]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3)))-1/3168.
    coneq[1718]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/9504.
    coneq[1719]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/19008.
    coneq[1720]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/6336.
    coneq[1721]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**4)))-1/1320.
    coneq[1722]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3))))-1/5280.
    coneq[1723]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/15840.
    coneq[1724]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/31680.
    coneq[1725]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/10560.
    coneq[1726]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2))))-1/3960.
    coneq[1727]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/7920.
    coneq[1728]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c))))-1/2640.
    coneq[1729]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/5280.
    coneq[1730]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**2)))-1/1188.
    coneq[1731]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c))))-1/2376.
    coneq[1732]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/4752.
    coneq[1733]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**3)))-1/1056.
    coneq[1734]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2))))-1/3168.
    coneq[1735]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/6336.
    coneq[1736]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c))))-1/2112.
    coneq[1737]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**2)))-1/792.
    coneq[1738]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c))))-1/1584.
    coneq[1739]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c)))-1/528.
    coneq[1740]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5)))-1/3168.
    coneq[1741]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4))))-1/15840.
    coneq[1742]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/63360.
    coneq[1743]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/190080.
    coneq[1744]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/380160.
    coneq[1745]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/126720.
    coneq[1746]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/47520.
    coneq[1747]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/95040.
    coneq[1748]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/31680.
    coneq[1749]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/63360.
    coneq[1750]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3))))-1/12672.
    coneq[1751]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/38016.
    coneq[1752]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/76032.
    coneq[1753]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/25344.
    coneq[1754]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/9504.
    coneq[1755]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/19008.
    coneq[1756]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c))))-1/6336.
    coneq[1757]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/19008.
    coneq[1758]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/38016.
    coneq[1759]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/12672.
    coneq[1760]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4)))-1/3960.
    coneq[1761]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3))))-1/15840.
    coneq[1762]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/47520.
    coneq[1763]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/95040.
    coneq[1764]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/31680.
    coneq[1765]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/11880.
    coneq[1766]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/23760.
    coneq[1767]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/7920.
    coneq[1768]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/15840.
    coneq[1769]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4)))-1/7920.
    coneq[1770]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/31680.
    coneq[1771]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/95040.
    coneq[1772]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/190080.
    coneq[1773]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/63360.
    coneq[1774]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/23760.
    coneq[1775]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/47520.
    coneq[1776]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/15840.
    coneq[1777]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/31680.
    coneq[1778]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3)))-1/4752.
    coneq[1779]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/14256.
    coneq[1780]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/28512.
    coneq[1781]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/9504.
    coneq[1782]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3)))-1/9504.
    coneq[1783]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/28512.
    coneq[1784]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/57024.
    coneq[1785]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/19008.
    coneq[1786]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3)))-1/19008.
    coneq[1787]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/57024.
    coneq[1788]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/114048.
    coneq[1789]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/38016.
    coneq[1790]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3)))-1/4224.
    coneq[1791]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/12672.
    coneq[1792]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/25344.
    coneq[1793]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/8448.
    coneq[1794]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/38016.
    coneq[1795]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/76032.
    coneq[1796]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/25344.
    coneq[1797]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/152064.
    coneq[1798]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/50688.
    coneq[1799]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/16896.
    coneq[1800]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4)))-1/2640.
    coneq[1801]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))-1/10560.
    coneq[1802]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/31680.
    coneq[1803]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/63360.
    coneq[1804]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/21120.
    coneq[1805]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))-1/7920.
    coneq[1806]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/15840.
    coneq[1807]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))-1/5280.
    coneq[1808]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/10560.
    coneq[1809]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3)))-1/3168.
    coneq[1810]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/9504.
    coneq[1811]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/19008.
    coneq[1812]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/6336.
    coneq[1813]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))-1/6336.
    coneq[1814]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/19008.
    coneq[1815]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/38016.
    coneq[1816]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/12672.
    coneq[1817]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/3564.
    coneq[1818]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/7128.
    coneq[1819]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/14256.
    coneq[1820]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/28512.
    coneq[1821]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/2112.
    coneq[1822]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/6336.
    coneq[1823]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/12672.
    coneq[1824]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/4224.
    coneq[1825]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/2376.
    coneq[1826]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/4752.
    coneq[1827]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/9504.
    coneq[1828]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/1584.
    coneq[1829]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/3168.
    coneq[1830]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c)))-1/1056.
    coneq[1831]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/4224.
    coneq[1832]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/12672.
    coneq[1833]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/25344.
    coneq[1834]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/8448.
    coneq[1835]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/4752.
    coneq[1836]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/9504.
    coneq[1837]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2)))-1/9504.
    coneq[1838]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/19008.
    coneq[1839]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/3168.
    coneq[1840]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/6336.
    coneq[1841]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))-1/2112.
    coneq[1842]=dot(b,dot(A,c**9)*c)-1/120.
    coneq[1843]=dot(b,dot(A,dot(A,c**8))*c)-1/1080.
    coneq[1844]=dot(b,dot(A,dot(A,dot(A,c**7)))*c)-1/8640.
    coneq[1845]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*c)-1/60480.
    coneq[1846]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*c)-1/362880.
    coneq[1847]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/1814400.
    coneq[1848]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/7257600.
    coneq[1849]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/21772800.
    coneq[1850]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/43545600.
    coneq[1851]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/14515200.
    coneq[1852]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/5443200.
    coneq[1853]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/10886400.
    coneq[1854]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/3628800.
    coneq[1855]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/7257600.
    coneq[1856]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/1451520.
    coneq[1857]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/4354560.
    coneq[1858]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/8709120.
    coneq[1859]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/2903040.
    coneq[1860]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1088640.
    coneq[1861]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/2177280.
    coneq[1862]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/725760.
    coneq[1863]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/2177280.
    coneq[1864]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/4354560.
    coneq[1865]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/1451520.
    coneq[1866]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c)-1/302400.
    coneq[1867]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/1209600.
    coneq[1868]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/3628800.
    coneq[1869]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/7257600.
    coneq[1870]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/2419200.
    coneq[1871]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/907200.
    coneq[1872]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/1814400.
    coneq[1873]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/604800.
    coneq[1874]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/1209600.
    coneq[1875]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/241920.
    coneq[1876]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/725760.
    coneq[1877]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/1451520.
    coneq[1878]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/483840.
    coneq[1879]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/181440.
    coneq[1880]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/362880.
    coneq[1881]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c)-1/120960.
    coneq[1882]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/544320.
    coneq[1883]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[1884]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/2177280.
    coneq[1885]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/483840.
    coneq[1886]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/1451520.
    coneq[1887]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/2903040.
    coneq[1888]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/967680.
    coneq[1889]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/362880.
    coneq[1890]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/725760.
    coneq[1891]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/241920.
    coneq[1892]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/483840.
    coneq[1893]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*c)-1/51840.
    coneq[1894]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c)-1/259200.
    coneq[1895]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/1036800.
    coneq[1896]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/3110400.
    coneq[1897]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/6220800.
    coneq[1898]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2073600.
    coneq[1899]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/777600.
    coneq[1900]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1555200.
    coneq[1901]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/518400.
    coneq[1902]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1036800.
    coneq[1903]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/207360.
    coneq[1904]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/622080.
    coneq[1905]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1244160.
    coneq[1906]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/414720.
    coneq[1907]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/155520.
    coneq[1908]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/311040.
    coneq[1909]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/103680.
    coneq[1910]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/311040.
    coneq[1911]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/622080.
    coneq[1912]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/207360.
    coneq[1913]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*c)-1/43200.
    coneq[1914]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/172800.
    coneq[1915]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/518400.
    coneq[1916]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1036800.
    coneq[1917]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/345600.
    coneq[1918]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/129600.
    coneq[1919]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/259200.
    coneq[1920]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/86400.
    coneq[1921]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/172800.
    coneq[1922]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*c)-1/34560.
    coneq[1923]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/103680.
    coneq[1924]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/207360.
    coneq[1925]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/69120.
    coneq[1926]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*c)-1/25920.
    coneq[1927]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c)-1/51840.
    coneq[1928]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*c)-1/17280.
    coneq[1929]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/103680.
    coneq[1930]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/311040.
    coneq[1931]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/622080.
    coneq[1932]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/207360.
    coneq[1933]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/207360.
    coneq[1934]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/622080.
    coneq[1935]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/1244160.
    coneq[1936]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/414720.
    coneq[1937]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c)-1/86400.
    coneq[1938]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/345600.
    coneq[1939]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1036800.
    coneq[1940]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2073600.
    coneq[1941]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/691200.
    coneq[1942]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/259200.
    coneq[1943]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/518400.
    coneq[1944]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/172800.
    coneq[1945]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/345600.
    coneq[1946]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/77760.
    coneq[1947]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/155520.
    coneq[1948]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/311040.
    coneq[1949]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/69120.
    coneq[1950]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/207360.
    coneq[1951]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/414720.
    coneq[1952]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/138240.
    coneq[1953]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/51840.
    coneq[1954]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/103680.
    coneq[1955]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/34560.
    coneq[1956]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/103680.
    coneq[1957]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/207360.
    coneq[1958]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/69120.
    coneq[1959]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*c)-1/7560.
    coneq[1960]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*c)-1/45360.
    coneq[1961]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c)-1/226800.
    coneq[1962]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/907200.
    coneq[1963]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/2721600.
    coneq[1964]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/5443200.
    coneq[1965]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/1814400.
    coneq[1966]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/680400.
    coneq[1967]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1360800.
    coneq[1968]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/453600.
    coneq[1969]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/907200.
    coneq[1970]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/181440.
    coneq[1971]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/544320.
    coneq[1972]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1088640.
    coneq[1973]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/362880.
    coneq[1974]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/136080.
    coneq[1975]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/272160.
    coneq[1976]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/90720.
    coneq[1977]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/272160.
    coneq[1978]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/544320.
    coneq[1979]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/181440.
    coneq[1980]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*c)-1/37800.
    coneq[1981]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/151200.
    coneq[1982]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/453600.
    coneq[1983]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/907200.
    coneq[1984]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/302400.
    coneq[1985]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/113400.
    coneq[1986]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/226800.
    coneq[1987]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/75600.
    coneq[1988]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/151200.
    coneq[1989]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*c)-1/30240.
    coneq[1990]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/90720.
    coneq[1991]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/181440.
    coneq[1992]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/60480.
    coneq[1993]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*c)-1/22680.
    coneq[1994]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/45360.
    coneq[1995]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*c)-1/15120.
    coneq[1996]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/68040.
    coneq[1997]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/136080.
    coneq[1998]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/272160.
    coneq[1999]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/60480.
    coneq[2000]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/181440.
    coneq[2001]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/362880.
    coneq[2002]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/120960.
    coneq[2003]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/45360.
    coneq[2004]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/90720.
    coneq[2005]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/30240.
    coneq[2006]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/60480.
    coneq[2007]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*c)-1/6480.
    coneq[2008]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*c)-1/32400.
    coneq[2009]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c)-1/129600.
    coneq[2010]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/388800.
    coneq[2011]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/777600.
    coneq[2012]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/259200.
    coneq[2013]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/97200.
    coneq[2014]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/194400.
    coneq[2015]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/64800.
    coneq[2016]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/129600.
    coneq[2017]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*c)-1/25920.
    coneq[2018]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/77760.
    coneq[2019]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/155520.
    coneq[2020]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/51840.
    coneq[2021]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c)-1/19440.
    coneq[2022]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/38880.
    coneq[2023]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*c)-1/12960.
    coneq[2024]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/38880.
    coneq[2025]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/77760.
    coneq[2026]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/25920.
    coneq[2027]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*c)-1/5400.
    coneq[2028]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*c)-1/21600.
    coneq[2029]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c)-1/64800.
    coneq[2030]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/129600.
    coneq[2031]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c)-1/43200.
    coneq[2032]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*c)-1/16200.
    coneq[2033]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c)-1/32400.
    coneq[2034]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*c)-1/10800.
    coneq[2035]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c)-1/21600.
    coneq[2036]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*c)-1/4320.
    coneq[2037]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*c)-1/12960.
    coneq[2038]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c)-1/25920.
    coneq[2039]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*c)-1/8640.
    coneq[2040]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*c)-1/3240.
    coneq[2041]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*c)-1/6480.
    coneq[2042]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*c)-1/2160.
    coneq[2043]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*c)-1/17280.
    coneq[2044]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/51840.
    coneq[2045]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/103680.
    coneq[2046]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/34560.
    coneq[2047]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/155520.
    coneq[2048]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/311040.
    coneq[2049]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/103680.
    coneq[2050]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/622080.
    coneq[2051]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/207360.
    coneq[2052]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/69120.
    coneq[2053]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*c)-1/16200.
    coneq[2054]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/64800.
    coneq[2055]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/194400.
    coneq[2056]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/388800.
    coneq[2057]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/129600.
    coneq[2058]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/48600.
    coneq[2059]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/97200.
    coneq[2060]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/32400.
    coneq[2061]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/64800.
    coneq[2062]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c)-1/32400.
    coneq[2063]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/129600.
    coneq[2064]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/388800.
    coneq[2065]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/777600.
    coneq[2066]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/259200.
    coneq[2067]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/97200.
    coneq[2068]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/194400.
    coneq[2069]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/64800.
    coneq[2070]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/129600.
    coneq[2071]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*c)-1/12960.
    coneq[2072]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c)-1/64800.
    coneq[2073]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/259200.
    coneq[2074]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/777600.
    coneq[2075]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1555200.
    coneq[2076]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/518400.
    coneq[2077]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/194400.
    coneq[2078]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/388800.
    coneq[2079]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/129600.
    coneq[2080]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/259200.
    coneq[2081]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/51840.
    coneq[2082]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/155520.
    coneq[2083]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/311040.
    coneq[2084]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/103680.
    coneq[2085]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/38880.
    coneq[2086]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/77760.
    coneq[2087]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/25920.
    coneq[2088]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/77760.
    coneq[2089]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/155520.
    coneq[2090]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/51840.
    coneq[2091]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*c)-1/12960.
    coneq[2092]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/38880.
    coneq[2093]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/77760.
    coneq[2094]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/25920.
    coneq[2095]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/25920.
    coneq[2096]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/77760.
    coneq[2097]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/155520.
    coneq[2098]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/51840.
    coneq[2099]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*c)-1/10800.
    coneq[2100]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/43200.
    coneq[2101]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/129600.
    coneq[2102]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/259200.
    coneq[2103]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/86400.
    coneq[2104]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/32400.
    coneq[2105]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/64800.
    coneq[2106]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/21600.
    coneq[2107]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/43200.
    coneq[2108]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c)-1/9720.
    coneq[2109]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/19440.
    coneq[2110]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/38880.
    coneq[2111]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*c)-1/8640.
    coneq[2112]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/25920.
    coneq[2113]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/51840.
    coneq[2114]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/17280.
    coneq[2115]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*c)-1/6480.
    coneq[2116]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c)-1/12960.
    coneq[2117]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*c)-1/4320.
    coneq[2118]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/17280.
    coneq[2119]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/51840.
    coneq[2120]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/103680.
    coneq[2121]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/34560.
    coneq[2122]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/19440.
    coneq[2123]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/38880.
    coneq[2124]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/77760.
    coneq[2125]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/12960.
    coneq[2126]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/25920.
    coneq[2127]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/8640.
    coneq[2128]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/17280.
    coneq[2129]=dot(b,dot(A,c*dot(A,c**7))*c)-1/960.
    coneq[2130]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*c)-1/6720.
    coneq[2131]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*c)-1/40320.
    coneq[2132]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/201600.
    coneq[2133]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/806400.
    coneq[2134]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/2419200.
    coneq[2135]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/4838400.
    coneq[2136]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/1612800.
    coneq[2137]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/604800.
    coneq[2138]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1209600.
    coneq[2139]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/403200.
    coneq[2140]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/806400.
    coneq[2141]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/161280.
    coneq[2142]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/483840.
    coneq[2143]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/967680.
    coneq[2144]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/322560.
    coneq[2145]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/120960.
    coneq[2146]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/241920.
    coneq[2147]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/80640.
    coneq[2148]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/241920.
    coneq[2149]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/483840.
    coneq[2150]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/161280.
    coneq[2151]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*c)-1/33600.
    coneq[2152]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/134400.
    coneq[2153]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/403200.
    coneq[2154]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/806400.
    coneq[2155]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/268800.
    coneq[2156]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/100800.
    coneq[2157]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/201600.
    coneq[2158]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/67200.
    coneq[2159]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/134400.
    coneq[2160]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/26880.
    coneq[2161]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/80640.
    coneq[2162]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/161280.
    coneq[2163]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/53760.
    coneq[2164]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/20160.
    coneq[2165]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/40320.
    coneq[2166]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*c)-1/13440.
    coneq[2167]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/60480.
    coneq[2168]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[2169]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/241920.
    coneq[2170]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/53760.
    coneq[2171]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/161280.
    coneq[2172]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/322560.
    coneq[2173]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/107520.
    coneq[2174]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/40320.
    coneq[2175]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/80640.
    coneq[2176]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/26880.
    coneq[2177]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/53760.
    coneq[2178]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*c)-1/5760.
    coneq[2179]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*c)-1/28800.
    coneq[2180]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/115200.
    coneq[2181]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/345600.
    coneq[2182]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/691200.
    coneq[2183]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/230400.
    coneq[2184]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/86400.
    coneq[2185]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/172800.
    coneq[2186]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/57600.
    coneq[2187]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/115200.
    coneq[2188]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/23040.
    coneq[2189]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/69120.
    coneq[2190]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/138240.
    coneq[2191]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/46080.
    coneq[2192]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/17280.
    coneq[2193]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/34560.
    coneq[2194]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/11520.
    coneq[2195]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/34560.
    coneq[2196]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/69120.
    coneq[2197]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/23040.
    coneq[2198]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*c)-1/4800.
    coneq[2199]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/19200.
    coneq[2200]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/57600.
    coneq[2201]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/115200.
    coneq[2202]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/38400.
    coneq[2203]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/14400.
    coneq[2204]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/28800.
    coneq[2205]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/9600.
    coneq[2206]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/19200.
    coneq[2207]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*c)-1/3840.
    coneq[2208]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/11520.
    coneq[2209]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/23040.
    coneq[2210]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/7680.
    coneq[2211]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*c)-1/2880.
    coneq[2212]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*c)-1/5760.
    coneq[2213]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*c)-1/1920.
    coneq[2214]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/11520.
    coneq[2215]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/34560.
    coneq[2216]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/69120.
    coneq[2217]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/23040.
    coneq[2218]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/23040.
    coneq[2219]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/69120.
    coneq[2220]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/138240.
    coneq[2221]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/46080.
    coneq[2222]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/9600.
    coneq[2223]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/38400.
    coneq[2224]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/115200.
    coneq[2225]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/230400.
    coneq[2226]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/76800.
    coneq[2227]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/28800.
    coneq[2228]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/57600.
    coneq[2229]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/19200.
    coneq[2230]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/38400.
    coneq[2231]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/8640.
    coneq[2232]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/17280.
    coneq[2233]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/34560.
    coneq[2234]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/7680.
    coneq[2235]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/23040.
    coneq[2236]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/46080.
    coneq[2237]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/15360.
    coneq[2238]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/5760.
    coneq[2239]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/11520.
    coneq[2240]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/3840.
    coneq[2241]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/11520.
    coneq[2242]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/23040.
    coneq[2243]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/7680.
    coneq[2244]=dot(b,dot(A,c**2*dot(A,c**6))*c)-1/840.
    coneq[2245]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*c)-1/5040.
    coneq[2246]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*c)-1/25200.
    coneq[2247]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/100800.
    coneq[2248]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/302400.
    coneq[2249]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/604800.
    coneq[2250]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/201600.
    coneq[2251]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/75600.
    coneq[2252]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/151200.
    coneq[2253]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/50400.
    coneq[2254]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/100800.
    coneq[2255]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*c)-1/20160.
    coneq[2256]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/60480.
    coneq[2257]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/120960.
    coneq[2258]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/40320.
    coneq[2259]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/15120.
    coneq[2260]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/30240.
    coneq[2261]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*c)-1/10080.
    coneq[2262]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/30240.
    coneq[2263]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/60480.
    coneq[2264]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/20160.
    coneq[2265]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*c)-1/4200.
    coneq[2266]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*c)-1/16800.
    coneq[2267]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/50400.
    coneq[2268]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/100800.
    coneq[2269]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/33600.
    coneq[2270]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/12600.
    coneq[2271]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/25200.
    coneq[2272]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/8400.
    coneq[2273]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/16800.
    coneq[2274]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*c)-1/3360.
    coneq[2275]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/10080.
    coneq[2276]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/20160.
    coneq[2277]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/6720.
    coneq[2278]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*c)-1/2520.
    coneq[2279]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*c)-1/5040.
    coneq[2280]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*c)-1/1680.
    coneq[2281]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/7560.
    coneq[2282]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/15120.
    coneq[2283]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/30240.
    coneq[2284]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/6720.
    coneq[2285]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/20160.
    coneq[2286]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/40320.
    coneq[2287]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/13440.
    coneq[2288]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/5040.
    coneq[2289]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/10080.
    coneq[2290]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/3360.
    coneq[2291]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/6720.
    coneq[2292]=dot(b,dot(A,c**3*dot(A,c**5))*c)-1/720.
    coneq[2293]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*c)-1/3600.
    coneq[2294]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*c)-1/14400.
    coneq[2295]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/43200.
    coneq[2296]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/86400.
    coneq[2297]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/28800.
    coneq[2298]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*c)-1/10800.
    coneq[2299]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/21600.
    coneq[2300]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*c)-1/7200.
    coneq[2301]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/14400.
    coneq[2302]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*c)-1/2880.
    coneq[2303]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*c)-1/8640.
    coneq[2304]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/17280.
    coneq[2305]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*c)-1/5760.
    coneq[2306]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*c)-1/2160.
    coneq[2307]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*c)-1/4320.
    coneq[2308]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*c)-1/1440.
    coneq[2309]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/4320.
    coneq[2310]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/8640.
    coneq[2311]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/2880.
    coneq[2312]=dot(b,dot(A,c**4*dot(A,c**4))*c)-1/600.
    coneq[2313]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*c)-1/2400.
    coneq[2314]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*c)-1/7200.
    coneq[2315]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/14400.
    coneq[2316]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*c)-1/4800.
    coneq[2317]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*c)-1/1800.
    coneq[2318]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*c)-1/3600.
    coneq[2319]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*c)-1/1200.
    coneq[2320]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*c)-1/2400.
    coneq[2321]=dot(b,dot(A,c**5*dot(A,c**3))*c)-1/480.
    coneq[2322]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*c)-1/1440.
    coneq[2323]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*c)-1/2880.
    coneq[2324]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*c)-1/960.
    coneq[2325]=dot(b,dot(A,c**6*dot(A,c**2))*c)-1/360.
    coneq[2326]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*c)-1/720.
    coneq[2327]=dot(b,dot(A,c**7*dot(A,c))*c)-1/240.
    coneq[2328]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*c)-1/2400.
    coneq[2329]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*c)-1/9600.
    coneq[2330]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c)-1/28800.
    coneq[2331]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/57600.
    coneq[2332]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c)-1/19200.
    coneq[2333]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*c)-1/7200.
    coneq[2334]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c)-1/14400.
    coneq[2335]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*c)-1/4800.
    coneq[2336]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c)-1/9600.
    coneq[2337]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*c)-1/7200.
    coneq[2338]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c)-1/28800.
    coneq[2339]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c)-1/86400.
    coneq[2340]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/172800.
    coneq[2341]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c)-1/57600.
    coneq[2342]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c)-1/21600.
    coneq[2343]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c)-1/43200.
    coneq[2344]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c)-1/14400.
    coneq[2345]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c)-1/28800.
    coneq[2346]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c)-1/14400.
    coneq[2347]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c)-1/57600.
    coneq[2348]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c)-1/172800.
    coneq[2349]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/345600.
    coneq[2350]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c)-1/115200.
    coneq[2351]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c)-1/43200.
    coneq[2352]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/86400.
    coneq[2353]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/28800.
    coneq[2354]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/57600.
    coneq[2355]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*c)-1/4800.
    coneq[2356]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c)-1/19200.
    coneq[2357]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/57600.
    coneq[2358]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/115200.
    coneq[2359]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/38400.
    coneq[2360]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/14400.
    coneq[2361]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/28800.
    coneq[2362]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/9600.
    coneq[2363]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/19200.
    coneq[2364]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*c)-1/2160.
    coneq[2365]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*c)-1/10800.
    coneq[2366]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c)-1/43200.
    coneq[2367]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/129600.
    coneq[2368]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/259200.
    coneq[2369]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/86400.
    coneq[2370]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/32400.
    coneq[2371]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/64800.
    coneq[2372]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/21600.
    coneq[2373]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/43200.
    coneq[2374]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*c)-1/8640.
    coneq[2375]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/25920.
    coneq[2376]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/51840.
    coneq[2377]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/17280.
    coneq[2378]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c)-1/6480.
    coneq[2379]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/12960.
    coneq[2380]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*c)-1/4320.
    coneq[2381]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/12960.
    coneq[2382]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/25920.
    coneq[2383]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/8640.
    coneq[2384]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*c)-1/4320.
    coneq[2385]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c)-1/21600.
    coneq[2386]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/86400.
    coneq[2387]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/259200.
    coneq[2388]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/518400.
    coneq[2389]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/172800.
    coneq[2390]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/64800.
    coneq[2391]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/129600.
    coneq[2392]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/43200.
    coneq[2393]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/86400.
    coneq[2394]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/17280.
    coneq[2395]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/51840.
    coneq[2396]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/103680.
    coneq[2397]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/34560.
    coneq[2398]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/12960.
    coneq[2399]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/25920.
    coneq[2400]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/8640.
    coneq[2401]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/25920.
    coneq[2402]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/51840.
    coneq[2403]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/17280.
    coneq[2404]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*c)-1/1680.
    coneq[2405]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*c)-1/10080.
    coneq[2406]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c)-1/50400.
    coneq[2407]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/201600.
    coneq[2408]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/604800.
    coneq[2409]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1209600.
    coneq[2410]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/403200.
    coneq[2411]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/151200.
    coneq[2412]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/302400.
    coneq[2413]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/100800.
    coneq[2414]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/201600.
    coneq[2415]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/40320.
    coneq[2416]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/120960.
    coneq[2417]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/241920.
    coneq[2418]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/80640.
    coneq[2419]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/30240.
    coneq[2420]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/60480.
    coneq[2421]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/20160.
    coneq[2422]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/60480.
    coneq[2423]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[2424]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/40320.
    coneq[2425]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*c)-1/8400.
    coneq[2426]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/33600.
    coneq[2427]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/100800.
    coneq[2428]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/201600.
    coneq[2429]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/67200.
    coneq[2430]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/25200.
    coneq[2431]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/50400.
    coneq[2432]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/16800.
    coneq[2433]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/33600.
    coneq[2434]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*c)-1/6720.
    coneq[2435]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/20160.
    coneq[2436]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/40320.
    coneq[2437]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/13440.
    coneq[2438]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*c)-1/5040.
    coneq[2439]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/10080.
    coneq[2440]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*c)-1/3360.
    coneq[2441]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/15120.
    coneq[2442]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/30240.
    coneq[2443]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/60480.
    coneq[2444]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/13440.
    coneq[2445]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/40320.
    coneq[2446]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/80640.
    coneq[2447]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/26880.
    coneq[2448]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/10080.
    coneq[2449]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/20160.
    coneq[2450]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/6720.
    coneq[2451]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/13440.
    coneq[2452]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*c)-1/1920.
    coneq[2453]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/5760.
    coneq[2454]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/11520.
    coneq[2455]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/3840.
    coneq[2456]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/17280.
    coneq[2457]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/34560.
    coneq[2458]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/11520.
    coneq[2459]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/69120.
    coneq[2460]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/23040.
    coneq[2461]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/7680.
    coneq[2462]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*c)-1/1800.
    coneq[2463]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/7200.
    coneq[2464]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/21600.
    coneq[2465]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/43200.
    coneq[2466]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/14400.
    coneq[2467]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/5400.
    coneq[2468]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/10800.
    coneq[2469]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/3600.
    coneq[2470]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/7200.
    coneq[2471]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*c)-1/3600.
    coneq[2472]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/14400.
    coneq[2473]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/43200.
    coneq[2474]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/86400.
    coneq[2475]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/28800.
    coneq[2476]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/10800.
    coneq[2477]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/21600.
    coneq[2478]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/7200.
    coneq[2479]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/14400.
    coneq[2480]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*c)-1/1440.
    coneq[2481]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*c)-1/7200.
    coneq[2482]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c)-1/28800.
    coneq[2483]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/86400.
    coneq[2484]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/172800.
    coneq[2485]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/57600.
    coneq[2486]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/21600.
    coneq[2487]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/43200.
    coneq[2488]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/14400.
    coneq[2489]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/28800.
    coneq[2490]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*c)-1/5760.
    coneq[2491]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/17280.
    coneq[2492]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/34560.
    coneq[2493]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/11520.
    coneq[2494]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c)-1/4320.
    coneq[2495]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/8640.
    coneq[2496]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*c)-1/2880.
    coneq[2497]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/8640.
    coneq[2498]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/17280.
    coneq[2499]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/5760.
    coneq[2500]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*c)-1/1440.
    coneq[2501]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/4320.
    coneq[2502]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/8640.
    coneq[2503]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/2880.
    coneq[2504]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*c)-1/2880.
    coneq[2505]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/8640.
    coneq[2506]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/17280.
    coneq[2507]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/5760.
    coneq[2508]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*c)-1/1200.
    coneq[2509]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/4800.
    coneq[2510]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/14400.
    coneq[2511]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/28800.
    coneq[2512]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/9600.
    coneq[2513]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/3600.
    coneq[2514]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/7200.
    coneq[2515]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/2400.
    coneq[2516]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/4800.
    coneq[2517]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*c)-1/1080.
    coneq[2518]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/2160.
    coneq[2519]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/4320.
    coneq[2520]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*c)-1/960.
    coneq[2521]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/2880.
    coneq[2522]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/5760.
    coneq[2523]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/1920.
    coneq[2524]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*c)-1/720.
    coneq[2525]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*c)-1/1440.
    coneq[2526]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*c)-1/480.
    coneq[2527]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*c)-1/2400.
    coneq[2528]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/9600.
    coneq[2529]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/28800.
    coneq[2530]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/57600.
    coneq[2531]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/19200.
    coneq[2532]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/7200.
    coneq[2533]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/14400.
    coneq[2534]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/4800.
    coneq[2535]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/9600.
    coneq[2536]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*c)-1/2880.
    coneq[2537]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/8640.
    coneq[2538]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/17280.
    coneq[2539]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/5760.
    coneq[2540]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c)-1/5760.
    coneq[2541]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/17280.
    coneq[2542]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/34560.
    coneq[2543]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/11520.
    coneq[2544]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c)-1/3240.
    coneq[2545]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/6480.
    coneq[2546]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/12960.
    coneq[2547]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/25920.
    coneq[2548]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*c)-1/1920.
    coneq[2549]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/5760.
    coneq[2550]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/11520.
    coneq[2551]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/3840.
    coneq[2552]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c)-1/2160.
    coneq[2553]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/4320.
    coneq[2554]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/8640.
    coneq[2555]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/1440.
    coneq[2556]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/2880.
    coneq[2557]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/960.
    coneq[2558]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/2880.
    coneq[2559]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/5760.
    coneq[2560]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/1920.
    coneq[2561]=dot(b,dot(A,c**8)*c*c)-1/108.
    coneq[2562]=dot(b,dot(A,dot(A,c**7))*c*c)-1/864.
    coneq[2563]=dot(b,dot(A,dot(A,dot(A,c**6)))*c*c)-1/6048.
    coneq[2564]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*c*c)-1/36288.
    coneq[2565]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*c*c)-1/181440.
    coneq[2566]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/725760.
    coneq[2567]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/2177280.
    coneq[2568]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/4354560.
    coneq[2569]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/1451520.
    coneq[2570]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/544320.
    coneq[2571]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1088640.
    coneq[2572]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/362880.
    coneq[2573]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/725760.
    coneq[2574]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/145152.
    coneq[2575]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/435456.
    coneq[2576]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/870912.
    coneq[2577]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/290304.
    coneq[2578]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/108864.
    coneq[2579]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/217728.
    coneq[2580]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/72576.
    coneq[2581]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/217728.
    coneq[2582]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/435456.
    coneq[2583]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/145152.
    coneq[2584]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*c*c)-1/30240.
    coneq[2585]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/120960.
    coneq[2586]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/362880.
    coneq[2587]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/725760.
    coneq[2588]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/241920.
    coneq[2589]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/90720.
    coneq[2590]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/181440.
    coneq[2591]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/60480.
    coneq[2592]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/120960.
    coneq[2593]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*c*c)-1/24192.
    coneq[2594]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/72576.
    coneq[2595]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/145152.
    coneq[2596]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/48384.
    coneq[2597]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*c*c)-1/18144.
    coneq[2598]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/36288.
    coneq[2599]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*c*c)-1/12096.
    coneq[2600]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/54432.
    coneq[2601]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/108864.
    coneq[2602]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/217728.
    coneq[2603]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/48384.
    coneq[2604]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/145152.
    coneq[2605]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/290304.
    coneq[2606]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/96768.
    coneq[2607]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/36288.
    coneq[2608]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/72576.
    coneq[2609]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/24192.
    coneq[2610]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/48384.
    coneq[2611]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*c*c)-1/5184.
    coneq[2612]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*c*c)-1/25920.
    coneq[2613]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/103680.
    coneq[2614]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/311040.
    coneq[2615]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/622080.
    coneq[2616]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/207360.
    coneq[2617]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/77760.
    coneq[2618]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/155520.
    coneq[2619]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/51840.
    coneq[2620]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/103680.
    coneq[2621]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*c*c)-1/20736.
    coneq[2622]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/62208.
    coneq[2623]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/124416.
    coneq[2624]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/41472.
    coneq[2625]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*c*c)-1/15552.
    coneq[2626]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/31104.
    coneq[2627]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*c*c)-1/10368.
    coneq[2628]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/31104.
    coneq[2629]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/62208.
    coneq[2630]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/20736.
    coneq[2631]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*c*c)-1/4320.
    coneq[2632]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*c*c)-1/17280.
    coneq[2633]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/51840.
    coneq[2634]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/103680.
    coneq[2635]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/34560.
    coneq[2636]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*c*c)-1/12960.
    coneq[2637]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/25920.
    coneq[2638]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*c*c)-1/8640.
    coneq[2639]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/17280.
    coneq[2640]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*c*c)-1/3456.
    coneq[2641]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*c*c)-1/10368.
    coneq[2642]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c*c)-1/20736.
    coneq[2643]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*c*c)-1/6912.
    coneq[2644]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*c*c)-1/2592.
    coneq[2645]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*c*c)-1/5184.
    coneq[2646]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*c*c)-1/1728.
    coneq[2647]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*c*c)-1/10368.
    coneq[2648]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/31104.
    coneq[2649]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/62208.
    coneq[2650]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/20736.
    coneq[2651]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/20736.
    coneq[2652]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/62208.
    coneq[2653]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/124416.
    coneq[2654]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/41472.
    coneq[2655]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*c*c)-1/8640.
    coneq[2656]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/34560.
    coneq[2657]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/103680.
    coneq[2658]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/207360.
    coneq[2659]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/69120.
    coneq[2660]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/25920.
    coneq[2661]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/51840.
    coneq[2662]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/17280.
    coneq[2663]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/34560.
    coneq[2664]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*c*c)-1/7776.
    coneq[2665]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/15552.
    coneq[2666]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/31104.
    coneq[2667]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*c*c)-1/6912.
    coneq[2668]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/20736.
    coneq[2669]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/41472.
    coneq[2670]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/13824.
    coneq[2671]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*c*c)-1/5184.
    coneq[2672]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/10368.
    coneq[2673]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*c*c)-1/3456.
    coneq[2674]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/10368.
    coneq[2675]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/20736.
    coneq[2676]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/6912.
    coneq[2677]=dot(b,dot(A,c*dot(A,c**6))*c*c)-1/756.
    coneq[2678]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*c*c)-1/4536.
    coneq[2679]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*c*c)-1/22680.
    coneq[2680]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/90720.
    coneq[2681]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/272160.
    coneq[2682]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/544320.
    coneq[2683]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/181440.
    coneq[2684]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/68040.
    coneq[2685]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/136080.
    coneq[2686]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/45360.
    coneq[2687]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/90720.
    coneq[2688]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/18144.
    coneq[2689]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/54432.
    coneq[2690]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/108864.
    coneq[2691]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/36288.
    coneq[2692]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/13608.
    coneq[2693]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/27216.
    coneq[2694]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/9072.
    coneq[2695]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/27216.
    coneq[2696]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/54432.
    coneq[2697]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/18144.
    coneq[2698]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*c*c)-1/3780.
    coneq[2699]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/15120.
    coneq[2700]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/45360.
    coneq[2701]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/90720.
    coneq[2702]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/30240.
    coneq[2703]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/11340.
    coneq[2704]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/22680.
    coneq[2705]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/7560.
    coneq[2706]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/15120.
    coneq[2707]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*c*c)-1/3024.
    coneq[2708]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/9072.
    coneq[2709]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/18144.
    coneq[2710]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/6048.
    coneq[2711]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*c*c)-1/2268.
    coneq[2712]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/4536.
    coneq[2713]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*c*c)-1/1512.
    coneq[2714]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/6804.
    coneq[2715]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/13608.
    coneq[2716]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/27216.
    coneq[2717]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/6048.
    coneq[2718]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/18144.
    coneq[2719]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/36288.
    coneq[2720]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/12096.
    coneq[2721]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/4536.
    coneq[2722]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/9072.
    coneq[2723]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/3024.
    coneq[2724]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/6048.
    coneq[2725]=dot(b,dot(A,c**2*dot(A,c**5))*c*c)-1/648.
    coneq[2726]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*c*c)-1/3240.
    coneq[2727]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*c*c)-1/12960.
    coneq[2728]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/38880.
    coneq[2729]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/77760.
    coneq[2730]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/25920.
    coneq[2731]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/9720.
    coneq[2732]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/19440.
    coneq[2733]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/6480.
    coneq[2734]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/12960.
    coneq[2735]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*c*c)-1/2592.
    coneq[2736]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/7776.
    coneq[2737]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/15552.
    coneq[2738]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/5184.
    coneq[2739]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*c*c)-1/1944.
    coneq[2740]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/3888.
    coneq[2741]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*c*c)-1/1296.
    coneq[2742]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/3888.
    coneq[2743]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/7776.
    coneq[2744]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/2592.
    coneq[2745]=dot(b,dot(A,c**3*dot(A,c**4))*c*c)-1/540.
    coneq[2746]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*c*c)-1/2160.
    coneq[2747]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*c*c)-1/6480.
    coneq[2748]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/12960.
    coneq[2749]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*c*c)-1/4320.
    coneq[2750]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*c*c)-1/1620.
    coneq[2751]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*c*c)-1/3240.
    coneq[2752]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*c*c)-1/1080.
    coneq[2753]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/2160.
    coneq[2754]=dot(b,dot(A,c**4*dot(A,c**3))*c*c)-1/432.
    coneq[2755]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*c*c)-1/1296.
    coneq[2756]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*c*c)-1/2592.
    coneq[2757]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*c*c)-1/864.
    coneq[2758]=dot(b,dot(A,c**5*dot(A,c**2))*c*c)-1/324.
    coneq[2759]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*c*c)-1/648.
    coneq[2760]=dot(b,dot(A,c**6*dot(A,c))*c*c)-1/216.
    coneq[2761]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*c*c)-1/1728.
    coneq[2762]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*c*c)-1/5184.
    coneq[2763]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c*c)-1/10368.
    coneq[2764]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*c*c)-1/3456.
    coneq[2765]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c*c)-1/15552.
    coneq[2766]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c*c)-1/31104.
    coneq[2767]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c*c)-1/10368.
    coneq[2768]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c*c)-1/62208.
    coneq[2769]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c*c)-1/20736.
    coneq[2770]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/6912.
    coneq[2771]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*c*c)-1/1620.
    coneq[2772]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*c*c)-1/6480.
    coneq[2773]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/19440.
    coneq[2774]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/38880.
    coneq[2775]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/12960.
    coneq[2776]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*c*c)-1/4860.
    coneq[2777]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/9720.
    coneq[2778]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*c*c)-1/3240.
    coneq[2779]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/6480.
    coneq[2780]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*c*c)-1/3240.
    coneq[2781]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c*c)-1/12960.
    coneq[2782]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/38880.
    coneq[2783]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/77760.
    coneq[2784]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/25920.
    coneq[2785]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c*c)-1/9720.
    coneq[2786]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/19440.
    coneq[2787]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/6480.
    coneq[2788]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/12960.
    coneq[2789]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*c*c)-1/1296.
    coneq[2790]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*c*c)-1/6480.
    coneq[2791]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/25920.
    coneq[2792]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/77760.
    coneq[2793]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/155520.
    coneq[2794]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/51840.
    coneq[2795]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/19440.
    coneq[2796]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/38880.
    coneq[2797]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/12960.
    coneq[2798]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/25920.
    coneq[2799]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*c*c)-1/5184.
    coneq[2800]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/15552.
    coneq[2801]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/31104.
    coneq[2802]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/10368.
    coneq[2803]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*c*c)-1/3888.
    coneq[2804]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/7776.
    coneq[2805]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*c*c)-1/2592.
    coneq[2806]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/7776.
    coneq[2807]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/15552.
    coneq[2808]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/5184.
    coneq[2809]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*c*c)-1/1296.
    coneq[2810]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/3888.
    coneq[2811]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/7776.
    coneq[2812]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/2592.
    coneq[2813]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/2592.
    coneq[2814]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/7776.
    coneq[2815]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/15552.
    coneq[2816]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/5184.
    coneq[2817]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*c*c)-1/1080.
    coneq[2818]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*c*c)-1/4320.
    coneq[2819]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/12960.
    coneq[2820]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/25920.
    coneq[2821]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/8640.
    coneq[2822]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*c*c)-1/3240.
    coneq[2823]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/6480.
    coneq[2824]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*c*c)-1/2160.
    coneq[2825]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/4320.
    coneq[2826]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*c*c)-1/972.
    coneq[2827]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/1944.
    coneq[2828]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/3888.
    coneq[2829]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*c*c)-1/864.
    coneq[2830]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/2592.
    coneq[2831]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/5184.
    coneq[2832]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/1728.
    coneq[2833]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*c*c)-1/648.
    coneq[2834]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/1296.
    coneq[2835]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*c*c)-1/432.
    coneq[2836]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*c*c)-1/1728.
    coneq[2837]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/5184.
    coneq[2838]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/10368.
    coneq[2839]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/3456.
    coneq[2840]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*c*c)-1/1944.
    coneq[2841]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/3888.
    coneq[2842]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/7776.
    coneq[2843]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*c*c)-1/1296.
    coneq[2844]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/2592.
    coneq[2845]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/864.
    coneq[2846]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/1728.
    coneq[2847]=dot(b,dot(A,c**7)*c**3)-1/96.
    coneq[2848]=dot(b,dot(A,dot(A,c**6))*c**3)-1/672.
    coneq[2849]=dot(b,dot(A,dot(A,dot(A,c**5)))*c**3)-1/4032.
    coneq[2850]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*c**3)-1/20160.
    coneq[2851]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*c**3)-1/80640.
    coneq[2852]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/241920.
    coneq[2853]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/483840.
    coneq[2854]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/161280.
    coneq[2855]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/60480.
    coneq[2856]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/120960.
    coneq[2857]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/40320.
    coneq[2858]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/80640.
    coneq[2859]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*c**3)-1/16128.
    coneq[2860]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/48384.
    coneq[2861]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/96768.
    coneq[2862]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/32256.
    coneq[2863]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*c**3)-1/12096.
    coneq[2864]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/24192.
    coneq[2865]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*c**3)-1/8064.
    coneq[2866]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/24192.
    coneq[2867]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/48384.
    coneq[2868]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/16128.
    coneq[2869]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*c**3)-1/3360.
    coneq[2870]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*c**3)-1/13440.
    coneq[2871]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/40320.
    coneq[2872]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/80640.
    coneq[2873]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/26880.
    coneq[2874]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*c**3)-1/10080.
    coneq[2875]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/20160.
    coneq[2876]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*c**3)-1/6720.
    coneq[2877]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/13440.
    coneq[2878]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*c**3)-1/2688.
    coneq[2879]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*c**3)-1/8064.
    coneq[2880]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**3)-1/16128.
    coneq[2881]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*c**3)-1/5376.
    coneq[2882]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*c**3)-1/2016.
    coneq[2883]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*c**3)-1/4032.
    coneq[2884]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*c**3)-1/1344.
    coneq[2885]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*c**3)-1/6048.
    coneq[2886]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/12096.
    coneq[2887]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/24192.
    coneq[2888]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*c**3)-1/5376.
    coneq[2889]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/16128.
    coneq[2890]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/32256.
    coneq[2891]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/10752.
    coneq[2892]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*c**3)-1/4032.
    coneq[2893]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/8064.
    coneq[2894]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*c**3)-1/2688.
    coneq[2895]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/5376.
    coneq[2896]=dot(b,dot(A,c*dot(A,c**5))*c**3)-1/576.
    coneq[2897]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*c**3)-1/2880.
    coneq[2898]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*c**3)-1/11520.
    coneq[2899]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/34560.
    coneq[2900]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/69120.
    coneq[2901]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/23040.
    coneq[2902]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/8640.
    coneq[2903]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/17280.
    coneq[2904]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/5760.
    coneq[2905]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/11520.
    coneq[2906]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*c**3)-1/2304.
    coneq[2907]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/6912.
    coneq[2908]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/13824.
    coneq[2909]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/4608.
    coneq[2910]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*c**3)-1/1728.
    coneq[2911]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/3456.
    coneq[2912]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*c**3)-1/1152.
    coneq[2913]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/3456.
    coneq[2914]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/6912.
    coneq[2915]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/2304.
    coneq[2916]=dot(b,dot(A,c**2*dot(A,c**4))*c**3)-1/480.
    coneq[2917]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*c**3)-1/1920.
    coneq[2918]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*c**3)-1/5760.
    coneq[2919]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/11520.
    coneq[2920]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*c**3)-1/3840.
    coneq[2921]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*c**3)-1/1440.
    coneq[2922]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*c**3)-1/2880.
    coneq[2923]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*c**3)-1/960.
    coneq[2924]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/1920.
    coneq[2925]=dot(b,dot(A,c**3*dot(A,c**3))*c**3)-1/384.
    coneq[2926]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*c**3)-1/1152.
    coneq[2927]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*c**3)-1/2304.
    coneq[2928]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*c**3)-1/768.
    coneq[2929]=dot(b,dot(A,c**4*dot(A,c**2))*c**3)-1/288.
    coneq[2930]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*c**3)-1/576.
    coneq[2931]=dot(b,dot(A,c**5*dot(A,c))*c**3)-1/192.
    coneq[2932]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*c**3)-1/1152.
    coneq[2933]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*c**3)-1/3456.
    coneq[2934]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**3)-1/6912.
    coneq[2935]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*c**3)-1/2304.
    coneq[2936]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*c**3)-1/2304.
    coneq[2937]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**3)-1/6912.
    coneq[2938]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**3)-1/13824.
    coneq[2939]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**3)-1/4608.
    coneq[2940]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*c**3)-1/960.
    coneq[2941]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*c**3)-1/3840.
    coneq[2942]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/11520.
    coneq[2943]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/23040.
    coneq[2944]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/7680.
    coneq[2945]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*c**3)-1/2880.
    coneq[2946]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/5760.
    coneq[2947]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*c**3)-1/1920.
    coneq[2948]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/3840.
    coneq[2949]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*c**3)-1/864.
    coneq[2950]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/1728.
    coneq[2951]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/3456.
    coneq[2952]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*c**3)-1/768.
    coneq[2953]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*c**3)-1/2304.
    coneq[2954]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**3)-1/4608.
    coneq[2955]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*c**3)-1/1536.
    coneq[2956]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*c**3)-1/576.
    coneq[2957]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/1152.
    coneq[2958]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*c**3)-1/384.
    coneq[2959]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*c**3)-1/1152.
    coneq[2960]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/2304.
    coneq[2961]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*c**3)-1/768.
    coneq[2962]=dot(b,dot(A,c**6)*c**4)-1/84.
    coneq[2963]=dot(b,dot(A,dot(A,c**5))*c**4)-1/504.
    coneq[2964]=dot(b,dot(A,dot(A,dot(A,c**4)))*c**4)-1/2520.
    coneq[2965]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*c**4)-1/10080.
    coneq[2966]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*c**4)-1/30240.
    coneq[2967]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/60480.
    coneq[2968]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*c**4)-1/20160.
    coneq[2969]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*c**4)-1/7560.
    coneq[2970]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*c**4)-1/15120.
    coneq[2971]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*c**4)-1/5040.
    coneq[2972]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*c**4)-1/10080.
    coneq[2973]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*c**4)-1/2016.
    coneq[2974]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*c**4)-1/6048.
    coneq[2975]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*c**4)-1/12096.
    coneq[2976]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*c**4)-1/4032.
    coneq[2977]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*c**4)-1/1512.
    coneq[2978]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*c**4)-1/3024.
    coneq[2979]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*c**4)-1/1008.
    coneq[2980]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*c**4)-1/3024.
    coneq[2981]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*c**4)-1/6048.
    coneq[2982]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*c**4)-1/2016.
    coneq[2983]=dot(b,dot(A,c*dot(A,c**4))*c**4)-1/420.
    coneq[2984]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*c**4)-1/1680.
    coneq[2985]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*c**4)-1/5040.
    coneq[2986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/10080.
    coneq[2987]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*c**4)-1/3360.
    coneq[2988]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*c**4)-1/1260.
    coneq[2989]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*c**4)-1/2520.
    coneq[2990]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*c**4)-1/840.
    coneq[2991]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/1680.
    coneq[2992]=dot(b,dot(A,c**2*dot(A,c**3))*c**4)-1/336.
    coneq[2993]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*c**4)-1/1008.
    coneq[2994]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*c**4)-1/2016.
    coneq[2995]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*c**4)-1/672.
    coneq[2996]=dot(b,dot(A,c**3*dot(A,c**2))*c**4)-1/252.
    coneq[2997]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*c**4)-1/504.
    coneq[2998]=dot(b,dot(A,c**4*dot(A,c))*c**4)-1/168.
    coneq[2999]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*c**4)-1/756.
    coneq[3000]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*c**4)-1/1512.
    coneq[3001]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*c**4)-1/3024.
    coneq[3002]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*c**4)-1/672.
    coneq[3003]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*c**4)-1/2016.
    coneq[3004]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*c**4)-1/4032.
    coneq[3005]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*c**4)-1/1344.
    coneq[3006]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*c**4)-1/504.
    coneq[3007]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*c**4)-1/1008.
    coneq[3008]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*c**4)-1/336.
    coneq[3009]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*c**4)-1/672.
    coneq[3010]=dot(b,dot(A,c**5)*c**5)-1/72.
    coneq[3011]=dot(b,dot(A,dot(A,c**4))*c**5)-1/360.
    coneq[3012]=dot(b,dot(A,dot(A,dot(A,c**3)))*c**5)-1/1440.
    coneq[3013]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c**5)-1/4320.
    coneq[3014]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c**5)-1/8640.
    coneq[3015]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c**5)-1/2880.
    coneq[3016]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c**5)-1/1080.
    coneq[3017]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c**5)-1/2160.
    coneq[3018]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c**5)-1/720.
    coneq[3019]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c**5)-1/1440.
    coneq[3020]=dot(b,dot(A,c*dot(A,c**3))*c**5)-1/288.
    coneq[3021]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c**5)-1/864.
    coneq[3022]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c**5)-1/1728.
    coneq[3023]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c**5)-1/576.
    coneq[3024]=dot(b,dot(A,c**2*dot(A,c**2))*c**5)-1/216.
    coneq[3025]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c**5)-1/432.
    coneq[3026]=dot(b,dot(A,c**3*dot(A,c))*c**5)-1/144.
    coneq[3027]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c**5)-1/432.
    coneq[3028]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c**5)-1/864.
    coneq[3029]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c**5)-1/288.
    coneq[3030]=dot(b,dot(A,c**4)*c**6)-1/60.
    coneq[3031]=dot(b,dot(A,dot(A,c**3))*c**6)-1/240.
    coneq[3032]=dot(b,dot(A,dot(A,dot(A,c**2)))*c**6)-1/720.
    coneq[3033]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c**6)-1/1440.
    coneq[3034]=dot(b,dot(A,dot(A,c*dot(A,c)))*c**6)-1/480.
    coneq[3035]=dot(b,dot(A,c*dot(A,c**2))*c**6)-1/180.
    coneq[3036]=dot(b,dot(A,c*dot(A,dot(A,c)))*c**6)-1/360.
    coneq[3037]=dot(b,dot(A,c**2*dot(A,c))*c**6)-1/120.
    coneq[3038]=dot(b,dot(A,dot(A,c)*dot(A,c))*c**6)-1/240.
    coneq[3039]=dot(b,dot(A,c**3)*c**7)-1/48.
    coneq[3040]=dot(b,dot(A,dot(A,c**2))*c**7)-1/144.
    coneq[3041]=dot(b,dot(A,dot(A,dot(A,c)))*c**7)-1/288.
    coneq[3042]=dot(b,dot(A,c*dot(A,c))*c**7)-1/96.
    coneq[3043]=dot(b,dot(A,c**2)*c**8)-1/36.
    coneq[3044]=dot(b,dot(A,dot(A,c))*c**8)-1/72.
    coneq[3045]=dot(b,dot(A,c)*c**9)-1/24.
    coneq[3046]=dot(b,dot(A,c**5)*dot(A,c**4))-1/360.
    coneq[3047]=dot(b,dot(A,dot(A,c**4))*dot(A,c**4))-1/1800.
    coneq[3048]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**4))-1/7200.
    coneq[3049]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**4))-1/21600.
    coneq[3050]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/43200.
    coneq[3051]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**4))-1/14400.
    coneq[3052]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**4))-1/5400.
    coneq[3053]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**4))-1/10800.
    coneq[3054]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**4))-1/3600.
    coneq[3055]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4))-1/7200.
    coneq[3056]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**4))-1/1440.
    coneq[3057]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**4))-1/4320.
    coneq[3058]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/8640.
    coneq[3059]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**4))-1/2880.
    coneq[3060]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**4))-1/1080.
    coneq[3061]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**4))-1/2160.
    coneq[3062]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**4))-1/720.
    coneq[3063]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**4))-1/2160.
    coneq[3064]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4))-1/4320.
    coneq[3065]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**4))-1/1440.
    coneq[3066]=dot(b,dot(A,c**5)*dot(A,dot(A,c**3)))-1/1440.
    coneq[3067]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**3)))-1/7200.
    coneq[3068]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**3)))-1/28800.
    coneq[3069]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/86400.
    coneq[3070]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/172800.
    coneq[3071]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/57600.
    coneq[3072]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/21600.
    coneq[3073]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/43200.
    coneq[3074]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3)))-1/14400.
    coneq[3075]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/28800.
    coneq[3076]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**3)))-1/5760.
    coneq[3077]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/17280.
    coneq[3078]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/34560.
    coneq[3079]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/11520.
    coneq[3080]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**3)))-1/4320.
    coneq[3081]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/8640.
    coneq[3082]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**3)))-1/2880.
    coneq[3083]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3)))-1/8640.
    coneq[3084]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/17280.
    coneq[3085]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3)))-1/5760.
    coneq[3086]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c**2))))-1/4320.
    coneq[3087]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c**2))))-1/21600.
    coneq[3088]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/86400.
    coneq[3089]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/259200.
    coneq[3090]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/518400.
    coneq[3091]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/172800.
    coneq[3092]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/64800.
    coneq[3093]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/129600.
    coneq[3094]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/43200.
    coneq[3095]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/86400.
    coneq[3096]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/17280.
    coneq[3097]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/51840.
    coneq[3098]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/103680.
    coneq[3099]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/34560.
    coneq[3100]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/12960.
    coneq[3101]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/25920.
    coneq[3102]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/8640.
    coneq[3103]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/25920.
    coneq[3104]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/51840.
    coneq[3105]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/17280.
    coneq[3106]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,dot(A,c)))))-1/8640.
    coneq[3107]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c)))))-1/43200.
    coneq[3108]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/172800.
    coneq[3109]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/518400.
    coneq[3110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1036800.
    coneq[3111]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/345600.
    coneq[3112]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/129600.
    coneq[3113]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/259200.
    coneq[3114]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/86400.
    coneq[3115]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/172800.
    coneq[3116]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/34560.
    coneq[3117]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/103680.
    coneq[3118]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/207360.
    coneq[3119]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/69120.
    coneq[3120]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/25920.
    coneq[3121]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/51840.
    coneq[3122]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/17280.
    coneq[3123]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/51840.
    coneq[3124]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/103680.
    coneq[3125]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/34560.
    coneq[3126]=dot(b,dot(A,c**5)*dot(A,dot(A,c*dot(A,c))))-1/2880.
    coneq[3127]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c*dot(A,c))))-1/14400.
    coneq[3128]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/57600.
    coneq[3129]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/172800.
    coneq[3130]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/345600.
    coneq[3131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/115200.
    coneq[3132]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/43200.
    coneq[3133]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/86400.
    coneq[3134]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/28800.
    coneq[3135]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/57600.
    coneq[3136]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/11520.
    coneq[3137]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/34560.
    coneq[3138]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/69120.
    coneq[3139]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/23040.
    coneq[3140]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/8640.
    coneq[3141]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/17280.
    coneq[3142]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/5760.
    coneq[3143]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/17280.
    coneq[3144]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/34560.
    coneq[3145]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/11520.
    coneq[3146]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c**2)))-1/1080.
    coneq[3147]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c**2)))-1/5400.
    coneq[3148]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/21600.
    coneq[3149]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/64800.
    coneq[3150]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/129600.
    coneq[3151]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/43200.
    coneq[3152]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/16200.
    coneq[3153]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/32400.
    coneq[3154]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/10800.
    coneq[3155]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/21600.
    coneq[3156]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/4320.
    coneq[3157]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/12960.
    coneq[3158]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/25920.
    coneq[3159]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/8640.
    coneq[3160]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/3240.
    coneq[3161]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/6480.
    coneq[3162]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c**2)))-1/2160.
    coneq[3163]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/6480.
    coneq[3164]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/12960.
    coneq[3165]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2)))-1/4320.
    coneq[3166]=dot(b,dot(A,c**5)*dot(A,c*dot(A,dot(A,c))))-1/2160.
    coneq[3167]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,dot(A,c))))-1/10800.
    coneq[3168]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/43200.
    coneq[3169]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/129600.
    coneq[3170]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/259200.
    coneq[3171]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/86400.
    coneq[3172]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/32400.
    coneq[3173]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/64800.
    coneq[3174]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/21600.
    coneq[3175]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/43200.
    coneq[3176]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/8640.
    coneq[3177]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/25920.
    coneq[3178]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/51840.
    coneq[3179]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/17280.
    coneq[3180]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/6480.
    coneq[3181]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/12960.
    coneq[3182]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/4320.
    coneq[3183]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/12960.
    coneq[3184]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/25920.
    coneq[3185]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/8640.
    coneq[3186]=dot(b,dot(A,c**5)*dot(A,c**2*dot(A,c)))-1/720.
    coneq[3187]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2*dot(A,c)))-1/3600.
    coneq[3188]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/14400.
    coneq[3189]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/43200.
    coneq[3190]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/86400.
    coneq[3191]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/28800.
    coneq[3192]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/10800.
    coneq[3193]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/21600.
    coneq[3194]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/7200.
    coneq[3195]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/14400.
    coneq[3196]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/2880.
    coneq[3197]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/8640.
    coneq[3198]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/17280.
    coneq[3199]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/5760.
    coneq[3200]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/2160.
    coneq[3201]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/4320.
    coneq[3202]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,c)))-1/1440.
    coneq[3203]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/4320.
    coneq[3204]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/8640.
    coneq[3205]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)))-1/2880.
    coneq[3206]=dot(b,dot(A,c**5)*dot(A,dot(A,c)*dot(A,c)))-1/1440.
    coneq[3207]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c)*dot(A,c)))-1/7200.
    coneq[3208]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/28800.
    coneq[3209]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/86400.
    coneq[3210]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/172800.
    coneq[3211]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/57600.
    coneq[3212]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/21600.
    coneq[3213]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/43200.
    coneq[3214]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/14400.
    coneq[3215]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/28800.
    coneq[3216]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/5760.
    coneq[3217]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/17280.
    coneq[3218]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/34560.
    coneq[3219]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/11520.
    coneq[3220]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/4320.
    coneq[3221]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/8640.
    coneq[3222]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/2880.
    coneq[3223]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/8640.
    coneq[3224]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/17280.
    coneq[3225]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/5760.
    coneq[3226]=dot(b,dot(A,c**6)*dot(A,c**3))-1/336.
    coneq[3227]=dot(b,dot(A,dot(A,c**5))*dot(A,c**3))-1/2016.
    coneq[3228]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**3))-1/10080.
    coneq[3229]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**3))-1/40320.
    coneq[3230]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/120960.
    coneq[3231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/241920.
    coneq[3232]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/80640.
    coneq[3233]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/30240.
    coneq[3234]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/60480.
    coneq[3235]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/20160.
    coneq[3236]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/40320.
    coneq[3237]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**3))-1/8064.
    coneq[3238]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3))-1/24192.
    coneq[3239]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/48384.
    coneq[3240]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3))-1/16128.
    coneq[3241]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**3))-1/6048.
    coneq[3242]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3))-1/12096.
    coneq[3243]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**3))-1/4032.
    coneq[3244]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/12096.
    coneq[3245]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/24192.
    coneq[3246]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/8064.
    coneq[3247]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**3))-1/1680.
    coneq[3248]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**3))-1/6720.
    coneq[3249]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/20160.
    coneq[3250]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/40320.
    coneq[3251]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/13440.
    coneq[3252]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/5040.
    coneq[3253]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/10080.
    coneq[3254]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/3360.
    coneq[3255]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/6720.
    coneq[3256]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**3))-1/1344.
    coneq[3257]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**3))-1/4032.
    coneq[3258]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/8064.
    coneq[3259]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**3))-1/2688.
    coneq[3260]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**3))-1/1008.
    coneq[3261]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**3))-1/2016.
    coneq[3262]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**3))-1/672.
    coneq[3263]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**3))-1/3024.
    coneq[3264]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3))-1/6048.
    coneq[3265]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3))-1/12096.
    coneq[3266]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**3))-1/2688.
    coneq[3267]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/8064.
    coneq[3268]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/16128.
    coneq[3269]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/5376.
    coneq[3270]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**3))-1/2016.
    coneq[3271]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3))-1/4032.
    coneq[3272]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**3))-1/1344.
    coneq[3273]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3))-1/2688.
    coneq[3274]=dot(b,dot(A,c**6)*dot(A,dot(A,c**2)))-1/1008.
    coneq[3275]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**2)))-1/6048.
    coneq[3276]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**2)))-1/30240.
    coneq[3277]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/120960.
    coneq[3278]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[3279]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/725760.
    coneq[3280]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/241920.
    coneq[3281]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/90720.
    coneq[3282]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[3283]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/60480.
    coneq[3284]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/120960.
    coneq[3285]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/24192.
    coneq[3286]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/72576.
    coneq[3287]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[3288]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/48384.
    coneq[3289]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/18144.
    coneq[3290]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/36288.
    coneq[3291]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2)))-1/12096.
    coneq[3292]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[3293]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/72576.
    coneq[3294]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/24192.
    coneq[3295]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**2)))-1/5040.
    coneq[3296]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/20160.
    coneq[3297]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/60480.
    coneq[3298]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/120960.
    coneq[3299]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/40320.
    coneq[3300]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/15120.
    coneq[3301]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/30240.
    coneq[3302]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/10080.
    coneq[3303]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/20160.
    coneq[3304]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**2)))-1/4032.
    coneq[3305]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/12096.
    coneq[3306]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/24192.
    coneq[3307]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/8064.
    coneq[3308]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**2)))-1/3024.
    coneq[3309]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/6048.
    coneq[3310]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**2)))-1/2016.
    coneq[3311]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/9072.
    coneq[3312]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/18144.
    coneq[3313]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[3314]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/8064.
    coneq[3315]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/24192.
    coneq[3316]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/48384.
    coneq[3317]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/16128.
    coneq[3318]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/6048.
    coneq[3319]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/12096.
    coneq[3320]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/4032.
    coneq[3321]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/8064.
    coneq[3322]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c))))-1/2016.
    coneq[3323]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c))))-1/12096.
    coneq[3324]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/60480.
    coneq[3325]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[3326]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[3327]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/1451520.
    coneq[3328]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/483840.
    coneq[3329]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[3330]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[3331]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[3332]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[3333]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[3334]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[3335]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[3336]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/96768.
    coneq[3337]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[3338]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[3339]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[3340]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[3341]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[3342]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[3343]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/10080.
    coneq[3344]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/40320.
    coneq[3345]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[3346]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[3347]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/80640.
    coneq[3348]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/30240.
    coneq[3349]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/60480.
    coneq[3350]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/20160.
    coneq[3351]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/40320.
    coneq[3352]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/8064.
    coneq[3353]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[3354]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[3355]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/16128.
    coneq[3356]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/6048.
    coneq[3357]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/12096.
    coneq[3358]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/4032.
    coneq[3359]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/18144.
    coneq[3360]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[3361]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[3362]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/16128.
    coneq[3363]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[3364]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/96768.
    coneq[3365]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/32256.
    coneq[3366]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/12096.
    coneq[3367]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[3368]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/8064.
    coneq[3369]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/16128.
    coneq[3370]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c)))-1/672.
    coneq[3371]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c)))-1/4032.
    coneq[3372]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c)))-1/20160.
    coneq[3373]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/80640.
    coneq[3374]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[3375]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/483840.
    coneq[3376]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/161280.
    coneq[3377]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/60480.
    coneq[3378]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[3379]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/40320.
    coneq[3380]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/80640.
    coneq[3381]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/16128.
    coneq[3382]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/48384.
    coneq[3383]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[3384]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/32256.
    coneq[3385]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/12096.
    coneq[3386]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/24192.
    coneq[3387]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c)))-1/8064.
    coneq[3388]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[3389]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/48384.
    coneq[3390]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/16128.
    coneq[3391]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c)))-1/3360.
    coneq[3392]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/13440.
    coneq[3393]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/40320.
    coneq[3394]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/80640.
    coneq[3395]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/26880.
    coneq[3396]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/10080.
    coneq[3397]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/20160.
    coneq[3398]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/6720.
    coneq[3399]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/13440.
    coneq[3400]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c)))-1/2688.
    coneq[3401]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/8064.
    coneq[3402]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/16128.
    coneq[3403]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/5376.
    coneq[3404]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c)))-1/2016.
    coneq[3405]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/4032.
    coneq[3406]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c)))-1/1344.
    coneq[3407]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/6048.
    coneq[3408]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/12096.
    coneq[3409]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[3410]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/5376.
    coneq[3411]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/16128.
    coneq[3412]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/32256.
    coneq[3413]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/10752.
    coneq[3414]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/4032.
    coneq[3415]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/8064.
    coneq[3416]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/2688.
    coneq[3417]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/5376.
    coneq[3418]=dot(b,dot(A,c**7)*dot(A,c**2))-1/288.
    coneq[3419]=dot(b,dot(A,dot(A,c**6))*dot(A,c**2))-1/2016.
    coneq[3420]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**2))-1/12096.
    coneq[3421]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**2))-1/60480.
    coneq[3422]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/241920.
    coneq[3423]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/725760.
    coneq[3424]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/1451520.
    coneq[3425]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/483840.
    coneq[3426]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/181440.
    coneq[3427]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/362880.
    coneq[3428]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/120960.
    coneq[3429]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/241920.
    coneq[3430]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/48384.
    coneq[3431]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/145152.
    coneq[3432]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/290304.
    coneq[3433]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/96768.
    coneq[3434]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/36288.
    coneq[3435]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/72576.
    coneq[3436]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/24192.
    coneq[3437]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/72576.
    coneq[3438]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/145152.
    coneq[3439]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/48384.
    coneq[3440]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**2))-1/10080.
    coneq[3441]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2))-1/40320.
    coneq[3442]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/120960.
    coneq[3443]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/241920.
    coneq[3444]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/80640.
    coneq[3445]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/30240.
    coneq[3446]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/60480.
    coneq[3447]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/20160.
    coneq[3448]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/40320.
    coneq[3449]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**2))-1/8064.
    coneq[3450]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2))-1/24192.
    coneq[3451]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/48384.
    coneq[3452]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2))-1/16128.
    coneq[3453]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**2))-1/6048.
    coneq[3454]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2))-1/12096.
    coneq[3455]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**2))-1/4032.
    coneq[3456]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/18144.
    coneq[3457]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/36288.
    coneq[3458]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/72576.
    coneq[3459]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/16128.
    coneq[3460]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/48384.
    coneq[3461]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/96768.
    coneq[3462]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/32256.
    coneq[3463]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/12096.
    coneq[3464]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/24192.
    coneq[3465]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/8064.
    coneq[3466]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/16128.
    coneq[3467]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**2))-1/1728.
    coneq[3468]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**2))-1/8640.
    coneq[3469]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/34560.
    coneq[3470]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/103680.
    coneq[3471]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/207360.
    coneq[3472]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/69120.
    coneq[3473]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/25920.
    coneq[3474]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/51840.
    coneq[3475]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/17280.
    coneq[3476]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/34560.
    coneq[3477]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/6912.
    coneq[3478]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/20736.
    coneq[3479]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/41472.
    coneq[3480]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/13824.
    coneq[3481]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/5184.
    coneq[3482]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/10368.
    coneq[3483]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/3456.
    coneq[3484]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/10368.
    coneq[3485]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/20736.
    coneq[3486]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/6912.
    coneq[3487]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**2))-1/1440.
    coneq[3488]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**2))-1/5760.
    coneq[3489]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/17280.
    coneq[3490]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/34560.
    coneq[3491]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/11520.
    coneq[3492]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/4320.
    coneq[3493]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/8640.
    coneq[3494]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/2880.
    coneq[3495]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/5760.
    coneq[3496]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**2))-1/1152.
    coneq[3497]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**2))-1/3456.
    coneq[3498]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/6912.
    coneq[3499]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**2))-1/2304.
    coneq[3500]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**2))-1/864.
    coneq[3501]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**2))-1/1728.
    coneq[3502]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**2))-1/576.
    coneq[3503]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**2))-1/3456.
    coneq[3504]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/10368.
    coneq[3505]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/20736.
    coneq[3506]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/6912.
    coneq[3507]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2))-1/6912.
    coneq[3508]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2))-1/20736.
    coneq[3509]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/41472.
    coneq[3510]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/13824.
    coneq[3511]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**2))-1/2880.
    coneq[3512]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/11520.
    coneq[3513]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/34560.
    coneq[3514]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/69120.
    coneq[3515]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/23040.
    coneq[3516]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/8640.
    coneq[3517]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/17280.
    coneq[3518]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/5760.
    coneq[3519]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/11520.
    coneq[3520]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/2592.
    coneq[3521]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/5184.
    coneq[3522]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/10368.
    coneq[3523]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**2))-1/2304.
    coneq[3524]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/6912.
    coneq[3525]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/13824.
    coneq[3526]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/4608.
    coneq[3527]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/1728.
    coneq[3528]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/3456.
    coneq[3529]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**2))-1/1152.
    coneq[3530]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/3456.
    coneq[3531]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/6912.
    coneq[3532]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2))-1/2304.
    coneq[3533]=dot(b,dot(A,c**7)*dot(A,dot(A,c)))-1/576.
    coneq[3534]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c)))-1/4032.
    coneq[3535]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c)))-1/24192.
    coneq[3536]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/120960.
    coneq[3537]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/483840.
    coneq[3538]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/1451520.
    coneq[3539]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/2903040.
    coneq[3540]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/967680.
    coneq[3541]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/362880.
    coneq[3542]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/725760.
    coneq[3543]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/241920.
    coneq[3544]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/483840.
    coneq[3545]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/96768.
    coneq[3546]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/290304.
    coneq[3547]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/580608.
    coneq[3548]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/193536.
    coneq[3549]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/72576.
    coneq[3550]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/145152.
    coneq[3551]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/48384.
    coneq[3552]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/145152.
    coneq[3553]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/290304.
    coneq[3554]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/96768.
    coneq[3555]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c)))-1/20160.
    coneq[3556]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/80640.
    coneq[3557]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/241920.
    coneq[3558]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/483840.
    coneq[3559]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/161280.
    coneq[3560]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/60480.
    coneq[3561]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/120960.
    coneq[3562]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/40320.
    coneq[3563]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/80640.
    coneq[3564]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c)))-1/16128.
    coneq[3565]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/48384.
    coneq[3566]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/96768.
    coneq[3567]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/32256.
    coneq[3568]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c)))-1/12096.
    coneq[3569]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/24192.
    coneq[3570]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c)))-1/8064.
    coneq[3571]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/36288.
    coneq[3572]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/72576.
    coneq[3573]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/145152.
    coneq[3574]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/32256.
    coneq[3575]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/96768.
    coneq[3576]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/193536.
    coneq[3577]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/64512.
    coneq[3578]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/24192.
    coneq[3579]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/48384.
    coneq[3580]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/16128.
    coneq[3581]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/32256.
    coneq[3582]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c)))-1/3456.
    coneq[3583]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/17280.
    coneq[3584]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/69120.
    coneq[3585]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/207360.
    coneq[3586]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/414720.
    coneq[3587]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/138240.
    coneq[3588]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/51840.
    coneq[3589]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/103680.
    coneq[3590]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/34560.
    coneq[3591]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/69120.
    coneq[3592]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/13824.
    coneq[3593]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/41472.
    coneq[3594]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/82944.
    coneq[3595]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/27648.
    coneq[3596]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/10368.
    coneq[3597]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/20736.
    coneq[3598]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/6912.
    coneq[3599]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/20736.
    coneq[3600]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/41472.
    coneq[3601]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/13824.
    coneq[3602]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c)))-1/2880.
    coneq[3603]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/11520.
    coneq[3604]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/34560.
    coneq[3605]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/69120.
    coneq[3606]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/23040.
    coneq[3607]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/8640.
    coneq[3608]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/17280.
    coneq[3609]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/5760.
    coneq[3610]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/11520.
    coneq[3611]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c)))-1/2304.
    coneq[3612]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/6912.
    coneq[3613]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/13824.
    coneq[3614]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/4608.
    coneq[3615]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c)))-1/1728.
    coneq[3616]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/3456.
    coneq[3617]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c)))-1/1152.
    coneq[3618]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c)))-1/6912.
    coneq[3619]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/20736.
    coneq[3620]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/41472.
    coneq[3621]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/13824.
    coneq[3622]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c)))-1/13824.
    coneq[3623]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/41472.
    coneq[3624]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/82944.
    coneq[3625]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/27648.
    coneq[3626]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c)))-1/5760.
    coneq[3627]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/23040.
    coneq[3628]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/69120.
    coneq[3629]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/138240.
    coneq[3630]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/46080.
    coneq[3631]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/17280.
    coneq[3632]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/34560.
    coneq[3633]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/11520.
    coneq[3634]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/23040.
    coneq[3635]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/5184.
    coneq[3636]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/10368.
    coneq[3637]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/20736.
    coneq[3638]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)))-1/4608.
    coneq[3639]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/13824.
    coneq[3640]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/27648.
    coneq[3641]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/9216.
    coneq[3642]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/3456.
    coneq[3643]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/6912.
    coneq[3644]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/2304.
    coneq[3645]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/6912.
    coneq[3646]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/13824.
    coneq[3647]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/4608.
    coneq[3648]=dot(b,dot(A,c**8)*dot(A,c))-1/216.
    coneq[3649]=dot(b,dot(A,dot(A,c**7))*dot(A,c))-1/1728.
    coneq[3650]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c))-1/12096.
    coneq[3651]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c))-1/72576.
    coneq[3652]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/362880.
    coneq[3653]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/1451520.
    coneq[3654]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/4354560.
    coneq[3655]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/8709120.
    coneq[3656]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/2903040.
    coneq[3657]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1088640.
    coneq[3658]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/2177280.
    coneq[3659]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/725760.
    coneq[3660]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/1451520.
    coneq[3661]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/290304.
    coneq[3662]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/870912.
    coneq[3663]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1741824.
    coneq[3664]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/580608.
    coneq[3665]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/217728.
    coneq[3666]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/435456.
    coneq[3667]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/145152.
    coneq[3668]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/435456.
    coneq[3669]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/870912.
    coneq[3670]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/290304.
    coneq[3671]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c))-1/60480.
    coneq[3672]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/241920.
    coneq[3673]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/725760.
    coneq[3674]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1451520.
    coneq[3675]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/483840.
    coneq[3676]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/181440.
    coneq[3677]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/362880.
    coneq[3678]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/120960.
    coneq[3679]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/241920.
    coneq[3680]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/48384.
    coneq[3681]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/145152.
    coneq[3682]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/290304.
    coneq[3683]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/96768.
    coneq[3684]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/36288.
    coneq[3685]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/72576.
    coneq[3686]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c))-1/24192.
    coneq[3687]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/108864.
    coneq[3688]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/217728.
    coneq[3689]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/435456.
    coneq[3690]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/96768.
    coneq[3691]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/290304.
    coneq[3692]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/580608.
    coneq[3693]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/193536.
    coneq[3694]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/72576.
    coneq[3695]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/145152.
    coneq[3696]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/48384.
    coneq[3697]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/96768.
    coneq[3698]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c))-1/10368.
    coneq[3699]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c))-1/51840.
    coneq[3700]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/207360.
    coneq[3701]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/622080.
    coneq[3702]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1244160.
    coneq[3703]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/414720.
    coneq[3704]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/155520.
    coneq[3705]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/311040.
    coneq[3706]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/103680.
    coneq[3707]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/207360.
    coneq[3708]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c))-1/41472.
    coneq[3709]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/124416.
    coneq[3710]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/248832.
    coneq[3711]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/82944.
    coneq[3712]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/31104.
    coneq[3713]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/62208.
    coneq[3714]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c))-1/20736.
    coneq[3715]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/62208.
    coneq[3716]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/124416.
    coneq[3717]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/41472.
    coneq[3718]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c))-1/8640.
    coneq[3719]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c))-1/34560.
    coneq[3720]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/103680.
    coneq[3721]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/207360.
    coneq[3722]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/69120.
    coneq[3723]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c))-1/25920.
    coneq[3724]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/51840.
    coneq[3725]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c))-1/17280.
    coneq[3726]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/34560.
    coneq[3727]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c))-1/6912.
    coneq[3728]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c))-1/20736.
    coneq[3729]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/41472.
    coneq[3730]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c))-1/13824.
    coneq[3731]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c))-1/5184.
    coneq[3732]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c))-1/10368.
    coneq[3733]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c))-1/3456.
    coneq[3734]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/20736.
    coneq[3735]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/62208.
    coneq[3736]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/124416.
    coneq[3737]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/41472.
    coneq[3738]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/41472.
    coneq[3739]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/124416.
    coneq[3740]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/248832.
    coneq[3741]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/82944.
    coneq[3742]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c))-1/17280.
    coneq[3743]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/69120.
    coneq[3744]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/207360.
    coneq[3745]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/414720.
    coneq[3746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/138240.
    coneq[3747]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/51840.
    coneq[3748]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/103680.
    coneq[3749]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/34560.
    coneq[3750]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/69120.
    coneq[3751]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/15552.
    coneq[3752]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/31104.
    coneq[3753]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/62208.
    coneq[3754]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/13824.
    coneq[3755]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/41472.
    coneq[3756]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/82944.
    coneq[3757]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/27648.
    coneq[3758]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/10368.
    coneq[3759]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/20736.
    coneq[3760]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c))-1/6912.
    coneq[3761]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/20736.
    coneq[3762]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/41472.
    coneq[3763]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/13824.
    coneq[3764]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c))-1/1512.
    coneq[3765]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c))-1/9072.
    coneq[3766]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/45360.
    coneq[3767]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/181440.
    coneq[3768]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/544320.
    coneq[3769]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1088640.
    coneq[3770]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/362880.
    coneq[3771]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/136080.
    coneq[3772]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/272160.
    coneq[3773]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/90720.
    coneq[3774]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/181440.
    coneq[3775]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/36288.
    coneq[3776]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/108864.
    coneq[3777]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/217728.
    coneq[3778]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/72576.
    coneq[3779]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/27216.
    coneq[3780]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/54432.
    coneq[3781]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/18144.
    coneq[3782]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/54432.
    coneq[3783]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/108864.
    coneq[3784]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/36288.
    coneq[3785]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c))-1/7560.
    coneq[3786]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/30240.
    coneq[3787]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/90720.
    coneq[3788]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/181440.
    coneq[3789]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/60480.
    coneq[3790]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/22680.
    coneq[3791]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/45360.
    coneq[3792]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/15120.
    coneq[3793]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/30240.
    coneq[3794]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/6048.
    coneq[3795]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/18144.
    coneq[3796]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/36288.
    coneq[3797]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/12096.
    coneq[3798]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/4536.
    coneq[3799]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/9072.
    coneq[3800]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c))-1/3024.
    coneq[3801]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/13608.
    coneq[3802]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/27216.
    coneq[3803]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/54432.
    coneq[3804]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/12096.
    coneq[3805]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/36288.
    coneq[3806]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/72576.
    coneq[3807]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/24192.
    coneq[3808]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/9072.
    coneq[3809]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/18144.
    coneq[3810]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/6048.
    coneq[3811]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/12096.
    coneq[3812]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c))-1/1296.
    coneq[3813]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c))-1/6480.
    coneq[3814]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/25920.
    coneq[3815]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/77760.
    coneq[3816]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/155520.
    coneq[3817]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/51840.
    coneq[3818]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/19440.
    coneq[3819]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/38880.
    coneq[3820]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/12960.
    coneq[3821]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/25920.
    coneq[3822]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c))-1/5184.
    coneq[3823]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/15552.
    coneq[3824]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/31104.
    coneq[3825]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/10368.
    coneq[3826]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/3888.
    coneq[3827]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/7776.
    coneq[3828]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c))-1/2592.
    coneq[3829]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/7776.
    coneq[3830]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/15552.
    coneq[3831]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/5184.
    coneq[3832]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c))-1/1080.
    coneq[3833]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c))-1/4320.
    coneq[3834]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/12960.
    coneq[3835]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/25920.
    coneq[3836]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/8640.
    coneq[3837]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c))-1/3240.
    coneq[3838]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/6480.
    coneq[3839]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c))-1/2160.
    coneq[3840]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/4320.
    coneq[3841]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c))-1/864.
    coneq[3842]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c))-1/2592.
    coneq[3843]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/5184.
    coneq[3844]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c))-1/1728.
    coneq[3845]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c))-1/648.
    coneq[3846]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c))-1/1296.
    coneq[3847]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c))-1/432.
    coneq[3848]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c))-1/3456.
    coneq[3849]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c))-1/10368.
    coneq[3850]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/20736.
    coneq[3851]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c))-1/6912.
    coneq[3852]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c))-1/31104.
    coneq[3853]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/62208.
    coneq[3854]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c))-1/20736.
    coneq[3855]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/124416.
    coneq[3856]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c))-1/41472.
    coneq[3857]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/13824.
    coneq[3858]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c))-1/3240.
    coneq[3859]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c))-1/12960.
    coneq[3860]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/38880.
    coneq[3861]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/77760.
    coneq[3862]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/25920.
    coneq[3863]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/9720.
    coneq[3864]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/19440.
    coneq[3865]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/6480.
    coneq[3866]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/12960.
    coneq[3867]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c))-1/6480.
    coneq[3868]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c))-1/25920.
    coneq[3869]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/77760.
    coneq[3870]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/155520.
    coneq[3871]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/51840.
    coneq[3872]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/19440.
    coneq[3873]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/38880.
    coneq[3874]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/12960.
    coneq[3875]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/25920.
    coneq[3876]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c))-1/2592.
    coneq[3877]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c))-1/12960.
    coneq[3878]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/51840.
    coneq[3879]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/155520.
    coneq[3880]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/311040.
    coneq[3881]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/103680.
    coneq[3882]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/38880.
    coneq[3883]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/77760.
    coneq[3884]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/25920.
    coneq[3885]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/51840.
    coneq[3886]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/10368.
    coneq[3887]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/31104.
    coneq[3888]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/62208.
    coneq[3889]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/20736.
    coneq[3890]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/7776.
    coneq[3891]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/15552.
    coneq[3892]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/5184.
    coneq[3893]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/15552.
    coneq[3894]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/31104.
    coneq[3895]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/10368.
    coneq[3896]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/2592.
    coneq[3897]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/7776.
    coneq[3898]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/15552.
    coneq[3899]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/5184.
    coneq[3900]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/5184.
    coneq[3901]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/15552.
    coneq[3902]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/31104.
    coneq[3903]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/10368.
    coneq[3904]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c))-1/2160.
    coneq[3905]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c))-1/8640.
    coneq[3906]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/25920.
    coneq[3907]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/51840.
    coneq[3908]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/17280.
    coneq[3909]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/6480.
    coneq[3910]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/12960.
    coneq[3911]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/4320.
    coneq[3912]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/8640.
    coneq[3913]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/1944.
    coneq[3914]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/3888.
    coneq[3915]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/7776.
    coneq[3916]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c))-1/1728.
    coneq[3917]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/5184.
    coneq[3918]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/10368.
    coneq[3919]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/3456.
    coneq[3920]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c))-1/1296.
    coneq[3921]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/2592.
    coneq[3922]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c))-1/864.
    coneq[3923]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c))-1/3456.
    coneq[3924]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/10368.
    coneq[3925]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/20736.
    coneq[3926]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/6912.
    coneq[3927]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/3888.
    coneq[3928]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/7776.
    coneq[3929]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/15552.
    coneq[3930]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c))-1/2592.
    coneq[3931]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/5184.
    coneq[3932]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/1728.
    coneq[3933]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/3456.
    coneq[3934]=dot(b,dot(A,c**4)*dot(A,c**4)*c)-1/300.
    coneq[3935]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*c)-1/1200.
    coneq[3936]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*c)-1/3600.
    coneq[3937]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c)-1/7200.
    coneq[3938]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*c)-1/2400.
    coneq[3939]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*c)-1/900.
    coneq[3940]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/1800.
    coneq[3941]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*c)-1/600.
    coneq[3942]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*c)-1/1200.
    coneq[3943]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*c)-1/4800.
    coneq[3944]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/14400.
    coneq[3945]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/28800.
    coneq[3946]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/9600.
    coneq[3947]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*c)-1/3600.
    coneq[3948]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/7200.
    coneq[3949]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*c)-1/2400.
    coneq[3950]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c)-1/4800.
    coneq[3951]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/43200.
    coneq[3952]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/86400.
    coneq[3953]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/28800.
    coneq[3954]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c)-1/10800.
    coneq[3955]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/21600.
    coneq[3956]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/7200.
    coneq[3957]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/14400.
    coneq[3958]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/172800.
    coneq[3959]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/57600.
    coneq[3960]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/21600.
    coneq[3961]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/43200.
    coneq[3962]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/14400.
    coneq[3963]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/28800.
    coneq[3964]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/19200.
    coneq[3965]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c)-1/7200.
    coneq[3966]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/14400.
    coneq[3967]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/4800.
    coneq[3968]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/9600.
    coneq[3969]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*c)-1/2700.
    coneq[3970]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/5400.
    coneq[3971]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/1800.
    coneq[3972]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/3600.
    coneq[3973]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/10800.
    coneq[3974]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/3600.
    coneq[3975]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/7200.
    coneq[3976]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/1200.
    coneq[3977]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/2400.
    coneq[3978]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c)-1/4800.
    coneq[3979]=dot(b,dot(A,c**5)*dot(A,c**3)*c)-1/288.
    coneq[3980]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*c)-1/1440.
    coneq[3981]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*c)-1/5760.
    coneq[3982]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/17280.
    coneq[3983]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/34560.
    coneq[3984]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/11520.
    coneq[3985]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*c)-1/4320.
    coneq[3986]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/8640.
    coneq[3987]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*c)-1/2880.
    coneq[3988]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/5760.
    coneq[3989]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*c)-1/1152.
    coneq[3990]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/3456.
    coneq[3991]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/6912.
    coneq[3992]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/2304.
    coneq[3993]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*c)-1/864.
    coneq[3994]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/1728.
    coneq[3995]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*c)-1/576.
    coneq[3996]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*c)-1/1728.
    coneq[3997]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/3456.
    coneq[3998]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*c)-1/1152.
    coneq[3999]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*c)-1/864.
    coneq[4000]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*c)-1/4320.
    coneq[4001]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/17280.
    coneq[4002]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/51840.
    coneq[4003]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/103680.
    coneq[4004]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/34560.
    coneq[4005]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/12960.
    coneq[4006]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/25920.
    coneq[4007]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/8640.
    coneq[4008]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/17280.
    coneq[4009]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/3456.
    coneq[4010]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/10368.
    coneq[4011]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/20736.
    coneq[4012]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/6912.
    coneq[4013]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/2592.
    coneq[4014]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/5184.
    coneq[4015]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*c)-1/1728.
    coneq[4016]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/5184.
    coneq[4017]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/10368.
    coneq[4018]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c)-1/3456.
    coneq[4019]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*c)-1/1728.
    coneq[4020]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c)-1/8640.
    coneq[4021]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/34560.
    coneq[4022]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/103680.
    coneq[4023]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/207360.
    coneq[4024]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/69120.
    coneq[4025]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/25920.
    coneq[4026]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/51840.
    coneq[4027]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/17280.
    coneq[4028]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/34560.
    coneq[4029]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/6912.
    coneq[4030]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/20736.
    coneq[4031]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/41472.
    coneq[4032]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/13824.
    coneq[4033]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/5184.
    coneq[4034]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/10368.
    coneq[4035]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/3456.
    coneq[4036]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/10368.
    coneq[4037]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/20736.
    coneq[4038]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/6912.
    coneq[4039]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*c)-1/576.
    coneq[4040]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*c)-1/2880.
    coneq[4041]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/11520.
    coneq[4042]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/34560.
    coneq[4043]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/69120.
    coneq[4044]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/23040.
    coneq[4045]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/8640.
    coneq[4046]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/17280.
    coneq[4047]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/5760.
    coneq[4048]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/11520.
    coneq[4049]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/2304.
    coneq[4050]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/6912.
    coneq[4051]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/13824.
    coneq[4052]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/4608.
    coneq[4053]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/1728.
    coneq[4054]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/3456.
    coneq[4055]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*c)-1/1152.
    coneq[4056]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/3456.
    coneq[4057]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/6912.
    coneq[4058]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c)-1/2304.
    coneq[4059]=dot(b,dot(A,c**6)*dot(A,c**2)*c)-1/252.
    coneq[4060]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2)*c)-1/1512.
    coneq[4061]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2)*c)-1/7560.
    coneq[4062]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/30240.
    coneq[4063]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/90720.
    coneq[4064]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/181440.
    coneq[4065]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/60480.
    coneq[4066]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/22680.
    coneq[4067]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/45360.
    coneq[4068]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/15120.
    coneq[4069]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/30240.
    coneq[4070]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2)*c)-1/6048.
    coneq[4071]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/18144.
    coneq[4072]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/36288.
    coneq[4073]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/12096.
    coneq[4074]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c)-1/4536.
    coneq[4075]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/9072.
    coneq[4076]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2)*c)-1/3024.
    coneq[4077]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/9072.
    coneq[4078]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/18144.
    coneq[4079]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/6048.
    coneq[4080]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2)*c)-1/1260.
    coneq[4081]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/5040.
    coneq[4082]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/15120.
    coneq[4083]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/30240.
    coneq[4084]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/10080.
    coneq[4085]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/3780.
    coneq[4086]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/7560.
    coneq[4087]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/2520.
    coneq[4088]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/5040.
    coneq[4089]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2)*c)-1/1008.
    coneq[4090]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/3024.
    coneq[4091]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/6048.
    coneq[4092]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/2016.
    coneq[4093]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2)*c)-1/756.
    coneq[4094]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/1512.
    coneq[4095]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2)*c)-1/504.
    coneq[4096]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c)-1/2268.
    coneq[4097]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/4536.
    coneq[4098]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/9072.
    coneq[4099]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2)*c)-1/2016.
    coneq[4100]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/6048.
    coneq[4101]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/12096.
    coneq[4102]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/4032.
    coneq[4103]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c)-1/1512.
    coneq[4104]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/3024.
    coneq[4105]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/1008.
    coneq[4106]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/2016.
    coneq[4107]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*c)-1/504.
    coneq[4108]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*c)-1/3024.
    coneq[4109]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c)-1/15120.
    coneq[4110]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/60480.
    coneq[4111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[4112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/362880.
    coneq[4113]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/120960.
    coneq[4114]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/45360.
    coneq[4115]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[4116]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/30240.
    coneq[4117]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/60480.
    coneq[4118]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/12096.
    coneq[4119]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/36288.
    coneq[4120]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[4121]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/24192.
    coneq[4122]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/9072.
    coneq[4123]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/18144.
    coneq[4124]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c)-1/6048.
    coneq[4125]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[4126]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/36288.
    coneq[4127]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/12096.
    coneq[4128]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*c)-1/2520.
    coneq[4129]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/10080.
    coneq[4130]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/30240.
    coneq[4131]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/60480.
    coneq[4132]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/20160.
    coneq[4133]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/7560.
    coneq[4134]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/15120.
    coneq[4135]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/5040.
    coneq[4136]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/10080.
    coneq[4137]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*c)-1/2016.
    coneq[4138]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/6048.
    coneq[4139]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/12096.
    coneq[4140]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/4032.
    coneq[4141]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*c)-1/1512.
    coneq[4142]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/3024.
    coneq[4143]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*c)-1/1008.
    coneq[4144]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/4536.
    coneq[4145]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/9072.
    coneq[4146]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[4147]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/4032.
    coneq[4148]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/12096.
    coneq[4149]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/24192.
    coneq[4150]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/8064.
    coneq[4151]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/3024.
    coneq[4152]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/6048.
    coneq[4153]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/2016.
    coneq[4154]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/4032.
    coneq[4155]=dot(b,dot(A,c**7)*dot(A,c)*c)-1/192.
    coneq[4156]=dot(b,dot(A,dot(A,c**6))*dot(A,c)*c)-1/1344.
    coneq[4157]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c)*c)-1/8064.
    coneq[4158]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c)-1/40320.
    coneq[4159]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/161280.
    coneq[4160]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/483840.
    coneq[4161]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/967680.
    coneq[4162]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/322560.
    coneq[4163]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/120960.
    coneq[4164]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/241920.
    coneq[4165]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/80640.
    coneq[4166]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/161280.
    coneq[4167]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/32256.
    coneq[4168]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/96768.
    coneq[4169]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/193536.
    coneq[4170]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/64512.
    coneq[4171]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/24192.
    coneq[4172]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/48384.
    coneq[4173]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/16128.
    coneq[4174]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/48384.
    coneq[4175]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/96768.
    coneq[4176]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/32256.
    coneq[4177]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c)*c)-1/6720.
    coneq[4178]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/26880.
    coneq[4179]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/80640.
    coneq[4180]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/161280.
    coneq[4181]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/53760.
    coneq[4182]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/20160.
    coneq[4183]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/40320.
    coneq[4184]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/13440.
    coneq[4185]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/26880.
    coneq[4186]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c)*c)-1/5376.
    coneq[4187]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/16128.
    coneq[4188]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/32256.
    coneq[4189]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/10752.
    coneq[4190]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c)*c)-1/4032.
    coneq[4191]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c)-1/8064.
    coneq[4192]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c)*c)-1/2688.
    coneq[4193]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/12096.
    coneq[4194]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/24192.
    coneq[4195]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/48384.
    coneq[4196]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/10752.
    coneq[4197]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/32256.
    coneq[4198]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/64512.
    coneq[4199]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/21504.
    coneq[4200]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/8064.
    coneq[4201]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/16128.
    coneq[4202]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/5376.
    coneq[4203]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/10752.
    coneq[4204]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c)*c)-1/1152.
    coneq[4205]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/5760.
    coneq[4206]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/23040.
    coneq[4207]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/69120.
    coneq[4208]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/138240.
    coneq[4209]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/46080.
    coneq[4210]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/17280.
    coneq[4211]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/34560.
    coneq[4212]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/11520.
    coneq[4213]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/23040.
    coneq[4214]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/4608.
    coneq[4215]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/13824.
    coneq[4216]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/27648.
    coneq[4217]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/9216.
    coneq[4218]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/3456.
    coneq[4219]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/6912.
    coneq[4220]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/2304.
    coneq[4221]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/6912.
    coneq[4222]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/13824.
    coneq[4223]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/4608.
    coneq[4224]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c)*c)-1/960.
    coneq[4225]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/3840.
    coneq[4226]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/11520.
    coneq[4227]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/23040.
    coneq[4228]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/7680.
    coneq[4229]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/2880.
    coneq[4230]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/5760.
    coneq[4231]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/1920.
    coneq[4232]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/3840.
    coneq[4233]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c)*c)-1/768.
    coneq[4234]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/2304.
    coneq[4235]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/4608.
    coneq[4236]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/1536.
    coneq[4237]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c)*c)-1/576.
    coneq[4238]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c)*c)-1/1152.
    coneq[4239]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c)*c)-1/384.
    coneq[4240]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c)*c)-1/2304.
    coneq[4241]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/6912.
    coneq[4242]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/13824.
    coneq[4243]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/4608.
    coneq[4244]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c)-1/4608.
    coneq[4245]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/13824.
    coneq[4246]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/27648.
    coneq[4247]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/9216.
    coneq[4248]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c)*c)-1/1920.
    coneq[4249]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/7680.
    coneq[4250]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/23040.
    coneq[4251]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/46080.
    coneq[4252]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/15360.
    coneq[4253]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/5760.
    coneq[4254]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/11520.
    coneq[4255]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/3840.
    coneq[4256]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/7680.
    coneq[4257]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/1728.
    coneq[4258]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/3456.
    coneq[4259]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/6912.
    coneq[4260]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c)*c)-1/1536.
    coneq[4261]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/4608.
    coneq[4262]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/9216.
    coneq[4263]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/3072.
    coneq[4264]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/1152.
    coneq[4265]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/2304.
    coneq[4266]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/768.
    coneq[4267]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/2304.
    coneq[4268]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/4608.
    coneq[4269]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/1536.
    coneq[4270]=dot(b,dot(A,c**4)*dot(A,c**3)*c*c)-1/240.
    coneq[4271]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*c*c)-1/960.
    coneq[4272]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*c*c)-1/2880.
    coneq[4273]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/5760.
    coneq[4274]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*c*c)-1/1920.
    coneq[4275]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*c*c)-1/720.
    coneq[4276]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/1440.
    coneq[4277]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*c*c)-1/480.
    coneq[4278]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*c*c)-1/960.
    coneq[4279]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*c*c)-1/720.
    coneq[4280]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*c*c)-1/2880.
    coneq[4281]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/8640.
    coneq[4282]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/17280.
    coneq[4283]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/5760.
    coneq[4284]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/2160.
    coneq[4285]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/4320.
    coneq[4286]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/1440.
    coneq[4287]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/2880.
    coneq[4288]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*c*c)-1/1440.
    coneq[4289]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c*c)-1/5760.
    coneq[4290]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/17280.
    coneq[4291]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/34560.
    coneq[4292]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/11520.
    coneq[4293]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c*c)-1/4320.
    coneq[4294]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/8640.
    coneq[4295]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/2880.
    coneq[4296]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/5760.
    coneq[4297]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*c*c)-1/480.
    coneq[4298]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*c*c)-1/1920.
    coneq[4299]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/5760.
    coneq[4300]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/11520.
    coneq[4301]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/3840.
    coneq[4302]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*c*c)-1/1440.
    coneq[4303]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/2880.
    coneq[4304]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/960.
    coneq[4305]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/1920.
    coneq[4306]=dot(b,dot(A,c**5)*dot(A,c**2)*c*c)-1/216.
    coneq[4307]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*c*c)-1/1080.
    coneq[4308]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*c*c)-1/4320.
    coneq[4309]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/12960.
    coneq[4310]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/25920.
    coneq[4311]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/8640.
    coneq[4312]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*c*c)-1/3240.
    coneq[4313]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/6480.
    coneq[4314]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*c*c)-1/2160.
    coneq[4315]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/4320.
    coneq[4316]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*c*c)-1/864.
    coneq[4317]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/2592.
    coneq[4318]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/5184.
    coneq[4319]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/1728.
    coneq[4320]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*c*c)-1/648.
    coneq[4321]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/1296.
    coneq[4322]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*c*c)-1/432.
    coneq[4323]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*c*c)-1/1296.
    coneq[4324]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/2592.
    coneq[4325]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*c*c)-1/864.
    coneq[4326]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*c*c)-1/432.
    coneq[4327]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*c*c)-1/2160.
    coneq[4328]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/8640.
    coneq[4329]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/25920.
    coneq[4330]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/51840.
    coneq[4331]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/17280.
    coneq[4332]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/6480.
    coneq[4333]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/12960.
    coneq[4334]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/4320.
    coneq[4335]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/8640.
    coneq[4336]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/1728.
    coneq[4337]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/5184.
    coneq[4338]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/10368.
    coneq[4339]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/3456.
    coneq[4340]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/1296.
    coneq[4341]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/2592.
    coneq[4342]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*c*c)-1/864.
    coneq[4343]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/2592.
    coneq[4344]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/5184.
    coneq[4345]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c*c)-1/1728.
    coneq[4346]=dot(b,dot(A,c**6)*dot(A,c)*c*c)-1/168.
    coneq[4347]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*c*c)-1/1008.
    coneq[4348]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*c*c)-1/5040.
    coneq[4349]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/20160.
    coneq[4350]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/60480.
    coneq[4351]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/120960.
    coneq[4352]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/40320.
    coneq[4353]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/15120.
    coneq[4354]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/30240.
    coneq[4355]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/10080.
    coneq[4356]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/20160.
    coneq[4357]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*c*c)-1/4032.
    coneq[4358]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/12096.
    coneq[4359]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/24192.
    coneq[4360]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/8064.
    coneq[4361]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*c*c)-1/3024.
    coneq[4362]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/6048.
    coneq[4363]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*c*c)-1/2016.
    coneq[4364]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/6048.
    coneq[4365]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/12096.
    coneq[4366]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/4032.
    coneq[4367]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*c*c)-1/840.
    coneq[4368]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/3360.
    coneq[4369]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/10080.
    coneq[4370]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/20160.
    coneq[4371]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/6720.
    coneq[4372]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/2520.
    coneq[4373]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/5040.
    coneq[4374]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/1680.
    coneq[4375]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/3360.
    coneq[4376]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*c*c)-1/672.
    coneq[4377]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/2016.
    coneq[4378]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/4032.
    coneq[4379]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/1344.
    coneq[4380]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*c*c)-1/504.
    coneq[4381]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/1008.
    coneq[4382]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*c*c)-1/336.
    coneq[4383]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*c*c)-1/1512.
    coneq[4384]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/3024.
    coneq[4385]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/6048.
    coneq[4386]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*c*c)-1/1344.
    coneq[4387]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/4032.
    coneq[4388]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/8064.
    coneq[4389]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/2688.
    coneq[4390]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*c*c)-1/1008.
    coneq[4391]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/2016.
    coneq[4392]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/672.
    coneq[4393]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/1344.
    coneq[4394]=dot(b,dot(A,c**3)*dot(A,c**3)*c**3)-1/192.
    coneq[4395]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*c**3)-1/576.
    coneq[4396]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c**3)-1/1152.
    coneq[4397]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*c**3)-1/384.
    coneq[4398]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c**3)-1/1728.
    coneq[4399]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/3456.
    coneq[4400]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*c**3)-1/1152.
    coneq[4401]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/6912.
    coneq[4402]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**3)-1/2304.
    coneq[4403]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*c**3)-1/768.
    coneq[4404]=dot(b,dot(A,c**4)*dot(A,c**2)*c**3)-1/180.
    coneq[4405]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*c**3)-1/720.
    coneq[4406]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*c**3)-1/2160.
    coneq[4407]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/4320.
    coneq[4408]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*c**3)-1/1440.
    coneq[4409]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*c**3)-1/540.
    coneq[4410]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/1080.
    coneq[4411]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*c**3)-1/360.
    coneq[4412]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*c**3)-1/720.
    coneq[4413]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*c**3)-1/360.
    coneq[4414]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*c**3)-1/1440.
    coneq[4415]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/4320.
    coneq[4416]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/8640.
    coneq[4417]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/2880.
    coneq[4418]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/1080.
    coneq[4419]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/2160.
    coneq[4420]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*c**3)-1/720.
    coneq[4421]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**3)-1/1440.
    coneq[4422]=dot(b,dot(A,c**5)*dot(A,c)*c**3)-1/144.
    coneq[4423]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*c**3)-1/720.
    coneq[4424]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*c**3)-1/2880.
    coneq[4425]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/8640.
    coneq[4426]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/17280.
    coneq[4427]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/5760.
    coneq[4428]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*c**3)-1/2160.
    coneq[4429]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/4320.
    coneq[4430]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*c**3)-1/1440.
    coneq[4431]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/2880.
    coneq[4432]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*c**3)-1/576.
    coneq[4433]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/1728.
    coneq[4434]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/3456.
    coneq[4435]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/1152.
    coneq[4436]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*c**3)-1/432.
    coneq[4437]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/864.
    coneq[4438]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*c**3)-1/288.
    coneq[4439]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*c**3)-1/864.
    coneq[4440]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/1728.
    coneq[4441]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*c**3)-1/576.
    coneq[4442]=dot(b,dot(A,c**3)*dot(A,c**2)*c**4)-1/144.
    coneq[4443]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*c**4)-1/432.
    coneq[4444]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c**4)-1/864.
    coneq[4445]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*c**4)-1/288.
    coneq[4446]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*c**4)-1/288.
    coneq[4447]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*c**4)-1/864.
    coneq[4448]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c**4)-1/1728.
    coneq[4449]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*c**4)-1/576.
    coneq[4450]=dot(b,dot(A,c**4)*dot(A,c)*c**4)-1/120.
    coneq[4451]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*c**4)-1/480.
    coneq[4452]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c**4)-1/1440.
    coneq[4453]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c**4)-1/2880.
    coneq[4454]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c**4)-1/960.
    coneq[4455]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*c**4)-1/360.
    coneq[4456]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/720.
    coneq[4457]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*c**4)-1/240.
    coneq[4458]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c**4)-1/480.
    coneq[4459]=dot(b,dot(A,c**2)*dot(A,c**2)*c**5)-1/108.
    coneq[4460]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c**5)-1/216.
    coneq[4461]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c**5)-1/432.
    coneq[4462]=dot(b,dot(A,c**3)*dot(A,c)*c**5)-1/96.
    coneq[4463]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c**5)-1/288.
    coneq[4464]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c**5)-1/576.
    coneq[4465]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c**5)-1/192.
    coneq[4466]=dot(b,dot(A,c**2)*dot(A,c)*c**6)-1/72.
    coneq[4467]=dot(b,dot(A,dot(A,c))*dot(A,c)*c**6)-1/144.
    coneq[4468]=dot(b,dot(A,c)*dot(A,c)*c**7)-1/48.
    coneq[4469]=dot(b,dot(A,c**6)*dot(A,c)*dot(A,c))-1/336.
    coneq[4470]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*dot(A,c))-1/2016.
    coneq[4471]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c))-1/10080.
    coneq[4472]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/40320.
    coneq[4473]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[4474]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/241920.
    coneq[4475]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/80640.
    coneq[4476]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/30240.
    coneq[4477]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[4478]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/20160.
    coneq[4479]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/40320.
    coneq[4480]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/8064.
    coneq[4481]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/24192.
    coneq[4482]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[4483]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/16128.
    coneq[4484]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/6048.
    coneq[4485]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/12096.
    coneq[4486]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c))-1/4032.
    coneq[4487]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[4488]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/24192.
    coneq[4489]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/8064.
    coneq[4490]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*dot(A,c))-1/1680.
    coneq[4491]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/6720.
    coneq[4492]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/20160.
    coneq[4493]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/40320.
    coneq[4494]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/13440.
    coneq[4495]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/5040.
    coneq[4496]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/10080.
    coneq[4497]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/3360.
    coneq[4498]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/6720.
    coneq[4499]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*dot(A,c))-1/1344.
    coneq[4500]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/4032.
    coneq[4501]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/8064.
    coneq[4502]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/2688.
    coneq[4503]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*dot(A,c))-1/1008.
    coneq[4504]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/2016.
    coneq[4505]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*dot(A,c))-1/672.
    coneq[4506]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/3024.
    coneq[4507]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/6048.
    coneq[4508]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[4509]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/2688.
    coneq[4510]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/8064.
    coneq[4511]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/16128.
    coneq[4512]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/5376.
    coneq[4513]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/2016.
    coneq[4514]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/4032.
    coneq[4515]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/1344.
    coneq[4516]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/2688.
    coneq[4517]=dot(b,dot(A,c**5)*dot(A,c**2)*dot(A,c))-1/432.
    coneq[4518]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*dot(A,c))-1/2160.
    coneq[4519]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/8640.
    coneq[4520]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/25920.
    coneq[4521]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/51840.
    coneq[4522]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/17280.
    coneq[4523]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/6480.
    coneq[4524]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/12960.
    coneq[4525]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/4320.
    coneq[4526]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/8640.
    coneq[4527]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/1728.
    coneq[4528]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/5184.
    coneq[4529]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/10368.
    coneq[4530]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/3456.
    coneq[4531]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/1296.
    coneq[4532]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/2592.
    coneq[4533]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*dot(A,c))-1/864.
    coneq[4534]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/2592.
    coneq[4535]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/5184.
    coneq[4536]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c))-1/1728.
    coneq[4537]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,c))-1/864.
    coneq[4538]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,c))-1/4320.
    coneq[4539]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/17280.
    coneq[4540]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/51840.
    coneq[4541]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/103680.
    coneq[4542]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/34560.
    coneq[4543]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/12960.
    coneq[4544]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/25920.
    coneq[4545]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/8640.
    coneq[4546]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/17280.
    coneq[4547]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/3456.
    coneq[4548]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/10368.
    coneq[4549]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/20736.
    coneq[4550]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/6912.
    coneq[4551]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/2592.
    coneq[4552]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/5184.
    coneq[4553]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/1728.
    coneq[4554]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/5184.
    coneq[4555]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/10368.
    coneq[4556]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/3456.
    coneq[4557]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c**2))-1/540.
    coneq[4558]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c**2))-1/2160.
    coneq[4559]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/6480.
    coneq[4560]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/12960.
    coneq[4561]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/4320.
    coneq[4562]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/1620.
    coneq[4563]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/3240.
    coneq[4564]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/1080.
    coneq[4565]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/2160.
    coneq[4566]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c**2))-1/1080.
    coneq[4567]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2))-1/4320.
    coneq[4568]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/12960.
    coneq[4569]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/25920.
    coneq[4570]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/8640.
    coneq[4571]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/3240.
    coneq[4572]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/6480.
    coneq[4573]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/2160.
    coneq[4574]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/4320.
    coneq[4575]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/2160.
    coneq[4576]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/8640.
    coneq[4577]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/25920.
    coneq[4578]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/51840.
    coneq[4579]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/17280.
    coneq[4580]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/6480.
    coneq[4581]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/12960.
    coneq[4582]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/4320.
    coneq[4583]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/8640.
    coneq[4584]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c))-1/480.
    coneq[4585]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c))-1/1920.
    coneq[4586]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/5760.
    coneq[4587]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/11520.
    coneq[4588]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/3840.
    coneq[4589]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/1440.
    coneq[4590]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/2880.
    coneq[4591]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c))-1/960.
    coneq[4592]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c))-1/1920.
    coneq[4593]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c))-1/1440.
    coneq[4594]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c))-1/5760.
    coneq[4595]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/17280.
    coneq[4596]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/34560.
    coneq[4597]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/11520.
    coneq[4598]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/4320.
    coneq[4599]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/8640.
    coneq[4600]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/2880.
    coneq[4601]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/5760.
    coneq[4602]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/2880.
    coneq[4603]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/11520.
    coneq[4604]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/34560.
    coneq[4605]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/69120.
    coneq[4606]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/23040.
    coneq[4607]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/8640.
    coneq[4608]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/17280.
    coneq[4609]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/5760.
    coneq[4610]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/11520.
    coneq[4611]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c))-1/960.
    coneq[4612]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c))-1/3840.
    coneq[4613]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/11520.
    coneq[4614]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/23040.
    coneq[4615]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/7680.
    coneq[4616]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c))-1/2880.
    coneq[4617]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/5760.
    coneq[4618]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/1920.
    coneq[4619]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/3840.
    coneq[4620]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c**2))-1/576.
    coneq[4621]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c**2))-1/1728.
    coneq[4622]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/3456.
    coneq[4623]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c**2))-1/1152.
    coneq[4624]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2))-1/5184.
    coneq[4625]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/10368.
    coneq[4626]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2))-1/3456.
    coneq[4627]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/20736.
    coneq[4628]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/6912.
    coneq[4629]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2))-1/2304.
    coneq[4630]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,dot(A,c)))-1/1152.
    coneq[4631]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c)))-1/3456.
    coneq[4632]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/6912.
    coneq[4633]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c)))-1/2304.
    coneq[4634]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/10368.
    coneq[4635]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/20736.
    coneq[4636]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/6912.
    coneq[4637]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/41472.
    coneq[4638]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/13824.
    coneq[4639]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/4608.
    coneq[4640]=dot(b,dot(A,c**5)*dot(A,c)*dot(A,c)*c)-1/288.
    coneq[4641]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*dot(A,c)*c)-1/1440.
    coneq[4642]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/5760.
    coneq[4643]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/17280.
    coneq[4644]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/34560.
    coneq[4645]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/11520.
    coneq[4646]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/4320.
    coneq[4647]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/8640.
    coneq[4648]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/2880.
    coneq[4649]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/5760.
    coneq[4650]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/1152.
    coneq[4651]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/3456.
    coneq[4652]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/6912.
    coneq[4653]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/2304.
    coneq[4654]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/864.
    coneq[4655]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/1728.
    coneq[4656]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/576.
    coneq[4657]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/1728.
    coneq[4658]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/3456.
    coneq[4659]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1152.
    coneq[4660]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c)*c)-1/360.
    coneq[4661]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c)*c)-1/1440.
    coneq[4662]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/4320.
    coneq[4663]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/8640.
    coneq[4664]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/2880.
    coneq[4665]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/1080.
    coneq[4666]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/2160.
    coneq[4667]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/720.
    coneq[4668]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/1440.
    coneq[4669]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c)*c)-1/720.
    coneq[4670]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c)-1/2880.
    coneq[4671]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/8640.
    coneq[4672]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/17280.
    coneq[4673]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/5760.
    coneq[4674]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/2160.
    coneq[4675]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/4320.
    coneq[4676]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/1440.
    coneq[4677]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/2880.
    coneq[4678]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2)*c)-1/432.
    coneq[4679]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c)-1/1296.
    coneq[4680]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/2592.
    coneq[4681]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/864.
    coneq[4682]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2)*c)-1/864.
    coneq[4683]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/2592.
    coneq[4684]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/5184.
    coneq[4685]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/1728.
    coneq[4686]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/1728.
    coneq[4687]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/5184.
    coneq[4688]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/10368.
    coneq[4689]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/3456.
    coneq[4690]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c)*c)-1/384.
    coneq[4691]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c)*c)-1/1152.
    coneq[4692]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/2304.
    coneq[4693]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c)*c)-1/768.
    coneq[4694]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/3456.
    coneq[4695]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/6912.
    coneq[4696]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/2304.
    coneq[4697]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/13824.
    coneq[4698]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/4608.
    coneq[4699]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/1536.
    coneq[4700]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*c*c)-1/240.
    coneq[4701]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*c*c)-1/960.
    coneq[4702]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/2880.
    coneq[4703]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/5760.
    coneq[4704]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/1920.
    coneq[4705]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/720.
    coneq[4706]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/1440.
    coneq[4707]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/480.
    coneq[4708]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/960.
    coneq[4709]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*c*c)-1/288.
    coneq[4710]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*c*c)-1/864.
    coneq[4711]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/1728.
    coneq[4712]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/576.
    coneq[4713]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*c*c)-1/576.
    coneq[4714]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/1728.
    coneq[4715]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/3456.
    coneq[4716]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/1152.
    coneq[4717]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*c*c)-1/324.
    coneq[4718]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*c*c)-1/648.
    coneq[4719]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/1296.
    coneq[4720]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/2592.
    coneq[4721]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*c**3)-1/192.
    coneq[4722]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c**3)-1/576.
    coneq[4723]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/1152.
    coneq[4724]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/384.
    coneq[4725]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*c**3)-1/216.
    coneq[4726]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c**3)-1/432.
    coneq[4727]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/864.
    coneq[4728]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*c**4)-1/144.
    coneq[4729]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c**4)-1/288.
    coneq[4730]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c**5)-1/96.
    coneq[4731]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*dot(A,c))-1/480.
    coneq[4732]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c))-1/1920.
    coneq[4733]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/5760.
    coneq[4734]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/11520.
    coneq[4735]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/3840.
    coneq[4736]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/1440.
    coneq[4737]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/2880.
    coneq[4738]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/960.
    coneq[4739]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/1920.
    coneq[4740]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*dot(A,c))-1/576.
    coneq[4741]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/1728.
    coneq[4742]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/3456.
    coneq[4743]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/1152.
    coneq[4744]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/1152.
    coneq[4745]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/3456.
    coneq[4746]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/6912.
    coneq[4747]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/2304.
    coneq[4748]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/648.
    coneq[4749]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/1296.
    coneq[4750]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/1296.
    coneq[4751]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/2592.
    coneq[4752]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/2592.
    coneq[4753]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/5184.
    coneq[4754]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/384.
    coneq[4755]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/1152.
    coneq[4756]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/2304.
    coneq[4757]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/768.
    coneq[4758]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/432.
    coneq[4759]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/864.
    coneq[4760]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/864.
    coneq[4761]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1728.
    coneq[4762]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/288.
    coneq[4763]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/576.
    coneq[4764]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/192.
    coneq[4765]=dot(b,c**11)-1/12.
    if any(abs(coneq)>tol):
        return 11
    # order 13 conditions:
    coneq[0]=dot(b,dot(A,c**11))-1/156.
    coneq[1]=dot(b,dot(A,dot(A,c**10)))-1/1716.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**9))))-1/17160.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**8)))))-1/154440.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**7))))))-1/1235520.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**6)))))))-1/8648640.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))))-1/51891840.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))))-1/259459200.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))))-1/1037836800.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/3113510400.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/6227020800.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/2075673600.
    coneq[12]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))))-1/778377600.
    coneq[13]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/1556755200.
    coneq[14]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))))-1/518918400.
    coneq[15]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/1037836800.
    coneq[16]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))))-1/207567360.
    coneq[17]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))))-1/622702080.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/1245404160.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))))-1/415134720.
    coneq[20]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))))-1/155675520.
    coneq[21]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))))-1/311351040.
    coneq[22]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))))-1/103783680.
    coneq[23]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))))-1/311351040.
    coneq[24]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/622702080.
    coneq[25]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))))-1/207567360.
    coneq[26]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))))-1/43243200.
    coneq[27]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))))-1/172972800.
    coneq[28]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))))-1/518918400.
    coneq[29]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1037836800.
    coneq[30]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))))-1/345945600.
    coneq[31]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))))-1/129729600.
    coneq[32]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))))-1/259459200.
    coneq[33]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))))-1/86486400.
    coneq[34]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))))-1/172972800.
    coneq[35]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))))-1/34594560.
    coneq[36]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))))-1/103783680.
    coneq[37]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))))-1/207567360.
    coneq[38]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))))-1/69189120.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))))-1/25945920.
    coneq[40]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))))-1/51891840.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))))-1/17297280.
    coneq[42]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))))-1/77837760.
    coneq[43]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))))-1/155675520.
    coneq[44]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/311351040.
    coneq[45]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))))-1/69189120.
    coneq[46]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))))-1/207567360.
    coneq[47]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/415134720.
    coneq[48]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))))-1/138378240.
    coneq[49]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))))-1/51891840.
    coneq[50]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))))-1/103783680.
    coneq[51]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))))-1/34594560.
    coneq[52]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))))-1/69189120.
    coneq[53]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5)))))))-1/7413120.
    coneq[54]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))))-1/37065600.
    coneq[55]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))))-1/148262400.
    coneq[56]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/444787200.
    coneq[57]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/889574400.
    coneq[58]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/296524800.
    coneq[59]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))))-1/111196800.
    coneq[60]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/222393600.
    coneq[61]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))))-1/74131200.
    coneq[62]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/148262400.
    coneq[63]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))))-1/29652480.
    coneq[64]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))))-1/88957440.
    coneq[65]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/177914880.
    coneq[66]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))))-1/59304960.
    coneq[67]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))))-1/22239360.
    coneq[68]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))))-1/44478720.
    coneq[69]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))))-1/14826240.
    coneq[70]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))))-1/44478720.
    coneq[71]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/88957440.
    coneq[72]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))))-1/29652480.
    coneq[73]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))))-1/6177600.
    coneq[74]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))))-1/24710400.
    coneq[75]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))))-1/74131200.
    coneq[76]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/148262400.
    coneq[77]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))))-1/49420800.
    coneq[78]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))))-1/18532800.
    coneq[79]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))))-1/37065600.
    coneq[80]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))))-1/12355200.
    coneq[81]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))))-1/24710400.
    coneq[82]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))))-1/4942080.
    coneq[83]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))))-1/14826240.
    coneq[84]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))))-1/29652480.
    coneq[85]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))))-1/9884160.
    coneq[86]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))))-1/3706560.
    coneq[87]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))))-1/7413120.
    coneq[88]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c)))))))-1/2471040.
    coneq[89]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))))-1/14826240.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))))-1/44478720.
    coneq[91]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))))-1/88957440.
    coneq[92]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))))-1/29652480.
    coneq[93]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))))-1/29652480.
    coneq[94]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))))-1/88957440.
    coneq[95]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))))-1/177914880.
    coneq[96]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))))-1/59304960.
    coneq[97]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))))-1/12355200.
    coneq[98]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))))-1/49420800.
    coneq[99]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))))-1/148262400.
    coneq[100]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/296524800.
    coneq[101]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))))-1/98841600.
    coneq[102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))))-1/37065600.
    coneq[103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))))-1/74131200.
    coneq[104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))))-1/24710400.
    coneq[105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))))-1/49420800.
    coneq[106]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))))-1/11119680.
    coneq[107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))))-1/22239360.
    coneq[108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/44478720.
    coneq[109]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))))-1/9884160.
    coneq[110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))))-1/29652480.
    coneq[111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/59304960.
    coneq[112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))))-1/19768320.
    coneq[113]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))))-1/7413120.
    coneq[114]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))))-1/14826240.
    coneq[115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))))-1/4942080.
    coneq[116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))))-1/14826240.
    coneq[117]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))))-1/29652480.
    coneq[118]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/9884160.
    coneq[119]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**6))))))-1/1081080.
    coneq[120]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5)))))))-1/6486480.
    coneq[121]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))))-1/32432400.
    coneq[122]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/129729600.
    coneq[123]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/389188800.
    coneq[124]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/778377600.
    coneq[125]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/259459200.
    coneq[126]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/97297200.
    coneq[127]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/194594400.
    coneq[128]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/64864800.
    coneq[129]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/129729600.
    coneq[130]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))))-1/25945920.
    coneq[131]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/77837760.
    coneq[132]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/155675520.
    coneq[133]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/51891840.
    coneq[134]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))))-1/19459440.
    coneq[135]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/38918880.
    coneq[136]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))))-1/12972960.
    coneq[137]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/38918880.
    coneq[138]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/77837760.
    coneq[139]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/25945920.
    coneq[140]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))))-1/5405400.
    coneq[141]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))))-1/21621600.
    coneq[142]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/64864800.
    coneq[143]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/129729600.
    coneq[144]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/43243200.
    coneq[145]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))))-1/16216200.
    coneq[146]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/32432400.
    coneq[147]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))))-1/10810800.
    coneq[148]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/21621600.
    coneq[149]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))))-1/4324320.
    coneq[150]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))))-1/12972960.
    coneq[151]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/25945920.
    coneq[152]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))))-1/8648640.
    coneq[153]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))))-1/3243240.
    coneq[154]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))))-1/6486480.
    coneq[155]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))))-1/2162160.
    coneq[156]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/9729720.
    coneq[157]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/19459440.
    coneq[158]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/38918880.
    coneq[159]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))))-1/8648640.
    coneq[160]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/25945920.
    coneq[161]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/51891840.
    coneq[162]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/17297280.
    coneq[163]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/6486480.
    coneq[164]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/12972960.
    coneq[165]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/4324320.
    coneq[166]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/8648640.
    coneq[167]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**5))))))-1/926640.
    coneq[168]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))))-1/4633200.
    coneq[169]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))))-1/18532800.
    coneq[170]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/55598400.
    coneq[171]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/111196800.
    coneq[172]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/37065600.
    coneq[173]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))))-1/13899600.
    coneq[174]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/27799200.
    coneq[175]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))))-1/9266400.
    coneq[176]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/18532800.
    coneq[177]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))))-1/3706560.
    coneq[178]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))))-1/11119680.
    coneq[179]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/22239360.
    coneq[180]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))))-1/7413120.
    coneq[181]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))))-1/2779920.
    coneq[182]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))))-1/5559840.
    coneq[183]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))))-1/1853280.
    coneq[184]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))))-1/5559840.
    coneq[185]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/11119680.
    coneq[186]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))))-1/3706560.
    coneq[187]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**4))))))-1/772200.
    coneq[188]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))))-1/3088800.
    coneq[189]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))))-1/9266400.
    coneq[190]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18532800.
    coneq[191]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))))-1/6177600.
    coneq[192]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))))-1/2316600.
    coneq[193]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))))-1/4633200.
    coneq[194]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))))-1/1544400.
    coneq[195]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))))-1/3088800.
    coneq[196]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**3))))))-1/617760.
    coneq[197]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))))-1/1853280.
    coneq[198]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))))-1/3706560.
    coneq[199]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))))-1/1235520.
    coneq[200]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c**2))))))-1/463320.
    coneq[201]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c)))))))-1/926640.
    coneq[202]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6*dot(A,c))))))-1/308880.
    coneq[203]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))))-1/2471040.
    coneq[204]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))))-1/7413120.
    coneq[205]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))))-1/14826240.
    coneq[206]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))))-1/4942080.
    coneq[207]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))))-1/22239360.
    coneq[208]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))))-1/44478720.
    coneq[209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))))-1/14826240.
    coneq[210]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))))-1/88957440.
    coneq[211]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))))-1/29652480.
    coneq[212]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))))-1/9884160.
    coneq[213]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))))-1/2316600.
    coneq[214]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))))-1/9266400.
    coneq[215]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))))-1/27799200.
    coneq[216]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/55598400.
    coneq[217]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))))-1/18532800.
    coneq[218]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))))-1/6949800.
    coneq[219]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))))-1/13899600.
    coneq[220]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))))-1/4633200.
    coneq[221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))))-1/9266400.
    coneq[222]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))))-1/4633200.
    coneq[223]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))))-1/18532800.
    coneq[224]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))))-1/55598400.
    coneq[225]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/111196800.
    coneq[226]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))))-1/37065600.
    coneq[227]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))))-1/13899600.
    coneq[228]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))))-1/27799200.
    coneq[229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))))-1/9266400.
    coneq[230]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))))-1/18532800.
    coneq[231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5))))))-1/1853280.
    coneq[232]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))))-1/9266400.
    coneq[233]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))))-1/37065600.
    coneq[234]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/111196800.
    coneq[235]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/222393600.
    coneq[236]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/74131200.
    coneq[237]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))))-1/27799200.
    coneq[238]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/55598400.
    coneq[239]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))))-1/18532800.
    coneq[240]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/37065600.
    coneq[241]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))))-1/7413120.
    coneq[242]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))))-1/22239360.
    coneq[243]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/44478720.
    coneq[244]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))))-1/14826240.
    coneq[245]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))))-1/5559840.
    coneq[246]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))))-1/11119680.
    coneq[247]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))))-1/3706560.
    coneq[248]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))))-1/11119680.
    coneq[249]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/22239360.
    coneq[250]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))))-1/7413120.
    coneq[251]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))))-1/1853280.
    coneq[252]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/5559840.
    coneq[253]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/11119680.
    coneq[254]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/3706560.
    coneq[255]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))))-1/3706560.
    coneq[256]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/11119680.
    coneq[257]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/22239360.
    coneq[258]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/7413120.
    coneq[259]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))))-1/1544400.
    coneq[260]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))))-1/6177600.
    coneq[261]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/18532800.
    coneq[262]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/37065600.
    coneq[263]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/12355200.
    coneq[264]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/4633200.
    coneq[265]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/9266400.
    coneq[266]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3088800.
    coneq[267]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/6177600.
    coneq[268]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))))-1/1389960.
    coneq[269]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2779920.
    coneq[270]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5559840.
    coneq[271]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))))-1/1235520.
    coneq[272]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))))-1/3706560.
    coneq[273]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/7413120.
    coneq[274]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2471040.
    coneq[275]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))))-1/926640.
    coneq[276]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))))-1/1853280.
    coneq[277]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))))-1/617760.
    coneq[278]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))))-1/2471040.
    coneq[279]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))))-1/7413120.
    coneq[280]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/14826240.
    coneq[281]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))))-1/4942080.
    coneq[282]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))))-1/2779920.
    coneq[283]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))))-1/5559840.
    coneq[284]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/11119680.
    coneq[285]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1853280.
    coneq[286]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/3706560.
    coneq[287]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1235520.
    coneq[288]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))))-1/2471040.
    coneq[289]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**7)))))-1/137280.
    coneq[290]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**6))))))-1/960960.
    coneq[291]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5)))))))-1/5765760.
    coneq[292]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/28828800.
    coneq[293]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/115315200.
    coneq[294]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/345945600.
    coneq[295]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/691891200.
    coneq[296]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/230630400.
    coneq[297]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/86486400.
    coneq[298]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/172972800.
    coneq[299]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/57657600.
    coneq[300]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/115315200.
    coneq[301]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/23063040.
    coneq[302]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/69189120.
    coneq[303]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/138378240.
    coneq[304]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/46126080.
    coneq[305]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/17297280.
    coneq[306]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/34594560.
    coneq[307]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/11531520.
    coneq[308]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/34594560.
    coneq[309]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/69189120.
    coneq[310]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/23063040.
    coneq[311]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))))-1/4804800.
    coneq[312]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/19219200.
    coneq[313]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/57657600.
    coneq[314]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/115315200.
    coneq[315]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/38438400.
    coneq[316]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/14414400.
    coneq[317]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/28828800.
    coneq[318]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/9609600.
    coneq[319]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/19219200.
    coneq[320]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))))-1/3843840.
    coneq[321]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/11531520.
    coneq[322]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/23063040.
    coneq[323]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/7687680.
    coneq[324]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))))-1/2882880.
    coneq[325]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/5765760.
    coneq[326]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))))-1/1921920.
    coneq[327]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/8648640.
    coneq[328]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/17297280.
    coneq[329]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/34594560.
    coneq[330]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/7687680.
    coneq[331]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/23063040.
    coneq[332]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/46126080.
    coneq[333]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/15375360.
    coneq[334]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/5765760.
    coneq[335]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/11531520.
    coneq[336]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/3843840.
    coneq[337]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/7687680.
    coneq[338]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**5))))))-1/823680.
    coneq[339]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))))-1/4118400.
    coneq[340]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/16473600.
    coneq[341]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/49420800.
    coneq[342]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/98841600.
    coneq[343]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/32947200.
    coneq[344]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/12355200.
    coneq[345]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/24710400.
    coneq[346]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/8236800.
    coneq[347]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/16473600.
    coneq[348]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))))-1/3294720.
    coneq[349]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/9884160.
    coneq[350]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/19768320.
    coneq[351]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/6589440.
    coneq[352]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2471040.
    coneq[353]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/4942080.
    coneq[354]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1647360.
    coneq[355]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/4942080.
    coneq[356]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/9884160.
    coneq[357]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/3294720.
    coneq[358]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4))))))-1/686400.
    coneq[359]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))))-1/2745600.
    coneq[360]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/8236800.
    coneq[361]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/16473600.
    coneq[362]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/5491200.
    coneq[363]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/2059200.
    coneq[364]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/4118400.
    coneq[365]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1372800.
    coneq[366]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/2745600.
    coneq[367]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3))))))-1/549120.
    coneq[368]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1647360.
    coneq[369]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/3294720.
    coneq[370]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1098240.
    coneq[371]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2))))))-1/411840.
    coneq[372]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))))-1/823680.
    coneq[373]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5*dot(A,c))))))-1/274560.
    coneq[374]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1647360.
    coneq[375]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/4942080.
    coneq[376]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/9884160.
    coneq[377]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/3294720.
    coneq[378]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/3294720.
    coneq[379]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/9884160.
    coneq[380]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/19768320.
    coneq[381]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/6589440.
    coneq[382]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))))-1/1372800.
    coneq[383]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/5491200.
    coneq[384]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/16473600.
    coneq[385]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/32947200.
    coneq[386]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/10982400.
    coneq[387]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/4118400.
    coneq[388]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/8236800.
    coneq[389]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/2745600.
    coneq[390]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/5491200.
    coneq[391]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1235520.
    coneq[392]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2471040.
    coneq[393]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4942080.
    coneq[394]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1098240.
    coneq[395]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/3294720.
    coneq[396]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/6589440.
    coneq[397]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2196480.
    coneq[398]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/823680.
    coneq[399]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1647360.
    coneq[400]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))))-1/549120.
    coneq[401]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1647360.
    coneq[402]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/3294720.
    coneq[403]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1098240.
    coneq[404]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**6)))))-1/120120.
    coneq[405]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**5))))))-1/720720.
    coneq[406]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))))-1/3603600.
    coneq[407]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/14414400.
    coneq[408]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/43243200.
    coneq[409]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/86486400.
    coneq[410]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/28828800.
    coneq[411]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/10810800.
    coneq[412]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/21621600.
    coneq[413]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/7207200.
    coneq[414]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/14414400.
    coneq[415]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))))-1/2882880.
    coneq[416]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/8648640.
    coneq[417]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/17297280.
    coneq[418]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/5765760.
    coneq[419]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2162160.
    coneq[420]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/4324320.
    coneq[421]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))))-1/1441440.
    coneq[422]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/4324320.
    coneq[423]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/8648640.
    coneq[424]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2882880.
    coneq[425]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4))))))-1/600600.
    coneq[426]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))))-1/2402400.
    coneq[427]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/7207200.
    coneq[428]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14414400.
    coneq[429]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/4804800.
    coneq[430]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1801800.
    coneq[431]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3603600.
    coneq[432]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1201200.
    coneq[433]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2402400.
    coneq[434]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3))))))-1/480480.
    coneq[435]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1441440.
    coneq[436]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2882880.
    coneq[437]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/960960.
    coneq[438]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2))))))-1/360360.
    coneq[439]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))))-1/720720.
    coneq[440]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c))))))-1/240240.
    coneq[441]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1081080.
    coneq[442]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2162160.
    coneq[443]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4324320.
    coneq[444]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))))-1/960960.
    coneq[445]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[446]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[447]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[448]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/720720.
    coneq[449]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1441440.
    coneq[450]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/480480.
    coneq[451]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/960960.
    coneq[452]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**5)))))-1/102960.
    coneq[453]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**4))))))-1/514800.
    coneq[454]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))))-1/2059200.
    coneq[455]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/6177600.
    coneq[456]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/12355200.
    coneq[457]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4118400.
    coneq[458]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))))-1/1544400.
    coneq[459]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3088800.
    coneq[460]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))))-1/1029600.
    coneq[461]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2059200.
    coneq[462]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3))))))-1/411840.
    coneq[463]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))))-1/1235520.
    coneq[464]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2471040.
    coneq[465]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))))-1/823680.
    coneq[466]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2))))))-1/308880.
    coneq[467]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))))-1/617760.
    coneq[468]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c))))))-1/205920.
    coneq[469]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))))-1/617760.
    coneq[470]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1235520.
    coneq[471]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))))-1/411840.
    coneq[472]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**4)))))-1/85800.
    coneq[473]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**3))))))-1/343200.
    coneq[474]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))))-1/1029600.
    coneq[475]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2059200.
    coneq[476]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))))-1/686400.
    coneq[477]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2))))))-1/257400.
    coneq[478]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))))-1/514800.
    coneq[479]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c))))))-1/171600.
    coneq[480]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))))-1/343200.
    coneq[481]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**3)))))-1/68640.
    coneq[482]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c**2))))))-1/205920.
    coneq[483]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c)))))))-1/411840.
    coneq[484]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c*dot(A,c))))))-1/137280.
    coneq[485]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c**2)))))-1/51480.
    coneq[486]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,dot(A,c))))))-1/102960.
    coneq[487]=dot(b,dot(A,dot(A,dot(A,c**7*dot(A,c)))))-1/34320.
    coneq[488]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**4)))))-1/343200.
    coneq[489]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))))-1/1372800.
    coneq[490]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))))-1/4118400.
    coneq[491]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8236800.
    coneq[492]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))))-1/2745600.
    coneq[493]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))))-1/1029600.
    coneq[494]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))))-1/2059200.
    coneq[495]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))))-1/686400.
    coneq[496]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))))-1/1372800.
    coneq[497]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))))-1/1029600.
    coneq[498]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))))-1/4118400.
    coneq[499]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))))-1/12355200.
    coneq[500]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/24710400.
    coneq[501]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))))-1/8236800.
    coneq[502]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))))-1/3088800.
    coneq[503]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))))-1/6177600.
    coneq[504]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))))-1/2059200.
    coneq[505]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))))-1/4118400.
    coneq[506]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))))-1/2059200.
    coneq[507]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))))-1/8236800.
    coneq[508]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))))-1/24710400.
    coneq[509]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/49420800.
    coneq[510]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))))-1/16473600.
    coneq[511]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))))-1/6177600.
    coneq[512]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))))-1/12355200.
    coneq[513]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))))-1/4118400.
    coneq[514]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))))-1/8236800.
    coneq[515]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))))-1/686400.
    coneq[516]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))))-1/2745600.
    coneq[517]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/8236800.
    coneq[518]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/16473600.
    coneq[519]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/5491200.
    coneq[520]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))))-1/2059200.
    coneq[521]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/4118400.
    coneq[522]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1372800.
    coneq[523]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2745600.
    coneq[524]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**5)))))-1/308880.
    coneq[525]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))))-1/1544400.
    coneq[526]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))))-1/6177600.
    coneq[527]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/18532800.
    coneq[528]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/37065600.
    coneq[529]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/12355200.
    coneq[530]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))))-1/4633200.
    coneq[531]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/9266400.
    coneq[532]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))))-1/3088800.
    coneq[533]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/6177600.
    coneq[534]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))))-1/1235520.
    coneq[535]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))))-1/3706560.
    coneq[536]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/7413120.
    coneq[537]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))))-1/2471040.
    coneq[538]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))))-1/926640.
    coneq[539]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1853280.
    coneq[540]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))))-1/617760.
    coneq[541]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1853280.
    coneq[542]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3706560.
    coneq[543]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1235520.
    coneq[544]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5)))))-1/617760.
    coneq[545]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))))-1/3088800.
    coneq[546]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))))-1/12355200.
    coneq[547]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/37065600.
    coneq[548]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/74131200.
    coneq[549]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/24710400.
    coneq[550]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))))-1/9266400.
    coneq[551]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/18532800.
    coneq[552]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))))-1/6177600.
    coneq[553]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/12355200.
    coneq[554]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))))-1/2471040.
    coneq[555]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))))-1/7413120.
    coneq[556]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/14826240.
    coneq[557]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))))-1/4942080.
    coneq[558]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))))-1/1853280.
    coneq[559]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))))-1/3706560.
    coneq[560]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))))-1/1235520.
    coneq[561]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))))-1/3706560.
    coneq[562]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/7413120.
    coneq[563]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))))-1/2471040.
    coneq[564]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**6)))))-1/240240.
    coneq[565]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5))))))-1/1441440.
    coneq[566]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))))-1/7207200.
    coneq[567]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/28828800.
    coneq[568]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/86486400.
    coneq[569]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/172972800.
    coneq[570]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/57657600.
    coneq[571]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/21621600.
    coneq[572]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/43243200.
    coneq[573]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/14414400.
    coneq[574]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/28828800.
    coneq[575]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))))-1/5765760.
    coneq[576]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/17297280.
    coneq[577]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/34594560.
    coneq[578]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/11531520.
    coneq[579]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/4324320.
    coneq[580]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/8648640.
    coneq[581]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))))-1/2882880.
    coneq[582]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/8648640.
    coneq[583]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/17297280.
    coneq[584]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/5765760.
    coneq[585]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))))-1/1201200.
    coneq[586]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))))-1/4804800.
    coneq[587]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/14414400.
    coneq[588]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/28828800.
    coneq[589]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/9609600.
    coneq[590]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/3603600.
    coneq[591]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/7207200.
    coneq[592]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2402400.
    coneq[593]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/4804800.
    coneq[594]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))))-1/960960.
    coneq[595]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[596]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[597]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[598]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))))-1/720720.
    coneq[599]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))))-1/1441440.
    coneq[600]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))))-1/480480.
    coneq[601]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2162160.
    coneq[602]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/4324320.
    coneq[603]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/8648640.
    coneq[604]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))))-1/1921920.
    coneq[605]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/5765760.
    coneq[606]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/11531520.
    coneq[607]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/3843840.
    coneq[608]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1441440.
    coneq[609]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2882880.
    coneq[610]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/960960.
    coneq[611]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1921920.
    coneq[612]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3)))))-1/274560.
    coneq[613]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))))-1/823680.
    coneq[614]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1647360.
    coneq[615]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))))-1/549120.
    coneq[616]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2471040.
    coneq[617]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/4942080.
    coneq[618]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1647360.
    coneq[619]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/9884160.
    coneq[620]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/3294720.
    coneq[621]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1098240.
    coneq[622]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4)))))-1/257400.
    coneq[623]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1029600.
    coneq[624]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/3088800.
    coneq[625]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6177600.
    coneq[626]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/2059200.
    coneq[627]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/772200.
    coneq[628]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1544400.
    coneq[629]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/514800.
    coneq[630]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1029600.
    coneq[631]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))))-1/514800.
    coneq[632]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/2059200.
    coneq[633]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/6177600.
    coneq[634]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/12355200.
    coneq[635]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/4118400.
    coneq[636]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1544400.
    coneq[637]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/3088800.
    coneq[638]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1029600.
    coneq[639]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2059200.
    coneq[640]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**5)))))-1/205920.
    coneq[641]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))))-1/1029600.
    coneq[642]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/4118400.
    coneq[643]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/12355200.
    coneq[644]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/24710400.
    coneq[645]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/8236800.
    coneq[646]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/3088800.
    coneq[647]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/6177600.
    coneq[648]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/2059200.
    coneq[649]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4118400.
    coneq[650]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))))-1/823680.
    coneq[651]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2471040.
    coneq[652]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4942080.
    coneq[653]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1647360.
    coneq[654]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/617760.
    coneq[655]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1235520.
    coneq[656]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))))-1/411840.
    coneq[657]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1235520.
    coneq[658]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2471040.
    coneq[659]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/823680.
    coneq[660]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3)))))-1/205920.
    coneq[661]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/617760.
    coneq[662]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1235520.
    coneq[663]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/411840.
    coneq[664]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))))-1/411840.
    coneq[665]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1235520.
    coneq[666]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2471040.
    coneq[667]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/823680.
    coneq[668]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4)))))-1/171600.
    coneq[669]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))))-1/686400.
    coneq[670]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2059200.
    coneq[671]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4118400.
    coneq[672]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1372800.
    coneq[673]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/514800.
    coneq[674]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1029600.
    coneq[675]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/343200.
    coneq[676]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/686400.
    coneq[677]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2)))))-1/154440.
    coneq[678]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))))-1/308880.
    coneq[679]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/617760.
    coneq[680]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3)))))-1/137280.
    coneq[681]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))))-1/411840.
    coneq[682]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/823680.
    coneq[683]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))))-1/274560.
    coneq[684]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2)))))-1/102960.
    coneq[685]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))))-1/205920.
    coneq[686]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c)*dot(A,c)))))-1/68640.
    coneq[687]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))))-1/343200.
    coneq[688]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))))-1/1372800.
    coneq[689]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/4118400.
    coneq[690]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8236800.
    coneq[691]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2745600.
    coneq[692]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1029600.
    coneq[693]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2059200.
    coneq[694]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/686400.
    coneq[695]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1372800.
    coneq[696]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))))-1/411840.
    coneq[697]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1235520.
    coneq[698]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2471040.
    coneq[699]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/823680.
    coneq[700]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))))-1/823680.
    coneq[701]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2471040.
    coneq[702]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/4942080.
    coneq[703]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1647360.
    coneq[704]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))))-1/463320.
    coneq[705]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))))-1/926640.
    coneq[706]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1853280.
    coneq[707]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/3706560.
    coneq[708]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/274560.
    coneq[709]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/823680.
    coneq[710]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1647360.
    coneq[711]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/549120.
    coneq[712]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/308880.
    coneq[713]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/617760.
    coneq[714]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1235520.
    coneq[715]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/205920.
    coneq[716]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/411840.
    coneq[717]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))))-1/137280.
    coneq[718]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/411840.
    coneq[719]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/823680.
    coneq[720]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/274560.
    coneq[721]=dot(b,dot(A,dot(A,c*dot(A,c**8))))-1/15444.
    coneq[722]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**7)))))-1/123552.
    coneq[723]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**6))))))-1/864864.
    coneq[724]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/5189184.
    coneq[725]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/25945920.
    coneq[726]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/103783680.
    coneq[727]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/311351040.
    coneq[728]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/622702080.
    coneq[729]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/207567360.
    coneq[730]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/77837760.
    coneq[731]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/155675520.
    coneq[732]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/51891840.
    coneq[733]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/103783680.
    coneq[734]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/20756736.
    coneq[735]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/62270208.
    coneq[736]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/124540416.
    coneq[737]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/41513472.
    coneq[738]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/15567552.
    coneq[739]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/31135104.
    coneq[740]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/10378368.
    coneq[741]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/31135104.
    coneq[742]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/62270208.
    coneq[743]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/20756736.
    coneq[744]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/4324320.
    coneq[745]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/17297280.
    coneq[746]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/51891840.
    coneq[747]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/103783680.
    coneq[748]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/34594560.
    coneq[749]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/12972960.
    coneq[750]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/25945920.
    coneq[751]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/8648640.
    coneq[752]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/17297280.
    coneq[753]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/3459456.
    coneq[754]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/10378368.
    coneq[755]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/20756736.
    coneq[756]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/6918912.
    coneq[757]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/2594592.
    coneq[758]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/5189184.
    coneq[759]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/1729728.
    coneq[760]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/7783776.
    coneq[761]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/15567552.
    coneq[762]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/31135104.
    coneq[763]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/6918912.
    coneq[764]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/20756736.
    coneq[765]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/41513472.
    coneq[766]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/13837824.
    coneq[767]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/5189184.
    coneq[768]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/10378368.
    coneq[769]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/3459456.
    coneq[770]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/6918912.
    coneq[771]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**5))))))-1/741312.
    coneq[772]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/3706560.
    coneq[773]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/14826240.
    coneq[774]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/44478720.
    coneq[775]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/88957440.
    coneq[776]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/29652480.
    coneq[777]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/11119680.
    coneq[778]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/22239360.
    coneq[779]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/7413120.
    coneq[780]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/14826240.
    coneq[781]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/2965248.
    coneq[782]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/8895744.
    coneq[783]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/17791488.
    coneq[784]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/5930496.
    coneq[785]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2223936.
    coneq[786]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/4447872.
    coneq[787]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1482624.
    coneq[788]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/4447872.
    coneq[789]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/8895744.
    coneq[790]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/2965248.
    coneq[791]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4))))))-1/617760.
    coneq[792]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/2471040.
    coneq[793]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/7413120.
    coneq[794]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14826240.
    coneq[795]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/4942080.
    coneq[796]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/1853280.
    coneq[797]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/3706560.
    coneq[798]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1235520.
    coneq[799]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/2471040.
    coneq[800]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3))))))-1/494208.
    coneq[801]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1482624.
    coneq[802]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/2965248.
    coneq[803]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/988416.
    coneq[804]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2))))))-1/370656.
    coneq[805]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/741312.
    coneq[806]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5*dot(A,c))))))-1/247104.
    coneq[807]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1482624.
    coneq[808]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/4447872.
    coneq[809]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/8895744.
    coneq[810]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/2965248.
    coneq[811]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/2965248.
    coneq[812]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/8895744.
    coneq[813]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/17791488.
    coneq[814]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/5930496.
    coneq[815]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/1235520.
    coneq[816]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/4942080.
    coneq[817]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/14826240.
    coneq[818]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/29652480.
    coneq[819]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/9884160.
    coneq[820]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/3706560.
    coneq[821]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/7413120.
    coneq[822]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/2471040.
    coneq[823]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/4942080.
    coneq[824]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1111968.
    coneq[825]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2223936.
    coneq[826]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4447872.
    coneq[827]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/988416.
    coneq[828]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/2965248.
    coneq[829]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5930496.
    coneq[830]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/1976832.
    coneq[831]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/741312.
    coneq[832]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1482624.
    coneq[833]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/494208.
    coneq[834]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1482624.
    coneq[835]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/2965248.
    coneq[836]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/988416.
    coneq[837]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**6)))))-1/108108.
    coneq[838]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**5))))))-1/648648.
    coneq[839]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/3243240.
    coneq[840]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/12972960.
    coneq[841]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/38918880.
    coneq[842]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/77837760.
    coneq[843]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/25945920.
    coneq[844]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/9729720.
    coneq[845]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/19459440.
    coneq[846]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/6486480.
    coneq[847]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/12972960.
    coneq[848]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/2594592.
    coneq[849]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/7783776.
    coneq[850]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/15567552.
    coneq[851]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/5189184.
    coneq[852]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1945944.
    coneq[853]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/3891888.
    coneq[854]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/1297296.
    coneq[855]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/3891888.
    coneq[856]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/7783776.
    coneq[857]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2594592.
    coneq[858]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4))))))-1/540540.
    coneq[859]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/2162160.
    coneq[860]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/6486480.
    coneq[861]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/12972960.
    coneq[862]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/4324320.
    coneq[863]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1621620.
    coneq[864]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3243240.
    coneq[865]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1081080.
    coneq[866]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2162160.
    coneq[867]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/432432.
    coneq[868]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1297296.
    coneq[869]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2594592.
    coneq[870]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/864864.
    coneq[871]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/324324.
    coneq[872]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/648648.
    coneq[873]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c))))))-1/216216.
    coneq[874]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/972972.
    coneq[875]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1945944.
    coneq[876]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3891888.
    coneq[877]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/864864.
    coneq[878]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2594592.
    coneq[879]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5189184.
    coneq[880]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1729728.
    coneq[881]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/648648.
    coneq[882]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1297296.
    coneq[883]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/432432.
    coneq[884]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/864864.
    coneq[885]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**5)))))-1/92664.
    coneq[886]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4))))))-1/463320.
    coneq[887]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/1853280.
    coneq[888]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5559840.
    coneq[889]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11119680.
    coneq[890]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3706560.
    coneq[891]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/1389960.
    coneq[892]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2779920.
    coneq[893]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/926640.
    coneq[894]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1853280.
    coneq[895]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/370656.
    coneq[896]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/1111968.
    coneq[897]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2223936.
    coneq[898]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/741312.
    coneq[899]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/277992.
    coneq[900]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/555984.
    coneq[901]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/185328.
    coneq[902]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/555984.
    coneq[903]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1111968.
    coneq[904]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/370656.
    coneq[905]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**4)))))-1/77220.
    coneq[906]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3))))))-1/308880.
    coneq[907]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/926640.
    coneq[908]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1853280.
    coneq[909]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/617760.
    coneq[910]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/231660.
    coneq[911]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/463320.
    coneq[912]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/154440.
    coneq[913]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/308880.
    coneq[914]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**3)))))-1/61776.
    coneq[915]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2))))))-1/185328.
    coneq[916]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/370656.
    coneq[917]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c))))))-1/123552.
    coneq[918]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c**2)))))-1/46332.
    coneq[919]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,dot(A,c))))))-1/92664.
    coneq[920]=dot(b,dot(A,dot(A,c*dot(A,c**6*dot(A,c)))))-1/30888.
    coneq[921]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3)))))-1/247104.
    coneq[922]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/741312.
    coneq[923]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1482624.
    coneq[924]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/494208.
    coneq[925]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2223936.
    coneq[926]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/4447872.
    coneq[927]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1482624.
    coneq[928]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/8895744.
    coneq[929]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/2965248.
    coneq[930]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/988416.
    coneq[931]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4)))))-1/231660.
    coneq[932]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/926640.
    coneq[933]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/2779920.
    coneq[934]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5559840.
    coneq[935]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/1853280.
    coneq[936]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/694980.
    coneq[937]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1389960.
    coneq[938]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/463320.
    coneq[939]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/926640.
    coneq[940]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/463320.
    coneq[941]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/1853280.
    coneq[942]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/5559840.
    coneq[943]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/11119680.
    coneq[944]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/3706560.
    coneq[945]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1389960.
    coneq[946]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/2779920.
    coneq[947]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/926640.
    coneq[948]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/1853280.
    coneq[949]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**5)))))-1/185328.
    coneq[950]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/926640.
    coneq[951]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/3706560.
    coneq[952]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/11119680.
    coneq[953]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/22239360.
    coneq[954]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/7413120.
    coneq[955]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/2779920.
    coneq[956]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5559840.
    coneq[957]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/1853280.
    coneq[958]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3706560.
    coneq[959]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/741312.
    coneq[960]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2223936.
    coneq[961]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4447872.
    coneq[962]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1482624.
    coneq[963]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/555984.
    coneq[964]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1111968.
    coneq[965]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/370656.
    coneq[966]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1111968.
    coneq[967]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2223936.
    coneq[968]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/741312.
    coneq[969]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/185328.
    coneq[970]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/555984.
    coneq[971]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1111968.
    coneq[972]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/370656.
    coneq[973]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/370656.
    coneq[974]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1111968.
    coneq[975]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2223936.
    coneq[976]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/741312.
    coneq[977]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4)))))-1/154440.
    coneq[978]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/617760.
    coneq[979]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1853280.
    coneq[980]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3706560.
    coneq[981]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1235520.
    coneq[982]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/463320.
    coneq[983]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/926640.
    coneq[984]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/308880.
    coneq[985]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/617760.
    coneq[986]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/138996.
    coneq[987]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/277992.
    coneq[988]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/555984.
    coneq[989]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/123552.
    coneq[990]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/370656.
    coneq[991]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/741312.
    coneq[992]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/247104.
    coneq[993]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/92664.
    coneq[994]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/185328.
    coneq[995]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c)))))-1/61776.
    coneq[996]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/247104.
    coneq[997]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/741312.
    coneq[998]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1482624.
    coneq[999]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/494208.
    coneq[1000]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/277992.
    coneq[1001]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/555984.
    coneq[1002]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1111968.
    coneq[1003]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/185328.
    coneq[1004]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/370656.
    coneq[1005]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/123552.
    coneq[1006]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/247104.
    coneq[1007]=dot(b,dot(A,dot(A,c**2*dot(A,c**7))))-1/13728.
    coneq[1008]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**6)))))-1/96096.
    coneq[1009]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**5))))))-1/576576.
    coneq[1010]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/2882880.
    coneq[1011]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/11531520.
    coneq[1012]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/34594560.
    coneq[1013]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/69189120.
    coneq[1014]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/23063040.
    coneq[1015]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/8648640.
    coneq[1016]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/17297280.
    coneq[1017]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/5765760.
    coneq[1018]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/11531520.
    coneq[1019]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/2306304.
    coneq[1020]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/6918912.
    coneq[1021]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/13837824.
    coneq[1022]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/4612608.
    coneq[1023]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1729728.
    coneq[1024]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/3459456.
    coneq[1025]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1153152.
    coneq[1026]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/3459456.
    coneq[1027]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/6918912.
    coneq[1028]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2306304.
    coneq[1029]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4))))))-1/480480.
    coneq[1030]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1921920.
    coneq[1031]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/5765760.
    coneq[1032]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11531520.
    coneq[1033]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/3843840.
    coneq[1034]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1441440.
    coneq[1035]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2882880.
    coneq[1036]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/960960.
    coneq[1037]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1921920.
    coneq[1038]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3))))))-1/384384.
    coneq[1039]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1153152.
    coneq[1040]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2306304.
    coneq[1041]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/768768.
    coneq[1042]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2))))))-1/288288.
    coneq[1043]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/576576.
    coneq[1044]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c))))))-1/192192.
    coneq[1045]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/864864.
    coneq[1046]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1729728.
    coneq[1047]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3459456.
    coneq[1048]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/768768.
    coneq[1049]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2306304.
    coneq[1050]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/4612608.
    coneq[1051]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1537536.
    coneq[1052]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/576576.
    coneq[1053]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1153152.
    coneq[1054]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/384384.
    coneq[1055]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/768768.
    coneq[1056]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**5)))))-1/82368.
    coneq[1057]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4))))))-1/411840.
    coneq[1058]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1647360.
    coneq[1059]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4942080.
    coneq[1060]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/9884160.
    coneq[1061]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3294720.
    coneq[1062]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1235520.
    coneq[1063]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2471040.
    coneq[1064]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/823680.
    coneq[1065]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1647360.
    coneq[1066]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3))))))-1/329472.
    coneq[1067]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/988416.
    coneq[1068]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1976832.
    coneq[1069]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/658944.
    coneq[1070]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/247104.
    coneq[1071]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/494208.
    coneq[1072]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c))))))-1/164736.
    coneq[1073]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/494208.
    coneq[1074]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/988416.
    coneq[1075]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/329472.
    coneq[1076]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**4)))))-1/68640.
    coneq[1077]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3))))))-1/274560.
    coneq[1078]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/823680.
    coneq[1079]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1647360.
    coneq[1080]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/549120.
    coneq[1081]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/205920.
    coneq[1082]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/411840.
    coneq[1083]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/137280.
    coneq[1084]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/274560.
    coneq[1085]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**3)))))-1/54912.
    coneq[1086]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2))))))-1/164736.
    coneq[1087]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/329472.
    coneq[1088]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c))))))-1/109824.
    coneq[1089]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c**2)))))-1/41184.
    coneq[1090]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c))))))-1/82368.
    coneq[1091]=dot(b,dot(A,dot(A,c**2*dot(A,c**5*dot(A,c)))))-1/27456.
    coneq[1092]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/164736.
    coneq[1093]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/494208.
    coneq[1094]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/988416.
    coneq[1095]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/329472.
    coneq[1096]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/329472.
    coneq[1097]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/988416.
    coneq[1098]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1976832.
    coneq[1099]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/658944.
    coneq[1100]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4)))))-1/137280.
    coneq[1101]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/549120.
    coneq[1102]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1647360.
    coneq[1103]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3294720.
    coneq[1104]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1098240.
    coneq[1105]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/411840.
    coneq[1106]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/823680.
    coneq[1107]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/274560.
    coneq[1108]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/549120.
    coneq[1109]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/123552.
    coneq[1110]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/247104.
    coneq[1111]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/494208.
    coneq[1112]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/109824.
    coneq[1113]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/329472.
    coneq[1114]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/658944.
    coneq[1115]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/219648.
    coneq[1116]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/82368.
    coneq[1117]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/164736.
    coneq[1118]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/54912.
    coneq[1119]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/164736.
    coneq[1120]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/329472.
    coneq[1121]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/109824.
    coneq[1122]=dot(b,dot(A,dot(A,c**3*dot(A,c**6))))-1/12012.
    coneq[1123]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**5)))))-1/72072.
    coneq[1124]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**4))))))-1/360360.
    coneq[1125]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1441440.
    coneq[1126]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4324320.
    coneq[1127]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/8648640.
    coneq[1128]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2882880.
    coneq[1129]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1081080.
    coneq[1130]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2162160.
    coneq[1131]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/720720.
    coneq[1132]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1441440.
    coneq[1133]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3))))))-1/288288.
    coneq[1134]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/864864.
    coneq[1135]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1729728.
    coneq[1136]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/576576.
    coneq[1137]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2))))))-1/216216.
    coneq[1138]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/432432.
    coneq[1139]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c))))))-1/144144.
    coneq[1140]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/432432.
    coneq[1141]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/864864.
    coneq[1142]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/288288.
    coneq[1143]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**4)))))-1/60060.
    coneq[1144]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3))))))-1/240240.
    coneq[1145]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/720720.
    coneq[1146]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1441440.
    coneq[1147]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/480480.
    coneq[1148]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2))))))-1/180180.
    coneq[1149]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/360360.
    coneq[1150]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c))))))-1/120120.
    coneq[1151]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/240240.
    coneq[1152]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**3)))))-1/48048.
    coneq[1153]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2))))))-1/144144.
    coneq[1154]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/288288.
    coneq[1155]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c))))))-1/96096.
    coneq[1156]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c**2)))))-1/36036.
    coneq[1157]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c))))))-1/72072.
    coneq[1158]=dot(b,dot(A,dot(A,c**3*dot(A,c**4*dot(A,c)))))-1/24024.
    coneq[1159]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/108108.
    coneq[1160]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/216216.
    coneq[1161]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/432432.
    coneq[1162]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3)))))-1/96096.
    coneq[1163]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/288288.
    coneq[1164]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/576576.
    coneq[1165]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/192192.
    coneq[1166]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/72072.
    coneq[1167]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/144144.
    coneq[1168]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/48048.
    coneq[1169]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/96096.
    coneq[1170]=dot(b,dot(A,dot(A,c**4*dot(A,c**5))))-1/10296.
    coneq[1171]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**4)))))-1/51480.
    coneq[1172]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**3))))))-1/205920.
    coneq[1173]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/617760.
    coneq[1174]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1235520.
    coneq[1175]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/411840.
    coneq[1176]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2))))))-1/154440.
    coneq[1177]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/308880.
    coneq[1178]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c))))))-1/102960.
    coneq[1179]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/205920.
    coneq[1180]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**3)))))-1/41184.
    coneq[1181]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2))))))-1/123552.
    coneq[1182]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/247104.
    coneq[1183]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c))))))-1/82368.
    coneq[1184]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c**2)))))-1/30888.
    coneq[1185]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c))))))-1/61776.
    coneq[1186]=dot(b,dot(A,dot(A,c**4*dot(A,c**3*dot(A,c)))))-1/20592.
    coneq[1187]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2)))))-1/61776.
    coneq[1188]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/123552.
    coneq[1189]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c)))))-1/41184.
    coneq[1190]=dot(b,dot(A,dot(A,c**5*dot(A,c**4))))-1/8580.
    coneq[1191]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**3)))))-1/34320.
    coneq[1192]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c**2))))))-1/102960.
    coneq[1193]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c)))))))-1/205920.
    coneq[1194]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c*dot(A,c))))))-1/68640.
    coneq[1195]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c**2)))))-1/25740.
    coneq[1196]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,dot(A,c))))))-1/51480.
    coneq[1197]=dot(b,dot(A,dot(A,c**5*dot(A,c**2*dot(A,c)))))-1/17160.
    coneq[1198]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c)*dot(A,c)))))-1/34320.
    coneq[1199]=dot(b,dot(A,dot(A,c**6*dot(A,c**3))))-1/6864.
    coneq[1200]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c**2)))))-1/20592.
    coneq[1201]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,dot(A,c))))))-1/41184.
    coneq[1202]=dot(b,dot(A,dot(A,c**6*dot(A,c*dot(A,c)))))-1/13728.
    coneq[1203]=dot(b,dot(A,dot(A,c**7*dot(A,c**2))))-1/5148.
    coneq[1204]=dot(b,dot(A,dot(A,c**7*dot(A,dot(A,c)))))-1/10296.
    coneq[1205]=dot(b,dot(A,dot(A,c**8*dot(A,c))))-1/3432.
    coneq[1206]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**4))))-1/42900.
    coneq[1207]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c**3)))))-1/171600.
    coneq[1208]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))))-1/514800.
    coneq[1209]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1029600.
    coneq[1210]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))))-1/343200.
    coneq[1211]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2)))))-1/128700.
    coneq[1212]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))))-1/257400.
    coneq[1213]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c)))))-1/85800.
    coneq[1214]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))))-1/171600.
    coneq[1215]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))))-1/686400.
    coneq[1216]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))))-1/2059200.
    coneq[1217]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4118400.
    coneq[1218]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))))-1/1372800.
    coneq[1219]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))))-1/514800.
    coneq[1220]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))))-1/1029600.
    coneq[1221]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))))-1/343200.
    coneq[1222]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))))-1/686400.
    coneq[1223]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))))-1/6177600.
    coneq[1224]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/12355200.
    coneq[1225]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))))-1/4118400.
    coneq[1226]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))))-1/1544400.
    coneq[1227]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))))-1/3088800.
    coneq[1228]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))))-1/1029600.
    coneq[1229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))))-1/2059200.
    coneq[1230]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/24710400.
    coneq[1231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))))-1/8236800.
    coneq[1232]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))))-1/3088800.
    coneq[1233]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))))-1/6177600.
    coneq[1234]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))))-1/2059200.
    coneq[1235]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))))-1/4118400.
    coneq[1236]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/2745600.
    coneq[1237]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/1029600.
    coneq[1238]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/2059200.
    coneq[1239]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/686400.
    coneq[1240]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1372800.
    coneq[1241]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/386100.
    coneq[1242]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/772200.
    coneq[1243]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/257400.
    coneq[1244]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/514800.
    coneq[1245]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1544400.
    coneq[1246]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/514800.
    coneq[1247]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1029600.
    coneq[1248]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/171600.
    coneq[1249]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/343200.
    coneq[1250]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/686400.
    coneq[1251]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**5))))-1/41184.
    coneq[1252]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**4)))))-1/205920.
    coneq[1253]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))))-1/823680.
    coneq[1254]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2471040.
    coneq[1255]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4942080.
    coneq[1256]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1647360.
    coneq[1257]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))))-1/617760.
    coneq[1258]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1235520.
    coneq[1259]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))))-1/411840.
    coneq[1260]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/823680.
    coneq[1261]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3)))))-1/164736.
    coneq[1262]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))))-1/494208.
    coneq[1263]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/988416.
    coneq[1264]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))))-1/329472.
    coneq[1265]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2)))))-1/123552.
    coneq[1266]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))))-1/247104.
    coneq[1267]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c)))))-1/82368.
    coneq[1268]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))))-1/247104.
    coneq[1269]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/494208.
    coneq[1270]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))))-1/164736.
    coneq[1271]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**5))))-1/123552.
    coneq[1272]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))))-1/617760.
    coneq[1273]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))))-1/2471040.
    coneq[1274]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/7413120.
    coneq[1275]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/14826240.
    coneq[1276]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/4942080.
    coneq[1277]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))))-1/1853280.
    coneq[1278]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3706560.
    coneq[1279]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))))-1/1235520.
    coneq[1280]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2471040.
    coneq[1281]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))))-1/494208.
    coneq[1282]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))))-1/1482624.
    coneq[1283]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2965248.
    coneq[1284]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))))-1/988416.
    coneq[1285]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))))-1/370656.
    coneq[1286]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))))-1/741312.
    coneq[1287]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))))-1/247104.
    coneq[1288]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))))-1/741312.
    coneq[1289]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1482624.
    coneq[1290]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))))-1/494208.
    coneq[1291]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5))))-1/247104.
    coneq[1292]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))))-1/1235520.
    coneq[1293]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))))-1/4942080.
    coneq[1294]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/14826240.
    coneq[1295]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/29652480.
    coneq[1296]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/9884160.
    coneq[1297]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))))-1/3706560.
    coneq[1298]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/7413120.
    coneq[1299]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))))-1/2471040.
    coneq[1300]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/4942080.
    coneq[1301]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))))-1/988416.
    coneq[1302]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))))-1/2965248.
    coneq[1303]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/5930496.
    coneq[1304]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))))-1/1976832.
    coneq[1305]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))))-1/741312.
    coneq[1306]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))))-1/1482624.
    coneq[1307]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))))-1/494208.
    coneq[1308]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))))-1/1482624.
    coneq[1309]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/2965248.
    coneq[1310]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))))-1/988416.
    coneq[1311]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**5))))-1/82368.
    coneq[1312]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))))-1/411840.
    coneq[1313]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1647360.
    coneq[1314]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4942080.
    coneq[1315]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/9884160.
    coneq[1316]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3294720.
    coneq[1317]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1235520.
    coneq[1318]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2471040.
    coneq[1319]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/823680.
    coneq[1320]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1647360.
    coneq[1321]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))))-1/329472.
    coneq[1322]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/988416.
    coneq[1323]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1976832.
    coneq[1324]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/658944.
    coneq[1325]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/247104.
    coneq[1326]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/494208.
    coneq[1327]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))))-1/164736.
    coneq[1328]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/494208.
    coneq[1329]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/988416.
    coneq[1330]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/329472.
    coneq[1331]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**6))))-1/36036.
    coneq[1332]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**5)))))-1/216216.
    coneq[1333]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))))-1/1081080.
    coneq[1334]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/4324320.
    coneq[1335]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/12972960.
    coneq[1336]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/25945920.
    coneq[1337]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/8648640.
    coneq[1338]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/3243240.
    coneq[1339]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/6486480.
    coneq[1340]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/2162160.
    coneq[1341]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4324320.
    coneq[1342]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))))-1/864864.
    coneq[1343]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2594592.
    coneq[1344]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5189184.
    coneq[1345]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1729728.
    coneq[1346]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/648648.
    coneq[1347]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1297296.
    coneq[1348]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))))-1/432432.
    coneq[1349]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1297296.
    coneq[1350]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2594592.
    coneq[1351]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/864864.
    coneq[1352]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4)))))-1/180180.
    coneq[1353]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))))-1/720720.
    coneq[1354]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/2162160.
    coneq[1355]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4324320.
    coneq[1356]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1441440.
    coneq[1357]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/540540.
    coneq[1358]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1081080.
    coneq[1359]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/360360.
    coneq[1360]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/720720.
    coneq[1361]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3)))))-1/144144.
    coneq[1362]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/432432.
    coneq[1363]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/864864.
    coneq[1364]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/288288.
    coneq[1365]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2)))))-1/108108.
    coneq[1366]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))))-1/216216.
    coneq[1367]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c)))))-1/72072.
    coneq[1368]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/324324.
    coneq[1369]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/648648.
    coneq[1370]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1297296.
    coneq[1371]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))))-1/288288.
    coneq[1372]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/864864.
    coneq[1373]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1729728.
    coneq[1374]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/576576.
    coneq[1375]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/216216.
    coneq[1376]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/432432.
    coneq[1377]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/144144.
    coneq[1378]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/288288.
    coneq[1379]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**6))))-1/72072.
    coneq[1380]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5)))))-1/432432.
    coneq[1381]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))))-1/2162160.
    coneq[1382]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/8648640.
    coneq[1383]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/25945920.
    coneq[1384]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/51891840.
    coneq[1385]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/17297280.
    coneq[1386]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/6486480.
    coneq[1387]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/12972960.
    coneq[1388]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/4324320.
    coneq[1389]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/8648640.
    coneq[1390]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))))-1/1729728.
    coneq[1391]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/5189184.
    coneq[1392]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/10378368.
    coneq[1393]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/3459456.
    coneq[1394]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))))-1/1297296.
    coneq[1395]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/2594592.
    coneq[1396]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))))-1/864864.
    coneq[1397]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/2594592.
    coneq[1398]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/5189184.
    coneq[1399]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1729728.
    coneq[1400]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))))-1/360360.
    coneq[1401]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))))-1/1441440.
    coneq[1402]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/4324320.
    coneq[1403]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8648640.
    coneq[1404]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2882880.
    coneq[1405]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))))-1/1081080.
    coneq[1406]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/2162160.
    coneq[1407]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))))-1/720720.
    coneq[1408]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1441440.
    coneq[1409]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))))-1/288288.
    coneq[1410]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))))-1/864864.
    coneq[1411]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1729728.
    coneq[1412]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))))-1/576576.
    coneq[1413]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))))-1/216216.
    coneq[1414]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))))-1/432432.
    coneq[1415]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))))-1/144144.
    coneq[1416]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/648648.
    coneq[1417]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1297296.
    coneq[1418]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2594592.
    coneq[1419]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))))-1/576576.
    coneq[1420]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1729728.
    coneq[1421]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/3459456.
    coneq[1422]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1153152.
    coneq[1423]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/432432.
    coneq[1424]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/864864.
    coneq[1425]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/288288.
    coneq[1426]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/576576.
    coneq[1427]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**7))))-1/27456.
    coneq[1428]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**6)))))-1/192192.
    coneq[1429]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5))))))-1/1153152.
    coneq[1430]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/5765760.
    coneq[1431]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/23063040.
    coneq[1432]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/69189120.
    coneq[1433]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/138378240.
    coneq[1434]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/46126080.
    coneq[1435]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/17297280.
    coneq[1436]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/34594560.
    coneq[1437]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/11531520.
    coneq[1438]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/23063040.
    coneq[1439]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/4612608.
    coneq[1440]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/13837824.
    coneq[1441]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/27675648.
    coneq[1442]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/9225216.
    coneq[1443]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/3459456.
    coneq[1444]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/6918912.
    coneq[1445]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/2306304.
    coneq[1446]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/6918912.
    coneq[1447]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/13837824.
    coneq[1448]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/4612608.
    coneq[1449]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))))-1/960960.
    coneq[1450]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/3843840.
    coneq[1451]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/11531520.
    coneq[1452]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/23063040.
    coneq[1453]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/7687680.
    coneq[1454]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2882880.
    coneq[1455]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/5765760.
    coneq[1456]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1921920.
    coneq[1457]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/3843840.
    coneq[1458]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))))-1/768768.
    coneq[1459]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2306304.
    coneq[1460]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/4612608.
    coneq[1461]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1537536.
    coneq[1462]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))))-1/576576.
    coneq[1463]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/1153152.
    coneq[1464]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))))-1/384384.
    coneq[1465]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1729728.
    coneq[1466]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/3459456.
    coneq[1467]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/6918912.
    coneq[1468]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/1537536.
    coneq[1469]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/4612608.
    coneq[1470]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/9225216.
    coneq[1471]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/3075072.
    coneq[1472]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1153152.
    coneq[1473]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2306304.
    coneq[1474]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/768768.
    coneq[1475]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1537536.
    coneq[1476]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**5)))))-1/164736.
    coneq[1477]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))))-1/823680.
    coneq[1478]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/3294720.
    coneq[1479]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/9884160.
    coneq[1480]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/19768320.
    coneq[1481]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6589440.
    coneq[1482]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/2471040.
    coneq[1483]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4942080.
    coneq[1484]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/1647360.
    coneq[1485]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3294720.
    coneq[1486]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))))-1/658944.
    coneq[1487]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/1976832.
    coneq[1488]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3953664.
    coneq[1489]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1317888.
    coneq[1490]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/494208.
    coneq[1491]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/988416.
    coneq[1492]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))))-1/329472.
    coneq[1493]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/988416.
    coneq[1494]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1976832.
    coneq[1495]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/658944.
    coneq[1496]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4)))))-1/137280.
    coneq[1497]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))))-1/549120.
    coneq[1498]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/1647360.
    coneq[1499]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3294720.
    coneq[1500]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/1098240.
    coneq[1501]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/411840.
    coneq[1502]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/823680.
    coneq[1503]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/274560.
    coneq[1504]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/549120.
    coneq[1505]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3)))))-1/109824.
    coneq[1506]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))))-1/329472.
    coneq[1507]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/658944.
    coneq[1508]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))))-1/219648.
    coneq[1509]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2)))))-1/82368.
    coneq[1510]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))))-1/164736.
    coneq[1511]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5*dot(A,c)))))-1/54912.
    coneq[1512]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/329472.
    coneq[1513]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/988416.
    coneq[1514]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1976832.
    coneq[1515]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/658944.
    coneq[1516]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/658944.
    coneq[1517]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1976832.
    coneq[1518]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/3953664.
    coneq[1519]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1317888.
    coneq[1520]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))))-1/274560.
    coneq[1521]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/1098240.
    coneq[1522]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/3294720.
    coneq[1523]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6589440.
    coneq[1524]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2196480.
    coneq[1525]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/823680.
    coneq[1526]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1647360.
    coneq[1527]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/549120.
    coneq[1528]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1098240.
    coneq[1529]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/247104.
    coneq[1530]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/494208.
    coneq[1531]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/988416.
    coneq[1532]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/219648.
    coneq[1533]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/658944.
    coneq[1534]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1317888.
    coneq[1535]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/439296.
    coneq[1536]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/164736.
    coneq[1537]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/329472.
    coneq[1538]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/109824.
    coneq[1539]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/329472.
    coneq[1540]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/658944.
    coneq[1541]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/219648.
    coneq[1542]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**4))))-1/34320.
    coneq[1543]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3)))))-1/137280.
    coneq[1544]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/411840.
    coneq[1545]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/823680.
    coneq[1546]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/274560.
    coneq[1547]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/102960.
    coneq[1548]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/205920.
    coneq[1549]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/68640.
    coneq[1550]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/137280.
    coneq[1551]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4))))-1/102960.
    coneq[1552]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/411840.
    coneq[1553]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/1235520.
    coneq[1554]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2471040.
    coneq[1555]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/823680.
    coneq[1556]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/308880.
    coneq[1557]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/617760.
    coneq[1558]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/205920.
    coneq[1559]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/411840.
    coneq[1560]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/205920.
    coneq[1561]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/823680.
    coneq[1562]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/2471040.
    coneq[1563]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4942080.
    coneq[1564]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/1647360.
    coneq[1565]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/617760.
    coneq[1566]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1235520.
    coneq[1567]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/411840.
    coneq[1568]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/823680.
    coneq[1569]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4))))-1/68640.
    coneq[1570]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/274560.
    coneq[1571]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/823680.
    coneq[1572]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1647360.
    coneq[1573]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/549120.
    coneq[1574]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/205920.
    coneq[1575]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/411840.
    coneq[1576]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/137280.
    coneq[1577]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/274560.
    coneq[1578]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**5))))-1/30888.
    coneq[1579]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4)))))-1/154440.
    coneq[1580]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/617760.
    coneq[1581]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1853280.
    coneq[1582]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3706560.
    coneq[1583]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1235520.
    coneq[1584]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/463320.
    coneq[1585]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/926640.
    coneq[1586]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/308880.
    coneq[1587]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/617760.
    coneq[1588]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/123552.
    coneq[1589]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/370656.
    coneq[1590]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/741312.
    coneq[1591]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/247104.
    coneq[1592]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/92664.
    coneq[1593]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/185328.
    coneq[1594]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/61776.
    coneq[1595]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/185328.
    coneq[1596]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/370656.
    coneq[1597]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/123552.
    coneq[1598]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**5))))-1/61776.
    coneq[1599]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/308880.
    coneq[1600]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1235520.
    coneq[1601]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3706560.
    coneq[1602]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7413120.
    coneq[1603]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2471040.
    coneq[1604]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/926640.
    coneq[1605]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1853280.
    coneq[1606]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/617760.
    coneq[1607]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1235520.
    coneq[1608]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/247104.
    coneq[1609]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/741312.
    coneq[1610]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1482624.
    coneq[1611]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/494208.
    coneq[1612]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/185328.
    coneq[1613]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/370656.
    coneq[1614]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/123552.
    coneq[1615]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/370656.
    coneq[1616]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/741312.
    coneq[1617]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/247104.
    coneq[1618]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**6))))-1/24024.
    coneq[1619]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**5)))))-1/144144.
    coneq[1620]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/720720.
    coneq[1621]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2882880.
    coneq[1622]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/8648640.
    coneq[1623]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/17297280.
    coneq[1624]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5765760.
    coneq[1625]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2162160.
    coneq[1626]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4324320.
    coneq[1627]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1441440.
    coneq[1628]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2882880.
    coneq[1629]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/576576.
    coneq[1630]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1729728.
    coneq[1631]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3459456.
    coneq[1632]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1153152.
    coneq[1633]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/432432.
    coneq[1634]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/864864.
    coneq[1635]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/288288.
    coneq[1636]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/864864.
    coneq[1637]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1729728.
    coneq[1638]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/576576.
    coneq[1639]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4)))))-1/120120.
    coneq[1640]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/480480.
    coneq[1641]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1441440.
    coneq[1642]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2882880.
    coneq[1643]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/960960.
    coneq[1644]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/360360.
    coneq[1645]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/720720.
    coneq[1646]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/240240.
    coneq[1647]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/480480.
    coneq[1648]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/96096.
    coneq[1649]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/288288.
    coneq[1650]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/576576.
    coneq[1651]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/192192.
    coneq[1652]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/72072.
    coneq[1653]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/144144.
    coneq[1654]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c)))))-1/48048.
    coneq[1655]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/216216.
    coneq[1656]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/432432.
    coneq[1657]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/864864.
    coneq[1658]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/192192.
    coneq[1659]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/576576.
    coneq[1660]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1153152.
    coneq[1661]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/384384.
    coneq[1662]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/144144.
    coneq[1663]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/288288.
    coneq[1664]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/96096.
    coneq[1665]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/192192.
    coneq[1666]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c**3))))-1/27456.
    coneq[1667]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/82368.
    coneq[1668]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/164736.
    coneq[1669]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/54912.
    coneq[1670]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/247104.
    coneq[1671]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/494208.
    coneq[1672]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/164736.
    coneq[1673]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/988416.
    coneq[1674]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/329472.
    coneq[1675]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/109824.
    coneq[1676]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**4))))-1/25740.
    coneq[1677]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/102960.
    coneq[1678]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/308880.
    coneq[1679]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/617760.
    coneq[1680]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/205920.
    coneq[1681]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/77220.
    coneq[1682]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/154440.
    coneq[1683]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/51480.
    coneq[1684]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/102960.
    coneq[1685]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4))))-1/51480.
    coneq[1686]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/205920.
    coneq[1687]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/617760.
    coneq[1688]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1235520.
    coneq[1689]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/411840.
    coneq[1690]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/154440.
    coneq[1691]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/308880.
    coneq[1692]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/102960.
    coneq[1693]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/205920.
    coneq[1694]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**5))))-1/20592.
    coneq[1695]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4)))))-1/102960.
    coneq[1696]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/411840.
    coneq[1697]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1235520.
    coneq[1698]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2471040.
    coneq[1699]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/823680.
    coneq[1700]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/308880.
    coneq[1701]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/617760.
    coneq[1702]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/205920.
    coneq[1703]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/411840.
    coneq[1704]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/82368.
    coneq[1705]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/247104.
    coneq[1706]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/494208.
    coneq[1707]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/164736.
    coneq[1708]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/61776.
    coneq[1709]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/123552.
    coneq[1710]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/41184.
    coneq[1711]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/123552.
    coneq[1712]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/247104.
    coneq[1713]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/82368.
    coneq[1714]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**3))))-1/20592.
    coneq[1715]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/61776.
    coneq[1716]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/123552.
    coneq[1717]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/41184.
    coneq[1718]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3))))-1/41184.
    coneq[1719]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/123552.
    coneq[1720]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/247104.
    coneq[1721]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/82368.
    coneq[1722]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**4))))-1/17160.
    coneq[1723]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3)))))-1/68640.
    coneq[1724]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/205920.
    coneq[1725]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/411840.
    coneq[1726]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/137280.
    coneq[1727]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/51480.
    coneq[1728]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/102960.
    coneq[1729]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/34320.
    coneq[1730]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/68640.
    coneq[1731]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,c**2))))-1/15444.
    coneq[1732]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c)))))-1/30888.
    coneq[1733]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/61776.
    coneq[1734]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**3))))-1/13728.
    coneq[1735]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2)))))-1/41184.
    coneq[1736]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/82368.
    coneq[1737]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c)))))-1/27456.
    coneq[1738]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c**2))))-1/10296.
    coneq[1739]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,dot(A,c)))))-1/20592.
    coneq[1740]=dot(b,dot(A,dot(A,c**6*dot(A,c)*dot(A,c))))-1/6864.
    coneq[1741]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5))))-1/41184.
    coneq[1742]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))))-1/205920.
    coneq[1743]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/823680.
    coneq[1744]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2471040.
    coneq[1745]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4942080.
    coneq[1746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1647360.
    coneq[1747]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/617760.
    coneq[1748]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1235520.
    coneq[1749]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/411840.
    coneq[1750]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/823680.
    coneq[1751]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/164736.
    coneq[1752]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/494208.
    coneq[1753]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/988416.
    coneq[1754]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/329472.
    coneq[1755]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/123552.
    coneq[1756]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/247104.
    coneq[1757]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/82368.
    coneq[1758]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/247104.
    coneq[1759]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/494208.
    coneq[1760]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/164736.
    coneq[1761]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4))))-1/51480.
    coneq[1762]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/205920.
    coneq[1763]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/617760.
    coneq[1764]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1235520.
    coneq[1765]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/411840.
    coneq[1766]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/154440.
    coneq[1767]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/308880.
    coneq[1768]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/102960.
    coneq[1769]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/205920.
    coneq[1770]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))))-1/102960.
    coneq[1771]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/411840.
    coneq[1772]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1235520.
    coneq[1773]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2471040.
    coneq[1774]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/823680.
    coneq[1775]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/308880.
    coneq[1776]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/617760.
    coneq[1777]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/205920.
    coneq[1778]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/411840.
    coneq[1779]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3))))-1/61776.
    coneq[1780]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/185328.
    coneq[1781]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/370656.
    coneq[1782]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/123552.
    coneq[1783]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))))-1/123552.
    coneq[1784]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/370656.
    coneq[1785]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/741312.
    coneq[1786]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/247104.
    coneq[1787]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))))-1/247104.
    coneq[1788]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/741312.
    coneq[1789]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1482624.
    coneq[1790]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/494208.
    coneq[1791]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3))))-1/54912.
    coneq[1792]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/164736.
    coneq[1793]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/329472.
    coneq[1794]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/109824.
    coneq[1795]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/494208.
    coneq[1796]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/988416.
    coneq[1797]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/329472.
    coneq[1798]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/1976832.
    coneq[1799]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/658944.
    coneq[1800]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/219648.
    coneq[1801]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4))))-1/34320.
    coneq[1802]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/137280.
    coneq[1803]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/411840.
    coneq[1804]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/823680.
    coneq[1805]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/274560.
    coneq[1806]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/102960.
    coneq[1807]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/205920.
    coneq[1808]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/68640.
    coneq[1809]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/137280.
    coneq[1810]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/41184.
    coneq[1811]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/123552.
    coneq[1812]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/247104.
    coneq[1813]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/82368.
    coneq[1814]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/82368.
    coneq[1815]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/247104.
    coneq[1816]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/494208.
    coneq[1817]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/164736.
    coneq[1818]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/46332.
    coneq[1819]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/92664.
    coneq[1820]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/185328.
    coneq[1821]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/370656.
    coneq[1822]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/27456.
    coneq[1823]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/82368.
    coneq[1824]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/164736.
    coneq[1825]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/54912.
    coneq[1826]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/30888.
    coneq[1827]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/61776.
    coneq[1828]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/123552.
    coneq[1829]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/20592.
    coneq[1830]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/41184.
    coneq[1831]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c))))-1/13728.
    coneq[1832]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/54912.
    coneq[1833]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/164736.
    coneq[1834]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/329472.
    coneq[1835]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/109824.
    coneq[1836]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/61776.
    coneq[1837]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/123552.
    coneq[1838]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))))-1/123552.
    coneq[1839]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/247104.
    coneq[1840]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/41184.
    coneq[1841]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/82368.
    coneq[1842]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/27456.
    coneq[1843]=dot(b,dot(A,c*dot(A,c**9)))-1/1560.
    coneq[1844]=dot(b,dot(A,c*dot(A,dot(A,c**8))))-1/14040.
    coneq[1845]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**7)))))-1/112320.
    coneq[1846]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**6))))))-1/786240.
    coneq[1847]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/4717440.
    coneq[1848]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/23587200.
    coneq[1849]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/94348800.
    coneq[1850]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/283046400.
    coneq[1851]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/566092800.
    coneq[1852]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/188697600.
    coneq[1853]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/70761600.
    coneq[1854]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/141523200.
    coneq[1855]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/47174400.
    coneq[1856]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/94348800.
    coneq[1857]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/18869760.
    coneq[1858]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/56609280.
    coneq[1859]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/113218560.
    coneq[1860]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/37739520.
    coneq[1861]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/14152320.
    coneq[1862]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/28304640.
    coneq[1863]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/9434880.
    coneq[1864]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/28304640.
    coneq[1865]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/56609280.
    coneq[1866]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/18869760.
    coneq[1867]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/3931200.
    coneq[1868]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/15724800.
    coneq[1869]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/47174400.
    coneq[1870]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/94348800.
    coneq[1871]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/31449600.
    coneq[1872]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/11793600.
    coneq[1873]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/23587200.
    coneq[1874]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/7862400.
    coneq[1875]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/15724800.
    coneq[1876]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/3144960.
    coneq[1877]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/9434880.
    coneq[1878]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/18869760.
    coneq[1879]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/6289920.
    coneq[1880]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/2358720.
    coneq[1881]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/4717440.
    coneq[1882]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/1572480.
    coneq[1883]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/7076160.
    coneq[1884]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/14152320.
    coneq[1885]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/28304640.
    coneq[1886]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/6289920.
    coneq[1887]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[1888]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[1889]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[1890]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/4717440.
    coneq[1891]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/9434880.
    coneq[1892]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/3144960.
    coneq[1893]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[1894]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**5))))))-1/673920.
    coneq[1895]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/3369600.
    coneq[1896]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/13478400.
    coneq[1897]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/40435200.
    coneq[1898]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/80870400.
    coneq[1899]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/26956800.
    coneq[1900]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/10108800.
    coneq[1901]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/20217600.
    coneq[1902]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/6739200.
    coneq[1903]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/13478400.
    coneq[1904]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/2695680.
    coneq[1905]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/8087040.
    coneq[1906]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/16174080.
    coneq[1907]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/5391360.
    coneq[1908]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2021760.
    coneq[1909]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/4043520.
    coneq[1910]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1347840.
    coneq[1911]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/4043520.
    coneq[1912]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/8087040.
    coneq[1913]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/2695680.
    coneq[1914]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**4))))))-1/561600.
    coneq[1915]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/2246400.
    coneq[1916]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/6739200.
    coneq[1917]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/13478400.
    coneq[1918]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/4492800.
    coneq[1919]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/1684800.
    coneq[1920]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/3369600.
    coneq[1921]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1123200.
    coneq[1922]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/2246400.
    coneq[1923]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**3))))))-1/449280.
    coneq[1924]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1347840.
    coneq[1925]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/2695680.
    coneq[1926]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/898560.
    coneq[1927]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c**2))))))-1/336960.
    coneq[1928]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/673920.
    coneq[1929]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5*dot(A,c))))))-1/224640.
    coneq[1930]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1347840.
    coneq[1931]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/4043520.
    coneq[1932]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/8087040.
    coneq[1933]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/2695680.
    coneq[1934]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/2695680.
    coneq[1935]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/8087040.
    coneq[1936]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/16174080.
    coneq[1937]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/5391360.
    coneq[1938]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/1123200.
    coneq[1939]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/4492800.
    coneq[1940]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/13478400.
    coneq[1941]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/26956800.
    coneq[1942]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/8985600.
    coneq[1943]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/3369600.
    coneq[1944]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/6739200.
    coneq[1945]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/2246400.
    coneq[1946]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/4492800.
    coneq[1947]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1010880.
    coneq[1948]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2021760.
    coneq[1949]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4043520.
    coneq[1950]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/898560.
    coneq[1951]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/2695680.
    coneq[1952]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5391360.
    coneq[1953]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/1797120.
    coneq[1954]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/673920.
    coneq[1955]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1347840.
    coneq[1956]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/449280.
    coneq[1957]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1347840.
    coneq[1958]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/2695680.
    coneq[1959]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/898560.
    coneq[1960]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**6)))))-1/98280.
    coneq[1961]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**5))))))-1/589680.
    coneq[1962]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/2948400.
    coneq[1963]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/11793600.
    coneq[1964]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/35380800.
    coneq[1965]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/70761600.
    coneq[1966]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/23587200.
    coneq[1967]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/8845200.
    coneq[1968]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/17690400.
    coneq[1969]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/5896800.
    coneq[1970]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/11793600.
    coneq[1971]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/2358720.
    coneq[1972]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/7076160.
    coneq[1973]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/14152320.
    coneq[1974]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/4717440.
    coneq[1975]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1769040.
    coneq[1976]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/3538080.
    coneq[1977]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/1179360.
    coneq[1978]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/3538080.
    coneq[1979]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/7076160.
    coneq[1980]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2358720.
    coneq[1981]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**4))))))-1/491400.
    coneq[1982]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/1965600.
    coneq[1983]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/5896800.
    coneq[1984]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11793600.
    coneq[1985]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/3931200.
    coneq[1986]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1474200.
    coneq[1987]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2948400.
    coneq[1988]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/982800.
    coneq[1989]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1965600.
    coneq[1990]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/393120.
    coneq[1991]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[1992]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[1993]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/786240.
    coneq[1994]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/294840.
    coneq[1995]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/589680.
    coneq[1996]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4*dot(A,c))))))-1/196560.
    coneq[1997]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/884520.
    coneq[1998]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1769040.
    coneq[1999]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3538080.
    coneq[2000]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/786240.
    coneq[2001]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[2002]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[2003]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[2004]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/589680.
    coneq[2005]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1179360.
    coneq[2006]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/393120.
    coneq[2007]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/786240.
    coneq[2008]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**5)))))-1/84240.
    coneq[2009]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**4))))))-1/421200.
    coneq[2010]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/1684800.
    coneq[2011]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5054400.
    coneq[2012]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/10108800.
    coneq[2013]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3369600.
    coneq[2014]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/1263600.
    coneq[2015]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2527200.
    coneq[2016]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/842400.
    coneq[2017]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1684800.
    coneq[2018]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/336960.
    coneq[2019]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/1010880.
    coneq[2020]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2021760.
    coneq[2021]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/673920.
    coneq[2022]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/252720.
    coneq[2023]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/505440.
    coneq[2024]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/168480.
    coneq[2025]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/505440.
    coneq[2026]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1010880.
    coneq[2027]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/336960.
    coneq[2028]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**4)))))-1/70200.
    coneq[2029]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**3))))))-1/280800.
    coneq[2030]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/842400.
    coneq[2031]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1684800.
    coneq[2032]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/561600.
    coneq[2033]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/210600.
    coneq[2034]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/421200.
    coneq[2035]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/140400.
    coneq[2036]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/280800.
    coneq[2037]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**3)))))-1/56160.
    coneq[2038]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c**2))))))-1/168480.
    coneq[2039]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/336960.
    coneq[2040]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c*dot(A,c))))))-1/112320.
    coneq[2041]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c**2)))))-1/42120.
    coneq[2042]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,dot(A,c))))))-1/84240.
    coneq[2043]=dot(b,dot(A,c*dot(A,dot(A,c**6*dot(A,c)))))-1/28080.
    coneq[2044]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))))-1/224640.
    coneq[2045]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/673920.
    coneq[2046]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1347840.
    coneq[2047]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/449280.
    coneq[2048]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2021760.
    coneq[2049]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/4043520.
    coneq[2050]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1347840.
    coneq[2051]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/8087040.
    coneq[2052]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/2695680.
    coneq[2053]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/898560.
    coneq[2054]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))))-1/210600.
    coneq[2055]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/842400.
    coneq[2056]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/2527200.
    coneq[2057]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5054400.
    coneq[2058]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/1684800.
    coneq[2059]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/631800.
    coneq[2060]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1263600.
    coneq[2061]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/421200.
    coneq[2062]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/842400.
    coneq[2063]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/421200.
    coneq[2064]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/1684800.
    coneq[2065]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/5054400.
    coneq[2066]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/10108800.
    coneq[2067]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/3369600.
    coneq[2068]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1263600.
    coneq[2069]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/2527200.
    coneq[2070]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/842400.
    coneq[2071]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/1684800.
    coneq[2072]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**5)))))-1/168480.
    coneq[2073]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/842400.
    coneq[2074]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/3369600.
    coneq[2075]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/10108800.
    coneq[2076]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/20217600.
    coneq[2077]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6739200.
    coneq[2078]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/2527200.
    coneq[2079]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5054400.
    coneq[2080]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/1684800.
    coneq[2081]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3369600.
    coneq[2082]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/673920.
    coneq[2083]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2021760.
    coneq[2084]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4043520.
    coneq[2085]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1347840.
    coneq[2086]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/505440.
    coneq[2087]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1010880.
    coneq[2088]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/336960.
    coneq[2089]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1010880.
    coneq[2090]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2021760.
    coneq[2091]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/673920.
    coneq[2092]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/168480.
    coneq[2093]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/505440.
    coneq[2094]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1010880.
    coneq[2095]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/336960.
    coneq[2096]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/336960.
    coneq[2097]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1010880.
    coneq[2098]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2021760.
    coneq[2099]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/673920.
    coneq[2100]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))))-1/140400.
    coneq[2101]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/561600.
    coneq[2102]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1684800.
    coneq[2103]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3369600.
    coneq[2104]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1123200.
    coneq[2105]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/421200.
    coneq[2106]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/842400.
    coneq[2107]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/280800.
    coneq[2108]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/561600.
    coneq[2109]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/126360.
    coneq[2110]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/252720.
    coneq[2111]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/505440.
    coneq[2112]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/112320.
    coneq[2113]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/336960.
    coneq[2114]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/673920.
    coneq[2115]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/224640.
    coneq[2116]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/84240.
    coneq[2117]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/168480.
    coneq[2118]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))))-1/56160.
    coneq[2119]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/224640.
    coneq[2120]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/673920.
    coneq[2121]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1347840.
    coneq[2122]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/449280.
    coneq[2123]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/252720.
    coneq[2124]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/505440.
    coneq[2125]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1010880.
    coneq[2126]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/168480.
    coneq[2127]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/336960.
    coneq[2128]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/112320.
    coneq[2129]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/224640.
    coneq[2130]=dot(b,dot(A,c*dot(A,c*dot(A,c**7))))-1/12480.
    coneq[2131]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**6)))))-1/87360.
    coneq[2132]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**5))))))-1/524160.
    coneq[2133]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/2620800.
    coneq[2134]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/10483200.
    coneq[2135]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/31449600.
    coneq[2136]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/62899200.
    coneq[2137]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/20966400.
    coneq[2138]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/7862400.
    coneq[2139]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/15724800.
    coneq[2140]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/5241600.
    coneq[2141]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/10483200.
    coneq[2142]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/2096640.
    coneq[2143]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/6289920.
    coneq[2144]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/12579840.
    coneq[2145]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/4193280.
    coneq[2146]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1572480.
    coneq[2147]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/3144960.
    coneq[2148]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1048320.
    coneq[2149]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/3144960.
    coneq[2150]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/6289920.
    coneq[2151]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2096640.
    coneq[2152]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**4))))))-1/436800.
    coneq[2153]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1747200.
    coneq[2154]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/5241600.
    coneq[2155]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/10483200.
    coneq[2156]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/3494400.
    coneq[2157]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1310400.
    coneq[2158]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2620800.
    coneq[2159]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/873600.
    coneq[2160]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1747200.
    coneq[2161]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))))-1/349440.
    coneq[2162]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1048320.
    coneq[2163]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2096640.
    coneq[2164]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/698880.
    coneq[2165]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))))-1/262080.
    coneq[2166]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/524160.
    coneq[2167]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4*dot(A,c))))))-1/174720.
    coneq[2168]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/786240.
    coneq[2169]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1572480.
    coneq[2170]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3144960.
    coneq[2171]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/698880.
    coneq[2172]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[2173]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[2174]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[2175]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/524160.
    coneq[2176]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1048320.
    coneq[2177]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/349440.
    coneq[2178]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/698880.
    coneq[2179]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**5)))))-1/74880.
    coneq[2180]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**4))))))-1/374400.
    coneq[2181]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1497600.
    coneq[2182]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4492800.
    coneq[2183]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/8985600.
    coneq[2184]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2995200.
    coneq[2185]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1123200.
    coneq[2186]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2246400.
    coneq[2187]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/748800.
    coneq[2188]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1497600.
    coneq[2189]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))))-1/299520.
    coneq[2190]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/898560.
    coneq[2191]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1797120.
    coneq[2192]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/599040.
    coneq[2193]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/224640.
    coneq[2194]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/449280.
    coneq[2195]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))))-1/149760.
    coneq[2196]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/449280.
    coneq[2197]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/898560.
    coneq[2198]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/299520.
    coneq[2199]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**4)))))-1/62400.
    coneq[2200]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))))-1/249600.
    coneq[2201]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/748800.
    coneq[2202]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1497600.
    coneq[2203]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/499200.
    coneq[2204]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/187200.
    coneq[2205]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/374400.
    coneq[2206]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/124800.
    coneq[2207]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/249600.
    coneq[2208]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**3)))))-1/49920.
    coneq[2209]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))))-1/149760.
    coneq[2210]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/299520.
    coneq[2211]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))))-1/99840.
    coneq[2212]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c**2)))))-1/37440.
    coneq[2213]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,dot(A,c))))))-1/74880.
    coneq[2214]=dot(b,dot(A,c*dot(A,c*dot(A,c**5*dot(A,c)))))-1/24960.
    coneq[2215]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/149760.
    coneq[2216]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/449280.
    coneq[2217]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/898560.
    coneq[2218]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/299520.
    coneq[2219]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/299520.
    coneq[2220]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/898560.
    coneq[2221]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1797120.
    coneq[2222]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/599040.
    coneq[2223]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))))-1/124800.
    coneq[2224]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/499200.
    coneq[2225]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1497600.
    coneq[2226]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2995200.
    coneq[2227]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/998400.
    coneq[2228]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/374400.
    coneq[2229]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/748800.
    coneq[2230]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/249600.
    coneq[2231]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/499200.
    coneq[2232]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/112320.
    coneq[2233]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/224640.
    coneq[2234]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/449280.
    coneq[2235]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/99840.
    coneq[2236]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/299520.
    coneq[2237]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/599040.
    coneq[2238]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/199680.
    coneq[2239]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/74880.
    coneq[2240]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/149760.
    coneq[2241]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/49920.
    coneq[2242]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/149760.
    coneq[2243]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/299520.
    coneq[2244]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/99840.
    coneq[2245]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**6))))-1/10920.
    coneq[2246]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**5)))))-1/65520.
    coneq[2247]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**4))))))-1/327600.
    coneq[2248]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1310400.
    coneq[2249]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3931200.
    coneq[2250]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/7862400.
    coneq[2251]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2620800.
    coneq[2252]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/982800.
    coneq[2253]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1965600.
    coneq[2254]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/655200.
    coneq[2255]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1310400.
    coneq[2256]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))))-1/262080.
    coneq[2257]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/786240.
    coneq[2258]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1572480.
    coneq[2259]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/524160.
    coneq[2260]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))))-1/196560.
    coneq[2261]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/393120.
    coneq[2262]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))))-1/131040.
    coneq[2263]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/393120.
    coneq[2264]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/786240.
    coneq[2265]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/262080.
    coneq[2266]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**4)))))-1/54600.
    coneq[2267]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))))-1/218400.
    coneq[2268]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/655200.
    coneq[2269]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1310400.
    coneq[2270]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/436800.
    coneq[2271]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))))-1/163800.
    coneq[2272]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/327600.
    coneq[2273]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))))-1/109200.
    coneq[2274]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/218400.
    coneq[2275]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**3)))))-1/43680.
    coneq[2276]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))))-1/131040.
    coneq[2277]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/262080.
    coneq[2278]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))))-1/87360.
    coneq[2279]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c**2)))))-1/32760.
    coneq[2280]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))))-1/65520.
    coneq[2281]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4*dot(A,c)))))-1/21840.
    coneq[2282]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/98280.
    coneq[2283]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/196560.
    coneq[2284]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/393120.
    coneq[2285]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))))-1/87360.
    coneq[2286]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/262080.
    coneq[2287]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[2288]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/174720.
    coneq[2289]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/65520.
    coneq[2290]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/131040.
    coneq[2291]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/43680.
    coneq[2292]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/87360.
    coneq[2293]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**5))))-1/9360.
    coneq[2294]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**4)))))-1/46800.
    coneq[2295]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**3))))))-1/187200.
    coneq[2296]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/561600.
    coneq[2297]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1123200.
    coneq[2298]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/374400.
    coneq[2299]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))))-1/140400.
    coneq[2300]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/280800.
    coneq[2301]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))))-1/93600.
    coneq[2302]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/187200.
    coneq[2303]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**3)))))-1/37440.
    coneq[2304]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))))-1/112320.
    coneq[2305]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/224640.
    coneq[2306]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))))-1/74880.
    coneq[2307]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c**2)))))-1/28080.
    coneq[2308]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))))-1/56160.
    coneq[2309]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3*dot(A,c)))))-1/18720.
    coneq[2310]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))))-1/56160.
    coneq[2311]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/112320.
    coneq[2312]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))))-1/37440.
    coneq[2313]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**4))))-1/7800.
    coneq[2314]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**3)))))-1/31200.
    coneq[2315]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c**2))))))-1/93600.
    coneq[2316]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))))-1/187200.
    coneq[2317]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c*dot(A,c))))))-1/62400.
    coneq[2318]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c**2)))))-1/23400.
    coneq[2319]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,dot(A,c))))))-1/46800.
    coneq[2320]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2*dot(A,c)))))-1/15600.
    coneq[2321]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))))-1/31200.
    coneq[2322]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**3))))-1/6240.
    coneq[2323]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c**2)))))-1/18720.
    coneq[2324]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,dot(A,c))))))-1/37440.
    coneq[2325]=dot(b,dot(A,c*dot(A,c**5*dot(A,c*dot(A,c)))))-1/12480.
    coneq[2326]=dot(b,dot(A,c*dot(A,c**6*dot(A,c**2))))-1/4680.
    coneq[2327]=dot(b,dot(A,c*dot(A,c**6*dot(A,dot(A,c)))))-1/9360.
    coneq[2328]=dot(b,dot(A,c*dot(A,c**7*dot(A,c))))-1/3120.
    coneq[2329]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**4))))-1/31200.
    coneq[2330]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))))-1/124800.
    coneq[2331]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/374400.
    coneq[2332]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/748800.
    coneq[2333]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/249600.
    coneq[2334]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/93600.
    coneq[2335]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/187200.
    coneq[2336]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/62400.
    coneq[2337]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/124800.
    coneq[2338]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**4))))-1/93600.
    coneq[2339]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/374400.
    coneq[2340]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/1123200.
    coneq[2341]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2246400.
    coneq[2342]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/748800.
    coneq[2343]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/280800.
    coneq[2344]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/561600.
    coneq[2345]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/187200.
    coneq[2346]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/374400.
    coneq[2347]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/187200.
    coneq[2348]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/748800.
    coneq[2349]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/2246400.
    coneq[2350]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4492800.
    coneq[2351]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/1497600.
    coneq[2352]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/561600.
    coneq[2353]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1123200.
    coneq[2354]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/374400.
    coneq[2355]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/748800.
    coneq[2356]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**4))))-1/62400.
    coneq[2357]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/249600.
    coneq[2358]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/748800.
    coneq[2359]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1497600.
    coneq[2360]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/499200.
    coneq[2361]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/187200.
    coneq[2362]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/374400.
    coneq[2363]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/124800.
    coneq[2364]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/249600.
    coneq[2365]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**5))))-1/28080.
    coneq[2366]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))))-1/140400.
    coneq[2367]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/561600.
    coneq[2368]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1684800.
    coneq[2369]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3369600.
    coneq[2370]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1123200.
    coneq[2371]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/421200.
    coneq[2372]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/842400.
    coneq[2373]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/280800.
    coneq[2374]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/561600.
    coneq[2375]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/112320.
    coneq[2376]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/336960.
    coneq[2377]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/673920.
    coneq[2378]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/224640.
    coneq[2379]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/84240.
    coneq[2380]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/168480.
    coneq[2381]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/56160.
    coneq[2382]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/168480.
    coneq[2383]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/336960.
    coneq[2384]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/112320.
    coneq[2385]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**5))))-1/56160.
    coneq[2386]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/280800.
    coneq[2387]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1123200.
    coneq[2388]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3369600.
    coneq[2389]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/6739200.
    coneq[2390]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2246400.
    coneq[2391]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/842400.
    coneq[2392]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1684800.
    coneq[2393]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/561600.
    coneq[2394]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1123200.
    coneq[2395]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/224640.
    coneq[2396]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/673920.
    coneq[2397]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1347840.
    coneq[2398]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/449280.
    coneq[2399]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/168480.
    coneq[2400]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/336960.
    coneq[2401]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/112320.
    coneq[2402]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/336960.
    coneq[2403]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/673920.
    coneq[2404]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/224640.
    coneq[2405]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**6))))-1/21840.
    coneq[2406]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**5)))))-1/131040.
    coneq[2407]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/655200.
    coneq[2408]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2620800.
    coneq[2409]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/7862400.
    coneq[2410]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/15724800.
    coneq[2411]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5241600.
    coneq[2412]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1965600.
    coneq[2413]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3931200.
    coneq[2414]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1310400.
    coneq[2415]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2620800.
    coneq[2416]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/524160.
    coneq[2417]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[2418]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[2419]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[2420]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/393120.
    coneq[2421]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/786240.
    coneq[2422]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/262080.
    coneq[2423]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/786240.
    coneq[2424]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1572480.
    coneq[2425]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/524160.
    coneq[2426]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))))-1/109200.
    coneq[2427]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/436800.
    coneq[2428]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1310400.
    coneq[2429]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2620800.
    coneq[2430]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/873600.
    coneq[2431]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/327600.
    coneq[2432]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/655200.
    coneq[2433]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/218400.
    coneq[2434]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/436800.
    coneq[2435]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/87360.
    coneq[2436]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/262080.
    coneq[2437]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[2438]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/174720.
    coneq[2439]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/65520.
    coneq[2440]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/131040.
    coneq[2441]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))))-1/43680.
    coneq[2442]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/196560.
    coneq[2443]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/393120.
    coneq[2444]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/786240.
    coneq[2445]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/174720.
    coneq[2446]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/524160.
    coneq[2447]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[2448]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/349440.
    coneq[2449]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/131040.
    coneq[2450]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/262080.
    coneq[2451]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/87360.
    coneq[2452]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/174720.
    coneq[2453]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c**3))))-1/24960.
    coneq[2454]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/74880.
    coneq[2455]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/149760.
    coneq[2456]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/49920.
    coneq[2457]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/224640.
    coneq[2458]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[2459]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/149760.
    coneq[2460]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/898560.
    coneq[2461]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/299520.
    coneq[2462]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/99840.
    coneq[2463]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**4))))-1/23400.
    coneq[2464]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/93600.
    coneq[2465]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/280800.
    coneq[2466]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/561600.
    coneq[2467]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/187200.
    coneq[2468]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/70200.
    coneq[2469]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/140400.
    coneq[2470]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/46800.
    coneq[2471]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/93600.
    coneq[2472]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**4))))-1/46800.
    coneq[2473]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/187200.
    coneq[2474]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/561600.
    coneq[2475]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1123200.
    coneq[2476]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/374400.
    coneq[2477]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/140400.
    coneq[2478]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/280800.
    coneq[2479]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/93600.
    coneq[2480]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/187200.
    coneq[2481]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**5))))-1/18720.
    coneq[2482]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))))-1/93600.
    coneq[2483]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/374400.
    coneq[2484]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1123200.
    coneq[2485]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2246400.
    coneq[2486]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/748800.
    coneq[2487]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/280800.
    coneq[2488]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/561600.
    coneq[2489]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/187200.
    coneq[2490]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/374400.
    coneq[2491]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/74880.
    coneq[2492]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/224640.
    coneq[2493]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/449280.
    coneq[2494]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/149760.
    coneq[2495]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/56160.
    coneq[2496]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/112320.
    coneq[2497]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/37440.
    coneq[2498]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/112320.
    coneq[2499]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/224640.
    coneq[2500]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/74880.
    coneq[2501]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**3))))-1/18720.
    coneq[2502]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/56160.
    coneq[2503]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/112320.
    coneq[2504]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/37440.
    coneq[2505]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))))-1/37440.
    coneq[2506]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/112320.
    coneq[2507]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[2508]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/74880.
    coneq[2509]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**4))))-1/15600.
    coneq[2510]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))))-1/62400.
    coneq[2511]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/187200.
    coneq[2512]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/374400.
    coneq[2513]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/124800.
    coneq[2514]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/46800.
    coneq[2515]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/93600.
    coneq[2516]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/31200.
    coneq[2517]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/62400.
    coneq[2518]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,c**2))))-1/14040.
    coneq[2519]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))))-1/28080.
    coneq[2520]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/56160.
    coneq[2521]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**3))))-1/12480.
    coneq[2522]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))))-1/37440.
    coneq[2523]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/74880.
    coneq[2524]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))))-1/24960.
    coneq[2525]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c**2))))-1/9360.
    coneq[2526]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))))-1/18720.
    coneq[2527]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)*dot(A,c))))-1/6240.
    coneq[2528]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))))-1/31200.
    coneq[2529]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/124800.
    coneq[2530]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/374400.
    coneq[2531]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/748800.
    coneq[2532]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/249600.
    coneq[2533]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/93600.
    coneq[2534]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/187200.
    coneq[2535]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/62400.
    coneq[2536]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/124800.
    coneq[2537]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/37440.
    coneq[2538]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/112320.
    coneq[2539]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[2540]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/74880.
    coneq[2541]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/74880.
    coneq[2542]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/224640.
    coneq[2543]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[2544]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/149760.
    coneq[2545]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/42120.
    coneq[2546]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/84240.
    coneq[2547]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/168480.
    coneq[2548]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/336960.
    coneq[2549]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/24960.
    coneq[2550]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/74880.
    coneq[2551]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/149760.
    coneq[2552]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/49920.
    coneq[2553]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/28080.
    coneq[2554]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/56160.
    coneq[2555]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/112320.
    coneq[2556]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/18720.
    coneq[2557]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/37440.
    coneq[2558]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))))-1/12480.
    coneq[2559]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/37440.
    coneq[2560]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/74880.
    coneq[2561]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/24960.
    coneq[2562]=dot(b,dot(A,c**2*dot(A,c**8)))-1/1404.
    coneq[2563]=dot(b,dot(A,c**2*dot(A,dot(A,c**7))))-1/11232.
    coneq[2564]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**6)))))-1/78624.
    coneq[2565]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/471744.
    coneq[2566]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/2358720.
    coneq[2567]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/9434880.
    coneq[2568]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/28304640.
    coneq[2569]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/56609280.
    coneq[2570]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/18869760.
    coneq[2571]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/7076160.
    coneq[2572]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/14152320.
    coneq[2573]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/4717440.
    coneq[2574]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/9434880.
    coneq[2575]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/1886976.
    coneq[2576]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/5660928.
    coneq[2577]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/11321856.
    coneq[2578]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/3773952.
    coneq[2579]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1415232.
    coneq[2580]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/2830464.
    coneq[2581]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/943488.
    coneq[2582]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/2830464.
    coneq[2583]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/5660928.
    coneq[2584]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/1886976.
    coneq[2585]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/393120.
    coneq[2586]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1572480.
    coneq[2587]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/4717440.
    coneq[2588]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/9434880.
    coneq[2589]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/3144960.
    coneq[2590]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1179360.
    coneq[2591]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2358720.
    coneq[2592]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/786240.
    coneq[2593]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1572480.
    coneq[2594]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/314496.
    coneq[2595]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/943488.
    coneq[2596]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/1886976.
    coneq[2597]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/628992.
    coneq[2598]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/235872.
    coneq[2599]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/471744.
    coneq[2600]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/157248.
    coneq[2601]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/707616.
    coneq[2602]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1415232.
    coneq[2603]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/2830464.
    coneq[2604]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/628992.
    coneq[2605]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/1886976.
    coneq[2606]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/3773952.
    coneq[2607]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1257984.
    coneq[2608]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/471744.
    coneq[2609]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/943488.
    coneq[2610]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/314496.
    coneq[2611]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/628992.
    coneq[2612]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**5)))))-1/67392.
    coneq[2613]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/336960.
    coneq[2614]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1347840.
    coneq[2615]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4043520.
    coneq[2616]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/8087040.
    coneq[2617]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2695680.
    coneq[2618]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1010880.
    coneq[2619]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2021760.
    coneq[2620]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/673920.
    coneq[2621]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1347840.
    coneq[2622]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/269568.
    coneq[2623]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/808704.
    coneq[2624]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1617408.
    coneq[2625]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/539136.
    coneq[2626]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/202176.
    coneq[2627]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/404352.
    coneq[2628]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/134784.
    coneq[2629]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/404352.
    coneq[2630]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/808704.
    coneq[2631]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/269568.
    coneq[2632]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**4)))))-1/56160.
    coneq[2633]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/224640.
    coneq[2634]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/673920.
    coneq[2635]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1347840.
    coneq[2636]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/449280.
    coneq[2637]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/168480.
    coneq[2638]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/336960.
    coneq[2639]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/112320.
    coneq[2640]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/224640.
    coneq[2641]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**3)))))-1/44928.
    coneq[2642]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/134784.
    coneq[2643]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/269568.
    coneq[2644]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/89856.
    coneq[2645]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c**2)))))-1/33696.
    coneq[2646]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/67392.
    coneq[2647]=dot(b,dot(A,c**2*dot(A,dot(A,c**5*dot(A,c)))))-1/22464.
    coneq[2648]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/134784.
    coneq[2649]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/404352.
    coneq[2650]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/808704.
    coneq[2651]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/269568.
    coneq[2652]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/269568.
    coneq[2653]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/808704.
    coneq[2654]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1617408.
    coneq[2655]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/539136.
    coneq[2656]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/112320.
    coneq[2657]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/449280.
    coneq[2658]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1347840.
    coneq[2659]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2695680.
    coneq[2660]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/898560.
    coneq[2661]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/336960.
    coneq[2662]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/673920.
    coneq[2663]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/224640.
    coneq[2664]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/449280.
    coneq[2665]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/101088.
    coneq[2666]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/202176.
    coneq[2667]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/404352.
    coneq[2668]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/89856.
    coneq[2669]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/269568.
    coneq[2670]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/539136.
    coneq[2671]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/179712.
    coneq[2672]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/67392.
    coneq[2673]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/134784.
    coneq[2674]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/44928.
    coneq[2675]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/134784.
    coneq[2676]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/269568.
    coneq[2677]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/89856.
    coneq[2678]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**6))))-1/9828.
    coneq[2679]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**5)))))-1/58968.
    coneq[2680]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/294840.
    coneq[2681]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1179360.
    coneq[2682]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3538080.
    coneq[2683]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/7076160.
    coneq[2684]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2358720.
    coneq[2685]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/884520.
    coneq[2686]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1769040.
    coneq[2687]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/589680.
    coneq[2688]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1179360.
    coneq[2689]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/235872.
    coneq[2690]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/707616.
    coneq[2691]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1415232.
    coneq[2692]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/471744.
    coneq[2693]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/176904.
    coneq[2694]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/353808.
    coneq[2695]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/117936.
    coneq[2696]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/353808.
    coneq[2697]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/707616.
    coneq[2698]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/235872.
    coneq[2699]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**4)))))-1/49140.
    coneq[2700]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/196560.
    coneq[2701]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/589680.
    coneq[2702]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1179360.
    coneq[2703]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/393120.
    coneq[2704]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/147420.
    coneq[2705]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/294840.
    coneq[2706]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/98280.
    coneq[2707]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/196560.
    coneq[2708]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/39312.
    coneq[2709]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/117936.
    coneq[2710]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/235872.
    coneq[2711]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/78624.
    coneq[2712]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/29484.
    coneq[2713]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/58968.
    coneq[2714]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4*dot(A,c)))))-1/19656.
    coneq[2715]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/88452.
    coneq[2716]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/176904.
    coneq[2717]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/353808.
    coneq[2718]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/78624.
    coneq[2719]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/235872.
    coneq[2720]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/471744.
    coneq[2721]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/157248.
    coneq[2722]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/58968.
    coneq[2723]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/117936.
    coneq[2724]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/39312.
    coneq[2725]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/78624.
    coneq[2726]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**5))))-1/8424.
    coneq[2727]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**4)))))-1/42120.
    coneq[2728]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/168480.
    coneq[2729]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/505440.
    coneq[2730]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1010880.
    coneq[2731]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/336960.
    coneq[2732]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/126360.
    coneq[2733]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/252720.
    coneq[2734]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/84240.
    coneq[2735]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/168480.
    coneq[2736]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/33696.
    coneq[2737]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/101088.
    coneq[2738]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/202176.
    coneq[2739]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/67392.
    coneq[2740]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/25272.
    coneq[2741]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/50544.
    coneq[2742]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/16848.
    coneq[2743]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/50544.
    coneq[2744]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/101088.
    coneq[2745]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/33696.
    coneq[2746]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**4))))-1/7020.
    coneq[2747]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**3)))))-1/28080.
    coneq[2748]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/84240.
    coneq[2749]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/168480.
    coneq[2750]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/56160.
    coneq[2751]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/21060.
    coneq[2752]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/42120.
    coneq[2753]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/14040.
    coneq[2754]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/28080.
    coneq[2755]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**3))))-1/5616.
    coneq[2756]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c**2)))))-1/16848.
    coneq[2757]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/33696.
    coneq[2758]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c*dot(A,c)))))-1/11232.
    coneq[2759]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c**2))))-1/4212.
    coneq[2760]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,dot(A,c)))))-1/8424.
    coneq[2761]=dot(b,dot(A,c**2*dot(A,c**6*dot(A,c))))-1/2808.
    coneq[2762]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c**3))))-1/22464.
    coneq[2763]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/67392.
    coneq[2764]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/134784.
    coneq[2765]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/44928.
    coneq[2766]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/202176.
    coneq[2767]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/404352.
    coneq[2768]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/134784.
    coneq[2769]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/808704.
    coneq[2770]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/269568.
    coneq[2771]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/89856.
    coneq[2772]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**4))))-1/21060.
    coneq[2773]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/84240.
    coneq[2774]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/252720.
    coneq[2775]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/505440.
    coneq[2776]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/168480.
    coneq[2777]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/63180.
    coneq[2778]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/126360.
    coneq[2779]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/42120.
    coneq[2780]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/84240.
    coneq[2781]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/42120.
    coneq[2782]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/168480.
    coneq[2783]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/505440.
    coneq[2784]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1010880.
    coneq[2785]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/336960.
    coneq[2786]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/126360.
    coneq[2787]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/252720.
    coneq[2788]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/84240.
    coneq[2789]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/168480.
    coneq[2790]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**5))))-1/16848.
    coneq[2791]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/84240.
    coneq[2792]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/336960.
    coneq[2793]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1010880.
    coneq[2794]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2021760.
    coneq[2795]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/673920.
    coneq[2796]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/252720.
    coneq[2797]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/505440.
    coneq[2798]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/168480.
    coneq[2799]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/336960.
    coneq[2800]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/67392.
    coneq[2801]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/202176.
    coneq[2802]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/404352.
    coneq[2803]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/134784.
    coneq[2804]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/50544.
    coneq[2805]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/101088.
    coneq[2806]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/33696.
    coneq[2807]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/101088.
    coneq[2808]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/202176.
    coneq[2809]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/67392.
    coneq[2810]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/16848.
    coneq[2811]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/50544.
    coneq[2812]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/101088.
    coneq[2813]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/33696.
    coneq[2814]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/33696.
    coneq[2815]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/101088.
    coneq[2816]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/202176.
    coneq[2817]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/67392.
    coneq[2818]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**4))))-1/14040.
    coneq[2819]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/56160.
    coneq[2820]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/168480.
    coneq[2821]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/336960.
    coneq[2822]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/112320.
    coneq[2823]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/42120.
    coneq[2824]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/84240.
    coneq[2825]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/28080.
    coneq[2826]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/56160.
    coneq[2827]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/12636.
    coneq[2828]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/25272.
    coneq[2829]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/50544.
    coneq[2830]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/11232.
    coneq[2831]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/33696.
    coneq[2832]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/67392.
    coneq[2833]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/22464.
    coneq[2834]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/8424.
    coneq[2835]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/16848.
    coneq[2836]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)*dot(A,c))))-1/5616.
    coneq[2837]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/22464.
    coneq[2838]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/67392.
    coneq[2839]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/134784.
    coneq[2840]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/44928.
    coneq[2841]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/25272.
    coneq[2842]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/50544.
    coneq[2843]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/101088.
    coneq[2844]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/16848.
    coneq[2845]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/33696.
    coneq[2846]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/11232.
    coneq[2847]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/22464.
    coneq[2848]=dot(b,dot(A,c**3*dot(A,c**7)))-1/1248.
    coneq[2849]=dot(b,dot(A,c**3*dot(A,dot(A,c**6))))-1/8736.
    coneq[2850]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**5)))))-1/52416.
    coneq[2851]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/262080.
    coneq[2852]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1048320.
    coneq[2853]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3144960.
    coneq[2854]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/6289920.
    coneq[2855]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2096640.
    coneq[2856]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/786240.
    coneq[2857]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1572480.
    coneq[2858]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/524160.
    coneq[2859]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1048320.
    coneq[2860]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/209664.
    coneq[2861]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/628992.
    coneq[2862]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1257984.
    coneq[2863]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/419328.
    coneq[2864]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/157248.
    coneq[2865]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/314496.
    coneq[2866]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/104832.
    coneq[2867]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/314496.
    coneq[2868]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/628992.
    coneq[2869]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/209664.
    coneq[2870]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**4)))))-1/43680.
    coneq[2871]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/174720.
    coneq[2872]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/524160.
    coneq[2873]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1048320.
    coneq[2874]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/349440.
    coneq[2875]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/131040.
    coneq[2876]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/262080.
    coneq[2877]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/87360.
    coneq[2878]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/174720.
    coneq[2879]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**3)))))-1/34944.
    coneq[2880]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/104832.
    coneq[2881]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/209664.
    coneq[2882]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/69888.
    coneq[2883]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c**2)))))-1/26208.
    coneq[2884]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/52416.
    coneq[2885]=dot(b,dot(A,c**3*dot(A,dot(A,c**4*dot(A,c)))))-1/17472.
    coneq[2886]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/78624.
    coneq[2887]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/157248.
    coneq[2888]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/314496.
    coneq[2889]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/69888.
    coneq[2890]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/209664.
    coneq[2891]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/419328.
    coneq[2892]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/139776.
    coneq[2893]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/52416.
    coneq[2894]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/104832.
    coneq[2895]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/34944.
    coneq[2896]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/69888.
    coneq[2897]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**5))))-1/7488.
    coneq[2898]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**4)))))-1/37440.
    coneq[2899]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/149760.
    coneq[2900]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/449280.
    coneq[2901]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/898560.
    coneq[2902]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/299520.
    coneq[2903]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/112320.
    coneq[2904]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/224640.
    coneq[2905]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/74880.
    coneq[2906]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/149760.
    coneq[2907]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**3)))))-1/29952.
    coneq[2908]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/89856.
    coneq[2909]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/179712.
    coneq[2910]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/59904.
    coneq[2911]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/22464.
    coneq[2912]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/44928.
    coneq[2913]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3*dot(A,c)))))-1/14976.
    coneq[2914]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/44928.
    coneq[2915]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/89856.
    coneq[2916]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/29952.
    coneq[2917]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**4))))-1/6240.
    coneq[2918]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**3)))))-1/24960.
    coneq[2919]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/74880.
    coneq[2920]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/149760.
    coneq[2921]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/49920.
    coneq[2922]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/18720.
    coneq[2923]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/37440.
    coneq[2924]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/12480.
    coneq[2925]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/24960.
    coneq[2926]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**3))))-1/4992.
    coneq[2927]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c**2)))))-1/14976.
    coneq[2928]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/29952.
    coneq[2929]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c*dot(A,c)))))-1/9984.
    coneq[2930]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c**2))))-1/3744.
    coneq[2931]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,dot(A,c)))))-1/7488.
    coneq[2932]=dot(b,dot(A,c**3*dot(A,c**5*dot(A,c))))-1/2496.
    coneq[2933]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**3))))-1/14976.
    coneq[2934]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/44928.
    coneq[2935]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/89856.
    coneq[2936]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/29952.
    coneq[2937]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/29952.
    coneq[2938]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/89856.
    coneq[2939]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/179712.
    coneq[2940]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/59904.
    coneq[2941]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**4))))-1/12480.
    coneq[2942]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/49920.
    coneq[2943]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/149760.
    coneq[2944]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/299520.
    coneq[2945]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/99840.
    coneq[2946]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/37440.
    coneq[2947]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/74880.
    coneq[2948]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/24960.
    coneq[2949]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/49920.
    coneq[2950]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/11232.
    coneq[2951]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/22464.
    coneq[2952]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/44928.
    coneq[2953]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**3))))-1/9984.
    coneq[2954]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/29952.
    coneq[2955]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/59904.
    coneq[2956]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/19968.
    coneq[2957]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/7488.
    coneq[2958]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/14976.
    coneq[2959]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)*dot(A,c))))-1/4992.
    coneq[2960]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/14976.
    coneq[2961]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/29952.
    coneq[2962]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/9984.
    coneq[2963]=dot(b,dot(A,c**4*dot(A,c**6)))-1/1092.
    coneq[2964]=dot(b,dot(A,c**4*dot(A,dot(A,c**5))))-1/6552.
    coneq[2965]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**4)))))-1/32760.
    coneq[2966]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/131040.
    coneq[2967]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/393120.
    coneq[2968]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/786240.
    coneq[2969]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/262080.
    coneq[2970]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/98280.
    coneq[2971]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/196560.
    coneq[2972]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/65520.
    coneq[2973]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/131040.
    coneq[2974]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**3)))))-1/26208.
    coneq[2975]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/78624.
    coneq[2976]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/157248.
    coneq[2977]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/52416.
    coneq[2978]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c**2)))))-1/19656.
    coneq[2979]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/39312.
    coneq[2980]=dot(b,dot(A,c**4*dot(A,dot(A,c**3*dot(A,c)))))-1/13104.
    coneq[2981]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/39312.
    coneq[2982]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/78624.
    coneq[2983]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/26208.
    coneq[2984]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**4))))-1/5460.
    coneq[2985]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**3)))))-1/21840.
    coneq[2986]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/65520.
    coneq[2987]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/131040.
    coneq[2988]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/43680.
    coneq[2989]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c**2)))))-1/16380.
    coneq[2990]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/32760.
    coneq[2991]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2*dot(A,c)))))-1/10920.
    coneq[2992]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/21840.
    coneq[2993]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**3))))-1/4368.
    coneq[2994]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c**2)))))-1/13104.
    coneq[2995]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/26208.
    coneq[2996]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c*dot(A,c)))))-1/8736.
    coneq[2997]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c**2))))-1/3276.
    coneq[2998]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,dot(A,c)))))-1/6552.
    coneq[2999]=dot(b,dot(A,c**4*dot(A,c**4*dot(A,c))))-1/2184.
    coneq[3000]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,c**2))))-1/9828.
    coneq[3001]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/19656.
    coneq[3002]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/39312.
    coneq[3003]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**3))))-1/8736.
    coneq[3004]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/26208.
    coneq[3005]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/52416.
    coneq[3006]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/17472.
    coneq[3007]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c**2))))-1/6552.
    coneq[3008]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/13104.
    coneq[3009]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)*dot(A,c))))-1/4368.
    coneq[3010]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/8736.
    coneq[3011]=dot(b,dot(A,c**5*dot(A,c**5)))-1/936.
    coneq[3012]=dot(b,dot(A,c**5*dot(A,dot(A,c**4))))-1/4680.
    coneq[3013]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**3)))))-1/18720.
    coneq[3014]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/56160.
    coneq[3015]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/112320.
    coneq[3016]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/37440.
    coneq[3017]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c**2)))))-1/14040.
    coneq[3018]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/28080.
    coneq[3019]=dot(b,dot(A,c**5*dot(A,dot(A,c**2*dot(A,c)))))-1/9360.
    coneq[3020]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/18720.
    coneq[3021]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**3))))-1/3744.
    coneq[3022]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c**2)))))-1/11232.
    coneq[3023]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/22464.
    coneq[3024]=dot(b,dot(A,c**5*dot(A,c*dot(A,c*dot(A,c)))))-1/7488.
    coneq[3025]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c**2))))-1/2808.
    coneq[3026]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,dot(A,c)))))-1/5616.
    coneq[3027]=dot(b,dot(A,c**5*dot(A,c**3*dot(A,c))))-1/1872.
    coneq[3028]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c**2))))-1/5616.
    coneq[3029]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/11232.
    coneq[3030]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)*dot(A,c))))-1/3744.
    coneq[3031]=dot(b,dot(A,c**6*dot(A,c**4)))-1/780.
    coneq[3032]=dot(b,dot(A,c**6*dot(A,dot(A,c**3))))-1/3120.
    coneq[3033]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c**2)))))-1/9360.
    coneq[3034]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,dot(A,c))))))-1/18720.
    coneq[3035]=dot(b,dot(A,c**6*dot(A,dot(A,c*dot(A,c)))))-1/6240.
    coneq[3036]=dot(b,dot(A,c**6*dot(A,c*dot(A,c**2))))-1/2340.
    coneq[3037]=dot(b,dot(A,c**6*dot(A,c*dot(A,dot(A,c)))))-1/4680.
    coneq[3038]=dot(b,dot(A,c**6*dot(A,c**2*dot(A,c))))-1/1560.
    coneq[3039]=dot(b,dot(A,c**6*dot(A,dot(A,c)*dot(A,c))))-1/3120.
    coneq[3040]=dot(b,dot(A,c**7*dot(A,c**3)))-1/624.
    coneq[3041]=dot(b,dot(A,c**7*dot(A,dot(A,c**2))))-1/1872.
    coneq[3042]=dot(b,dot(A,c**7*dot(A,dot(A,dot(A,c)))))-1/3744.
    coneq[3043]=dot(b,dot(A,c**7*dot(A,c*dot(A,c))))-1/1248.
    coneq[3044]=dot(b,dot(A,c**8*dot(A,c**2)))-1/468.
    coneq[3045]=dot(b,dot(A,c**8*dot(A,dot(A,c))))-1/936.
    coneq[3046]=dot(b,dot(A,c**9*dot(A,c)))-1/312.
    coneq[3047]=dot(b,dot(A,dot(A,c**4)*dot(A,c**5)))-1/4680.
    coneq[3048]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**4))))-1/23400.
    coneq[3049]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**3)))))-1/93600.
    coneq[3050]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/280800.
    coneq[3051]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/561600.
    coneq[3052]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/187200.
    coneq[3053]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c**2)))))-1/70200.
    coneq[3054]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/140400.
    coneq[3055]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**2*dot(A,c)))))-1/46800.
    coneq[3056]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/93600.
    coneq[3057]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**3))))-1/18720.
    coneq[3058]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c**2)))))-1/56160.
    coneq[3059]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/112320.
    coneq[3060]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c*dot(A,c)))))-1/37440.
    coneq[3061]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c**2))))-1/14040.
    coneq[3062]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,dot(A,c)))))-1/28080.
    coneq[3063]=dot(b,dot(A,dot(A,c**4)*dot(A,c**3*dot(A,c))))-1/9360.
    coneq[3064]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c**2))))-1/28080.
    coneq[3065]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/56160.
    coneq[3066]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c)*dot(A,c))))-1/18720.
    coneq[3067]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**5)))-1/18720.
    coneq[3068]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**4))))-1/93600.
    coneq[3069]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**3)))))-1/374400.
    coneq[3070]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1123200.
    coneq[3071]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2246400.
    coneq[3072]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/748800.
    coneq[3073]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2)))))-1/280800.
    coneq[3074]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/561600.
    coneq[3075]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c)))))-1/187200.
    coneq[3076]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/374400.
    coneq[3077]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**3))))-1/74880.
    coneq[3078]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2)))))-1/224640.
    coneq[3079]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[3080]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c)))))-1/149760.
    coneq[3081]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c**2))))-1/56160.
    coneq[3082]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c)))))-1/112320.
    coneq[3083]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**3*dot(A,c))))-1/37440.
    coneq[3084]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2))))-1/112320.
    coneq[3085]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/224640.
    coneq[3086]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c))))-1/74880.
    coneq[3087]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**5)))-1/56160.
    coneq[3088]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**4))))-1/280800.
    coneq[3089]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3)))))-1/1123200.
    coneq[3090]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/3369600.
    coneq[3091]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/6739200.
    coneq[3092]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/2246400.
    coneq[3093]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2)))))-1/842400.
    coneq[3094]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/1684800.
    coneq[3095]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c)))))-1/561600.
    coneq[3096]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/1123200.
    coneq[3097]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3))))-1/224640.
    coneq[3098]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2)))))-1/673920.
    coneq[3099]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/1347840.
    coneq[3100]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c)))))-1/449280.
    coneq[3101]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2))))-1/168480.
    coneq[3102]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c)))))-1/336960.
    coneq[3103]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c))))-1/112320.
    coneq[3104]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2))))-1/336960.
    coneq[3105]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/673920.
    coneq[3106]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c))))-1/224640.
    coneq[3107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**5)))-1/112320.
    coneq[3108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4))))-1/561600.
    coneq[3109]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3)))))-1/2246400.
    coneq[3110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/6739200.
    coneq[3111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/13478400.
    coneq[3112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/4492800.
    coneq[3113]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2)))))-1/1684800.
    coneq[3114]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/3369600.
    coneq[3115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c)))))-1/1123200.
    coneq[3116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/2246400.
    coneq[3117]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3))))-1/449280.
    coneq[3118]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2)))))-1/1347840.
    coneq[3119]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/2695680.
    coneq[3120]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c)))))-1/898560.
    coneq[3121]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2))))-1/336960.
    coneq[3122]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c)))))-1/673920.
    coneq[3123]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c))))-1/224640.
    coneq[3124]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2))))-1/673920.
    coneq[3125]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/1347840.
    coneq[3126]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c))))-1/449280.
    coneq[3127]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**5)))-1/37440.
    coneq[3128]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**4))))-1/187200.
    coneq[3129]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/748800.
    coneq[3130]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/2246400.
    coneq[3131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/4492800.
    coneq[3132]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1497600.
    coneq[3133]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/561600.
    coneq[3134]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/1123200.
    coneq[3135]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/374400.
    coneq[3136]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/748800.
    coneq[3137]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3))))-1/149760.
    coneq[3138]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/449280.
    coneq[3139]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/898560.
    coneq[3140]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/299520.
    coneq[3141]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/112320.
    coneq[3142]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/224640.
    coneq[3143]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c))))-1/74880.
    coneq[3144]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/224640.
    coneq[3145]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/449280.
    coneq[3146]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/149760.
    coneq[3147]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**5)))-1/14040.
    coneq[3148]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**4))))-1/70200.
    coneq[3149]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))-1/280800.
    coneq[3150]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/842400.
    coneq[3151]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1684800.
    coneq[3152]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/561600.
    coneq[3153]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))-1/210600.
    coneq[3154]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/421200.
    coneq[3155]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))-1/140400.
    coneq[3156]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/280800.
    coneq[3157]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**3))))-1/56160.
    coneq[3158]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))-1/168480.
    coneq[3159]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/336960.
    coneq[3160]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))-1/112320.
    coneq[3161]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/42120.
    coneq[3162]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/84240.
    coneq[3163]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/28080.
    coneq[3164]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/84240.
    coneq[3165]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/168480.
    coneq[3166]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/56160.
    coneq[3167]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**5)))-1/28080.
    coneq[3168]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**4))))-1/140400.
    coneq[3169]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/561600.
    coneq[3170]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1684800.
    coneq[3171]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/3369600.
    coneq[3172]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1123200.
    coneq[3173]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/421200.
    coneq[3174]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/842400.
    coneq[3175]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/280800.
    coneq[3176]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/561600.
    coneq[3177]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))-1/112320.
    coneq[3178]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/336960.
    coneq[3179]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/673920.
    coneq[3180]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/224640.
    coneq[3181]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/84240.
    coneq[3182]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/168480.
    coneq[3183]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/56160.
    coneq[3184]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/168480.
    coneq[3185]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/336960.
    coneq[3186]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/112320.
    coneq[3187]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**5)))-1/9360.
    coneq[3188]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**4))))-1/46800.
    coneq[3189]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/187200.
    coneq[3190]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/561600.
    coneq[3191]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1123200.
    coneq[3192]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/374400.
    coneq[3193]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/140400.
    coneq[3194]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/280800.
    coneq[3195]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/93600.
    coneq[3196]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/187200.
    coneq[3197]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**3))))-1/37440.
    coneq[3198]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/112320.
    coneq[3199]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[3200]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/74880.
    coneq[3201]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/28080.
    coneq[3202]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/56160.
    coneq[3203]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**3*dot(A,c))))-1/18720.
    coneq[3204]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/56160.
    coneq[3205]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/112320.
    coneq[3206]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/37440.
    coneq[3207]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**5)))-1/18720.
    coneq[3208]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**4))))-1/93600.
    coneq[3209]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/374400.
    coneq[3210]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1123200.
    coneq[3211]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2246400.
    coneq[3212]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/748800.
    coneq[3213]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/280800.
    coneq[3214]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/561600.
    coneq[3215]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/187200.
    coneq[3216]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/374400.
    coneq[3217]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3))))-1/74880.
    coneq[3218]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/224640.
    coneq[3219]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[3220]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/149760.
    coneq[3221]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/56160.
    coneq[3222]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/112320.
    coneq[3223]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c))))-1/37440.
    coneq[3224]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/112320.
    coneq[3225]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/224640.
    coneq[3226]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/74880.
    coneq[3227]=dot(b,dot(A,dot(A,c**3)*dot(A,c**6)))-1/4368.
    coneq[3228]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**5))))-1/26208.
    coneq[3229]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**4)))))-1/131040.
    coneq[3230]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/524160.
    coneq[3231]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[3232]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[3233]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[3234]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[3235]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[3236]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[3237]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[3238]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**3)))))-1/104832.
    coneq[3239]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/314496.
    coneq[3240]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[3241]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/209664.
    coneq[3242]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/78624.
    coneq[3243]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/157248.
    coneq[3244]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3*dot(A,c)))))-1/52416.
    coneq[3245]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[3246]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[3247]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[3248]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**4))))-1/21840.
    coneq[3249]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**3)))))-1/87360.
    coneq[3250]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/262080.
    coneq[3251]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[3252]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/174720.
    coneq[3253]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/65520.
    coneq[3254]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/131040.
    coneq[3255]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/43680.
    coneq[3256]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/87360.
    coneq[3257]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**3))))-1/17472.
    coneq[3258]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/52416.
    coneq[3259]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[3260]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/34944.
    coneq[3261]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c**2))))-1/13104.
    coneq[3262]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,dot(A,c)))))-1/26208.
    coneq[3263]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4*dot(A,c))))-1/8736.
    coneq[3264]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/39312.
    coneq[3265]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/78624.
    coneq[3266]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/157248.
    coneq[3267]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**3))))-1/34944.
    coneq[3268]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/104832.
    coneq[3269]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[3270]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/69888.
    coneq[3271]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/26208.
    coneq[3272]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/52416.
    coneq[3273]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/17472.
    coneq[3274]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/34944.
    coneq[3275]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**6)))-1/13104.
    coneq[3276]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**5))))-1/78624.
    coneq[3277]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**4)))))-1/393120.
    coneq[3278]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/1572480.
    coneq[3279]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[3280]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[3281]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[3282]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/1179360.
    coneq[3283]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2358720.
    coneq[3284]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/786240.
    coneq[3285]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[3286]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**3)))))-1/314496.
    coneq[3287]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/943488.
    coneq[3288]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[3289]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/628992.
    coneq[3290]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/235872.
    coneq[3291]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/471744.
    coneq[3292]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3*dot(A,c)))))-1/157248.
    coneq[3293]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/471744.
    coneq[3294]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/943488.
    coneq[3295]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[3296]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**4))))-1/65520.
    coneq[3297]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**3)))))-1/262080.
    coneq[3298]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/786240.
    coneq[3299]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[3300]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/524160.
    coneq[3301]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/196560.
    coneq[3302]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/393120.
    coneq[3303]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/131040.
    coneq[3304]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/262080.
    coneq[3305]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**3))))-1/52416.
    coneq[3306]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/157248.
    coneq[3307]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[3308]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/104832.
    coneq[3309]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c**2))))-1/39312.
    coneq[3310]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,dot(A,c)))))-1/78624.
    coneq[3311]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4*dot(A,c))))-1/26208.
    coneq[3312]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/117936.
    coneq[3313]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/235872.
    coneq[3314]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/471744.
    coneq[3315]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**3))))-1/104832.
    coneq[3316]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/314496.
    coneq[3317]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[3318]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/209664.
    coneq[3319]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/78624.
    coneq[3320]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/157248.
    coneq[3321]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/52416.
    coneq[3322]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/104832.
    coneq[3323]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**6)))-1/26208.
    coneq[3324]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**5))))-1/157248.
    coneq[3325]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**4)))))-1/786240.
    coneq[3326]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/3144960.
    coneq[3327]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[3328]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[3329]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[3330]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/2358720.
    coneq[3331]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/4717440.
    coneq[3332]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/1572480.
    coneq[3333]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3144960.
    coneq[3334]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**3)))))-1/628992.
    coneq[3335]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[3336]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[3337]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[3338]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/471744.
    coneq[3339]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/943488.
    coneq[3340]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,c)))))-1/314496.
    coneq[3341]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/943488.
    coneq[3342]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1886976.
    coneq[3343]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/628992.
    coneq[3344]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**4))))-1/131040.
    coneq[3345]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**3)))))-1/524160.
    coneq[3346]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/1572480.
    coneq[3347]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[3348]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/1048320.
    coneq[3349]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/393120.
    coneq[3350]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/786240.
    coneq[3351]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/262080.
    coneq[3352]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/524160.
    coneq[3353]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**3))))-1/104832.
    coneq[3354]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/314496.
    coneq[3355]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[3356]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/209664.
    coneq[3357]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c**2))))-1/78624.
    coneq[3358]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,c)))))-1/157248.
    coneq[3359]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4*dot(A,c))))-1/52416.
    coneq[3360]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/235872.
    coneq[3361]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/471744.
    coneq[3362]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/943488.
    coneq[3363]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**3))))-1/209664.
    coneq[3364]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/628992.
    coneq[3365]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[3366]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/419328.
    coneq[3367]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/157248.
    coneq[3368]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/314496.
    coneq[3369]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/104832.
    coneq[3370]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/209664.
    coneq[3371]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**6)))-1/8736.
    coneq[3372]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**5))))-1/52416.
    coneq[3373]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/262080.
    coneq[3374]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/1048320.
    coneq[3375]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[3376]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[3377]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[3378]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[3379]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[3380]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[3381]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[3382]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/209664.
    coneq[3383]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/628992.
    coneq[3384]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[3385]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/419328.
    coneq[3386]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/157248.
    coneq[3387]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/314496.
    coneq[3388]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/104832.
    coneq[3389]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[3390]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[3391]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[3392]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**4))))-1/43680.
    coneq[3393]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/174720.
    coneq[3394]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[3395]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[3396]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[3397]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[3398]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[3399]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[3400]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[3401]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/34944.
    coneq[3402]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/104832.
    coneq[3403]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[3404]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/69888.
    coneq[3405]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/26208.
    coneq[3406]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/52416.
    coneq[3407]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4*dot(A,c))))-1/17472.
    coneq[3408]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/78624.
    coneq[3409]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/157248.
    coneq[3410]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/314496.
    coneq[3411]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/69888.
    coneq[3412]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/209664.
    coneq[3413]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[3414]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/139776.
    coneq[3415]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[3416]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[3417]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/34944.
    coneq[3418]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/69888.
    coneq[3419]=dot(b,dot(A,dot(A,c**2)*dot(A,c**7)))-1/3744.
    coneq[3420]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**6))))-1/26208.
    coneq[3421]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**5)))))-1/157248.
    coneq[3422]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/786240.
    coneq[3423]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/3144960.
    coneq[3424]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/9434880.
    coneq[3425]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18869760.
    coneq[3426]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6289920.
    coneq[3427]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2358720.
    coneq[3428]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4717440.
    coneq[3429]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1572480.
    coneq[3430]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3144960.
    coneq[3431]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/628992.
    coneq[3432]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1886976.
    coneq[3433]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3773952.
    coneq[3434]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1257984.
    coneq[3435]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/471744.
    coneq[3436]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/943488.
    coneq[3437]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/314496.
    coneq[3438]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/943488.
    coneq[3439]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1886976.
    coneq[3440]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/628992.
    coneq[3441]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**4)))))-1/131040.
    coneq[3442]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/524160.
    coneq[3443]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[3444]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[3445]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[3446]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[3447]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[3448]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[3449]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[3450]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/104832.
    coneq[3451]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/314496.
    coneq[3452]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[3453]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/209664.
    coneq[3454]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/78624.
    coneq[3455]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/157248.
    coneq[3456]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4*dot(A,c)))))-1/52416.
    coneq[3457]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/235872.
    coneq[3458]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/471744.
    coneq[3459]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/943488.
    coneq[3460]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/209664.
    coneq[3461]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/628992.
    coneq[3462]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[3463]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/419328.
    coneq[3464]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[3465]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[3466]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[3467]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[3468]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**5))))-1/22464.
    coneq[3469]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**4)))))-1/112320.
    coneq[3470]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/449280.
    coneq[3471]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1347840.
    coneq[3472]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2695680.
    coneq[3473]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/898560.
    coneq[3474]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/336960.
    coneq[3475]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/673920.
    coneq[3476]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/224640.
    coneq[3477]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/449280.
    coneq[3478]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/89856.
    coneq[3479]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/269568.
    coneq[3480]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/539136.
    coneq[3481]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/179712.
    coneq[3482]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/67392.
    coneq[3483]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/134784.
    coneq[3484]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/44928.
    coneq[3485]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/134784.
    coneq[3486]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/269568.
    coneq[3487]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/89856.
    coneq[3488]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**4))))-1/18720.
    coneq[3489]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/74880.
    coneq[3490]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/224640.
    coneq[3491]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/449280.
    coneq[3492]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/149760.
    coneq[3493]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/56160.
    coneq[3494]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/112320.
    coneq[3495]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/37440.
    coneq[3496]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/74880.
    coneq[3497]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**3))))-1/14976.
    coneq[3498]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/44928.
    coneq[3499]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/89856.
    coneq[3500]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/29952.
    coneq[3501]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c**2))))-1/11232.
    coneq[3502]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,dot(A,c)))))-1/22464.
    coneq[3503]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5*dot(A,c))))-1/7488.
    coneq[3504]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/44928.
    coneq[3505]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/134784.
    coneq[3506]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/269568.
    coneq[3507]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/89856.
    coneq[3508]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/89856.
    coneq[3509]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/269568.
    coneq[3510]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/539136.
    coneq[3511]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/179712.
    coneq[3512]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**4))))-1/37440.
    coneq[3513]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/149760.
    coneq[3514]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/449280.
    coneq[3515]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/898560.
    coneq[3516]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/299520.
    coneq[3517]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/112320.
    coneq[3518]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/224640.
    coneq[3519]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/74880.
    coneq[3520]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/149760.
    coneq[3521]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/33696.
    coneq[3522]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/67392.
    coneq[3523]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/134784.
    coneq[3524]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/29952.
    coneq[3525]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/89856.
    coneq[3526]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/179712.
    coneq[3527]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/59904.
    coneq[3528]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/22464.
    coneq[3529]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/44928.
    coneq[3530]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/14976.
    coneq[3531]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/44928.
    coneq[3532]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/89856.
    coneq[3533]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/29952.
    coneq[3534]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**7)))-1/7488.
    coneq[3535]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**6))))-1/52416.
    coneq[3536]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**5)))))-1/314496.
    coneq[3537]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/1572480.
    coneq[3538]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/6289920.
    coneq[3539]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[3540]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[3541]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[3542]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/4717440.
    coneq[3543]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/9434880.
    coneq[3544]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/3144960.
    coneq[3545]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[3546]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/1257984.
    coneq[3547]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/3773952.
    coneq[3548]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/7547904.
    coneq[3549]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2515968.
    coneq[3550]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/943488.
    coneq[3551]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1886976.
    coneq[3552]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/628992.
    coneq[3553]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1886976.
    coneq[3554]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3773952.
    coneq[3555]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1257984.
    coneq[3556]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**4)))))-1/262080.
    coneq[3557]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/1048320.
    coneq[3558]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[3559]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[3560]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[3561]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[3562]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[3563]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[3564]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[3565]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**3)))))-1/209664.
    coneq[3566]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/628992.
    coneq[3567]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[3568]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/419328.
    coneq[3569]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c**2)))))-1/157248.
    coneq[3570]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/314496.
    coneq[3571]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4*dot(A,c)))))-1/104832.
    coneq[3572]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/471744.
    coneq[3573]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/943488.
    coneq[3574]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1886976.
    coneq[3575]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/419328.
    coneq[3576]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[3577]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[3578]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/838656.
    coneq[3579]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[3580]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[3581]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[3582]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/419328.
    coneq[3583]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**5))))-1/44928.
    coneq[3584]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**4)))))-1/224640.
    coneq[3585]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/898560.
    coneq[3586]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2695680.
    coneq[3587]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5391360.
    coneq[3588]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1797120.
    coneq[3589]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/673920.
    coneq[3590]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1347840.
    coneq[3591]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/449280.
    coneq[3592]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/898560.
    coneq[3593]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**3)))))-1/179712.
    coneq[3594]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/539136.
    coneq[3595]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1078272.
    coneq[3596]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/359424.
    coneq[3597]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/134784.
    coneq[3598]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/269568.
    coneq[3599]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3*dot(A,c)))))-1/89856.
    coneq[3600]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/269568.
    coneq[3601]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/539136.
    coneq[3602]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/179712.
    coneq[3603]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**4))))-1/37440.
    coneq[3604]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**3)))))-1/149760.
    coneq[3605]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/449280.
    coneq[3606]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/898560.
    coneq[3607]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/299520.
    coneq[3608]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/112320.
    coneq[3609]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/224640.
    coneq[3610]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/74880.
    coneq[3611]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/149760.
    coneq[3612]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**3))))-1/29952.
    coneq[3613]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c**2)))))-1/89856.
    coneq[3614]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/179712.
    coneq[3615]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c*dot(A,c)))))-1/59904.
    coneq[3616]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c**2))))-1/22464.
    coneq[3617]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,dot(A,c)))))-1/44928.
    coneq[3618]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5*dot(A,c))))-1/14976.
    coneq[3619]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**3))))-1/89856.
    coneq[3620]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/269568.
    coneq[3621]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/539136.
    coneq[3622]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/179712.
    coneq[3623]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/179712.
    coneq[3624]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/539136.
    coneq[3625]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1078272.
    coneq[3626]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/359424.
    coneq[3627]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**4))))-1/74880.
    coneq[3628]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/299520.
    coneq[3629]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/898560.
    coneq[3630]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1797120.
    coneq[3631]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/599040.
    coneq[3632]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/224640.
    coneq[3633]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/449280.
    coneq[3634]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/149760.
    coneq[3635]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/299520.
    coneq[3636]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/67392.
    coneq[3637]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/134784.
    coneq[3638]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/269568.
    coneq[3639]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**3))))-1/59904.
    coneq[3640]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/179712.
    coneq[3641]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/359424.
    coneq[3642]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/119808.
    coneq[3643]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/44928.
    coneq[3644]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/89856.
    coneq[3645]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,c))))-1/29952.
    coneq[3646]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/89856.
    coneq[3647]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/179712.
    coneq[3648]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/59904.
    coneq[3649]=dot(b,dot(A,dot(A,c)*dot(A,c**8)))-1/2808.
    coneq[3650]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**7))))-1/22464.
    coneq[3651]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**6)))))-1/157248.
    coneq[3652]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/943488.
    coneq[3653]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/4717440.
    coneq[3654]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/18869760.
    coneq[3655]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/56609280.
    coneq[3656]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/113218560.
    coneq[3657]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/37739520.
    coneq[3658]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/14152320.
    coneq[3659]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/28304640.
    coneq[3660]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/9434880.
    coneq[3661]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/18869760.
    coneq[3662]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/3773952.
    coneq[3663]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/11321856.
    coneq[3664]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/22643712.
    coneq[3665]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/7547904.
    coneq[3666]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2830464.
    coneq[3667]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/5660928.
    coneq[3668]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1886976.
    coneq[3669]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/5660928.
    coneq[3670]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/11321856.
    coneq[3671]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/3773952.
    coneq[3672]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/786240.
    coneq[3673]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/3144960.
    coneq[3674]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/9434880.
    coneq[3675]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18869760.
    coneq[3676]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/6289920.
    coneq[3677]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2358720.
    coneq[3678]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/4717440.
    coneq[3679]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1572480.
    coneq[3680]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/3144960.
    coneq[3681]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/628992.
    coneq[3682]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1886976.
    coneq[3683]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/3773952.
    coneq[3684]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1257984.
    coneq[3685]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/471744.
    coneq[3686]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/943488.
    coneq[3687]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/314496.
    coneq[3688]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1415232.
    coneq[3689]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2830464.
    coneq[3690]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5660928.
    coneq[3691]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/1257984.
    coneq[3692]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/3773952.
    coneq[3693]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/7547904.
    coneq[3694]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2515968.
    coneq[3695]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/943488.
    coneq[3696]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1886976.
    coneq[3697]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/628992.
    coneq[3698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1257984.
    coneq[3699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**5)))))-1/134784.
    coneq[3700]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/673920.
    coneq[3701]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/2695680.
    coneq[3702]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/8087040.
    coneq[3703]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/16174080.
    coneq[3704]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5391360.
    coneq[3705]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/2021760.
    coneq[3706]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4043520.
    coneq[3707]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/1347840.
    coneq[3708]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2695680.
    coneq[3709]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/539136.
    coneq[3710]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/1617408.
    coneq[3711]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3234816.
    coneq[3712]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1078272.
    coneq[3713]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/404352.
    coneq[3714]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/808704.
    coneq[3715]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/269568.
    coneq[3716]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/808704.
    coneq[3717]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1617408.
    coneq[3718]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/539136.
    coneq[3719]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**4)))))-1/112320.
    coneq[3720]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/449280.
    coneq[3721]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/1347840.
    coneq[3722]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2695680.
    coneq[3723]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/898560.
    coneq[3724]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/336960.
    coneq[3725]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/673920.
    coneq[3726]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/224640.
    coneq[3727]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/449280.
    coneq[3728]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**3)))))-1/89856.
    coneq[3729]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/269568.
    coneq[3730]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/539136.
    coneq[3731]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/179712.
    coneq[3732]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c**2)))))-1/67392.
    coneq[3733]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/134784.
    coneq[3734]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5*dot(A,c)))))-1/44928.
    coneq[3735]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/269568.
    coneq[3736]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/808704.
    coneq[3737]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1617408.
    coneq[3738]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/539136.
    coneq[3739]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/539136.
    coneq[3740]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1617408.
    coneq[3741]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/3234816.
    coneq[3742]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1078272.
    coneq[3743]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/224640.
    coneq[3744]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/898560.
    coneq[3745]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2695680.
    coneq[3746]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5391360.
    coneq[3747]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1797120.
    coneq[3748]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/673920.
    coneq[3749]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1347840.
    coneq[3750]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/449280.
    coneq[3751]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/898560.
    coneq[3752]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/202176.
    coneq[3753]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/404352.
    coneq[3754]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/808704.
    coneq[3755]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/179712.
    coneq[3756]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/539136.
    coneq[3757]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1078272.
    coneq[3758]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/359424.
    coneq[3759]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/134784.
    coneq[3760]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/269568.
    coneq[3761]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/89856.
    coneq[3762]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/269568.
    coneq[3763]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/539136.
    coneq[3764]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/179712.
    coneq[3765]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**6))))-1/19656.
    coneq[3766]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**5)))))-1/117936.
    coneq[3767]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/589680.
    coneq[3768]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2358720.
    coneq[3769]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/7076160.
    coneq[3770]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14152320.
    coneq[3771]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4717440.
    coneq[3772]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1769040.
    coneq[3773]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3538080.
    coneq[3774]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1179360.
    coneq[3775]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2358720.
    coneq[3776]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/471744.
    coneq[3777]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1415232.
    coneq[3778]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2830464.
    coneq[3779]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/943488.
    coneq[3780]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/353808.
    coneq[3781]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/707616.
    coneq[3782]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/235872.
    coneq[3783]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/707616.
    coneq[3784]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1415232.
    coneq[3785]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/471744.
    coneq[3786]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**4)))))-1/98280.
    coneq[3787]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/393120.
    coneq[3788]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[3789]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[3790]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/786240.
    coneq[3791]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/294840.
    coneq[3792]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/589680.
    coneq[3793]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/196560.
    coneq[3794]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/393120.
    coneq[3795]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/78624.
    coneq[3796]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/235872.
    coneq[3797]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/471744.
    coneq[3798]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/157248.
    coneq[3799]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/58968.
    coneq[3800]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/117936.
    coneq[3801]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4*dot(A,c)))))-1/39312.
    coneq[3802]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/176904.
    coneq[3803]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/353808.
    coneq[3804]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/707616.
    coneq[3805]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/157248.
    coneq[3806]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/471744.
    coneq[3807]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[3808]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/314496.
    coneq[3809]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/117936.
    coneq[3810]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/235872.
    coneq[3811]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/78624.
    coneq[3812]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[3813]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**5))))-1/16848.
    coneq[3814]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**4)))))-1/84240.
    coneq[3815]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/336960.
    coneq[3816]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1010880.
    coneq[3817]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2021760.
    coneq[3818]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/673920.
    coneq[3819]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/252720.
    coneq[3820]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/505440.
    coneq[3821]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/168480.
    coneq[3822]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/336960.
    coneq[3823]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/67392.
    coneq[3824]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/202176.
    coneq[3825]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/404352.
    coneq[3826]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/134784.
    coneq[3827]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/50544.
    coneq[3828]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/101088.
    coneq[3829]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/33696.
    coneq[3830]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/101088.
    coneq[3831]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/202176.
    coneq[3832]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/67392.
    coneq[3833]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**4))))-1/14040.
    coneq[3834]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**3)))))-1/56160.
    coneq[3835]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/168480.
    coneq[3836]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/336960.
    coneq[3837]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/112320.
    coneq[3838]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/42120.
    coneq[3839]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/84240.
    coneq[3840]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/28080.
    coneq[3841]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/56160.
    coneq[3842]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**3))))-1/11232.
    coneq[3843]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c**2)))))-1/33696.
    coneq[3844]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/67392.
    coneq[3845]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c*dot(A,c)))))-1/22464.
    coneq[3846]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c**2))))-1/8424.
    coneq[3847]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,dot(A,c)))))-1/16848.
    coneq[3848]=dot(b,dot(A,dot(A,c)*dot(A,c**6*dot(A,c))))-1/5616.
    coneq[3849]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c**3))))-1/44928.
    coneq[3850]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/134784.
    coneq[3851]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/269568.
    coneq[3852]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/89856.
    coneq[3853]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/404352.
    coneq[3854]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/808704.
    coneq[3855]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/269568.
    coneq[3856]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/1617408.
    coneq[3857]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/539136.
    coneq[3858]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/179712.
    coneq[3859]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**4))))-1/42120.
    coneq[3860]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/168480.
    coneq[3861]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/505440.
    coneq[3862]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1010880.
    coneq[3863]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/336960.
    coneq[3864]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/126360.
    coneq[3865]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/252720.
    coneq[3866]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/84240.
    coneq[3867]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/168480.
    coneq[3868]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/84240.
    coneq[3869]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/336960.
    coneq[3870]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1010880.
    coneq[3871]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2021760.
    coneq[3872]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/673920.
    coneq[3873]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/252720.
    coneq[3874]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/505440.
    coneq[3875]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/168480.
    coneq[3876]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/336960.
    coneq[3877]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**5))))-1/33696.
    coneq[3878]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/168480.
    coneq[3879]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/673920.
    coneq[3880]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2021760.
    coneq[3881]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4043520.
    coneq[3882]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1347840.
    coneq[3883]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/505440.
    coneq[3884]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1010880.
    coneq[3885]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/336960.
    coneq[3886]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/673920.
    coneq[3887]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/134784.
    coneq[3888]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/404352.
    coneq[3889]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/808704.
    coneq[3890]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/269568.
    coneq[3891]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/101088.
    coneq[3892]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/202176.
    coneq[3893]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/67392.
    coneq[3894]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/202176.
    coneq[3895]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/404352.
    coneq[3896]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/134784.
    coneq[3897]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/33696.
    coneq[3898]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/101088.
    coneq[3899]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/202176.
    coneq[3900]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/67392.
    coneq[3901]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/67392.
    coneq[3902]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/202176.
    coneq[3903]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/404352.
    coneq[3904]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/134784.
    coneq[3905]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**4))))-1/28080.
    coneq[3906]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/112320.
    coneq[3907]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/336960.
    coneq[3908]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/673920.
    coneq[3909]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/224640.
    coneq[3910]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/84240.
    coneq[3911]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/168480.
    coneq[3912]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/56160.
    coneq[3913]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/112320.
    coneq[3914]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/25272.
    coneq[3915]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/50544.
    coneq[3916]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/101088.
    coneq[3917]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/22464.
    coneq[3918]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/67392.
    coneq[3919]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/134784.
    coneq[3920]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/44928.
    coneq[3921]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/16848.
    coneq[3922]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/33696.
    coneq[3923]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)*dot(A,c))))-1/11232.
    coneq[3924]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/44928.
    coneq[3925]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/134784.
    coneq[3926]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/269568.
    coneq[3927]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/89856.
    coneq[3928]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/50544.
    coneq[3929]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/101088.
    coneq[3930]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/202176.
    coneq[3931]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/33696.
    coneq[3932]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/67392.
    coneq[3933]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/22464.
    coneq[3934]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/44928.
    coneq[3935]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**4)))-1/3900.
    coneq[3936]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c**3))))-1/15600.
    coneq[3937]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,c**2)))))-1/46800.
    coneq[3938]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c))))))-1/93600.
    coneq[3939]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c*dot(A,c)))))-1/31200.
    coneq[3940]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,c**2))))-1/11700.
    coneq[3941]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,dot(A,c)))))-1/23400.
    coneq[3942]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**2*dot(A,c))))-1/7800.
    coneq[3943]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c)*dot(A,c))))-1/15600.
    coneq[3944]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c**3))))-1/62400.
    coneq[3945]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))))-1/187200.
    coneq[3946]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))))-1/374400.
    coneq[3947]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))))-1/124800.
    coneq[3948]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2))))-1/46800.
    coneq[3949]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))))-1/93600.
    coneq[3950]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c))))-1/31200.
    coneq[3951]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))))-1/62400.
    coneq[3952]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))))-1/561600.
    coneq[3953]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1123200.
    coneq[3954]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))))-1/374400.
    coneq[3955]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))))-1/140400.
    coneq[3956]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))))-1/280800.
    coneq[3957]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))))-1/93600.
    coneq[3958]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))))-1/187200.
    coneq[3959]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))))-1/2246400.
    coneq[3960]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))))-1/748800.
    coneq[3961]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))))-1/280800.
    coneq[3962]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))))-1/561600.
    coneq[3963]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))))-1/187200.
    coneq[3964]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))))-1/374400.
    coneq[3965]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/249600.
    coneq[3966]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))))-1/93600.
    coneq[3967]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/187200.
    coneq[3968]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))))-1/62400.
    coneq[3969]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/124800.
    coneq[3970]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/35100.
    coneq[3971]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/70200.
    coneq[3972]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/23400.
    coneq[3973]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/46800.
    coneq[3974]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/140400.
    coneq[3975]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/46800.
    coneq[3976]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/93600.
    coneq[3977]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))))-1/15600.
    coneq[3978]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/31200.
    coneq[3979]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/62400.
    coneq[3980]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**5)))-1/3744.
    coneq[3981]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**4))))-1/18720.
    coneq[3982]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**3)))))-1/74880.
    coneq[3983]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/224640.
    coneq[3984]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/449280.
    coneq[3985]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/149760.
    coneq[3986]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2)))))-1/56160.
    coneq[3987]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/112320.
    coneq[3988]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)))))-1/37440.
    coneq[3989]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/74880.
    coneq[3990]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**3))))-1/14976.
    coneq[3991]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2)))))-1/44928.
    coneq[3992]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/89856.
    coneq[3993]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)))))-1/29952.
    coneq[3994]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c**2))))-1/11232.
    coneq[3995]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)))))-1/22464.
    coneq[3996]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3*dot(A,c))))-1/7488.
    coneq[3997]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2))))-1/22464.
    coneq[3998]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/44928.
    coneq[3999]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c))))-1/14976.
    coneq[4000]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**5)))-1/11232.
    coneq[4001]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**4))))-1/56160.
    coneq[4002]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))-1/224640.
    coneq[4003]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/673920.
    coneq[4004]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1347840.
    coneq[4005]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/449280.
    coneq[4006]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))-1/168480.
    coneq[4007]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/336960.
    coneq[4008]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))-1/112320.
    coneq[4009]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/224640.
    coneq[4010]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3))))-1/44928.
    coneq[4011]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))-1/134784.
    coneq[4012]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/269568.
    coneq[4013]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))-1/89856.
    coneq[4014]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/33696.
    coneq[4015]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/67392.
    coneq[4016]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/22464.
    coneq[4017]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/67392.
    coneq[4018]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/134784.
    coneq[4019]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/44928.
    coneq[4020]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**5)))-1/22464.
    coneq[4021]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4))))-1/112320.
    coneq[4022]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/449280.
    coneq[4023]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1347840.
    coneq[4024]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2695680.
    coneq[4025]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/898560.
    coneq[4026]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/336960.
    coneq[4027]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/673920.
    coneq[4028]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/224640.
    coneq[4029]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/449280.
    coneq[4030]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))-1/89856.
    coneq[4031]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/269568.
    coneq[4032]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/539136.
    coneq[4033]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/179712.
    coneq[4034]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/67392.
    coneq[4035]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/134784.
    coneq[4036]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/44928.
    coneq[4037]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/134784.
    coneq[4038]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/269568.
    coneq[4039]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/89856.
    coneq[4040]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**5)))-1/7488.
    coneq[4041]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**4))))-1/37440.
    coneq[4042]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/149760.
    coneq[4043]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/449280.
    coneq[4044]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/898560.
    coneq[4045]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/299520.
    coneq[4046]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/112320.
    coneq[4047]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/224640.
    coneq[4048]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/74880.
    coneq[4049]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/149760.
    coneq[4050]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3))))-1/29952.
    coneq[4051]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/89856.
    coneq[4052]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/179712.
    coneq[4053]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/59904.
    coneq[4054]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/22464.
    coneq[4055]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/44928.
    coneq[4056]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c))))-1/14976.
    coneq[4057]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/44928.
    coneq[4058]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/89856.
    coneq[4059]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/29952.
    coneq[4060]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**6)))-1/3276.
    coneq[4061]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**5))))-1/19656.
    coneq[4062]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**4)))))-1/98280.
    coneq[4063]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/393120.
    coneq[4064]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[4065]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[4066]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/786240.
    coneq[4067]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/294840.
    coneq[4068]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/589680.
    coneq[4069]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/196560.
    coneq[4070]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/393120.
    coneq[4071]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3)))))-1/78624.
    coneq[4072]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/235872.
    coneq[4073]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/471744.
    coneq[4074]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/157248.
    coneq[4075]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/58968.
    coneq[4076]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/117936.
    coneq[4077]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)))))-1/39312.
    coneq[4078]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/117936.
    coneq[4079]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/235872.
    coneq[4080]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/78624.
    coneq[4081]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**4))))-1/16380.
    coneq[4082]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3)))))-1/65520.
    coneq[4083]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/196560.
    coneq[4084]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/393120.
    coneq[4085]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/131040.
    coneq[4086]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/49140.
    coneq[4087]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/98280.
    coneq[4088]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/32760.
    coneq[4089]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/65520.
    coneq[4090]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**3))))-1/13104.
    coneq[4091]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/39312.
    coneq[4092]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/78624.
    coneq[4093]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/26208.
    coneq[4094]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c**2))))-1/9828.
    coneq[4095]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)))))-1/19656.
    coneq[4096]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4*dot(A,c))))-1/6552.
    coneq[4097]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/29484.
    coneq[4098]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/58968.
    coneq[4099]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/117936.
    coneq[4100]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3))))-1/26208.
    coneq[4101]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/78624.
    coneq[4102]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[4103]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/52416.
    coneq[4104]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/19656.
    coneq[4105]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/39312.
    coneq[4106]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/13104.
    coneq[4107]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/26208.
    coneq[4108]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**6)))-1/6552.
    coneq[4109]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**5))))-1/39312.
    coneq[4110]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/196560.
    coneq[4111]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/786240.
    coneq[4112]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[4113]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[4114]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[4115]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/589680.
    coneq[4116]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1179360.
    coneq[4117]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/393120.
    coneq[4118]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/786240.
    coneq[4119]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/157248.
    coneq[4120]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/471744.
    coneq[4121]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[4122]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/314496.
    coneq[4123]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/117936.
    coneq[4124]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/235872.
    coneq[4125]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/78624.
    coneq[4126]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/235872.
    coneq[4127]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/471744.
    coneq[4128]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[4129]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**4))))-1/32760.
    coneq[4130]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/131040.
    coneq[4131]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/393120.
    coneq[4132]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[4133]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/262080.
    coneq[4134]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/98280.
    coneq[4135]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/196560.
    coneq[4136]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/65520.
    coneq[4137]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/131040.
    coneq[4138]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/26208.
    coneq[4139]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/78624.
    coneq[4140]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[4141]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/52416.
    coneq[4142]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/19656.
    coneq[4143]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/39312.
    coneq[4144]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4*dot(A,c))))-1/13104.
    coneq[4145]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/58968.
    coneq[4146]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/117936.
    coneq[4147]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/235872.
    coneq[4148]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/52416.
    coneq[4149]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/157248.
    coneq[4150]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[4151]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/104832.
    coneq[4152]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/39312.
    coneq[4153]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/78624.
    coneq[4154]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/26208.
    coneq[4155]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/52416.
    coneq[4156]=dot(b,dot(A,c*dot(A,c)*dot(A,c**7)))-1/2496.
    coneq[4157]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**6))))-1/17472.
    coneq[4158]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**5)))))-1/104832.
    coneq[4159]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/524160.
    coneq[4160]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2096640.
    coneq[4161]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/6289920.
    coneq[4162]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/12579840.
    coneq[4163]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4193280.
    coneq[4164]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1572480.
    coneq[4165]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3144960.
    coneq[4166]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1048320.
    coneq[4167]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2096640.
    coneq[4168]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/419328.
    coneq[4169]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1257984.
    coneq[4170]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2515968.
    coneq[4171]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/838656.
    coneq[4172]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/314496.
    coneq[4173]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/628992.
    coneq[4174]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/209664.
    coneq[4175]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/628992.
    coneq[4176]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1257984.
    coneq[4177]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/419328.
    coneq[4178]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**4)))))-1/87360.
    coneq[4179]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/349440.
    coneq[4180]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1048320.
    coneq[4181]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2096640.
    coneq[4182]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/698880.
    coneq[4183]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/262080.
    coneq[4184]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/524160.
    coneq[4185]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/174720.
    coneq[4186]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/349440.
    coneq[4187]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/69888.
    coneq[4188]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/209664.
    coneq[4189]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/419328.
    coneq[4190]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/139776.
    coneq[4191]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/52416.
    coneq[4192]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/104832.
    coneq[4193]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4*dot(A,c)))))-1/34944.
    coneq[4194]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/157248.
    coneq[4195]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/314496.
    coneq[4196]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/628992.
    coneq[4197]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/139776.
    coneq[4198]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/419328.
    coneq[4199]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/838656.
    coneq[4200]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/279552.
    coneq[4201]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/104832.
    coneq[4202]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/209664.
    coneq[4203]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/69888.
    coneq[4204]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/139776.
    coneq[4205]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**5))))-1/14976.
    coneq[4206]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**4)))))-1/74880.
    coneq[4207]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/299520.
    coneq[4208]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/898560.
    coneq[4209]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1797120.
    coneq[4210]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/599040.
    coneq[4211]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/224640.
    coneq[4212]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/449280.
    coneq[4213]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/149760.
    coneq[4214]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/299520.
    coneq[4215]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/59904.
    coneq[4216]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/179712.
    coneq[4217]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/359424.
    coneq[4218]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/119808.
    coneq[4219]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/44928.
    coneq[4220]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/89856.
    coneq[4221]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/29952.
    coneq[4222]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/89856.
    coneq[4223]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/179712.
    coneq[4224]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/59904.
    coneq[4225]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**4))))-1/12480.
    coneq[4226]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/49920.
    coneq[4227]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/149760.
    coneq[4228]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/299520.
    coneq[4229]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/99840.
    coneq[4230]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/37440.
    coneq[4231]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/74880.
    coneq[4232]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/24960.
    coneq[4233]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/49920.
    coneq[4234]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**3))))-1/9984.
    coneq[4235]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/29952.
    coneq[4236]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/59904.
    coneq[4237]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/19968.
    coneq[4238]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c**2))))-1/7488.
    coneq[4239]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,dot(A,c)))))-1/14976.
    coneq[4240]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5*dot(A,c))))-1/4992.
    coneq[4241]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/29952.
    coneq[4242]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/89856.
    coneq[4243]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/179712.
    coneq[4244]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/59904.
    coneq[4245]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/59904.
    coneq[4246]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/179712.
    coneq[4247]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/359424.
    coneq[4248]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/119808.
    coneq[4249]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**4))))-1/24960.
    coneq[4250]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/99840.
    coneq[4251]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/299520.
    coneq[4252]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/599040.
    coneq[4253]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/199680.
    coneq[4254]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/74880.
    coneq[4255]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/149760.
    coneq[4256]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/49920.
    coneq[4257]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/99840.
    coneq[4258]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/22464.
    coneq[4259]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/44928.
    coneq[4260]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/89856.
    coneq[4261]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/19968.
    coneq[4262]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/59904.
    coneq[4263]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/119808.
    coneq[4264]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/39936.
    coneq[4265]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/14976.
    coneq[4266]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/29952.
    coneq[4267]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/9984.
    coneq[4268]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/29952.
    coneq[4269]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/59904.
    coneq[4270]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/19968.
    coneq[4271]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**4)))-1/3120.
    coneq[4272]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**3))))-1/12480.
    coneq[4273]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/37440.
    coneq[4274]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/74880.
    coneq[4275]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/24960.
    coneq[4276]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/9360.
    coneq[4277]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/18720.
    coneq[4278]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/6240.
    coneq[4279]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/12480.
    coneq[4280]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**4)))-1/9360.
    coneq[4281]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/37440.
    coneq[4282]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/112320.
    coneq[4283]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[4284]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/74880.
    coneq[4285]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/28080.
    coneq[4286]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/56160.
    coneq[4287]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/18720.
    coneq[4288]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/37440.
    coneq[4289]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/18720.
    coneq[4290]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/74880.
    coneq[4291]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/224640.
    coneq[4292]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[4293]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/149760.
    coneq[4294]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/56160.
    coneq[4295]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/112320.
    coneq[4296]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/37440.
    coneq[4297]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/74880.
    coneq[4298]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**4)))-1/6240.
    coneq[4299]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/24960.
    coneq[4300]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/74880.
    coneq[4301]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/149760.
    coneq[4302]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/49920.
    coneq[4303]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/18720.
    coneq[4304]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/37440.
    coneq[4305]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/12480.
    coneq[4306]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/24960.
    coneq[4307]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**5)))-1/2808.
    coneq[4308]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**4))))-1/14040.
    coneq[4309]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/56160.
    coneq[4310]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/168480.
    coneq[4311]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/336960.
    coneq[4312]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/112320.
    coneq[4313]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/42120.
    coneq[4314]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/84240.
    coneq[4315]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/28080.
    coneq[4316]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/56160.
    coneq[4317]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/11232.
    coneq[4318]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/33696.
    coneq[4319]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/67392.
    coneq[4320]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/22464.
    coneq[4321]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/8424.
    coneq[4322]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/16848.
    coneq[4323]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/5616.
    coneq[4324]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/16848.
    coneq[4325]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/33696.
    coneq[4326]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/11232.
    coneq[4327]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**5)))-1/5616.
    coneq[4328]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/28080.
    coneq[4329]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/112320.
    coneq[4330]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/336960.
    coneq[4331]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/673920.
    coneq[4332]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/224640.
    coneq[4333]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/84240.
    coneq[4334]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/168480.
    coneq[4335]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/56160.
    coneq[4336]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/112320.
    coneq[4337]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/22464.
    coneq[4338]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/67392.
    coneq[4339]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/134784.
    coneq[4340]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/44928.
    coneq[4341]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/16848.
    coneq[4342]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/33696.
    coneq[4343]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/11232.
    coneq[4344]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/33696.
    coneq[4345]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/67392.
    coneq[4346]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/22464.
    coneq[4347]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**6)))-1/2184.
    coneq[4348]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**5))))-1/13104.
    coneq[4349]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))-1/65520.
    coneq[4350]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/262080.
    coneq[4351]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/786240.
    coneq[4352]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1572480.
    coneq[4353]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/524160.
    coneq[4354]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/196560.
    coneq[4355]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/393120.
    coneq[4356]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/131040.
    coneq[4357]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/262080.
    coneq[4358]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))-1/52416.
    coneq[4359]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/157248.
    coneq[4360]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/314496.
    coneq[4361]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/104832.
    coneq[4362]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/39312.
    coneq[4363]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/78624.
    coneq[4364]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))-1/26208.
    coneq[4365]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/78624.
    coneq[4366]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/157248.
    coneq[4367]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/52416.
    coneq[4368]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**4))))-1/10920.
    coneq[4369]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))-1/43680.
    coneq[4370]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/131040.
    coneq[4371]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/262080.
    coneq[4372]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/87360.
    coneq[4373]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/32760.
    coneq[4374]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/65520.
    coneq[4375]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/21840.
    coneq[4376]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/43680.
    coneq[4377]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**3))))-1/8736.
    coneq[4378]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/26208.
    coneq[4379]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/52416.
    coneq[4380]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/17472.
    coneq[4381]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c**2))))-1/6552.
    coneq[4382]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))-1/13104.
    coneq[4383]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4*dot(A,c))))-1/4368.
    coneq[4384]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/19656.
    coneq[4385]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/39312.
    coneq[4386]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/78624.
    coneq[4387]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))-1/17472.
    coneq[4388]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/52416.
    coneq[4389]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[4390]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/34944.
    coneq[4391]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/13104.
    coneq[4392]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/26208.
    coneq[4393]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/8736.
    coneq[4394]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/17472.
    coneq[4395]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c**3)))-1/2496.
    coneq[4396]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,c**2))))-1/7488.
    coneq[4397]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/14976.
    coneq[4398]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c*dot(A,c))))-1/4992.
    coneq[4399]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/22464.
    coneq[4400]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/44928.
    coneq[4401]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/14976.
    coneq[4402]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/89856.
    coneq[4403]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/29952.
    coneq[4404]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/9984.
    coneq[4405]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**4)))-1/2340.
    coneq[4406]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**3))))-1/9360.
    coneq[4407]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/28080.
    coneq[4408]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/56160.
    coneq[4409]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/18720.
    coneq[4410]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/7020.
    coneq[4411]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/14040.
    coneq[4412]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/4680.
    coneq[4413]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/9360.
    coneq[4414]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**4)))-1/4680.
    coneq[4415]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/18720.
    coneq[4416]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/56160.
    coneq[4417]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/112320.
    coneq[4418]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/37440.
    coneq[4419]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/14040.
    coneq[4420]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/28080.
    coneq[4421]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/9360.
    coneq[4422]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/18720.
    coneq[4423]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**5)))-1/1872.
    coneq[4424]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**4))))-1/9360.
    coneq[4425]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/37440.
    coneq[4426]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/112320.
    coneq[4427]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/224640.
    coneq[4428]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/74880.
    coneq[4429]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/28080.
    coneq[4430]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/56160.
    coneq[4431]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/18720.
    coneq[4432]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/37440.
    coneq[4433]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**3))))-1/7488.
    coneq[4434]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/22464.
    coneq[4435]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/44928.
    coneq[4436]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/14976.
    coneq[4437]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/5616.
    coneq[4438]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/11232.
    coneq[4439]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3*dot(A,c))))-1/3744.
    coneq[4440]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/11232.
    coneq[4441]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/22464.
    coneq[4442]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/7488.
    coneq[4443]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**3)))-1/1872.
    coneq[4444]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c**2))))-1/5616.
    coneq[4445]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/11232.
    coneq[4446]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c*dot(A,c))))-1/3744.
    coneq[4447]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c**3)))-1/3744.
    coneq[4448]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/11232.
    coneq[4449]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/22464.
    coneq[4450]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/7488.
    coneq[4451]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**4)))-1/1560.
    coneq[4452]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**3))))-1/6240.
    coneq[4453]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/18720.
    coneq[4454]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/37440.
    coneq[4455]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/12480.
    coneq[4456]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c**2))))-1/4680.
    coneq[4457]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/9360.
    coneq[4458]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2*dot(A,c))))-1/3120.
    coneq[4459]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/6240.
    coneq[4460]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,c**2)))-1/1404.
    coneq[4461]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,dot(A,c))))-1/2808.
    coneq[4462]=dot(b,dot(A,c**5*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/5616.
    coneq[4463]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**3)))-1/1248.
    coneq[4464]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c**2))))-1/3744.
    coneq[4465]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/7488.
    coneq[4466]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c*dot(A,c))))-1/2496.
    coneq[4467]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c**2)))-1/936.
    coneq[4468]=dot(b,dot(A,c**6*dot(A,c)*dot(A,dot(A,c))))-1/1872.
    coneq[4469]=dot(b,dot(A,c**7*dot(A,c)*dot(A,c)))-1/624.
    coneq[4470]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**6)))-1/4368.
    coneq[4471]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**5))))-1/26208.
    coneq[4472]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))-1/131040.
    coneq[4473]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/524160.
    coneq[4474]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[4475]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[4476]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[4477]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[4478]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[4479]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[4480]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[4481]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))-1/104832.
    coneq[4482]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/314496.
    coneq[4483]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[4484]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/209664.
    coneq[4485]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/78624.
    coneq[4486]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/157248.
    coneq[4487]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))-1/52416.
    coneq[4488]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[4489]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[4490]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[4491]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**4))))-1/21840.
    coneq[4492]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))-1/87360.
    coneq[4493]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/262080.
    coneq[4494]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[4495]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/174720.
    coneq[4496]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/65520.
    coneq[4497]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/131040.
    coneq[4498]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/43680.
    coneq[4499]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/87360.
    coneq[4500]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**3))))-1/17472.
    coneq[4501]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/52416.
    coneq[4502]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[4503]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/34944.
    coneq[4504]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c**2))))-1/13104.
    coneq[4505]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))-1/26208.
    coneq[4506]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4*dot(A,c))))-1/8736.
    coneq[4507]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/39312.
    coneq[4508]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/78624.
    coneq[4509]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/157248.
    coneq[4510]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))-1/34944.
    coneq[4511]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/104832.
    coneq[4512]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[4513]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/69888.
    coneq[4514]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/26208.
    coneq[4515]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/52416.
    coneq[4516]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/17472.
    coneq[4517]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/34944.
    coneq[4518]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**5)))-1/5616.
    coneq[4519]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**4))))-1/28080.
    coneq[4520]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/112320.
    coneq[4521]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/336960.
    coneq[4522]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/673920.
    coneq[4523]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/224640.
    coneq[4524]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/84240.
    coneq[4525]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/168480.
    coneq[4526]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/56160.
    coneq[4527]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/112320.
    coneq[4528]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/22464.
    coneq[4529]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/67392.
    coneq[4530]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/134784.
    coneq[4531]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/44928.
    coneq[4532]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/16848.
    coneq[4533]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/33696.
    coneq[4534]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/11232.
    coneq[4535]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/33696.
    coneq[4536]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/67392.
    coneq[4537]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/22464.
    coneq[4538]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**5)))-1/11232.
    coneq[4539]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/56160.
    coneq[4540]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/224640.
    coneq[4541]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/673920.
    coneq[4542]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1347840.
    coneq[4543]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/449280.
    coneq[4544]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/168480.
    coneq[4545]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/336960.
    coneq[4546]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/112320.
    coneq[4547]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/224640.
    coneq[4548]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/44928.
    coneq[4549]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/134784.
    coneq[4550]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/269568.
    coneq[4551]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/89856.
    coneq[4552]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/33696.
    coneq[4553]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/67392.
    coneq[4554]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/22464.
    coneq[4555]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/67392.
    coneq[4556]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/134784.
    coneq[4557]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/44928.
    coneq[4558]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**4)))-1/7020.
    coneq[4559]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**3))))-1/28080.
    coneq[4560]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/84240.
    coneq[4561]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/168480.
    coneq[4562]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/56160.
    coneq[4563]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/21060.
    coneq[4564]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/42120.
    coneq[4565]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/14040.
    coneq[4566]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/28080.
    coneq[4567]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**4)))-1/14040.
    coneq[4568]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/56160.
    coneq[4569]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/168480.
    coneq[4570]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/336960.
    coneq[4571]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/112320.
    coneq[4572]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/42120.
    coneq[4573]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/84240.
    coneq[4574]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/28080.
    coneq[4575]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/56160.
    coneq[4576]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**4)))-1/28080.
    coneq[4577]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/112320.
    coneq[4578]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/336960.
    coneq[4579]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/673920.
    coneq[4580]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/224640.
    coneq[4581]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/84240.
    coneq[4582]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/168480.
    coneq[4583]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/56160.
    coneq[4584]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/112320.
    coneq[4585]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**4)))-1/6240.
    coneq[4586]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**3))))-1/24960.
    coneq[4587]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/74880.
    coneq[4588]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/149760.
    coneq[4589]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/49920.
    coneq[4590]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/18720.
    coneq[4591]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/37440.
    coneq[4592]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/12480.
    coneq[4593]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/24960.
    coneq[4594]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**4)))-1/18720.
    coneq[4595]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/74880.
    coneq[4596]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/224640.
    coneq[4597]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[4598]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/149760.
    coneq[4599]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/56160.
    coneq[4600]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/112320.
    coneq[4601]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/37440.
    coneq[4602]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/74880.
    coneq[4603]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/37440.
    coneq[4604]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/149760.
    coneq[4605]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/449280.
    coneq[4606]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/898560.
    coneq[4607]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/299520.
    coneq[4608]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/112320.
    coneq[4609]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/224640.
    coneq[4610]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/74880.
    coneq[4611]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/149760.
    coneq[4612]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**4)))-1/12480.
    coneq[4613]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/49920.
    coneq[4614]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/149760.
    coneq[4615]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/299520.
    coneq[4616]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/99840.
    coneq[4617]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/37440.
    coneq[4618]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/74880.
    coneq[4619]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/24960.
    coneq[4620]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/49920.
    coneq[4621]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c**3)))-1/7488.
    coneq[4622]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/22464.
    coneq[4623]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/44928.
    coneq[4624]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/14976.
    coneq[4625]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/67392.
    coneq[4626]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/134784.
    coneq[4627]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/44928.
    coneq[4628]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/269568.
    coneq[4629]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/89856.
    coneq[4630]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/29952.
    coneq[4631]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c**3)))-1/14976.
    coneq[4632]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c**2))))-1/44928.
    coneq[4633]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/89856.
    coneq[4634]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c*dot(A,c))))-1/29952.
    coneq[4635]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/134784.
    coneq[4636]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/269568.
    coneq[4637]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/89856.
    coneq[4638]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/539136.
    coneq[4639]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/179712.
    coneq[4640]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/59904.
    coneq[4641]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**5)))-1/3744.
    coneq[4642]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**4))))-1/18720.
    coneq[4643]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/74880.
    coneq[4644]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/224640.
    coneq[4645]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/449280.
    coneq[4646]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/149760.
    coneq[4647]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/56160.
    coneq[4648]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/112320.
    coneq[4649]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/37440.
    coneq[4650]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/74880.
    coneq[4651]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3))))-1/14976.
    coneq[4652]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/44928.
    coneq[4653]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/89856.
    coneq[4654]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/29952.
    coneq[4655]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/11232.
    coneq[4656]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/22464.
    coneq[4657]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c))))-1/7488.
    coneq[4658]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/22464.
    coneq[4659]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/44928.
    coneq[4660]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/14976.
    coneq[4661]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**4)))-1/4680.
    coneq[4662]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3))))-1/18720.
    coneq[4663]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/56160.
    coneq[4664]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/112320.
    coneq[4665]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/37440.
    coneq[4666]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/14040.
    coneq[4667]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/28080.
    coneq[4668]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/9360.
    coneq[4669]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/18720.
    coneq[4670]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**4)))-1/9360.
    coneq[4671]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/37440.
    coneq[4672]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/112320.
    coneq[4673]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[4674]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/74880.
    coneq[4675]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/28080.
    coneq[4676]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/56160.
    coneq[4677]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/18720.
    coneq[4678]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/37440.
    coneq[4679]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**3)))-1/5616.
    coneq[4680]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/16848.
    coneq[4681]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/33696.
    coneq[4682]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/11232.
    coneq[4683]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3)))-1/11232.
    coneq[4684]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/33696.
    coneq[4685]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/67392.
    coneq[4686]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/22464.
    coneq[4687]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3)))-1/22464.
    coneq[4688]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/67392.
    coneq[4689]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/134784.
    coneq[4690]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/44928.
    coneq[4691]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c**3)))-1/4992.
    coneq[4692]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/14976.
    coneq[4693]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/29952.
    coneq[4694]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/9984.
    coneq[4695]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/44928.
    coneq[4696]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/89856.
    coneq[4697]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/29952.
    coneq[4698]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/179712.
    coneq[4699]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/59904.
    coneq[4700]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/19968.
    coneq[4701]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**4)))-1/3120.
    coneq[4702]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))-1/12480.
    coneq[4703]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/37440.
    coneq[4704]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/74880.
    coneq[4705]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/24960.
    coneq[4706]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))-1/9360.
    coneq[4707]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/18720.
    coneq[4708]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))-1/6240.
    coneq[4709]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/12480.
    coneq[4710]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**3)))-1/3744.
    coneq[4711]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/11232.
    coneq[4712]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/22464.
    coneq[4713]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/7488.
    coneq[4714]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))-1/7488.
    coneq[4715]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/22464.
    coneq[4716]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/44928.
    coneq[4717]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/14976.
    coneq[4718]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/4212.
    coneq[4719]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/8424.
    coneq[4720]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/16848.
    coneq[4721]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/33696.
    coneq[4722]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/2496.
    coneq[4723]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/7488.
    coneq[4724]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/14976.
    coneq[4725]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/4992.
    coneq[4726]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/2808.
    coneq[4727]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/5616.
    coneq[4728]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/11232.
    coneq[4729]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/1872.
    coneq[4730]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/3744.
    coneq[4731]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c)*dot(A,c)))-1/1248.
    coneq[4732]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**4)))-1/6240.
    coneq[4733]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))-1/24960.
    coneq[4734]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/74880.
    coneq[4735]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/149760.
    coneq[4736]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/49920.
    coneq[4737]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))-1/18720.
    coneq[4738]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/37440.
    coneq[4739]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))-1/12480.
    coneq[4740]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/24960.
    coneq[4741]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**3)))-1/7488.
    coneq[4742]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/22464.
    coneq[4743]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/44928.
    coneq[4744]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/14976.
    coneq[4745]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))-1/14976.
    coneq[4746]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/44928.
    coneq[4747]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/89856.
    coneq[4748]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/29952.
    coneq[4749]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/8424.
    coneq[4750]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/16848.
    coneq[4751]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)))-1/16848.
    coneq[4752]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/33696.
    coneq[4753]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)))-1/33696.
    coneq[4754]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/67392.
    coneq[4755]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/4992.
    coneq[4756]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/14976.
    coneq[4757]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/29952.
    coneq[4758]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/9984.
    coneq[4759]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/5616.
    coneq[4760]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/11232.
    coneq[4761]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2)))-1/11232.
    coneq[4762]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/22464.
    coneq[4763]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/3744.
    coneq[4764]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/7488.
    coneq[4765]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))-1/2496.
    coneq[4766]=dot(b,dot(A,c**10)*c)-1/143.
    coneq[4767]=dot(b,dot(A,dot(A,c**9))*c)-1/1430.
    coneq[4768]=dot(b,dot(A,dot(A,dot(A,c**8)))*c)-1/12870.
    coneq[4769]=dot(b,dot(A,dot(A,dot(A,dot(A,c**7))))*c)-1/102960.
    coneq[4770]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**6)))))*c)-1/720720.
    coneq[4771]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))*c)-1/4324320.
    coneq[4772]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))*c)-1/21621600.
    coneq[4773]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))*c)-1/86486400.
    coneq[4774]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c)-1/259459200.
    coneq[4775]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/518918400.
    coneq[4776]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c)-1/172972800.
    coneq[4777]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*c)-1/64864800.
    coneq[4778]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c)-1/129729600.
    coneq[4779]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*c)-1/43243200.
    coneq[4780]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c)-1/86486400.
    coneq[4781]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))*c)-1/17297280.
    coneq[4782]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*c)-1/51891840.
    coneq[4783]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c)-1/103783680.
    coneq[4784]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*c)-1/34594560.
    coneq[4785]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))*c)-1/12972960.
    coneq[4786]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*c)-1/25945920.
    coneq[4787]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))*c)-1/8648640.
    coneq[4788]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*c)-1/25945920.
    coneq[4789]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c)-1/51891840.
    coneq[4790]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*c)-1/17297280.
    coneq[4791]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))*c)-1/3603600.
    coneq[4792]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))*c)-1/14414400.
    coneq[4793]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*c)-1/43243200.
    coneq[4794]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/86486400.
    coneq[4795]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*c)-1/28828800.
    coneq[4796]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))*c)-1/10810800.
    coneq[4797]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*c)-1/21621600.
    coneq[4798]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))*c)-1/7207200.
    coneq[4799]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/14414400.
    coneq[4800]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))*c)-1/2882880.
    coneq[4801]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))*c)-1/8648640.
    coneq[4802]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*c)-1/17297280.
    coneq[4803]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))*c)-1/5765760.
    coneq[4804]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))*c)-1/2162160.
    coneq[4805]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))*c)-1/4324320.
    coneq[4806]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))*c)-1/1441440.
    coneq[4807]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))*c)-1/6486480.
    coneq[4808]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*c)-1/12972960.
    coneq[4809]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c)-1/25945920.
    coneq[4810]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))*c)-1/5765760.
    coneq[4811]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*c)-1/17297280.
    coneq[4812]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c)-1/34594560.
    coneq[4813]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*c)-1/11531520.
    coneq[4814]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))*c)-1/4324320.
    coneq[4815]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/8648640.
    coneq[4816]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))*c)-1/2882880.
    coneq[4817]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*c)-1/5765760.
    coneq[4818]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5)))))*c)-1/617760.
    coneq[4819]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))*c)-1/3088800.
    coneq[4820]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))*c)-1/12355200.
    coneq[4821]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/37065600.
    coneq[4822]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/74131200.
    coneq[4823]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/24710400.
    coneq[4824]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/9266400.
    coneq[4825]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/18532800.
    coneq[4826]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/6177600.
    coneq[4827]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/12355200.
    coneq[4828]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))*c)-1/2471040.
    coneq[4829]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/7413120.
    coneq[4830]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/14826240.
    coneq[4831]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/4942080.
    coneq[4832]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))*c)-1/1853280.
    coneq[4833]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/3706560.
    coneq[4834]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))*c)-1/1235520.
    coneq[4835]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/3706560.
    coneq[4836]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/7413120.
    coneq[4837]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2471040.
    coneq[4838]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))*c)-1/514800.
    coneq[4839]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))*c)-1/2059200.
    coneq[4840]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))*c)-1/6177600.
    coneq[4841]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/12355200.
    coneq[4842]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))*c)-1/4118400.
    coneq[4843]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))*c)-1/1544400.
    coneq[4844]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3088800.
    coneq[4845]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))*c)-1/1029600.
    coneq[4846]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2059200.
    coneq[4847]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))*c)-1/411840.
    coneq[4848]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))*c)-1/1235520.
    coneq[4849]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))*c)-1/2471040.
    coneq[4850]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))*c)-1/823680.
    coneq[4851]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))*c)-1/308880.
    coneq[4852]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))*c)-1/617760.
    coneq[4853]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c)))))*c)-1/205920.
    coneq[4854]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))*c)-1/1235520.
    coneq[4855]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))*c)-1/3706560.
    coneq[4856]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*c)-1/7413120.
    coneq[4857]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))*c)-1/2471040.
    coneq[4858]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))*c)-1/2471040.
    coneq[4859]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*c)-1/7413120.
    coneq[4860]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*c)-1/14826240.
    coneq[4861]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*c)-1/4942080.
    coneq[4862]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))*c)-1/1029600.
    coneq[4863]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))*c)-1/4118400.
    coneq[4864]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*c)-1/12355200.
    coneq[4865]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/24710400.
    coneq[4866]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*c)-1/8236800.
    coneq[4867]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))*c)-1/3088800.
    coneq[4868]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*c)-1/6177600.
    coneq[4869]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))*c)-1/2059200.
    coneq[4870]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*c)-1/4118400.
    coneq[4871]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))*c)-1/926640.
    coneq[4872]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1853280.
    coneq[4873]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/3706560.
    coneq[4874]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))*c)-1/823680.
    coneq[4875]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2471040.
    coneq[4876]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/4942080.
    coneq[4877]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1647360.
    coneq[4878]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))*c)-1/617760.
    coneq[4879]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1235520.
    coneq[4880]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))*c)-1/411840.
    coneq[4881]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))*c)-1/1235520.
    coneq[4882]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*c)-1/2471040.
    coneq[4883]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/823680.
    coneq[4884]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**6))))*c)-1/90090.
    coneq[4885]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5)))))*c)-1/540540.
    coneq[4886]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))*c)-1/2702700.
    coneq[4887]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/10810800.
    coneq[4888]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/32432400.
    coneq[4889]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/64864800.
    coneq[4890]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/21621600.
    coneq[4891]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/8108100.
    coneq[4892]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/16216200.
    coneq[4893]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/5405400.
    coneq[4894]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/10810800.
    coneq[4895]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))*c)-1/2162160.
    coneq[4896]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/6486480.
    coneq[4897]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/12972960.
    coneq[4898]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/4324320.
    coneq[4899]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1621620.
    coneq[4900]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/3243240.
    coneq[4901]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1081080.
    coneq[4902]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/3243240.
    coneq[4903]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/6486480.
    coneq[4904]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2162160.
    coneq[4905]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))*c)-1/450450.
    coneq[4906]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))*c)-1/1801800.
    coneq[4907]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/5405400.
    coneq[4908]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/10810800.
    coneq[4909]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/3603600.
    coneq[4910]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1351350.
    coneq[4911]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/2702700.
    coneq[4912]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/900900.
    coneq[4913]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/1801800.
    coneq[4914]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))*c)-1/360360.
    coneq[4915]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1081080.
    coneq[4916]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/2162160.
    coneq[4917]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/720720.
    coneq[4918]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))*c)-1/270270.
    coneq[4919]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))*c)-1/540540.
    coneq[4920]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))*c)-1/180180.
    coneq[4921]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/810810.
    coneq[4922]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1621620.
    coneq[4923]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/3243240.
    coneq[4924]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/720720.
    coneq[4925]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2162160.
    coneq[4926]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/4324320.
    coneq[4927]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1441440.
    coneq[4928]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/540540.
    coneq[4929]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1081080.
    coneq[4930]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/360360.
    coneq[4931]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/720720.
    coneq[4932]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**5))))*c)-1/77220.
    coneq[4933]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))*c)-1/386100.
    coneq[4934]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))*c)-1/1544400.
    coneq[4935]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/4633200.
    coneq[4936]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/9266400.
    coneq[4937]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3088800.
    coneq[4938]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1158300.
    coneq[4939]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2316600.
    coneq[4940]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/772200.
    coneq[4941]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1544400.
    coneq[4942]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))*c)-1/308880.
    coneq[4943]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/926640.
    coneq[4944]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1853280.
    coneq[4945]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/617760.
    coneq[4946]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))*c)-1/231660.
    coneq[4947]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/463320.
    coneq[4948]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))*c)-1/154440.
    coneq[4949]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/463320.
    coneq[4950]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/926640.
    coneq[4951]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/308880.
    coneq[4952]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**4))))*c)-1/64350.
    coneq[4953]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))*c)-1/257400.
    coneq[4954]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))*c)-1/772200.
    coneq[4955]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1544400.
    coneq[4956]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))*c)-1/514800.
    coneq[4957]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))*c)-1/193050.
    coneq[4958]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))*c)-1/386100.
    coneq[4959]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))*c)-1/128700.
    coneq[4960]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))*c)-1/257400.
    coneq[4961]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**3))))*c)-1/51480.
    coneq[4962]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))*c)-1/154440.
    coneq[4963]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))*c)-1/308880.
    coneq[4964]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))*c)-1/102960.
    coneq[4965]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**2))))*c)-1/38610.
    coneq[4966]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c)))))*c)-1/77220.
    coneq[4967]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c))))*c)-1/25740.
    coneq[4968]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))*c)-1/205920.
    coneq[4969]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))*c)-1/617760.
    coneq[4970]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))*c)-1/1235520.
    coneq[4971]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))*c)-1/411840.
    coneq[4972]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))*c)-1/1853280.
    coneq[4973]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))*c)-1/3706560.
    coneq[4974]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))*c)-1/1235520.
    coneq[4975]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))*c)-1/7413120.
    coneq[4976]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))*c)-1/2471040.
    coneq[4977]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/823680.
    coneq[4978]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))*c)-1/193050.
    coneq[4979]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))*c)-1/772200.
    coneq[4980]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))*c)-1/2316600.
    coneq[4981]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/4633200.
    coneq[4982]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1544400.
    coneq[4983]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))*c)-1/579150.
    coneq[4984]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1158300.
    coneq[4985]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))*c)-1/386100.
    coneq[4986]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/772200.
    coneq[4987]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))*c)-1/386100.
    coneq[4988]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))*c)-1/1544400.
    coneq[4989]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*c)-1/4633200.
    coneq[4990]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/9266400.
    coneq[4991]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*c)-1/3088800.
    coneq[4992]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))*c)-1/1158300.
    coneq[4993]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*c)-1/2316600.
    coneq[4994]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))*c)-1/772200.
    coneq[4995]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1544400.
    coneq[4996]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5))))*c)-1/154440.
    coneq[4997]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))*c)-1/772200.
    coneq[4998]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))*c)-1/3088800.
    coneq[4999]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/9266400.
    coneq[5000]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/18532800.
    coneq[5001]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/6177600.
    coneq[5002]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2316600.
    coneq[5003]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/4633200.
    coneq[5004]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1544400.
    coneq[5005]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/3088800.
    coneq[5006]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))*c)-1/617760.
    coneq[5007]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1853280.
    coneq[5008]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/3706560.
    coneq[5009]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1235520.
    coneq[5010]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))*c)-1/463320.
    coneq[5011]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/926640.
    coneq[5012]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))*c)-1/308880.
    coneq[5013]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/926640.
    coneq[5014]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1853280.
    coneq[5015]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/617760.
    coneq[5016]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))*c)-1/154440.
    coneq[5017]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/463320.
    coneq[5018]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/926640.
    coneq[5019]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/308880.
    coneq[5020]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))*c)-1/308880.
    coneq[5021]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/926640.
    coneq[5022]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/1853280.
    coneq[5023]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/617760.
    coneq[5024]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))*c)-1/128700.
    coneq[5025]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/514800.
    coneq[5026]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1544400.
    coneq[5027]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3088800.
    coneq[5028]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1029600.
    coneq[5029]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/386100.
    coneq[5030]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/772200.
    coneq[5031]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/257400.
    coneq[5032]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/514800.
    coneq[5033]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))*c)-1/115830.
    coneq[5034]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/231660.
    coneq[5035]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/463320.
    coneq[5036]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))*c)-1/102960.
    coneq[5037]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/308880.
    coneq[5038]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/617760.
    coneq[5039]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/205920.
    coneq[5040]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))*c)-1/77220.
    coneq[5041]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))*c)-1/154440.
    coneq[5042]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))*c)-1/51480.
    coneq[5043]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))*c)-1/205920.
    coneq[5044]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/617760.
    coneq[5045]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1235520.
    coneq[5046]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/411840.
    coneq[5047]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))*c)-1/231660.
    coneq[5048]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/463320.
    coneq[5049]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/926640.
    coneq[5050]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/154440.
    coneq[5051]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/308880.
    coneq[5052]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/102960.
    coneq[5053]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/205920.
    coneq[5054]=dot(b,dot(A,dot(A,c*dot(A,c**7)))*c)-1/11440.
    coneq[5055]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**6))))*c)-1/80080.
    coneq[5056]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5)))))*c)-1/480480.
    coneq[5057]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/2402400.
    coneq[5058]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/9609600.
    coneq[5059]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/28828800.
    coneq[5060]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/57657600.
    coneq[5061]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/19219200.
    coneq[5062]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/7207200.
    coneq[5063]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/14414400.
    coneq[5064]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/4804800.
    coneq[5065]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/9609600.
    coneq[5066]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/1921920.
    coneq[5067]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/5765760.
    coneq[5068]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/11531520.
    coneq[5069]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/3843840.
    coneq[5070]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1441440.
    coneq[5071]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/2882880.
    coneq[5072]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/960960.
    coneq[5073]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/2882880.
    coneq[5074]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/5765760.
    coneq[5075]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/1921920.
    coneq[5076]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))*c)-1/400400.
    coneq[5077]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/1601600.
    coneq[5078]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/4804800.
    coneq[5079]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/9609600.
    coneq[5080]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/3203200.
    coneq[5081]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1201200.
    coneq[5082]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/2402400.
    coneq[5083]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/800800.
    coneq[5084]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/1601600.
    coneq[5085]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/320320.
    coneq[5086]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/960960.
    coneq[5087]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/1921920.
    coneq[5088]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/640640.
    coneq[5089]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/240240.
    coneq[5090]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/480480.
    coneq[5091]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))*c)-1/160160.
    coneq[5092]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/720720.
    coneq[5093]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1441440.
    coneq[5094]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/2882880.
    coneq[5095]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/640640.
    coneq[5096]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/1921920.
    coneq[5097]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/3843840.
    coneq[5098]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1281280.
    coneq[5099]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/480480.
    coneq[5100]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/960960.
    coneq[5101]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/320320.
    coneq[5102]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/640640.
    coneq[5103]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**5))))*c)-1/68640.
    coneq[5104]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))*c)-1/343200.
    coneq[5105]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/1372800.
    coneq[5106]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/4118400.
    coneq[5107]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/8236800.
    coneq[5108]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2745600.
    coneq[5109]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1029600.
    coneq[5110]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2059200.
    coneq[5111]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/686400.
    coneq[5112]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1372800.
    coneq[5113]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/274560.
    coneq[5114]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/823680.
    coneq[5115]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1647360.
    coneq[5116]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/549120.
    coneq[5117]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/205920.
    coneq[5118]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/411840.
    coneq[5119]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/137280.
    coneq[5120]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/411840.
    coneq[5121]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/823680.
    coneq[5122]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/274560.
    coneq[5123]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4))))*c)-1/57200.
    coneq[5124]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/228800.
    coneq[5125]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/686400.
    coneq[5126]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1372800.
    coneq[5127]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/457600.
    coneq[5128]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/171600.
    coneq[5129]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/343200.
    coneq[5130]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/114400.
    coneq[5131]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/228800.
    coneq[5132]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3))))*c)-1/45760.
    coneq[5133]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/137280.
    coneq[5134]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/274560.
    coneq[5135]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/91520.
    coneq[5136]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2))))*c)-1/34320.
    coneq[5137]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))*c)-1/68640.
    coneq[5138]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c))))*c)-1/22880.
    coneq[5139]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/137280.
    coneq[5140]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/411840.
    coneq[5141]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/823680.
    coneq[5142]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/274560.
    coneq[5143]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/274560.
    coneq[5144]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/823680.
    coneq[5145]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/1647360.
    coneq[5146]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/549120.
    coneq[5147]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))*c)-1/114400.
    coneq[5148]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/457600.
    coneq[5149]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1372800.
    coneq[5150]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2745600.
    coneq[5151]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/915200.
    coneq[5152]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/343200.
    coneq[5153]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/686400.
    coneq[5154]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/228800.
    coneq[5155]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/457600.
    coneq[5156]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/102960.
    coneq[5157]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/205920.
    coneq[5158]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/411840.
    coneq[5159]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/91520.
    coneq[5160]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/274560.
    coneq[5161]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/549120.
    coneq[5162]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/183040.
    coneq[5163]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/68640.
    coneq[5164]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/137280.
    coneq[5165]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/45760.
    coneq[5166]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/137280.
    coneq[5167]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/274560.
    coneq[5168]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/91520.
    coneq[5169]=dot(b,dot(A,dot(A,c**2*dot(A,c**6)))*c)-1/10010.
    coneq[5170]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**5))))*c)-1/60060.
    coneq[5171]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))*c)-1/300300.
    coneq[5172]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1201200.
    coneq[5173]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/3603600.
    coneq[5174]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/7207200.
    coneq[5175]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2402400.
    coneq[5176]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/900900.
    coneq[5177]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1801800.
    coneq[5178]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/600600.
    coneq[5179]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1201200.
    coneq[5180]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/240240.
    coneq[5181]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/720720.
    coneq[5182]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1441440.
    coneq[5183]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/480480.
    coneq[5184]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/180180.
    coneq[5185]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/360360.
    coneq[5186]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/120120.
    coneq[5187]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/360360.
    coneq[5188]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/720720.
    coneq[5189]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/240240.
    coneq[5190]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4))))*c)-1/50050.
    coneq[5191]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/200200.
    coneq[5192]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/600600.
    coneq[5193]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1201200.
    coneq[5194]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/400400.
    coneq[5195]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/150150.
    coneq[5196]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/300300.
    coneq[5197]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/100100.
    coneq[5198]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/200200.
    coneq[5199]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3))))*c)-1/40040.
    coneq[5200]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/120120.
    coneq[5201]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/240240.
    coneq[5202]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/80080.
    coneq[5203]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2))))*c)-1/30030.
    coneq[5204]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/60060.
    coneq[5205]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c))))*c)-1/20020.
    coneq[5206]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/90090.
    coneq[5207]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/180180.
    coneq[5208]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/360360.
    coneq[5209]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/80080.
    coneq[5210]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/240240.
    coneq[5211]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/480480.
    coneq[5212]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/160160.
    coneq[5213]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/60060.
    coneq[5214]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/120120.
    coneq[5215]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/40040.
    coneq[5216]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/80080.
    coneq[5217]=dot(b,dot(A,dot(A,c**3*dot(A,c**5)))*c)-1/8580.
    coneq[5218]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**4))))*c)-1/42900.
    coneq[5219]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))*c)-1/171600.
    coneq[5220]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/514800.
    coneq[5221]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1029600.
    coneq[5222]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/343200.
    coneq[5223]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/128700.
    coneq[5224]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/257400.
    coneq[5225]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/85800.
    coneq[5226]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/171600.
    coneq[5227]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3))))*c)-1/34320.
    coneq[5228]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/102960.
    coneq[5229]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/205920.
    coneq[5230]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/68640.
    coneq[5231]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2))))*c)-1/25740.
    coneq[5232]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/51480.
    coneq[5233]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c))))*c)-1/17160.
    coneq[5234]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/51480.
    coneq[5235]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/102960.
    coneq[5236]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/34320.
    coneq[5237]=dot(b,dot(A,dot(A,c**4*dot(A,c**4)))*c)-1/7150.
    coneq[5238]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**3))))*c)-1/28600.
    coneq[5239]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))*c)-1/85800.
    coneq[5240]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/171600.
    coneq[5241]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))*c)-1/57200.
    coneq[5242]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2))))*c)-1/21450.
    coneq[5243]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))*c)-1/42900.
    coneq[5244]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c))))*c)-1/14300.
    coneq[5245]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))*c)-1/28600.
    coneq[5246]=dot(b,dot(A,dot(A,c**5*dot(A,c**3)))*c)-1/5720.
    coneq[5247]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**2))))*c)-1/17160.
    coneq[5248]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c)))))*c)-1/34320.
    coneq[5249]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c))))*c)-1/11440.
    coneq[5250]=dot(b,dot(A,dot(A,c**6*dot(A,c**2)))*c)-1/4290.
    coneq[5251]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c))))*c)-1/8580.
    coneq[5252]=dot(b,dot(A,dot(A,c**7*dot(A,c)))*c)-1/2860.
    coneq[5253]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**4)))*c)-1/28600.
    coneq[5254]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))*c)-1/114400.
    coneq[5255]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))*c)-1/343200.
    coneq[5256]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/686400.
    coneq[5257]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))*c)-1/228800.
    coneq[5258]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))*c)-1/85800.
    coneq[5259]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))*c)-1/171600.
    coneq[5260]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))*c)-1/57200.
    coneq[5261]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))*c)-1/114400.
    coneq[5262]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))*c)-1/85800.
    coneq[5263]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))*c)-1/343200.
    coneq[5264]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))*c)-1/1029600.
    coneq[5265]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2059200.
    coneq[5266]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))*c)-1/686400.
    coneq[5267]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))*c)-1/257400.
    coneq[5268]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))*c)-1/514800.
    coneq[5269]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))*c)-1/171600.
    coneq[5270]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))*c)-1/343200.
    coneq[5271]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))*c)-1/171600.
    coneq[5272]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))*c)-1/686400.
    coneq[5273]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))*c)-1/2059200.
    coneq[5274]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/4118400.
    coneq[5275]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))*c)-1/1372800.
    coneq[5276]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))*c)-1/514800.
    coneq[5277]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*c)-1/1029600.
    coneq[5278]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))*c)-1/343200.
    coneq[5279]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*c)-1/686400.
    coneq[5280]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))*c)-1/57200.
    coneq[5281]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))*c)-1/228800.
    coneq[5282]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/686400.
    coneq[5283]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1372800.
    coneq[5284]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/457600.
    coneq[5285]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/171600.
    coneq[5286]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/343200.
    coneq[5287]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/114400.
    coneq[5288]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/228800.
    coneq[5289]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**5)))*c)-1/25740.
    coneq[5290]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))*c)-1/128700.
    coneq[5291]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))*c)-1/514800.
    coneq[5292]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1544400.
    coneq[5293]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3088800.
    coneq[5294]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1029600.
    coneq[5295]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/386100.
    coneq[5296]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/772200.
    coneq[5297]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/257400.
    coneq[5298]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/514800.
    coneq[5299]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))*c)-1/102960.
    coneq[5300]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/308880.
    coneq[5301]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/617760.
    coneq[5302]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/205920.
    coneq[5303]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))*c)-1/77220.
    coneq[5304]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/154440.
    coneq[5305]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))*c)-1/51480.
    coneq[5306]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/154440.
    coneq[5307]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/308880.
    coneq[5308]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/102960.
    coneq[5309]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5)))*c)-1/51480.
    coneq[5310]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))*c)-1/257400.
    coneq[5311]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))*c)-1/1029600.
    coneq[5312]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/3088800.
    coneq[5313]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/6177600.
    coneq[5314]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/2059200.
    coneq[5315]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/772200.
    coneq[5316]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1544400.
    coneq[5317]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/514800.
    coneq[5318]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/1029600.
    coneq[5319]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))*c)-1/205920.
    coneq[5320]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/617760.
    coneq[5321]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1235520.
    coneq[5322]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/411840.
    coneq[5323]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))*c)-1/154440.
    coneq[5324]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/308880.
    coneq[5325]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))*c)-1/102960.
    coneq[5326]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/308880.
    coneq[5327]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/617760.
    coneq[5328]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/205920.
    coneq[5329]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**6)))*c)-1/20020.
    coneq[5330]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5))))*c)-1/120120.
    coneq[5331]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))*c)-1/600600.
    coneq[5332]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/2402400.
    coneq[5333]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/7207200.
    coneq[5334]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/14414400.
    coneq[5335]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/4804800.
    coneq[5336]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1801800.
    coneq[5337]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/3603600.
    coneq[5338]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1201200.
    coneq[5339]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/2402400.
    coneq[5340]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/480480.
    coneq[5341]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1441440.
    coneq[5342]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2882880.
    coneq[5343]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/960960.
    coneq[5344]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/360360.
    coneq[5345]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/720720.
    coneq[5346]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/240240.
    coneq[5347]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/720720.
    coneq[5348]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1441440.
    coneq[5349]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/480480.
    coneq[5350]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))*c)-1/100100.
    coneq[5351]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/400400.
    coneq[5352]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/1201200.
    coneq[5353]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2402400.
    coneq[5354]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/800800.
    coneq[5355]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/300300.
    coneq[5356]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/600600.
    coneq[5357]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/200200.
    coneq[5358]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/400400.
    coneq[5359]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))*c)-1/80080.
    coneq[5360]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/240240.
    coneq[5361]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/480480.
    coneq[5362]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/160160.
    coneq[5363]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))*c)-1/60060.
    coneq[5364]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/120120.
    coneq[5365]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))*c)-1/40040.
    coneq[5366]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/180180.
    coneq[5367]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/360360.
    coneq[5368]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/720720.
    coneq[5369]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/160160.
    coneq[5370]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/480480.
    coneq[5371]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/960960.
    coneq[5372]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/320320.
    coneq[5373]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/120120.
    coneq[5374]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/240240.
    coneq[5375]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/80080.
    coneq[5376]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/160160.
    coneq[5377]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3)))*c)-1/22880.
    coneq[5378]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/68640.
    coneq[5379]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/137280.
    coneq[5380]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/45760.
    coneq[5381]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/205920.
    coneq[5382]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/411840.
    coneq[5383]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/137280.
    coneq[5384]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/823680.
    coneq[5385]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/274560.
    coneq[5386]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/91520.
    coneq[5387]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4)))*c)-1/21450.
    coneq[5388]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/85800.
    coneq[5389]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/257400.
    coneq[5390]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/514800.
    coneq[5391]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/171600.
    coneq[5392]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/64350.
    coneq[5393]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/128700.
    coneq[5394]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/42900.
    coneq[5395]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/85800.
    coneq[5396]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))*c)-1/42900.
    coneq[5397]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/171600.
    coneq[5398]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/514800.
    coneq[5399]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1029600.
    coneq[5400]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/343200.
    coneq[5401]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/128700.
    coneq[5402]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/257400.
    coneq[5403]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/85800.
    coneq[5404]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/171600.
    coneq[5405]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**5)))*c)-1/17160.
    coneq[5406]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))*c)-1/85800.
    coneq[5407]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/343200.
    coneq[5408]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1029600.
    coneq[5409]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2059200.
    coneq[5410]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/686400.
    coneq[5411]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/257400.
    coneq[5412]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/514800.
    coneq[5413]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/171600.
    coneq[5414]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/343200.
    coneq[5415]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/68640.
    coneq[5416]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/205920.
    coneq[5417]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/411840.
    coneq[5418]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/137280.
    coneq[5419]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/51480.
    coneq[5420]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/102960.
    coneq[5421]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/34320.
    coneq[5422]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/102960.
    coneq[5423]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/205920.
    coneq[5424]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/68640.
    coneq[5425]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3)))*c)-1/17160.
    coneq[5426]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/51480.
    coneq[5427]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/102960.
    coneq[5428]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/34320.
    coneq[5429]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/34320.
    coneq[5430]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/102960.
    coneq[5431]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/205920.
    coneq[5432]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/68640.
    coneq[5433]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4)))*c)-1/14300.
    coneq[5434]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/57200.
    coneq[5435]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/171600.
    coneq[5436]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/343200.
    coneq[5437]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/114400.
    coneq[5438]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/42900.
    coneq[5439]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/85800.
    coneq[5440]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/28600.
    coneq[5441]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/57200.
    coneq[5442]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2)))*c)-1/12870.
    coneq[5443]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/25740.
    coneq[5444]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/51480.
    coneq[5445]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3)))*c)-1/11440.
    coneq[5446]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/34320.
    coneq[5447]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/68640.
    coneq[5448]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/22880.
    coneq[5449]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2)))*c)-1/8580.
    coneq[5450]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))*c)-1/17160.
    coneq[5451]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c)))*c)-1/5720.
    coneq[5452]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))*c)-1/28600.
    coneq[5453]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/114400.
    coneq[5454]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/343200.
    coneq[5455]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/686400.
    coneq[5456]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/228800.
    coneq[5457]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/85800.
    coneq[5458]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/171600.
    coneq[5459]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/57200.
    coneq[5460]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/114400.
    coneq[5461]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))*c)-1/34320.
    coneq[5462]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/102960.
    coneq[5463]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/205920.
    coneq[5464]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/68640.
    coneq[5465]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/68640.
    coneq[5466]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/205920.
    coneq[5467]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/411840.
    coneq[5468]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/137280.
    coneq[5469]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))*c)-1/38610.
    coneq[5470]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/77220.
    coneq[5471]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/154440.
    coneq[5472]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/308880.
    coneq[5473]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/22880.
    coneq[5474]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/68640.
    coneq[5475]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/137280.
    coneq[5476]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/45760.
    coneq[5477]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/25740.
    coneq[5478]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/51480.
    coneq[5479]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/102960.
    coneq[5480]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/17160.
    coneq[5481]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/34320.
    coneq[5482]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/11440.
    coneq[5483]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/34320.
    coneq[5484]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/68640.
    coneq[5485]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/22880.
    coneq[5486]=dot(b,dot(A,c*dot(A,c**8))*c)-1/1287.
    coneq[5487]=dot(b,dot(A,c*dot(A,dot(A,c**7)))*c)-1/10296.
    coneq[5488]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**6))))*c)-1/72072.
    coneq[5489]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5)))))*c)-1/432432.
    coneq[5490]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/2162160.
    coneq[5491]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/8648640.
    coneq[5492]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/25945920.
    coneq[5493]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/51891840.
    coneq[5494]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/17297280.
    coneq[5495]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/6486480.
    coneq[5496]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/12972960.
    coneq[5497]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/4324320.
    coneq[5498]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/8648640.
    coneq[5499]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/1729728.
    coneq[5500]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/5189184.
    coneq[5501]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/10378368.
    coneq[5502]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/3459456.
    coneq[5503]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1297296.
    coneq[5504]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/2594592.
    coneq[5505]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/864864.
    coneq[5506]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/2594592.
    coneq[5507]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/5189184.
    coneq[5508]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/1729728.
    coneq[5509]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c)-1/360360.
    coneq[5510]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/1441440.
    coneq[5511]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/4324320.
    coneq[5512]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/8648640.
    coneq[5513]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/2882880.
    coneq[5514]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1081080.
    coneq[5515]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/2162160.
    coneq[5516]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/720720.
    coneq[5517]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/1441440.
    coneq[5518]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/288288.
    coneq[5519]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/864864.
    coneq[5520]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/1729728.
    coneq[5521]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/576576.
    coneq[5522]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/216216.
    coneq[5523]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/432432.
    coneq[5524]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c)-1/144144.
    coneq[5525]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/648648.
    coneq[5526]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1297296.
    coneq[5527]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/2594592.
    coneq[5528]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/576576.
    coneq[5529]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/1729728.
    coneq[5530]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/3459456.
    coneq[5531]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1153152.
    coneq[5532]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/432432.
    coneq[5533]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/864864.
    coneq[5534]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/288288.
    coneq[5535]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/576576.
    coneq[5536]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**5))))*c)-1/61776.
    coneq[5537]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c)-1/308880.
    coneq[5538]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/1235520.
    coneq[5539]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/3706560.
    coneq[5540]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/7413120.
    coneq[5541]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2471040.
    coneq[5542]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/926640.
    coneq[5543]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1853280.
    coneq[5544]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/617760.
    coneq[5545]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1235520.
    coneq[5546]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/247104.
    coneq[5547]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/741312.
    coneq[5548]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1482624.
    coneq[5549]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/494208.
    coneq[5550]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/185328.
    coneq[5551]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/370656.
    coneq[5552]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/123552.
    coneq[5553]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/370656.
    coneq[5554]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/741312.
    coneq[5555]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/247104.
    coneq[5556]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4))))*c)-1/51480.
    coneq[5557]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/205920.
    coneq[5558]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/617760.
    coneq[5559]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1235520.
    coneq[5560]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/411840.
    coneq[5561]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/154440.
    coneq[5562]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/308880.
    coneq[5563]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/102960.
    coneq[5564]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/205920.
    coneq[5565]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3))))*c)-1/41184.
    coneq[5566]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/123552.
    coneq[5567]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/247104.
    coneq[5568]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/82368.
    coneq[5569]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2))))*c)-1/30888.
    coneq[5570]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c)-1/61776.
    coneq[5571]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c))))*c)-1/20592.
    coneq[5572]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/123552.
    coneq[5573]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/370656.
    coneq[5574]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/741312.
    coneq[5575]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/247104.
    coneq[5576]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/247104.
    coneq[5577]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/741312.
    coneq[5578]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/1482624.
    coneq[5579]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/494208.
    coneq[5580]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c)-1/102960.
    coneq[5581]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/411840.
    coneq[5582]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1235520.
    coneq[5583]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2471040.
    coneq[5584]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/823680.
    coneq[5585]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/308880.
    coneq[5586]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/617760.
    coneq[5587]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/205920.
    coneq[5588]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/411840.
    coneq[5589]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/92664.
    coneq[5590]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/185328.
    coneq[5591]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/370656.
    coneq[5592]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/82368.
    coneq[5593]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/247104.
    coneq[5594]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/494208.
    coneq[5595]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/164736.
    coneq[5596]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/61776.
    coneq[5597]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/123552.
    coneq[5598]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/41184.
    coneq[5599]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/123552.
    coneq[5600]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/247104.
    coneq[5601]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/82368.
    coneq[5602]=dot(b,dot(A,c*dot(A,c*dot(A,c**6)))*c)-1/9009.
    coneq[5603]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**5))))*c)-1/54054.
    coneq[5604]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c)-1/270270.
    coneq[5605]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1081080.
    coneq[5606]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/3243240.
    coneq[5607]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/6486480.
    coneq[5608]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2162160.
    coneq[5609]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/810810.
    coneq[5610]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1621620.
    coneq[5611]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/540540.
    coneq[5612]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1081080.
    coneq[5613]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/216216.
    coneq[5614]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/648648.
    coneq[5615]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1297296.
    coneq[5616]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/432432.
    coneq[5617]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/162162.
    coneq[5618]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/324324.
    coneq[5619]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/108108.
    coneq[5620]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/324324.
    coneq[5621]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/648648.
    coneq[5622]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/216216.
    coneq[5623]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4))))*c)-1/45045.
    coneq[5624]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/180180.
    coneq[5625]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/540540.
    coneq[5626]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1081080.
    coneq[5627]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/360360.
    coneq[5628]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/135135.
    coneq[5629]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/270270.
    coneq[5630]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/90090.
    coneq[5631]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/180180.
    coneq[5632]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3))))*c)-1/36036.
    coneq[5633]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/108108.
    coneq[5634]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/216216.
    coneq[5635]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/72072.
    coneq[5636]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2))))*c)-1/27027.
    coneq[5637]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/54054.
    coneq[5638]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c))))*c)-1/18018.
    coneq[5639]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/81081.
    coneq[5640]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/162162.
    coneq[5641]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/324324.
    coneq[5642]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/72072.
    coneq[5643]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/216216.
    coneq[5644]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/432432.
    coneq[5645]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/144144.
    coneq[5646]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/54054.
    coneq[5647]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/108108.
    coneq[5648]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/36036.
    coneq[5649]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/72072.
    coneq[5650]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**5)))*c)-1/7722.
    coneq[5651]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4))))*c)-1/38610.
    coneq[5652]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c)-1/154440.
    coneq[5653]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/463320.
    coneq[5654]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/926640.
    coneq[5655]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/308880.
    coneq[5656]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/115830.
    coneq[5657]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/231660.
    coneq[5658]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/77220.
    coneq[5659]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/154440.
    coneq[5660]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3))))*c)-1/30888.
    coneq[5661]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/92664.
    coneq[5662]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/185328.
    coneq[5663]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/61776.
    coneq[5664]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c)-1/23166.
    coneq[5665]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/46332.
    coneq[5666]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c))))*c)-1/15444.
    coneq[5667]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/46332.
    coneq[5668]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/92664.
    coneq[5669]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/30888.
    coneq[5670]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**4)))*c)-1/6435.
    coneq[5671]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3))))*c)-1/25740.
    coneq[5672]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c)-1/77220.
    coneq[5673]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/154440.
    coneq[5674]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c)-1/51480.
    coneq[5675]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2))))*c)-1/19305.
    coneq[5676]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c)-1/38610.
    coneq[5677]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c))))*c)-1/12870.
    coneq[5678]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c)-1/25740.
    coneq[5679]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**3)))*c)-1/5148.
    coneq[5680]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2))))*c)-1/15444.
    coneq[5681]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c)-1/30888.
    coneq[5682]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c))))*c)-1/10296.
    coneq[5683]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**2)))*c)-1/3861.
    coneq[5684]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c))))*c)-1/7722.
    coneq[5685]=dot(b,dot(A,c*dot(A,c**6*dot(A,c)))*c)-1/2574.
    coneq[5686]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3)))*c)-1/20592.
    coneq[5687]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/61776.
    coneq[5688]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/123552.
    coneq[5689]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/41184.
    coneq[5690]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/185328.
    coneq[5691]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/370656.
    coneq[5692]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/123552.
    coneq[5693]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/741312.
    coneq[5694]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/247104.
    coneq[5695]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/82368.
    coneq[5696]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4)))*c)-1/19305.
    coneq[5697]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/77220.
    coneq[5698]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/231660.
    coneq[5699]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/463320.
    coneq[5700]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/154440.
    coneq[5701]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/57915.
    coneq[5702]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/115830.
    coneq[5703]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/38610.
    coneq[5704]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/77220.
    coneq[5705]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c)-1/38610.
    coneq[5706]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/154440.
    coneq[5707]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/463320.
    coneq[5708]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/926640.
    coneq[5709]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/308880.
    coneq[5710]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/115830.
    coneq[5711]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/231660.
    coneq[5712]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/77220.
    coneq[5713]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/154440.
    coneq[5714]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**5)))*c)-1/15444.
    coneq[5715]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c)-1/77220.
    coneq[5716]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/308880.
    coneq[5717]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/926640.
    coneq[5718]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1853280.
    coneq[5719]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/617760.
    coneq[5720]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/231660.
    coneq[5721]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/463320.
    coneq[5722]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/154440.
    coneq[5723]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/308880.
    coneq[5724]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/61776.
    coneq[5725]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/185328.
    coneq[5726]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/370656.
    coneq[5727]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/123552.
    coneq[5728]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/46332.
    coneq[5729]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/92664.
    coneq[5730]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/30888.
    coneq[5731]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/92664.
    coneq[5732]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/185328.
    coneq[5733]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/61776.
    coneq[5734]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3)))*c)-1/15444.
    coneq[5735]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/46332.
    coneq[5736]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/92664.
    coneq[5737]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/30888.
    coneq[5738]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/30888.
    coneq[5739]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/92664.
    coneq[5740]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/185328.
    coneq[5741]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/61776.
    coneq[5742]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4)))*c)-1/12870.
    coneq[5743]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/51480.
    coneq[5744]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/154440.
    coneq[5745]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/308880.
    coneq[5746]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/102960.
    coneq[5747]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/38610.
    coneq[5748]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/77220.
    coneq[5749]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/25740.
    coneq[5750]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/51480.
    coneq[5751]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c)-1/11583.
    coneq[5752]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/23166.
    coneq[5753]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/46332.
    coneq[5754]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3)))*c)-1/10296.
    coneq[5755]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/30888.
    coneq[5756]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/61776.
    coneq[5757]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/20592.
    coneq[5758]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2)))*c)-1/7722.
    coneq[5759]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c)-1/15444.
    coneq[5760]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c)))*c)-1/5148.
    coneq[5761]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/20592.
    coneq[5762]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/61776.
    coneq[5763]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/123552.
    coneq[5764]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/41184.
    coneq[5765]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/23166.
    coneq[5766]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/46332.
    coneq[5767]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/92664.
    coneq[5768]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/15444.
    coneq[5769]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/30888.
    coneq[5770]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/10296.
    coneq[5771]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/20592.
    coneq[5772]=dot(b,dot(A,c**2*dot(A,c**7))*c)-1/1144.
    coneq[5773]=dot(b,dot(A,c**2*dot(A,dot(A,c**6)))*c)-1/8008.
    coneq[5774]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**5))))*c)-1/48048.
    coneq[5775]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/240240.
    coneq[5776]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/960960.
    coneq[5777]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/2882880.
    coneq[5778]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/5765760.
    coneq[5779]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/1921920.
    coneq[5780]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/720720.
    coneq[5781]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1441440.
    coneq[5782]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/480480.
    coneq[5783]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/960960.
    coneq[5784]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/192192.
    coneq[5785]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/576576.
    coneq[5786]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1153152.
    coneq[5787]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/384384.
    coneq[5788]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/144144.
    coneq[5789]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/288288.
    coneq[5790]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/96096.
    coneq[5791]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/288288.
    coneq[5792]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/576576.
    coneq[5793]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/192192.
    coneq[5794]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4))))*c)-1/40040.
    coneq[5795]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/160160.
    coneq[5796]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/480480.
    coneq[5797]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/960960.
    coneq[5798]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/320320.
    coneq[5799]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/120120.
    coneq[5800]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/240240.
    coneq[5801]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/80080.
    coneq[5802]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/160160.
    coneq[5803]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/32032.
    coneq[5804]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/96096.
    coneq[5805]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/192192.
    coneq[5806]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/64064.
    coneq[5807]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/24024.
    coneq[5808]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/48048.
    coneq[5809]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c))))*c)-1/16016.
    coneq[5810]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/72072.
    coneq[5811]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/144144.
    coneq[5812]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/288288.
    coneq[5813]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/64064.
    coneq[5814]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/192192.
    coneq[5815]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/384384.
    coneq[5816]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/128128.
    coneq[5817]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/48048.
    coneq[5818]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/96096.
    coneq[5819]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/32032.
    coneq[5820]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/64064.
    coneq[5821]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**5)))*c)-1/6864.
    coneq[5822]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4))))*c)-1/34320.
    coneq[5823]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/137280.
    coneq[5824]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/411840.
    coneq[5825]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/823680.
    coneq[5826]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/274560.
    coneq[5827]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/102960.
    coneq[5828]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/205920.
    coneq[5829]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/68640.
    coneq[5830]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/137280.
    coneq[5831]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/27456.
    coneq[5832]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/82368.
    coneq[5833]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/164736.
    coneq[5834]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/54912.
    coneq[5835]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/20592.
    coneq[5836]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/41184.
    coneq[5837]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/13728.
    coneq[5838]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/41184.
    coneq[5839]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/82368.
    coneq[5840]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/27456.
    coneq[5841]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**4)))*c)-1/5720.
    coneq[5842]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/22880.
    coneq[5843]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/68640.
    coneq[5844]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/137280.
    coneq[5845]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/45760.
    coneq[5846]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/17160.
    coneq[5847]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/34320.
    coneq[5848]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/11440.
    coneq[5849]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/22880.
    coneq[5850]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**3)))*c)-1/4576.
    coneq[5851]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/13728.
    coneq[5852]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/27456.
    coneq[5853]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/9152.
    coneq[5854]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**2)))*c)-1/3432.
    coneq[5855]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c))))*c)-1/6864.
    coneq[5856]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c)))*c)-1/2288.
    coneq[5857]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/13728.
    coneq[5858]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/41184.
    coneq[5859]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/82368.
    coneq[5860]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/27456.
    coneq[5861]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/27456.
    coneq[5862]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/82368.
    coneq[5863]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/164736.
    coneq[5864]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/54912.
    coneq[5865]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/11440.
    coneq[5866]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/45760.
    coneq[5867]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/137280.
    coneq[5868]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/274560.
    coneq[5869]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/91520.
    coneq[5870]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/34320.
    coneq[5871]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/68640.
    coneq[5872]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/22880.
    coneq[5873]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/45760.
    coneq[5874]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/10296.
    coneq[5875]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/20592.
    coneq[5876]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/41184.
    coneq[5877]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/9152.
    coneq[5878]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/27456.
    coneq[5879]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/54912.
    coneq[5880]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/18304.
    coneq[5881]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/6864.
    coneq[5882]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/13728.
    coneq[5883]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/4576.
    coneq[5884]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/13728.
    coneq[5885]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/27456.
    coneq[5886]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/9152.
    coneq[5887]=dot(b,dot(A,c**3*dot(A,c**6))*c)-1/1001.
    coneq[5888]=dot(b,dot(A,c**3*dot(A,dot(A,c**5)))*c)-1/6006.
    coneq[5889]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**4))))*c)-1/30030.
    coneq[5890]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/120120.
    coneq[5891]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/360360.
    coneq[5892]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/720720.
    coneq[5893]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/240240.
    coneq[5894]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/90090.
    coneq[5895]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/180180.
    coneq[5896]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/60060.
    coneq[5897]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/120120.
    coneq[5898]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3))))*c)-1/24024.
    coneq[5899]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/72072.
    coneq[5900]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/144144.
    coneq[5901]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/48048.
    coneq[5902]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/18018.
    coneq[5903]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/36036.
    coneq[5904]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c))))*c)-1/12012.
    coneq[5905]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/36036.
    coneq[5906]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/72072.
    coneq[5907]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/24024.
    coneq[5908]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**4)))*c)-1/5005.
    coneq[5909]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3))))*c)-1/20020.
    coneq[5910]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/60060.
    coneq[5911]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/120120.
    coneq[5912]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/40040.
    coneq[5913]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/15015.
    coneq[5914]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/30030.
    coneq[5915]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/10010.
    coneq[5916]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/20020.
    coneq[5917]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**3)))*c)-1/4004.
    coneq[5918]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/12012.
    coneq[5919]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/24024.
    coneq[5920]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/8008.
    coneq[5921]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**2)))*c)-1/3003.
    coneq[5922]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c))))*c)-1/6006.
    coneq[5923]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c)))*c)-1/2002.
    coneq[5924]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/9009.
    coneq[5925]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/18018.
    coneq[5926]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/36036.
    coneq[5927]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/8008.
    coneq[5928]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/24024.
    coneq[5929]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/48048.
    coneq[5930]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/16016.
    coneq[5931]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/6006.
    coneq[5932]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/12012.
    coneq[5933]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/4004.
    coneq[5934]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/8008.
    coneq[5935]=dot(b,dot(A,c**4*dot(A,c**5))*c)-1/858.
    coneq[5936]=dot(b,dot(A,c**4*dot(A,dot(A,c**4)))*c)-1/4290.
    coneq[5937]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**3))))*c)-1/17160.
    coneq[5938]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/51480.
    coneq[5939]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/102960.
    coneq[5940]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/34320.
    coneq[5941]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2))))*c)-1/12870.
    coneq[5942]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/25740.
    coneq[5943]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c))))*c)-1/8580.
    coneq[5944]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/17160.
    coneq[5945]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**3)))*c)-1/3432.
    coneq[5946]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2))))*c)-1/10296.
    coneq[5947]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/20592.
    coneq[5948]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c))))*c)-1/6864.
    coneq[5949]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**2)))*c)-1/2574.
    coneq[5950]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c))))*c)-1/5148.
    coneq[5951]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c)))*c)-1/1716.
    coneq[5952]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/5148.
    coneq[5953]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/10296.
    coneq[5954]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/3432.
    coneq[5955]=dot(b,dot(A,c**5*dot(A,c**4))*c)-1/715.
    coneq[5956]=dot(b,dot(A,c**5*dot(A,dot(A,c**3)))*c)-1/2860.
    coneq[5957]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**2))))*c)-1/8580.
    coneq[5958]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/17160.
    coneq[5959]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c))))*c)-1/5720.
    coneq[5960]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**2)))*c)-1/2145.
    coneq[5961]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c))))*c)-1/4290.
    coneq[5962]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c)))*c)-1/1430.
    coneq[5963]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c)))*c)-1/2860.
    coneq[5964]=dot(b,dot(A,c**6*dot(A,c**3))*c)-1/572.
    coneq[5965]=dot(b,dot(A,c**6*dot(A,dot(A,c**2)))*c)-1/1716.
    coneq[5966]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c))))*c)-1/3432.
    coneq[5967]=dot(b,dot(A,c**6*dot(A,c*dot(A,c)))*c)-1/1144.
    coneq[5968]=dot(b,dot(A,c**7*dot(A,c**2))*c)-1/429.
    coneq[5969]=dot(b,dot(A,c**7*dot(A,dot(A,c)))*c)-1/858.
    coneq[5970]=dot(b,dot(A,c**8*dot(A,c))*c)-1/286.
    coneq[5971]=dot(b,dot(A,dot(A,c**4)*dot(A,c**4))*c)-1/3575.
    coneq[5972]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**3)))*c)-1/14300.
    coneq[5973]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))*c)-1/42900.
    coneq[5974]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/85800.
    coneq[5975]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))*c)-1/28600.
    coneq[5976]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2)))*c)-1/10725.
    coneq[5977]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))*c)-1/21450.
    coneq[5978]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c)))*c)-1/7150.
    coneq[5979]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))*c)-1/14300.
    coneq[5980]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))*c)-1/57200.
    coneq[5981]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))*c)-1/171600.
    coneq[5982]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/343200.
    coneq[5983]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))*c)-1/114400.
    coneq[5984]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))*c)-1/42900.
    coneq[5985]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))*c)-1/85800.
    coneq[5986]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))*c)-1/28600.
    coneq[5987]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))*c)-1/57200.
    coneq[5988]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))*c)-1/514800.
    coneq[5989]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/1029600.
    coneq[5990]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))*c)-1/343200.
    coneq[5991]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))*c)-1/128700.
    coneq[5992]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))*c)-1/257400.
    coneq[5993]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))*c)-1/85800.
    coneq[5994]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/171600.
    coneq[5995]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/2059200.
    coneq[5996]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))*c)-1/686400.
    coneq[5997]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))*c)-1/257400.
    coneq[5998]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))*c)-1/514800.
    coneq[5999]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))*c)-1/171600.
    coneq[6000]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))*c)-1/343200.
    coneq[6001]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c)-1/228800.
    coneq[6002]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))*c)-1/85800.
    coneq[6003]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/171600.
    coneq[6004]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/57200.
    coneq[6005]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/114400.
    coneq[6006]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))*c)-1/32175.
    coneq[6007]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c)-1/64350.
    coneq[6008]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))*c)-1/21450.
    coneq[6009]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c)-1/42900.
    coneq[6010]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/128700.
    coneq[6011]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/42900.
    coneq[6012]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/85800.
    coneq[6013]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/14300.
    coneq[6014]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/28600.
    coneq[6015]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/57200.
    coneq[6016]=dot(b,dot(A,dot(A,c**3)*dot(A,c**5))*c)-1/3432.
    coneq[6017]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**4)))*c)-1/17160.
    coneq[6018]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))*c)-1/68640.
    coneq[6019]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/205920.
    coneq[6020]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/411840.
    coneq[6021]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/137280.
    coneq[6022]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/51480.
    coneq[6023]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/102960.
    coneq[6024]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/34320.
    coneq[6025]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/68640.
    coneq[6026]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3)))*c)-1/13728.
    coneq[6027]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/41184.
    coneq[6028]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/82368.
    coneq[6029]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/27456.
    coneq[6030]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2)))*c)-1/10296.
    coneq[6031]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/20592.
    coneq[6032]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c)))*c)-1/6864.
    coneq[6033]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/20592.
    coneq[6034]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/41184.
    coneq[6035]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/13728.
    coneq[6036]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**5))*c)-1/10296.
    coneq[6037]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))*c)-1/51480.
    coneq[6038]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))*c)-1/205920.
    coneq[6039]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/617760.
    coneq[6040]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1235520.
    coneq[6041]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/411840.
    coneq[6042]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/154440.
    coneq[6043]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/308880.
    coneq[6044]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/102960.
    coneq[6045]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/205920.
    coneq[6046]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))*c)-1/41184.
    coneq[6047]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/123552.
    coneq[6048]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/247104.
    coneq[6049]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/82368.
    coneq[6050]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))*c)-1/30888.
    coneq[6051]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/61776.
    coneq[6052]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))*c)-1/20592.
    coneq[6053]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/61776.
    coneq[6054]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/123552.
    coneq[6055]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/41184.
    coneq[6056]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5))*c)-1/20592.
    coneq[6057]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))*c)-1/102960.
    coneq[6058]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))*c)-1/411840.
    coneq[6059]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/1235520.
    coneq[6060]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2471040.
    coneq[6061]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/823680.
    coneq[6062]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/308880.
    coneq[6063]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/617760.
    coneq[6064]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/205920.
    coneq[6065]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/411840.
    coneq[6066]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))*c)-1/82368.
    coneq[6067]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/247104.
    coneq[6068]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/494208.
    coneq[6069]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/164736.
    coneq[6070]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))*c)-1/61776.
    coneq[6071]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/123552.
    coneq[6072]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))*c)-1/41184.
    coneq[6073]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/123552.
    coneq[6074]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/247104.
    coneq[6075]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/82368.
    coneq[6076]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**5))*c)-1/6864.
    coneq[6077]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))*c)-1/34320.
    coneq[6078]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/137280.
    coneq[6079]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/411840.
    coneq[6080]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/823680.
    coneq[6081]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/274560.
    coneq[6082]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/102960.
    coneq[6083]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/205920.
    coneq[6084]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/68640.
    coneq[6085]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/137280.
    coneq[6086]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/27456.
    coneq[6087]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/82368.
    coneq[6088]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/164736.
    coneq[6089]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/54912.
    coneq[6090]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/20592.
    coneq[6091]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/41184.
    coneq[6092]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/13728.
    coneq[6093]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/41184.
    coneq[6094]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/82368.
    coneq[6095]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/27456.
    coneq[6096]=dot(b,dot(A,dot(A,c**2)*dot(A,c**6))*c)-1/3003.
    coneq[6097]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**5)))*c)-1/18018.
    coneq[6098]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))*c)-1/90090.
    coneq[6099]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/360360.
    coneq[6100]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1081080.
    coneq[6101]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2162160.
    coneq[6102]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/720720.
    coneq[6103]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/270270.
    coneq[6104]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/540540.
    coneq[6105]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/180180.
    coneq[6106]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/360360.
    coneq[6107]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/72072.
    coneq[6108]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/216216.
    coneq[6109]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/432432.
    coneq[6110]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/144144.
    coneq[6111]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/54054.
    coneq[6112]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/108108.
    coneq[6113]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/36036.
    coneq[6114]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/108108.
    coneq[6115]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/216216.
    coneq[6116]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/72072.
    coneq[6117]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4)))*c)-1/15015.
    coneq[6118]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/60060.
    coneq[6119]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/180180.
    coneq[6120]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/360360.
    coneq[6121]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/120120.
    coneq[6122]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/45045.
    coneq[6123]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/90090.
    coneq[6124]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/30030.
    coneq[6125]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/60060.
    coneq[6126]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3)))*c)-1/12012.
    coneq[6127]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/36036.
    coneq[6128]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/72072.
    coneq[6129]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/24024.
    coneq[6130]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2)))*c)-1/9009.
    coneq[6131]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/18018.
    coneq[6132]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c)))*c)-1/6006.
    coneq[6133]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/27027.
    coneq[6134]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/54054.
    coneq[6135]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/108108.
    coneq[6136]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/24024.
    coneq[6137]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/72072.
    coneq[6138]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/144144.
    coneq[6139]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/48048.
    coneq[6140]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/18018.
    coneq[6141]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/36036.
    coneq[6142]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/12012.
    coneq[6143]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/24024.
    coneq[6144]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**6))*c)-1/6006.
    coneq[6145]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5)))*c)-1/36036.
    coneq[6146]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))*c)-1/180180.
    coneq[6147]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/720720.
    coneq[6148]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/2162160.
    coneq[6149]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/4324320.
    coneq[6150]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1441440.
    coneq[6151]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/540540.
    coneq[6152]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1081080.
    coneq[6153]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/360360.
    coneq[6154]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/720720.
    coneq[6155]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))*c)-1/144144.
    coneq[6156]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/432432.
    coneq[6157]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/864864.
    coneq[6158]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/288288.
    coneq[6159]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/108108.
    coneq[6160]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/216216.
    coneq[6161]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))*c)-1/72072.
    coneq[6162]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/216216.
    coneq[6163]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/432432.
    coneq[6164]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/144144.
    coneq[6165]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))*c)-1/30030.
    coneq[6166]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))*c)-1/120120.
    coneq[6167]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/360360.
    coneq[6168]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/720720.
    coneq[6169]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/240240.
    coneq[6170]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/90090.
    coneq[6171]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/180180.
    coneq[6172]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/60060.
    coneq[6173]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/120120.
    coneq[6174]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))*c)-1/24024.
    coneq[6175]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/72072.
    coneq[6176]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/144144.
    coneq[6177]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/48048.
    coneq[6178]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))*c)-1/18018.
    coneq[6179]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))*c)-1/36036.
    coneq[6180]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))*c)-1/12012.
    coneq[6181]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/54054.
    coneq[6182]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/108108.
    coneq[6183]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/216216.
    coneq[6184]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/48048.
    coneq[6185]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/144144.
    coneq[6186]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/288288.
    coneq[6187]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/96096.
    coneq[6188]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/36036.
    coneq[6189]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/72072.
    coneq[6190]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/24024.
    coneq[6191]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/48048.
    coneq[6192]=dot(b,dot(A,dot(A,c)*dot(A,c**7))*c)-1/2288.
    coneq[6193]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**6)))*c)-1/16016.
    coneq[6194]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5))))*c)-1/96096.
    coneq[6195]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/480480.
    coneq[6196]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1921920.
    coneq[6197]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/5765760.
    coneq[6198]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/11531520.
    coneq[6199]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3843840.
    coneq[6200]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1441440.
    coneq[6201]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2882880.
    coneq[6202]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/960960.
    coneq[6203]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1921920.
    coneq[6204]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/384384.
    coneq[6205]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1153152.
    coneq[6206]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2306304.
    coneq[6207]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/768768.
    coneq[6208]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/288288.
    coneq[6209]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/576576.
    coneq[6210]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/192192.
    coneq[6211]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/576576.
    coneq[6212]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1153152.
    coneq[6213]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/384384.
    coneq[6214]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))*c)-1/80080.
    coneq[6215]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/320320.
    coneq[6216]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/960960.
    coneq[6217]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1921920.
    coneq[6218]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/640640.
    coneq[6219]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/240240.
    coneq[6220]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/480480.
    coneq[6221]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/160160.
    coneq[6222]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/320320.
    coneq[6223]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/64064.
    coneq[6224]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/192192.
    coneq[6225]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/384384.
    coneq[6226]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/128128.
    coneq[6227]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/48048.
    coneq[6228]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/96096.
    coneq[6229]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))*c)-1/32032.
    coneq[6230]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/144144.
    coneq[6231]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/288288.
    coneq[6232]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/576576.
    coneq[6233]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/128128.
    coneq[6234]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/384384.
    coneq[6235]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/768768.
    coneq[6236]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/256256.
    coneq[6237]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/96096.
    coneq[6238]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/192192.
    coneq[6239]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/64064.
    coneq[6240]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/128128.
    coneq[6241]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**5)))*c)-1/13728.
    coneq[6242]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))*c)-1/68640.
    coneq[6243]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/274560.
    coneq[6244]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/823680.
    coneq[6245]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1647360.
    coneq[6246]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/549120.
    coneq[6247]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/205920.
    coneq[6248]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/411840.
    coneq[6249]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/137280.
    coneq[6250]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/274560.
    coneq[6251]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/54912.
    coneq[6252]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/164736.
    coneq[6253]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/329472.
    coneq[6254]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/109824.
    coneq[6255]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/41184.
    coneq[6256]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/82368.
    coneq[6257]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/27456.
    coneq[6258]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/82368.
    coneq[6259]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/164736.
    coneq[6260]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/54912.
    coneq[6261]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4)))*c)-1/11440.
    coneq[6262]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/45760.
    coneq[6263]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/137280.
    coneq[6264]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/274560.
    coneq[6265]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/91520.
    coneq[6266]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/34320.
    coneq[6267]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/68640.
    coneq[6268]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/22880.
    coneq[6269]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/45760.
    coneq[6270]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3)))*c)-1/9152.
    coneq[6271]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/27456.
    coneq[6272]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/54912.
    coneq[6273]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/18304.
    coneq[6274]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2)))*c)-1/6864.
    coneq[6275]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))*c)-1/13728.
    coneq[6276]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c)))*c)-1/4576.
    coneq[6277]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/27456.
    coneq[6278]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/82368.
    coneq[6279]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/164736.
    coneq[6280]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/54912.
    coneq[6281]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/54912.
    coneq[6282]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/164736.
    coneq[6283]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/329472.
    coneq[6284]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/109824.
    coneq[6285]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/22880.
    coneq[6286]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/91520.
    coneq[6287]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/274560.
    coneq[6288]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/549120.
    coneq[6289]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/183040.
    coneq[6290]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/68640.
    coneq[6291]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/137280.
    coneq[6292]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/45760.
    coneq[6293]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/91520.
    coneq[6294]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/20592.
    coneq[6295]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/41184.
    coneq[6296]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/82368.
    coneq[6297]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/18304.
    coneq[6298]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/54912.
    coneq[6299]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/109824.
    coneq[6300]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/36608.
    coneq[6301]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/13728.
    coneq[6302]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/27456.
    coneq[6303]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/9152.
    coneq[6304]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/27456.
    coneq[6305]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/54912.
    coneq[6306]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/18304.
    coneq[6307]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**4))*c)-1/2860.
    coneq[6308]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3)))*c)-1/11440.
    coneq[6309]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c)-1/34320.
    coneq[6310]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/68640.
    coneq[6311]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c)-1/22880.
    coneq[6312]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2)))*c)-1/8580.
    coneq[6313]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c)-1/17160.
    coneq[6314]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c)))*c)-1/5720.
    coneq[6315]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c)-1/11440.
    coneq[6316]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4))*c)-1/8580.
    coneq[6317]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c)-1/34320.
    coneq[6318]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c)-1/102960.
    coneq[6319]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/205920.
    coneq[6320]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c)-1/68640.
    coneq[6321]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c)-1/25740.
    coneq[6322]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c)-1/51480.
    coneq[6323]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c)-1/17160.
    coneq[6324]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c)-1/34320.
    coneq[6325]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c)-1/17160.
    coneq[6326]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c)-1/68640.
    coneq[6327]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c)-1/205920.
    coneq[6328]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/411840.
    coneq[6329]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c)-1/137280.
    coneq[6330]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c)-1/51480.
    coneq[6331]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/102960.
    coneq[6332]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/34320.
    coneq[6333]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/68640.
    coneq[6334]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4))*c)-1/5720.
    coneq[6335]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c)-1/22880.
    coneq[6336]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/68640.
    coneq[6337]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/137280.
    coneq[6338]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/45760.
    coneq[6339]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/17160.
    coneq[6340]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/34320.
    coneq[6341]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/11440.
    coneq[6342]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/22880.
    coneq[6343]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**5))*c)-1/2574.
    coneq[6344]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4)))*c)-1/12870.
    coneq[6345]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c)-1/51480.
    coneq[6346]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/154440.
    coneq[6347]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/308880.
    coneq[6348]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/102960.
    coneq[6349]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/38610.
    coneq[6350]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/77220.
    coneq[6351]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/25740.
    coneq[6352]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/51480.
    coneq[6353]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3)))*c)-1/10296.
    coneq[6354]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/30888.
    coneq[6355]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/61776.
    coneq[6356]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/20592.
    coneq[6357]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c)-1/7722.
    coneq[6358]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/15444.
    coneq[6359]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c)))*c)-1/5148.
    coneq[6360]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/15444.
    coneq[6361]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/30888.
    coneq[6362]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/10296.
    coneq[6363]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**5))*c)-1/5148.
    coneq[6364]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c)-1/25740.
    coneq[6365]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/102960.
    coneq[6366]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/308880.
    coneq[6367]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/617760.
    coneq[6368]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/205920.
    coneq[6369]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/77220.
    coneq[6370]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/154440.
    coneq[6371]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/51480.
    coneq[6372]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/102960.
    coneq[6373]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/20592.
    coneq[6374]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/61776.
    coneq[6375]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/123552.
    coneq[6376]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/41184.
    coneq[6377]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/15444.
    coneq[6378]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/30888.
    coneq[6379]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/10296.
    coneq[6380]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/30888.
    coneq[6381]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/61776.
    coneq[6382]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/20592.
    coneq[6383]=dot(b,dot(A,c*dot(A,c)*dot(A,c**6))*c)-1/2002.
    coneq[6384]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**5)))*c)-1/12012.
    coneq[6385]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c)-1/60060.
    coneq[6386]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/240240.
    coneq[6387]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/720720.
    coneq[6388]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1441440.
    coneq[6389]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/480480.
    coneq[6390]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/180180.
    coneq[6391]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/360360.
    coneq[6392]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/120120.
    coneq[6393]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/240240.
    coneq[6394]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/48048.
    coneq[6395]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/144144.
    coneq[6396]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/288288.
    coneq[6397]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/96096.
    coneq[6398]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/36036.
    coneq[6399]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/72072.
    coneq[6400]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/24024.
    coneq[6401]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/72072.
    coneq[6402]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/144144.
    coneq[6403]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/48048.
    coneq[6404]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4)))*c)-1/10010.
    coneq[6405]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/40040.
    coneq[6406]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/120120.
    coneq[6407]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/240240.
    coneq[6408]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/80080.
    coneq[6409]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/30030.
    coneq[6410]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/60060.
    coneq[6411]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/20020.
    coneq[6412]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/40040.
    coneq[6413]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3)))*c)-1/8008.
    coneq[6414]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/24024.
    coneq[6415]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/48048.
    coneq[6416]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/16016.
    coneq[6417]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2)))*c)-1/6006.
    coneq[6418]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/12012.
    coneq[6419]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c)))*c)-1/4004.
    coneq[6420]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/18018.
    coneq[6421]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/36036.
    coneq[6422]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/72072.
    coneq[6423]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/16016.
    coneq[6424]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/48048.
    coneq[6425]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/96096.
    coneq[6426]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/32032.
    coneq[6427]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/12012.
    coneq[6428]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/24024.
    coneq[6429]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/8008.
    coneq[6430]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/16016.
    coneq[6431]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**3))*c)-1/2288.
    coneq[6432]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/6864.
    coneq[6433]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/13728.
    coneq[6434]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/4576.
    coneq[6435]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/20592.
    coneq[6436]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/41184.
    coneq[6437]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/13728.
    coneq[6438]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/82368.
    coneq[6439]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/27456.
    coneq[6440]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/9152.
    coneq[6441]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**4))*c)-1/2145.
    coneq[6442]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/8580.
    coneq[6443]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/25740.
    coneq[6444]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/51480.
    coneq[6445]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/17160.
    coneq[6446]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/6435.
    coneq[6447]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/12870.
    coneq[6448]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/4290.
    coneq[6449]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/8580.
    coneq[6450]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4))*c)-1/4290.
    coneq[6451]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/17160.
    coneq[6452]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/51480.
    coneq[6453]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/102960.
    coneq[6454]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/34320.
    coneq[6455]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/12870.
    coneq[6456]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/25740.
    coneq[6457]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/8580.
    coneq[6458]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/17160.
    coneq[6459]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**5))*c)-1/1716.
    coneq[6460]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4)))*c)-1/8580.
    coneq[6461]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c)-1/34320.
    coneq[6462]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/102960.
    coneq[6463]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/205920.
    coneq[6464]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/68640.
    coneq[6465]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/25740.
    coneq[6466]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/51480.
    coneq[6467]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/17160.
    coneq[6468]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/34320.
    coneq[6469]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3)))*c)-1/6864.
    coneq[6470]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/20592.
    coneq[6471]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/41184.
    coneq[6472]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/13728.
    coneq[6473]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c)-1/5148.
    coneq[6474]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/10296.
    coneq[6475]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c)))*c)-1/3432.
    coneq[6476]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/10296.
    coneq[6477]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/20592.
    coneq[6478]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/6864.
    coneq[6479]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**3))*c)-1/1716.
    coneq[6480]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/5148.
    coneq[6481]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/10296.
    coneq[6482]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/3432.
    coneq[6483]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3))*c)-1/3432.
    coneq[6484]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/10296.
    coneq[6485]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/20592.
    coneq[6486]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/6864.
    coneq[6487]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**4))*c)-1/1430.
    coneq[6488]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/5720.
    coneq[6489]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/17160.
    coneq[6490]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/34320.
    coneq[6491]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/11440.
    coneq[6492]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/4290.
    coneq[6493]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/8580.
    coneq[6494]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/2860.
    coneq[6495]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/5720.
    coneq[6496]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**2))*c)-1/1287.
    coneq[6497]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/2574.
    coneq[6498]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/5148.
    coneq[6499]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**3))*c)-1/1144.
    coneq[6500]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/3432.
    coneq[6501]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/6864.
    coneq[6502]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/2288.
    coneq[6503]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**2))*c)-1/858.
    coneq[6504]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c)))*c)-1/1716.
    coneq[6505]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c))*c)-1/572.
    coneq[6506]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5))*c)-1/3432.
    coneq[6507]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))*c)-1/17160.
    coneq[6508]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c)-1/68640.
    coneq[6509]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/205920.
    coneq[6510]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/411840.
    coneq[6511]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/137280.
    coneq[6512]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/51480.
    coneq[6513]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/102960.
    coneq[6514]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/34320.
    coneq[6515]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/68640.
    coneq[6516]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))*c)-1/13728.
    coneq[6517]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/41184.
    coneq[6518]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/82368.
    coneq[6519]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/27456.
    coneq[6520]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c)-1/10296.
    coneq[6521]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/20592.
    coneq[6522]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))*c)-1/6864.
    coneq[6523]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/20592.
    coneq[6524]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/41184.
    coneq[6525]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/13728.
    coneq[6526]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4))*c)-1/4290.
    coneq[6527]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/17160.
    coneq[6528]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/51480.
    coneq[6529]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/102960.
    coneq[6530]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/34320.
    coneq[6531]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/12870.
    coneq[6532]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/25740.
    coneq[6533]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/8580.
    coneq[6534]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/17160.
    coneq[6535]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))*c)-1/8580.
    coneq[6536]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/34320.
    coneq[6537]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/102960.
    coneq[6538]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/205920.
    coneq[6539]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/68640.
    coneq[6540]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/25740.
    coneq[6541]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/51480.
    coneq[6542]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/17160.
    coneq[6543]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/34320.
    coneq[6544]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3))*c)-1/5148.
    coneq[6545]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/15444.
    coneq[6546]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/30888.
    coneq[6547]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/10296.
    coneq[6548]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))*c)-1/10296.
    coneq[6549]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/30888.
    coneq[6550]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/61776.
    coneq[6551]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/20592.
    coneq[6552]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))*c)-1/20592.
    coneq[6553]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/61776.
    coneq[6554]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/123552.
    coneq[6555]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/41184.
    coneq[6556]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3))*c)-1/4576.
    coneq[6557]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/13728.
    coneq[6558]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/27456.
    coneq[6559]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/9152.
    coneq[6560]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/41184.
    coneq[6561]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/82368.
    coneq[6562]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/27456.
    coneq[6563]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/164736.
    coneq[6564]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/54912.
    coneq[6565]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/18304.
    coneq[6566]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4))*c)-1/2860.
    coneq[6567]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/11440.
    coneq[6568]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/34320.
    coneq[6569]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/68640.
    coneq[6570]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/22880.
    coneq[6571]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/8580.
    coneq[6572]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/17160.
    coneq[6573]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/5720.
    coneq[6574]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/11440.
    coneq[6575]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3))*c)-1/3432.
    coneq[6576]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/10296.
    coneq[6577]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/20592.
    coneq[6578]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/6864.
    coneq[6579]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c)-1/6864.
    coneq[6580]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/20592.
    coneq[6581]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/41184.
    coneq[6582]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/13728.
    coneq[6583]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c)-1/3861.
    coneq[6584]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/7722.
    coneq[6585]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/15444.
    coneq[6586]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/30888.
    coneq[6587]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3))*c)-1/2288.
    coneq[6588]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/6864.
    coneq[6589]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/13728.
    coneq[6590]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/4576.
    coneq[6591]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c)-1/2574.
    coneq[6592]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/5148.
    coneq[6593]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/10296.
    coneq[6594]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/1716.
    coneq[6595]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/3432.
    coneq[6596]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/1144.
    coneq[6597]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))*c)-1/4576.
    coneq[6598]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/13728.
    coneq[6599]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/27456.
    coneq[6600]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/9152.
    coneq[6601]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c)-1/5148.
    coneq[6602]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/10296.
    coneq[6603]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))*c)-1/10296.
    coneq[6604]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/20592.
    coneq[6605]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/3432.
    coneq[6606]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/6864.
    coneq[6607]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/2288.
    coneq[6608]=dot(b,dot(A,c**9)*c*c)-1/130.
    coneq[6609]=dot(b,dot(A,dot(A,c**8))*c*c)-1/1170.
    coneq[6610]=dot(b,dot(A,dot(A,dot(A,c**7)))*c*c)-1/9360.
    coneq[6611]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*c*c)-1/65520.
    coneq[6612]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*c*c)-1/393120.
    coneq[6613]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c*c)-1/1965600.
    coneq[6614]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c*c)-1/7862400.
    coneq[6615]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c*c)-1/23587200.
    coneq[6616]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c*c)-1/47174400.
    coneq[6617]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c*c)-1/15724800.
    coneq[6618]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c*c)-1/5896800.
    coneq[6619]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c*c)-1/11793600.
    coneq[6620]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c*c)-1/3931200.
    coneq[6621]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c*c)-1/7862400.
    coneq[6622]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c*c)-1/1572480.
    coneq[6623]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c*c)-1/4717440.
    coneq[6624]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c*c)-1/9434880.
    coneq[6625]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c*c)-1/3144960.
    coneq[6626]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c*c)-1/1179360.
    coneq[6627]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c*c)-1/2358720.
    coneq[6628]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c*c)-1/786240.
    coneq[6629]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c*c)-1/2358720.
    coneq[6630]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c*c)-1/4717440.
    coneq[6631]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c*c)-1/1572480.
    coneq[6632]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c*c)-1/327600.
    coneq[6633]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c*c)-1/1310400.
    coneq[6634]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/3931200.
    coneq[6635]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/7862400.
    coneq[6636]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2620800.
    coneq[6637]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c*c)-1/982800.
    coneq[6638]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1965600.
    coneq[6639]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c*c)-1/655200.
    coneq[6640]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1310400.
    coneq[6641]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c*c)-1/262080.
    coneq[6642]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c*c)-1/786240.
    coneq[6643]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1572480.
    coneq[6644]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c*c)-1/524160.
    coneq[6645]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c*c)-1/196560.
    coneq[6646]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c*c)-1/393120.
    coneq[6647]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c*c)-1/131040.
    coneq[6648]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c*c)-1/589680.
    coneq[6649]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c*c)-1/1179360.
    coneq[6650]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c*c)-1/2358720.
    coneq[6651]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c*c)-1/524160.
    coneq[6652]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c*c)-1/1572480.
    coneq[6653]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c*c)-1/3144960.
    coneq[6654]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c*c)-1/1048320.
    coneq[6655]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c*c)-1/393120.
    coneq[6656]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/786240.
    coneq[6657]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c*c)-1/262080.
    coneq[6658]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c*c)-1/524160.
    coneq[6659]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*c*c)-1/56160.
    coneq[6660]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c*c)-1/280800.
    coneq[6661]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1123200.
    coneq[6662]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/3369600.
    coneq[6663]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/6739200.
    coneq[6664]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2246400.
    coneq[6665]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/842400.
    coneq[6666]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1684800.
    coneq[6667]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/561600.
    coneq[6668]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1123200.
    coneq[6669]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c*c)-1/224640.
    coneq[6670]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/673920.
    coneq[6671]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1347840.
    coneq[6672]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/449280.
    coneq[6673]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c*c)-1/168480.
    coneq[6674]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/336960.
    coneq[6675]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c*c)-1/112320.
    coneq[6676]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/336960.
    coneq[6677]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/673920.
    coneq[6678]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/224640.
    coneq[6679]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*c*c)-1/46800.
    coneq[6680]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c*c)-1/187200.
    coneq[6681]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/561600.
    coneq[6682]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1123200.
    coneq[6683]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/374400.
    coneq[6684]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c*c)-1/140400.
    coneq[6685]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/280800.
    coneq[6686]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c*c)-1/93600.
    coneq[6687]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/187200.
    coneq[6688]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*c*c)-1/37440.
    coneq[6689]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c*c)-1/112320.
    coneq[6690]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c*c)-1/224640.
    coneq[6691]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c*c)-1/74880.
    coneq[6692]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*c*c)-1/28080.
    coneq[6693]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c*c)-1/56160.
    coneq[6694]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*c*c)-1/18720.
    coneq[6695]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c*c)-1/112320.
    coneq[6696]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c*c)-1/336960.
    coneq[6697]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c*c)-1/673920.
    coneq[6698]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c*c)-1/224640.
    coneq[6699]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c*c)-1/224640.
    coneq[6700]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c*c)-1/673920.
    coneq[6701]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c*c)-1/1347840.
    coneq[6702]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c*c)-1/449280.
    coneq[6703]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c*c)-1/93600.
    coneq[6704]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c*c)-1/374400.
    coneq[6705]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1123200.
    coneq[6706]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2246400.
    coneq[6707]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/748800.
    coneq[6708]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c*c)-1/280800.
    coneq[6709]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/561600.
    coneq[6710]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c*c)-1/187200.
    coneq[6711]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/374400.
    coneq[6712]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c*c)-1/84240.
    coneq[6713]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/168480.
    coneq[6714]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/336960.
    coneq[6715]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c*c)-1/74880.
    coneq[6716]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/224640.
    coneq[6717]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/449280.
    coneq[6718]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/149760.
    coneq[6719]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c*c)-1/56160.
    coneq[6720]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/112320.
    coneq[6721]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c*c)-1/37440.
    coneq[6722]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c*c)-1/112320.
    coneq[6723]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/224640.
    coneq[6724]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/74880.
    coneq[6725]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*c*c)-1/8190.
    coneq[6726]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*c*c)-1/49140.
    coneq[6727]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c*c)-1/245700.
    coneq[6728]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/982800.
    coneq[6729]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/2948400.
    coneq[6730]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/5896800.
    coneq[6731]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/1965600.
    coneq[6732]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/737100.
    coneq[6733]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1474200.
    coneq[6734]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/491400.
    coneq[6735]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/982800.
    coneq[6736]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/196560.
    coneq[6737]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/589680.
    coneq[6738]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1179360.
    coneq[6739]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/393120.
    coneq[6740]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/147420.
    coneq[6741]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/294840.
    coneq[6742]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/98280.
    coneq[6743]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/294840.
    coneq[6744]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/589680.
    coneq[6745]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/196560.
    coneq[6746]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*c*c)-1/40950.
    coneq[6747]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/163800.
    coneq[6748]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/491400.
    coneq[6749]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/982800.
    coneq[6750]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/327600.
    coneq[6751]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/122850.
    coneq[6752]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/245700.
    coneq[6753]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/81900.
    coneq[6754]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/163800.
    coneq[6755]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*c*c)-1/32760.
    coneq[6756]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/98280.
    coneq[6757]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/196560.
    coneq[6758]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/65520.
    coneq[6759]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*c*c)-1/24570.
    coneq[6760]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/49140.
    coneq[6761]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*c*c)-1/16380.
    coneq[6762]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/73710.
    coneq[6763]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/147420.
    coneq[6764]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/294840.
    coneq[6765]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/65520.
    coneq[6766]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/196560.
    coneq[6767]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/393120.
    coneq[6768]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/131040.
    coneq[6769]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/49140.
    coneq[6770]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/98280.
    coneq[6771]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/32760.
    coneq[6772]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/65520.
    coneq[6773]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*c*c)-1/7020.
    coneq[6774]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*c*c)-1/35100.
    coneq[6775]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/140400.
    coneq[6776]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/421200.
    coneq[6777]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/842400.
    coneq[6778]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/280800.
    coneq[6779]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/105300.
    coneq[6780]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/210600.
    coneq[6781]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/70200.
    coneq[6782]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/140400.
    coneq[6783]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*c*c)-1/28080.
    coneq[6784]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/84240.
    coneq[6785]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/168480.
    coneq[6786]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/56160.
    coneq[6787]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c*c)-1/21060.
    coneq[6788]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/42120.
    coneq[6789]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*c*c)-1/14040.
    coneq[6790]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/42120.
    coneq[6791]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/84240.
    coneq[6792]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/28080.
    coneq[6793]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*c*c)-1/5850.
    coneq[6794]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*c*c)-1/23400.
    coneq[6795]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/70200.
    coneq[6796]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/140400.
    coneq[6797]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/46800.
    coneq[6798]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*c*c)-1/17550.
    coneq[6799]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/35100.
    coneq[6800]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*c*c)-1/11700.
    coneq[6801]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/23400.
    coneq[6802]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*c*c)-1/4680.
    coneq[6803]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*c*c)-1/14040.
    coneq[6804]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c*c)-1/28080.
    coneq[6805]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*c*c)-1/9360.
    coneq[6806]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*c*c)-1/3510.
    coneq[6807]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*c*c)-1/7020.
    coneq[6808]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*c*c)-1/2340.
    coneq[6809]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*c*c)-1/18720.
    coneq[6810]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c*c)-1/56160.
    coneq[6811]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c*c)-1/112320.
    coneq[6812]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c*c)-1/37440.
    coneq[6813]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c*c)-1/168480.
    coneq[6814]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c*c)-1/336960.
    coneq[6815]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c*c)-1/112320.
    coneq[6816]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c*c)-1/673920.
    coneq[6817]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c*c)-1/224640.
    coneq[6818]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/74880.
    coneq[6819]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*c*c)-1/17550.
    coneq[6820]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c*c)-1/70200.
    coneq[6821]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/210600.
    coneq[6822]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/421200.
    coneq[6823]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/140400.
    coneq[6824]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c*c)-1/52650.
    coneq[6825]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/105300.
    coneq[6826]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c*c)-1/35100.
    coneq[6827]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/70200.
    coneq[6828]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c*c)-1/35100.
    coneq[6829]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c*c)-1/140400.
    coneq[6830]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/421200.
    coneq[6831]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/842400.
    coneq[6832]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/280800.
    coneq[6833]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c*c)-1/105300.
    coneq[6834]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/210600.
    coneq[6835]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c*c)-1/70200.
    coneq[6836]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/140400.
    coneq[6837]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*c*c)-1/14040.
    coneq[6838]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c*c)-1/70200.
    coneq[6839]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/280800.
    coneq[6840]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/842400.
    coneq[6841]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1684800.
    coneq[6842]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/561600.
    coneq[6843]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/210600.
    coneq[6844]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/421200.
    coneq[6845]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/140400.
    coneq[6846]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/280800.
    coneq[6847]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c*c)-1/56160.
    coneq[6848]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/168480.
    coneq[6849]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/336960.
    coneq[6850]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/112320.
    coneq[6851]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c*c)-1/42120.
    coneq[6852]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/84240.
    coneq[6853]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c*c)-1/28080.
    coneq[6854]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/84240.
    coneq[6855]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/168480.
    coneq[6856]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/56160.
    coneq[6857]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*c*c)-1/14040.
    coneq[6858]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/42120.
    coneq[6859]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/84240.
    coneq[6860]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/28080.
    coneq[6861]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/28080.
    coneq[6862]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/84240.
    coneq[6863]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/168480.
    coneq[6864]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/56160.
    coneq[6865]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*c*c)-1/11700.
    coneq[6866]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/46800.
    coneq[6867]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/140400.
    coneq[6868]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/280800.
    coneq[6869]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/93600.
    coneq[6870]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/35100.
    coneq[6871]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/70200.
    coneq[6872]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/23400.
    coneq[6873]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/46800.
    coneq[6874]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c*c)-1/10530.
    coneq[6875]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/21060.
    coneq[6876]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/42120.
    coneq[6877]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*c*c)-1/9360.
    coneq[6878]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/28080.
    coneq[6879]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/56160.
    coneq[6880]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/18720.
    coneq[6881]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*c*c)-1/7020.
    coneq[6882]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/14040.
    coneq[6883]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*c*c)-1/4680.
    coneq[6884]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c*c)-1/18720.
    coneq[6885]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/56160.
    coneq[6886]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/112320.
    coneq[6887]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/37440.
    coneq[6888]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c*c)-1/21060.
    coneq[6889]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/42120.
    coneq[6890]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/84240.
    coneq[6891]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/14040.
    coneq[6892]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/28080.
    coneq[6893]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/9360.
    coneq[6894]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/18720.
    coneq[6895]=dot(b,dot(A,c*dot(A,c**7))*c*c)-1/1040.
    coneq[6896]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*c*c)-1/7280.
    coneq[6897]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*c*c)-1/43680.
    coneq[6898]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*c*c)-1/218400.
    coneq[6899]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/873600.
    coneq[6900]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/2620800.
    coneq[6901]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/5241600.
    coneq[6902]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/1747200.
    coneq[6903]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/655200.
    coneq[6904]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1310400.
    coneq[6905]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/436800.
    coneq[6906]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/873600.
    coneq[6907]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/174720.
    coneq[6908]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/524160.
    coneq[6909]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1048320.
    coneq[6910]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/349440.
    coneq[6911]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/131040.
    coneq[6912]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/262080.
    coneq[6913]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/87360.
    coneq[6914]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/262080.
    coneq[6915]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/524160.
    coneq[6916]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/174720.
    coneq[6917]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*c*c)-1/36400.
    coneq[6918]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/145600.
    coneq[6919]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/436800.
    coneq[6920]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/873600.
    coneq[6921]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/291200.
    coneq[6922]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/109200.
    coneq[6923]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/218400.
    coneq[6924]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/72800.
    coneq[6925]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/145600.
    coneq[6926]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*c*c)-1/29120.
    coneq[6927]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/87360.
    coneq[6928]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/174720.
    coneq[6929]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/58240.
    coneq[6930]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*c*c)-1/21840.
    coneq[6931]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/43680.
    coneq[6932]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*c*c)-1/14560.
    coneq[6933]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/65520.
    coneq[6934]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/131040.
    coneq[6935]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/262080.
    coneq[6936]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/58240.
    coneq[6937]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/174720.
    coneq[6938]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/349440.
    coneq[6939]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/116480.
    coneq[6940]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/43680.
    coneq[6941]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/87360.
    coneq[6942]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/29120.
    coneq[6943]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/58240.
    coneq[6944]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*c*c)-1/6240.
    coneq[6945]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*c*c)-1/31200.
    coneq[6946]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/124800.
    coneq[6947]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/374400.
    coneq[6948]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/748800.
    coneq[6949]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/249600.
    coneq[6950]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/93600.
    coneq[6951]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/187200.
    coneq[6952]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/62400.
    coneq[6953]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/124800.
    coneq[6954]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*c*c)-1/24960.
    coneq[6955]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/74880.
    coneq[6956]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/149760.
    coneq[6957]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/49920.
    coneq[6958]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*c*c)-1/18720.
    coneq[6959]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/37440.
    coneq[6960]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*c*c)-1/12480.
    coneq[6961]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/37440.
    coneq[6962]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/74880.
    coneq[6963]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/24960.
    coneq[6964]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*c*c)-1/5200.
    coneq[6965]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*c*c)-1/20800.
    coneq[6966]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/62400.
    coneq[6967]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/124800.
    coneq[6968]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/41600.
    coneq[6969]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*c*c)-1/15600.
    coneq[6970]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/31200.
    coneq[6971]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*c*c)-1/10400.
    coneq[6972]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/20800.
    coneq[6973]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*c*c)-1/4160.
    coneq[6974]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*c*c)-1/12480.
    coneq[6975]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c*c)-1/24960.
    coneq[6976]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*c*c)-1/8320.
    coneq[6977]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*c*c)-1/3120.
    coneq[6978]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*c*c)-1/6240.
    coneq[6979]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*c*c)-1/2080.
    coneq[6980]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*c*c)-1/12480.
    coneq[6981]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/37440.
    coneq[6982]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/74880.
    coneq[6983]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/24960.
    coneq[6984]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/24960.
    coneq[6985]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/74880.
    coneq[6986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/149760.
    coneq[6987]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/49920.
    coneq[6988]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*c*c)-1/10400.
    coneq[6989]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/41600.
    coneq[6990]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/124800.
    coneq[6991]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/249600.
    coneq[6992]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/83200.
    coneq[6993]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/31200.
    coneq[6994]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/62400.
    coneq[6995]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/20800.
    coneq[6996]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/41600.
    coneq[6997]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c*c)-1/9360.
    coneq[6998]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/18720.
    coneq[6999]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/37440.
    coneq[7000]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*c*c)-1/8320.
    coneq[7001]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/24960.
    coneq[7002]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/49920.
    coneq[7003]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/16640.
    coneq[7004]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c*c)-1/6240.
    coneq[7005]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/12480.
    coneq[7006]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*c*c)-1/4160.
    coneq[7007]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/12480.
    coneq[7008]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/24960.
    coneq[7009]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/8320.
    coneq[7010]=dot(b,dot(A,c**2*dot(A,c**6))*c*c)-1/910.
    coneq[7011]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*c*c)-1/5460.
    coneq[7012]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*c*c)-1/27300.
    coneq[7013]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/109200.
    coneq[7014]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/327600.
    coneq[7015]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/655200.
    coneq[7016]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/218400.
    coneq[7017]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/81900.
    coneq[7018]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/163800.
    coneq[7019]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/54600.
    coneq[7020]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/109200.
    coneq[7021]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/21840.
    coneq[7022]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/65520.
    coneq[7023]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/131040.
    coneq[7024]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/43680.
    coneq[7025]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/16380.
    coneq[7026]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/32760.
    coneq[7027]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/10920.
    coneq[7028]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/32760.
    coneq[7029]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/65520.
    coneq[7030]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/21840.
    coneq[7031]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*c*c)-1/4550.
    coneq[7032]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/18200.
    coneq[7033]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/54600.
    coneq[7034]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/109200.
    coneq[7035]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/36400.
    coneq[7036]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/13650.
    coneq[7037]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/27300.
    coneq[7038]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/9100.
    coneq[7039]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/18200.
    coneq[7040]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*c*c)-1/3640.
    coneq[7041]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/10920.
    coneq[7042]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/21840.
    coneq[7043]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/7280.
    coneq[7044]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*c*c)-1/2730.
    coneq[7045]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/5460.
    coneq[7046]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*c*c)-1/1820.
    coneq[7047]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/8190.
    coneq[7048]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/16380.
    coneq[7049]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/32760.
    coneq[7050]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/7280.
    coneq[7051]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/21840.
    coneq[7052]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/43680.
    coneq[7053]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/14560.
    coneq[7054]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/5460.
    coneq[7055]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/10920.
    coneq[7056]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/3640.
    coneq[7057]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/7280.
    coneq[7058]=dot(b,dot(A,c**3*dot(A,c**5))*c*c)-1/780.
    coneq[7059]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*c*c)-1/3900.
    coneq[7060]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*c*c)-1/15600.
    coneq[7061]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/46800.
    coneq[7062]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/93600.
    coneq[7063]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/31200.
    coneq[7064]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/11700.
    coneq[7065]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/23400.
    coneq[7066]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/7800.
    coneq[7067]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/15600.
    coneq[7068]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*c*c)-1/3120.
    coneq[7069]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/9360.
    coneq[7070]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/18720.
    coneq[7071]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/6240.
    coneq[7072]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*c*c)-1/2340.
    coneq[7073]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/4680.
    coneq[7074]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*c*c)-1/1560.
    coneq[7075]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/4680.
    coneq[7076]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/9360.
    coneq[7077]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/3120.
    coneq[7078]=dot(b,dot(A,c**4*dot(A,c**4))*c*c)-1/650.
    coneq[7079]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*c*c)-1/2600.
    coneq[7080]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*c*c)-1/7800.
    coneq[7081]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/15600.
    coneq[7082]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*c*c)-1/5200.
    coneq[7083]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*c*c)-1/1950.
    coneq[7084]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*c*c)-1/3900.
    coneq[7085]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*c*c)-1/1300.
    coneq[7086]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/2600.
    coneq[7087]=dot(b,dot(A,c**5*dot(A,c**3))*c*c)-1/520.
    coneq[7088]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*c*c)-1/1560.
    coneq[7089]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*c*c)-1/3120.
    coneq[7090]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*c*c)-1/1040.
    coneq[7091]=dot(b,dot(A,c**6*dot(A,c**2))*c*c)-1/390.
    coneq[7092]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*c*c)-1/780.
    coneq[7093]=dot(b,dot(A,c**7*dot(A,c))*c*c)-1/260.
    coneq[7094]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*c*c)-1/2600.
    coneq[7095]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*c*c)-1/10400.
    coneq[7096]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/31200.
    coneq[7097]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/62400.
    coneq[7098]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/20800.
    coneq[7099]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*c*c)-1/7800.
    coneq[7100]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/15600.
    coneq[7101]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*c*c)-1/5200.
    coneq[7102]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/10400.
    coneq[7103]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*c*c)-1/7800.
    coneq[7104]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c*c)-1/31200.
    coneq[7105]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/93600.
    coneq[7106]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/187200.
    coneq[7107]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/62400.
    coneq[7108]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c*c)-1/23400.
    coneq[7109]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/46800.
    coneq[7110]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c*c)-1/15600.
    coneq[7111]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/31200.
    coneq[7112]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c*c)-1/15600.
    coneq[7113]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c*c)-1/62400.
    coneq[7114]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/187200.
    coneq[7115]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/374400.
    coneq[7116]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/124800.
    coneq[7117]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c*c)-1/46800.
    coneq[7118]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/93600.
    coneq[7119]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c*c)-1/31200.
    coneq[7120]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/62400.
    coneq[7121]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*c*c)-1/5200.
    coneq[7122]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c*c)-1/20800.
    coneq[7123]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/62400.
    coneq[7124]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/124800.
    coneq[7125]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/41600.
    coneq[7126]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c*c)-1/15600.
    coneq[7127]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/31200.
    coneq[7128]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/10400.
    coneq[7129]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/20800.
    coneq[7130]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*c*c)-1/2340.
    coneq[7131]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*c*c)-1/11700.
    coneq[7132]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/46800.
    coneq[7133]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/140400.
    coneq[7134]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/280800.
    coneq[7135]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/93600.
    coneq[7136]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/35100.
    coneq[7137]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/70200.
    coneq[7138]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/23400.
    coneq[7139]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/46800.
    coneq[7140]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*c*c)-1/9360.
    coneq[7141]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/28080.
    coneq[7142]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/56160.
    coneq[7143]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/18720.
    coneq[7144]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c*c)-1/7020.
    coneq[7145]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/14040.
    coneq[7146]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*c*c)-1/4680.
    coneq[7147]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/14040.
    coneq[7148]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/28080.
    coneq[7149]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/9360.
    coneq[7150]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*c*c)-1/4680.
    coneq[7151]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c*c)-1/23400.
    coneq[7152]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c*c)-1/93600.
    coneq[7153]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/280800.
    coneq[7154]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/561600.
    coneq[7155]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/187200.
    coneq[7156]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/70200.
    coneq[7157]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/140400.
    coneq[7158]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/46800.
    coneq[7159]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/93600.
    coneq[7160]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c*c)-1/18720.
    coneq[7161]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/56160.
    coneq[7162]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/112320.
    coneq[7163]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/37440.
    coneq[7164]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c*c)-1/14040.
    coneq[7165]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/28080.
    coneq[7166]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c*c)-1/9360.
    coneq[7167]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/28080.
    coneq[7168]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/56160.
    coneq[7169]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/18720.
    coneq[7170]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*c*c)-1/1820.
    coneq[7171]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*c*c)-1/10920.
    coneq[7172]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c*c)-1/54600.
    coneq[7173]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/218400.
    coneq[7174]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/655200.
    coneq[7175]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1310400.
    coneq[7176]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/436800.
    coneq[7177]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/163800.
    coneq[7178]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/327600.
    coneq[7179]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/109200.
    coneq[7180]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/218400.
    coneq[7181]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/43680.
    coneq[7182]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/131040.
    coneq[7183]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/262080.
    coneq[7184]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/87360.
    coneq[7185]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/32760.
    coneq[7186]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/65520.
    coneq[7187]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/21840.
    coneq[7188]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/65520.
    coneq[7189]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/131040.
    coneq[7190]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/43680.
    coneq[7191]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*c*c)-1/9100.
    coneq[7192]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/36400.
    coneq[7193]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/109200.
    coneq[7194]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/218400.
    coneq[7195]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/72800.
    coneq[7196]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/27300.
    coneq[7197]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/54600.
    coneq[7198]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/18200.
    coneq[7199]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/36400.
    coneq[7200]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*c*c)-1/7280.
    coneq[7201]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/21840.
    coneq[7202]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/43680.
    coneq[7203]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/14560.
    coneq[7204]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*c*c)-1/5460.
    coneq[7205]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/10920.
    coneq[7206]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*c*c)-1/3640.
    coneq[7207]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/16380.
    coneq[7208]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/32760.
    coneq[7209]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/65520.
    coneq[7210]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/14560.
    coneq[7211]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/43680.
    coneq[7212]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/87360.
    coneq[7213]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/29120.
    coneq[7214]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/10920.
    coneq[7215]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/21840.
    coneq[7216]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/7280.
    coneq[7217]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/14560.
    coneq[7218]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*c*c)-1/2080.
    coneq[7219]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*c*c)-1/6240.
    coneq[7220]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c*c)-1/12480.
    coneq[7221]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*c*c)-1/4160.
    coneq[7222]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c*c)-1/18720.
    coneq[7223]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c*c)-1/37440.
    coneq[7224]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c*c)-1/12480.
    coneq[7225]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c*c)-1/74880.
    coneq[7226]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c*c)-1/24960.
    coneq[7227]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/8320.
    coneq[7228]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*c*c)-1/1950.
    coneq[7229]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*c*c)-1/7800.
    coneq[7230]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/23400.
    coneq[7231]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/46800.
    coneq[7232]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/15600.
    coneq[7233]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c*c)-1/5850.
    coneq[7234]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/11700.
    coneq[7235]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c*c)-1/3900.
    coneq[7236]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/7800.
    coneq[7237]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*c*c)-1/3900.
    coneq[7238]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c*c)-1/15600.
    coneq[7239]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/46800.
    coneq[7240]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/93600.
    coneq[7241]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/31200.
    coneq[7242]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c*c)-1/11700.
    coneq[7243]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/23400.
    coneq[7244]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/7800.
    coneq[7245]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/15600.
    coneq[7246]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*c*c)-1/1560.
    coneq[7247]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*c*c)-1/7800.
    coneq[7248]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/31200.
    coneq[7249]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/93600.
    coneq[7250]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/187200.
    coneq[7251]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/62400.
    coneq[7252]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/23400.
    coneq[7253]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/46800.
    coneq[7254]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/15600.
    coneq[7255]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/31200.
    coneq[7256]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*c*c)-1/6240.
    coneq[7257]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/18720.
    coneq[7258]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/37440.
    coneq[7259]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/12480.
    coneq[7260]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c*c)-1/4680.
    coneq[7261]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/9360.
    coneq[7262]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*c*c)-1/3120.
    coneq[7263]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/9360.
    coneq[7264]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/18720.
    coneq[7265]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/6240.
    coneq[7266]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*c*c)-1/1560.
    coneq[7267]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/4680.
    coneq[7268]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/9360.
    coneq[7269]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/3120.
    coneq[7270]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/3120.
    coneq[7271]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/9360.
    coneq[7272]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/18720.
    coneq[7273]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/6240.
    coneq[7274]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*c*c)-1/1300.
    coneq[7275]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*c*c)-1/5200.
    coneq[7276]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/15600.
    coneq[7277]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/31200.
    coneq[7278]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/10400.
    coneq[7279]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*c*c)-1/3900.
    coneq[7280]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/7800.
    coneq[7281]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*c*c)-1/2600.
    coneq[7282]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/5200.
    coneq[7283]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*c*c)-1/1170.
    coneq[7284]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/2340.
    coneq[7285]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/4680.
    coneq[7286]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*c*c)-1/1040.
    coneq[7287]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/3120.
    coneq[7288]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/6240.
    coneq[7289]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/2080.
    coneq[7290]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*c*c)-1/780.
    coneq[7291]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/1560.
    coneq[7292]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*c*c)-1/520.
    coneq[7293]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*c*c)-1/2600.
    coneq[7294]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c*c)-1/10400.
    coneq[7295]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/31200.
    coneq[7296]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/62400.
    coneq[7297]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/20800.
    coneq[7298]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c*c)-1/7800.
    coneq[7299]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/15600.
    coneq[7300]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c*c)-1/5200.
    coneq[7301]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/10400.
    coneq[7302]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*c*c)-1/3120.
    coneq[7303]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/9360.
    coneq[7304]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/18720.
    coneq[7305]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/6240.
    coneq[7306]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/6240.
    coneq[7307]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/18720.
    coneq[7308]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/37440.
    coneq[7309]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/12480.
    coneq[7310]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c*c)-1/3510.
    coneq[7311]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/7020.
    coneq[7312]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/14040.
    coneq[7313]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/28080.
    coneq[7314]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*c*c)-1/2080.
    coneq[7315]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/6240.
    coneq[7316]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/12480.
    coneq[7317]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/4160.
    coneq[7318]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c*c)-1/2340.
    coneq[7319]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/4680.
    coneq[7320]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/9360.
    coneq[7321]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*c*c)-1/1560.
    coneq[7322]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/3120.
    coneq[7323]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/1040.
    coneq[7324]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*c*c)-1/3120.
    coneq[7325]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/6240.
    coneq[7326]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/2080.
    coneq[7327]=dot(b,dot(A,c**8)*c**3)-1/117.
    coneq[7328]=dot(b,dot(A,dot(A,c**7))*c**3)-1/936.
    coneq[7329]=dot(b,dot(A,dot(A,dot(A,c**6)))*c**3)-1/6552.
    coneq[7330]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*c**3)-1/39312.
    coneq[7331]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*c**3)-1/196560.
    coneq[7332]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c**3)-1/786240.
    coneq[7333]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c**3)-1/2358720.
    coneq[7334]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c**3)-1/4717440.
    coneq[7335]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c**3)-1/1572480.
    coneq[7336]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c**3)-1/589680.
    coneq[7337]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c**3)-1/1179360.
    coneq[7338]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c**3)-1/393120.
    coneq[7339]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c**3)-1/786240.
    coneq[7340]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c**3)-1/157248.
    coneq[7341]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c**3)-1/471744.
    coneq[7342]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c**3)-1/943488.
    coneq[7343]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c**3)-1/314496.
    coneq[7344]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c**3)-1/117936.
    coneq[7345]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c**3)-1/235872.
    coneq[7346]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c**3)-1/78624.
    coneq[7347]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c**3)-1/235872.
    coneq[7348]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c**3)-1/471744.
    coneq[7349]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c**3)-1/157248.
    coneq[7350]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*c**3)-1/32760.
    coneq[7351]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c**3)-1/131040.
    coneq[7352]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c**3)-1/393120.
    coneq[7353]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/786240.
    coneq[7354]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c**3)-1/262080.
    coneq[7355]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c**3)-1/98280.
    coneq[7356]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c**3)-1/196560.
    coneq[7357]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c**3)-1/65520.
    coneq[7358]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/131040.
    coneq[7359]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*c**3)-1/26208.
    coneq[7360]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c**3)-1/78624.
    coneq[7361]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c**3)-1/157248.
    coneq[7362]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c**3)-1/52416.
    coneq[7363]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*c**3)-1/19656.
    coneq[7364]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c**3)-1/39312.
    coneq[7365]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*c**3)-1/13104.
    coneq[7366]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c**3)-1/58968.
    coneq[7367]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c**3)-1/117936.
    coneq[7368]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c**3)-1/235872.
    coneq[7369]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c**3)-1/52416.
    coneq[7370]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c**3)-1/157248.
    coneq[7371]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c**3)-1/314496.
    coneq[7372]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c**3)-1/104832.
    coneq[7373]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c**3)-1/39312.
    coneq[7374]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/78624.
    coneq[7375]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c**3)-1/26208.
    coneq[7376]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c**3)-1/52416.
    coneq[7377]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*c**3)-1/5616.
    coneq[7378]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*c**3)-1/28080.
    coneq[7379]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c**3)-1/112320.
    coneq[7380]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/336960.
    coneq[7381]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/673920.
    coneq[7382]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/224640.
    coneq[7383]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/84240.
    coneq[7384]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/168480.
    coneq[7385]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/56160.
    coneq[7386]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/112320.
    coneq[7387]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*c**3)-1/22464.
    coneq[7388]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/67392.
    coneq[7389]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/134784.
    coneq[7390]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/44928.
    coneq[7391]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*c**3)-1/16848.
    coneq[7392]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/33696.
    coneq[7393]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*c**3)-1/11232.
    coneq[7394]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/33696.
    coneq[7395]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/67392.
    coneq[7396]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/22464.
    coneq[7397]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*c**3)-1/4680.
    coneq[7398]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*c**3)-1/18720.
    coneq[7399]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/56160.
    coneq[7400]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/112320.
    coneq[7401]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/37440.
    coneq[7402]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*c**3)-1/14040.
    coneq[7403]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/28080.
    coneq[7404]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*c**3)-1/9360.
    coneq[7405]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/18720.
    coneq[7406]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*c**3)-1/3744.
    coneq[7407]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*c**3)-1/11232.
    coneq[7408]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c**3)-1/22464.
    coneq[7409]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*c**3)-1/7488.
    coneq[7410]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*c**3)-1/2808.
    coneq[7411]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*c**3)-1/5616.
    coneq[7412]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*c**3)-1/1872.
    coneq[7413]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*c**3)-1/11232.
    coneq[7414]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c**3)-1/33696.
    coneq[7415]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c**3)-1/67392.
    coneq[7416]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c**3)-1/22464.
    coneq[7417]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c**3)-1/22464.
    coneq[7418]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c**3)-1/67392.
    coneq[7419]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c**3)-1/134784.
    coneq[7420]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c**3)-1/44928.
    coneq[7421]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*c**3)-1/9360.
    coneq[7422]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c**3)-1/37440.
    coneq[7423]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/112320.
    coneq[7424]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/224640.
    coneq[7425]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/74880.
    coneq[7426]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c**3)-1/28080.
    coneq[7427]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/56160.
    coneq[7428]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c**3)-1/18720.
    coneq[7429]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/37440.
    coneq[7430]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*c**3)-1/8424.
    coneq[7431]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/16848.
    coneq[7432]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/33696.
    coneq[7433]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*c**3)-1/7488.
    coneq[7434]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/22464.
    coneq[7435]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/44928.
    coneq[7436]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/14976.
    coneq[7437]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*c**3)-1/5616.
    coneq[7438]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/11232.
    coneq[7439]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*c**3)-1/3744.
    coneq[7440]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c**3)-1/11232.
    coneq[7441]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/22464.
    coneq[7442]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/7488.
    coneq[7443]=dot(b,dot(A,c*dot(A,c**6))*c**3)-1/819.
    coneq[7444]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*c**3)-1/4914.
    coneq[7445]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*c**3)-1/24570.
    coneq[7446]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*c**3)-1/98280.
    coneq[7447]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/294840.
    coneq[7448]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/589680.
    coneq[7449]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/196560.
    coneq[7450]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/73710.
    coneq[7451]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/147420.
    coneq[7452]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/49140.
    coneq[7453]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/98280.
    coneq[7454]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*c**3)-1/19656.
    coneq[7455]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/58968.
    coneq[7456]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/117936.
    coneq[7457]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/39312.
    coneq[7458]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*c**3)-1/14742.
    coneq[7459]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/29484.
    coneq[7460]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*c**3)-1/9828.
    coneq[7461]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/29484.
    coneq[7462]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/58968.
    coneq[7463]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/19656.
    coneq[7464]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*c**3)-1/4095.
    coneq[7465]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*c**3)-1/16380.
    coneq[7466]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/49140.
    coneq[7467]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/98280.
    coneq[7468]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/32760.
    coneq[7469]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*c**3)-1/12285.
    coneq[7470]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/24570.
    coneq[7471]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*c**3)-1/8190.
    coneq[7472]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/16380.
    coneq[7473]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*c**3)-1/3276.
    coneq[7474]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*c**3)-1/9828.
    coneq[7475]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**3)-1/19656.
    coneq[7476]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*c**3)-1/6552.
    coneq[7477]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*c**3)-1/2457.
    coneq[7478]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*c**3)-1/4914.
    coneq[7479]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*c**3)-1/1638.
    coneq[7480]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*c**3)-1/7371.
    coneq[7481]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/14742.
    coneq[7482]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/29484.
    coneq[7483]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*c**3)-1/6552.
    coneq[7484]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/19656.
    coneq[7485]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/39312.
    coneq[7486]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/13104.
    coneq[7487]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*c**3)-1/4914.
    coneq[7488]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/9828.
    coneq[7489]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*c**3)-1/3276.
    coneq[7490]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/6552.
    coneq[7491]=dot(b,dot(A,c**2*dot(A,c**5))*c**3)-1/702.
    coneq[7492]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*c**3)-1/3510.
    coneq[7493]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*c**3)-1/14040.
    coneq[7494]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/42120.
    coneq[7495]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/84240.
    coneq[7496]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/28080.
    coneq[7497]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/10530.
    coneq[7498]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/21060.
    coneq[7499]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/7020.
    coneq[7500]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/14040.
    coneq[7501]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*c**3)-1/2808.
    coneq[7502]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/8424.
    coneq[7503]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/16848.
    coneq[7504]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/5616.
    coneq[7505]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*c**3)-1/2106.
    coneq[7506]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/4212.
    coneq[7507]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*c**3)-1/1404.
    coneq[7508]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/4212.
    coneq[7509]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/8424.
    coneq[7510]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/2808.
    coneq[7511]=dot(b,dot(A,c**3*dot(A,c**4))*c**3)-1/585.
    coneq[7512]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*c**3)-1/2340.
    coneq[7513]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*c**3)-1/7020.
    coneq[7514]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/14040.
    coneq[7515]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*c**3)-1/4680.
    coneq[7516]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*c**3)-1/1755.
    coneq[7517]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*c**3)-1/3510.
    coneq[7518]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*c**3)-1/1170.
    coneq[7519]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/2340.
    coneq[7520]=dot(b,dot(A,c**4*dot(A,c**3))*c**3)-1/468.
    coneq[7521]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*c**3)-1/1404.
    coneq[7522]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*c**3)-1/2808.
    coneq[7523]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*c**3)-1/936.
    coneq[7524]=dot(b,dot(A,c**5*dot(A,c**2))*c**3)-1/351.
    coneq[7525]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*c**3)-1/702.
    coneq[7526]=dot(b,dot(A,c**6*dot(A,c))*c**3)-1/234.
    coneq[7527]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*c**3)-1/1872.
    coneq[7528]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*c**3)-1/5616.
    coneq[7529]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c**3)-1/11232.
    coneq[7530]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*c**3)-1/3744.
    coneq[7531]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c**3)-1/16848.
    coneq[7532]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c**3)-1/33696.
    coneq[7533]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c**3)-1/11232.
    coneq[7534]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c**3)-1/67392.
    coneq[7535]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c**3)-1/22464.
    coneq[7536]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c**3)-1/7488.
    coneq[7537]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*c**3)-1/1755.
    coneq[7538]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*c**3)-1/7020.
    coneq[7539]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/21060.
    coneq[7540]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/42120.
    coneq[7541]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/14040.
    coneq[7542]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*c**3)-1/5265.
    coneq[7543]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/10530.
    coneq[7544]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*c**3)-1/3510.
    coneq[7545]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/7020.
    coneq[7546]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*c**3)-1/3510.
    coneq[7547]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c**3)-1/14040.
    coneq[7548]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c**3)-1/42120.
    coneq[7549]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/84240.
    coneq[7550]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c**3)-1/28080.
    coneq[7551]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c**3)-1/10530.
    coneq[7552]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c**3)-1/21060.
    coneq[7553]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c**3)-1/7020.
    coneq[7554]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/14040.
    coneq[7555]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*c**3)-1/1404.
    coneq[7556]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*c**3)-1/7020.
    coneq[7557]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c**3)-1/28080.
    coneq[7558]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/84240.
    coneq[7559]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/168480.
    coneq[7560]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/56160.
    coneq[7561]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/21060.
    coneq[7562]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/42120.
    coneq[7563]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/14040.
    coneq[7564]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/28080.
    coneq[7565]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*c**3)-1/5616.
    coneq[7566]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/16848.
    coneq[7567]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/33696.
    coneq[7568]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/11232.
    coneq[7569]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*c**3)-1/4212.
    coneq[7570]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/8424.
    coneq[7571]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*c**3)-1/2808.
    coneq[7572]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/8424.
    coneq[7573]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/16848.
    coneq[7574]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/5616.
    coneq[7575]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*c**3)-1/1404.
    coneq[7576]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*c**3)-1/4212.
    coneq[7577]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**3)-1/8424.
    coneq[7578]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*c**3)-1/2808.
    coneq[7579]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*c**3)-1/2808.
    coneq[7580]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**3)-1/8424.
    coneq[7581]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**3)-1/16848.
    coneq[7582]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**3)-1/5616.
    coneq[7583]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*c**3)-1/1170.
    coneq[7584]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*c**3)-1/4680.
    coneq[7585]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/14040.
    coneq[7586]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/28080.
    coneq[7587]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/9360.
    coneq[7588]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*c**3)-1/3510.
    coneq[7589]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/7020.
    coneq[7590]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*c**3)-1/2340.
    coneq[7591]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/4680.
    coneq[7592]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*c**3)-1/1053.
    coneq[7593]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/2106.
    coneq[7594]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/4212.
    coneq[7595]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*c**3)-1/936.
    coneq[7596]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*c**3)-1/2808.
    coneq[7597]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**3)-1/5616.
    coneq[7598]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*c**3)-1/1872.
    coneq[7599]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*c**3)-1/702.
    coneq[7600]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/1404.
    coneq[7601]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*c**3)-1/468.
    coneq[7602]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*c**3)-1/1872.
    coneq[7603]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c**3)-1/5616.
    coneq[7604]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**3)-1/11232.
    coneq[7605]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c**3)-1/3744.
    coneq[7606]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*c**3)-1/2106.
    coneq[7607]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/4212.
    coneq[7608]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/8424.
    coneq[7609]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*c**3)-1/1404.
    coneq[7610]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/2808.
    coneq[7611]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*c**3)-1/936.
    coneq[7612]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c**3)-1/1872.
    coneq[7613]=dot(b,dot(A,c**7)*c**4)-1/104.
    coneq[7614]=dot(b,dot(A,dot(A,c**6))*c**4)-1/728.
    coneq[7615]=dot(b,dot(A,dot(A,dot(A,c**5)))*c**4)-1/4368.
    coneq[7616]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*c**4)-1/21840.
    coneq[7617]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*c**4)-1/87360.
    coneq[7618]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**4)-1/262080.
    coneq[7619]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**4)-1/524160.
    coneq[7620]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**4)-1/174720.
    coneq[7621]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**4)-1/65520.
    coneq[7622]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**4)-1/131040.
    coneq[7623]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**4)-1/43680.
    coneq[7624]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**4)-1/87360.
    coneq[7625]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*c**4)-1/17472.
    coneq[7626]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**4)-1/52416.
    coneq[7627]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**4)-1/104832.
    coneq[7628]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**4)-1/34944.
    coneq[7629]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*c**4)-1/13104.
    coneq[7630]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**4)-1/26208.
    coneq[7631]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*c**4)-1/8736.
    coneq[7632]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**4)-1/26208.
    coneq[7633]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**4)-1/52416.
    coneq[7634]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**4)-1/17472.
    coneq[7635]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*c**4)-1/3640.
    coneq[7636]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*c**4)-1/14560.
    coneq[7637]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**4)-1/43680.
    coneq[7638]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/87360.
    coneq[7639]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**4)-1/29120.
    coneq[7640]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*c**4)-1/10920.
    coneq[7641]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**4)-1/21840.
    coneq[7642]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*c**4)-1/7280.
    coneq[7643]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**4)-1/14560.
    coneq[7644]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*c**4)-1/2912.
    coneq[7645]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*c**4)-1/8736.
    coneq[7646]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**4)-1/17472.
    coneq[7647]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*c**4)-1/5824.
    coneq[7648]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*c**4)-1/2184.
    coneq[7649]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*c**4)-1/4368.
    coneq[7650]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*c**4)-1/1456.
    coneq[7651]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*c**4)-1/6552.
    coneq[7652]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**4)-1/13104.
    coneq[7653]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**4)-1/26208.
    coneq[7654]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*c**4)-1/5824.
    coneq[7655]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**4)-1/17472.
    coneq[7656]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**4)-1/34944.
    coneq[7657]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**4)-1/11648.
    coneq[7658]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*c**4)-1/4368.
    coneq[7659]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**4)-1/8736.
    coneq[7660]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*c**4)-1/2912.
    coneq[7661]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**4)-1/5824.
    coneq[7662]=dot(b,dot(A,c*dot(A,c**5))*c**4)-1/624.
    coneq[7663]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*c**4)-1/3120.
    coneq[7664]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*c**4)-1/12480.
    coneq[7665]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**4)-1/37440.
    coneq[7666]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/74880.
    coneq[7667]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**4)-1/24960.
    coneq[7668]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*c**4)-1/9360.
    coneq[7669]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**4)-1/18720.
    coneq[7670]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*c**4)-1/6240.
    coneq[7671]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**4)-1/12480.
    coneq[7672]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*c**4)-1/2496.
    coneq[7673]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*c**4)-1/7488.
    coneq[7674]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**4)-1/14976.
    coneq[7675]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*c**4)-1/4992.
    coneq[7676]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*c**4)-1/1872.
    coneq[7677]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*c**4)-1/3744.
    coneq[7678]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*c**4)-1/1248.
    coneq[7679]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*c**4)-1/3744.
    coneq[7680]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**4)-1/7488.
    coneq[7681]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*c**4)-1/2496.
    coneq[7682]=dot(b,dot(A,c**2*dot(A,c**4))*c**4)-1/520.
    coneq[7683]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*c**4)-1/2080.
    coneq[7684]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*c**4)-1/6240.
    coneq[7685]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/12480.
    coneq[7686]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*c**4)-1/4160.
    coneq[7687]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*c**4)-1/1560.
    coneq[7688]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*c**4)-1/3120.
    coneq[7689]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*c**4)-1/1040.
    coneq[7690]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/2080.
    coneq[7691]=dot(b,dot(A,c**3*dot(A,c**3))*c**4)-1/416.
    coneq[7692]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*c**4)-1/1248.
    coneq[7693]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*c**4)-1/2496.
    coneq[7694]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*c**4)-1/832.
    coneq[7695]=dot(b,dot(A,c**4*dot(A,c**2))*c**4)-1/312.
    coneq[7696]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*c**4)-1/624.
    coneq[7697]=dot(b,dot(A,c**5*dot(A,c))*c**4)-1/208.
    coneq[7698]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*c**4)-1/1248.
    coneq[7699]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*c**4)-1/3744.
    coneq[7700]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**4)-1/7488.
    coneq[7701]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*c**4)-1/2496.
    coneq[7702]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*c**4)-1/2496.
    coneq[7703]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**4)-1/7488.
    coneq[7704]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**4)-1/14976.
    coneq[7705]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**4)-1/4992.
    coneq[7706]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*c**4)-1/1040.
    coneq[7707]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*c**4)-1/4160.
    coneq[7708]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**4)-1/12480.
    coneq[7709]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/24960.
    coneq[7710]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**4)-1/8320.
    coneq[7711]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*c**4)-1/3120.
    coneq[7712]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**4)-1/6240.
    coneq[7713]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*c**4)-1/2080.
    coneq[7714]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/4160.
    coneq[7715]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*c**4)-1/936.
    coneq[7716]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*c**4)-1/1872.
    coneq[7717]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**4)-1/3744.
    coneq[7718]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*c**4)-1/832.
    coneq[7719]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*c**4)-1/2496.
    coneq[7720]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**4)-1/4992.
    coneq[7721]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*c**4)-1/1664.
    coneq[7722]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*c**4)-1/624.
    coneq[7723]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*c**4)-1/1248.
    coneq[7724]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*c**4)-1/416.
    coneq[7725]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*c**4)-1/1248.
    coneq[7726]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**4)-1/2496.
    coneq[7727]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*c**4)-1/832.
    coneq[7728]=dot(b,dot(A,c**6)*c**5)-1/91.
    coneq[7729]=dot(b,dot(A,dot(A,c**5))*c**5)-1/546.
    coneq[7730]=dot(b,dot(A,dot(A,dot(A,c**4)))*c**5)-1/2730.
    coneq[7731]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*c**5)-1/10920.
    coneq[7732]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*c**5)-1/32760.
    coneq[7733]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**5)-1/65520.
    coneq[7734]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*c**5)-1/21840.
    coneq[7735]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*c**5)-1/8190.
    coneq[7736]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*c**5)-1/16380.
    coneq[7737]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*c**5)-1/5460.
    coneq[7738]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*c**5)-1/10920.
    coneq[7739]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*c**5)-1/2184.
    coneq[7740]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*c**5)-1/6552.
    coneq[7741]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*c**5)-1/13104.
    coneq[7742]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*c**5)-1/4368.
    coneq[7743]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*c**5)-1/1638.
    coneq[7744]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*c**5)-1/3276.
    coneq[7745]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*c**5)-1/1092.
    coneq[7746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*c**5)-1/3276.
    coneq[7747]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*c**5)-1/6552.
    coneq[7748]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*c**5)-1/2184.
    coneq[7749]=dot(b,dot(A,c*dot(A,c**4))*c**5)-1/455.
    coneq[7750]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*c**5)-1/1820.
    coneq[7751]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*c**5)-1/5460.
    coneq[7752]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*c**5)-1/10920.
    coneq[7753]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*c**5)-1/3640.
    coneq[7754]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*c**5)-1/1365.
    coneq[7755]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*c**5)-1/2730.
    coneq[7756]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*c**5)-1/910.
    coneq[7757]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*c**5)-1/1820.
    coneq[7758]=dot(b,dot(A,c**2*dot(A,c**3))*c**5)-1/364.
    coneq[7759]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*c**5)-1/1092.
    coneq[7760]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*c**5)-1/2184.
    coneq[7761]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*c**5)-1/728.
    coneq[7762]=dot(b,dot(A,c**3*dot(A,c**2))*c**5)-1/273.
    coneq[7763]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*c**5)-1/546.
    coneq[7764]=dot(b,dot(A,c**4*dot(A,c))*c**5)-1/182.
    coneq[7765]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*c**5)-1/819.
    coneq[7766]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*c**5)-1/1638.
    coneq[7767]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*c**5)-1/3276.
    coneq[7768]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*c**5)-1/728.
    coneq[7769]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*c**5)-1/2184.
    coneq[7770]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*c**5)-1/4368.
    coneq[7771]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*c**5)-1/1456.
    coneq[7772]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*c**5)-1/546.
    coneq[7773]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*c**5)-1/1092.
    coneq[7774]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*c**5)-1/364.
    coneq[7775]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*c**5)-1/728.
    coneq[7776]=dot(b,dot(A,c**5)*c**6)-1/78.
    coneq[7777]=dot(b,dot(A,dot(A,c**4))*c**6)-1/390.
    coneq[7778]=dot(b,dot(A,dot(A,dot(A,c**3)))*c**6)-1/1560.
    coneq[7779]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c**6)-1/4680.
    coneq[7780]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c**6)-1/9360.
    coneq[7781]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c**6)-1/3120.
    coneq[7782]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c**6)-1/1170.
    coneq[7783]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c**6)-1/2340.
    coneq[7784]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c**6)-1/780.
    coneq[7785]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c**6)-1/1560.
    coneq[7786]=dot(b,dot(A,c*dot(A,c**3))*c**6)-1/312.
    coneq[7787]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c**6)-1/936.
    coneq[7788]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c**6)-1/1872.
    coneq[7789]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c**6)-1/624.
    coneq[7790]=dot(b,dot(A,c**2*dot(A,c**2))*c**6)-1/234.
    coneq[7791]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c**6)-1/468.
    coneq[7792]=dot(b,dot(A,c**3*dot(A,c))*c**6)-1/156.
    coneq[7793]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c**6)-1/468.
    coneq[7794]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c**6)-1/936.
    coneq[7795]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c**6)-1/312.
    coneq[7796]=dot(b,dot(A,c**4)*c**7)-1/65.
    coneq[7797]=dot(b,dot(A,dot(A,c**3))*c**7)-1/260.
    coneq[7798]=dot(b,dot(A,dot(A,dot(A,c**2)))*c**7)-1/780.
    coneq[7799]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c**7)-1/1560.
    coneq[7800]=dot(b,dot(A,dot(A,c*dot(A,c)))*c**7)-1/520.
    coneq[7801]=dot(b,dot(A,c*dot(A,c**2))*c**7)-1/195.
    coneq[7802]=dot(b,dot(A,c*dot(A,dot(A,c)))*c**7)-1/390.
    coneq[7803]=dot(b,dot(A,c**2*dot(A,c))*c**7)-1/130.
    coneq[7804]=dot(b,dot(A,dot(A,c)*dot(A,c))*c**7)-1/260.
    coneq[7805]=dot(b,dot(A,c**3)*c**8)-1/52.
    coneq[7806]=dot(b,dot(A,dot(A,c**2))*c**8)-1/156.
    coneq[7807]=dot(b,dot(A,dot(A,dot(A,c)))*c**8)-1/312.
    coneq[7808]=dot(b,dot(A,c*dot(A,c))*c**8)-1/104.
    coneq[7809]=dot(b,dot(A,c**2)*c**9)-1/39.
    coneq[7810]=dot(b,dot(A,dot(A,c))*c**9)-1/78.
    coneq[7811]=dot(b,dot(A,c)*c**10)-1/26.
    coneq[7812]=dot(b,dot(A,c**5)*dot(A,c**5))-1/468.
    coneq[7813]=dot(b,dot(A,dot(A,c**4))*dot(A,c**5))-1/2340.
    coneq[7814]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**5))-1/9360.
    coneq[7815]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**5))-1/28080.
    coneq[7816]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**5))-1/56160.
    coneq[7817]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**5))-1/18720.
    coneq[7818]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**5))-1/7020.
    coneq[7819]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**5))-1/14040.
    coneq[7820]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**5))-1/4680.
    coneq[7821]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**5))-1/9360.
    coneq[7822]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**5))-1/1872.
    coneq[7823]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**5))-1/5616.
    coneq[7824]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**5))-1/11232.
    coneq[7825]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**5))-1/3744.
    coneq[7826]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**5))-1/1404.
    coneq[7827]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**5))-1/2808.
    coneq[7828]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**5))-1/936.
    coneq[7829]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**5))-1/2808.
    coneq[7830]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**5))-1/5616.
    coneq[7831]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**5))-1/1872.
    coneq[7832]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**4)))-1/11700.
    coneq[7833]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**4)))-1/46800.
    coneq[7834]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**4)))-1/140400.
    coneq[7835]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**4)))-1/280800.
    coneq[7836]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**4)))-1/93600.
    coneq[7837]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**4)))-1/35100.
    coneq[7838]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/70200.
    coneq[7839]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**4)))-1/23400.
    coneq[7840]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**4)))-1/46800.
    coneq[7841]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**4)))-1/9360.
    coneq[7842]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**4)))-1/28080.
    coneq[7843]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/56160.
    coneq[7844]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**4)))-1/18720.
    coneq[7845]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**4)))-1/7020.
    coneq[7846]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))-1/14040.
    coneq[7847]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**4)))-1/4680.
    coneq[7848]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**4)))-1/14040.
    coneq[7849]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))-1/28080.
    coneq[7850]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**4)))-1/9360.
    coneq[7851]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**3))))-1/187200.
    coneq[7852]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**3))))-1/561600.
    coneq[7853]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**3))))-1/1123200.
    coneq[7854]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/374400.
    coneq[7855]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/140400.
    coneq[7856]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/280800.
    coneq[7857]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/93600.
    coneq[7858]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/187200.
    coneq[7859]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c**3))))-1/37440.
    coneq[7860]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/112320.
    coneq[7861]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/224640.
    coneq[7862]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/74880.
    coneq[7863]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))-1/28080.
    coneq[7864]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/56160.
    coneq[7865]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c**3))))-1/18720.
    coneq[7866]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))-1/56160.
    coneq[7867]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/112320.
    coneq[7868]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3))))-1/37440.
    coneq[7869]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1684800.
    coneq[7870]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/3369600.
    coneq[7871]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1123200.
    coneq[7872]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/421200.
    coneq[7873]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/842400.
    coneq[7874]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/280800.
    coneq[7875]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/561600.
    coneq[7876]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/112320.
    coneq[7877]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/336960.
    coneq[7878]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/673920.
    coneq[7879]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/224640.
    coneq[7880]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/84240.
    coneq[7881]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/168480.
    coneq[7882]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/56160.
    coneq[7883]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/168480.
    coneq[7884]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/336960.
    coneq[7885]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/112320.
    coneq[7886]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/6739200.
    coneq[7887]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2246400.
    coneq[7888]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/842400.
    coneq[7889]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1684800.
    coneq[7890]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/561600.
    coneq[7891]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1123200.
    coneq[7892]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[7893]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/673920.
    coneq[7894]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1347840.
    coneq[7895]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/449280.
    coneq[7896]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/168480.
    coneq[7897]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/336960.
    coneq[7898]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/112320.
    coneq[7899]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/336960.
    coneq[7900]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/673920.
    coneq[7901]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/224640.
    coneq[7902]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/748800.
    coneq[7903]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/280800.
    coneq[7904]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/561600.
    coneq[7905]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/187200.
    coneq[7906]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/374400.
    coneq[7907]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/74880.
    coneq[7908]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/224640.
    coneq[7909]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/449280.
    coneq[7910]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/149760.
    coneq[7911]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/56160.
    coneq[7912]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/112320.
    coneq[7913]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/37440.
    coneq[7914]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/112320.
    coneq[7915]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/224640.
    coneq[7916]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/74880.
    coneq[7917]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/105300.
    coneq[7918]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/210600.
    coneq[7919]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/70200.
    coneq[7920]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/140400.
    coneq[7921]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2))))-1/28080.
    coneq[7922]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/84240.
    coneq[7923]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/168480.
    coneq[7924]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/56160.
    coneq[7925]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))-1/21060.
    coneq[7926]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/42120.
    coneq[7927]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))-1/14040.
    coneq[7928]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))-1/42120.
    coneq[7929]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/84240.
    coneq[7930]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))-1/28080.
    coneq[7931]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/421200.
    coneq[7932]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/140400.
    coneq[7933]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/280800.
    coneq[7934]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/56160.
    coneq[7935]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/168480.
    coneq[7936]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/336960.
    coneq[7937]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/112320.
    coneq[7938]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/42120.
    coneq[7939]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/84240.
    coneq[7940]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/28080.
    coneq[7941]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/84240.
    coneq[7942]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/168480.
    coneq[7943]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/56160.
    coneq[7944]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/46800.
    coneq[7945]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/93600.
    coneq[7946]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c))))-1/18720.
    coneq[7947]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))-1/56160.
    coneq[7948]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/112320.
    coneq[7949]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/37440.
    coneq[7950]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))-1/14040.
    coneq[7951]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/28080.
    coneq[7952]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))-1/9360.
    coneq[7953]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))-1/28080.
    coneq[7954]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/56160.
    coneq[7955]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))-1/18720.
    coneq[7956]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/187200.
    coneq[7957]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/37440.
    coneq[7958]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/112320.
    coneq[7959]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/224640.
    coneq[7960]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/74880.
    coneq[7961]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/28080.
    coneq[7962]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/56160.
    coneq[7963]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/18720.
    coneq[7964]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/56160.
    coneq[7965]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/112320.
    coneq[7966]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/37440.
    coneq[7967]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**3)))-1/7488.
    coneq[7968]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3)))-1/22464.
    coneq[7969]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))-1/44928.
    coneq[7970]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/14976.
    coneq[7971]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c**3)))-1/5616.
    coneq[7972]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))-1/11232.
    coneq[7973]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c**3)))-1/3744.
    coneq[7974]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**3)))-1/11232.
    coneq[7975]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))-1/22464.
    coneq[7976]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3)))-1/7488.
    coneq[7977]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))-1/67392.
    coneq[7978]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/134784.
    coneq[7979]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/44928.
    coneq[7980]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))-1/16848.
    coneq[7981]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/33696.
    coneq[7982]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))-1/11232.
    coneq[7983]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))-1/33696.
    coneq[7984]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/67392.
    coneq[7985]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))-1/22464.
    coneq[7986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/269568.
    coneq[7987]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/89856.
    coneq[7988]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/33696.
    coneq[7989]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/67392.
    coneq[7990]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/22464.
    coneq[7991]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/67392.
    coneq[7992]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/134784.
    coneq[7993]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/44928.
    coneq[7994]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/29952.
    coneq[7995]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))-1/11232.
    coneq[7996]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/22464.
    coneq[7997]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))-1/7488.
    coneq[7998]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))-1/22464.
    coneq[7999]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/44928.
    coneq[8000]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))-1/14976.
    coneq[8001]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))-1/4212.
    coneq[8002]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/8424.
    coneq[8003]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,c**2)))-1/2808.
    coneq[8004]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))-1/8424.
    coneq[8005]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/16848.
    coneq[8006]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2)))-1/5616.
    coneq[8007]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/16848.
    coneq[8008]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))-1/5616.
    coneq[8009]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))-1/16848.
    coneq[8010]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/33696.
    coneq[8011]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))-1/11232.
    coneq[8012]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3*dot(A,c)))-1/1872.
    coneq[8013]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3*dot(A,c)))-1/5616.
    coneq[8014]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))-1/11232.
    coneq[8015]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c)))-1/3744.
    coneq[8016]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))-1/16848.
    coneq[8017]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/33696.
    coneq[8018]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))-1/11232.
    coneq[8019]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/67392.
    coneq[8020]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/22464.
    coneq[8021]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))-1/7488.
    coneq[8022]=dot(b,dot(A,c**6)*dot(A,c**4))-1/455.
    coneq[8023]=dot(b,dot(A,dot(A,c**5))*dot(A,c**4))-1/2730.
    coneq[8024]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**4))-1/13650.
    coneq[8025]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**4))-1/54600.
    coneq[8026]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**4))-1/163800.
    coneq[8027]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**4))-1/327600.
    coneq[8028]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**4))-1/109200.
    coneq[8029]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**4))-1/40950.
    coneq[8030]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**4))-1/81900.
    coneq[8031]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**4))-1/27300.
    coneq[8032]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**4))-1/54600.
    coneq[8033]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**4))-1/10920.
    coneq[8034]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**4))-1/32760.
    coneq[8035]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/65520.
    coneq[8036]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**4))-1/21840.
    coneq[8037]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**4))-1/8190.
    coneq[8038]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**4))-1/16380.
    coneq[8039]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**4))-1/5460.
    coneq[8040]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**4))-1/16380.
    coneq[8041]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**4))-1/32760.
    coneq[8042]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**4))-1/10920.
    coneq[8043]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**4))-1/2275.
    coneq[8044]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**4))-1/9100.
    coneq[8045]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**4))-1/27300.
    coneq[8046]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/54600.
    coneq[8047]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**4))-1/18200.
    coneq[8048]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**4))-1/6825.
    coneq[8049]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**4))-1/13650.
    coneq[8050]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**4))-1/4550.
    coneq[8051]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4))-1/9100.
    coneq[8052]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**4))-1/1820.
    coneq[8053]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**4))-1/5460.
    coneq[8054]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/10920.
    coneq[8055]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**4))-1/3640.
    coneq[8056]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**4))-1/1365.
    coneq[8057]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**4))-1/2730.
    coneq[8058]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**4))-1/910.
    coneq[8059]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**4))-1/4095.
    coneq[8060]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**4))-1/8190.
    coneq[8061]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**4))-1/16380.
    coneq[8062]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**4))-1/3640.
    coneq[8063]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**4))-1/10920.
    coneq[8064]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/21840.
    coneq[8065]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**4))-1/7280.
    coneq[8066]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**4))-1/2730.
    coneq[8067]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4))-1/5460.
    coneq[8068]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**4))-1/1820.
    coneq[8069]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**4))-1/3640.
    coneq[8070]=dot(b,dot(A,c**6)*dot(A,dot(A,c**3)))-1/1820.
    coneq[8071]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**3)))-1/10920.
    coneq[8072]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**3)))-1/54600.
    coneq[8073]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**3)))-1/218400.
    coneq[8074]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**3)))-1/655200.
    coneq[8075]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**3)))-1/1310400.
    coneq[8076]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**3)))-1/436800.
    coneq[8077]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**3)))-1/163800.
    coneq[8078]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/327600.
    coneq[8079]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**3)))-1/109200.
    coneq[8080]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**3)))-1/218400.
    coneq[8081]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**3)))-1/43680.
    coneq[8082]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/131040.
    coneq[8083]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/262080.
    coneq[8084]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/87360.
    coneq[8085]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/32760.
    coneq[8086]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/65520.
    coneq[8087]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**3)))-1/21840.
    coneq[8088]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/65520.
    coneq[8089]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/131040.
    coneq[8090]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/43680.
    coneq[8091]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**3)))-1/9100.
    coneq[8092]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**3)))-1/36400.
    coneq[8093]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/109200.
    coneq[8094]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/218400.
    coneq[8095]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/72800.
    coneq[8096]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/27300.
    coneq[8097]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/54600.
    coneq[8098]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3)))-1/18200.
    coneq[8099]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/36400.
    coneq[8100]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**3)))-1/7280.
    coneq[8101]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/21840.
    coneq[8102]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/43680.
    coneq[8103]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/14560.
    coneq[8104]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**3)))-1/5460.
    coneq[8105]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/10920.
    coneq[8106]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**3)))-1/3640.
    coneq[8107]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**3)))-1/16380.
    coneq[8108]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/32760.
    coneq[8109]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/65520.
    coneq[8110]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**3)))-1/14560.
    coneq[8111]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/43680.
    coneq[8112]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/87360.
    coneq[8113]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/29120.
    coneq[8114]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3)))-1/10920.
    coneq[8115]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/21840.
    coneq[8116]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3)))-1/7280.
    coneq[8117]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3)))-1/14560.
    coneq[8118]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c**2))))-1/5460.
    coneq[8119]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c**2))))-1/32760.
    coneq[8120]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c**2))))-1/163800.
    coneq[8121]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c**2))))-1/655200.
    coneq[8122]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c**2))))-1/1965600.
    coneq[8123]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**2))))-1/3931200.
    coneq[8124]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1310400.
    coneq[8125]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/491400.
    coneq[8126]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/982800.
    coneq[8127]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/327600.
    coneq[8128]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/655200.
    coneq[8129]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/131040.
    coneq[8130]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/393120.
    coneq[8131]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/786240.
    coneq[8132]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/262080.
    coneq[8133]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/98280.
    coneq[8134]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/196560.
    coneq[8135]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/65520.
    coneq[8136]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/196560.
    coneq[8137]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/393120.
    coneq[8138]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/131040.
    coneq[8139]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c**2))))-1/27300.
    coneq[8140]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/109200.
    coneq[8141]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/327600.
    coneq[8142]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/655200.
    coneq[8143]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/218400.
    coneq[8144]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/81900.
    coneq[8145]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/163800.
    coneq[8146]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/54600.
    coneq[8147]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/109200.
    coneq[8148]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/21840.
    coneq[8149]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/65520.
    coneq[8150]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/131040.
    coneq[8151]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/43680.
    coneq[8152]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/16380.
    coneq[8153]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/32760.
    coneq[8154]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/10920.
    coneq[8155]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/49140.
    coneq[8156]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/98280.
    coneq[8157]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/196560.
    coneq[8158]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/43680.
    coneq[8159]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/131040.
    coneq[8160]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/262080.
    coneq[8161]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/87360.
    coneq[8162]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/32760.
    coneq[8163]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/65520.
    coneq[8164]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/21840.
    coneq[8165]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/43680.
    coneq[8166]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,dot(A,c)))))-1/10920.
    coneq[8167]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,dot(A,c)))))-1/65520.
    coneq[8168]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/327600.
    coneq[8169]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1310400.
    coneq[8170]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3931200.
    coneq[8171]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/7862400.
    coneq[8172]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2620800.
    coneq[8173]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/982800.
    coneq[8174]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1965600.
    coneq[8175]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/655200.
    coneq[8176]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1310400.
    coneq[8177]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/262080.
    coneq[8178]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/786240.
    coneq[8179]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1572480.
    coneq[8180]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/524160.
    coneq[8181]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/196560.
    coneq[8182]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/393120.
    coneq[8183]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/131040.
    coneq[8184]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/393120.
    coneq[8185]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/786240.
    coneq[8186]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/262080.
    coneq[8187]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c)))))-1/54600.
    coneq[8188]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/218400.
    coneq[8189]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/655200.
    coneq[8190]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1310400.
    coneq[8191]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/436800.
    coneq[8192]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/163800.
    coneq[8193]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/327600.
    coneq[8194]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/109200.
    coneq[8195]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/218400.
    coneq[8196]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/43680.
    coneq[8197]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/131040.
    coneq[8198]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/262080.
    coneq[8199]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/87360.
    coneq[8200]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/32760.
    coneq[8201]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/65520.
    coneq[8202]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/21840.
    coneq[8203]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/98280.
    coneq[8204]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/196560.
    coneq[8205]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/393120.
    coneq[8206]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/87360.
    coneq[8207]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/262080.
    coneq[8208]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/524160.
    coneq[8209]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/174720.
    coneq[8210]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/65520.
    coneq[8211]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/131040.
    coneq[8212]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/43680.
    coneq[8213]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/87360.
    coneq[8214]=dot(b,dot(A,c**6)*dot(A,dot(A,c*dot(A,c))))-1/3640.
    coneq[8215]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c*dot(A,c))))-1/21840.
    coneq[8216]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c*dot(A,c))))-1/109200.
    coneq[8217]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c*dot(A,c))))-1/436800.
    coneq[8218]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c))))-1/1310400.
    coneq[8219]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c))))-1/2620800.
    coneq[8220]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/873600.
    coneq[8221]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/327600.
    coneq[8222]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/655200.
    coneq[8223]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/218400.
    coneq[8224]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/436800.
    coneq[8225]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/87360.
    coneq[8226]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/262080.
    coneq[8227]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/524160.
    coneq[8228]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/174720.
    coneq[8229]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/65520.
    coneq[8230]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/131040.
    coneq[8231]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/43680.
    coneq[8232]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/131040.
    coneq[8233]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/262080.
    coneq[8234]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/87360.
    coneq[8235]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c*dot(A,c))))-1/18200.
    coneq[8236]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/72800.
    coneq[8237]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/218400.
    coneq[8238]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/436800.
    coneq[8239]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/145600.
    coneq[8240]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/54600.
    coneq[8241]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/109200.
    coneq[8242]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/36400.
    coneq[8243]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/72800.
    coneq[8244]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/14560.
    coneq[8245]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/43680.
    coneq[8246]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/87360.
    coneq[8247]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/29120.
    coneq[8248]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/10920.
    coneq[8249]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/21840.
    coneq[8250]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/7280.
    coneq[8251]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/32760.
    coneq[8252]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/65520.
    coneq[8253]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/131040.
    coneq[8254]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/29120.
    coneq[8255]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/87360.
    coneq[8256]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/174720.
    coneq[8257]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/58240.
    coneq[8258]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/21840.
    coneq[8259]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/43680.
    coneq[8260]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/14560.
    coneq[8261]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/29120.
    coneq[8262]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c**2)))-1/1365.
    coneq[8263]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c**2)))-1/8190.
    coneq[8264]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c**2)))-1/40950.
    coneq[8265]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c**2)))-1/163800.
    coneq[8266]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c**2)))-1/491400.
    coneq[8267]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c**2)))-1/982800.
    coneq[8268]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/327600.
    coneq[8269]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/122850.
    coneq[8270]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/245700.
    coneq[8271]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/81900.
    coneq[8272]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/163800.
    coneq[8273]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/32760.
    coneq[8274]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/98280.
    coneq[8275]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/196560.
    coneq[8276]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/65520.
    coneq[8277]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/24570.
    coneq[8278]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/49140.
    coneq[8279]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/16380.
    coneq[8280]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/49140.
    coneq[8281]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/98280.
    coneq[8282]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/32760.
    coneq[8283]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c**2)))-1/6825.
    coneq[8284]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/27300.
    coneq[8285]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/81900.
    coneq[8286]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/163800.
    coneq[8287]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/54600.
    coneq[8288]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/20475.
    coneq[8289]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/40950.
    coneq[8290]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/13650.
    coneq[8291]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/27300.
    coneq[8292]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/5460.
    coneq[8293]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/16380.
    coneq[8294]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/32760.
    coneq[8295]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/10920.
    coneq[8296]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/4095.
    coneq[8297]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/8190.
    coneq[8298]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c**2)))-1/2730.
    coneq[8299]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/12285.
    coneq[8300]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/24570.
    coneq[8301]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/49140.
    coneq[8302]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/10920.
    coneq[8303]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/32760.
    coneq[8304]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/65520.
    coneq[8305]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/21840.
    coneq[8306]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/8190.
    coneq[8307]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/16380.
    coneq[8308]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2)))-1/5460.
    coneq[8309]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2)))-1/10920.
    coneq[8310]=dot(b,dot(A,c**6)*dot(A,c*dot(A,dot(A,c))))-1/2730.
    coneq[8311]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,dot(A,c))))-1/16380.
    coneq[8312]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,dot(A,c))))-1/81900.
    coneq[8313]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,dot(A,c))))-1/327600.
    coneq[8314]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c))))-1/982800.
    coneq[8315]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c))))-1/1965600.
    coneq[8316]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/655200.
    coneq[8317]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/245700.
    coneq[8318]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/491400.
    coneq[8319]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/163800.
    coneq[8320]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/327600.
    coneq[8321]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/65520.
    coneq[8322]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/196560.
    coneq[8323]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/393120.
    coneq[8324]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/131040.
    coneq[8325]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/49140.
    coneq[8326]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/98280.
    coneq[8327]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/32760.
    coneq[8328]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/98280.
    coneq[8329]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/196560.
    coneq[8330]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/65520.
    coneq[8331]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,dot(A,c))))-1/13650.
    coneq[8332]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/54600.
    coneq[8333]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/163800.
    coneq[8334]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/327600.
    coneq[8335]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/109200.
    coneq[8336]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/40950.
    coneq[8337]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/81900.
    coneq[8338]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/27300.
    coneq[8339]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/54600.
    coneq[8340]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/10920.
    coneq[8341]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/32760.
    coneq[8342]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/65520.
    coneq[8343]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/21840.
    coneq[8344]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/8190.
    coneq[8345]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/16380.
    coneq[8346]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/5460.
    coneq[8347]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/24570.
    coneq[8348]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/49140.
    coneq[8349]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/98280.
    coneq[8350]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/21840.
    coneq[8351]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/65520.
    coneq[8352]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/131040.
    coneq[8353]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/43680.
    coneq[8354]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/16380.
    coneq[8355]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/32760.
    coneq[8356]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/10920.
    coneq[8357]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/21840.
    coneq[8358]=dot(b,dot(A,c**6)*dot(A,c**2*dot(A,c)))-1/910.
    coneq[8359]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2*dot(A,c)))-1/5460.
    coneq[8360]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2*dot(A,c)))-1/27300.
    coneq[8361]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2*dot(A,c)))-1/109200.
    coneq[8362]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,c)))-1/327600.
    coneq[8363]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c)))-1/655200.
    coneq[8364]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/218400.
    coneq[8365]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/81900.
    coneq[8366]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/163800.
    coneq[8367]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/54600.
    coneq[8368]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/109200.
    coneq[8369]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/21840.
    coneq[8370]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/65520.
    coneq[8371]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/131040.
    coneq[8372]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/43680.
    coneq[8373]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/16380.
    coneq[8374]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/32760.
    coneq[8375]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/10920.
    coneq[8376]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/32760.
    coneq[8377]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/65520.
    coneq[8378]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/21840.
    coneq[8379]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2*dot(A,c)))-1/4550.
    coneq[8380]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/18200.
    coneq[8381]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/54600.
    coneq[8382]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/109200.
    coneq[8383]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/36400.
    coneq[8384]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/13650.
    coneq[8385]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/27300.
    coneq[8386]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/9100.
    coneq[8387]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/18200.
    coneq[8388]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/3640.
    coneq[8389]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/10920.
    coneq[8390]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/21840.
    coneq[8391]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/7280.
    coneq[8392]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/2730.
    coneq[8393]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/5460.
    coneq[8394]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2*dot(A,c)))-1/1820.
    coneq[8395]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/8190.
    coneq[8396]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/16380.
    coneq[8397]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/32760.
    coneq[8398]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/7280.
    coneq[8399]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/21840.
    coneq[8400]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/43680.
    coneq[8401]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/14560.
    coneq[8402]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/5460.
    coneq[8403]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/10920.
    coneq[8404]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)))-1/3640.
    coneq[8405]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)))-1/7280.
    coneq[8406]=dot(b,dot(A,c**6)*dot(A,dot(A,c)*dot(A,c)))-1/1820.
    coneq[8407]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c)*dot(A,c)))-1/10920.
    coneq[8408]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c)*dot(A,c)))-1/54600.
    coneq[8409]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)*dot(A,c)))-1/218400.
    coneq[8410]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c)))-1/655200.
    coneq[8411]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c)))-1/1310400.
    coneq[8412]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/436800.
    coneq[8413]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/163800.
    coneq[8414]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/327600.
    coneq[8415]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/109200.
    coneq[8416]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/218400.
    coneq[8417]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/43680.
    coneq[8418]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/131040.
    coneq[8419]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/262080.
    coneq[8420]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/87360.
    coneq[8421]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/32760.
    coneq[8422]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/65520.
    coneq[8423]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/21840.
    coneq[8424]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/65520.
    coneq[8425]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/131040.
    coneq[8426]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/43680.
    coneq[8427]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c)*dot(A,c)))-1/9100.
    coneq[8428]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/36400.
    coneq[8429]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/109200.
    coneq[8430]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/218400.
    coneq[8431]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/72800.
    coneq[8432]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/27300.
    coneq[8433]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/54600.
    coneq[8434]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/18200.
    coneq[8435]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/36400.
    coneq[8436]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/7280.
    coneq[8437]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/21840.
    coneq[8438]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/43680.
    coneq[8439]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/14560.
    coneq[8440]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/5460.
    coneq[8441]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/10920.
    coneq[8442]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/3640.
    coneq[8443]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/16380.
    coneq[8444]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/32760.
    coneq[8445]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/65520.
    coneq[8446]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/14560.
    coneq[8447]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/43680.
    coneq[8448]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/87360.
    coneq[8449]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/29120.
    coneq[8450]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/10920.
    coneq[8451]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/21840.
    coneq[8452]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/7280.
    coneq[8453]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/14560.
    coneq[8454]=dot(b,dot(A,c**7)*dot(A,c**3))-1/416.
    coneq[8455]=dot(b,dot(A,dot(A,c**6))*dot(A,c**3))-1/2912.
    coneq[8456]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**3))-1/17472.
    coneq[8457]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**3))-1/87360.
    coneq[8458]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**3))-1/349440.
    coneq[8459]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**3))-1/1048320.
    coneq[8460]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**3))-1/2096640.
    coneq[8461]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**3))-1/698880.
    coneq[8462]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**3))-1/262080.
    coneq[8463]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**3))-1/524160.
    coneq[8464]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**3))-1/174720.
    coneq[8465]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**3))-1/349440.
    coneq[8466]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**3))-1/69888.
    coneq[8467]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**3))-1/209664.
    coneq[8468]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/419328.
    coneq[8469]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**3))-1/139776.
    coneq[8470]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**3))-1/52416.
    coneq[8471]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**3))-1/104832.
    coneq[8472]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**3))-1/34944.
    coneq[8473]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**3))-1/104832.
    coneq[8474]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**3))-1/209664.
    coneq[8475]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**3))-1/69888.
    coneq[8476]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**3))-1/14560.
    coneq[8477]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**3))-1/58240.
    coneq[8478]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/174720.
    coneq[8479]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/349440.
    coneq[8480]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/116480.
    coneq[8481]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/43680.
    coneq[8482]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/87360.
    coneq[8483]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/29120.
    coneq[8484]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/58240.
    coneq[8485]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**3))-1/11648.
    coneq[8486]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**3))-1/34944.
    coneq[8487]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/69888.
    coneq[8488]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**3))-1/23296.
    coneq[8489]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**3))-1/8736.
    coneq[8490]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**3))-1/17472.
    coneq[8491]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**3))-1/5824.
    coneq[8492]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**3))-1/26208.
    coneq[8493]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**3))-1/52416.
    coneq[8494]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**3))-1/104832.
    coneq[8495]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**3))-1/23296.
    coneq[8496]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**3))-1/69888.
    coneq[8497]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/139776.
    coneq[8498]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**3))-1/46592.
    coneq[8499]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/17472.
    coneq[8500]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/34944.
    coneq[8501]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/11648.
    coneq[8502]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/23296.
    coneq[8503]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**3))-1/2496.
    coneq[8504]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**3))-1/12480.
    coneq[8505]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**3))-1/49920.
    coneq[8506]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/149760.
    coneq[8507]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/299520.
    coneq[8508]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/99840.
    coneq[8509]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/37440.
    coneq[8510]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/74880.
    coneq[8511]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/24960.
    coneq[8512]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/49920.
    coneq[8513]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**3))-1/9984.
    coneq[8514]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3))-1/29952.
    coneq[8515]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/59904.
    coneq[8516]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3))-1/19968.
    coneq[8517]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**3))-1/7488.
    coneq[8518]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3))-1/14976.
    coneq[8519]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**3))-1/4992.
    coneq[8520]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/14976.
    coneq[8521]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/29952.
    coneq[8522]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/9984.
    coneq[8523]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**3))-1/2080.
    coneq[8524]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**3))-1/8320.
    coneq[8525]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/24960.
    coneq[8526]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/49920.
    coneq[8527]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/16640.
    coneq[8528]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/6240.
    coneq[8529]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/12480.
    coneq[8530]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/4160.
    coneq[8531]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/8320.
    coneq[8532]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**3))-1/1664.
    coneq[8533]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**3))-1/4992.
    coneq[8534]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/9984.
    coneq[8535]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**3))-1/3328.
    coneq[8536]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**3))-1/1248.
    coneq[8537]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**3))-1/2496.
    coneq[8538]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**3))-1/832.
    coneq[8539]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**3))-1/4992.
    coneq[8540]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/14976.
    coneq[8541]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/29952.
    coneq[8542]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/9984.
    coneq[8543]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**3))-1/9984.
    coneq[8544]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**3))-1/29952.
    coneq[8545]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/59904.
    coneq[8546]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**3))-1/19968.
    coneq[8547]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**3))-1/4160.
    coneq[8548]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**3))-1/16640.
    coneq[8549]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/49920.
    coneq[8550]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/99840.
    coneq[8551]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/33280.
    coneq[8552]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/12480.
    coneq[8553]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/24960.
    coneq[8554]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/8320.
    coneq[8555]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/16640.
    coneq[8556]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**3))-1/3744.
    coneq[8557]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3))-1/7488.
    coneq[8558]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3))-1/14976.
    coneq[8559]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**3))-1/3328.
    coneq[8560]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/9984.
    coneq[8561]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/19968.
    coneq[8562]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/6656.
    coneq[8563]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**3))-1/2496.
    coneq[8564]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3))-1/4992.
    coneq[8565]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**3))-1/1664.
    coneq[8566]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**3))-1/4992.
    coneq[8567]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3))-1/9984.
    coneq[8568]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3))-1/3328.
    coneq[8569]=dot(b,dot(A,c**7)*dot(A,dot(A,c**2)))-1/1248.
    coneq[8570]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c**2)))-1/8736.
    coneq[8571]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c**2)))-1/52416.
    coneq[8572]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c**2)))-1/262080.
    coneq[8573]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c**2)))-1/1048320.
    coneq[8574]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c**2)))-1/3144960.
    coneq[8575]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**2)))-1/6289920.
    coneq[8576]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c**2)))-1/2096640.
    coneq[8577]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/786240.
    coneq[8578]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1572480.
    coneq[8579]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c**2)))-1/524160.
    coneq[8580]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**2)))-1/1048320.
    coneq[8581]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c**2)))-1/209664.
    coneq[8582]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/628992.
    coneq[8583]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1257984.
    coneq[8584]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/419328.
    coneq[8585]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/157248.
    coneq[8586]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/314496.
    coneq[8587]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c**2)))-1/104832.
    coneq[8588]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/314496.
    coneq[8589]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/628992.
    coneq[8590]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/209664.
    coneq[8591]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c**2)))-1/43680.
    coneq[8592]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/174720.
    coneq[8593]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/524160.
    coneq[8594]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1048320.
    coneq[8595]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/349440.
    coneq[8596]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/131040.
    coneq[8597]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/262080.
    coneq[8598]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/87360.
    coneq[8599]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/174720.
    coneq[8600]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/34944.
    coneq[8601]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/104832.
    coneq[8602]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/209664.
    coneq[8603]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/69888.
    coneq[8604]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/26208.
    coneq[8605]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/52416.
    coneq[8606]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c**2)))-1/17472.
    coneq[8607]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/78624.
    coneq[8608]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/157248.
    coneq[8609]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/314496.
    coneq[8610]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/69888.
    coneq[8611]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/209664.
    coneq[8612]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/419328.
    coneq[8613]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/139776.
    coneq[8614]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/52416.
    coneq[8615]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/104832.
    coneq[8616]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/34944.
    coneq[8617]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/69888.
    coneq[8618]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c**2)))-1/7488.
    coneq[8619]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c**2)))-1/37440.
    coneq[8620]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/149760.
    coneq[8621]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/449280.
    coneq[8622]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/898560.
    coneq[8623]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/299520.
    coneq[8624]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/112320.
    coneq[8625]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/224640.
    coneq[8626]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/74880.
    coneq[8627]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/149760.
    coneq[8628]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8629]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/89856.
    coneq[8630]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/179712.
    coneq[8631]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/59904.
    coneq[8632]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/22464.
    coneq[8633]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/44928.
    coneq[8634]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2)))-1/14976.
    coneq[8635]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/44928.
    coneq[8636]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/89856.
    coneq[8637]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8638]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c**2)))-1/6240.
    coneq[8639]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/24960.
    coneq[8640]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/74880.
    coneq[8641]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/149760.
    coneq[8642]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/49920.
    coneq[8643]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/18720.
    coneq[8644]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/37440.
    coneq[8645]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/12480.
    coneq[8646]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/24960.
    coneq[8647]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c**2)))-1/4992.
    coneq[8648]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/14976.
    coneq[8649]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8650]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/9984.
    coneq[8651]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c**2)))-1/3744.
    coneq[8652]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/7488.
    coneq[8653]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c**2)))-1/2496.
    coneq[8654]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/14976.
    coneq[8655]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/44928.
    coneq[8656]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/89856.
    coneq[8657]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8658]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8659]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/89856.
    coneq[8660]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/179712.
    coneq[8661]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/59904.
    coneq[8662]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c**2)))-1/12480.
    coneq[8663]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/49920.
    coneq[8664]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/149760.
    coneq[8665]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/299520.
    coneq[8666]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/99840.
    coneq[8667]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/37440.
    coneq[8668]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/74880.
    coneq[8669]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/24960.
    coneq[8670]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/49920.
    coneq[8671]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/11232.
    coneq[8672]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/22464.
    coneq[8673]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/44928.
    coneq[8674]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/9984.
    coneq[8675]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8676]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/59904.
    coneq[8677]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/19968.
    coneq[8678]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/7488.
    coneq[8679]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/14976.
    coneq[8680]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/4992.
    coneq[8681]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/14976.
    coneq[8682]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/29952.
    coneq[8683]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/9984.
    coneq[8684]=dot(b,dot(A,c**7)*dot(A,dot(A,dot(A,c))))-1/2496.
    coneq[8685]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,dot(A,c))))-1/17472.
    coneq[8686]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,dot(A,c))))-1/104832.
    coneq[8687]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,dot(A,c))))-1/524160.
    coneq[8688]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,c))))-1/2096640.
    coneq[8689]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c))))-1/6289920.
    coneq[8690]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/12579840.
    coneq[8691]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/4193280.
    coneq[8692]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1572480.
    coneq[8693]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/3144960.
    coneq[8694]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1048320.
    coneq[8695]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2096640.
    coneq[8696]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/419328.
    coneq[8697]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1257984.
    coneq[8698]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/2515968.
    coneq[8699]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/838656.
    coneq[8700]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/314496.
    coneq[8701]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/628992.
    coneq[8702]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/209664.
    coneq[8703]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/628992.
    coneq[8704]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1257984.
    coneq[8705]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/419328.
    coneq[8706]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/87360.
    coneq[8707]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/349440.
    coneq[8708]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1048320.
    coneq[8709]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/2096640.
    coneq[8710]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/698880.
    coneq[8711]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/262080.
    coneq[8712]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/524160.
    coneq[8713]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/174720.
    coneq[8714]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/349440.
    coneq[8715]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/69888.
    coneq[8716]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/209664.
    coneq[8717]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/419328.
    coneq[8718]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/139776.
    coneq[8719]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/52416.
    coneq[8720]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/104832.
    coneq[8721]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/34944.
    coneq[8722]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/157248.
    coneq[8723]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/314496.
    coneq[8724]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/628992.
    coneq[8725]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/139776.
    coneq[8726]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/419328.
    coneq[8727]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/838656.
    coneq[8728]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/279552.
    coneq[8729]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/104832.
    coneq[8730]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/209664.
    coneq[8731]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/69888.
    coneq[8732]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/139776.
    coneq[8733]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,dot(A,c))))-1/14976.
    coneq[8734]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/74880.
    coneq[8735]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/299520.
    coneq[8736]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/898560.
    coneq[8737]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/1797120.
    coneq[8738]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/599040.
    coneq[8739]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/224640.
    coneq[8740]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/449280.
    coneq[8741]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/149760.
    coneq[8742]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/299520.
    coneq[8743]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8744]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/179712.
    coneq[8745]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/359424.
    coneq[8746]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/119808.
    coneq[8747]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/44928.
    coneq[8748]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/89856.
    coneq[8749]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/29952.
    coneq[8750]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/89856.
    coneq[8751]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/179712.
    coneq[8752]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8753]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/12480.
    coneq[8754]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/49920.
    coneq[8755]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/149760.
    coneq[8756]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/299520.
    coneq[8757]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/99840.
    coneq[8758]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/37440.
    coneq[8759]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/74880.
    coneq[8760]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/24960.
    coneq[8761]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/49920.
    coneq[8762]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/9984.
    coneq[8763]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/29952.
    coneq[8764]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8765]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/19968.
    coneq[8766]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/7488.
    coneq[8767]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/14976.
    coneq[8768]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/4992.
    coneq[8769]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/29952.
    coneq[8770]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/89856.
    coneq[8771]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/179712.
    coneq[8772]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8773]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8774]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/179712.
    coneq[8775]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/359424.
    coneq[8776]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/119808.
    coneq[8777]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/24960.
    coneq[8778]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/99840.
    coneq[8779]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/299520.
    coneq[8780]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/599040.
    coneq[8781]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/199680.
    coneq[8782]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/74880.
    coneq[8783]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/149760.
    coneq[8784]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/49920.
    coneq[8785]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/99840.
    coneq[8786]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/22464.
    coneq[8787]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/44928.
    coneq[8788]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/89856.
    coneq[8789]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/19968.
    coneq[8790]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8791]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/119808.
    coneq[8792]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/39936.
    coneq[8793]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/14976.
    coneq[8794]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/29952.
    coneq[8795]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/9984.
    coneq[8796]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/29952.
    coneq[8797]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[8798]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/19968.
    coneq[8799]=dot(b,dot(A,c**7)*dot(A,c*dot(A,c)))-1/832.
    coneq[8800]=dot(b,dot(A,dot(A,c**6))*dot(A,c*dot(A,c)))-1/5824.
    coneq[8801]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c*dot(A,c)))-1/34944.
    coneq[8802]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c*dot(A,c)))-1/174720.
    coneq[8803]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c*dot(A,c)))-1/698880.
    coneq[8804]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c)))-1/2096640.
    coneq[8805]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c)))-1/4193280.
    coneq[8806]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c)))-1/1397760.
    coneq[8807]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/524160.
    coneq[8808]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1048320.
    coneq[8809]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,c)))-1/349440.
    coneq[8810]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c)))-1/698880.
    coneq[8811]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c*dot(A,c)))-1/139776.
    coneq[8812]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/419328.
    coneq[8813]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/838656.
    coneq[8814]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/279552.
    coneq[8815]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/104832.
    coneq[8816]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/209664.
    coneq[8817]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c*dot(A,c)))-1/69888.
    coneq[8818]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/209664.
    coneq[8819]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/419328.
    coneq[8820]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/139776.
    coneq[8821]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c*dot(A,c)))-1/29120.
    coneq[8822]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/116480.
    coneq[8823]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/349440.
    coneq[8824]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/698880.
    coneq[8825]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/232960.
    coneq[8826]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/87360.
    coneq[8827]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/174720.
    coneq[8828]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/58240.
    coneq[8829]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/116480.
    coneq[8830]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/23296.
    coneq[8831]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/69888.
    coneq[8832]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/139776.
    coneq[8833]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/46592.
    coneq[8834]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/17472.
    coneq[8835]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/34944.
    coneq[8836]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c*dot(A,c)))-1/11648.
    coneq[8837]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/52416.
    coneq[8838]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/104832.
    coneq[8839]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/209664.
    coneq[8840]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/46592.
    coneq[8841]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/139776.
    coneq[8842]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/279552.
    coneq[8843]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/93184.
    coneq[8844]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/34944.
    coneq[8845]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/69888.
    coneq[8846]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/23296.
    coneq[8847]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/46592.
    coneq[8848]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c*dot(A,c)))-1/4992.
    coneq[8849]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c*dot(A,c)))-1/24960.
    coneq[8850]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/99840.
    coneq[8851]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/299520.
    coneq[8852]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/599040.
    coneq[8853]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/199680.
    coneq[8854]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/74880.
    coneq[8855]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/149760.
    coneq[8856]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/49920.
    coneq[8857]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/99840.
    coneq[8858]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8859]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/59904.
    coneq[8860]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/119808.
    coneq[8861]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/39936.
    coneq[8862]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/14976.
    coneq[8863]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/29952.
    coneq[8864]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c)))-1/9984.
    coneq[8865]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/29952.
    coneq[8866]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/59904.
    coneq[8867]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8868]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c*dot(A,c)))-1/4160.
    coneq[8869]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/16640.
    coneq[8870]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/49920.
    coneq[8871]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/99840.
    coneq[8872]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/33280.
    coneq[8873]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/12480.
    coneq[8874]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/24960.
    coneq[8875]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/8320.
    coneq[8876]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/16640.
    coneq[8877]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c*dot(A,c)))-1/3328.
    coneq[8878]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/9984.
    coneq[8879]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8880]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/6656.
    coneq[8881]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c*dot(A,c)))-1/2496.
    coneq[8882]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/4992.
    coneq[8883]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c*dot(A,c)))-1/1664.
    coneq[8884]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/9984.
    coneq[8885]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/29952.
    coneq[8886]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/59904.
    coneq[8887]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8888]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8889]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/59904.
    coneq[8890]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/119808.
    coneq[8891]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/39936.
    coneq[8892]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c*dot(A,c)))-1/8320.
    coneq[8893]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/33280.
    coneq[8894]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/99840.
    coneq[8895]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/199680.
    coneq[8896]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/66560.
    coneq[8897]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/24960.
    coneq[8898]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/49920.
    coneq[8899]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/16640.
    coneq[8900]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/33280.
    coneq[8901]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/7488.
    coneq[8902]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/14976.
    coneq[8903]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/29952.
    coneq[8904]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/6656.
    coneq[8905]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8906]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/39936.
    coneq[8907]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/13312.
    coneq[8908]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/4992.
    coneq[8909]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/9984.
    coneq[8910]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/3328.
    coneq[8911]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/9984.
    coneq[8912]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/19968.
    coneq[8913]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/6656.
    coneq[8914]=dot(b,dot(A,c**8)*dot(A,c**2))-1/351.
    coneq[8915]=dot(b,dot(A,dot(A,c**7))*dot(A,c**2))-1/2808.
    coneq[8916]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c**2))-1/19656.
    coneq[8917]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c**2))-1/117936.
    coneq[8918]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c**2))-1/589680.
    coneq[8919]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c**2))-1/2358720.
    coneq[8920]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**2))-1/7076160.
    coneq[8921]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**2))-1/14152320.
    coneq[8922]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**2))-1/4717440.
    coneq[8923]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c**2))-1/1769040.
    coneq[8924]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**2))-1/3538080.
    coneq[8925]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c**2))-1/1179360.
    coneq[8926]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**2))-1/2358720.
    coneq[8927]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c**2))-1/471744.
    coneq[8928]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1415232.
    coneq[8929]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2830464.
    coneq[8930]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c**2))-1/943488.
    coneq[8931]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c**2))-1/353808.
    coneq[8932]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c**2))-1/707616.
    coneq[8933]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c**2))-1/235872.
    coneq[8934]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c**2))-1/707616.
    coneq[8935]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**2))-1/1415232.
    coneq[8936]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/471744.
    coneq[8937]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c**2))-1/98280.
    coneq[8938]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c**2))-1/393120.
    coneq[8939]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1179360.
    coneq[8940]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2358720.
    coneq[8941]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/786240.
    coneq[8942]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/294840.
    coneq[8943]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/589680.
    coneq[8944]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/196560.
    coneq[8945]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/393120.
    coneq[8946]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c**2))-1/78624.
    coneq[8947]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/235872.
    coneq[8948]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/471744.
    coneq[8949]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/157248.
    coneq[8950]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c**2))-1/58968.
    coneq[8951]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c**2))-1/117936.
    coneq[8952]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c**2))-1/39312.
    coneq[8953]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c**2))-1/176904.
    coneq[8954]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c**2))-1/353808.
    coneq[8955]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c**2))-1/707616.
    coneq[8956]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c**2))-1/157248.
    coneq[8957]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/471744.
    coneq[8958]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/943488.
    coneq[8959]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/314496.
    coneq[8960]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/117936.
    coneq[8961]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/235872.
    coneq[8962]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/78624.
    coneq[8963]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/157248.
    coneq[8964]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c**2))-1/16848.
    coneq[8965]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c**2))-1/84240.
    coneq[8966]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/336960.
    coneq[8967]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1010880.
    coneq[8968]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2021760.
    coneq[8969]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/673920.
    coneq[8970]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/252720.
    coneq[8971]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/505440.
    coneq[8972]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/168480.
    coneq[8973]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/336960.
    coneq[8974]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/67392.
    coneq[8975]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/202176.
    coneq[8976]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/404352.
    coneq[8977]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/134784.
    coneq[8978]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/50544.
    coneq[8979]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/101088.
    coneq[8980]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/33696.
    coneq[8981]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/101088.
    coneq[8982]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/202176.
    coneq[8983]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/67392.
    coneq[8984]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c**2))-1/14040.
    coneq[8985]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c**2))-1/56160.
    coneq[8986]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/168480.
    coneq[8987]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/336960.
    coneq[8988]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/112320.
    coneq[8989]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/42120.
    coneq[8990]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/84240.
    coneq[8991]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/28080.
    coneq[8992]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/56160.
    coneq[8993]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c**2))-1/11232.
    coneq[8994]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c**2))-1/33696.
    coneq[8995]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/67392.
    coneq[8996]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c**2))-1/22464.
    coneq[8997]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c**2))-1/8424.
    coneq[8998]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c**2))-1/16848.
    coneq[8999]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c**2))-1/5616.
    coneq[9000]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c**2))-1/33696.
    coneq[9001]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/101088.
    coneq[9002]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/202176.
    coneq[9003]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/67392.
    coneq[9004]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c**2))-1/67392.
    coneq[9005]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c**2))-1/202176.
    coneq[9006]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/404352.
    coneq[9007]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c**2))-1/134784.
    coneq[9008]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c**2))-1/28080.
    coneq[9009]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c**2))-1/112320.
    coneq[9010]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/336960.
    coneq[9011]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/673920.
    coneq[9012]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/224640.
    coneq[9013]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/84240.
    coneq[9014]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/168480.
    coneq[9015]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/56160.
    coneq[9016]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/112320.
    coneq[9017]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/25272.
    coneq[9018]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/50544.
    coneq[9019]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/101088.
    coneq[9020]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/22464.
    coneq[9021]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/67392.
    coneq[9022]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/134784.
    coneq[9023]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/44928.
    coneq[9024]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/16848.
    coneq[9025]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/33696.
    coneq[9026]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/11232.
    coneq[9027]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/33696.
    coneq[9028]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/67392.
    coneq[9029]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/22464.
    coneq[9030]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c**2))-1/2457.
    coneq[9031]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c**2))-1/14742.
    coneq[9032]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c**2))-1/73710.
    coneq[9033]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/294840.
    coneq[9034]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/884520.
    coneq[9035]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/1769040.
    coneq[9036]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/589680.
    coneq[9037]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/221130.
    coneq[9038]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/442260.
    coneq[9039]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/147420.
    coneq[9040]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/294840.
    coneq[9041]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/58968.
    coneq[9042]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/176904.
    coneq[9043]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/353808.
    coneq[9044]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/117936.
    coneq[9045]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/44226.
    coneq[9046]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/88452.
    coneq[9047]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/29484.
    coneq[9048]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/88452.
    coneq[9049]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/176904.
    coneq[9050]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/58968.
    coneq[9051]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c**2))-1/12285.
    coneq[9052]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2))-1/49140.
    coneq[9053]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/147420.
    coneq[9054]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/294840.
    coneq[9055]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/98280.
    coneq[9056]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/36855.
    coneq[9057]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/73710.
    coneq[9058]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/24570.
    coneq[9059]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/49140.
    coneq[9060]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c**2))-1/9828.
    coneq[9061]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2))-1/29484.
    coneq[9062]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/58968.
    coneq[9063]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2))-1/19656.
    coneq[9064]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c**2))-1/7371.
    coneq[9065]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2))-1/14742.
    coneq[9066]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c**2))-1/4914.
    coneq[9067]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/22113.
    coneq[9068]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/44226.
    coneq[9069]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/88452.
    coneq[9070]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/19656.
    coneq[9071]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/58968.
    coneq[9072]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/117936.
    coneq[9073]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/39312.
    coneq[9074]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/14742.
    coneq[9075]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/29484.
    coneq[9076]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/9828.
    coneq[9077]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/19656.
    coneq[9078]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c**2))-1/2106.
    coneq[9079]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c**2))-1/10530.
    coneq[9080]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/42120.
    coneq[9081]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/126360.
    coneq[9082]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/252720.
    coneq[9083]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/84240.
    coneq[9084]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/31590.
    coneq[9085]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/63180.
    coneq[9086]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/21060.
    coneq[9087]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/42120.
    coneq[9088]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/8424.
    coneq[9089]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/25272.
    coneq[9090]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/50544.
    coneq[9091]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/16848.
    coneq[9092]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/6318.
    coneq[9093]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/12636.
    coneq[9094]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/4212.
    coneq[9095]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/12636.
    coneq[9096]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/25272.
    coneq[9097]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/8424.
    coneq[9098]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c**2))-1/1755.
    coneq[9099]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c**2))-1/7020.
    coneq[9100]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/21060.
    coneq[9101]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/42120.
    coneq[9102]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/14040.
    coneq[9103]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/5265.
    coneq[9104]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/10530.
    coneq[9105]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/3510.
    coneq[9106]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/7020.
    coneq[9107]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c**2))-1/1404.
    coneq[9108]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c**2))-1/4212.
    coneq[9109]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/8424.
    coneq[9110]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c**2))-1/2808.
    coneq[9111]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c**2))-1/1053.
    coneq[9112]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c**2))-1/2106.
    coneq[9113]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c**2))-1/702.
    coneq[9114]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c**2))-1/5616.
    coneq[9115]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/16848.
    coneq[9116]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/33696.
    coneq[9117]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/11232.
    coneq[9118]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c**2))-1/50544.
    coneq[9119]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/101088.
    coneq[9120]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/33696.
    coneq[9121]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/202176.
    coneq[9122]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/67392.
    coneq[9123]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/22464.
    coneq[9124]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c**2))-1/5265.
    coneq[9125]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/21060.
    coneq[9126]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/63180.
    coneq[9127]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/126360.
    coneq[9128]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/42120.
    coneq[9129]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/15795.
    coneq[9130]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/31590.
    coneq[9131]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/10530.
    coneq[9132]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/21060.
    coneq[9133]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c**2))-1/10530.
    coneq[9134]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c**2))-1/42120.
    coneq[9135]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/126360.
    coneq[9136]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/252720.
    coneq[9137]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/84240.
    coneq[9138]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/31590.
    coneq[9139]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/63180.
    coneq[9140]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/21060.
    coneq[9141]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/42120.
    coneq[9142]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c**2))-1/4212.
    coneq[9143]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c**2))-1/21060.
    coneq[9144]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/84240.
    coneq[9145]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/252720.
    coneq[9146]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/505440.
    coneq[9147]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/168480.
    coneq[9148]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/63180.
    coneq[9149]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/126360.
    coneq[9150]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/42120.
    coneq[9151]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/84240.
    coneq[9152]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/16848.
    coneq[9153]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/50544.
    coneq[9154]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/101088.
    coneq[9155]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/33696.
    coneq[9156]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/12636.
    coneq[9157]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/25272.
    coneq[9158]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/8424.
    coneq[9159]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/25272.
    coneq[9160]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/50544.
    coneq[9161]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/16848.
    coneq[9162]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c**2))-1/4212.
    coneq[9163]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/12636.
    coneq[9164]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/25272.
    coneq[9165]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/8424.
    coneq[9166]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2))-1/8424.
    coneq[9167]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2))-1/25272.
    coneq[9168]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/50544.
    coneq[9169]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/16848.
    coneq[9170]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c**2))-1/3510.
    coneq[9171]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/14040.
    coneq[9172]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/42120.
    coneq[9173]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/84240.
    coneq[9174]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/28080.
    coneq[9175]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/10530.
    coneq[9176]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/21060.
    coneq[9177]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/7020.
    coneq[9178]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/14040.
    coneq[9179]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/3159.
    coneq[9180]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/6318.
    coneq[9181]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/12636.
    coneq[9182]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c**2))-1/2808.
    coneq[9183]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/8424.
    coneq[9184]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/16848.
    coneq[9185]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/5616.
    coneq[9186]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/2106.
    coneq[9187]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/4212.
    coneq[9188]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c**2))-1/1404.
    coneq[9189]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c**2))-1/5616.
    coneq[9190]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/16848.
    coneq[9191]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/33696.
    coneq[9192]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/11232.
    coneq[9193]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/6318.
    coneq[9194]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/12636.
    coneq[9195]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/25272.
    coneq[9196]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/4212.
    coneq[9197]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/8424.
    coneq[9198]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2))-1/2808.
    coneq[9199]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2))-1/5616.
    coneq[9200]=dot(b,dot(A,c**8)*dot(A,dot(A,c)))-1/702.
    coneq[9201]=dot(b,dot(A,dot(A,c**7))*dot(A,dot(A,c)))-1/5616.
    coneq[9202]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,dot(A,c)))-1/39312.
    coneq[9203]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,dot(A,c)))-1/235872.
    coneq[9204]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,dot(A,c)))-1/1179360.
    coneq[9205]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,c)))-1/4717440.
    coneq[9206]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c)))-1/14152320.
    coneq[9207]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/28304640.
    coneq[9208]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c)))-1/9434880.
    coneq[9209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c)))-1/3538080.
    coneq[9210]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/7076160.
    coneq[9211]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c)))-1/2358720.
    coneq[9212]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c)))-1/4717440.
    coneq[9213]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,dot(A,c)))-1/943488.
    coneq[9214]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2830464.
    coneq[9215]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/5660928.
    coneq[9216]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1886976.
    coneq[9217]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,c)))-1/707616.
    coneq[9218]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1415232.
    coneq[9219]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,dot(A,c)))-1/471744.
    coneq[9220]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1415232.
    coneq[9221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2830464.
    coneq[9222]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/943488.
    coneq[9223]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,dot(A,c)))-1/196560.
    coneq[9224]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/786240.
    coneq[9225]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2358720.
    coneq[9226]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/4717440.
    coneq[9227]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1572480.
    coneq[9228]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/589680.
    coneq[9229]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1179360.
    coneq[9230]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/393120.
    coneq[9231]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/786240.
    coneq[9232]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,dot(A,c)))-1/157248.
    coneq[9233]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/471744.
    coneq[9234]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/943488.
    coneq[9235]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/314496.
    coneq[9236]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,dot(A,c)))-1/117936.
    coneq[9237]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/235872.
    coneq[9238]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,dot(A,c)))-1/78624.
    coneq[9239]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,c)))-1/353808.
    coneq[9240]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/707616.
    coneq[9241]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1415232.
    coneq[9242]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,dot(A,c)))-1/314496.
    coneq[9243]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/943488.
    coneq[9244]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1886976.
    coneq[9245]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/628992.
    coneq[9246]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/235872.
    coneq[9247]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/471744.
    coneq[9248]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/157248.
    coneq[9249]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/314496.
    coneq[9250]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,dot(A,c)))-1/33696.
    coneq[9251]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/168480.
    coneq[9252]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/673920.
    coneq[9253]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2021760.
    coneq[9254]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/4043520.
    coneq[9255]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1347840.
    coneq[9256]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/505440.
    coneq[9257]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1010880.
    coneq[9258]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/336960.
    coneq[9259]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/673920.
    coneq[9260]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/134784.
    coneq[9261]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/404352.
    coneq[9262]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/808704.
    coneq[9263]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/269568.
    coneq[9264]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/101088.
    coneq[9265]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/202176.
    coneq[9266]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/67392.
    coneq[9267]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/202176.
    coneq[9268]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/404352.
    coneq[9269]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/134784.
    coneq[9270]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,dot(A,c)))-1/28080.
    coneq[9271]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/112320.
    coneq[9272]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/336960.
    coneq[9273]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/673920.
    coneq[9274]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/224640.
    coneq[9275]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/84240.
    coneq[9276]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/168480.
    coneq[9277]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/56160.
    coneq[9278]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/112320.
    coneq[9279]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,dot(A,c)))-1/22464.
    coneq[9280]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/67392.
    coneq[9281]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/134784.
    coneq[9282]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/44928.
    coneq[9283]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,dot(A,c)))-1/16848.
    coneq[9284]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/33696.
    coneq[9285]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,dot(A,c)))-1/11232.
    coneq[9286]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,dot(A,c)))-1/67392.
    coneq[9287]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/202176.
    coneq[9288]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/404352.
    coneq[9289]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/134784.
    coneq[9290]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,dot(A,c)))-1/134784.
    coneq[9291]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/404352.
    coneq[9292]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/808704.
    coneq[9293]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/269568.
    coneq[9294]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,dot(A,c)))-1/56160.
    coneq[9295]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/224640.
    coneq[9296]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/673920.
    coneq[9297]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1347840.
    coneq[9298]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/449280.
    coneq[9299]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/168480.
    coneq[9300]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/336960.
    coneq[9301]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/112320.
    coneq[9302]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/224640.
    coneq[9303]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/50544.
    coneq[9304]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/101088.
    coneq[9305]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/202176.
    coneq[9306]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/44928.
    coneq[9307]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/134784.
    coneq[9308]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/269568.
    coneq[9309]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/89856.
    coneq[9310]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/33696.
    coneq[9311]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/67392.
    coneq[9312]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/22464.
    coneq[9313]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/67392.
    coneq[9314]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/134784.
    coneq[9315]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/44928.
    coneq[9316]=dot(b,dot(A,c*dot(A,c**6))*dot(A,dot(A,c)))-1/4914.
    coneq[9317]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,dot(A,c)))-1/29484.
    coneq[9318]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/147420.
    coneq[9319]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/589680.
    coneq[9320]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/1769040.
    coneq[9321]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/3538080.
    coneq[9322]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1179360.
    coneq[9323]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/442260.
    coneq[9324]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/884520.
    coneq[9325]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/294840.
    coneq[9326]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/589680.
    coneq[9327]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/117936.
    coneq[9328]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/353808.
    coneq[9329]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/707616.
    coneq[9330]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/235872.
    coneq[9331]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/88452.
    coneq[9332]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/176904.
    coneq[9333]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/58968.
    coneq[9334]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/176904.
    coneq[9335]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/353808.
    coneq[9336]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/117936.
    coneq[9337]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,dot(A,c)))-1/24570.
    coneq[9338]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/98280.
    coneq[9339]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/294840.
    coneq[9340]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/589680.
    coneq[9341]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/196560.
    coneq[9342]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/73710.
    coneq[9343]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/147420.
    coneq[9344]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/49140.
    coneq[9345]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/98280.
    coneq[9346]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c)))-1/19656.
    coneq[9347]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/58968.
    coneq[9348]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/117936.
    coneq[9349]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/39312.
    coneq[9350]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c)))-1/14742.
    coneq[9351]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/29484.
    coneq[9352]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,dot(A,c)))-1/9828.
    coneq[9353]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/44226.
    coneq[9354]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/88452.
    coneq[9355]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/176904.
    coneq[9356]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/39312.
    coneq[9357]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/117936.
    coneq[9358]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/235872.
    coneq[9359]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/78624.
    coneq[9360]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/29484.
    coneq[9361]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/58968.
    coneq[9362]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/19656.
    coneq[9363]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/39312.
    coneq[9364]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,dot(A,c)))-1/4212.
    coneq[9365]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/21060.
    coneq[9366]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/84240.
    coneq[9367]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/252720.
    coneq[9368]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/505440.
    coneq[9369]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/168480.
    coneq[9370]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/63180.
    coneq[9371]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/126360.
    coneq[9372]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/42120.
    coneq[9373]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/84240.
    coneq[9374]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/16848.
    coneq[9375]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/50544.
    coneq[9376]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/101088.
    coneq[9377]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/33696.
    coneq[9378]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/12636.
    coneq[9379]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/25272.
    coneq[9380]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/8424.
    coneq[9381]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/25272.
    coneq[9382]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/50544.
    coneq[9383]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/16848.
    coneq[9384]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,dot(A,c)))-1/3510.
    coneq[9385]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/14040.
    coneq[9386]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/42120.
    coneq[9387]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/84240.
    coneq[9388]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/28080.
    coneq[9389]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/10530.
    coneq[9390]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/21060.
    coneq[9391]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/7020.
    coneq[9392]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/14040.
    coneq[9393]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,dot(A,c)))-1/2808.
    coneq[9394]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/8424.
    coneq[9395]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/16848.
    coneq[9396]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/5616.
    coneq[9397]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,dot(A,c)))-1/2106.
    coneq[9398]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/4212.
    coneq[9399]=dot(b,dot(A,c**6*dot(A,c))*dot(A,dot(A,c)))-1/1404.
    coneq[9400]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,dot(A,c)))-1/11232.
    coneq[9401]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/33696.
    coneq[9402]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/67392.
    coneq[9403]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/22464.
    coneq[9404]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/101088.
    coneq[9405]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/202176.
    coneq[9406]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/67392.
    coneq[9407]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/404352.
    coneq[9408]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/134784.
    coneq[9409]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/44928.
    coneq[9410]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,dot(A,c)))-1/10530.
    coneq[9411]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/42120.
    coneq[9412]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/126360.
    coneq[9413]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/252720.
    coneq[9414]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/84240.
    coneq[9415]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/31590.
    coneq[9416]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/63180.
    coneq[9417]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/21060.
    coneq[9418]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/42120.
    coneq[9419]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,dot(A,c)))-1/21060.
    coneq[9420]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/84240.
    coneq[9421]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/252720.
    coneq[9422]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/505440.
    coneq[9423]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/168480.
    coneq[9424]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/63180.
    coneq[9425]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/126360.
    coneq[9426]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/42120.
    coneq[9427]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/84240.
    coneq[9428]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,dot(A,c)))-1/8424.
    coneq[9429]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/42120.
    coneq[9430]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/168480.
    coneq[9431]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/505440.
    coneq[9432]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1010880.
    coneq[9433]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/336960.
    coneq[9434]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/126360.
    coneq[9435]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/252720.
    coneq[9436]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/84240.
    coneq[9437]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/168480.
    coneq[9438]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/33696.
    coneq[9439]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/101088.
    coneq[9440]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/202176.
    coneq[9441]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/67392.
    coneq[9442]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/25272.
    coneq[9443]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/50544.
    coneq[9444]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/16848.
    coneq[9445]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/50544.
    coneq[9446]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/101088.
    coneq[9447]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/33696.
    coneq[9448]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c)))-1/8424.
    coneq[9449]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/25272.
    coneq[9450]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/50544.
    coneq[9451]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/16848.
    coneq[9452]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c)))-1/16848.
    coneq[9453]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/50544.
    coneq[9454]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/101088.
    coneq[9455]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/33696.
    coneq[9456]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,dot(A,c)))-1/7020.
    coneq[9457]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/28080.
    coneq[9458]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/84240.
    coneq[9459]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/168480.
    coneq[9460]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/56160.
    coneq[9461]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/21060.
    coneq[9462]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/42120.
    coneq[9463]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/14040.
    coneq[9464]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/28080.
    coneq[9465]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/6318.
    coneq[9466]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/12636.
    coneq[9467]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/25272.
    coneq[9468]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)))-1/5616.
    coneq[9469]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/16848.
    coneq[9470]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/33696.
    coneq[9471]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/11232.
    coneq[9472]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/4212.
    coneq[9473]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/8424.
    coneq[9474]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/2808.
    coneq[9475]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)))-1/11232.
    coneq[9476]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/33696.
    coneq[9477]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/67392.
    coneq[9478]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/22464.
    coneq[9479]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/12636.
    coneq[9480]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/25272.
    coneq[9481]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/50544.
    coneq[9482]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/8424.
    coneq[9483]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/16848.
    coneq[9484]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/5616.
    coneq[9485]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/11232.
    coneq[9486]=dot(b,dot(A,c**9)*dot(A,c))-1/260.
    coneq[9487]=dot(b,dot(A,dot(A,c**8))*dot(A,c))-1/2340.
    coneq[9488]=dot(b,dot(A,dot(A,dot(A,c**7)))*dot(A,c))-1/18720.
    coneq[9489]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*dot(A,c))-1/131040.
    coneq[9490]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*dot(A,c))-1/786240.
    coneq[9491]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*dot(A,c))-1/3931200.
    coneq[9492]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,c))-1/15724800.
    coneq[9493]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c))-1/47174400.
    coneq[9494]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/94348800.
    coneq[9495]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c))-1/31449600.
    coneq[9496]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c))-1/11793600.
    coneq[9497]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c))-1/23587200.
    coneq[9498]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c))-1/7862400.
    coneq[9499]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c))-1/15724800.
    coneq[9500]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*dot(A,c))-1/3144960.
    coneq[9501]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c))-1/9434880.
    coneq[9502]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/18869760.
    coneq[9503]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c))-1/6289920.
    coneq[9504]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,c))-1/2358720.
    coneq[9505]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c))-1/4717440.
    coneq[9506]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*dot(A,c))-1/1572480.
    coneq[9507]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c))-1/4717440.
    coneq[9508]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c))-1/9434880.
    coneq[9509]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c))-1/3144960.
    coneq[9510]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*dot(A,c))-1/655200.
    coneq[9511]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*dot(A,c))-1/2620800.
    coneq[9512]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/7862400.
    coneq[9513]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/15724800.
    coneq[9514]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/5241600.
    coneq[9515]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1965600.
    coneq[9516]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/3931200.
    coneq[9517]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1310400.
    coneq[9518]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2620800.
    coneq[9519]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*dot(A,c))-1/524160.
    coneq[9520]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,c))-1/1572480.
    coneq[9521]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3144960.
    coneq[9522]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,c))-1/1048320.
    coneq[9523]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*dot(A,c))-1/393120.
    coneq[9524]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*dot(A,c))-1/786240.
    coneq[9525]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*dot(A,c))-1/262080.
    coneq[9526]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,c))-1/1179360.
    coneq[9527]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c))-1/2358720.
    coneq[9528]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c))-1/4717440.
    coneq[9529]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,c))-1/1048320.
    coneq[9530]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c))-1/3144960.
    coneq[9531]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/6289920.
    coneq[9532]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c))-1/2096640.
    coneq[9533]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/786240.
    coneq[9534]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1572480.
    coneq[9535]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,c))-1/524160.
    coneq[9536]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1048320.
    coneq[9537]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*dot(A,c))-1/112320.
    coneq[9538]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*dot(A,c))-1/561600.
    coneq[9539]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/2246400.
    coneq[9540]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/6739200.
    coneq[9541]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/13478400.
    coneq[9542]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/4492800.
    coneq[9543]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1684800.
    coneq[9544]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/3369600.
    coneq[9545]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1123200.
    coneq[9546]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2246400.
    coneq[9547]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*dot(A,c))-1/449280.
    coneq[9548]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1347840.
    coneq[9549]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2695680.
    coneq[9550]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/898560.
    coneq[9551]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/336960.
    coneq[9552]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/673920.
    coneq[9553]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*dot(A,c))-1/224640.
    coneq[9554]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/673920.
    coneq[9555]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1347840.
    coneq[9556]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/449280.
    coneq[9557]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*dot(A,c))-1/93600.
    coneq[9558]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*dot(A,c))-1/374400.
    coneq[9559]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1123200.
    coneq[9560]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2246400.
    coneq[9561]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/748800.
    coneq[9562]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/280800.
    coneq[9563]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/561600.
    coneq[9564]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/187200.
    coneq[9565]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/374400.
    coneq[9566]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*dot(A,c))-1/74880.
    coneq[9567]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*dot(A,c))-1/224640.
    coneq[9568]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/449280.
    coneq[9569]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*dot(A,c))-1/149760.
    coneq[9570]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*dot(A,c))-1/56160.
    coneq[9571]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*dot(A,c))-1/112320.
    coneq[9572]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*dot(A,c))-1/37440.
    coneq[9573]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*dot(A,c))-1/224640.
    coneq[9574]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,c))-1/673920.
    coneq[9575]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1347840.
    coneq[9576]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,c))-1/449280.
    coneq[9577]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*dot(A,c))-1/449280.
    coneq[9578]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,c))-1/1347840.
    coneq[9579]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2695680.
    coneq[9580]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c))-1/898560.
    coneq[9581]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*dot(A,c))-1/187200.
    coneq[9582]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,c))-1/748800.
    coneq[9583]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2246400.
    coneq[9584]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4492800.
    coneq[9585]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1497600.
    coneq[9586]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/561600.
    coneq[9587]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1123200.
    coneq[9588]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/374400.
    coneq[9589]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/748800.
    coneq[9590]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/168480.
    coneq[9591]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/336960.
    coneq[9592]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/673920.
    coneq[9593]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*dot(A,c))-1/149760.
    coneq[9594]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/449280.
    coneq[9595]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/898560.
    coneq[9596]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/299520.
    coneq[9597]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/112320.
    coneq[9598]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/224640.
    coneq[9599]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*dot(A,c))-1/74880.
    coneq[9600]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/224640.
    coneq[9601]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/449280.
    coneq[9602]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/149760.
    coneq[9603]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*dot(A,c))-1/16380.
    coneq[9604]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*dot(A,c))-1/98280.
    coneq[9605]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/491400.
    coneq[9606]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/1965600.
    coneq[9607]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/5896800.
    coneq[9608]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/11793600.
    coneq[9609]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/3931200.
    coneq[9610]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1474200.
    coneq[9611]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/2948400.
    coneq[9612]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/982800.
    coneq[9613]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/1965600.
    coneq[9614]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/393120.
    coneq[9615]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1179360.
    coneq[9616]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2358720.
    coneq[9617]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/786240.
    coneq[9618]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/294840.
    coneq[9619]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/589680.
    coneq[9620]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/196560.
    coneq[9621]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/589680.
    coneq[9622]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1179360.
    coneq[9623]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/393120.
    coneq[9624]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*dot(A,c))-1/81900.
    coneq[9625]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/327600.
    coneq[9626]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/982800.
    coneq[9627]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1965600.
    coneq[9628]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/655200.
    coneq[9629]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/245700.
    coneq[9630]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/491400.
    coneq[9631]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/163800.
    coneq[9632]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/327600.
    coneq[9633]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/65520.
    coneq[9634]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/196560.
    coneq[9635]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/393120.
    coneq[9636]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/131040.
    coneq[9637]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/49140.
    coneq[9638]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/98280.
    coneq[9639]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*dot(A,c))-1/32760.
    coneq[9640]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/147420.
    coneq[9641]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/294840.
    coneq[9642]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/589680.
    coneq[9643]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/131040.
    coneq[9644]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/393120.
    coneq[9645]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/786240.
    coneq[9646]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/262080.
    coneq[9647]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/98280.
    coneq[9648]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/196560.
    coneq[9649]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/65520.
    coneq[9650]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/131040.
    coneq[9651]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*dot(A,c))-1/14040.
    coneq[9652]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*dot(A,c))-1/70200.
    coneq[9653]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/280800.
    coneq[9654]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/842400.
    coneq[9655]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1684800.
    coneq[9656]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/561600.
    coneq[9657]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/210600.
    coneq[9658]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/421200.
    coneq[9659]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/140400.
    coneq[9660]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/280800.
    coneq[9661]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*dot(A,c))-1/56160.
    coneq[9662]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/168480.
    coneq[9663]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/336960.
    coneq[9664]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/112320.
    coneq[9665]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/42120.
    coneq[9666]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/84240.
    coneq[9667]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*dot(A,c))-1/28080.
    coneq[9668]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/84240.
    coneq[9669]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/168480.
    coneq[9670]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/56160.
    coneq[9671]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*dot(A,c))-1/11700.
    coneq[9672]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*dot(A,c))-1/46800.
    coneq[9673]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/140400.
    coneq[9674]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/280800.
    coneq[9675]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/93600.
    coneq[9676]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*dot(A,c))-1/35100.
    coneq[9677]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/70200.
    coneq[9678]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*dot(A,c))-1/23400.
    coneq[9679]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/46800.
    coneq[9680]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*dot(A,c))-1/9360.
    coneq[9681]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*dot(A,c))-1/28080.
    coneq[9682]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/56160.
    coneq[9683]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*dot(A,c))-1/18720.
    coneq[9684]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*dot(A,c))-1/7020.
    coneq[9685]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*dot(A,c))-1/14040.
    coneq[9686]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*dot(A,c))-1/4680.
    coneq[9687]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*dot(A,c))-1/37440.
    coneq[9688]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*dot(A,c))-1/112320.
    coneq[9689]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/224640.
    coneq[9690]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*dot(A,c))-1/74880.
    coneq[9691]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*dot(A,c))-1/336960.
    coneq[9692]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/673920.
    coneq[9693]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*dot(A,c))-1/224640.
    coneq[9694]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/1347840.
    coneq[9695]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*dot(A,c))-1/449280.
    coneq[9696]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/149760.
    coneq[9697]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*dot(A,c))-1/35100.
    coneq[9698]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*dot(A,c))-1/140400.
    coneq[9699]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/421200.
    coneq[9700]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/842400.
    coneq[9701]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/280800.
    coneq[9702]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/105300.
    coneq[9703]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/210600.
    coneq[9704]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/70200.
    coneq[9705]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/140400.
    coneq[9706]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*dot(A,c))-1/70200.
    coneq[9707]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*dot(A,c))-1/280800.
    coneq[9708]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/842400.
    coneq[9709]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1684800.
    coneq[9710]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/561600.
    coneq[9711]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,c))-1/210600.
    coneq[9712]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/421200.
    coneq[9713]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,c))-1/140400.
    coneq[9714]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/280800.
    coneq[9715]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*dot(A,c))-1/28080.
    coneq[9716]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*dot(A,c))-1/140400.
    coneq[9717]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/561600.
    coneq[9718]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1684800.
    coneq[9719]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3369600.
    coneq[9720]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1123200.
    coneq[9721]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/421200.
    coneq[9722]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/842400.
    coneq[9723]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/280800.
    coneq[9724]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/561600.
    coneq[9725]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*dot(A,c))-1/112320.
    coneq[9726]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/336960.
    coneq[9727]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/673920.
    coneq[9728]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/224640.
    coneq[9729]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/84240.
    coneq[9730]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/168480.
    coneq[9731]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*dot(A,c))-1/56160.
    coneq[9732]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/168480.
    coneq[9733]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/336960.
    coneq[9734]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/112320.
    coneq[9735]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/28080.
    coneq[9736]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/84240.
    coneq[9737]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/168480.
    coneq[9738]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/56160.
    coneq[9739]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/56160.
    coneq[9740]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/168480.
    coneq[9741]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/336960.
    coneq[9742]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/112320.
    coneq[9743]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*dot(A,c))-1/23400.
    coneq[9744]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/93600.
    coneq[9745]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/280800.
    coneq[9746]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/561600.
    coneq[9747]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/187200.
    coneq[9748]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/70200.
    coneq[9749]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/140400.
    coneq[9750]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/46800.
    coneq[9751]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/93600.
    coneq[9752]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/21060.
    coneq[9753]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/42120.
    coneq[9754]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/84240.
    coneq[9755]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/18720.
    coneq[9756]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/56160.
    coneq[9757]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/112320.
    coneq[9758]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/37440.
    coneq[9759]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/14040.
    coneq[9760]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/28080.
    coneq[9761]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*dot(A,c))-1/9360.
    coneq[9762]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/37440.
    coneq[9763]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/112320.
    coneq[9764]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/224640.
    coneq[9765]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/74880.
    coneq[9766]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/42120.
    coneq[9767]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/84240.
    coneq[9768]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/168480.
    coneq[9769]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/28080.
    coneq[9770]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/56160.
    coneq[9771]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/18720.
    coneq[9772]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/37440.
    coneq[9773]=dot(b,dot(A,c*dot(A,c**7))*dot(A,c))-1/2080.
    coneq[9774]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*dot(A,c))-1/14560.
    coneq[9775]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*dot(A,c))-1/87360.
    coneq[9776]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/436800.
    coneq[9777]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/1747200.
    coneq[9778]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/5241600.
    coneq[9779]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/10483200.
    coneq[9780]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/3494400.
    coneq[9781]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1310400.
    coneq[9782]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/2620800.
    coneq[9783]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/873600.
    coneq[9784]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/1747200.
    coneq[9785]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/349440.
    coneq[9786]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1048320.
    coneq[9787]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2096640.
    coneq[9788]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/698880.
    coneq[9789]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/262080.
    coneq[9790]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/524160.
    coneq[9791]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/174720.
    coneq[9792]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/524160.
    coneq[9793]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1048320.
    coneq[9794]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/349440.
    coneq[9795]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*dot(A,c))-1/72800.
    coneq[9796]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/291200.
    coneq[9797]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/873600.
    coneq[9798]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1747200.
    coneq[9799]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/582400.
    coneq[9800]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/218400.
    coneq[9801]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/436800.
    coneq[9802]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/145600.
    coneq[9803]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/291200.
    coneq[9804]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/58240.
    coneq[9805]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/174720.
    coneq[9806]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/349440.
    coneq[9807]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/116480.
    coneq[9808]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/43680.
    coneq[9809]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/87360.
    coneq[9810]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*dot(A,c))-1/29120.
    coneq[9811]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/131040.
    coneq[9812]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/262080.
    coneq[9813]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/524160.
    coneq[9814]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/116480.
    coneq[9815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/349440.
    coneq[9816]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/698880.
    coneq[9817]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/232960.
    coneq[9818]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/87360.
    coneq[9819]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/174720.
    coneq[9820]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/58240.
    coneq[9821]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/116480.
    coneq[9822]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*dot(A,c))-1/12480.
    coneq[9823]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*dot(A,c))-1/62400.
    coneq[9824]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/249600.
    coneq[9825]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/748800.
    coneq[9826]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1497600.
    coneq[9827]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/499200.
    coneq[9828]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/187200.
    coneq[9829]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/374400.
    coneq[9830]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/124800.
    coneq[9831]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/249600.
    coneq[9832]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c))-1/49920.
    coneq[9833]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/149760.
    coneq[9834]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/299520.
    coneq[9835]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/99840.
    coneq[9836]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/37440.
    coneq[9837]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/74880.
    coneq[9838]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c))-1/24960.
    coneq[9839]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/74880.
    coneq[9840]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/149760.
    coneq[9841]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/49920.
    coneq[9842]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*dot(A,c))-1/10400.
    coneq[9843]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c))-1/41600.
    coneq[9844]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/124800.
    coneq[9845]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/249600.
    coneq[9846]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/83200.
    coneq[9847]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c))-1/31200.
    coneq[9848]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/62400.
    coneq[9849]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c))-1/20800.
    coneq[9850]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/41600.
    coneq[9851]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*dot(A,c))-1/8320.
    coneq[9852]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c))-1/24960.
    coneq[9853]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/49920.
    coneq[9854]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c))-1/16640.
    coneq[9855]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*dot(A,c))-1/6240.
    coneq[9856]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*dot(A,c))-1/12480.
    coneq[9857]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*dot(A,c))-1/4160.
    coneq[9858]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/24960.
    coneq[9859]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/74880.
    coneq[9860]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/149760.
    coneq[9861]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/49920.
    coneq[9862]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/49920.
    coneq[9863]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/149760.
    coneq[9864]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/299520.
    coneq[9865]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/99840.
    coneq[9866]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c))-1/20800.
    coneq[9867]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/83200.
    coneq[9868]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/249600.
    coneq[9869]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/499200.
    coneq[9870]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/166400.
    coneq[9871]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/62400.
    coneq[9872]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/124800.
    coneq[9873]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/41600.
    coneq[9874]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/83200.
    coneq[9875]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/18720.
    coneq[9876]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/37440.
    coneq[9877]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/74880.
    coneq[9878]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/16640.
    coneq[9879]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/49920.
    coneq[9880]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/99840.
    coneq[9881]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/33280.
    coneq[9882]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/12480.
    coneq[9883]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/24960.
    coneq[9884]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c))-1/8320.
    coneq[9885]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/24960.
    coneq[9886]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/49920.
    coneq[9887]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/16640.
    coneq[9888]=dot(b,dot(A,c**2*dot(A,c**6))*dot(A,c))-1/1820.
    coneq[9889]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*dot(A,c))-1/10920.
    coneq[9890]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/54600.
    coneq[9891]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/218400.
    coneq[9892]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/655200.
    coneq[9893]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1310400.
    coneq[9894]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/436800.
    coneq[9895]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/163800.
    coneq[9896]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/327600.
    coneq[9897]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/109200.
    coneq[9898]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/218400.
    coneq[9899]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/43680.
    coneq[9900]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/131040.
    coneq[9901]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/262080.
    coneq[9902]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/87360.
    coneq[9903]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/32760.
    coneq[9904]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/65520.
    coneq[9905]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/21840.
    coneq[9906]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/65520.
    coneq[9907]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/131040.
    coneq[9908]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/43680.
    coneq[9909]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*dot(A,c))-1/9100.
    coneq[9910]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/36400.
    coneq[9911]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/109200.
    coneq[9912]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/218400.
    coneq[9913]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/72800.
    coneq[9914]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/27300.
    coneq[9915]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/54600.
    coneq[9916]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/18200.
    coneq[9917]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/36400.
    coneq[9918]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/7280.
    coneq[9919]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/21840.
    coneq[9920]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/43680.
    coneq[9921]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/14560.
    coneq[9922]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/5460.
    coneq[9923]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/10920.
    coneq[9924]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*dot(A,c))-1/3640.
    coneq[9925]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/16380.
    coneq[9926]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/32760.
    coneq[9927]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/65520.
    coneq[9928]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/14560.
    coneq[9929]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/43680.
    coneq[9930]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/87360.
    coneq[9931]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/29120.
    coneq[9932]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/10920.
    coneq[9933]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/21840.
    coneq[9934]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/7280.
    coneq[9935]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/14560.
    coneq[9936]=dot(b,dot(A,c**3*dot(A,c**5))*dot(A,c))-1/1560.
    coneq[9937]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*dot(A,c))-1/7800.
    coneq[9938]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/31200.
    coneq[9939]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/93600.
    coneq[9940]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/187200.
    coneq[9941]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/62400.
    coneq[9942]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/23400.
    coneq[9943]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/46800.
    coneq[9944]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/15600.
    coneq[9945]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/31200.
    coneq[9946]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*dot(A,c))-1/6240.
    coneq[9947]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/18720.
    coneq[9948]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/37440.
    coneq[9949]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/12480.
    coneq[9950]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/4680.
    coneq[9951]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/9360.
    coneq[9952]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*dot(A,c))-1/3120.
    coneq[9953]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/9360.
    coneq[9954]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/18720.
    coneq[9955]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/6240.
    coneq[9956]=dot(b,dot(A,c**4*dot(A,c**4))*dot(A,c))-1/1300.
    coneq[9957]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*dot(A,c))-1/5200.
    coneq[9958]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/15600.
    coneq[9959]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/31200.
    coneq[9960]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/10400.
    coneq[9961]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*dot(A,c))-1/3900.
    coneq[9962]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/7800.
    coneq[9963]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*dot(A,c))-1/2600.
    coneq[9964]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/5200.
    coneq[9965]=dot(b,dot(A,c**5*dot(A,c**3))*dot(A,c))-1/1040.
    coneq[9966]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*dot(A,c))-1/3120.
    coneq[9967]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/6240.
    coneq[9968]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*dot(A,c))-1/2080.
    coneq[9969]=dot(b,dot(A,c**6*dot(A,c**2))*dot(A,c))-1/780.
    coneq[9970]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*dot(A,c))-1/1560.
    coneq[9971]=dot(b,dot(A,c**7*dot(A,c))*dot(A,c))-1/520.
    coneq[9972]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*dot(A,c))-1/5200.
    coneq[9973]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*dot(A,c))-1/20800.
    coneq[9974]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/62400.
    coneq[9975]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/124800.
    coneq[9976]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/41600.
    coneq[9977]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/15600.
    coneq[9978]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/31200.
    coneq[9979]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/10400.
    coneq[9980]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/20800.
    coneq[9981]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*dot(A,c))-1/15600.
    coneq[9982]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*dot(A,c))-1/62400.
    coneq[9983]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/187200.
    coneq[9984]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/374400.
    coneq[9985]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/124800.
    coneq[9986]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/46800.
    coneq[9987]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/93600.
    coneq[9988]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/31200.
    coneq[9989]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/62400.
    coneq[9990]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*dot(A,c))-1/31200.
    coneq[9991]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*dot(A,c))-1/124800.
    coneq[9992]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/374400.
    coneq[9993]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/748800.
    coneq[9994]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/249600.
    coneq[9995]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/93600.
    coneq[9996]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/187200.
    coneq[9997]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/62400.
    coneq[9998]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/124800.
    coneq[9999]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*dot(A,c))-1/10400.
    coneq[10000]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c))-1/41600.
    coneq[10001]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/124800.
    coneq[10002]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/249600.
    coneq[10003]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/83200.
    coneq[10004]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/31200.
    coneq[10005]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/62400.
    coneq[10006]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/20800.
    coneq[10007]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/41600.
    coneq[10008]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*dot(A,c))-1/4680.
    coneq[10009]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*dot(A,c))-1/23400.
    coneq[10010]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/93600.
    coneq[10011]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/280800.
    coneq[10012]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/561600.
    coneq[10013]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/187200.
    coneq[10014]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/70200.
    coneq[10015]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/140400.
    coneq[10016]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/46800.
    coneq[10017]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/93600.
    coneq[10018]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/18720.
    coneq[10019]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/56160.
    coneq[10020]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/112320.
    coneq[10021]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/37440.
    coneq[10022]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/14040.
    coneq[10023]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/28080.
    coneq[10024]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/9360.
    coneq[10025]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/28080.
    coneq[10026]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/56160.
    coneq[10027]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/18720.
    coneq[10028]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*dot(A,c))-1/9360.
    coneq[10029]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*dot(A,c))-1/46800.
    coneq[10030]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/187200.
    coneq[10031]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/561600.
    coneq[10032]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1123200.
    coneq[10033]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/374400.
    coneq[10034]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/140400.
    coneq[10035]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/280800.
    coneq[10036]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/93600.
    coneq[10037]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/187200.
    coneq[10038]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*dot(A,c))-1/37440.
    coneq[10039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/112320.
    coneq[10040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/224640.
    coneq[10041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/74880.
    coneq[10042]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/28080.
    coneq[10043]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/56160.
    coneq[10044]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*dot(A,c))-1/18720.
    coneq[10045]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/56160.
    coneq[10046]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/112320.
    coneq[10047]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/37440.
    coneq[10048]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*dot(A,c))-1/3640.
    coneq[10049]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*dot(A,c))-1/21840.
    coneq[10050]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/109200.
    coneq[10051]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/436800.
    coneq[10052]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1310400.
    coneq[10053]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2620800.
    coneq[10054]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/873600.
    coneq[10055]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/327600.
    coneq[10056]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/655200.
    coneq[10057]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/218400.
    coneq[10058]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/436800.
    coneq[10059]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/87360.
    coneq[10060]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/262080.
    coneq[10061]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/524160.
    coneq[10062]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/174720.
    coneq[10063]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/65520.
    coneq[10064]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/131040.
    coneq[10065]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/43680.
    coneq[10066]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/131040.
    coneq[10067]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/262080.
    coneq[10068]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/87360.
    coneq[10069]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*dot(A,c))-1/18200.
    coneq[10070]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/72800.
    coneq[10071]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/218400.
    coneq[10072]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/436800.
    coneq[10073]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/145600.
    coneq[10074]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/54600.
    coneq[10075]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/109200.
    coneq[10076]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/36400.
    coneq[10077]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/72800.
    coneq[10078]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/14560.
    coneq[10079]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/43680.
    coneq[10080]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/87360.
    coneq[10081]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/29120.
    coneq[10082]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/10920.
    coneq[10083]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/21840.
    coneq[10084]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*dot(A,c))-1/7280.
    coneq[10085]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/32760.
    coneq[10086]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/65520.
    coneq[10087]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/131040.
    coneq[10088]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/29120.
    coneq[10089]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/87360.
    coneq[10090]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/174720.
    coneq[10091]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/58240.
    coneq[10092]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/21840.
    coneq[10093]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/43680.
    coneq[10094]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/14560.
    coneq[10095]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/29120.
    coneq[10096]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*dot(A,c))-1/4160.
    coneq[10097]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c))-1/12480.
    coneq[10098]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/24960.
    coneq[10099]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c))-1/8320.
    coneq[10100]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c))-1/37440.
    coneq[10101]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/74880.
    coneq[10102]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c))-1/24960.
    coneq[10103]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/149760.
    coneq[10104]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c))-1/49920.
    coneq[10105]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/16640.
    coneq[10106]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*dot(A,c))-1/3900.
    coneq[10107]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c))-1/15600.
    coneq[10108]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/46800.
    coneq[10109]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/93600.
    coneq[10110]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/31200.
    coneq[10111]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/11700.
    coneq[10112]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/23400.
    coneq[10113]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/7800.
    coneq[10114]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/15600.
    coneq[10115]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*dot(A,c))-1/7800.
    coneq[10116]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c))-1/31200.
    coneq[10117]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/93600.
    coneq[10118]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/187200.
    coneq[10119]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/62400.
    coneq[10120]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/23400.
    coneq[10121]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/46800.
    coneq[10122]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/15600.
    coneq[10123]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/31200.
    coneq[10124]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*dot(A,c))-1/3120.
    coneq[10125]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c))-1/15600.
    coneq[10126]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/62400.
    coneq[10127]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/187200.
    coneq[10128]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/374400.
    coneq[10129]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/124800.
    coneq[10130]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/46800.
    coneq[10131]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/93600.
    coneq[10132]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/31200.
    coneq[10133]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/62400.
    coneq[10134]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/12480.
    coneq[10135]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/37440.
    coneq[10136]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/74880.
    coneq[10137]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/24960.
    coneq[10138]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/9360.
    coneq[10139]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/18720.
    coneq[10140]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/6240.
    coneq[10141]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/18720.
    coneq[10142]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/37440.
    coneq[10143]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/12480.
    coneq[10144]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/3120.
    coneq[10145]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/9360.
    coneq[10146]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/18720.
    coneq[10147]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/6240.
    coneq[10148]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/6240.
    coneq[10149]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/18720.
    coneq[10150]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/37440.
    coneq[10151]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/12480.
    coneq[10152]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*dot(A,c))-1/2600.
    coneq[10153]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c))-1/10400.
    coneq[10154]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/31200.
    coneq[10155]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/62400.
    coneq[10156]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/20800.
    coneq[10157]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/7800.
    coneq[10158]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/15600.
    coneq[10159]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/5200.
    coneq[10160]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/10400.
    coneq[10161]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/2340.
    coneq[10162]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/4680.
    coneq[10163]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/9360.
    coneq[10164]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*dot(A,c))-1/2080.
    coneq[10165]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/6240.
    coneq[10166]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/12480.
    coneq[10167]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/4160.
    coneq[10168]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*dot(A,c))-1/1560.
    coneq[10169]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/3120.
    coneq[10170]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*dot(A,c))-1/1040.
    coneq[10171]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*dot(A,c))-1/5200.
    coneq[10172]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c))-1/20800.
    coneq[10173]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/62400.
    coneq[10174]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/124800.
    coneq[10175]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/41600.
    coneq[10176]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/15600.
    coneq[10177]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/31200.
    coneq[10178]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/10400.
    coneq[10179]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/20800.
    coneq[10180]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/6240.
    coneq[10181]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/18720.
    coneq[10182]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/37440.
    coneq[10183]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/12480.
    coneq[10184]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/12480.
    coneq[10185]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/37440.
    coneq[10186]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/74880.
    coneq[10187]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/24960.
    coneq[10188]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/7020.
    coneq[10189]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/14040.
    coneq[10190]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/28080.
    coneq[10191]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/56160.
    coneq[10192]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c))-1/4160.
    coneq[10193]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/12480.
    coneq[10194]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/24960.
    coneq[10195]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/8320.
    coneq[10196]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/4680.
    coneq[10197]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/9360.
    coneq[10198]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/18720.
    coneq[10199]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c))-1/3120.
    coneq[10200]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/6240.
    coneq[10201]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/2080.
    coneq[10202]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c))-1/6240.
    coneq[10203]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/12480.
    coneq[10204]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/4160.
    coneq[10205]=dot(b,dot(A,c**5)*dot(A,c**4)*c)-1/390.
    coneq[10206]=dot(b,dot(A,dot(A,c**4))*dot(A,c**4)*c)-1/1950.
    coneq[10207]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**4)*c)-1/7800.
    coneq[10208]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**4)*c)-1/23400.
    coneq[10209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4)*c)-1/46800.
    coneq[10210]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**4)*c)-1/15600.
    coneq[10211]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**4)*c)-1/5850.
    coneq[10212]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**4)*c)-1/11700.
    coneq[10213]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**4)*c)-1/3900.
    coneq[10214]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4)*c)-1/7800.
    coneq[10215]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**4)*c)-1/1560.
    coneq[10216]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**4)*c)-1/4680.
    coneq[10217]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c)-1/9360.
    coneq[10218]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**4)*c)-1/3120.
    coneq[10219]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**4)*c)-1/1170.
    coneq[10220]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/2340.
    coneq[10221]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**4)*c)-1/780.
    coneq[10222]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**4)*c)-1/2340.
    coneq[10223]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/4680.
    coneq[10224]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**4)*c)-1/1560.
    coneq[10225]=dot(b,dot(A,c**5)*dot(A,dot(A,c**3))*c)-1/1560.
    coneq[10226]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**3))*c)-1/7800.
    coneq[10227]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**3))*c)-1/31200.
    coneq[10228]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3))*c)-1/93600.
    coneq[10229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3))*c)-1/187200.
    coneq[10230]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3))*c)-1/62400.
    coneq[10231]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/23400.
    coneq[10232]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/46800.
    coneq[10233]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/15600.
    coneq[10234]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/31200.
    coneq[10235]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**3))*c)-1/6240.
    coneq[10236]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/18720.
    coneq[10237]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/37440.
    coneq[10238]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/12480.
    coneq[10239]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**3))*c)-1/4680.
    coneq[10240]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/9360.
    coneq[10241]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**3))*c)-1/3120.
    coneq[10242]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3))*c)-1/9360.
    coneq[10243]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/18720.
    coneq[10244]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c)-1/6240.
    coneq[10245]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c**2)))*c)-1/4680.
    coneq[10246]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c**2)))*c)-1/23400.
    coneq[10247]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2)))*c)-1/93600.
    coneq[10248]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2)))*c)-1/280800.
    coneq[10249]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*c)-1/561600.
    coneq[10250]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/187200.
    coneq[10251]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/70200.
    coneq[10252]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/140400.
    coneq[10253]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/46800.
    coneq[10254]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/93600.
    coneq[10255]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))*c)-1/18720.
    coneq[10256]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/56160.
    coneq[10257]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/112320.
    coneq[10258]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/37440.
    coneq[10259]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c)-1/14040.
    coneq[10260]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/28080.
    coneq[10261]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/9360.
    coneq[10262]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c)-1/28080.
    coneq[10263]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/56160.
    coneq[10264]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/18720.
    coneq[10265]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/9360.
    coneq[10266]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/46800.
    coneq[10267]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/187200.
    coneq[10268]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/561600.
    coneq[10269]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/1123200.
    coneq[10270]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/374400.
    coneq[10271]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/140400.
    coneq[10272]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/280800.
    coneq[10273]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/93600.
    coneq[10274]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/187200.
    coneq[10275]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/37440.
    coneq[10276]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/112320.
    coneq[10277]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/224640.
    coneq[10278]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/74880.
    coneq[10279]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/28080.
    coneq[10280]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/56160.
    coneq[10281]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/18720.
    coneq[10282]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/56160.
    coneq[10283]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/112320.
    coneq[10284]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/37440.
    coneq[10285]=dot(b,dot(A,c**5)*dot(A,dot(A,c*dot(A,c)))*c)-1/3120.
    coneq[10286]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c*dot(A,c)))*c)-1/15600.
    coneq[10287]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c)))*c)-1/62400.
    coneq[10288]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c)))*c)-1/187200.
    coneq[10289]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*c)-1/374400.
    coneq[10290]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/124800.
    coneq[10291]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/46800.
    coneq[10292]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/93600.
    coneq[10293]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/31200.
    coneq[10294]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/62400.
    coneq[10295]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))*c)-1/12480.
    coneq[10296]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/37440.
    coneq[10297]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/74880.
    coneq[10298]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/24960.
    coneq[10299]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c)-1/9360.
    coneq[10300]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/18720.
    coneq[10301]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/6240.
    coneq[10302]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c)-1/18720.
    coneq[10303]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/37440.
    coneq[10304]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/12480.
    coneq[10305]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c**2))*c)-1/1170.
    coneq[10306]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c**2))*c)-1/5850.
    coneq[10307]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2))*c)-1/23400.
    coneq[10308]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2))*c)-1/70200.
    coneq[10309]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2))*c)-1/140400.
    coneq[10310]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/46800.
    coneq[10311]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/17550.
    coneq[10312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/35100.
    coneq[10313]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/11700.
    coneq[10314]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/23400.
    coneq[10315]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**2))*c)-1/4680.
    coneq[10316]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/14040.
    coneq[10317]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/28080.
    coneq[10318]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/9360.
    coneq[10319]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c**2))*c)-1/3510.
    coneq[10320]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/7020.
    coneq[10321]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/2340.
    coneq[10322]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2))*c)-1/7020.
    coneq[10323]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/14040.
    coneq[10324]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/4680.
    coneq[10325]=dot(b,dot(A,c**5)*dot(A,c*dot(A,dot(A,c)))*c)-1/2340.
    coneq[10326]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,dot(A,c)))*c)-1/11700.
    coneq[10327]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c)))*c)-1/46800.
    coneq[10328]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c)))*c)-1/140400.
    coneq[10329]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*c)-1/280800.
    coneq[10330]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/93600.
    coneq[10331]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/35100.
    coneq[10332]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/70200.
    coneq[10333]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/23400.
    coneq[10334]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/46800.
    coneq[10335]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))*c)-1/9360.
    coneq[10336]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/28080.
    coneq[10337]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/56160.
    coneq[10338]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/18720.
    coneq[10339]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c)-1/7020.
    coneq[10340]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/14040.
    coneq[10341]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/4680.
    coneq[10342]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c)-1/14040.
    coneq[10343]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/28080.
    coneq[10344]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/9360.
    coneq[10345]=dot(b,dot(A,c**5)*dot(A,c**2*dot(A,c))*c)-1/780.
    coneq[10346]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2*dot(A,c))*c)-1/3900.
    coneq[10347]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c))*c)-1/15600.
    coneq[10348]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c))*c)-1/46800.
    coneq[10349]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c))*c)-1/93600.
    coneq[10350]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/31200.
    coneq[10351]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/11700.
    coneq[10352]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/23400.
    coneq[10353]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/7800.
    coneq[10354]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/15600.
    coneq[10355]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2*dot(A,c))*c)-1/3120.
    coneq[10356]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/9360.
    coneq[10357]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/18720.
    coneq[10358]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/6240.
    coneq[10359]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c))*c)-1/2340.
    coneq[10360]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/4680.
    coneq[10361]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/1560.
    coneq[10362]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c))*c)-1/4680.
    coneq[10363]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/9360.
    coneq[10364]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/3120.
    coneq[10365]=dot(b,dot(A,c**5)*dot(A,dot(A,c)*dot(A,c))*c)-1/1560.
    coneq[10366]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c)*dot(A,c))*c)-1/7800.
    coneq[10367]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c))*c)-1/31200.
    coneq[10368]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c))*c)-1/93600.
    coneq[10369]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*c)-1/187200.
    coneq[10370]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/62400.
    coneq[10371]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/23400.
    coneq[10372]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/46800.
    coneq[10373]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/15600.
    coneq[10374]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/31200.
    coneq[10375]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))*c)-1/6240.
    coneq[10376]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/18720.
    coneq[10377]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/37440.
    coneq[10378]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/12480.
    coneq[10379]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c)-1/4680.
    coneq[10380]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/9360.
    coneq[10381]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c)-1/3120.
    coneq[10382]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c)-1/9360.
    coneq[10383]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/18720.
    coneq[10384]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c)-1/6240.
    coneq[10385]=dot(b,dot(A,c**6)*dot(A,c**3)*c)-1/364.
    coneq[10386]=dot(b,dot(A,dot(A,c**5))*dot(A,c**3)*c)-1/2184.
    coneq[10387]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**3)*c)-1/10920.
    coneq[10388]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**3)*c)-1/43680.
    coneq[10389]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3)*c)-1/131040.
    coneq[10390]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3)*c)-1/262080.
    coneq[10391]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3)*c)-1/87360.
    coneq[10392]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3)*c)-1/32760.
    coneq[10393]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/65520.
    coneq[10394]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3)*c)-1/21840.
    coneq[10395]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3)*c)-1/43680.
    coneq[10396]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**3)*c)-1/8736.
    coneq[10397]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/26208.
    coneq[10398]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/52416.
    coneq[10399]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/17472.
    coneq[10400]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**3)*c)-1/6552.
    coneq[10401]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/13104.
    coneq[10402]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**3)*c)-1/4368.
    coneq[10403]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3)*c)-1/13104.
    coneq[10404]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/26208.
    coneq[10405]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/8736.
    coneq[10406]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**3)*c)-1/1820.
    coneq[10407]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**3)*c)-1/7280.
    coneq[10408]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/21840.
    coneq[10409]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/43680.
    coneq[10410]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/14560.
    coneq[10411]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**3)*c)-1/5460.
    coneq[10412]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/10920.
    coneq[10413]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**3)*c)-1/3640.
    coneq[10414]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/7280.
    coneq[10415]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**3)*c)-1/1456.
    coneq[10416]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/4368.
    coneq[10417]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/8736.
    coneq[10418]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/2912.
    coneq[10419]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**3)*c)-1/1092.
    coneq[10420]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/2184.
    coneq[10421]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**3)*c)-1/728.
    coneq[10422]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**3)*c)-1/3276.
    coneq[10423]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/6552.
    coneq[10424]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/13104.
    coneq[10425]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**3)*c)-1/2912.
    coneq[10426]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/8736.
    coneq[10427]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/17472.
    coneq[10428]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/5824.
    coneq[10429]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**3)*c)-1/2184.
    coneq[10430]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/4368.
    coneq[10431]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**3)*c)-1/1456.
    coneq[10432]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3)*c)-1/2912.
    coneq[10433]=dot(b,dot(A,c**6)*dot(A,dot(A,c**2))*c)-1/1092.
    coneq[10434]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**2))*c)-1/6552.
    coneq[10435]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**2))*c)-1/32760.
    coneq[10436]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2))*c)-1/131040.
    coneq[10437]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2))*c)-1/393120.
    coneq[10438]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*c)-1/786240.
    coneq[10439]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/262080.
    coneq[10440]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/98280.
    coneq[10441]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/196560.
    coneq[10442]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/65520.
    coneq[10443]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/131040.
    coneq[10444]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/26208.
    coneq[10445]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/78624.
    coneq[10446]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/157248.
    coneq[10447]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/52416.
    coneq[10448]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/19656.
    coneq[10449]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/39312.
    coneq[10450]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/13104.
    coneq[10451]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/39312.
    coneq[10452]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/78624.
    coneq[10453]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/26208.
    coneq[10454]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**2))*c)-1/5460.
    coneq[10455]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/21840.
    coneq[10456]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/65520.
    coneq[10457]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/131040.
    coneq[10458]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/43680.
    coneq[10459]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/16380.
    coneq[10460]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/32760.
    coneq[10461]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/10920.
    coneq[10462]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/21840.
    coneq[10463]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/4368.
    coneq[10464]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/13104.
    coneq[10465]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/26208.
    coneq[10466]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/8736.
    coneq[10467]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/3276.
    coneq[10468]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/6552.
    coneq[10469]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**2))*c)-1/2184.
    coneq[10470]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/9828.
    coneq[10471]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/19656.
    coneq[10472]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/39312.
    coneq[10473]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/8736.
    coneq[10474]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/26208.
    coneq[10475]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/52416.
    coneq[10476]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/17472.
    coneq[10477]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/6552.
    coneq[10478]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/13104.
    coneq[10479]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c)-1/4368.
    coneq[10480]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c)-1/8736.
    coneq[10481]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c)))*c)-1/2184.
    coneq[10482]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c)))*c)-1/13104.
    coneq[10483]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c)))*c)-1/65520.
    coneq[10484]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c)))*c)-1/262080.
    coneq[10485]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*c)-1/786240.
    coneq[10486]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c)-1/1572480.
    coneq[10487]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/524160.
    coneq[10488]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/196560.
    coneq[10489]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/393120.
    coneq[10490]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/131040.
    coneq[10491]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/262080.
    coneq[10492]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/52416.
    coneq[10493]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/157248.
    coneq[10494]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/314496.
    coneq[10495]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/104832.
    coneq[10496]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/39312.
    coneq[10497]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/78624.
    coneq[10498]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/26208.
    coneq[10499]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/78624.
    coneq[10500]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/157248.
    coneq[10501]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/52416.
    coneq[10502]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c)-1/10920.
    coneq[10503]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/43680.
    coneq[10504]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/131040.
    coneq[10505]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/262080.
    coneq[10506]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/87360.
    coneq[10507]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/32760.
    coneq[10508]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/65520.
    coneq[10509]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/21840.
    coneq[10510]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/43680.
    coneq[10511]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/8736.
    coneq[10512]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/26208.
    coneq[10513]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/52416.
    coneq[10514]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/17472.
    coneq[10515]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/6552.
    coneq[10516]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/13104.
    coneq[10517]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/4368.
    coneq[10518]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/19656.
    coneq[10519]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/39312.
    coneq[10520]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/78624.
    coneq[10521]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/17472.
    coneq[10522]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/52416.
    coneq[10523]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/104832.
    coneq[10524]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/34944.
    coneq[10525]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/13104.
    coneq[10526]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/26208.
    coneq[10527]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/8736.
    coneq[10528]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/17472.
    coneq[10529]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c))*c)-1/728.
    coneq[10530]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c))*c)-1/4368.
    coneq[10531]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c))*c)-1/21840.
    coneq[10532]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c))*c)-1/87360.
    coneq[10533]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c))*c)-1/262080.
    coneq[10534]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*c)-1/524160.
    coneq[10535]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/174720.
    coneq[10536]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/65520.
    coneq[10537]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/131040.
    coneq[10538]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/43680.
    coneq[10539]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/87360.
    coneq[10540]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/17472.
    coneq[10541]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/52416.
    coneq[10542]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/104832.
    coneq[10543]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/34944.
    coneq[10544]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/13104.
    coneq[10545]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/26208.
    coneq[10546]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/8736.
    coneq[10547]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/26208.
    coneq[10548]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/52416.
    coneq[10549]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/17472.
    coneq[10550]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c))*c)-1/3640.
    coneq[10551]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/14560.
    coneq[10552]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/43680.
    coneq[10553]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/87360.
    coneq[10554]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/29120.
    coneq[10555]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/10920.
    coneq[10556]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/21840.
    coneq[10557]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/7280.
    coneq[10558]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/14560.
    coneq[10559]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/2912.
    coneq[10560]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/8736.
    coneq[10561]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/17472.
    coneq[10562]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/5824.
    coneq[10563]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/2184.
    coneq[10564]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/4368.
    coneq[10565]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c))*c)-1/1456.
    coneq[10566]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/6552.
    coneq[10567]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/13104.
    coneq[10568]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/26208.
    coneq[10569]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/5824.
    coneq[10570]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/17472.
    coneq[10571]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/34944.
    coneq[10572]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/11648.
    coneq[10573]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/4368.
    coneq[10574]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/8736.
    coneq[10575]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c)-1/2912.
    coneq[10576]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c)-1/5824.
    coneq[10577]=dot(b,dot(A,c**7)*dot(A,c**2)*c)-1/312.
    coneq[10578]=dot(b,dot(A,dot(A,c**6))*dot(A,c**2)*c)-1/2184.
    coneq[10579]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**2)*c)-1/13104.
    coneq[10580]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**2)*c)-1/65520.
    coneq[10581]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2)*c)-1/262080.
    coneq[10582]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2)*c)-1/786240.
    coneq[10583]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*c)-1/1572480.
    coneq[10584]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2)*c)-1/524160.
    coneq[10585]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2)*c)-1/196560.
    coneq[10586]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/393120.
    coneq[10587]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2)*c)-1/131040.
    coneq[10588]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2)*c)-1/262080.
    coneq[10589]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2)*c)-1/52416.
    coneq[10590]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/157248.
    coneq[10591]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/314496.
    coneq[10592]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/104832.
    coneq[10593]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2)*c)-1/39312.
    coneq[10594]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/78624.
    coneq[10595]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2)*c)-1/26208.
    coneq[10596]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2)*c)-1/78624.
    coneq[10597]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/157248.
    coneq[10598]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/52416.
    coneq[10599]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**2)*c)-1/10920.
    coneq[10600]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/43680.
    coneq[10601]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/131040.
    coneq[10602]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/262080.
    coneq[10603]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/87360.
    coneq[10604]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/32760.
    coneq[10605]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/65520.
    coneq[10606]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/21840.
    coneq[10607]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/43680.
    coneq[10608]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**2)*c)-1/8736.
    coneq[10609]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/26208.
    coneq[10610]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/52416.
    coneq[10611]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/17472.
    coneq[10612]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**2)*c)-1/6552.
    coneq[10613]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/13104.
    coneq[10614]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**2)*c)-1/4368.
    coneq[10615]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2)*c)-1/19656.
    coneq[10616]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/39312.
    coneq[10617]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/78624.
    coneq[10618]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2)*c)-1/17472.
    coneq[10619]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/52416.
    coneq[10620]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/104832.
    coneq[10621]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/34944.
    coneq[10622]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/13104.
    coneq[10623]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/26208.
    coneq[10624]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/8736.
    coneq[10625]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/17472.
    coneq[10626]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**2)*c)-1/1872.
    coneq[10627]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**2)*c)-1/9360.
    coneq[10628]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/37440.
    coneq[10629]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/112320.
    coneq[10630]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/224640.
    coneq[10631]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/74880.
    coneq[10632]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/28080.
    coneq[10633]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/56160.
    coneq[10634]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/18720.
    coneq[10635]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/37440.
    coneq[10636]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**2)*c)-1/7488.
    coneq[10637]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/22464.
    coneq[10638]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/44928.
    coneq[10639]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/14976.
    coneq[10640]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c)-1/5616.
    coneq[10641]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/11232.
    coneq[10642]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**2)*c)-1/3744.
    coneq[10643]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/11232.
    coneq[10644]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/22464.
    coneq[10645]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/7488.
    coneq[10646]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**2)*c)-1/1560.
    coneq[10647]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/6240.
    coneq[10648]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/18720.
    coneq[10649]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/37440.
    coneq[10650]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/12480.
    coneq[10651]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/4680.
    coneq[10652]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/9360.
    coneq[10653]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/3120.
    coneq[10654]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/6240.
    coneq[10655]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**2)*c)-1/1248.
    coneq[10656]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/3744.
    coneq[10657]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/7488.
    coneq[10658]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/2496.
    coneq[10659]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**2)*c)-1/936.
    coneq[10660]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/1872.
    coneq[10661]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**2)*c)-1/624.
    coneq[10662]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**2)*c)-1/3744.
    coneq[10663]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/11232.
    coneq[10664]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/22464.
    coneq[10665]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/7488.
    coneq[10666]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2)*c)-1/7488.
    coneq[10667]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/22464.
    coneq[10668]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/44928.
    coneq[10669]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/14976.
    coneq[10670]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**2)*c)-1/3120.
    coneq[10671]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/12480.
    coneq[10672]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/37440.
    coneq[10673]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/74880.
    coneq[10674]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/24960.
    coneq[10675]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/9360.
    coneq[10676]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/18720.
    coneq[10677]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/6240.
    coneq[10678]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/12480.
    coneq[10679]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c)-1/2808.
    coneq[10680]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/5616.
    coneq[10681]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/11232.
    coneq[10682]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**2)*c)-1/2496.
    coneq[10683]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/7488.
    coneq[10684]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/14976.
    coneq[10685]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/4992.
    coneq[10686]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c)-1/1872.
    coneq[10687]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/3744.
    coneq[10688]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/1248.
    coneq[10689]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c)-1/3744.
    coneq[10690]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/7488.
    coneq[10691]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/2496.
    coneq[10692]=dot(b,dot(A,c**7)*dot(A,dot(A,c))*c)-1/624.
    coneq[10693]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c))*c)-1/4368.
    coneq[10694]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c))*c)-1/26208.
    coneq[10695]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c))*c)-1/131040.
    coneq[10696]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c))*c)-1/524160.
    coneq[10697]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*c)-1/1572480.
    coneq[10698]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c)-1/3144960.
    coneq[10699]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*c)-1/1048320.
    coneq[10700]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/393120.
    coneq[10701]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/786240.
    coneq[10702]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c))*c)-1/262080.
    coneq[10703]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*c)-1/524160.
    coneq[10704]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c))*c)-1/104832.
    coneq[10705]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/314496.
    coneq[10706]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/628992.
    coneq[10707]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/209664.
    coneq[10708]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/78624.
    coneq[10709]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/157248.
    coneq[10710]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c))*c)-1/52416.
    coneq[10711]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/157248.
    coneq[10712]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/314496.
    coneq[10713]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/104832.
    coneq[10714]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c))*c)-1/21840.
    coneq[10715]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/87360.
    coneq[10716]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/262080.
    coneq[10717]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/524160.
    coneq[10718]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/174720.
    coneq[10719]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/65520.
    coneq[10720]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/131040.
    coneq[10721]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/43680.
    coneq[10722]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/87360.
    coneq[10723]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/17472.
    coneq[10724]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/52416.
    coneq[10725]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/104832.
    coneq[10726]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/34944.
    coneq[10727]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/13104.
    coneq[10728]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/26208.
    coneq[10729]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c))*c)-1/8736.
    coneq[10730]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/39312.
    coneq[10731]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/78624.
    coneq[10732]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/157248.
    coneq[10733]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/34944.
    coneq[10734]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/104832.
    coneq[10735]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/209664.
    coneq[10736]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/69888.
    coneq[10737]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/26208.
    coneq[10738]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/52416.
    coneq[10739]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/17472.
    coneq[10740]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/34944.
    coneq[10741]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c))*c)-1/3744.
    coneq[10742]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c)-1/18720.
    coneq[10743]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/74880.
    coneq[10744]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/224640.
    coneq[10745]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/449280.
    coneq[10746]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/149760.
    coneq[10747]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/56160.
    coneq[10748]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/112320.
    coneq[10749]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/37440.
    coneq[10750]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/74880.
    coneq[10751]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10752]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/44928.
    coneq[10753]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/89856.
    coneq[10754]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/29952.
    coneq[10755]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/11232.
    coneq[10756]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/22464.
    coneq[10757]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c)-1/7488.
    coneq[10758]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/22464.
    coneq[10759]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/44928.
    coneq[10760]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10761]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c))*c)-1/3120.
    coneq[10762]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/12480.
    coneq[10763]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/37440.
    coneq[10764]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/74880.
    coneq[10765]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/24960.
    coneq[10766]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/9360.
    coneq[10767]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/18720.
    coneq[10768]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/6240.
    coneq[10769]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/12480.
    coneq[10770]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c))*c)-1/2496.
    coneq[10771]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/7488.
    coneq[10772]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10773]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/4992.
    coneq[10774]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c))*c)-1/1872.
    coneq[10775]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/3744.
    coneq[10776]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c))*c)-1/1248.
    coneq[10777]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/7488.
    coneq[10778]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/22464.
    coneq[10779]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/44928.
    coneq[10780]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10781]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10782]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/44928.
    coneq[10783]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/89856.
    coneq[10784]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/29952.
    coneq[10785]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c))*c)-1/6240.
    coneq[10786]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/24960.
    coneq[10787]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/74880.
    coneq[10788]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/149760.
    coneq[10789]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/49920.
    coneq[10790]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/18720.
    coneq[10791]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/37440.
    coneq[10792]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/12480.
    coneq[10793]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/24960.
    coneq[10794]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/5616.
    coneq[10795]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/11232.
    coneq[10796]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/22464.
    coneq[10797]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/4992.
    coneq[10798]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10799]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/29952.
    coneq[10800]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/9984.
    coneq[10801]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/3744.
    coneq[10802]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/7488.
    coneq[10803]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/2496.
    coneq[10804]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/7488.
    coneq[10805]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/14976.
    coneq[10806]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/4992.
    coneq[10807]=dot(b,dot(A,c**8)*dot(A,c)*c)-1/234.
    coneq[10808]=dot(b,dot(A,dot(A,c**7))*dot(A,c)*c)-1/1872.
    coneq[10809]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c)*c)-1/13104.
    coneq[10810]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c)*c)-1/78624.
    coneq[10811]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c)*c)-1/393120.
    coneq[10812]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c)*c)-1/1572480.
    coneq[10813]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*c)-1/4717440.
    coneq[10814]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c)-1/9434880.
    coneq[10815]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*c)-1/3144960.
    coneq[10816]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c)*c)-1/1179360.
    coneq[10817]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2358720.
    coneq[10818]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c)*c)-1/786240.
    coneq[10819]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*c)-1/1572480.
    coneq[10820]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c)*c)-1/314496.
    coneq[10821]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/943488.
    coneq[10822]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1886976.
    coneq[10823]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/628992.
    coneq[10824]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c)*c)-1/235872.
    coneq[10825]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c)*c)-1/471744.
    coneq[10826]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c)*c)-1/157248.
    coneq[10827]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c)*c)-1/471744.
    coneq[10828]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*c)-1/943488.
    coneq[10829]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/314496.
    coneq[10830]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c)*c)-1/65520.
    coneq[10831]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/262080.
    coneq[10832]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/786240.
    coneq[10833]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1572480.
    coneq[10834]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/524160.
    coneq[10835]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/196560.
    coneq[10836]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/393120.
    coneq[10837]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/131040.
    coneq[10838]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/262080.
    coneq[10839]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c)*c)-1/52416.
    coneq[10840]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/157248.
    coneq[10841]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/314496.
    coneq[10842]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/104832.
    coneq[10843]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c)*c)-1/39312.
    coneq[10844]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c)*c)-1/78624.
    coneq[10845]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c)*c)-1/26208.
    coneq[10846]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c)*c)-1/117936.
    coneq[10847]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/235872.
    coneq[10848]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c)*c)-1/471744.
    coneq[10849]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c)*c)-1/104832.
    coneq[10850]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/314496.
    coneq[10851]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/628992.
    coneq[10852]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/209664.
    coneq[10853]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/78624.
    coneq[10854]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/157248.
    coneq[10855]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/52416.
    coneq[10856]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/104832.
    coneq[10857]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c)*c)-1/11232.
    coneq[10858]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c)*c)-1/56160.
    coneq[10859]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/224640.
    coneq[10860]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/673920.
    coneq[10861]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1347840.
    coneq[10862]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/449280.
    coneq[10863]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/168480.
    coneq[10864]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/336960.
    coneq[10865]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/112320.
    coneq[10866]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/224640.
    coneq[10867]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/44928.
    coneq[10868]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/134784.
    coneq[10869]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/269568.
    coneq[10870]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/89856.
    coneq[10871]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/33696.
    coneq[10872]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/67392.
    coneq[10873]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/22464.
    coneq[10874]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/67392.
    coneq[10875]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/134784.
    coneq[10876]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/44928.
    coneq[10877]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c)*c)-1/9360.
    coneq[10878]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/37440.
    coneq[10879]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/112320.
    coneq[10880]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/224640.
    coneq[10881]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/74880.
    coneq[10882]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/28080.
    coneq[10883]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/56160.
    coneq[10884]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/18720.
    coneq[10885]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/37440.
    coneq[10886]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c)*c)-1/7488.
    coneq[10887]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/22464.
    coneq[10888]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/44928.
    coneq[10889]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/14976.
    coneq[10890]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c)*c)-1/5616.
    coneq[10891]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c)*c)-1/11232.
    coneq[10892]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c)*c)-1/3744.
    coneq[10893]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c)*c)-1/22464.
    coneq[10894]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/67392.
    coneq[10895]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/134784.
    coneq[10896]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/44928.
    coneq[10897]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c)*c)-1/44928.
    coneq[10898]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/134784.
    coneq[10899]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/269568.
    coneq[10900]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/89856.
    coneq[10901]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c)*c)-1/18720.
    coneq[10902]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/74880.
    coneq[10903]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/224640.
    coneq[10904]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/449280.
    coneq[10905]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/149760.
    coneq[10906]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/56160.
    coneq[10907]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/112320.
    coneq[10908]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/37440.
    coneq[10909]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/74880.
    coneq[10910]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/16848.
    coneq[10911]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/33696.
    coneq[10912]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/67392.
    coneq[10913]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/14976.
    coneq[10914]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/44928.
    coneq[10915]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/89856.
    coneq[10916]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/29952.
    coneq[10917]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/11232.
    coneq[10918]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/22464.
    coneq[10919]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/7488.
    coneq[10920]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/22464.
    coneq[10921]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/44928.
    coneq[10922]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/14976.
    coneq[10923]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c)*c)-1/1638.
    coneq[10924]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c)*c)-1/9828.
    coneq[10925]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c)-1/49140.
    coneq[10926]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/196560.
    coneq[10927]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/589680.
    coneq[10928]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1179360.
    coneq[10929]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/393120.
    coneq[10930]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/147420.
    coneq[10931]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/294840.
    coneq[10932]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/98280.
    coneq[10933]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/196560.
    coneq[10934]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/39312.
    coneq[10935]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/117936.
    coneq[10936]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/235872.
    coneq[10937]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/78624.
    coneq[10938]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/29484.
    coneq[10939]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/58968.
    coneq[10940]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/19656.
    coneq[10941]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/58968.
    coneq[10942]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/117936.
    coneq[10943]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/39312.
    coneq[10944]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c)*c)-1/8190.
    coneq[10945]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/32760.
    coneq[10946]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/98280.
    coneq[10947]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/196560.
    coneq[10948]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/65520.
    coneq[10949]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/24570.
    coneq[10950]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/49140.
    coneq[10951]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/16380.
    coneq[10952]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/32760.
    coneq[10953]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c)*c)-1/6552.
    coneq[10954]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/19656.
    coneq[10955]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/39312.
    coneq[10956]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/13104.
    coneq[10957]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c)*c)-1/4914.
    coneq[10958]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c)-1/9828.
    coneq[10959]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c)*c)-1/3276.
    coneq[10960]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/14742.
    coneq[10961]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/29484.
    coneq[10962]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/58968.
    coneq[10963]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/13104.
    coneq[10964]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/39312.
    coneq[10965]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/78624.
    coneq[10966]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/26208.
    coneq[10967]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/9828.
    coneq[10968]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/19656.
    coneq[10969]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/6552.
    coneq[10970]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/13104.
    coneq[10971]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c)*c)-1/1404.
    coneq[10972]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/7020.
    coneq[10973]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/28080.
    coneq[10974]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/84240.
    coneq[10975]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/168480.
    coneq[10976]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/56160.
    coneq[10977]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/21060.
    coneq[10978]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/42120.
    coneq[10979]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/14040.
    coneq[10980]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/28080.
    coneq[10981]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/5616.
    coneq[10982]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/16848.
    coneq[10983]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/33696.
    coneq[10984]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/11232.
    coneq[10985]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/4212.
    coneq[10986]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/8424.
    coneq[10987]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/2808.
    coneq[10988]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/8424.
    coneq[10989]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/16848.
    coneq[10990]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/5616.
    coneq[10991]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c)*c)-1/1170.
    coneq[10992]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/4680.
    coneq[10993]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/14040.
    coneq[10994]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/28080.
    coneq[10995]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/9360.
    coneq[10996]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/3510.
    coneq[10997]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/7020.
    coneq[10998]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/2340.
    coneq[10999]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/4680.
    coneq[11000]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c)*c)-1/936.
    coneq[11001]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/2808.
    coneq[11002]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/5616.
    coneq[11003]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/1872.
    coneq[11004]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c)*c)-1/702.
    coneq[11005]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c)*c)-1/1404.
    coneq[11006]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c)*c)-1/468.
    coneq[11007]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c)*c)-1/3744.
    coneq[11008]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/11232.
    coneq[11009]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/22464.
    coneq[11010]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/7488.
    coneq[11011]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/33696.
    coneq[11012]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/67392.
    coneq[11013]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/22464.
    coneq[11014]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/134784.
    coneq[11015]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/44928.
    coneq[11016]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/14976.
    coneq[11017]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c)*c)-1/3510.
    coneq[11018]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/14040.
    coneq[11019]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/42120.
    coneq[11020]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/84240.
    coneq[11021]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/28080.
    coneq[11022]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/10530.
    coneq[11023]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/21060.
    coneq[11024]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/7020.
    coneq[11025]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/14040.
    coneq[11026]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c)*c)-1/7020.
    coneq[11027]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/28080.
    coneq[11028]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/84240.
    coneq[11029]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/168480.
    coneq[11030]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/56160.
    coneq[11031]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/21060.
    coneq[11032]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/42120.
    coneq[11033]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/14040.
    coneq[11034]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/28080.
    coneq[11035]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c)*c)-1/2808.
    coneq[11036]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/14040.
    coneq[11037]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/56160.
    coneq[11038]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/168480.
    coneq[11039]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/336960.
    coneq[11040]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/112320.
    coneq[11041]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/42120.
    coneq[11042]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/84240.
    coneq[11043]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/28080.
    coneq[11044]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/56160.
    coneq[11045]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/11232.
    coneq[11046]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/33696.
    coneq[11047]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/67392.
    coneq[11048]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/22464.
    coneq[11049]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/8424.
    coneq[11050]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/16848.
    coneq[11051]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/5616.
    coneq[11052]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/16848.
    coneq[11053]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/33696.
    coneq[11054]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/11232.
    coneq[11055]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c)*c)-1/2808.
    coneq[11056]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/8424.
    coneq[11057]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/16848.
    coneq[11058]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/5616.
    coneq[11059]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c)-1/5616.
    coneq[11060]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/16848.
    coneq[11061]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/33696.
    coneq[11062]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/11232.
    coneq[11063]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c)*c)-1/2340.
    coneq[11064]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/9360.
    coneq[11065]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/28080.
    coneq[11066]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/56160.
    coneq[11067]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/18720.
    coneq[11068]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/7020.
    coneq[11069]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/14040.
    coneq[11070]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/4680.
    coneq[11071]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/9360.
    coneq[11072]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/2106.
    coneq[11073]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/4212.
    coneq[11074]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/8424.
    coneq[11075]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c)*c)-1/1872.
    coneq[11076]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/5616.
    coneq[11077]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/11232.
    coneq[11078]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/3744.
    coneq[11079]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/1404.
    coneq[11080]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/2808.
    coneq[11081]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/936.
    coneq[11082]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c)*c)-1/3744.
    coneq[11083]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/11232.
    coneq[11084]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/22464.
    coneq[11085]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/7488.
    coneq[11086]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/4212.
    coneq[11087]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/8424.
    coneq[11088]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/16848.
    coneq[11089]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/2808.
    coneq[11090]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/5616.
    coneq[11091]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/1872.
    coneq[11092]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/3744.
    coneq[11093]=dot(b,dot(A,c**4)*dot(A,c**4)*c*c)-1/325.
    coneq[11094]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*c*c)-1/1300.
    coneq[11095]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*c*c)-1/3900.
    coneq[11096]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c*c)-1/7800.
    coneq[11097]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*c*c)-1/2600.
    coneq[11098]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*c*c)-1/975.
    coneq[11099]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*c*c)-1/1950.
    coneq[11100]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*c*c)-1/650.
    coneq[11101]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*c*c)-1/1300.
    coneq[11102]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*c*c)-1/5200.
    coneq[11103]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c*c)-1/15600.
    coneq[11104]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c*c)-1/31200.
    coneq[11105]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/10400.
    coneq[11106]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*c*c)-1/3900.
    coneq[11107]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/7800.
    coneq[11108]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*c*c)-1/2600.
    coneq[11109]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c*c)-1/5200.
    coneq[11110]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/46800.
    coneq[11111]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/93600.
    coneq[11112]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/31200.
    coneq[11113]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/11700.
    coneq[11114]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/23400.
    coneq[11115]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/7800.
    coneq[11116]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/15600.
    coneq[11117]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/187200.
    coneq[11118]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/62400.
    coneq[11119]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/23400.
    coneq[11120]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/46800.
    coneq[11121]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/15600.
    coneq[11122]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/31200.
    coneq[11123]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/20800.
    coneq[11124]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/7800.
    coneq[11125]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/15600.
    coneq[11126]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/5200.
    coneq[11127]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/10400.
    coneq[11128]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*c*c)-1/2925.
    coneq[11129]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c*c)-1/5850.
    coneq[11130]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*c*c)-1/1950.
    coneq[11131]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c*c)-1/3900.
    coneq[11132]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/11700.
    coneq[11133]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/3900.
    coneq[11134]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/7800.
    coneq[11135]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*c*c)-1/1300.
    coneq[11136]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c*c)-1/2600.
    coneq[11137]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/5200.
    coneq[11138]=dot(b,dot(A,c**5)*dot(A,c**3)*c*c)-1/312.
    coneq[11139]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*c*c)-1/1560.
    coneq[11140]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*c*c)-1/6240.
    coneq[11141]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c*c)-1/18720.
    coneq[11142]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c*c)-1/37440.
    coneq[11143]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c*c)-1/12480.
    coneq[11144]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*c*c)-1/4680.
    coneq[11145]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/9360.
    coneq[11146]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*c*c)-1/3120.
    coneq[11147]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c*c)-1/6240.
    coneq[11148]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*c*c)-1/1248.
    coneq[11149]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*c*c)-1/3744.
    coneq[11150]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/7488.
    coneq[11151]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*c*c)-1/2496.
    coneq[11152]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*c*c)-1/936.
    coneq[11153]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/1872.
    coneq[11154]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*c*c)-1/624.
    coneq[11155]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*c*c)-1/1872.
    coneq[11156]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/3744.
    coneq[11157]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*c*c)-1/1248.
    coneq[11158]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*c*c)-1/936.
    coneq[11159]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*c*c)-1/4680.
    coneq[11160]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c*c)-1/18720.
    coneq[11161]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c*c)-1/56160.
    coneq[11162]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c*c)-1/112320.
    coneq[11163]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/37440.
    coneq[11164]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/14040.
    coneq[11165]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/28080.
    coneq[11166]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/9360.
    coneq[11167]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/18720.
    coneq[11168]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*c*c)-1/3744.
    coneq[11169]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/11232.
    coneq[11170]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/22464.
    coneq[11171]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/7488.
    coneq[11172]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/2808.
    coneq[11173]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/5616.
    coneq[11174]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/1872.
    coneq[11175]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/5616.
    coneq[11176]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/11232.
    coneq[11177]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/3744.
    coneq[11178]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*c*c)-1/1872.
    coneq[11179]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c*c)-1/9360.
    coneq[11180]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c*c)-1/37440.
    coneq[11181]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c*c)-1/112320.
    coneq[11182]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c*c)-1/224640.
    coneq[11183]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/74880.
    coneq[11184]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/28080.
    coneq[11185]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/56160.
    coneq[11186]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/18720.
    coneq[11187]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/37440.
    coneq[11188]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c*c)-1/7488.
    coneq[11189]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/22464.
    coneq[11190]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/44928.
    coneq[11191]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/14976.
    coneq[11192]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c*c)-1/5616.
    coneq[11193]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/11232.
    coneq[11194]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/3744.
    coneq[11195]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c*c)-1/11232.
    coneq[11196]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/22464.
    coneq[11197]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/7488.
    coneq[11198]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*c*c)-1/624.
    coneq[11199]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*c*c)-1/3120.
    coneq[11200]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c*c)-1/12480.
    coneq[11201]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c*c)-1/37440.
    coneq[11202]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c*c)-1/74880.
    coneq[11203]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/24960.
    coneq[11204]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/9360.
    coneq[11205]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/18720.
    coneq[11206]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/6240.
    coneq[11207]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/12480.
    coneq[11208]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*c*c)-1/2496.
    coneq[11209]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/7488.
    coneq[11210]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/14976.
    coneq[11211]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/4992.
    coneq[11212]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*c*c)-1/1872.
    coneq[11213]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/3744.
    coneq[11214]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/1248.
    coneq[11215]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c*c)-1/3744.
    coneq[11216]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/7488.
    coneq[11217]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/2496.
    coneq[11218]=dot(b,dot(A,c**6)*dot(A,c**2)*c*c)-1/273.
    coneq[11219]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2)*c*c)-1/1638.
    coneq[11220]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2)*c*c)-1/8190.
    coneq[11221]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c*c)-1/32760.
    coneq[11222]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c*c)-1/98280.
    coneq[11223]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c*c)-1/196560.
    coneq[11224]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c*c)-1/65520.
    coneq[11225]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c*c)-1/24570.
    coneq[11226]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/49140.
    coneq[11227]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c*c)-1/16380.
    coneq[11228]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c*c)-1/32760.
    coneq[11229]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2)*c*c)-1/6552.
    coneq[11230]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/19656.
    coneq[11231]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/39312.
    coneq[11232]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/13104.
    coneq[11233]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c*c)-1/4914.
    coneq[11234]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/9828.
    coneq[11235]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2)*c*c)-1/3276.
    coneq[11236]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c*c)-1/9828.
    coneq[11237]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/19656.
    coneq[11238]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/6552.
    coneq[11239]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2)*c*c)-1/1365.
    coneq[11240]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2)*c*c)-1/5460.
    coneq[11241]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/16380.
    coneq[11242]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/32760.
    coneq[11243]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/10920.
    coneq[11244]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c*c)-1/4095.
    coneq[11245]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/8190.
    coneq[11246]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c*c)-1/2730.
    coneq[11247]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/5460.
    coneq[11248]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2)*c*c)-1/1092.
    coneq[11249]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/3276.
    coneq[11250]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/6552.
    coneq[11251]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/2184.
    coneq[11252]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2)*c*c)-1/819.
    coneq[11253]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/1638.
    coneq[11254]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2)*c*c)-1/546.
    coneq[11255]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c*c)-1/2457.
    coneq[11256]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/4914.
    coneq[11257]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/9828.
    coneq[11258]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2)*c*c)-1/2184.
    coneq[11259]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/6552.
    coneq[11260]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/13104.
    coneq[11261]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/4368.
    coneq[11262]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c*c)-1/1638.
    coneq[11263]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/3276.
    coneq[11264]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2)*c*c)-1/1092.
    coneq[11265]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c*c)-1/2184.
    coneq[11266]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*c*c)-1/546.
    coneq[11267]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*c*c)-1/3276.
    coneq[11268]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c*c)-1/16380.
    coneq[11269]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c*c)-1/65520.
    coneq[11270]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c*c)-1/196560.
    coneq[11271]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c*c)-1/393120.
    coneq[11272]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/131040.
    coneq[11273]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/49140.
    coneq[11274]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/98280.
    coneq[11275]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/32760.
    coneq[11276]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/65520.
    coneq[11277]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/13104.
    coneq[11278]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/39312.
    coneq[11279]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/78624.
    coneq[11280]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/26208.
    coneq[11281]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/9828.
    coneq[11282]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/19656.
    coneq[11283]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/6552.
    coneq[11284]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/19656.
    coneq[11285]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/39312.
    coneq[11286]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/13104.
    coneq[11287]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*c*c)-1/2730.
    coneq[11288]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/10920.
    coneq[11289]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/32760.
    coneq[11290]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/65520.
    coneq[11291]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/21840.
    coneq[11292]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/8190.
    coneq[11293]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/16380.
    coneq[11294]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/5460.
    coneq[11295]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/10920.
    coneq[11296]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/2184.
    coneq[11297]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/6552.
    coneq[11298]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/13104.
    coneq[11299]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/4368.
    coneq[11300]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/1638.
    coneq[11301]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/3276.
    coneq[11302]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*c*c)-1/1092.
    coneq[11303]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/4914.
    coneq[11304]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/9828.
    coneq[11305]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/19656.
    coneq[11306]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/4368.
    coneq[11307]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/13104.
    coneq[11308]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/26208.
    coneq[11309]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/8736.
    coneq[11310]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/3276.
    coneq[11311]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/6552.
    coneq[11312]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c*c)-1/2184.
    coneq[11313]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c*c)-1/4368.
    coneq[11314]=dot(b,dot(A,c**7)*dot(A,c)*c*c)-1/208.
    coneq[11315]=dot(b,dot(A,dot(A,c**6))*dot(A,c)*c*c)-1/1456.
    coneq[11316]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c)*c*c)-1/8736.
    coneq[11317]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c*c)-1/43680.
    coneq[11318]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c*c)-1/174720.
    coneq[11319]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c*c)-1/524160.
    coneq[11320]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c*c)-1/1048320.
    coneq[11321]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c*c)-1/349440.
    coneq[11322]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c*c)-1/131040.
    coneq[11323]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/262080.
    coneq[11324]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c*c)-1/87360.
    coneq[11325]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c*c)-1/174720.
    coneq[11326]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c*c)-1/34944.
    coneq[11327]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/104832.
    coneq[11328]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/209664.
    coneq[11329]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/69888.
    coneq[11330]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c*c)-1/26208.
    coneq[11331]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/52416.
    coneq[11332]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c*c)-1/17472.
    coneq[11333]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c*c)-1/52416.
    coneq[11334]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/104832.
    coneq[11335]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/34944.
    coneq[11336]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c)*c*c)-1/7280.
    coneq[11337]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/29120.
    coneq[11338]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/87360.
    coneq[11339]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/174720.
    coneq[11340]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/58240.
    coneq[11341]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/21840.
    coneq[11342]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/43680.
    coneq[11343]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/14560.
    coneq[11344]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/29120.
    coneq[11345]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c)*c*c)-1/5824.
    coneq[11346]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/17472.
    coneq[11347]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/34944.
    coneq[11348]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/11648.
    coneq[11349]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c)*c*c)-1/4368.
    coneq[11350]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/8736.
    coneq[11351]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c)*c*c)-1/2912.
    coneq[11352]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c*c)-1/13104.
    coneq[11353]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/26208.
    coneq[11354]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/52416.
    coneq[11355]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c*c)-1/11648.
    coneq[11356]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/34944.
    coneq[11357]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/69888.
    coneq[11358]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/23296.
    coneq[11359]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/8736.
    coneq[11360]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/17472.
    coneq[11361]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/5824.
    coneq[11362]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/11648.
    coneq[11363]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c)*c*c)-1/1248.
    coneq[11364]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c)*c*c)-1/6240.
    coneq[11365]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/24960.
    coneq[11366]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/74880.
    coneq[11367]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/149760.
    coneq[11368]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/49920.
    coneq[11369]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/18720.
    coneq[11370]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/37440.
    coneq[11371]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/12480.
    coneq[11372]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/24960.
    coneq[11373]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c)*c*c)-1/4992.
    coneq[11374]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/14976.
    coneq[11375]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/29952.
    coneq[11376]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/9984.
    coneq[11377]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c*c)-1/3744.
    coneq[11378]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/7488.
    coneq[11379]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c)*c*c)-1/2496.
    coneq[11380]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/7488.
    coneq[11381]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/14976.
    coneq[11382]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/4992.
    coneq[11383]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c)*c*c)-1/1040.
    coneq[11384]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/4160.
    coneq[11385]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/12480.
    coneq[11386]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/24960.
    coneq[11387]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/8320.
    coneq[11388]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/3120.
    coneq[11389]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/6240.
    coneq[11390]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/2080.
    coneq[11391]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/4160.
    coneq[11392]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c)*c*c)-1/832.
    coneq[11393]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/2496.
    coneq[11394]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/4992.
    coneq[11395]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/1664.
    coneq[11396]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c)*c*c)-1/624.
    coneq[11397]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/1248.
    coneq[11398]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c)*c*c)-1/416.
    coneq[11399]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c)*c*c)-1/2496.
    coneq[11400]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/7488.
    coneq[11401]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/14976.
    coneq[11402]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/4992.
    coneq[11403]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c*c)-1/4992.
    coneq[11404]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/14976.
    coneq[11405]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/29952.
    coneq[11406]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/9984.
    coneq[11407]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c)*c*c)-1/2080.
    coneq[11408]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/8320.
    coneq[11409]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/24960.
    coneq[11410]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/49920.
    coneq[11411]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/16640.
    coneq[11412]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/6240.
    coneq[11413]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/12480.
    coneq[11414]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/4160.
    coneq[11415]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/8320.
    coneq[11416]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c*c)-1/1872.
    coneq[11417]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/3744.
    coneq[11418]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/7488.
    coneq[11419]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c)*c*c)-1/1664.
    coneq[11420]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/4992.
    coneq[11421]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/9984.
    coneq[11422]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/3328.
    coneq[11423]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c)*c*c)-1/1248.
    coneq[11424]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/2496.
    coneq[11425]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/832.
    coneq[11426]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c*c)-1/2496.
    coneq[11427]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/4992.
    coneq[11428]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/1664.
    coneq[11429]=dot(b,dot(A,c**4)*dot(A,c**3)*c**3)-1/260.
    coneq[11430]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*c**3)-1/1040.
    coneq[11431]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*c**3)-1/3120.
    coneq[11432]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c**3)-1/6240.
    coneq[11433]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*c**3)-1/2080.
    coneq[11434]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*c**3)-1/780.
    coneq[11435]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*c**3)-1/1560.
    coneq[11436]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*c**3)-1/520.
    coneq[11437]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*c**3)-1/1040.
    coneq[11438]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*c**3)-1/780.
    coneq[11439]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*c**3)-1/3120.
    coneq[11440]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c**3)-1/9360.
    coneq[11441]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c**3)-1/18720.
    coneq[11442]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/6240.
    coneq[11443]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*c**3)-1/2340.
    coneq[11444]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/4680.
    coneq[11445]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*c**3)-1/1560.
    coneq[11446]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c**3)-1/3120.
    coneq[11447]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*c**3)-1/1560.
    coneq[11448]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c**3)-1/6240.
    coneq[11449]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c**3)-1/18720.
    coneq[11450]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c**3)-1/37440.
    coneq[11451]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/12480.
    coneq[11452]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c**3)-1/4680.
    coneq[11453]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/9360.
    coneq[11454]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**3)-1/3120.
    coneq[11455]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**3)-1/6240.
    coneq[11456]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*c**3)-1/520.
    coneq[11457]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*c**3)-1/2080.
    coneq[11458]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c**3)-1/6240.
    coneq[11459]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c**3)-1/12480.
    coneq[11460]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/4160.
    coneq[11461]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*c**3)-1/1560.
    coneq[11462]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/3120.
    coneq[11463]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*c**3)-1/1040.
    coneq[11464]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c**3)-1/2080.
    coneq[11465]=dot(b,dot(A,c**5)*dot(A,c**2)*c**3)-1/234.
    coneq[11466]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*c**3)-1/1170.
    coneq[11467]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*c**3)-1/4680.
    coneq[11468]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c**3)-1/14040.
    coneq[11469]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c**3)-1/28080.
    coneq[11470]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c**3)-1/9360.
    coneq[11471]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*c**3)-1/3510.
    coneq[11472]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/7020.
    coneq[11473]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*c**3)-1/2340.
    coneq[11474]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c**3)-1/4680.
    coneq[11475]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*c**3)-1/936.
    coneq[11476]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*c**3)-1/2808.
    coneq[11477]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/5616.
    coneq[11478]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*c**3)-1/1872.
    coneq[11479]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*c**3)-1/702.
    coneq[11480]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/1404.
    coneq[11481]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*c**3)-1/468.
    coneq[11482]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*c**3)-1/1404.
    coneq[11483]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/2808.
    coneq[11484]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*c**3)-1/936.
    coneq[11485]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*c**3)-1/468.
    coneq[11486]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*c**3)-1/2340.
    coneq[11487]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c**3)-1/9360.
    coneq[11488]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c**3)-1/28080.
    coneq[11489]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c**3)-1/56160.
    coneq[11490]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c**3)-1/18720.
    coneq[11491]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/7020.
    coneq[11492]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/14040.
    coneq[11493]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/4680.
    coneq[11494]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/9360.
    coneq[11495]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*c**3)-1/1872.
    coneq[11496]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/5616.
    coneq[11497]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/11232.
    coneq[11498]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/3744.
    coneq[11499]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/1404.
    coneq[11500]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/2808.
    coneq[11501]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*c**3)-1/936.
    coneq[11502]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/2808.
    coneq[11503]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/5616.
    coneq[11504]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**3)-1/1872.
    coneq[11505]=dot(b,dot(A,c**6)*dot(A,c)*c**3)-1/182.
    coneq[11506]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*c**3)-1/1092.
    coneq[11507]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*c**3)-1/5460.
    coneq[11508]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c**3)-1/21840.
    coneq[11509]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c**3)-1/65520.
    coneq[11510]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c**3)-1/131040.
    coneq[11511]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c**3)-1/43680.
    coneq[11512]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c**3)-1/16380.
    coneq[11513]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/32760.
    coneq[11514]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c**3)-1/10920.
    coneq[11515]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c**3)-1/21840.
    coneq[11516]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*c**3)-1/4368.
    coneq[11517]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/13104.
    coneq[11518]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/26208.
    coneq[11519]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/8736.
    coneq[11520]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*c**3)-1/3276.
    coneq[11521]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/6552.
    coneq[11522]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*c**3)-1/2184.
    coneq[11523]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c**3)-1/6552.
    coneq[11524]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/13104.
    coneq[11525]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/4368.
    coneq[11526]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*c**3)-1/910.
    coneq[11527]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*c**3)-1/3640.
    coneq[11528]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/10920.
    coneq[11529]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/21840.
    coneq[11530]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/7280.
    coneq[11531]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*c**3)-1/2730.
    coneq[11532]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/5460.
    coneq[11533]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*c**3)-1/1820.
    coneq[11534]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/3640.
    coneq[11535]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*c**3)-1/728.
    coneq[11536]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/2184.
    coneq[11537]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/4368.
    coneq[11538]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/1456.
    coneq[11539]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*c**3)-1/546.
    coneq[11540]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/1092.
    coneq[11541]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*c**3)-1/364.
    coneq[11542]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*c**3)-1/1638.
    coneq[11543]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/3276.
    coneq[11544]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/6552.
    coneq[11545]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*c**3)-1/1456.
    coneq[11546]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/4368.
    coneq[11547]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/8736.
    coneq[11548]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/2912.
    coneq[11549]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*c**3)-1/1092.
    coneq[11550]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/2184.
    coneq[11551]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*c**3)-1/728.
    coneq[11552]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c**3)-1/1456.
    coneq[11553]=dot(b,dot(A,c**3)*dot(A,c**3)*c**4)-1/208.
    coneq[11554]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*c**4)-1/624.
    coneq[11555]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c**4)-1/1248.
    coneq[11556]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*c**4)-1/416.
    coneq[11557]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c**4)-1/1872.
    coneq[11558]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**4)-1/3744.
    coneq[11559]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*c**4)-1/1248.
    coneq[11560]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**4)-1/7488.
    coneq[11561]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**4)-1/2496.
    coneq[11562]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*c**4)-1/832.
    coneq[11563]=dot(b,dot(A,c**4)*dot(A,c**2)*c**4)-1/195.
    coneq[11564]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*c**4)-1/780.
    coneq[11565]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*c**4)-1/2340.
    coneq[11566]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**4)-1/4680.
    coneq[11567]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*c**4)-1/1560.
    coneq[11568]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*c**4)-1/585.
    coneq[11569]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*c**4)-1/1170.
    coneq[11570]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*c**4)-1/390.
    coneq[11571]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*c**4)-1/780.
    coneq[11572]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*c**4)-1/390.
    coneq[11573]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*c**4)-1/1560.
    coneq[11574]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**4)-1/4680.
    coneq[11575]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**4)-1/9360.
    coneq[11576]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**4)-1/3120.
    coneq[11577]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*c**4)-1/1170.
    coneq[11578]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**4)-1/2340.
    coneq[11579]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*c**4)-1/780.
    coneq[11580]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**4)-1/1560.
    coneq[11581]=dot(b,dot(A,c**5)*dot(A,c)*c**4)-1/156.
    coneq[11582]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*c**4)-1/780.
    coneq[11583]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*c**4)-1/3120.
    coneq[11584]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**4)-1/9360.
    coneq[11585]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**4)-1/18720.
    coneq[11586]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**4)-1/6240.
    coneq[11587]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*c**4)-1/2340.
    coneq[11588]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**4)-1/4680.
    coneq[11589]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*c**4)-1/1560.
    coneq[11590]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**4)-1/3120.
    coneq[11591]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*c**4)-1/624.
    coneq[11592]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*c**4)-1/1872.
    coneq[11593]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**4)-1/3744.
    coneq[11594]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*c**4)-1/1248.
    coneq[11595]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*c**4)-1/468.
    coneq[11596]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/936.
    coneq[11597]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*c**4)-1/312.
    coneq[11598]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*c**4)-1/936.
    coneq[11599]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/1872.
    coneq[11600]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*c**4)-1/624.
    coneq[11601]=dot(b,dot(A,c**3)*dot(A,c**2)*c**5)-1/156.
    coneq[11602]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*c**5)-1/468.
    coneq[11603]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c**5)-1/936.
    coneq[11604]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*c**5)-1/312.
    coneq[11605]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*c**5)-1/312.
    coneq[11606]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*c**5)-1/936.
    coneq[11607]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c**5)-1/1872.
    coneq[11608]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*c**5)-1/624.
    coneq[11609]=dot(b,dot(A,c**4)*dot(A,c)*c**5)-1/130.
    coneq[11610]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*c**5)-1/520.
    coneq[11611]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c**5)-1/1560.
    coneq[11612]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c**5)-1/3120.
    coneq[11613]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c**5)-1/1040.
    coneq[11614]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*c**5)-1/390.
    coneq[11615]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c**5)-1/780.
    coneq[11616]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*c**5)-1/260.
    coneq[11617]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c**5)-1/520.
    coneq[11618]=dot(b,dot(A,c**2)*dot(A,c**2)*c**6)-1/117.
    coneq[11619]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c**6)-1/234.
    coneq[11620]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c**6)-1/468.
    coneq[11621]=dot(b,dot(A,c**3)*dot(A,c)*c**6)-1/104.
    coneq[11622]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c**6)-1/312.
    coneq[11623]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c**6)-1/624.
    coneq[11624]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c**6)-1/208.
    coneq[11625]=dot(b,dot(A,c**2)*dot(A,c)*c**7)-1/78.
    coneq[11626]=dot(b,dot(A,dot(A,c))*dot(A,c)*c**7)-1/156.
    coneq[11627]=dot(b,dot(A,c)*dot(A,c)*c**8)-1/52.
    coneq[11628]=dot(b,dot(A,c**7)*dot(A,c)*dot(A,c))-1/416.
    coneq[11629]=dot(b,dot(A,dot(A,c**6))*dot(A,c)*dot(A,c))-1/2912.
    coneq[11630]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c)*dot(A,c))-1/17472.
    coneq[11631]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c)*dot(A,c))-1/87360.
    coneq[11632]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*dot(A,c))-1/349440.
    coneq[11633]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*dot(A,c))-1/1048320.
    coneq[11634]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c))-1/2096640.
    coneq[11635]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*dot(A,c))-1/698880.
    coneq[11636]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/262080.
    coneq[11637]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/524160.
    coneq[11638]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*dot(A,c))-1/174720.
    coneq[11639]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*dot(A,c))-1/349440.
    coneq[11640]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*dot(A,c))-1/69888.
    coneq[11641]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/209664.
    coneq[11642]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/419328.
    coneq[11643]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/139776.
    coneq[11644]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/52416.
    coneq[11645]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/104832.
    coneq[11646]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*dot(A,c))-1/34944.
    coneq[11647]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/104832.
    coneq[11648]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/209664.
    coneq[11649]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/69888.
    coneq[11650]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c)*dot(A,c))-1/14560.
    coneq[11651]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/58240.
    coneq[11652]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/174720.
    coneq[11653]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/349440.
    coneq[11654]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/116480.
    coneq[11655]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/43680.
    coneq[11656]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/87360.
    coneq[11657]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/29120.
    coneq[11658]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/58240.
    coneq[11659]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/11648.
    coneq[11660]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/34944.
    coneq[11661]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/69888.
    coneq[11662]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/23296.
    coneq[11663]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/8736.
    coneq[11664]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/17472.
    coneq[11665]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c)*dot(A,c))-1/5824.
    coneq[11666]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/26208.
    coneq[11667]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/52416.
    coneq[11668]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/104832.
    coneq[11669]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/23296.
    coneq[11670]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/69888.
    coneq[11671]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/139776.
    coneq[11672]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/46592.
    coneq[11673]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/17472.
    coneq[11674]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/34944.
    coneq[11675]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/11648.
    coneq[11676]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/23296.
    coneq[11677]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c)*dot(A,c))-1/2496.
    coneq[11678]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c))-1/12480.
    coneq[11679]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/49920.
    coneq[11680]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/149760.
    coneq[11681]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/299520.
    coneq[11682]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/99840.
    coneq[11683]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/37440.
    coneq[11684]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/74880.
    coneq[11685]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/24960.
    coneq[11686]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/49920.
    coneq[11687]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11688]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/29952.
    coneq[11689]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/59904.
    coneq[11690]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/19968.
    coneq[11691]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/7488.
    coneq[11692]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/14976.
    coneq[11693]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c))-1/4992.
    coneq[11694]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/14976.
    coneq[11695]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/29952.
    coneq[11696]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11697]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c)*dot(A,c))-1/2080.
    coneq[11698]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/8320.
    coneq[11699]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/24960.
    coneq[11700]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/49920.
    coneq[11701]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/16640.
    coneq[11702]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/6240.
    coneq[11703]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/12480.
    coneq[11704]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/4160.
    coneq[11705]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/8320.
    coneq[11706]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c)*dot(A,c))-1/1664.
    coneq[11707]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/4992.
    coneq[11708]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11709]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/3328.
    coneq[11710]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c)*dot(A,c))-1/1248.
    coneq[11711]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/2496.
    coneq[11712]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c)*dot(A,c))-1/832.
    coneq[11713]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/4992.
    coneq[11714]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/14976.
    coneq[11715]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/29952.
    coneq[11716]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11717]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11718]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/29952.
    coneq[11719]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/59904.
    coneq[11720]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/19968.
    coneq[11721]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c)*dot(A,c))-1/4160.
    coneq[11722]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/16640.
    coneq[11723]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/49920.
    coneq[11724]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/99840.
    coneq[11725]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/33280.
    coneq[11726]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/12480.
    coneq[11727]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/24960.
    coneq[11728]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/8320.
    coneq[11729]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/16640.
    coneq[11730]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/3744.
    coneq[11731]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/7488.
    coneq[11732]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/14976.
    coneq[11733]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/3328.
    coneq[11734]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11735]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/19968.
    coneq[11736]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/6656.
    coneq[11737]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/2496.
    coneq[11738]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/4992.
    coneq[11739]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/1664.
    coneq[11740]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/4992.
    coneq[11741]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/9984.
    coneq[11742]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/3328.
    coneq[11743]=dot(b,dot(A,c**6)*dot(A,c**2)*dot(A,c))-1/546.
    coneq[11744]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2)*dot(A,c))-1/3276.
    coneq[11745]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2)*dot(A,c))-1/16380.
    coneq[11746]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*dot(A,c))-1/65520.
    coneq[11747]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*dot(A,c))-1/196560.
    coneq[11748]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c))-1/393120.
    coneq[11749]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/131040.
    coneq[11750]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/49140.
    coneq[11751]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/98280.
    coneq[11752]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/32760.
    coneq[11753]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/65520.
    coneq[11754]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/13104.
    coneq[11755]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/39312.
    coneq[11756]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/78624.
    coneq[11757]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/26208.
    coneq[11758]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/9828.
    coneq[11759]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/19656.
    coneq[11760]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/6552.
    coneq[11761]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/19656.
    coneq[11762]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/39312.
    coneq[11763]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/13104.
    coneq[11764]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2)*dot(A,c))-1/2730.
    coneq[11765]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/10920.
    coneq[11766]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/32760.
    coneq[11767]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/65520.
    coneq[11768]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/21840.
    coneq[11769]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/8190.
    coneq[11770]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/16380.
    coneq[11771]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/5460.
    coneq[11772]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/10920.
    coneq[11773]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/2184.
    coneq[11774]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/6552.
    coneq[11775]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/13104.
    coneq[11776]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/4368.
    coneq[11777]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/1638.
    coneq[11778]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/3276.
    coneq[11779]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2)*dot(A,c))-1/1092.
    coneq[11780]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/4914.
    coneq[11781]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/9828.
    coneq[11782]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/19656.
    coneq[11783]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/4368.
    coneq[11784]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/13104.
    coneq[11785]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/26208.
    coneq[11786]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/8736.
    coneq[11787]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/3276.
    coneq[11788]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/6552.
    coneq[11789]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c))-1/2184.
    coneq[11790]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c))-1/4368.
    coneq[11791]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*dot(A,c))-1/1092.
    coneq[11792]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*dot(A,c))-1/6552.
    coneq[11793]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*dot(A,c))-1/32760.
    coneq[11794]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*dot(A,c))-1/131040.
    coneq[11795]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c))-1/393120.
    coneq[11796]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c))-1/786240.
    coneq[11797]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/262080.
    coneq[11798]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/98280.
    coneq[11799]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/196560.
    coneq[11800]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/65520.
    coneq[11801]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/131040.
    coneq[11802]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/26208.
    coneq[11803]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/78624.
    coneq[11804]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/157248.
    coneq[11805]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/52416.
    coneq[11806]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/19656.
    coneq[11807]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/39312.
    coneq[11808]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/13104.
    coneq[11809]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/39312.
    coneq[11810]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/78624.
    coneq[11811]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/26208.
    coneq[11812]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*dot(A,c))-1/5460.
    coneq[11813]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/21840.
    coneq[11814]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/65520.
    coneq[11815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/131040.
    coneq[11816]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/43680.
    coneq[11817]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/16380.
    coneq[11818]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/32760.
    coneq[11819]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/10920.
    coneq[11820]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/21840.
    coneq[11821]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/4368.
    coneq[11822]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/13104.
    coneq[11823]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/26208.
    coneq[11824]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/8736.
    coneq[11825]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/3276.
    coneq[11826]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/6552.
    coneq[11827]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/2184.
    coneq[11828]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/9828.
    coneq[11829]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/19656.
    coneq[11830]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/39312.
    coneq[11831]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/8736.
    coneq[11832]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/26208.
    coneq[11833]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/52416.
    coneq[11834]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/17472.
    coneq[11835]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/6552.
    coneq[11836]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/13104.
    coneq[11837]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/4368.
    coneq[11838]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/8736.
    coneq[11839]=dot(b,dot(A,c**5)*dot(A,c**2)*dot(A,c**2))-1/702.
    coneq[11840]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*dot(A,c**2))-1/3510.
    coneq[11841]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c**2))-1/14040.
    coneq[11842]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c**2))-1/42120.
    coneq[11843]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c**2))-1/84240.
    coneq[11844]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/28080.
    coneq[11845]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/10530.
    coneq[11846]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/21060.
    coneq[11847]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/7020.
    coneq[11848]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/14040.
    coneq[11849]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*dot(A,c**2))-1/2808.
    coneq[11850]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/8424.
    coneq[11851]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/16848.
    coneq[11852]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/5616.
    coneq[11853]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/2106.
    coneq[11854]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/4212.
    coneq[11855]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/1404.
    coneq[11856]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/4212.
    coneq[11857]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/8424.
    coneq[11858]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/2808.
    coneq[11859]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,c**2))-1/1404.
    coneq[11860]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,c**2))-1/7020.
    coneq[11861]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c**2))-1/28080.
    coneq[11862]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c**2))-1/84240.
    coneq[11863]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c**2))-1/168480.
    coneq[11864]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/56160.
    coneq[11865]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/21060.
    coneq[11866]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/42120.
    coneq[11867]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/14040.
    coneq[11868]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/28080.
    coneq[11869]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2))-1/5616.
    coneq[11870]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/16848.
    coneq[11871]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/33696.
    coneq[11872]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/11232.
    coneq[11873]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/4212.
    coneq[11874]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/8424.
    coneq[11875]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/2808.
    coneq[11876]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/8424.
    coneq[11877]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/16848.
    coneq[11878]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/5616.
    coneq[11879]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/2808.
    coneq[11880]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/14040.
    coneq[11881]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/56160.
    coneq[11882]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/168480.
    coneq[11883]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/336960.
    coneq[11884]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/112320.
    coneq[11885]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/42120.
    coneq[11886]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/84240.
    coneq[11887]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/28080.
    coneq[11888]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/56160.
    coneq[11889]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/11232.
    coneq[11890]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/33696.
    coneq[11891]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/67392.
    coneq[11892]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/22464.
    coneq[11893]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/8424.
    coneq[11894]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/16848.
    coneq[11895]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/5616.
    coneq[11896]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/16848.
    coneq[11897]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/33696.
    coneq[11898]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/11232.
    coneq[11899]=dot(b,dot(A,c**5)*dot(A,c**3)*dot(A,c))-1/624.
    coneq[11900]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*dot(A,c))-1/3120.
    coneq[11901]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*dot(A,c))-1/12480.
    coneq[11902]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*dot(A,c))-1/37440.
    coneq[11903]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,c))-1/74880.
    coneq[11904]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*dot(A,c))-1/24960.
    coneq[11905]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/9360.
    coneq[11906]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/18720.
    coneq[11907]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/6240.
    coneq[11908]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/12480.
    coneq[11909]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*dot(A,c))-1/2496.
    coneq[11910]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/7488.
    coneq[11911]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/14976.
    coneq[11912]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/4992.
    coneq[11913]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/1872.
    coneq[11914]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/3744.
    coneq[11915]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*dot(A,c))-1/1248.
    coneq[11916]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/3744.
    coneq[11917]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/7488.
    coneq[11918]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c))-1/2496.
    coneq[11919]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*dot(A,c))-1/1872.
    coneq[11920]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*dot(A,c))-1/9360.
    coneq[11921]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*dot(A,c))-1/37440.
    coneq[11922]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,c))-1/112320.
    coneq[11923]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c))-1/224640.
    coneq[11924]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/74880.
    coneq[11925]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/28080.
    coneq[11926]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/56160.
    coneq[11927]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/18720.
    coneq[11928]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/37440.
    coneq[11929]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c))-1/7488.
    coneq[11930]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/22464.
    coneq[11931]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/44928.
    coneq[11932]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/14976.
    coneq[11933]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/5616.
    coneq[11934]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/11232.
    coneq[11935]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/3744.
    coneq[11936]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/11232.
    coneq[11937]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/22464.
    coneq[11938]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/7488.
    coneq[11939]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/3744.
    coneq[11940]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/18720.
    coneq[11941]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/74880.
    coneq[11942]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/224640.
    coneq[11943]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/449280.
    coneq[11944]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/149760.
    coneq[11945]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/56160.
    coneq[11946]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/112320.
    coneq[11947]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/37440.
    coneq[11948]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/74880.
    coneq[11949]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/14976.
    coneq[11950]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/44928.
    coneq[11951]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/89856.
    coneq[11952]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/29952.
    coneq[11953]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/11232.
    coneq[11954]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/22464.
    coneq[11955]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/7488.
    coneq[11956]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/22464.
    coneq[11957]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/44928.
    coneq[11958]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/14976.
    coneq[11959]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*dot(A,c))-1/1248.
    coneq[11960]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*dot(A,c))-1/6240.
    coneq[11961]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*dot(A,c))-1/24960.
    coneq[11962]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,c))-1/74880.
    coneq[11963]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c))-1/149760.
    coneq[11964]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/49920.
    coneq[11965]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/18720.
    coneq[11966]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/37440.
    coneq[11967]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/12480.
    coneq[11968]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/24960.
    coneq[11969]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c))-1/4992.
    coneq[11970]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/14976.
    coneq[11971]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/29952.
    coneq[11972]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/9984.
    coneq[11973]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c))-1/3744.
    coneq[11974]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/7488.
    coneq[11975]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/2496.
    coneq[11976]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c))-1/7488.
    coneq[11977]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/14976.
    coneq[11978]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/4992.
    coneq[11979]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c**2))-1/780.
    coneq[11980]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c**2))-1/3120.
    coneq[11981]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c**2))-1/9360.
    coneq[11982]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c**2))-1/18720.
    coneq[11983]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/6240.
    coneq[11984]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c**2))-1/2340.
    coneq[11985]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/4680.
    coneq[11986]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c**2))-1/1560.
    coneq[11987]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c**2))-1/3120.
    coneq[11988]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c**2))-1/2340.
    coneq[11989]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c**2))-1/9360.
    coneq[11990]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/28080.
    coneq[11991]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c**2))-1/56160.
    coneq[11992]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/18720.
    coneq[11993]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2))-1/7020.
    coneq[11994]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/14040.
    coneq[11995]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2))-1/4680.
    coneq[11996]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2))-1/9360.
    coneq[11997]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/4680.
    coneq[11998]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/18720.
    coneq[11999]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/56160.
    coneq[12000]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/112320.
    coneq[12001]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/37440.
    coneq[12002]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/14040.
    coneq[12003]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/28080.
    coneq[12004]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/9360.
    coneq[12005]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/18720.
    coneq[12006]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c**2))-1/1560.
    coneq[12007]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c**2))-1/6240.
    coneq[12008]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/18720.
    coneq[12009]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c**2))-1/37440.
    coneq[12010]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/12480.
    coneq[12011]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c**2))-1/4680.
    coneq[12012]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/9360.
    coneq[12013]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2))-1/3120.
    coneq[12014]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2))-1/6240.
    coneq[12015]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,dot(A,c)))-1/1560.
    coneq[12016]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,dot(A,c)))-1/6240.
    coneq[12017]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,dot(A,c)))-1/18720.
    coneq[12018]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,dot(A,c)))-1/37440.
    coneq[12019]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/12480.
    coneq[12020]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c)))-1/4680.
    coneq[12021]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/9360.
    coneq[12022]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c)))-1/3120.
    coneq[12023]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c)))-1/6240.
    coneq[12024]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/4680.
    coneq[12025]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/18720.
    coneq[12026]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/56160.
    coneq[12027]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/112320.
    coneq[12028]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/37440.
    coneq[12029]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/14040.
    coneq[12030]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/28080.
    coneq[12031]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/9360.
    coneq[12032]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/18720.
    coneq[12033]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/9360.
    coneq[12034]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/37440.
    coneq[12035]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/112320.
    coneq[12036]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/224640.
    coneq[12037]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/74880.
    coneq[12038]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/28080.
    coneq[12039]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/56160.
    coneq[12040]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/18720.
    coneq[12041]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/37440.
    coneq[12042]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/3120.
    coneq[12043]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/12480.
    coneq[12044]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/37440.
    coneq[12045]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/74880.
    coneq[12046]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/24960.
    coneq[12047]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/9360.
    coneq[12048]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/18720.
    coneq[12049]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/6240.
    coneq[12050]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/12480.
    coneq[12051]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c**3))-1/832.
    coneq[12052]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c**3))-1/2496.
    coneq[12053]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**3))-1/4992.
    coneq[12054]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c**3))-1/1664.
    coneq[12055]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**3))-1/7488.
    coneq[12056]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**3))-1/14976.
    coneq[12057]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**3))-1/4992.
    coneq[12058]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/29952.
    coneq[12059]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/9984.
    coneq[12060]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**3))-1/3328.
    coneq[12061]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/22464.
    coneq[12062]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/44928.
    coneq[12063]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/14976.
    coneq[12064]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/89856.
    coneq[12065]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/29952.
    coneq[12066]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/9984.
    coneq[12067]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/179712.
    coneq[12068]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/59904.
    coneq[12069]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/19968.
    coneq[12070]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/6656.
    coneq[12071]=dot(b,dot(A,c**4)*dot(A,c**4)*dot(A,c))-1/650.
    coneq[12072]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*dot(A,c))-1/2600.
    coneq[12073]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*dot(A,c))-1/7800.
    coneq[12074]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*dot(A,c))-1/15600.
    coneq[12075]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*dot(A,c))-1/5200.
    coneq[12076]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*dot(A,c))-1/1950.
    coneq[12077]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*dot(A,c))-1/3900.
    coneq[12078]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*dot(A,c))-1/1300.
    coneq[12079]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*dot(A,c))-1/2600.
    coneq[12080]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*dot(A,c))-1/10400.
    coneq[12081]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*dot(A,c))-1/31200.
    coneq[12082]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*dot(A,c))-1/62400.
    coneq[12083]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/20800.
    coneq[12084]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*dot(A,c))-1/7800.
    coneq[12085]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/15600.
    coneq[12086]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c))-1/5200.
    coneq[12087]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c))-1/10400.
    coneq[12088]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/93600.
    coneq[12089]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/187200.
    coneq[12090]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/62400.
    coneq[12091]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/23400.
    coneq[12092]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/46800.
    coneq[12093]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/15600.
    coneq[12094]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/31200.
    coneq[12095]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/374400.
    coneq[12096]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/124800.
    coneq[12097]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/46800.
    coneq[12098]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/93600.
    coneq[12099]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/31200.
    coneq[12100]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/62400.
    coneq[12101]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/41600.
    coneq[12102]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/15600.
    coneq[12103]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/31200.
    coneq[12104]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/10400.
    coneq[12105]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/20800.
    coneq[12106]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*dot(A,c))-1/5850.
    coneq[12107]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/11700.
    coneq[12108]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c))-1/3900.
    coneq[12109]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c))-1/7800.
    coneq[12110]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/23400.
    coneq[12111]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/7800.
    coneq[12112]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/15600.
    coneq[12113]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c))-1/2600.
    coneq[12114]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c))-1/5200.
    coneq[12115]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/10400.
    coneq[12116]=dot(b,dot(A,c**6)*dot(A,c)*dot(A,c)*c)-1/364.
    coneq[12117]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*dot(A,c)*c)-1/2184.
    coneq[12118]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c)*c)-1/10920.
    coneq[12119]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c)*c)-1/43680.
    coneq[12120]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c)*c)-1/131040.
    coneq[12121]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*c)-1/262080.
    coneq[12122]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/87360.
    coneq[12123]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/32760.
    coneq[12124]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/65520.
    coneq[12125]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/21840.
    coneq[12126]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/43680.
    coneq[12127]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/8736.
    coneq[12128]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/26208.
    coneq[12129]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/52416.
    coneq[12130]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/17472.
    coneq[12131]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/6552.
    coneq[12132]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/13104.
    coneq[12133]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/4368.
    coneq[12134]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/13104.
    coneq[12135]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/26208.
    coneq[12136]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/8736.
    coneq[12137]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*dot(A,c)*c)-1/1820.
    coneq[12138]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/7280.
    coneq[12139]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/21840.
    coneq[12140]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/43680.
    coneq[12141]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/14560.
    coneq[12142]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/5460.
    coneq[12143]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/10920.
    coneq[12144]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/3640.
    coneq[12145]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/7280.
    coneq[12146]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/1456.
    coneq[12147]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/4368.
    coneq[12148]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/8736.
    coneq[12149]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/2912.
    coneq[12150]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/1092.
    coneq[12151]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/2184.
    coneq[12152]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/728.
    coneq[12153]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/3276.
    coneq[12154]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/6552.
    coneq[12155]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/13104.
    coneq[12156]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/2912.
    coneq[12157]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/8736.
    coneq[12158]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/17472.
    coneq[12159]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/5824.
    coneq[12160]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/2184.
    coneq[12161]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/4368.
    coneq[12162]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1456.
    coneq[12163]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/2912.
    coneq[12164]=dot(b,dot(A,c**5)*dot(A,c**2)*dot(A,c)*c)-1/468.
    coneq[12165]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*dot(A,c)*c)-1/2340.
    coneq[12166]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c)*c)-1/9360.
    coneq[12167]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c)*c)-1/28080.
    coneq[12168]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c)*c)-1/56160.
    coneq[12169]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/18720.
    coneq[12170]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/7020.
    coneq[12171]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/14040.
    coneq[12172]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/4680.
    coneq[12173]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/9360.
    coneq[12174]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*dot(A,c)*c)-1/1872.
    coneq[12175]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/5616.
    coneq[12176]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/11232.
    coneq[12177]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/3744.
    coneq[12178]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/1404.
    coneq[12179]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/2808.
    coneq[12180]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/936.
    coneq[12181]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/2808.
    coneq[12182]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/5616.
    coneq[12183]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/1872.
    coneq[12184]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,c)*c)-1/936.
    coneq[12185]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,c)*c)-1/4680.
    coneq[12186]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c)*c)-1/18720.
    coneq[12187]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c)*c)-1/56160.
    coneq[12188]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*c)-1/112320.
    coneq[12189]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/37440.
    coneq[12190]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/14040.
    coneq[12191]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/28080.
    coneq[12192]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/9360.
    coneq[12193]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/18720.
    coneq[12194]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c)-1/3744.
    coneq[12195]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/11232.
    coneq[12196]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/22464.
    coneq[12197]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/7488.
    coneq[12198]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/2808.
    coneq[12199]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/5616.
    coneq[12200]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/1872.
    coneq[12201]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/5616.
    coneq[12202]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/11232.
    coneq[12203]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/3744.
    coneq[12204]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c**2)*c)-1/585.
    coneq[12205]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c**2)*c)-1/2340.
    coneq[12206]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2)*c)-1/7020.
    coneq[12207]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2)*c)-1/14040.
    coneq[12208]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/4680.
    coneq[12209]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c)-1/1755.
    coneq[12210]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/3510.
    coneq[12211]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/1170.
    coneq[12212]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/2340.
    coneq[12213]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c**2)*c)-1/1170.
    coneq[12214]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/4680.
    coneq[12215]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/14040.
    coneq[12216]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/28080.
    coneq[12217]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/9360.
    coneq[12218]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/3510.
    coneq[12219]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/7020.
    coneq[12220]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/2340.
    coneq[12221]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/4680.
    coneq[12222]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/2340.
    coneq[12223]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/9360.
    coneq[12224]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/28080.
    coneq[12225]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/56160.
    coneq[12226]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/18720.
    coneq[12227]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/7020.
    coneq[12228]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/14040.
    coneq[12229]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/4680.
    coneq[12230]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/9360.
    coneq[12231]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c)*c)-1/520.
    coneq[12232]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c)*c)-1/2080.
    coneq[12233]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c)*c)-1/6240.
    coneq[12234]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c)*c)-1/12480.
    coneq[12235]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/4160.
    coneq[12236]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c)*c)-1/1560.
    coneq[12237]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/3120.
    coneq[12238]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c)*c)-1/1040.
    coneq[12239]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c)*c)-1/2080.
    coneq[12240]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c)*c)-1/1560.
    coneq[12241]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/6240.
    coneq[12242]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/18720.
    coneq[12243]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/37440.
    coneq[12244]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/12480.
    coneq[12245]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/4680.
    coneq[12246]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/9360.
    coneq[12247]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/3120.
    coneq[12248]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/6240.
    coneq[12249]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/3120.
    coneq[12250]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/12480.
    coneq[12251]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/37440.
    coneq[12252]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/74880.
    coneq[12253]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/24960.
    coneq[12254]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/9360.
    coneq[12255]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/18720.
    coneq[12256]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/6240.
    coneq[12257]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/12480.
    coneq[12258]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c)*c)-1/1040.
    coneq[12259]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/4160.
    coneq[12260]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/12480.
    coneq[12261]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/24960.
    coneq[12262]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/8320.
    coneq[12263]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/3120.
    coneq[12264]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/6240.
    coneq[12265]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/2080.
    coneq[12266]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/4160.
    coneq[12267]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c**2)*c)-1/624.
    coneq[12268]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c**2)*c)-1/1872.
    coneq[12269]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2)*c)-1/3744.
    coneq[12270]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c**2)*c)-1/1248.
    coneq[12271]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/5616.
    coneq[12272]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/11232.
    coneq[12273]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/3744.
    coneq[12274]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/22464.
    coneq[12275]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/7488.
    coneq[12276]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/2496.
    coneq[12277]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,dot(A,c))*c)-1/1248.
    coneq[12278]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/3744.
    coneq[12279]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/7488.
    coneq[12280]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/2496.
    coneq[12281]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/11232.
    coneq[12282]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/22464.
    coneq[12283]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/7488.
    coneq[12284]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/44928.
    coneq[12285]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/14976.
    coneq[12286]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/4992.
    coneq[12287]=dot(b,dot(A,c**5)*dot(A,c)*dot(A,c)*c*c)-1/312.
    coneq[12288]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*dot(A,c)*c*c)-1/1560.
    coneq[12289]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c*c)-1/6240.
    coneq[12290]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c*c)-1/18720.
    coneq[12291]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c*c)-1/37440.
    coneq[12292]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/12480.
    coneq[12293]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/4680.
    coneq[12294]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/9360.
    coneq[12295]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/3120.
    coneq[12296]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/6240.
    coneq[12297]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*dot(A,c)*c*c)-1/1248.
    coneq[12298]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/3744.
    coneq[12299]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/7488.
    coneq[12300]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/2496.
    coneq[12301]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/936.
    coneq[12302]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/1872.
    coneq[12303]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/624.
    coneq[12304]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/1872.
    coneq[12305]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/3744.
    coneq[12306]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/1248.
    coneq[12307]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c)*c*c)-1/390.
    coneq[12308]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c)*c*c)-1/1560.
    coneq[12309]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c*c)-1/4680.
    coneq[12310]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c*c)-1/9360.
    coneq[12311]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/3120.
    coneq[12312]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c*c)-1/1170.
    coneq[12313]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/2340.
    coneq[12314]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/780.
    coneq[12315]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/1560.
    coneq[12316]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c)*c*c)-1/780.
    coneq[12317]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/3120.
    coneq[12318]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/9360.
    coneq[12319]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/18720.
    coneq[12320]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/6240.
    coneq[12321]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/2340.
    coneq[12322]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/4680.
    coneq[12323]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/1560.
    coneq[12324]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/3120.
    coneq[12325]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2)*c*c)-1/468.
    coneq[12326]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c*c)-1/1404.
    coneq[12327]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c*c)-1/2808.
    coneq[12328]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c*c)-1/936.
    coneq[12329]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/936.
    coneq[12330]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/2808.
    coneq[12331]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/5616.
    coneq[12332]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/1872.
    coneq[12333]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/1872.
    coneq[12334]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/5616.
    coneq[12335]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/11232.
    coneq[12336]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/3744.
    coneq[12337]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c)*c*c)-1/416.
    coneq[12338]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c)*c*c)-1/1248.
    coneq[12339]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c*c)-1/2496.
    coneq[12340]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c)*c*c)-1/832.
    coneq[12341]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/3744.
    coneq[12342]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/7488.
    coneq[12343]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/2496.
    coneq[12344]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/14976.
    coneq[12345]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/4992.
    coneq[12346]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/1664.
    coneq[12347]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*c**3)-1/260.
    coneq[12348]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*c**3)-1/1040.
    coneq[12349]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c**3)-1/3120.
    coneq[12350]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c**3)-1/6240.
    coneq[12351]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/2080.
    coneq[12352]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*c**3)-1/780.
    coneq[12353]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/1560.
    coneq[12354]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/520.
    coneq[12355]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/1040.
    coneq[12356]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*c**3)-1/312.
    coneq[12357]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*c**3)-1/936.
    coneq[12358]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c**3)-1/1872.
    coneq[12359]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*c**3)-1/624.
    coneq[12360]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*c**3)-1/624.
    coneq[12361]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/1872.
    coneq[12362]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/3744.
    coneq[12363]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/1248.
    coneq[12364]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*c**3)-1/351.
    coneq[12365]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*c**3)-1/702.
    coneq[12366]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c**3)-1/1404.
    coneq[12367]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c**3)-1/2808.
    coneq[12368]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*c**4)-1/208.
    coneq[12369]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c**4)-1/624.
    coneq[12370]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**4)-1/1248.
    coneq[12371]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c**4)-1/416.
    coneq[12372]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*c**4)-1/234.
    coneq[12373]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c**4)-1/468.
    coneq[12374]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**4)-1/936.
    coneq[12375]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*c**5)-1/156.
    coneq[12376]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c**5)-1/312.
    coneq[12377]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c**6)-1/104.
    coneq[12378]=dot(b,dot(A,c**5)*dot(A,c)*dot(A,c)*dot(A,c))-1/624.
    coneq[12379]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*dot(A,c)*dot(A,c))-1/3120.
    coneq[12380]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*dot(A,c))-1/12480.
    coneq[12381]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*dot(A,c))-1/37440.
    coneq[12382]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*dot(A,c))-1/74880.
    coneq[12383]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/24960.
    coneq[12384]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/9360.
    coneq[12385]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/18720.
    coneq[12386]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/6240.
    coneq[12387]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/12480.
    coneq[12388]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c))-1/2496.
    coneq[12389]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/7488.
    coneq[12390]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/14976.
    coneq[12391]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/4992.
    coneq[12392]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/1872.
    coneq[12393]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/3744.
    coneq[12394]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/1248.
    coneq[12395]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/3744.
    coneq[12396]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/7488.
    coneq[12397]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/2496.
    coneq[12398]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c)*dot(A,c))-1/780.
    coneq[12399]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/3120.
    coneq[12400]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/9360.
    coneq[12401]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/18720.
    coneq[12402]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/6240.
    coneq[12403]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/2340.
    coneq[12404]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/4680.
    coneq[12405]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/1560.
    coneq[12406]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/3120.
    coneq[12407]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/1560.
    coneq[12408]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/6240.
    coneq[12409]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/18720.
    coneq[12410]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/37440.
    coneq[12411]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/12480.
    coneq[12412]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/4680.
    coneq[12413]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/9360.
    coneq[12414]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/3120.
    coneq[12415]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/6240.
    coneq[12416]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c)*dot(A,c))-1/832.
    coneq[12417]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/2496.
    coneq[12418]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/4992.
    coneq[12419]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/1664.
    coneq[12420]=dot(b,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/2496.
    coneq[12421]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/7488.
    coneq[12422]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/14976.
    coneq[12423]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/4992.
    coneq[12424]=dot(b,dot(A,c**3)*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/4992.
    coneq[12425]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/14976.
    coneq[12426]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/29952.
    coneq[12427]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/9984.
    coneq[12428]=dot(b,dot(A,c**3)*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/1664.
    coneq[12429]=dot(b,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/4992.
    coneq[12430]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/9984.
    coneq[12431]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/3328.
    coneq[12432]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/936.
    coneq[12433]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/2808.
    coneq[12434]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/5616.
    coneq[12435]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/1872.
    coneq[12436]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/1872.
    coneq[12437]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/5616.
    coneq[12438]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/11232.
    coneq[12439]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/3744.
    coneq[12440]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/3744.
    coneq[12441]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/11232.
    coneq[12442]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/22464.
    coneq[12443]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/7488.
    coneq[12444]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/1053.
    coneq[12445]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/2106.
    coneq[12446]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/2106.
    coneq[12447]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/4212.
    coneq[12448]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/4212.
    coneq[12449]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/8424.
    coneq[12450]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/8424.
    coneq[12451]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/16848.
    coneq[12452]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/520.
    coneq[12453]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/2080.
    coneq[12454]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/6240.
    coneq[12455]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/12480.
    coneq[12456]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/4160.
    coneq[12457]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/1560.
    coneq[12458]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/3120.
    coneq[12459]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/1040.
    coneq[12460]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/2080.
    coneq[12461]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/624.
    coneq[12462]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/1872.
    coneq[12463]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/3744.
    coneq[12464]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/1248.
    coneq[12465]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1248.
    coneq[12466]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/3744.
    coneq[12467]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/7488.
    coneq[12468]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/2496.
    coneq[12469]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/702.
    coneq[12470]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/1404.
    coneq[12471]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/1404.
    coneq[12472]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/2808.
    coneq[12473]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/2808.
    coneq[12474]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/5616.
    coneq[12475]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/416.
    coneq[12476]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/1248.
    coneq[12477]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/2496.
    coneq[12478]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/832.
    coneq[12479]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/468.
    coneq[12480]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/936.
    coneq[12481]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/936.
    coneq[12482]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/1872.
    coneq[12483]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/312.
    coneq[12484]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/624.
    coneq[12485]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)*c**4)-1/208.
    coneq[12486]=dot(b,c**12)-1/13.
    if any(abs(coneq)>tol):
        return 12
    # order 14 conditions:
    coneq[0]=dot(b,dot(A,c**12))-1/182.
    coneq[1]=dot(b,dot(A,dot(A,c**11)))-1/2184.
    coneq[2]=dot(b,dot(A,dot(A,dot(A,c**10))))-1/24024.
    coneq[3]=dot(b,dot(A,dot(A,dot(A,dot(A,c**9)))))-1/240240.
    coneq[4]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**8))))))-1/2162160.
    coneq[5]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**7)))))))-1/17297280.
    coneq[6]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**6))))))))-1/121080960.
    coneq[7]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))))))-1/726485760.
    coneq[8]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))))-1/3632428800.
    coneq[9]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))))-1/14529715200.
    coneq[10]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))))-1/43589145600.
    coneq[11]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))))-1/87178291200.
    coneq[12]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))))-1/29059430400.
    coneq[13]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))))-1/10897286400.
    coneq[14]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))))-1/21794572800.
    coneq[15]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))))-1/7264857600.
    coneq[16]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))))-1/14529715200.
    coneq[17]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))))-1/2905943040.
    coneq[18]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))))-1/8717829120.
    coneq[19]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))))-1/17435658240.
    coneq[20]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))))-1/5811886080.
    coneq[21]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))))-1/2179457280.
    coneq[22]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))))-1/4358914560.
    coneq[23]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))))-1/1452971520.
    coneq[24]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))))-1/4358914560.
    coneq[25]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))))-1/8717829120.
    coneq[26]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))))-1/2905943040.
    coneq[27]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))))))-1/605404800.
    coneq[28]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))))-1/2421619200.
    coneq[29]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))))-1/7264857600.
    coneq[30]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/14529715200.
    coneq[31]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))))-1/4843238400.
    coneq[32]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))))-1/1816214400.
    coneq[33]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))))-1/3632428800.
    coneq[34]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))))-1/1210809600.
    coneq[35]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))))-1/2421619200.
    coneq[36]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))))-1/484323840.
    coneq[37]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))))-1/1452971520.
    coneq[38]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))))-1/2905943040.
    coneq[39]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))))-1/968647680.
    coneq[40]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))))-1/363242880.
    coneq[41]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))))-1/726485760.
    coneq[42]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))))))-1/242161920.
    coneq[43]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))))-1/1089728640.
    coneq[44]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))))-1/2179457280.
    coneq[45]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))))-1/4358914560.
    coneq[46]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))))-1/968647680.
    coneq[47]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))))-1/2905943040.
    coneq[48]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))))-1/5811886080.
    coneq[49]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))))-1/1937295360.
    coneq[50]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))))-1/726485760.
    coneq[51]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))))-1/1452971520.
    coneq[52]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))))-1/484323840.
    coneq[53]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))))-1/968647680.
    coneq[54]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5))))))))-1/103783680.
    coneq[55]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))))))-1/518918400.
    coneq[56]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))))-1/2075673600.
    coneq[57]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/6227020800.
    coneq[58]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/12454041600.
    coneq[59]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/4151347200.
    coneq[60]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))))-1/1556755200.
    coneq[61]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/3113510400.
    coneq[62]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))))-1/1037836800.
    coneq[63]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/2075673600.
    coneq[64]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))))-1/415134720.
    coneq[65]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))))-1/1245404160.
    coneq[66]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/2490808320.
    coneq[67]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))))-1/830269440.
    coneq[68]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))))-1/311351040.
    coneq[69]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))))-1/622702080.
    coneq[70]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))))-1/207567360.
    coneq[71]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))))-1/622702080.
    coneq[72]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/1245404160.
    coneq[73]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))))-1/415134720.
    coneq[74]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))))))-1/86486400.
    coneq[75]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))))-1/345945600.
    coneq[76]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))))-1/1037836800.
    coneq[77]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/2075673600.
    coneq[78]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))))-1/691891200.
    coneq[79]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))))-1/259459200.
    coneq[80]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))))-1/518918400.
    coneq[81]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))))-1/172972800.
    coneq[82]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))))-1/345945600.
    coneq[83]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))))))-1/69189120.
    coneq[84]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))))-1/207567360.
    coneq[85]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))))-1/415134720.
    coneq[86]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))))-1/138378240.
    coneq[87]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))))))-1/51891840.
    coneq[88]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))))))-1/103783680.
    coneq[89]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c))))))))-1/34594560.
    coneq[90]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))))-1/207567360.
    coneq[91]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))))-1/622702080.
    coneq[92]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))))-1/1245404160.
    coneq[93]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))))-1/415134720.
    coneq[94]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))))-1/415134720.
    coneq[95]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))))-1/1245404160.
    coneq[96]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))))-1/2490808320.
    coneq[97]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))))-1/830269440.
    coneq[98]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))))))-1/172972800.
    coneq[99]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))))-1/691891200.
    coneq[100]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))))-1/2075673600.
    coneq[101]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/4151347200.
    coneq[102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))))-1/1383782400.
    coneq[103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))))-1/518918400.
    coneq[104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))))-1/1037836800.
    coneq[105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))))-1/345945600.
    coneq[106]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))))-1/691891200.
    coneq[107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))))-1/155675520.
    coneq[108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))))-1/311351040.
    coneq[109]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/622702080.
    coneq[110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))))-1/138378240.
    coneq[111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))))-1/415134720.
    coneq[112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/830269440.
    coneq[113]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))))-1/276756480.
    coneq[114]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))))-1/103783680.
    coneq[115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))))-1/207567360.
    coneq[116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))))-1/69189120.
    coneq[117]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))))-1/207567360.
    coneq[118]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))))-1/415134720.
    coneq[119]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))))-1/138378240.
    coneq[120]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**6)))))))-1/15135120.
    coneq[121]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5))))))))-1/90810720.
    coneq[122]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))))))-1/454053600.
    coneq[123]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))))-1/1816214400.
    coneq[124]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/5448643200.
    coneq[125]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/10897286400.
    coneq[126]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/3632428800.
    coneq[127]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))))-1/1362160800.
    coneq[128]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/2724321600.
    coneq[129]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))))-1/908107200.
    coneq[130]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/1816214400.
    coneq[131]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))))-1/363242880.
    coneq[132]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))))-1/1089728640.
    coneq[133]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/2179457280.
    coneq[134]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))))-1/726485760.
    coneq[135]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))))-1/272432160.
    coneq[136]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))))-1/544864320.
    coneq[137]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))))-1/181621440.
    coneq[138]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))))-1/544864320.
    coneq[139]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/1089728640.
    coneq[140]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))))-1/363242880.
    coneq[141]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))))))-1/75675600.
    coneq[142]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))))-1/302702400.
    coneq[143]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))))-1/908107200.
    coneq[144]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1816214400.
    coneq[145]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))))-1/605404800.
    coneq[146]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))))-1/227026800.
    coneq[147]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))))-1/454053600.
    coneq[148]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))))-1/151351200.
    coneq[149]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))))-1/302702400.
    coneq[150]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))))))-1/60540480.
    coneq[151]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))))-1/181621440.
    coneq[152]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))))-1/363242880.
    coneq[153]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))))-1/121080960.
    coneq[154]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))))))-1/45405360.
    coneq[155]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))))-1/90810720.
    coneq[156]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))))))-1/30270240.
    coneq[157]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))))-1/136216080.
    coneq[158]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))))-1/272432160.
    coneq[159]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/544864320.
    coneq[160]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))))-1/121080960.
    coneq[161]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))))-1/363242880.
    coneq[162]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/726485760.
    coneq[163]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))))-1/242161920.
    coneq[164]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))))-1/90810720.
    coneq[165]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))))-1/181621440.
    coneq[166]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))))-1/60540480.
    coneq[167]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))))-1/121080960.
    coneq[168]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**5)))))))-1/12972960.
    coneq[169]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))))))-1/64864800.
    coneq[170]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))))-1/259459200.
    coneq[171]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/778377600.
    coneq[172]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1556755200.
    coneq[173]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/518918400.
    coneq[174]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))))-1/194594400.
    coneq[175]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/389188800.
    coneq[176]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))))-1/129729600.
    coneq[177]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/259459200.
    coneq[178]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))))))-1/51891840.
    coneq[179]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))))-1/155675520.
    coneq[180]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/311351040.
    coneq[181]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))))-1/103783680.
    coneq[182]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))))))-1/38918880.
    coneq[183]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))))-1/77837760.
    coneq[184]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))))))-1/25945920.
    coneq[185]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))))-1/77837760.
    coneq[186]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/155675520.
    coneq[187]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))))-1/51891840.
    coneq[188]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**4)))))))-1/10810800.
    coneq[189]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))))))-1/43243200.
    coneq[190]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))))-1/129729600.
    coneq[191]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/259459200.
    coneq[192]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))))-1/86486400.
    coneq[193]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))))))-1/32432400.
    coneq[194]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))))-1/64864800.
    coneq[195]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))))))-1/21621600.
    coneq[196]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))))-1/43243200.
    coneq[197]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**3)))))))-1/8648640.
    coneq[198]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))))))-1/25945920.
    coneq[199]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))))))-1/51891840.
    coneq[200]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))))))-1/17297280.
    coneq[201]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c**2)))))))-1/6486480.
    coneq[202]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c))))))))-1/12972960.
    coneq[203]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**6*dot(A,c)))))))-1/4324320.
    coneq[204]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))))))-1/34594560.
    coneq[205]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))))-1/103783680.
    coneq[206]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))))-1/207567360.
    coneq[207]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))))-1/69189120.
    coneq[208]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))))-1/311351040.
    coneq[209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))))-1/622702080.
    coneq[210]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))))-1/207567360.
    coneq[211]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))))-1/1245404160.
    coneq[212]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))))-1/415134720.
    coneq[213]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))))-1/138378240.
    coneq[214]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))))))-1/32432400.
    coneq[215]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))))-1/129729600.
    coneq[216]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))))-1/389188800.
    coneq[217]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/778377600.
    coneq[218]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))))-1/259459200.
    coneq[219]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))))-1/97297200.
    coneq[220]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))))-1/194594400.
    coneq[221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))))-1/64864800.
    coneq[222]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))))-1/129729600.
    coneq[223]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))))))-1/64864800.
    coneq[224]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))))-1/259459200.
    coneq[225]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))))-1/778377600.
    coneq[226]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/1556755200.
    coneq[227]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))))-1/518918400.
    coneq[228]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))))-1/194594400.
    coneq[229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))))-1/389188800.
    coneq[230]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))))-1/129729600.
    coneq[231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))))-1/259459200.
    coneq[232]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5)))))))-1/25945920.
    coneq[233]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))))))-1/129729600.
    coneq[234]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))))-1/518918400.
    coneq[235]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/1556755200.
    coneq[236]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/3113510400.
    coneq[237]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/1037836800.
    coneq[238]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))))-1/389188800.
    coneq[239]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/778377600.
    coneq[240]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))))-1/259459200.
    coneq[241]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/518918400.
    coneq[242]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))))-1/103783680.
    coneq[243]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))))-1/311351040.
    coneq[244]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/622702080.
    coneq[245]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))))-1/207567360.
    coneq[246]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))))-1/77837760.
    coneq[247]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))))-1/155675520.
    coneq[248]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))))-1/51891840.
    coneq[249]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))))-1/155675520.
    coneq[250]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/311351040.
    coneq[251]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))))-1/103783680.
    coneq[252]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))))))-1/25945920.
    coneq[253]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))))-1/77837760.
    coneq[254]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))))-1/155675520.
    coneq[255]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))))-1/51891840.
    coneq[256]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))))-1/51891840.
    coneq[257]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))))-1/155675520.
    coneq[258]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))))-1/311351040.
    coneq[259]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))))-1/103783680.
    coneq[260]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))))))-1/21621600.
    coneq[261]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))))-1/86486400.
    coneq[262]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))))-1/259459200.
    coneq[263]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/518918400.
    coneq[264]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))))-1/172972800.
    coneq[265]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))))-1/64864800.
    coneq[266]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))))-1/129729600.
    coneq[267]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))))-1/43243200.
    coneq[268]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))))-1/86486400.
    coneq[269]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))))-1/19459440.
    coneq[270]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))))-1/38918880.
    coneq[271]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/77837760.
    coneq[272]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))))))-1/17297280.
    coneq[273]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))))-1/51891840.
    coneq[274]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/103783680.
    coneq[275]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))))-1/34594560.
    coneq[276]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))))))-1/12972960.
    coneq[277]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))))-1/25945920.
    coneq[278]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))))))-1/8648640.
    coneq[279]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))))-1/34594560.
    coneq[280]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))))-1/103783680.
    coneq[281]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/207567360.
    coneq[282]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))))-1/69189120.
    coneq[283]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))))-1/38918880.
    coneq[284]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))))-1/77837760.
    coneq[285]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/155675520.
    coneq[286]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))))-1/25945920.
    coneq[287]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))))-1/51891840.
    coneq[288]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/17297280.
    coneq[289]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/34594560.
    coneq[290]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**7))))))-1/1921920.
    coneq[291]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**6)))))))-1/13453440.
    coneq[292]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5))))))))-1/80720640.
    coneq[293]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))))))-1/403603200.
    coneq[294]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))))-1/1614412800.
    coneq[295]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/4843238400.
    coneq[296]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/9686476800.
    coneq[297]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/3228825600.
    coneq[298]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))))-1/1210809600.
    coneq[299]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/2421619200.
    coneq[300]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))))-1/807206400.
    coneq[301]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/1614412800.
    coneq[302]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))))-1/322882560.
    coneq[303]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))))-1/968647680.
    coneq[304]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/1937295360.
    coneq[305]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))))-1/645765120.
    coneq[306]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))))-1/242161920.
    coneq[307]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))))-1/484323840.
    coneq[308]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))))-1/161441280.
    coneq[309]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))))-1/484323840.
    coneq[310]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/968647680.
    coneq[311]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))))-1/322882560.
    coneq[312]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))))))-1/67267200.
    coneq[313]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))))-1/269068800.
    coneq[314]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))))-1/807206400.
    coneq[315]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1614412800.
    coneq[316]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))))-1/538137600.
    coneq[317]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))))-1/201801600.
    coneq[318]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))))-1/403603200.
    coneq[319]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))))-1/134534400.
    coneq[320]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))))-1/269068800.
    coneq[321]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))))))-1/53813760.
    coneq[322]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))))-1/161441280.
    coneq[323]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))))-1/322882560.
    coneq[324]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))))-1/107627520.
    coneq[325]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))))))-1/40360320.
    coneq[326]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))))-1/80720640.
    coneq[327]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))))))-1/26906880.
    coneq[328]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))))-1/121080960.
    coneq[329]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))))-1/242161920.
    coneq[330]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/484323840.
    coneq[331]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))))-1/107627520.
    coneq[332]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))))-1/322882560.
    coneq[333]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/645765120.
    coneq[334]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))))-1/215255040.
    coneq[335]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))))-1/80720640.
    coneq[336]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))))-1/161441280.
    coneq[337]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))))-1/53813760.
    coneq[338]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))))-1/107627520.
    coneq[339]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**5)))))))-1/11531520.
    coneq[340]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))))))-1/57657600.
    coneq[341]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))))-1/230630400.
    coneq[342]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/691891200.
    coneq[343]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1383782400.
    coneq[344]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/461260800.
    coneq[345]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))))-1/172972800.
    coneq[346]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/345945600.
    coneq[347]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))))-1/115315200.
    coneq[348]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/230630400.
    coneq[349]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))))))-1/46126080.
    coneq[350]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))))-1/138378240.
    coneq[351]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/276756480.
    coneq[352]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))))-1/92252160.
    coneq[353]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))))))-1/34594560.
    coneq[354]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))))-1/69189120.
    coneq[355]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))))))-1/23063040.
    coneq[356]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))))-1/69189120.
    coneq[357]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/138378240.
    coneq[358]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))))-1/46126080.
    coneq[359]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4)))))))-1/9609600.
    coneq[360]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))))))-1/38438400.
    coneq[361]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))))-1/115315200.
    coneq[362]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/230630400.
    coneq[363]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))))-1/76876800.
    coneq[364]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))))))-1/28828800.
    coneq[365]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))))-1/57657600.
    coneq[366]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))))))-1/19219200.
    coneq[367]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))))-1/38438400.
    coneq[368]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3)))))))-1/7687680.
    coneq[369]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))))))-1/23063040.
    coneq[370]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))))-1/46126080.
    coneq[371]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))))))-1/15375360.
    coneq[372]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2)))))))-1/5765760.
    coneq[373]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))))))-1/11531520.
    coneq[374]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5*dot(A,c)))))))-1/3843840.
    coneq[375]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))))))-1/23063040.
    coneq[376]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))))-1/69189120.
    coneq[377]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))))-1/138378240.
    coneq[378]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))))-1/46126080.
    coneq[379]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))))-1/46126080.
    coneq[380]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))))-1/138378240.
    coneq[381]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))))-1/276756480.
    coneq[382]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))))-1/92252160.
    coneq[383]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))))))-1/19219200.
    coneq[384]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))))-1/76876800.
    coneq[385]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))))-1/230630400.
    coneq[386]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/461260800.
    coneq[387]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))))-1/153753600.
    coneq[388]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))))-1/57657600.
    coneq[389]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))))-1/115315200.
    coneq[390]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))))-1/38438400.
    coneq[391]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))))-1/76876800.
    coneq[392]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))))))-1/17297280.
    coneq[393]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))))-1/34594560.
    coneq[394]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/69189120.
    coneq[395]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))))))-1/15375360.
    coneq[396]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))))-1/46126080.
    coneq[397]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/92252160.
    coneq[398]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))))-1/30750720.
    coneq[399]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))))))-1/11531520.
    coneq[400]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))))-1/23063040.
    coneq[401]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))))))-1/7687680.
    coneq[402]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))))-1/23063040.
    coneq[403]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))))-1/46126080.
    coneq[404]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/15375360.
    coneq[405]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**6))))))-1/1681680.
    coneq[406]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**5)))))))-1/10090080.
    coneq[407]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))))))-1/50450400.
    coneq[408]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/201801600.
    coneq[409]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/605404800.
    coneq[410]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1210809600.
    coneq[411]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/403603200.
    coneq[412]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/151351200.
    coneq[413]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/302702400.
    coneq[414]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/100900800.
    coneq[415]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/201801600.
    coneq[416]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))))))-1/40360320.
    coneq[417]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/121080960.
    coneq[418]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/242161920.
    coneq[419]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/80720640.
    coneq[420]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))))))-1/30270240.
    coneq[421]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/60540480.
    coneq[422]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))))))-1/20180160.
    coneq[423]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/60540480.
    coneq[424]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/121080960.
    coneq[425]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/40360320.
    coneq[426]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4)))))))-1/8408400.
    coneq[427]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))))))-1/33633600.
    coneq[428]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/100900800.
    coneq[429]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/201801600.
    coneq[430]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/67267200.
    coneq[431]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))))))-1/25225200.
    coneq[432]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/50450400.
    coneq[433]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))))))-1/16816800.
    coneq[434]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/33633600.
    coneq[435]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3)))))))-1/6726720.
    coneq[436]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))))))-1/20180160.
    coneq[437]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/40360320.
    coneq[438]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))))))-1/13453440.
    coneq[439]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2)))))))-1/5045040.
    coneq[440]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))))))-1/10090080.
    coneq[441]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c)))))))-1/3363360.
    coneq[442]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/15135120.
    coneq[443]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/30270240.
    coneq[444]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/60540480.
    coneq[445]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))))))-1/13453440.
    coneq[446]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/40360320.
    coneq[447]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/80720640.
    coneq[448]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/26906880.
    coneq[449]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/10090080.
    coneq[450]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/20180160.
    coneq[451]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/6726720.
    coneq[452]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/13453440.
    coneq[453]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**5))))))-1/1441440.
    coneq[454]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**4)))))))-1/7207200.
    coneq[455]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))))))-1/28828800.
    coneq[456]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/86486400.
    coneq[457]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/172972800.
    coneq[458]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/57657600.
    coneq[459]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))))))-1/21621600.
    coneq[460]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/43243200.
    coneq[461]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))))))-1/14414400.
    coneq[462]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/28828800.
    coneq[463]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3)))))))-1/5765760.
    coneq[464]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))))))-1/17297280.
    coneq[465]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/34594560.
    coneq[466]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))))))-1/11531520.
    coneq[467]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2)))))))-1/4324320.
    coneq[468]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))))))-1/8648640.
    coneq[469]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c)))))))-1/2882880.
    coneq[470]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))))))-1/8648640.
    coneq[471]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/17297280.
    coneq[472]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))))))-1/5765760.
    coneq[473]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**4))))))-1/1201200.
    coneq[474]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**3)))))))-1/4804800.
    coneq[475]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))))))-1/14414400.
    coneq[476]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/28828800.
    coneq[477]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))))))-1/9609600.
    coneq[478]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2)))))))-1/3603600.
    coneq[479]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))))))-1/7207200.
    coneq[480]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c)))))))-1/2402400.
    coneq[481]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))))))-1/4804800.
    coneq[482]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c**3))))))-1/960960.
    coneq[483]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[484]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[485]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[486]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6*dot(A,c**2))))))-1/720720.
    coneq[487]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6*dot(A,dot(A,c)))))))-1/1441440.
    coneq[488]=dot(b,dot(A,dot(A,dot(A,dot(A,c**7*dot(A,c))))))-1/480480.
    coneq[489]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**4))))))-1/4804800.
    coneq[490]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))))))-1/19219200.
    coneq[491]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))))-1/57657600.
    coneq[492]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/115315200.
    coneq[493]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))))-1/38438400.
    coneq[494]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))))))-1/14414400.
    coneq[495]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))))-1/28828800.
    coneq[496]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))))))-1/9609600.
    coneq[497]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))))-1/19219200.
    coneq[498]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))))))-1/14414400.
    coneq[499]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))))-1/57657600.
    coneq[500]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))))-1/172972800.
    coneq[501]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/345945600.
    coneq[502]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))))-1/115315200.
    coneq[503]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))))-1/43243200.
    coneq[504]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))))-1/86486400.
    coneq[505]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))))-1/28828800.
    coneq[506]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))))-1/57657600.
    coneq[507]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))))))-1/28828800.
    coneq[508]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))))-1/115315200.
    coneq[509]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))))-1/345945600.
    coneq[510]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/691891200.
    coneq[511]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))))-1/230630400.
    coneq[512]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))))-1/86486400.
    coneq[513]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))))-1/172972800.
    coneq[514]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))))-1/57657600.
    coneq[515]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))))-1/115315200.
    coneq[516]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))))))-1/9609600.
    coneq[517]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))))-1/38438400.
    coneq[518]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))))-1/115315200.
    coneq[519]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/230630400.
    coneq[520]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))))-1/76876800.
    coneq[521]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))))-1/28828800.
    coneq[522]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))))-1/57657600.
    coneq[523]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))))-1/19219200.
    coneq[524]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))))-1/38438400.
    coneq[525]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**5))))))-1/4324320.
    coneq[526]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))))))-1/21621600.
    coneq[527]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))))-1/86486400.
    coneq[528]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/259459200.
    coneq[529]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/518918400.
    coneq[530]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/172972800.
    coneq[531]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))))-1/64864800.
    coneq[532]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/129729600.
    coneq[533]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))))-1/43243200.
    coneq[534]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/86486400.
    coneq[535]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))))))-1/17297280.
    coneq[536]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))))-1/51891840.
    coneq[537]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/103783680.
    coneq[538]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))))-1/34594560.
    coneq[539]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))))-1/12972960.
    coneq[540]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))))-1/25945920.
    coneq[541]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))))))-1/8648640.
    coneq[542]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))))-1/25945920.
    coneq[543]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/51891840.
    coneq[544]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))))-1/17297280.
    coneq[545]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5))))))-1/8648640.
    coneq[546]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))))))-1/43243200.
    coneq[547]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))))-1/172972800.
    coneq[548]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/518918400.
    coneq[549]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/1037836800.
    coneq[550]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/345945600.
    coneq[551]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))))-1/129729600.
    coneq[552]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/259459200.
    coneq[553]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))))-1/86486400.
    coneq[554]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/172972800.
    coneq[555]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))))-1/34594560.
    coneq[556]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))))-1/103783680.
    coneq[557]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/207567360.
    coneq[558]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))))-1/69189120.
    coneq[559]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))))-1/25945920.
    coneq[560]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))))-1/51891840.
    coneq[561]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))))-1/17297280.
    coneq[562]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))))-1/51891840.
    coneq[563]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/103783680.
    coneq[564]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))))-1/34594560.
    coneq[565]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**6))))))-1/3363360.
    coneq[566]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5)))))))-1/20180160.
    coneq[567]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))))))-1/100900800.
    coneq[568]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/403603200.
    coneq[569]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/1210809600.
    coneq[570]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/2421619200.
    coneq[571]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/807206400.
    coneq[572]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/302702400.
    coneq[573]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/605404800.
    coneq[574]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/201801600.
    coneq[575]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/403603200.
    coneq[576]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))))-1/80720640.
    coneq[577]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/242161920.
    coneq[578]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/484323840.
    coneq[579]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/161441280.
    coneq[580]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))))-1/60540480.
    coneq[581]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/121080960.
    coneq[582]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))))-1/40360320.
    coneq[583]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/121080960.
    coneq[584]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/242161920.
    coneq[585]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/80720640.
    coneq[586]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))))))-1/16816800.
    coneq[587]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))))-1/67267200.
    coneq[588]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/201801600.
    coneq[589]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/403603200.
    coneq[590]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/134534400.
    coneq[591]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))))-1/50450400.
    coneq[592]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/100900800.
    coneq[593]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))))-1/33633600.
    coneq[594]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/67267200.
    coneq[595]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))))))-1/13453440.
    coneq[596]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))))-1/40360320.
    coneq[597]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/80720640.
    coneq[598]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))))-1/26906880.
    coneq[599]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))))))-1/10090080.
    coneq[600]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))))-1/20180160.
    coneq[601]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))))))-1/6726720.
    coneq[602]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/30270240.
    coneq[603]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/60540480.
    coneq[604]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/121080960.
    coneq[605]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))))-1/26906880.
    coneq[606]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/80720640.
    coneq[607]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/161441280.
    coneq[608]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/53813760.
    coneq[609]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/20180160.
    coneq[610]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/40360320.
    coneq[611]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/13453440.
    coneq[612]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/26906880.
    coneq[613]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3))))))-1/3843840.
    coneq[614]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))))))-1/11531520.
    coneq[615]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))))-1/23063040.
    coneq[616]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))))))-1/7687680.
    coneq[617]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))))-1/34594560.
    coneq[618]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))))-1/69189120.
    coneq[619]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))))-1/23063040.
    coneq[620]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))))-1/138378240.
    coneq[621]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))))-1/46126080.
    coneq[622]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))))-1/15375360.
    coneq[623]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4))))))-1/3603600.
    coneq[624]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))))))-1/14414400.
    coneq[625]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))))-1/43243200.
    coneq[626]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/86486400.
    coneq[627]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))))-1/28828800.
    coneq[628]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))))))-1/10810800.
    coneq[629]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))))-1/21621600.
    coneq[630]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))))))-1/7207200.
    coneq[631]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))))-1/14414400.
    coneq[632]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))))))-1/7207200.
    coneq[633]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))))-1/28828800.
    coneq[634]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))))-1/86486400.
    coneq[635]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/172972800.
    coneq[636]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))))-1/57657600.
    coneq[637]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))))-1/21621600.
    coneq[638]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))))-1/43243200.
    coneq[639]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))))-1/14414400.
    coneq[640]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))))-1/28828800.
    coneq[641]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**5))))))-1/2882880.
    coneq[642]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))))))-1/14414400.
    coneq[643]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))))-1/57657600.
    coneq[644]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/172972800.
    coneq[645]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/345945600.
    coneq[646]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/115315200.
    coneq[647]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))))-1/43243200.
    coneq[648]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/86486400.
    coneq[649]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))))-1/28828800.
    coneq[650]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/57657600.
    coneq[651]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))))))-1/11531520.
    coneq[652]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))))-1/34594560.
    coneq[653]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/69189120.
    coneq[654]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))))-1/23063040.
    coneq[655]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))))))-1/8648640.
    coneq[656]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))))-1/17297280.
    coneq[657]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))))))-1/5765760.
    coneq[658]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))))-1/17297280.
    coneq[659]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/34594560.
    coneq[660]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))))-1/11531520.
    coneq[661]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3))))))-1/2882880.
    coneq[662]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[663]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[664]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[665]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))))))-1/5765760.
    coneq[666]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/17297280.
    coneq[667]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/34594560.
    coneq[668]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/11531520.
    coneq[669]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4))))))-1/2402400.
    coneq[670]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))))))-1/9609600.
    coneq[671]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/28828800.
    coneq[672]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/57657600.
    coneq[673]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/19219200.
    coneq[674]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/7207200.
    coneq[675]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/14414400.
    coneq[676]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/4804800.
    coneq[677]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/9609600.
    coneq[678]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2))))))-1/2162160.
    coneq[679]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))))))-1/4324320.
    coneq[680]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/8648640.
    coneq[681]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3))))))-1/1921920.
    coneq[682]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))))))-1/5765760.
    coneq[683]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/11531520.
    coneq[684]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))))))-1/3843840.
    coneq[685]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2))))))-1/1441440.
    coneq[686]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))))))-1/2882880.
    coneq[687]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c)*dot(A,c))))))-1/960960.
    coneq[688]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))))))-1/4804800.
    coneq[689]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))))-1/19219200.
    coneq[690]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/57657600.
    coneq[691]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/115315200.
    coneq[692]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/38438400.
    coneq[693]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/14414400.
    coneq[694]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/28828800.
    coneq[695]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/9609600.
    coneq[696]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/19219200.
    coneq[697]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))))))-1/5765760.
    coneq[698]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/17297280.
    coneq[699]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/34594560.
    coneq[700]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/11531520.
    coneq[701]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))))-1/11531520.
    coneq[702]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/34594560.
    coneq[703]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/69189120.
    coneq[704]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/23063040.
    coneq[705]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))))-1/6486480.
    coneq[706]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))))-1/12972960.
    coneq[707]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/25945920.
    coneq[708]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/51891840.
    coneq[709]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))))))-1/3843840.
    coneq[710]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))))-1/11531520.
    coneq[711]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/23063040.
    coneq[712]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))))-1/7687680.
    coneq[713]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))))))-1/4324320.
    coneq[714]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))))-1/8648640.
    coneq[715]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/17297280.
    coneq[716]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/2882880.
    coneq[717]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/5765760.
    coneq[718]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1921920.
    coneq[719]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/5765760.
    coneq[720]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/11531520.
    coneq[721]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))))-1/3843840.
    coneq[722]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**8)))))-1/216216.
    coneq[723]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**7))))))-1/1729728.
    coneq[724]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**6)))))))-1/12108096.
    coneq[725]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5))))))))-1/72648576.
    coneq[726]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))))-1/363242880.
    coneq[727]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))))-1/1452971520.
    coneq[728]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/4358914560.
    coneq[729]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/8717829120.
    coneq[730]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/2905943040.
    coneq[731]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))))-1/1089728640.
    coneq[732]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/2179457280.
    coneq[733]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))))-1/726485760.
    coneq[734]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/1452971520.
    coneq[735]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))))-1/290594304.
    coneq[736]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))))-1/871782912.
    coneq[737]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/1743565824.
    coneq[738]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))))-1/581188608.
    coneq[739]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))))-1/217945728.
    coneq[740]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))))-1/435891456.
    coneq[741]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))))-1/145297152.
    coneq[742]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))))-1/435891456.
    coneq[743]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/871782912.
    coneq[744]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))))-1/290594304.
    coneq[745]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4))))))))-1/60540480.
    coneq[746]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))))-1/242161920.
    coneq[747]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))))-1/726485760.
    coneq[748]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1452971520.
    coneq[749]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))))-1/484323840.
    coneq[750]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))))-1/181621440.
    coneq[751]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))))-1/363242880.
    coneq[752]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))))-1/121080960.
    coneq[753]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))))-1/242161920.
    coneq[754]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))))-1/48432384.
    coneq[755]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))))-1/145297152.
    coneq[756]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))))-1/290594304.
    coneq[757]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))))-1/96864768.
    coneq[758]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))))-1/36324288.
    coneq[759]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))))-1/72648576.
    coneq[760]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c))))))))-1/24216192.
    coneq[761]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))))-1/108972864.
    coneq[762]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))))-1/217945728.
    coneq[763]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/435891456.
    coneq[764]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))))-1/96864768.
    coneq[765]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))))-1/290594304.
    coneq[766]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/581188608.
    coneq[767]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))))-1/193729536.
    coneq[768]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))))-1/72648576.
    coneq[769]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))))-1/145297152.
    coneq[770]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))))-1/48432384.
    coneq[771]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))))-1/96864768.
    coneq[772]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**5)))))))-1/10378368.
    coneq[773]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4))))))))-1/51891840.
    coneq[774]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))))-1/207567360.
    coneq[775]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/622702080.
    coneq[776]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1245404160.
    coneq[777]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/415134720.
    coneq[778]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))))-1/155675520.
    coneq[779]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/311351040.
    coneq[780]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))))-1/103783680.
    coneq[781]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/207567360.
    coneq[782]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))))-1/41513472.
    coneq[783]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))))-1/124540416.
    coneq[784]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/249080832.
    coneq[785]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))))-1/83026944.
    coneq[786]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))))-1/31135104.
    coneq[787]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))))-1/62270208.
    coneq[788]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))))-1/20756736.
    coneq[789]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))))-1/62270208.
    coneq[790]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/124540416.
    coneq[791]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))))-1/41513472.
    coneq[792]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4)))))))-1/8648640.
    coneq[793]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))))-1/34594560.
    coneq[794]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))))-1/103783680.
    coneq[795]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/207567360.
    coneq[796]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))))-1/69189120.
    coneq[797]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))))-1/25945920.
    coneq[798]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))))-1/51891840.
    coneq[799]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))))-1/17297280.
    coneq[800]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))))-1/34594560.
    coneq[801]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3)))))))-1/6918912.
    coneq[802]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))))-1/20756736.
    coneq[803]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))))-1/41513472.
    coneq[804]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))))-1/13837824.
    coneq[805]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2)))))))-1/5189184.
    coneq[806]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c))))))))-1/10378368.
    coneq[807]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5*dot(A,c)))))))-1/3459456.
    coneq[808]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))))-1/20756736.
    coneq[809]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))))-1/62270208.
    coneq[810]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))))-1/124540416.
    coneq[811]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))))-1/41513472.
    coneq[812]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))))-1/41513472.
    coneq[813]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))))-1/124540416.
    coneq[814]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))))-1/249080832.
    coneq[815]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))))-1/83026944.
    coneq[816]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))))-1/17297280.
    coneq[817]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))))-1/69189120.
    coneq[818]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))))-1/207567360.
    coneq[819]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/415134720.
    coneq[820]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))))-1/138378240.
    coneq[821]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))))-1/51891840.
    coneq[822]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))))-1/103783680.
    coneq[823]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))))-1/34594560.
    coneq[824]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))))-1/69189120.
    coneq[825]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))))-1/15567552.
    coneq[826]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))))-1/31135104.
    coneq[827]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/62270208.
    coneq[828]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))))-1/13837824.
    coneq[829]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))))-1/41513472.
    coneq[830]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/83026944.
    coneq[831]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))))-1/27675648.
    coneq[832]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))))-1/10378368.
    coneq[833]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))))-1/20756736.
    coneq[834]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))))-1/6918912.
    coneq[835]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))))-1/20756736.
    coneq[836]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))))-1/41513472.
    coneq[837]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/13837824.
    coneq[838]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**6))))))-1/1513512.
    coneq[839]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**5)))))))-1/9081072.
    coneq[840]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4))))))))-1/45405360.
    coneq[841]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/181621440.
    coneq[842]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/544864320.
    coneq[843]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1089728640.
    coneq[844]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/363242880.
    coneq[845]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/136216080.
    coneq[846]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/272432160.
    coneq[847]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/90810720.
    coneq[848]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/181621440.
    coneq[849]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))))-1/36324288.
    coneq[850]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/108972864.
    coneq[851]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/217945728.
    coneq[852]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/72648576.
    coneq[853]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))))-1/27243216.
    coneq[854]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/54486432.
    coneq[855]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))))-1/18162144.
    coneq[856]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/54486432.
    coneq[857]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/108972864.
    coneq[858]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/36324288.
    coneq[859]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4)))))))-1/7567560.
    coneq[860]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))))-1/30270240.
    coneq[861]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/90810720.
    coneq[862]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/181621440.
    coneq[863]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/60540480.
    coneq[864]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))))-1/22702680.
    coneq[865]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/45405360.
    coneq[866]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))))-1/15135120.
    coneq[867]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/30270240.
    coneq[868]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3)))))))-1/6054048.
    coneq[869]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))))-1/18162144.
    coneq[870]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/36324288.
    coneq[871]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))))-1/12108096.
    coneq[872]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2)))))))-1/4540536.
    coneq[873]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))))-1/9081072.
    coneq[874]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c)))))))-1/3027024.
    coneq[875]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/13621608.
    coneq[876]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/27243216.
    coneq[877]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/54486432.
    coneq[878]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))))-1/12108096.
    coneq[879]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/36324288.
    coneq[880]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/72648576.
    coneq[881]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/24216192.
    coneq[882]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/9081072.
    coneq[883]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/18162144.
    coneq[884]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/6054048.
    coneq[885]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/12108096.
    coneq[886]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**5))))))-1/1297296.
    coneq[887]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4)))))))-1/6486480.
    coneq[888]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))))-1/25945920.
    coneq[889]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/77837760.
    coneq[890]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/155675520.
    coneq[891]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/51891840.
    coneq[892]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))))-1/19459440.
    coneq[893]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/38918880.
    coneq[894]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))))-1/12972960.
    coneq[895]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/25945920.
    coneq[896]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3)))))))-1/5189184.
    coneq[897]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))))-1/15567552.
    coneq[898]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/31135104.
    coneq[899]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))))-1/10378368.
    coneq[900]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))))-1/3891888.
    coneq[901]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))))-1/7783776.
    coneq[902]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c)))))))-1/2594592.
    coneq[903]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))))-1/7783776.
    coneq[904]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/15567552.
    coneq[905]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))))-1/5189184.
    coneq[906]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**4))))))-1/1081080.
    coneq[907]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3)))))))-1/4324320.
    coneq[908]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))))-1/12972960.
    coneq[909]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/25945920.
    coneq[910]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))))-1/8648640.
    coneq[911]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2)))))))-1/3243240.
    coneq[912]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))))-1/6486480.
    coneq[913]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c)))))))-1/2162160.
    coneq[914]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))))-1/4324320.
    coneq[915]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c**3))))))-1/864864.
    coneq[916]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2)))))))-1/2594592.
    coneq[917]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c))))))))-1/5189184.
    coneq[918]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c)))))))-1/1729728.
    coneq[919]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5*dot(A,c**2))))))-1/648648.
    coneq[920]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5*dot(A,dot(A,c)))))))-1/1297296.
    coneq[921]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**6*dot(A,c))))))-1/432432.
    coneq[922]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3))))))-1/3459456.
    coneq[923]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))))-1/10378368.
    coneq[924]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))))-1/20756736.
    coneq[925]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))))-1/6918912.
    coneq[926]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))))-1/31135104.
    coneq[927]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))))-1/62270208.
    coneq[928]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))))-1/20756736.
    coneq[929]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))))-1/124540416.
    coneq[930]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))))-1/41513472.
    coneq[931]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))))-1/13837824.
    coneq[932]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4))))))-1/3243240.
    coneq[933]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))))-1/12972960.
    coneq[934]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))))-1/38918880.
    coneq[935]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/77837760.
    coneq[936]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))))-1/25945920.
    coneq[937]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))))-1/9729720.
    coneq[938]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))))-1/19459440.
    coneq[939]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))))-1/6486480.
    coneq[940]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))))-1/12972960.
    coneq[941]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4))))))-1/6486480.
    coneq[942]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))))-1/25945920.
    coneq[943]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))))-1/77837760.
    coneq[944]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/155675520.
    coneq[945]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))))-1/51891840.
    coneq[946]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))))-1/19459440.
    coneq[947]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))))-1/38918880.
    coneq[948]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))))-1/12972960.
    coneq[949]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))))-1/25945920.
    coneq[950]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**5))))))-1/2594592.
    coneq[951]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))))-1/12972960.
    coneq[952]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))))-1/51891840.
    coneq[953]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/155675520.
    coneq[954]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/311351040.
    coneq[955]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/103783680.
    coneq[956]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))))-1/38918880.
    coneq[957]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/77837760.
    coneq[958]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))))-1/25945920.
    coneq[959]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/51891840.
    coneq[960]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))))-1/10378368.
    coneq[961]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))))-1/31135104.
    coneq[962]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/62270208.
    coneq[963]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))))-1/20756736.
    coneq[964]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))))-1/7783776.
    coneq[965]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))))-1/15567552.
    coneq[966]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))))-1/5189184.
    coneq[967]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))))-1/15567552.
    coneq[968]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/31135104.
    coneq[969]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))))-1/10378368.
    coneq[970]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3))))))-1/2594592.
    coneq[971]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/7783776.
    coneq[972]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/15567552.
    coneq[973]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/5189184.
    coneq[974]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))))-1/5189184.
    coneq[975]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/15567552.
    coneq[976]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/31135104.
    coneq[977]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/10378368.
    coneq[978]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4))))))-1/2162160.
    coneq[979]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))))-1/8648640.
    coneq[980]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/25945920.
    coneq[981]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/51891840.
    coneq[982]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/17297280.
    coneq[983]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/6486480.
    coneq[984]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/12972960.
    coneq[985]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/4324320.
    coneq[986]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/8648640.
    coneq[987]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))))-1/1945944.
    coneq[988]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))))-1/3891888.
    coneq[989]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/7783776.
    coneq[990]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3))))))-1/1729728.
    coneq[991]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))))-1/5189184.
    coneq[992]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/10378368.
    coneq[993]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))))-1/3459456.
    coneq[994]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2))))))-1/1297296.
    coneq[995]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))))-1/2594592.
    coneq[996]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c))))))-1/864864.
    coneq[997]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))))-1/3459456.
    coneq[998]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))))-1/10378368.
    coneq[999]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/20756736.
    coneq[1000]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))))-1/6918912.
    coneq[1001]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))))-1/3891888.
    coneq[1002]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))))-1/7783776.
    coneq[1003]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/15567552.
    coneq[1004]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/2594592.
    coneq[1005]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/5189184.
    coneq[1006]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1729728.
    coneq[1007]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))))-1/3459456.
    coneq[1008]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**7)))))-1/192192.
    coneq[1009]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**6))))))-1/1345344.
    coneq[1010]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**5)))))))-1/8072064.
    coneq[1011]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/40360320.
    coneq[1012]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/161441280.
    coneq[1013]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/484323840.
    coneq[1014]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/968647680.
    coneq[1015]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/322882560.
    coneq[1016]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/121080960.
    coneq[1017]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/242161920.
    coneq[1018]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/80720640.
    coneq[1019]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/161441280.
    coneq[1020]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/32288256.
    coneq[1021]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/96864768.
    coneq[1022]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/193729536.
    coneq[1023]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/64576512.
    coneq[1024]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/24216192.
    coneq[1025]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/48432384.
    coneq[1026]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/16144128.
    coneq[1027]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/48432384.
    coneq[1028]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/96864768.
    coneq[1029]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/32288256.
    coneq[1030]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4)))))))-1/6726720.
    coneq[1031]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/26906880.
    coneq[1032]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/80720640.
    coneq[1033]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/161441280.
    coneq[1034]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/53813760.
    coneq[1035]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/20180160.
    coneq[1036]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/40360320.
    coneq[1037]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/13453440.
    coneq[1038]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/26906880.
    coneq[1039]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3)))))))-1/5381376.
    coneq[1040]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/16144128.
    coneq[1041]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/32288256.
    coneq[1042]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/10762752.
    coneq[1043]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2)))))))-1/4036032.
    coneq[1044]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/8072064.
    coneq[1045]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c)))))))-1/2690688.
    coneq[1046]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/12108096.
    coneq[1047]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/24216192.
    coneq[1048]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/48432384.
    coneq[1049]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/10762752.
    coneq[1050]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/32288256.
    coneq[1051]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/64576512.
    coneq[1052]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/21525504.
    coneq[1053]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/8072064.
    coneq[1054]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/16144128.
    coneq[1055]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/5381376.
    coneq[1056]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/10762752.
    coneq[1057]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**5))))))-1/1153152.
    coneq[1058]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4)))))))-1/5765760.
    coneq[1059]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/23063040.
    coneq[1060]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/69189120.
    coneq[1061]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/138378240.
    coneq[1062]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/46126080.
    coneq[1063]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/17297280.
    coneq[1064]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/34594560.
    coneq[1065]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/11531520.
    coneq[1066]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/23063040.
    coneq[1067]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3)))))))-1/4612608.
    coneq[1068]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/13837824.
    coneq[1069]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/27675648.
    coneq[1070]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/9225216.
    coneq[1071]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/3459456.
    coneq[1072]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/6918912.
    coneq[1073]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c)))))))-1/2306304.
    coneq[1074]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/6918912.
    coneq[1075]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/13837824.
    coneq[1076]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/4612608.
    coneq[1077]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**4))))))-1/960960.
    coneq[1078]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3)))))))-1/3843840.
    coneq[1079]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/11531520.
    coneq[1080]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/23063040.
    coneq[1081]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/7687680.
    coneq[1082]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/2882880.
    coneq[1083]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/5765760.
    coneq[1084]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1921920.
    coneq[1085]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/3843840.
    coneq[1086]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**3))))))-1/768768.
    coneq[1087]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2)))))))-1/2306304.
    coneq[1088]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/4612608.
    coneq[1089]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1537536.
    coneq[1090]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c**2))))))-1/576576.
    coneq[1091]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c)))))))-1/1153152.
    coneq[1092]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**5*dot(A,c))))))-1/384384.
    coneq[1093]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3))))))-1/2306304.
    coneq[1094]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/6918912.
    coneq[1095]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/13837824.
    coneq[1096]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/4612608.
    coneq[1097]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/4612608.
    coneq[1098]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/13837824.
    coneq[1099]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/27675648.
    coneq[1100]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/9225216.
    coneq[1101]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4))))))-1/1921920.
    coneq[1102]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/7687680.
    coneq[1103]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/23063040.
    coneq[1104]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/46126080.
    coneq[1105]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/15375360.
    coneq[1106]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/5765760.
    coneq[1107]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/11531520.
    coneq[1108]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3843840.
    coneq[1109]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/7687680.
    coneq[1110]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1729728.
    coneq[1111]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/3459456.
    coneq[1112]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/6918912.
    coneq[1113]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1537536.
    coneq[1114]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/4612608.
    coneq[1115]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/9225216.
    coneq[1116]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/3075072.
    coneq[1117]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/1153152.
    coneq[1118]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/2306304.
    coneq[1119]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c))))))-1/768768.
    coneq[1120]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/2306304.
    coneq[1121]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/4612608.
    coneq[1122]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1537536.
    coneq[1123]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**6)))))-1/168168.
    coneq[1124]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**5))))))-1/1009008.
    coneq[1125]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**4)))))))-1/5045040.
    coneq[1126]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/20180160.
    coneq[1127]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/60540480.
    coneq[1128]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/121080960.
    coneq[1129]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/40360320.
    coneq[1130]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/15135120.
    coneq[1131]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/30270240.
    coneq[1132]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/10090080.
    coneq[1133]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/20180160.
    coneq[1134]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3)))))))-1/4036032.
    coneq[1135]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/12108096.
    coneq[1136]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/24216192.
    coneq[1137]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/8072064.
    coneq[1138]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/3027024.
    coneq[1139]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/6054048.
    coneq[1140]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c)))))))-1/2018016.
    coneq[1141]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/6054048.
    coneq[1142]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/12108096.
    coneq[1143]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/4036032.
    coneq[1144]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**4))))))-1/840840.
    coneq[1145]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3)))))))-1/3363360.
    coneq[1146]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/10090080.
    coneq[1147]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/20180160.
    coneq[1148]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/6726720.
    coneq[1149]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2522520.
    coneq[1150]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/5045040.
    coneq[1151]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1681680.
    coneq[1152]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/3363360.
    coneq[1153]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**3))))))-1/672672.
    coneq[1154]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2018016.
    coneq[1155]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/4036032.
    coneq[1156]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1345344.
    coneq[1157]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c**2))))))-1/504504.
    coneq[1158]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c)))))))-1/1009008.
    coneq[1159]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**4*dot(A,c))))))-1/336336.
    coneq[1160]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1513512.
    coneq[1161]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/3027024.
    coneq[1162]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/6054048.
    coneq[1163]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3))))))-1/1345344.
    coneq[1164]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/4036032.
    coneq[1165]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/8072064.
    coneq[1166]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2690688.
    coneq[1167]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1009008.
    coneq[1168]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2018016.
    coneq[1169]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/672672.
    coneq[1170]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1345344.
    coneq[1171]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**5)))))-1/144144.
    coneq[1172]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**4))))))-1/720720.
    coneq[1173]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**3)))))))-1/2882880.
    coneq[1174]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/8648640.
    coneq[1175]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/17297280.
    coneq[1176]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5765760.
    coneq[1177]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2)))))))-1/2162160.
    coneq[1178]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4324320.
    coneq[1179]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c)))))))-1/1441440.
    coneq[1180]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2882880.
    coneq[1181]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c**3))))))-1/576576.
    coneq[1182]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2)))))))-1/1729728.
    coneq[1183]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3459456.
    coneq[1184]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c)))))))-1/1153152.
    coneq[1185]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c**2))))))-1/432432.
    coneq[1186]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c)))))))-1/864864.
    coneq[1187]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**3*dot(A,c))))))-1/288288.
    coneq[1188]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2))))))-1/864864.
    coneq[1189]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1729728.
    coneq[1190]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c))))))-1/576576.
    coneq[1191]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**4)))))-1/120120.
    coneq[1192]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c**3))))))-1/480480.
    coneq[1193]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c**2)))))))-1/1441440.
    coneq[1194]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2882880.
    coneq[1195]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c*dot(A,c)))))))-1/960960.
    coneq[1196]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c*dot(A,c**2))))))-1/360360.
    coneq[1197]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c*dot(A,dot(A,c)))))))-1/720720.
    coneq[1198]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**2*dot(A,c))))))-1/240240.
    coneq[1199]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c)*dot(A,c))))))-1/480480.
    coneq[1200]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c**3)))))-1/96096.
    coneq[1201]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,dot(A,c**2))))))-1/288288.
    coneq[1202]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,dot(A,dot(A,c)))))))-1/576576.
    coneq[1203]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c*dot(A,c))))))-1/192192.
    coneq[1204]=dot(b,dot(A,dot(A,dot(A,c**7*dot(A,c**2)))))-1/72072.
    coneq[1205]=dot(b,dot(A,dot(A,dot(A,c**7*dot(A,dot(A,c))))))-1/144144.
    coneq[1206]=dot(b,dot(A,dot(A,dot(A,c**8*dot(A,c)))))-1/48048.
    coneq[1207]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,c**4)))))-1/600600.
    coneq[1208]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c**3))))))-1/2402400.
    coneq[1209]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2)))))))-1/7207200.
    coneq[1210]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/14414400.
    coneq[1211]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c)))))))-1/4804800.
    coneq[1212]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2))))))-1/1801800.
    coneq[1213]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c)))))))-1/3603600.
    coneq[1214]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c))))))-1/1201200.
    coneq[1215]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c))))))-1/2402400.
    coneq[1216]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))))))-1/9609600.
    coneq[1217]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))))))-1/28828800.
    coneq[1218]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/57657600.
    coneq[1219]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))))))-1/19219200.
    coneq[1220]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2))))))-1/7207200.
    coneq[1221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))))))-1/14414400.
    coneq[1222]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c))))))-1/4804800.
    coneq[1223]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))))))-1/9609600.
    coneq[1224]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))))))-1/86486400.
    coneq[1225]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/172972800.
    coneq[1226]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))))))-1/57657600.
    coneq[1227]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))))))-1/21621600.
    coneq[1228]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))))))-1/43243200.
    coneq[1229]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))))))-1/14414400.
    coneq[1230]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))))))-1/28828800.
    coneq[1231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/345945600.
    coneq[1232]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))))))-1/115315200.
    coneq[1233]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))))))-1/43243200.
    coneq[1234]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))))))-1/86486400.
    coneq[1235]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))))))-1/28828800.
    coneq[1236]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))))))-1/57657600.
    coneq[1237]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))))-1/38438400.
    coneq[1238]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))))))-1/14414400.
    coneq[1239]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))))-1/28828800.
    coneq[1240]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))))))-1/9609600.
    coneq[1241]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))))-1/19219200.
    coneq[1242]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))))))-1/5405400.
    coneq[1243]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))))-1/10810800.
    coneq[1244]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c))))))-1/3603600.
    coneq[1245]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))))-1/7207200.
    coneq[1246]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))))-1/21621600.
    coneq[1247]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))))-1/7207200.
    coneq[1248]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))))-1/14414400.
    coneq[1249]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))))))-1/2402400.
    coneq[1250]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/4804800.
    coneq[1251]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/9609600.
    coneq[1252]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**5)))))-1/576576.
    coneq[1253]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**4))))))-1/2882880.
    coneq[1254]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3)))))))-1/11531520.
    coneq[1255]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/34594560.
    coneq[1256]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/69189120.
    coneq[1257]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/23063040.
    coneq[1258]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2)))))))-1/8648640.
    coneq[1259]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/17297280.
    coneq[1260]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)))))))-1/5765760.
    coneq[1261]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/11531520.
    coneq[1262]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3))))))-1/2306304.
    coneq[1263]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2)))))))-1/6918912.
    coneq[1264]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/13837824.
    coneq[1265]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)))))))-1/4612608.
    coneq[1266]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2))))))-1/1729728.
    coneq[1267]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)))))))-1/3459456.
    coneq[1268]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c))))))-1/1153152.
    coneq[1269]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2))))))-1/3459456.
    coneq[1270]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/6918912.
    coneq[1271]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c))))))-1/2306304.
    coneq[1272]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**5)))))-1/1729728.
    coneq[1273]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4))))))-1/8648640.
    coneq[1274]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))))-1/34594560.
    coneq[1275]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/103783680.
    coneq[1276]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/207567360.
    coneq[1277]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/69189120.
    coneq[1278]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))))-1/25945920.
    coneq[1279]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/51891840.
    coneq[1280]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))))-1/17297280.
    coneq[1281]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/34594560.
    coneq[1282]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3))))))-1/6918912.
    coneq[1283]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))))-1/20756736.
    coneq[1284]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/41513472.
    coneq[1285]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))))-1/13837824.
    coneq[1286]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2))))))-1/5189184.
    coneq[1287]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))))-1/10378368.
    coneq[1288]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c))))))-1/3459456.
    coneq[1289]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))))-1/10378368.
    coneq[1290]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/20756736.
    coneq[1291]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))))-1/6918912.
    coneq[1292]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5)))))-1/3459456.
    coneq[1293]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4))))))-1/17297280.
    coneq[1294]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))))-1/69189120.
    coneq[1295]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/207567360.
    coneq[1296]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/415134720.
    coneq[1297]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/138378240.
    coneq[1298]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))))-1/51891840.
    coneq[1299]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/103783680.
    coneq[1300]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))))-1/34594560.
    coneq[1301]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/69189120.
    coneq[1302]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))))-1/13837824.
    coneq[1303]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))))-1/41513472.
    coneq[1304]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/83026944.
    coneq[1305]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))))-1/27675648.
    coneq[1306]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))))-1/10378368.
    coneq[1307]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))))-1/20756736.
    coneq[1308]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))))-1/6918912.
    coneq[1309]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))))-1/20756736.
    coneq[1310]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/41513472.
    coneq[1311]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))))-1/13837824.
    coneq[1312]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**5)))))-1/1153152.
    coneq[1313]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4))))))-1/5765760.
    coneq[1314]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))))-1/23063040.
    coneq[1315]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/69189120.
    coneq[1316]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/138378240.
    coneq[1317]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/46126080.
    coneq[1318]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))))-1/17297280.
    coneq[1319]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/34594560.
    coneq[1320]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))))-1/11531520.
    coneq[1321]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/23063040.
    coneq[1322]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3))))))-1/4612608.
    coneq[1323]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))))-1/13837824.
    coneq[1324]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/27675648.
    coneq[1325]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))))-1/9225216.
    coneq[1326]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2))))))-1/3459456.
    coneq[1327]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))))-1/6918912.
    coneq[1328]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c))))))-1/2306304.
    coneq[1329]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))))-1/6918912.
    coneq[1330]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/13837824.
    coneq[1331]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))))-1/4612608.
    coneq[1332]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**6)))))-1/504504.
    coneq[1333]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**5))))))-1/3027024.
    coneq[1334]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4)))))))-1/15135120.
    coneq[1335]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/60540480.
    coneq[1336]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/181621440.
    coneq[1337]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/363242880.
    coneq[1338]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/121080960.
    coneq[1339]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/45405360.
    coneq[1340]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/90810720.
    coneq[1341]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/30270240.
    coneq[1342]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/60540480.
    coneq[1343]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3)))))))-1/12108096.
    coneq[1344]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/36324288.
    coneq[1345]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/72648576.
    coneq[1346]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/24216192.
    coneq[1347]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/9081072.
    coneq[1348]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/18162144.
    coneq[1349]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)))))))-1/6054048.
    coneq[1350]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/18162144.
    coneq[1351]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/36324288.
    coneq[1352]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/12108096.
    coneq[1353]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4))))))-1/2522520.
    coneq[1354]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3)))))))-1/10090080.
    coneq[1355]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/30270240.
    coneq[1356]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/60540480.
    coneq[1357]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/20180160.
    coneq[1358]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/7567560.
    coneq[1359]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/15135120.
    coneq[1360]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/5045040.
    coneq[1361]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/10090080.
    coneq[1362]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3))))))-1/2018016.
    coneq[1363]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/6054048.
    coneq[1364]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/12108096.
    coneq[1365]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/4036032.
    coneq[1366]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2))))))-1/1513512.
    coneq[1367]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)))))))-1/3027024.
    coneq[1368]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c))))))-1/1009008.
    coneq[1369]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/4540536.
    coneq[1370]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/9081072.
    coneq[1371]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/18162144.
    coneq[1372]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3))))))-1/4036032.
    coneq[1373]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/12108096.
    coneq[1374]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/24216192.
    coneq[1375]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/8072064.
    coneq[1376]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/3027024.
    coneq[1377]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/6054048.
    coneq[1378]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/2018016.
    coneq[1379]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/4036032.
    coneq[1380]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**6)))))-1/1009008.
    coneq[1381]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5))))))-1/6054048.
    coneq[1382]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4)))))))-1/30270240.
    coneq[1383]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/121080960.
    coneq[1384]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/363242880.
    coneq[1385]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/726485760.
    coneq[1386]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/242161920.
    coneq[1387]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/90810720.
    coneq[1388]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/181621440.
    coneq[1389]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/60540480.
    coneq[1390]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/121080960.
    coneq[1391]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))))-1/24216192.
    coneq[1392]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/72648576.
    coneq[1393]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/145297152.
    coneq[1394]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/48432384.
    coneq[1395]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/18162144.
    coneq[1396]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/36324288.
    coneq[1397]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))))-1/12108096.
    coneq[1398]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/36324288.
    coneq[1399]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/72648576.
    coneq[1400]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/24216192.
    coneq[1401]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4))))))-1/5045040.
    coneq[1402]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))))-1/20180160.
    coneq[1403]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/60540480.
    coneq[1404]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/121080960.
    coneq[1405]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/40360320.
    coneq[1406]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/15135120.
    coneq[1407]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/30270240.
    coneq[1408]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/10090080.
    coneq[1409]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/20180160.
    coneq[1410]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3))))))-1/4036032.
    coneq[1411]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/12108096.
    coneq[1412]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/24216192.
    coneq[1413]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/8072064.
    coneq[1414]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2))))))-1/3027024.
    coneq[1415]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))))-1/6054048.
    coneq[1416]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c))))))-1/2018016.
    coneq[1417]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/9081072.
    coneq[1418]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/18162144.
    coneq[1419]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/36324288.
    coneq[1420]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))))-1/8072064.
    coneq[1421]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/24216192.
    coneq[1422]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/48432384.
    coneq[1423]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/16144128.
    coneq[1424]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/6054048.
    coneq[1425]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/12108096.
    coneq[1426]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/4036032.
    coneq[1427]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/8072064.
    coneq[1428]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**7)))))-1/384384.
    coneq[1429]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**6))))))-1/2690688.
    coneq[1430]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5)))))))-1/16144128.
    coneq[1431]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/80720640.
    coneq[1432]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/322882560.
    coneq[1433]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/968647680.
    coneq[1434]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1937295360.
    coneq[1435]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/645765120.
    coneq[1436]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/242161920.
    coneq[1437]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/484323840.
    coneq[1438]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/161441280.
    coneq[1439]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/322882560.
    coneq[1440]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/64576512.
    coneq[1441]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/193729536.
    coneq[1442]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/387459072.
    coneq[1443]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/129153024.
    coneq[1444]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/48432384.
    coneq[1445]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/96864768.
    coneq[1446]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/32288256.
    coneq[1447]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/96864768.
    coneq[1448]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/193729536.
    coneq[1449]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/64576512.
    coneq[1450]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4)))))))-1/13453440.
    coneq[1451]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/53813760.
    coneq[1452]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/161441280.
    coneq[1453]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/322882560.
    coneq[1454]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/107627520.
    coneq[1455]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/40360320.
    coneq[1456]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/80720640.
    coneq[1457]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/26906880.
    coneq[1458]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/53813760.
    coneq[1459]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3)))))))-1/10762752.
    coneq[1460]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/32288256.
    coneq[1461]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/64576512.
    coneq[1462]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/21525504.
    coneq[1463]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2)))))))-1/8072064.
    coneq[1464]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/16144128.
    coneq[1465]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c)))))))-1/5381376.
    coneq[1466]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/24216192.
    coneq[1467]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/48432384.
    coneq[1468]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/96864768.
    coneq[1469]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/21525504.
    coneq[1470]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/64576512.
    coneq[1471]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/129153024.
    coneq[1472]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/43051008.
    coneq[1473]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/16144128.
    coneq[1474]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/32288256.
    coneq[1475]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/10762752.
    coneq[1476]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/21525504.
    coneq[1477]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**5))))))-1/2306304.
    coneq[1478]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4)))))))-1/11531520.
    coneq[1479]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/46126080.
    coneq[1480]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/138378240.
    coneq[1481]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/276756480.
    coneq[1482]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/92252160.
    coneq[1483]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/34594560.
    coneq[1484]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/69189120.
    coneq[1485]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/23063040.
    coneq[1486]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/46126080.
    coneq[1487]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3)))))))-1/9225216.
    coneq[1488]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/27675648.
    coneq[1489]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/55351296.
    coneq[1490]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/18450432.
    coneq[1491]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/6918912.
    coneq[1492]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/13837824.
    coneq[1493]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)))))))-1/4612608.
    coneq[1494]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/13837824.
    coneq[1495]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/27675648.
    coneq[1496]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/9225216.
    coneq[1497]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4))))))-1/1921920.
    coneq[1498]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3)))))))-1/7687680.
    coneq[1499]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/23063040.
    coneq[1500]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/46126080.
    coneq[1501]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/15375360.
    coneq[1502]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/5765760.
    coneq[1503]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/11531520.
    coneq[1504]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/3843840.
    coneq[1505]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/7687680.
    coneq[1506]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3))))))-1/1537536.
    coneq[1507]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2)))))))-1/4612608.
    coneq[1508]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/9225216.
    coneq[1509]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)))))))-1/3075072.
    coneq[1510]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2))))))-1/1153152.
    coneq[1511]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c)))))))-1/2306304.
    coneq[1512]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5*dot(A,c))))))-1/768768.
    coneq[1513]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3))))))-1/4612608.
    coneq[1514]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/13837824.
    coneq[1515]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/27675648.
    coneq[1516]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/9225216.
    coneq[1517]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/9225216.
    coneq[1518]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/27675648.
    coneq[1519]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/55351296.
    coneq[1520]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/18450432.
    coneq[1521]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4))))))-1/3843840.
    coneq[1522]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/15375360.
    coneq[1523]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/46126080.
    coneq[1524]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/92252160.
    coneq[1525]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/30750720.
    coneq[1526]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/11531520.
    coneq[1527]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/23063040.
    coneq[1528]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/7687680.
    coneq[1529]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/15375360.
    coneq[1530]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/3459456.
    coneq[1531]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/6918912.
    coneq[1532]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/13837824.
    coneq[1533]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3))))))-1/3075072.
    coneq[1534]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/9225216.
    coneq[1535]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/18450432.
    coneq[1536]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/6150144.
    coneq[1537]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/2306304.
    coneq[1538]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/4612608.
    coneq[1539]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c))))))-1/1537536.
    coneq[1540]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/4612608.
    coneq[1541]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/9225216.
    coneq[1542]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/3075072.
    coneq[1543]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**4)))))-1/480480.
    coneq[1544]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3))))))-1/1921920.
    coneq[1545]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))))-1/5765760.
    coneq[1546]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/11531520.
    coneq[1547]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))))-1/3843840.
    coneq[1548]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2))))))-1/1441440.
    coneq[1549]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))))-1/2882880.
    coneq[1550]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c))))))-1/960960.
    coneq[1551]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))))-1/1921920.
    coneq[1552]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4)))))-1/1441440.
    coneq[1553]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))))-1/5765760.
    coneq[1554]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))))-1/17297280.
    coneq[1555]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/34594560.
    coneq[1556]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))))-1/11531520.
    coneq[1557]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))))-1/4324320.
    coneq[1558]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))))-1/8648640.
    coneq[1559]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))))-1/2882880.
    coneq[1560]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))))-1/5765760.
    coneq[1561]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))))-1/2882880.
    coneq[1562]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))))-1/11531520.
    coneq[1563]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))))-1/34594560.
    coneq[1564]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/69189120.
    coneq[1565]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))))-1/23063040.
    coneq[1566]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))))-1/8648640.
    coneq[1567]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))))-1/17297280.
    coneq[1568]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))))-1/5765760.
    coneq[1569]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))))-1/11531520.
    coneq[1570]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4)))))-1/960960.
    coneq[1571]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))))-1/3843840.
    coneq[1572]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/11531520.
    coneq[1573]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/23063040.
    coneq[1574]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/7687680.
    coneq[1575]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))))-1/2882880.
    coneq[1576]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/5765760.
    coneq[1577]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1921920.
    coneq[1578]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/3843840.
    coneq[1579]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**5)))))-1/432432.
    coneq[1580]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4))))))-1/2162160.
    coneq[1581]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))))-1/8648640.
    coneq[1582]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/25945920.
    coneq[1583]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/51891840.
    coneq[1584]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/17297280.
    coneq[1585]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))))-1/6486480.
    coneq[1586]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/12972960.
    coneq[1587]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))))-1/4324320.
    coneq[1588]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/8648640.
    coneq[1589]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3))))))-1/1729728.
    coneq[1590]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))))-1/5189184.
    coneq[1591]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/10378368.
    coneq[1592]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))))-1/3459456.
    coneq[1593]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))))-1/1297296.
    coneq[1594]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))))-1/2594592.
    coneq[1595]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c))))))-1/864864.
    coneq[1596]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))))-1/2594592.
    coneq[1597]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/5189184.
    coneq[1598]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1729728.
    coneq[1599]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**5)))))-1/864864.
    coneq[1600]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4))))))-1/4324320.
    coneq[1601]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))))-1/17297280.
    coneq[1602]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/51891840.
    coneq[1603]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/103783680.
    coneq[1604]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/34594560.
    coneq[1605]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))))-1/12972960.
    coneq[1606]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/25945920.
    coneq[1607]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))))-1/8648640.
    coneq[1608]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/17297280.
    coneq[1609]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))))-1/3459456.
    coneq[1610]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))))-1/10378368.
    coneq[1611]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/20756736.
    coneq[1612]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))))-1/6918912.
    coneq[1613]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))))-1/2594592.
    coneq[1614]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))))-1/5189184.
    coneq[1615]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))))-1/1729728.
    coneq[1616]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))))-1/5189184.
    coneq[1617]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/10378368.
    coneq[1618]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))))-1/3459456.
    coneq[1619]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**6)))))-1/336336.
    coneq[1620]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**5))))))-1/2018016.
    coneq[1621]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))))-1/10090080.
    coneq[1622]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/40360320.
    coneq[1623]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/121080960.
    coneq[1624]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/242161920.
    coneq[1625]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/80720640.
    coneq[1626]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/30270240.
    coneq[1627]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/60540480.
    coneq[1628]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/20180160.
    coneq[1629]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/40360320.
    coneq[1630]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))))-1/8072064.
    coneq[1631]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/24216192.
    coneq[1632]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/48432384.
    coneq[1633]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/16144128.
    coneq[1634]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/6054048.
    coneq[1635]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/12108096.
    coneq[1636]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))))-1/4036032.
    coneq[1637]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/12108096.
    coneq[1638]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/24216192.
    coneq[1639]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/8072064.
    coneq[1640]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4))))))-1/1681680.
    coneq[1641]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))))-1/6726720.
    coneq[1642]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/20180160.
    coneq[1643]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/40360320.
    coneq[1644]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/13453440.
    coneq[1645]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/5045040.
    coneq[1646]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/10090080.
    coneq[1647]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/3363360.
    coneq[1648]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/6726720.
    coneq[1649]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3))))))-1/1345344.
    coneq[1650]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/4036032.
    coneq[1651]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/8072064.
    coneq[1652]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/2690688.
    coneq[1653]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2))))))-1/1009008.
    coneq[1654]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))))-1/2018016.
    coneq[1655]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c))))))-1/672672.
    coneq[1656]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/3027024.
    coneq[1657]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/6054048.
    coneq[1658]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/12108096.
    coneq[1659]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))))-1/2690688.
    coneq[1660]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/8072064.
    coneq[1661]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/16144128.
    coneq[1662]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/5381376.
    coneq[1663]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/2018016.
    coneq[1664]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/4036032.
    coneq[1665]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/1345344.
    coneq[1666]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/2690688.
    coneq[1667]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c**3)))))-1/384384.
    coneq[1668]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2))))))-1/1153152.
    coneq[1669]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/2306304.
    coneq[1670]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c))))))-1/768768.
    coneq[1671]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/3459456.
    coneq[1672]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/6918912.
    coneq[1673]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/2306304.
    coneq[1674]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/13837824.
    coneq[1675]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/4612608.
    coneq[1676]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1537536.
    coneq[1677]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**4)))))-1/360360.
    coneq[1678]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1441440.
    coneq[1679]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/4324320.
    coneq[1680]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8648640.
    coneq[1681]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/2882880.
    coneq[1682]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/1081080.
    coneq[1683]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/2162160.
    coneq[1684]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/720720.
    coneq[1685]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1441440.
    coneq[1686]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4)))))-1/720720.
    coneq[1687]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/2882880.
    coneq[1688]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[1689]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[1690]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[1691]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/2162160.
    coneq[1692]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/4324320.
    coneq[1693]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1441440.
    coneq[1694]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2882880.
    coneq[1695]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**5)))))-1/288288.
    coneq[1696]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4))))))-1/1441440.
    coneq[1697]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/5765760.
    coneq[1698]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/17297280.
    coneq[1699]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/34594560.
    coneq[1700]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/11531520.
    coneq[1701]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/4324320.
    coneq[1702]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/8648640.
    coneq[1703]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/2882880.
    coneq[1704]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/5765760.
    coneq[1705]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3))))))-1/1153152.
    coneq[1706]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/3459456.
    coneq[1707]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/6918912.
    coneq[1708]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/2306304.
    coneq[1709]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/864864.
    coneq[1710]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1729728.
    coneq[1711]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c))))))-1/576576.
    coneq[1712]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1729728.
    coneq[1713]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3459456.
    coneq[1714]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1153152.
    coneq[1715]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**3)))))-1/288288.
    coneq[1716]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/864864.
    coneq[1717]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1729728.
    coneq[1718]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/576576.
    coneq[1719]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3)))))-1/576576.
    coneq[1720]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1729728.
    coneq[1721]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/3459456.
    coneq[1722]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1153152.
    coneq[1723]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**4)))))-1/240240.
    coneq[1724]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3))))))-1/960960.
    coneq[1725]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[1726]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[1727]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[1728]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/720720.
    coneq[1729]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1441440.
    coneq[1730]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/480480.
    coneq[1731]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/960960.
    coneq[1732]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,c**2)))))-1/216216.
    coneq[1733]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c))))))-1/432432.
    coneq[1734]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/864864.
    coneq[1735]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**3)))))-1/192192.
    coneq[1736]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2))))))-1/576576.
    coneq[1737]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1153152.
    coneq[1738]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c))))))-1/384384.
    coneq[1739]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c)*dot(A,c**2)))))-1/144144.
    coneq[1740]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c)*dot(A,dot(A,c))))))-1/288288.
    coneq[1741]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c)*dot(A,c)))))-1/96096.
    coneq[1742]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5)))))-1/576576.
    coneq[1743]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4))))))-1/2882880.
    coneq[1744]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/11531520.
    coneq[1745]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/34594560.
    coneq[1746]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/69189120.
    coneq[1747]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/23063040.
    coneq[1748]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/8648640.
    coneq[1749]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/17297280.
    coneq[1750]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/5765760.
    coneq[1751]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/11531520.
    coneq[1752]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3))))))-1/2306304.
    coneq[1753]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/6918912.
    coneq[1754]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/13837824.
    coneq[1755]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/4612608.
    coneq[1756]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/1729728.
    coneq[1757]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/3459456.
    coneq[1758]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c))))))-1/1153152.
    coneq[1759]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/3459456.
    coneq[1760]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/6918912.
    coneq[1761]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/2306304.
    coneq[1762]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4)))))-1/720720.
    coneq[1763]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3))))))-1/2882880.
    coneq[1764]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[1765]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[1766]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[1767]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/2162160.
    coneq[1768]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/4324320.
    coneq[1769]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/1441440.
    coneq[1770]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/2882880.
    coneq[1771]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4)))))-1/1441440.
    coneq[1772]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/5765760.
    coneq[1773]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/17297280.
    coneq[1774]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/34594560.
    coneq[1775]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/11531520.
    coneq[1776]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/4324320.
    coneq[1777]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/8648640.
    coneq[1778]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/2882880.
    coneq[1779]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/5765760.
    coneq[1780]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3)))))-1/864864.
    coneq[1781]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/2594592.
    coneq[1782]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/5189184.
    coneq[1783]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/1729728.
    coneq[1784]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3)))))-1/1729728.
    coneq[1785]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/5189184.
    coneq[1786]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/10378368.
    coneq[1787]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/3459456.
    coneq[1788]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3)))))-1/3459456.
    coneq[1789]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/10378368.
    coneq[1790]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/20756736.
    coneq[1791]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/6918912.
    coneq[1792]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3)))))-1/768768.
    coneq[1793]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2))))))-1/2306304.
    coneq[1794]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/4612608.
    coneq[1795]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c))))))-1/1537536.
    coneq[1796]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/6918912.
    coneq[1797]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/13837824.
    coneq[1798]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/4612608.
    coneq[1799]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/27675648.
    coneq[1800]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/9225216.
    coneq[1801]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/3075072.
    coneq[1802]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4)))))-1/480480.
    coneq[1803]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))))-1/1921920.
    coneq[1804]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/5765760.
    coneq[1805]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/11531520.
    coneq[1806]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/3843840.
    coneq[1807]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1441440.
    coneq[1808]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2882880.
    coneq[1809]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/960960.
    coneq[1810]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1921920.
    coneq[1811]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3)))))-1/576576.
    coneq[1812]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1729728.
    coneq[1813]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/3459456.
    coneq[1814]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/1153152.
    coneq[1815]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))))-1/1153152.
    coneq[1816]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/3459456.
    coneq[1817]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/6918912.
    coneq[1818]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/2306304.
    coneq[1819]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))))-1/648648.
    coneq[1820]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))))-1/1297296.
    coneq[1821]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2594592.
    coneq[1822]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/5189184.
    coneq[1823]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/384384.
    coneq[1824]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/1153152.
    coneq[1825]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2306304.
    coneq[1826]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/768768.
    coneq[1827]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/432432.
    coneq[1828]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/864864.
    coneq[1829]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1729728.
    coneq[1830]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/288288.
    coneq[1831]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/576576.
    coneq[1832]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c)))))-1/192192.
    coneq[1833]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/768768.
    coneq[1834]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/2306304.
    coneq[1835]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/4612608.
    coneq[1836]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/1537536.
    coneq[1837]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/864864.
    coneq[1838]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/1729728.
    coneq[1839]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2)))))-1/1729728.
    coneq[1840]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/3459456.
    coneq[1841]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/576576.
    coneq[1842]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/1153152.
    coneq[1843]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/384384.
    coneq[1844]=dot(b,dot(A,dot(A,c*dot(A,c**9))))-1/21840.
    coneq[1845]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**8)))))-1/196560.
    coneq[1846]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**7))))))-1/1572480.
    coneq[1847]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**6)))))))-1/11007360.
    coneq[1848]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))))-1/66044160.
    coneq[1849]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))))-1/330220800.
    coneq[1850]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))))-1/1320883200.
    coneq[1851]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/3962649600.
    coneq[1852]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/7925299200.
    coneq[1853]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/2641766400.
    coneq[1854]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))))-1/990662400.
    coneq[1855]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/1981324800.
    coneq[1856]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))))-1/660441600.
    coneq[1857]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/1320883200.
    coneq[1858]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))))-1/264176640.
    coneq[1859]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))))-1/792529920.
    coneq[1860]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/1585059840.
    coneq[1861]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))))-1/528353280.
    coneq[1862]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))))-1/198132480.
    coneq[1863]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))))-1/396264960.
    coneq[1864]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))))-1/132088320.
    coneq[1865]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))))-1/396264960.
    coneq[1866]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/792529920.
    coneq[1867]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))))-1/264176640.
    coneq[1868]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))))-1/55036800.
    coneq[1869]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))))-1/220147200.
    coneq[1870]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))))-1/660441600.
    coneq[1871]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1320883200.
    coneq[1872]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))))-1/440294400.
    coneq[1873]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))))-1/165110400.
    coneq[1874]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))))-1/330220800.
    coneq[1875]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))))-1/110073600.
    coneq[1876]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))))-1/220147200.
    coneq[1877]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))))-1/44029440.
    coneq[1878]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))))-1/132088320.
    coneq[1879]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))))-1/264176640.
    coneq[1880]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))))-1/88058880.
    coneq[1881]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))))-1/33022080.
    coneq[1882]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))))-1/66044160.
    coneq[1883]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))))-1/22014720.
    coneq[1884]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))))-1/99066240.
    coneq[1885]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))))-1/198132480.
    coneq[1886]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/396264960.
    coneq[1887]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))))-1/88058880.
    coneq[1888]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))))-1/264176640.
    coneq[1889]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/528353280.
    coneq[1890]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))))-1/176117760.
    coneq[1891]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))))-1/66044160.
    coneq[1892]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))))-1/132088320.
    coneq[1893]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))))-1/44029440.
    coneq[1894]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))))-1/88058880.
    coneq[1895]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**5)))))))-1/9434880.
    coneq[1896]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))))-1/47174400.
    coneq[1897]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))))-1/188697600.
    coneq[1898]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/566092800.
    coneq[1899]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1132185600.
    coneq[1900]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/377395200.
    coneq[1901]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))))-1/141523200.
    coneq[1902]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/283046400.
    coneq[1903]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))))-1/94348800.
    coneq[1904]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/188697600.
    coneq[1905]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))))-1/37739520.
    coneq[1906]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))))-1/113218560.
    coneq[1907]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/226437120.
    coneq[1908]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))))-1/75479040.
    coneq[1909]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))))-1/28304640.
    coneq[1910]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))))-1/56609280.
    coneq[1911]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))))-1/18869760.
    coneq[1912]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))))-1/56609280.
    coneq[1913]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/113218560.
    coneq[1914]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))))-1/37739520.
    coneq[1915]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))))-1/7862400.
    coneq[1916]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))))-1/31449600.
    coneq[1917]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))))-1/94348800.
    coneq[1918]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/188697600.
    coneq[1919]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))))-1/62899200.
    coneq[1920]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))))-1/23587200.
    coneq[1921]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))))-1/47174400.
    coneq[1922]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))))-1/15724800.
    coneq[1923]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))))-1/31449600.
    coneq[1924]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))))-1/6289920.
    coneq[1925]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[1926]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[1927]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[1928]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))))-1/4717440.
    coneq[1929]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))))-1/9434880.
    coneq[1930]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5*dot(A,c)))))))-1/3144960.
    coneq[1931]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))))-1/18869760.
    coneq[1932]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))))-1/56609280.
    coneq[1933]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))))-1/113218560.
    coneq[1934]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))))-1/37739520.
    coneq[1935]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))))-1/37739520.
    coneq[1936]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))))-1/113218560.
    coneq[1937]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))))-1/226437120.
    coneq[1938]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))))-1/75479040.
    coneq[1939]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))))-1/15724800.
    coneq[1940]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))))-1/62899200.
    coneq[1941]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))))-1/188697600.
    coneq[1942]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/377395200.
    coneq[1943]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))))-1/125798400.
    coneq[1944]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))))-1/47174400.
    coneq[1945]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))))-1/94348800.
    coneq[1946]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))))-1/31449600.
    coneq[1947]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))))-1/62899200.
    coneq[1948]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))))-1/14152320.
    coneq[1949]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))))-1/28304640.
    coneq[1950]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/56609280.
    coneq[1951]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))))-1/12579840.
    coneq[1952]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))))-1/37739520.
    coneq[1953]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/75479040.
    coneq[1954]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))))-1/25159680.
    coneq[1955]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))))-1/9434880.
    coneq[1956]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))))-1/18869760.
    coneq[1957]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[1958]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))))-1/18869760.
    coneq[1959]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))))-1/37739520.
    coneq[1960]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/12579840.
    coneq[1961]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**6))))))-1/1375920.
    coneq[1962]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**5)))))))-1/8255520.
    coneq[1963]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))))-1/41277600.
    coneq[1964]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/165110400.
    coneq[1965]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/495331200.
    coneq[1966]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/990662400.
    coneq[1967]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/330220800.
    coneq[1968]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/123832800.
    coneq[1969]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/247665600.
    coneq[1970]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/82555200.
    coneq[1971]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/165110400.
    coneq[1972]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))))-1/33022080.
    coneq[1973]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/99066240.
    coneq[1974]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/198132480.
    coneq[1975]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/66044160.
    coneq[1976]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))))-1/24766560.
    coneq[1977]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/49533120.
    coneq[1978]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))))-1/16511040.
    coneq[1979]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/49533120.
    coneq[1980]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/99066240.
    coneq[1981]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/33022080.
    coneq[1982]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))))-1/6879600.
    coneq[1983]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))))-1/27518400.
    coneq[1984]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/82555200.
    coneq[1985]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/165110400.
    coneq[1986]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/55036800.
    coneq[1987]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))))-1/20638800.
    coneq[1988]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/41277600.
    coneq[1989]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))))-1/13759200.
    coneq[1990]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/27518400.
    coneq[1991]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))))-1/5503680.
    coneq[1992]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))))-1/16511040.
    coneq[1993]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/33022080.
    coneq[1994]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))))-1/11007360.
    coneq[1995]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))))-1/4127760.
    coneq[1996]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))))-1/8255520.
    coneq[1997]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))))-1/2751840.
    coneq[1998]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/12383280.
    coneq[1999]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/24766560.
    coneq[2000]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/49533120.
    coneq[2001]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))))-1/11007360.
    coneq[2002]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/33022080.
    coneq[2003]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/66044160.
    coneq[2004]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/22014720.
    coneq[2005]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/8255520.
    coneq[2006]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/16511040.
    coneq[2007]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/5503680.
    coneq[2008]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/11007360.
    coneq[2009]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**5))))))-1/1179360.
    coneq[2010]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))))-1/5896800.
    coneq[2011]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))))-1/23587200.
    coneq[2012]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/70761600.
    coneq[2013]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/141523200.
    coneq[2014]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/47174400.
    coneq[2015]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))))-1/17690400.
    coneq[2016]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/35380800.
    coneq[2017]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))))-1/11793600.
    coneq[2018]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/23587200.
    coneq[2019]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))))-1/4717440.
    coneq[2020]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))))-1/14152320.
    coneq[2021]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/28304640.
    coneq[2022]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))))-1/9434880.
    coneq[2023]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))))-1/3538080.
    coneq[2024]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))))-1/7076160.
    coneq[2025]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))))-1/2358720.
    coneq[2026]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))))-1/7076160.
    coneq[2027]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/14152320.
    coneq[2028]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))))-1/4717440.
    coneq[2029]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**4))))))-1/982800.
    coneq[2030]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))))-1/3931200.
    coneq[2031]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))))-1/11793600.
    coneq[2032]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/23587200.
    coneq[2033]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))))-1/7862400.
    coneq[2034]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))))-1/2948400.
    coneq[2035]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))))-1/5896800.
    coneq[2036]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))))-1/1965600.
    coneq[2037]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))))-1/3931200.
    coneq[2038]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c**3))))))-1/786240.
    coneq[2039]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[2040]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[2041]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[2042]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5*dot(A,c**2))))))-1/589680.
    coneq[2043]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5*dot(A,dot(A,c)))))))-1/1179360.
    coneq[2044]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**6*dot(A,c))))))-1/393120.
    coneq[2045]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))))-1/3144960.
    coneq[2046]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[2047]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[2048]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[2049]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))))-1/28304640.
    coneq[2050]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))))-1/56609280.
    coneq[2051]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))))-1/18869760.
    coneq[2052]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))))-1/113218560.
    coneq[2053]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))))-1/37739520.
    coneq[2054]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))))-1/12579840.
    coneq[2055]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))))-1/2948400.
    coneq[2056]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))))-1/11793600.
    coneq[2057]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))))-1/35380800.
    coneq[2058]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/70761600.
    coneq[2059]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))))-1/23587200.
    coneq[2060]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))))-1/8845200.
    coneq[2061]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))))-1/17690400.
    coneq[2062]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))))-1/5896800.
    coneq[2063]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))))-1/11793600.
    coneq[2064]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))))-1/5896800.
    coneq[2065]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))))-1/23587200.
    coneq[2066]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))))-1/70761600.
    coneq[2067]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/141523200.
    coneq[2068]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))))-1/47174400.
    coneq[2069]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))))-1/17690400.
    coneq[2070]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))))-1/35380800.
    coneq[2071]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))))-1/11793600.
    coneq[2072]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))))-1/23587200.
    coneq[2073]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**5))))))-1/2358720.
    coneq[2074]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))))-1/11793600.
    coneq[2075]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))))-1/47174400.
    coneq[2076]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/141523200.
    coneq[2077]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/283046400.
    coneq[2078]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/94348800.
    coneq[2079]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))))-1/35380800.
    coneq[2080]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/70761600.
    coneq[2081]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))))-1/23587200.
    coneq[2082]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/47174400.
    coneq[2083]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))))-1/9434880.
    coneq[2084]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))))-1/28304640.
    coneq[2085]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/56609280.
    coneq[2086]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))))-1/18869760.
    coneq[2087]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))))-1/7076160.
    coneq[2088]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))))-1/14152320.
    coneq[2089]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))))-1/4717440.
    coneq[2090]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))))-1/14152320.
    coneq[2091]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/28304640.
    coneq[2092]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))))-1/9434880.
    coneq[2093]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))))-1/2358720.
    coneq[2094]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/7076160.
    coneq[2095]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/14152320.
    coneq[2096]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/4717440.
    coneq[2097]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))))-1/4717440.
    coneq[2098]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/14152320.
    coneq[2099]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/28304640.
    coneq[2100]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/9434880.
    coneq[2101]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))))-1/1965600.
    coneq[2102]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))))-1/7862400.
    coneq[2103]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/23587200.
    coneq[2104]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/47174400.
    coneq[2105]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/15724800.
    coneq[2106]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/5896800.
    coneq[2107]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/11793600.
    coneq[2108]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3931200.
    coneq[2109]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/7862400.
    coneq[2110]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))))-1/1769040.
    coneq[2111]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))))-1/3538080.
    coneq[2112]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/7076160.
    coneq[2113]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))))-1/1572480.
    coneq[2114]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[2115]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[2116]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[2117]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))))-1/1179360.
    coneq[2118]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))))-1/2358720.
    coneq[2119]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))))-1/786240.
    coneq[2120]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))))-1/3144960.
    coneq[2121]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[2122]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[2123]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[2124]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))))-1/3538080.
    coneq[2125]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))))-1/7076160.
    coneq[2126]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/14152320.
    coneq[2127]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/2358720.
    coneq[2128]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/4717440.
    coneq[2129]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[2130]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))))-1/3144960.
    coneq[2131]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**7)))))-1/174720.
    coneq[2132]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**6))))))-1/1223040.
    coneq[2133]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**5)))))))-1/7338240.
    coneq[2134]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/36691200.
    coneq[2135]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/146764800.
    coneq[2136]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/440294400.
    coneq[2137]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/880588800.
    coneq[2138]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/293529600.
    coneq[2139]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/110073600.
    coneq[2140]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/220147200.
    coneq[2141]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/73382400.
    coneq[2142]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/146764800.
    coneq[2143]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/29352960.
    coneq[2144]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/88058880.
    coneq[2145]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/176117760.
    coneq[2146]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/58705920.
    coneq[2147]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/22014720.
    coneq[2148]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/44029440.
    coneq[2149]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/14676480.
    coneq[2150]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/44029440.
    coneq[2151]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/88058880.
    coneq[2152]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/29352960.
    coneq[2153]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))))-1/6115200.
    coneq[2154]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/24460800.
    coneq[2155]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/73382400.
    coneq[2156]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/146764800.
    coneq[2157]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/48921600.
    coneq[2158]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/18345600.
    coneq[2159]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/36691200.
    coneq[2160]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/12230400.
    coneq[2161]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/24460800.
    coneq[2162]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))))-1/4892160.
    coneq[2163]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/14676480.
    coneq[2164]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/29352960.
    coneq[2165]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/9784320.
    coneq[2166]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))))-1/3669120.
    coneq[2167]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/7338240.
    coneq[2168]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))))-1/2446080.
    coneq[2169]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/11007360.
    coneq[2170]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/22014720.
    coneq[2171]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/44029440.
    coneq[2172]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/9784320.
    coneq[2173]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/29352960.
    coneq[2174]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/58705920.
    coneq[2175]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/19568640.
    coneq[2176]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/7338240.
    coneq[2177]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/14676480.
    coneq[2178]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/4892160.
    coneq[2179]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/9784320.
    coneq[2180]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**5))))))-1/1048320.
    coneq[2181]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))))-1/5241600.
    coneq[2182]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/20966400.
    coneq[2183]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/62899200.
    coneq[2184]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/125798400.
    coneq[2185]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/41932800.
    coneq[2186]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/15724800.
    coneq[2187]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/31449600.
    coneq[2188]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/10483200.
    coneq[2189]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/20966400.
    coneq[2190]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))))-1/4193280.
    coneq[2191]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/12579840.
    coneq[2192]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/25159680.
    coneq[2193]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/8386560.
    coneq[2194]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/3144960.
    coneq[2195]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/6289920.
    coneq[2196]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))))-1/2096640.
    coneq[2197]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/6289920.
    coneq[2198]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/12579840.
    coneq[2199]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/4193280.
    coneq[2200]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**4))))))-1/873600.
    coneq[2201]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))))-1/3494400.
    coneq[2202]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/10483200.
    coneq[2203]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/20966400.
    coneq[2204]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/6988800.
    coneq[2205]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/2620800.
    coneq[2206]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/5241600.
    coneq[2207]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1747200.
    coneq[2208]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/3494400.
    coneq[2209]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**3))))))-1/698880.
    coneq[2210]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[2211]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[2212]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[2213]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c**2))))))-1/524160.
    coneq[2214]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))))-1/1048320.
    coneq[2215]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**5*dot(A,c))))))-1/349440.
    coneq[2216]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))))-1/2096640.
    coneq[2217]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/6289920.
    coneq[2218]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/12579840.
    coneq[2219]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/4193280.
    coneq[2220]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/4193280.
    coneq[2221]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/12579840.
    coneq[2222]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/25159680.
    coneq[2223]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/8386560.
    coneq[2224]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))))-1/1747200.
    coneq[2225]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/6988800.
    coneq[2226]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/20966400.
    coneq[2227]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/41932800.
    coneq[2228]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/13977600.
    coneq[2229]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/5241600.
    coneq[2230]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/10483200.
    coneq[2231]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3494400.
    coneq[2232]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/6988800.
    coneq[2233]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1572480.
    coneq[2234]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/3144960.
    coneq[2235]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/6289920.
    coneq[2236]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1397760.
    coneq[2237]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/4193280.
    coneq[2238]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/8386560.
    coneq[2239]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2795520.
    coneq[2240]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/1048320.
    coneq[2241]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/2096640.
    coneq[2242]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))))-1/698880.
    coneq[2243]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/2096640.
    coneq[2244]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/4193280.
    coneq[2245]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1397760.
    coneq[2246]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**6)))))-1/152880.
    coneq[2247]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**5))))))-1/917280.
    coneq[2248]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))))-1/4586400.
    coneq[2249]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/18345600.
    coneq[2250]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/55036800.
    coneq[2251]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/110073600.
    coneq[2252]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/36691200.
    coneq[2253]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/13759200.
    coneq[2254]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/27518400.
    coneq[2255]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/9172800.
    coneq[2256]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/18345600.
    coneq[2257]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))))-1/3669120.
    coneq[2258]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/11007360.
    coneq[2259]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/22014720.
    coneq[2260]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/7338240.
    coneq[2261]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2751840.
    coneq[2262]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/5503680.
    coneq[2263]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))))-1/1834560.
    coneq[2264]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/5503680.
    coneq[2265]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/11007360.
    coneq[2266]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/3669120.
    coneq[2267]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**4))))))-1/764400.
    coneq[2268]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))))-1/3057600.
    coneq[2269]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/9172800.
    coneq[2270]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18345600.
    coneq[2271]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/6115200.
    coneq[2272]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2293200.
    coneq[2273]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/4586400.
    coneq[2274]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1528800.
    coneq[2275]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/3057600.
    coneq[2276]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**3))))))-1/611520.
    coneq[2277]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[2278]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[2279]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[2280]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c**2))))))-1/458640.
    coneq[2281]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))))-1/917280.
    coneq[2282]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4*dot(A,c))))))-1/305760.
    coneq[2283]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1375920.
    coneq[2284]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2751840.
    coneq[2285]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5503680.
    coneq[2286]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))))-1/1223040.
    coneq[2287]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[2288]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[2289]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[2290]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/917280.
    coneq[2291]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1834560.
    coneq[2292]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/611520.
    coneq[2293]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[2294]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**5)))))-1/131040.
    coneq[2295]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**4))))))-1/655200.
    coneq[2296]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))))-1/2620800.
    coneq[2297]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/7862400.
    coneq[2298]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/15724800.
    coneq[2299]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5241600.
    coneq[2300]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))))-1/1965600.
    coneq[2301]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3931200.
    coneq[2302]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))))-1/1310400.
    coneq[2303]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2620800.
    coneq[2304]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**3))))))-1/524160.
    coneq[2305]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[2306]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[2307]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[2308]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c**2))))))-1/393120.
    coneq[2309]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))))-1/786240.
    coneq[2310]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3*dot(A,c))))))-1/262080.
    coneq[2311]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))))-1/786240.
    coneq[2312]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1572480.
    coneq[2313]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))))-1/524160.
    coneq[2314]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**4)))))-1/109200.
    coneq[2315]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c**3))))))-1/436800.
    coneq[2316]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))))-1/1310400.
    coneq[2317]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2620800.
    coneq[2318]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))))-1/873600.
    coneq[2319]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c**2))))))-1/327600.
    coneq[2320]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))))-1/655200.
    coneq[2321]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2*dot(A,c))))))-1/218400.
    coneq[2322]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))))-1/436800.
    coneq[2323]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c**3)))))-1/87360.
    coneq[2324]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,dot(A,c**2))))))-1/262080.
    coneq[2325]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[2326]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c*dot(A,c))))))-1/174720.
    coneq[2327]=dot(b,dot(A,dot(A,c*dot(A,c**6*dot(A,c**2)))))-1/65520.
    coneq[2328]=dot(b,dot(A,dot(A,c*dot(A,c**6*dot(A,dot(A,c))))))-1/131040.
    coneq[2329]=dot(b,dot(A,dot(A,c*dot(A,c**7*dot(A,c)))))-1/43680.
    coneq[2330]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**4)))))-1/436800.
    coneq[2331]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))))-1/1747200.
    coneq[2332]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))))-1/5241600.
    coneq[2333]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/10483200.
    coneq[2334]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))))-1/3494400.
    coneq[2335]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))))-1/1310400.
    coneq[2336]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))))-1/2620800.
    coneq[2337]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))))-1/873600.
    coneq[2338]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))))-1/1747200.
    coneq[2339]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))))-1/1310400.
    coneq[2340]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))))-1/5241600.
    coneq[2341]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))))-1/15724800.
    coneq[2342]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/31449600.
    coneq[2343]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))))-1/10483200.
    coneq[2344]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))))-1/3931200.
    coneq[2345]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))))-1/7862400.
    coneq[2346]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))))-1/2620800.
    coneq[2347]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))))-1/5241600.
    coneq[2348]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))))-1/2620800.
    coneq[2349]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))))-1/10483200.
    coneq[2350]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))))-1/31449600.
    coneq[2351]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/62899200.
    coneq[2352]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))))-1/20966400.
    coneq[2353]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))))-1/7862400.
    coneq[2354]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))))-1/15724800.
    coneq[2355]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))))-1/5241600.
    coneq[2356]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))))-1/10483200.
    coneq[2357]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))))-1/873600.
    coneq[2358]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))))-1/3494400.
    coneq[2359]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/10483200.
    coneq[2360]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/20966400.
    coneq[2361]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/6988800.
    coneq[2362]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))))-1/2620800.
    coneq[2363]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/5241600.
    coneq[2364]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1747200.
    coneq[2365]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/3494400.
    coneq[2366]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**5)))))-1/393120.
    coneq[2367]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))))-1/1965600.
    coneq[2368]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))))-1/7862400.
    coneq[2369]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/23587200.
    coneq[2370]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/47174400.
    coneq[2371]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/15724800.
    coneq[2372]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))))-1/5896800.
    coneq[2373]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/11793600.
    coneq[2374]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))))-1/3931200.
    coneq[2375]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/7862400.
    coneq[2376]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))))-1/1572480.
    coneq[2377]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[2378]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[2379]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[2380]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))))-1/1179360.
    coneq[2381]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))))-1/2358720.
    coneq[2382]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))))-1/786240.
    coneq[2383]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))))-1/2358720.
    coneq[2384]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4717440.
    coneq[2385]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[2386]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**5)))))-1/786240.
    coneq[2387]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))))-1/3931200.
    coneq[2388]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))))-1/15724800.
    coneq[2389]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/47174400.
    coneq[2390]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/94348800.
    coneq[2391]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/31449600.
    coneq[2392]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))))-1/11793600.
    coneq[2393]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/23587200.
    coneq[2394]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))))-1/7862400.
    coneq[2395]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/15724800.
    coneq[2396]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))))-1/3144960.
    coneq[2397]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[2398]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[2399]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[2400]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))))-1/2358720.
    coneq[2401]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))))-1/4717440.
    coneq[2402]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))))-1/1572480.
    coneq[2403]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))))-1/4717440.
    coneq[2404]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/9434880.
    coneq[2405]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))))-1/3144960.
    coneq[2406]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**6)))))-1/305760.
    coneq[2407]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**5))))))-1/1834560.
    coneq[2408]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))))-1/9172800.
    coneq[2409]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/36691200.
    coneq[2410]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/110073600.
    coneq[2411]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/220147200.
    coneq[2412]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/73382400.
    coneq[2413]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/27518400.
    coneq[2414]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/55036800.
    coneq[2415]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/18345600.
    coneq[2416]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/36691200.
    coneq[2417]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))))-1/7338240.
    coneq[2418]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[2419]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[2420]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[2421]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/5503680.
    coneq[2422]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/11007360.
    coneq[2423]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))))-1/3669120.
    coneq[2424]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/11007360.
    coneq[2425]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/22014720.
    coneq[2426]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[2427]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))))-1/1528800.
    coneq[2428]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))))-1/6115200.
    coneq[2429]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/18345600.
    coneq[2430]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/36691200.
    coneq[2431]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/12230400.
    coneq[2432]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/4586400.
    coneq[2433]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/9172800.
    coneq[2434]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/3057600.
    coneq[2435]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/6115200.
    coneq[2436]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))))-1/1223040.
    coneq[2437]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[2438]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[2439]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[2440]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))))-1/917280.
    coneq[2441]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))))-1/1834560.
    coneq[2442]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))))-1/611520.
    coneq[2443]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2751840.
    coneq[2444]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/5503680.
    coneq[2445]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/11007360.
    coneq[2446]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))))-1/2446080.
    coneq[2447]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/7338240.
    coneq[2448]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/14676480.
    coneq[2449]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/4892160.
    coneq[2450]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1834560.
    coneq[2451]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/3669120.
    coneq[2452]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[2453]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/2446080.
    coneq[2454]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c**3)))))-1/349440.
    coneq[2455]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))))-1/1048320.
    coneq[2456]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[2457]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))))-1/698880.
    coneq[2458]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/3144960.
    coneq[2459]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[2460]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/2096640.
    coneq[2461]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/12579840.
    coneq[2462]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/4193280.
    coneq[2463]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1397760.
    coneq[2464]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**4)))))-1/327600.
    coneq[2465]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1310400.
    coneq[2466]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/3931200.
    coneq[2467]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7862400.
    coneq[2468]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/2620800.
    coneq[2469]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/982800.
    coneq[2470]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1965600.
    coneq[2471]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/655200.
    coneq[2472]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1310400.
    coneq[2473]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))))-1/655200.
    coneq[2474]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/2620800.
    coneq[2475]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/7862400.
    coneq[2476]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/15724800.
    coneq[2477]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/5241600.
    coneq[2478]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1965600.
    coneq[2479]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/3931200.
    coneq[2480]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1310400.
    coneq[2481]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2620800.
    coneq[2482]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**5)))))-1/262080.
    coneq[2483]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))))-1/1310400.
    coneq[2484]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/5241600.
    coneq[2485]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/15724800.
    coneq[2486]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/31449600.
    coneq[2487]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/10483200.
    coneq[2488]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/3931200.
    coneq[2489]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7862400.
    coneq[2490]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/2620800.
    coneq[2491]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/5241600.
    coneq[2492]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))))-1/1048320.
    coneq[2493]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[2494]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[2495]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[2496]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/786240.
    coneq[2497]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1572480.
    coneq[2498]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))))-1/524160.
    coneq[2499]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1572480.
    coneq[2500]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3144960.
    coneq[2501]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[2502]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**3)))))-1/262080.
    coneq[2503]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/786240.
    coneq[2504]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[2505]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/524160.
    coneq[2506]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))))-1/524160.
    coneq[2507]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1572480.
    coneq[2508]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[2509]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[2510]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**4)))))-1/218400.
    coneq[2511]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))))-1/873600.
    coneq[2512]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2620800.
    coneq[2513]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5241600.
    coneq[2514]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1747200.
    coneq[2515]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/655200.
    coneq[2516]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1310400.
    coneq[2517]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/436800.
    coneq[2518]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/873600.
    coneq[2519]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,c**2)))))-1/196560.
    coneq[2520]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))))-1/393120.
    coneq[2521]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/786240.
    coneq[2522]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**3)))))-1/174720.
    coneq[2523]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))))-1/524160.
    coneq[2524]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[2525]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))))-1/349440.
    coneq[2526]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c**2)))))-1/131040.
    coneq[2527]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))))-1/262080.
    coneq[2528]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c)*dot(A,c)))))-1/87360.
    coneq[2529]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))))-1/436800.
    coneq[2530]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))))-1/1747200.
    coneq[2531]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/5241600.
    coneq[2532]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/10483200.
    coneq[2533]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/3494400.
    coneq[2534]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1310400.
    coneq[2535]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2620800.
    coneq[2536]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/873600.
    coneq[2537]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1747200.
    coneq[2538]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))))-1/524160.
    coneq[2539]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1572480.
    coneq[2540]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[2541]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[2542]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))))-1/1048320.
    coneq[2543]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/3144960.
    coneq[2544]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[2545]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/2096640.
    coneq[2546]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))))-1/589680.
    coneq[2547]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))))-1/1179360.
    coneq[2548]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2358720.
    coneq[2549]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/4717440.
    coneq[2550]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/349440.
    coneq[2551]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/1048320.
    coneq[2552]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[2553]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/698880.
    coneq[2554]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/393120.
    coneq[2555]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/786240.
    coneq[2556]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1572480.
    coneq[2557]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/262080.
    coneq[2558]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/524160.
    coneq[2559]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))))-1/174720.
    coneq[2560]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/524160.
    coneq[2561]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/1048320.
    coneq[2562]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/349440.
    coneq[2563]=dot(b,dot(A,dot(A,c**2*dot(A,c**8))))-1/19656.
    coneq[2564]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**7)))))-1/157248.
    coneq[2565]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**6))))))-1/1100736.
    coneq[2566]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/6604416.
    coneq[2567]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/33022080.
    coneq[2568]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/132088320.
    coneq[2569]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/396264960.
    coneq[2570]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/792529920.
    coneq[2571]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/264176640.
    coneq[2572]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/99066240.
    coneq[2573]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/198132480.
    coneq[2574]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/66044160.
    coneq[2575]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/132088320.
    coneq[2576]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/26417664.
    coneq[2577]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/79252992.
    coneq[2578]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/158505984.
    coneq[2579]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/52835328.
    coneq[2580]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/19813248.
    coneq[2581]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/39626496.
    coneq[2582]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/13208832.
    coneq[2583]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/39626496.
    coneq[2584]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/79252992.
    coneq[2585]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/26417664.
    coneq[2586]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/5503680.
    coneq[2587]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/22014720.
    coneq[2588]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/66044160.
    coneq[2589]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/132088320.
    coneq[2590]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/44029440.
    coneq[2591]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/16511040.
    coneq[2592]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/33022080.
    coneq[2593]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/11007360.
    coneq[2594]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/22014720.
    coneq[2595]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/4402944.
    coneq[2596]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/13208832.
    coneq[2597]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/26417664.
    coneq[2598]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/8805888.
    coneq[2599]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/3302208.
    coneq[2600]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/6604416.
    coneq[2601]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/2201472.
    coneq[2602]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/9906624.
    coneq[2603]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/19813248.
    coneq[2604]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/39626496.
    coneq[2605]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/8805888.
    coneq[2606]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/26417664.
    coneq[2607]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/52835328.
    coneq[2608]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/17611776.
    coneq[2609]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/6604416.
    coneq[2610]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/13208832.
    coneq[2611]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/4402944.
    coneq[2612]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/8805888.
    coneq[2613]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**5))))))-1/943488.
    coneq[2614]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/4717440.
    coneq[2615]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/18869760.
    coneq[2616]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/56609280.
    coneq[2617]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/113218560.
    coneq[2618]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/37739520.
    coneq[2619]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/14152320.
    coneq[2620]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/28304640.
    coneq[2621]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/9434880.
    coneq[2622]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/18869760.
    coneq[2623]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/3773952.
    coneq[2624]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/11321856.
    coneq[2625]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/22643712.
    coneq[2626]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/7547904.
    coneq[2627]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2830464.
    coneq[2628]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/5660928.
    coneq[2629]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1886976.
    coneq[2630]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/5660928.
    coneq[2631]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/11321856.
    coneq[2632]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/3773952.
    coneq[2633]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**4))))))-1/786240.
    coneq[2634]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/3144960.
    coneq[2635]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/9434880.
    coneq[2636]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18869760.
    coneq[2637]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/6289920.
    coneq[2638]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/2358720.
    coneq[2639]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/4717440.
    coneq[2640]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1572480.
    coneq[2641]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/3144960.
    coneq[2642]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**3))))))-1/628992.
    coneq[2643]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1886976.
    coneq[2644]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/3773952.
    coneq[2645]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1257984.
    coneq[2646]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c**2))))))-1/471744.
    coneq[2647]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/943488.
    coneq[2648]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**5*dot(A,c))))))-1/314496.
    coneq[2649]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1886976.
    coneq[2650]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/5660928.
    coneq[2651]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/11321856.
    coneq[2652]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/3773952.
    coneq[2653]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/3773952.
    coneq[2654]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/11321856.
    coneq[2655]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/22643712.
    coneq[2656]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/7547904.
    coneq[2657]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/1572480.
    coneq[2658]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/6289920.
    coneq[2659]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[2660]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[2661]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[2662]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/4717440.
    coneq[2663]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/9434880.
    coneq[2664]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3144960.
    coneq[2665]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[2666]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1415232.
    coneq[2667]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2830464.
    coneq[2668]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5660928.
    coneq[2669]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1257984.
    coneq[2670]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/3773952.
    coneq[2671]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/7547904.
    coneq[2672]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2515968.
    coneq[2673]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/943488.
    coneq[2674]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1886976.
    coneq[2675]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/628992.
    coneq[2676]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1886976.
    coneq[2677]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/3773952.
    coneq[2678]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1257984.
    coneq[2679]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**6)))))-1/137592.
    coneq[2680]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**5))))))-1/825552.
    coneq[2681]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/4127760.
    coneq[2682]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/16511040.
    coneq[2683]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/49533120.
    coneq[2684]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/99066240.
    coneq[2685]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/33022080.
    coneq[2686]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/12383280.
    coneq[2687]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/24766560.
    coneq[2688]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/8255520.
    coneq[2689]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/16511040.
    coneq[2690]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/3302208.
    coneq[2691]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/9906624.
    coneq[2692]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/19813248.
    coneq[2693]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/6604416.
    coneq[2694]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2476656.
    coneq[2695]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/4953312.
    coneq[2696]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/1651104.
    coneq[2697]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/4953312.
    coneq[2698]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/9906624.
    coneq[2699]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/3302208.
    coneq[2700]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**4))))))-1/687960.
    coneq[2701]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/2751840.
    coneq[2702]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/8255520.
    coneq[2703]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/16511040.
    coneq[2704]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/5503680.
    coneq[2705]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2063880.
    coneq[2706]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/4127760.
    coneq[2707]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1375920.
    coneq[2708]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2751840.
    coneq[2709]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/550368.
    coneq[2710]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1651104.
    coneq[2711]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/3302208.
    coneq[2712]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1100736.
    coneq[2713]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/412776.
    coneq[2714]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/825552.
    coneq[2715]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4*dot(A,c))))))-1/275184.
    coneq[2716]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1238328.
    coneq[2717]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2476656.
    coneq[2718]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4953312.
    coneq[2719]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/1100736.
    coneq[2720]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/3302208.
    coneq[2721]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/6604416.
    coneq[2722]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2201472.
    coneq[2723]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/825552.
    coneq[2724]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1651104.
    coneq[2725]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/550368.
    coneq[2726]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1100736.
    coneq[2727]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**5)))))-1/117936.
    coneq[2728]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**4))))))-1/589680.
    coneq[2729]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/2358720.
    coneq[2730]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/7076160.
    coneq[2731]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14152320.
    coneq[2732]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4717440.
    coneq[2733]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/1769040.
    coneq[2734]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3538080.
    coneq[2735]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/1179360.
    coneq[2736]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2358720.
    coneq[2737]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/471744.
    coneq[2738]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/1415232.
    coneq[2739]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2830464.
    coneq[2740]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/943488.
    coneq[2741]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/353808.
    coneq[2742]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/707616.
    coneq[2743]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/235872.
    coneq[2744]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/707616.
    coneq[2745]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1415232.
    coneq[2746]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/471744.
    coneq[2747]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**4)))))-1/98280.
    coneq[2748]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**3))))))-1/393120.
    coneq[2749]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[2750]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[2751]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/786240.
    coneq[2752]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/294840.
    coneq[2753]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/589680.
    coneq[2754]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/196560.
    coneq[2755]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/393120.
    coneq[2756]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c**3)))))-1/78624.
    coneq[2757]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c**2))))))-1/235872.
    coneq[2758]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/471744.
    coneq[2759]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c*dot(A,c))))))-1/157248.
    coneq[2760]=dot(b,dot(A,dot(A,c**2*dot(A,c**5*dot(A,c**2)))))-1/58968.
    coneq[2761]=dot(b,dot(A,dot(A,c**2*dot(A,c**5*dot(A,dot(A,c))))))-1/117936.
    coneq[2762]=dot(b,dot(A,dot(A,c**2*dot(A,c**6*dot(A,c)))))-1/39312.
    coneq[2763]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c**3)))))-1/314496.
    coneq[2764]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/943488.
    coneq[2765]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[2766]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/628992.
    coneq[2767]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2830464.
    coneq[2768]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/5660928.
    coneq[2769]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1886976.
    coneq[2770]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/11321856.
    coneq[2771]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/3773952.
    coneq[2772]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[2773]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**4)))))-1/294840.
    coneq[2774]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1179360.
    coneq[2775]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/3538080.
    coneq[2776]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7076160.
    coneq[2777]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/2358720.
    coneq[2778]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/884520.
    coneq[2779]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1769040.
    coneq[2780]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/589680.
    coneq[2781]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1179360.
    coneq[2782]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/589680.
    coneq[2783]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/2358720.
    coneq[2784]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/7076160.
    coneq[2785]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/14152320.
    coneq[2786]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/4717440.
    coneq[2787]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1769040.
    coneq[2788]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/3538080.
    coneq[2789]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1179360.
    coneq[2790]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2358720.
    coneq[2791]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**5)))))-1/235872.
    coneq[2792]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/1179360.
    coneq[2793]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/4717440.
    coneq[2794]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/14152320.
    coneq[2795]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/28304640.
    coneq[2796]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/9434880.
    coneq[2797]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/3538080.
    coneq[2798]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7076160.
    coneq[2799]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/2358720.
    coneq[2800]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4717440.
    coneq[2801]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/943488.
    coneq[2802]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2830464.
    coneq[2803]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5660928.
    coneq[2804]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1886976.
    coneq[2805]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/707616.
    coneq[2806]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1415232.
    coneq[2807]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/471744.
    coneq[2808]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1415232.
    coneq[2809]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2830464.
    coneq[2810]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/943488.
    coneq[2811]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/235872.
    coneq[2812]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/707616.
    coneq[2813]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1415232.
    coneq[2814]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/471744.
    coneq[2815]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/471744.
    coneq[2816]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1415232.
    coneq[2817]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2830464.
    coneq[2818]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/943488.
    coneq[2819]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**4)))))-1/196560.
    coneq[2820]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/786240.
    coneq[2821]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[2822]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[2823]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[2824]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/589680.
    coneq[2825]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1179360.
    coneq[2826]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/393120.
    coneq[2827]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/786240.
    coneq[2828]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/176904.
    coneq[2829]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/353808.
    coneq[2830]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/707616.
    coneq[2831]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/157248.
    coneq[2832]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/471744.
    coneq[2833]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[2834]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/314496.
    coneq[2835]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/117936.
    coneq[2836]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/235872.
    coneq[2837]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c)*dot(A,c)))))-1/78624.
    coneq[2838]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/314496.
    coneq[2839]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/943488.
    coneq[2840]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[2841]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/628992.
    coneq[2842]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/353808.
    coneq[2843]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/707616.
    coneq[2844]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1415232.
    coneq[2845]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/235872.
    coneq[2846]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/471744.
    coneq[2847]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[2848]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[2849]=dot(b,dot(A,dot(A,c**3*dot(A,c**7))))-1/17472.
    coneq[2850]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**6)))))-1/122304.
    coneq[2851]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**5))))))-1/733824.
    coneq[2852]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/3669120.
    coneq[2853]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/14676480.
    coneq[2854]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/44029440.
    coneq[2855]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/88058880.
    coneq[2856]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/29352960.
    coneq[2857]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/11007360.
    coneq[2858]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/22014720.
    coneq[2859]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/7338240.
    coneq[2860]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/14676480.
    coneq[2861]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/2935296.
    coneq[2862]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/8805888.
    coneq[2863]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/17611776.
    coneq[2864]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/5870592.
    coneq[2865]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2201472.
    coneq[2866]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/4402944.
    coneq[2867]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1467648.
    coneq[2868]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/4402944.
    coneq[2869]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/8805888.
    coneq[2870]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2935296.
    coneq[2871]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**4))))))-1/611520.
    coneq[2872]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/2446080.
    coneq[2873]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/7338240.
    coneq[2874]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14676480.
    coneq[2875]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/4892160.
    coneq[2876]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1834560.
    coneq[2877]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3669120.
    coneq[2878]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1223040.
    coneq[2879]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2446080.
    coneq[2880]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**3))))))-1/489216.
    coneq[2881]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1467648.
    coneq[2882]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2935296.
    coneq[2883]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/978432.
    coneq[2884]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c**2))))))-1/366912.
    coneq[2885]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/733824.
    coneq[2886]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**4*dot(A,c))))))-1/244608.
    coneq[2887]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1100736.
    coneq[2888]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2201472.
    coneq[2889]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4402944.
    coneq[2890]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/978432.
    coneq[2891]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2935296.
    coneq[2892]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5870592.
    coneq[2893]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1956864.
    coneq[2894]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/733824.
    coneq[2895]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1467648.
    coneq[2896]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/489216.
    coneq[2897]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/978432.
    coneq[2898]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**5)))))-1/104832.
    coneq[2899]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**4))))))-1/524160.
    coneq[2900]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/2096640.
    coneq[2901]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/6289920.
    coneq[2902]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/12579840.
    coneq[2903]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4193280.
    coneq[2904]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1572480.
    coneq[2905]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3144960.
    coneq[2906]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/1048320.
    coneq[2907]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2096640.
    coneq[2908]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**3))))))-1/419328.
    coneq[2909]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/1257984.
    coneq[2910]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2515968.
    coneq[2911]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/838656.
    coneq[2912]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/314496.
    coneq[2913]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/628992.
    coneq[2914]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3*dot(A,c))))))-1/209664.
    coneq[2915]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/628992.
    coneq[2916]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1257984.
    coneq[2917]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/419328.
    coneq[2918]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**4)))))-1/87360.
    coneq[2919]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**3))))))-1/349440.
    coneq[2920]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/1048320.
    coneq[2921]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2096640.
    coneq[2922]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/698880.
    coneq[2923]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/262080.
    coneq[2924]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/524160.
    coneq[2925]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/174720.
    coneq[2926]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/349440.
    coneq[2927]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c**3)))))-1/69888.
    coneq[2928]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c**2))))))-1/209664.
    coneq[2929]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/419328.
    coneq[2930]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c*dot(A,c))))))-1/139776.
    coneq[2931]=dot(b,dot(A,dot(A,c**3*dot(A,c**4*dot(A,c**2)))))-1/52416.
    coneq[2932]=dot(b,dot(A,dot(A,c**3*dot(A,c**4*dot(A,dot(A,c))))))-1/104832.
    coneq[2933]=dot(b,dot(A,dot(A,c**3*dot(A,c**5*dot(A,c)))))-1/34944.
    coneq[2934]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/209664.
    coneq[2935]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/628992.
    coneq[2936]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[2937]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/419328.
    coneq[2938]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/419328.
    coneq[2939]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[2940]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[2941]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/838656.
    coneq[2942]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**4)))))-1/174720.
    coneq[2943]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/698880.
    coneq[2944]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[2945]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[2946]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[2947]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/524160.
    coneq[2948]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1048320.
    coneq[2949]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/349440.
    coneq[2950]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/698880.
    coneq[2951]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/157248.
    coneq[2952]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/314496.
    coneq[2953]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/628992.
    coneq[2954]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/139776.
    coneq[2955]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/419328.
    coneq[2956]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/838656.
    coneq[2957]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/279552.
    coneq[2958]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/104832.
    coneq[2959]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/209664.
    coneq[2960]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/69888.
    coneq[2961]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/209664.
    coneq[2962]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/419328.
    coneq[2963]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/139776.
    coneq[2964]=dot(b,dot(A,dot(A,c**4*dot(A,c**6))))-1/15288.
    coneq[2965]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**5)))))-1/91728.
    coneq[2966]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**4))))))-1/458640.
    coneq[2967]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1834560.
    coneq[2968]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5503680.
    coneq[2969]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11007360.
    coneq[2970]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3669120.
    coneq[2971]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1375920.
    coneq[2972]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2751840.
    coneq[2973]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/917280.
    coneq[2974]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1834560.
    coneq[2975]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c**3))))))-1/366912.
    coneq[2976]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1100736.
    coneq[2977]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2201472.
    coneq[2978]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/733824.
    coneq[2979]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c**2))))))-1/275184.
    coneq[2980]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/550368.
    coneq[2981]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**3*dot(A,c))))))-1/183456.
    coneq[2982]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/550368.
    coneq[2983]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1100736.
    coneq[2984]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/366912.
    coneq[2985]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**4)))))-1/76440.
    coneq[2986]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c**3))))))-1/305760.
    coneq[2987]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/917280.
    coneq[2988]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1834560.
    coneq[2989]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/611520.
    coneq[2990]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c**2))))))-1/229320.
    coneq[2991]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/458640.
    coneq[2992]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2*dot(A,c))))))-1/152880.
    coneq[2993]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/305760.
    coneq[2994]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c**3)))))-1/61152.
    coneq[2995]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c**2))))))-1/183456.
    coneq[2996]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/366912.
    coneq[2997]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c*dot(A,c))))))-1/122304.
    coneq[2998]=dot(b,dot(A,dot(A,c**4*dot(A,c**3*dot(A,c**2)))))-1/45864.
    coneq[2999]=dot(b,dot(A,dot(A,c**4*dot(A,c**3*dot(A,dot(A,c))))))-1/91728.
    coneq[3000]=dot(b,dot(A,dot(A,c**4*dot(A,c**4*dot(A,c)))))-1/30576.
    coneq[3001]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/137592.
    coneq[3002]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/275184.
    coneq[3003]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/550368.
    coneq[3004]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**3)))))-1/122304.
    coneq[3005]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/366912.
    coneq[3006]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/733824.
    coneq[3007]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/244608.
    coneq[3008]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/91728.
    coneq[3009]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/183456.
    coneq[3010]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/61152.
    coneq[3011]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/122304.
    coneq[3012]=dot(b,dot(A,dot(A,c**5*dot(A,c**5))))-1/13104.
    coneq[3013]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**4)))))-1/65520.
    coneq[3014]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c**3))))))-1/262080.
    coneq[3015]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/786240.
    coneq[3016]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1572480.
    coneq[3017]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/524160.
    coneq[3018]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c*dot(A,c**2))))))-1/196560.
    coneq[3019]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/393120.
    coneq[3020]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**2*dot(A,c))))))-1/131040.
    coneq[3021]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/262080.
    coneq[3022]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c**3)))))-1/52416.
    coneq[3023]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,dot(A,c**2))))))-1/157248.
    coneq[3024]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/314496.
    coneq[3025]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c*dot(A,c))))))-1/104832.
    coneq[3026]=dot(b,dot(A,dot(A,c**5*dot(A,c**2*dot(A,c**2)))))-1/39312.
    coneq[3027]=dot(b,dot(A,dot(A,c**5*dot(A,c**2*dot(A,dot(A,c))))))-1/78624.
    coneq[3028]=dot(b,dot(A,dot(A,c**5*dot(A,c**3*dot(A,c)))))-1/26208.
    coneq[3029]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c)*dot(A,c**2)))))-1/78624.
    coneq[3030]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/157248.
    coneq[3031]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c)*dot(A,c)))))-1/52416.
    coneq[3032]=dot(b,dot(A,dot(A,c**6*dot(A,c**4))))-1/10920.
    coneq[3033]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c**3)))))-1/43680.
    coneq[3034]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,dot(A,c**2))))))-1/131040.
    coneq[3035]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,dot(A,dot(A,c)))))))-1/262080.
    coneq[3036]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c*dot(A,c))))))-1/87360.
    coneq[3037]=dot(b,dot(A,dot(A,c**6*dot(A,c*dot(A,c**2)))))-1/32760.
    coneq[3038]=dot(b,dot(A,dot(A,c**6*dot(A,c*dot(A,dot(A,c))))))-1/65520.
    coneq[3039]=dot(b,dot(A,dot(A,c**6*dot(A,c**2*dot(A,c)))))-1/21840.
    coneq[3040]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c)*dot(A,c)))))-1/43680.
    coneq[3041]=dot(b,dot(A,dot(A,c**7*dot(A,c**3))))-1/8736.
    coneq[3042]=dot(b,dot(A,dot(A,c**7*dot(A,dot(A,c**2)))))-1/26208.
    coneq[3043]=dot(b,dot(A,dot(A,c**7*dot(A,dot(A,dot(A,c))))))-1/52416.
    coneq[3044]=dot(b,dot(A,dot(A,c**7*dot(A,c*dot(A,c)))))-1/17472.
    coneq[3045]=dot(b,dot(A,dot(A,c**8*dot(A,c**2))))-1/6552.
    coneq[3046]=dot(b,dot(A,dot(A,c**8*dot(A,dot(A,c)))))-1/13104.
    coneq[3047]=dot(b,dot(A,dot(A,c**9*dot(A,c))))-1/4368.
    coneq[3048]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**5))))-1/65520.
    coneq[3049]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c**4)))))-1/327600.
    coneq[3050]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**3))))))-1/1310400.
    coneq[3051]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3931200.
    coneq[3052]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7862400.
    coneq[3053]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2620800.
    coneq[3054]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c**2))))))-1/982800.
    coneq[3055]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1965600.
    coneq[3056]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c**2*dot(A,c))))))-1/655200.
    coneq[3057]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1310400.
    coneq[3058]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**3)))))-1/262080.
    coneq[3059]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c**2))))))-1/786240.
    coneq[3060]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[3061]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,c*dot(A,c))))))-1/524160.
    coneq[3062]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c**2)))))-1/196560.
    coneq[3063]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,dot(A,c))))))-1/393120.
    coneq[3064]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**3*dot(A,c)))))-1/131040.
    coneq[3065]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c**2)))))-1/393120.
    coneq[3066]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/786240.
    coneq[3067]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,c)*dot(A,c)))))-1/262080.
    coneq[3068]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**5))))-1/262080.
    coneq[3069]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**4)))))-1/1310400.
    coneq[3070]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**3))))))-1/5241600.
    coneq[3071]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/15724800.
    coneq[3072]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/31449600.
    coneq[3073]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/10483200.
    coneq[3074]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2))))))-1/3931200.
    coneq[3075]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/7862400.
    coneq[3076]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c))))))-1/2620800.
    coneq[3077]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/5241600.
    coneq[3078]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**3)))))-1/1048320.
    coneq[3079]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2))))))-1/3144960.
    coneq[3080]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[3081]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c))))))-1/2096640.
    coneq[3082]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c**2)))))-1/786240.
    coneq[3083]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c))))))-1/1572480.
    coneq[3084]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**3*dot(A,c)))))-1/524160.
    coneq[3085]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2)))))-1/1572480.
    coneq[3086]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/3144960.
    coneq[3087]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c)))))-1/1048320.
    coneq[3088]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**5))))-1/786240.
    coneq[3089]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**4)))))-1/3931200.
    coneq[3090]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))))-1/15724800.
    coneq[3091]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/47174400.
    coneq[3092]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/94348800.
    coneq[3093]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/31449600.
    coneq[3094]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))))-1/11793600.
    coneq[3095]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/23587200.
    coneq[3096]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))))-1/7862400.
    coneq[3097]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/15724800.
    coneq[3098]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3)))))-1/3144960.
    coneq[3099]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))))-1/9434880.
    coneq[3100]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/18869760.
    coneq[3101]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))))-1/6289920.
    coneq[3102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))))-1/2358720.
    coneq[3103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))))-1/4717440.
    coneq[3104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c)))))-1/1572480.
    coneq[3105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))))-1/4717440.
    coneq[3106]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/9434880.
    coneq[3107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))))-1/3144960.
    coneq[3108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**5))))-1/1572480.
    coneq[3109]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4)))))-1/7862400.
    coneq[3110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))))-1/31449600.
    coneq[3111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/94348800.
    coneq[3112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/188697600.
    coneq[3113]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/62899200.
    coneq[3114]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))))-1/23587200.
    coneq[3115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/47174400.
    coneq[3116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))))-1/15724800.
    coneq[3117]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/31449600.
    coneq[3118]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))))-1/6289920.
    coneq[3119]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))))-1/18869760.
    coneq[3120]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/37739520.
    coneq[3121]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))))-1/12579840.
    coneq[3122]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))))-1/4717440.
    coneq[3123]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))))-1/9434880.
    coneq[3124]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))))-1/3144960.
    coneq[3125]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))))-1/9434880.
    coneq[3126]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/18869760.
    coneq[3127]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))))-1/6289920.
    coneq[3128]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**5))))-1/524160.
    coneq[3129]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**4)))))-1/2620800.
    coneq[3130]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))))-1/10483200.
    coneq[3131]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/31449600.
    coneq[3132]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/62899200.
    coneq[3133]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/20966400.
    coneq[3134]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))))-1/7862400.
    coneq[3135]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/15724800.
    coneq[3136]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))))-1/5241600.
    coneq[3137]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/10483200.
    coneq[3138]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3)))))-1/2096640.
    coneq[3139]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))))-1/6289920.
    coneq[3140]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/12579840.
    coneq[3141]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))))-1/4193280.
    coneq[3142]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2)))))-1/1572480.
    coneq[3143]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))))-1/3144960.
    coneq[3144]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c)))))-1/1048320.
    coneq[3145]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))))-1/3144960.
    coneq[3146]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/6289920.
    coneq[3147]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))))-1/2096640.
    coneq[3148]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**5))))-1/196560.
    coneq[3149]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**4)))))-1/982800.
    coneq[3150]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))))-1/3931200.
    coneq[3151]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/11793600.
    coneq[3152]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/23587200.
    coneq[3153]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/7862400.
    coneq[3154]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))))-1/2948400.
    coneq[3155]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/5896800.
    coneq[3156]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))))-1/1965600.
    coneq[3157]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3931200.
    coneq[3158]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**3)))))-1/786240.
    coneq[3159]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))))-1/2358720.
    coneq[3160]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/4717440.
    coneq[3161]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))))-1/1572480.
    coneq[3162]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))))-1/589680.
    coneq[3163]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))))-1/1179360.
    coneq[3164]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**3*dot(A,c)))))-1/393120.
    coneq[3165]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))))-1/1179360.
    coneq[3166]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/2358720.
    coneq[3167]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))))-1/786240.
    coneq[3168]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**5))))-1/393120.
    coneq[3169]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))))-1/1965600.
    coneq[3170]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))))-1/7862400.
    coneq[3171]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/23587200.
    coneq[3172]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/47174400.
    coneq[3173]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/15724800.
    coneq[3174]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))))-1/5896800.
    coneq[3175]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/11793600.
    coneq[3176]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))))-1/3931200.
    coneq[3177]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/7862400.
    coneq[3178]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))))-1/1572480.
    coneq[3179]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))))-1/4717440.
    coneq[3180]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/9434880.
    coneq[3181]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))))-1/3144960.
    coneq[3182]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))))-1/1179360.
    coneq[3183]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))))-1/2358720.
    coneq[3184]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))))-1/786240.
    coneq[3185]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))))-1/2358720.
    coneq[3186]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/4717440.
    coneq[3187]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))))-1/1572480.
    coneq[3188]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**5))))-1/131040.
    coneq[3189]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**4)))))-1/655200.
    coneq[3190]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/2620800.
    coneq[3191]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/7862400.
    coneq[3192]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/15724800.
    coneq[3193]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/5241600.
    coneq[3194]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1965600.
    coneq[3195]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3931200.
    coneq[3196]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/1310400.
    coneq[3197]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2620800.
    coneq[3198]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**3)))))-1/524160.
    coneq[3199]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/1572480.
    coneq[3200]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[3201]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[3202]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/393120.
    coneq[3203]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/786240.
    coneq[3204]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**3*dot(A,c)))))-1/262080.
    coneq[3205]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/786240.
    coneq[3206]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1572480.
    coneq[3207]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/524160.
    coneq[3208]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**5))))-1/262080.
    coneq[3209]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**4)))))-1/1310400.
    coneq[3210]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/5241600.
    coneq[3211]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/15724800.
    coneq[3212]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/31449600.
    coneq[3213]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/10483200.
    coneq[3214]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/3931200.
    coneq[3215]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/7862400.
    coneq[3216]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/2620800.
    coneq[3217]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/5241600.
    coneq[3218]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3)))))-1/1048320.
    coneq[3219]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/3144960.
    coneq[3220]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[3221]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/2096640.
    coneq[3222]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/786240.
    coneq[3223]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/1572480.
    coneq[3224]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c)))))-1/524160.
    coneq[3225]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/1572480.
    coneq[3226]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/3144960.
    coneq[3227]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/1048320.
    coneq[3228]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**6))))-1/61152.
    coneq[3229]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**5)))))-1/366912.
    coneq[3230]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**4))))))-1/1834560.
    coneq[3231]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/7338240.
    coneq[3232]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[3233]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[3234]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[3235]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/5503680.
    coneq[3236]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/11007360.
    coneq[3237]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/3669120.
    coneq[3238]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[3239]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**3))))))-1/1467648.
    coneq[3240]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/4402944.
    coneq[3241]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/8805888.
    coneq[3242]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2935296.
    coneq[3243]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/1100736.
    coneq[3244]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/2201472.
    coneq[3245]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3*dot(A,c))))))-1/733824.
    coneq[3246]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/2201472.
    coneq[3247]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4402944.
    coneq[3248]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1467648.
    coneq[3249]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**4)))))-1/305760.
    coneq[3250]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**3))))))-1/1223040.
    coneq[3251]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[3252]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[3253]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[3254]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/917280.
    coneq[3255]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1834560.
    coneq[3256]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/611520.
    coneq[3257]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[3258]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**3)))))-1/244608.
    coneq[3259]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/733824.
    coneq[3260]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1467648.
    coneq[3261]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/489216.
    coneq[3262]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c**2)))))-1/183456.
    coneq[3263]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,dot(A,c))))))-1/366912.
    coneq[3264]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**4*dot(A,c)))))-1/122304.
    coneq[3265]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/550368.
    coneq[3266]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1100736.
    coneq[3267]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2201472.
    coneq[3268]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**3)))))-1/489216.
    coneq[3269]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1467648.
    coneq[3270]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2935296.
    coneq[3271]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/978432.
    coneq[3272]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/366912.
    coneq[3273]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/733824.
    coneq[3274]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/244608.
    coneq[3275]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/489216.
    coneq[3276]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**6))))-1/183456.
    coneq[3277]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**5)))))-1/1100736.
    coneq[3278]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**4))))))-1/5503680.
    coneq[3279]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/22014720.
    coneq[3280]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/66044160.
    coneq[3281]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/132088320.
    coneq[3282]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/44029440.
    coneq[3283]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/16511040.
    coneq[3284]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/33022080.
    coneq[3285]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/11007360.
    coneq[3286]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/22014720.
    coneq[3287]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**3))))))-1/4402944.
    coneq[3288]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/13208832.
    coneq[3289]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/26417664.
    coneq[3290]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/8805888.
    coneq[3291]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c**2))))))-1/3302208.
    coneq[3292]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/6604416.
    coneq[3293]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3*dot(A,c))))))-1/2201472.
    coneq[3294]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/6604416.
    coneq[3295]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/13208832.
    coneq[3296]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/4402944.
    coneq[3297]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**4)))))-1/917280.
    coneq[3298]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**3))))))-1/3669120.
    coneq[3299]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/11007360.
    coneq[3300]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/22014720.
    coneq[3301]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/7338240.
    coneq[3302]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c**2))))))-1/2751840.
    coneq[3303]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/5503680.
    coneq[3304]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,c))))))-1/1834560.
    coneq[3305]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/3669120.
    coneq[3306]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**3)))))-1/733824.
    coneq[3307]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c**2))))))-1/2201472.
    coneq[3308]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/4402944.
    coneq[3309]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,c))))))-1/1467648.
    coneq[3310]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c**2)))))-1/550368.
    coneq[3311]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,dot(A,c))))))-1/1100736.
    coneq[3312]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4*dot(A,c)))))-1/366912.
    coneq[3313]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/1651104.
    coneq[3314]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/3302208.
    coneq[3315]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/6604416.
    coneq[3316]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**3)))))-1/1467648.
    coneq[3317]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/4402944.
    coneq[3318]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/8805888.
    coneq[3319]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/2935296.
    coneq[3320]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/1100736.
    coneq[3321]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/2201472.
    coneq[3322]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/733824.
    coneq[3323]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/1467648.
    coneq[3324]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**6))))-1/366912.
    coneq[3325]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**5)))))-1/2201472.
    coneq[3326]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**4))))))-1/11007360.
    coneq[3327]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/44029440.
    coneq[3328]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/132088320.
    coneq[3329]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/264176640.
    coneq[3330]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/88058880.
    coneq[3331]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/33022080.
    coneq[3332]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/66044160.
    coneq[3333]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/22014720.
    coneq[3334]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/44029440.
    coneq[3335]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**3))))))-1/8805888.
    coneq[3336]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/26417664.
    coneq[3337]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/52835328.
    coneq[3338]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/17611776.
    coneq[3339]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**2))))))-1/6604416.
    coneq[3340]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/13208832.
    coneq[3341]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,c))))))-1/4402944.
    coneq[3342]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/13208832.
    coneq[3343]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/26417664.
    coneq[3344]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/8805888.
    coneq[3345]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**4)))))-1/1834560.
    coneq[3346]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**3))))))-1/7338240.
    coneq[3347]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/22014720.
    coneq[3348]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/44029440.
    coneq[3349]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/14676480.
    coneq[3350]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**2))))))-1/5503680.
    coneq[3351]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/11007360.
    coneq[3352]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c))))))-1/3669120.
    coneq[3353]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/7338240.
    coneq[3354]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**3)))))-1/1467648.
    coneq[3355]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**2))))))-1/4402944.
    coneq[3356]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/8805888.
    coneq[3357]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c))))))-1/2935296.
    coneq[3358]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c**2)))))-1/1100736.
    coneq[3359]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,c))))))-1/2201472.
    coneq[3360]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4*dot(A,c)))))-1/733824.
    coneq[3361]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/3302208.
    coneq[3362]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/6604416.
    coneq[3363]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/13208832.
    coneq[3364]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**3)))))-1/2935296.
    coneq[3365]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/8805888.
    coneq[3366]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/17611776.
    coneq[3367]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/5870592.
    coneq[3368]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/2201472.
    coneq[3369]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/4402944.
    coneq[3370]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/1467648.
    coneq[3371]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/2935296.
    coneq[3372]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**6))))-1/122304.
    coneq[3373]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**5)))))-1/733824.
    coneq[3374]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**4))))))-1/3669120.
    coneq[3375]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/14676480.
    coneq[3376]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/44029440.
    coneq[3377]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/88058880.
    coneq[3378]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/29352960.
    coneq[3379]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/11007360.
    coneq[3380]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/22014720.
    coneq[3381]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/7338240.
    coneq[3382]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/14676480.
    coneq[3383]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))))-1/2935296.
    coneq[3384]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/8805888.
    coneq[3385]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/17611776.
    coneq[3386]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/5870592.
    coneq[3387]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))))-1/2201472.
    coneq[3388]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/4402944.
    coneq[3389]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))))-1/1467648.
    coneq[3390]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/4402944.
    coneq[3391]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/8805888.
    coneq[3392]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/2935296.
    coneq[3393]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**4)))))-1/611520.
    coneq[3394]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))))-1/2446080.
    coneq[3395]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/7338240.
    coneq[3396]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/14676480.
    coneq[3397]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/4892160.
    coneq[3398]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))))-1/1834560.
    coneq[3399]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/3669120.
    coneq[3400]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))))-1/1223040.
    coneq[3401]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/2446080.
    coneq[3402]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**3)))))-1/489216.
    coneq[3403]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))))-1/1467648.
    coneq[3404]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/2935296.
    coneq[3405]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))))-1/978432.
    coneq[3406]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c**2)))))-1/366912.
    coneq[3407]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))))-1/733824.
    coneq[3408]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4*dot(A,c)))))-1/244608.
    coneq[3409]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/1100736.
    coneq[3410]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/2201472.
    coneq[3411]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/4402944.
    coneq[3412]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))))-1/978432.
    coneq[3413]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/2935296.
    coneq[3414]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/5870592.
    coneq[3415]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1956864.
    coneq[3416]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/733824.
    coneq[3417]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/1467648.
    coneq[3418]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/489216.
    coneq[3419]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/978432.
    coneq[3420]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**7))))-1/52416.
    coneq[3421]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**6)))))-1/366912.
    coneq[3422]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**5))))))-1/2201472.
    coneq[3423]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/11007360.
    coneq[3424]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/44029440.
    coneq[3425]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/132088320.
    coneq[3426]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/264176640.
    coneq[3427]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/88058880.
    coneq[3428]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/33022080.
    coneq[3429]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/66044160.
    coneq[3430]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/22014720.
    coneq[3431]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/44029440.
    coneq[3432]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/8805888.
    coneq[3433]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/26417664.
    coneq[3434]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/52835328.
    coneq[3435]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/17611776.
    coneq[3436]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/6604416.
    coneq[3437]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/13208832.
    coneq[3438]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/4402944.
    coneq[3439]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/13208832.
    coneq[3440]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/26417664.
    coneq[3441]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/8805888.
    coneq[3442]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**4))))))-1/1834560.
    coneq[3443]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/7338240.
    coneq[3444]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[3445]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[3446]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[3447]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/5503680.
    coneq[3448]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/11007360.
    coneq[3449]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/3669120.
    coneq[3450]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[3451]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**3))))))-1/1467648.
    coneq[3452]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/4402944.
    coneq[3453]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/8805888.
    coneq[3454]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/2935296.
    coneq[3455]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c**2))))))-1/1100736.
    coneq[3456]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/2201472.
    coneq[3457]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4*dot(A,c))))))-1/733824.
    coneq[3458]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/3302208.
    coneq[3459]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/6604416.
    coneq[3460]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/13208832.
    coneq[3461]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/2935296.
    coneq[3462]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/8805888.
    coneq[3463]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/17611776.
    coneq[3464]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/5870592.
    coneq[3465]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/2201472.
    coneq[3466]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/4402944.
    coneq[3467]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/1467648.
    coneq[3468]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/2935296.
    coneq[3469]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**5)))))-1/314496.
    coneq[3470]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**4))))))-1/1572480.
    coneq[3471]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/6289920.
    coneq[3472]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[3473]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[3474]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[3475]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/4717440.
    coneq[3476]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/9434880.
    coneq[3477]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/3144960.
    coneq[3478]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[3479]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**3))))))-1/1257984.
    coneq[3480]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/3773952.
    coneq[3481]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/7547904.
    coneq[3482]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/2515968.
    coneq[3483]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/943488.
    coneq[3484]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/1886976.
    coneq[3485]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3*dot(A,c))))))-1/628992.
    coneq[3486]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/1886976.
    coneq[3487]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3773952.
    coneq[3488]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/1257984.
    coneq[3489]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**4)))))-1/262080.
    coneq[3490]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**3))))))-1/1048320.
    coneq[3491]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[3492]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[3493]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[3494]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[3495]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[3496]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[3497]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[3498]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**3)))))-1/209664.
    coneq[3499]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c**2))))))-1/628992.
    coneq[3500]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[3501]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c*dot(A,c))))))-1/419328.
    coneq[3502]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c**2)))))-1/157248.
    coneq[3503]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,dot(A,c))))))-1/314496.
    coneq[3504]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**5*dot(A,c)))))-1/104832.
    coneq[3505]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/628992.
    coneq[3506]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[3507]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[3508]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[3509]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/1257984.
    coneq[3510]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/3773952.
    coneq[3511]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/7547904.
    coneq[3512]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/2515968.
    coneq[3513]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**4)))))-1/524160.
    coneq[3514]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/2096640.
    coneq[3515]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/6289920.
    coneq[3516]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/12579840.
    coneq[3517]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/4193280.
    coneq[3518]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1572480.
    coneq[3519]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/3144960.
    coneq[3520]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/1048320.
    coneq[3521]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/2096640.
    coneq[3522]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/471744.
    coneq[3523]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/943488.
    coneq[3524]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1886976.
    coneq[3525]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/419328.
    coneq[3526]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[3527]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[3528]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/838656.
    coneq[3529]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[3530]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[3531]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[3532]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/628992.
    coneq[3533]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/1257984.
    coneq[3534]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/419328.
    coneq[3535]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**7))))-1/104832.
    coneq[3536]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**6)))))-1/733824.
    coneq[3537]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**5))))))-1/4402944.
    coneq[3538]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/22014720.
    coneq[3539]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/88058880.
    coneq[3540]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/264176640.
    coneq[3541]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/528353280.
    coneq[3542]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/176117760.
    coneq[3543]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/66044160.
    coneq[3544]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/132088320.
    coneq[3545]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/44029440.
    coneq[3546]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/88058880.
    coneq[3547]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/17611776.
    coneq[3548]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/52835328.
    coneq[3549]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/105670656.
    coneq[3550]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/35223552.
    coneq[3551]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/13208832.
    coneq[3552]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/26417664.
    coneq[3553]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/8805888.
    coneq[3554]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/26417664.
    coneq[3555]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/52835328.
    coneq[3556]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/17611776.
    coneq[3557]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**4))))))-1/3669120.
    coneq[3558]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/14676480.
    coneq[3559]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/44029440.
    coneq[3560]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/88058880.
    coneq[3561]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/29352960.
    coneq[3562]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/11007360.
    coneq[3563]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/22014720.
    coneq[3564]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/7338240.
    coneq[3565]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/14676480.
    coneq[3566]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**3))))))-1/2935296.
    coneq[3567]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/8805888.
    coneq[3568]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/17611776.
    coneq[3569]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/5870592.
    coneq[3570]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c**2))))))-1/2201472.
    coneq[3571]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/4402944.
    coneq[3572]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4*dot(A,c))))))-1/1467648.
    coneq[3573]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/6604416.
    coneq[3574]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/13208832.
    coneq[3575]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/26417664.
    coneq[3576]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/5870592.
    coneq[3577]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/17611776.
    coneq[3578]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/35223552.
    coneq[3579]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/11741184.
    coneq[3580]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/4402944.
    coneq[3581]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/8805888.
    coneq[3582]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/2935296.
    coneq[3583]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/5870592.
    coneq[3584]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**5)))))-1/628992.
    coneq[3585]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**4))))))-1/3144960.
    coneq[3586]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/12579840.
    coneq[3587]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/37739520.
    coneq[3588]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/75479040.
    coneq[3589]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/25159680.
    coneq[3590]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/9434880.
    coneq[3591]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/18869760.
    coneq[3592]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/6289920.
    coneq[3593]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/12579840.
    coneq[3594]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**3))))))-1/2515968.
    coneq[3595]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/7547904.
    coneq[3596]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/15095808.
    coneq[3597]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/5031936.
    coneq[3598]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/1886976.
    coneq[3599]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/3773952.
    coneq[3600]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3*dot(A,c))))))-1/1257984.
    coneq[3601]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/3773952.
    coneq[3602]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/7547904.
    coneq[3603]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/2515968.
    coneq[3604]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**4)))))-1/524160.
    coneq[3605]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**3))))))-1/2096640.
    coneq[3606]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/6289920.
    coneq[3607]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/12579840.
    coneq[3608]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/4193280.
    coneq[3609]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/1572480.
    coneq[3610]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/3144960.
    coneq[3611]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/1048320.
    coneq[3612]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/2096640.
    coneq[3613]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**3)))))-1/419328.
    coneq[3614]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[3615]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[3616]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c*dot(A,c))))))-1/838656.
    coneq[3617]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c**2)))))-1/314496.
    coneq[3618]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,dot(A,c))))))-1/628992.
    coneq[3619]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5*dot(A,c)))))-1/209664.
    coneq[3620]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/1257984.
    coneq[3621]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/3773952.
    coneq[3622]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/7547904.
    coneq[3623]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/2515968.
    coneq[3624]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/2515968.
    coneq[3625]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/7547904.
    coneq[3626]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/15095808.
    coneq[3627]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/5031936.
    coneq[3628]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**4)))))-1/1048320.
    coneq[3629]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/4193280.
    coneq[3630]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/12579840.
    coneq[3631]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/25159680.
    coneq[3632]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/8386560.
    coneq[3633]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/3144960.
    coneq[3634]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/6289920.
    coneq[3635]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/2096640.
    coneq[3636]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/4193280.
    coneq[3637]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/943488.
    coneq[3638]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/1886976.
    coneq[3639]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/3773952.
    coneq[3640]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/838656.
    coneq[3641]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/2515968.
    coneq[3642]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/5031936.
    coneq[3643]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/1677312.
    coneq[3644]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/628992.
    coneq[3645]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/1257984.
    coneq[3646]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/419328.
    coneq[3647]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/1257984.
    coneq[3648]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/2515968.
    coneq[3649]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/838656.
    coneq[3650]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**8))))-1/39312.
    coneq[3651]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**7)))))-1/314496.
    coneq[3652]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**6))))))-1/2201472.
    coneq[3653]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/13208832.
    coneq[3654]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/66044160.
    coneq[3655]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/264176640.
    coneq[3656]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/792529920.
    coneq[3657]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1585059840.
    coneq[3658]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/528353280.
    coneq[3659]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/198132480.
    coneq[3660]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/396264960.
    coneq[3661]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/132088320.
    coneq[3662]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/264176640.
    coneq[3663]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/52835328.
    coneq[3664]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/158505984.
    coneq[3665]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/317011968.
    coneq[3666]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/105670656.
    coneq[3667]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/39626496.
    coneq[3668]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/79252992.
    coneq[3669]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/26417664.
    coneq[3670]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/79252992.
    coneq[3671]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/158505984.
    coneq[3672]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/52835328.
    coneq[3673]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/11007360.
    coneq[3674]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/44029440.
    coneq[3675]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/132088320.
    coneq[3676]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/264176640.
    coneq[3677]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/88058880.
    coneq[3678]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/33022080.
    coneq[3679]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/66044160.
    coneq[3680]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/22014720.
    coneq[3681]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/44029440.
    coneq[3682]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/8805888.
    coneq[3683]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/26417664.
    coneq[3684]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/52835328.
    coneq[3685]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/17611776.
    coneq[3686]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/6604416.
    coneq[3687]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/13208832.
    coneq[3688]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/4402944.
    coneq[3689]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/19813248.
    coneq[3690]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/39626496.
    coneq[3691]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/79252992.
    coneq[3692]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/17611776.
    coneq[3693]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/52835328.
    coneq[3694]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/105670656.
    coneq[3695]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/35223552.
    coneq[3696]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/13208832.
    coneq[3697]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/26417664.
    coneq[3698]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/8805888.
    coneq[3699]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/17611776.
    coneq[3700]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**5))))))-1/1886976.
    coneq[3701]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/9434880.
    coneq[3702]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/37739520.
    coneq[3703]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/113218560.
    coneq[3704]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/226437120.
    coneq[3705]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/75479040.
    coneq[3706]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/28304640.
    coneq[3707]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/56609280.
    coneq[3708]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/18869760.
    coneq[3709]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/37739520.
    coneq[3710]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/7547904.
    coneq[3711]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/22643712.
    coneq[3712]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/45287424.
    coneq[3713]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/15095808.
    coneq[3714]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/5660928.
    coneq[3715]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/11321856.
    coneq[3716]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/3773952.
    coneq[3717]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/11321856.
    coneq[3718]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/22643712.
    coneq[3719]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/7547904.
    coneq[3720]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**4))))))-1/1572480.
    coneq[3721]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/6289920.
    coneq[3722]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[3723]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[3724]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[3725]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/4717440.
    coneq[3726]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/9434880.
    coneq[3727]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/3144960.
    coneq[3728]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[3729]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**3))))))-1/1257984.
    coneq[3730]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/3773952.
    coneq[3731]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/7547904.
    coneq[3732]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/2515968.
    coneq[3733]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c**2))))))-1/943488.
    coneq[3734]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/1886976.
    coneq[3735]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5*dot(A,c))))))-1/628992.
    coneq[3736]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/3773952.
    coneq[3737]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/11321856.
    coneq[3738]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/22643712.
    coneq[3739]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/7547904.
    coneq[3740]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/7547904.
    coneq[3741]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/22643712.
    coneq[3742]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/45287424.
    coneq[3743]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/15095808.
    coneq[3744]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/3144960.
    coneq[3745]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/12579840.
    coneq[3746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/37739520.
    coneq[3747]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/75479040.
    coneq[3748]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/25159680.
    coneq[3749]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/9434880.
    coneq[3750]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/18869760.
    coneq[3751]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/6289920.
    coneq[3752]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/12579840.
    coneq[3753]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/2830464.
    coneq[3754]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/5660928.
    coneq[3755]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/11321856.
    coneq[3756]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/2515968.
    coneq[3757]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/7547904.
    coneq[3758]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/15095808.
    coneq[3759]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/5031936.
    coneq[3760]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/1886976.
    coneq[3761]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/3773952.
    coneq[3762]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/1257984.
    coneq[3763]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/3773952.
    coneq[3764]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/7547904.
    coneq[3765]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/2515968.
    coneq[3766]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**6)))))-1/275184.
    coneq[3767]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**5))))))-1/1651104.
    coneq[3768]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/8255520.
    coneq[3769]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/33022080.
    coneq[3770]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/99066240.
    coneq[3771]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/198132480.
    coneq[3772]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/66044160.
    coneq[3773]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/24766560.
    coneq[3774]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/49533120.
    coneq[3775]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/16511040.
    coneq[3776]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/33022080.
    coneq[3777]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/6604416.
    coneq[3778]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/19813248.
    coneq[3779]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/39626496.
    coneq[3780]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/13208832.
    coneq[3781]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/4953312.
    coneq[3782]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/9906624.
    coneq[3783]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/3302208.
    coneq[3784]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/9906624.
    coneq[3785]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/19813248.
    coneq[3786]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/6604416.
    coneq[3787]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**4))))))-1/1375920.
    coneq[3788]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/5503680.
    coneq[3789]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/16511040.
    coneq[3790]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/33022080.
    coneq[3791]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/11007360.
    coneq[3792]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/4127760.
    coneq[3793]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/8255520.
    coneq[3794]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2751840.
    coneq[3795]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/5503680.
    coneq[3796]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/1100736.
    coneq[3797]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/3302208.
    coneq[3798]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/6604416.
    coneq[3799]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/2201472.
    coneq[3800]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/825552.
    coneq[3801]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/1651104.
    coneq[3802]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4*dot(A,c))))))-1/550368.
    coneq[3803]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2476656.
    coneq[3804]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/4953312.
    coneq[3805]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/9906624.
    coneq[3806]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/2201472.
    coneq[3807]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/6604416.
    coneq[3808]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/13208832.
    coneq[3809]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/4402944.
    coneq[3810]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1651104.
    coneq[3811]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/3302208.
    coneq[3812]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/1100736.
    coneq[3813]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/2201472.
    coneq[3814]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**5)))))-1/235872.
    coneq[3815]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**4))))))-1/1179360.
    coneq[3816]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/4717440.
    coneq[3817]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/14152320.
    coneq[3818]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/28304640.
    coneq[3819]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/9434880.
    coneq[3820]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/3538080.
    coneq[3821]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7076160.
    coneq[3822]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/2358720.
    coneq[3823]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4717440.
    coneq[3824]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/943488.
    coneq[3825]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/2830464.
    coneq[3826]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5660928.
    coneq[3827]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/1886976.
    coneq[3828]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/707616.
    coneq[3829]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/1415232.
    coneq[3830]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/471744.
    coneq[3831]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/1415232.
    coneq[3832]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2830464.
    coneq[3833]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/943488.
    coneq[3834]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**4)))))-1/196560.
    coneq[3835]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**3))))))-1/786240.
    coneq[3836]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[3837]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[3838]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[3839]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/589680.
    coneq[3840]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/1179360.
    coneq[3841]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/393120.
    coneq[3842]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/786240.
    coneq[3843]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**3)))))-1/157248.
    coneq[3844]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c**2))))))-1/471744.
    coneq[3845]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[3846]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c*dot(A,c))))))-1/314496.
    coneq[3847]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5*dot(A,c**2)))))-1/117936.
    coneq[3848]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5*dot(A,dot(A,c))))))-1/235872.
    coneq[3849]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**6*dot(A,c)))))-1/78624.
    coneq[3850]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c**3)))))-1/628992.
    coneq[3851]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[3852]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[3853]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[3854]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/5660928.
    coneq[3855]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/11321856.
    coneq[3856]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/3773952.
    coneq[3857]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/22643712.
    coneq[3858]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/7547904.
    coneq[3859]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/2515968.
    coneq[3860]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**4)))))-1/589680.
    coneq[3861]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/2358720.
    coneq[3862]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/7076160.
    coneq[3863]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/14152320.
    coneq[3864]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/4717440.
    coneq[3865]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/1769040.
    coneq[3866]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/3538080.
    coneq[3867]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/1179360.
    coneq[3868]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/2358720.
    coneq[3869]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/1179360.
    coneq[3870]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/4717440.
    coneq[3871]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/14152320.
    coneq[3872]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/28304640.
    coneq[3873]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/9434880.
    coneq[3874]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/3538080.
    coneq[3875]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/7076160.
    coneq[3876]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/2358720.
    coneq[3877]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/4717440.
    coneq[3878]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**5)))))-1/471744.
    coneq[3879]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/2358720.
    coneq[3880]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/9434880.
    coneq[3881]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/28304640.
    coneq[3882]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/56609280.
    coneq[3883]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/18869760.
    coneq[3884]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/7076160.
    coneq[3885]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/14152320.
    coneq[3886]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/4717440.
    coneq[3887]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/9434880.
    coneq[3888]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/1886976.
    coneq[3889]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/5660928.
    coneq[3890]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/11321856.
    coneq[3891]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/3773952.
    coneq[3892]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/1415232.
    coneq[3893]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/2830464.
    coneq[3894]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/943488.
    coneq[3895]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/2830464.
    coneq[3896]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/5660928.
    coneq[3897]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1886976.
    coneq[3898]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/471744.
    coneq[3899]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1415232.
    coneq[3900]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2830464.
    coneq[3901]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/943488.
    coneq[3902]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/943488.
    coneq[3903]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2830464.
    coneq[3904]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/5660928.
    coneq[3905]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1886976.
    coneq[3906]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**4)))))-1/393120.
    coneq[3907]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/1572480.
    coneq[3908]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[3909]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[3910]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[3911]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1179360.
    coneq[3912]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2358720.
    coneq[3913]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/786240.
    coneq[3914]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[3915]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/353808.
    coneq[3916]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/707616.
    coneq[3917]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1415232.
    coneq[3918]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/314496.
    coneq[3919]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/943488.
    coneq[3920]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[3921]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/628992.
    coneq[3922]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/235872.
    coneq[3923]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/471744.
    coneq[3924]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[3925]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/628992.
    coneq[3926]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[3927]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[3928]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[3929]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/707616.
    coneq[3930]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/1415232.
    coneq[3931]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2830464.
    coneq[3932]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/471744.
    coneq[3933]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/943488.
    coneq[3934]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[3935]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/628992.
    coneq[3936]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,c**4))))-1/54600.
    coneq[3937]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,dot(A,c**3)))))-1/218400.
    coneq[3938]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))))-1/655200.
    coneq[3939]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1310400.
    coneq[3940]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))))-1/436800.
    coneq[3941]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,c**2)))))-1/163800.
    coneq[3942]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))))-1/327600.
    coneq[3943]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,c**2*dot(A,c)))))-1/109200.
    coneq[3944]=dot(b,dot(A,dot(A,c*dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))))-1/218400.
    coneq[3945]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))))-1/873600.
    coneq[3946]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))))-1/2620800.
    coneq[3947]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/5241600.
    coneq[3948]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))))-1/1747200.
    coneq[3949]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))))-1/655200.
    coneq[3950]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))))-1/1310400.
    coneq[3951]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))))-1/436800.
    coneq[3952]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))))-1/873600.
    coneq[3953]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))))-1/7862400.
    coneq[3954]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/15724800.
    coneq[3955]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))))-1/5241600.
    coneq[3956]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))))-1/1965600.
    coneq[3957]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))))-1/3931200.
    coneq[3958]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))))-1/1310400.
    coneq[3959]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))))-1/2620800.
    coneq[3960]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/31449600.
    coneq[3961]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))))-1/10483200.
    coneq[3962]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))))-1/3931200.
    coneq[3963]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))))-1/7862400.
    coneq[3964]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))))-1/2620800.
    coneq[3965]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))))-1/5241600.
    coneq[3966]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/3494400.
    coneq[3967]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/1310400.
    coneq[3968]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/2620800.
    coneq[3969]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/873600.
    coneq[3970]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1747200.
    coneq[3971]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/491400.
    coneq[3972]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/982800.
    coneq[3973]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/327600.
    coneq[3974]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/655200.
    coneq[3975]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1965600.
    coneq[3976]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/655200.
    coneq[3977]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1310400.
    coneq[3978]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/218400.
    coneq[3979]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/436800.
    coneq[3980]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/873600.
    coneq[3981]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**5))))-1/52416.
    coneq[3982]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**4)))))-1/262080.
    coneq[3983]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))))-1/1048320.
    coneq[3984]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[3985]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[3986]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[3987]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[3988]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[3989]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[3990]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[3991]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**3)))))-1/209664.
    coneq[3992]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))))-1/628992.
    coneq[3993]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[3994]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))))-1/419328.
    coneq[3995]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c**2)))))-1/157248.
    coneq[3996]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))))-1/314496.
    coneq[3997]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3*dot(A,c)))))-1/104832.
    coneq[3998]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[3999]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[4000]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[4001]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**5))))-1/157248.
    coneq[4002]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))))-1/786240.
    coneq[4003]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))))-1/3144960.
    coneq[4004]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[4005]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[4006]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[4007]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))))-1/2358720.
    coneq[4008]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/4717440.
    coneq[4009]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))))-1/1572480.
    coneq[4010]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3144960.
    coneq[4011]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))))-1/628992.
    coneq[4012]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[4013]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[4014]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[4015]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))))-1/471744.
    coneq[4016]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))))-1/943488.
    coneq[4017]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))))-1/314496.
    coneq[4018]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))))-1/943488.
    coneq[4019]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1886976.
    coneq[4020]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))))-1/628992.
    coneq[4021]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**5))))-1/314496.
    coneq[4022]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))))-1/1572480.
    coneq[4023]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))))-1/6289920.
    coneq[4024]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/18869760.
    coneq[4025]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/37739520.
    coneq[4026]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/12579840.
    coneq[4027]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))))-1/4717440.
    coneq[4028]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/9434880.
    coneq[4029]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))))-1/3144960.
    coneq[4030]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/6289920.
    coneq[4031]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))))-1/1257984.
    coneq[4032]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))))-1/3773952.
    coneq[4033]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/7547904.
    coneq[4034]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))))-1/2515968.
    coneq[4035]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))))-1/943488.
    coneq[4036]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))))-1/1886976.
    coneq[4037]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))))-1/628992.
    coneq[4038]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))))-1/1886976.
    coneq[4039]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/3773952.
    coneq[4040]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))))-1/1257984.
    coneq[4041]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**5))))-1/104832.
    coneq[4042]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))))-1/524160.
    coneq[4043]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/2096640.
    coneq[4044]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/6289920.
    coneq[4045]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/12579840.
    coneq[4046]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/4193280.
    coneq[4047]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1572480.
    coneq[4048]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3144960.
    coneq[4049]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/1048320.
    coneq[4050]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2096640.
    coneq[4051]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))))-1/419328.
    coneq[4052]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[4053]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[4054]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/838656.
    coneq[4055]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/314496.
    coneq[4056]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/628992.
    coneq[4057]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))))-1/209664.
    coneq[4058]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/628992.
    coneq[4059]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1257984.
    coneq[4060]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/419328.
    coneq[4061]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**6))))-1/45864.
    coneq[4062]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**5)))))-1/275184.
    coneq[4063]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))))-1/1375920.
    coneq[4064]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/5503680.
    coneq[4065]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/16511040.
    coneq[4066]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/33022080.
    coneq[4067]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/11007360.
    coneq[4068]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/4127760.
    coneq[4069]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/8255520.
    coneq[4070]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/2751840.
    coneq[4071]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/5503680.
    coneq[4072]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))))-1/1100736.
    coneq[4073]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/3302208.
    coneq[4074]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/6604416.
    coneq[4075]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2201472.
    coneq[4076]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/825552.
    coneq[4077]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1651104.
    coneq[4078]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))))-1/550368.
    coneq[4079]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1651104.
    coneq[4080]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3302208.
    coneq[4081]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1100736.
    coneq[4082]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**4)))))-1/229320.
    coneq[4083]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))))-1/917280.
    coneq[4084]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/2751840.
    coneq[4085]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5503680.
    coneq[4086]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1834560.
    coneq[4087]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/687960.
    coneq[4088]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1375920.
    coneq[4089]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/458640.
    coneq[4090]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/917280.
    coneq[4091]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**3)))))-1/183456.
    coneq[4092]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/550368.
    coneq[4093]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1100736.
    coneq[4094]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/366912.
    coneq[4095]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c**2)))))-1/137592.
    coneq[4096]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))))-1/275184.
    coneq[4097]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4*dot(A,c)))))-1/91728.
    coneq[4098]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/412776.
    coneq[4099]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/825552.
    coneq[4100]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1651104.
    coneq[4101]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))))-1/366912.
    coneq[4102]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1100736.
    coneq[4103]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2201472.
    coneq[4104]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/733824.
    coneq[4105]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/275184.
    coneq[4106]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/550368.
    coneq[4107]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/183456.
    coneq[4108]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/366912.
    coneq[4109]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**6))))-1/91728.
    coneq[4110]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**5)))))-1/550368.
    coneq[4111]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))))-1/2751840.
    coneq[4112]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/11007360.
    coneq[4113]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/33022080.
    coneq[4114]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/66044160.
    coneq[4115]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/22014720.
    coneq[4116]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/8255520.
    coneq[4117]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/16511040.
    coneq[4118]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/5503680.
    coneq[4119]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/11007360.
    coneq[4120]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))))-1/2201472.
    coneq[4121]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/6604416.
    coneq[4122]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/13208832.
    coneq[4123]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/4402944.
    coneq[4124]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))))-1/1651104.
    coneq[4125]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/3302208.
    coneq[4126]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))))-1/1100736.
    coneq[4127]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/3302208.
    coneq[4128]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/6604416.
    coneq[4129]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/2201472.
    coneq[4130]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))))-1/458640.
    coneq[4131]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))))-1/1834560.
    coneq[4132]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/5503680.
    coneq[4133]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/11007360.
    coneq[4134]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/3669120.
    coneq[4135]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))))-1/1375920.
    coneq[4136]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/2751840.
    coneq[4137]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))))-1/917280.
    coneq[4138]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1834560.
    coneq[4139]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))))-1/366912.
    coneq[4140]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))))-1/1100736.
    coneq[4141]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/2201472.
    coneq[4142]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))))-1/733824.
    coneq[4143]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))))-1/275184.
    coneq[4144]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))))-1/550368.
    coneq[4145]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))))-1/183456.
    coneq[4146]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/825552.
    coneq[4147]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1651104.
    coneq[4148]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/3302208.
    coneq[4149]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))))-1/733824.
    coneq[4150]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/2201472.
    coneq[4151]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/4402944.
    coneq[4152]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1467648.
    coneq[4153]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/550368.
    coneq[4154]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/1100736.
    coneq[4155]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/366912.
    coneq[4156]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/733824.
    coneq[4157]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**7))))-1/34944.
    coneq[4158]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**6)))))-1/244608.
    coneq[4159]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**5))))))-1/1467648.
    coneq[4160]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/7338240.
    coneq[4161]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/29352960.
    coneq[4162]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/88058880.
    coneq[4163]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/176117760.
    coneq[4164]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/58705920.
    coneq[4165]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/22014720.
    coneq[4166]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/44029440.
    coneq[4167]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/14676480.
    coneq[4168]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/29352960.
    coneq[4169]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/5870592.
    coneq[4170]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/17611776.
    coneq[4171]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/35223552.
    coneq[4172]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/11741184.
    coneq[4173]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/4402944.
    coneq[4174]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/8805888.
    coneq[4175]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/2935296.
    coneq[4176]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/8805888.
    coneq[4177]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/17611776.
    coneq[4178]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/5870592.
    coneq[4179]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))))-1/1223040.
    coneq[4180]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/4892160.
    coneq[4181]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/14676480.
    coneq[4182]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/29352960.
    coneq[4183]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/9784320.
    coneq[4184]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/3669120.
    coneq[4185]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/7338240.
    coneq[4186]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2446080.
    coneq[4187]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/4892160.
    coneq[4188]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))))-1/978432.
    coneq[4189]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2935296.
    coneq[4190]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/5870592.
    coneq[4191]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1956864.
    coneq[4192]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))))-1/733824.
    coneq[4193]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/1467648.
    coneq[4194]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))))-1/489216.
    coneq[4195]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2201472.
    coneq[4196]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/4402944.
    coneq[4197]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/8805888.
    coneq[4198]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/1956864.
    coneq[4199]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/5870592.
    coneq[4200]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/11741184.
    coneq[4201]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/3913728.
    coneq[4202]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1467648.
    coneq[4203]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2935296.
    coneq[4204]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/978432.
    coneq[4205]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1956864.
    coneq[4206]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**5)))))-1/209664.
    coneq[4207]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))))-1/1048320.
    coneq[4208]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/4193280.
    coneq[4209]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/12579840.
    coneq[4210]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/25159680.
    coneq[4211]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/8386560.
    coneq[4212]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/3144960.
    coneq[4213]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/6289920.
    coneq[4214]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/2096640.
    coneq[4215]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4193280.
    coneq[4216]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))))-1/838656.
    coneq[4217]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/2515968.
    coneq[4218]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5031936.
    coneq[4219]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1677312.
    coneq[4220]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/628992.
    coneq[4221]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/1257984.
    coneq[4222]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))))-1/419328.
    coneq[4223]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/1257984.
    coneq[4224]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2515968.
    coneq[4225]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/838656.
    coneq[4226]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**4)))))-1/174720.
    coneq[4227]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))))-1/698880.
    coneq[4228]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[4229]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[4230]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[4231]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/524160.
    coneq[4232]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/1048320.
    coneq[4233]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/349440.
    coneq[4234]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/698880.
    coneq[4235]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**3)))))-1/139776.
    coneq[4236]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))))-1/419328.
    coneq[4237]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/838656.
    coneq[4238]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))))-1/279552.
    coneq[4239]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c**2)))))-1/104832.
    coneq[4240]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))))-1/209664.
    coneq[4241]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**5*dot(A,c)))))-1/69888.
    coneq[4242]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/419328.
    coneq[4243]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[4244]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[4245]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/838656.
    coneq[4246]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/838656.
    coneq[4247]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2515968.
    coneq[4248]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/5031936.
    coneq[4249]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1677312.
    coneq[4250]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))))-1/349440.
    coneq[4251]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/1397760.
    coneq[4252]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/4193280.
    coneq[4253]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8386560.
    coneq[4254]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2795520.
    coneq[4255]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1048320.
    coneq[4256]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2096640.
    coneq[4257]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/698880.
    coneq[4258]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1397760.
    coneq[4259]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/314496.
    coneq[4260]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/628992.
    coneq[4261]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1257984.
    coneq[4262]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/279552.
    coneq[4263]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/838656.
    coneq[4264]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1677312.
    coneq[4265]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/559104.
    coneq[4266]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/209664.
    coneq[4267]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/419328.
    coneq[4268]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/139776.
    coneq[4269]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/419328.
    coneq[4270]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/838656.
    coneq[4271]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/279552.
    coneq[4272]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c**4))))-1/43680.
    coneq[4273]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**3)))))-1/174720.
    coneq[4274]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[4275]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[4276]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[4277]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[4278]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[4279]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[4280]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[4281]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**4))))-1/131040.
    coneq[4282]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/524160.
    coneq[4283]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/1572480.
    coneq[4284]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[4285]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/1048320.
    coneq[4286]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/393120.
    coneq[4287]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/786240.
    coneq[4288]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/262080.
    coneq[4289]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/524160.
    coneq[4290]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/262080.
    coneq[4291]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/1048320.
    coneq[4292]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/3144960.
    coneq[4293]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[4294]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/2096640.
    coneq[4295]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/786240.
    coneq[4296]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1572480.
    coneq[4297]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/524160.
    coneq[4298]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1048320.
    coneq[4299]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**4))))-1/87360.
    coneq[4300]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/349440.
    coneq[4301]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1048320.
    coneq[4302]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[4303]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/698880.
    coneq[4304]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/262080.
    coneq[4305]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/524160.
    coneq[4306]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/174720.
    coneq[4307]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/349440.
    coneq[4308]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**5))))-1/39312.
    coneq[4309]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**4)))))-1/196560.
    coneq[4310]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/786240.
    coneq[4311]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[4312]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[4313]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[4314]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/589680.
    coneq[4315]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1179360.
    coneq[4316]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/393120.
    coneq[4317]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/786240.
    coneq[4318]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/157248.
    coneq[4319]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/471744.
    coneq[4320]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[4321]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/314496.
    coneq[4322]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/117936.
    coneq[4323]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/235872.
    coneq[4324]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/78624.
    coneq[4325]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/235872.
    coneq[4326]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/471744.
    coneq[4327]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[4328]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**5))))-1/78624.
    coneq[4329]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/393120.
    coneq[4330]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1572480.
    coneq[4331]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[4332]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[4333]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[4334]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1179360.
    coneq[4335]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2358720.
    coneq[4336]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/786240.
    coneq[4337]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[4338]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/314496.
    coneq[4339]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/943488.
    coneq[4340]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[4341]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/628992.
    coneq[4342]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/235872.
    coneq[4343]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/471744.
    coneq[4344]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/157248.
    coneq[4345]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/471744.
    coneq[4346]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/943488.
    coneq[4347]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[4348]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**6))))-1/30576.
    coneq[4349]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**5)))))-1/183456.
    coneq[4350]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/917280.
    coneq[4351]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/3669120.
    coneq[4352]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/11007360.
    coneq[4353]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/22014720.
    coneq[4354]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/7338240.
    coneq[4355]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2751840.
    coneq[4356]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5503680.
    coneq[4357]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1834560.
    coneq[4358]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3669120.
    coneq[4359]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/733824.
    coneq[4360]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2201472.
    coneq[4361]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4402944.
    coneq[4362]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1467648.
    coneq[4363]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/550368.
    coneq[4364]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1100736.
    coneq[4365]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/366912.
    coneq[4366]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1100736.
    coneq[4367]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2201472.
    coneq[4368]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/733824.
    coneq[4369]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**4)))))-1/152880.
    coneq[4370]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/611520.
    coneq[4371]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[4372]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[4373]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[4374]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/458640.
    coneq[4375]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/917280.
    coneq[4376]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/305760.
    coneq[4377]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/611520.
    coneq[4378]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/122304.
    coneq[4379]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/366912.
    coneq[4380]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/733824.
    coneq[4381]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/244608.
    coneq[4382]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/91728.
    coneq[4383]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/183456.
    coneq[4384]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4*dot(A,c)))))-1/61152.
    coneq[4385]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/275184.
    coneq[4386]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/550368.
    coneq[4387]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1100736.
    coneq[4388]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/244608.
    coneq[4389]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/733824.
    coneq[4390]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1467648.
    coneq[4391]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/489216.
    coneq[4392]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/183456.
    coneq[4393]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/366912.
    coneq[4394]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/122304.
    coneq[4395]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/244608.
    coneq[4396]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)*dot(A,c**3))))-1/34944.
    coneq[4397]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/104832.
    coneq[4398]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[4399]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/69888.
    coneq[4400]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/314496.
    coneq[4401]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[4402]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/209664.
    coneq[4403]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[4404]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/419328.
    coneq[4405]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/139776.
    coneq[4406]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**4))))-1/32760.
    coneq[4407]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/131040.
    coneq[4408]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/393120.
    coneq[4409]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[4410]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/262080.
    coneq[4411]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/98280.
    coneq[4412]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/196560.
    coneq[4413]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/65520.
    coneq[4414]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/131040.
    coneq[4415]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**4))))-1/65520.
    coneq[4416]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/262080.
    coneq[4417]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/786240.
    coneq[4418]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[4419]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/524160.
    coneq[4420]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/196560.
    coneq[4421]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/393120.
    coneq[4422]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/131040.
    coneq[4423]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/262080.
    coneq[4424]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**5))))-1/26208.
    coneq[4425]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**4)))))-1/131040.
    coneq[4426]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/524160.
    coneq[4427]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[4428]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[4429]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[4430]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[4431]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[4432]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[4433]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[4434]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/104832.
    coneq[4435]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/314496.
    coneq[4436]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[4437]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/209664.
    coneq[4438]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/78624.
    coneq[4439]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/157248.
    coneq[4440]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/52416.
    coneq[4441]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[4442]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[4443]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[4444]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,c**3))))-1/26208.
    coneq[4445]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/78624.
    coneq[4446]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[4447]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/52416.
    coneq[4448]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,c**3))))-1/52416.
    coneq[4449]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/157248.
    coneq[4450]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[4451]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/104832.
    coneq[4452]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**4))))-1/21840.
    coneq[4453]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**3)))))-1/87360.
    coneq[4454]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/262080.
    coneq[4455]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[4456]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/174720.
    coneq[4457]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/65520.
    coneq[4458]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/131040.
    coneq[4459]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/43680.
    coneq[4460]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/87360.
    coneq[4461]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)*dot(A,c**2))))-1/19656.
    coneq[4462]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)*dot(A,dot(A,c)))))-1/39312.
    coneq[4463]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/78624.
    coneq[4464]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c**3))))-1/17472.
    coneq[4465]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,dot(A,c**2)))))-1/52416.
    coneq[4466]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[4467]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c*dot(A,c)))))-1/34944.
    coneq[4468]=dot(b,dot(A,dot(A,c**6*dot(A,c)*dot(A,c**2))))-1/13104.
    coneq[4469]=dot(b,dot(A,dot(A,c**6*dot(A,c)*dot(A,dot(A,c)))))-1/26208.
    coneq[4470]=dot(b,dot(A,dot(A,c**7*dot(A,c)*dot(A,c))))-1/8736.
    coneq[4471]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**6))))-1/61152.
    coneq[4472]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**5)))))-1/366912.
    coneq[4473]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/1834560.
    coneq[4474]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/7338240.
    coneq[4475]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[4476]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[4477]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[4478]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/5503680.
    coneq[4479]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/11007360.
    coneq[4480]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/3669120.
    coneq[4481]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[4482]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/1467648.
    coneq[4483]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/4402944.
    coneq[4484]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/8805888.
    coneq[4485]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2935296.
    coneq[4486]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/1100736.
    coneq[4487]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/2201472.
    coneq[4488]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/733824.
    coneq[4489]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/2201472.
    coneq[4490]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4402944.
    coneq[4491]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1467648.
    coneq[4492]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**4)))))-1/305760.
    coneq[4493]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/1223040.
    coneq[4494]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[4495]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[4496]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[4497]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/917280.
    coneq[4498]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1834560.
    coneq[4499]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/611520.
    coneq[4500]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[4501]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/244608.
    coneq[4502]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/733824.
    coneq[4503]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1467648.
    coneq[4504]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/489216.
    coneq[4505]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/183456.
    coneq[4506]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/366912.
    coneq[4507]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4*dot(A,c)))))-1/122304.
    coneq[4508]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/550368.
    coneq[4509]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1100736.
    coneq[4510]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2201472.
    coneq[4511]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/489216.
    coneq[4512]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1467648.
    coneq[4513]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2935296.
    coneq[4514]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/978432.
    coneq[4515]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/366912.
    coneq[4516]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/733824.
    coneq[4517]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/244608.
    coneq[4518]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/489216.
    coneq[4519]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**5))))-1/78624.
    coneq[4520]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**4)))))-1/393120.
    coneq[4521]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/1572480.
    coneq[4522]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[4523]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[4524]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[4525]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/1179360.
    coneq[4526]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2358720.
    coneq[4527]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/786240.
    coneq[4528]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[4529]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/314496.
    coneq[4530]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/943488.
    coneq[4531]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[4532]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/628992.
    coneq[4533]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/235872.
    coneq[4534]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/471744.
    coneq[4535]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/157248.
    coneq[4536]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/471744.
    coneq[4537]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/943488.
    coneq[4538]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[4539]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**5))))-1/157248.
    coneq[4540]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/786240.
    coneq[4541]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/3144960.
    coneq[4542]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[4543]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[4544]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[4545]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/2358720.
    coneq[4546]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/4717440.
    coneq[4547]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/1572480.
    coneq[4548]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3144960.
    coneq[4549]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/628992.
    coneq[4550]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[4551]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[4552]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[4553]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/471744.
    coneq[4554]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/943488.
    coneq[4555]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/314496.
    coneq[4556]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/943488.
    coneq[4557]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1886976.
    coneq[4558]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/628992.
    coneq[4559]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**4))))-1/98280.
    coneq[4560]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/393120.
    coneq[4561]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/1179360.
    coneq[4562]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2358720.
    coneq[4563]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/786240.
    coneq[4564]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/294840.
    coneq[4565]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/589680.
    coneq[4566]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/196560.
    coneq[4567]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/393120.
    coneq[4568]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**4))))-1/196560.
    coneq[4569]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/786240.
    coneq[4570]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/2358720.
    coneq[4571]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4717440.
    coneq[4572]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/1572480.
    coneq[4573]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/589680.
    coneq[4574]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/1179360.
    coneq[4575]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/393120.
    coneq[4576]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/786240.
    coneq[4577]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**4))))-1/393120.
    coneq[4578]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/1572480.
    coneq[4579]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/4717440.
    coneq[4580]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/9434880.
    coneq[4581]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/3144960.
    coneq[4582]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/1179360.
    coneq[4583]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/2358720.
    coneq[4584]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/786240.
    coneq[4585]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/1572480.
    coneq[4586]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**4))))-1/87360.
    coneq[4587]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**3)))))-1/349440.
    coneq[4588]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/1048320.
    coneq[4589]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[4590]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/698880.
    coneq[4591]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/262080.
    coneq[4592]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/524160.
    coneq[4593]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/174720.
    coneq[4594]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/349440.
    coneq[4595]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**4))))-1/262080.
    coneq[4596]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/1048320.
    coneq[4597]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/3144960.
    coneq[4598]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[4599]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/2096640.
    coneq[4600]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/786240.
    coneq[4601]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/1572480.
    coneq[4602]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/524160.
    coneq[4603]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/1048320.
    coneq[4604]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/524160.
    coneq[4605]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/2096640.
    coneq[4606]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/6289920.
    coneq[4607]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/12579840.
    coneq[4608]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/4193280.
    coneq[4609]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/1572480.
    coneq[4610]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/3144960.
    coneq[4611]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/1048320.
    coneq[4612]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/2096640.
    coneq[4613]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**4))))-1/174720.
    coneq[4614]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/698880.
    coneq[4615]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/2096640.
    coneq[4616]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4193280.
    coneq[4617]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/1397760.
    coneq[4618]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/524160.
    coneq[4619]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/1048320.
    coneq[4620]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/349440.
    coneq[4621]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/698880.
    coneq[4622]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c**3))))-1/104832.
    coneq[4623]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/314496.
    coneq[4624]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[4625]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/209664.
    coneq[4626]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/943488.
    coneq[4627]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/1886976.
    coneq[4628]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/628992.
    coneq[4629]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/3773952.
    coneq[4630]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/1257984.
    coneq[4631]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/419328.
    coneq[4632]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c**3))))-1/209664.
    coneq[4633]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/628992.
    coneq[4634]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[4635]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/419328.
    coneq[4636]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/1886976.
    coneq[4637]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/3773952.
    coneq[4638]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/1257984.
    coneq[4639]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/7547904.
    coneq[4640]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/2515968.
    coneq[4641]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/838656.
    coneq[4642]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**5))))-1/52416.
    coneq[4643]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))))-1/262080.
    coneq[4644]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/1048320.
    coneq[4645]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[4646]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[4647]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[4648]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[4649]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[4650]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[4651]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[4652]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/209664.
    coneq[4653]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/628992.
    coneq[4654]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[4655]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/419328.
    coneq[4656]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/157248.
    coneq[4657]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/314496.
    coneq[4658]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/104832.
    coneq[4659]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[4660]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[4661]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[4662]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**4))))-1/65520.
    coneq[4663]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/262080.
    coneq[4664]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/786240.
    coneq[4665]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[4666]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/524160.
    coneq[4667]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/196560.
    coneq[4668]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/393120.
    coneq[4669]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/131040.
    coneq[4670]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/262080.
    coneq[4671]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))))-1/131040.
    coneq[4672]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/524160.
    coneq[4673]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1572480.
    coneq[4674]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[4675]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/1048320.
    coneq[4676]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/393120.
    coneq[4677]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/786240.
    coneq[4678]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/262080.
    coneq[4679]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/524160.
    coneq[4680]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**3))))-1/78624.
    coneq[4681]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/235872.
    coneq[4682]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[4683]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/157248.
    coneq[4684]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))))-1/157248.
    coneq[4685]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/471744.
    coneq[4686]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/943488.
    coneq[4687]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/314496.
    coneq[4688]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))))-1/314496.
    coneq[4689]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/943488.
    coneq[4690]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1886976.
    coneq[4691]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/628992.
    coneq[4692]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c**3))))-1/69888.
    coneq[4693]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/209664.
    coneq[4694]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[4695]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/139776.
    coneq[4696]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/628992.
    coneq[4697]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[4698]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/419328.
    coneq[4699]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/2515968.
    coneq[4700]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/838656.
    coneq[4701]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/279552.
    coneq[4702]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**4))))-1/43680.
    coneq[4703]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/174720.
    coneq[4704]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[4705]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[4706]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[4707]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[4708]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[4709]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[4710]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[4711]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/52416.
    coneq[4712]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/157248.
    coneq[4713]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[4714]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/104832.
    coneq[4715]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/104832.
    coneq[4716]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/314496.
    coneq[4717]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[4718]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/209664.
    coneq[4719]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/58968.
    coneq[4720]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/117936.
    coneq[4721]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/235872.
    coneq[4722]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/471744.
    coneq[4723]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/34944.
    coneq[4724]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/104832.
    coneq[4725]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[4726]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/69888.
    coneq[4727]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/39312.
    coneq[4728]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/78624.
    coneq[4729]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/157248.
    coneq[4730]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/26208.
    coneq[4731]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/52416.
    coneq[4732]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c)*dot(A,c))))-1/17472.
    coneq[4733]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**4))))-1/87360.
    coneq[4734]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/349440.
    coneq[4735]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/1048320.
    coneq[4736]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[4737]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/698880.
    coneq[4738]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/262080.
    coneq[4739]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/524160.
    coneq[4740]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/174720.
    coneq[4741]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/349440.
    coneq[4742]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/104832.
    coneq[4743]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/314496.
    coneq[4744]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[4745]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/209664.
    coneq[4746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/209664.
    coneq[4747]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/628992.
    coneq[4748]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[4749]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/419328.
    coneq[4750]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/117936.
    coneq[4751]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/235872.
    coneq[4752]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2))))-1/235872.
    coneq[4753]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/471744.
    coneq[4754]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))))-1/471744.
    coneq[4755]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/943488.
    coneq[4756]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/69888.
    coneq[4757]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/209664.
    coneq[4758]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[4759]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/139776.
    coneq[4760]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/78624.
    coneq[4761]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/157248.
    coneq[4762]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))))-1/157248.
    coneq[4763]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/314496.
    coneq[4764]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[4765]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[4766]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/34944.
    coneq[4767]=dot(b,dot(A,c*dot(A,c**10)))-1/2002.
    coneq[4768]=dot(b,dot(A,c*dot(A,dot(A,c**9))))-1/20020.
    coneq[4769]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**8)))))-1/180180.
    coneq[4770]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**7))))))-1/1441440.
    coneq[4771]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**6)))))))-1/10090080.
    coneq[4772]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))))-1/60540480.
    coneq[4773]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))))-1/302702400.
    coneq[4774]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))))-1/1210809600.
    coneq[4775]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))))-1/3632428800.
    coneq[4776]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))))-1/7264857600.
    coneq[4777]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))))-1/2421619200.
    coneq[4778]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))))-1/908107200.
    coneq[4779]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))))-1/1816214400.
    coneq[4780]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))))-1/605404800.
    coneq[4781]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))))-1/1210809600.
    coneq[4782]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))))-1/242161920.
    coneq[4783]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))))-1/726485760.
    coneq[4784]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))))-1/1452971520.
    coneq[4785]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))))-1/484323840.
    coneq[4786]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))))-1/181621440.
    coneq[4787]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))))-1/363242880.
    coneq[4788]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))))-1/121080960.
    coneq[4789]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))))-1/363242880.
    coneq[4790]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))))-1/726485760.
    coneq[4791]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))))-1/242161920.
    coneq[4792]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))))-1/50450400.
    coneq[4793]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))))-1/201801600.
    coneq[4794]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))))-1/605404800.
    coneq[4795]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1210809600.
    coneq[4796]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))))-1/403603200.
    coneq[4797]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))))-1/151351200.
    coneq[4798]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))))-1/302702400.
    coneq[4799]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))))-1/100900800.
    coneq[4800]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))))-1/201801600.
    coneq[4801]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))))-1/40360320.
    coneq[4802]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))))-1/121080960.
    coneq[4803]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))))-1/242161920.
    coneq[4804]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))))-1/80720640.
    coneq[4805]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))))-1/30270240.
    coneq[4806]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))))-1/60540480.
    coneq[4807]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))))-1/20180160.
    coneq[4808]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))))-1/90810720.
    coneq[4809]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))))-1/181621440.
    coneq[4810]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))))-1/363242880.
    coneq[4811]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))))-1/80720640.
    coneq[4812]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))))-1/242161920.
    coneq[4813]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))))-1/484323840.
    coneq[4814]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))))-1/161441280.
    coneq[4815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))))-1/60540480.
    coneq[4816]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))))-1/121080960.
    coneq[4817]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))))-1/40360320.
    coneq[4818]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))))-1/80720640.
    coneq[4819]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5)))))))-1/8648640.
    coneq[4820]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))))-1/43243200.
    coneq[4821]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))))-1/172972800.
    coneq[4822]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/518918400.
    coneq[4823]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1037836800.
    coneq[4824]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/345945600.
    coneq[4825]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))))-1/129729600.
    coneq[4826]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/259459200.
    coneq[4827]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))))-1/86486400.
    coneq[4828]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/172972800.
    coneq[4829]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))))-1/34594560.
    coneq[4830]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))))-1/103783680.
    coneq[4831]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/207567360.
    coneq[4832]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))))-1/69189120.
    coneq[4833]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))))-1/25945920.
    coneq[4834]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))))-1/51891840.
    coneq[4835]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))))-1/17297280.
    coneq[4836]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))))-1/51891840.
    coneq[4837]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/103783680.
    coneq[4838]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))))-1/34594560.
    coneq[4839]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))))-1/7207200.
    coneq[4840]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))))-1/28828800.
    coneq[4841]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))))-1/86486400.
    coneq[4842]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/172972800.
    coneq[4843]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))))-1/57657600.
    coneq[4844]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))))-1/21621600.
    coneq[4845]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))))-1/43243200.
    coneq[4846]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))))-1/14414400.
    coneq[4847]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))))-1/28828800.
    coneq[4848]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))))-1/5765760.
    coneq[4849]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))))-1/17297280.
    coneq[4850]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))))-1/34594560.
    coneq[4851]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))))-1/11531520.
    coneq[4852]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))))-1/4324320.
    coneq[4853]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))))-1/8648640.
    coneq[4854]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c)))))))-1/2882880.
    coneq[4855]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))))-1/17297280.
    coneq[4856]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))))-1/51891840.
    coneq[4857]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))))-1/103783680.
    coneq[4858]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))))-1/34594560.
    coneq[4859]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))))-1/34594560.
    coneq[4860]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))))-1/103783680.
    coneq[4861]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))))-1/207567360.
    coneq[4862]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))))-1/69189120.
    coneq[4863]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))))-1/14414400.
    coneq[4864]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))))-1/57657600.
    coneq[4865]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))))-1/172972800.
    coneq[4866]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/345945600.
    coneq[4867]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))))-1/115315200.
    coneq[4868]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))))-1/43243200.
    coneq[4869]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))))-1/86486400.
    coneq[4870]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))))-1/28828800.
    coneq[4871]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))))-1/57657600.
    coneq[4872]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))))-1/12972960.
    coneq[4873]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))))-1/25945920.
    coneq[4874]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/51891840.
    coneq[4875]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))))-1/11531520.
    coneq[4876]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))))-1/34594560.
    coneq[4877]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/69189120.
    coneq[4878]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))))-1/23063040.
    coneq[4879]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))))-1/8648640.
    coneq[4880]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))))-1/17297280.
    coneq[4881]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))))-1/5765760.
    coneq[4882]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))))-1/17297280.
    coneq[4883]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))))-1/34594560.
    coneq[4884]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))))-1/11531520.
    coneq[4885]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**6))))))-1/1261260.
    coneq[4886]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5)))))))-1/7567560.
    coneq[4887]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))))-1/37837800.
    coneq[4888]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/151351200.
    coneq[4889]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/454053600.
    coneq[4890]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/908107200.
    coneq[4891]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/302702400.
    coneq[4892]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/113513400.
    coneq[4893]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/227026800.
    coneq[4894]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/75675600.
    coneq[4895]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/151351200.
    coneq[4896]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))))-1/30270240.
    coneq[4897]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/90810720.
    coneq[4898]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/181621440.
    coneq[4899]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/60540480.
    coneq[4900]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))))-1/22702680.
    coneq[4901]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/45405360.
    coneq[4902]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))))-1/15135120.
    coneq[4903]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/45405360.
    coneq[4904]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/90810720.
    coneq[4905]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/30270240.
    coneq[4906]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))))-1/6306300.
    coneq[4907]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))))-1/25225200.
    coneq[4908]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/75675600.
    coneq[4909]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/151351200.
    coneq[4910]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/50450400.
    coneq[4911]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))))-1/18918900.
    coneq[4912]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/37837800.
    coneq[4913]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))))-1/12612600.
    coneq[4914]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/25225200.
    coneq[4915]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))))-1/5045040.
    coneq[4916]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))))-1/15135120.
    coneq[4917]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/30270240.
    coneq[4918]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))))-1/10090080.
    coneq[4919]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))))-1/3783780.
    coneq[4920]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))))-1/7567560.
    coneq[4921]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))))-1/2522520.
    coneq[4922]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/11351340.
    coneq[4923]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/22702680.
    coneq[4924]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/45405360.
    coneq[4925]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))))-1/10090080.
    coneq[4926]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/30270240.
    coneq[4927]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/60540480.
    coneq[4928]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/20180160.
    coneq[4929]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/7567560.
    coneq[4930]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/15135120.
    coneq[4931]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/5045040.
    coneq[4932]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/10090080.
    coneq[4933]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**5))))))-1/1081080.
    coneq[4934]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))))-1/5405400.
    coneq[4935]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))))-1/21621600.
    coneq[4936]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/64864800.
    coneq[4937]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/129729600.
    coneq[4938]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/43243200.
    coneq[4939]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))))-1/16216200.
    coneq[4940]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/32432400.
    coneq[4941]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))))-1/10810800.
    coneq[4942]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/21621600.
    coneq[4943]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))))-1/4324320.
    coneq[4944]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))))-1/12972960.
    coneq[4945]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/25945920.
    coneq[4946]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))))-1/8648640.
    coneq[4947]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))))-1/3243240.
    coneq[4948]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))))-1/6486480.
    coneq[4949]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))))-1/2162160.
    coneq[4950]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))))-1/6486480.
    coneq[4951]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/12972960.
    coneq[4952]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))))-1/4324320.
    coneq[4953]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**4))))))-1/900900.
    coneq[4954]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))))-1/3603600.
    coneq[4955]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))))-1/10810800.
    coneq[4956]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/21621600.
    coneq[4957]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))))-1/7207200.
    coneq[4958]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))))-1/2702700.
    coneq[4959]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))))-1/5405400.
    coneq[4960]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))))-1/1801800.
    coneq[4961]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))))-1/3603600.
    coneq[4962]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c**3))))))-1/720720.
    coneq[4963]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))))-1/2162160.
    coneq[4964]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))))-1/4324320.
    coneq[4965]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))))-1/1441440.
    coneq[4966]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5*dot(A,c**2))))))-1/540540.
    coneq[4967]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c)))))))-1/1081080.
    coneq[4968]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**6*dot(A,c))))))-1/360360.
    coneq[4969]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))))-1/2882880.
    coneq[4970]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[4971]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[4972]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[4973]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))))-1/25945920.
    coneq[4974]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))))-1/51891840.
    coneq[4975]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))))-1/17297280.
    coneq[4976]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))))-1/103783680.
    coneq[4977]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))))-1/34594560.
    coneq[4978]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))))-1/11531520.
    coneq[4979]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))))-1/2702700.
    coneq[4980]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))))-1/10810800.
    coneq[4981]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))))-1/32432400.
    coneq[4982]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/64864800.
    coneq[4983]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))))-1/21621600.
    coneq[4984]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))))-1/8108100.
    coneq[4985]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))))-1/16216200.
    coneq[4986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))))-1/5405400.
    coneq[4987]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))))-1/10810800.
    coneq[4988]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))))-1/5405400.
    coneq[4989]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))))-1/21621600.
    coneq[4990]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))))-1/64864800.
    coneq[4991]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/129729600.
    coneq[4992]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))))-1/43243200.
    coneq[4993]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))))-1/16216200.
    coneq[4994]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))))-1/32432400.
    coneq[4995]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))))-1/10810800.
    coneq[4996]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))))-1/21621600.
    coneq[4997]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5))))))-1/2162160.
    coneq[4998]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))))-1/10810800.
    coneq[4999]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))))-1/43243200.
    coneq[5000]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/129729600.
    coneq[5001]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/259459200.
    coneq[5002]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/86486400.
    coneq[5003]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))))-1/32432400.
    coneq[5004]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/64864800.
    coneq[5005]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))))-1/21621600.
    coneq[5006]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/43243200.
    coneq[5007]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))))-1/8648640.
    coneq[5008]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))))-1/25945920.
    coneq[5009]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/51891840.
    coneq[5010]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))))-1/17297280.
    coneq[5011]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))))-1/6486480.
    coneq[5012]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))))-1/12972960.
    coneq[5013]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))))-1/4324320.
    coneq[5014]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))))-1/12972960.
    coneq[5015]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/25945920.
    coneq[5016]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))))-1/8648640.
    coneq[5017]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))))-1/2162160.
    coneq[5018]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/6486480.
    coneq[5019]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/12972960.
    coneq[5020]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/4324320.
    coneq[5021]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))))-1/4324320.
    coneq[5022]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/12972960.
    coneq[5023]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/25945920.
    coneq[5024]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/8648640.
    coneq[5025]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))))-1/1801800.
    coneq[5026]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))))-1/7207200.
    coneq[5027]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/21621600.
    coneq[5028]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/43243200.
    coneq[5029]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/14414400.
    coneq[5030]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/5405400.
    coneq[5031]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/10810800.
    coneq[5032]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3603600.
    coneq[5033]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/7207200.
    coneq[5034]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))))-1/1621620.
    coneq[5035]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))))-1/3243240.
    coneq[5036]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/6486480.
    coneq[5037]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))))-1/1441440.
    coneq[5038]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))))-1/4324320.
    coneq[5039]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/8648640.
    coneq[5040]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2882880.
    coneq[5041]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))))-1/1081080.
    coneq[5042]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))))-1/2162160.
    coneq[5043]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))))-1/720720.
    coneq[5044]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))))-1/2882880.
    coneq[5045]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[5046]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[5047]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[5048]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))))-1/3243240.
    coneq[5049]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))))-1/6486480.
    coneq[5050]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/12972960.
    coneq[5051]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/2162160.
    coneq[5052]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/4324320.
    coneq[5053]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1441440.
    coneq[5054]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))))-1/2882880.
    coneq[5055]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**7)))))-1/160160.
    coneq[5056]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**6))))))-1/1121120.
    coneq[5057]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5)))))))-1/6726720.
    coneq[5058]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/33633600.
    coneq[5059]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/134534400.
    coneq[5060]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/403603200.
    coneq[5061]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/807206400.
    coneq[5062]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/269068800.
    coneq[5063]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/100900800.
    coneq[5064]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/201801600.
    coneq[5065]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/67267200.
    coneq[5066]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/134534400.
    coneq[5067]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/26906880.
    coneq[5068]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/80720640.
    coneq[5069]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/161441280.
    coneq[5070]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/53813760.
    coneq[5071]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/20180160.
    coneq[5072]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/40360320.
    coneq[5073]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/13453440.
    coneq[5074]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/40360320.
    coneq[5075]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/80720640.
    coneq[5076]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/26906880.
    coneq[5077]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))))-1/5605600.
    coneq[5078]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/22422400.
    coneq[5079]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/67267200.
    coneq[5080]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/134534400.
    coneq[5081]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/44844800.
    coneq[5082]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/16816800.
    coneq[5083]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/33633600.
    coneq[5084]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/11211200.
    coneq[5085]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/22422400.
    coneq[5086]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))))-1/4484480.
    coneq[5087]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/13453440.
    coneq[5088]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/26906880.
    coneq[5089]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/8968960.
    coneq[5090]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))))-1/3363360.
    coneq[5091]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/6726720.
    coneq[5092]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))))-1/2242240.
    coneq[5093]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/10090080.
    coneq[5094]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/20180160.
    coneq[5095]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/40360320.
    coneq[5096]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/8968960.
    coneq[5097]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/26906880.
    coneq[5098]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/53813760.
    coneq[5099]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/17937920.
    coneq[5100]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/6726720.
    coneq[5101]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/13453440.
    coneq[5102]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/4484480.
    coneq[5103]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/8968960.
    coneq[5104]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**5))))))-1/960960.
    coneq[5105]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))))-1/4804800.
    coneq[5106]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/19219200.
    coneq[5107]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/57657600.
    coneq[5108]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/115315200.
    coneq[5109]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/38438400.
    coneq[5110]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/14414400.
    coneq[5111]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/28828800.
    coneq[5112]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/9609600.
    coneq[5113]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/19219200.
    coneq[5114]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))))-1/3843840.
    coneq[5115]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/11531520.
    coneq[5116]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/23063040.
    coneq[5117]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/7687680.
    coneq[5118]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2882880.
    coneq[5119]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/5765760.
    coneq[5120]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1921920.
    coneq[5121]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/5765760.
    coneq[5122]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/11531520.
    coneq[5123]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/3843840.
    coneq[5124]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**4))))))-1/800800.
    coneq[5125]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))))-1/3203200.
    coneq[5126]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/9609600.
    coneq[5127]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/19219200.
    coneq[5128]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/6406400.
    coneq[5129]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/2402400.
    coneq[5130]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/4804800.
    coneq[5131]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1601600.
    coneq[5132]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/3203200.
    coneq[5133]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c**3))))))-1/640640.
    coneq[5134]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1921920.
    coneq[5135]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/3843840.
    coneq[5136]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1281280.
    coneq[5137]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4*dot(A,c**2))))))-1/480480.
    coneq[5138]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))))-1/960960.
    coneq[5139]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**5*dot(A,c))))))-1/320320.
    coneq[5140]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1921920.
    coneq[5141]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/5765760.
    coneq[5142]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/11531520.
    coneq[5143]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/3843840.
    coneq[5144]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/3843840.
    coneq[5145]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/11531520.
    coneq[5146]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/23063040.
    coneq[5147]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/7687680.
    coneq[5148]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))))-1/1601600.
    coneq[5149]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/6406400.
    coneq[5150]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/19219200.
    coneq[5151]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/38438400.
    coneq[5152]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/12812800.
    coneq[5153]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/4804800.
    coneq[5154]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/9609600.
    coneq[5155]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/3203200.
    coneq[5156]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/6406400.
    coneq[5157]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1441440.
    coneq[5158]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2882880.
    coneq[5159]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5765760.
    coneq[5160]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1281280.
    coneq[5161]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/3843840.
    coneq[5162]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/7687680.
    coneq[5163]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2562560.
    coneq[5164]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/960960.
    coneq[5165]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1921920.
    coneq[5166]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))))-1/640640.
    coneq[5167]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1921920.
    coneq[5168]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/3843840.
    coneq[5169]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1281280.
    coneq[5170]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**6)))))-1/140140.
    coneq[5171]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**5))))))-1/840840.
    coneq[5172]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))))-1/4204200.
    coneq[5173]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/16816800.
    coneq[5174]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/50450400.
    coneq[5175]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/100900800.
    coneq[5176]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/33633600.
    coneq[5177]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/12612600.
    coneq[5178]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/25225200.
    coneq[5179]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/8408400.
    coneq[5180]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/16816800.
    coneq[5181]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))))-1/3363360.
    coneq[5182]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/10090080.
    coneq[5183]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/20180160.
    coneq[5184]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/6726720.
    coneq[5185]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2522520.
    coneq[5186]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/5045040.
    coneq[5187]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))))-1/1681680.
    coneq[5188]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/5045040.
    coneq[5189]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/10090080.
    coneq[5190]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/3363360.
    coneq[5191]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**4))))))-1/700700.
    coneq[5192]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))))-1/2802800.
    coneq[5193]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/8408400.
    coneq[5194]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/16816800.
    coneq[5195]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/5605600.
    coneq[5196]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2102100.
    coneq[5197]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/4204200.
    coneq[5198]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1401400.
    coneq[5199]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2802800.
    coneq[5200]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3))))))-1/560560.
    coneq[5201]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1681680.
    coneq[5202]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/3363360.
    coneq[5203]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1121120.
    coneq[5204]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2))))))-1/420420.
    coneq[5205]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))))-1/840840.
    coneq[5206]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4*dot(A,c))))))-1/280280.
    coneq[5207]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1261260.
    coneq[5208]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2522520.
    coneq[5209]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5045040.
    coneq[5210]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))))-1/1121120.
    coneq[5211]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/3363360.
    coneq[5212]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/6726720.
    coneq[5213]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2242240.
    coneq[5214]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/840840.
    coneq[5215]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1681680.
    coneq[5216]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/560560.
    coneq[5217]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1121120.
    coneq[5218]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**5)))))-1/120120.
    coneq[5219]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**4))))))-1/600600.
    coneq[5220]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))))-1/2402400.
    coneq[5221]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/7207200.
    coneq[5222]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14414400.
    coneq[5223]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4804800.
    coneq[5224]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))))-1/1801800.
    coneq[5225]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3603600.
    coneq[5226]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))))-1/1201200.
    coneq[5227]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2402400.
    coneq[5228]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c**3))))))-1/480480.
    coneq[5229]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))))-1/1441440.
    coneq[5230]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2882880.
    coneq[5231]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))))-1/960960.
    coneq[5232]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2))))))-1/360360.
    coneq[5233]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))))-1/720720.
    coneq[5234]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3*dot(A,c))))))-1/240240.
    coneq[5235]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))))-1/720720.
    coneq[5236]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1441440.
    coneq[5237]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))))-1/480480.
    coneq[5238]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**4)))))-1/100100.
    coneq[5239]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c**3))))))-1/400400.
    coneq[5240]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))))-1/1201200.
    coneq[5241]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2402400.
    coneq[5242]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))))-1/800800.
    coneq[5243]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c*dot(A,c**2))))))-1/300300.
    coneq[5244]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))))-1/600600.
    coneq[5245]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2*dot(A,c))))))-1/200200.
    coneq[5246]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))))-1/400400.
    coneq[5247]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c**3)))))-1/80080.
    coneq[5248]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,dot(A,c**2))))))-1/240240.
    coneq[5249]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c)))))))-1/480480.
    coneq[5250]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c*dot(A,c))))))-1/160160.
    coneq[5251]=dot(b,dot(A,c*dot(A,dot(A,c**6*dot(A,c**2)))))-1/60060.
    coneq[5252]=dot(b,dot(A,c*dot(A,dot(A,c**6*dot(A,dot(A,c))))))-1/120120.
    coneq[5253]=dot(b,dot(A,c*dot(A,dot(A,c**7*dot(A,c)))))-1/40040.
    coneq[5254]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c**4)))))-1/400400.
    coneq[5255]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))))-1/1601600.
    coneq[5256]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))))-1/4804800.
    coneq[5257]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/9609600.
    coneq[5258]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))))-1/3203200.
    coneq[5259]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))))-1/1201200.
    coneq[5260]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))))-1/2402400.
    coneq[5261]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))))-1/800800.
    coneq[5262]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))))-1/1601600.
    coneq[5263]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))))-1/1201200.
    coneq[5264]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))))-1/4804800.
    coneq[5265]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))))-1/14414400.
    coneq[5266]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/28828800.
    coneq[5267]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))))-1/9609600.
    coneq[5268]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))))-1/3603600.
    coneq[5269]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))))-1/7207200.
    coneq[5270]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))))-1/2402400.
    coneq[5271]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))))-1/4804800.
    coneq[5272]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))))-1/2402400.
    coneq[5273]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))))-1/9609600.
    coneq[5274]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))))-1/28828800.
    coneq[5275]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/57657600.
    coneq[5276]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))))-1/19219200.
    coneq[5277]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))))-1/7207200.
    coneq[5278]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))))-1/14414400.
    coneq[5279]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))))-1/4804800.
    coneq[5280]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))))-1/9609600.
    coneq[5281]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))))-1/800800.
    coneq[5282]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))))-1/3203200.
    coneq[5283]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/9609600.
    coneq[5284]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/19219200.
    coneq[5285]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/6406400.
    coneq[5286]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))))-1/2402400.
    coneq[5287]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/4804800.
    coneq[5288]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1601600.
    coneq[5289]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/3203200.
    coneq[5290]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**5)))))-1/360360.
    coneq[5291]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))))-1/1801800.
    coneq[5292]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))))-1/7207200.
    coneq[5293]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/21621600.
    coneq[5294]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/43243200.
    coneq[5295]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/14414400.
    coneq[5296]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))))-1/5405400.
    coneq[5297]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/10810800.
    coneq[5298]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))))-1/3603600.
    coneq[5299]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/7207200.
    coneq[5300]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))))-1/1441440.
    coneq[5301]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))))-1/4324320.
    coneq[5302]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/8648640.
    coneq[5303]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))))-1/2882880.
    coneq[5304]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))))-1/1081080.
    coneq[5305]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))))-1/2162160.
    coneq[5306]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))))-1/720720.
    coneq[5307]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))))-1/2162160.
    coneq[5308]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4324320.
    coneq[5309]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1441440.
    coneq[5310]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5)))))-1/720720.
    coneq[5311]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))))-1/3603600.
    coneq[5312]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))))-1/14414400.
    coneq[5313]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/43243200.
    coneq[5314]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/86486400.
    coneq[5315]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/28828800.
    coneq[5316]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))))-1/10810800.
    coneq[5317]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/21621600.
    coneq[5318]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))))-1/7207200.
    coneq[5319]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/14414400.
    coneq[5320]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))))-1/2882880.
    coneq[5321]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[5322]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[5323]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[5324]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))))-1/2162160.
    coneq[5325]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))))-1/4324320.
    coneq[5326]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))))-1/1441440.
    coneq[5327]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))))-1/4324320.
    coneq[5328]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/8648640.
    coneq[5329]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))))-1/2882880.
    coneq[5330]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**6)))))-1/280280.
    coneq[5331]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5))))))-1/1681680.
    coneq[5332]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))))-1/8408400.
    coneq[5333]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/33633600.
    coneq[5334]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/100900800.
    coneq[5335]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/201801600.
    coneq[5336]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/67267200.
    coneq[5337]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/25225200.
    coneq[5338]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/50450400.
    coneq[5339]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/16816800.
    coneq[5340]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/33633600.
    coneq[5341]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))))-1/6726720.
    coneq[5342]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/20180160.
    coneq[5343]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/40360320.
    coneq[5344]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/13453440.
    coneq[5345]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/5045040.
    coneq[5346]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/10090080.
    coneq[5347]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))))-1/3363360.
    coneq[5348]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/10090080.
    coneq[5349]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/20180160.
    coneq[5350]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/6726720.
    coneq[5351]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))))-1/1401400.
    coneq[5352]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))))-1/5605600.
    coneq[5353]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/16816800.
    coneq[5354]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/33633600.
    coneq[5355]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/11211200.
    coneq[5356]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/4204200.
    coneq[5357]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/8408400.
    coneq[5358]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2802800.
    coneq[5359]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/5605600.
    coneq[5360]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))))-1/1121120.
    coneq[5361]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/3363360.
    coneq[5362]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/6726720.
    coneq[5363]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/2242240.
    coneq[5364]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))))-1/840840.
    coneq[5365]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))))-1/1681680.
    coneq[5366]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))))-1/560560.
    coneq[5367]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2522520.
    coneq[5368]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/5045040.
    coneq[5369]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/10090080.
    coneq[5370]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))))-1/2242240.
    coneq[5371]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/6726720.
    coneq[5372]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/13453440.
    coneq[5373]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/4484480.
    coneq[5374]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1681680.
    coneq[5375]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/3363360.
    coneq[5376]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/1121120.
    coneq[5377]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/2242240.
    coneq[5378]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3)))))-1/320320.
    coneq[5379]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))))-1/960960.
    coneq[5380]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1921920.
    coneq[5381]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))))-1/640640.
    coneq[5382]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2882880.
    coneq[5383]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/5765760.
    coneq[5384]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1921920.
    coneq[5385]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/11531520.
    coneq[5386]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/3843840.
    coneq[5387]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1281280.
    coneq[5388]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4)))))-1/300300.
    coneq[5389]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1201200.
    coneq[5390]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/3603600.
    coneq[5391]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7207200.
    coneq[5392]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/2402400.
    coneq[5393]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/900900.
    coneq[5394]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1801800.
    coneq[5395]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/600600.
    coneq[5396]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1201200.
    coneq[5397]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))))-1/600600.
    coneq[5398]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/2402400.
    coneq[5399]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/7207200.
    coneq[5400]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/14414400.
    coneq[5401]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/4804800.
    coneq[5402]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1801800.
    coneq[5403]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/3603600.
    coneq[5404]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1201200.
    coneq[5405]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2402400.
    coneq[5406]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**5)))))-1/240240.
    coneq[5407]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))))-1/1201200.
    coneq[5408]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/4804800.
    coneq[5409]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/14414400.
    coneq[5410]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/28828800.
    coneq[5411]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/9609600.
    coneq[5412]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/3603600.
    coneq[5413]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7207200.
    coneq[5414]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/2402400.
    coneq[5415]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4804800.
    coneq[5416]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))))-1/960960.
    coneq[5417]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[5418]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[5419]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[5420]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/720720.
    coneq[5421]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1441440.
    coneq[5422]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))))-1/480480.
    coneq[5423]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1441440.
    coneq[5424]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2882880.
    coneq[5425]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/960960.
    coneq[5426]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3)))))-1/240240.
    coneq[5427]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/720720.
    coneq[5428]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1441440.
    coneq[5429]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/480480.
    coneq[5430]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))))-1/480480.
    coneq[5431]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1441440.
    coneq[5432]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2882880.
    coneq[5433]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/960960.
    coneq[5434]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4)))))-1/200200.
    coneq[5435]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))))-1/800800.
    coneq[5436]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2402400.
    coneq[5437]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4804800.
    coneq[5438]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1601600.
    coneq[5439]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/600600.
    coneq[5440]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1201200.
    coneq[5441]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/400400.
    coneq[5442]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/800800.
    coneq[5443]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2)))))-1/180180.
    coneq[5444]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))))-1/360360.
    coneq[5445]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/720720.
    coneq[5446]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3)))))-1/160160.
    coneq[5447]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))))-1/480480.
    coneq[5448]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/960960.
    coneq[5449]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))))-1/320320.
    coneq[5450]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2)))))-1/120120.
    coneq[5451]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))))-1/240240.
    coneq[5452]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c)*dot(A,c)))))-1/80080.
    coneq[5453]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))))-1/400400.
    coneq[5454]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))))-1/1601600.
    coneq[5455]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/4804800.
    coneq[5456]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/9609600.
    coneq[5457]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/3203200.
    coneq[5458]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1201200.
    coneq[5459]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2402400.
    coneq[5460]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/800800.
    coneq[5461]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1601600.
    coneq[5462]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))))-1/480480.
    coneq[5463]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1441440.
    coneq[5464]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2882880.
    coneq[5465]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/960960.
    coneq[5466]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))))-1/960960.
    coneq[5467]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2882880.
    coneq[5468]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/5765760.
    coneq[5469]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1921920.
    coneq[5470]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))))-1/540540.
    coneq[5471]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))))-1/1081080.
    coneq[5472]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2162160.
    coneq[5473]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/4324320.
    coneq[5474]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/320320.
    coneq[5475]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/960960.
    coneq[5476]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1921920.
    coneq[5477]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/640640.
    coneq[5478]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/360360.
    coneq[5479]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/720720.
    coneq[5480]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1441440.
    coneq[5481]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/240240.
    coneq[5482]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/480480.
    coneq[5483]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))))-1/160160.
    coneq[5484]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/480480.
    coneq[5485]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/960960.
    coneq[5486]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/320320.
    coneq[5487]=dot(b,dot(A,c*dot(A,c*dot(A,c**8))))-1/18018.
    coneq[5488]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**7)))))-1/144144.
    coneq[5489]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**6))))))-1/1009008.
    coneq[5490]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/6054048.
    coneq[5491]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/30270240.
    coneq[5492]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/121080960.
    coneq[5493]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/363242880.
    coneq[5494]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/726485760.
    coneq[5495]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/242161920.
    coneq[5496]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/90810720.
    coneq[5497]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/181621440.
    coneq[5498]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/60540480.
    coneq[5499]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/121080960.
    coneq[5500]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/24216192.
    coneq[5501]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/72648576.
    coneq[5502]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/145297152.
    coneq[5503]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/48432384.
    coneq[5504]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/18162144.
    coneq[5505]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/36324288.
    coneq[5506]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/12108096.
    coneq[5507]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/36324288.
    coneq[5508]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/72648576.
    coneq[5509]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/24216192.
    coneq[5510]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/5045040.
    coneq[5511]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/20180160.
    coneq[5512]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/60540480.
    coneq[5513]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/121080960.
    coneq[5514]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/40360320.
    coneq[5515]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/15135120.
    coneq[5516]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/30270240.
    coneq[5517]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/10090080.
    coneq[5518]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/20180160.
    coneq[5519]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/4036032.
    coneq[5520]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/12108096.
    coneq[5521]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/24216192.
    coneq[5522]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/8072064.
    coneq[5523]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/3027024.
    coneq[5524]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/6054048.
    coneq[5525]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/2018016.
    coneq[5526]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/9081072.
    coneq[5527]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/18162144.
    coneq[5528]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/36324288.
    coneq[5529]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/8072064.
    coneq[5530]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/24216192.
    coneq[5531]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/48432384.
    coneq[5532]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/16144128.
    coneq[5533]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/6054048.
    coneq[5534]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/12108096.
    coneq[5535]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/4036032.
    coneq[5536]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/8072064.
    coneq[5537]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**5))))))-1/864864.
    coneq[5538]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/4324320.
    coneq[5539]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/17297280.
    coneq[5540]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/51891840.
    coneq[5541]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/103783680.
    coneq[5542]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/34594560.
    coneq[5543]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/12972960.
    coneq[5544]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/25945920.
    coneq[5545]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/8648640.
    coneq[5546]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/17297280.
    coneq[5547]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/3459456.
    coneq[5548]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/10378368.
    coneq[5549]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/20756736.
    coneq[5550]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/6918912.
    coneq[5551]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2594592.
    coneq[5552]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/5189184.
    coneq[5553]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1729728.
    coneq[5554]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/5189184.
    coneq[5555]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/10378368.
    coneq[5556]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/3459456.
    coneq[5557]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**4))))))-1/720720.
    coneq[5558]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/2882880.
    coneq[5559]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/8648640.
    coneq[5560]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/17297280.
    coneq[5561]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/5765760.
    coneq[5562]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/2162160.
    coneq[5563]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/4324320.
    coneq[5564]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1441440.
    coneq[5565]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/2882880.
    coneq[5566]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c**3))))))-1/576576.
    coneq[5567]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1729728.
    coneq[5568]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/3459456.
    coneq[5569]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1153152.
    coneq[5570]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4*dot(A,c**2))))))-1/432432.
    coneq[5571]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/864864.
    coneq[5572]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**5*dot(A,c))))))-1/288288.
    coneq[5573]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1729728.
    coneq[5574]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/5189184.
    coneq[5575]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/10378368.
    coneq[5576]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/3459456.
    coneq[5577]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/3459456.
    coneq[5578]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/10378368.
    coneq[5579]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/20756736.
    coneq[5580]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/6918912.
    coneq[5581]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/1441440.
    coneq[5582]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/5765760.
    coneq[5583]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/17297280.
    coneq[5584]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/34594560.
    coneq[5585]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/11531520.
    coneq[5586]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/4324320.
    coneq[5587]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/8648640.
    coneq[5588]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/2882880.
    coneq[5589]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/5765760.
    coneq[5590]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1297296.
    coneq[5591]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2594592.
    coneq[5592]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/5189184.
    coneq[5593]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1153152.
    coneq[5594]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/3459456.
    coneq[5595]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/6918912.
    coneq[5596]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2306304.
    coneq[5597]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/864864.
    coneq[5598]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1729728.
    coneq[5599]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/576576.
    coneq[5600]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1729728.
    coneq[5601]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/3459456.
    coneq[5602]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1153152.
    coneq[5603]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**6)))))-1/126126.
    coneq[5604]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**5))))))-1/756756.
    coneq[5605]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/3783780.
    coneq[5606]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/15135120.
    coneq[5607]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/45405360.
    coneq[5608]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/90810720.
    coneq[5609]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/30270240.
    coneq[5610]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/11351340.
    coneq[5611]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/22702680.
    coneq[5612]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/7567560.
    coneq[5613]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/15135120.
    coneq[5614]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/3027024.
    coneq[5615]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/9081072.
    coneq[5616]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/18162144.
    coneq[5617]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/6054048.
    coneq[5618]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2270268.
    coneq[5619]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/4540536.
    coneq[5620]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/1513512.
    coneq[5621]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/4540536.
    coneq[5622]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/9081072.
    coneq[5623]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/3027024.
    coneq[5624]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**4))))))-1/630630.
    coneq[5625]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/2522520.
    coneq[5626]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/7567560.
    coneq[5627]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/15135120.
    coneq[5628]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/5045040.
    coneq[5629]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1891890.
    coneq[5630]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3783780.
    coneq[5631]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1261260.
    coneq[5632]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2522520.
    coneq[5633]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/504504.
    coneq[5634]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1513512.
    coneq[5635]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/3027024.
    coneq[5636]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1009008.
    coneq[5637]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/378378.
    coneq[5638]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/756756.
    coneq[5639]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4*dot(A,c))))))-1/252252.
    coneq[5640]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1135134.
    coneq[5641]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2270268.
    coneq[5642]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4540536.
    coneq[5643]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/1009008.
    coneq[5644]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/3027024.
    coneq[5645]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/6054048.
    coneq[5646]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2018016.
    coneq[5647]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/756756.
    coneq[5648]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1513512.
    coneq[5649]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/504504.
    coneq[5650]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1009008.
    coneq[5651]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**5)))))-1/108108.
    coneq[5652]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**4))))))-1/540540.
    coneq[5653]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/2162160.
    coneq[5654]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/6486480.
    coneq[5655]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/12972960.
    coneq[5656]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4324320.
    coneq[5657]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/1621620.
    coneq[5658]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3243240.
    coneq[5659]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/1081080.
    coneq[5660]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2162160.
    coneq[5661]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/432432.
    coneq[5662]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/1297296.
    coneq[5663]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2594592.
    coneq[5664]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/864864.
    coneq[5665]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/324324.
    coneq[5666]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/648648.
    coneq[5667]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/216216.
    coneq[5668]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/648648.
    coneq[5669]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1297296.
    coneq[5670]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/432432.
    coneq[5671]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**4)))))-1/90090.
    coneq[5672]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c**3))))))-1/360360.
    coneq[5673]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/1081080.
    coneq[5674]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2162160.
    coneq[5675]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/720720.
    coneq[5676]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/270270.
    coneq[5677]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/540540.
    coneq[5678]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/180180.
    coneq[5679]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/360360.
    coneq[5680]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c**3)))))-1/72072.
    coneq[5681]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,dot(A,c**2))))))-1/216216.
    coneq[5682]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/432432.
    coneq[5683]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c*dot(A,c))))))-1/144144.
    coneq[5684]=dot(b,dot(A,c*dot(A,c*dot(A,c**5*dot(A,c**2)))))-1/54054.
    coneq[5685]=dot(b,dot(A,c*dot(A,c*dot(A,c**5*dot(A,dot(A,c))))))-1/108108.
    coneq[5686]=dot(b,dot(A,c*dot(A,c*dot(A,c**6*dot(A,c)))))-1/36036.
    coneq[5687]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3)))))-1/288288.
    coneq[5688]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/864864.
    coneq[5689]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1729728.
    coneq[5690]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/576576.
    coneq[5691]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2594592.
    coneq[5692]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/5189184.
    coneq[5693]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1729728.
    coneq[5694]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/10378368.
    coneq[5695]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/3459456.
    coneq[5696]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1153152.
    coneq[5697]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4)))))-1/270270.
    coneq[5698]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1081080.
    coneq[5699]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/3243240.
    coneq[5700]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6486480.
    coneq[5701]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/2162160.
    coneq[5702]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/810810.
    coneq[5703]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1621620.
    coneq[5704]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/540540.
    coneq[5705]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1081080.
    coneq[5706]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/540540.
    coneq[5707]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/2162160.
    coneq[5708]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/6486480.
    coneq[5709]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/12972960.
    coneq[5710]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/4324320.
    coneq[5711]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1621620.
    coneq[5712]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/3243240.
    coneq[5713]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1081080.
    coneq[5714]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/2162160.
    coneq[5715]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**5)))))-1/216216.
    coneq[5716]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/1081080.
    coneq[5717]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/4324320.
    coneq[5718]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/12972960.
    coneq[5719]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/25945920.
    coneq[5720]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/8648640.
    coneq[5721]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/3243240.
    coneq[5722]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/6486480.
    coneq[5723]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/2162160.
    coneq[5724]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4324320.
    coneq[5725]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/864864.
    coneq[5726]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2594592.
    coneq[5727]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5189184.
    coneq[5728]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1729728.
    coneq[5729]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/648648.
    coneq[5730]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1297296.
    coneq[5731]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/432432.
    coneq[5732]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1297296.
    coneq[5733]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2594592.
    coneq[5734]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/864864.
    coneq[5735]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/216216.
    coneq[5736]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/648648.
    coneq[5737]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1297296.
    coneq[5738]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/432432.
    coneq[5739]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/432432.
    coneq[5740]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1297296.
    coneq[5741]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2594592.
    coneq[5742]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/864864.
    coneq[5743]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4)))))-1/180180.
    coneq[5744]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/720720.
    coneq[5745]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/2162160.
    coneq[5746]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4324320.
    coneq[5747]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1441440.
    coneq[5748]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/540540.
    coneq[5749]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1081080.
    coneq[5750]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/360360.
    coneq[5751]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/720720.
    coneq[5752]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/162162.
    coneq[5753]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/324324.
    coneq[5754]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/648648.
    coneq[5755]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/144144.
    coneq[5756]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/432432.
    coneq[5757]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/864864.
    coneq[5758]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/288288.
    coneq[5759]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/108108.
    coneq[5760]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/216216.
    coneq[5761]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c)))))-1/72072.
    coneq[5762]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/288288.
    coneq[5763]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/864864.
    coneq[5764]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1729728.
    coneq[5765]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/576576.
    coneq[5766]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/324324.
    coneq[5767]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/648648.
    coneq[5768]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1297296.
    coneq[5769]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/216216.
    coneq[5770]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/432432.
    coneq[5771]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/144144.
    coneq[5772]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/288288.
    coneq[5773]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**7))))-1/16016.
    coneq[5774]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**6)))))-1/112112.
    coneq[5775]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**5))))))-1/672672.
    coneq[5776]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/3363360.
    coneq[5777]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/13453440.
    coneq[5778]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/40360320.
    coneq[5779]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/80720640.
    coneq[5780]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/26906880.
    coneq[5781]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/10090080.
    coneq[5782]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/20180160.
    coneq[5783]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/6726720.
    coneq[5784]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/13453440.
    coneq[5785]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/2690688.
    coneq[5786]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/8072064.
    coneq[5787]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/16144128.
    coneq[5788]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/5381376.
    coneq[5789]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2018016.
    coneq[5790]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/4036032.
    coneq[5791]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1345344.
    coneq[5792]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/4036032.
    coneq[5793]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/8072064.
    coneq[5794]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2690688.
    coneq[5795]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**4))))))-1/560560.
    coneq[5796]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/2242240.
    coneq[5797]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/6726720.
    coneq[5798]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/13453440.
    coneq[5799]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/4484480.
    coneq[5800]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1681680.
    coneq[5801]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3363360.
    coneq[5802]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1121120.
    coneq[5803]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2242240.
    coneq[5804]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3))))))-1/448448.
    coneq[5805]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1345344.
    coneq[5806]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2690688.
    coneq[5807]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/896896.
    coneq[5808]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2))))))-1/336336.
    coneq[5809]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/672672.
    coneq[5810]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4*dot(A,c))))))-1/224224.
    coneq[5811]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1009008.
    coneq[5812]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2018016.
    coneq[5813]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4036032.
    coneq[5814]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/896896.
    coneq[5815]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2690688.
    coneq[5816]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5381376.
    coneq[5817]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1793792.
    coneq[5818]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/672672.
    coneq[5819]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1345344.
    coneq[5820]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/448448.
    coneq[5821]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/896896.
    coneq[5822]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**5)))))-1/96096.
    coneq[5823]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**4))))))-1/480480.
    coneq[5824]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1921920.
    coneq[5825]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5765760.
    coneq[5826]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11531520.
    coneq[5827]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3843840.
    coneq[5828]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1441440.
    coneq[5829]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2882880.
    coneq[5830]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/960960.
    coneq[5831]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1921920.
    coneq[5832]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3))))))-1/384384.
    coneq[5833]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/1153152.
    coneq[5834]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2306304.
    coneq[5835]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/768768.
    coneq[5836]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/288288.
    coneq[5837]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/576576.
    coneq[5838]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c))))))-1/192192.
    coneq[5839]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/576576.
    coneq[5840]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1153152.
    coneq[5841]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/384384.
    coneq[5842]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**4)))))-1/80080.
    coneq[5843]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3))))))-1/320320.
    coneq[5844]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/960960.
    coneq[5845]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1921920.
    coneq[5846]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/640640.
    coneq[5847]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/240240.
    coneq[5848]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/480480.
    coneq[5849]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/160160.
    coneq[5850]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/320320.
    coneq[5851]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c**3)))))-1/64064.
    coneq[5852]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2))))))-1/192192.
    coneq[5853]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/384384.
    coneq[5854]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c))))))-1/128128.
    coneq[5855]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4*dot(A,c**2)))))-1/48048.
    coneq[5856]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4*dot(A,dot(A,c))))))-1/96096.
    coneq[5857]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**5*dot(A,c)))))-1/32032.
    coneq[5858]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/192192.
    coneq[5859]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/576576.
    coneq[5860]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1153152.
    coneq[5861]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/384384.
    coneq[5862]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/384384.
    coneq[5863]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1153152.
    coneq[5864]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2306304.
    coneq[5865]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/768768.
    coneq[5866]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4)))))-1/160160.
    coneq[5867]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/640640.
    coneq[5868]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1921920.
    coneq[5869]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3843840.
    coneq[5870]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1281280.
    coneq[5871]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/480480.
    coneq[5872]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/960960.
    coneq[5873]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/320320.
    coneq[5874]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/640640.
    coneq[5875]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/144144.
    coneq[5876]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/288288.
    coneq[5877]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/576576.
    coneq[5878]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/128128.
    coneq[5879]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/384384.
    coneq[5880]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/768768.
    coneq[5881]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/256256.
    coneq[5882]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/96096.
    coneq[5883]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/192192.
    coneq[5884]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/64064.
    coneq[5885]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/192192.
    coneq[5886]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/384384.
    coneq[5887]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/128128.
    coneq[5888]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**6))))-1/14014.
    coneq[5889]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**5)))))-1/84084.
    coneq[5890]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**4))))))-1/420420.
    coneq[5891]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1681680.
    coneq[5892]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5045040.
    coneq[5893]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/10090080.
    coneq[5894]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3363360.
    coneq[5895]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1261260.
    coneq[5896]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2522520.
    coneq[5897]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/840840.
    coneq[5898]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1681680.
    coneq[5899]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c**3))))))-1/336336.
    coneq[5900]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1009008.
    coneq[5901]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2018016.
    coneq[5902]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/672672.
    coneq[5903]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2))))))-1/252252.
    coneq[5904]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/504504.
    coneq[5905]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3*dot(A,c))))))-1/168168.
    coneq[5906]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/504504.
    coneq[5907]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1009008.
    coneq[5908]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/336336.
    coneq[5909]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**4)))))-1/70070.
    coneq[5910]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c**3))))))-1/280280.
    coneq[5911]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/840840.
    coneq[5912]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1681680.
    coneq[5913]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/560560.
    coneq[5914]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2))))))-1/210210.
    coneq[5915]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/420420.
    coneq[5916]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c))))))-1/140140.
    coneq[5917]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/280280.
    coneq[5918]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c**3)))))-1/56056.
    coneq[5919]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2))))))-1/168168.
    coneq[5920]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/336336.
    coneq[5921]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c))))))-1/112112.
    coneq[5922]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3*dot(A,c**2)))))-1/42042.
    coneq[5923]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3*dot(A,dot(A,c))))))-1/84084.
    coneq[5924]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**4*dot(A,c)))))-1/28028.
    coneq[5925]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/126126.
    coneq[5926]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/252252.
    coneq[5927]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/504504.
    coneq[5928]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3)))))-1/112112.
    coneq[5929]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/336336.
    coneq[5930]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/672672.
    coneq[5931]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/224224.
    coneq[5932]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/84084.
    coneq[5933]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/168168.
    coneq[5934]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/56056.
    coneq[5935]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/112112.
    coneq[5936]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**5))))-1/12012.
    coneq[5937]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**4)))))-1/60060.
    coneq[5938]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c**3))))))-1/240240.
    coneq[5939]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/720720.
    coneq[5940]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1441440.
    coneq[5941]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/480480.
    coneq[5942]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c*dot(A,c**2))))))-1/180180.
    coneq[5943]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/360360.
    coneq[5944]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2*dot(A,c))))))-1/120120.
    coneq[5945]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/240240.
    coneq[5946]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c**3)))))-1/48048.
    coneq[5947]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,dot(A,c**2))))))-1/144144.
    coneq[5948]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/288288.
    coneq[5949]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c*dot(A,c))))))-1/96096.
    coneq[5950]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2*dot(A,c**2)))))-1/36036.
    coneq[5951]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2*dot(A,dot(A,c))))))-1/72072.
    coneq[5952]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**3*dot(A,c)))))-1/24024.
    coneq[5953]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2)))))-1/72072.
    coneq[5954]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/144144.
    coneq[5955]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c)))))-1/48048.
    coneq[5956]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**4))))-1/10010.
    coneq[5957]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c**3)))))-1/40040.
    coneq[5958]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,dot(A,c**2))))))-1/120120.
    coneq[5959]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c)))))))-1/240240.
    coneq[5960]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c*dot(A,c))))))-1/80080.
    coneq[5961]=dot(b,dot(A,c*dot(A,c**5*dot(A,c*dot(A,c**2)))))-1/30030.
    coneq[5962]=dot(b,dot(A,c*dot(A,c**5*dot(A,c*dot(A,dot(A,c))))))-1/60060.
    coneq[5963]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**2*dot(A,c)))))-1/20020.
    coneq[5964]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c)*dot(A,c)))))-1/40040.
    coneq[5965]=dot(b,dot(A,c*dot(A,c**6*dot(A,c**3))))-1/8008.
    coneq[5966]=dot(b,dot(A,c*dot(A,c**6*dot(A,dot(A,c**2)))))-1/24024.
    coneq[5967]=dot(b,dot(A,c*dot(A,c**6*dot(A,dot(A,dot(A,c))))))-1/48048.
    coneq[5968]=dot(b,dot(A,c*dot(A,c**6*dot(A,c*dot(A,c)))))-1/16016.
    coneq[5969]=dot(b,dot(A,c*dot(A,c**7*dot(A,c**2))))-1/6006.
    coneq[5970]=dot(b,dot(A,c*dot(A,c**7*dot(A,dot(A,c)))))-1/12012.
    coneq[5971]=dot(b,dot(A,c*dot(A,c**8*dot(A,c))))-1/4004.
    coneq[5972]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,c**4))))-1/50050.
    coneq[5973]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,dot(A,c**3)))))-1/200200.
    coneq[5974]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))))-1/600600.
    coneq[5975]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1201200.
    coneq[5976]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))))-1/400400.
    coneq[5977]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2)))))-1/150150.
    coneq[5978]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))))-1/300300.
    coneq[5979]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c)))))-1/100100.
    coneq[5980]=dot(b,dot(A,c*dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))))-1/200200.
    coneq[5981]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))))-1/800800.
    coneq[5982]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))))-1/2402400.
    coneq[5983]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4804800.
    coneq[5984]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))))-1/1601600.
    coneq[5985]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))))-1/600600.
    coneq[5986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))))-1/1201200.
    coneq[5987]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))))-1/400400.
    coneq[5988]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))))-1/800800.
    coneq[5989]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))))-1/7207200.
    coneq[5990]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/14414400.
    coneq[5991]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))))-1/4804800.
    coneq[5992]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))))-1/1801800.
    coneq[5993]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))))-1/3603600.
    coneq[5994]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))))-1/1201200.
    coneq[5995]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))))-1/2402400.
    coneq[5996]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/28828800.
    coneq[5997]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))))-1/9609600.
    coneq[5998]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))))-1/3603600.
    coneq[5999]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))))-1/7207200.
    coneq[6000]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))))-1/2402400.
    coneq[6001]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))))-1/4804800.
    coneq[6002]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/3203200.
    coneq[6003]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/1201200.
    coneq[6004]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/2402400.
    coneq[6005]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/800800.
    coneq[6006]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1601600.
    coneq[6007]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/450450.
    coneq[6008]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/900900.
    coneq[6009]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/300300.
    coneq[6010]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/600600.
    coneq[6011]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1801800.
    coneq[6012]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/600600.
    coneq[6013]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1201200.
    coneq[6014]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/200200.
    coneq[6015]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/400400.
    coneq[6016]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/800800.
    coneq[6017]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**5))))-1/48048.
    coneq[6018]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**4)))))-1/240240.
    coneq[6019]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))))-1/960960.
    coneq[6020]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[6021]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[6022]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[6023]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))))-1/720720.
    coneq[6024]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1441440.
    coneq[6025]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))))-1/480480.
    coneq[6026]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/960960.
    coneq[6027]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3)))))-1/192192.
    coneq[6028]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))))-1/576576.
    coneq[6029]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1153152.
    coneq[6030]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))))-1/384384.
    coneq[6031]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2)))))-1/144144.
    coneq[6032]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))))-1/288288.
    coneq[6033]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c)))))-1/96096.
    coneq[6034]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))))-1/288288.
    coneq[6035]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/576576.
    coneq[6036]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))))-1/192192.
    coneq[6037]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**5))))-1/144144.
    coneq[6038]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))))-1/720720.
    coneq[6039]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))))-1/2882880.
    coneq[6040]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/8648640.
    coneq[6041]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/17297280.
    coneq[6042]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/5765760.
    coneq[6043]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))))-1/2162160.
    coneq[6044]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/4324320.
    coneq[6045]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))))-1/1441440.
    coneq[6046]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2882880.
    coneq[6047]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))))-1/576576.
    coneq[6048]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))))-1/1729728.
    coneq[6049]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3459456.
    coneq[6050]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))))-1/1153152.
    coneq[6051]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))))-1/432432.
    coneq[6052]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))))-1/864864.
    coneq[6053]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))))-1/288288.
    coneq[6054]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))))-1/864864.
    coneq[6055]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1729728.
    coneq[6056]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))))-1/576576.
    coneq[6057]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5))))-1/288288.
    coneq[6058]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))))-1/1441440.
    coneq[6059]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))))-1/5765760.
    coneq[6060]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/17297280.
    coneq[6061]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/34594560.
    coneq[6062]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/11531520.
    coneq[6063]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))))-1/4324320.
    coneq[6064]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/8648640.
    coneq[6065]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))))-1/2882880.
    coneq[6066]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/5765760.
    coneq[6067]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))))-1/1153152.
    coneq[6068]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))))-1/3459456.
    coneq[6069]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/6918912.
    coneq[6070]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))))-1/2306304.
    coneq[6071]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))))-1/864864.
    coneq[6072]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))))-1/1729728.
    coneq[6073]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))))-1/576576.
    coneq[6074]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))))-1/1729728.
    coneq[6075]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/3459456.
    coneq[6076]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))))-1/1153152.
    coneq[6077]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**5))))-1/96096.
    coneq[6078]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))))-1/480480.
    coneq[6079]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1921920.
    coneq[6080]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/5765760.
    coneq[6081]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/11531520.
    coneq[6082]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3843840.
    coneq[6083]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1441440.
    coneq[6084]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2882880.
    coneq[6085]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/960960.
    coneq[6086]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1921920.
    coneq[6087]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))))-1/384384.
    coneq[6088]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/1153152.
    coneq[6089]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2306304.
    coneq[6090]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/768768.
    coneq[6091]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/288288.
    coneq[6092]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/576576.
    coneq[6093]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))))-1/192192.
    coneq[6094]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/576576.
    coneq[6095]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1153152.
    coneq[6096]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/384384.
    coneq[6097]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**6))))-1/42042.
    coneq[6098]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**5)))))-1/252252.
    coneq[6099]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))))-1/1261260.
    coneq[6100]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/5045040.
    coneq[6101]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/15135120.
    coneq[6102]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/30270240.
    coneq[6103]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/10090080.
    coneq[6104]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/3783780.
    coneq[6105]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7567560.
    coneq[6106]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/2522520.
    coneq[6107]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/5045040.
    coneq[6108]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))))-1/1009008.
    coneq[6109]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/3027024.
    coneq[6110]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/6054048.
    coneq[6111]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2018016.
    coneq[6112]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/756756.
    coneq[6113]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1513512.
    coneq[6114]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))))-1/504504.
    coneq[6115]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1513512.
    coneq[6116]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3027024.
    coneq[6117]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1009008.
    coneq[6118]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4)))))-1/210210.
    coneq[6119]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))))-1/840840.
    coneq[6120]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/2522520.
    coneq[6121]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5045040.
    coneq[6122]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1681680.
    coneq[6123]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/630630.
    coneq[6124]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1261260.
    coneq[6125]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/420420.
    coneq[6126]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/840840.
    coneq[6127]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3)))))-1/168168.
    coneq[6128]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/504504.
    coneq[6129]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1009008.
    coneq[6130]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/336336.
    coneq[6131]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2)))))-1/126126.
    coneq[6132]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))))-1/252252.
    coneq[6133]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c)))))-1/84084.
    coneq[6134]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/378378.
    coneq[6135]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/756756.
    coneq[6136]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1513512.
    coneq[6137]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))))-1/336336.
    coneq[6138]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1009008.
    coneq[6139]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2018016.
    coneq[6140]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/672672.
    coneq[6141]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/252252.
    coneq[6142]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/504504.
    coneq[6143]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/168168.
    coneq[6144]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/336336.
    coneq[6145]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**6))))-1/84084.
    coneq[6146]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5)))))-1/504504.
    coneq[6147]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))))-1/2522520.
    coneq[6148]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/10090080.
    coneq[6149]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/30270240.
    coneq[6150]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/60540480.
    coneq[6151]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/20180160.
    coneq[6152]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/7567560.
    coneq[6153]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/15135120.
    coneq[6154]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/5045040.
    coneq[6155]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/10090080.
    coneq[6156]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))))-1/2018016.
    coneq[6157]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/6054048.
    coneq[6158]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/12108096.
    coneq[6159]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/4036032.
    coneq[6160]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))))-1/1513512.
    coneq[6161]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/3027024.
    coneq[6162]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))))-1/1009008.
    coneq[6163]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/3027024.
    coneq[6164]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/6054048.
    coneq[6165]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/2018016.
    coneq[6166]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))))-1/420420.
    coneq[6167]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))))-1/1681680.
    coneq[6168]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/5045040.
    coneq[6169]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/10090080.
    coneq[6170]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/3363360.
    coneq[6171]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))))-1/1261260.
    coneq[6172]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/2522520.
    coneq[6173]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))))-1/840840.
    coneq[6174]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1681680.
    coneq[6175]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))))-1/336336.
    coneq[6176]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))))-1/1009008.
    coneq[6177]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/2018016.
    coneq[6178]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))))-1/672672.
    coneq[6179]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))))-1/252252.
    coneq[6180]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))))-1/504504.
    coneq[6181]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))))-1/168168.
    coneq[6182]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/756756.
    coneq[6183]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1513512.
    coneq[6184]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/3027024.
    coneq[6185]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))))-1/672672.
    coneq[6186]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/2018016.
    coneq[6187]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/4036032.
    coneq[6188]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1345344.
    coneq[6189]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/504504.
    coneq[6190]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/1009008.
    coneq[6191]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/336336.
    coneq[6192]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/672672.
    coneq[6193]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**7))))-1/32032.
    coneq[6194]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**6)))))-1/224224.
    coneq[6195]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5))))))-1/1345344.
    coneq[6196]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/6726720.
    coneq[6197]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/26906880.
    coneq[6198]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/80720640.
    coneq[6199]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/161441280.
    coneq[6200]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/53813760.
    coneq[6201]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/20180160.
    coneq[6202]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/40360320.
    coneq[6203]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/13453440.
    coneq[6204]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/26906880.
    coneq[6205]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/5381376.
    coneq[6206]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/16144128.
    coneq[6207]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/32288256.
    coneq[6208]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/10762752.
    coneq[6209]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/4036032.
    coneq[6210]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/8072064.
    coneq[6211]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/2690688.
    coneq[6212]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/8072064.
    coneq[6213]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/16144128.
    coneq[6214]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/5381376.
    coneq[6215]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))))-1/1121120.
    coneq[6216]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/4484480.
    coneq[6217]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/13453440.
    coneq[6218]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/26906880.
    coneq[6219]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/8968960.
    coneq[6220]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/3363360.
    coneq[6221]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/6726720.
    coneq[6222]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2242240.
    coneq[6223]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/4484480.
    coneq[6224]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))))-1/896896.
    coneq[6225]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2690688.
    coneq[6226]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/5381376.
    coneq[6227]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1793792.
    coneq[6228]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))))-1/672672.
    coneq[6229]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/1345344.
    coneq[6230]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))))-1/448448.
    coneq[6231]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2018016.
    coneq[6232]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/4036032.
    coneq[6233]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/8072064.
    coneq[6234]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/1793792.
    coneq[6235]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/5381376.
    coneq[6236]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/10762752.
    coneq[6237]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/3587584.
    coneq[6238]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1345344.
    coneq[6239]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2690688.
    coneq[6240]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/896896.
    coneq[6241]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1793792.
    coneq[6242]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**5)))))-1/192192.
    coneq[6243]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))))-1/960960.
    coneq[6244]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/3843840.
    coneq[6245]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/11531520.
    coneq[6246]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/23063040.
    coneq[6247]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/7687680.
    coneq[6248]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/2882880.
    coneq[6249]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5765760.
    coneq[6250]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/1921920.
    coneq[6251]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3843840.
    coneq[6252]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))))-1/768768.
    coneq[6253]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/2306304.
    coneq[6254]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4612608.
    coneq[6255]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1537536.
    coneq[6256]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/576576.
    coneq[6257]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/1153152.
    coneq[6258]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))))-1/384384.
    coneq[6259]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/1153152.
    coneq[6260]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2306304.
    coneq[6261]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/768768.
    coneq[6262]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4)))))-1/160160.
    coneq[6263]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))))-1/640640.
    coneq[6264]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/1921920.
    coneq[6265]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3843840.
    coneq[6266]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/1281280.
    coneq[6267]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/480480.
    coneq[6268]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/960960.
    coneq[6269]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/320320.
    coneq[6270]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/640640.
    coneq[6271]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3)))))-1/128128.
    coneq[6272]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))))-1/384384.
    coneq[6273]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/768768.
    coneq[6274]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))))-1/256256.
    coneq[6275]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2)))))-1/96096.
    coneq[6276]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))))-1/192192.
    coneq[6277]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**5*dot(A,c)))))-1/64064.
    coneq[6278]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/384384.
    coneq[6279]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1153152.
    coneq[6280]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2306304.
    coneq[6281]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/768768.
    coneq[6282]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/768768.
    coneq[6283]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2306304.
    coneq[6284]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/4612608.
    coneq[6285]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1537536.
    coneq[6286]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))))-1/320320.
    coneq[6287]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/1281280.
    coneq[6288]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/3843840.
    coneq[6289]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7687680.
    coneq[6290]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2562560.
    coneq[6291]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/960960.
    coneq[6292]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1921920.
    coneq[6293]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/640640.
    coneq[6294]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1281280.
    coneq[6295]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/288288.
    coneq[6296]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/576576.
    coneq[6297]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1153152.
    coneq[6298]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/256256.
    coneq[6299]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/768768.
    coneq[6300]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1537536.
    coneq[6301]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/512512.
    coneq[6302]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/192192.
    coneq[6303]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/384384.
    coneq[6304]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/128128.
    coneq[6305]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/384384.
    coneq[6306]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/768768.
    coneq[6307]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/256256.
    coneq[6308]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c**4))))-1/40040.
    coneq[6309]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3)))))-1/160160.
    coneq[6310]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/480480.
    coneq[6311]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/960960.
    coneq[6312]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/320320.
    coneq[6313]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/120120.
    coneq[6314]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/240240.
    coneq[6315]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/80080.
    coneq[6316]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/160160.
    coneq[6317]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4))))-1/120120.
    coneq[6318]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/480480.
    coneq[6319]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/1441440.
    coneq[6320]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2882880.
    coneq[6321]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/960960.
    coneq[6322]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/360360.
    coneq[6323]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/720720.
    coneq[6324]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/240240.
    coneq[6325]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/480480.
    coneq[6326]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/240240.
    coneq[6327]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/960960.
    coneq[6328]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/2882880.
    coneq[6329]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/5765760.
    coneq[6330]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/1921920.
    coneq[6331]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/720720.
    coneq[6332]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1441440.
    coneq[6333]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/480480.
    coneq[6334]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/960960.
    coneq[6335]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4))))-1/80080.
    coneq[6336]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/320320.
    coneq[6337]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/960960.
    coneq[6338]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1921920.
    coneq[6339]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/640640.
    coneq[6340]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/240240.
    coneq[6341]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/480480.
    coneq[6342]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/160160.
    coneq[6343]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/320320.
    coneq[6344]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**5))))-1/36036.
    coneq[6345]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4)))))-1/180180.
    coneq[6346]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/720720.
    coneq[6347]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2162160.
    coneq[6348]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4324320.
    coneq[6349]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1441440.
    coneq[6350]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/540540.
    coneq[6351]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1081080.
    coneq[6352]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/360360.
    coneq[6353]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/720720.
    coneq[6354]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/144144.
    coneq[6355]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/432432.
    coneq[6356]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/864864.
    coneq[6357]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/288288.
    coneq[6358]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/108108.
    coneq[6359]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/216216.
    coneq[6360]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/72072.
    coneq[6361]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/216216.
    coneq[6362]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/432432.
    coneq[6363]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/144144.
    coneq[6364]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**5))))-1/72072.
    coneq[6365]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/360360.
    coneq[6366]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1441440.
    coneq[6367]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4324320.
    coneq[6368]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/8648640.
    coneq[6369]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2882880.
    coneq[6370]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1081080.
    coneq[6371]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2162160.
    coneq[6372]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/720720.
    coneq[6373]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1441440.
    coneq[6374]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/288288.
    coneq[6375]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/864864.
    coneq[6376]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1729728.
    coneq[6377]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/576576.
    coneq[6378]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/216216.
    coneq[6379]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/432432.
    coneq[6380]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/144144.
    coneq[6381]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/432432.
    coneq[6382]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/864864.
    coneq[6383]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/288288.
    coneq[6384]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**6))))-1/28028.
    coneq[6385]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**5)))))-1/168168.
    coneq[6386]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/840840.
    coneq[6387]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/3363360.
    coneq[6388]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/10090080.
    coneq[6389]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/20180160.
    coneq[6390]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6726720.
    coneq[6391]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2522520.
    coneq[6392]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5045040.
    coneq[6393]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1681680.
    coneq[6394]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3363360.
    coneq[6395]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/672672.
    coneq[6396]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2018016.
    coneq[6397]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4036032.
    coneq[6398]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1345344.
    coneq[6399]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/504504.
    coneq[6400]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1009008.
    coneq[6401]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/336336.
    coneq[6402]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1009008.
    coneq[6403]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2018016.
    coneq[6404]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/672672.
    coneq[6405]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4)))))-1/140140.
    coneq[6406]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/560560.
    coneq[6407]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1681680.
    coneq[6408]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3363360.
    coneq[6409]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1121120.
    coneq[6410]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/420420.
    coneq[6411]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/840840.
    coneq[6412]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/280280.
    coneq[6413]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/560560.
    coneq[6414]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/112112.
    coneq[6415]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/336336.
    coneq[6416]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/672672.
    coneq[6417]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/224224.
    coneq[6418]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/84084.
    coneq[6419]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/168168.
    coneq[6420]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c)))))-1/56056.
    coneq[6421]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/252252.
    coneq[6422]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/504504.
    coneq[6423]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1009008.
    coneq[6424]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/224224.
    coneq[6425]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/672672.
    coneq[6426]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1345344.
    coneq[6427]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/448448.
    coneq[6428]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/168168.
    coneq[6429]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/336336.
    coneq[6430]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/112112.
    coneq[6431]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/224224.
    coneq[6432]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)*dot(A,c**3))))-1/32032.
    coneq[6433]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/96096.
    coneq[6434]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/192192.
    coneq[6435]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/64064.
    coneq[6436]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/288288.
    coneq[6437]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/576576.
    coneq[6438]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/192192.
    coneq[6439]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/1153152.
    coneq[6440]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/384384.
    coneq[6441]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/128128.
    coneq[6442]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**4))))-1/30030.
    coneq[6443]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/120120.
    coneq[6444]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/360360.
    coneq[6445]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/720720.
    coneq[6446]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/240240.
    coneq[6447]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/90090.
    coneq[6448]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/180180.
    coneq[6449]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/60060.
    coneq[6450]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/120120.
    coneq[6451]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4))))-1/60060.
    coneq[6452]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/240240.
    coneq[6453]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/720720.
    coneq[6454]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1441440.
    coneq[6455]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/480480.
    coneq[6456]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/180180.
    coneq[6457]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/360360.
    coneq[6458]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/120120.
    coneq[6459]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/240240.
    coneq[6460]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**5))))-1/24024.
    coneq[6461]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4)))))-1/120120.
    coneq[6462]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/480480.
    coneq[6463]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1441440.
    coneq[6464]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2882880.
    coneq[6465]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/960960.
    coneq[6466]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/360360.
    coneq[6467]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/720720.
    coneq[6468]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/240240.
    coneq[6469]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/480480.
    coneq[6470]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/96096.
    coneq[6471]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/288288.
    coneq[6472]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/576576.
    coneq[6473]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/192192.
    coneq[6474]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/72072.
    coneq[6475]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/144144.
    coneq[6476]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/48048.
    coneq[6477]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/144144.
    coneq[6478]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/288288.
    coneq[6479]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/96096.
    coneq[6480]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,c**3))))-1/24024.
    coneq[6481]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/72072.
    coneq[6482]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/144144.
    coneq[6483]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/48048.
    coneq[6484]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3))))-1/48048.
    coneq[6485]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/144144.
    coneq[6486]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/288288.
    coneq[6487]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/96096.
    coneq[6488]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**4))))-1/20020.
    coneq[6489]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3)))))-1/80080.
    coneq[6490]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/240240.
    coneq[6491]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/480480.
    coneq[6492]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/160160.
    coneq[6493]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/60060.
    coneq[6494]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/120120.
    coneq[6495]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/40040.
    coneq[6496]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/80080.
    coneq[6497]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)*dot(A,c**2))))-1/18018.
    coneq[6498]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c)))))-1/36036.
    coneq[6499]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/72072.
    coneq[6500]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c**3))))-1/16016.
    coneq[6501]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2)))))-1/48048.
    coneq[6502]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/96096.
    coneq[6503]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c)))))-1/32032.
    coneq[6504]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)*dot(A,c**2))))-1/12012.
    coneq[6505]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)*dot(A,dot(A,c)))))-1/24024.
    coneq[6506]=dot(b,dot(A,c*dot(A,c**6*dot(A,c)*dot(A,c))))-1/8008.
    coneq[6507]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**5))))-1/48048.
    coneq[6508]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))))-1/240240.
    coneq[6509]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/960960.
    coneq[6510]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2882880.
    coneq[6511]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5765760.
    coneq[6512]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1921920.
    coneq[6513]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/720720.
    coneq[6514]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1441440.
    coneq[6515]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/480480.
    coneq[6516]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/960960.
    coneq[6517]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/192192.
    coneq[6518]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/576576.
    coneq[6519]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1153152.
    coneq[6520]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/384384.
    coneq[6521]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/144144.
    coneq[6522]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/288288.
    coneq[6523]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/96096.
    coneq[6524]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/288288.
    coneq[6525]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/576576.
    coneq[6526]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/192192.
    coneq[6527]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4))))-1/60060.
    coneq[6528]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/240240.
    coneq[6529]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/720720.
    coneq[6530]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1441440.
    coneq[6531]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/480480.
    coneq[6532]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/180180.
    coneq[6533]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/360360.
    coneq[6534]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/120120.
    coneq[6535]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/240240.
    coneq[6536]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))))-1/120120.
    coneq[6537]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/480480.
    coneq[6538]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1441440.
    coneq[6539]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2882880.
    coneq[6540]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/960960.
    coneq[6541]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/360360.
    coneq[6542]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/720720.
    coneq[6543]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/240240.
    coneq[6544]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/480480.
    coneq[6545]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3))))-1/72072.
    coneq[6546]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/216216.
    coneq[6547]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/432432.
    coneq[6548]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/144144.
    coneq[6549]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))))-1/144144.
    coneq[6550]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/432432.
    coneq[6551]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/864864.
    coneq[6552]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/288288.
    coneq[6553]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))))-1/288288.
    coneq[6554]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/864864.
    coneq[6555]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1729728.
    coneq[6556]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/576576.
    coneq[6557]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3))))-1/64064.
    coneq[6558]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/192192.
    coneq[6559]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/384384.
    coneq[6560]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/128128.
    coneq[6561]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/576576.
    coneq[6562]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/1153152.
    coneq[6563]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/384384.
    coneq[6564]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/2306304.
    coneq[6565]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/768768.
    coneq[6566]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/256256.
    coneq[6567]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4))))-1/40040.
    coneq[6568]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/160160.
    coneq[6569]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/480480.
    coneq[6570]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/960960.
    coneq[6571]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/320320.
    coneq[6572]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/120120.
    coneq[6573]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/240240.
    coneq[6574]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/80080.
    coneq[6575]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/160160.
    coneq[6576]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/48048.
    coneq[6577]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/144144.
    coneq[6578]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/288288.
    coneq[6579]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/96096.
    coneq[6580]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/96096.
    coneq[6581]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/288288.
    coneq[6582]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/576576.
    coneq[6583]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/192192.
    coneq[6584]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/54054.
    coneq[6585]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/108108.
    coneq[6586]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/216216.
    coneq[6587]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/432432.
    coneq[6588]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/32032.
    coneq[6589]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/96096.
    coneq[6590]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/192192.
    coneq[6591]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/64064.
    coneq[6592]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/36036.
    coneq[6593]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/72072.
    coneq[6594]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/144144.
    coneq[6595]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/24024.
    coneq[6596]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/48048.
    coneq[6597]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c))))-1/16016.
    coneq[6598]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/64064.
    coneq[6599]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/192192.
    coneq[6600]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/384384.
    coneq[6601]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/128128.
    coneq[6602]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/72072.
    coneq[6603]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/144144.
    coneq[6604]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))))-1/144144.
    coneq[6605]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/288288.
    coneq[6606]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/48048.
    coneq[6607]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/96096.
    coneq[6608]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/32032.
    coneq[6609]=dot(b,dot(A,c**2*dot(A,c**9)))-1/1820.
    coneq[6610]=dot(b,dot(A,c**2*dot(A,dot(A,c**8))))-1/16380.
    coneq[6611]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**7)))))-1/131040.
    coneq[6612]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**6))))))-1/917280.
    coneq[6613]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/5503680.
    coneq[6614]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/27518400.
    coneq[6615]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/110073600.
    coneq[6616]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/330220800.
    coneq[6617]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/660441600.
    coneq[6618]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/220147200.
    coneq[6619]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/82555200.
    coneq[6620]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/165110400.
    coneq[6621]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/55036800.
    coneq[6622]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/110073600.
    coneq[6623]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/22014720.
    coneq[6624]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/66044160.
    coneq[6625]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/132088320.
    coneq[6626]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/44029440.
    coneq[6627]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/16511040.
    coneq[6628]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/33022080.
    coneq[6629]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/11007360.
    coneq[6630]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/33022080.
    coneq[6631]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/66044160.
    coneq[6632]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/22014720.
    coneq[6633]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/4586400.
    coneq[6634]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/18345600.
    coneq[6635]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/55036800.
    coneq[6636]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/110073600.
    coneq[6637]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/36691200.
    coneq[6638]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/13759200.
    coneq[6639]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/27518400.
    coneq[6640]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/9172800.
    coneq[6641]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/18345600.
    coneq[6642]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/3669120.
    coneq[6643]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/11007360.
    coneq[6644]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/22014720.
    coneq[6645]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/7338240.
    coneq[6646]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/2751840.
    coneq[6647]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/5503680.
    coneq[6648]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/1834560.
    coneq[6649]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/8255520.
    coneq[6650]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/16511040.
    coneq[6651]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/33022080.
    coneq[6652]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/7338240.
    coneq[6653]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[6654]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[6655]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[6656]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/5503680.
    coneq[6657]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/11007360.
    coneq[6658]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/3669120.
    coneq[6659]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[6660]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**5))))))-1/786240.
    coneq[6661]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/3931200.
    coneq[6662]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/15724800.
    coneq[6663]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/47174400.
    coneq[6664]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/94348800.
    coneq[6665]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/31449600.
    coneq[6666]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/11793600.
    coneq[6667]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/23587200.
    coneq[6668]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/7862400.
    coneq[6669]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/15724800.
    coneq[6670]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/3144960.
    coneq[6671]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/9434880.
    coneq[6672]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/18869760.
    coneq[6673]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/6289920.
    coneq[6674]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/2358720.
    coneq[6675]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/4717440.
    coneq[6676]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/1572480.
    coneq[6677]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/4717440.
    coneq[6678]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/9434880.
    coneq[6679]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/3144960.
    coneq[6680]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**4))))))-1/655200.
    coneq[6681]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/2620800.
    coneq[6682]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/7862400.
    coneq[6683]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/15724800.
    coneq[6684]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/5241600.
    coneq[6685]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/1965600.
    coneq[6686]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/3931200.
    coneq[6687]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/1310400.
    coneq[6688]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/2620800.
    coneq[6689]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c**3))))))-1/524160.
    coneq[6690]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[6691]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[6692]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[6693]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4*dot(A,c**2))))))-1/393120.
    coneq[6694]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/786240.
    coneq[6695]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**5*dot(A,c))))))-1/262080.
    coneq[6696]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/1572480.
    coneq[6697]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[6698]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[6699]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[6700]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/3144960.
    coneq[6701]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[6702]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[6703]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[6704]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/1310400.
    coneq[6705]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/5241600.
    coneq[6706]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/15724800.
    coneq[6707]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/31449600.
    coneq[6708]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/10483200.
    coneq[6709]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/3931200.
    coneq[6710]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/7862400.
    coneq[6711]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/2620800.
    coneq[6712]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/5241600.
    coneq[6713]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/1179360.
    coneq[6714]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/2358720.
    coneq[6715]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4717440.
    coneq[6716]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/1048320.
    coneq[6717]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[6718]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[6719]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[6720]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/786240.
    coneq[6721]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/1572480.
    coneq[6722]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/524160.
    coneq[6723]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/1572480.
    coneq[6724]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/3144960.
    coneq[6725]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[6726]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**6)))))-1/114660.
    coneq[6727]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**5))))))-1/687960.
    coneq[6728]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/3439800.
    coneq[6729]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/13759200.
    coneq[6730]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/41277600.
    coneq[6731]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/82555200.
    coneq[6732]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/27518400.
    coneq[6733]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/10319400.
    coneq[6734]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/20638800.
    coneq[6735]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/6879600.
    coneq[6736]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/13759200.
    coneq[6737]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/2751840.
    coneq[6738]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/8255520.
    coneq[6739]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/16511040.
    coneq[6740]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/5503680.
    coneq[6741]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/2063880.
    coneq[6742]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/4127760.
    coneq[6743]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/1375920.
    coneq[6744]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/4127760.
    coneq[6745]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/8255520.
    coneq[6746]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2751840.
    coneq[6747]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**4))))))-1/573300.
    coneq[6748]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/2293200.
    coneq[6749]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/6879600.
    coneq[6750]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/13759200.
    coneq[6751]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/4586400.
    coneq[6752]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1719900.
    coneq[6753]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3439800.
    coneq[6754]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1146600.
    coneq[6755]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2293200.
    coneq[6756]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/458640.
    coneq[6757]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1375920.
    coneq[6758]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2751840.
    coneq[6759]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/917280.
    coneq[6760]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/343980.
    coneq[6761]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/687960.
    coneq[6762]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4*dot(A,c))))))-1/229320.
    coneq[6763]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1031940.
    coneq[6764]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/2063880.
    coneq[6765]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/4127760.
    coneq[6766]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/917280.
    coneq[6767]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2751840.
    coneq[6768]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/5503680.
    coneq[6769]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1834560.
    coneq[6770]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/687960.
    coneq[6771]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1375920.
    coneq[6772]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/458640.
    coneq[6773]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/917280.
    coneq[6774]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**5)))))-1/98280.
    coneq[6775]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**4))))))-1/491400.
    coneq[6776]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/1965600.
    coneq[6777]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5896800.
    coneq[6778]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11793600.
    coneq[6779]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3931200.
    coneq[6780]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/1474200.
    coneq[6781]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2948400.
    coneq[6782]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/982800.
    coneq[6783]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1965600.
    coneq[6784]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/393120.
    coneq[6785]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[6786]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[6787]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/786240.
    coneq[6788]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/294840.
    coneq[6789]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/589680.
    coneq[6790]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/196560.
    coneq[6791]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/589680.
    coneq[6792]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1179360.
    coneq[6793]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/393120.
    coneq[6794]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**4)))))-1/81900.
    coneq[6795]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c**3))))))-1/327600.
    coneq[6796]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/982800.
    coneq[6797]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1965600.
    coneq[6798]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/655200.
    coneq[6799]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/245700.
    coneq[6800]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/491400.
    coneq[6801]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/163800.
    coneq[6802]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/327600.
    coneq[6803]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c**3)))))-1/65520.
    coneq[6804]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,dot(A,c**2))))))-1/196560.
    coneq[6805]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/393120.
    coneq[6806]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c*dot(A,c))))))-1/131040.
    coneq[6807]=dot(b,dot(A,c**2*dot(A,dot(A,c**5*dot(A,c**2)))))-1/49140.
    coneq[6808]=dot(b,dot(A,c**2*dot(A,dot(A,c**5*dot(A,dot(A,c))))))-1/98280.
    coneq[6809]=dot(b,dot(A,c**2*dot(A,dot(A,c**6*dot(A,c)))))-1/32760.
    coneq[6810]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))))-1/262080.
    coneq[6811]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/786240.
    coneq[6812]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[6813]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/524160.
    coneq[6814]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/2358720.
    coneq[6815]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/4717440.
    coneq[6816]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/1572480.
    coneq[6817]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/9434880.
    coneq[6818]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/3144960.
    coneq[6819]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[6820]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))))-1/245700.
    coneq[6821]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/982800.
    coneq[6822]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/2948400.
    coneq[6823]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/5896800.
    coneq[6824]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/1965600.
    coneq[6825]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/737100.
    coneq[6826]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/1474200.
    coneq[6827]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/491400.
    coneq[6828]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/982800.
    coneq[6829]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/491400.
    coneq[6830]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/1965600.
    coneq[6831]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/5896800.
    coneq[6832]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/11793600.
    coneq[6833]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/3931200.
    coneq[6834]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/1474200.
    coneq[6835]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/2948400.
    coneq[6836]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/982800.
    coneq[6837]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/1965600.
    coneq[6838]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**5)))))-1/196560.
    coneq[6839]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/982800.
    coneq[6840]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/3931200.
    coneq[6841]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/11793600.
    coneq[6842]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/23587200.
    coneq[6843]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/7862400.
    coneq[6844]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/2948400.
    coneq[6845]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5896800.
    coneq[6846]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/1965600.
    coneq[6847]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3931200.
    coneq[6848]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/786240.
    coneq[6849]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[6850]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[6851]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[6852]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/589680.
    coneq[6853]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/1179360.
    coneq[6854]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/393120.
    coneq[6855]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/1179360.
    coneq[6856]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2358720.
    coneq[6857]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/786240.
    coneq[6858]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/196560.
    coneq[6859]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/589680.
    coneq[6860]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1179360.
    coneq[6861]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/393120.
    coneq[6862]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/393120.
    coneq[6863]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1179360.
    coneq[6864]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2358720.
    coneq[6865]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/786240.
    coneq[6866]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))))-1/163800.
    coneq[6867]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/655200.
    coneq[6868]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1965600.
    coneq[6869]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3931200.
    coneq[6870]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1310400.
    coneq[6871]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/491400.
    coneq[6872]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/982800.
    coneq[6873]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/327600.
    coneq[6874]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/655200.
    coneq[6875]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/147420.
    coneq[6876]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/294840.
    coneq[6877]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/589680.
    coneq[6878]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/131040.
    coneq[6879]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/393120.
    coneq[6880]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[6881]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/262080.
    coneq[6882]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/98280.
    coneq[6883]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/196560.
    coneq[6884]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))))-1/65520.
    coneq[6885]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/262080.
    coneq[6886]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/786240.
    coneq[6887]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[6888]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/524160.
    coneq[6889]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/294840.
    coneq[6890]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/589680.
    coneq[6891]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1179360.
    coneq[6892]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/196560.
    coneq[6893]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/393120.
    coneq[6894]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/131040.
    coneq[6895]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/262080.
    coneq[6896]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**7))))-1/14560.
    coneq[6897]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**6)))))-1/101920.
    coneq[6898]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**5))))))-1/611520.
    coneq[6899]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/3057600.
    coneq[6900]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/12230400.
    coneq[6901]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/36691200.
    coneq[6902]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/73382400.
    coneq[6903]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/24460800.
    coneq[6904]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/9172800.
    coneq[6905]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/18345600.
    coneq[6906]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/6115200.
    coneq[6907]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/12230400.
    coneq[6908]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/2446080.
    coneq[6909]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/7338240.
    coneq[6910]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/14676480.
    coneq[6911]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/4892160.
    coneq[6912]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1834560.
    coneq[6913]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/3669120.
    coneq[6914]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1223040.
    coneq[6915]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/3669120.
    coneq[6916]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/7338240.
    coneq[6917]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2446080.
    coneq[6918]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**4))))))-1/509600.
    coneq[6919]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/2038400.
    coneq[6920]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/6115200.
    coneq[6921]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/12230400.
    coneq[6922]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/4076800.
    coneq[6923]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1528800.
    coneq[6924]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/3057600.
    coneq[6925]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1019200.
    coneq[6926]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/2038400.
    coneq[6927]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))))-1/407680.
    coneq[6928]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1223040.
    coneq[6929]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2446080.
    coneq[6930]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/815360.
    coneq[6931]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))))-1/305760.
    coneq[6932]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/611520.
    coneq[6933]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4*dot(A,c))))))-1/203840.
    coneq[6934]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/917280.
    coneq[6935]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1834560.
    coneq[6936]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3669120.
    coneq[6937]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/815360.
    coneq[6938]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2446080.
    coneq[6939]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/4892160.
    coneq[6940]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1630720.
    coneq[6941]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/611520.
    coneq[6942]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1223040.
    coneq[6943]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/407680.
    coneq[6944]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/815360.
    coneq[6945]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**5)))))-1/87360.
    coneq[6946]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**4))))))-1/436800.
    coneq[6947]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1747200.
    coneq[6948]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/5241600.
    coneq[6949]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/10483200.
    coneq[6950]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3494400.
    coneq[6951]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1310400.
    coneq[6952]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2620800.
    coneq[6953]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/873600.
    coneq[6954]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1747200.
    coneq[6955]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))))-1/349440.
    coneq[6956]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/1048320.
    coneq[6957]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2096640.
    coneq[6958]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/698880.
    coneq[6959]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/262080.
    coneq[6960]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/524160.
    coneq[6961]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))))-1/174720.
    coneq[6962]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/524160.
    coneq[6963]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1048320.
    coneq[6964]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/349440.
    coneq[6965]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**4)))))-1/72800.
    coneq[6966]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))))-1/291200.
    coneq[6967]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/873600.
    coneq[6968]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1747200.
    coneq[6969]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/582400.
    coneq[6970]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/218400.
    coneq[6971]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/436800.
    coneq[6972]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/145600.
    coneq[6973]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/291200.
    coneq[6974]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c**3)))))-1/58240.
    coneq[6975]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))))-1/174720.
    coneq[6976]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/349440.
    coneq[6977]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))))-1/116480.
    coneq[6978]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4*dot(A,c**2)))))-1/43680.
    coneq[6979]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4*dot(A,dot(A,c))))))-1/87360.
    coneq[6980]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**5*dot(A,c)))))-1/29120.
    coneq[6981]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/174720.
    coneq[6982]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/524160.
    coneq[6983]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[6984]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/349440.
    coneq[6985]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/349440.
    coneq[6986]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1048320.
    coneq[6987]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[6988]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/698880.
    coneq[6989]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))))-1/145600.
    coneq[6990]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/582400.
    coneq[6991]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1747200.
    coneq[6992]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3494400.
    coneq[6993]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1164800.
    coneq[6994]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/436800.
    coneq[6995]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/873600.
    coneq[6996]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/291200.
    coneq[6997]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/582400.
    coneq[6998]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/131040.
    coneq[6999]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/262080.
    coneq[7000]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/524160.
    coneq[7001]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/116480.
    coneq[7002]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/349440.
    coneq[7003]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/698880.
    coneq[7004]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/232960.
    coneq[7005]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/87360.
    coneq[7006]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/174720.
    coneq[7007]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/58240.
    coneq[7008]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/174720.
    coneq[7009]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/349440.
    coneq[7010]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/116480.
    coneq[7011]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**6))))-1/12740.
    coneq[7012]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**5)))))-1/76440.
    coneq[7013]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**4))))))-1/382200.
    coneq[7014]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1528800.
    coneq[7015]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4586400.
    coneq[7016]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/9172800.
    coneq[7017]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3057600.
    coneq[7018]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1146600.
    coneq[7019]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2293200.
    coneq[7020]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/764400.
    coneq[7021]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1528800.
    coneq[7022]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))))-1/305760.
    coneq[7023]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/917280.
    coneq[7024]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1834560.
    coneq[7025]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/611520.
    coneq[7026]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))))-1/229320.
    coneq[7027]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/458640.
    coneq[7028]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))))-1/152880.
    coneq[7029]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/458640.
    coneq[7030]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/917280.
    coneq[7031]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/305760.
    coneq[7032]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**4)))))-1/63700.
    coneq[7033]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))))-1/254800.
    coneq[7034]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/764400.
    coneq[7035]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1528800.
    coneq[7036]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/509600.
    coneq[7037]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))))-1/191100.
    coneq[7038]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/382200.
    coneq[7039]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))))-1/127400.
    coneq[7040]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/254800.
    coneq[7041]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c**3)))))-1/50960.
    coneq[7042]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))))-1/152880.
    coneq[7043]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/305760.
    coneq[7044]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))))-1/101920.
    coneq[7045]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3*dot(A,c**2)))))-1/38220.
    coneq[7046]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))))-1/76440.
    coneq[7047]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**4*dot(A,c)))))-1/25480.
    coneq[7048]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/114660.
    coneq[7049]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/229320.
    coneq[7050]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/458640.
    coneq[7051]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))))-1/101920.
    coneq[7052]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/305760.
    coneq[7053]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/611520.
    coneq[7054]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/203840.
    coneq[7055]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/76440.
    coneq[7056]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/152880.
    coneq[7057]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/50960.
    coneq[7058]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/101920.
    coneq[7059]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**5))))-1/10920.
    coneq[7060]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**4)))))-1/54600.
    coneq[7061]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c**3))))))-1/218400.
    coneq[7062]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/655200.
    coneq[7063]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1310400.
    coneq[7064]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/436800.
    coneq[7065]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))))-1/163800.
    coneq[7066]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/327600.
    coneq[7067]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))))-1/109200.
    coneq[7068]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/218400.
    coneq[7069]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c**3)))))-1/43680.
    coneq[7070]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))))-1/131040.
    coneq[7071]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/262080.
    coneq[7072]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))))-1/87360.
    coneq[7073]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2*dot(A,c**2)))))-1/32760.
    coneq[7074]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))))-1/65520.
    coneq[7075]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**3*dot(A,c)))))-1/21840.
    coneq[7076]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))))-1/65520.
    coneq[7077]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/131040.
    coneq[7078]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))))-1/43680.
    coneq[7079]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**4))))-1/9100.
    coneq[7080]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c**3)))))-1/36400.
    coneq[7081]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,dot(A,c**2))))))-1/109200.
    coneq[7082]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))))-1/218400.
    coneq[7083]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c*dot(A,c))))))-1/72800.
    coneq[7084]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c*dot(A,c**2)))))-1/27300.
    coneq[7085]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c*dot(A,dot(A,c))))))-1/54600.
    coneq[7086]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**2*dot(A,c)))))-1/18200.
    coneq[7087]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))))-1/36400.
    coneq[7088]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c**3))))-1/7280.
    coneq[7089]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,dot(A,c**2)))))-1/21840.
    coneq[7090]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,dot(A,dot(A,c))))))-1/43680.
    coneq[7091]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c*dot(A,c)))))-1/14560.
    coneq[7092]=dot(b,dot(A,c**2*dot(A,c**6*dot(A,c**2))))-1/5460.
    coneq[7093]=dot(b,dot(A,c**2*dot(A,c**6*dot(A,dot(A,c)))))-1/10920.
    coneq[7094]=dot(b,dot(A,c**2*dot(A,c**7*dot(A,c))))-1/3640.
    coneq[7095]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c**4))))-1/36400.
    coneq[7096]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))))-1/145600.
    coneq[7097]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/436800.
    coneq[7098]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/873600.
    coneq[7099]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/291200.
    coneq[7100]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/109200.
    coneq[7101]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/218400.
    coneq[7102]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/72800.
    coneq[7103]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/145600.
    coneq[7104]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c**4))))-1/109200.
    coneq[7105]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/436800.
    coneq[7106]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/1310400.
    coneq[7107]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2620800.
    coneq[7108]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/873600.
    coneq[7109]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/327600.
    coneq[7110]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/655200.
    coneq[7111]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/218400.
    coneq[7112]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/436800.
    coneq[7113]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/218400.
    coneq[7114]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/873600.
    coneq[7115]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/2620800.
    coneq[7116]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/5241600.
    coneq[7117]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/1747200.
    coneq[7118]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/655200.
    coneq[7119]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/1310400.
    coneq[7120]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/436800.
    coneq[7121]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/873600.
    coneq[7122]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c**4))))-1/72800.
    coneq[7123]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/291200.
    coneq[7124]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/873600.
    coneq[7125]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1747200.
    coneq[7126]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/582400.
    coneq[7127]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/218400.
    coneq[7128]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/436800.
    coneq[7129]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/145600.
    coneq[7130]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/291200.
    coneq[7131]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**5))))-1/32760.
    coneq[7132]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))))-1/163800.
    coneq[7133]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/655200.
    coneq[7134]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1965600.
    coneq[7135]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3931200.
    coneq[7136]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1310400.
    coneq[7137]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/491400.
    coneq[7138]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/982800.
    coneq[7139]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/327600.
    coneq[7140]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/655200.
    coneq[7141]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/131040.
    coneq[7142]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/393120.
    coneq[7143]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[7144]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/262080.
    coneq[7145]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/98280.
    coneq[7146]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/196560.
    coneq[7147]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/65520.
    coneq[7148]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/196560.
    coneq[7149]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/393120.
    coneq[7150]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/131040.
    coneq[7151]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**5))))-1/65520.
    coneq[7152]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/327600.
    coneq[7153]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/1310400.
    coneq[7154]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3931200.
    coneq[7155]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7862400.
    coneq[7156]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2620800.
    coneq[7157]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/982800.
    coneq[7158]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1965600.
    coneq[7159]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/655200.
    coneq[7160]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1310400.
    coneq[7161]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/262080.
    coneq[7162]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/786240.
    coneq[7163]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[7164]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/524160.
    coneq[7165]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/196560.
    coneq[7166]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/393120.
    coneq[7167]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/131040.
    coneq[7168]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/393120.
    coneq[7169]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/786240.
    coneq[7170]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/262080.
    coneq[7171]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**6))))-1/25480.
    coneq[7172]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**5)))))-1/152880.
    coneq[7173]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/764400.
    coneq[7174]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/3057600.
    coneq[7175]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/9172800.
    coneq[7176]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18345600.
    coneq[7177]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6115200.
    coneq[7178]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2293200.
    coneq[7179]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4586400.
    coneq[7180]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1528800.
    coneq[7181]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3057600.
    coneq[7182]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/611520.
    coneq[7183]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[7184]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[7185]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[7186]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/458640.
    coneq[7187]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/917280.
    coneq[7188]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/305760.
    coneq[7189]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/917280.
    coneq[7190]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1834560.
    coneq[7191]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/611520.
    coneq[7192]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))))-1/127400.
    coneq[7193]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/509600.
    coneq[7194]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1528800.
    coneq[7195]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3057600.
    coneq[7196]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1019200.
    coneq[7197]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/382200.
    coneq[7198]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/764400.
    coneq[7199]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/254800.
    coneq[7200]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/509600.
    coneq[7201]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/101920.
    coneq[7202]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/305760.
    coneq[7203]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/611520.
    coneq[7204]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/203840.
    coneq[7205]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/76440.
    coneq[7206]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/152880.
    coneq[7207]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))))-1/50960.
    coneq[7208]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/229320.
    coneq[7209]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/458640.
    coneq[7210]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/917280.
    coneq[7211]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/203840.
    coneq[7212]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/611520.
    coneq[7213]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1223040.
    coneq[7214]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/407680.
    coneq[7215]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/152880.
    coneq[7216]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/305760.
    coneq[7217]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/101920.
    coneq[7218]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/203840.
    coneq[7219]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)*dot(A,c**3))))-1/29120.
    coneq[7220]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/87360.
    coneq[7221]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/174720.
    coneq[7222]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/58240.
    coneq[7223]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/262080.
    coneq[7224]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[7225]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/174720.
    coneq[7226]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/1048320.
    coneq[7227]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/349440.
    coneq[7228]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/116480.
    coneq[7229]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**4))))-1/27300.
    coneq[7230]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/109200.
    coneq[7231]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/327600.
    coneq[7232]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/655200.
    coneq[7233]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/218400.
    coneq[7234]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/81900.
    coneq[7235]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/163800.
    coneq[7236]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/54600.
    coneq[7237]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/109200.
    coneq[7238]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c**4))))-1/54600.
    coneq[7239]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/218400.
    coneq[7240]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/655200.
    coneq[7241]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1310400.
    coneq[7242]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/436800.
    coneq[7243]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/163800.
    coneq[7244]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/327600.
    coneq[7245]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/109200.
    coneq[7246]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/218400.
    coneq[7247]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**5))))-1/21840.
    coneq[7248]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))))-1/109200.
    coneq[7249]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/436800.
    coneq[7250]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1310400.
    coneq[7251]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2620800.
    coneq[7252]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/873600.
    coneq[7253]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/327600.
    coneq[7254]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/655200.
    coneq[7255]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/218400.
    coneq[7256]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/436800.
    coneq[7257]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/87360.
    coneq[7258]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/262080.
    coneq[7259]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[7260]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/174720.
    coneq[7261]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/65520.
    coneq[7262]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/131040.
    coneq[7263]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/43680.
    coneq[7264]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/131040.
    coneq[7265]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/262080.
    coneq[7266]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/87360.
    coneq[7267]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,c**3))))-1/21840.
    coneq[7268]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/65520.
    coneq[7269]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/131040.
    coneq[7270]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/43680.
    coneq[7271]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))))-1/43680.
    coneq[7272]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/131040.
    coneq[7273]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[7274]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/87360.
    coneq[7275]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**4))))-1/18200.
    coneq[7276]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))))-1/72800.
    coneq[7277]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/218400.
    coneq[7278]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/436800.
    coneq[7279]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/145600.
    coneq[7280]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/54600.
    coneq[7281]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/109200.
    coneq[7282]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/36400.
    coneq[7283]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/72800.
    coneq[7284]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)*dot(A,c**2))))-1/16380.
    coneq[7285]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))))-1/32760.
    coneq[7286]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/65520.
    coneq[7287]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c**3))))-1/14560.
    coneq[7288]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))))-1/43680.
    coneq[7289]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/87360.
    coneq[7290]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))))-1/29120.
    coneq[7291]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)*dot(A,c**2))))-1/10920.
    coneq[7292]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))))-1/21840.
    coneq[7293]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c)*dot(A,c))))-1/7280.
    coneq[7294]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))))-1/36400.
    coneq[7295]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/145600.
    coneq[7296]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/436800.
    coneq[7297]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/873600.
    coneq[7298]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/291200.
    coneq[7299]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/109200.
    coneq[7300]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/218400.
    coneq[7301]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/72800.
    coneq[7302]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/145600.
    coneq[7303]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/43680.
    coneq[7304]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/131040.
    coneq[7305]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[7306]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/87360.
    coneq[7307]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/87360.
    coneq[7308]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/262080.
    coneq[7309]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[7310]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/174720.
    coneq[7311]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/49140.
    coneq[7312]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/98280.
    coneq[7313]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/196560.
    coneq[7314]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/393120.
    coneq[7315]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/29120.
    coneq[7316]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/87360.
    coneq[7317]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/174720.
    coneq[7318]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/58240.
    coneq[7319]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/32760.
    coneq[7320]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/65520.
    coneq[7321]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/131040.
    coneq[7322]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/21840.
    coneq[7323]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/43680.
    coneq[7324]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))))-1/14560.
    coneq[7325]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/43680.
    coneq[7326]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/87360.
    coneq[7327]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/29120.
    coneq[7328]=dot(b,dot(A,c**3*dot(A,c**8)))-1/1638.
    coneq[7329]=dot(b,dot(A,c**3*dot(A,dot(A,c**7))))-1/13104.
    coneq[7330]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**6)))))-1/91728.
    coneq[7331]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/550368.
    coneq[7332]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/2751840.
    coneq[7333]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/11007360.
    coneq[7334]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/33022080.
    coneq[7335]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/66044160.
    coneq[7336]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/22014720.
    coneq[7337]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/8255520.
    coneq[7338]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/16511040.
    coneq[7339]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/5503680.
    coneq[7340]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/11007360.
    coneq[7341]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/2201472.
    coneq[7342]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/6604416.
    coneq[7343]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/13208832.
    coneq[7344]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/4402944.
    coneq[7345]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/1651104.
    coneq[7346]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/3302208.
    coneq[7347]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/1100736.
    coneq[7348]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/3302208.
    coneq[7349]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/6604416.
    coneq[7350]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/2201472.
    coneq[7351]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/458640.
    coneq[7352]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/1834560.
    coneq[7353]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/5503680.
    coneq[7354]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/11007360.
    coneq[7355]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/3669120.
    coneq[7356]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/1375920.
    coneq[7357]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/2751840.
    coneq[7358]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/917280.
    coneq[7359]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/1834560.
    coneq[7360]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/366912.
    coneq[7361]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/1100736.
    coneq[7362]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/2201472.
    coneq[7363]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/733824.
    coneq[7364]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/275184.
    coneq[7365]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/550368.
    coneq[7366]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/183456.
    coneq[7367]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/825552.
    coneq[7368]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/1651104.
    coneq[7369]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/3302208.
    coneq[7370]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/733824.
    coneq[7371]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/2201472.
    coneq[7372]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/4402944.
    coneq[7373]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/1467648.
    coneq[7374]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/550368.
    coneq[7375]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/1100736.
    coneq[7376]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/366912.
    coneq[7377]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/733824.
    coneq[7378]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**5)))))-1/78624.
    coneq[7379]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/393120.
    coneq[7380]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/1572480.
    coneq[7381]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4717440.
    coneq[7382]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/9434880.
    coneq[7383]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/3144960.
    coneq[7384]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/1179360.
    coneq[7385]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2358720.
    coneq[7386]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/786240.
    coneq[7387]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1572480.
    coneq[7388]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/314496.
    coneq[7389]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/943488.
    coneq[7390]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1886976.
    coneq[7391]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/628992.
    coneq[7392]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/235872.
    coneq[7393]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/471744.
    coneq[7394]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/157248.
    coneq[7395]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/471744.
    coneq[7396]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/943488.
    coneq[7397]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/314496.
    coneq[7398]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**4)))))-1/65520.
    coneq[7399]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/262080.
    coneq[7400]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/786240.
    coneq[7401]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1572480.
    coneq[7402]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/524160.
    coneq[7403]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/196560.
    coneq[7404]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/393120.
    coneq[7405]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/131040.
    coneq[7406]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/262080.
    coneq[7407]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c**3)))))-1/52416.
    coneq[7408]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/157248.
    coneq[7409]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/314496.
    coneq[7410]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/104832.
    coneq[7411]=dot(b,dot(A,c**3*dot(A,dot(A,c**4*dot(A,c**2)))))-1/39312.
    coneq[7412]=dot(b,dot(A,c**3*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/78624.
    coneq[7413]=dot(b,dot(A,c**3*dot(A,dot(A,c**5*dot(A,c)))))-1/26208.
    coneq[7414]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/157248.
    coneq[7415]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/471744.
    coneq[7416]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[7417]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/314496.
    coneq[7418]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/314496.
    coneq[7419]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/943488.
    coneq[7420]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[7421]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/628992.
    coneq[7422]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/131040.
    coneq[7423]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/524160.
    coneq[7424]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[7425]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[7426]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[7427]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[7428]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[7429]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[7430]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[7431]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/117936.
    coneq[7432]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/235872.
    coneq[7433]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/471744.
    coneq[7434]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/104832.
    coneq[7435]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/314496.
    coneq[7436]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[7437]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/209664.
    coneq[7438]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/78624.
    coneq[7439]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/157248.
    coneq[7440]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/52416.
    coneq[7441]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[7442]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[7443]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[7444]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**6))))-1/11466.
    coneq[7445]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**5)))))-1/68796.
    coneq[7446]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/343980.
    coneq[7447]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1375920.
    coneq[7448]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/4127760.
    coneq[7449]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/8255520.
    coneq[7450]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2751840.
    coneq[7451]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1031940.
    coneq[7452]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/2063880.
    coneq[7453]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/687960.
    coneq[7454]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1375920.
    coneq[7455]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/275184.
    coneq[7456]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/825552.
    coneq[7457]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1651104.
    coneq[7458]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/550368.
    coneq[7459]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/206388.
    coneq[7460]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/412776.
    coneq[7461]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/137592.
    coneq[7462]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/412776.
    coneq[7463]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/825552.
    coneq[7464]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/275184.
    coneq[7465]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**4)))))-1/57330.
    coneq[7466]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/229320.
    coneq[7467]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/687960.
    coneq[7468]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1375920.
    coneq[7469]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/458640.
    coneq[7470]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/171990.
    coneq[7471]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/343980.
    coneq[7472]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/114660.
    coneq[7473]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/229320.
    coneq[7474]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/45864.
    coneq[7475]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/137592.
    coneq[7476]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/275184.
    coneq[7477]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/91728.
    coneq[7478]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/34398.
    coneq[7479]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/68796.
    coneq[7480]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**4*dot(A,c)))))-1/22932.
    coneq[7481]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/103194.
    coneq[7482]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/206388.
    coneq[7483]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/412776.
    coneq[7484]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/91728.
    coneq[7485]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/275184.
    coneq[7486]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/550368.
    coneq[7487]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/183456.
    coneq[7488]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/68796.
    coneq[7489]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/137592.
    coneq[7490]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/45864.
    coneq[7491]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/91728.
    coneq[7492]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**5))))-1/9828.
    coneq[7493]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**4)))))-1/49140.
    coneq[7494]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/196560.
    coneq[7495]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/589680.
    coneq[7496]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1179360.
    coneq[7497]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/393120.
    coneq[7498]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/147420.
    coneq[7499]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/294840.
    coneq[7500]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/98280.
    coneq[7501]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/196560.
    coneq[7502]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/39312.
    coneq[7503]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/117936.
    coneq[7504]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/235872.
    coneq[7505]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/78624.
    coneq[7506]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/29484.
    coneq[7507]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/58968.
    coneq[7508]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/19656.
    coneq[7509]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/58968.
    coneq[7510]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/117936.
    coneq[7511]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/39312.
    coneq[7512]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**4))))-1/8190.
    coneq[7513]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c**3)))))-1/32760.
    coneq[7514]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/98280.
    coneq[7515]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/196560.
    coneq[7516]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/65520.
    coneq[7517]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/24570.
    coneq[7518]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/49140.
    coneq[7519]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/16380.
    coneq[7520]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/32760.
    coneq[7521]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c**3))))-1/6552.
    coneq[7522]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,dot(A,c**2)))))-1/19656.
    coneq[7523]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/39312.
    coneq[7524]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c*dot(A,c)))))-1/13104.
    coneq[7525]=dot(b,dot(A,c**3*dot(A,c**5*dot(A,c**2))))-1/4914.
    coneq[7526]=dot(b,dot(A,c**3*dot(A,c**5*dot(A,dot(A,c)))))-1/9828.
    coneq[7527]=dot(b,dot(A,c**3*dot(A,c**6*dot(A,c))))-1/3276.
    coneq[7528]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)*dot(A,c**3))))-1/26208.
    coneq[7529]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/78624.
    coneq[7530]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[7531]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/52416.
    coneq[7532]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/235872.
    coneq[7533]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[7534]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/157248.
    coneq[7535]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/943488.
    coneq[7536]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/314496.
    coneq[7537]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/104832.
    coneq[7538]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**4))))-1/24570.
    coneq[7539]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/98280.
    coneq[7540]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/294840.
    coneq[7541]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/589680.
    coneq[7542]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/196560.
    coneq[7543]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/73710.
    coneq[7544]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/147420.
    coneq[7545]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/49140.
    coneq[7546]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/98280.
    coneq[7547]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/49140.
    coneq[7548]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/196560.
    coneq[7549]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/589680.
    coneq[7550]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1179360.
    coneq[7551]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/393120.
    coneq[7552]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/147420.
    coneq[7553]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/294840.
    coneq[7554]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/98280.
    coneq[7555]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/196560.
    coneq[7556]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**5))))-1/19656.
    coneq[7557]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/98280.
    coneq[7558]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/393120.
    coneq[7559]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[7560]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[7561]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/786240.
    coneq[7562]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/294840.
    coneq[7563]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/589680.
    coneq[7564]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/196560.
    coneq[7565]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/393120.
    coneq[7566]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/78624.
    coneq[7567]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/235872.
    coneq[7568]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/471744.
    coneq[7569]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/157248.
    coneq[7570]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/58968.
    coneq[7571]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/117936.
    coneq[7572]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/39312.
    coneq[7573]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/117936.
    coneq[7574]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/235872.
    coneq[7575]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/78624.
    coneq[7576]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/19656.
    coneq[7577]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/58968.
    coneq[7578]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/117936.
    coneq[7579]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/39312.
    coneq[7580]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/39312.
    coneq[7581]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/117936.
    coneq[7582]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/235872.
    coneq[7583]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/78624.
    coneq[7584]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**4))))-1/16380.
    coneq[7585]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/65520.
    coneq[7586]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/196560.
    coneq[7587]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/393120.
    coneq[7588]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/131040.
    coneq[7589]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/49140.
    coneq[7590]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/98280.
    coneq[7591]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/32760.
    coneq[7592]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/65520.
    coneq[7593]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/14742.
    coneq[7594]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/29484.
    coneq[7595]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/58968.
    coneq[7596]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/13104.
    coneq[7597]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/39312.
    coneq[7598]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/78624.
    coneq[7599]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/26208.
    coneq[7600]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/9828.
    coneq[7601]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/19656.
    coneq[7602]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c)*dot(A,c))))-1/6552.
    coneq[7603]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/26208.
    coneq[7604]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/78624.
    coneq[7605]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[7606]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/52416.
    coneq[7607]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/29484.
    coneq[7608]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/58968.
    coneq[7609]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/117936.
    coneq[7610]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/19656.
    coneq[7611]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/39312.
    coneq[7612]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/13104.
    coneq[7613]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/26208.
    coneq[7614]=dot(b,dot(A,c**4*dot(A,c**7)))-1/1456.
    coneq[7615]=dot(b,dot(A,c**4*dot(A,dot(A,c**6))))-1/10192.
    coneq[7616]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**5)))))-1/61152.
    coneq[7617]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/305760.
    coneq[7618]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/1223040.
    coneq[7619]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/3669120.
    coneq[7620]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/7338240.
    coneq[7621]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/2446080.
    coneq[7622]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/917280.
    coneq[7623]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/1834560.
    coneq[7624]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/611520.
    coneq[7625]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/1223040.
    coneq[7626]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/244608.
    coneq[7627]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/733824.
    coneq[7628]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/1467648.
    coneq[7629]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/489216.
    coneq[7630]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/183456.
    coneq[7631]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/366912.
    coneq[7632]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/122304.
    coneq[7633]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/366912.
    coneq[7634]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/733824.
    coneq[7635]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/244608.
    coneq[7636]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**4)))))-1/50960.
    coneq[7637]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/203840.
    coneq[7638]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/611520.
    coneq[7639]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/1223040.
    coneq[7640]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/407680.
    coneq[7641]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/152880.
    coneq[7642]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/305760.
    coneq[7643]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/101920.
    coneq[7644]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/203840.
    coneq[7645]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c**3)))))-1/40768.
    coneq[7646]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/122304.
    coneq[7647]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/244608.
    coneq[7648]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/81536.
    coneq[7649]=dot(b,dot(A,c**4*dot(A,dot(A,c**3*dot(A,c**2)))))-1/30576.
    coneq[7650]=dot(b,dot(A,c**4*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/61152.
    coneq[7651]=dot(b,dot(A,c**4*dot(A,dot(A,c**4*dot(A,c)))))-1/20384.
    coneq[7652]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/91728.
    coneq[7653]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/183456.
    coneq[7654]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/366912.
    coneq[7655]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/81536.
    coneq[7656]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/244608.
    coneq[7657]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/489216.
    coneq[7658]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/163072.
    coneq[7659]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/61152.
    coneq[7660]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/122304.
    coneq[7661]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/40768.
    coneq[7662]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/81536.
    coneq[7663]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**5))))-1/8736.
    coneq[7664]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**4)))))-1/43680.
    coneq[7665]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/174720.
    coneq[7666]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/524160.
    coneq[7667]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1048320.
    coneq[7668]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/349440.
    coneq[7669]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/131040.
    coneq[7670]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/262080.
    coneq[7671]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/87360.
    coneq[7672]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/174720.
    coneq[7673]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c**3)))))-1/34944.
    coneq[7674]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/104832.
    coneq[7675]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/209664.
    coneq[7676]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/69888.
    coneq[7677]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/26208.
    coneq[7678]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/52416.
    coneq[7679]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**3*dot(A,c)))))-1/17472.
    coneq[7680]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/52416.
    coneq[7681]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/104832.
    coneq[7682]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/34944.
    coneq[7683]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**4))))-1/7280.
    coneq[7684]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c**3)))))-1/29120.
    coneq[7685]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/87360.
    coneq[7686]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/174720.
    coneq[7687]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/58240.
    coneq[7688]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/21840.
    coneq[7689]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/43680.
    coneq[7690]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/14560.
    coneq[7691]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/29120.
    coneq[7692]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c**3))))-1/5824.
    coneq[7693]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,dot(A,c**2)))))-1/17472.
    coneq[7694]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/34944.
    coneq[7695]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c*dot(A,c)))))-1/11648.
    coneq[7696]=dot(b,dot(A,c**4*dot(A,c**4*dot(A,c**2))))-1/4368.
    coneq[7697]=dot(b,dot(A,c**4*dot(A,c**4*dot(A,dot(A,c)))))-1/8736.
    coneq[7698]=dot(b,dot(A,c**4*dot(A,c**5*dot(A,c))))-1/2912.
    coneq[7699]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,c**3))))-1/17472.
    coneq[7700]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/52416.
    coneq[7701]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[7702]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/34944.
    coneq[7703]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/34944.
    coneq[7704]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/104832.
    coneq[7705]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[7706]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/69888.
    coneq[7707]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**4))))-1/14560.
    coneq[7708]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/58240.
    coneq[7709]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/174720.
    coneq[7710]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/349440.
    coneq[7711]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/116480.
    coneq[7712]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/43680.
    coneq[7713]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/87360.
    coneq[7714]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/29120.
    coneq[7715]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/58240.
    coneq[7716]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/13104.
    coneq[7717]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/26208.
    coneq[7718]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/52416.
    coneq[7719]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c**3))))-1/11648.
    coneq[7720]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/34944.
    coneq[7721]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/69888.
    coneq[7722]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/23296.
    coneq[7723]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/8736.
    coneq[7724]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/17472.
    coneq[7725]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c)*dot(A,c))))-1/5824.
    coneq[7726]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/17472.
    coneq[7727]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/34944.
    coneq[7728]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/11648.
    coneq[7729]=dot(b,dot(A,c**5*dot(A,c**6)))-1/1274.
    coneq[7730]=dot(b,dot(A,c**5*dot(A,dot(A,c**5))))-1/7644.
    coneq[7731]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**4)))))-1/38220.
    coneq[7732]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/152880.
    coneq[7733]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/458640.
    coneq[7734]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/917280.
    coneq[7735]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/305760.
    coneq[7736]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/114660.
    coneq[7737]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/229320.
    coneq[7738]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/76440.
    coneq[7739]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/152880.
    coneq[7740]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c**3)))))-1/30576.
    coneq[7741]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/91728.
    coneq[7742]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/183456.
    coneq[7743]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/61152.
    coneq[7744]=dot(b,dot(A,c**5*dot(A,dot(A,c**2*dot(A,c**2)))))-1/22932.
    coneq[7745]=dot(b,dot(A,c**5*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/45864.
    coneq[7746]=dot(b,dot(A,c**5*dot(A,dot(A,c**3*dot(A,c)))))-1/15288.
    coneq[7747]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/45864.
    coneq[7748]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/91728.
    coneq[7749]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/30576.
    coneq[7750]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**4))))-1/6370.
    coneq[7751]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c**3)))))-1/25480.
    coneq[7752]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/76440.
    coneq[7753]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/152880.
    coneq[7754]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/50960.
    coneq[7755]=dot(b,dot(A,c**5*dot(A,c*dot(A,c*dot(A,c**2)))))-1/19110.
    coneq[7756]=dot(b,dot(A,c**5*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/38220.
    coneq[7757]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**2*dot(A,c)))))-1/12740.
    coneq[7758]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/25480.
    coneq[7759]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c**3))))-1/5096.
    coneq[7760]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,dot(A,c**2)))))-1/15288.
    coneq[7761]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/30576.
    coneq[7762]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c*dot(A,c)))))-1/10192.
    coneq[7763]=dot(b,dot(A,c**5*dot(A,c**3*dot(A,c**2))))-1/3822.
    coneq[7764]=dot(b,dot(A,c**5*dot(A,c**3*dot(A,dot(A,c)))))-1/7644.
    coneq[7765]=dot(b,dot(A,c**5*dot(A,c**4*dot(A,c))))-1/2548.
    coneq[7766]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)*dot(A,c**2))))-1/11466.
    coneq[7767]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/22932.
    coneq[7768]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/45864.
    coneq[7769]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c**3))))-1/10192.
    coneq[7770]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/30576.
    coneq[7771]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/61152.
    coneq[7772]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/20384.
    coneq[7773]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)*dot(A,c**2))))-1/7644.
    coneq[7774]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/15288.
    coneq[7775]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c)*dot(A,c))))-1/5096.
    coneq[7776]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/10192.
    coneq[7777]=dot(b,dot(A,c**6*dot(A,c**5)))-1/1092.
    coneq[7778]=dot(b,dot(A,c**6*dot(A,dot(A,c**4))))-1/5460.
    coneq[7779]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c**3)))))-1/21840.
    coneq[7780]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/65520.
    coneq[7781]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/131040.
    coneq[7782]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/43680.
    coneq[7783]=dot(b,dot(A,c**6*dot(A,dot(A,c*dot(A,c**2)))))-1/16380.
    coneq[7784]=dot(b,dot(A,c**6*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/32760.
    coneq[7785]=dot(b,dot(A,c**6*dot(A,dot(A,c**2*dot(A,c)))))-1/10920.
    coneq[7786]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/21840.
    coneq[7787]=dot(b,dot(A,c**6*dot(A,c*dot(A,c**3))))-1/4368.
    coneq[7788]=dot(b,dot(A,c**6*dot(A,c*dot(A,dot(A,c**2)))))-1/13104.
    coneq[7789]=dot(b,dot(A,c**6*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/26208.
    coneq[7790]=dot(b,dot(A,c**6*dot(A,c*dot(A,c*dot(A,c)))))-1/8736.
    coneq[7791]=dot(b,dot(A,c**6*dot(A,c**2*dot(A,c**2))))-1/3276.
    coneq[7792]=dot(b,dot(A,c**6*dot(A,c**2*dot(A,dot(A,c)))))-1/6552.
    coneq[7793]=dot(b,dot(A,c**6*dot(A,c**3*dot(A,c))))-1/2184.
    coneq[7794]=dot(b,dot(A,c**6*dot(A,dot(A,c)*dot(A,c**2))))-1/6552.
    coneq[7795]=dot(b,dot(A,c**6*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/13104.
    coneq[7796]=dot(b,dot(A,c**6*dot(A,c*dot(A,c)*dot(A,c))))-1/4368.
    coneq[7797]=dot(b,dot(A,c**7*dot(A,c**4)))-1/910.
    coneq[7798]=dot(b,dot(A,c**7*dot(A,dot(A,c**3))))-1/3640.
    coneq[7799]=dot(b,dot(A,c**7*dot(A,dot(A,dot(A,c**2)))))-1/10920.
    coneq[7800]=dot(b,dot(A,c**7*dot(A,dot(A,dot(A,dot(A,c))))))-1/21840.
    coneq[7801]=dot(b,dot(A,c**7*dot(A,dot(A,c*dot(A,c)))))-1/7280.
    coneq[7802]=dot(b,dot(A,c**7*dot(A,c*dot(A,c**2))))-1/2730.
    coneq[7803]=dot(b,dot(A,c**7*dot(A,c*dot(A,dot(A,c)))))-1/5460.
    coneq[7804]=dot(b,dot(A,c**7*dot(A,c**2*dot(A,c))))-1/1820.
    coneq[7805]=dot(b,dot(A,c**7*dot(A,dot(A,c)*dot(A,c))))-1/3640.
    coneq[7806]=dot(b,dot(A,c**8*dot(A,c**3)))-1/728.
    coneq[7807]=dot(b,dot(A,c**8*dot(A,dot(A,c**2))))-1/2184.
    coneq[7808]=dot(b,dot(A,c**8*dot(A,dot(A,dot(A,c)))))-1/4368.
    coneq[7809]=dot(b,dot(A,c**8*dot(A,c*dot(A,c))))-1/1456.
    coneq[7810]=dot(b,dot(A,c**9*dot(A,c**2)))-1/546.
    coneq[7811]=dot(b,dot(A,c**9*dot(A,dot(A,c))))-1/1092.
    coneq[7812]=dot(b,dot(A,c**10*dot(A,c)))-1/364.
    coneq[7813]=dot(b,dot(A,dot(A,c**5)*dot(A,c**5)))-1/6552.
    coneq[7814]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,c**4))))-1/32760.
    coneq[7815]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,dot(A,c**3)))))-1/131040.
    coneq[7816]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/393120.
    coneq[7817]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[7818]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/262080.
    coneq[7819]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,c*dot(A,c**2)))))-1/98280.
    coneq[7820]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/196560.
    coneq[7821]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,c**2*dot(A,c)))))-1/65520.
    coneq[7822]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/131040.
    coneq[7823]=dot(b,dot(A,dot(A,c**5)*dot(A,c*dot(A,c**3))))-1/26208.
    coneq[7824]=dot(b,dot(A,dot(A,c**5)*dot(A,c*dot(A,dot(A,c**2)))))-1/78624.
    coneq[7825]=dot(b,dot(A,dot(A,c**5)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[7826]=dot(b,dot(A,dot(A,c**5)*dot(A,c*dot(A,c*dot(A,c)))))-1/52416.
    coneq[7827]=dot(b,dot(A,dot(A,c**5)*dot(A,c**2*dot(A,c**2))))-1/19656.
    coneq[7828]=dot(b,dot(A,dot(A,c**5)*dot(A,c**2*dot(A,dot(A,c)))))-1/39312.
    coneq[7829]=dot(b,dot(A,dot(A,c**5)*dot(A,c**3*dot(A,c))))-1/13104.
    coneq[7830]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,c)*dot(A,c**2))))-1/39312.
    coneq[7831]=dot(b,dot(A,dot(A,c**5)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/78624.
    coneq[7832]=dot(b,dot(A,dot(A,c**5)*dot(A,c*dot(A,c)*dot(A,c))))-1/26208.
    coneq[7833]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,c**4))))-1/163800.
    coneq[7834]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c**3)))))-1/655200.
    coneq[7835]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1965600.
    coneq[7836]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/3931200.
    coneq[7837]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1310400.
    coneq[7838]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,c*dot(A,c**2)))))-1/491400.
    coneq[7839]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/982800.
    coneq[7840]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,c**2*dot(A,c)))))-1/327600.
    coneq[7841]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/655200.
    coneq[7842]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c*dot(A,c**3))))-1/131040.
    coneq[7843]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c*dot(A,dot(A,c**2)))))-1/393120.
    coneq[7844]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/786240.
    coneq[7845]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c*dot(A,c*dot(A,c)))))-1/262080.
    coneq[7846]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c**2*dot(A,c**2))))-1/98280.
    coneq[7847]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c**2*dot(A,dot(A,c)))))-1/196560.
    coneq[7848]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c**3*dot(A,c))))-1/65520.
    coneq[7849]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,c)*dot(A,c**2))))-1/196560.
    coneq[7850]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/393120.
    coneq[7851]=dot(b,dot(A,dot(A,dot(A,c**4))*dot(A,c*dot(A,c)*dot(A,c))))-1/131040.
    coneq[7852]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**3)))))-1/2620800.
    coneq[7853]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/7862400.
    coneq[7854]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/15724800.
    coneq[7855]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/5241600.
    coneq[7856]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c**2)))))-1/1965600.
    coneq[7857]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/3931200.
    coneq[7858]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2*dot(A,c)))))-1/1310400.
    coneq[7859]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/2620800.
    coneq[7860]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**3))))-1/524160.
    coneq[7861]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c**2)))))-1/1572480.
    coneq[7862]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/3144960.
    coneq[7863]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c*dot(A,c)))))-1/1048320.
    coneq[7864]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c**2))))-1/393120.
    coneq[7865]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,dot(A,c)))))-1/786240.
    coneq[7866]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3*dot(A,c))))-1/262080.
    coneq[7867]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c**2))))-1/786240.
    coneq[7868]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/1572480.
    coneq[7869]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)*dot(A,c))))-1/524160.
    coneq[7870]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/23587200.
    coneq[7871]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/47174400.
    coneq[7872]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/15724800.
    coneq[7873]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c**2)))))-1/5896800.
    coneq[7874]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/11793600.
    coneq[7875]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2*dot(A,c)))))-1/3931200.
    coneq[7876]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/7862400.
    coneq[7877]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**3))))-1/1572480.
    coneq[7878]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c**2)))))-1/4717440.
    coneq[7879]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/9434880.
    coneq[7880]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c*dot(A,c)))))-1/3144960.
    coneq[7881]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c**2))))-1/1179360.
    coneq[7882]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,dot(A,c)))))-1/2358720.
    coneq[7883]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3*dot(A,c))))-1/786240.
    coneq[7884]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c**2))))-1/2358720.
    coneq[7885]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/4717440.
    coneq[7886]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)*dot(A,c))))-1/1572480.
    coneq[7887]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/94348800.
    coneq[7888]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/31449600.
    coneq[7889]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c**2)))))-1/11793600.
    coneq[7890]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/23587200.
    coneq[7891]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2*dot(A,c)))))-1/7862400.
    coneq[7892]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/15724800.
    coneq[7893]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**3))))-1/3144960.
    coneq[7894]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c**2)))))-1/9434880.
    coneq[7895]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/18869760.
    coneq[7896]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c*dot(A,c)))))-1/6289920.
    coneq[7897]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c**2))))-1/2358720.
    coneq[7898]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,dot(A,c)))))-1/4717440.
    coneq[7899]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3*dot(A,c))))-1/1572480.
    coneq[7900]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c**2))))-1/4717440.
    coneq[7901]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/9434880.
    coneq[7902]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)*dot(A,c))))-1/3144960.
    coneq[7903]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/10483200.
    coneq[7904]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c**2)))))-1/3931200.
    coneq[7905]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/7862400.
    coneq[7906]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2*dot(A,c)))))-1/2620800.
    coneq[7907]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/5241600.
    coneq[7908]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**3))))-1/1048320.
    coneq[7909]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c**2)))))-1/3144960.
    coneq[7910]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/6289920.
    coneq[7911]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c*dot(A,c)))))-1/2096640.
    coneq[7912]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c**2))))-1/786240.
    coneq[7913]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,dot(A,c)))))-1/1572480.
    coneq[7914]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3*dot(A,c))))-1/524160.
    coneq[7915]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2))))-1/1572480.
    coneq[7916]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/3144960.
    coneq[7917]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c))))-1/1048320.
    coneq[7918]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2)))))-1/1474200.
    coneq[7919]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/2948400.
    coneq[7920]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c)))))-1/982800.
    coneq[7921]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/1965600.
    coneq[7922]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**3))))-1/393120.
    coneq[7923]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2)))))-1/1179360.
    coneq[7924]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/2358720.
    coneq[7925]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c)))))-1/786240.
    coneq[7926]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c**2))))-1/294840.
    coneq[7927]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c)))))-1/589680.
    coneq[7928]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3*dot(A,c))))-1/196560.
    coneq[7929]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2))))-1/589680.
    coneq[7930]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/1179360.
    coneq[7931]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c))))-1/393120.
    coneq[7932]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/5896800.
    coneq[7933]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c)))))-1/1965600.
    coneq[7934]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/3931200.
    coneq[7935]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**3))))-1/786240.
    coneq[7936]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2)))))-1/2358720.
    coneq[7937]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/4717440.
    coneq[7938]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c)))))-1/1572480.
    coneq[7939]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2))))-1/589680.
    coneq[7940]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c)))))-1/1179360.
    coneq[7941]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3*dot(A,c))))-1/393120.
    coneq[7942]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2))))-1/1179360.
    coneq[7943]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/2358720.
    coneq[7944]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c))))-1/786240.
    coneq[7945]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/655200.
    coneq[7946]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/1310400.
    coneq[7947]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**3))))-1/262080.
    coneq[7948]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/786240.
    coneq[7949]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/1572480.
    coneq[7950]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/524160.
    coneq[7951]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/196560.
    coneq[7952]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/393120.
    coneq[7953]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3*dot(A,c))))-1/131040.
    coneq[7954]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/393120.
    coneq[7955]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/786240.
    coneq[7956]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/262080.
    coneq[7957]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/2620800.
    coneq[7958]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**3))))-1/524160.
    coneq[7959]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/1572480.
    coneq[7960]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/3144960.
    coneq[7961]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/1048320.
    coneq[7962]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/393120.
    coneq[7963]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/786240.
    coneq[7964]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3*dot(A,c))))-1/262080.
    coneq[7965]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/786240.
    coneq[7966]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/1572480.
    coneq[7967]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/524160.
    coneq[7968]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**3))))-1/104832.
    coneq[7969]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2)))))-1/314496.
    coneq[7970]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[7971]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c)))))-1/209664.
    coneq[7972]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c**2*dot(A,c**2))))-1/78624.
    coneq[7973]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c)))))-1/157248.
    coneq[7974]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c**3*dot(A,c))))-1/52416.
    coneq[7975]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2))))-1/157248.
    coneq[7976]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/314496.
    coneq[7977]=dot(b,dot(A,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c))))-1/104832.
    coneq[7978]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2)))))-1/943488.
    coneq[7979]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/1886976.
    coneq[7980]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c)))))-1/628992.
    coneq[7981]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2))))-1/235872.
    coneq[7982]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c)))))-1/471744.
    coneq[7983]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c))))-1/157248.
    coneq[7984]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2))))-1/471744.
    coneq[7985]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/943488.
    coneq[7986]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c))))-1/314496.
    coneq[7987]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/3773952.
    coneq[7988]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c)))))-1/1257984.
    coneq[7989]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2))))-1/471744.
    coneq[7990]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c)))))-1/943488.
    coneq[7991]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c))))-1/314496.
    coneq[7992]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2))))-1/943488.
    coneq[7993]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/1886976.
    coneq[7994]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c))))-1/628992.
    coneq[7995]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/419328.
    coneq[7996]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/157248.
    coneq[7997]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/314496.
    coneq[7998]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c))))-1/104832.
    coneq[7999]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/314496.
    coneq[8000]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/628992.
    coneq[8001]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/209664.
    coneq[8002]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/58968.
    coneq[8003]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/117936.
    coneq[8004]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/39312.
    coneq[8005]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/117936.
    coneq[8006]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/235872.
    coneq[8007]=dot(b,dot(A,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/78624.
    coneq[8008]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/235872.
    coneq[8009]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/78624.
    coneq[8010]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/235872.
    coneq[8011]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/471744.
    coneq[8012]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/157248.
    coneq[8013]=dot(b,dot(A,dot(A,c**3*dot(A,c))*dot(A,c**3*dot(A,c))))-1/26208.
    coneq[8014]=dot(b,dot(A,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/78624.
    coneq[8015]=dot(b,dot(A,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/157248.
    coneq[8016]=dot(b,dot(A,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/52416.
    coneq[8017]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/235872.
    coneq[8018]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/471744.
    coneq[8019]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/157248.
    coneq[8020]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/943488.
    coneq[8021]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/314496.
    coneq[8022]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/104832.
    coneq[8023]=dot(b,dot(A,dot(A,c**4)*dot(A,c**6)))-1/6370.
    coneq[8024]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**5))))-1/38220.
    coneq[8025]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**4)))))-1/191100.
    coneq[8026]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/764400.
    coneq[8027]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2293200.
    coneq[8028]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4586400.
    coneq[8029]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1528800.
    coneq[8030]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/573300.
    coneq[8031]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1146600.
    coneq[8032]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/382200.
    coneq[8033]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/764400.
    coneq[8034]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c**3)))))-1/152880.
    coneq[8035]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/458640.
    coneq[8036]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/917280.
    coneq[8037]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/305760.
    coneq[8038]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/114660.
    coneq[8039]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/229320.
    coneq[8040]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**3*dot(A,c)))))-1/76440.
    coneq[8041]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/229320.
    coneq[8042]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/458640.
    coneq[8043]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/152880.
    coneq[8044]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**4))))-1/31850.
    coneq[8045]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c**3)))))-1/127400.
    coneq[8046]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/382200.
    coneq[8047]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/764400.
    coneq[8048]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/254800.
    coneq[8049]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/95550.
    coneq[8050]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/191100.
    coneq[8051]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/63700.
    coneq[8052]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/127400.
    coneq[8053]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c**3))))-1/25480.
    coneq[8054]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/76440.
    coneq[8055]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/152880.
    coneq[8056]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/50960.
    coneq[8057]=dot(b,dot(A,dot(A,c**4)*dot(A,c**3*dot(A,c**2))))-1/19110.
    coneq[8058]=dot(b,dot(A,dot(A,c**4)*dot(A,c**3*dot(A,dot(A,c)))))-1/38220.
    coneq[8059]=dot(b,dot(A,dot(A,c**4)*dot(A,c**4*dot(A,c))))-1/12740.
    coneq[8060]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/57330.
    coneq[8061]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/114660.
    coneq[8062]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/229320.
    coneq[8063]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c**3))))-1/50960.
    coneq[8064]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/152880.
    coneq[8065]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/305760.
    coneq[8066]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/101920.
    coneq[8067]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/38220.
    coneq[8068]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/76440.
    coneq[8069]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/25480.
    coneq[8070]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/50960.
    coneq[8071]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**6)))-1/25480.
    coneq[8072]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**5))))-1/152880.
    coneq[8073]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**4)))))-1/764400.
    coneq[8074]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/3057600.
    coneq[8075]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/9172800.
    coneq[8076]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/18345600.
    coneq[8077]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/6115200.
    coneq[8078]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/2293200.
    coneq[8079]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/4586400.
    coneq[8080]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/1528800.
    coneq[8081]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3057600.
    coneq[8082]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c**3)))))-1/611520.
    coneq[8083]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/1834560.
    coneq[8084]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3669120.
    coneq[8085]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/1223040.
    coneq[8086]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/458640.
    coneq[8087]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/917280.
    coneq[8088]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3*dot(A,c)))))-1/305760.
    coneq[8089]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/917280.
    coneq[8090]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1834560.
    coneq[8091]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/611520.
    coneq[8092]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**4))))-1/127400.
    coneq[8093]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c**3)))))-1/509600.
    coneq[8094]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/1528800.
    coneq[8095]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3057600.
    coneq[8096]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/1019200.
    coneq[8097]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/382200.
    coneq[8098]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/764400.
    coneq[8099]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/254800.
    coneq[8100]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/509600.
    coneq[8101]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c**3))))-1/101920.
    coneq[8102]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/305760.
    coneq[8103]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/611520.
    coneq[8104]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/203840.
    coneq[8105]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**3*dot(A,c**2))))-1/76440.
    coneq[8106]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**3*dot(A,dot(A,c)))))-1/152880.
    coneq[8107]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**4*dot(A,c))))-1/50960.
    coneq[8108]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/229320.
    coneq[8109]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/458640.
    coneq[8110]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/917280.
    coneq[8111]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**3))))-1/203840.
    coneq[8112]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/611520.
    coneq[8113]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/1223040.
    coneq[8114]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/407680.
    coneq[8115]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/152880.
    coneq[8116]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/305760.
    coneq[8117]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/101920.
    coneq[8118]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/203840.
    coneq[8119]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**6)))-1/76440.
    coneq[8120]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**5))))-1/458640.
    coneq[8121]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**4)))))-1/2293200.
    coneq[8122]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/9172800.
    coneq[8123]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/27518400.
    coneq[8124]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/55036800.
    coneq[8125]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/18345600.
    coneq[8126]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/6879600.
    coneq[8127]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/13759200.
    coneq[8128]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/4586400.
    coneq[8129]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/9172800.
    coneq[8130]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**3)))))-1/1834560.
    coneq[8131]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/5503680.
    coneq[8132]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/11007360.
    coneq[8133]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/3669120.
    coneq[8134]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/1375920.
    coneq[8135]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/2751840.
    coneq[8136]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3*dot(A,c)))))-1/917280.
    coneq[8137]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/2751840.
    coneq[8138]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/5503680.
    coneq[8139]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/1834560.
    coneq[8140]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**4))))-1/382200.
    coneq[8141]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**3)))))-1/1528800.
    coneq[8142]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/4586400.
    coneq[8143]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/9172800.
    coneq[8144]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/3057600.
    coneq[8145]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/1146600.
    coneq[8146]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/2293200.
    coneq[8147]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/764400.
    coneq[8148]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/1528800.
    coneq[8149]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**3))))-1/305760.
    coneq[8150]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/917280.
    coneq[8151]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/1834560.
    coneq[8152]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/611520.
    coneq[8153]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c**2))))-1/229320.
    coneq[8154]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,dot(A,c)))))-1/458640.
    coneq[8155]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4*dot(A,c))))-1/152880.
    coneq[8156]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/687960.
    coneq[8157]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/1375920.
    coneq[8158]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/2751840.
    coneq[8159]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**3))))-1/611520.
    coneq[8160]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/1834560.
    coneq[8161]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/3669120.
    coneq[8162]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/1223040.
    coneq[8163]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/458640.
    coneq[8164]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/917280.
    coneq[8165]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/305760.
    coneq[8166]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/611520.
    coneq[8167]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**6)))-1/152880.
    coneq[8168]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**5))))-1/917280.
    coneq[8169]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**4)))))-1/4586400.
    coneq[8170]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/18345600.
    coneq[8171]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/55036800.
    coneq[8172]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/110073600.
    coneq[8173]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/36691200.
    coneq[8174]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/13759200.
    coneq[8175]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/27518400.
    coneq[8176]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/9172800.
    coneq[8177]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/18345600.
    coneq[8178]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**3)))))-1/3669120.
    coneq[8179]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/11007360.
    coneq[8180]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/22014720.
    coneq[8181]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/7338240.
    coneq[8182]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/2751840.
    coneq[8183]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/5503680.
    coneq[8184]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3*dot(A,c)))))-1/1834560.
    coneq[8185]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/5503680.
    coneq[8186]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/11007360.
    coneq[8187]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/3669120.
    coneq[8188]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**4))))-1/764400.
    coneq[8189]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**3)))))-1/3057600.
    coneq[8190]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/9172800.
    coneq[8191]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/18345600.
    coneq[8192]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/6115200.
    coneq[8193]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/2293200.
    coneq[8194]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/4586400.
    coneq[8195]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/1528800.
    coneq[8196]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/3057600.
    coneq[8197]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**3))))-1/611520.
    coneq[8198]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/1834560.
    coneq[8199]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/3669120.
    coneq[8200]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/1223040.
    coneq[8201]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c**2))))-1/458640.
    coneq[8202]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,dot(A,c)))))-1/917280.
    coneq[8203]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4*dot(A,c))))-1/305760.
    coneq[8204]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/1375920.
    coneq[8205]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/2751840.
    coneq[8206]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/5503680.
    coneq[8207]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**3))))-1/1223040.
    coneq[8208]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/3669120.
    coneq[8209]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/7338240.
    coneq[8210]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/2446080.
    coneq[8211]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/917280.
    coneq[8212]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/1834560.
    coneq[8213]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/611520.
    coneq[8214]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/1223040.
    coneq[8215]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**6)))-1/50960.
    coneq[8216]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**5))))-1/305760.
    coneq[8217]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**4)))))-1/1528800.
    coneq[8218]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/6115200.
    coneq[8219]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/18345600.
    coneq[8220]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/36691200.
    coneq[8221]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/12230400.
    coneq[8222]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/4586400.
    coneq[8223]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/9172800.
    coneq[8224]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/3057600.
    coneq[8225]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/6115200.
    coneq[8226]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**3)))))-1/1223040.
    coneq[8227]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/3669120.
    coneq[8228]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/7338240.
    coneq[8229]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/2446080.
    coneq[8230]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/917280.
    coneq[8231]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/1834560.
    coneq[8232]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3*dot(A,c)))))-1/611520.
    coneq[8233]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/1834560.
    coneq[8234]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/3669120.
    coneq[8235]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/1223040.
    coneq[8236]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**4))))-1/254800.
    coneq[8237]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**3)))))-1/1019200.
    coneq[8238]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/3057600.
    coneq[8239]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/6115200.
    coneq[8240]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/2038400.
    coneq[8241]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/764400.
    coneq[8242]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/1528800.
    coneq[8243]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/509600.
    coneq[8244]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/1019200.
    coneq[8245]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**3))))-1/203840.
    coneq[8246]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/611520.
    coneq[8247]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/1223040.
    coneq[8248]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/407680.
    coneq[8249]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c**2))))-1/152880.
    coneq[8250]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,dot(A,c)))))-1/305760.
    coneq[8251]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4*dot(A,c))))-1/101920.
    coneq[8252]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/458640.
    coneq[8253]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/917280.
    coneq[8254]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/1834560.
    coneq[8255]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**3))))-1/407680.
    coneq[8256]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/1223040.
    coneq[8257]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/2446080.
    coneq[8258]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/815360.
    coneq[8259]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/305760.
    coneq[8260]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/611520.
    coneq[8261]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/203840.
    coneq[8262]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/407680.
    coneq[8263]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**6)))-1/19110.
    coneq[8264]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**5))))-1/114660.
    coneq[8265]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**4)))))-1/573300.
    coneq[8266]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/2293200.
    coneq[8267]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/6879600.
    coneq[8268]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/13759200.
    coneq[8269]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/4586400.
    coneq[8270]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/1719900.
    coneq[8271]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3439800.
    coneq[8272]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/1146600.
    coneq[8273]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2293200.
    coneq[8274]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**3)))))-1/458640.
    coneq[8275]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/1375920.
    coneq[8276]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2751840.
    coneq[8277]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/917280.
    coneq[8278]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/343980.
    coneq[8279]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/687960.
    coneq[8280]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3*dot(A,c)))))-1/229320.
    coneq[8281]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/687960.
    coneq[8282]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1375920.
    coneq[8283]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/458640.
    coneq[8284]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**4))))-1/95550.
    coneq[8285]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**3)))))-1/382200.
    coneq[8286]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/1146600.
    coneq[8287]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2293200.
    coneq[8288]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/764400.
    coneq[8289]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/286650.
    coneq[8290]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/573300.
    coneq[8291]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/191100.
    coneq[8292]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/382200.
    coneq[8293]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c**3))))-1/76440.
    coneq[8294]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/229320.
    coneq[8295]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/458640.
    coneq[8296]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/152880.
    coneq[8297]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**3*dot(A,c**2))))-1/57330.
    coneq[8298]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**3*dot(A,dot(A,c)))))-1/114660.
    coneq[8299]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**4*dot(A,c))))-1/38220.
    coneq[8300]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/171990.
    coneq[8301]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/343980.
    coneq[8302]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/687960.
    coneq[8303]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**3))))-1/152880.
    coneq[8304]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/458640.
    coneq[8305]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/917280.
    coneq[8306]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/305760.
    coneq[8307]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/114660.
    coneq[8308]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/229320.
    coneq[8309]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/76440.
    coneq[8310]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/152880.
    coneq[8311]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**6)))-1/38220.
    coneq[8312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**5))))-1/229320.
    coneq[8313]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**4)))))-1/1146600.
    coneq[8314]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/4586400.
    coneq[8315]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/13759200.
    coneq[8316]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/27518400.
    coneq[8317]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/9172800.
    coneq[8318]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/3439800.
    coneq[8319]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/6879600.
    coneq[8320]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/2293200.
    coneq[8321]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/4586400.
    coneq[8322]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**3)))))-1/917280.
    coneq[8323]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/2751840.
    coneq[8324]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/5503680.
    coneq[8325]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/1834560.
    coneq[8326]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/687960.
    coneq[8327]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/1375920.
    coneq[8328]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,c)))))-1/458640.
    coneq[8329]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/1375920.
    coneq[8330]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/2751840.
    coneq[8331]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/917280.
    coneq[8332]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**4))))-1/191100.
    coneq[8333]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**3)))))-1/764400.
    coneq[8334]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/2293200.
    coneq[8335]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4586400.
    coneq[8336]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/1528800.
    coneq[8337]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/573300.
    coneq[8338]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/1146600.
    coneq[8339]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/382200.
    coneq[8340]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/764400.
    coneq[8341]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**3))))-1/152880.
    coneq[8342]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/458640.
    coneq[8343]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/917280.
    coneq[8344]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/305760.
    coneq[8345]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c**2))))-1/114660.
    coneq[8346]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,c)))))-1/229320.
    coneq[8347]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4*dot(A,c))))-1/76440.
    coneq[8348]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/343980.
    coneq[8349]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/687960.
    coneq[8350]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/1375920.
    coneq[8351]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**3))))-1/305760.
    coneq[8352]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/917280.
    coneq[8353]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/1834560.
    coneq[8354]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/611520.
    coneq[8355]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/229320.
    coneq[8356]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/458640.
    coneq[8357]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/152880.
    coneq[8358]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/305760.
    coneq[8359]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**6)))-1/12740.
    coneq[8360]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**5))))-1/76440.
    coneq[8361]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/382200.
    coneq[8362]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/1528800.
    coneq[8363]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4586400.
    coneq[8364]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/9172800.
    coneq[8365]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3057600.
    coneq[8366]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/1146600.
    coneq[8367]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2293200.
    coneq[8368]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/764400.
    coneq[8369]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1528800.
    coneq[8370]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/305760.
    coneq[8371]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/917280.
    coneq[8372]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1834560.
    coneq[8373]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/611520.
    coneq[8374]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/229320.
    coneq[8375]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/458640.
    coneq[8376]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/152880.
    coneq[8377]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/458640.
    coneq[8378]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/917280.
    coneq[8379]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/305760.
    coneq[8380]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**4))))-1/63700.
    coneq[8381]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/254800.
    coneq[8382]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/764400.
    coneq[8383]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1528800.
    coneq[8384]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/509600.
    coneq[8385]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/191100.
    coneq[8386]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/382200.
    coneq[8387]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/127400.
    coneq[8388]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/254800.
    coneq[8389]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/50960.
    coneq[8390]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/152880.
    coneq[8391]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/305760.
    coneq[8392]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/101920.
    coneq[8393]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/38220.
    coneq[8394]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/76440.
    coneq[8395]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**4*dot(A,c))))-1/25480.
    coneq[8396]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/114660.
    coneq[8397]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/229320.
    coneq[8398]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/458640.
    coneq[8399]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/101920.
    coneq[8400]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/305760.
    coneq[8401]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/611520.
    coneq[8402]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/203840.
    coneq[8403]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/76440.
    coneq[8404]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/152880.
    coneq[8405]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/50960.
    coneq[8406]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/101920.
    coneq[8407]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**6)))-1/25480.
    coneq[8408]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**5))))-1/152880.
    coneq[8409]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/764400.
    coneq[8410]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/3057600.
    coneq[8411]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/9172800.
    coneq[8412]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/18345600.
    coneq[8413]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/6115200.
    coneq[8414]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/2293200.
    coneq[8415]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/4586400.
    coneq[8416]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/1528800.
    coneq[8417]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3057600.
    coneq[8418]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/611520.
    coneq[8419]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/1834560.
    coneq[8420]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3669120.
    coneq[8421]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/1223040.
    coneq[8422]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/458640.
    coneq[8423]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/917280.
    coneq[8424]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/305760.
    coneq[8425]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/917280.
    coneq[8426]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1834560.
    coneq[8427]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/611520.
    coneq[8428]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**4))))-1/127400.
    coneq[8429]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/509600.
    coneq[8430]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/1528800.
    coneq[8431]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3057600.
    coneq[8432]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/1019200.
    coneq[8433]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/382200.
    coneq[8434]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/764400.
    coneq[8435]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/254800.
    coneq[8436]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/509600.
    coneq[8437]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/101920.
    coneq[8438]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/305760.
    coneq[8439]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/611520.
    coneq[8440]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/203840.
    coneq[8441]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/76440.
    coneq[8442]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/152880.
    coneq[8443]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4*dot(A,c))))-1/50960.
    coneq[8444]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/229320.
    coneq[8445]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/458640.
    coneq[8446]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/917280.
    coneq[8447]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/203840.
    coneq[8448]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/611520.
    coneq[8449]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/1223040.
    coneq[8450]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/407680.
    coneq[8451]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/152880.
    coneq[8452]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/305760.
    coneq[8453]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/101920.
    coneq[8454]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/203840.
    coneq[8455]=dot(b,dot(A,dot(A,c**3)*dot(A,c**7)))-1/5824.
    coneq[8456]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**6))))-1/40768.
    coneq[8457]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**5)))))-1/244608.
    coneq[8458]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/1223040.
    coneq[8459]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/4892160.
    coneq[8460]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/14676480.
    coneq[8461]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/29352960.
    coneq[8462]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/9784320.
    coneq[8463]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/3669120.
    coneq[8464]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7338240.
    coneq[8465]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/2446080.
    coneq[8466]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4892160.
    coneq[8467]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/978432.
    coneq[8468]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2935296.
    coneq[8469]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5870592.
    coneq[8470]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1956864.
    coneq[8471]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/733824.
    coneq[8472]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1467648.
    coneq[8473]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/489216.
    coneq[8474]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1467648.
    coneq[8475]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2935296.
    coneq[8476]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/978432.
    coneq[8477]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**4)))))-1/203840.
    coneq[8478]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/815360.
    coneq[8479]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/2446080.
    coneq[8480]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4892160.
    coneq[8481]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1630720.
    coneq[8482]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/611520.
    coneq[8483]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1223040.
    coneq[8484]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/407680.
    coneq[8485]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/815360.
    coneq[8486]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/163072.
    coneq[8487]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/489216.
    coneq[8488]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/978432.
    coneq[8489]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/326144.
    coneq[8490]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/122304.
    coneq[8491]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/244608.
    coneq[8492]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**4*dot(A,c)))))-1/81536.
    coneq[8493]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/366912.
    coneq[8494]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/733824.
    coneq[8495]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1467648.
    coneq[8496]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/326144.
    coneq[8497]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/978432.
    coneq[8498]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1956864.
    coneq[8499]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/652288.
    coneq[8500]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/244608.
    coneq[8501]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/489216.
    coneq[8502]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/163072.
    coneq[8503]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/326144.
    coneq[8504]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**5))))-1/34944.
    coneq[8505]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**4)))))-1/174720.
    coneq[8506]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/698880.
    coneq[8507]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[8508]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[8509]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[8510]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/524160.
    coneq[8511]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1048320.
    coneq[8512]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/349440.
    coneq[8513]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/698880.
    coneq[8514]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/139776.
    coneq[8515]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/419328.
    coneq[8516]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/838656.
    coneq[8517]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/279552.
    coneq[8518]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/104832.
    coneq[8519]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/209664.
    coneq[8520]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/69888.
    coneq[8521]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/209664.
    coneq[8522]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/419328.
    coneq[8523]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/139776.
    coneq[8524]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**4))))-1/29120.
    coneq[8525]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/116480.
    coneq[8526]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/349440.
    coneq[8527]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/698880.
    coneq[8528]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/232960.
    coneq[8529]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/87360.
    coneq[8530]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/174720.
    coneq[8531]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/58240.
    coneq[8532]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/116480.
    coneq[8533]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c**3))))-1/23296.
    coneq[8534]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/69888.
    coneq[8535]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/139776.
    coneq[8536]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/46592.
    coneq[8537]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4*dot(A,c**2))))-1/17472.
    coneq[8538]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4*dot(A,dot(A,c)))))-1/34944.
    coneq[8539]=dot(b,dot(A,dot(A,c**3)*dot(A,c**5*dot(A,c))))-1/11648.
    coneq[8540]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/69888.
    coneq[8541]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/209664.
    coneq[8542]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[8543]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/139776.
    coneq[8544]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/139776.
    coneq[8545]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/419328.
    coneq[8546]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/838656.
    coneq[8547]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/279552.
    coneq[8548]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**4))))-1/58240.
    coneq[8549]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/232960.
    coneq[8550]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/698880.
    coneq[8551]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1397760.
    coneq[8552]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/465920.
    coneq[8553]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/174720.
    coneq[8554]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/349440.
    coneq[8555]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/116480.
    coneq[8556]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/232960.
    coneq[8557]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/52416.
    coneq[8558]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/104832.
    coneq[8559]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/209664.
    coneq[8560]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/46592.
    coneq[8561]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/139776.
    coneq[8562]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/279552.
    coneq[8563]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/93184.
    coneq[8564]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/34944.
    coneq[8565]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/69888.
    coneq[8566]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/23296.
    coneq[8567]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/69888.
    coneq[8568]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/139776.
    coneq[8569]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/46592.
    coneq[8570]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**7)))-1/17472.
    coneq[8571]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**6))))-1/122304.
    coneq[8572]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**5)))))-1/733824.
    coneq[8573]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/3669120.
    coneq[8574]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/14676480.
    coneq[8575]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/44029440.
    coneq[8576]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/88058880.
    coneq[8577]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/29352960.
    coneq[8578]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/11007360.
    coneq[8579]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/22014720.
    coneq[8580]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/7338240.
    coneq[8581]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/14676480.
    coneq[8582]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/2935296.
    coneq[8583]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/8805888.
    coneq[8584]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/17611776.
    coneq[8585]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/5870592.
    coneq[8586]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/2201472.
    coneq[8587]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/4402944.
    coneq[8588]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/1467648.
    coneq[8589]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/4402944.
    coneq[8590]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/8805888.
    coneq[8591]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/2935296.
    coneq[8592]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**4)))))-1/611520.
    coneq[8593]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/2446080.
    coneq[8594]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/7338240.
    coneq[8595]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/14676480.
    coneq[8596]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/4892160.
    coneq[8597]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/1834560.
    coneq[8598]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/3669120.
    coneq[8599]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/1223040.
    coneq[8600]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/2446080.
    coneq[8601]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c**3)))))-1/489216.
    coneq[8602]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/1467648.
    coneq[8603]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/2935296.
    coneq[8604]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/978432.
    coneq[8605]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3*dot(A,c**2)))))-1/366912.
    coneq[8606]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/733824.
    coneq[8607]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4*dot(A,c)))))-1/244608.
    coneq[8608]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/1100736.
    coneq[8609]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/2201472.
    coneq[8610]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/4402944.
    coneq[8611]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/978432.
    coneq[8612]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/2935296.
    coneq[8613]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/5870592.
    coneq[8614]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1956864.
    coneq[8615]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/733824.
    coneq[8616]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/1467648.
    coneq[8617]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/489216.
    coneq[8618]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/978432.
    coneq[8619]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**5))))-1/104832.
    coneq[8620]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**4)))))-1/524160.
    coneq[8621]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/2096640.
    coneq[8622]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/6289920.
    coneq[8623]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/12579840.
    coneq[8624]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/4193280.
    coneq[8625]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/1572480.
    coneq[8626]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3144960.
    coneq[8627]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/1048320.
    coneq[8628]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2096640.
    coneq[8629]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c**3)))))-1/419328.
    coneq[8630]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/1257984.
    coneq[8631]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2515968.
    coneq[8632]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/838656.
    coneq[8633]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/314496.
    coneq[8634]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/628992.
    coneq[8635]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3*dot(A,c)))))-1/209664.
    coneq[8636]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/628992.
    coneq[8637]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1257984.
    coneq[8638]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/419328.
    coneq[8639]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**4))))-1/87360.
    coneq[8640]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c**3)))))-1/349440.
    coneq[8641]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/1048320.
    coneq[8642]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[8643]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/698880.
    coneq[8644]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/262080.
    coneq[8645]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/524160.
    coneq[8646]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/174720.
    coneq[8647]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/349440.
    coneq[8648]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c**3))))-1/69888.
    coneq[8649]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,dot(A,c**2)))))-1/209664.
    coneq[8650]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[8651]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c*dot(A,c)))))-1/139776.
    coneq[8652]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4*dot(A,c**2))))-1/52416.
    coneq[8653]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4*dot(A,dot(A,c)))))-1/104832.
    coneq[8654]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**5*dot(A,c))))-1/34944.
    coneq[8655]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c**3))))-1/209664.
    coneq[8656]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/628992.
    coneq[8657]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[8658]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/419328.
    coneq[8659]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/419328.
    coneq[8660]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/1257984.
    coneq[8661]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/2515968.
    coneq[8662]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/838656.
    coneq[8663]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**4))))-1/174720.
    coneq[8664]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/698880.
    coneq[8665]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/2096640.
    coneq[8666]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4193280.
    coneq[8667]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/1397760.
    coneq[8668]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/524160.
    coneq[8669]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/1048320.
    coneq[8670]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/349440.
    coneq[8671]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/698880.
    coneq[8672]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/157248.
    coneq[8673]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/314496.
    coneq[8674]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/628992.
    coneq[8675]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c**3))))-1/139776.
    coneq[8676]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/419328.
    coneq[8677]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/838656.
    coneq[8678]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/279552.
    coneq[8679]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/104832.
    coneq[8680]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/209664.
    coneq[8681]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)*dot(A,c))))-1/69888.
    coneq[8682]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/209664.
    coneq[8683]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/419328.
    coneq[8684]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/139776.
    coneq[8685]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**7)))-1/34944.
    coneq[8686]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**6))))-1/244608.
    coneq[8687]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**5)))))-1/1467648.
    coneq[8688]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/7338240.
    coneq[8689]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/29352960.
    coneq[8690]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/88058880.
    coneq[8691]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/176117760.
    coneq[8692]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/58705920.
    coneq[8693]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/22014720.
    coneq[8694]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/44029440.
    coneq[8695]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/14676480.
    coneq[8696]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/29352960.
    coneq[8697]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/5870592.
    coneq[8698]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/17611776.
    coneq[8699]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/35223552.
    coneq[8700]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/11741184.
    coneq[8701]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/4402944.
    coneq[8702]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/8805888.
    coneq[8703]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/2935296.
    coneq[8704]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/8805888.
    coneq[8705]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/17611776.
    coneq[8706]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/5870592.
    coneq[8707]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**4)))))-1/1223040.
    coneq[8708]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/4892160.
    coneq[8709]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/14676480.
    coneq[8710]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/29352960.
    coneq[8711]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/9784320.
    coneq[8712]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/3669120.
    coneq[8713]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/7338240.
    coneq[8714]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/2446080.
    coneq[8715]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/4892160.
    coneq[8716]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**3)))))-1/978432.
    coneq[8717]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/2935296.
    coneq[8718]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/5870592.
    coneq[8719]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/1956864.
    coneq[8720]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,c**2)))))-1/733824.
    coneq[8721]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/1467648.
    coneq[8722]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4*dot(A,c)))))-1/489216.
    coneq[8723]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/2201472.
    coneq[8724]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/4402944.
    coneq[8725]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/8805888.
    coneq[8726]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/1956864.
    coneq[8727]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/5870592.
    coneq[8728]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/11741184.
    coneq[8729]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/3913728.
    coneq[8730]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/1467648.
    coneq[8731]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/2935296.
    coneq[8732]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/978432.
    coneq[8733]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/1956864.
    coneq[8734]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**5))))-1/209664.
    coneq[8735]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**4)))))-1/1048320.
    coneq[8736]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/4193280.
    coneq[8737]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/12579840.
    coneq[8738]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/25159680.
    coneq[8739]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/8386560.
    coneq[8740]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/3144960.
    coneq[8741]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/6289920.
    coneq[8742]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/2096640.
    coneq[8743]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/4193280.
    coneq[8744]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**3)))))-1/838656.
    coneq[8745]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/2515968.
    coneq[8746]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/5031936.
    coneq[8747]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/1677312.
    coneq[8748]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/628992.
    coneq[8749]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/1257984.
    coneq[8750]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3*dot(A,c)))))-1/419328.
    coneq[8751]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/1257984.
    coneq[8752]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/2515968.
    coneq[8753]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/838656.
    coneq[8754]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**4))))-1/174720.
    coneq[8755]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**3)))))-1/698880.
    coneq[8756]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/2096640.
    coneq[8757]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/4193280.
    coneq[8758]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/1397760.
    coneq[8759]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/524160.
    coneq[8760]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/1048320.
    coneq[8761]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/349440.
    coneq[8762]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/698880.
    coneq[8763]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c**3))))-1/139776.
    coneq[8764]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,c**2)))))-1/419328.
    coneq[8765]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/838656.
    coneq[8766]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c*dot(A,c)))))-1/279552.
    coneq[8767]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4*dot(A,c**2))))-1/104832.
    coneq[8768]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4*dot(A,dot(A,c)))))-1/209664.
    coneq[8769]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5*dot(A,c))))-1/69888.
    coneq[8770]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**3))))-1/419328.
    coneq[8771]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/1257984.
    coneq[8772]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/2515968.
    coneq[8773]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/838656.
    coneq[8774]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/838656.
    coneq[8775]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/2515968.
    coneq[8776]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/5031936.
    coneq[8777]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/1677312.
    coneq[8778]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**4))))-1/349440.
    coneq[8779]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/1397760.
    coneq[8780]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/4193280.
    coneq[8781]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/8386560.
    coneq[8782]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/2795520.
    coneq[8783]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/1048320.
    coneq[8784]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/2096640.
    coneq[8785]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/698880.
    coneq[8786]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/1397760.
    coneq[8787]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/314496.
    coneq[8788]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/628992.
    coneq[8789]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/1257984.
    coneq[8790]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**3))))-1/279552.
    coneq[8791]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/838656.
    coneq[8792]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/1677312.
    coneq[8793]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/559104.
    coneq[8794]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/209664.
    coneq[8795]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/419328.
    coneq[8796]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)*dot(A,c))))-1/139776.
    coneq[8797]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/419328.
    coneq[8798]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/838656.
    coneq[8799]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/279552.
    coneq[8800]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**7)))-1/11648.
    coneq[8801]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**6))))-1/81536.
    coneq[8802]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**5)))))-1/489216.
    coneq[8803]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/2446080.
    coneq[8804]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/9784320.
    coneq[8805]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/29352960.
    coneq[8806]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/58705920.
    coneq[8807]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/19568640.
    coneq[8808]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/7338240.
    coneq[8809]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/14676480.
    coneq[8810]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/4892160.
    coneq[8811]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/9784320.
    coneq[8812]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/1956864.
    coneq[8813]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/5870592.
    coneq[8814]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/11741184.
    coneq[8815]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/3913728.
    coneq[8816]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/1467648.
    coneq[8817]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/2935296.
    coneq[8818]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/978432.
    coneq[8819]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/2935296.
    coneq[8820]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/5870592.
    coneq[8821]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1956864.
    coneq[8822]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**4)))))-1/407680.
    coneq[8823]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/1630720.
    coneq[8824]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/4892160.
    coneq[8825]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/9784320.
    coneq[8826]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/3261440.
    coneq[8827]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/1223040.
    coneq[8828]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/2446080.
    coneq[8829]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/815360.
    coneq[8830]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1630720.
    coneq[8831]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**3)))))-1/326144.
    coneq[8832]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/978432.
    coneq[8833]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1956864.
    coneq[8834]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/652288.
    coneq[8835]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3*dot(A,c**2)))))-1/244608.
    coneq[8836]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/489216.
    coneq[8837]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4*dot(A,c)))))-1/163072.
    coneq[8838]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/733824.
    coneq[8839]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1467648.
    coneq[8840]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2935296.
    coneq[8841]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/652288.
    coneq[8842]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1956864.
    coneq[8843]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/3913728.
    coneq[8844]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1304576.
    coneq[8845]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/489216.
    coneq[8846]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/978432.
    coneq[8847]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/326144.
    coneq[8848]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/652288.
    coneq[8849]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**5))))-1/69888.
    coneq[8850]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**4)))))-1/349440.
    coneq[8851]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/1397760.
    coneq[8852]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/4193280.
    coneq[8853]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/8386560.
    coneq[8854]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2795520.
    coneq[8855]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/1048320.
    coneq[8856]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2096640.
    coneq[8857]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/698880.
    coneq[8858]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1397760.
    coneq[8859]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**3)))))-1/279552.
    coneq[8860]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/838656.
    coneq[8861]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1677312.
    coneq[8862]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/559104.
    coneq[8863]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/209664.
    coneq[8864]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/419328.
    coneq[8865]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3*dot(A,c)))))-1/139776.
    coneq[8866]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/419328.
    coneq[8867]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/838656.
    coneq[8868]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/279552.
    coneq[8869]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**4))))-1/58240.
    coneq[8870]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**3)))))-1/232960.
    coneq[8871]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/698880.
    coneq[8872]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1397760.
    coneq[8873]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/465920.
    coneq[8874]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/174720.
    coneq[8875]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/349440.
    coneq[8876]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/116480.
    coneq[8877]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/232960.
    coneq[8878]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c**3))))-1/46592.
    coneq[8879]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,dot(A,c**2)))))-1/139776.
    coneq[8880]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/279552.
    coneq[8881]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c*dot(A,c)))))-1/93184.
    coneq[8882]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4*dot(A,c**2))))-1/34944.
    coneq[8883]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4*dot(A,dot(A,c)))))-1/69888.
    coneq[8884]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**5*dot(A,c))))-1/23296.
    coneq[8885]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**3))))-1/139776.
    coneq[8886]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/419328.
    coneq[8887]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/838656.
    coneq[8888]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/279552.
    coneq[8889]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/279552.
    coneq[8890]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/838656.
    coneq[8891]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1677312.
    coneq[8892]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/559104.
    coneq[8893]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**4))))-1/116480.
    coneq[8894]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/465920.
    coneq[8895]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/1397760.
    coneq[8896]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2795520.
    coneq[8897]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/931840.
    coneq[8898]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/349440.
    coneq[8899]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/698880.
    coneq[8900]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/232960.
    coneq[8901]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/465920.
    coneq[8902]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/104832.
    coneq[8903]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/209664.
    coneq[8904]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/419328.
    coneq[8905]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**3))))-1/93184.
    coneq[8906]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/279552.
    coneq[8907]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/559104.
    coneq[8908]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/186368.
    coneq[8909]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/69888.
    coneq[8910]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/139776.
    coneq[8911]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,c))))-1/46592.
    coneq[8912]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/139776.
    coneq[8913]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/279552.
    coneq[8914]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/93184.
    coneq[8915]=dot(b,dot(A,dot(A,c**2)*dot(A,c**8)))-1/4914.
    coneq[8916]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**7))))-1/39312.
    coneq[8917]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**6)))))-1/275184.
    coneq[8918]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/1651104.
    coneq[8919]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/8255520.
    coneq[8920]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/33022080.
    coneq[8921]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/99066240.
    coneq[8922]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/198132480.
    coneq[8923]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/66044160.
    coneq[8924]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/24766560.
    coneq[8925]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/49533120.
    coneq[8926]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/16511040.
    coneq[8927]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/33022080.
    coneq[8928]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/6604416.
    coneq[8929]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/19813248.
    coneq[8930]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/39626496.
    coneq[8931]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/13208832.
    coneq[8932]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/4953312.
    coneq[8933]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/9906624.
    coneq[8934]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/3302208.
    coneq[8935]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/9906624.
    coneq[8936]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/19813248.
    coneq[8937]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/6604416.
    coneq[8938]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/1375920.
    coneq[8939]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/5503680.
    coneq[8940]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/16511040.
    coneq[8941]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/33022080.
    coneq[8942]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/11007360.
    coneq[8943]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/4127760.
    coneq[8944]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/8255520.
    coneq[8945]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2751840.
    coneq[8946]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/5503680.
    coneq[8947]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/1100736.
    coneq[8948]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/3302208.
    coneq[8949]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/6604416.
    coneq[8950]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/2201472.
    coneq[8951]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/825552.
    coneq[8952]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/1651104.
    coneq[8953]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/550368.
    coneq[8954]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2476656.
    coneq[8955]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/4953312.
    coneq[8956]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/9906624.
    coneq[8957]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/2201472.
    coneq[8958]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/6604416.
    coneq[8959]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/13208832.
    coneq[8960]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/4402944.
    coneq[8961]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1651104.
    coneq[8962]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/3302208.
    coneq[8963]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/1100736.
    coneq[8964]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/2201472.
    coneq[8965]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**5)))))-1/235872.
    coneq[8966]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/1179360.
    coneq[8967]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/4717440.
    coneq[8968]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/14152320.
    coneq[8969]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/28304640.
    coneq[8970]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/9434880.
    coneq[8971]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/3538080.
    coneq[8972]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7076160.
    coneq[8973]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/2358720.
    coneq[8974]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4717440.
    coneq[8975]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/943488.
    coneq[8976]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/2830464.
    coneq[8977]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5660928.
    coneq[8978]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1886976.
    coneq[8979]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/707616.
    coneq[8980]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/1415232.
    coneq[8981]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/471744.
    coneq[8982]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/1415232.
    coneq[8983]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2830464.
    coneq[8984]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/943488.
    coneq[8985]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**4)))))-1/196560.
    coneq[8986]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/786240.
    coneq[8987]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[8988]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[8989]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[8990]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/589680.
    coneq[8991]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/1179360.
    coneq[8992]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/393120.
    coneq[8993]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/786240.
    coneq[8994]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c**3)))))-1/157248.
    coneq[8995]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/471744.
    coneq[8996]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[8997]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/314496.
    coneq[8998]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4*dot(A,c**2)))))-1/117936.
    coneq[8999]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/235872.
    coneq[9000]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**5*dot(A,c)))))-1/78624.
    coneq[9001]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/471744.
    coneq[9002]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1415232.
    coneq[9003]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2830464.
    coneq[9004]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/943488.
    coneq[9005]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/943488.
    coneq[9006]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2830464.
    coneq[9007]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/5660928.
    coneq[9008]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1886976.
    coneq[9009]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/393120.
    coneq[9010]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/1572480.
    coneq[9011]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[9012]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[9013]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[9014]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/1179360.
    coneq[9015]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/2358720.
    coneq[9016]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/786240.
    coneq[9017]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[9018]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/353808.
    coneq[9019]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/707616.
    coneq[9020]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1415232.
    coneq[9021]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/314496.
    coneq[9022]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/943488.
    coneq[9023]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[9024]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/628992.
    coneq[9025]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/235872.
    coneq[9026]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/471744.
    coneq[9027]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[9028]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/471744.
    coneq[9029]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/943488.
    coneq[9030]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[9031]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**6))))-1/34398.
    coneq[9032]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**5)))))-1/206388.
    coneq[9033]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/1031940.
    coneq[9034]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/4127760.
    coneq[9035]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/12383280.
    coneq[9036]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/24766560.
    coneq[9037]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/8255520.
    coneq[9038]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/3095820.
    coneq[9039]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/6191640.
    coneq[9040]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/2063880.
    coneq[9041]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4127760.
    coneq[9042]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/825552.
    coneq[9043]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2476656.
    coneq[9044]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4953312.
    coneq[9045]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1651104.
    coneq[9046]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/619164.
    coneq[9047]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1238328.
    coneq[9048]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/412776.
    coneq[9049]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1238328.
    coneq[9050]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2476656.
    coneq[9051]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/825552.
    coneq[9052]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**4)))))-1/171990.
    coneq[9053]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/687960.
    coneq[9054]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/2063880.
    coneq[9055]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4127760.
    coneq[9056]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1375920.
    coneq[9057]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/515970.
    coneq[9058]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1031940.
    coneq[9059]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/343980.
    coneq[9060]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/687960.
    coneq[9061]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/137592.
    coneq[9062]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/412776.
    coneq[9063]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/825552.
    coneq[9064]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/275184.
    coneq[9065]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/103194.
    coneq[9066]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/206388.
    coneq[9067]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4*dot(A,c)))))-1/68796.
    coneq[9068]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/309582.
    coneq[9069]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/619164.
    coneq[9070]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1238328.
    coneq[9071]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/275184.
    coneq[9072]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/825552.
    coneq[9073]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1651104.
    coneq[9074]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/550368.
    coneq[9075]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/206388.
    coneq[9076]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/412776.
    coneq[9077]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/137592.
    coneq[9078]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/275184.
    coneq[9079]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**5))))-1/29484.
    coneq[9080]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**4)))))-1/147420.
    coneq[9081]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/589680.
    coneq[9082]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1769040.
    coneq[9083]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3538080.
    coneq[9084]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1179360.
    coneq[9085]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/442260.
    coneq[9086]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/884520.
    coneq[9087]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/294840.
    coneq[9088]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/589680.
    coneq[9089]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/117936.
    coneq[9090]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/353808.
    coneq[9091]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/707616.
    coneq[9092]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/235872.
    coneq[9093]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/88452.
    coneq[9094]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/176904.
    coneq[9095]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/58968.
    coneq[9096]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/176904.
    coneq[9097]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/353808.
    coneq[9098]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/117936.
    coneq[9099]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**4))))-1/24570.
    coneq[9100]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c**3)))))-1/98280.
    coneq[9101]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/294840.
    coneq[9102]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/589680.
    coneq[9103]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/196560.
    coneq[9104]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/73710.
    coneq[9105]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/147420.
    coneq[9106]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/49140.
    coneq[9107]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/98280.
    coneq[9108]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c**3))))-1/19656.
    coneq[9109]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,dot(A,c**2)))))-1/58968.
    coneq[9110]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/117936.
    coneq[9111]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c*dot(A,c)))))-1/39312.
    coneq[9112]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5*dot(A,c**2))))-1/14742.
    coneq[9113]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5*dot(A,dot(A,c)))))-1/29484.
    coneq[9114]=dot(b,dot(A,dot(A,c**2)*dot(A,c**6*dot(A,c))))-1/9828.
    coneq[9115]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)*dot(A,c**3))))-1/78624.
    coneq[9116]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/235872.
    coneq[9117]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[9118]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/157248.
    coneq[9119]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/707616.
    coneq[9120]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/1415232.
    coneq[9121]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/471744.
    coneq[9122]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/2830464.
    coneq[9123]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/943488.
    coneq[9124]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/314496.
    coneq[9125]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**4))))-1/73710.
    coneq[9126]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/294840.
    coneq[9127]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/884520.
    coneq[9128]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1769040.
    coneq[9129]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/589680.
    coneq[9130]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/221130.
    coneq[9131]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/442260.
    coneq[9132]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/147420.
    coneq[9133]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/294840.
    coneq[9134]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/147420.
    coneq[9135]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/589680.
    coneq[9136]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1769040.
    coneq[9137]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3538080.
    coneq[9138]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/1179360.
    coneq[9139]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/442260.
    coneq[9140]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/884520.
    coneq[9141]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/294840.
    coneq[9142]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/589680.
    coneq[9143]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**5))))-1/58968.
    coneq[9144]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/294840.
    coneq[9145]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/1179360.
    coneq[9146]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3538080.
    coneq[9147]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7076160.
    coneq[9148]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2358720.
    coneq[9149]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/884520.
    coneq[9150]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1769040.
    coneq[9151]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/589680.
    coneq[9152]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1179360.
    coneq[9153]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/235872.
    coneq[9154]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/707616.
    coneq[9155]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1415232.
    coneq[9156]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/471744.
    coneq[9157]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/176904.
    coneq[9158]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/353808.
    coneq[9159]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/117936.
    coneq[9160]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/353808.
    coneq[9161]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/707616.
    coneq[9162]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/235872.
    coneq[9163]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/58968.
    coneq[9164]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/176904.
    coneq[9165]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/353808.
    coneq[9166]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/117936.
    coneq[9167]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/117936.
    coneq[9168]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/353808.
    coneq[9169]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/707616.
    coneq[9170]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/235872.
    coneq[9171]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**4))))-1/49140.
    coneq[9172]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/196560.
    coneq[9173]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/589680.
    coneq[9174]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1179360.
    coneq[9175]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/393120.
    coneq[9176]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/147420.
    coneq[9177]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/294840.
    coneq[9178]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/98280.
    coneq[9179]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/196560.
    coneq[9180]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/44226.
    coneq[9181]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/88452.
    coneq[9182]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/176904.
    coneq[9183]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/39312.
    coneq[9184]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/117936.
    coneq[9185]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/235872.
    coneq[9186]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/78624.
    coneq[9187]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/29484.
    coneq[9188]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/58968.
    coneq[9189]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c)*dot(A,c))))-1/19656.
    coneq[9190]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/78624.
    coneq[9191]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/235872.
    coneq[9192]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[9193]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/157248.
    coneq[9194]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/88452.
    coneq[9195]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/176904.
    coneq[9196]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/353808.
    coneq[9197]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/58968.
    coneq[9198]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/117936.
    coneq[9199]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/39312.
    coneq[9200]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/78624.
    coneq[9201]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**8)))-1/9828.
    coneq[9202]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**7))))-1/78624.
    coneq[9203]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**6)))))-1/550368.
    coneq[9204]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/3302208.
    coneq[9205]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/16511040.
    coneq[9206]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/66044160.
    coneq[9207]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/198132480.
    coneq[9208]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/396264960.
    coneq[9209]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/132088320.
    coneq[9210]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/49533120.
    coneq[9211]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/99066240.
    coneq[9212]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/33022080.
    coneq[9213]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/66044160.
    coneq[9214]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/13208832.
    coneq[9215]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/39626496.
    coneq[9216]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/79252992.
    coneq[9217]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/26417664.
    coneq[9218]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/9906624.
    coneq[9219]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/19813248.
    coneq[9220]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/6604416.
    coneq[9221]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/19813248.
    coneq[9222]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/39626496.
    coneq[9223]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/13208832.
    coneq[9224]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/2751840.
    coneq[9225]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/11007360.
    coneq[9226]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/33022080.
    coneq[9227]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/66044160.
    coneq[9228]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/22014720.
    coneq[9229]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/8255520.
    coneq[9230]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/16511040.
    coneq[9231]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/5503680.
    coneq[9232]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/11007360.
    coneq[9233]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/2201472.
    coneq[9234]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/6604416.
    coneq[9235]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/13208832.
    coneq[9236]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/4402944.
    coneq[9237]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/1651104.
    coneq[9238]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/3302208.
    coneq[9239]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/1100736.
    coneq[9240]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/4953312.
    coneq[9241]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/9906624.
    coneq[9242]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/19813248.
    coneq[9243]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/4402944.
    coneq[9244]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/13208832.
    coneq[9245]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/26417664.
    coneq[9246]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/8805888.
    coneq[9247]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/3302208.
    coneq[9248]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/6604416.
    coneq[9249]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/2201472.
    coneq[9250]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/4402944.
    coneq[9251]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**5)))))-1/471744.
    coneq[9252]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/2358720.
    coneq[9253]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/9434880.
    coneq[9254]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/28304640.
    coneq[9255]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/56609280.
    coneq[9256]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/18869760.
    coneq[9257]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/7076160.
    coneq[9258]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/14152320.
    coneq[9259]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/4717440.
    coneq[9260]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/9434880.
    coneq[9261]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/1886976.
    coneq[9262]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/5660928.
    coneq[9263]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/11321856.
    coneq[9264]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/3773952.
    coneq[9265]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/1415232.
    coneq[9266]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/2830464.
    coneq[9267]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/943488.
    coneq[9268]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/2830464.
    coneq[9269]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/5660928.
    coneq[9270]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/1886976.
    coneq[9271]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**4)))))-1/393120.
    coneq[9272]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/1572480.
    coneq[9273]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[9274]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[9275]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[9276]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/1179360.
    coneq[9277]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/2358720.
    coneq[9278]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/786240.
    coneq[9279]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[9280]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c**3)))))-1/314496.
    coneq[9281]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/943488.
    coneq[9282]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[9283]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/628992.
    coneq[9284]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4*dot(A,c**2)))))-1/235872.
    coneq[9285]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/471744.
    coneq[9286]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5*dot(A,c)))))-1/157248.
    coneq[9287]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/943488.
    coneq[9288]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/2830464.
    coneq[9289]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/5660928.
    coneq[9290]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/1886976.
    coneq[9291]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/1886976.
    coneq[9292]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/5660928.
    coneq[9293]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/11321856.
    coneq[9294]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/3773952.
    coneq[9295]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/786240.
    coneq[9296]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/3144960.
    coneq[9297]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[9298]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[9299]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[9300]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/2358720.
    coneq[9301]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/4717440.
    coneq[9302]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/1572480.
    coneq[9303]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/3144960.
    coneq[9304]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/707616.
    coneq[9305]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/1415232.
    coneq[9306]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2830464.
    coneq[9307]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/628992.
    coneq[9308]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[9309]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[9310]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[9311]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/471744.
    coneq[9312]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/943488.
    coneq[9313]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/314496.
    coneq[9314]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/943488.
    coneq[9315]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/1886976.
    coneq[9316]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/628992.
    coneq[9317]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**6))))-1/68796.
    coneq[9318]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**5)))))-1/412776.
    coneq[9319]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/2063880.
    coneq[9320]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/8255520.
    coneq[9321]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/24766560.
    coneq[9322]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/49533120.
    coneq[9323]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/16511040.
    coneq[9324]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/6191640.
    coneq[9325]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/12383280.
    coneq[9326]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/4127760.
    coneq[9327]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/8255520.
    coneq[9328]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/1651104.
    coneq[9329]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/4953312.
    coneq[9330]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/9906624.
    coneq[9331]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/3302208.
    coneq[9332]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/1238328.
    coneq[9333]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/2476656.
    coneq[9334]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/825552.
    coneq[9335]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/2476656.
    coneq[9336]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4953312.
    coneq[9337]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1651104.
    coneq[9338]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**4)))))-1/343980.
    coneq[9339]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/1375920.
    coneq[9340]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/4127760.
    coneq[9341]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/8255520.
    coneq[9342]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2751840.
    coneq[9343]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/1031940.
    coneq[9344]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/2063880.
    coneq[9345]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/687960.
    coneq[9346]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1375920.
    coneq[9347]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/275184.
    coneq[9348]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/825552.
    coneq[9349]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1651104.
    coneq[9350]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/550368.
    coneq[9351]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/206388.
    coneq[9352]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/412776.
    coneq[9353]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4*dot(A,c)))))-1/137592.
    coneq[9354]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/619164.
    coneq[9355]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1238328.
    coneq[9356]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2476656.
    coneq[9357]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/550368.
    coneq[9358]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1651104.
    coneq[9359]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/3302208.
    coneq[9360]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/1100736.
    coneq[9361]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/412776.
    coneq[9362]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/825552.
    coneq[9363]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/275184.
    coneq[9364]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/550368.
    coneq[9365]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**5))))-1/58968.
    coneq[9366]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**4)))))-1/294840.
    coneq[9367]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/1179360.
    coneq[9368]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3538080.
    coneq[9369]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7076160.
    coneq[9370]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2358720.
    coneq[9371]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/884520.
    coneq[9372]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1769040.
    coneq[9373]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/589680.
    coneq[9374]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1179360.
    coneq[9375]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/235872.
    coneq[9376]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/707616.
    coneq[9377]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1415232.
    coneq[9378]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/471744.
    coneq[9379]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/176904.
    coneq[9380]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/353808.
    coneq[9381]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/117936.
    coneq[9382]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/353808.
    coneq[9383]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/707616.
    coneq[9384]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/235872.
    coneq[9385]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**4))))-1/49140.
    coneq[9386]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c**3)))))-1/196560.
    coneq[9387]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/589680.
    coneq[9388]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1179360.
    coneq[9389]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/393120.
    coneq[9390]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/147420.
    coneq[9391]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/294840.
    coneq[9392]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/98280.
    coneq[9393]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/196560.
    coneq[9394]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c**3))))-1/39312.
    coneq[9395]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,dot(A,c**2)))))-1/117936.
    coneq[9396]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/235872.
    coneq[9397]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c*dot(A,c)))))-1/78624.
    coneq[9398]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5*dot(A,c**2))))-1/29484.
    coneq[9399]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5*dot(A,dot(A,c)))))-1/58968.
    coneq[9400]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**6*dot(A,c))))-1/19656.
    coneq[9401]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)*dot(A,c**3))))-1/157248.
    coneq[9402]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/471744.
    coneq[9403]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/943488.
    coneq[9404]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/314496.
    coneq[9405]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/1415232.
    coneq[9406]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/2830464.
    coneq[9407]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/943488.
    coneq[9408]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/5660928.
    coneq[9409]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/1886976.
    coneq[9410]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/628992.
    coneq[9411]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**4))))-1/147420.
    coneq[9412]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/589680.
    coneq[9413]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/1769040.
    coneq[9414]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3538080.
    coneq[9415]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/1179360.
    coneq[9416]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/442260.
    coneq[9417]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/884520.
    coneq[9418]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/294840.
    coneq[9419]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/589680.
    coneq[9420]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/294840.
    coneq[9421]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/1179360.
    coneq[9422]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/3538080.
    coneq[9423]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/7076160.
    coneq[9424]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/2358720.
    coneq[9425]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/884520.
    coneq[9426]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/1769040.
    coneq[9427]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/589680.
    coneq[9428]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/1179360.
    coneq[9429]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**5))))-1/117936.
    coneq[9430]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/589680.
    coneq[9431]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/2358720.
    coneq[9432]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/7076160.
    coneq[9433]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/14152320.
    coneq[9434]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/4717440.
    coneq[9435]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/1769040.
    coneq[9436]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3538080.
    coneq[9437]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/1179360.
    coneq[9438]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2358720.
    coneq[9439]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/471744.
    coneq[9440]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/1415232.
    coneq[9441]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2830464.
    coneq[9442]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/943488.
    coneq[9443]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/353808.
    coneq[9444]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/707616.
    coneq[9445]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/235872.
    coneq[9446]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/707616.
    coneq[9447]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1415232.
    coneq[9448]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/471744.
    coneq[9449]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/117936.
    coneq[9450]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/353808.
    coneq[9451]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/707616.
    coneq[9452]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/235872.
    coneq[9453]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/235872.
    coneq[9454]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/707616.
    coneq[9455]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1415232.
    coneq[9456]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/471744.
    coneq[9457]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**4))))-1/98280.
    coneq[9458]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/393120.
    coneq[9459]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/1179360.
    coneq[9460]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2358720.
    coneq[9461]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/786240.
    coneq[9462]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/294840.
    coneq[9463]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/589680.
    coneq[9464]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/196560.
    coneq[9465]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/393120.
    coneq[9466]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/88452.
    coneq[9467]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/176904.
    coneq[9468]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/353808.
    coneq[9469]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/78624.
    coneq[9470]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/235872.
    coneq[9471]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[9472]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/157248.
    coneq[9473]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/58968.
    coneq[9474]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/117936.
    coneq[9475]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c)*dot(A,c))))-1/39312.
    coneq[9476]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/157248.
    coneq[9477]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/471744.
    coneq[9478]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/943488.
    coneq[9479]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/314496.
    coneq[9480]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/176904.
    coneq[9481]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/353808.
    coneq[9482]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/707616.
    coneq[9483]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/117936.
    coneq[9484]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/235872.
    coneq[9485]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/78624.
    coneq[9486]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/157248.
    coneq[9487]=dot(b,dot(A,dot(A,c)*dot(A,c**9)))-1/3640.
    coneq[9488]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**8))))-1/32760.
    coneq[9489]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**7)))))-1/262080.
    coneq[9490]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**6))))))-1/1834560.
    coneq[9491]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))))-1/11007360.
    coneq[9492]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))-1/55036800.
    coneq[9493]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))-1/220147200.
    coneq[9494]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))-1/660441600.
    coneq[9495]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))-1/1320883200.
    coneq[9496]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))-1/440294400.
    coneq[9497]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))-1/165110400.
    coneq[9498]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))-1/330220800.
    coneq[9499]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))-1/110073600.
    coneq[9500]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))-1/220147200.
    coneq[9501]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))-1/44029440.
    coneq[9502]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))-1/132088320.
    coneq[9503]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))-1/264176640.
    coneq[9504]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))-1/88058880.
    coneq[9505]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))-1/33022080.
    coneq[9506]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))-1/66044160.
    coneq[9507]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))-1/22014720.
    coneq[9508]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))-1/66044160.
    coneq[9509]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))-1/132088320.
    coneq[9510]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))-1/44029440.
    coneq[9511]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))))-1/9172800.
    coneq[9512]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))-1/36691200.
    coneq[9513]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))-1/110073600.
    coneq[9514]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))-1/220147200.
    coneq[9515]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))-1/73382400.
    coneq[9516]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))-1/27518400.
    coneq[9517]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))-1/55036800.
    coneq[9518]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))-1/18345600.
    coneq[9519]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))-1/36691200.
    coneq[9520]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))-1/7338240.
    coneq[9521]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[9522]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[9523]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[9524]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))-1/5503680.
    coneq[9525]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))-1/11007360.
    coneq[9526]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))))-1/3669120.
    coneq[9527]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))-1/16511040.
    coneq[9528]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))-1/33022080.
    coneq[9529]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))-1/66044160.
    coneq[9530]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))-1/14676480.
    coneq[9531]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))-1/44029440.
    coneq[9532]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))-1/88058880.
    coneq[9533]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))-1/29352960.
    coneq[9534]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))-1/11007360.
    coneq[9535]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))-1/22014720.
    coneq[9536]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[9537]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))-1/14676480.
    coneq[9538]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**5))))))-1/1572480.
    coneq[9539]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))))-1/7862400.
    coneq[9540]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))-1/31449600.
    coneq[9541]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/94348800.
    coneq[9542]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/188697600.
    coneq[9543]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/62899200.
    coneq[9544]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))-1/23587200.
    coneq[9545]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/47174400.
    coneq[9546]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))-1/15724800.
    coneq[9547]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/31449600.
    coneq[9548]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))-1/6289920.
    coneq[9549]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))-1/18869760.
    coneq[9550]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/37739520.
    coneq[9551]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))-1/12579840.
    coneq[9552]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))-1/4717440.
    coneq[9553]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))-1/9434880.
    coneq[9554]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))-1/3144960.
    coneq[9555]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))-1/9434880.
    coneq[9556]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/18869760.
    coneq[9557]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))-1/6289920.
    coneq[9558]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**4))))))-1/1310400.
    coneq[9559]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))-1/5241600.
    coneq[9560]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))-1/15724800.
    coneq[9561]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/31449600.
    coneq[9562]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))-1/10483200.
    coneq[9563]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))-1/3931200.
    coneq[9564]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))-1/7862400.
    coneq[9565]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))-1/2620800.
    coneq[9566]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))-1/5241600.
    coneq[9567]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c**3))))))-1/1048320.
    coneq[9568]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[9569]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[9570]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[9571]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4*dot(A,c**2))))))-1/786240.
    coneq[9572]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))))-1/1572480.
    coneq[9573]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5*dot(A,c))))))-1/524160.
    coneq[9574]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))-1/3144960.
    coneq[9575]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))-1/9434880.
    coneq[9576]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))-1/18869760.
    coneq[9577]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))-1/6289920.
    coneq[9578]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))-1/6289920.
    coneq[9579]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))-1/18869760.
    coneq[9580]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))-1/37739520.
    coneq[9581]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))-1/12579840.
    coneq[9582]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))))-1/2620800.
    coneq[9583]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))-1/10483200.
    coneq[9584]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))-1/31449600.
    coneq[9585]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/62899200.
    coneq[9586]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))-1/20966400.
    coneq[9587]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))-1/7862400.
    coneq[9588]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))-1/15724800.
    coneq[9589]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))-1/5241600.
    coneq[9590]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))-1/10483200.
    coneq[9591]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))-1/2358720.
    coneq[9592]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))-1/4717440.
    coneq[9593]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/9434880.
    coneq[9594]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))-1/2096640.
    coneq[9595]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))-1/6289920.
    coneq[9596]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/12579840.
    coneq[9597]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))-1/4193280.
    coneq[9598]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))-1/1572480.
    coneq[9599]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))-1/3144960.
    coneq[9600]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[9601]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))-1/3144960.
    coneq[9602]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))-1/6289920.
    coneq[9603]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))-1/2096640.
    coneq[9604]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**6)))))-1/229320.
    coneq[9605]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**5))))))-1/1375920.
    coneq[9606]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))))-1/6879600.
    coneq[9607]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/27518400.
    coneq[9608]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/82555200.
    coneq[9609]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/165110400.
    coneq[9610]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/55036800.
    coneq[9611]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/20638800.
    coneq[9612]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/41277600.
    coneq[9613]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/13759200.
    coneq[9614]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/27518400.
    coneq[9615]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))-1/5503680.
    coneq[9616]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/16511040.
    coneq[9617]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/33022080.
    coneq[9618]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/11007360.
    coneq[9619]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))-1/4127760.
    coneq[9620]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/8255520.
    coneq[9621]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))-1/2751840.
    coneq[9622]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/8255520.
    coneq[9623]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/16511040.
    coneq[9624]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/5503680.
    coneq[9625]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**4))))))-1/1146600.
    coneq[9626]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))-1/4586400.
    coneq[9627]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/13759200.
    coneq[9628]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/27518400.
    coneq[9629]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/9172800.
    coneq[9630]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))-1/3439800.
    coneq[9631]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/6879600.
    coneq[9632]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2293200.
    coneq[9633]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/4586400.
    coneq[9634]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))))-1/917280.
    coneq[9635]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2751840.
    coneq[9636]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/5503680.
    coneq[9637]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1834560.
    coneq[9638]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))))-1/687960.
    coneq[9639]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))-1/1375920.
    coneq[9640]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4*dot(A,c))))))-1/458640.
    coneq[9641]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))-1/2063880.
    coneq[9642]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/4127760.
    coneq[9643]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/8255520.
    coneq[9644]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))-1/1834560.
    coneq[9645]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/5503680.
    coneq[9646]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/11007360.
    coneq[9647]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/3669120.
    coneq[9648]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1375920.
    coneq[9649]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2751840.
    coneq[9650]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))-1/917280.
    coneq[9651]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1834560.
    coneq[9652]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**5)))))-1/196560.
    coneq[9653]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**4))))))-1/982800.
    coneq[9654]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))-1/3931200.
    coneq[9655]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/11793600.
    coneq[9656]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/23587200.
    coneq[9657]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/7862400.
    coneq[9658]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))-1/2948400.
    coneq[9659]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5896800.
    coneq[9660]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))-1/1965600.
    coneq[9661]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3931200.
    coneq[9662]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))))-1/786240.
    coneq[9663]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[9664]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[9665]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[9666]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))))-1/589680.
    coneq[9667]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))-1/1179360.
    coneq[9668]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))))-1/393120.
    coneq[9669]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))-1/1179360.
    coneq[9670]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2358720.
    coneq[9671]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))-1/786240.
    coneq[9672]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**4)))))-1/163800.
    coneq[9673]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c**3))))))-1/655200.
    coneq[9674]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))-1/1965600.
    coneq[9675]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3931200.
    coneq[9676]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))-1/1310400.
    coneq[9677]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))))-1/491400.
    coneq[9678]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))-1/982800.
    coneq[9679]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))))-1/327600.
    coneq[9680]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))-1/655200.
    coneq[9681]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c**3)))))-1/131040.
    coneq[9682]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,dot(A,c**2))))))-1/393120.
    coneq[9683]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[9684]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c*dot(A,c))))))-1/262080.
    coneq[9685]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5*dot(A,c**2)))))-1/98280.
    coneq[9686]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5*dot(A,dot(A,c))))))-1/196560.
    coneq[9687]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**6*dot(A,c)))))-1/65520.
    coneq[9688]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))))-1/524160.
    coneq[9689]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))-1/1572480.
    coneq[9690]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[9691]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[9692]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))-1/4717440.
    coneq[9693]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))-1/9434880.
    coneq[9694]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))-1/3144960.
    coneq[9695]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))-1/18869760.
    coneq[9696]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))-1/6289920.
    coneq[9697]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))-1/2096640.
    coneq[9698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))))-1/491400.
    coneq[9699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))-1/1965600.
    coneq[9700]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))-1/5896800.
    coneq[9701]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/11793600.
    coneq[9702]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))-1/3931200.
    coneq[9703]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))-1/1474200.
    coneq[9704]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))-1/2948400.
    coneq[9705]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))-1/982800.
    coneq[9706]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))-1/1965600.
    coneq[9707]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))))-1/982800.
    coneq[9708]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))-1/3931200.
    coneq[9709]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))-1/11793600.
    coneq[9710]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))-1/23587200.
    coneq[9711]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))-1/7862400.
    coneq[9712]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))-1/2948400.
    coneq[9713]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))-1/5896800.
    coneq[9714]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))-1/1965600.
    coneq[9715]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))-1/3931200.
    coneq[9716]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**5)))))-1/393120.
    coneq[9717]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))))-1/1965600.
    coneq[9718]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))-1/7862400.
    coneq[9719]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/23587200.
    coneq[9720]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/47174400.
    coneq[9721]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/15724800.
    coneq[9722]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))-1/5896800.
    coneq[9723]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/11793600.
    coneq[9724]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))-1/3931200.
    coneq[9725]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/7862400.
    coneq[9726]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))-1/1572480.
    coneq[9727]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))-1/4717440.
    coneq[9728]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/9434880.
    coneq[9729]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))-1/3144960.
    coneq[9730]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))-1/1179360.
    coneq[9731]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))-1/2358720.
    coneq[9732]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))-1/786240.
    coneq[9733]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))-1/2358720.
    coneq[9734]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4717440.
    coneq[9735]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))-1/1572480.
    coneq[9736]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))))-1/393120.
    coneq[9737]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1179360.
    coneq[9738]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2358720.
    coneq[9739]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))-1/786240.
    coneq[9740]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))-1/786240.
    coneq[9741]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2358720.
    coneq[9742]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/4717440.
    coneq[9743]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1572480.
    coneq[9744]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))))-1/327600.
    coneq[9745]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))-1/1310400.
    coneq[9746]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/3931200.
    coneq[9747]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7862400.
    coneq[9748]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2620800.
    coneq[9749]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))-1/982800.
    coneq[9750]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1965600.
    coneq[9751]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))-1/655200.
    coneq[9752]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1310400.
    coneq[9753]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))-1/294840.
    coneq[9754]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))-1/589680.
    coneq[9755]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1179360.
    coneq[9756]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))))-1/262080.
    coneq[9757]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))-1/786240.
    coneq[9758]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[9759]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))-1/524160.
    coneq[9760]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))))-1/196560.
    coneq[9761]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))-1/393120.
    coneq[9762]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))))-1/131040.
    coneq[9763]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))-1/524160.
    coneq[9764]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))-1/1572480.
    coneq[9765]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[9766]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[9767]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))-1/589680.
    coneq[9768]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))-1/1179360.
    coneq[9769]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2358720.
    coneq[9770]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/393120.
    coneq[9771]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/786240.
    coneq[9772]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))-1/262080.
    coneq[9773]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))-1/524160.
    coneq[9774]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**7))))-1/29120.
    coneq[9775]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**6)))))-1/203840.
    coneq[9776]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**5))))))-1/1223040.
    coneq[9777]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/6115200.
    coneq[9778]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/24460800.
    coneq[9779]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/73382400.
    coneq[9780]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/146764800.
    coneq[9781]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/48921600.
    coneq[9782]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/18345600.
    coneq[9783]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/36691200.
    coneq[9784]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/12230400.
    coneq[9785]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/24460800.
    coneq[9786]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/4892160.
    coneq[9787]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/14676480.
    coneq[9788]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/29352960.
    coneq[9789]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/9784320.
    coneq[9790]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/3669120.
    coneq[9791]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/7338240.
    coneq[9792]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/2446080.
    coneq[9793]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/7338240.
    coneq[9794]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/14676480.
    coneq[9795]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/4892160.
    coneq[9796]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**4))))))-1/1019200.
    coneq[9797]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/4076800.
    coneq[9798]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/12230400.
    coneq[9799]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/24460800.
    coneq[9800]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/8153600.
    coneq[9801]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/3057600.
    coneq[9802]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/6115200.
    coneq[9803]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/2038400.
    coneq[9804]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/4076800.
    coneq[9805]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))))-1/815360.
    coneq[9806]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2446080.
    coneq[9807]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/4892160.
    coneq[9808]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1630720.
    coneq[9809]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))))-1/611520.
    coneq[9810]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/1223040.
    coneq[9811]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4*dot(A,c))))))-1/407680.
    coneq[9812]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1834560.
    coneq[9813]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/3669120.
    coneq[9814]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/7338240.
    coneq[9815]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/1630720.
    coneq[9816]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/4892160.
    coneq[9817]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/9784320.
    coneq[9818]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/3261440.
    coneq[9819]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1223040.
    coneq[9820]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2446080.
    coneq[9821]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/815360.
    coneq[9822]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1630720.
    coneq[9823]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**5)))))-1/174720.
    coneq[9824]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**4))))))-1/873600.
    coneq[9825]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/3494400.
    coneq[9826]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/10483200.
    coneq[9827]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/20966400.
    coneq[9828]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6988800.
    coneq[9829]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/2620800.
    coneq[9830]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5241600.
    coneq[9831]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/1747200.
    coneq[9832]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3494400.
    coneq[9833]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))))-1/698880.
    coneq[9834]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[9835]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[9836]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[9837]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/524160.
    coneq[9838]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/1048320.
    coneq[9839]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))))-1/349440.
    coneq[9840]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/1048320.
    coneq[9841]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2096640.
    coneq[9842]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/698880.
    coneq[9843]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**4)))))-1/145600.
    coneq[9844]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))))-1/582400.
    coneq[9845]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/1747200.
    coneq[9846]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3494400.
    coneq[9847]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/1164800.
    coneq[9848]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/436800.
    coneq[9849]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/873600.
    coneq[9850]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/291200.
    coneq[9851]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/582400.
    coneq[9852]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c**3)))))-1/116480.
    coneq[9853]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))))-1/349440.
    coneq[9854]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/698880.
    coneq[9855]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))))-1/232960.
    coneq[9856]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4*dot(A,c**2)))))-1/87360.
    coneq[9857]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4*dot(A,dot(A,c))))))-1/174720.
    coneq[9858]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**5*dot(A,c)))))-1/58240.
    coneq[9859]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))))-1/349440.
    coneq[9860]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/1048320.
    coneq[9861]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[9862]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/698880.
    coneq[9863]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/698880.
    coneq[9864]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/2096640.
    coneq[9865]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/4193280.
    coneq[9866]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1397760.
    coneq[9867]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))))-1/291200.
    coneq[9868]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/1164800.
    coneq[9869]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/3494400.
    coneq[9870]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6988800.
    coneq[9871]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2329600.
    coneq[9872]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/873600.
    coneq[9873]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1747200.
    coneq[9874]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/582400.
    coneq[9875]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1164800.
    coneq[9876]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/262080.
    coneq[9877]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/524160.
    coneq[9878]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1048320.
    coneq[9879]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))))-1/232960.
    coneq[9880]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/698880.
    coneq[9881]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1397760.
    coneq[9882]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/465920.
    coneq[9883]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/174720.
    coneq[9884]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/349440.
    coneq[9885]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))))-1/116480.
    coneq[9886]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/349440.
    coneq[9887]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/698880.
    coneq[9888]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/232960.
    coneq[9889]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**6))))-1/25480.
    coneq[9890]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**5)))))-1/152880.
    coneq[9891]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**4))))))-1/764400.
    coneq[9892]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/3057600.
    coneq[9893]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/9172800.
    coneq[9894]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18345600.
    coneq[9895]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6115200.
    coneq[9896]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2293200.
    coneq[9897]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4586400.
    coneq[9898]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1528800.
    coneq[9899]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3057600.
    coneq[9900]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))))-1/611520.
    coneq[9901]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[9902]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[9903]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[9904]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))))-1/458640.
    coneq[9905]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/917280.
    coneq[9906]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))))-1/305760.
    coneq[9907]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/917280.
    coneq[9908]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1834560.
    coneq[9909]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/611520.
    coneq[9910]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**4)))))-1/127400.
    coneq[9911]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))))-1/509600.
    coneq[9912]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1528800.
    coneq[9913]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3057600.
    coneq[9914]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1019200.
    coneq[9915]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))))-1/382200.
    coneq[9916]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/764400.
    coneq[9917]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))))-1/254800.
    coneq[9918]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/509600.
    coneq[9919]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c**3)))))-1/101920.
    coneq[9920]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))))-1/305760.
    coneq[9921]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/611520.
    coneq[9922]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))))-1/203840.
    coneq[9923]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3*dot(A,c**2)))))-1/76440.
    coneq[9924]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))))-1/152880.
    coneq[9925]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4*dot(A,c)))))-1/50960.
    coneq[9926]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/229320.
    coneq[9927]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/458640.
    coneq[9928]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/917280.
    coneq[9929]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))))-1/203840.
    coneq[9930]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/611520.
    coneq[9931]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1223040.
    coneq[9932]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/407680.
    coneq[9933]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/152880.
    coneq[9934]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/305760.
    coneq[9935]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/101920.
    coneq[9936]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/203840.
    coneq[9937]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**5))))-1/21840.
    coneq[9938]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**4)))))-1/109200.
    coneq[9939]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c**3))))))-1/436800.
    coneq[9940]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1310400.
    coneq[9941]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2620800.
    coneq[9942]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/873600.
    coneq[9943]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))))-1/327600.
    coneq[9944]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/655200.
    coneq[9945]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))))-1/218400.
    coneq[9946]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/436800.
    coneq[9947]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c**3)))))-1/87360.
    coneq[9948]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))))-1/262080.
    coneq[9949]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[9950]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))))-1/174720.
    coneq[9951]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2*dot(A,c**2)))))-1/65520.
    coneq[9952]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))))-1/131040.
    coneq[9953]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3*dot(A,c)))))-1/43680.
    coneq[9954]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))))-1/131040.
    coneq[9955]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/262080.
    coneq[9956]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))))-1/87360.
    coneq[9957]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**4))))-1/18200.
    coneq[9958]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c**3)))))-1/72800.
    coneq[9959]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,dot(A,c**2))))))-1/218400.
    coneq[9960]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))))-1/436800.
    coneq[9961]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c*dot(A,c))))))-1/145600.
    coneq[9962]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c*dot(A,c**2)))))-1/54600.
    coneq[9963]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c*dot(A,dot(A,c))))))-1/109200.
    coneq[9964]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2*dot(A,c)))))-1/36400.
    coneq[9965]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))))-1/72800.
    coneq[9966]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c**3))))-1/14560.
    coneq[9967]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,dot(A,c**2)))))-1/43680.
    coneq[9968]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,dot(A,dot(A,c))))))-1/87360.
    coneq[9969]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c*dot(A,c)))))-1/29120.
    coneq[9970]=dot(b,dot(A,dot(A,c)*dot(A,c**6*dot(A,c**2))))-1/10920.
    coneq[9971]=dot(b,dot(A,dot(A,c)*dot(A,c**6*dot(A,dot(A,c)))))-1/21840.
    coneq[9972]=dot(b,dot(A,dot(A,c)*dot(A,c**7*dot(A,c))))-1/7280.
    coneq[9973]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c**4))))-1/72800.
    coneq[9974]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))))-1/291200.
    coneq[9975]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))-1/873600.
    coneq[9976]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1747200.
    coneq[9977]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))-1/582400.
    coneq[9978]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))))-1/218400.
    coneq[9979]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))-1/436800.
    coneq[9980]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))))-1/145600.
    coneq[9981]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))-1/291200.
    coneq[9982]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c**4))))-1/218400.
    coneq[9983]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))-1/873600.
    coneq[9984]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))-1/2620800.
    coneq[9985]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/5241600.
    coneq[9986]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))-1/1747200.
    coneq[9987]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))-1/655200.
    coneq[9988]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))-1/1310400.
    coneq[9989]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))-1/436800.
    coneq[9990]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))-1/873600.
    coneq[9991]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))))-1/436800.
    coneq[9992]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))-1/1747200.
    coneq[9993]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))-1/5241600.
    coneq[9994]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/10483200.
    coneq[9995]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))-1/3494400.
    coneq[9996]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))-1/1310400.
    coneq[9997]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))-1/2620800.
    coneq[9998]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))-1/873600.
    coneq[9999]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))-1/1747200.
    coneq[10000]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c**4))))-1/145600.
    coneq[10001]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))-1/582400.
    coneq[10002]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1747200.
    coneq[10003]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3494400.
    coneq[10004]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/1164800.
    coneq[10005]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))-1/436800.
    coneq[10006]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/873600.
    coneq[10007]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))-1/291200.
    coneq[10008]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/582400.
    coneq[10009]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**5))))-1/65520.
    coneq[10010]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))))-1/327600.
    coneq[10011]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))-1/1310400.
    coneq[10012]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3931200.
    coneq[10013]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7862400.
    coneq[10014]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2620800.
    coneq[10015]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))-1/982800.
    coneq[10016]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1965600.
    coneq[10017]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))-1/655200.
    coneq[10018]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1310400.
    coneq[10019]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))))-1/262080.
    coneq[10020]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))-1/786240.
    coneq[10021]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[10022]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))-1/524160.
    coneq[10023]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))-1/196560.
    coneq[10024]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))-1/393120.
    coneq[10025]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))))-1/131040.
    coneq[10026]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))-1/393120.
    coneq[10027]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/786240.
    coneq[10028]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))-1/262080.
    coneq[10029]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**5))))-1/131040.
    coneq[10030]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))))-1/655200.
    coneq[10031]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))-1/2620800.
    coneq[10032]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/7862400.
    coneq[10033]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/15724800.
    coneq[10034]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/5241600.
    coneq[10035]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))-1/1965600.
    coneq[10036]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/3931200.
    coneq[10037]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))-1/1310400.
    coneq[10038]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/2620800.
    coneq[10039]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))-1/524160.
    coneq[10040]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))-1/1572480.
    coneq[10041]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[10042]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))-1/1048320.
    coneq[10043]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))-1/393120.
    coneq[10044]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))-1/786240.
    coneq[10045]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))-1/262080.
    coneq[10046]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))-1/786240.
    coneq[10047]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1572480.
    coneq[10048]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))-1/524160.
    coneq[10049]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**6))))-1/50960.
    coneq[10050]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**5)))))-1/305760.
    coneq[10051]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))))-1/1528800.
    coneq[10052]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/6115200.
    coneq[10053]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/18345600.
    coneq[10054]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/36691200.
    coneq[10055]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/12230400.
    coneq[10056]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/4586400.
    coneq[10057]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/9172800.
    coneq[10058]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/3057600.
    coneq[10059]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/6115200.
    coneq[10060]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))-1/1223040.
    coneq[10061]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[10062]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[10063]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[10064]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))-1/917280.
    coneq[10065]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1834560.
    coneq[10066]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))-1/611520.
    coneq[10067]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1834560.
    coneq[10068]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/3669120.
    coneq[10069]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[10070]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))))-1/254800.
    coneq[10071]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))-1/1019200.
    coneq[10072]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/3057600.
    coneq[10073]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6115200.
    coneq[10074]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2038400.
    coneq[10075]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))-1/764400.
    coneq[10076]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1528800.
    coneq[10077]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))-1/509600.
    coneq[10078]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1019200.
    coneq[10079]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))))-1/203840.
    coneq[10080]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))-1/611520.
    coneq[10081]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1223040.
    coneq[10082]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))-1/407680.
    coneq[10083]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))))-1/152880.
    coneq[10084]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))-1/305760.
    coneq[10085]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))))-1/101920.
    coneq[10086]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/458640.
    coneq[10087]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/917280.
    coneq[10088]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1834560.
    coneq[10089]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))-1/407680.
    coneq[10090]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1223040.
    coneq[10091]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2446080.
    coneq[10092]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/815360.
    coneq[10093]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/305760.
    coneq[10094]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/611520.
    coneq[10095]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/203840.
    coneq[10096]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/407680.
    coneq[10097]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)*dot(A,c**3))))-1/58240.
    coneq[10098]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))))-1/174720.
    coneq[10099]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/349440.
    coneq[10100]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))))-1/116480.
    coneq[10101]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/524160.
    coneq[10102]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/1048320.
    coneq[10103]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/349440.
    coneq[10104]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/2096640.
    coneq[10105]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/698880.
    coneq[10106]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/232960.
    coneq[10107]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**4))))-1/54600.
    coneq[10108]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))))-1/218400.
    coneq[10109]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/655200.
    coneq[10110]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1310400.
    coneq[10111]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/436800.
    coneq[10112]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/163800.
    coneq[10113]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/327600.
    coneq[10114]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/109200.
    coneq[10115]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/218400.
    coneq[10116]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c**4))))-1/109200.
    coneq[10117]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/436800.
    coneq[10118]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1310400.
    coneq[10119]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2620800.
    coneq[10120]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/873600.
    coneq[10121]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/327600.
    coneq[10122]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/655200.
    coneq[10123]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/218400.
    coneq[10124]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/436800.
    coneq[10125]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**5))))-1/43680.
    coneq[10126]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))))-1/218400.
    coneq[10127]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/873600.
    coneq[10128]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2620800.
    coneq[10129]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5241600.
    coneq[10130]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1747200.
    coneq[10131]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/655200.
    coneq[10132]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1310400.
    coneq[10133]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/436800.
    coneq[10134]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/873600.
    coneq[10135]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))))-1/174720.
    coneq[10136]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/524160.
    coneq[10137]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[10138]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/349440.
    coneq[10139]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/131040.
    coneq[10140]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/262080.
    coneq[10141]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))))-1/87360.
    coneq[10142]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/262080.
    coneq[10143]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/524160.
    coneq[10144]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/174720.
    coneq[10145]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,c**3))))-1/43680.
    coneq[10146]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/131040.
    coneq[10147]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[10148]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/87360.
    coneq[10149]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))))-1/87360.
    coneq[10150]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/262080.
    coneq[10151]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[10152]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/174720.
    coneq[10153]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**4))))-1/36400.
    coneq[10154]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))))-1/145600.
    coneq[10155]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/436800.
    coneq[10156]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/873600.
    coneq[10157]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/291200.
    coneq[10158]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/109200.
    coneq[10159]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/218400.
    coneq[10160]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/72800.
    coneq[10161]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/145600.
    coneq[10162]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)*dot(A,c**2))))-1/32760.
    coneq[10163]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))))-1/65520.
    coneq[10164]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/131040.
    coneq[10165]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c**3))))-1/29120.
    coneq[10166]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))))-1/87360.
    coneq[10167]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/174720.
    coneq[10168]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))))-1/58240.
    coneq[10169]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)*dot(A,c**2))))-1/21840.
    coneq[10170]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))))-1/43680.
    coneq[10171]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c)*dot(A,c))))-1/14560.
    coneq[10172]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))))-1/72800.
    coneq[10173]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))-1/291200.
    coneq[10174]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/873600.
    coneq[10175]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1747200.
    coneq[10176]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/582400.
    coneq[10177]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/218400.
    coneq[10178]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/436800.
    coneq[10179]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/145600.
    coneq[10180]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/291200.
    coneq[10181]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))))-1/87360.
    coneq[10182]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/262080.
    coneq[10183]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[10184]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/174720.
    coneq[10185]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))-1/174720.
    coneq[10186]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/524160.
    coneq[10187]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1048320.
    coneq[10188]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/349440.
    coneq[10189]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))-1/98280.
    coneq[10190]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))-1/196560.
    coneq[10191]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/393120.
    coneq[10192]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/786240.
    coneq[10193]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))))-1/58240.
    coneq[10194]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/174720.
    coneq[10195]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/349440.
    coneq[10196]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/116480.
    coneq[10197]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/65520.
    coneq[10198]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/131040.
    coneq[10199]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/262080.
    coneq[10200]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/43680.
    coneq[10201]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/87360.
    coneq[10202]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))))-1/29120.
    coneq[10203]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/87360.
    coneq[10204]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/174720.
    coneq[10205]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/58240.
    coneq[10206]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**5)))-1/5460.
    coneq[10207]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c**4))))-1/27300.
    coneq[10208]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,c**3)))))-1/109200.
    coneq[10209]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/327600.
    coneq[10210]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/655200.
    coneq[10211]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/218400.
    coneq[10212]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c*dot(A,c**2)))))-1/81900.
    coneq[10213]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/163800.
    coneq[10214]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c**2*dot(A,c)))))-1/54600.
    coneq[10215]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/109200.
    coneq[10216]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,c**3))))-1/21840.
    coneq[10217]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,dot(A,c**2)))))-1/65520.
    coneq[10218]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/131040.
    coneq[10219]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,c*dot(A,c)))))-1/43680.
    coneq[10220]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**2*dot(A,c**2))))-1/16380.
    coneq[10221]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**2*dot(A,dot(A,c)))))-1/32760.
    coneq[10222]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**3*dot(A,c))))-1/10920.
    coneq[10223]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c)*dot(A,c**2))))-1/32760.
    coneq[10224]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/65520.
    coneq[10225]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,c)*dot(A,c))))-1/21840.
    coneq[10226]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**5)))-1/21840.
    coneq[10227]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c**4))))-1/109200.
    coneq[10228]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**3)))))-1/436800.
    coneq[10229]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1310400.
    coneq[10230]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2620800.
    coneq[10231]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/873600.
    coneq[10232]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2)))))-1/327600.
    coneq[10233]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/655200.
    coneq[10234]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c)))))-1/218400.
    coneq[10235]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/436800.
    coneq[10236]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,c**3))))-1/87360.
    coneq[10237]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2)))))-1/262080.
    coneq[10238]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[10239]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c)))))-1/174720.
    coneq[10240]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c**2))))-1/65520.
    coneq[10241]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c)))))-1/131040.
    coneq[10242]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**3*dot(A,c))))-1/43680.
    coneq[10243]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2))))-1/131040.
    coneq[10244]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/262080.
    coneq[10245]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c))))-1/87360.
    coneq[10246]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**5)))-1/65520.
    coneq[10247]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**4))))-1/327600.
    coneq[10248]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3)))))-1/1310400.
    coneq[10249]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/3931200.
    coneq[10250]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/7862400.
    coneq[10251]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/2620800.
    coneq[10252]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2)))))-1/982800.
    coneq[10253]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/1965600.
    coneq[10254]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c)))))-1/655200.
    coneq[10255]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/1310400.
    coneq[10256]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3))))-1/262080.
    coneq[10257]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2)))))-1/786240.
    coneq[10258]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/1572480.
    coneq[10259]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c)))))-1/524160.
    coneq[10260]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2))))-1/196560.
    coneq[10261]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c)))))-1/393120.
    coneq[10262]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c))))-1/131040.
    coneq[10263]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2))))-1/393120.
    coneq[10264]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/786240.
    coneq[10265]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c))))-1/262080.
    coneq[10266]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**5)))-1/131040.
    coneq[10267]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4))))-1/655200.
    coneq[10268]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3)))))-1/2620800.
    coneq[10269]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/7862400.
    coneq[10270]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/15724800.
    coneq[10271]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/5241600.
    coneq[10272]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2)))))-1/1965600.
    coneq[10273]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/3931200.
    coneq[10274]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c)))))-1/1310400.
    coneq[10275]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/2620800.
    coneq[10276]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3))))-1/524160.
    coneq[10277]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2)))))-1/1572480.
    coneq[10278]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/3144960.
    coneq[10279]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c)))))-1/1048320.
    coneq[10280]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2))))-1/393120.
    coneq[10281]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c)))))-1/786240.
    coneq[10282]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c))))-1/262080.
    coneq[10283]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2))))-1/786240.
    coneq[10284]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/1572480.
    coneq[10285]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c))))-1/524160.
    coneq[10286]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**5)))-1/43680.
    coneq[10287]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**4))))-1/218400.
    coneq[10288]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/873600.
    coneq[10289]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/2620800.
    coneq[10290]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/5241600.
    coneq[10291]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1747200.
    coneq[10292]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/655200.
    coneq[10293]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/1310400.
    coneq[10294]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/436800.
    coneq[10295]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/873600.
    coneq[10296]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3))))-1/174720.
    coneq[10297]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/524160.
    coneq[10298]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/1048320.
    coneq[10299]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/349440.
    coneq[10300]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/131040.
    coneq[10301]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/262080.
    coneq[10302]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c))))-1/87360.
    coneq[10303]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/262080.
    coneq[10304]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/524160.
    coneq[10305]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/174720.
    coneq[10306]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**5)))-1/16380.
    coneq[10307]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c**4))))-1/81900.
    coneq[10308]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))-1/327600.
    coneq[10309]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/982800.
    coneq[10310]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1965600.
    coneq[10311]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/655200.
    coneq[10312]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))-1/245700.
    coneq[10313]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/491400.
    coneq[10314]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))-1/163800.
    coneq[10315]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/327600.
    coneq[10316]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**3))))-1/65520.
    coneq[10317]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))-1/196560.
    coneq[10318]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/393120.
    coneq[10319]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))-1/131040.
    coneq[10320]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/49140.
    coneq[10321]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/98280.
    coneq[10322]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/32760.
    coneq[10323]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/98280.
    coneq[10324]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/196560.
    coneq[10325]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/65520.
    coneq[10326]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**5)))-1/32760.
    coneq[10327]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**4))))-1/163800.
    coneq[10328]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/655200.
    coneq[10329]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1965600.
    coneq[10330]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/3931200.
    coneq[10331]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1310400.
    coneq[10332]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/491400.
    coneq[10333]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/982800.
    coneq[10334]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/327600.
    coneq[10335]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/655200.
    coneq[10336]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))-1/131040.
    coneq[10337]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/393120.
    coneq[10338]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/786240.
    coneq[10339]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/262080.
    coneq[10340]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/98280.
    coneq[10341]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/196560.
    coneq[10342]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/65520.
    coneq[10343]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/196560.
    coneq[10344]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/393120.
    coneq[10345]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/131040.
    coneq[10346]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**5)))-1/10920.
    coneq[10347]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c**4))))-1/54600.
    coneq[10348]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/218400.
    coneq[10349]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/655200.
    coneq[10350]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1310400.
    coneq[10351]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/436800.
    coneq[10352]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/163800.
    coneq[10353]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/327600.
    coneq[10354]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/109200.
    coneq[10355]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/218400.
    coneq[10356]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**3))))-1/43680.
    coneq[10357]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/131040.
    coneq[10358]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[10359]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/87360.
    coneq[10360]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/32760.
    coneq[10361]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/65520.
    coneq[10362]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**3*dot(A,c))))-1/21840.
    coneq[10363]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/65520.
    coneq[10364]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/131040.
    coneq[10365]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/43680.
    coneq[10366]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c**5)))-1/21840.
    coneq[10367]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**4))))-1/109200.
    coneq[10368]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/436800.
    coneq[10369]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1310400.
    coneq[10370]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2620800.
    coneq[10371]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/873600.
    coneq[10372]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/327600.
    coneq[10373]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/655200.
    coneq[10374]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/218400.
    coneq[10375]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/436800.
    coneq[10376]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3))))-1/87360.
    coneq[10377]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/262080.
    coneq[10378]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[10379]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/174720.
    coneq[10380]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/65520.
    coneq[10381]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/131040.
    coneq[10382]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c))))-1/43680.
    coneq[10383]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/131040.
    coneq[10384]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/262080.
    coneq[10385]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/87360.
    coneq[10386]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**6)))-1/5096.
    coneq[10387]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**5))))-1/30576.
    coneq[10388]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**4)))))-1/152880.
    coneq[10389]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/611520.
    coneq[10390]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[10391]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[10392]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[10393]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/458640.
    coneq[10394]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/917280.
    coneq[10395]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/305760.
    coneq[10396]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/611520.
    coneq[10397]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c**3)))))-1/122304.
    coneq[10398]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/366912.
    coneq[10399]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/733824.
    coneq[10400]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/244608.
    coneq[10401]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/91728.
    coneq[10402]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/183456.
    coneq[10403]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3*dot(A,c)))))-1/61152.
    coneq[10404]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/183456.
    coneq[10405]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/366912.
    coneq[10406]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/122304.
    coneq[10407]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**4))))-1/25480.
    coneq[10408]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c**3)))))-1/101920.
    coneq[10409]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/305760.
    coneq[10410]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/611520.
    coneq[10411]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/203840.
    coneq[10412]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/76440.
    coneq[10413]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/152880.
    coneq[10414]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/50960.
    coneq[10415]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/101920.
    coneq[10416]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c**3))))-1/20384.
    coneq[10417]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/61152.
    coneq[10418]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/122304.
    coneq[10419]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/40768.
    coneq[10420]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3*dot(A,c**2))))-1/15288.
    coneq[10421]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3*dot(A,dot(A,c)))))-1/30576.
    coneq[10422]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**4*dot(A,c))))-1/10192.
    coneq[10423]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/45864.
    coneq[10424]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/91728.
    coneq[10425]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/183456.
    coneq[10426]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**3))))-1/40768.
    coneq[10427]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/122304.
    coneq[10428]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/244608.
    coneq[10429]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/81536.
    coneq[10430]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/30576.
    coneq[10431]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/61152.
    coneq[10432]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/20384.
    coneq[10433]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/40768.
    coneq[10434]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**6)))-1/15288.
    coneq[10435]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**5))))-1/91728.
    coneq[10436]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**4)))))-1/458640.
    coneq[10437]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/1834560.
    coneq[10438]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/5503680.
    coneq[10439]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/11007360.
    coneq[10440]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3669120.
    coneq[10441]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/1375920.
    coneq[10442]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2751840.
    coneq[10443]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/917280.
    coneq[10444]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1834560.
    coneq[10445]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**3)))))-1/366912.
    coneq[10446]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/1100736.
    coneq[10447]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2201472.
    coneq[10448]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/733824.
    coneq[10449]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/275184.
    coneq[10450]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/550368.
    coneq[10451]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3*dot(A,c)))))-1/183456.
    coneq[10452]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/550368.
    coneq[10453]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1100736.
    coneq[10454]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/366912.
    coneq[10455]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**4))))-1/76440.
    coneq[10456]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**3)))))-1/305760.
    coneq[10457]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/917280.
    coneq[10458]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1834560.
    coneq[10459]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/611520.
    coneq[10460]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/229320.
    coneq[10461]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/458640.
    coneq[10462]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/152880.
    coneq[10463]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/305760.
    coneq[10464]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**3))))-1/61152.
    coneq[10465]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/183456.
    coneq[10466]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/366912.
    coneq[10467]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/122304.
    coneq[10468]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c**2))))-1/45864.
    coneq[10469]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,dot(A,c)))))-1/91728.
    coneq[10470]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4*dot(A,c))))-1/30576.
    coneq[10471]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/137592.
    coneq[10472]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/275184.
    coneq[10473]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/550368.
    coneq[10474]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**3))))-1/122304.
    coneq[10475]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/366912.
    coneq[10476]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/733824.
    coneq[10477]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/244608.
    coneq[10478]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/91728.
    coneq[10479]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/183456.
    coneq[10480]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/61152.
    coneq[10481]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/122304.
    coneq[10482]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**6)))-1/30576.
    coneq[10483]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**5))))-1/183456.
    coneq[10484]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**4)))))-1/917280.
    coneq[10485]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/3669120.
    coneq[10486]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/11007360.
    coneq[10487]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/22014720.
    coneq[10488]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/7338240.
    coneq[10489]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/2751840.
    coneq[10490]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/5503680.
    coneq[10491]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/1834560.
    coneq[10492]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/3669120.
    coneq[10493]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**3)))))-1/733824.
    coneq[10494]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/2201472.
    coneq[10495]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/4402944.
    coneq[10496]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/1467648.
    coneq[10497]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/550368.
    coneq[10498]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/1100736.
    coneq[10499]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,c)))))-1/366912.
    coneq[10500]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/1100736.
    coneq[10501]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/2201472.
    coneq[10502]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/733824.
    coneq[10503]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**4))))-1/152880.
    coneq[10504]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**3)))))-1/611520.
    coneq[10505]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/1834560.
    coneq[10506]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/3669120.
    coneq[10507]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/1223040.
    coneq[10508]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/458640.
    coneq[10509]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/917280.
    coneq[10510]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/305760.
    coneq[10511]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/611520.
    coneq[10512]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**3))))-1/122304.
    coneq[10513]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/366912.
    coneq[10514]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/733824.
    coneq[10515]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/244608.
    coneq[10516]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c**2))))-1/91728.
    coneq[10517]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,c)))))-1/183456.
    coneq[10518]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4*dot(A,c))))-1/61152.
    coneq[10519]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/275184.
    coneq[10520]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/550368.
    coneq[10521]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/1100736.
    coneq[10522]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**3))))-1/244608.
    coneq[10523]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/733824.
    coneq[10524]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/1467648.
    coneq[10525]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/489216.
    coneq[10526]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/183456.
    coneq[10527]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/366912.
    coneq[10528]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/122304.
    coneq[10529]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/244608.
    coneq[10530]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**6)))-1/10192.
    coneq[10531]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**5))))-1/61152.
    coneq[10532]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/305760.
    coneq[10533]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/1223040.
    coneq[10534]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[10535]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[10536]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[10537]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/917280.
    coneq[10538]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1834560.
    coneq[10539]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/611520.
    coneq[10540]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[10541]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/244608.
    coneq[10542]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/733824.
    coneq[10543]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1467648.
    coneq[10544]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/489216.
    coneq[10545]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/183456.
    coneq[10546]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/366912.
    coneq[10547]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/122304.
    coneq[10548]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/366912.
    coneq[10549]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/733824.
    coneq[10550]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/244608.
    coneq[10551]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**4))))-1/50960.
    coneq[10552]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/203840.
    coneq[10553]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/611520.
    coneq[10554]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1223040.
    coneq[10555]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/407680.
    coneq[10556]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/152880.
    coneq[10557]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/305760.
    coneq[10558]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/101920.
    coneq[10559]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/203840.
    coneq[10560]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/40768.
    coneq[10561]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/122304.
    coneq[10562]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/244608.
    coneq[10563]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/81536.
    coneq[10564]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/30576.
    coneq[10565]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/61152.
    coneq[10566]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4*dot(A,c))))-1/20384.
    coneq[10567]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/91728.
    coneq[10568]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/183456.
    coneq[10569]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/366912.
    coneq[10570]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/81536.
    coneq[10571]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/244608.
    coneq[10572]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/489216.
    coneq[10573]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/163072.
    coneq[10574]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/61152.
    coneq[10575]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/122304.
    coneq[10576]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/40768.
    coneq[10577]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/81536.
    coneq[10578]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**7)))-1/4368.
    coneq[10579]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**6))))-1/30576.
    coneq[10580]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**5)))))-1/183456.
    coneq[10581]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/917280.
    coneq[10582]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/3669120.
    coneq[10583]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/11007360.
    coneq[10584]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/22014720.
    coneq[10585]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/7338240.
    coneq[10586]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2751840.
    coneq[10587]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/5503680.
    coneq[10588]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1834560.
    coneq[10589]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3669120.
    coneq[10590]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/733824.
    coneq[10591]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2201472.
    coneq[10592]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/4402944.
    coneq[10593]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1467648.
    coneq[10594]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/550368.
    coneq[10595]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1100736.
    coneq[10596]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/366912.
    coneq[10597]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1100736.
    coneq[10598]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2201472.
    coneq[10599]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/733824.
    coneq[10600]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**4)))))-1/152880.
    coneq[10601]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/611520.
    coneq[10602]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[10603]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[10604]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[10605]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/458640.
    coneq[10606]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/917280.
    coneq[10607]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/305760.
    coneq[10608]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/611520.
    coneq[10609]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/122304.
    coneq[10610]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/366912.
    coneq[10611]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/733824.
    coneq[10612]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/244608.
    coneq[10613]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/91728.
    coneq[10614]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/183456.
    coneq[10615]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4*dot(A,c)))))-1/61152.
    coneq[10616]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/275184.
    coneq[10617]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/550368.
    coneq[10618]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1100736.
    coneq[10619]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/244608.
    coneq[10620]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/733824.
    coneq[10621]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1467648.
    coneq[10622]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/489216.
    coneq[10623]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/183456.
    coneq[10624]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/366912.
    coneq[10625]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/122304.
    coneq[10626]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/244608.
    coneq[10627]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**5))))-1/26208.
    coneq[10628]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**4)))))-1/131040.
    coneq[10629]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/524160.
    coneq[10630]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[10631]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[10632]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[10633]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[10634]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[10635]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[10636]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[10637]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/104832.
    coneq[10638]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/314496.
    coneq[10639]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[10640]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/209664.
    coneq[10641]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/78624.
    coneq[10642]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/157248.
    coneq[10643]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/52416.
    coneq[10644]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[10645]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[10646]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[10647]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**4))))-1/21840.
    coneq[10648]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/87360.
    coneq[10649]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/262080.
    coneq[10650]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[10651]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/174720.
    coneq[10652]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/65520.
    coneq[10653]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/131040.
    coneq[10654]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/43680.
    coneq[10655]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/87360.
    coneq[10656]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c**3))))-1/17472.
    coneq[10657]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/52416.
    coneq[10658]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[10659]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/34944.
    coneq[10660]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4*dot(A,c**2))))-1/13104.
    coneq[10661]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4*dot(A,dot(A,c)))))-1/26208.
    coneq[10662]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**5*dot(A,c))))-1/8736.
    coneq[10663]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/52416.
    coneq[10664]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/157248.
    coneq[10665]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[10666]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/104832.
    coneq[10667]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/104832.
    coneq[10668]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/314496.
    coneq[10669]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[10670]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/209664.
    coneq[10671]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**4))))-1/43680.
    coneq[10672]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/174720.
    coneq[10673]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[10674]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[10675]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[10676]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[10677]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[10678]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[10679]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[10680]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/39312.
    coneq[10681]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/78624.
    coneq[10682]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/157248.
    coneq[10683]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/34944.
    coneq[10684]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/104832.
    coneq[10685]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[10686]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/69888.
    coneq[10687]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/26208.
    coneq[10688]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/52416.
    coneq[10689]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/17472.
    coneq[10690]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[10691]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[10692]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/34944.
    coneq[10693]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**7)))-1/8736.
    coneq[10694]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**6))))-1/61152.
    coneq[10695]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**5)))))-1/366912.
    coneq[10696]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/1834560.
    coneq[10697]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/7338240.
    coneq[10698]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/22014720.
    coneq[10699]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/44029440.
    coneq[10700]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/14676480.
    coneq[10701]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/5503680.
    coneq[10702]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/11007360.
    coneq[10703]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/3669120.
    coneq[10704]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/7338240.
    coneq[10705]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/1467648.
    coneq[10706]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/4402944.
    coneq[10707]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/8805888.
    coneq[10708]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/2935296.
    coneq[10709]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/1100736.
    coneq[10710]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/2201472.
    coneq[10711]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/733824.
    coneq[10712]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/2201472.
    coneq[10713]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/4402944.
    coneq[10714]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/1467648.
    coneq[10715]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**4)))))-1/305760.
    coneq[10716]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/1223040.
    coneq[10717]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/3669120.
    coneq[10718]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/7338240.
    coneq[10719]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/2446080.
    coneq[10720]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/917280.
    coneq[10721]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1834560.
    coneq[10722]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/611520.
    coneq[10723]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/1223040.
    coneq[10724]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**3)))))-1/244608.
    coneq[10725]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/733824.
    coneq[10726]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/1467648.
    coneq[10727]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/489216.
    coneq[10728]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c**2)))))-1/183456.
    coneq[10729]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/366912.
    coneq[10730]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4*dot(A,c)))))-1/122304.
    coneq[10731]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/550368.
    coneq[10732]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/1100736.
    coneq[10733]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/2201472.
    coneq[10734]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/489216.
    coneq[10735]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/1467648.
    coneq[10736]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/2935296.
    coneq[10737]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/978432.
    coneq[10738]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/366912.
    coneq[10739]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/733824.
    coneq[10740]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/244608.
    coneq[10741]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/489216.
    coneq[10742]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**5))))-1/52416.
    coneq[10743]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**4)))))-1/262080.
    coneq[10744]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/1048320.
    coneq[10745]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[10746]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[10747]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[10748]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[10749]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[10750]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[10751]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[10752]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**3)))))-1/209664.
    coneq[10753]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/628992.
    coneq[10754]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[10755]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/419328.
    coneq[10756]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/157248.
    coneq[10757]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/314496.
    coneq[10758]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3*dot(A,c)))))-1/104832.
    coneq[10759]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[10760]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[10761]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[10762]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**4))))-1/43680.
    coneq[10763]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**3)))))-1/174720.
    coneq[10764]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[10765]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[10766]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[10767]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[10768]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[10769]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[10770]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[10771]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c**3))))-1/34944.
    coneq[10772]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c**2)))))-1/104832.
    coneq[10773]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[10774]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c*dot(A,c)))))-1/69888.
    coneq[10775]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4*dot(A,c**2))))-1/26208.
    coneq[10776]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4*dot(A,dot(A,c)))))-1/52416.
    coneq[10777]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**5*dot(A,c))))-1/17472.
    coneq[10778]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**3))))-1/104832.
    coneq[10779]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/314496.
    coneq[10780]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[10781]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/209664.
    coneq[10782]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/209664.
    coneq[10783]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/628992.
    coneq[10784]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[10785]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/419328.
    coneq[10786]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**4))))-1/87360.
    coneq[10787]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/349440.
    coneq[10788]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/1048320.
    coneq[10789]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[10790]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/698880.
    coneq[10791]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/262080.
    coneq[10792]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/524160.
    coneq[10793]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/174720.
    coneq[10794]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/349440.
    coneq[10795]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/78624.
    coneq[10796]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/157248.
    coneq[10797]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/314496.
    coneq[10798]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**3))))-1/69888.
    coneq[10799]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/209664.
    coneq[10800]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[10801]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/139776.
    coneq[10802]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[10803]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[10804]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,c))))-1/34944.
    coneq[10805]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/104832.
    coneq[10806]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/209664.
    coneq[10807]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/69888.
    coneq[10808]=dot(b,dot(A,c*dot(A,c)*dot(A,c**8)))-1/3276.
    coneq[10809]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**7))))-1/26208.
    coneq[10810]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**6)))))-1/183456.
    coneq[10811]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**5))))))-1/1100736.
    coneq[10812]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))-1/5503680.
    coneq[10813]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))-1/22014720.
    coneq[10814]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))-1/66044160.
    coneq[10815]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))-1/132088320.
    coneq[10816]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))-1/44029440.
    coneq[10817]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))-1/16511040.
    coneq[10818]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))-1/33022080.
    coneq[10819]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))-1/11007360.
    coneq[10820]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))-1/22014720.
    coneq[10821]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))-1/4402944.
    coneq[10822]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))-1/13208832.
    coneq[10823]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))-1/26417664.
    coneq[10824]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))-1/8805888.
    coneq[10825]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))-1/3302208.
    coneq[10826]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))-1/6604416.
    coneq[10827]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))-1/2201472.
    coneq[10828]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))-1/6604416.
    coneq[10829]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))-1/13208832.
    coneq[10830]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))-1/4402944.
    coneq[10831]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**4))))))-1/917280.
    coneq[10832]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))-1/3669120.
    coneq[10833]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))-1/11007360.
    coneq[10834]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))-1/22014720.
    coneq[10835]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))-1/7338240.
    coneq[10836]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))-1/2751840.
    coneq[10837]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))-1/5503680.
    coneq[10838]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))-1/1834560.
    coneq[10839]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))-1/3669120.
    coneq[10840]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))-1/733824.
    coneq[10841]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))-1/2201472.
    coneq[10842]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))-1/4402944.
    coneq[10843]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))-1/1467648.
    coneq[10844]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))-1/550368.
    coneq[10845]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))-1/1100736.
    coneq[10846]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4*dot(A,c))))))-1/366912.
    coneq[10847]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))-1/1651104.
    coneq[10848]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))-1/3302208.
    coneq[10849]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))-1/6604416.
    coneq[10850]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))-1/1467648.
    coneq[10851]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))-1/4402944.
    coneq[10852]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))-1/8805888.
    coneq[10853]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))-1/2935296.
    coneq[10854]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))-1/1100736.
    coneq[10855]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))-1/2201472.
    coneq[10856]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))-1/733824.
    coneq[10857]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))-1/1467648.
    coneq[10858]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**5)))))-1/157248.
    coneq[10859]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**4))))))-1/786240.
    coneq[10860]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))-1/3144960.
    coneq[10861]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/9434880.
    coneq[10862]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/18869760.
    coneq[10863]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/6289920.
    coneq[10864]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))-1/2358720.
    coneq[10865]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4717440.
    coneq[10866]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))-1/1572480.
    coneq[10867]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/3144960.
    coneq[10868]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))-1/628992.
    coneq[10869]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))-1/1886976.
    coneq[10870]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3773952.
    coneq[10871]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))-1/1257984.
    coneq[10872]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))-1/471744.
    coneq[10873]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))-1/943488.
    coneq[10874]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))-1/314496.
    coneq[10875]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))-1/943488.
    coneq[10876]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1886976.
    coneq[10877]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))-1/628992.
    coneq[10878]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**4)))))-1/131040.
    coneq[10879]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))-1/524160.
    coneq[10880]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))-1/1572480.
    coneq[10881]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))-1/3144960.
    coneq[10882]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))-1/1048320.
    coneq[10883]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))-1/393120.
    coneq[10884]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))-1/786240.
    coneq[10885]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))-1/262080.
    coneq[10886]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))-1/524160.
    coneq[10887]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c**3)))))-1/104832.
    coneq[10888]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))-1/314496.
    coneq[10889]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))-1/628992.
    coneq[10890]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))-1/209664.
    coneq[10891]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4*dot(A,c**2)))))-1/78624.
    coneq[10892]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4*dot(A,dot(A,c))))))-1/157248.
    coneq[10893]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**5*dot(A,c)))))-1/52416.
    coneq[10894]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))-1/314496.
    coneq[10895]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))-1/943488.
    coneq[10896]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))-1/1886976.
    coneq[10897]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))-1/628992.
    coneq[10898]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))-1/628992.
    coneq[10899]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))-1/1886976.
    coneq[10900]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))-1/3773952.
    coneq[10901]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))-1/1257984.
    coneq[10902]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))-1/262080.
    coneq[10903]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))-1/1048320.
    coneq[10904]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))-1/3144960.
    coneq[10905]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))-1/6289920.
    coneq[10906]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))-1/2096640.
    coneq[10907]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))-1/786240.
    coneq[10908]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))-1/1572480.
    coneq[10909]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))-1/524160.
    coneq[10910]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))-1/1048320.
    coneq[10911]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))-1/235872.
    coneq[10912]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))-1/471744.
    coneq[10913]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/943488.
    coneq[10914]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))-1/209664.
    coneq[10915]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))-1/628992.
    coneq[10916]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1257984.
    coneq[10917]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))-1/419328.
    coneq[10918]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))-1/157248.
    coneq[10919]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))-1/314496.
    coneq[10920]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))-1/104832.
    coneq[10921]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))-1/314496.
    coneq[10922]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))-1/628992.
    coneq[10923]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))-1/209664.
    coneq[10924]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**6))))-1/22932.
    coneq[10925]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**5)))))-1/137592.
    coneq[10926]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**4))))))-1/687960.
    coneq[10927]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2751840.
    coneq[10928]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/8255520.
    coneq[10929]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/16511040.
    coneq[10930]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/5503680.
    coneq[10931]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/2063880.
    coneq[10932]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/4127760.
    coneq[10933]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1375920.
    coneq[10934]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2751840.
    coneq[10935]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))-1/550368.
    coneq[10936]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1651104.
    coneq[10937]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/3302208.
    coneq[10938]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1100736.
    coneq[10939]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))-1/412776.
    coneq[10940]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/825552.
    coneq[10941]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))-1/275184.
    coneq[10942]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/825552.
    coneq[10943]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1651104.
    coneq[10944]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/550368.
    coneq[10945]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**4)))))-1/114660.
    coneq[10946]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))-1/458640.
    coneq[10947]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1375920.
    coneq[10948]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2751840.
    coneq[10949]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/917280.
    coneq[10950]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))-1/343980.
    coneq[10951]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/687960.
    coneq[10952]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))-1/229320.
    coneq[10953]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/458640.
    coneq[10954]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**3)))))-1/91728.
    coneq[10955]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))-1/275184.
    coneq[10956]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/550368.
    coneq[10957]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))-1/183456.
    coneq[10958]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c**2)))))-1/68796.
    coneq[10959]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))-1/137592.
    coneq[10960]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4*dot(A,c)))))-1/45864.
    coneq[10961]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))-1/206388.
    coneq[10962]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/412776.
    coneq[10963]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/825552.
    coneq[10964]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))-1/183456.
    coneq[10965]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/550368.
    coneq[10966]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1100736.
    coneq[10967]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/366912.
    coneq[10968]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))-1/137592.
    coneq[10969]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/275184.
    coneq[10970]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))-1/91728.
    coneq[10971]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/183456.
    coneq[10972]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**5))))-1/19656.
    coneq[10973]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**4)))))-1/98280.
    coneq[10974]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))-1/393120.
    coneq[10975]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1179360.
    coneq[10976]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2358720.
    coneq[10977]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/786240.
    coneq[10978]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))-1/294840.
    coneq[10979]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/589680.
    coneq[10980]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))-1/196560.
    coneq[10981]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/393120.
    coneq[10982]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**3)))))-1/78624.
    coneq[10983]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))-1/235872.
    coneq[10984]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/471744.
    coneq[10985]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))-1/157248.
    coneq[10986]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))-1/58968.
    coneq[10987]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))-1/117936.
    coneq[10988]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3*dot(A,c)))))-1/39312.
    coneq[10989]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))-1/117936.
    coneq[10990]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/235872.
    coneq[10991]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))-1/78624.
    coneq[10992]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**4))))-1/16380.
    coneq[10993]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c**3)))))-1/65520.
    coneq[10994]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))-1/196560.
    coneq[10995]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))-1/393120.
    coneq[10996]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))-1/131040.
    coneq[10997]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c**2)))))-1/49140.
    coneq[10998]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))-1/98280.
    coneq[10999]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2*dot(A,c)))))-1/32760.
    coneq[11000]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))-1/65520.
    coneq[11001]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c**3))))-1/13104.
    coneq[11002]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,dot(A,c**2)))))-1/39312.
    coneq[11003]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,dot(A,dot(A,c))))))-1/78624.
    coneq[11004]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c*dot(A,c)))))-1/26208.
    coneq[11005]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5*dot(A,c**2))))-1/9828.
    coneq[11006]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5*dot(A,dot(A,c)))))-1/19656.
    coneq[11007]=dot(b,dot(A,c*dot(A,c)*dot(A,c**6*dot(A,c))))-1/6552.
    coneq[11008]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)*dot(A,c**3))))-1/52416.
    coneq[11009]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))-1/157248.
    coneq[11010]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[11011]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))-1/104832.
    coneq[11012]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))-1/471744.
    coneq[11013]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))-1/943488.
    coneq[11014]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))-1/314496.
    coneq[11015]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))-1/1886976.
    coneq[11016]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))-1/628992.
    coneq[11017]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))-1/209664.
    coneq[11018]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**4))))-1/49140.
    coneq[11019]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))-1/196560.
    coneq[11020]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))-1/589680.
    coneq[11021]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1179360.
    coneq[11022]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))-1/393120.
    coneq[11023]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))-1/147420.
    coneq[11024]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))-1/294840.
    coneq[11025]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))-1/98280.
    coneq[11026]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))-1/196560.
    coneq[11027]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**4))))-1/98280.
    coneq[11028]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))-1/393120.
    coneq[11029]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))-1/1179360.
    coneq[11030]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))-1/2358720.
    coneq[11031]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))-1/786240.
    coneq[11032]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))-1/294840.
    coneq[11033]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))-1/589680.
    coneq[11034]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))-1/196560.
    coneq[11035]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))-1/393120.
    coneq[11036]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**5))))-1/39312.
    coneq[11037]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))-1/196560.
    coneq[11038]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))-1/786240.
    coneq[11039]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2358720.
    coneq[11040]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4717440.
    coneq[11041]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1572480.
    coneq[11042]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))-1/589680.
    coneq[11043]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1179360.
    coneq[11044]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))-1/393120.
    coneq[11045]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/786240.
    coneq[11046]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))-1/157248.
    coneq[11047]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))-1/471744.
    coneq[11048]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/943488.
    coneq[11049]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))-1/314496.
    coneq[11050]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))-1/117936.
    coneq[11051]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))-1/235872.
    coneq[11052]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))-1/78624.
    coneq[11053]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))-1/235872.
    coneq[11054]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/471744.
    coneq[11055]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))-1/157248.
    coneq[11056]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**3))))-1/39312.
    coneq[11057]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))-1/117936.
    coneq[11058]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/235872.
    coneq[11059]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))-1/78624.
    coneq[11060]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))-1/78624.
    coneq[11061]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/235872.
    coneq[11062]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[11063]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/157248.
    coneq[11064]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**4))))-1/32760.
    coneq[11065]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))-1/131040.
    coneq[11066]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/393120.
    coneq[11067]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[11068]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/262080.
    coneq[11069]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))-1/98280.
    coneq[11070]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/196560.
    coneq[11071]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))-1/65520.
    coneq[11072]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/131040.
    coneq[11073]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))-1/29484.
    coneq[11074]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))-1/58968.
    coneq[11075]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/117936.
    coneq[11076]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**3))))-1/26208.
    coneq[11077]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))-1/78624.
    coneq[11078]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[11079]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))-1/52416.
    coneq[11080]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c**2))))-1/19656.
    coneq[11081]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))-1/39312.
    coneq[11082]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c)*dot(A,c))))-1/13104.
    coneq[11083]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))-1/52416.
    coneq[11084]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))-1/157248.
    coneq[11085]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[11086]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))-1/104832.
    coneq[11087]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))-1/58968.
    coneq[11088]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))-1/117936.
    coneq[11089]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/235872.
    coneq[11090]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))-1/39312.
    coneq[11091]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/78624.
    coneq[11092]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))-1/26208.
    coneq[11093]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))-1/52416.
    coneq[11094]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,c**4)))-1/4550.
    coneq[11095]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,dot(A,c**3))))-1/18200.
    coneq[11096]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,dot(A,dot(A,c**2)))))-1/54600.
    coneq[11097]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c))))))-1/109200.
    coneq[11098]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,dot(A,c*dot(A,c)))))-1/36400.
    coneq[11099]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,c*dot(A,c**2))))-1/13650.
    coneq[11100]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,c*dot(A,dot(A,c)))))-1/27300.
    coneq[11101]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,c**2*dot(A,c))))-1/9100.
    coneq[11102]=dot(b,dot(A,c**2*dot(A,c**4)*dot(A,dot(A,c)*dot(A,c))))-1/18200.
    coneq[11103]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,dot(A,c**3))))-1/72800.
    coneq[11104]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))))-1/218400.
    coneq[11105]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))))-1/436800.
    coneq[11106]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))))-1/145600.
    coneq[11107]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2))))-1/54600.
    coneq[11108]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))))-1/109200.
    coneq[11109]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c))))-1/36400.
    coneq[11110]=dot(b,dot(A,c**2*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))))-1/72800.
    coneq[11111]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))))-1/655200.
    coneq[11112]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1310400.
    coneq[11113]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))))-1/436800.
    coneq[11114]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))))-1/163800.
    coneq[11115]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))))-1/327600.
    coneq[11116]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))))-1/109200.
    coneq[11117]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))))-1/218400.
    coneq[11118]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))))-1/2620800.
    coneq[11119]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))))-1/873600.
    coneq[11120]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))))-1/327600.
    coneq[11121]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))))-1/655200.
    coneq[11122]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))))-1/218400.
    coneq[11123]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))))-1/436800.
    coneq[11124]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/291200.
    coneq[11125]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))))-1/109200.
    coneq[11126]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/218400.
    coneq[11127]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))))-1/72800.
    coneq[11128]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/145600.
    coneq[11129]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/40950.
    coneq[11130]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/81900.
    coneq[11131]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/27300.
    coneq[11132]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/54600.
    coneq[11133]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/163800.
    coneq[11134]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/54600.
    coneq[11135]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/109200.
    coneq[11136]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))))-1/18200.
    coneq[11137]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/36400.
    coneq[11138]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/72800.
    coneq[11139]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**5)))-1/4368.
    coneq[11140]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**4))))-1/21840.
    coneq[11141]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c**3)))))-1/87360.
    coneq[11142]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/262080.
    coneq[11143]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[11144]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/174720.
    coneq[11145]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2)))))-1/65520.
    coneq[11146]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/131040.
    coneq[11147]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)))))-1/43680.
    coneq[11148]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/87360.
    coneq[11149]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c**3))))-1/17472.
    coneq[11150]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2)))))-1/52416.
    coneq[11151]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[11152]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)))))-1/34944.
    coneq[11153]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**2*dot(A,c**2))))-1/13104.
    coneq[11154]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)))))-1/26208.
    coneq[11155]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**3*dot(A,c))))-1/8736.
    coneq[11156]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2))))-1/26208.
    coneq[11157]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/52416.
    coneq[11158]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c))))-1/17472.
    coneq[11159]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**5)))-1/13104.
    coneq[11160]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**4))))-1/65520.
    coneq[11161]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))-1/262080.
    coneq[11162]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/786240.
    coneq[11163]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[11164]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/524160.
    coneq[11165]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))-1/196560.
    coneq[11166]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/393120.
    coneq[11167]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))-1/131040.
    coneq[11168]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/262080.
    coneq[11169]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3))))-1/52416.
    coneq[11170]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))-1/157248.
    coneq[11171]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[11172]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))-1/104832.
    coneq[11173]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/39312.
    coneq[11174]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/78624.
    coneq[11175]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/26208.
    coneq[11176]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/78624.
    coneq[11177]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/157248.
    coneq[11178]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/52416.
    coneq[11179]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**5)))-1/26208.
    coneq[11180]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4))))-1/131040.
    coneq[11181]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/524160.
    coneq[11182]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1572480.
    coneq[11183]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[11184]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1048320.
    coneq[11185]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/393120.
    coneq[11186]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/786240.
    coneq[11187]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/262080.
    coneq[11188]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/524160.
    coneq[11189]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))-1/104832.
    coneq[11190]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/314496.
    coneq[11191]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[11192]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/209664.
    coneq[11193]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/78624.
    coneq[11194]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/157248.
    coneq[11195]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/52416.
    coneq[11196]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/157248.
    coneq[11197]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/314496.
    coneq[11198]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/104832.
    coneq[11199]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**5)))-1/8736.
    coneq[11200]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c**4))))-1/43680.
    coneq[11201]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/174720.
    coneq[11202]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[11203]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[11204]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[11205]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[11206]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[11207]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[11208]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[11209]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3))))-1/34944.
    coneq[11210]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/104832.
    coneq[11211]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[11212]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/69888.
    coneq[11213]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/26208.
    coneq[11214]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/52416.
    coneq[11215]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c))))-1/17472.
    coneq[11216]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[11217]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[11218]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/34944.
    coneq[11219]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**6)))-1/3822.
    coneq[11220]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**5))))-1/22932.
    coneq[11221]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**4)))))-1/114660.
    coneq[11222]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/458640.
    coneq[11223]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1375920.
    coneq[11224]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2751840.
    coneq[11225]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/917280.
    coneq[11226]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/343980.
    coneq[11227]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/687960.
    coneq[11228]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/229320.
    coneq[11229]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/458640.
    coneq[11230]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3)))))-1/91728.
    coneq[11231]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/275184.
    coneq[11232]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/550368.
    coneq[11233]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/183456.
    coneq[11234]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/68796.
    coneq[11235]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/137592.
    coneq[11236]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)))))-1/45864.
    coneq[11237]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/137592.
    coneq[11238]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/275184.
    coneq[11239]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/91728.
    coneq[11240]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**4))))-1/19110.
    coneq[11241]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3)))))-1/76440.
    coneq[11242]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/229320.
    coneq[11243]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/458640.
    coneq[11244]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/152880.
    coneq[11245]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/57330.
    coneq[11246]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/114660.
    coneq[11247]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/38220.
    coneq[11248]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/76440.
    coneq[11249]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c**3))))-1/15288.
    coneq[11250]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/45864.
    coneq[11251]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/91728.
    coneq[11252]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/30576.
    coneq[11253]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3*dot(A,c**2))))-1/11466.
    coneq[11254]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)))))-1/22932.
    coneq[11255]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**4*dot(A,c))))-1/7644.
    coneq[11256]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/34398.
    coneq[11257]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/68796.
    coneq[11258]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/137592.
    coneq[11259]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3))))-1/30576.
    coneq[11260]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/91728.
    coneq[11261]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/183456.
    coneq[11262]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/61152.
    coneq[11263]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/22932.
    coneq[11264]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/45864.
    coneq[11265]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/15288.
    coneq[11266]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/30576.
    coneq[11267]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**6)))-1/7644.
    coneq[11268]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**5))))-1/45864.
    coneq[11269]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/229320.
    coneq[11270]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/917280.
    coneq[11271]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2751840.
    coneq[11272]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5503680.
    coneq[11273]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1834560.
    coneq[11274]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/687960.
    coneq[11275]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1375920.
    coneq[11276]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/458640.
    coneq[11277]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/917280.
    coneq[11278]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/183456.
    coneq[11279]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/550368.
    coneq[11280]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1100736.
    coneq[11281]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/366912.
    coneq[11282]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/137592.
    coneq[11283]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/275184.
    coneq[11284]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/91728.
    coneq[11285]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/275184.
    coneq[11286]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/550368.
    coneq[11287]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/183456.
    coneq[11288]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**4))))-1/38220.
    coneq[11289]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/152880.
    coneq[11290]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/458640.
    coneq[11291]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/917280.
    coneq[11292]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/305760.
    coneq[11293]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/114660.
    coneq[11294]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/229320.
    coneq[11295]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/76440.
    coneq[11296]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/152880.
    coneq[11297]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/30576.
    coneq[11298]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/91728.
    coneq[11299]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/183456.
    coneq[11300]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/61152.
    coneq[11301]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/22932.
    coneq[11302]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/45864.
    coneq[11303]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4*dot(A,c))))-1/15288.
    coneq[11304]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/68796.
    coneq[11305]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/137592.
    coneq[11306]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/275184.
    coneq[11307]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/61152.
    coneq[11308]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/183456.
    coneq[11309]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/366912.
    coneq[11310]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/122304.
    coneq[11311]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/45864.
    coneq[11312]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/91728.
    coneq[11313]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/30576.
    coneq[11314]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/61152.
    coneq[11315]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**7)))-1/2912.
    coneq[11316]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**6))))-1/20384.
    coneq[11317]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**5)))))-1/122304.
    coneq[11318]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/611520.
    coneq[11319]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/2446080.
    coneq[11320]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/7338240.
    coneq[11321]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/14676480.
    coneq[11322]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/4892160.
    coneq[11323]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/1834560.
    coneq[11324]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/3669120.
    coneq[11325]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/1223040.
    coneq[11326]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/2446080.
    coneq[11327]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/489216.
    coneq[11328]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/1467648.
    coneq[11329]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/2935296.
    coneq[11330]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/978432.
    coneq[11331]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/366912.
    coneq[11332]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/733824.
    coneq[11333]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/244608.
    coneq[11334]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/733824.
    coneq[11335]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/1467648.
    coneq[11336]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/489216.
    coneq[11337]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**4)))))-1/101920.
    coneq[11338]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/407680.
    coneq[11339]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/1223040.
    coneq[11340]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/2446080.
    coneq[11341]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/815360.
    coneq[11342]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/305760.
    coneq[11343]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/611520.
    coneq[11344]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/203840.
    coneq[11345]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/407680.
    coneq[11346]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/81536.
    coneq[11347]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/244608.
    coneq[11348]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/489216.
    coneq[11349]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/163072.
    coneq[11350]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/61152.
    coneq[11351]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/122304.
    coneq[11352]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4*dot(A,c)))))-1/40768.
    coneq[11353]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/183456.
    coneq[11354]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/366912.
    coneq[11355]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/733824.
    coneq[11356]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/163072.
    coneq[11357]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/489216.
    coneq[11358]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/978432.
    coneq[11359]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/326144.
    coneq[11360]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/122304.
    coneq[11361]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/244608.
    coneq[11362]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/81536.
    coneq[11363]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/163072.
    coneq[11364]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**5))))-1/17472.
    coneq[11365]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**4)))))-1/87360.
    coneq[11366]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/349440.
    coneq[11367]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1048320.
    coneq[11368]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/2096640.
    coneq[11369]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/698880.
    coneq[11370]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/262080.
    coneq[11371]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/524160.
    coneq[11372]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/174720.
    coneq[11373]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/349440.
    coneq[11374]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/69888.
    coneq[11375]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/209664.
    coneq[11376]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/419328.
    coneq[11377]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/139776.
    coneq[11378]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/52416.
    coneq[11379]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/104832.
    coneq[11380]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/34944.
    coneq[11381]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/104832.
    coneq[11382]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/209664.
    coneq[11383]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/69888.
    coneq[11384]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**4))))-1/14560.
    coneq[11385]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/58240.
    coneq[11386]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/174720.
    coneq[11387]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/349440.
    coneq[11388]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/116480.
    coneq[11389]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/43680.
    coneq[11390]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/87360.
    coneq[11391]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/29120.
    coneq[11392]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/58240.
    coneq[11393]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c**3))))-1/11648.
    coneq[11394]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/34944.
    coneq[11395]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/69888.
    coneq[11396]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/23296.
    coneq[11397]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4*dot(A,c**2))))-1/8736.
    coneq[11398]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4*dot(A,dot(A,c)))))-1/17472.
    coneq[11399]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**5*dot(A,c))))-1/5824.
    coneq[11400]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/34944.
    coneq[11401]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/104832.
    coneq[11402]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[11403]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/69888.
    coneq[11404]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/69888.
    coneq[11405]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/209664.
    coneq[11406]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[11407]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/139776.
    coneq[11408]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**4))))-1/29120.
    coneq[11409]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/116480.
    coneq[11410]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/349440.
    coneq[11411]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/698880.
    coneq[11412]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/232960.
    coneq[11413]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/87360.
    coneq[11414]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/174720.
    coneq[11415]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/58240.
    coneq[11416]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/116480.
    coneq[11417]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/26208.
    coneq[11418]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/52416.
    coneq[11419]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/104832.
    coneq[11420]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/23296.
    coneq[11421]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/69888.
    coneq[11422]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/139776.
    coneq[11423]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/46592.
    coneq[11424]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/17472.
    coneq[11425]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/34944.
    coneq[11426]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/11648.
    coneq[11427]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/34944.
    coneq[11428]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/69888.
    coneq[11429]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/23296.
    coneq[11430]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c**4)))-1/3640.
    coneq[11431]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,c**3))))-1/14560.
    coneq[11432]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/43680.
    coneq[11433]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/87360.
    coneq[11434]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/29120.
    coneq[11435]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/10920.
    coneq[11436]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/21840.
    coneq[11437]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/7280.
    coneq[11438]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/14560.
    coneq[11439]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c**4)))-1/10920.
    coneq[11440]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/43680.
    coneq[11441]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/131040.
    coneq[11442]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[11443]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/87360.
    coneq[11444]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/32760.
    coneq[11445]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/65520.
    coneq[11446]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/21840.
    coneq[11447]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/43680.
    coneq[11448]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/21840.
    coneq[11449]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/87360.
    coneq[11450]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/262080.
    coneq[11451]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[11452]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/174720.
    coneq[11453]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/65520.
    coneq[11454]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/131040.
    coneq[11455]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/43680.
    coneq[11456]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/87360.
    coneq[11457]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c**4)))-1/7280.
    coneq[11458]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/29120.
    coneq[11459]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/87360.
    coneq[11460]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/174720.
    coneq[11461]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/58240.
    coneq[11462]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/21840.
    coneq[11463]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/43680.
    coneq[11464]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/14560.
    coneq[11465]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/29120.
    coneq[11466]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**5)))-1/3276.
    coneq[11467]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**4))))-1/16380.
    coneq[11468]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/65520.
    coneq[11469]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/196560.
    coneq[11470]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/393120.
    coneq[11471]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/131040.
    coneq[11472]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/49140.
    coneq[11473]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/98280.
    coneq[11474]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/32760.
    coneq[11475]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/65520.
    coneq[11476]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/13104.
    coneq[11477]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/39312.
    coneq[11478]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/78624.
    coneq[11479]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/26208.
    coneq[11480]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/9828.
    coneq[11481]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/19656.
    coneq[11482]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/6552.
    coneq[11483]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/19656.
    coneq[11484]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/39312.
    coneq[11485]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/13104.
    coneq[11486]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**5)))-1/6552.
    coneq[11487]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/32760.
    coneq[11488]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/131040.
    coneq[11489]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/393120.
    coneq[11490]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[11491]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/262080.
    coneq[11492]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/98280.
    coneq[11493]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/196560.
    coneq[11494]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/65520.
    coneq[11495]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/131040.
    coneq[11496]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/26208.
    coneq[11497]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/78624.
    coneq[11498]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[11499]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/52416.
    coneq[11500]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/19656.
    coneq[11501]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/39312.
    coneq[11502]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/13104.
    coneq[11503]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/39312.
    coneq[11504]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/78624.
    coneq[11505]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/26208.
    coneq[11506]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**6)))-1/2548.
    coneq[11507]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**5))))-1/15288.
    coneq[11508]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))-1/76440.
    coneq[11509]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/305760.
    coneq[11510]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/917280.
    coneq[11511]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/1834560.
    coneq[11512]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/611520.
    coneq[11513]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/229320.
    coneq[11514]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/458640.
    coneq[11515]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/152880.
    coneq[11516]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/305760.
    coneq[11517]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))-1/61152.
    coneq[11518]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/183456.
    coneq[11519]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/366912.
    coneq[11520]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/122304.
    coneq[11521]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/45864.
    coneq[11522]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/91728.
    coneq[11523]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))-1/30576.
    coneq[11524]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/91728.
    coneq[11525]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/183456.
    coneq[11526]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/61152.
    coneq[11527]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**4))))-1/12740.
    coneq[11528]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))-1/50960.
    coneq[11529]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/152880.
    coneq[11530]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/305760.
    coneq[11531]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/101920.
    coneq[11532]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/38220.
    coneq[11533]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/76440.
    coneq[11534]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/25480.
    coneq[11535]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/50960.
    coneq[11536]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c**3))))-1/10192.
    coneq[11537]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/30576.
    coneq[11538]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/61152.
    coneq[11539]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/20384.
    coneq[11540]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3*dot(A,c**2))))-1/7644.
    coneq[11541]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))-1/15288.
    coneq[11542]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**4*dot(A,c))))-1/5096.
    coneq[11543]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/22932.
    coneq[11544]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/45864.
    coneq[11545]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/91728.
    coneq[11546]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))-1/20384.
    coneq[11547]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/61152.
    coneq[11548]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/122304.
    coneq[11549]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/40768.
    coneq[11550]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/15288.
    coneq[11551]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/30576.
    coneq[11552]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/10192.
    coneq[11553]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/20384.
    coneq[11554]=dot(b,dot(A,c**4*dot(A,c**3)*dot(A,c**3)))-1/2912.
    coneq[11555]=dot(b,dot(A,c**4*dot(A,c**3)*dot(A,dot(A,c**2))))-1/8736.
    coneq[11556]=dot(b,dot(A,c**4*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/17472.
    coneq[11557]=dot(b,dot(A,c**4*dot(A,c**3)*dot(A,c*dot(A,c))))-1/5824.
    coneq[11558]=dot(b,dot(A,c**4*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/26208.
    coneq[11559]=dot(b,dot(A,c**4*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/52416.
    coneq[11560]=dot(b,dot(A,c**4*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/17472.
    coneq[11561]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/104832.
    coneq[11562]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/34944.
    coneq[11563]=dot(b,dot(A,c**4*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/11648.
    coneq[11564]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**4)))-1/2730.
    coneq[11565]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c**3))))-1/10920.
    coneq[11566]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/32760.
    coneq[11567]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/65520.
    coneq[11568]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/21840.
    coneq[11569]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/8190.
    coneq[11570]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/16380.
    coneq[11571]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/5460.
    coneq[11572]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/10920.
    coneq[11573]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c**4)))-1/5460.
    coneq[11574]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/21840.
    coneq[11575]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/65520.
    coneq[11576]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/131040.
    coneq[11577]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/43680.
    coneq[11578]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/16380.
    coneq[11579]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/32760.
    coneq[11580]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/10920.
    coneq[11581]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/21840.
    coneq[11582]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**5)))-1/2184.
    coneq[11583]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**4))))-1/10920.
    coneq[11584]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/43680.
    coneq[11585]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/131040.
    coneq[11586]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/262080.
    coneq[11587]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/87360.
    coneq[11588]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/32760.
    coneq[11589]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/65520.
    coneq[11590]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/21840.
    coneq[11591]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/43680.
    coneq[11592]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c**3))))-1/8736.
    coneq[11593]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/26208.
    coneq[11594]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/52416.
    coneq[11595]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/17472.
    coneq[11596]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/6552.
    coneq[11597]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/13104.
    coneq[11598]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**3*dot(A,c))))-1/4368.
    coneq[11599]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/13104.
    coneq[11600]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/26208.
    coneq[11601]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/8736.
    coneq[11602]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,c**3)))-1/2184.
    coneq[11603]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,dot(A,c**2))))-1/6552.
    coneq[11604]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/13104.
    coneq[11605]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,c*dot(A,c))))-1/4368.
    coneq[11606]=dot(b,dot(A,c**5*dot(A,dot(A,c))*dot(A,c**3)))-1/4368.
    coneq[11607]=dot(b,dot(A,c**5*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/13104.
    coneq[11608]=dot(b,dot(A,c**5*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/26208.
    coneq[11609]=dot(b,dot(A,c**5*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/8736.
    coneq[11610]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**4)))-1/1820.
    coneq[11611]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c**3))))-1/7280.
    coneq[11612]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/21840.
    coneq[11613]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/43680.
    coneq[11614]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/14560.
    coneq[11615]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c*dot(A,c**2))))-1/5460.
    coneq[11616]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/10920.
    coneq[11617]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**2*dot(A,c))))-1/3640.
    coneq[11618]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/7280.
    coneq[11619]=dot(b,dot(A,c**6*dot(A,c**2)*dot(A,c**2)))-1/1638.
    coneq[11620]=dot(b,dot(A,c**6*dot(A,c**2)*dot(A,dot(A,c))))-1/3276.
    coneq[11621]=dot(b,dot(A,c**6*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/6552.
    coneq[11622]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c**3)))-1/1456.
    coneq[11623]=dot(b,dot(A,c**6*dot(A,c)*dot(A,dot(A,c**2))))-1/4368.
    coneq[11624]=dot(b,dot(A,c**6*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/8736.
    coneq[11625]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c*dot(A,c))))-1/2912.
    coneq[11626]=dot(b,dot(A,c**7*dot(A,c)*dot(A,c**2)))-1/1092.
    coneq[11627]=dot(b,dot(A,c**7*dot(A,c)*dot(A,dot(A,c))))-1/2184.
    coneq[11628]=dot(b,dot(A,c**8*dot(A,c)*dot(A,c)))-1/728.
    coneq[11629]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**7)))-1/5824.
    coneq[11630]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**6))))-1/40768.
    coneq[11631]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**5)))))-1/244608.
    coneq[11632]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4))))))-1/1223040.
    coneq[11633]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))-1/4892160.
    coneq[11634]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))-1/14676480.
    coneq[11635]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))-1/29352960.
    coneq[11636]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))-1/9784320.
    coneq[11637]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))-1/3669120.
    coneq[11638]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))-1/7338240.
    coneq[11639]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))-1/2446080.
    coneq[11640]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))-1/4892160.
    coneq[11641]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))-1/978432.
    coneq[11642]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))-1/2935296.
    coneq[11643]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))-1/5870592.
    coneq[11644]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))-1/1956864.
    coneq[11645]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))-1/733824.
    coneq[11646]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))-1/1467648.
    coneq[11647]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))-1/489216.
    coneq[11648]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))-1/1467648.
    coneq[11649]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))-1/2935296.
    coneq[11650]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))-1/978432.
    coneq[11651]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**4)))))-1/203840.
    coneq[11652]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))-1/815360.
    coneq[11653]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))-1/2446080.
    coneq[11654]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))-1/4892160.
    coneq[11655]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))-1/1630720.
    coneq[11656]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))-1/611520.
    coneq[11657]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))-1/1223040.
    coneq[11658]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))-1/407680.
    coneq[11659]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))-1/815360.
    coneq[11660]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3)))))-1/163072.
    coneq[11661]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))-1/489216.
    coneq[11662]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))-1/978432.
    coneq[11663]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))-1/326144.
    coneq[11664]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2)))))-1/122304.
    coneq[11665]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))-1/244608.
    coneq[11666]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4*dot(A,c)))))-1/81536.
    coneq[11667]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))-1/366912.
    coneq[11668]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))-1/733824.
    coneq[11669]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))-1/1467648.
    coneq[11670]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))-1/326144.
    coneq[11671]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))-1/978432.
    coneq[11672]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))-1/1956864.
    coneq[11673]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))-1/652288.
    coneq[11674]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))-1/244608.
    coneq[11675]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))-1/489216.
    coneq[11676]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))-1/163072.
    coneq[11677]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))-1/326144.
    coneq[11678]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**5))))-1/34944.
    coneq[11679]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**4)))))-1/174720.
    coneq[11680]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))-1/698880.
    coneq[11681]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2096640.
    coneq[11682]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/4193280.
    coneq[11683]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1397760.
    coneq[11684]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))-1/524160.
    coneq[11685]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1048320.
    coneq[11686]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))-1/349440.
    coneq[11687]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/698880.
    coneq[11688]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3)))))-1/139776.
    coneq[11689]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))-1/419328.
    coneq[11690]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/838656.
    coneq[11691]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))-1/279552.
    coneq[11692]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2)))))-1/104832.
    coneq[11693]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))-1/209664.
    coneq[11694]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)))))-1/69888.
    coneq[11695]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))-1/209664.
    coneq[11696]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/419328.
    coneq[11697]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))-1/139776.
    coneq[11698]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**4))))-1/29120.
    coneq[11699]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3)))))-1/116480.
    coneq[11700]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))-1/349440.
    coneq[11701]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))-1/698880.
    coneq[11702]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))-1/232960.
    coneq[11703]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2)))))-1/87360.
    coneq[11704]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))-1/174720.
    coneq[11705]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)))))-1/58240.
    coneq[11706]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))-1/116480.
    coneq[11707]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c**3))))-1/23296.
    coneq[11708]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2)))))-1/69888.
    coneq[11709]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))-1/139776.
    coneq[11710]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)))))-1/46592.
    coneq[11711]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4*dot(A,c**2))))-1/17472.
    coneq[11712]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4*dot(A,dot(A,c)))))-1/34944.
    coneq[11713]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5*dot(A,c))))-1/11648.
    coneq[11714]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3))))-1/69888.
    coneq[11715]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))-1/209664.
    coneq[11716]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[11717]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))-1/139776.
    coneq[11718]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))-1/139776.
    coneq[11719]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))-1/419328.
    coneq[11720]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))-1/838656.
    coneq[11721]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))-1/279552.
    coneq[11722]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**4))))-1/58240.
    coneq[11723]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))-1/232960.
    coneq[11724]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))-1/698880.
    coneq[11725]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1397760.
    coneq[11726]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))-1/465920.
    coneq[11727]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))-1/174720.
    coneq[11728]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))-1/349440.
    coneq[11729]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))-1/116480.
    coneq[11730]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))-1/232960.
    coneq[11731]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2))))-1/52416.
    coneq[11732]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))-1/104832.
    coneq[11733]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/209664.
    coneq[11734]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3))))-1/46592.
    coneq[11735]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))-1/139776.
    coneq[11736]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/279552.
    coneq[11737]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))-1/93184.
    coneq[11738]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2))))-1/34944.
    coneq[11739]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))-1/69888.
    coneq[11740]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c))))-1/23296.
    coneq[11741]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))-1/69888.
    coneq[11742]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))-1/139776.
    coneq[11743]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))-1/46592.
    coneq[11744]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**6)))-1/7644.
    coneq[11745]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**5))))-1/45864.
    coneq[11746]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**4)))))-1/229320.
    coneq[11747]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/917280.
    coneq[11748]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/2751840.
    coneq[11749]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/5503680.
    coneq[11750]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1834560.
    coneq[11751]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/687960.
    coneq[11752]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/1375920.
    coneq[11753]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/458640.
    coneq[11754]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/917280.
    coneq[11755]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3)))))-1/183456.
    coneq[11756]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/550368.
    coneq[11757]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/1100736.
    coneq[11758]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/366912.
    coneq[11759]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/137592.
    coneq[11760]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/275184.
    coneq[11761]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)))))-1/91728.
    coneq[11762]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/275184.
    coneq[11763]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/550368.
    coneq[11764]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/183456.
    coneq[11765]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**4))))-1/38220.
    coneq[11766]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3)))))-1/152880.
    coneq[11767]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/458640.
    coneq[11768]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/917280.
    coneq[11769]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/305760.
    coneq[11770]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/114660.
    coneq[11771]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/229320.
    coneq[11772]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/76440.
    coneq[11773]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/152880.
    coneq[11774]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c**3))))-1/30576.
    coneq[11775]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/91728.
    coneq[11776]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/183456.
    coneq[11777]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/61152.
    coneq[11778]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3*dot(A,c**2))))-1/22932.
    coneq[11779]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)))))-1/45864.
    coneq[11780]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4*dot(A,c))))-1/15288.
    coneq[11781]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/68796.
    coneq[11782]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/137592.
    coneq[11783]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/275184.
    coneq[11784]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3))))-1/61152.
    coneq[11785]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/183456.
    coneq[11786]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/366912.
    coneq[11787]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/122304.
    coneq[11788]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/45864.
    coneq[11789]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/91728.
    coneq[11790]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/30576.
    coneq[11791]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/61152.
    coneq[11792]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**6)))-1/15288.
    coneq[11793]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**5))))-1/91728.
    coneq[11794]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4)))))-1/458640.
    coneq[11795]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/1834560.
    coneq[11796]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/5503680.
    coneq[11797]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/11007360.
    coneq[11798]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/3669120.
    coneq[11799]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/1375920.
    coneq[11800]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/2751840.
    coneq[11801]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/917280.
    coneq[11802]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/1834560.
    coneq[11803]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))-1/366912.
    coneq[11804]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/1100736.
    coneq[11805]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/2201472.
    coneq[11806]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/733824.
    coneq[11807]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))-1/275184.
    coneq[11808]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/550368.
    coneq[11809]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))-1/183456.
    coneq[11810]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/550368.
    coneq[11811]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/1100736.
    coneq[11812]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/366912.
    coneq[11813]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**4))))-1/76440.
    coneq[11814]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))-1/305760.
    coneq[11815]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/917280.
    coneq[11816]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/1834560.
    coneq[11817]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/611520.
    coneq[11818]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))-1/229320.
    coneq[11819]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/458640.
    coneq[11820]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))-1/152880.
    coneq[11821]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/305760.
    coneq[11822]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3))))-1/61152.
    coneq[11823]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))-1/183456.
    coneq[11824]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/366912.
    coneq[11825]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))-1/122304.
    coneq[11826]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2))))-1/45864.
    coneq[11827]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))-1/91728.
    coneq[11828]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4*dot(A,c))))-1/30576.
    coneq[11829]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))-1/137592.
    coneq[11830]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/275184.
    coneq[11831]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/550368.
    coneq[11832]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))-1/122304.
    coneq[11833]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/366912.
    coneq[11834]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/733824.
    coneq[11835]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/244608.
    coneq[11836]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))-1/91728.
    coneq[11837]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/183456.
    coneq[11838]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))-1/61152.
    coneq[11839]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/122304.
    coneq[11840]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**5)))-1/9828.
    coneq[11841]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**4))))-1/49140.
    coneq[11842]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/196560.
    coneq[11843]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/589680.
    coneq[11844]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1179360.
    coneq[11845]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/393120.
    coneq[11846]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/147420.
    coneq[11847]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/294840.
    coneq[11848]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/98280.
    coneq[11849]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/196560.
    coneq[11850]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/39312.
    coneq[11851]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/117936.
    coneq[11852]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/235872.
    coneq[11853]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/78624.
    coneq[11854]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/29484.
    coneq[11855]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/58968.
    coneq[11856]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/19656.
    coneq[11857]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/58968.
    coneq[11858]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/117936.
    coneq[11859]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/39312.
    coneq[11860]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**5)))-1/19656.
    coneq[11861]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/98280.
    coneq[11862]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/393120.
    coneq[11863]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1179360.
    coneq[11864]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2358720.
    coneq[11865]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/786240.
    coneq[11866]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/294840.
    coneq[11867]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/589680.
    coneq[11868]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/196560.
    coneq[11869]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/393120.
    coneq[11870]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/78624.
    coneq[11871]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/235872.
    coneq[11872]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/471744.
    coneq[11873]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/157248.
    coneq[11874]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/58968.
    coneq[11875]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/117936.
    coneq[11876]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/39312.
    coneq[11877]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/117936.
    coneq[11878]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/235872.
    coneq[11879]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/78624.
    coneq[11880]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**5)))-1/39312.
    coneq[11881]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/196560.
    coneq[11882]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/786240.
    coneq[11883]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/2358720.
    coneq[11884]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/4717440.
    coneq[11885]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1572480.
    coneq[11886]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/589680.
    coneq[11887]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/1179360.
    coneq[11888]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/393120.
    coneq[11889]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/786240.
    coneq[11890]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/157248.
    coneq[11891]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/471744.
    coneq[11892]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/943488.
    coneq[11893]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/314496.
    coneq[11894]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/117936.
    coneq[11895]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/235872.
    coneq[11896]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/78624.
    coneq[11897]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/235872.
    coneq[11898]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/471744.
    coneq[11899]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/157248.
    coneq[11900]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**5)))-1/8736.
    coneq[11901]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**4))))-1/43680.
    coneq[11902]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c**3)))))-1/174720.
    coneq[11903]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[11904]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[11905]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[11906]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[11907]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[11908]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[11909]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[11910]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c**3))))-1/34944.
    coneq[11911]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2)))))-1/104832.
    coneq[11912]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[11913]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)))))-1/69888.
    coneq[11914]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**2*dot(A,c**2))))-1/26208.
    coneq[11915]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)))))-1/52416.
    coneq[11916]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3*dot(A,c))))-1/17472.
    coneq[11917]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[11918]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[11919]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c))))-1/34944.
    coneq[11920]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**5)))-1/26208.
    coneq[11921]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**4))))-1/131040.
    coneq[11922]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))-1/524160.
    coneq[11923]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1572480.
    coneq[11924]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/3144960.
    coneq[11925]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/1048320.
    coneq[11926]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))-1/393120.
    coneq[11927]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/786240.
    coneq[11928]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))-1/262080.
    coneq[11929]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/524160.
    coneq[11930]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3))))-1/104832.
    coneq[11931]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))-1/314496.
    coneq[11932]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/628992.
    coneq[11933]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))-1/209664.
    coneq[11934]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2))))-1/78624.
    coneq[11935]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))-1/157248.
    coneq[11936]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c))))-1/52416.
    coneq[11937]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))-1/157248.
    coneq[11938]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/314496.
    coneq[11939]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))-1/104832.
    coneq[11940]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**5)))-1/52416.
    coneq[11941]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4))))-1/262080.
    coneq[11942]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))-1/1048320.
    coneq[11943]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/3144960.
    coneq[11944]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/6289920.
    coneq[11945]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/2096640.
    coneq[11946]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))-1/786240.
    coneq[11947]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/1572480.
    coneq[11948]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))-1/524160.
    coneq[11949]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/1048320.
    coneq[11950]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))-1/209664.
    coneq[11951]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))-1/628992.
    coneq[11952]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/1257984.
    coneq[11953]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))-1/419328.
    coneq[11954]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))-1/157248.
    coneq[11955]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))-1/314496.
    coneq[11956]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))-1/104832.
    coneq[11957]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))-1/314496.
    coneq[11958]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/628992.
    coneq[11959]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))-1/209664.
    coneq[11960]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**5)))-1/17472.
    coneq[11961]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**4))))-1/87360.
    coneq[11962]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/349440.
    coneq[11963]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/1048320.
    coneq[11964]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/2096640.
    coneq[11965]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/698880.
    coneq[11966]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/262080.
    coneq[11967]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/524160.
    coneq[11968]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/174720.
    coneq[11969]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/349440.
    coneq[11970]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3))))-1/69888.
    coneq[11971]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/209664.
    coneq[11972]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/419328.
    coneq[11973]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/139776.
    coneq[11974]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/52416.
    coneq[11975]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/104832.
    coneq[11976]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c))))-1/34944.
    coneq[11977]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/104832.
    coneq[11978]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/209664.
    coneq[11979]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/69888.
    coneq[11980]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c**4)))-1/10920.
    coneq[11981]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c**3))))-1/43680.
    coneq[11982]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/131040.
    coneq[11983]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[11984]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/87360.
    coneq[11985]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/32760.
    coneq[11986]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/65520.
    coneq[11987]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/21840.
    coneq[11988]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/43680.
    coneq[11989]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c**4)))-1/32760.
    coneq[11990]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/131040.
    coneq[11991]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/393120.
    coneq[11992]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/786240.
    coneq[11993]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/262080.
    coneq[11994]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/98280.
    coneq[11995]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/196560.
    coneq[11996]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/65520.
    coneq[11997]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/131040.
    coneq[11998]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/65520.
    coneq[11999]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/262080.
    coneq[12000]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/786240.
    coneq[12001]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1572480.
    coneq[12002]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/524160.
    coneq[12003]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/196560.
    coneq[12004]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/393120.
    coneq[12005]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/131040.
    coneq[12006]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/262080.
    coneq[12007]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c**4)))-1/21840.
    coneq[12008]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/87360.
    coneq[12009]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/262080.
    coneq[12010]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[12011]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/174720.
    coneq[12012]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/65520.
    coneq[12013]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/131040.
    coneq[12014]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/43680.
    coneq[12015]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/87360.
    coneq[12016]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c**4)))-1/21840.
    coneq[12017]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c**3))))-1/87360.
    coneq[12018]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/262080.
    coneq[12019]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[12020]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/174720.
    coneq[12021]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/65520.
    coneq[12022]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/131040.
    coneq[12023]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/43680.
    coneq[12024]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/87360.
    coneq[12025]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**4)))-1/65520.
    coneq[12026]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/262080.
    coneq[12027]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/786240.
    coneq[12028]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1572480.
    coneq[12029]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/524160.
    coneq[12030]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/196560.
    coneq[12031]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/393120.
    coneq[12032]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/131040.
    coneq[12033]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/262080.
    coneq[12034]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/131040.
    coneq[12035]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/524160.
    coneq[12036]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/1572480.
    coneq[12037]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/3144960.
    coneq[12038]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/1048320.
    coneq[12039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/393120.
    coneq[12040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/786240.
    coneq[12041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/262080.
    coneq[12042]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/524160.
    coneq[12043]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**4)))-1/43680.
    coneq[12044]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/174720.
    coneq[12045]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/524160.
    coneq[12046]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1048320.
    coneq[12047]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/349440.
    coneq[12048]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/131040.
    coneq[12049]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/262080.
    coneq[12050]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/87360.
    coneq[12051]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/174720.
    coneq[12052]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3)*dot(A,c**3)))-1/11648.
    coneq[12053]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/34944.
    coneq[12054]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/69888.
    coneq[12055]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/23296.
    coneq[12056]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/104832.
    coneq[12057]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/209664.
    coneq[12058]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/69888.
    coneq[12059]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/419328.
    coneq[12060]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/139776.
    coneq[12061]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/46592.
    coneq[12062]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/314496.
    coneq[12063]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/628992.
    coneq[12064]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/209664.
    coneq[12065]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/1257984.
    coneq[12066]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/419328.
    coneq[12067]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/139776.
    coneq[12068]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/2515968.
    coneq[12069]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/838656.
    coneq[12070]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/279552.
    coneq[12071]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/93184.
    coneq[12072]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,c**4)))-1/9100.
    coneq[12073]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,dot(A,c**3))))-1/36400.
    coneq[12074]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,dot(A,dot(A,c**2)))))-1/109200.
    coneq[12075]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c))))))-1/218400.
    coneq[12076]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,dot(A,c*dot(A,c)))))-1/72800.
    coneq[12077]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,c*dot(A,c**2))))-1/27300.
    coneq[12078]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,c*dot(A,dot(A,c)))))-1/54600.
    coneq[12079]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,c**2*dot(A,c))))-1/18200.
    coneq[12080]=dot(b,dot(A,dot(A,c)*dot(A,c**4)*dot(A,dot(A,c)*dot(A,c))))-1/36400.
    coneq[12081]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,dot(A,c**3))))-1/145600.
    coneq[12082]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))))-1/436800.
    coneq[12083]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))))-1/873600.
    coneq[12084]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))))-1/291200.
    coneq[12085]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2))))-1/109200.
    coneq[12086]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))))-1/218400.
    coneq[12087]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c))))-1/72800.
    coneq[12088]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))))-1/145600.
    coneq[12089]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))))-1/1310400.
    coneq[12090]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/2620800.
    coneq[12091]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))))-1/873600.
    coneq[12092]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))))-1/327600.
    coneq[12093]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))))-1/655200.
    coneq[12094]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))))-1/218400.
    coneq[12095]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))))-1/436800.
    coneq[12096]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))))-1/5241600.
    coneq[12097]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))))-1/1747200.
    coneq[12098]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))))-1/655200.
    coneq[12099]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))))-1/1310400.
    coneq[12100]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))))-1/436800.
    coneq[12101]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))))-1/873600.
    coneq[12102]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/582400.
    coneq[12103]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))))-1/218400.
    coneq[12104]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/436800.
    coneq[12105]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))))-1/145600.
    coneq[12106]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/291200.
    coneq[12107]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/81900.
    coneq[12108]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/163800.
    coneq[12109]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/54600.
    coneq[12110]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/109200.
    coneq[12111]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/327600.
    coneq[12112]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/109200.
    coneq[12113]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/218400.
    coneq[12114]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))))-1/36400.
    coneq[12115]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/72800.
    coneq[12116]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/145600.
    coneq[12117]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**6)))-1/5096.
    coneq[12118]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**5))))-1/30576.
    coneq[12119]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))-1/152880.
    coneq[12120]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))-1/611520.
    coneq[12121]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))-1/1834560.
    coneq[12122]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))-1/3669120.
    coneq[12123]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))-1/1223040.
    coneq[12124]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))-1/458640.
    coneq[12125]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))-1/917280.
    coneq[12126]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))-1/305760.
    coneq[12127]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))-1/611520.
    coneq[12128]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))-1/122304.
    coneq[12129]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))-1/366912.
    coneq[12130]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))-1/733824.
    coneq[12131]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))-1/244608.
    coneq[12132]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))-1/91728.
    coneq[12133]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))-1/183456.
    coneq[12134]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))-1/61152.
    coneq[12135]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))-1/183456.
    coneq[12136]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))-1/366912.
    coneq[12137]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))-1/122304.
    coneq[12138]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**4))))-1/25480.
    coneq[12139]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))-1/101920.
    coneq[12140]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))-1/305760.
    coneq[12141]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))-1/611520.
    coneq[12142]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))-1/203840.
    coneq[12143]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))-1/76440.
    coneq[12144]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))-1/152880.
    coneq[12145]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))-1/50960.
    coneq[12146]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))-1/101920.
    coneq[12147]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**3))))-1/20384.
    coneq[12148]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))-1/61152.
    coneq[12149]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))-1/122304.
    coneq[12150]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))-1/40768.
    coneq[12151]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c**2))))-1/15288.
    coneq[12152]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))-1/30576.
    coneq[12153]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4*dot(A,c))))-1/10192.
    coneq[12154]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))-1/45864.
    coneq[12155]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))-1/91728.
    coneq[12156]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))-1/183456.
    coneq[12157]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))-1/40768.
    coneq[12158]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))-1/122304.
    coneq[12159]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))-1/244608.
    coneq[12160]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))-1/81536.
    coneq[12161]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))-1/30576.
    coneq[12162]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))-1/61152.
    coneq[12163]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))-1/20384.
    coneq[12164]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))-1/40768.
    coneq[12165]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**5)))-1/6552.
    coneq[12166]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**4))))-1/32760.
    coneq[12167]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))-1/131040.
    coneq[12168]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/393120.
    coneq[12169]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/786240.
    coneq[12170]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/262080.
    coneq[12171]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))-1/98280.
    coneq[12172]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/196560.
    coneq[12173]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))-1/65520.
    coneq[12174]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/131040.
    coneq[12175]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**3))))-1/26208.
    coneq[12176]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))-1/78624.
    coneq[12177]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/157248.
    coneq[12178]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))-1/52416.
    coneq[12179]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))-1/19656.
    coneq[12180]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))-1/39312.
    coneq[12181]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3*dot(A,c))))-1/13104.
    coneq[12182]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))-1/39312.
    coneq[12183]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/78624.
    coneq[12184]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))-1/26208.
    coneq[12185]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**5)))-1/13104.
    coneq[12186]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**4))))-1/65520.
    coneq[12187]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))-1/262080.
    coneq[12188]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/786240.
    coneq[12189]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1572480.
    coneq[12190]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/524160.
    coneq[12191]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))-1/196560.
    coneq[12192]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/393120.
    coneq[12193]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))-1/131040.
    coneq[12194]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/262080.
    coneq[12195]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))-1/52416.
    coneq[12196]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))-1/157248.
    coneq[12197]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/314496.
    coneq[12198]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))-1/104832.
    coneq[12199]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))-1/39312.
    coneq[12200]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))-1/78624.
    coneq[12201]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))-1/26208.
    coneq[12202]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))-1/78624.
    coneq[12203]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/157248.
    coneq[12204]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))-1/52416.
    coneq[12205]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**4)))-1/8190.
    coneq[12206]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**3))))-1/32760.
    coneq[12207]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/98280.
    coneq[12208]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/196560.
    coneq[12209]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/65520.
    coneq[12210]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/24570.
    coneq[12211]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/49140.
    coneq[12212]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/16380.
    coneq[12213]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/32760.
    coneq[12214]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**4)))-1/16380.
    coneq[12215]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/65520.
    coneq[12216]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/196560.
    coneq[12217]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/393120.
    coneq[12218]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/131040.
    coneq[12219]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/49140.
    coneq[12220]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/98280.
    coneq[12221]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/32760.
    coneq[12222]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/65520.
    coneq[12223]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**4)))-1/32760.
    coneq[12224]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/131040.
    coneq[12225]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/393120.
    coneq[12226]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/786240.
    coneq[12227]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/262080.
    coneq[12228]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/98280.
    coneq[12229]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/196560.
    coneq[12230]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/65520.
    coneq[12231]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/131040.
    coneq[12232]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c**4)))-1/7280.
    coneq[12233]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**3))))-1/29120.
    coneq[12234]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))-1/87360.
    coneq[12235]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))-1/174720.
    coneq[12236]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))-1/58240.
    coneq[12237]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c**2))))-1/21840.
    coneq[12238]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))-1/43680.
    coneq[12239]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c**2*dot(A,c))))-1/14560.
    coneq[12240]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))-1/29120.
    coneq[12241]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**4)))-1/21840.
    coneq[12242]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))-1/87360.
    coneq[12243]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))-1/262080.
    coneq[12244]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[12245]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))-1/174720.
    coneq[12246]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))-1/65520.
    coneq[12247]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))-1/131040.
    coneq[12248]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))-1/43680.
    coneq[12249]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))-1/87360.
    coneq[12250]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))-1/43680.
    coneq[12251]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))-1/174720.
    coneq[12252]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))-1/524160.
    coneq[12253]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))-1/1048320.
    coneq[12254]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))-1/349440.
    coneq[12255]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))-1/131040.
    coneq[12256]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))-1/262080.
    coneq[12257]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))-1/87360.
    coneq[12258]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))-1/174720.
    coneq[12259]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**4)))-1/14560.
    coneq[12260]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))-1/58240.
    coneq[12261]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/174720.
    coneq[12262]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/349440.
    coneq[12263]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/116480.
    coneq[12264]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))-1/43680.
    coneq[12265]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/87360.
    coneq[12266]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))-1/29120.
    coneq[12267]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/58240.
    coneq[12268]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3)*dot(A,c**3)))-1/8736.
    coneq[12269]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/26208.
    coneq[12270]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/52416.
    coneq[12271]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/17472.
    coneq[12272]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/78624.
    coneq[12273]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/157248.
    coneq[12274]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/52416.
    coneq[12275]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/314496.
    coneq[12276]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/104832.
    coneq[12277]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/34944.
    coneq[12278]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)*dot(A,c**3)))-1/17472.
    coneq[12279]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c**2))))-1/52416.
    coneq[12280]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/104832.
    coneq[12281]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)*dot(A,c*dot(A,c))))-1/34944.
    coneq[12282]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/157248.
    coneq[12283]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/314496.
    coneq[12284]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/104832.
    coneq[12285]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/628992.
    coneq[12286]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/209664.
    coneq[12287]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/69888.
    coneq[12288]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**5)))-1/4368.
    coneq[12289]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**4))))-1/21840.
    coneq[12290]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/87360.
    coneq[12291]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/262080.
    coneq[12292]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/524160.
    coneq[12293]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/174720.
    coneq[12294]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/65520.
    coneq[12295]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/131040.
    coneq[12296]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/43680.
    coneq[12297]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/87360.
    coneq[12298]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3))))-1/17472.
    coneq[12299]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/52416.
    coneq[12300]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/104832.
    coneq[12301]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/34944.
    coneq[12302]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/13104.
    coneq[12303]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/26208.
    coneq[12304]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c))))-1/8736.
    coneq[12305]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/26208.
    coneq[12306]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/52416.
    coneq[12307]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/17472.
    coneq[12308]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**4)))-1/5460.
    coneq[12309]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3))))-1/21840.
    coneq[12310]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/65520.
    coneq[12311]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/131040.
    coneq[12312]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/43680.
    coneq[12313]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/16380.
    coneq[12314]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/32760.
    coneq[12315]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/10920.
    coneq[12316]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/21840.
    coneq[12317]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c**4)))-1/10920.
    coneq[12318]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/43680.
    coneq[12319]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/131040.
    coneq[12320]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[12321]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/87360.
    coneq[12322]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/32760.
    coneq[12323]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/65520.
    coneq[12324]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/21840.
    coneq[12325]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/43680.
    coneq[12326]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,c**3)))-1/6552.
    coneq[12327]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/19656.
    coneq[12328]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/39312.
    coneq[12329]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/13104.
    coneq[12330]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3)))-1/13104.
    coneq[12331]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/39312.
    coneq[12332]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/78624.
    coneq[12333]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/26208.
    coneq[12334]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3)))-1/26208.
    coneq[12335]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/78624.
    coneq[12336]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/157248.
    coneq[12337]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/52416.
    coneq[12338]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3)*dot(A,c**3)))-1/5824.
    coneq[12339]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/17472.
    coneq[12340]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/34944.
    coneq[12341]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/11648.
    coneq[12342]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/52416.
    coneq[12343]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/104832.
    coneq[12344]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/34944.
    coneq[12345]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/209664.
    coneq[12346]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/69888.
    coneq[12347]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/23296.
    coneq[12348]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**4)))-1/3640.
    coneq[12349]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))-1/14560.
    coneq[12350]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/43680.
    coneq[12351]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/87360.
    coneq[12352]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/29120.
    coneq[12353]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))-1/10920.
    coneq[12354]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/21840.
    coneq[12355]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))-1/7280.
    coneq[12356]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/14560.
    coneq[12357]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,c**3)))-1/4368.
    coneq[12358]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/13104.
    coneq[12359]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/26208.
    coneq[12360]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/8736.
    coneq[12361]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))-1/8736.
    coneq[12362]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/26208.
    coneq[12363]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/52416.
    coneq[12364]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/17472.
    coneq[12365]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/4914.
    coneq[12366]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/9828.
    coneq[12367]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/19656.
    coneq[12368]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/39312.
    coneq[12369]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/2912.
    coneq[12370]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/8736.
    coneq[12371]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/17472.
    coneq[12372]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/5824.
    coneq[12373]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/3276.
    coneq[12374]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/6552.
    coneq[12375]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/13104.
    coneq[12376]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/2184.
    coneq[12377]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/4368.
    coneq[12378]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c)*dot(A,c)))-1/1456.
    coneq[12379]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**5)))-1/8736.
    coneq[12380]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**4))))-1/43680.
    coneq[12381]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))-1/174720.
    coneq[12382]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))-1/524160.
    coneq[12383]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))-1/1048320.
    coneq[12384]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))-1/349440.
    coneq[12385]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))-1/131040.
    coneq[12386]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))-1/262080.
    coneq[12387]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))-1/87360.
    coneq[12388]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))-1/174720.
    coneq[12389]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3))))-1/34944.
    coneq[12390]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))-1/104832.
    coneq[12391]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))-1/209664.
    coneq[12392]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))-1/69888.
    coneq[12393]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2))))-1/26208.
    coneq[12394]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))-1/52416.
    coneq[12395]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c))))-1/17472.
    coneq[12396]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))-1/52416.
    coneq[12397]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))-1/104832.
    coneq[12398]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))-1/34944.
    coneq[12399]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**4)))-1/10920.
    coneq[12400]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3))))-1/43680.
    coneq[12401]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))-1/131040.
    coneq[12402]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))-1/262080.
    coneq[12403]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))-1/87360.
    coneq[12404]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2))))-1/32760.
    coneq[12405]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))-1/65520.
    coneq[12406]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c))))-1/21840.
    coneq[12407]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))-1/43680.
    coneq[12408]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**4)))-1/21840.
    coneq[12409]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))-1/87360.
    coneq[12410]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))-1/262080.
    coneq[12411]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))-1/524160.
    coneq[12412]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))-1/174720.
    coneq[12413]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))-1/65520.
    coneq[12414]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))-1/131040.
    coneq[12415]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))-1/43680.
    coneq[12416]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))-1/87360.
    coneq[12417]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)*dot(A,c**3)))-1/11648.
    coneq[12418]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2))))-1/34944.
    coneq[12419]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))-1/69888.
    coneq[12420]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c))))-1/23296.
    coneq[12421]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**3)))-1/34944.
    coneq[12422]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))-1/104832.
    coneq[12423]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))-1/209664.
    coneq[12424]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))-1/69888.
    coneq[12425]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**3)))-1/69888.
    coneq[12426]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))))-1/209664.
    coneq[12427]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))-1/419328.
    coneq[12428]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))-1/139776.
    coneq[12429]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**3)))-1/23296.
    coneq[12430]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**2))))-1/69888.
    coneq[12431]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/139776.
    coneq[12432]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))-1/46592.
    coneq[12433]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,c**3)))-1/13104.
    coneq[12434]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/39312.
    coneq[12435]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/78624.
    coneq[12436]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/26208.
    coneq[12437]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3)))-1/26208.
    coneq[12438]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/78624.
    coneq[12439]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/157248.
    coneq[12440]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/52416.
    coneq[12441]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3)))-1/52416.
    coneq[12442]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/157248.
    coneq[12443]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/314496.
    coneq[12444]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/104832.
    coneq[12445]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/14742.
    coneq[12446]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/29484.
    coneq[12447]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)))-1/29484.
    coneq[12448]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/58968.
    coneq[12449]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)))-1/58968.
    coneq[12450]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/117936.
    coneq[12451]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)))-1/117936.
    coneq[12452]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/235872.
    coneq[12453]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**4)))-1/7280.
    coneq[12454]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))-1/29120.
    coneq[12455]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))-1/87360.
    coneq[12456]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))-1/174720.
    coneq[12457]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))-1/58240.
    coneq[12458]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))-1/21840.
    coneq[12459]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))-1/43680.
    coneq[12460]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))-1/14560.
    coneq[12461]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))-1/29120.
    coneq[12462]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**3)))-1/8736.
    coneq[12463]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))-1/26208.
    coneq[12464]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))-1/52416.
    coneq[12465]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))-1/17472.
    coneq[12466]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))-1/17472.
    coneq[12467]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))-1/52416.
    coneq[12468]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))-1/104832.
    coneq[12469]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))-1/34944.
    coneq[12470]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))-1/9828.
    coneq[12471]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))-1/19656.
    coneq[12472]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)))-1/19656.
    coneq[12473]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/39312.
    coneq[12474]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)))-1/39312.
    coneq[12475]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/78624.
    coneq[12476]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3)))-1/5824.
    coneq[12477]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))-1/17472.
    coneq[12478]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))-1/34944.
    coneq[12479]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))-1/11648.
    coneq[12480]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2)))-1/6552.
    coneq[12481]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))-1/13104.
    coneq[12482]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2)))-1/13104.
    coneq[12483]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))-1/26208.
    coneq[12484]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))-1/4368.
    coneq[12485]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))-1/8736.
    coneq[12486]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))-1/2912.
    coneq[12487]=dot(b,dot(A,c**11)*c)-1/168.
    coneq[12488]=dot(b,dot(A,dot(A,c**10))*c)-1/1848.
    coneq[12489]=dot(b,dot(A,dot(A,dot(A,c**9)))*c)-1/18480.
    coneq[12490]=dot(b,dot(A,dot(A,dot(A,dot(A,c**8))))*c)-1/166320.
    coneq[12491]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**7)))))*c)-1/1330560.
    coneq[12492]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**6))))))*c)-1/9313920.
    coneq[12493]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))))*c)-1/55883520.
    coneq[12494]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))))*c)-1/279417600.
    coneq[12495]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))))*c)-1/1117670400.
    coneq[12496]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))))*c)-1/3353011200.
    coneq[12497]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))))*c)-1/6706022400.
    coneq[12498]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))))*c)-1/2235340800.
    coneq[12499]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))))*c)-1/838252800.
    coneq[12500]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))))*c)-1/1676505600.
    coneq[12501]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))))*c)-1/558835200.
    coneq[12502]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))))*c)-1/1117670400.
    coneq[12503]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))))*c)-1/223534080.
    coneq[12504]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))))*c)-1/670602240.
    coneq[12505]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))))*c)-1/1341204480.
    coneq[12506]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))))*c)-1/447068160.
    coneq[12507]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))))*c)-1/167650560.
    coneq[12508]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))))*c)-1/335301120.
    coneq[12509]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))))*c)-1/111767040.
    coneq[12510]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))))*c)-1/335301120.
    coneq[12511]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))))*c)-1/670602240.
    coneq[12512]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))))*c)-1/223534080.
    coneq[12513]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))))*c)-1/46569600.
    coneq[12514]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))))*c)-1/186278400.
    coneq[12515]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))))*c)-1/558835200.
    coneq[12516]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/1117670400.
    coneq[12517]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))))*c)-1/372556800.
    coneq[12518]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))))*c)-1/139708800.
    coneq[12519]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))))*c)-1/279417600.
    coneq[12520]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))))*c)-1/93139200.
    coneq[12521]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))))*c)-1/186278400.
    coneq[12522]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))))*c)-1/37255680.
    coneq[12523]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))))*c)-1/111767040.
    coneq[12524]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))))*c)-1/223534080.
    coneq[12525]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))))*c)-1/74511360.
    coneq[12526]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))))*c)-1/27941760.
    coneq[12527]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))))*c)-1/55883520.
    coneq[12528]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))))*c)-1/18627840.
    coneq[12529]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))))*c)-1/83825280.
    coneq[12530]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))))*c)-1/167650560.
    coneq[12531]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))))*c)-1/335301120.
    coneq[12532]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))))*c)-1/74511360.
    coneq[12533]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))))*c)-1/223534080.
    coneq[12534]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))))*c)-1/447068160.
    coneq[12535]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))))*c)-1/149022720.
    coneq[12536]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))))*c)-1/55883520.
    coneq[12537]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))))*c)-1/111767040.
    coneq[12538]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))))*c)-1/37255680.
    coneq[12539]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))))*c)-1/74511360.
    coneq[12540]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5))))))*c)-1/7983360.
    coneq[12541]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))))*c)-1/39916800.
    coneq[12542]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))))*c)-1/159667200.
    coneq[12543]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c)-1/479001600.
    coneq[12544]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/958003200.
    coneq[12545]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c)-1/319334400.
    coneq[12546]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))))*c)-1/119750400.
    coneq[12547]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c)-1/239500800.
    coneq[12548]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))))*c)-1/79833600.
    coneq[12549]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c)-1/159667200.
    coneq[12550]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))))*c)-1/31933440.
    coneq[12551]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))))*c)-1/95800320.
    coneq[12552]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c)-1/191600640.
    coneq[12553]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))))*c)-1/63866880.
    coneq[12554]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))))*c)-1/23950080.
    coneq[12555]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))))*c)-1/47900160.
    coneq[12556]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))))*c)-1/15966720.
    coneq[12557]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))))*c)-1/47900160.
    coneq[12558]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c)-1/95800320.
    coneq[12559]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))))*c)-1/31933440.
    coneq[12560]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))))*c)-1/6652800.
    coneq[12561]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))))*c)-1/26611200.
    coneq[12562]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))))*c)-1/79833600.
    coneq[12563]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/159667200.
    coneq[12564]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))))*c)-1/53222400.
    coneq[12565]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))))*c)-1/19958400.
    coneq[12566]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))))*c)-1/39916800.
    coneq[12567]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))))*c)-1/13305600.
    coneq[12568]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/26611200.
    coneq[12569]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))))*c)-1/5322240.
    coneq[12570]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))))*c)-1/15966720.
    coneq[12571]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))))*c)-1/31933440.
    coneq[12572]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))))*c)-1/10644480.
    coneq[12573]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))))*c)-1/3991680.
    coneq[12574]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))))*c)-1/7983360.
    coneq[12575]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c))))))*c)-1/2661120.
    coneq[12576]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))))*c)-1/15966720.
    coneq[12577]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))))*c)-1/47900160.
    coneq[12578]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))))*c)-1/95800320.
    coneq[12579]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))))*c)-1/31933440.
    coneq[12580]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))))*c)-1/31933440.
    coneq[12581]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))))*c)-1/95800320.
    coneq[12582]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))))*c)-1/191600640.
    coneq[12583]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))))*c)-1/63866880.
    coneq[12584]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))))*c)-1/13305600.
    coneq[12585]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))))*c)-1/53222400.
    coneq[12586]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))))*c)-1/159667200.
    coneq[12587]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/319334400.
    coneq[12588]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))))*c)-1/106444800.
    coneq[12589]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))))*c)-1/39916800.
    coneq[12590]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))))*c)-1/79833600.
    coneq[12591]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))))*c)-1/26611200.
    coneq[12592]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/53222400.
    coneq[12593]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))))*c)-1/11975040.
    coneq[12594]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))))*c)-1/23950080.
    coneq[12595]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c)-1/47900160.
    coneq[12596]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))))*c)-1/10644480.
    coneq[12597]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))))*c)-1/31933440.
    coneq[12598]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c)-1/63866880.
    coneq[12599]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))))*c)-1/21288960.
    coneq[12600]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))))*c)-1/7983360.
    coneq[12601]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/15966720.
    coneq[12602]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))))*c)-1/5322240.
    coneq[12603]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))))*c)-1/15966720.
    coneq[12604]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/31933440.
    coneq[12605]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))))*c)-1/10644480.
    coneq[12606]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**6)))))*c)-1/1164240.
    coneq[12607]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5))))))*c)-1/6985440.
    coneq[12608]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))))*c)-1/34927200.
    coneq[12609]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))))*c)-1/139708800.
    coneq[12610]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c)-1/419126400.
    coneq[12611]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/838252800.
    coneq[12612]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c)-1/279417600.
    coneq[12613]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*c)-1/104781600.
    coneq[12614]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c)-1/209563200.
    coneq[12615]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*c)-1/69854400.
    coneq[12616]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c)-1/139708800.
    coneq[12617]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))))*c)-1/27941760.
    coneq[12618]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*c)-1/83825280.
    coneq[12619]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c)-1/167650560.
    coneq[12620]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*c)-1/55883520.
    coneq[12621]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))))*c)-1/20956320.
    coneq[12622]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*c)-1/41912640.
    coneq[12623]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))))*c)-1/13970880.
    coneq[12624]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*c)-1/41912640.
    coneq[12625]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c)-1/83825280.
    coneq[12626]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*c)-1/27941760.
    coneq[12627]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))))*c)-1/5821200.
    coneq[12628]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))))*c)-1/23284800.
    coneq[12629]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*c)-1/69854400.
    coneq[12630]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/139708800.
    coneq[12631]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*c)-1/46569600.
    coneq[12632]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))))*c)-1/17463600.
    coneq[12633]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*c)-1/34927200.
    coneq[12634]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))))*c)-1/11642400.
    coneq[12635]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/23284800.
    coneq[12636]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))))*c)-1/4656960.
    coneq[12637]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))))*c)-1/13970880.
    coneq[12638]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*c)-1/27941760.
    coneq[12639]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))))*c)-1/9313920.
    coneq[12640]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))))*c)-1/3492720.
    coneq[12641]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))))*c)-1/6985440.
    coneq[12642]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))))*c)-1/2328480.
    coneq[12643]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))))*c)-1/10478160.
    coneq[12644]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*c)-1/20956320.
    coneq[12645]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c)-1/41912640.
    coneq[12646]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))))*c)-1/9313920.
    coneq[12647]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*c)-1/27941760.
    coneq[12648]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c)-1/55883520.
    coneq[12649]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*c)-1/18627840.
    coneq[12650]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))))*c)-1/6985440.
    coneq[12651]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/13970880.
    coneq[12652]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))))*c)-1/4656960.
    coneq[12653]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*c)-1/9313920.
    coneq[12654]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**5)))))*c)-1/997920.
    coneq[12655]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))))*c)-1/4989600.
    coneq[12656]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))))*c)-1/19958400.
    coneq[12657]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/59875200.
    coneq[12658]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/119750400.
    coneq[12659]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/39916800.
    coneq[12660]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/14968800.
    coneq[12661]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/29937600.
    coneq[12662]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/9979200.
    coneq[12663]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/19958400.
    coneq[12664]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))))*c)-1/3991680.
    coneq[12665]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/11975040.
    coneq[12666]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/23950080.
    coneq[12667]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/7983360.
    coneq[12668]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))))*c)-1/2993760.
    coneq[12669]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/5987520.
    coneq[12670]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))))*c)-1/1995840.
    coneq[12671]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/5987520.
    coneq[12672]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/11975040.
    coneq[12673]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/3991680.
    coneq[12674]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**4)))))*c)-1/831600.
    coneq[12675]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))))*c)-1/3326400.
    coneq[12676]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))))*c)-1/9979200.
    coneq[12677]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/19958400.
    coneq[12678]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))))*c)-1/6652800.
    coneq[12679]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))))*c)-1/2494800.
    coneq[12680]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))))*c)-1/4989600.
    coneq[12681]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))))*c)-1/1663200.
    coneq[12682]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))))*c)-1/3326400.
    coneq[12683]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**3)))))*c)-1/665280.
    coneq[12684]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))))*c)-1/1995840.
    coneq[12685]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))))*c)-1/3991680.
    coneq[12686]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))))*c)-1/1330560.
    coneq[12687]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c**2)))))*c)-1/498960.
    coneq[12688]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c))))))*c)-1/997920.
    coneq[12689]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6*dot(A,c)))))*c)-1/332640.
    coneq[12690]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))))*c)-1/2661120.
    coneq[12691]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))))*c)-1/7983360.
    coneq[12692]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))))*c)-1/15966720.
    coneq[12693]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))))*c)-1/5322240.
    coneq[12694]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))))*c)-1/23950080.
    coneq[12695]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))))*c)-1/47900160.
    coneq[12696]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))))*c)-1/15966720.
    coneq[12697]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))))*c)-1/95800320.
    coneq[12698]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))))*c)-1/31933440.
    coneq[12699]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))))*c)-1/10644480.
    coneq[12700]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))))*c)-1/2494800.
    coneq[12701]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))))*c)-1/9979200.
    coneq[12702]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))))*c)-1/29937600.
    coneq[12703]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/59875200.
    coneq[12704]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))))*c)-1/19958400.
    coneq[12705]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))))*c)-1/7484400.
    coneq[12706]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))))*c)-1/14968800.
    coneq[12707]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))))*c)-1/4989600.
    coneq[12708]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))))*c)-1/9979200.
    coneq[12709]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))))*c)-1/4989600.
    coneq[12710]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))))*c)-1/19958400.
    coneq[12711]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))))*c)-1/59875200.
    coneq[12712]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/119750400.
    coneq[12713]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))))*c)-1/39916800.
    coneq[12714]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))))*c)-1/14968800.
    coneq[12715]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))))*c)-1/29937600.
    coneq[12716]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))))*c)-1/9979200.
    coneq[12717]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))))*c)-1/19958400.
    coneq[12718]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5)))))*c)-1/1995840.
    coneq[12719]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))))*c)-1/9979200.
    coneq[12720]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))))*c)-1/39916800.
    coneq[12721]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/119750400.
    coneq[12722]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/239500800.
    coneq[12723]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/79833600.
    coneq[12724]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/29937600.
    coneq[12725]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/59875200.
    coneq[12726]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/19958400.
    coneq[12727]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/39916800.
    coneq[12728]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))))*c)-1/7983360.
    coneq[12729]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/23950080.
    coneq[12730]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/47900160.
    coneq[12731]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/15966720.
    coneq[12732]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))))*c)-1/5987520.
    coneq[12733]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/11975040.
    coneq[12734]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))))*c)-1/3991680.
    coneq[12735]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/11975040.
    coneq[12736]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/23950080.
    coneq[12737]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/7983360.
    coneq[12738]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))))*c)-1/1995840.
    coneq[12739]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))))*c)-1/5987520.
    coneq[12740]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*c)-1/11975040.
    coneq[12741]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))))*c)-1/3991680.
    coneq[12742]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))))*c)-1/3991680.
    coneq[12743]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*c)-1/11975040.
    coneq[12744]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*c)-1/23950080.
    coneq[12745]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*c)-1/7983360.
    coneq[12746]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))))*c)-1/1663200.
    coneq[12747]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))))*c)-1/6652800.
    coneq[12748]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*c)-1/19958400.
    coneq[12749]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/39916800.
    coneq[12750]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*c)-1/13305600.
    coneq[12751]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))))*c)-1/4989600.
    coneq[12752]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*c)-1/9979200.
    coneq[12753]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))))*c)-1/3326400.
    coneq[12754]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*c)-1/6652800.
    coneq[12755]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))))*c)-1/1496880.
    coneq[12756]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/2993760.
    coneq[12757]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/5987520.
    coneq[12758]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))))*c)-1/1330560.
    coneq[12759]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/3991680.
    coneq[12760]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/7983360.
    coneq[12761]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/2661120.
    coneq[12762]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))))*c)-1/997920.
    coneq[12763]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1995840.
    coneq[12764]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))))*c)-1/665280.
    coneq[12765]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))))*c)-1/2661120.
    coneq[12766]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/7983360.
    coneq[12767]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/15966720.
    coneq[12768]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/5322240.
    coneq[12769]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))))*c)-1/2993760.
    coneq[12770]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/5987520.
    coneq[12771]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/11975040.
    coneq[12772]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))))*c)-1/1995840.
    coneq[12773]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*c)-1/3991680.
    coneq[12774]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/1330560.
    coneq[12775]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/2661120.
    coneq[12776]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**7))))*c)-1/147840.
    coneq[12777]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**6)))))*c)-1/1034880.
    coneq[12778]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5))))))*c)-1/6209280.
    coneq[12779]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))))*c)-1/31046400.
    coneq[12780]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))*c)-1/124185600.
    coneq[12781]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c)-1/372556800.
    coneq[12782]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/745113600.
    coneq[12783]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c)-1/248371200.
    coneq[12784]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*c)-1/93139200.
    coneq[12785]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c)-1/186278400.
    coneq[12786]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*c)-1/62092800.
    coneq[12787]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c)-1/124185600.
    coneq[12788]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))))*c)-1/24837120.
    coneq[12789]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*c)-1/74511360.
    coneq[12790]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c)-1/149022720.
    coneq[12791]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*c)-1/49674240.
    coneq[12792]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))*c)-1/18627840.
    coneq[12793]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*c)-1/37255680.
    coneq[12794]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))))*c)-1/12418560.
    coneq[12795]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*c)-1/37255680.
    coneq[12796]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c)-1/74511360.
    coneq[12797]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*c)-1/24837120.
    coneq[12798]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))))*c)-1/5174400.
    coneq[12799]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))))*c)-1/20697600.
    coneq[12800]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*c)-1/62092800.
    coneq[12801]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/124185600.
    coneq[12802]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*c)-1/41395200.
    coneq[12803]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))*c)-1/15523200.
    coneq[12804]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*c)-1/31046400.
    coneq[12805]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))*c)-1/10348800.
    coneq[12806]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/20697600.
    coneq[12807]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))))*c)-1/4139520.
    coneq[12808]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))*c)-1/12418560.
    coneq[12809]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*c)-1/24837120.
    coneq[12810]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))*c)-1/8279040.
    coneq[12811]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))))*c)-1/3104640.
    coneq[12812]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))))*c)-1/6209280.
    coneq[12813]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))))*c)-1/2069760.
    coneq[12814]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))*c)-1/9313920.
    coneq[12815]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*c)-1/18627840.
    coneq[12816]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c)-1/37255680.
    coneq[12817]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))))*c)-1/8279040.
    coneq[12818]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*c)-1/24837120.
    coneq[12819]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c)-1/49674240.
    coneq[12820]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*c)-1/16558080.
    coneq[12821]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))*c)-1/6209280.
    coneq[12822]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/12418560.
    coneq[12823]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))*c)-1/4139520.
    coneq[12824]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*c)-1/8279040.
    coneq[12825]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**5)))))*c)-1/887040.
    coneq[12826]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))))*c)-1/4435200.
    coneq[12827]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))))*c)-1/17740800.
    coneq[12828]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/53222400.
    coneq[12829]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/106444800.
    coneq[12830]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/35481600.
    coneq[12831]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/13305600.
    coneq[12832]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/26611200.
    coneq[12833]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/8870400.
    coneq[12834]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/17740800.
    coneq[12835]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))))*c)-1/3548160.
    coneq[12836]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/10644480.
    coneq[12837]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/21288960.
    coneq[12838]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/7096320.
    coneq[12839]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))))*c)-1/2661120.
    coneq[12840]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/5322240.
    coneq[12841]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))))*c)-1/1774080.
    coneq[12842]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/5322240.
    coneq[12843]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/10644480.
    coneq[12844]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/3548160.
    coneq[12845]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4)))))*c)-1/739200.
    coneq[12846]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))))*c)-1/2956800.
    coneq[12847]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))*c)-1/8870400.
    coneq[12848]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/17740800.
    coneq[12849]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))*c)-1/5913600.
    coneq[12850]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))))*c)-1/2217600.
    coneq[12851]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))*c)-1/4435200.
    coneq[12852]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))))*c)-1/1478400.
    coneq[12853]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2956800.
    coneq[12854]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3)))))*c)-1/591360.
    coneq[12855]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))))*c)-1/1774080.
    coneq[12856]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))))*c)-1/3548160.
    coneq[12857]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))))*c)-1/1182720.
    coneq[12858]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2)))))*c)-1/443520.
    coneq[12859]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))))*c)-1/887040.
    coneq[12860]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5*dot(A,c)))))*c)-1/295680.
    coneq[12861]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))))*c)-1/1774080.
    coneq[12862]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))*c)-1/5322240.
    coneq[12863]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*c)-1/10644480.
    coneq[12864]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))*c)-1/3548160.
    coneq[12865]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))))*c)-1/3548160.
    coneq[12866]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*c)-1/10644480.
    coneq[12867]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*c)-1/21288960.
    coneq[12868]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*c)-1/7096320.
    coneq[12869]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))))*c)-1/1478400.
    coneq[12870]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))))*c)-1/5913600.
    coneq[12871]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*c)-1/17740800.
    coneq[12872]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/35481600.
    coneq[12873]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*c)-1/11827200.
    coneq[12874]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))*c)-1/4435200.
    coneq[12875]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*c)-1/8870400.
    coneq[12876]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))*c)-1/2956800.
    coneq[12877]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*c)-1/5913600.
    coneq[12878]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))))*c)-1/1330560.
    coneq[12879]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[12880]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/5322240.
    coneq[12881]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))))*c)-1/1182720.
    coneq[12882]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/3548160.
    coneq[12883]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/7096320.
    coneq[12884]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/2365440.
    coneq[12885]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))))*c)-1/887040.
    coneq[12886]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1774080.
    coneq[12887]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))))*c)-1/591360.
    coneq[12888]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))*c)-1/1774080.
    coneq[12889]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*c)-1/3548160.
    coneq[12890]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/1182720.
    coneq[12891]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**6))))*c)-1/129360.
    coneq[12892]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**5)))))*c)-1/776160.
    coneq[12893]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))))*c)-1/3880800.
    coneq[12894]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/15523200.
    coneq[12895]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/46569600.
    coneq[12896]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/93139200.
    coneq[12897]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/31046400.
    coneq[12898]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/11642400.
    coneq[12899]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/23284800.
    coneq[12900]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/7761600.
    coneq[12901]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/15523200.
    coneq[12902]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))))*c)-1/3104640.
    coneq[12903]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/9313920.
    coneq[12904]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/18627840.
    coneq[12905]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/6209280.
    coneq[12906]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/2328480.
    coneq[12907]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/4656960.
    coneq[12908]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1552320.
    coneq[12909]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/4656960.
    coneq[12910]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/9313920.
    coneq[12911]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/3104640.
    coneq[12912]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4)))))*c)-1/646800.
    coneq[12913]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))))*c)-1/2587200.
    coneq[12914]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/7761600.
    coneq[12915]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/15523200.
    coneq[12916]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/5174400.
    coneq[12917]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1940400.
    coneq[12918]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3880800.
    coneq[12919]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/1293600.
    coneq[12920]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2587200.
    coneq[12921]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3)))))*c)-1/517440.
    coneq[12922]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1552320.
    coneq[12923]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/3104640.
    coneq[12924]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/1034880.
    coneq[12925]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2)))))*c)-1/388080.
    coneq[12926]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))))*c)-1/776160.
    coneq[12927]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c)))))*c)-1/258720.
    coneq[12928]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/1164240.
    coneq[12929]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/2328480.
    coneq[12930]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/4656960.
    coneq[12931]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/1034880.
    coneq[12932]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/3104640.
    coneq[12933]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/6209280.
    coneq[12934]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/2069760.
    coneq[12935]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/776160.
    coneq[12936]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1552320.
    coneq[12937]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/517440.
    coneq[12938]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/1034880.
    coneq[12939]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**5))))*c)-1/110880.
    coneq[12940]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**4)))))*c)-1/554400.
    coneq[12941]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))))*c)-1/2217600.
    coneq[12942]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/6652800.
    coneq[12943]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/13305600.
    coneq[12944]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/4435200.
    coneq[12945]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1663200.
    coneq[12946]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/3326400.
    coneq[12947]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1108800.
    coneq[12948]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/2217600.
    coneq[12949]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3)))))*c)-1/443520.
    coneq[12950]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1330560.
    coneq[12951]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2661120.
    coneq[12952]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/887040.
    coneq[12953]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2)))))*c)-1/332640.
    coneq[12954]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/665280.
    coneq[12955]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c)))))*c)-1/221760.
    coneq[12956]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/665280.
    coneq[12957]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[12958]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/443520.
    coneq[12959]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**4))))*c)-1/92400.
    coneq[12960]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**3)))))*c)-1/369600.
    coneq[12961]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))))*c)-1/1108800.
    coneq[12962]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2217600.
    coneq[12963]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))))*c)-1/739200.
    coneq[12964]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2)))))*c)-1/277200.
    coneq[12965]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))))*c)-1/554400.
    coneq[12966]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c)))))*c)-1/184800.
    coneq[12967]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))))*c)-1/369600.
    coneq[12968]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**3))))*c)-1/73920.
    coneq[12969]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c**2)))))*c)-1/221760.
    coneq[12970]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c))))))*c)-1/443520.
    coneq[12971]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c*dot(A,c)))))*c)-1/147840.
    coneq[12972]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c**2))))*c)-1/55440.
    coneq[12973]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,dot(A,c)))))*c)-1/110880.
    coneq[12974]=dot(b,dot(A,dot(A,dot(A,c**7*dot(A,c))))*c)-1/36960.
    coneq[12975]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**4))))*c)-1/369600.
    coneq[12976]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))))*c)-1/1478400.
    coneq[12977]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))))*c)-1/4435200.
    coneq[12978]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/8870400.
    coneq[12979]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))))*c)-1/2956800.
    coneq[12980]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))))*c)-1/1108800.
    coneq[12981]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))))*c)-1/2217600.
    coneq[12982]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))))*c)-1/739200.
    coneq[12983]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1478400.
    coneq[12984]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))))*c)-1/1108800.
    coneq[12985]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))))*c)-1/4435200.
    coneq[12986]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))))*c)-1/13305600.
    coneq[12987]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/26611200.
    coneq[12988]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))))*c)-1/8870400.
    coneq[12989]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))))*c)-1/3326400.
    coneq[12990]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))))*c)-1/6652800.
    coneq[12991]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))))*c)-1/2217600.
    coneq[12992]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/4435200.
    coneq[12993]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))))*c)-1/2217600.
    coneq[12994]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))))*c)-1/8870400.
    coneq[12995]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))))*c)-1/26611200.
    coneq[12996]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/53222400.
    coneq[12997]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))))*c)-1/17740800.
    coneq[12998]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))))*c)-1/6652800.
    coneq[12999]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))))*c)-1/13305600.
    coneq[13000]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))))*c)-1/4435200.
    coneq[13001]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/8870400.
    coneq[13002]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))))*c)-1/739200.
    coneq[13003]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))))*c)-1/2956800.
    coneq[13004]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*c)-1/8870400.
    coneq[13005]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/17740800.
    coneq[13006]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*c)-1/5913600.
    coneq[13007]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))))*c)-1/2217600.
    coneq[13008]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*c)-1/4435200.
    coneq[13009]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))))*c)-1/1478400.
    coneq[13010]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/2956800.
    coneq[13011]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**5))))*c)-1/332640.
    coneq[13012]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))))*c)-1/1663200.
    coneq[13013]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))))*c)-1/6652800.
    coneq[13014]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/19958400.
    coneq[13015]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/39916800.
    coneq[13016]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/13305600.
    coneq[13017]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/4989600.
    coneq[13018]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/9979200.
    coneq[13019]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/3326400.
    coneq[13020]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/6652800.
    coneq[13021]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))))*c)-1/1330560.
    coneq[13022]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/3991680.
    coneq[13023]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/7983360.
    coneq[13024]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/2661120.
    coneq[13025]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))))*c)-1/997920.
    coneq[13026]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1995840.
    coneq[13027]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))))*c)-1/665280.
    coneq[13028]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1995840.
    coneq[13029]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/3991680.
    coneq[13030]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/1330560.
    coneq[13031]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5))))*c)-1/665280.
    coneq[13032]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))))*c)-1/3326400.
    coneq[13033]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))))*c)-1/13305600.
    coneq[13034]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/39916800.
    coneq[13035]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/79833600.
    coneq[13036]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/26611200.
    coneq[13037]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/9979200.
    coneq[13038]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/19958400.
    coneq[13039]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/6652800.
    coneq[13040]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/13305600.
    coneq[13041]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))))*c)-1/2661120.
    coneq[13042]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/7983360.
    coneq[13043]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/15966720.
    coneq[13044]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/5322240.
    coneq[13045]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))))*c)-1/1995840.
    coneq[13046]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/3991680.
    coneq[13047]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))))*c)-1/1330560.
    coneq[13048]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/3991680.
    coneq[13049]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/7983360.
    coneq[13050]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/2661120.
    coneq[13051]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**6))))*c)-1/258720.
    coneq[13052]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5)))))*c)-1/1552320.
    coneq[13053]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))))*c)-1/7761600.
    coneq[13054]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/31046400.
    coneq[13055]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/93139200.
    coneq[13056]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/186278400.
    coneq[13057]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/62092800.
    coneq[13058]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/23284800.
    coneq[13059]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/46569600.
    coneq[13060]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/15523200.
    coneq[13061]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/31046400.
    coneq[13062]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))))*c)-1/6209280.
    coneq[13063]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/18627840.
    coneq[13064]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/37255680.
    coneq[13065]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/12418560.
    coneq[13066]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/4656960.
    coneq[13067]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/9313920.
    coneq[13068]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))))*c)-1/3104640.
    coneq[13069]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/9313920.
    coneq[13070]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/18627840.
    coneq[13071]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/6209280.
    coneq[13072]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))))*c)-1/1293600.
    coneq[13073]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))))*c)-1/5174400.
    coneq[13074]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/15523200.
    coneq[13075]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/31046400.
    coneq[13076]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/10348800.
    coneq[13077]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/3880800.
    coneq[13078]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/7761600.
    coneq[13079]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/2587200.
    coneq[13080]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/5174400.
    coneq[13081]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))))*c)-1/1034880.
    coneq[13082]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/3104640.
    coneq[13083]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/6209280.
    coneq[13084]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/2069760.
    coneq[13085]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))))*c)-1/776160.
    coneq[13086]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))))*c)-1/1552320.
    coneq[13087]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))))*c)-1/517440.
    coneq[13088]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/2328480.
    coneq[13089]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/4656960.
    coneq[13090]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/9313920.
    coneq[13091]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/2069760.
    coneq[13092]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/6209280.
    coneq[13093]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/12418560.
    coneq[13094]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/4139520.
    coneq[13095]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/1552320.
    coneq[13096]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/3104640.
    coneq[13097]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/1034880.
    coneq[13098]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/2069760.
    coneq[13099]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3))))*c)-1/295680.
    coneq[13100]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))))*c)-1/887040.
    coneq[13101]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))))*c)-1/1774080.
    coneq[13102]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))))*c)-1/591360.
    coneq[13103]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))*c)-1/2661120.
    coneq[13104]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))*c)-1/5322240.
    coneq[13105]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))*c)-1/1774080.
    coneq[13106]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))*c)-1/10644480.
    coneq[13107]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))*c)-1/3548160.
    coneq[13108]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/1182720.
    coneq[13109]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4))))*c)-1/277200.
    coneq[13110]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))))*c)-1/1108800.
    coneq[13111]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))*c)-1/3326400.
    coneq[13112]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/6652800.
    coneq[13113]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))*c)-1/2217600.
    coneq[13114]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))))*c)-1/831600.
    coneq[13115]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1663200.
    coneq[13116]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))))*c)-1/554400.
    coneq[13117]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1108800.
    coneq[13118]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))))*c)-1/554400.
    coneq[13119]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))))*c)-1/2217600.
    coneq[13120]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*c)-1/6652800.
    coneq[13121]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/13305600.
    coneq[13122]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*c)-1/4435200.
    coneq[13123]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))*c)-1/1663200.
    coneq[13124]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*c)-1/3326400.
    coneq[13125]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))*c)-1/1108800.
    coneq[13126]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/2217600.
    coneq[13127]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**5))))*c)-1/221760.
    coneq[13128]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))))*c)-1/1108800.
    coneq[13129]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))))*c)-1/4435200.
    coneq[13130]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/13305600.
    coneq[13131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/26611200.
    coneq[13132]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/8870400.
    coneq[13133]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/3326400.
    coneq[13134]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/6652800.
    coneq[13135]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/2217600.
    coneq[13136]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/4435200.
    coneq[13137]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))))*c)-1/887040.
    coneq[13138]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/2661120.
    coneq[13139]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/5322240.
    coneq[13140]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1774080.
    coneq[13141]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))))*c)-1/665280.
    coneq[13142]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[13143]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))))*c)-1/443520.
    coneq[13144]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1330560.
    coneq[13145]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[13146]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/887040.
    coneq[13147]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3))))*c)-1/221760.
    coneq[13148]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/665280.
    coneq[13149]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[13150]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/443520.
    coneq[13151]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))))*c)-1/443520.
    coneq[13152]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/1330560.
    coneq[13153]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[13154]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/887040.
    coneq[13155]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4))))*c)-1/184800.
    coneq[13156]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/739200.
    coneq[13157]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/2217600.
    coneq[13158]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/4435200.
    coneq[13159]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1478400.
    coneq[13160]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/554400.
    coneq[13161]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1108800.
    coneq[13162]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/369600.
    coneq[13163]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/739200.
    coneq[13164]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2))))*c)-1/166320.
    coneq[13165]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/332640.
    coneq[13166]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/665280.
    coneq[13167]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3))))*c)-1/147840.
    coneq[13168]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/443520.
    coneq[13169]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/887040.
    coneq[13170]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/295680.
    coneq[13171]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2))))*c)-1/110880.
    coneq[13172]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))))*c)-1/221760.
    coneq[13173]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c)*dot(A,c))))*c)-1/73920.
    coneq[13174]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))))*c)-1/369600.
    coneq[13175]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/1478400.
    coneq[13176]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/4435200.
    coneq[13177]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/8870400.
    coneq[13178]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/2956800.
    coneq[13179]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/1108800.
    coneq[13180]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/2217600.
    coneq[13181]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/739200.
    coneq[13182]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1478400.
    coneq[13183]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))))*c)-1/443520.
    coneq[13184]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/1330560.
    coneq[13185]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[13186]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/887040.
    coneq[13187]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))))*c)-1/887040.
    coneq[13188]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/2661120.
    coneq[13189]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/5322240.
    coneq[13190]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/1774080.
    coneq[13191]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))))*c)-1/498960.
    coneq[13192]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/997920.
    coneq[13193]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1995840.
    coneq[13194]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/3991680.
    coneq[13195]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))))*c)-1/295680.
    coneq[13196]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/887040.
    coneq[13197]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1774080.
    coneq[13198]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/591360.
    coneq[13199]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))))*c)-1/332640.
    coneq[13200]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/665280.
    coneq[13201]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1330560.
    coneq[13202]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/221760.
    coneq[13203]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/443520.
    coneq[13204]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/147840.
    coneq[13205]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/443520.
    coneq[13206]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/887040.
    coneq[13207]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/295680.
    coneq[13208]=dot(b,dot(A,dot(A,c*dot(A,c**8)))*c)-1/16632.
    coneq[13209]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**7))))*c)-1/133056.
    coneq[13210]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**6)))))*c)-1/931392.
    coneq[13211]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5))))))*c)-1/5588352.
    coneq[13212]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))*c)-1/27941760.
    coneq[13213]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))*c)-1/111767040.
    coneq[13214]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c)-1/335301120.
    coneq[13215]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/670602240.
    coneq[13216]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c)-1/223534080.
    coneq[13217]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*c)-1/83825280.
    coneq[13218]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c)-1/167650560.
    coneq[13219]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*c)-1/55883520.
    coneq[13220]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c)-1/111767040.
    coneq[13221]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))*c)-1/22353408.
    coneq[13222]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*c)-1/67060224.
    coneq[13223]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c)-1/134120448.
    coneq[13224]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*c)-1/44706816.
    coneq[13225]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))*c)-1/16765056.
    coneq[13226]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*c)-1/33530112.
    coneq[13227]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))*c)-1/11176704.
    coneq[13228]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*c)-1/33530112.
    coneq[13229]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c)-1/67060224.
    coneq[13230]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*c)-1/22353408.
    coneq[13231]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4))))))*c)-1/4656960.
    coneq[13232]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))*c)-1/18627840.
    coneq[13233]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*c)-1/55883520.
    coneq[13234]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/111767040.
    coneq[13235]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*c)-1/37255680.
    coneq[13236]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))*c)-1/13970880.
    coneq[13237]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*c)-1/27941760.
    coneq[13238]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))*c)-1/9313920.
    coneq[13239]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/18627840.
    coneq[13240]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))*c)-1/3725568.
    coneq[13241]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))*c)-1/11176704.
    coneq[13242]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*c)-1/22353408.
    coneq[13243]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))*c)-1/7451136.
    coneq[13244]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))*c)-1/2794176.
    coneq[13245]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))*c)-1/5588352.
    coneq[13246]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c))))))*c)-1/1862784.
    coneq[13247]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))*c)-1/8382528.
    coneq[13248]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*c)-1/16765056.
    coneq[13249]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c)-1/33530112.
    coneq[13250]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))*c)-1/7451136.
    coneq[13251]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*c)-1/22353408.
    coneq[13252]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c)-1/44706816.
    coneq[13253]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*c)-1/14902272.
    coneq[13254]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))*c)-1/5588352.
    coneq[13255]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/11176704.
    coneq[13256]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))*c)-1/3725568.
    coneq[13257]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*c)-1/7451136.
    coneq[13258]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**5)))))*c)-1/798336.
    coneq[13259]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4))))))*c)-1/3991680.
    coneq[13260]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))*c)-1/15966720.
    coneq[13261]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/47900160.
    coneq[13262]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/95800320.
    coneq[13263]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/31933440.
    coneq[13264]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/11975040.
    coneq[13265]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/23950080.
    coneq[13266]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/7983360.
    coneq[13267]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/15966720.
    coneq[13268]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))*c)-1/3193344.
    coneq[13269]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/9580032.
    coneq[13270]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/19160064.
    coneq[13271]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/6386688.
    coneq[13272]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))*c)-1/2395008.
    coneq[13273]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/4790016.
    coneq[13274]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))*c)-1/1596672.
    coneq[13275]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/4790016.
    coneq[13276]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/9580032.
    coneq[13277]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/3193344.
    coneq[13278]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4)))))*c)-1/665280.
    coneq[13279]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))*c)-1/2661120.
    coneq[13280]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))*c)-1/7983360.
    coneq[13281]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/15966720.
    coneq[13282]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))*c)-1/5322240.
    coneq[13283]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))*c)-1/1995840.
    coneq[13284]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3991680.
    coneq[13285]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))*c)-1/1330560.
    coneq[13286]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2661120.
    coneq[13287]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3)))))*c)-1/532224.
    coneq[13288]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))*c)-1/1596672.
    coneq[13289]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))*c)-1/3193344.
    coneq[13290]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))*c)-1/1064448.
    coneq[13291]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2)))))*c)-1/399168.
    coneq[13292]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c))))))*c)-1/798336.
    coneq[13293]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5*dot(A,c)))))*c)-1/266112.
    coneq[13294]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))*c)-1/1596672.
    coneq[13295]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))*c)-1/4790016.
    coneq[13296]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*c)-1/9580032.
    coneq[13297]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))*c)-1/3193344.
    coneq[13298]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))*c)-1/3193344.
    coneq[13299]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*c)-1/9580032.
    coneq[13300]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*c)-1/19160064.
    coneq[13301]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*c)-1/6386688.
    coneq[13302]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4)))))*c)-1/1330560.
    coneq[13303]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))*c)-1/5322240.
    coneq[13304]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*c)-1/15966720.
    coneq[13305]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/31933440.
    coneq[13306]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*c)-1/10644480.
    coneq[13307]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))*c)-1/3991680.
    coneq[13308]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*c)-1/7983360.
    coneq[13309]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))*c)-1/2661120.
    coneq[13310]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*c)-1/5322240.
    coneq[13311]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))*c)-1/1197504.
    coneq[13312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/2395008.
    coneq[13313]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/4790016.
    coneq[13314]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))*c)-1/1064448.
    coneq[13315]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/3193344.
    coneq[13316]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/6386688.
    coneq[13317]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/2128896.
    coneq[13318]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))*c)-1/798336.
    coneq[13319]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1596672.
    coneq[13320]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))*c)-1/532224.
    coneq[13321]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))*c)-1/1596672.
    coneq[13322]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*c)-1/3193344.
    coneq[13323]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/1064448.
    coneq[13324]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**6))))*c)-1/116424.
    coneq[13325]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**5)))))*c)-1/698544.
    coneq[13326]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4))))))*c)-1/3492720.
    coneq[13327]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/13970880.
    coneq[13328]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/41912640.
    coneq[13329]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/83825280.
    coneq[13330]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/27941760.
    coneq[13331]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/10478160.
    coneq[13332]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/20956320.
    coneq[13333]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/6985440.
    coneq[13334]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/13970880.
    coneq[13335]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))*c)-1/2794176.
    coneq[13336]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/8382528.
    coneq[13337]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/16765056.
    coneq[13338]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/5588352.
    coneq[13339]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/2095632.
    coneq[13340]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/4191264.
    coneq[13341]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1397088.
    coneq[13342]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/4191264.
    coneq[13343]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/8382528.
    coneq[13344]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2794176.
    coneq[13345]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4)))))*c)-1/582120.
    coneq[13346]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))*c)-1/2328480.
    coneq[13347]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/6985440.
    coneq[13348]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/13970880.
    coneq[13349]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/4656960.
    coneq[13350]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1746360.
    coneq[13351]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3492720.
    coneq[13352]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/1164240.
    coneq[13353]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2328480.
    coneq[13354]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3)))))*c)-1/465696.
    coneq[13355]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1397088.
    coneq[13356]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/2794176.
    coneq[13357]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/931392.
    coneq[13358]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2)))))*c)-1/349272.
    coneq[13359]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))*c)-1/698544.
    coneq[13360]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c)))))*c)-1/232848.
    coneq[13361]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/1047816.
    coneq[13362]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/2095632.
    coneq[13363]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/4191264.
    coneq[13364]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/931392.
    coneq[13365]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2794176.
    coneq[13366]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/5588352.
    coneq[13367]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1862784.
    coneq[13368]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/698544.
    coneq[13369]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1397088.
    coneq[13370]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/465696.
    coneq[13371]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/931392.
    coneq[13372]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**5))))*c)-1/99792.
    coneq[13373]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4)))))*c)-1/498960.
    coneq[13374]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))*c)-1/1995840.
    coneq[13375]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/5987520.
    coneq[13376]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/11975040.
    coneq[13377]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3991680.
    coneq[13378]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1496880.
    coneq[13379]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2993760.
    coneq[13380]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/997920.
    coneq[13381]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1995840.
    coneq[13382]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3)))))*c)-1/399168.
    coneq[13383]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1197504.
    coneq[13384]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2395008.
    coneq[13385]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/798336.
    coneq[13386]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2)))))*c)-1/299376.
    coneq[13387]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/598752.
    coneq[13388]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c)))))*c)-1/199584.
    coneq[13389]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/598752.
    coneq[13390]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1197504.
    coneq[13391]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/399168.
    coneq[13392]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**4))))*c)-1/83160.
    coneq[13393]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3)))))*c)-1/332640.
    coneq[13394]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))*c)-1/997920.
    coneq[13395]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1995840.
    coneq[13396]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))*c)-1/665280.
    coneq[13397]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2)))))*c)-1/249480.
    coneq[13398]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))*c)-1/498960.
    coneq[13399]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c)))))*c)-1/166320.
    coneq[13400]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))*c)-1/332640.
    coneq[13401]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**3))))*c)-1/66528.
    coneq[13402]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2)))))*c)-1/199584.
    coneq[13403]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c))))))*c)-1/399168.
    coneq[13404]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c)))))*c)-1/133056.
    coneq[13405]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c**2))))*c)-1/49896.
    coneq[13406]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,dot(A,c)))))*c)-1/99792.
    coneq[13407]=dot(b,dot(A,dot(A,c*dot(A,c**6*dot(A,c))))*c)-1/33264.
    coneq[13408]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3))))*c)-1/266112.
    coneq[13409]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))*c)-1/798336.
    coneq[13410]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))*c)-1/1596672.
    coneq[13411]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))*c)-1/532224.
    coneq[13412]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))*c)-1/2395008.
    coneq[13413]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))*c)-1/4790016.
    coneq[13414]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))*c)-1/1596672.
    coneq[13415]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))*c)-1/9580032.
    coneq[13416]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))*c)-1/3193344.
    coneq[13417]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/1064448.
    coneq[13418]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4))))*c)-1/249480.
    coneq[13419]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))*c)-1/997920.
    coneq[13420]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))*c)-1/2993760.
    coneq[13421]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5987520.
    coneq[13422]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1995840.
    coneq[13423]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))*c)-1/748440.
    coneq[13424]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1496880.
    coneq[13425]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))*c)-1/498960.
    coneq[13426]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/997920.
    coneq[13427]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4))))*c)-1/498960.
    coneq[13428]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))*c)-1/1995840.
    coneq[13429]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*c)-1/5987520.
    coneq[13430]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/11975040.
    coneq[13431]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*c)-1/3991680.
    coneq[13432]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))*c)-1/1496880.
    coneq[13433]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*c)-1/2993760.
    coneq[13434]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))*c)-1/997920.
    coneq[13435]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1995840.
    coneq[13436]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**5))))*c)-1/199584.
    coneq[13437]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4)))))*c)-1/997920.
    coneq[13438]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))*c)-1/3991680.
    coneq[13439]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/11975040.
    coneq[13440]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/23950080.
    coneq[13441]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/7983360.
    coneq[13442]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2993760.
    coneq[13443]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/5987520.
    coneq[13444]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1995840.
    coneq[13445]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/3991680.
    coneq[13446]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))*c)-1/798336.
    coneq[13447]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/2395008.
    coneq[13448]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/4790016.
    coneq[13449]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1596672.
    coneq[13450]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))*c)-1/598752.
    coneq[13451]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1197504.
    coneq[13452]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))*c)-1/399168.
    coneq[13453]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1197504.
    coneq[13454]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/2395008.
    coneq[13455]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/798336.
    coneq[13456]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3))))*c)-1/199584.
    coneq[13457]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/598752.
    coneq[13458]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/1197504.
    coneq[13459]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/399168.
    coneq[13460]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))*c)-1/399168.
    coneq[13461]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/1197504.
    coneq[13462]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/2395008.
    coneq[13463]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/798336.
    coneq[13464]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4))))*c)-1/166320.
    coneq[13465]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/665280.
    coneq[13466]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1995840.
    coneq[13467]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3991680.
    coneq[13468]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1330560.
    coneq[13469]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/498960.
    coneq[13470]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/997920.
    coneq[13471]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/332640.
    coneq[13472]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/665280.
    coneq[13473]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2))))*c)-1/149688.
    coneq[13474]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/299376.
    coneq[13475]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/598752.
    coneq[13476]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3))))*c)-1/133056.
    coneq[13477]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/399168.
    coneq[13478]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/798336.
    coneq[13479]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/266112.
    coneq[13480]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2))))*c)-1/99792.
    coneq[13481]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))*c)-1/199584.
    coneq[13482]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c))))*c)-1/66528.
    coneq[13483]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))*c)-1/266112.
    coneq[13484]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/798336.
    coneq[13485]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1596672.
    coneq[13486]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/532224.
    coneq[13487]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))*c)-1/299376.
    coneq[13488]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/598752.
    coneq[13489]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1197504.
    coneq[13490]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/199584.
    coneq[13491]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/399168.
    coneq[13492]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/133056.
    coneq[13493]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/266112.
    coneq[13494]=dot(b,dot(A,dot(A,c**2*dot(A,c**7)))*c)-1/14784.
    coneq[13495]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**6))))*c)-1/103488.
    coneq[13496]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**5)))))*c)-1/620928.
    coneq[13497]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/3104640.
    coneq[13498]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/12418560.
    coneq[13499]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/37255680.
    coneq[13500]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/74511360.
    coneq[13501]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/24837120.
    coneq[13502]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/9313920.
    coneq[13503]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/18627840.
    coneq[13504]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/6209280.
    coneq[13505]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/12418560.
    coneq[13506]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/2483712.
    coneq[13507]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/7451136.
    coneq[13508]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/14902272.
    coneq[13509]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/4967424.
    coneq[13510]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1862784.
    coneq[13511]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/3725568.
    coneq[13512]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1241856.
    coneq[13513]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/3725568.
    coneq[13514]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/7451136.
    coneq[13515]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2483712.
    coneq[13516]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4)))))*c)-1/517440.
    coneq[13517]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/2069760.
    coneq[13518]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/6209280.
    coneq[13519]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/12418560.
    coneq[13520]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/4139520.
    coneq[13521]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1552320.
    coneq[13522]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3104640.
    coneq[13523]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/1034880.
    coneq[13524]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2069760.
    coneq[13525]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/413952.
    coneq[13526]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1241856.
    coneq[13527]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/2483712.
    coneq[13528]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/827904.
    coneq[13529]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/310464.
    coneq[13530]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/620928.
    coneq[13531]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c)))))*c)-1/206976.
    coneq[13532]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/931392.
    coneq[13533]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1862784.
    coneq[13534]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/3725568.
    coneq[13535]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/827904.
    coneq[13536]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2483712.
    coneq[13537]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/4967424.
    coneq[13538]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1655808.
    coneq[13539]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/620928.
    coneq[13540]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1241856.
    coneq[13541]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/413952.
    coneq[13542]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/827904.
    coneq[13543]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**5))))*c)-1/88704.
    coneq[13544]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4)))))*c)-1/443520.
    coneq[13545]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/1774080.
    coneq[13546]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/5322240.
    coneq[13547]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/10644480.
    coneq[13548]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3548160.
    coneq[13549]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1330560.
    coneq[13550]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2661120.
    coneq[13551]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/887040.
    coneq[13552]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1774080.
    coneq[13553]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/354816.
    coneq[13554]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1064448.
    coneq[13555]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2128896.
    coneq[13556]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/709632.
    coneq[13557]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/266112.
    coneq[13558]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/532224.
    coneq[13559]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/177408.
    coneq[13560]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/532224.
    coneq[13561]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1064448.
    coneq[13562]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/354816.
    coneq[13563]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**4))))*c)-1/73920.
    coneq[13564]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/295680.
    coneq[13565]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/887040.
    coneq[13566]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1774080.
    coneq[13567]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/591360.
    coneq[13568]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/221760.
    coneq[13569]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/443520.
    coneq[13570]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/147840.
    coneq[13571]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/295680.
    coneq[13572]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**3))))*c)-1/59136.
    coneq[13573]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/177408.
    coneq[13574]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/354816.
    coneq[13575]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/118272.
    coneq[13576]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c**2))))*c)-1/44352.
    coneq[13577]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c)))))*c)-1/88704.
    coneq[13578]=dot(b,dot(A,dot(A,c**2*dot(A,c**5*dot(A,c))))*c)-1/29568.
    coneq[13579]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/177408.
    coneq[13580]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/532224.
    coneq[13581]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/1064448.
    coneq[13582]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/354816.
    coneq[13583]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/354816.
    coneq[13584]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/1064448.
    coneq[13585]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/2128896.
    coneq[13586]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/709632.
    coneq[13587]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4))))*c)-1/147840.
    coneq[13588]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/591360.
    coneq[13589]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1774080.
    coneq[13590]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3548160.
    coneq[13591]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1182720.
    coneq[13592]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/443520.
    coneq[13593]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/887040.
    coneq[13594]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/295680.
    coneq[13595]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/591360.
    coneq[13596]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/133056.
    coneq[13597]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/266112.
    coneq[13598]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/532224.
    coneq[13599]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/118272.
    coneq[13600]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/354816.
    coneq[13601]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/709632.
    coneq[13602]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/236544.
    coneq[13603]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/88704.
    coneq[13604]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/177408.
    coneq[13605]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/59136.
    coneq[13606]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/177408.
    coneq[13607]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/354816.
    coneq[13608]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/118272.
    coneq[13609]=dot(b,dot(A,dot(A,c**3*dot(A,c**6)))*c)-1/12936.
    coneq[13610]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**5))))*c)-1/77616.
    coneq[13611]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**4)))))*c)-1/388080.
    coneq[13612]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1552320.
    coneq[13613]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/4656960.
    coneq[13614]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/9313920.
    coneq[13615]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3104640.
    coneq[13616]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1164240.
    coneq[13617]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2328480.
    coneq[13618]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/776160.
    coneq[13619]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1552320.
    coneq[13620]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/310464.
    coneq[13621]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/931392.
    coneq[13622]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1862784.
    coneq[13623]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/620928.
    coneq[13624]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/232848.
    coneq[13625]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/465696.
    coneq[13626]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/155232.
    coneq[13627]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/465696.
    coneq[13628]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/931392.
    coneq[13629]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/310464.
    coneq[13630]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**4))))*c)-1/64680.
    coneq[13631]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/258720.
    coneq[13632]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/776160.
    coneq[13633]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1552320.
    coneq[13634]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/517440.
    coneq[13635]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/194040.
    coneq[13636]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/388080.
    coneq[13637]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/129360.
    coneq[13638]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/258720.
    coneq[13639]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**3))))*c)-1/51744.
    coneq[13640]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/155232.
    coneq[13641]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/310464.
    coneq[13642]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/103488.
    coneq[13643]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c**2))))*c)-1/38808.
    coneq[13644]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/77616.
    coneq[13645]=dot(b,dot(A,dot(A,c**3*dot(A,c**4*dot(A,c))))*c)-1/25872.
    coneq[13646]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/116424.
    coneq[13647]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/232848.
    coneq[13648]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/465696.
    coneq[13649]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/103488.
    coneq[13650]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/310464.
    coneq[13651]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/620928.
    coneq[13652]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/206976.
    coneq[13653]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/77616.
    coneq[13654]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/155232.
    coneq[13655]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/51744.
    coneq[13656]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/103488.
    coneq[13657]=dot(b,dot(A,dot(A,c**4*dot(A,c**5)))*c)-1/11088.
    coneq[13658]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**4))))*c)-1/55440.
    coneq[13659]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**3)))))*c)-1/221760.
    coneq[13660]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/665280.
    coneq[13661]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1330560.
    coneq[13662]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/443520.
    coneq[13663]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/166320.
    coneq[13664]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/332640.
    coneq[13665]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/110880.
    coneq[13666]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/221760.
    coneq[13667]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**3))))*c)-1/44352.
    coneq[13668]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/133056.
    coneq[13669]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/266112.
    coneq[13670]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/88704.
    coneq[13671]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c**2))))*c)-1/33264.
    coneq[13672]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/66528.
    coneq[13673]=dot(b,dot(A,dot(A,c**4*dot(A,c**3*dot(A,c))))*c)-1/22176.
    coneq[13674]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/66528.
    coneq[13675]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/133056.
    coneq[13676]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/44352.
    coneq[13677]=dot(b,dot(A,dot(A,c**5*dot(A,c**4)))*c)-1/9240.
    coneq[13678]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**3))))*c)-1/36960.
    coneq[13679]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c**2)))))*c)-1/110880.
    coneq[13680]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/221760.
    coneq[13681]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c*dot(A,c)))))*c)-1/73920.
    coneq[13682]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c**2))))*c)-1/27720.
    coneq[13683]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,dot(A,c)))))*c)-1/55440.
    coneq[13684]=dot(b,dot(A,dot(A,c**5*dot(A,c**2*dot(A,c))))*c)-1/18480.
    coneq[13685]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c)*dot(A,c))))*c)-1/36960.
    coneq[13686]=dot(b,dot(A,dot(A,c**6*dot(A,c**3)))*c)-1/7392.
    coneq[13687]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c**2))))*c)-1/22176.
    coneq[13688]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,dot(A,c)))))*c)-1/44352.
    coneq[13689]=dot(b,dot(A,dot(A,c**6*dot(A,c*dot(A,c))))*c)-1/14784.
    coneq[13690]=dot(b,dot(A,dot(A,c**7*dot(A,c**2)))*c)-1/5544.
    coneq[13691]=dot(b,dot(A,dot(A,c**7*dot(A,dot(A,c))))*c)-1/11088.
    coneq[13692]=dot(b,dot(A,dot(A,c**8*dot(A,c)))*c)-1/3696.
    coneq[13693]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**4)))*c)-1/46200.
    coneq[13694]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c**3))))*c)-1/184800.
    coneq[13695]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2)))))*c)-1/554400.
    coneq[13696]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1108800.
    coneq[13697]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c)))))*c)-1/369600.
    coneq[13698]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2))))*c)-1/138600.
    coneq[13699]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c)))))*c)-1/277200.
    coneq[13700]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c))))*c)-1/92400.
    coneq[13701]=dot(b,dot(A,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c))))*c)-1/184800.
    coneq[13702]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))))*c)-1/739200.
    coneq[13703]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))))*c)-1/2217600.
    coneq[13704]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/4435200.
    coneq[13705]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))))*c)-1/1478400.
    coneq[13706]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2))))*c)-1/554400.
    coneq[13707]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))))*c)-1/1108800.
    coneq[13708]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c))))*c)-1/369600.
    coneq[13709]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))))*c)-1/739200.
    coneq[13710]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))))*c)-1/6652800.
    coneq[13711]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/13305600.
    coneq[13712]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))))*c)-1/4435200.
    coneq[13713]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))))*c)-1/1663200.
    coneq[13714]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))))*c)-1/3326400.
    coneq[13715]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))))*c)-1/1108800.
    coneq[13716]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))))*c)-1/2217600.
    coneq[13717]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/26611200.
    coneq[13718]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))))*c)-1/8870400.
    coneq[13719]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))))*c)-1/3326400.
    coneq[13720]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))))*c)-1/6652800.
    coneq[13721]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))))*c)-1/2217600.
    coneq[13722]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))))*c)-1/4435200.
    coneq[13723]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))*c)-1/2956800.
    coneq[13724]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))))*c)-1/1108800.
    coneq[13725]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*c)-1/2217600.
    coneq[13726]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))))*c)-1/739200.
    coneq[13727]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*c)-1/1478400.
    coneq[13728]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))))*c)-1/415800.
    coneq[13729]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))*c)-1/831600.
    coneq[13730]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c))))*c)-1/277200.
    coneq[13731]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))*c)-1/554400.
    coneq[13732]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*c)-1/1663200.
    coneq[13733]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))*c)-1/554400.
    coneq[13734]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*c)-1/1108800.
    coneq[13735]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/184800.
    coneq[13736]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/369600.
    coneq[13737]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/739200.
    coneq[13738]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**5)))*c)-1/44352.
    coneq[13739]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**4))))*c)-1/221760.
    coneq[13740]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3)))))*c)-1/887040.
    coneq[13741]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/2661120.
    coneq[13742]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5322240.
    coneq[13743]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1774080.
    coneq[13744]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/665280.
    coneq[13745]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[13746]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/443520.
    coneq[13747]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/887040.
    coneq[13748]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3))))*c)-1/177408.
    coneq[13749]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/532224.
    coneq[13750]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1064448.
    coneq[13751]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/354816.
    coneq[13752]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2))))*c)-1/133056.
    coneq[13753]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/266112.
    coneq[13754]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c))))*c)-1/88704.
    coneq[13755]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/266112.
    coneq[13756]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/532224.
    coneq[13757]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/177408.
    coneq[13758]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**5)))*c)-1/133056.
    coneq[13759]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4))))*c)-1/665280.
    coneq[13760]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))))*c)-1/2661120.
    coneq[13761]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/7983360.
    coneq[13762]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/15966720.
    coneq[13763]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/5322240.
    coneq[13764]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/1995840.
    coneq[13765]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/3991680.
    coneq[13766]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/1330560.
    coneq[13767]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/2661120.
    coneq[13768]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3))))*c)-1/532224.
    coneq[13769]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/1596672.
    coneq[13770]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/3193344.
    coneq[13771]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/1064448.
    coneq[13772]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2))))*c)-1/399168.
    coneq[13773]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/798336.
    coneq[13774]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c))))*c)-1/266112.
    coneq[13775]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/798336.
    coneq[13776]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/1596672.
    coneq[13777]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/532224.
    coneq[13778]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5)))*c)-1/266112.
    coneq[13779]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4))))*c)-1/1330560.
    coneq[13780]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))))*c)-1/5322240.
    coneq[13781]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/15966720.
    coneq[13782]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/31933440.
    coneq[13783]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/10644480.
    coneq[13784]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/3991680.
    coneq[13785]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/7983360.
    coneq[13786]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/2661120.
    coneq[13787]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/5322240.
    coneq[13788]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))))*c)-1/1064448.
    coneq[13789]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/3193344.
    coneq[13790]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/6386688.
    coneq[13791]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/2128896.
    coneq[13792]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))))*c)-1/798336.
    coneq[13793]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/1596672.
    coneq[13794]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))))*c)-1/532224.
    coneq[13795]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/1596672.
    coneq[13796]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/3193344.
    coneq[13797]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/1064448.
    coneq[13798]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**5)))*c)-1/88704.
    coneq[13799]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4))))*c)-1/443520.
    coneq[13800]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3)))))*c)-1/1774080.
    coneq[13801]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/5322240.
    coneq[13802]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/10644480.
    coneq[13803]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/3548160.
    coneq[13804]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/1330560.
    coneq[13805]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[13806]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/887040.
    coneq[13807]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/1774080.
    coneq[13808]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3))))*c)-1/354816.
    coneq[13809]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/1064448.
    coneq[13810]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/2128896.
    coneq[13811]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/709632.
    coneq[13812]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2))))*c)-1/266112.
    coneq[13813]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/532224.
    coneq[13814]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c))))*c)-1/177408.
    coneq[13815]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/532224.
    coneq[13816]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/1064448.
    coneq[13817]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/354816.
    coneq[13818]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**6)))*c)-1/38808.
    coneq[13819]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**5))))*c)-1/232848.
    coneq[13820]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4)))))*c)-1/1164240.
    coneq[13821]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/4656960.
    coneq[13822]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/13970880.
    coneq[13823]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/27941760.
    coneq[13824]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/9313920.
    coneq[13825]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/3492720.
    coneq[13826]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/6985440.
    coneq[13827]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/2328480.
    coneq[13828]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/4656960.
    coneq[13829]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/931392.
    coneq[13830]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/2794176.
    coneq[13831]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/5588352.
    coneq[13832]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1862784.
    coneq[13833]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/698544.
    coneq[13834]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1397088.
    coneq[13835]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/465696.
    coneq[13836]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1397088.
    coneq[13837]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/2794176.
    coneq[13838]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/931392.
    coneq[13839]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4))))*c)-1/194040.
    coneq[13840]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/776160.
    coneq[13841]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/2328480.
    coneq[13842]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/4656960.
    coneq[13843]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/1552320.
    coneq[13844]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/582120.
    coneq[13845]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/1164240.
    coneq[13846]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/388080.
    coneq[13847]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/776160.
    coneq[13848]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3))))*c)-1/155232.
    coneq[13849]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/465696.
    coneq[13850]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/931392.
    coneq[13851]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/310464.
    coneq[13852]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2))))*c)-1/116424.
    coneq[13853]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/232848.
    coneq[13854]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c))))*c)-1/77616.
    coneq[13855]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/349272.
    coneq[13856]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/698544.
    coneq[13857]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1397088.
    coneq[13858]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/310464.
    coneq[13859]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/931392.
    coneq[13860]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1862784.
    coneq[13861]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/620928.
    coneq[13862]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/232848.
    coneq[13863]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/465696.
    coneq[13864]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/155232.
    coneq[13865]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/310464.
    coneq[13866]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**6)))*c)-1/77616.
    coneq[13867]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5))))*c)-1/465696.
    coneq[13868]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4)))))*c)-1/2328480.
    coneq[13869]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/9313920.
    coneq[13870]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/27941760.
    coneq[13871]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/55883520.
    coneq[13872]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/18627840.
    coneq[13873]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/6985440.
    coneq[13874]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/13970880.
    coneq[13875]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/4656960.
    coneq[13876]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/9313920.
    coneq[13877]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/1862784.
    coneq[13878]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/5588352.
    coneq[13879]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/11176704.
    coneq[13880]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/3725568.
    coneq[13881]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/1397088.
    coneq[13882]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/2794176.
    coneq[13883]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/931392.
    coneq[13884]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/2794176.
    coneq[13885]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/5588352.
    coneq[13886]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/1862784.
    coneq[13887]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4))))*c)-1/388080.
    coneq[13888]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/1552320.
    coneq[13889]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/4656960.
    coneq[13890]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/9313920.
    coneq[13891]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/3104640.
    coneq[13892]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/1164240.
    coneq[13893]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/2328480.
    coneq[13894]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/776160.
    coneq[13895]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1552320.
    coneq[13896]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3))))*c)-1/310464.
    coneq[13897]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/931392.
    coneq[13898]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/1862784.
    coneq[13899]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/620928.
    coneq[13900]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2))))*c)-1/232848.
    coneq[13901]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/465696.
    coneq[13902]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c))))*c)-1/155232.
    coneq[13903]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/698544.
    coneq[13904]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/1397088.
    coneq[13905]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/2794176.
    coneq[13906]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/620928.
    coneq[13907]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/1862784.
    coneq[13908]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/3725568.
    coneq[13909]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/1241856.
    coneq[13910]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/465696.
    coneq[13911]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/931392.
    coneq[13912]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/310464.
    coneq[13913]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/620928.
    coneq[13914]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**7)))*c)-1/29568.
    coneq[13915]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**6))))*c)-1/206976.
    coneq[13916]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5)))))*c)-1/1241856.
    coneq[13917]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/6209280.
    coneq[13918]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/24837120.
    coneq[13919]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/74511360.
    coneq[13920]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/149022720.
    coneq[13921]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/49674240.
    coneq[13922]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/18627840.
    coneq[13923]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/37255680.
    coneq[13924]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/12418560.
    coneq[13925]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/24837120.
    coneq[13926]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/4967424.
    coneq[13927]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/14902272.
    coneq[13928]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/29804544.
    coneq[13929]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/9934848.
    coneq[13930]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/3725568.
    coneq[13931]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/7451136.
    coneq[13932]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/2483712.
    coneq[13933]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/7451136.
    coneq[13934]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/14902272.
    coneq[13935]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/4967424.
    coneq[13936]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4)))))*c)-1/1034880.
    coneq[13937]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/4139520.
    coneq[13938]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/12418560.
    coneq[13939]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/24837120.
    coneq[13940]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/8279040.
    coneq[13941]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/3104640.
    coneq[13942]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/6209280.
    coneq[13943]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/2069760.
    coneq[13944]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/4139520.
    coneq[13945]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/827904.
    coneq[13946]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/2483712.
    coneq[13947]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/4967424.
    coneq[13948]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/1655808.
    coneq[13949]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/620928.
    coneq[13950]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/1241856.
    coneq[13951]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c)))))*c)-1/413952.
    coneq[13952]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/1862784.
    coneq[13953]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/3725568.
    coneq[13954]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/7451136.
    coneq[13955]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/1655808.
    coneq[13956]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/4967424.
    coneq[13957]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/9934848.
    coneq[13958]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/3311616.
    coneq[13959]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/1241856.
    coneq[13960]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/2483712.
    coneq[13961]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/827904.
    coneq[13962]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/1655808.
    coneq[13963]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**5))))*c)-1/177408.
    coneq[13964]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4)))))*c)-1/887040.
    coneq[13965]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/3548160.
    coneq[13966]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/10644480.
    coneq[13967]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/21288960.
    coneq[13968]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/7096320.
    coneq[13969]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2661120.
    coneq[13970]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/5322240.
    coneq[13971]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1774080.
    coneq[13972]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/3548160.
    coneq[13973]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/709632.
    coneq[13974]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/2128896.
    coneq[13975]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/4257792.
    coneq[13976]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1419264.
    coneq[13977]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/532224.
    coneq[13978]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1064448.
    coneq[13979]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/354816.
    coneq[13980]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1064448.
    coneq[13981]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/2128896.
    coneq[13982]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/709632.
    coneq[13983]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4))))*c)-1/147840.
    coneq[13984]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/591360.
    coneq[13985]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/1774080.
    coneq[13986]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3548160.
    coneq[13987]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/1182720.
    coneq[13988]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/443520.
    coneq[13989]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/887040.
    coneq[13990]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/295680.
    coneq[13991]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/591360.
    coneq[13992]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3))))*c)-1/118272.
    coneq[13993]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/354816.
    coneq[13994]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/709632.
    coneq[13995]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/236544.
    coneq[13996]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2))))*c)-1/88704.
    coneq[13997]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c)))))*c)-1/177408.
    coneq[13998]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5*dot(A,c))))*c)-1/59136.
    coneq[13999]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/354816.
    coneq[14000]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/1064448.
    coneq[14001]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/2128896.
    coneq[14002]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/709632.
    coneq[14003]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/709632.
    coneq[14004]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/2128896.
    coneq[14005]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/4257792.
    coneq[14006]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/1419264.
    coneq[14007]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4))))*c)-1/295680.
    coneq[14008]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/1182720.
    coneq[14009]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/3548160.
    coneq[14010]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/7096320.
    coneq[14011]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/2365440.
    coneq[14012]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/887040.
    coneq[14013]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1774080.
    coneq[14014]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/591360.
    coneq[14015]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1182720.
    coneq[14016]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/266112.
    coneq[14017]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/532224.
    coneq[14018]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1064448.
    coneq[14019]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/236544.
    coneq[14020]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/709632.
    coneq[14021]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1419264.
    coneq[14022]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/473088.
    coneq[14023]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/177408.
    coneq[14024]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/354816.
    coneq[14025]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/118272.
    coneq[14026]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/354816.
    coneq[14027]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/709632.
    coneq[14028]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/236544.
    coneq[14029]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**4)))*c)-1/36960.
    coneq[14030]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3))))*c)-1/147840.
    coneq[14031]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))*c)-1/443520.
    coneq[14032]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/887040.
    coneq[14033]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))*c)-1/295680.
    coneq[14034]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2))))*c)-1/110880.
    coneq[14035]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))*c)-1/221760.
    coneq[14036]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c))))*c)-1/73920.
    coneq[14037]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))*c)-1/147840.
    coneq[14038]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4)))*c)-1/110880.
    coneq[14039]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))*c)-1/443520.
    coneq[14040]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))*c)-1/1330560.
    coneq[14041]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[14042]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))*c)-1/887040.
    coneq[14043]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))*c)-1/332640.
    coneq[14044]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))*c)-1/665280.
    coneq[14045]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))*c)-1/221760.
    coneq[14046]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))*c)-1/443520.
    coneq[14047]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4)))*c)-1/221760.
    coneq[14048]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))*c)-1/887040.
    coneq[14049]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))*c)-1/2661120.
    coneq[14050]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/5322240.
    coneq[14051]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))*c)-1/1774080.
    coneq[14052]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))*c)-1/665280.
    coneq[14053]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*c)-1/1330560.
    coneq[14054]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))*c)-1/443520.
    coneq[14055]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*c)-1/887040.
    coneq[14056]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4)))*c)-1/73920.
    coneq[14057]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))*c)-1/295680.
    coneq[14058]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/887040.
    coneq[14059]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1774080.
    coneq[14060]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/591360.
    coneq[14061]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/221760.
    coneq[14062]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/443520.
    coneq[14063]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/147840.
    coneq[14064]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/295680.
    coneq[14065]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**5)))*c)-1/33264.
    coneq[14066]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4))))*c)-1/166320.
    coneq[14067]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))*c)-1/665280.
    coneq[14068]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1995840.
    coneq[14069]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3991680.
    coneq[14070]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1330560.
    coneq[14071]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/498960.
    coneq[14072]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/997920.
    coneq[14073]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/332640.
    coneq[14074]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/665280.
    coneq[14075]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3))))*c)-1/133056.
    coneq[14076]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/399168.
    coneq[14077]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/798336.
    coneq[14078]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/266112.
    coneq[14079]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2))))*c)-1/99792.
    coneq[14080]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/199584.
    coneq[14081]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c))))*c)-1/66528.
    coneq[14082]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/199584.
    coneq[14083]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/399168.
    coneq[14084]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/133056.
    coneq[14085]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**5)))*c)-1/66528.
    coneq[14086]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4))))*c)-1/332640.
    coneq[14087]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))*c)-1/1330560.
    coneq[14088]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/3991680.
    coneq[14089]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/7983360.
    coneq[14090]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/2661120.
    coneq[14091]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/997920.
    coneq[14092]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1995840.
    coneq[14093]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/665280.
    coneq[14094]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/1330560.
    coneq[14095]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))*c)-1/266112.
    coneq[14096]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/798336.
    coneq[14097]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1596672.
    coneq[14098]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/532224.
    coneq[14099]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))*c)-1/199584.
    coneq[14100]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/399168.
    coneq[14101]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))*c)-1/133056.
    coneq[14102]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/399168.
    coneq[14103]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/798336.
    coneq[14104]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/266112.
    coneq[14105]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**6)))*c)-1/25872.
    coneq[14106]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**5))))*c)-1/155232.
    coneq[14107]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4)))))*c)-1/776160.
    coneq[14108]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/3104640.
    coneq[14109]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/9313920.
    coneq[14110]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/18627840.
    coneq[14111]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/6209280.
    coneq[14112]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2328480.
    coneq[14113]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/4656960.
    coneq[14114]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1552320.
    coneq[14115]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/3104640.
    coneq[14116]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/620928.
    coneq[14117]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1862784.
    coneq[14118]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/3725568.
    coneq[14119]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1241856.
    coneq[14120]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/465696.
    coneq[14121]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/931392.
    coneq[14122]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/310464.
    coneq[14123]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/931392.
    coneq[14124]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1862784.
    coneq[14125]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/620928.
    coneq[14126]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4))))*c)-1/129360.
    coneq[14127]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/517440.
    coneq[14128]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/1552320.
    coneq[14129]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3104640.
    coneq[14130]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/1034880.
    coneq[14131]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/388080.
    coneq[14132]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/776160.
    coneq[14133]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/258720.
    coneq[14134]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/517440.
    coneq[14135]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3))))*c)-1/103488.
    coneq[14136]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/310464.
    coneq[14137]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/620928.
    coneq[14138]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/206976.
    coneq[14139]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2))))*c)-1/77616.
    coneq[14140]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/155232.
    coneq[14141]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c))))*c)-1/51744.
    coneq[14142]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/232848.
    coneq[14143]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/465696.
    coneq[14144]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/931392.
    coneq[14145]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/206976.
    coneq[14146]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/620928.
    coneq[14147]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1241856.
    coneq[14148]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/413952.
    coneq[14149]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/155232.
    coneq[14150]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/310464.
    coneq[14151]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/103488.
    coneq[14152]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/206976.
    coneq[14153]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c**3)))*c)-1/29568.
    coneq[14154]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/88704.
    coneq[14155]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/177408.
    coneq[14156]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/59136.
    coneq[14157]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/266112.
    coneq[14158]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/532224.
    coneq[14159]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/177408.
    coneq[14160]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/1064448.
    coneq[14161]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/354816.
    coneq[14162]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/118272.
    coneq[14163]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**4)))*c)-1/27720.
    coneq[14164]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/110880.
    coneq[14165]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/332640.
    coneq[14166]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/665280.
    coneq[14167]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/221760.
    coneq[14168]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/83160.
    coneq[14169]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/166320.
    coneq[14170]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/55440.
    coneq[14171]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/110880.
    coneq[14172]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4)))*c)-1/55440.
    coneq[14173]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/221760.
    coneq[14174]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/665280.
    coneq[14175]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[14176]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/443520.
    coneq[14177]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/166320.
    coneq[14178]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/332640.
    coneq[14179]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/110880.
    coneq[14180]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/221760.
    coneq[14181]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**5)))*c)-1/22176.
    coneq[14182]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4))))*c)-1/110880.
    coneq[14183]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/443520.
    coneq[14184]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1330560.
    coneq[14185]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2661120.
    coneq[14186]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/887040.
    coneq[14187]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/332640.
    coneq[14188]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/665280.
    coneq[14189]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/221760.
    coneq[14190]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/443520.
    coneq[14191]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/88704.
    coneq[14192]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/266112.
    coneq[14193]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/532224.
    coneq[14194]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/177408.
    coneq[14195]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/66528.
    coneq[14196]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/133056.
    coneq[14197]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/44352.
    coneq[14198]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/133056.
    coneq[14199]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/266112.
    coneq[14200]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/88704.
    coneq[14201]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**3)))*c)-1/22176.
    coneq[14202]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/66528.
    coneq[14203]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/133056.
    coneq[14204]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/44352.
    coneq[14205]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/44352.
    coneq[14206]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/133056.
    coneq[14207]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/266112.
    coneq[14208]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/88704.
    coneq[14209]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**4)))*c)-1/18480.
    coneq[14210]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/73920.
    coneq[14211]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/221760.
    coneq[14212]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/443520.
    coneq[14213]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/147840.
    coneq[14214]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/55440.
    coneq[14215]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/110880.
    coneq[14216]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/36960.
    coneq[14217]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/73920.
    coneq[14218]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,c**2)))*c)-1/16632.
    coneq[14219]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/33264.
    coneq[14220]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/66528.
    coneq[14221]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**3)))*c)-1/14784.
    coneq[14222]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/44352.
    coneq[14223]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/88704.
    coneq[14224]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/29568.
    coneq[14225]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c**2)))*c)-1/11088.
    coneq[14226]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,dot(A,c))))*c)-1/22176.
    coneq[14227]=dot(b,dot(A,dot(A,c**6*dot(A,c)*dot(A,c)))*c)-1/7392.
    coneq[14228]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5)))*c)-1/44352.
    coneq[14229]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4))))*c)-1/221760.
    coneq[14230]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/887040.
    coneq[14231]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/2661120.
    coneq[14232]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5322240.
    coneq[14233]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1774080.
    coneq[14234]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/665280.
    coneq[14235]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[14236]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/443520.
    coneq[14237]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/887040.
    coneq[14238]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/177408.
    coneq[14239]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/532224.
    coneq[14240]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1064448.
    coneq[14241]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/354816.
    coneq[14242]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/133056.
    coneq[14243]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/266112.
    coneq[14244]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/88704.
    coneq[14245]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/266112.
    coneq[14246]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/532224.
    coneq[14247]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/177408.
    coneq[14248]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4)))*c)-1/55440.
    coneq[14249]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/221760.
    coneq[14250]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/665280.
    coneq[14251]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1330560.
    coneq[14252]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/443520.
    coneq[14253]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/166320.
    coneq[14254]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/332640.
    coneq[14255]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/110880.
    coneq[14256]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/221760.
    coneq[14257]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4)))*c)-1/110880.
    coneq[14258]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/443520.
    coneq[14259]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/1330560.
    coneq[14260]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2661120.
    coneq[14261]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/887040.
    coneq[14262]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/332640.
    coneq[14263]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/665280.
    coneq[14264]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/221760.
    coneq[14265]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/443520.
    coneq[14266]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3)))*c)-1/66528.
    coneq[14267]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/199584.
    coneq[14268]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/399168.
    coneq[14269]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/133056.
    coneq[14270]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/133056.
    coneq[14271]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/399168.
    coneq[14272]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/798336.
    coneq[14273]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/266112.
    coneq[14274]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/266112.
    coneq[14275]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/798336.
    coneq[14276]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/1596672.
    coneq[14277]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/532224.
    coneq[14278]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3)))*c)-1/59136.
    coneq[14279]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/177408.
    coneq[14280]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/354816.
    coneq[14281]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/118272.
    coneq[14282]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/532224.
    coneq[14283]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/1064448.
    coneq[14284]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/354816.
    coneq[14285]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/2128896.
    coneq[14286]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/709632.
    coneq[14287]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/236544.
    coneq[14288]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4)))*c)-1/36960.
    coneq[14289]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/147840.
    coneq[14290]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/443520.
    coneq[14291]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/887040.
    coneq[14292]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/295680.
    coneq[14293]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/110880.
    coneq[14294]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/221760.
    coneq[14295]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/73920.
    coneq[14296]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/147840.
    coneq[14297]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3)))*c)-1/44352.
    coneq[14298]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/133056.
    coneq[14299]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/266112.
    coneq[14300]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/88704.
    coneq[14301]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/88704.
    coneq[14302]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/266112.
    coneq[14303]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/532224.
    coneq[14304]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/177408.
    coneq[14305]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))*c)-1/49896.
    coneq[14306]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/99792.
    coneq[14307]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/199584.
    coneq[14308]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/399168.
    coneq[14309]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/29568.
    coneq[14310]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/88704.
    coneq[14311]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/177408.
    coneq[14312]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/59136.
    coneq[14313]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/33264.
    coneq[14314]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/66528.
    coneq[14315]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/133056.
    coneq[14316]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/22176.
    coneq[14317]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/44352.
    coneq[14318]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/14784.
    coneq[14319]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/59136.
    coneq[14320]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/177408.
    coneq[14321]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/354816.
    coneq[14322]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/118272.
    coneq[14323]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/66528.
    coneq[14324]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/133056.
    coneq[14325]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2)))*c)-1/133056.
    coneq[14326]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/266112.
    coneq[14327]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/44352.
    coneq[14328]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/88704.
    coneq[14329]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/29568.
    coneq[14330]=dot(b,dot(A,c*dot(A,c**9))*c)-1/1680.
    coneq[14331]=dot(b,dot(A,c*dot(A,dot(A,c**8)))*c)-1/15120.
    coneq[14332]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**7))))*c)-1/120960.
    coneq[14333]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**6)))))*c)-1/846720.
    coneq[14334]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))*c)-1/5080320.
    coneq[14335]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))*c)-1/25401600.
    coneq[14336]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))*c)-1/101606400.
    coneq[14337]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c)-1/304819200.
    coneq[14338]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c)-1/609638400.
    coneq[14339]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c)-1/203212800.
    coneq[14340]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*c)-1/76204800.
    coneq[14341]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c)-1/152409600.
    coneq[14342]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*c)-1/50803200.
    coneq[14343]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c)-1/101606400.
    coneq[14344]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))*c)-1/20321280.
    coneq[14345]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*c)-1/60963840.
    coneq[14346]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c)-1/121927680.
    coneq[14347]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*c)-1/40642560.
    coneq[14348]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))*c)-1/15240960.
    coneq[14349]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*c)-1/30481920.
    coneq[14350]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))*c)-1/10160640.
    coneq[14351]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*c)-1/30481920.
    coneq[14352]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c)-1/60963840.
    coneq[14353]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*c)-1/20321280.
    coneq[14354]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))*c)-1/4233600.
    coneq[14355]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))*c)-1/16934400.
    coneq[14356]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*c)-1/50803200.
    coneq[14357]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/101606400.
    coneq[14358]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*c)-1/33868800.
    coneq[14359]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))*c)-1/12700800.
    coneq[14360]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*c)-1/25401600.
    coneq[14361]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))*c)-1/8467200.
    coneq[14362]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*c)-1/16934400.
    coneq[14363]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))*c)-1/3386880.
    coneq[14364]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))*c)-1/10160640.
    coneq[14365]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*c)-1/20321280.
    coneq[14366]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))*c)-1/6773760.
    coneq[14367]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))*c)-1/2540160.
    coneq[14368]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))*c)-1/5080320.
    coneq[14369]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))*c)-1/1693440.
    coneq[14370]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))*c)-1/7620480.
    coneq[14371]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*c)-1/15240960.
    coneq[14372]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c)-1/30481920.
    coneq[14373]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))*c)-1/6773760.
    coneq[14374]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*c)-1/20321280.
    coneq[14375]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c)-1/40642560.
    coneq[14376]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*c)-1/13547520.
    coneq[14377]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))*c)-1/5080320.
    coneq[14378]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*c)-1/10160640.
    coneq[14379]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))*c)-1/3386880.
    coneq[14380]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*c)-1/6773760.
    coneq[14381]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**5)))))*c)-1/725760.
    coneq[14382]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))*c)-1/3628800.
    coneq[14383]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))*c)-1/14515200.
    coneq[14384]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/43545600.
    coneq[14385]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/87091200.
    coneq[14386]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/29030400.
    coneq[14387]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/10886400.
    coneq[14388]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/21772800.
    coneq[14389]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/7257600.
    coneq[14390]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/14515200.
    coneq[14391]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))*c)-1/2903040.
    coneq[14392]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/8709120.
    coneq[14393]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/17418240.
    coneq[14394]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/5806080.
    coneq[14395]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))*c)-1/2177280.
    coneq[14396]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/4354560.
    coneq[14397]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))*c)-1/1451520.
    coneq[14398]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/4354560.
    coneq[14399]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/8709120.
    coneq[14400]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2903040.
    coneq[14401]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))*c)-1/604800.
    coneq[14402]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))*c)-1/2419200.
    coneq[14403]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))*c)-1/7257600.
    coneq[14404]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/14515200.
    coneq[14405]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))*c)-1/4838400.
    coneq[14406]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))*c)-1/1814400.
    coneq[14407]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3628800.
    coneq[14408]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))*c)-1/1209600.
    coneq[14409]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2419200.
    coneq[14410]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))*c)-1/483840.
    coneq[14411]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))*c)-1/1451520.
    coneq[14412]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))*c)-1/2903040.
    coneq[14413]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))*c)-1/967680.
    coneq[14414]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))*c)-1/362880.
    coneq[14415]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))*c)-1/725760.
    coneq[14416]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5*dot(A,c)))))*c)-1/241920.
    coneq[14417]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))*c)-1/1451520.
    coneq[14418]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))*c)-1/4354560.
    coneq[14419]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*c)-1/8709120.
    coneq[14420]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))*c)-1/2903040.
    coneq[14421]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))*c)-1/2903040.
    coneq[14422]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*c)-1/8709120.
    coneq[14423]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*c)-1/17418240.
    coneq[14424]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*c)-1/5806080.
    coneq[14425]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))*c)-1/1209600.
    coneq[14426]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))*c)-1/4838400.
    coneq[14427]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*c)-1/14515200.
    coneq[14428]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/29030400.
    coneq[14429]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*c)-1/9676800.
    coneq[14430]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))*c)-1/3628800.
    coneq[14431]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*c)-1/7257600.
    coneq[14432]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))*c)-1/2419200.
    coneq[14433]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*c)-1/4838400.
    coneq[14434]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))*c)-1/1088640.
    coneq[14435]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/2177280.
    coneq[14436]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/4354560.
    coneq[14437]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))*c)-1/967680.
    coneq[14438]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2903040.
    coneq[14439]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/5806080.
    coneq[14440]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1935360.
    coneq[14441]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))*c)-1/725760.
    coneq[14442]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[14443]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))*c)-1/483840.
    coneq[14444]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))*c)-1/1451520.
    coneq[14445]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*c)-1/2903040.
    coneq[14446]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/967680.
    coneq[14447]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**6))))*c)-1/105840.
    coneq[14448]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**5)))))*c)-1/635040.
    coneq[14449]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))*c)-1/3175200.
    coneq[14450]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/12700800.
    coneq[14451]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/38102400.
    coneq[14452]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/76204800.
    coneq[14453]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/25401600.
    coneq[14454]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/9525600.
    coneq[14455]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/19051200.
    coneq[14456]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/6350400.
    coneq[14457]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/12700800.
    coneq[14458]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))*c)-1/2540160.
    coneq[14459]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/7620480.
    coneq[14460]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/15240960.
    coneq[14461]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/5080320.
    coneq[14462]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1905120.
    coneq[14463]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/3810240.
    coneq[14464]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1270080.
    coneq[14465]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/3810240.
    coneq[14466]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/7620480.
    coneq[14467]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2540160.
    coneq[14468]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))*c)-1/529200.
    coneq[14469]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))*c)-1/2116800.
    coneq[14470]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/6350400.
    coneq[14471]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/12700800.
    coneq[14472]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/4233600.
    coneq[14473]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1587600.
    coneq[14474]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/3175200.
    coneq[14475]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/1058400.
    coneq[14476]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/2116800.
    coneq[14477]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))*c)-1/423360.
    coneq[14478]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1270080.
    coneq[14479]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/2540160.
    coneq[14480]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/846720.
    coneq[14481]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))*c)-1/317520.
    coneq[14482]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))*c)-1/635040.
    coneq[14483]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))*c)-1/211680.
    coneq[14484]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/952560.
    coneq[14485]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1905120.
    coneq[14486]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/3810240.
    coneq[14487]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/846720.
    coneq[14488]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2540160.
    coneq[14489]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/5080320.
    coneq[14490]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1693440.
    coneq[14491]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/635040.
    coneq[14492]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1270080.
    coneq[14493]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/423360.
    coneq[14494]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/846720.
    coneq[14495]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**5))))*c)-1/90720.
    coneq[14496]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))*c)-1/453600.
    coneq[14497]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))*c)-1/1814400.
    coneq[14498]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/5443200.
    coneq[14499]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/10886400.
    coneq[14500]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3628800.
    coneq[14501]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1360800.
    coneq[14502]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2721600.
    coneq[14503]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/907200.
    coneq[14504]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1814400.
    coneq[14505]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))*c)-1/362880.
    coneq[14506]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1088640.
    coneq[14507]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2177280.
    coneq[14508]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/725760.
    coneq[14509]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))*c)-1/272160.
    coneq[14510]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/544320.
    coneq[14511]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))*c)-1/181440.
    coneq[14512]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/544320.
    coneq[14513]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[14514]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/362880.
    coneq[14515]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**4))))*c)-1/75600.
    coneq[14516]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))*c)-1/302400.
    coneq[14517]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))*c)-1/907200.
    coneq[14518]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1814400.
    coneq[14519]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))*c)-1/604800.
    coneq[14520]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))*c)-1/226800.
    coneq[14521]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))*c)-1/453600.
    coneq[14522]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))*c)-1/151200.
    coneq[14523]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))*c)-1/302400.
    coneq[14524]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**3))))*c)-1/60480.
    coneq[14525]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))*c)-1/181440.
    coneq[14526]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))*c)-1/362880.
    coneq[14527]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))*c)-1/120960.
    coneq[14528]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c**2))))*c)-1/45360.
    coneq[14529]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,dot(A,c)))))*c)-1/90720.
    coneq[14530]=dot(b,dot(A,c*dot(A,dot(A,c**6*dot(A,c))))*c)-1/30240.
    coneq[14531]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))*c)-1/241920.
    coneq[14532]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))*c)-1/725760.
    coneq[14533]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[14534]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))*c)-1/483840.
    coneq[14535]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))*c)-1/2177280.
    coneq[14536]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))*c)-1/4354560.
    coneq[14537]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))*c)-1/1451520.
    coneq[14538]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))*c)-1/8709120.
    coneq[14539]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))*c)-1/2903040.
    coneq[14540]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/967680.
    coneq[14541]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))*c)-1/226800.
    coneq[14542]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))*c)-1/907200.
    coneq[14543]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))*c)-1/2721600.
    coneq[14544]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5443200.
    coneq[14545]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1814400.
    coneq[14546]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))*c)-1/680400.
    coneq[14547]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1360800.
    coneq[14548]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))*c)-1/453600.
    coneq[14549]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/907200.
    coneq[14550]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))*c)-1/453600.
    coneq[14551]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))*c)-1/1814400.
    coneq[14552]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*c)-1/5443200.
    coneq[14553]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/10886400.
    coneq[14554]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*c)-1/3628800.
    coneq[14555]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))*c)-1/1360800.
    coneq[14556]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*c)-1/2721600.
    coneq[14557]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))*c)-1/907200.
    coneq[14558]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1814400.
    coneq[14559]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**5))))*c)-1/181440.
    coneq[14560]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))*c)-1/907200.
    coneq[14561]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))*c)-1/3628800.
    coneq[14562]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/10886400.
    coneq[14563]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/21772800.
    coneq[14564]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/7257600.
    coneq[14565]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2721600.
    coneq[14566]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/5443200.
    coneq[14567]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1814400.
    coneq[14568]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/3628800.
    coneq[14569]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))*c)-1/725760.
    coneq[14570]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/2177280.
    coneq[14571]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/4354560.
    coneq[14572]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1451520.
    coneq[14573]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))*c)-1/544320.
    coneq[14574]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[14575]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))*c)-1/362880.
    coneq[14576]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1088640.
    coneq[14577]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/2177280.
    coneq[14578]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/725760.
    coneq[14579]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))*c)-1/181440.
    coneq[14580]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/544320.
    coneq[14581]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[14582]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/362880.
    coneq[14583]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))*c)-1/362880.
    coneq[14584]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/1088640.
    coneq[14585]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/2177280.
    coneq[14586]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/725760.
    coneq[14587]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))*c)-1/151200.
    coneq[14588]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/604800.
    coneq[14589]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1814400.
    coneq[14590]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3628800.
    coneq[14591]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1209600.
    coneq[14592]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/453600.
    coneq[14593]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/907200.
    coneq[14594]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/302400.
    coneq[14595]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/604800.
    coneq[14596]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))*c)-1/136080.
    coneq[14597]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/272160.
    coneq[14598]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/544320.
    coneq[14599]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))*c)-1/120960.
    coneq[14600]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/362880.
    coneq[14601]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/725760.
    coneq[14602]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/241920.
    coneq[14603]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))*c)-1/90720.
    coneq[14604]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))*c)-1/181440.
    coneq[14605]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))*c)-1/60480.
    coneq[14606]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))*c)-1/241920.
    coneq[14607]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/725760.
    coneq[14608]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[14609]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/483840.
    coneq[14610]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))*c)-1/272160.
    coneq[14611]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/544320.
    coneq[14612]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1088640.
    coneq[14613]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/181440.
    coneq[14614]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/362880.
    coneq[14615]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/120960.
    coneq[14616]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/241920.
    coneq[14617]=dot(b,dot(A,c*dot(A,c*dot(A,c**7)))*c)-1/13440.
    coneq[14618]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**6))))*c)-1/94080.
    coneq[14619]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**5)))))*c)-1/564480.
    coneq[14620]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/2822400.
    coneq[14621]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/11289600.
    coneq[14622]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/33868800.
    coneq[14623]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/67737600.
    coneq[14624]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/22579200.
    coneq[14625]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/8467200.
    coneq[14626]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/16934400.
    coneq[14627]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/5644800.
    coneq[14628]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/11289600.
    coneq[14629]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/2257920.
    coneq[14630]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/6773760.
    coneq[14631]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/13547520.
    coneq[14632]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/4515840.
    coneq[14633]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1693440.
    coneq[14634]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/3386880.
    coneq[14635]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1128960.
    coneq[14636]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/3386880.
    coneq[14637]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/6773760.
    coneq[14638]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2257920.
    coneq[14639]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))*c)-1/470400.
    coneq[14640]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/1881600.
    coneq[14641]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/5644800.
    coneq[14642]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/11289600.
    coneq[14643]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/3763200.
    coneq[14644]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1411200.
    coneq[14645]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/2822400.
    coneq[14646]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/940800.
    coneq[14647]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/1881600.
    coneq[14648]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/376320.
    coneq[14649]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1128960.
    coneq[14650]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/2257920.
    coneq[14651]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/752640.
    coneq[14652]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/282240.
    coneq[14653]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/564480.
    coneq[14654]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))*c)-1/188160.
    coneq[14655]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/846720.
    coneq[14656]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1693440.
    coneq[14657]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/3386880.
    coneq[14658]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/752640.
    coneq[14659]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2257920.
    coneq[14660]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/4515840.
    coneq[14661]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1505280.
    coneq[14662]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/564480.
    coneq[14663]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1128960.
    coneq[14664]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/376320.
    coneq[14665]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/752640.
    coneq[14666]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**5))))*c)-1/80640.
    coneq[14667]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))*c)-1/403200.
    coneq[14668]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/1612800.
    coneq[14669]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/4838400.
    coneq[14670]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/9676800.
    coneq[14671]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/3225600.
    coneq[14672]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1209600.
    coneq[14673]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2419200.
    coneq[14674]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/806400.
    coneq[14675]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1612800.
    coneq[14676]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/322560.
    coneq[14677]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/967680.
    coneq[14678]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1935360.
    coneq[14679]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/645120.
    coneq[14680]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/241920.
    coneq[14681]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/483840.
    coneq[14682]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/161280.
    coneq[14683]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/483840.
    coneq[14684]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/967680.
    coneq[14685]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/322560.
    coneq[14686]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**4))))*c)-1/67200.
    coneq[14687]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/268800.
    coneq[14688]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/806400.
    coneq[14689]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1612800.
    coneq[14690]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/537600.
    coneq[14691]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/201600.
    coneq[14692]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/403200.
    coneq[14693]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/134400.
    coneq[14694]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/268800.
    coneq[14695]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**3))))*c)-1/53760.
    coneq[14696]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/161280.
    coneq[14697]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/322560.
    coneq[14698]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/107520.
    coneq[14699]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c**2))))*c)-1/40320.
    coneq[14700]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))*c)-1/80640.
    coneq[14701]=dot(b,dot(A,c*dot(A,c*dot(A,c**5*dot(A,c))))*c)-1/26880.
    coneq[14702]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/161280.
    coneq[14703]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/483840.
    coneq[14704]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/967680.
    coneq[14705]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/322560.
    coneq[14706]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/322560.
    coneq[14707]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/967680.
    coneq[14708]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/1935360.
    coneq[14709]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/645120.
    coneq[14710]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))*c)-1/134400.
    coneq[14711]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/537600.
    coneq[14712]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1612800.
    coneq[14713]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3225600.
    coneq[14714]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1075200.
    coneq[14715]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/403200.
    coneq[14716]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/806400.
    coneq[14717]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/268800.
    coneq[14718]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/537600.
    coneq[14719]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/120960.
    coneq[14720]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/241920.
    coneq[14721]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/483840.
    coneq[14722]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/107520.
    coneq[14723]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/322560.
    coneq[14724]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/645120.
    coneq[14725]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/215040.
    coneq[14726]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/80640.
    coneq[14727]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/161280.
    coneq[14728]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/53760.
    coneq[14729]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/161280.
    coneq[14730]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/322560.
    coneq[14731]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/107520.
    coneq[14732]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**6)))*c)-1/11760.
    coneq[14733]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**5))))*c)-1/70560.
    coneq[14734]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))*c)-1/352800.
    coneq[14735]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1411200.
    coneq[14736]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/4233600.
    coneq[14737]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/8467200.
    coneq[14738]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2822400.
    coneq[14739]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1058400.
    coneq[14740]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2116800.
    coneq[14741]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/705600.
    coneq[14742]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1411200.
    coneq[14743]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/282240.
    coneq[14744]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/846720.
    coneq[14745]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1693440.
    coneq[14746]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/564480.
    coneq[14747]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/211680.
    coneq[14748]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/423360.
    coneq[14749]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/141120.
    coneq[14750]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/423360.
    coneq[14751]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/846720.
    coneq[14752]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/282240.
    coneq[14753]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**4))))*c)-1/58800.
    coneq[14754]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/235200.
    coneq[14755]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/705600.
    coneq[14756]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1411200.
    coneq[14757]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/470400.
    coneq[14758]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/176400.
    coneq[14759]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/352800.
    coneq[14760]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/117600.
    coneq[14761]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/235200.
    coneq[14762]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**3))))*c)-1/47040.
    coneq[14763]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/141120.
    coneq[14764]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/282240.
    coneq[14765]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/94080.
    coneq[14766]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c**2))))*c)-1/35280.
    coneq[14767]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/70560.
    coneq[14768]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4*dot(A,c))))*c)-1/23520.
    coneq[14769]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/105840.
    coneq[14770]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/211680.
    coneq[14771]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/423360.
    coneq[14772]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/94080.
    coneq[14773]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/282240.
    coneq[14774]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/564480.
    coneq[14775]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/188160.
    coneq[14776]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/70560.
    coneq[14777]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/141120.
    coneq[14778]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/47040.
    coneq[14779]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/94080.
    coneq[14780]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**5)))*c)-1/10080.
    coneq[14781]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**4))))*c)-1/50400.
    coneq[14782]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))*c)-1/201600.
    coneq[14783]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/604800.
    coneq[14784]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1209600.
    coneq[14785]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/403200.
    coneq[14786]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/151200.
    coneq[14787]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/302400.
    coneq[14788]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/100800.
    coneq[14789]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/201600.
    coneq[14790]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**3))))*c)-1/40320.
    coneq[14791]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/120960.
    coneq[14792]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/241920.
    coneq[14793]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/80640.
    coneq[14794]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c**2))))*c)-1/30240.
    coneq[14795]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/60480.
    coneq[14796]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3*dot(A,c))))*c)-1/20160.
    coneq[14797]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/60480.
    coneq[14798]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[14799]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/40320.
    coneq[14800]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**4)))*c)-1/8400.
    coneq[14801]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**3))))*c)-1/33600.
    coneq[14802]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))*c)-1/100800.
    coneq[14803]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/201600.
    coneq[14804]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))*c)-1/67200.
    coneq[14805]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c**2))))*c)-1/25200.
    coneq[14806]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))*c)-1/50400.
    coneq[14807]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2*dot(A,c))))*c)-1/16800.
    coneq[14808]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))*c)-1/33600.
    coneq[14809]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**3)))*c)-1/6720.
    coneq[14810]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c**2))))*c)-1/20160.
    coneq[14811]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,dot(A,c)))))*c)-1/40320.
    coneq[14812]=dot(b,dot(A,c*dot(A,c**5*dot(A,c*dot(A,c))))*c)-1/13440.
    coneq[14813]=dot(b,dot(A,c*dot(A,c**6*dot(A,c**2)))*c)-1/5040.
    coneq[14814]=dot(b,dot(A,c*dot(A,c**6*dot(A,dot(A,c))))*c)-1/10080.
    coneq[14815]=dot(b,dot(A,c*dot(A,c**7*dot(A,c)))*c)-1/3360.
    coneq[14816]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**4)))*c)-1/33600.
    coneq[14817]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))*c)-1/134400.
    coneq[14818]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))*c)-1/403200.
    coneq[14819]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/806400.
    coneq[14820]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))*c)-1/268800.
    coneq[14821]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))*c)-1/100800.
    coneq[14822]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))*c)-1/201600.
    coneq[14823]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))*c)-1/67200.
    coneq[14824]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))*c)-1/134400.
    coneq[14825]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))*c)-1/100800.
    coneq[14826]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))*c)-1/403200.
    coneq[14827]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))*c)-1/1209600.
    coneq[14828]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2419200.
    coneq[14829]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))*c)-1/806400.
    coneq[14830]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))*c)-1/302400.
    coneq[14831]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))*c)-1/604800.
    coneq[14832]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))*c)-1/201600.
    coneq[14833]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))*c)-1/403200.
    coneq[14834]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))*c)-1/201600.
    coneq[14835]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))*c)-1/806400.
    coneq[14836]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))*c)-1/2419200.
    coneq[14837]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/4838400.
    coneq[14838]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))*c)-1/1612800.
    coneq[14839]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))*c)-1/604800.
    coneq[14840]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*c)-1/1209600.
    coneq[14841]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))*c)-1/403200.
    coneq[14842]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*c)-1/806400.
    coneq[14843]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))*c)-1/67200.
    coneq[14844]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))*c)-1/268800.
    coneq[14845]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/806400.
    coneq[14846]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1612800.
    coneq[14847]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/537600.
    coneq[14848]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/201600.
    coneq[14849]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/403200.
    coneq[14850]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/134400.
    coneq[14851]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/268800.
    coneq[14852]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**5)))*c)-1/30240.
    coneq[14853]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))*c)-1/151200.
    coneq[14854]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))*c)-1/604800.
    coneq[14855]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1814400.
    coneq[14856]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3628800.
    coneq[14857]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1209600.
    coneq[14858]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/453600.
    coneq[14859]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/907200.
    coneq[14860]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/302400.
    coneq[14861]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/604800.
    coneq[14862]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))*c)-1/120960.
    coneq[14863]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/362880.
    coneq[14864]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/725760.
    coneq[14865]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/241920.
    coneq[14866]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))*c)-1/90720.
    coneq[14867]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/181440.
    coneq[14868]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))*c)-1/60480.
    coneq[14869]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/181440.
    coneq[14870]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/362880.
    coneq[14871]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/120960.
    coneq[14872]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**5)))*c)-1/60480.
    coneq[14873]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))*c)-1/302400.
    coneq[14874]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))*c)-1/1209600.
    coneq[14875]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/3628800.
    coneq[14876]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/7257600.
    coneq[14877]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/2419200.
    coneq[14878]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/907200.
    coneq[14879]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1814400.
    coneq[14880]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/604800.
    coneq[14881]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/1209600.
    coneq[14882]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))*c)-1/241920.
    coneq[14883]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/725760.
    coneq[14884]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[14885]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/483840.
    coneq[14886]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))*c)-1/181440.
    coneq[14887]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/362880.
    coneq[14888]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))*c)-1/120960.
    coneq[14889]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/362880.
    coneq[14890]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/725760.
    coneq[14891]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/241920.
    coneq[14892]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**6)))*c)-1/23520.
    coneq[14893]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**5))))*c)-1/141120.
    coneq[14894]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))*c)-1/705600.
    coneq[14895]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/2822400.
    coneq[14896]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/8467200.
    coneq[14897]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/16934400.
    coneq[14898]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/5644800.
    coneq[14899]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2116800.
    coneq[14900]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/4233600.
    coneq[14901]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1411200.
    coneq[14902]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/2822400.
    coneq[14903]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/564480.
    coneq[14904]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1693440.
    coneq[14905]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/3386880.
    coneq[14906]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1128960.
    coneq[14907]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/423360.
    coneq[14908]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/846720.
    coneq[14909]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/282240.
    coneq[14910]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/846720.
    coneq[14911]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1693440.
    coneq[14912]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/564480.
    coneq[14913]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))*c)-1/117600.
    coneq[14914]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/470400.
    coneq[14915]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/1411200.
    coneq[14916]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2822400.
    coneq[14917]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/940800.
    coneq[14918]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/352800.
    coneq[14919]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/705600.
    coneq[14920]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/235200.
    coneq[14921]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/470400.
    coneq[14922]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))*c)-1/94080.
    coneq[14923]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/282240.
    coneq[14924]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/564480.
    coneq[14925]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/188160.
    coneq[14926]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))*c)-1/70560.
    coneq[14927]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/141120.
    coneq[14928]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))*c)-1/47040.
    coneq[14929]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/211680.
    coneq[14930]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/423360.
    coneq[14931]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/846720.
    coneq[14932]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/188160.
    coneq[14933]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/564480.
    coneq[14934]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1128960.
    coneq[14935]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/376320.
    coneq[14936]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/141120.
    coneq[14937]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/282240.
    coneq[14938]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/94080.
    coneq[14939]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/188160.
    coneq[14940]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c**3)))*c)-1/26880.
    coneq[14941]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/80640.
    coneq[14942]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/161280.
    coneq[14943]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/53760.
    coneq[14944]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[14945]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[14946]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[14947]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/967680.
    coneq[14948]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/322560.
    coneq[14949]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/107520.
    coneq[14950]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**4)))*c)-1/25200.
    coneq[14951]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/100800.
    coneq[14952]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/302400.
    coneq[14953]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/604800.
    coneq[14954]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/201600.
    coneq[14955]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/75600.
    coneq[14956]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/151200.
    coneq[14957]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/50400.
    coneq[14958]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/100800.
    coneq[14959]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))*c)-1/50400.
    coneq[14960]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/201600.
    coneq[14961]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/604800.
    coneq[14962]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1209600.
    coneq[14963]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/403200.
    coneq[14964]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/151200.
    coneq[14965]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/302400.
    coneq[14966]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/100800.
    coneq[14967]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/201600.
    coneq[14968]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**5)))*c)-1/20160.
    coneq[14969]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))*c)-1/100800.
    coneq[14970]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/403200.
    coneq[14971]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1209600.
    coneq[14972]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2419200.
    coneq[14973]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/806400.
    coneq[14974]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/302400.
    coneq[14975]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/604800.
    coneq[14976]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/201600.
    coneq[14977]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/403200.
    coneq[14978]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/80640.
    coneq[14979]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/241920.
    coneq[14980]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/483840.
    coneq[14981]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/161280.
    coneq[14982]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/60480.
    coneq[14983]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[14984]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/40320.
    coneq[14985]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/120960.
    coneq[14986]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/241920.
    coneq[14987]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/80640.
    coneq[14988]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**3)))*c)-1/20160.
    coneq[14989]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/60480.
    coneq[14990]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/120960.
    coneq[14991]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/40320.
    coneq[14992]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/40320.
    coneq[14993]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[14994]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[14995]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[14996]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**4)))*c)-1/16800.
    coneq[14997]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/67200.
    coneq[14998]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/201600.
    coneq[14999]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/403200.
    coneq[15000]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/134400.
    coneq[15001]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/50400.
    coneq[15002]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/100800.
    coneq[15003]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/33600.
    coneq[15004]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/67200.
    coneq[15005]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,c**2)))*c)-1/15120.
    coneq[15006]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/30240.
    coneq[15007]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/60480.
    coneq[15008]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**3)))*c)-1/13440.
    coneq[15009]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/40320.
    coneq[15010]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/80640.
    coneq[15011]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/26880.
    coneq[15012]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c**2)))*c)-1/10080.
    coneq[15013]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))*c)-1/20160.
    coneq[15014]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)*dot(A,c)))*c)-1/6720.
    coneq[15015]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))*c)-1/33600.
    coneq[15016]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/134400.
    coneq[15017]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/403200.
    coneq[15018]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/806400.
    coneq[15019]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/268800.
    coneq[15020]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/100800.
    coneq[15021]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/201600.
    coneq[15022]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/67200.
    coneq[15023]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/134400.
    coneq[15024]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))*c)-1/40320.
    coneq[15025]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[15026]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[15027]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[15028]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/80640.
    coneq[15029]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[15030]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[15031]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[15032]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))*c)-1/45360.
    coneq[15033]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/90720.
    coneq[15034]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/181440.
    coneq[15035]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/362880.
    coneq[15036]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/26880.
    coneq[15037]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/80640.
    coneq[15038]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/161280.
    coneq[15039]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/53760.
    coneq[15040]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/30240.
    coneq[15041]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/60480.
    coneq[15042]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/120960.
    coneq[15043]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/20160.
    coneq[15044]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/40320.
    coneq[15045]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/13440.
    coneq[15046]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/40320.
    coneq[15047]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/80640.
    coneq[15048]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/26880.
    coneq[15049]=dot(b,dot(A,c**2*dot(A,c**8))*c)-1/1512.
    coneq[15050]=dot(b,dot(A,c**2*dot(A,dot(A,c**7)))*c)-1/12096.
    coneq[15051]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**6))))*c)-1/84672.
    coneq[15052]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**5)))))*c)-1/508032.
    coneq[15053]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/2540160.
    coneq[15054]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/10160640.
    coneq[15055]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/30481920.
    coneq[15056]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/60963840.
    coneq[15057]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/20321280.
    coneq[15058]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/7620480.
    coneq[15059]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/15240960.
    coneq[15060]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/5080320.
    coneq[15061]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/10160640.
    coneq[15062]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/2032128.
    coneq[15063]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/6096384.
    coneq[15064]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/12192768.
    coneq[15065]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/4064256.
    coneq[15066]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/1524096.
    coneq[15067]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/3048192.
    coneq[15068]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/1016064.
    coneq[15069]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/3048192.
    coneq[15070]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/6096384.
    coneq[15071]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/2032128.
    coneq[15072]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c)-1/423360.
    coneq[15073]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/1693440.
    coneq[15074]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/5080320.
    coneq[15075]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/10160640.
    coneq[15076]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/3386880.
    coneq[15077]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/1270080.
    coneq[15078]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/2540160.
    coneq[15079]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/846720.
    coneq[15080]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/1693440.
    coneq[15081]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/338688.
    coneq[15082]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/1016064.
    coneq[15083]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/2032128.
    coneq[15084]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/677376.
    coneq[15085]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/254016.
    coneq[15086]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/508032.
    coneq[15087]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c)-1/169344.
    coneq[15088]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/762048.
    coneq[15089]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/1524096.
    coneq[15090]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/3048192.
    coneq[15091]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/677376.
    coneq[15092]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/2032128.
    coneq[15093]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/4064256.
    coneq[15094]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/1354752.
    coneq[15095]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/508032.
    coneq[15096]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/1016064.
    coneq[15097]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/338688.
    coneq[15098]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/677376.
    coneq[15099]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**5))))*c)-1/72576.
    coneq[15100]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c)-1/362880.
    coneq[15101]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/1451520.
    coneq[15102]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/4354560.
    coneq[15103]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/8709120.
    coneq[15104]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2903040.
    coneq[15105]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1088640.
    coneq[15106]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/2177280.
    coneq[15107]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/725760.
    coneq[15108]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1451520.
    coneq[15109]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/290304.
    coneq[15110]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/870912.
    coneq[15111]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1741824.
    coneq[15112]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/580608.
    coneq[15113]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/217728.
    coneq[15114]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/435456.
    coneq[15115]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/145152.
    coneq[15116]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/435456.
    coneq[15117]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/870912.
    coneq[15118]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/290304.
    coneq[15119]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**4))))*c)-1/60480.
    coneq[15120]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/241920.
    coneq[15121]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/725760.
    coneq[15122]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1451520.
    coneq[15123]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/483840.
    coneq[15124]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/181440.
    coneq[15125]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/362880.
    coneq[15126]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/120960.
    coneq[15127]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/241920.
    coneq[15128]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**3))))*c)-1/48384.
    coneq[15129]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/145152.
    coneq[15130]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/290304.
    coneq[15131]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/96768.
    coneq[15132]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c**2))))*c)-1/36288.
    coneq[15133]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c)-1/72576.
    coneq[15134]=dot(b,dot(A,c**2*dot(A,dot(A,c**5*dot(A,c))))*c)-1/24192.
    coneq[15135]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/145152.
    coneq[15136]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/435456.
    coneq[15137]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/870912.
    coneq[15138]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/290304.
    coneq[15139]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/290304.
    coneq[15140]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/870912.
    coneq[15141]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/1741824.
    coneq[15142]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/580608.
    coneq[15143]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c)-1/120960.
    coneq[15144]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/483840.
    coneq[15145]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/1451520.
    coneq[15146]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2903040.
    coneq[15147]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/967680.
    coneq[15148]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/362880.
    coneq[15149]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/725760.
    coneq[15150]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/241920.
    coneq[15151]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/483840.
    coneq[15152]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/108864.
    coneq[15153]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/217728.
    coneq[15154]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/435456.
    coneq[15155]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/96768.
    coneq[15156]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/290304.
    coneq[15157]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/580608.
    coneq[15158]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/193536.
    coneq[15159]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/72576.
    coneq[15160]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/145152.
    coneq[15161]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/48384.
    coneq[15162]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/145152.
    coneq[15163]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/290304.
    coneq[15164]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/96768.
    coneq[15165]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**6)))*c)-1/10584.
    coneq[15166]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**5))))*c)-1/63504.
    coneq[15167]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c)-1/317520.
    coneq[15168]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1270080.
    coneq[15169]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/3810240.
    coneq[15170]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/7620480.
    coneq[15171]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2540160.
    coneq[15172]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/952560.
    coneq[15173]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1905120.
    coneq[15174]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/635040.
    coneq[15175]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1270080.
    coneq[15176]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/254016.
    coneq[15177]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/762048.
    coneq[15178]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1524096.
    coneq[15179]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/508032.
    coneq[15180]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/190512.
    coneq[15181]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/381024.
    coneq[15182]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/127008.
    coneq[15183]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/381024.
    coneq[15184]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/762048.
    coneq[15185]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/254016.
    coneq[15186]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**4))))*c)-1/52920.
    coneq[15187]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/211680.
    coneq[15188]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/635040.
    coneq[15189]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1270080.
    coneq[15190]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/423360.
    coneq[15191]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/158760.
    coneq[15192]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/317520.
    coneq[15193]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/105840.
    coneq[15194]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/211680.
    coneq[15195]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**3))))*c)-1/42336.
    coneq[15196]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/127008.
    coneq[15197]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/254016.
    coneq[15198]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/84672.
    coneq[15199]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c**2))))*c)-1/31752.
    coneq[15200]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/63504.
    coneq[15201]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4*dot(A,c))))*c)-1/21168.
    coneq[15202]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/95256.
    coneq[15203]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/190512.
    coneq[15204]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/381024.
    coneq[15205]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/84672.
    coneq[15206]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/254016.
    coneq[15207]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/508032.
    coneq[15208]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/169344.
    coneq[15209]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/63504.
    coneq[15210]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/127008.
    coneq[15211]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/42336.
    coneq[15212]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/84672.
    coneq[15213]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**5)))*c)-1/9072.
    coneq[15214]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**4))))*c)-1/45360.
    coneq[15215]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c)-1/181440.
    coneq[15216]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/544320.
    coneq[15217]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1088640.
    coneq[15218]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/362880.
    coneq[15219]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/136080.
    coneq[15220]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/272160.
    coneq[15221]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/90720.
    coneq[15222]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/181440.
    coneq[15223]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**3))))*c)-1/36288.
    coneq[15224]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/108864.
    coneq[15225]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/217728.
    coneq[15226]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/72576.
    coneq[15227]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c)-1/27216.
    coneq[15228]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/54432.
    coneq[15229]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3*dot(A,c))))*c)-1/18144.
    coneq[15230]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/54432.
    coneq[15231]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/108864.
    coneq[15232]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/36288.
    coneq[15233]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**4)))*c)-1/7560.
    coneq[15234]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**3))))*c)-1/30240.
    coneq[15235]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c)-1/90720.
    coneq[15236]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/181440.
    coneq[15237]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c)-1/60480.
    coneq[15238]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c**2))))*c)-1/22680.
    coneq[15239]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c)-1/45360.
    coneq[15240]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2*dot(A,c))))*c)-1/15120.
    coneq[15241]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c)-1/30240.
    coneq[15242]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**3)))*c)-1/6048.
    coneq[15243]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c**2))))*c)-1/18144.
    coneq[15244]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c)-1/36288.
    coneq[15245]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c*dot(A,c))))*c)-1/12096.
    coneq[15246]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c**2)))*c)-1/4536.
    coneq[15247]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,dot(A,c))))*c)-1/9072.
    coneq[15248]=dot(b,dot(A,c**2*dot(A,c**6*dot(A,c)))*c)-1/3024.
    coneq[15249]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c**3)))*c)-1/24192.
    coneq[15250]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/72576.
    coneq[15251]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/145152.
    coneq[15252]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/48384.
    coneq[15253]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/217728.
    coneq[15254]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/435456.
    coneq[15255]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/145152.
    coneq[15256]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/870912.
    coneq[15257]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/290304.
    coneq[15258]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/96768.
    coneq[15259]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**4)))*c)-1/22680.
    coneq[15260]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/90720.
    coneq[15261]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/272160.
    coneq[15262]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/544320.
    coneq[15263]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/181440.
    coneq[15264]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/68040.
    coneq[15265]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/136080.
    coneq[15266]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/45360.
    coneq[15267]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/90720.
    coneq[15268]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c)-1/45360.
    coneq[15269]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/181440.
    coneq[15270]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/544320.
    coneq[15271]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[15272]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/362880.
    coneq[15273]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/136080.
    coneq[15274]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/272160.
    coneq[15275]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/90720.
    coneq[15276]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/181440.
    coneq[15277]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**5)))*c)-1/18144.
    coneq[15278]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c)-1/90720.
    coneq[15279]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/362880.
    coneq[15280]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1088640.
    coneq[15281]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2177280.
    coneq[15282]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/725760.
    coneq[15283]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/272160.
    coneq[15284]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/544320.
    coneq[15285]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/181440.
    coneq[15286]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/362880.
    coneq[15287]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/72576.
    coneq[15288]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/217728.
    coneq[15289]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/435456.
    coneq[15290]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/145152.
    coneq[15291]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/54432.
    coneq[15292]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/108864.
    coneq[15293]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/36288.
    coneq[15294]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/108864.
    coneq[15295]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/217728.
    coneq[15296]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/72576.
    coneq[15297]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**3)))*c)-1/18144.
    coneq[15298]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/54432.
    coneq[15299]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/108864.
    coneq[15300]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/36288.
    coneq[15301]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/36288.
    coneq[15302]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/108864.
    coneq[15303]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/217728.
    coneq[15304]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/72576.
    coneq[15305]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**4)))*c)-1/15120.
    coneq[15306]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/60480.
    coneq[15307]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/181440.
    coneq[15308]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/362880.
    coneq[15309]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/120960.
    coneq[15310]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/45360.
    coneq[15311]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/90720.
    coneq[15312]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/30240.
    coneq[15313]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/60480.
    coneq[15314]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c)-1/13608.
    coneq[15315]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/27216.
    coneq[15316]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/54432.
    coneq[15317]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**3)))*c)-1/12096.
    coneq[15318]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/36288.
    coneq[15319]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/72576.
    coneq[15320]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/24192.
    coneq[15321]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c**2)))*c)-1/9072.
    coneq[15322]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c)-1/18144.
    coneq[15323]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)*dot(A,c)))*c)-1/6048.
    coneq[15324]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/24192.
    coneq[15325]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/72576.
    coneq[15326]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/145152.
    coneq[15327]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/48384.
    coneq[15328]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/27216.
    coneq[15329]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/54432.
    coneq[15330]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/108864.
    coneq[15331]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/18144.
    coneq[15332]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/36288.
    coneq[15333]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/12096.
    coneq[15334]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/24192.
    coneq[15335]=dot(b,dot(A,c**3*dot(A,c**7))*c)-1/1344.
    coneq[15336]=dot(b,dot(A,c**3*dot(A,dot(A,c**6)))*c)-1/9408.
    coneq[15337]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**5))))*c)-1/56448.
    coneq[15338]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/282240.
    coneq[15339]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/1128960.
    coneq[15340]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/3386880.
    coneq[15341]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/6773760.
    coneq[15342]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/2257920.
    coneq[15343]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/846720.
    coneq[15344]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/1693440.
    coneq[15345]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/564480.
    coneq[15346]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/1128960.
    coneq[15347]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/225792.
    coneq[15348]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/677376.
    coneq[15349]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/1354752.
    coneq[15350]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/451584.
    coneq[15351]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/169344.
    coneq[15352]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/338688.
    coneq[15353]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/112896.
    coneq[15354]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/338688.
    coneq[15355]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/677376.
    coneq[15356]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/225792.
    coneq[15357]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**4))))*c)-1/47040.
    coneq[15358]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/188160.
    coneq[15359]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/564480.
    coneq[15360]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1128960.
    coneq[15361]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/376320.
    coneq[15362]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/141120.
    coneq[15363]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/282240.
    coneq[15364]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/94080.
    coneq[15365]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/188160.
    coneq[15366]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/37632.
    coneq[15367]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/112896.
    coneq[15368]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/225792.
    coneq[15369]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/75264.
    coneq[15370]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/28224.
    coneq[15371]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/56448.
    coneq[15372]=dot(b,dot(A,c**3*dot(A,dot(A,c**4*dot(A,c))))*c)-1/18816.
    coneq[15373]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/84672.
    coneq[15374]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/169344.
    coneq[15375]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[15376]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/75264.
    coneq[15377]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/225792.
    coneq[15378]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/451584.
    coneq[15379]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/150528.
    coneq[15380]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/56448.
    coneq[15381]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/112896.
    coneq[15382]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/37632.
    coneq[15383]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/75264.
    coneq[15384]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**5)))*c)-1/8064.
    coneq[15385]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**4))))*c)-1/40320.
    coneq[15386]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/161280.
    coneq[15387]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/483840.
    coneq[15388]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/967680.
    coneq[15389]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/322560.
    coneq[15390]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/120960.
    coneq[15391]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/241920.
    coneq[15392]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/80640.
    coneq[15393]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/161280.
    coneq[15394]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/32256.
    coneq[15395]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/96768.
    coneq[15396]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/193536.
    coneq[15397]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/64512.
    coneq[15398]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/24192.
    coneq[15399]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/48384.
    coneq[15400]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/16128.
    coneq[15401]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/48384.
    coneq[15402]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/96768.
    coneq[15403]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/32256.
    coneq[15404]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**4)))*c)-1/6720.
    coneq[15405]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/26880.
    coneq[15406]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/80640.
    coneq[15407]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/161280.
    coneq[15408]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/53760.
    coneq[15409]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/20160.
    coneq[15410]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/40320.
    coneq[15411]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/13440.
    coneq[15412]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/26880.
    coneq[15413]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**3)))*c)-1/5376.
    coneq[15414]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/16128.
    coneq[15415]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/32256.
    coneq[15416]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/10752.
    coneq[15417]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c**2)))*c)-1/4032.
    coneq[15418]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,dot(A,c))))*c)-1/8064.
    coneq[15419]=dot(b,dot(A,c**3*dot(A,c**5*dot(A,c)))*c)-1/2688.
    coneq[15420]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/16128.
    coneq[15421]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/48384.
    coneq[15422]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/96768.
    coneq[15423]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/32256.
    coneq[15424]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/32256.
    coneq[15425]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/96768.
    coneq[15426]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/193536.
    coneq[15427]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/64512.
    coneq[15428]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/13440.
    coneq[15429]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/53760.
    coneq[15430]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/161280.
    coneq[15431]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/322560.
    coneq[15432]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/107520.
    coneq[15433]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/40320.
    coneq[15434]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/80640.
    coneq[15435]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/26880.
    coneq[15436]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/53760.
    coneq[15437]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/12096.
    coneq[15438]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/24192.
    coneq[15439]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/48384.
    coneq[15440]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/10752.
    coneq[15441]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/32256.
    coneq[15442]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/64512.
    coneq[15443]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/21504.
    coneq[15444]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/8064.
    coneq[15445]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/16128.
    coneq[15446]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/5376.
    coneq[15447]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/16128.
    coneq[15448]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/32256.
    coneq[15449]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/10752.
    coneq[15450]=dot(b,dot(A,c**4*dot(A,c**6))*c)-1/1176.
    coneq[15451]=dot(b,dot(A,c**4*dot(A,dot(A,c**5)))*c)-1/7056.
    coneq[15452]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**4))))*c)-1/35280.
    coneq[15453]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/141120.
    coneq[15454]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/423360.
    coneq[15455]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/846720.
    coneq[15456]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/282240.
    coneq[15457]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/105840.
    coneq[15458]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/211680.
    coneq[15459]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/70560.
    coneq[15460]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/141120.
    coneq[15461]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**3))))*c)-1/28224.
    coneq[15462]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/84672.
    coneq[15463]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/169344.
    coneq[15464]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/56448.
    coneq[15465]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/21168.
    coneq[15466]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/42336.
    coneq[15467]=dot(b,dot(A,c**4*dot(A,dot(A,c**3*dot(A,c))))*c)-1/14112.
    coneq[15468]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/42336.
    coneq[15469]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/84672.
    coneq[15470]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/28224.
    coneq[15471]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**4)))*c)-1/5880.
    coneq[15472]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**3))))*c)-1/23520.
    coneq[15473]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/70560.
    coneq[15474]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/141120.
    coneq[15475]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/47040.
    coneq[15476]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/17640.
    coneq[15477]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/35280.
    coneq[15478]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/11760.
    coneq[15479]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/23520.
    coneq[15480]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**3)))*c)-1/4704.
    coneq[15481]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/14112.
    coneq[15482]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/28224.
    coneq[15483]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/9408.
    coneq[15484]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c**2)))*c)-1/3528.
    coneq[15485]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,dot(A,c))))*c)-1/7056.
    coneq[15486]=dot(b,dot(A,c**4*dot(A,c**4*dot(A,c)))*c)-1/2352.
    coneq[15487]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/10584.
    coneq[15488]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/21168.
    coneq[15489]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/42336.
    coneq[15490]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/9408.
    coneq[15491]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/28224.
    coneq[15492]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/56448.
    coneq[15493]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/18816.
    coneq[15494]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/7056.
    coneq[15495]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/14112.
    coneq[15496]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/4704.
    coneq[15497]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/9408.
    coneq[15498]=dot(b,dot(A,c**5*dot(A,c**5))*c)-1/1008.
    coneq[15499]=dot(b,dot(A,c**5*dot(A,dot(A,c**4)))*c)-1/5040.
    coneq[15500]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**3))))*c)-1/20160.
    coneq[15501]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/60480.
    coneq[15502]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/120960.
    coneq[15503]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/40320.
    coneq[15504]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c**2))))*c)-1/15120.
    coneq[15505]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/30240.
    coneq[15506]=dot(b,dot(A,c**5*dot(A,dot(A,c**2*dot(A,c))))*c)-1/10080.
    coneq[15507]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/20160.
    coneq[15508]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**3)))*c)-1/4032.
    coneq[15509]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c**2))))*c)-1/12096.
    coneq[15510]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/24192.
    coneq[15511]=dot(b,dot(A,c**5*dot(A,c*dot(A,c*dot(A,c))))*c)-1/8064.
    coneq[15512]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c**2)))*c)-1/3024.
    coneq[15513]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,dot(A,c))))*c)-1/6048.
    coneq[15514]=dot(b,dot(A,c**5*dot(A,c**3*dot(A,c)))*c)-1/2016.
    coneq[15515]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/6048.
    coneq[15516]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/12096.
    coneq[15517]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/4032.
    coneq[15518]=dot(b,dot(A,c**6*dot(A,c**4))*c)-1/840.
    coneq[15519]=dot(b,dot(A,c**6*dot(A,dot(A,c**3)))*c)-1/3360.
    coneq[15520]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c**2))))*c)-1/10080.
    coneq[15521]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/20160.
    coneq[15522]=dot(b,dot(A,c**6*dot(A,dot(A,c*dot(A,c))))*c)-1/6720.
    coneq[15523]=dot(b,dot(A,c**6*dot(A,c*dot(A,c**2)))*c)-1/2520.
    coneq[15524]=dot(b,dot(A,c**6*dot(A,c*dot(A,dot(A,c))))*c)-1/5040.
    coneq[15525]=dot(b,dot(A,c**6*dot(A,c**2*dot(A,c)))*c)-1/1680.
    coneq[15526]=dot(b,dot(A,c**6*dot(A,dot(A,c)*dot(A,c)))*c)-1/3360.
    coneq[15527]=dot(b,dot(A,c**7*dot(A,c**3))*c)-1/672.
    coneq[15528]=dot(b,dot(A,c**7*dot(A,dot(A,c**2)))*c)-1/2016.
    coneq[15529]=dot(b,dot(A,c**7*dot(A,dot(A,dot(A,c))))*c)-1/4032.
    coneq[15530]=dot(b,dot(A,c**7*dot(A,c*dot(A,c)))*c)-1/1344.
    coneq[15531]=dot(b,dot(A,c**8*dot(A,c**2))*c)-1/504.
    coneq[15532]=dot(b,dot(A,c**8*dot(A,dot(A,c)))*c)-1/1008.
    coneq[15533]=dot(b,dot(A,c**9*dot(A,c))*c)-1/336.
    coneq[15534]=dot(b,dot(A,dot(A,c**4)*dot(A,c**5))*c)-1/5040.
    coneq[15535]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**4)))*c)-1/25200.
    coneq[15536]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**3))))*c)-1/100800.
    coneq[15537]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/302400.
    coneq[15538]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/604800.
    coneq[15539]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/201600.
    coneq[15540]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/75600.
    coneq[15541]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/151200.
    coneq[15542]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/50400.
    coneq[15543]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/100800.
    coneq[15544]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**3)))*c)-1/20160.
    coneq[15545]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/60480.
    coneq[15546]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/120960.
    coneq[15547]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/40320.
    coneq[15548]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c**2)))*c)-1/15120.
    coneq[15549]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/30240.
    coneq[15550]=dot(b,dot(A,dot(A,c**4)*dot(A,c**3*dot(A,c)))*c)-1/10080.
    coneq[15551]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/30240.
    coneq[15552]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/60480.
    coneq[15553]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/20160.
    coneq[15554]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**5))*c)-1/20160.
    coneq[15555]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**4)))*c)-1/100800.
    coneq[15556]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**3))))*c)-1/403200.
    coneq[15557]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/1209600.
    coneq[15558]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2419200.
    coneq[15559]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/806400.
    coneq[15560]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/302400.
    coneq[15561]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/604800.
    coneq[15562]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/201600.
    coneq[15563]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/403200.
    coneq[15564]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**3)))*c)-1/80640.
    coneq[15565]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[15566]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[15567]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[15568]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c**2)))*c)-1/60480.
    coneq[15569]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/120960.
    coneq[15570]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**3*dot(A,c)))*c)-1/40320.
    coneq[15571]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/120960.
    coneq[15572]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/241920.
    coneq[15573]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/80640.
    coneq[15574]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**5))*c)-1/60480.
    coneq[15575]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**4)))*c)-1/302400.
    coneq[15576]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))*c)-1/1209600.
    coneq[15577]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/3628800.
    coneq[15578]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/7257600.
    coneq[15579]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/2419200.
    coneq[15580]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/907200.
    coneq[15581]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/1814400.
    coneq[15582]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/604800.
    coneq[15583]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/1209600.
    coneq[15584]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3)))*c)-1/241920.
    coneq[15585]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/725760.
    coneq[15586]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/1451520.
    coneq[15587]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/483840.
    coneq[15588]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))*c)-1/181440.
    coneq[15589]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/362880.
    coneq[15590]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c)))*c)-1/120960.
    coneq[15591]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/362880.
    coneq[15592]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/725760.
    coneq[15593]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/241920.
    coneq[15594]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**5))*c)-1/120960.
    coneq[15595]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4)))*c)-1/604800.
    coneq[15596]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))*c)-1/2419200.
    coneq[15597]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/7257600.
    coneq[15598]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/14515200.
    coneq[15599]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/4838400.
    coneq[15600]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/1814400.
    coneq[15601]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/3628800.
    coneq[15602]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/1209600.
    coneq[15603]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/2419200.
    coneq[15604]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))*c)-1/483840.
    coneq[15605]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/1451520.
    coneq[15606]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/2903040.
    coneq[15607]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/967680.
    coneq[15608]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))*c)-1/362880.
    coneq[15609]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/725760.
    coneq[15610]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))*c)-1/241920.
    coneq[15611]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/725760.
    coneq[15612]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/1451520.
    coneq[15613]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/483840.
    coneq[15614]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**5))*c)-1/40320.
    coneq[15615]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**4)))*c)-1/201600.
    coneq[15616]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))*c)-1/806400.
    coneq[15617]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/2419200.
    coneq[15618]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/4838400.
    coneq[15619]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/1612800.
    coneq[15620]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/604800.
    coneq[15621]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/1209600.
    coneq[15622]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/403200.
    coneq[15623]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/806400.
    coneq[15624]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3)))*c)-1/161280.
    coneq[15625]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/483840.
    coneq[15626]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/967680.
    coneq[15627]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/322560.
    coneq[15628]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2)))*c)-1/120960.
    coneq[15629]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/241920.
    coneq[15630]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c)))*c)-1/80640.
    coneq[15631]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/241920.
    coneq[15632]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/483840.
    coneq[15633]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/161280.
    coneq[15634]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**5))*c)-1/15120.
    coneq[15635]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**4)))*c)-1/75600.
    coneq[15636]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))*c)-1/302400.
    coneq[15637]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/907200.
    coneq[15638]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1814400.
    coneq[15639]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/604800.
    coneq[15640]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/226800.
    coneq[15641]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/453600.
    coneq[15642]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/151200.
    coneq[15643]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/302400.
    coneq[15644]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**3)))*c)-1/60480.
    coneq[15645]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/181440.
    coneq[15646]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/362880.
    coneq[15647]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/120960.
    coneq[15648]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))*c)-1/45360.
    coneq[15649]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/90720.
    coneq[15650]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**3*dot(A,c)))*c)-1/30240.
    coneq[15651]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/90720.
    coneq[15652]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/181440.
    coneq[15653]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/60480.
    coneq[15654]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**5))*c)-1/30240.
    coneq[15655]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))*c)-1/151200.
    coneq[15656]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))*c)-1/604800.
    coneq[15657]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/1814400.
    coneq[15658]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/3628800.
    coneq[15659]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/1209600.
    coneq[15660]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/453600.
    coneq[15661]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/907200.
    coneq[15662]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/302400.
    coneq[15663]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/604800.
    coneq[15664]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))*c)-1/120960.
    coneq[15665]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/362880.
    coneq[15666]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/725760.
    coneq[15667]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/241920.
    coneq[15668]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))*c)-1/90720.
    coneq[15669]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/181440.
    coneq[15670]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))*c)-1/60480.
    coneq[15671]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/181440.
    coneq[15672]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/362880.
    coneq[15673]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/120960.
    coneq[15674]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**5))*c)-1/10080.
    coneq[15675]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**4)))*c)-1/50400.
    coneq[15676]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/201600.
    coneq[15677]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/604800.
    coneq[15678]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1209600.
    coneq[15679]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/403200.
    coneq[15680]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/151200.
    coneq[15681]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/302400.
    coneq[15682]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/100800.
    coneq[15683]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/201600.
    coneq[15684]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/40320.
    coneq[15685]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[15686]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[15687]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[15688]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/30240.
    coneq[15689]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/60480.
    coneq[15690]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/20160.
    coneq[15691]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/60480.
    coneq[15692]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/120960.
    coneq[15693]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/40320.
    coneq[15694]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**5))*c)-1/20160.
    coneq[15695]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**4)))*c)-1/100800.
    coneq[15696]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/403200.
    coneq[15697]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/1209600.
    coneq[15698]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2419200.
    coneq[15699]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/806400.
    coneq[15700]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/302400.
    coneq[15701]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/604800.
    coneq[15702]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/201600.
    coneq[15703]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/403200.
    coneq[15704]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/80640.
    coneq[15705]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[15706]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[15707]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[15708]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/60480.
    coneq[15709]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/120960.
    coneq[15710]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/40320.
    coneq[15711]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/120960.
    coneq[15712]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/241920.
    coneq[15713]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/80640.
    coneq[15714]=dot(b,dot(A,dot(A,c**3)*dot(A,c**6))*c)-1/4704.
    coneq[15715]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**5)))*c)-1/28224.
    coneq[15716]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**4))))*c)-1/141120.
    coneq[15717]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/564480.
    coneq[15718]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1693440.
    coneq[15719]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3386880.
    coneq[15720]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1128960.
    coneq[15721]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/423360.
    coneq[15722]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/846720.
    coneq[15723]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/282240.
    coneq[15724]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/564480.
    coneq[15725]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/112896.
    coneq[15726]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/338688.
    coneq[15727]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/677376.
    coneq[15728]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/225792.
    coneq[15729]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/84672.
    coneq[15730]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/169344.
    coneq[15731]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/56448.
    coneq[15732]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/169344.
    coneq[15733]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[15734]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/112896.
    coneq[15735]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**4)))*c)-1/23520.
    coneq[15736]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/94080.
    coneq[15737]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/282240.
    coneq[15738]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/564480.
    coneq[15739]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/188160.
    coneq[15740]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/70560.
    coneq[15741]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/141120.
    coneq[15742]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/47040.
    coneq[15743]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/94080.
    coneq[15744]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**3)))*c)-1/18816.
    coneq[15745]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/56448.
    coneq[15746]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/112896.
    coneq[15747]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/37632.
    coneq[15748]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c**2)))*c)-1/14112.
    coneq[15749]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/28224.
    coneq[15750]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4*dot(A,c)))*c)-1/9408.
    coneq[15751]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/42336.
    coneq[15752]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/84672.
    coneq[15753]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/169344.
    coneq[15754]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/37632.
    coneq[15755]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/112896.
    coneq[15756]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/225792.
    coneq[15757]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/75264.
    coneq[15758]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/28224.
    coneq[15759]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/56448.
    coneq[15760]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/18816.
    coneq[15761]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/37632.
    coneq[15762]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**6))*c)-1/14112.
    coneq[15763]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**5)))*c)-1/84672.
    coneq[15764]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**4))))*c)-1/423360.
    coneq[15765]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/1693440.
    coneq[15766]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/5080320.
    coneq[15767]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/10160640.
    coneq[15768]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/3386880.
    coneq[15769]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/1270080.
    coneq[15770]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/2540160.
    coneq[15771]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/846720.
    coneq[15772]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/1693440.
    coneq[15773]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**3))))*c)-1/338688.
    coneq[15774]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/1016064.
    coneq[15775]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/2032128.
    coneq[15776]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/677376.
    coneq[15777]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/254016.
    coneq[15778]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/508032.
    coneq[15779]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3*dot(A,c))))*c)-1/169344.
    coneq[15780]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/508032.
    coneq[15781]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/1016064.
    coneq[15782]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/338688.
    coneq[15783]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**4)))*c)-1/70560.
    coneq[15784]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**3))))*c)-1/282240.
    coneq[15785]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/846720.
    coneq[15786]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1693440.
    coneq[15787]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/564480.
    coneq[15788]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/211680.
    coneq[15789]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/423360.
    coneq[15790]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/141120.
    coneq[15791]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/282240.
    coneq[15792]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**3)))*c)-1/56448.
    coneq[15793]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/169344.
    coneq[15794]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/338688.
    coneq[15795]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/112896.
    coneq[15796]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c**2)))*c)-1/42336.
    coneq[15797]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,dot(A,c))))*c)-1/84672.
    coneq[15798]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4*dot(A,c)))*c)-1/28224.
    coneq[15799]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/127008.
    coneq[15800]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/254016.
    coneq[15801]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/508032.
    coneq[15802]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/112896.
    coneq[15803]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/338688.
    coneq[15804]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/677376.
    coneq[15805]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/225792.
    coneq[15806]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/84672.
    coneq[15807]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/169344.
    coneq[15808]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/56448.
    coneq[15809]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/112896.
    coneq[15810]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**6))*c)-1/28224.
    coneq[15811]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**5)))*c)-1/169344.
    coneq[15812]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**4))))*c)-1/846720.
    coneq[15813]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/3386880.
    coneq[15814]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/10160640.
    coneq[15815]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/20321280.
    coneq[15816]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/6773760.
    coneq[15817]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/2540160.
    coneq[15818]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/5080320.
    coneq[15819]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/1693440.
    coneq[15820]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/3386880.
    coneq[15821]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**3))))*c)-1/677376.
    coneq[15822]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/2032128.
    coneq[15823]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/4064256.
    coneq[15824]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/1354752.
    coneq[15825]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/508032.
    coneq[15826]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/1016064.
    coneq[15827]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3*dot(A,c))))*c)-1/338688.
    coneq[15828]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/1016064.
    coneq[15829]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/2032128.
    coneq[15830]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/677376.
    coneq[15831]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**4)))*c)-1/141120.
    coneq[15832]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**3))))*c)-1/564480.
    coneq[15833]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/1693440.
    coneq[15834]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/3386880.
    coneq[15835]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/1128960.
    coneq[15836]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/423360.
    coneq[15837]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/846720.
    coneq[15838]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/282240.
    coneq[15839]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/564480.
    coneq[15840]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**3)))*c)-1/112896.
    coneq[15841]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/338688.
    coneq[15842]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/677376.
    coneq[15843]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/225792.
    coneq[15844]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c**2)))*c)-1/84672.
    coneq[15845]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,dot(A,c))))*c)-1/169344.
    coneq[15846]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4*dot(A,c)))*c)-1/56448.
    coneq[15847]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/254016.
    coneq[15848]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/508032.
    coneq[15849]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/1016064.
    coneq[15850]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/225792.
    coneq[15851]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/677376.
    coneq[15852]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/1354752.
    coneq[15853]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/451584.
    coneq[15854]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/169344.
    coneq[15855]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/338688.
    coneq[15856]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/112896.
    coneq[15857]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/225792.
    coneq[15858]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**6))*c)-1/9408.
    coneq[15859]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**5)))*c)-1/56448.
    coneq[15860]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**4))))*c)-1/282240.
    coneq[15861]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/1128960.
    coneq[15862]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/3386880.
    coneq[15863]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/6773760.
    coneq[15864]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/2257920.
    coneq[15865]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/846720.
    coneq[15866]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1693440.
    coneq[15867]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/564480.
    coneq[15868]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/1128960.
    coneq[15869]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))*c)-1/225792.
    coneq[15870]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/677376.
    coneq[15871]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1354752.
    coneq[15872]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/451584.
    coneq[15873]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/169344.
    coneq[15874]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[15875]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))*c)-1/112896.
    coneq[15876]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/338688.
    coneq[15877]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/677376.
    coneq[15878]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/225792.
    coneq[15879]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**4)))*c)-1/47040.
    coneq[15880]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))*c)-1/188160.
    coneq[15881]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/564480.
    coneq[15882]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1128960.
    coneq[15883]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/376320.
    coneq[15884]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/141120.
    coneq[15885]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/282240.
    coneq[15886]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/94080.
    coneq[15887]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/188160.
    coneq[15888]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**3)))*c)-1/37632.
    coneq[15889]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/112896.
    coneq[15890]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/225792.
    coneq[15891]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/75264.
    coneq[15892]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c**2)))*c)-1/28224.
    coneq[15893]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))*c)-1/56448.
    coneq[15894]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4*dot(A,c)))*c)-1/18816.
    coneq[15895]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/84672.
    coneq[15896]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/169344.
    coneq[15897]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/338688.
    coneq[15898]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/75264.
    coneq[15899]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/225792.
    coneq[15900]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/451584.
    coneq[15901]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/150528.
    coneq[15902]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/56448.
    coneq[15903]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/112896.
    coneq[15904]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/37632.
    coneq[15905]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/75264.
    coneq[15906]=dot(b,dot(A,dot(A,c**2)*dot(A,c**7))*c)-1/4032.
    coneq[15907]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**6)))*c)-1/28224.
    coneq[15908]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**5))))*c)-1/169344.
    coneq[15909]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/846720.
    coneq[15910]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/3386880.
    coneq[15911]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/10160640.
    coneq[15912]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/20321280.
    coneq[15913]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/6773760.
    coneq[15914]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2540160.
    coneq[15915]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/5080320.
    coneq[15916]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1693440.
    coneq[15917]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/3386880.
    coneq[15918]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/677376.
    coneq[15919]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/2032128.
    coneq[15920]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/4064256.
    coneq[15921]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1354752.
    coneq[15922]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/508032.
    coneq[15923]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/1016064.
    coneq[15924]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/338688.
    coneq[15925]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/1016064.
    coneq[15926]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/2032128.
    coneq[15927]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/677376.
    coneq[15928]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**4))))*c)-1/141120.
    coneq[15929]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/564480.
    coneq[15930]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/1693440.
    coneq[15931]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3386880.
    coneq[15932]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/1128960.
    coneq[15933]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/423360.
    coneq[15934]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/846720.
    coneq[15935]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/282240.
    coneq[15936]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/564480.
    coneq[15937]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/112896.
    coneq[15938]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/338688.
    coneq[15939]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/677376.
    coneq[15940]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/225792.
    coneq[15941]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/84672.
    coneq[15942]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/169344.
    coneq[15943]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4*dot(A,c))))*c)-1/56448.
    coneq[15944]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/254016.
    coneq[15945]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/508032.
    coneq[15946]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/1016064.
    coneq[15947]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/225792.
    coneq[15948]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/677376.
    coneq[15949]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1354752.
    coneq[15950]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/451584.
    coneq[15951]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/169344.
    coneq[15952]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[15953]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/112896.
    coneq[15954]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/225792.
    coneq[15955]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**5)))*c)-1/24192.
    coneq[15956]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**4))))*c)-1/120960.
    coneq[15957]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/483840.
    coneq[15958]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1451520.
    coneq[15959]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2903040.
    coneq[15960]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/967680.
    coneq[15961]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/362880.
    coneq[15962]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/725760.
    coneq[15963]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/241920.
    coneq[15964]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/483840.
    coneq[15965]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/96768.
    coneq[15966]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/290304.
    coneq[15967]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/580608.
    coneq[15968]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/193536.
    coneq[15969]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/72576.
    coneq[15970]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/145152.
    coneq[15971]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/48384.
    coneq[15972]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/145152.
    coneq[15973]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/290304.
    coneq[15974]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/96768.
    coneq[15975]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**4)))*c)-1/20160.
    coneq[15976]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/80640.
    coneq[15977]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/241920.
    coneq[15978]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/483840.
    coneq[15979]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/161280.
    coneq[15980]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/60480.
    coneq[15981]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[15982]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/40320.
    coneq[15983]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/80640.
    coneq[15984]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**3)))*c)-1/16128.
    coneq[15985]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/48384.
    coneq[15986]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/96768.
    coneq[15987]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/32256.
    coneq[15988]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c**2)))*c)-1/12096.
    coneq[15989]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,dot(A,c))))*c)-1/24192.
    coneq[15990]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5*dot(A,c)))*c)-1/8064.
    coneq[15991]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/48384.
    coneq[15992]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/145152.
    coneq[15993]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/290304.
    coneq[15994]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/96768.
    coneq[15995]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/96768.
    coneq[15996]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/290304.
    coneq[15997]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/580608.
    coneq[15998]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/193536.
    coneq[15999]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/40320.
    coneq[16000]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/161280.
    coneq[16001]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/483840.
    coneq[16002]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/967680.
    coneq[16003]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/322560.
    coneq[16004]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/120960.
    coneq[16005]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/241920.
    coneq[16006]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/80640.
    coneq[16007]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/161280.
    coneq[16008]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/36288.
    coneq[16009]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/72576.
    coneq[16010]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/145152.
    coneq[16011]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/32256.
    coneq[16012]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/96768.
    coneq[16013]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/193536.
    coneq[16014]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/64512.
    coneq[16015]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/24192.
    coneq[16016]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/48384.
    coneq[16017]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/16128.
    coneq[16018]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/48384.
    coneq[16019]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/96768.
    coneq[16020]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/32256.
    coneq[16021]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**7))*c)-1/8064.
    coneq[16022]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**6)))*c)-1/56448.
    coneq[16023]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**5))))*c)-1/338688.
    coneq[16024]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/1693440.
    coneq[16025]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/6773760.
    coneq[16026]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/20321280.
    coneq[16027]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/40642560.
    coneq[16028]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/13547520.
    coneq[16029]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/5080320.
    coneq[16030]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/10160640.
    coneq[16031]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/3386880.
    coneq[16032]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/6773760.
    coneq[16033]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/1354752.
    coneq[16034]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/4064256.
    coneq[16035]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/8128512.
    coneq[16036]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/2709504.
    coneq[16037]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/1016064.
    coneq[16038]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/2032128.
    coneq[16039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/677376.
    coneq[16040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/2032128.
    coneq[16041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/4064256.
    coneq[16042]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/1354752.
    coneq[16043]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**4))))*c)-1/282240.
    coneq[16044]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/1128960.
    coneq[16045]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/3386880.
    coneq[16046]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/6773760.
    coneq[16047]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/2257920.
    coneq[16048]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/846720.
    coneq[16049]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/1693440.
    coneq[16050]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/564480.
    coneq[16051]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/1128960.
    coneq[16052]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/225792.
    coneq[16053]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/677376.
    coneq[16054]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/1354752.
    coneq[16055]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/451584.
    coneq[16056]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/169344.
    coneq[16057]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[16058]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4*dot(A,c))))*c)-1/112896.
    coneq[16059]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/508032.
    coneq[16060]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/1016064.
    coneq[16061]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/2032128.
    coneq[16062]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/451584.
    coneq[16063]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/1354752.
    coneq[16064]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/2709504.
    coneq[16065]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/903168.
    coneq[16066]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/338688.
    coneq[16067]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/677376.
    coneq[16068]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/225792.
    coneq[16069]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/451584.
    coneq[16070]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**5)))*c)-1/48384.
    coneq[16071]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**4))))*c)-1/241920.
    coneq[16072]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/967680.
    coneq[16073]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/2903040.
    coneq[16074]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5806080.
    coneq[16075]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1935360.
    coneq[16076]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/725760.
    coneq[16077]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[16078]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/483840.
    coneq[16079]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/967680.
    coneq[16080]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/193536.
    coneq[16081]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/580608.
    coneq[16082]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1161216.
    coneq[16083]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/387072.
    coneq[16084]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/145152.
    coneq[16085]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/290304.
    coneq[16086]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/96768.
    coneq[16087]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/290304.
    coneq[16088]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/580608.
    coneq[16089]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/193536.
    coneq[16090]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**4)))*c)-1/40320.
    coneq[16091]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/161280.
    coneq[16092]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/483840.
    coneq[16093]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/967680.
    coneq[16094]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/322560.
    coneq[16095]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/120960.
    coneq[16096]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/241920.
    coneq[16097]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/80640.
    coneq[16098]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/161280.
    coneq[16099]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**3)))*c)-1/32256.
    coneq[16100]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/96768.
    coneq[16101]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/193536.
    coneq[16102]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/64512.
    coneq[16103]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c**2)))*c)-1/24192.
    coneq[16104]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,dot(A,c))))*c)-1/48384.
    coneq[16105]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5*dot(A,c)))*c)-1/16128.
    coneq[16106]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/96768.
    coneq[16107]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/290304.
    coneq[16108]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/580608.
    coneq[16109]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/193536.
    coneq[16110]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/193536.
    coneq[16111]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/580608.
    coneq[16112]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/1161216.
    coneq[16113]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/387072.
    coneq[16114]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/80640.
    coneq[16115]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/322560.
    coneq[16116]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/967680.
    coneq[16117]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1935360.
    coneq[16118]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/645120.
    coneq[16119]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/241920.
    coneq[16120]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/483840.
    coneq[16121]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/161280.
    coneq[16122]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/322560.
    coneq[16123]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/72576.
    coneq[16124]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/145152.
    coneq[16125]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/290304.
    coneq[16126]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/64512.
    coneq[16127]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/193536.
    coneq[16128]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/387072.
    coneq[16129]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/129024.
    coneq[16130]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/48384.
    coneq[16131]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/96768.
    coneq[16132]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/32256.
    coneq[16133]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/96768.
    coneq[16134]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/193536.
    coneq[16135]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/64512.
    coneq[16136]=dot(b,dot(A,dot(A,c)*dot(A,c**8))*c)-1/3024.
    coneq[16137]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**7)))*c)-1/24192.
    coneq[16138]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**6))))*c)-1/169344.
    coneq[16139]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**5)))))*c)-1/1016064.
    coneq[16140]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c)-1/5080320.
    coneq[16141]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c)-1/20321280.
    coneq[16142]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c)-1/60963840.
    coneq[16143]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c)-1/121927680.
    coneq[16144]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c)-1/40642560.
    coneq[16145]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c)-1/15240960.
    coneq[16146]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c)-1/30481920.
    coneq[16147]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c)-1/10160640.
    coneq[16148]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c)-1/20321280.
    coneq[16149]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c)-1/4064256.
    coneq[16150]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c)-1/12192768.
    coneq[16151]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c)-1/24385536.
    coneq[16152]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c)-1/8128512.
    coneq[16153]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c)-1/3048192.
    coneq[16154]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c)-1/6096384.
    coneq[16155]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c)-1/2032128.
    coneq[16156]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c)-1/6096384.
    coneq[16157]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c)-1/12192768.
    coneq[16158]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c)-1/4064256.
    coneq[16159]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c)-1/846720.
    coneq[16160]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c)-1/3386880.
    coneq[16161]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c)-1/10160640.
    coneq[16162]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/20321280.
    coneq[16163]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c)-1/6773760.
    coneq[16164]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c)-1/2540160.
    coneq[16165]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c)-1/5080320.
    coneq[16166]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c)-1/1693440.
    coneq[16167]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c)-1/3386880.
    coneq[16168]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c)-1/677376.
    coneq[16169]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c)-1/2032128.
    coneq[16170]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c)-1/4064256.
    coneq[16171]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c)-1/1354752.
    coneq[16172]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c)-1/508032.
    coneq[16173]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c)-1/1016064.
    coneq[16174]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c)-1/338688.
    coneq[16175]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c)-1/1524096.
    coneq[16176]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c)-1/3048192.
    coneq[16177]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c)-1/6096384.
    coneq[16178]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c)-1/1354752.
    coneq[16179]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c)-1/4064256.
    coneq[16180]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c)-1/8128512.
    coneq[16181]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c)-1/2709504.
    coneq[16182]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c)-1/1016064.
    coneq[16183]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c)-1/2032128.
    coneq[16184]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c)-1/677376.
    coneq[16185]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c)-1/1354752.
    coneq[16186]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**5))))*c)-1/145152.
    coneq[16187]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c)-1/725760.
    coneq[16188]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c)-1/2903040.
    coneq[16189]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/8709120.
    coneq[16190]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/17418240.
    coneq[16191]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/5806080.
    coneq[16192]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c)-1/2177280.
    coneq[16193]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/4354560.
    coneq[16194]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1451520.
    coneq[16195]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/2903040.
    coneq[16196]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c)-1/580608.
    coneq[16197]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1741824.
    coneq[16198]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/3483648.
    coneq[16199]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1161216.
    coneq[16200]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c)-1/435456.
    coneq[16201]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c)-1/870912.
    coneq[16202]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c)-1/290304.
    coneq[16203]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/870912.
    coneq[16204]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1741824.
    coneq[16205]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/580608.
    coneq[16206]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**4))))*c)-1/120960.
    coneq[16207]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c)-1/483840.
    coneq[16208]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c)-1/1451520.
    coneq[16209]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2903040.
    coneq[16210]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c)-1/967680.
    coneq[16211]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c)-1/362880.
    coneq[16212]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c)-1/725760.
    coneq[16213]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c)-1/241920.
    coneq[16214]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c)-1/483840.
    coneq[16215]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**3))))*c)-1/96768.
    coneq[16216]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c)-1/290304.
    coneq[16217]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c)-1/580608.
    coneq[16218]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c)-1/193536.
    coneq[16219]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c**2))))*c)-1/72576.
    coneq[16220]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c)-1/145152.
    coneq[16221]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5*dot(A,c))))*c)-1/48384.
    coneq[16222]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c)-1/290304.
    coneq[16223]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c)-1/870912.
    coneq[16224]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c)-1/1741824.
    coneq[16225]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c)-1/580608.
    coneq[16226]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c)-1/580608.
    coneq[16227]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c)-1/1741824.
    coneq[16228]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c)-1/3483648.
    coneq[16229]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c)-1/1161216.
    coneq[16230]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c)-1/241920.
    coneq[16231]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c)-1/967680.
    coneq[16232]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c)-1/2903040.
    coneq[16233]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5806080.
    coneq[16234]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c)-1/1935360.
    coneq[16235]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c)-1/725760.
    coneq[16236]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[16237]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c)-1/483840.
    coneq[16238]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c)-1/967680.
    coneq[16239]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c)-1/217728.
    coneq[16240]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/435456.
    coneq[16241]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/870912.
    coneq[16242]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c)-1/193536.
    coneq[16243]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/580608.
    coneq[16244]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1161216.
    coneq[16245]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/387072.
    coneq[16246]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c)-1/145152.
    coneq[16247]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c)-1/290304.
    coneq[16248]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c)-1/96768.
    coneq[16249]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c)-1/290304.
    coneq[16250]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c)-1/580608.
    coneq[16251]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/193536.
    coneq[16252]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**6)))*c)-1/21168.
    coneq[16253]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**5))))*c)-1/127008.
    coneq[16254]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c)-1/635040.
    coneq[16255]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/2540160.
    coneq[16256]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/7620480.
    coneq[16257]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/15240960.
    coneq[16258]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/5080320.
    coneq[16259]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1905120.
    coneq[16260]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/3810240.
    coneq[16261]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1270080.
    coneq[16262]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/2540160.
    coneq[16263]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c)-1/508032.
    coneq[16264]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1524096.
    coneq[16265]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/3048192.
    coneq[16266]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/1016064.
    coneq[16267]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/381024.
    coneq[16268]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/762048.
    coneq[16269]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c)-1/254016.
    coneq[16270]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/762048.
    coneq[16271]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1524096.
    coneq[16272]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/508032.
    coneq[16273]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**4))))*c)-1/105840.
    coneq[16274]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c)-1/423360.
    coneq[16275]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/1270080.
    coneq[16276]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2540160.
    coneq[16277]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/846720.
    coneq[16278]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/317520.
    coneq[16279]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/635040.
    coneq[16280]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/211680.
    coneq[16281]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/423360.
    coneq[16282]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**3))))*c)-1/84672.
    coneq[16283]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/254016.
    coneq[16284]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/508032.
    coneq[16285]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/169344.
    coneq[16286]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c**2))))*c)-1/63504.
    coneq[16287]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c)-1/127008.
    coneq[16288]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4*dot(A,c))))*c)-1/42336.
    coneq[16289]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/190512.
    coneq[16290]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/381024.
    coneq[16291]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/762048.
    coneq[16292]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c)-1/169344.
    coneq[16293]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/508032.
    coneq[16294]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/1016064.
    coneq[16295]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/338688.
    coneq[16296]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/127008.
    coneq[16297]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/254016.
    coneq[16298]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/84672.
    coneq[16299]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/169344.
    coneq[16300]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**5)))*c)-1/18144.
    coneq[16301]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**4))))*c)-1/90720.
    coneq[16302]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c)-1/362880.
    coneq[16303]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1088640.
    coneq[16304]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2177280.
    coneq[16305]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/725760.
    coneq[16306]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/272160.
    coneq[16307]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/544320.
    coneq[16308]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/181440.
    coneq[16309]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/362880.
    coneq[16310]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**3))))*c)-1/72576.
    coneq[16311]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/217728.
    coneq[16312]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/435456.
    coneq[16313]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/145152.
    coneq[16314]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c)-1/54432.
    coneq[16315]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/108864.
    coneq[16316]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3*dot(A,c))))*c)-1/36288.
    coneq[16317]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/108864.
    coneq[16318]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/217728.
    coneq[16319]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/72576.
    coneq[16320]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**4)))*c)-1/15120.
    coneq[16321]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**3))))*c)-1/60480.
    coneq[16322]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c)-1/181440.
    coneq[16323]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/362880.
    coneq[16324]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c)-1/120960.
    coneq[16325]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c**2))))*c)-1/45360.
    coneq[16326]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c)-1/90720.
    coneq[16327]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2*dot(A,c))))*c)-1/30240.
    coneq[16328]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c)-1/60480.
    coneq[16329]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**3)))*c)-1/12096.
    coneq[16330]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c**2))))*c)-1/36288.
    coneq[16331]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c)-1/72576.
    coneq[16332]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c*dot(A,c))))*c)-1/24192.
    coneq[16333]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c**2)))*c)-1/9072.
    coneq[16334]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,dot(A,c))))*c)-1/18144.
    coneq[16335]=dot(b,dot(A,dot(A,c)*dot(A,c**6*dot(A,c)))*c)-1/6048.
    coneq[16336]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c**3)))*c)-1/48384.
    coneq[16337]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c)-1/145152.
    coneq[16338]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c)-1/290304.
    coneq[16339]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c)-1/96768.
    coneq[16340]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c)-1/435456.
    coneq[16341]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c)-1/870912.
    coneq[16342]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c)-1/290304.
    coneq[16343]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c)-1/1741824.
    coneq[16344]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c)-1/580608.
    coneq[16345]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c)-1/193536.
    coneq[16346]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**4)))*c)-1/45360.
    coneq[16347]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c)-1/181440.
    coneq[16348]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c)-1/544320.
    coneq[16349]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[16350]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c)-1/362880.
    coneq[16351]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c)-1/136080.
    coneq[16352]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c)-1/272160.
    coneq[16353]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c)-1/90720.
    coneq[16354]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c)-1/181440.
    coneq[16355]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c)-1/90720.
    coneq[16356]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c)-1/362880.
    coneq[16357]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c)-1/1088640.
    coneq[16358]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2177280.
    coneq[16359]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c)-1/725760.
    coneq[16360]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c)-1/272160.
    coneq[16361]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c)-1/544320.
    coneq[16362]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c)-1/181440.
    coneq[16363]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c)-1/362880.
    coneq[16364]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**5)))*c)-1/36288.
    coneq[16365]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c)-1/181440.
    coneq[16366]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c)-1/725760.
    coneq[16367]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/2177280.
    coneq[16368]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/4354560.
    coneq[16369]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1451520.
    coneq[16370]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/544320.
    coneq[16371]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1088640.
    coneq[16372]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/362880.
    coneq[16373]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/725760.
    coneq[16374]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c)-1/145152.
    coneq[16375]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/435456.
    coneq[16376]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/870912.
    coneq[16377]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/290304.
    coneq[16378]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c)-1/108864.
    coneq[16379]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/217728.
    coneq[16380]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c)-1/72576.
    coneq[16381]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/217728.
    coneq[16382]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/435456.
    coneq[16383]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/145152.
    coneq[16384]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**3)))*c)-1/36288.
    coneq[16385]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/108864.
    coneq[16386]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/217728.
    coneq[16387]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/72576.
    coneq[16388]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c)-1/72576.
    coneq[16389]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/217728.
    coneq[16390]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/435456.
    coneq[16391]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/145152.
    coneq[16392]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**4)))*c)-1/30240.
    coneq[16393]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c)-1/120960.
    coneq[16394]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/362880.
    coneq[16395]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/725760.
    coneq[16396]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/241920.
    coneq[16397]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/90720.
    coneq[16398]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/181440.
    coneq[16399]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/60480.
    coneq[16400]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/120960.
    coneq[16401]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c)-1/27216.
    coneq[16402]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/54432.
    coneq[16403]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/108864.
    coneq[16404]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**3)))*c)-1/24192.
    coneq[16405]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/72576.
    coneq[16406]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/145152.
    coneq[16407]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/48384.
    coneq[16408]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c**2)))*c)-1/18144.
    coneq[16409]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c)-1/36288.
    coneq[16410]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)*dot(A,c)))*c)-1/12096.
    coneq[16411]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c)-1/48384.
    coneq[16412]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/145152.
    coneq[16413]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/290304.
    coneq[16414]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/96768.
    coneq[16415]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c)-1/54432.
    coneq[16416]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/108864.
    coneq[16417]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/217728.
    coneq[16418]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/36288.
    coneq[16419]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/72576.
    coneq[16420]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/24192.
    coneq[16421]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/48384.
    coneq[16422]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**4))*c)-1/4200.
    coneq[16423]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c**3)))*c)-1/16800.
    coneq[16424]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))*c)-1/50400.
    coneq[16425]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/100800.
    coneq[16426]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))*c)-1/33600.
    coneq[16427]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,c**2)))*c)-1/12600.
    coneq[16428]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))*c)-1/25200.
    coneq[16429]=dot(b,dot(A,c*dot(A,c**4)*dot(A,c**2*dot(A,c)))*c)-1/8400.
    coneq[16430]=dot(b,dot(A,c*dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))*c)-1/16800.
    coneq[16431]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))*c)-1/67200.
    coneq[16432]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))*c)-1/201600.
    coneq[16433]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/403200.
    coneq[16434]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))*c)-1/134400.
    coneq[16435]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))*c)-1/50400.
    coneq[16436]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))*c)-1/100800.
    coneq[16437]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))*c)-1/33600.
    coneq[16438]=dot(b,dot(A,c*dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))*c)-1/67200.
    coneq[16439]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))*c)-1/604800.
    coneq[16440]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/1209600.
    coneq[16441]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))*c)-1/403200.
    coneq[16442]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))*c)-1/151200.
    coneq[16443]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))*c)-1/302400.
    coneq[16444]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))*c)-1/100800.
    coneq[16445]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/201600.
    coneq[16446]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/2419200.
    coneq[16447]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))*c)-1/806400.
    coneq[16448]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))*c)-1/302400.
    coneq[16449]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))*c)-1/604800.
    coneq[16450]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))*c)-1/201600.
    coneq[16451]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))*c)-1/403200.
    coneq[16452]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c)-1/268800.
    coneq[16453]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))*c)-1/100800.
    coneq[16454]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/201600.
    coneq[16455]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/67200.
    coneq[16456]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/134400.
    coneq[16457]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))*c)-1/37800.
    coneq[16458]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c)-1/75600.
    coneq[16459]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))*c)-1/25200.
    coneq[16460]=dot(b,dot(A,c*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c)-1/50400.
    coneq[16461]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/151200.
    coneq[16462]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/50400.
    coneq[16463]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/100800.
    coneq[16464]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/16800.
    coneq[16465]=dot(b,dot(A,c*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/33600.
    coneq[16466]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/67200.
    coneq[16467]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**5))*c)-1/4032.
    coneq[16468]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**4)))*c)-1/20160.
    coneq[16469]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))*c)-1/80640.
    coneq[16470]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/241920.
    coneq[16471]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/483840.
    coneq[16472]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/161280.
    coneq[16473]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/60480.
    coneq[16474]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[16475]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/40320.
    coneq[16476]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/80640.
    coneq[16477]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**3)))*c)-1/16128.
    coneq[16478]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/48384.
    coneq[16479]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/96768.
    coneq[16480]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/32256.
    coneq[16481]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c**2)))*c)-1/12096.
    coneq[16482]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/24192.
    coneq[16483]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3*dot(A,c)))*c)-1/8064.
    coneq[16484]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/24192.
    coneq[16485]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/48384.
    coneq[16486]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/16128.
    coneq[16487]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**5))*c)-1/12096.
    coneq[16488]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))*c)-1/60480.
    coneq[16489]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))*c)-1/241920.
    coneq[16490]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/725760.
    coneq[16491]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[16492]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/483840.
    coneq[16493]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/181440.
    coneq[16494]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/362880.
    coneq[16495]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/120960.
    coneq[16496]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/241920.
    coneq[16497]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))*c)-1/48384.
    coneq[16498]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/145152.
    coneq[16499]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/290304.
    coneq[16500]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/96768.
    coneq[16501]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))*c)-1/36288.
    coneq[16502]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/72576.
    coneq[16503]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))*c)-1/24192.
    coneq[16504]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/72576.
    coneq[16505]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/145152.
    coneq[16506]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/48384.
    coneq[16507]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**5))*c)-1/24192.
    coneq[16508]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))*c)-1/120960.
    coneq[16509]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))*c)-1/483840.
    coneq[16510]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/1451520.
    coneq[16511]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/2903040.
    coneq[16512]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/967680.
    coneq[16513]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/362880.
    coneq[16514]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/725760.
    coneq[16515]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/241920.
    coneq[16516]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/483840.
    coneq[16517]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))*c)-1/96768.
    coneq[16518]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/290304.
    coneq[16519]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/580608.
    coneq[16520]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/193536.
    coneq[16521]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))*c)-1/72576.
    coneq[16522]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/145152.
    coneq[16523]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))*c)-1/48384.
    coneq[16524]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/145152.
    coneq[16525]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/290304.
    coneq[16526]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/96768.
    coneq[16527]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**5))*c)-1/8064.
    coneq[16528]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))*c)-1/40320.
    coneq[16529]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/161280.
    coneq[16530]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/483840.
    coneq[16531]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/967680.
    coneq[16532]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/322560.
    coneq[16533]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/120960.
    coneq[16534]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/241920.
    coneq[16535]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/80640.
    coneq[16536]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/161280.
    coneq[16537]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/32256.
    coneq[16538]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/96768.
    coneq[16539]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/193536.
    coneq[16540]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/64512.
    coneq[16541]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/24192.
    coneq[16542]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/48384.
    coneq[16543]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/16128.
    coneq[16544]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/48384.
    coneq[16545]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/96768.
    coneq[16546]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/32256.
    coneq[16547]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**6))*c)-1/3528.
    coneq[16548]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**5)))*c)-1/21168.
    coneq[16549]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))*c)-1/105840.
    coneq[16550]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/423360.
    coneq[16551]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1270080.
    coneq[16552]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2540160.
    coneq[16553]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/846720.
    coneq[16554]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/317520.
    coneq[16555]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/635040.
    coneq[16556]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/211680.
    coneq[16557]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/423360.
    coneq[16558]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/84672.
    coneq[16559]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/254016.
    coneq[16560]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/508032.
    coneq[16561]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/169344.
    coneq[16562]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/63504.
    coneq[16563]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/127008.
    coneq[16564]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/42336.
    coneq[16565]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/127008.
    coneq[16566]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/254016.
    coneq[16567]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/84672.
    coneq[16568]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**4)))*c)-1/17640.
    coneq[16569]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/70560.
    coneq[16570]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/211680.
    coneq[16571]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/423360.
    coneq[16572]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/141120.
    coneq[16573]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/52920.
    coneq[16574]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/105840.
    coneq[16575]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/35280.
    coneq[16576]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/70560.
    coneq[16577]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**3)))*c)-1/14112.
    coneq[16578]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/42336.
    coneq[16579]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/84672.
    coneq[16580]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/28224.
    coneq[16581]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c**2)))*c)-1/10584.
    coneq[16582]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/21168.
    coneq[16583]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4*dot(A,c)))*c)-1/7056.
    coneq[16584]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/31752.
    coneq[16585]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/63504.
    coneq[16586]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/127008.
    coneq[16587]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/28224.
    coneq[16588]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/84672.
    coneq[16589]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/169344.
    coneq[16590]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/56448.
    coneq[16591]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/21168.
    coneq[16592]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/42336.
    coneq[16593]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/14112.
    coneq[16594]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/28224.
    coneq[16595]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**6))*c)-1/7056.
    coneq[16596]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**5)))*c)-1/42336.
    coneq[16597]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))*c)-1/211680.
    coneq[16598]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/846720.
    coneq[16599]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/2540160.
    coneq[16600]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/5080320.
    coneq[16601]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1693440.
    coneq[16602]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/635040.
    coneq[16603]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/1270080.
    coneq[16604]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/423360.
    coneq[16605]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/846720.
    coneq[16606]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))*c)-1/169344.
    coneq[16607]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/508032.
    coneq[16608]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/1016064.
    coneq[16609]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/338688.
    coneq[16610]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/127008.
    coneq[16611]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/254016.
    coneq[16612]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))*c)-1/84672.
    coneq[16613]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/254016.
    coneq[16614]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/508032.
    coneq[16615]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/169344.
    coneq[16616]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))*c)-1/35280.
    coneq[16617]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))*c)-1/141120.
    coneq[16618]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/423360.
    coneq[16619]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/846720.
    coneq[16620]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/282240.
    coneq[16621]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/105840.
    coneq[16622]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/211680.
    coneq[16623]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/70560.
    coneq[16624]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/141120.
    coneq[16625]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))*c)-1/28224.
    coneq[16626]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/84672.
    coneq[16627]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/169344.
    coneq[16628]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/56448.
    coneq[16629]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))*c)-1/21168.
    coneq[16630]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))*c)-1/42336.
    coneq[16631]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))*c)-1/14112.
    coneq[16632]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/63504.
    coneq[16633]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/127008.
    coneq[16634]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/254016.
    coneq[16635]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/56448.
    coneq[16636]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/169344.
    coneq[16637]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/338688.
    coneq[16638]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/112896.
    coneq[16639]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/42336.
    coneq[16640]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/84672.
    coneq[16641]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/28224.
    coneq[16642]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/56448.
    coneq[16643]=dot(b,dot(A,c*dot(A,c)*dot(A,c**7))*c)-1/2688.
    coneq[16644]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**6)))*c)-1/18816.
    coneq[16645]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**5))))*c)-1/112896.
    coneq[16646]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))*c)-1/564480.
    coneq[16647]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c)-1/2257920.
    coneq[16648]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c)-1/6773760.
    coneq[16649]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c)-1/13547520.
    coneq[16650]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c)-1/4515840.
    coneq[16651]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c)-1/1693440.
    coneq[16652]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c)-1/3386880.
    coneq[16653]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c)-1/1128960.
    coneq[16654]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c)-1/2257920.
    coneq[16655]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c)-1/451584.
    coneq[16656]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c)-1/1354752.
    coneq[16657]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c)-1/2709504.
    coneq[16658]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c)-1/903168.
    coneq[16659]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c)-1/338688.
    coneq[16660]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c)-1/677376.
    coneq[16661]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c)-1/225792.
    coneq[16662]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c)-1/677376.
    coneq[16663]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c)-1/1354752.
    coneq[16664]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c)-1/451584.
    coneq[16665]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))*c)-1/94080.
    coneq[16666]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c)-1/376320.
    coneq[16667]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c)-1/1128960.
    coneq[16668]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/2257920.
    coneq[16669]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c)-1/752640.
    coneq[16670]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c)-1/282240.
    coneq[16671]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c)-1/564480.
    coneq[16672]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c)-1/188160.
    coneq[16673]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c)-1/376320.
    coneq[16674]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))*c)-1/75264.
    coneq[16675]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c)-1/225792.
    coneq[16676]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c)-1/451584.
    coneq[16677]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c)-1/150528.
    coneq[16678]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))*c)-1/56448.
    coneq[16679]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c)-1/112896.
    coneq[16680]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))*c)-1/37632.
    coneq[16681]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c)-1/169344.
    coneq[16682]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[16683]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c)-1/677376.
    coneq[16684]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c)-1/150528.
    coneq[16685]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c)-1/451584.
    coneq[16686]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c)-1/903168.
    coneq[16687]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c)-1/301056.
    coneq[16688]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c)-1/112896.
    coneq[16689]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c)-1/225792.
    coneq[16690]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c)-1/75264.
    coneq[16691]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c)-1/150528.
    coneq[16692]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**5)))*c)-1/16128.
    coneq[16693]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))*c)-1/80640.
    coneq[16694]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c)-1/322560.
    coneq[16695]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/967680.
    coneq[16696]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1935360.
    coneq[16697]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/645120.
    coneq[16698]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c)-1/241920.
    coneq[16699]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/483840.
    coneq[16700]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c)-1/161280.
    coneq[16701]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/322560.
    coneq[16702]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))*c)-1/64512.
    coneq[16703]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c)-1/193536.
    coneq[16704]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/387072.
    coneq[16705]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c)-1/129024.
    coneq[16706]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))*c)-1/48384.
    coneq[16707]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c)-1/96768.
    coneq[16708]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))*c)-1/32256.
    coneq[16709]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c)-1/96768.
    coneq[16710]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/193536.
    coneq[16711]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c)-1/64512.
    coneq[16712]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**4)))*c)-1/13440.
    coneq[16713]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))*c)-1/53760.
    coneq[16714]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c)-1/161280.
    coneq[16715]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/322560.
    coneq[16716]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c)-1/107520.
    coneq[16717]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))*c)-1/40320.
    coneq[16718]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c)-1/80640.
    coneq[16719]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))*c)-1/26880.
    coneq[16720]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c)-1/53760.
    coneq[16721]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**3)))*c)-1/10752.
    coneq[16722]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))*c)-1/32256.
    coneq[16723]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c)-1/64512.
    coneq[16724]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))*c)-1/21504.
    coneq[16725]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c**2)))*c)-1/8064.
    coneq[16726]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))*c)-1/16128.
    coneq[16727]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5*dot(A,c)))*c)-1/5376.
    coneq[16728]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))*c)-1/32256.
    coneq[16729]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c)-1/96768.
    coneq[16730]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c)-1/193536.
    coneq[16731]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c)-1/64512.
    coneq[16732]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c)-1/64512.
    coneq[16733]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c)-1/193536.
    coneq[16734]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c)-1/387072.
    coneq[16735]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c)-1/129024.
    coneq[16736]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))*c)-1/26880.
    coneq[16737]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c)-1/107520.
    coneq[16738]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c)-1/322560.
    coneq[16739]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/645120.
    coneq[16740]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c)-1/215040.
    coneq[16741]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c)-1/80640.
    coneq[16742]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c)-1/161280.
    coneq[16743]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c)-1/53760.
    coneq[16744]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c)-1/107520.
    coneq[16745]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c)-1/24192.
    coneq[16746]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c)-1/48384.
    coneq[16747]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/96768.
    coneq[16748]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))*c)-1/21504.
    coneq[16749]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c)-1/64512.
    coneq[16750]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/129024.
    coneq[16751]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c)-1/43008.
    coneq[16752]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c)-1/16128.
    coneq[16753]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c)-1/32256.
    coneq[16754]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))*c)-1/10752.
    coneq[16755]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c)-1/32256.
    coneq[16756]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c)-1/64512.
    coneq[16757]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/21504.
    coneq[16758]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**4))*c)-1/3360.
    coneq[16759]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**3)))*c)-1/13440.
    coneq[16760]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c)-1/40320.
    coneq[16761]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/80640.
    coneq[16762]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c)-1/26880.
    coneq[16763]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c**2)))*c)-1/10080.
    coneq[16764]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c)-1/20160.
    coneq[16765]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**2*dot(A,c)))*c)-1/6720.
    coneq[16766]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c)-1/13440.
    coneq[16767]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**4))*c)-1/10080.
    coneq[16768]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c)-1/40320.
    coneq[16769]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[16770]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[16771]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[16772]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c)-1/30240.
    coneq[16773]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c)-1/60480.
    coneq[16774]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c)-1/20160.
    coneq[16775]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c)-1/40320.
    coneq[16776]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c)-1/20160.
    coneq[16777]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c)-1/80640.
    coneq[16778]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[16779]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[16780]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[16781]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c)-1/60480.
    coneq[16782]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/120960.
    coneq[16783]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/40320.
    coneq[16784]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/80640.
    coneq[16785]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**4))*c)-1/6720.
    coneq[16786]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c)-1/26880.
    coneq[16787]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/80640.
    coneq[16788]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/161280.
    coneq[16789]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/53760.
    coneq[16790]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/20160.
    coneq[16791]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/40320.
    coneq[16792]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/13440.
    coneq[16793]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/26880.
    coneq[16794]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**5))*c)-1/3024.
    coneq[16795]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**4)))*c)-1/15120.
    coneq[16796]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c)-1/60480.
    coneq[16797]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/181440.
    coneq[16798]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/362880.
    coneq[16799]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/120960.
    coneq[16800]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/45360.
    coneq[16801]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/90720.
    coneq[16802]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/30240.
    coneq[16803]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/60480.
    coneq[16804]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**3)))*c)-1/12096.
    coneq[16805]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/36288.
    coneq[16806]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/72576.
    coneq[16807]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/24192.
    coneq[16808]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c)-1/9072.
    coneq[16809]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/18144.
    coneq[16810]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3*dot(A,c)))*c)-1/6048.
    coneq[16811]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/18144.
    coneq[16812]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/36288.
    coneq[16813]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/12096.
    coneq[16814]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**5))*c)-1/6048.
    coneq[16815]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c)-1/30240.
    coneq[16816]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/120960.
    coneq[16817]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/362880.
    coneq[16818]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/725760.
    coneq[16819]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/241920.
    coneq[16820]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/90720.
    coneq[16821]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/181440.
    coneq[16822]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/60480.
    coneq[16823]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/120960.
    coneq[16824]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/24192.
    coneq[16825]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/72576.
    coneq[16826]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/145152.
    coneq[16827]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/48384.
    coneq[16828]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/18144.
    coneq[16829]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/36288.
    coneq[16830]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/12096.
    coneq[16831]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/36288.
    coneq[16832]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/72576.
    coneq[16833]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/24192.
    coneq[16834]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**6))*c)-1/2352.
    coneq[16835]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**5)))*c)-1/14112.
    coneq[16836]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c)-1/70560.
    coneq[16837]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/282240.
    coneq[16838]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/846720.
    coneq[16839]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/1693440.
    coneq[16840]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/564480.
    coneq[16841]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/211680.
    coneq[16842]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/423360.
    coneq[16843]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/141120.
    coneq[16844]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/282240.
    coneq[16845]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/56448.
    coneq[16846]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/169344.
    coneq[16847]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/338688.
    coneq[16848]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/112896.
    coneq[16849]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/42336.
    coneq[16850]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/84672.
    coneq[16851]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/28224.
    coneq[16852]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/84672.
    coneq[16853]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/169344.
    coneq[16854]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/56448.
    coneq[16855]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**4)))*c)-1/11760.
    coneq[16856]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/47040.
    coneq[16857]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/141120.
    coneq[16858]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/282240.
    coneq[16859]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/94080.
    coneq[16860]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/35280.
    coneq[16861]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/70560.
    coneq[16862]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/23520.
    coneq[16863]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/47040.
    coneq[16864]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**3)))*c)-1/9408.
    coneq[16865]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/28224.
    coneq[16866]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/56448.
    coneq[16867]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/18816.
    coneq[16868]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c**2)))*c)-1/7056.
    coneq[16869]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/14112.
    coneq[16870]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4*dot(A,c)))*c)-1/4704.
    coneq[16871]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/21168.
    coneq[16872]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/42336.
    coneq[16873]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/84672.
    coneq[16874]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/18816.
    coneq[16875]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/56448.
    coneq[16876]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/112896.
    coneq[16877]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/37632.
    coneq[16878]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/14112.
    coneq[16879]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/28224.
    coneq[16880]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/9408.
    coneq[16881]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/18816.
    coneq[16882]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c**3))*c)-1/2688.
    coneq[16883]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/8064.
    coneq[16884]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/16128.
    coneq[16885]=dot(b,dot(A,c**3*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/5376.
    coneq[16886]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/24192.
    coneq[16887]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/48384.
    coneq[16888]=dot(b,dot(A,c**3*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/16128.
    coneq[16889]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/96768.
    coneq[16890]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/32256.
    coneq[16891]=dot(b,dot(A,c**3*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/10752.
    coneq[16892]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**4))*c)-1/2520.
    coneq[16893]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/10080.
    coneq[16894]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/30240.
    coneq[16895]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/60480.
    coneq[16896]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/20160.
    coneq[16897]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/7560.
    coneq[16898]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/15120.
    coneq[16899]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/5040.
    coneq[16900]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/10080.
    coneq[16901]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**4))*c)-1/5040.
    coneq[16902]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/20160.
    coneq[16903]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/60480.
    coneq[16904]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/120960.
    coneq[16905]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/40320.
    coneq[16906]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/15120.
    coneq[16907]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/30240.
    coneq[16908]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/10080.
    coneq[16909]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/20160.
    coneq[16910]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**5))*c)-1/2016.
    coneq[16911]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**4)))*c)-1/10080.
    coneq[16912]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c)-1/40320.
    coneq[16913]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/120960.
    coneq[16914]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/241920.
    coneq[16915]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/80640.
    coneq[16916]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/30240.
    coneq[16917]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/60480.
    coneq[16918]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/20160.
    coneq[16919]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/40320.
    coneq[16920]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**3)))*c)-1/8064.
    coneq[16921]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/24192.
    coneq[16922]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/48384.
    coneq[16923]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/16128.
    coneq[16924]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c)-1/6048.
    coneq[16925]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/12096.
    coneq[16926]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3*dot(A,c)))*c)-1/4032.
    coneq[16927]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/12096.
    coneq[16928]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/24192.
    coneq[16929]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/8064.
    coneq[16930]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**3))*c)-1/2016.
    coneq[16931]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/6048.
    coneq[16932]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/12096.
    coneq[16933]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/4032.
    coneq[16934]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c**3))*c)-1/4032.
    coneq[16935]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/12096.
    coneq[16936]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/24192.
    coneq[16937]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/8064.
    coneq[16938]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**4))*c)-1/1680.
    coneq[16939]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/6720.
    coneq[16940]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/20160.
    coneq[16941]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/40320.
    coneq[16942]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/13440.
    coneq[16943]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/5040.
    coneq[16944]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/10080.
    coneq[16945]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/3360.
    coneq[16946]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/6720.
    coneq[16947]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,c**2))*c)-1/1512.
    coneq[16948]=dot(b,dot(A,c**5*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/3024.
    coneq[16949]=dot(b,dot(A,c**5*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/6048.
    coneq[16950]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**3))*c)-1/1344.
    coneq[16951]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/4032.
    coneq[16952]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/8064.
    coneq[16953]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/2688.
    coneq[16954]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c**2))*c)-1/1008.
    coneq[16955]=dot(b,dot(A,c**6*dot(A,c)*dot(A,dot(A,c)))*c)-1/2016.
    coneq[16956]=dot(b,dot(A,c**7*dot(A,c)*dot(A,c))*c)-1/672.
    coneq[16957]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**6))*c)-1/4704.
    coneq[16958]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**5)))*c)-1/28224.
    coneq[16959]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c)-1/141120.
    coneq[16960]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c)-1/564480.
    coneq[16961]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c)-1/1693440.
    coneq[16962]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c)-1/3386880.
    coneq[16963]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c)-1/1128960.
    coneq[16964]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c)-1/423360.
    coneq[16965]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c)-1/846720.
    coneq[16966]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c)-1/282240.
    coneq[16967]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c)-1/564480.
    coneq[16968]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c)-1/112896.
    coneq[16969]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c)-1/338688.
    coneq[16970]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c)-1/677376.
    coneq[16971]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c)-1/225792.
    coneq[16972]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c)-1/84672.
    coneq[16973]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c)-1/169344.
    coneq[16974]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c)-1/56448.
    coneq[16975]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c)-1/169344.
    coneq[16976]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c)-1/338688.
    coneq[16977]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c)-1/112896.
    coneq[16978]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**4)))*c)-1/23520.
    coneq[16979]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c)-1/94080.
    coneq[16980]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c)-1/282240.
    coneq[16981]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/564480.
    coneq[16982]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c)-1/188160.
    coneq[16983]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c)-1/70560.
    coneq[16984]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c)-1/141120.
    coneq[16985]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c)-1/47040.
    coneq[16986]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c)-1/94080.
    coneq[16987]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**3)))*c)-1/18816.
    coneq[16988]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c)-1/56448.
    coneq[16989]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c)-1/112896.
    coneq[16990]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c)-1/37632.
    coneq[16991]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c**2)))*c)-1/14112.
    coneq[16992]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c)-1/28224.
    coneq[16993]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4*dot(A,c)))*c)-1/9408.
    coneq[16994]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c)-1/42336.
    coneq[16995]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c)-1/84672.
    coneq[16996]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c)-1/169344.
    coneq[16997]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c)-1/37632.
    coneq[16998]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c)-1/112896.
    coneq[16999]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c)-1/225792.
    coneq[17000]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c)-1/75264.
    coneq[17001]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c)-1/28224.
    coneq[17002]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c)-1/56448.
    coneq[17003]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c)-1/18816.
    coneq[17004]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c)-1/37632.
    coneq[17005]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**5))*c)-1/6048.
    coneq[17006]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**4)))*c)-1/30240.
    coneq[17007]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c)-1/120960.
    coneq[17008]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/362880.
    coneq[17009]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/725760.
    coneq[17010]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/241920.
    coneq[17011]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/90720.
    coneq[17012]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/181440.
    coneq[17013]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/60480.
    coneq[17014]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/120960.
    coneq[17015]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**3)))*c)-1/24192.
    coneq[17016]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/72576.
    coneq[17017]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/145152.
    coneq[17018]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/48384.
    coneq[17019]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c)-1/18144.
    coneq[17020]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/36288.
    coneq[17021]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3*dot(A,c)))*c)-1/12096.
    coneq[17022]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/36288.
    coneq[17023]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/72576.
    coneq[17024]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/24192.
    coneq[17025]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**5))*c)-1/12096.
    coneq[17026]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c)-1/60480.
    coneq[17027]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c)-1/241920.
    coneq[17028]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/725760.
    coneq[17029]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/1451520.
    coneq[17030]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/483840.
    coneq[17031]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c)-1/181440.
    coneq[17032]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/362880.
    coneq[17033]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c)-1/120960.
    coneq[17034]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/241920.
    coneq[17035]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c)-1/48384.
    coneq[17036]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c)-1/145152.
    coneq[17037]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/290304.
    coneq[17038]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c)-1/96768.
    coneq[17039]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c)-1/36288.
    coneq[17040]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c)-1/72576.
    coneq[17041]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c)-1/24192.
    coneq[17042]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/72576.
    coneq[17043]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/145152.
    coneq[17044]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/48384.
    coneq[17045]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**4))*c)-1/7560.
    coneq[17046]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/30240.
    coneq[17047]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/90720.
    coneq[17048]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/181440.
    coneq[17049]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/60480.
    coneq[17050]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/22680.
    coneq[17051]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/45360.
    coneq[17052]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/15120.
    coneq[17053]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/30240.
    coneq[17054]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**4))*c)-1/15120.
    coneq[17055]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/60480.
    coneq[17056]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/181440.
    coneq[17057]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/362880.
    coneq[17058]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/120960.
    coneq[17059]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/45360.
    coneq[17060]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/90720.
    coneq[17061]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/30240.
    coneq[17062]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/60480.
    coneq[17063]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**4))*c)-1/30240.
    coneq[17064]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/120960.
    coneq[17065]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/362880.
    coneq[17066]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/725760.
    coneq[17067]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/241920.
    coneq[17068]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/90720.
    coneq[17069]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/181440.
    coneq[17070]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/60480.
    coneq[17071]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/120960.
    coneq[17072]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**4))*c)-1/6720.
    coneq[17073]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**3)))*c)-1/26880.
    coneq[17074]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c)-1/80640.
    coneq[17075]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/161280.
    coneq[17076]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c)-1/53760.
    coneq[17077]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c**2)))*c)-1/20160.
    coneq[17078]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c)-1/40320.
    coneq[17079]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**2*dot(A,c)))*c)-1/13440.
    coneq[17080]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c)-1/26880.
    coneq[17081]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**4))*c)-1/20160.
    coneq[17082]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c)-1/80640.
    coneq[17083]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[17084]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[17085]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[17086]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c)-1/60480.
    coneq[17087]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c)-1/120960.
    coneq[17088]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c)-1/40320.
    coneq[17089]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c)-1/80640.
    coneq[17090]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c)-1/40320.
    coneq[17091]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c)-1/161280.
    coneq[17092]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c)-1/483840.
    coneq[17093]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/967680.
    coneq[17094]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c)-1/322560.
    coneq[17095]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c)-1/120960.
    coneq[17096]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c)-1/241920.
    coneq[17097]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c)-1/80640.
    coneq[17098]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c)-1/161280.
    coneq[17099]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**4))*c)-1/13440.
    coneq[17100]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c)-1/53760.
    coneq[17101]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/161280.
    coneq[17102]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/322560.
    coneq[17103]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/107520.
    coneq[17104]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/40320.
    coneq[17105]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/80640.
    coneq[17106]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/26880.
    coneq[17107]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/53760.
    coneq[17108]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c**3))*c)-1/8064.
    coneq[17109]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/24192.
    coneq[17110]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/48384.
    coneq[17111]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/16128.
    coneq[17112]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/72576.
    coneq[17113]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/145152.
    coneq[17114]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/48384.
    coneq[17115]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/290304.
    coneq[17116]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/96768.
    coneq[17117]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/32256.
    coneq[17118]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c**3))*c)-1/16128.
    coneq[17119]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/48384.
    coneq[17120]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/96768.
    coneq[17121]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/32256.
    coneq[17122]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/145152.
    coneq[17123]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/290304.
    coneq[17124]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/96768.
    coneq[17125]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/580608.
    coneq[17126]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/193536.
    coneq[17127]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/64512.
    coneq[17128]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**5))*c)-1/4032.
    coneq[17129]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))*c)-1/20160.
    coneq[17130]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c)-1/80640.
    coneq[17131]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c)-1/241920.
    coneq[17132]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c)-1/483840.
    coneq[17133]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c)-1/161280.
    coneq[17134]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c)-1/60480.
    coneq[17135]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c)-1/120960.
    coneq[17136]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c)-1/40320.
    coneq[17137]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c)-1/80640.
    coneq[17138]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))*c)-1/16128.
    coneq[17139]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c)-1/48384.
    coneq[17140]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c)-1/96768.
    coneq[17141]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c)-1/32256.
    coneq[17142]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c)-1/12096.
    coneq[17143]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c)-1/24192.
    coneq[17144]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))*c)-1/8064.
    coneq[17145]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c)-1/24192.
    coneq[17146]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c)-1/48384.
    coneq[17147]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c)-1/16128.
    coneq[17148]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**4))*c)-1/5040.
    coneq[17149]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))*c)-1/20160.
    coneq[17150]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c)-1/60480.
    coneq[17151]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/120960.
    coneq[17152]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c)-1/40320.
    coneq[17153]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c)-1/15120.
    coneq[17154]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c)-1/30240.
    coneq[17155]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c)-1/10080.
    coneq[17156]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c)-1/20160.
    coneq[17157]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))*c)-1/10080.
    coneq[17158]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c)-1/40320.
    coneq[17159]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[17160]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[17161]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[17162]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c)-1/30240.
    coneq[17163]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c)-1/60480.
    coneq[17164]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c)-1/20160.
    coneq[17165]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c)-1/40320.
    coneq[17166]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**3))*c)-1/6048.
    coneq[17167]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/18144.
    coneq[17168]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/36288.
    coneq[17169]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/12096.
    coneq[17170]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))*c)-1/12096.
    coneq[17171]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/36288.
    coneq[17172]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/72576.
    coneq[17173]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/24192.
    coneq[17174]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))*c)-1/24192.
    coneq[17175]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/72576.
    coneq[17176]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/145152.
    coneq[17177]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/48384.
    coneq[17178]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c**3))*c)-1/5376.
    coneq[17179]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))*c)-1/16128.
    coneq[17180]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c)-1/32256.
    coneq[17181]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))*c)-1/10752.
    coneq[17182]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c)-1/48384.
    coneq[17183]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c)-1/96768.
    coneq[17184]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c)-1/32256.
    coneq[17185]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c)-1/193536.
    coneq[17186]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c)-1/64512.
    coneq[17187]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c)-1/21504.
    coneq[17188]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**4))*c)-1/3360.
    coneq[17189]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/13440.
    coneq[17190]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/40320.
    coneq[17191]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/80640.
    coneq[17192]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/26880.
    coneq[17193]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/10080.
    coneq[17194]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/20160.
    coneq[17195]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/6720.
    coneq[17196]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/13440.
    coneq[17197]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**3))*c)-1/4032.
    coneq[17198]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/12096.
    coneq[17199]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/24192.
    coneq[17200]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/8064.
    coneq[17201]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c)-1/8064.
    coneq[17202]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/24192.
    coneq[17203]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/48384.
    coneq[17204]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/16128.
    coneq[17205]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c)-1/4536.
    coneq[17206]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/9072.
    coneq[17207]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/18144.
    coneq[17208]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/36288.
    coneq[17209]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**3))*c)-1/2688.
    coneq[17210]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/8064.
    coneq[17211]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/16128.
    coneq[17212]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/5376.
    coneq[17213]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c)-1/3024.
    coneq[17214]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/6048.
    coneq[17215]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/12096.
    coneq[17216]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/2016.
    coneq[17217]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/4032.
    coneq[17218]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/1344.
    coneq[17219]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**4))*c)-1/6720.
    coneq[17220]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c)-1/26880.
    coneq[17221]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c)-1/80640.
    coneq[17222]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/161280.
    coneq[17223]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c)-1/53760.
    coneq[17224]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c)-1/20160.
    coneq[17225]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c)-1/40320.
    coneq[17226]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c)-1/13440.
    coneq[17227]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c)-1/26880.
    coneq[17228]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**3))*c)-1/8064.
    coneq[17229]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c)-1/24192.
    coneq[17230]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c)-1/48384.
    coneq[17231]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c)-1/16128.
    coneq[17232]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c)-1/16128.
    coneq[17233]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c)-1/48384.
    coneq[17234]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c)-1/96768.
    coneq[17235]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c)-1/32256.
    coneq[17236]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c)-1/9072.
    coneq[17237]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/18144.
    coneq[17238]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2))*c)-1/18144.
    coneq[17239]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/36288.
    coneq[17240]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))*c)-1/36288.
    coneq[17241]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/72576.
    coneq[17242]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))*c)-1/5376.
    coneq[17243]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c)-1/16128.
    coneq[17244]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c)-1/32256.
    coneq[17245]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c)-1/10752.
    coneq[17246]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c)-1/6048.
    coneq[17247]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c)-1/12096.
    coneq[17248]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))*c)-1/12096.
    coneq[17249]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c)-1/24192.
    coneq[17250]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*c)-1/4032.
    coneq[17251]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c)-1/8064.
    coneq[17252]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c)-1/2688.
    coneq[17253]=dot(b,dot(A,c**10)*c*c)-1/154.
    coneq[17254]=dot(b,dot(A,dot(A,c**9))*c*c)-1/1540.
    coneq[17255]=dot(b,dot(A,dot(A,dot(A,c**8)))*c*c)-1/13860.
    coneq[17256]=dot(b,dot(A,dot(A,dot(A,dot(A,c**7))))*c*c)-1/110880.
    coneq[17257]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**6)))))*c*c)-1/776160.
    coneq[17258]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))*c*c)-1/4656960.
    coneq[17259]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))*c*c)-1/23284800.
    coneq[17260]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))*c*c)-1/93139200.
    coneq[17261]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*c*c)-1/279417600.
    coneq[17262]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*c*c)-1/558835200.
    coneq[17263]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*c*c)-1/186278400.
    coneq[17264]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*c*c)-1/69854400.
    coneq[17265]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*c*c)-1/139708800.
    coneq[17266]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*c*c)-1/46569600.
    coneq[17267]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*c*c)-1/93139200.
    coneq[17268]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))*c*c)-1/18627840.
    coneq[17269]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*c*c)-1/55883520.
    coneq[17270]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*c*c)-1/111767040.
    coneq[17271]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*c*c)-1/37255680.
    coneq[17272]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))*c*c)-1/13970880.
    coneq[17273]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*c*c)-1/27941760.
    coneq[17274]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))*c*c)-1/9313920.
    coneq[17275]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*c*c)-1/27941760.
    coneq[17276]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*c*c)-1/55883520.
    coneq[17277]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*c*c)-1/18627840.
    coneq[17278]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))*c*c)-1/3880800.
    coneq[17279]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))*c*c)-1/15523200.
    coneq[17280]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*c*c)-1/46569600.
    coneq[17281]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*c*c)-1/93139200.
    coneq[17282]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*c*c)-1/31046400.
    coneq[17283]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))*c*c)-1/11642400.
    coneq[17284]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*c*c)-1/23284800.
    coneq[17285]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))*c*c)-1/7761600.
    coneq[17286]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*c*c)-1/15523200.
    coneq[17287]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))*c*c)-1/3104640.
    coneq[17288]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))*c*c)-1/9313920.
    coneq[17289]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*c*c)-1/18627840.
    coneq[17290]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))*c*c)-1/6209280.
    coneq[17291]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))*c*c)-1/2328480.
    coneq[17292]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))*c*c)-1/4656960.
    coneq[17293]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))*c*c)-1/1552320.
    coneq[17294]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))*c*c)-1/6985440.
    coneq[17295]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*c*c)-1/13970880.
    coneq[17296]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*c*c)-1/27941760.
    coneq[17297]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))*c*c)-1/6209280.
    coneq[17298]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*c*c)-1/18627840.
    coneq[17299]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*c*c)-1/37255680.
    coneq[17300]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*c*c)-1/12418560.
    coneq[17301]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))*c*c)-1/4656960.
    coneq[17302]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*c*c)-1/9313920.
    coneq[17303]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))*c*c)-1/3104640.
    coneq[17304]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*c*c)-1/6209280.
    coneq[17305]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5)))))*c*c)-1/665280.
    coneq[17306]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))*c*c)-1/3326400.
    coneq[17307]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))*c*c)-1/13305600.
    coneq[17308]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))*c*c)-1/39916800.
    coneq[17309]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c*c)-1/79833600.
    coneq[17310]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))*c*c)-1/26611200.
    coneq[17311]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))*c*c)-1/9979200.
    coneq[17312]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))*c*c)-1/19958400.
    coneq[17313]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))*c*c)-1/6652800.
    coneq[17314]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c*c)-1/13305600.
    coneq[17315]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))*c*c)-1/2661120.
    coneq[17316]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))*c*c)-1/7983360.
    coneq[17317]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))*c*c)-1/15966720.
    coneq[17318]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))*c*c)-1/5322240.
    coneq[17319]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))*c*c)-1/1995840.
    coneq[17320]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))*c*c)-1/3991680.
    coneq[17321]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))*c*c)-1/1330560.
    coneq[17322]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))*c*c)-1/3991680.
    coneq[17323]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c*c)-1/7983360.
    coneq[17324]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))*c*c)-1/2661120.
    coneq[17325]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))*c*c)-1/554400.
    coneq[17326]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))*c*c)-1/2217600.
    coneq[17327]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/6652800.
    coneq[17328]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/13305600.
    coneq[17329]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/4435200.
    coneq[17330]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))*c*c)-1/1663200.
    coneq[17331]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/3326400.
    coneq[17332]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))*c*c)-1/1108800.
    coneq[17333]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/2217600.
    coneq[17334]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))*c*c)-1/443520.
    coneq[17335]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))*c*c)-1/1330560.
    coneq[17336]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))*c*c)-1/2661120.
    coneq[17337]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))*c*c)-1/887040.
    coneq[17338]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))*c*c)-1/332640.
    coneq[17339]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))*c*c)-1/665280.
    coneq[17340]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c)))))*c*c)-1/221760.
    coneq[17341]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))*c*c)-1/1330560.
    coneq[17342]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))*c*c)-1/3991680.
    coneq[17343]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*c*c)-1/7983360.
    coneq[17344]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))*c*c)-1/2661120.
    coneq[17345]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))*c*c)-1/2661120.
    coneq[17346]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*c*c)-1/7983360.
    coneq[17347]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*c*c)-1/15966720.
    coneq[17348]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*c*c)-1/5322240.
    coneq[17349]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))*c*c)-1/1108800.
    coneq[17350]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))*c*c)-1/4435200.
    coneq[17351]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/13305600.
    coneq[17352]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/26611200.
    coneq[17353]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/8870400.
    coneq[17354]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))*c*c)-1/3326400.
    coneq[17355]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/6652800.
    coneq[17356]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))*c*c)-1/2217600.
    coneq[17357]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/4435200.
    coneq[17358]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))*c*c)-1/997920.
    coneq[17359]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))*c*c)-1/1995840.
    coneq[17360]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))*c*c)-1/3991680.
    coneq[17361]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))*c*c)-1/887040.
    coneq[17362]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))*c*c)-1/2661120.
    coneq[17363]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c*c)-1/5322240.
    coneq[17364]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))*c*c)-1/1774080.
    coneq[17365]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))*c*c)-1/665280.
    coneq[17366]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/1330560.
    coneq[17367]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))*c*c)-1/443520.
    coneq[17368]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))*c*c)-1/1330560.
    coneq[17369]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/2661120.
    coneq[17370]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))*c*c)-1/887040.
    coneq[17371]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**6))))*c*c)-1/97020.
    coneq[17372]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5)))))*c*c)-1/582120.
    coneq[17373]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))*c*c)-1/2910600.
    coneq[17374]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))*c*c)-1/11642400.
    coneq[17375]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c*c)-1/34927200.
    coneq[17376]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c*c)-1/69854400.
    coneq[17377]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c*c)-1/23284800.
    coneq[17378]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c*c)-1/8731800.
    coneq[17379]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c*c)-1/17463600.
    coneq[17380]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c*c)-1/5821200.
    coneq[17381]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c*c)-1/11642400.
    coneq[17382]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))*c*c)-1/2328480.
    coneq[17383]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c*c)-1/6985440.
    coneq[17384]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c*c)-1/13970880.
    coneq[17385]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c*c)-1/4656960.
    coneq[17386]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))*c*c)-1/1746360.
    coneq[17387]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c*c)-1/3492720.
    coneq[17388]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))*c*c)-1/1164240.
    coneq[17389]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c*c)-1/3492720.
    coneq[17390]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c*c)-1/6985440.
    coneq[17391]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c*c)-1/2328480.
    coneq[17392]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))*c*c)-1/485100.
    coneq[17393]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))*c*c)-1/1940400.
    coneq[17394]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/5821200.
    coneq[17395]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/11642400.
    coneq[17396]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/3880800.
    coneq[17397]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))*c*c)-1/1455300.
    coneq[17398]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/2910600.
    coneq[17399]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))*c*c)-1/970200.
    coneq[17400]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1940400.
    coneq[17401]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))*c*c)-1/388080.
    coneq[17402]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))*c*c)-1/1164240.
    coneq[17403]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c*c)-1/2328480.
    coneq[17404]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))*c*c)-1/776160.
    coneq[17405]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))*c*c)-1/291060.
    coneq[17406]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))*c*c)-1/582120.
    coneq[17407]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))*c*c)-1/194040.
    coneq[17408]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))*c*c)-1/873180.
    coneq[17409]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c*c)-1/1746360.
    coneq[17410]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c*c)-1/3492720.
    coneq[17411]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))*c*c)-1/776160.
    coneq[17412]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c*c)-1/2328480.
    coneq[17413]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c*c)-1/4656960.
    coneq[17414]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c*c)-1/1552320.
    coneq[17415]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))*c*c)-1/582120.
    coneq[17416]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/1164240.
    coneq[17417]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))*c*c)-1/388080.
    coneq[17418]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c*c)-1/776160.
    coneq[17419]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**5))))*c*c)-1/83160.
    coneq[17420]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))*c*c)-1/415800.
    coneq[17421]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1663200.
    coneq[17422]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/4989600.
    coneq[17423]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/9979200.
    coneq[17424]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/3326400.
    coneq[17425]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/1247400.
    coneq[17426]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/2494800.
    coneq[17427]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/831600.
    coneq[17428]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1663200.
    coneq[17429]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))*c*c)-1/332640.
    coneq[17430]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/997920.
    coneq[17431]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1995840.
    coneq[17432]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/665280.
    coneq[17433]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))*c*c)-1/249480.
    coneq[17434]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/498960.
    coneq[17435]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))*c*c)-1/166320.
    coneq[17436]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/498960.
    coneq[17437]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/997920.
    coneq[17438]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/332640.
    coneq[17439]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**4))))*c*c)-1/69300.
    coneq[17440]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))*c*c)-1/277200.
    coneq[17441]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/831600.
    coneq[17442]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1663200.
    coneq[17443]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/554400.
    coneq[17444]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))*c*c)-1/207900.
    coneq[17445]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/415800.
    coneq[17446]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))*c*c)-1/138600.
    coneq[17447]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/277200.
    coneq[17448]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**3))))*c*c)-1/55440.
    coneq[17449]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))*c*c)-1/166320.
    coneq[17450]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))*c*c)-1/332640.
    coneq[17451]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))*c*c)-1/110880.
    coneq[17452]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**2))))*c*c)-1/41580.
    coneq[17453]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c)))))*c*c)-1/83160.
    coneq[17454]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c))))*c*c)-1/27720.
    coneq[17455]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))*c*c)-1/221760.
    coneq[17456]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))*c*c)-1/665280.
    coneq[17457]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))*c*c)-1/1330560.
    coneq[17458]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))*c*c)-1/443520.
    coneq[17459]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))*c*c)-1/1995840.
    coneq[17460]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))*c*c)-1/3991680.
    coneq[17461]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))*c*c)-1/1330560.
    coneq[17462]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))*c*c)-1/7983360.
    coneq[17463]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))*c*c)-1/2661120.
    coneq[17464]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))*c*c)-1/887040.
    coneq[17465]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))*c*c)-1/207900.
    coneq[17466]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))*c*c)-1/831600.
    coneq[17467]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/2494800.
    coneq[17468]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/4989600.
    coneq[17469]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/1663200.
    coneq[17470]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))*c*c)-1/623700.
    coneq[17471]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/1247400.
    coneq[17472]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))*c*c)-1/415800.
    coneq[17473]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/831600.
    coneq[17474]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))*c*c)-1/415800.
    coneq[17475]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))*c*c)-1/1663200.
    coneq[17476]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/4989600.
    coneq[17477]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/9979200.
    coneq[17478]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/3326400.
    coneq[17479]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))*c*c)-1/1247400.
    coneq[17480]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/2494800.
    coneq[17481]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))*c*c)-1/831600.
    coneq[17482]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/1663200.
    coneq[17483]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5))))*c*c)-1/166320.
    coneq[17484]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))*c*c)-1/831600.
    coneq[17485]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))*c*c)-1/3326400.
    coneq[17486]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/9979200.
    coneq[17487]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/19958400.
    coneq[17488]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/6652800.
    coneq[17489]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/2494800.
    coneq[17490]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/4989600.
    coneq[17491]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/1663200.
    coneq[17492]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/3326400.
    coneq[17493]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))*c*c)-1/665280.
    coneq[17494]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/1995840.
    coneq[17495]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/3991680.
    coneq[17496]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/1330560.
    coneq[17497]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))*c*c)-1/498960.
    coneq[17498]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/997920.
    coneq[17499]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))*c*c)-1/332640.
    coneq[17500]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/997920.
    coneq[17501]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/1995840.
    coneq[17502]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/665280.
    coneq[17503]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))*c*c)-1/166320.
    coneq[17504]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))*c*c)-1/498960.
    coneq[17505]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c*c)-1/997920.
    coneq[17506]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))*c*c)-1/332640.
    coneq[17507]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))*c*c)-1/332640.
    coneq[17508]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c*c)-1/997920.
    coneq[17509]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c*c)-1/1995840.
    coneq[17510]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c*c)-1/665280.
    coneq[17511]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))*c*c)-1/138600.
    coneq[17512]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))*c*c)-1/554400.
    coneq[17513]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1663200.
    coneq[17514]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/3326400.
    coneq[17515]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/1108800.
    coneq[17516]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))*c*c)-1/415800.
    coneq[17517]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/831600.
    coneq[17518]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))*c*c)-1/277200.
    coneq[17519]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/554400.
    coneq[17520]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))*c*c)-1/124740.
    coneq[17521]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/249480.
    coneq[17522]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/498960.
    coneq[17523]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))*c*c)-1/110880.
    coneq[17524]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/332640.
    coneq[17525]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/665280.
    coneq[17526]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/221760.
    coneq[17527]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))*c*c)-1/83160.
    coneq[17528]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/166320.
    coneq[17529]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))*c*c)-1/55440.
    coneq[17530]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))*c*c)-1/221760.
    coneq[17531]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/665280.
    coneq[17532]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/1330560.
    coneq[17533]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/443520.
    coneq[17534]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))*c*c)-1/249480.
    coneq[17535]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/498960.
    coneq[17536]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/997920.
    coneq[17537]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))*c*c)-1/166320.
    coneq[17538]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/332640.
    coneq[17539]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/110880.
    coneq[17540]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/221760.
    coneq[17541]=dot(b,dot(A,dot(A,c*dot(A,c**7)))*c*c)-1/12320.
    coneq[17542]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**6))))*c*c)-1/86240.
    coneq[17543]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5)))))*c*c)-1/517440.
    coneq[17544]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))*c*c)-1/2587200.
    coneq[17545]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c*c)-1/10348800.
    coneq[17546]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c*c)-1/31046400.
    coneq[17547]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c*c)-1/62092800.
    coneq[17548]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c*c)-1/20697600.
    coneq[17549]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c*c)-1/7761600.
    coneq[17550]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c*c)-1/15523200.
    coneq[17551]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c*c)-1/5174400.
    coneq[17552]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c*c)-1/10348800.
    coneq[17553]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c*c)-1/2069760.
    coneq[17554]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c*c)-1/6209280.
    coneq[17555]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c*c)-1/12418560.
    coneq[17556]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c*c)-1/4139520.
    coneq[17557]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c*c)-1/1552320.
    coneq[17558]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c*c)-1/3104640.
    coneq[17559]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c*c)-1/1034880.
    coneq[17560]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c*c)-1/3104640.
    coneq[17561]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c*c)-1/6209280.
    coneq[17562]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c*c)-1/2069760.
    coneq[17563]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))*c*c)-1/431200.
    coneq[17564]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c*c)-1/1724800.
    coneq[17565]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/5174400.
    coneq[17566]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/10348800.
    coneq[17567]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/3449600.
    coneq[17568]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c*c)-1/1293600.
    coneq[17569]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/2587200.
    coneq[17570]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c*c)-1/862400.
    coneq[17571]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1724800.
    coneq[17572]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))*c*c)-1/344960.
    coneq[17573]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c*c)-1/1034880.
    coneq[17574]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c*c)-1/2069760.
    coneq[17575]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c*c)-1/689920.
    coneq[17576]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))*c*c)-1/258720.
    coneq[17577]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c*c)-1/517440.
    coneq[17578]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))*c*c)-1/172480.
    coneq[17579]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c*c)-1/776160.
    coneq[17580]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c*c)-1/1552320.
    coneq[17581]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c*c)-1/3104640.
    coneq[17582]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c*c)-1/689920.
    coneq[17583]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c*c)-1/2069760.
    coneq[17584]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c*c)-1/4139520.
    coneq[17585]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c*c)-1/1379840.
    coneq[17586]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c*c)-1/517440.
    coneq[17587]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/1034880.
    coneq[17588]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c*c)-1/344960.
    coneq[17589]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c*c)-1/689920.
    coneq[17590]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**5))))*c*c)-1/73920.
    coneq[17591]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))*c*c)-1/369600.
    coneq[17592]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1478400.
    coneq[17593]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/4435200.
    coneq[17594]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/8870400.
    coneq[17595]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2956800.
    coneq[17596]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/1108800.
    coneq[17597]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/2217600.
    coneq[17598]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/739200.
    coneq[17599]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1478400.
    coneq[17600]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))*c*c)-1/295680.
    coneq[17601]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/887040.
    coneq[17602]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1774080.
    coneq[17603]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/591360.
    coneq[17604]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))*c*c)-1/221760.
    coneq[17605]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/443520.
    coneq[17606]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))*c*c)-1/147840.
    coneq[17607]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/443520.
    coneq[17608]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/887040.
    coneq[17609]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/295680.
    coneq[17610]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4))))*c*c)-1/61600.
    coneq[17611]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))*c*c)-1/246400.
    coneq[17612]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/739200.
    coneq[17613]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1478400.
    coneq[17614]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/492800.
    coneq[17615]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))*c*c)-1/184800.
    coneq[17616]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/369600.
    coneq[17617]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))*c*c)-1/123200.
    coneq[17618]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/246400.
    coneq[17619]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3))))*c*c)-1/49280.
    coneq[17620]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))*c*c)-1/147840.
    coneq[17621]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c*c)-1/295680.
    coneq[17622]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))*c*c)-1/98560.
    coneq[17623]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2))))*c*c)-1/36960.
    coneq[17624]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))*c*c)-1/73920.
    coneq[17625]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c))))*c*c)-1/24640.
    coneq[17626]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))*c*c)-1/147840.
    coneq[17627]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c*c)-1/443520.
    coneq[17628]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c*c)-1/887040.
    coneq[17629]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c*c)-1/295680.
    coneq[17630]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c*c)-1/295680.
    coneq[17631]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c*c)-1/887040.
    coneq[17632]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c*c)-1/1774080.
    coneq[17633]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c*c)-1/591360.
    coneq[17634]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))*c*c)-1/123200.
    coneq[17635]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c*c)-1/492800.
    coneq[17636]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1478400.
    coneq[17637]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2956800.
    coneq[17638]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/985600.
    coneq[17639]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c*c)-1/369600.
    coneq[17640]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/739200.
    coneq[17641]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c*c)-1/246400.
    coneq[17642]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/492800.
    coneq[17643]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))*c*c)-1/110880.
    coneq[17644]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[17645]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/443520.
    coneq[17646]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))*c*c)-1/98560.
    coneq[17647]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/295680.
    coneq[17648]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/591360.
    coneq[17649]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/197120.
    coneq[17650]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))*c*c)-1/73920.
    coneq[17651]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/147840.
    coneq[17652]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))*c*c)-1/49280.
    coneq[17653]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c*c)-1/147840.
    coneq[17654]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/295680.
    coneq[17655]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/98560.
    coneq[17656]=dot(b,dot(A,dot(A,c**2*dot(A,c**6)))*c*c)-1/10780.
    coneq[17657]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**5))))*c*c)-1/64680.
    coneq[17658]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))*c*c)-1/323400.
    coneq[17659]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1293600.
    coneq[17660]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/3880800.
    coneq[17661]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/7761600.
    coneq[17662]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2587200.
    coneq[17663]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/970200.
    coneq[17664]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1940400.
    coneq[17665]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/646800.
    coneq[17666]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1293600.
    coneq[17667]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/258720.
    coneq[17668]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/776160.
    coneq[17669]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1552320.
    coneq[17670]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/517440.
    coneq[17671]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/194040.
    coneq[17672]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/388080.
    coneq[17673]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/129360.
    coneq[17674]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/388080.
    coneq[17675]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/776160.
    coneq[17676]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/258720.
    coneq[17677]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4))))*c*c)-1/53900.
    coneq[17678]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/215600.
    coneq[17679]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/646800.
    coneq[17680]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1293600.
    coneq[17681]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/431200.
    coneq[17682]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/161700.
    coneq[17683]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/323400.
    coneq[17684]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/107800.
    coneq[17685]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/215600.
    coneq[17686]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3))))*c*c)-1/43120.
    coneq[17687]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/129360.
    coneq[17688]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/258720.
    coneq[17689]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/86240.
    coneq[17690]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2))))*c*c)-1/32340.
    coneq[17691]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/64680.
    coneq[17692]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c))))*c*c)-1/21560.
    coneq[17693]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/97020.
    coneq[17694]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/194040.
    coneq[17695]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/388080.
    coneq[17696]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/86240.
    coneq[17697]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/258720.
    coneq[17698]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/517440.
    coneq[17699]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/172480.
    coneq[17700]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/64680.
    coneq[17701]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/129360.
    coneq[17702]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/43120.
    coneq[17703]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/86240.
    coneq[17704]=dot(b,dot(A,dot(A,c**3*dot(A,c**5)))*c*c)-1/9240.
    coneq[17705]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**4))))*c*c)-1/46200.
    coneq[17706]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/184800.
    coneq[17707]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/554400.
    coneq[17708]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1108800.
    coneq[17709]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/369600.
    coneq[17710]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/138600.
    coneq[17711]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/277200.
    coneq[17712]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/92400.
    coneq[17713]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/184800.
    coneq[17714]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3))))*c*c)-1/36960.
    coneq[17715]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/110880.
    coneq[17716]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/221760.
    coneq[17717]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/73920.
    coneq[17718]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2))))*c*c)-1/27720.
    coneq[17719]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/55440.
    coneq[17720]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c))))*c*c)-1/18480.
    coneq[17721]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/55440.
    coneq[17722]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[17723]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/36960.
    coneq[17724]=dot(b,dot(A,dot(A,c**4*dot(A,c**4)))*c*c)-1/7700.
    coneq[17725]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**3))))*c*c)-1/30800.
    coneq[17726]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/92400.
    coneq[17727]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/184800.
    coneq[17728]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/61600.
    coneq[17729]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2))))*c*c)-1/23100.
    coneq[17730]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/46200.
    coneq[17731]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c))))*c*c)-1/15400.
    coneq[17732]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/30800.
    coneq[17733]=dot(b,dot(A,dot(A,c**5*dot(A,c**3)))*c*c)-1/6160.
    coneq[17734]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**2))))*c*c)-1/18480.
    coneq[17735]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c)))))*c*c)-1/36960.
    coneq[17736]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c))))*c*c)-1/12320.
    coneq[17737]=dot(b,dot(A,dot(A,c**6*dot(A,c**2)))*c*c)-1/4620.
    coneq[17738]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c))))*c*c)-1/9240.
    coneq[17739]=dot(b,dot(A,dot(A,c**7*dot(A,c)))*c*c)-1/3080.
    coneq[17740]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**4)))*c*c)-1/30800.
    coneq[17741]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))*c*c)-1/123200.
    coneq[17742]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/369600.
    coneq[17743]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/739200.
    coneq[17744]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/246400.
    coneq[17745]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))*c*c)-1/92400.
    coneq[17746]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/184800.
    coneq[17747]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))*c*c)-1/61600.
    coneq[17748]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/123200.
    coneq[17749]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))*c*c)-1/92400.
    coneq[17750]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))*c*c)-1/369600.
    coneq[17751]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/1108800.
    coneq[17752]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/2217600.
    coneq[17753]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/739200.
    coneq[17754]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))*c*c)-1/277200.
    coneq[17755]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/554400.
    coneq[17756]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))*c*c)-1/184800.
    coneq[17757]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/369600.
    coneq[17758]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))*c*c)-1/184800.
    coneq[17759]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))*c*c)-1/739200.
    coneq[17760]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/2217600.
    coneq[17761]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/4435200.
    coneq[17762]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/1478400.
    coneq[17763]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))*c*c)-1/554400.
    coneq[17764]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/1108800.
    coneq[17765]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))*c*c)-1/369600.
    coneq[17766]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/739200.
    coneq[17767]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))*c*c)-1/61600.
    coneq[17768]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))*c*c)-1/246400.
    coneq[17769]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/739200.
    coneq[17770]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/1478400.
    coneq[17771]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/492800.
    coneq[17772]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))*c*c)-1/184800.
    coneq[17773]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/369600.
    coneq[17774]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))*c*c)-1/123200.
    coneq[17775]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/246400.
    coneq[17776]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**5)))*c*c)-1/27720.
    coneq[17777]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))*c*c)-1/138600.
    coneq[17778]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/554400.
    coneq[17779]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1663200.
    coneq[17780]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/3326400.
    coneq[17781]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/1108800.
    coneq[17782]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/415800.
    coneq[17783]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/831600.
    coneq[17784]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/277200.
    coneq[17785]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/554400.
    coneq[17786]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))*c*c)-1/110880.
    coneq[17787]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/332640.
    coneq[17788]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/665280.
    coneq[17789]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/221760.
    coneq[17790]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))*c*c)-1/83160.
    coneq[17791]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/166320.
    coneq[17792]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))*c*c)-1/55440.
    coneq[17793]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/166320.
    coneq[17794]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/332640.
    coneq[17795]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/110880.
    coneq[17796]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5)))*c*c)-1/55440.
    coneq[17797]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))*c*c)-1/277200.
    coneq[17798]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/1108800.
    coneq[17799]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/3326400.
    coneq[17800]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/6652800.
    coneq[17801]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/2217600.
    coneq[17802]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/831600.
    coneq[17803]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/1663200.
    coneq[17804]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/554400.
    coneq[17805]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/1108800.
    coneq[17806]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))*c*c)-1/221760.
    coneq[17807]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/665280.
    coneq[17808]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/1330560.
    coneq[17809]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/443520.
    coneq[17810]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))*c*c)-1/166320.
    coneq[17811]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/332640.
    coneq[17812]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))*c*c)-1/110880.
    coneq[17813]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/332640.
    coneq[17814]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/665280.
    coneq[17815]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/221760.
    coneq[17816]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**6)))*c*c)-1/21560.
    coneq[17817]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5))))*c*c)-1/129360.
    coneq[17818]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))*c*c)-1/646800.
    coneq[17819]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/2587200.
    coneq[17820]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/7761600.
    coneq[17821]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/15523200.
    coneq[17822]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/5174400.
    coneq[17823]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/1940400.
    coneq[17824]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/3880800.
    coneq[17825]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/1293600.
    coneq[17826]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/2587200.
    coneq[17827]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/517440.
    coneq[17828]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/1552320.
    coneq[17829]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/3104640.
    coneq[17830]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/1034880.
    coneq[17831]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/388080.
    coneq[17832]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/776160.
    coneq[17833]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/258720.
    coneq[17834]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/776160.
    coneq[17835]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/1552320.
    coneq[17836]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/517440.
    coneq[17837]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))*c*c)-1/107800.
    coneq[17838]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/431200.
    coneq[17839]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1293600.
    coneq[17840]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2587200.
    coneq[17841]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/862400.
    coneq[17842]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/323400.
    coneq[17843]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/646800.
    coneq[17844]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/215600.
    coneq[17845]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/431200.
    coneq[17846]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))*c*c)-1/86240.
    coneq[17847]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/258720.
    coneq[17848]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/517440.
    coneq[17849]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/172480.
    coneq[17850]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))*c*c)-1/64680.
    coneq[17851]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/129360.
    coneq[17852]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))*c*c)-1/43120.
    coneq[17853]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/194040.
    coneq[17854]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/388080.
    coneq[17855]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/776160.
    coneq[17856]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/172480.
    coneq[17857]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/517440.
    coneq[17858]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/1034880.
    coneq[17859]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/344960.
    coneq[17860]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/129360.
    coneq[17861]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/258720.
    coneq[17862]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/86240.
    coneq[17863]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/172480.
    coneq[17864]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3)))*c*c)-1/24640.
    coneq[17865]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))*c*c)-1/73920.
    coneq[17866]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c*c)-1/147840.
    coneq[17867]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))*c*c)-1/49280.
    coneq[17868]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c*c)-1/221760.
    coneq[17869]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c*c)-1/443520.
    coneq[17870]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c*c)-1/147840.
    coneq[17871]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c*c)-1/887040.
    coneq[17872]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c*c)-1/295680.
    coneq[17873]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/98560.
    coneq[17874]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4)))*c*c)-1/23100.
    coneq[17875]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))*c*c)-1/92400.
    coneq[17876]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/277200.
    coneq[17877]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/554400.
    coneq[17878]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/184800.
    coneq[17879]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))*c*c)-1/69300.
    coneq[17880]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/138600.
    coneq[17881]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))*c*c)-1/46200.
    coneq[17882]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/92400.
    coneq[17883]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))*c*c)-1/46200.
    coneq[17884]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c*c)-1/184800.
    coneq[17885]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/554400.
    coneq[17886]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/1108800.
    coneq[17887]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/369600.
    coneq[17888]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c*c)-1/138600.
    coneq[17889]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/277200.
    coneq[17890]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c*c)-1/92400.
    coneq[17891]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/184800.
    coneq[17892]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**5)))*c*c)-1/18480.
    coneq[17893]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))*c*c)-1/92400.
    coneq[17894]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/369600.
    coneq[17895]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1108800.
    coneq[17896]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2217600.
    coneq[17897]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/739200.
    coneq[17898]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/277200.
    coneq[17899]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/554400.
    coneq[17900]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/184800.
    coneq[17901]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/369600.
    coneq[17902]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))*c*c)-1/73920.
    coneq[17903]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/221760.
    coneq[17904]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/443520.
    coneq[17905]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/147840.
    coneq[17906]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))*c*c)-1/55440.
    coneq[17907]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[17908]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))*c*c)-1/36960.
    coneq[17909]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/110880.
    coneq[17910]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[17911]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/73920.
    coneq[17912]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3)))*c*c)-1/18480.
    coneq[17913]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/55440.
    coneq[17914]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[17915]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/36960.
    coneq[17916]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/36960.
    coneq[17917]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/110880.
    coneq[17918]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[17919]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/73920.
    coneq[17920]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4)))*c*c)-1/15400.
    coneq[17921]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/61600.
    coneq[17922]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/184800.
    coneq[17923]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/369600.
    coneq[17924]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/123200.
    coneq[17925]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/46200.
    coneq[17926]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/92400.
    coneq[17927]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/30800.
    coneq[17928]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/61600.
    coneq[17929]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2)))*c*c)-1/13860.
    coneq[17930]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/27720.
    coneq[17931]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/55440.
    coneq[17932]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3)))*c*c)-1/12320.
    coneq[17933]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/36960.
    coneq[17934]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/73920.
    coneq[17935]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/24640.
    coneq[17936]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2)))*c*c)-1/9240.
    coneq[17937]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/18480.
    coneq[17938]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c)))*c*c)-1/6160.
    coneq[17939]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))*c*c)-1/30800.
    coneq[17940]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/123200.
    coneq[17941]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/369600.
    coneq[17942]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/739200.
    coneq[17943]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/246400.
    coneq[17944]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/92400.
    coneq[17945]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/184800.
    coneq[17946]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/61600.
    coneq[17947]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/123200.
    coneq[17948]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))*c*c)-1/36960.
    coneq[17949]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/110880.
    coneq[17950]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[17951]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/73920.
    coneq[17952]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/73920.
    coneq[17953]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/221760.
    coneq[17954]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/443520.
    coneq[17955]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/147840.
    coneq[17956]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))*c*c)-1/41580.
    coneq[17957]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/83160.
    coneq[17958]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/166320.
    coneq[17959]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/332640.
    coneq[17960]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))*c*c)-1/24640.
    coneq[17961]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/73920.
    coneq[17962]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/147840.
    coneq[17963]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/49280.
    coneq[17964]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c*c)-1/27720.
    coneq[17965]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/55440.
    coneq[17966]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/110880.
    coneq[17967]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/18480.
    coneq[17968]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/36960.
    coneq[17969]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/12320.
    coneq[17970]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/36960.
    coneq[17971]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/73920.
    coneq[17972]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/24640.
    coneq[17973]=dot(b,dot(A,c*dot(A,c**8))*c*c)-1/1386.
    coneq[17974]=dot(b,dot(A,c*dot(A,dot(A,c**7)))*c*c)-1/11088.
    coneq[17975]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**6))))*c*c)-1/77616.
    coneq[17976]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5)))))*c*c)-1/465696.
    coneq[17977]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c*c)-1/2328480.
    coneq[17978]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c*c)-1/9313920.
    coneq[17979]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c*c)-1/27941760.
    coneq[17980]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c*c)-1/55883520.
    coneq[17981]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c*c)-1/18627840.
    coneq[17982]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c*c)-1/6985440.
    coneq[17983]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c*c)-1/13970880.
    coneq[17984]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c*c)-1/4656960.
    coneq[17985]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c*c)-1/9313920.
    coneq[17986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c*c)-1/1862784.
    coneq[17987]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c*c)-1/5588352.
    coneq[17988]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c*c)-1/11176704.
    coneq[17989]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c*c)-1/3725568.
    coneq[17990]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c*c)-1/1397088.
    coneq[17991]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c*c)-1/2794176.
    coneq[17992]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c*c)-1/931392.
    coneq[17993]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c*c)-1/2794176.
    coneq[17994]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c*c)-1/5588352.
    coneq[17995]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c*c)-1/1862784.
    coneq[17996]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c*c)-1/388080.
    coneq[17997]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c*c)-1/1552320.
    coneq[17998]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/4656960.
    coneq[17999]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/9313920.
    coneq[18000]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/3104640.
    coneq[18001]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c*c)-1/1164240.
    coneq[18002]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/2328480.
    coneq[18003]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c*c)-1/776160.
    coneq[18004]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1552320.
    coneq[18005]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c*c)-1/310464.
    coneq[18006]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c*c)-1/931392.
    coneq[18007]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1862784.
    coneq[18008]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c*c)-1/620928.
    coneq[18009]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c*c)-1/232848.
    coneq[18010]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c*c)-1/465696.
    coneq[18011]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c*c)-1/155232.
    coneq[18012]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c*c)-1/698544.
    coneq[18013]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c*c)-1/1397088.
    coneq[18014]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c*c)-1/2794176.
    coneq[18015]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c*c)-1/620928.
    coneq[18016]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c*c)-1/1862784.
    coneq[18017]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c*c)-1/3725568.
    coneq[18018]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c*c)-1/1241856.
    coneq[18019]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c*c)-1/465696.
    coneq[18020]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/931392.
    coneq[18021]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c*c)-1/310464.
    coneq[18022]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c*c)-1/620928.
    coneq[18023]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**5))))*c*c)-1/66528.
    coneq[18024]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c*c)-1/332640.
    coneq[18025]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1330560.
    coneq[18026]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/3991680.
    coneq[18027]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/7983360.
    coneq[18028]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2661120.
    coneq[18029]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/997920.
    coneq[18030]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1995840.
    coneq[18031]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/665280.
    coneq[18032]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1330560.
    coneq[18033]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c*c)-1/266112.
    coneq[18034]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/798336.
    coneq[18035]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1596672.
    coneq[18036]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/532224.
    coneq[18037]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c*c)-1/199584.
    coneq[18038]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/399168.
    coneq[18039]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c*c)-1/133056.
    coneq[18040]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/399168.
    coneq[18041]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/798336.
    coneq[18042]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/266112.
    coneq[18043]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4))))*c*c)-1/55440.
    coneq[18044]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c*c)-1/221760.
    coneq[18045]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/665280.
    coneq[18046]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1330560.
    coneq[18047]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/443520.
    coneq[18048]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c*c)-1/166320.
    coneq[18049]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/332640.
    coneq[18050]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c*c)-1/110880.
    coneq[18051]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/221760.
    coneq[18052]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3))))*c*c)-1/44352.
    coneq[18053]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c*c)-1/133056.
    coneq[18054]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c*c)-1/266112.
    coneq[18055]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c*c)-1/88704.
    coneq[18056]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2))))*c*c)-1/33264.
    coneq[18057]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c*c)-1/66528.
    coneq[18058]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c))))*c*c)-1/22176.
    coneq[18059]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c*c)-1/133056.
    coneq[18060]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c*c)-1/399168.
    coneq[18061]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c*c)-1/798336.
    coneq[18062]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c*c)-1/266112.
    coneq[18063]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c*c)-1/266112.
    coneq[18064]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c*c)-1/798336.
    coneq[18065]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c*c)-1/1596672.
    coneq[18066]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c*c)-1/532224.
    coneq[18067]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c*c)-1/110880.
    coneq[18068]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c*c)-1/443520.
    coneq[18069]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1330560.
    coneq[18070]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2661120.
    coneq[18071]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/887040.
    coneq[18072]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c*c)-1/332640.
    coneq[18073]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/665280.
    coneq[18074]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c*c)-1/221760.
    coneq[18075]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/443520.
    coneq[18076]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c*c)-1/99792.
    coneq[18077]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/199584.
    coneq[18078]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/399168.
    coneq[18079]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c*c)-1/88704.
    coneq[18080]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/266112.
    coneq[18081]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/532224.
    coneq[18082]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/177408.
    coneq[18083]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c*c)-1/66528.
    coneq[18084]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/133056.
    coneq[18085]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c*c)-1/44352.
    coneq[18086]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c*c)-1/133056.
    coneq[18087]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/266112.
    coneq[18088]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/88704.
    coneq[18089]=dot(b,dot(A,c*dot(A,c*dot(A,c**6)))*c*c)-1/9702.
    coneq[18090]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**5))))*c*c)-1/58212.
    coneq[18091]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c*c)-1/291060.
    coneq[18092]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1164240.
    coneq[18093]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/3492720.
    coneq[18094]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/6985440.
    coneq[18095]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2328480.
    coneq[18096]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/873180.
    coneq[18097]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1746360.
    coneq[18098]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/582120.
    coneq[18099]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1164240.
    coneq[18100]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/232848.
    coneq[18101]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/698544.
    coneq[18102]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1397088.
    coneq[18103]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/465696.
    coneq[18104]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/174636.
    coneq[18105]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/349272.
    coneq[18106]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/116424.
    coneq[18107]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/349272.
    coneq[18108]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/698544.
    coneq[18109]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/232848.
    coneq[18110]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4))))*c*c)-1/48510.
    coneq[18111]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/194040.
    coneq[18112]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/582120.
    coneq[18113]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1164240.
    coneq[18114]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/388080.
    coneq[18115]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/145530.
    coneq[18116]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/291060.
    coneq[18117]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/97020.
    coneq[18118]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/194040.
    coneq[18119]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3))))*c*c)-1/38808.
    coneq[18120]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/116424.
    coneq[18121]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/232848.
    coneq[18122]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/77616.
    coneq[18123]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2))))*c*c)-1/29106.
    coneq[18124]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/58212.
    coneq[18125]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c))))*c*c)-1/19404.
    coneq[18126]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/87318.
    coneq[18127]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/174636.
    coneq[18128]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/349272.
    coneq[18129]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/77616.
    coneq[18130]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/232848.
    coneq[18131]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/465696.
    coneq[18132]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/155232.
    coneq[18133]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/58212.
    coneq[18134]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/116424.
    coneq[18135]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/38808.
    coneq[18136]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/77616.
    coneq[18137]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**5)))*c*c)-1/8316.
    coneq[18138]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4))))*c*c)-1/41580.
    coneq[18139]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/166320.
    coneq[18140]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/498960.
    coneq[18141]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/997920.
    coneq[18142]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/332640.
    coneq[18143]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/124740.
    coneq[18144]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/249480.
    coneq[18145]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/83160.
    coneq[18146]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/166320.
    coneq[18147]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3))))*c*c)-1/33264.
    coneq[18148]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/99792.
    coneq[18149]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/199584.
    coneq[18150]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/66528.
    coneq[18151]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c*c)-1/24948.
    coneq[18152]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/49896.
    coneq[18153]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c))))*c*c)-1/16632.
    coneq[18154]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/49896.
    coneq[18155]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/99792.
    coneq[18156]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/33264.
    coneq[18157]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**4)))*c*c)-1/6930.
    coneq[18158]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3))))*c*c)-1/27720.
    coneq[18159]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/83160.
    coneq[18160]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/166320.
    coneq[18161]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/55440.
    coneq[18162]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2))))*c*c)-1/20790.
    coneq[18163]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/41580.
    coneq[18164]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c))))*c*c)-1/13860.
    coneq[18165]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/27720.
    coneq[18166]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**3)))*c*c)-1/5544.
    coneq[18167]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2))))*c*c)-1/16632.
    coneq[18168]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c*c)-1/33264.
    coneq[18169]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c))))*c*c)-1/11088.
    coneq[18170]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**2)))*c*c)-1/4158.
    coneq[18171]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c))))*c*c)-1/8316.
    coneq[18172]=dot(b,dot(A,c*dot(A,c**6*dot(A,c)))*c*c)-1/2772.
    coneq[18173]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3)))*c*c)-1/22176.
    coneq[18174]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c*c)-1/66528.
    coneq[18175]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c*c)-1/133056.
    coneq[18176]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c*c)-1/44352.
    coneq[18177]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c*c)-1/199584.
    coneq[18178]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c*c)-1/399168.
    coneq[18179]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c*c)-1/133056.
    coneq[18180]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c*c)-1/798336.
    coneq[18181]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c*c)-1/266112.
    coneq[18182]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/88704.
    coneq[18183]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4)))*c*c)-1/20790.
    coneq[18184]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c*c)-1/83160.
    coneq[18185]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/249480.
    coneq[18186]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/498960.
    coneq[18187]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/166320.
    coneq[18188]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c*c)-1/62370.
    coneq[18189]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/124740.
    coneq[18190]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c*c)-1/41580.
    coneq[18191]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/83160.
    coneq[18192]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c*c)-1/41580.
    coneq[18193]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c*c)-1/166320.
    coneq[18194]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/498960.
    coneq[18195]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/997920.
    coneq[18196]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/332640.
    coneq[18197]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c*c)-1/124740.
    coneq[18198]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/249480.
    coneq[18199]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c*c)-1/83160.
    coneq[18200]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/166320.
    coneq[18201]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**5)))*c*c)-1/16632.
    coneq[18202]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c*c)-1/83160.
    coneq[18203]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/332640.
    coneq[18204]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/997920.
    coneq[18205]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1995840.
    coneq[18206]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/665280.
    coneq[18207]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/249480.
    coneq[18208]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/498960.
    coneq[18209]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/166320.
    coneq[18210]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/332640.
    coneq[18211]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c*c)-1/66528.
    coneq[18212]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/199584.
    coneq[18213]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/399168.
    coneq[18214]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/133056.
    coneq[18215]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c*c)-1/49896.
    coneq[18216]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/99792.
    coneq[18217]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c*c)-1/33264.
    coneq[18218]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/99792.
    coneq[18219]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/199584.
    coneq[18220]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/66528.
    coneq[18221]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3)))*c*c)-1/16632.
    coneq[18222]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/49896.
    coneq[18223]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/99792.
    coneq[18224]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/33264.
    coneq[18225]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/33264.
    coneq[18226]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/99792.
    coneq[18227]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/199584.
    coneq[18228]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/66528.
    coneq[18229]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4)))*c*c)-1/13860.
    coneq[18230]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/55440.
    coneq[18231]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/166320.
    coneq[18232]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/332640.
    coneq[18233]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/110880.
    coneq[18234]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/41580.
    coneq[18235]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/83160.
    coneq[18236]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/27720.
    coneq[18237]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/55440.
    coneq[18238]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c*c)-1/12474.
    coneq[18239]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/24948.
    coneq[18240]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/49896.
    coneq[18241]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3)))*c*c)-1/11088.
    coneq[18242]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/33264.
    coneq[18243]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/66528.
    coneq[18244]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/22176.
    coneq[18245]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2)))*c*c)-1/8316.
    coneq[18246]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/16632.
    coneq[18247]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c)))*c*c)-1/5544.
    coneq[18248]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c*c)-1/22176.
    coneq[18249]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/66528.
    coneq[18250]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/133056.
    coneq[18251]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/44352.
    coneq[18252]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c*c)-1/24948.
    coneq[18253]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/49896.
    coneq[18254]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/99792.
    coneq[18255]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/16632.
    coneq[18256]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/33264.
    coneq[18257]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/11088.
    coneq[18258]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/22176.
    coneq[18259]=dot(b,dot(A,c**2*dot(A,c**7))*c*c)-1/1232.
    coneq[18260]=dot(b,dot(A,c**2*dot(A,dot(A,c**6)))*c*c)-1/8624.
    coneq[18261]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**5))))*c*c)-1/51744.
    coneq[18262]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4)))))*c*c)-1/258720.
    coneq[18263]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/1034880.
    coneq[18264]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/3104640.
    coneq[18265]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/6209280.
    coneq[18266]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/2069760.
    coneq[18267]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/776160.
    coneq[18268]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/1552320.
    coneq[18269]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/517440.
    coneq[18270]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/1034880.
    coneq[18271]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/206976.
    coneq[18272]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/620928.
    coneq[18273]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/1241856.
    coneq[18274]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/413952.
    coneq[18275]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/155232.
    coneq[18276]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/310464.
    coneq[18277]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/103488.
    coneq[18278]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/310464.
    coneq[18279]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/620928.
    coneq[18280]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/206976.
    coneq[18281]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4))))*c*c)-1/43120.
    coneq[18282]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/172480.
    coneq[18283]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/517440.
    coneq[18284]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1034880.
    coneq[18285]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/344960.
    coneq[18286]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/129360.
    coneq[18287]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/258720.
    coneq[18288]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/86240.
    coneq[18289]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/172480.
    coneq[18290]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3))))*c*c)-1/34496.
    coneq[18291]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/103488.
    coneq[18292]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/206976.
    coneq[18293]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/68992.
    coneq[18294]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2))))*c*c)-1/25872.
    coneq[18295]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/51744.
    coneq[18296]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c))))*c*c)-1/17248.
    coneq[18297]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/77616.
    coneq[18298]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/155232.
    coneq[18299]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/310464.
    coneq[18300]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/68992.
    coneq[18301]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/206976.
    coneq[18302]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/413952.
    coneq[18303]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/137984.
    coneq[18304]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/51744.
    coneq[18305]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/103488.
    coneq[18306]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/34496.
    coneq[18307]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/68992.
    coneq[18308]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**5)))*c*c)-1/7392.
    coneq[18309]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4))))*c*c)-1/36960.
    coneq[18310]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/147840.
    coneq[18311]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/443520.
    coneq[18312]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/887040.
    coneq[18313]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/295680.
    coneq[18314]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/110880.
    coneq[18315]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/221760.
    coneq[18316]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/73920.
    coneq[18317]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/147840.
    coneq[18318]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3))))*c*c)-1/29568.
    coneq[18319]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/88704.
    coneq[18320]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/177408.
    coneq[18321]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/59136.
    coneq[18322]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2))))*c*c)-1/22176.
    coneq[18323]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/44352.
    coneq[18324]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c))))*c*c)-1/14784.
    coneq[18325]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/44352.
    coneq[18326]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/88704.
    coneq[18327]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/29568.
    coneq[18328]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**4)))*c*c)-1/6160.
    coneq[18329]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3))))*c*c)-1/24640.
    coneq[18330]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/73920.
    coneq[18331]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/147840.
    coneq[18332]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/49280.
    coneq[18333]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2))))*c*c)-1/18480.
    coneq[18334]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/36960.
    coneq[18335]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c))))*c*c)-1/12320.
    coneq[18336]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/24640.
    coneq[18337]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**3)))*c*c)-1/4928.
    coneq[18338]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2))))*c*c)-1/14784.
    coneq[18339]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c*c)-1/29568.
    coneq[18340]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c))))*c*c)-1/9856.
    coneq[18341]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**2)))*c*c)-1/3696.
    coneq[18342]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c))))*c*c)-1/7392.
    coneq[18343]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c)))*c*c)-1/2464.
    coneq[18344]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3)))*c*c)-1/14784.
    coneq[18345]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/44352.
    coneq[18346]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/88704.
    coneq[18347]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/29568.
    coneq[18348]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/29568.
    coneq[18349]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/88704.
    coneq[18350]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/177408.
    coneq[18351]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/59136.
    coneq[18352]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4)))*c*c)-1/12320.
    coneq[18353]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/49280.
    coneq[18354]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/147840.
    coneq[18355]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/295680.
    coneq[18356]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/98560.
    coneq[18357]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/36960.
    coneq[18358]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/73920.
    coneq[18359]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/24640.
    coneq[18360]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/49280.
    coneq[18361]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c*c)-1/11088.
    coneq[18362]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[18363]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[18364]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3)))*c*c)-1/9856.
    coneq[18365]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/29568.
    coneq[18366]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/59136.
    coneq[18367]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/19712.
    coneq[18368]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c*c)-1/7392.
    coneq[18369]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/14784.
    coneq[18370]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c)))*c*c)-1/4928.
    coneq[18371]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/14784.
    coneq[18372]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/29568.
    coneq[18373]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/9856.
    coneq[18374]=dot(b,dot(A,c**3*dot(A,c**6))*c*c)-1/1078.
    coneq[18375]=dot(b,dot(A,c**3*dot(A,dot(A,c**5)))*c*c)-1/6468.
    coneq[18376]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**4))))*c*c)-1/32340.
    coneq[18377]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/129360.
    coneq[18378]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/388080.
    coneq[18379]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/776160.
    coneq[18380]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/258720.
    coneq[18381]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/97020.
    coneq[18382]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/194040.
    coneq[18383]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/64680.
    coneq[18384]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/129360.
    coneq[18385]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/25872.
    coneq[18386]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/77616.
    coneq[18387]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/155232.
    coneq[18388]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/51744.
    coneq[18389]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/19404.
    coneq[18390]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/38808.
    coneq[18391]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/12936.
    coneq[18392]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/38808.
    coneq[18393]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/77616.
    coneq[18394]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/25872.
    coneq[18395]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**4)))*c*c)-1/5390.
    coneq[18396]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/21560.
    coneq[18397]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/64680.
    coneq[18398]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/129360.
    coneq[18399]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/43120.
    coneq[18400]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/16170.
    coneq[18401]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/32340.
    coneq[18402]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/10780.
    coneq[18403]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/21560.
    coneq[18404]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**3)))*c*c)-1/4312.
    coneq[18405]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/12936.
    coneq[18406]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/25872.
    coneq[18407]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/8624.
    coneq[18408]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**2)))*c*c)-1/3234.
    coneq[18409]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/6468.
    coneq[18410]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c)))*c*c)-1/2156.
    coneq[18411]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/9702.
    coneq[18412]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/19404.
    coneq[18413]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/38808.
    coneq[18414]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/8624.
    coneq[18415]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/25872.
    coneq[18416]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/51744.
    coneq[18417]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/17248.
    coneq[18418]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/6468.
    coneq[18419]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/12936.
    coneq[18420]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/4312.
    coneq[18421]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/8624.
    coneq[18422]=dot(b,dot(A,c**4*dot(A,c**5))*c*c)-1/924.
    coneq[18423]=dot(b,dot(A,c**4*dot(A,dot(A,c**4)))*c*c)-1/4620.
    coneq[18424]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**3))))*c*c)-1/18480.
    coneq[18425]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/55440.
    coneq[18426]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/110880.
    coneq[18427]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/36960.
    coneq[18428]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/13860.
    coneq[18429]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/27720.
    coneq[18430]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/9240.
    coneq[18431]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/18480.
    coneq[18432]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**3)))*c*c)-1/3696.
    coneq[18433]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/11088.
    coneq[18434]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/22176.
    coneq[18435]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/7392.
    coneq[18436]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**2)))*c*c)-1/2772.
    coneq[18437]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/5544.
    coneq[18438]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c)))*c*c)-1/1848.
    coneq[18439]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/5544.
    coneq[18440]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/11088.
    coneq[18441]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/3696.
    coneq[18442]=dot(b,dot(A,c**5*dot(A,c**4))*c*c)-1/770.
    coneq[18443]=dot(b,dot(A,c**5*dot(A,dot(A,c**3)))*c*c)-1/3080.
    coneq[18444]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**2))))*c*c)-1/9240.
    coneq[18445]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/18480.
    coneq[18446]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c))))*c*c)-1/6160.
    coneq[18447]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**2)))*c*c)-1/2310.
    coneq[18448]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c))))*c*c)-1/4620.
    coneq[18449]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c)))*c*c)-1/1540.
    coneq[18450]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/3080.
    coneq[18451]=dot(b,dot(A,c**6*dot(A,c**3))*c*c)-1/616.
    coneq[18452]=dot(b,dot(A,c**6*dot(A,dot(A,c**2)))*c*c)-1/1848.
    coneq[18453]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c))))*c*c)-1/3696.
    coneq[18454]=dot(b,dot(A,c**6*dot(A,c*dot(A,c)))*c*c)-1/1232.
    coneq[18455]=dot(b,dot(A,c**7*dot(A,c**2))*c*c)-1/462.
    coneq[18456]=dot(b,dot(A,c**7*dot(A,dot(A,c)))*c*c)-1/924.
    coneq[18457]=dot(b,dot(A,c**8*dot(A,c))*c*c)-1/308.
    coneq[18458]=dot(b,dot(A,dot(A,c**4)*dot(A,c**4))*c*c)-1/3850.
    coneq[18459]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**3)))*c*c)-1/15400.
    coneq[18460]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/46200.
    coneq[18461]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/92400.
    coneq[18462]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/30800.
    coneq[18463]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2)))*c*c)-1/11550.
    coneq[18464]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/23100.
    coneq[18465]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c)))*c*c)-1/7700.
    coneq[18466]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/15400.
    coneq[18467]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))*c*c)-1/61600.
    coneq[18468]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/184800.
    coneq[18469]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/369600.
    coneq[18470]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/123200.
    coneq[18471]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))*c*c)-1/46200.
    coneq[18472]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/92400.
    coneq[18473]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))*c*c)-1/30800.
    coneq[18474]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/61600.
    coneq[18475]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/554400.
    coneq[18476]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/1108800.
    coneq[18477]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/369600.
    coneq[18478]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))*c*c)-1/138600.
    coneq[18479]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/277200.
    coneq[18480]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))*c*c)-1/92400.
    coneq[18481]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/184800.
    coneq[18482]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/2217600.
    coneq[18483]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/739200.
    coneq[18484]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))*c*c)-1/277200.
    coneq[18485]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/554400.
    coneq[18486]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))*c*c)-1/184800.
    coneq[18487]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/369600.
    coneq[18488]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/246400.
    coneq[18489]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))*c*c)-1/92400.
    coneq[18490]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/184800.
    coneq[18491]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))*c*c)-1/61600.
    coneq[18492]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/123200.
    coneq[18493]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))*c*c)-1/34650.
    coneq[18494]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/69300.
    coneq[18495]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))*c*c)-1/23100.
    coneq[18496]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/46200.
    coneq[18497]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/138600.
    coneq[18498]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c*c)-1/46200.
    coneq[18499]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/92400.
    coneq[18500]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/15400.
    coneq[18501]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/30800.
    coneq[18502]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/61600.
    coneq[18503]=dot(b,dot(A,dot(A,c**3)*dot(A,c**5))*c*c)-1/3696.
    coneq[18504]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**4)))*c*c)-1/18480.
    coneq[18505]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/73920.
    coneq[18506]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/221760.
    coneq[18507]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/443520.
    coneq[18508]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/147840.
    coneq[18509]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/55440.
    coneq[18510]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[18511]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/36960.
    coneq[18512]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/73920.
    coneq[18513]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3)))*c*c)-1/14784.
    coneq[18514]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/44352.
    coneq[18515]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/88704.
    coneq[18516]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/29568.
    coneq[18517]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2)))*c*c)-1/11088.
    coneq[18518]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[18519]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c)))*c*c)-1/7392.
    coneq[18520]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/22176.
    coneq[18521]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[18522]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/14784.
    coneq[18523]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**5))*c*c)-1/11088.
    coneq[18524]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))*c*c)-1/55440.
    coneq[18525]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))*c*c)-1/221760.
    coneq[18526]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/665280.
    coneq[18527]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/1330560.
    coneq[18528]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/443520.
    coneq[18529]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/166320.
    coneq[18530]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/332640.
    coneq[18531]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/110880.
    coneq[18532]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/221760.
    coneq[18533]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))*c*c)-1/44352.
    coneq[18534]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/133056.
    coneq[18535]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/266112.
    coneq[18536]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/88704.
    coneq[18537]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))*c*c)-1/33264.
    coneq[18538]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/66528.
    coneq[18539]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))*c*c)-1/22176.
    coneq[18540]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/66528.
    coneq[18541]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/133056.
    coneq[18542]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/44352.
    coneq[18543]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5))*c*c)-1/22176.
    coneq[18544]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))*c*c)-1/110880.
    coneq[18545]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))*c*c)-1/443520.
    coneq[18546]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/1330560.
    coneq[18547]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/2661120.
    coneq[18548]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/887040.
    coneq[18549]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/332640.
    coneq[18550]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/665280.
    coneq[18551]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/221760.
    coneq[18552]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/443520.
    coneq[18553]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))*c*c)-1/88704.
    coneq[18554]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/266112.
    coneq[18555]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/532224.
    coneq[18556]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/177408.
    coneq[18557]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))*c*c)-1/66528.
    coneq[18558]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/133056.
    coneq[18559]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))*c*c)-1/44352.
    coneq[18560]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/133056.
    coneq[18561]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/266112.
    coneq[18562]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/88704.
    coneq[18563]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**5))*c*c)-1/7392.
    coneq[18564]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))*c*c)-1/36960.
    coneq[18565]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c*c)-1/147840.
    coneq[18566]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/443520.
    coneq[18567]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/887040.
    coneq[18568]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/295680.
    coneq[18569]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/110880.
    coneq[18570]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[18571]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/73920.
    coneq[18572]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/147840.
    coneq[18573]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))*c*c)-1/29568.
    coneq[18574]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/88704.
    coneq[18575]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/177408.
    coneq[18576]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/59136.
    coneq[18577]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))*c*c)-1/22176.
    coneq[18578]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[18579]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))*c*c)-1/14784.
    coneq[18580]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/44352.
    coneq[18581]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/88704.
    coneq[18582]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/29568.
    coneq[18583]=dot(b,dot(A,dot(A,c**2)*dot(A,c**6))*c*c)-1/3234.
    coneq[18584]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**5)))*c*c)-1/19404.
    coneq[18585]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))*c*c)-1/97020.
    coneq[18586]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/388080.
    coneq[18587]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1164240.
    coneq[18588]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2328480.
    coneq[18589]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/776160.
    coneq[18590]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/291060.
    coneq[18591]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/582120.
    coneq[18592]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/194040.
    coneq[18593]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/388080.
    coneq[18594]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/77616.
    coneq[18595]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/232848.
    coneq[18596]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/465696.
    coneq[18597]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/155232.
    coneq[18598]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/58212.
    coneq[18599]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/116424.
    coneq[18600]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/38808.
    coneq[18601]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/116424.
    coneq[18602]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/232848.
    coneq[18603]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/77616.
    coneq[18604]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4)))*c*c)-1/16170.
    coneq[18605]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/64680.
    coneq[18606]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/194040.
    coneq[18607]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/388080.
    coneq[18608]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/129360.
    coneq[18609]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/48510.
    coneq[18610]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/97020.
    coneq[18611]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/32340.
    coneq[18612]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/64680.
    coneq[18613]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3)))*c*c)-1/12936.
    coneq[18614]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/38808.
    coneq[18615]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/77616.
    coneq[18616]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/25872.
    coneq[18617]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2)))*c*c)-1/9702.
    coneq[18618]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/19404.
    coneq[18619]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c)))*c*c)-1/6468.
    coneq[18620]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/29106.
    coneq[18621]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/58212.
    coneq[18622]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/116424.
    coneq[18623]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/25872.
    coneq[18624]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/77616.
    coneq[18625]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/155232.
    coneq[18626]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/51744.
    coneq[18627]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/19404.
    coneq[18628]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/38808.
    coneq[18629]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/12936.
    coneq[18630]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/25872.
    coneq[18631]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**6))*c*c)-1/6468.
    coneq[18632]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5)))*c*c)-1/38808.
    coneq[18633]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))*c*c)-1/194040.
    coneq[18634]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/776160.
    coneq[18635]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/2328480.
    coneq[18636]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/4656960.
    coneq[18637]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/1552320.
    coneq[18638]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/582120.
    coneq[18639]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/1164240.
    coneq[18640]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/388080.
    coneq[18641]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/776160.
    coneq[18642]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/155232.
    coneq[18643]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/465696.
    coneq[18644]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/931392.
    coneq[18645]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/310464.
    coneq[18646]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/116424.
    coneq[18647]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/232848.
    coneq[18648]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/77616.
    coneq[18649]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/232848.
    coneq[18650]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/465696.
    coneq[18651]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/155232.
    coneq[18652]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))*c*c)-1/32340.
    coneq[18653]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/129360.
    coneq[18654]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/388080.
    coneq[18655]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/776160.
    coneq[18656]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/258720.
    coneq[18657]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/97020.
    coneq[18658]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/194040.
    coneq[18659]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/64680.
    coneq[18660]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/129360.
    coneq[18661]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))*c*c)-1/25872.
    coneq[18662]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/77616.
    coneq[18663]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/155232.
    coneq[18664]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/51744.
    coneq[18665]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))*c*c)-1/19404.
    coneq[18666]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/38808.
    coneq[18667]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))*c*c)-1/12936.
    coneq[18668]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/58212.
    coneq[18669]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/116424.
    coneq[18670]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/232848.
    coneq[18671]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/51744.
    coneq[18672]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/155232.
    coneq[18673]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/310464.
    coneq[18674]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/103488.
    coneq[18675]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/38808.
    coneq[18676]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/77616.
    coneq[18677]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/25872.
    coneq[18678]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/51744.
    coneq[18679]=dot(b,dot(A,dot(A,c)*dot(A,c**7))*c*c)-1/2464.
    coneq[18680]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**6)))*c*c)-1/17248.
    coneq[18681]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5))))*c*c)-1/103488.
    coneq[18682]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))*c*c)-1/517440.
    coneq[18683]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c*c)-1/2069760.
    coneq[18684]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c*c)-1/6209280.
    coneq[18685]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c*c)-1/12418560.
    coneq[18686]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c*c)-1/4139520.
    coneq[18687]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c*c)-1/1552320.
    coneq[18688]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c*c)-1/3104640.
    coneq[18689]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c*c)-1/1034880.
    coneq[18690]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c*c)-1/2069760.
    coneq[18691]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c*c)-1/413952.
    coneq[18692]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c*c)-1/1241856.
    coneq[18693]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c*c)-1/2483712.
    coneq[18694]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c*c)-1/827904.
    coneq[18695]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c*c)-1/310464.
    coneq[18696]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c*c)-1/620928.
    coneq[18697]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c*c)-1/206976.
    coneq[18698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c*c)-1/620928.
    coneq[18699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c*c)-1/1241856.
    coneq[18700]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c*c)-1/413952.
    coneq[18701]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))*c*c)-1/86240.
    coneq[18702]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c*c)-1/344960.
    coneq[18703]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c*c)-1/1034880.
    coneq[18704]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/2069760.
    coneq[18705]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c*c)-1/689920.
    coneq[18706]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c*c)-1/258720.
    coneq[18707]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c*c)-1/517440.
    coneq[18708]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c*c)-1/172480.
    coneq[18709]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/344960.
    coneq[18710]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))*c*c)-1/68992.
    coneq[18711]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c*c)-1/206976.
    coneq[18712]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c*c)-1/413952.
    coneq[18713]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c*c)-1/137984.
    coneq[18714]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))*c*c)-1/51744.
    coneq[18715]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c*c)-1/103488.
    coneq[18716]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))*c*c)-1/34496.
    coneq[18717]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c*c)-1/155232.
    coneq[18718]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c*c)-1/310464.
    coneq[18719]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c*c)-1/620928.
    coneq[18720]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c*c)-1/137984.
    coneq[18721]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c*c)-1/413952.
    coneq[18722]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c*c)-1/827904.
    coneq[18723]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c*c)-1/275968.
    coneq[18724]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c*c)-1/103488.
    coneq[18725]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/206976.
    coneq[18726]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c*c)-1/68992.
    coneq[18727]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c*c)-1/137984.
    coneq[18728]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**5)))*c*c)-1/14784.
    coneq[18729]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))*c*c)-1/73920.
    coneq[18730]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c*c)-1/295680.
    coneq[18731]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/887040.
    coneq[18732]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1774080.
    coneq[18733]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/591360.
    coneq[18734]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/221760.
    coneq[18735]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/443520.
    coneq[18736]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/147840.
    coneq[18737]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/295680.
    coneq[18738]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))*c*c)-1/59136.
    coneq[18739]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/177408.
    coneq[18740]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/354816.
    coneq[18741]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/118272.
    coneq[18742]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))*c*c)-1/44352.
    coneq[18743]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/88704.
    coneq[18744]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))*c*c)-1/29568.
    coneq[18745]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/88704.
    coneq[18746]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/177408.
    coneq[18747]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/59136.
    coneq[18748]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4)))*c*c)-1/12320.
    coneq[18749]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))*c*c)-1/49280.
    coneq[18750]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/147840.
    coneq[18751]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/295680.
    coneq[18752]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/98560.
    coneq[18753]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))*c*c)-1/36960.
    coneq[18754]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/73920.
    coneq[18755]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))*c*c)-1/24640.
    coneq[18756]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/49280.
    coneq[18757]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3)))*c*c)-1/9856.
    coneq[18758]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))*c*c)-1/29568.
    coneq[18759]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c*c)-1/59136.
    coneq[18760]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))*c*c)-1/19712.
    coneq[18761]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2)))*c*c)-1/7392.
    coneq[18762]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))*c*c)-1/14784.
    coneq[18763]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c)))*c*c)-1/4928.
    coneq[18764]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))*c*c)-1/29568.
    coneq[18765]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c*c)-1/88704.
    coneq[18766]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c*c)-1/177408.
    coneq[18767]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c*c)-1/59136.
    coneq[18768]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c*c)-1/59136.
    coneq[18769]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c*c)-1/177408.
    coneq[18770]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c*c)-1/354816.
    coneq[18771]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c*c)-1/118272.
    coneq[18772]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))*c*c)-1/24640.
    coneq[18773]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c*c)-1/98560.
    coneq[18774]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/295680.
    coneq[18775]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/591360.
    coneq[18776]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/197120.
    coneq[18777]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c*c)-1/73920.
    coneq[18778]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/147840.
    coneq[18779]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c*c)-1/49280.
    coneq[18780]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/98560.
    coneq[18781]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c*c)-1/22176.
    coneq[18782]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[18783]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/88704.
    coneq[18784]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))*c*c)-1/19712.
    coneq[18785]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/59136.
    coneq[18786]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/118272.
    coneq[18787]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/39424.
    coneq[18788]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c*c)-1/14784.
    coneq[18789]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/29568.
    coneq[18790]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))*c*c)-1/9856.
    coneq[18791]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c*c)-1/29568.
    coneq[18792]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/59136.
    coneq[18793]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/19712.
    coneq[18794]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**4))*c*c)-1/3080.
    coneq[18795]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3)))*c*c)-1/12320.
    coneq[18796]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/36960.
    coneq[18797]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/73920.
    coneq[18798]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/24640.
    coneq[18799]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2)))*c*c)-1/9240.
    coneq[18800]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/18480.
    coneq[18801]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c)))*c*c)-1/6160.
    coneq[18802]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/12320.
    coneq[18803]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4))*c*c)-1/9240.
    coneq[18804]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c*c)-1/36960.
    coneq[18805]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/110880.
    coneq[18806]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[18807]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/73920.
    coneq[18808]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c*c)-1/27720.
    coneq[18809]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/55440.
    coneq[18810]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c*c)-1/18480.
    coneq[18811]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/36960.
    coneq[18812]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c*c)-1/18480.
    coneq[18813]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c*c)-1/73920.
    coneq[18814]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/221760.
    coneq[18815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/443520.
    coneq[18816]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/147840.
    coneq[18817]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c*c)-1/55440.
    coneq[18818]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/110880.
    coneq[18819]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c*c)-1/36960.
    coneq[18820]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/73920.
    coneq[18821]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4))*c*c)-1/6160.
    coneq[18822]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c*c)-1/24640.
    coneq[18823]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/73920.
    coneq[18824]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/147840.
    coneq[18825]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/49280.
    coneq[18826]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c*c)-1/18480.
    coneq[18827]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/36960.
    coneq[18828]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/12320.
    coneq[18829]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/24640.
    coneq[18830]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**5))*c*c)-1/2772.
    coneq[18831]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4)))*c*c)-1/13860.
    coneq[18832]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/55440.
    coneq[18833]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/166320.
    coneq[18834]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/332640.
    coneq[18835]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/110880.
    coneq[18836]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/41580.
    coneq[18837]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/83160.
    coneq[18838]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/27720.
    coneq[18839]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/55440.
    coneq[18840]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3)))*c*c)-1/11088.
    coneq[18841]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/33264.
    coneq[18842]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/66528.
    coneq[18843]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/22176.
    coneq[18844]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c*c)-1/8316.
    coneq[18845]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/16632.
    coneq[18846]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c)))*c*c)-1/5544.
    coneq[18847]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/16632.
    coneq[18848]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/33264.
    coneq[18849]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/11088.
    coneq[18850]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**5))*c*c)-1/5544.
    coneq[18851]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c*c)-1/27720.
    coneq[18852]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c*c)-1/110880.
    coneq[18853]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/332640.
    coneq[18854]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/665280.
    coneq[18855]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/221760.
    coneq[18856]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/83160.
    coneq[18857]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/166320.
    coneq[18858]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/55440.
    coneq[18859]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/110880.
    coneq[18860]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c*c)-1/22176.
    coneq[18861]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/66528.
    coneq[18862]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/133056.
    coneq[18863]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/44352.
    coneq[18864]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c*c)-1/16632.
    coneq[18865]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/33264.
    coneq[18866]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c*c)-1/11088.
    coneq[18867]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/33264.
    coneq[18868]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/66528.
    coneq[18869]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/22176.
    coneq[18870]=dot(b,dot(A,c*dot(A,c)*dot(A,c**6))*c*c)-1/2156.
    coneq[18871]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**5)))*c*c)-1/12936.
    coneq[18872]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c*c)-1/64680.
    coneq[18873]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c*c)-1/258720.
    coneq[18874]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c*c)-1/776160.
    coneq[18875]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c*c)-1/1552320.
    coneq[18876]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c*c)-1/517440.
    coneq[18877]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c*c)-1/194040.
    coneq[18878]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c*c)-1/388080.
    coneq[18879]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c*c)-1/129360.
    coneq[18880]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c*c)-1/258720.
    coneq[18881]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c*c)-1/51744.
    coneq[18882]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c*c)-1/155232.
    coneq[18883]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c*c)-1/310464.
    coneq[18884]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c*c)-1/103488.
    coneq[18885]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c*c)-1/38808.
    coneq[18886]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c*c)-1/77616.
    coneq[18887]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c*c)-1/25872.
    coneq[18888]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c*c)-1/77616.
    coneq[18889]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c*c)-1/155232.
    coneq[18890]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c*c)-1/51744.
    coneq[18891]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4)))*c*c)-1/10780.
    coneq[18892]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c*c)-1/43120.
    coneq[18893]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c*c)-1/129360.
    coneq[18894]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/258720.
    coneq[18895]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c*c)-1/86240.
    coneq[18896]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c*c)-1/32340.
    coneq[18897]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c*c)-1/64680.
    coneq[18898]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c*c)-1/21560.
    coneq[18899]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c*c)-1/43120.
    coneq[18900]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3)))*c*c)-1/8624.
    coneq[18901]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c*c)-1/25872.
    coneq[18902]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c*c)-1/51744.
    coneq[18903]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c*c)-1/17248.
    coneq[18904]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2)))*c*c)-1/6468.
    coneq[18905]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c*c)-1/12936.
    coneq[18906]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c)))*c*c)-1/4312.
    coneq[18907]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c*c)-1/19404.
    coneq[18908]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c*c)-1/38808.
    coneq[18909]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c*c)-1/77616.
    coneq[18910]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c*c)-1/17248.
    coneq[18911]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c*c)-1/51744.
    coneq[18912]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c*c)-1/103488.
    coneq[18913]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c*c)-1/34496.
    coneq[18914]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c*c)-1/12936.
    coneq[18915]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c*c)-1/25872.
    coneq[18916]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c*c)-1/8624.
    coneq[18917]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c*c)-1/17248.
    coneq[18918]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**3))*c*c)-1/2464.
    coneq[18919]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2)))*c*c)-1/7392.
    coneq[18920]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c*c)-1/14784.
    coneq[18921]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c)))*c*c)-1/4928.
    coneq[18922]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c*c)-1/22176.
    coneq[18923]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[18924]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c*c)-1/14784.
    coneq[18925]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c*c)-1/88704.
    coneq[18926]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c*c)-1/29568.
    coneq[18927]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/9856.
    coneq[18928]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**4))*c*c)-1/2310.
    coneq[18929]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3)))*c*c)-1/9240.
    coneq[18930]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/27720.
    coneq[18931]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/55440.
    coneq[18932]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/18480.
    coneq[18933]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c*c)-1/6930.
    coneq[18934]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/13860.
    coneq[18935]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c*c)-1/4620.
    coneq[18936]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/9240.
    coneq[18937]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4))*c*c)-1/4620.
    coneq[18938]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c*c)-1/18480.
    coneq[18939]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/55440.
    coneq[18940]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[18941]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/36960.
    coneq[18942]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c*c)-1/13860.
    coneq[18943]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/27720.
    coneq[18944]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/9240.
    coneq[18945]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/18480.
    coneq[18946]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**5))*c*c)-1/1848.
    coneq[18947]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4)))*c*c)-1/9240.
    coneq[18948]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/36960.
    coneq[18949]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/110880.
    coneq[18950]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/221760.
    coneq[18951]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/73920.
    coneq[18952]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/27720.
    coneq[18953]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/55440.
    coneq[18954]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/18480.
    coneq[18955]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/36960.
    coneq[18956]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3)))*c*c)-1/7392.
    coneq[18957]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/22176.
    coneq[18958]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/44352.
    coneq[18959]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/14784.
    coneq[18960]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c*c)-1/5544.
    coneq[18961]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/11088.
    coneq[18962]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c)))*c*c)-1/3696.
    coneq[18963]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/11088.
    coneq[18964]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[18965]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/7392.
    coneq[18966]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**3))*c*c)-1/1848.
    coneq[18967]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/5544.
    coneq[18968]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/11088.
    coneq[18969]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/3696.
    coneq[18970]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/3696.
    coneq[18971]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/11088.
    coneq[18972]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[18973]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/7392.
    coneq[18974]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**4))*c*c)-1/1540.
    coneq[18975]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3)))*c*c)-1/6160.
    coneq[18976]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/18480.
    coneq[18977]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/36960.
    coneq[18978]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/12320.
    coneq[18979]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2)))*c*c)-1/4620.
    coneq[18980]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/9240.
    coneq[18981]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c)))*c*c)-1/3080.
    coneq[18982]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/6160.
    coneq[18983]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**2))*c*c)-1/1386.
    coneq[18984]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/2772.
    coneq[18985]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/5544.
    coneq[18986]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**3))*c*c)-1/1232.
    coneq[18987]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/3696.
    coneq[18988]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/7392.
    coneq[18989]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/2464.
    coneq[18990]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**2))*c*c)-1/924.
    coneq[18991]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/1848.
    coneq[18992]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c))*c*c)-1/616.
    coneq[18993]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5))*c*c)-1/3696.
    coneq[18994]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))*c*c)-1/18480.
    coneq[18995]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c*c)-1/73920.
    coneq[18996]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c*c)-1/221760.
    coneq[18997]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c*c)-1/443520.
    coneq[18998]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c*c)-1/147840.
    coneq[18999]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c*c)-1/55440.
    coneq[19000]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[19001]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c*c)-1/36960.
    coneq[19002]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c*c)-1/73920.
    coneq[19003]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))*c*c)-1/14784.
    coneq[19004]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c*c)-1/44352.
    coneq[19005]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c*c)-1/88704.
    coneq[19006]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c*c)-1/29568.
    coneq[19007]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c*c)-1/11088.
    coneq[19008]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[19009]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))*c*c)-1/7392.
    coneq[19010]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c*c)-1/22176.
    coneq[19011]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[19012]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c*c)-1/14784.
    coneq[19013]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4))*c*c)-1/4620.
    coneq[19014]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))*c*c)-1/18480.
    coneq[19015]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/55440.
    coneq[19016]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/110880.
    coneq[19017]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/36960.
    coneq[19018]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c*c)-1/13860.
    coneq[19019]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/27720.
    coneq[19020]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c*c)-1/9240.
    coneq[19021]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/18480.
    coneq[19022]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))*c*c)-1/9240.
    coneq[19023]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c*c)-1/36960.
    coneq[19024]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c*c)-1/110880.
    coneq[19025]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/221760.
    coneq[19026]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c*c)-1/73920.
    coneq[19027]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c*c)-1/27720.
    coneq[19028]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c*c)-1/55440.
    coneq[19029]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c*c)-1/18480.
    coneq[19030]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/36960.
    coneq[19031]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3))*c*c)-1/5544.
    coneq[19032]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/16632.
    coneq[19033]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/33264.
    coneq[19034]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/11088.
    coneq[19035]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/11088.
    coneq[19036]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/33264.
    coneq[19037]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/66528.
    coneq[19038]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/22176.
    coneq[19039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/22176.
    coneq[19040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/66528.
    coneq[19041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/133056.
    coneq[19042]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/44352.
    coneq[19043]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3))*c*c)-1/4928.
    coneq[19044]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))*c*c)-1/14784.
    coneq[19045]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c*c)-1/29568.
    coneq[19046]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))*c*c)-1/9856.
    coneq[19047]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c*c)-1/44352.
    coneq[19048]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c*c)-1/88704.
    coneq[19049]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c*c)-1/29568.
    coneq[19050]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c*c)-1/177408.
    coneq[19051]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c*c)-1/59136.
    coneq[19052]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/19712.
    coneq[19053]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4))*c*c)-1/3080.
    coneq[19054]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c*c)-1/12320.
    coneq[19055]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c*c)-1/36960.
    coneq[19056]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c*c)-1/73920.
    coneq[19057]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c*c)-1/24640.
    coneq[19058]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c*c)-1/9240.
    coneq[19059]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c*c)-1/18480.
    coneq[19060]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c*c)-1/6160.
    coneq[19061]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c*c)-1/12320.
    coneq[19062]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3))*c*c)-1/3696.
    coneq[19063]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c*c)-1/11088.
    coneq[19064]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c*c)-1/22176.
    coneq[19065]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c*c)-1/7392.
    coneq[19066]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c*c)-1/7392.
    coneq[19067]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c*c)-1/22176.
    coneq[19068]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c*c)-1/44352.
    coneq[19069]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c*c)-1/14784.
    coneq[19070]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c*c)-1/4158.
    coneq[19071]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/8316.
    coneq[19072]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/16632.
    coneq[19073]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/33264.
    coneq[19074]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3))*c*c)-1/2464.
    coneq[19075]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/7392.
    coneq[19076]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/14784.
    coneq[19077]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/4928.
    coneq[19078]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c*c)-1/2772.
    coneq[19079]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/5544.
    coneq[19080]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/11088.
    coneq[19081]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2))*c*c)-1/1848.
    coneq[19082]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/3696.
    coneq[19083]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/1232.
    coneq[19084]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))*c*c)-1/4928.
    coneq[19085]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c*c)-1/14784.
    coneq[19086]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c*c)-1/29568.
    coneq[19087]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c*c)-1/9856.
    coneq[19088]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c*c)-1/5544.
    coneq[19089]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c*c)-1/11088.
    coneq[19090]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))*c*c)-1/11088.
    coneq[19091]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c*c)-1/22176.
    coneq[19092]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*c*c)-1/3696.
    coneq[19093]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c*c)-1/7392.
    coneq[19094]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c*c)-1/2464.
    coneq[19095]=dot(b,dot(A,c**9)*c**3)-1/140.
    coneq[19096]=dot(b,dot(A,dot(A,c**8))*c**3)-1/1260.
    coneq[19097]=dot(b,dot(A,dot(A,dot(A,c**7)))*c**3)-1/10080.
    coneq[19098]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*c**3)-1/70560.
    coneq[19099]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*c**3)-1/423360.
    coneq[19100]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*c**3)-1/2116800.
    coneq[19101]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*c**3)-1/8467200.
    coneq[19102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*c**3)-1/25401600.
    coneq[19103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*c**3)-1/50803200.
    coneq[19104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*c**3)-1/16934400.
    coneq[19105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*c**3)-1/6350400.
    coneq[19106]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*c**3)-1/12700800.
    coneq[19107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*c**3)-1/4233600.
    coneq[19108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*c**3)-1/8467200.
    coneq[19109]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*c**3)-1/1693440.
    coneq[19110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*c**3)-1/5080320.
    coneq[19111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*c**3)-1/10160640.
    coneq[19112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*c**3)-1/3386880.
    coneq[19113]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*c**3)-1/1270080.
    coneq[19114]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*c**3)-1/2540160.
    coneq[19115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*c**3)-1/846720.
    coneq[19116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*c**3)-1/2540160.
    coneq[19117]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*c**3)-1/5080320.
    coneq[19118]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*c**3)-1/1693440.
    coneq[19119]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*c**3)-1/352800.
    coneq[19120]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*c**3)-1/1411200.
    coneq[19121]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*c**3)-1/4233600.
    coneq[19122]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*c**3)-1/8467200.
    coneq[19123]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*c**3)-1/2822400.
    coneq[19124]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*c**3)-1/1058400.
    coneq[19125]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*c**3)-1/2116800.
    coneq[19126]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*c**3)-1/705600.
    coneq[19127]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*c**3)-1/1411200.
    coneq[19128]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*c**3)-1/282240.
    coneq[19129]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*c**3)-1/846720.
    coneq[19130]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*c**3)-1/1693440.
    coneq[19131]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*c**3)-1/564480.
    coneq[19132]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*c**3)-1/211680.
    coneq[19133]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*c**3)-1/423360.
    coneq[19134]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*c**3)-1/141120.
    coneq[19135]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*c**3)-1/635040.
    coneq[19136]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*c**3)-1/1270080.
    coneq[19137]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*c**3)-1/2540160.
    coneq[19138]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*c**3)-1/564480.
    coneq[19139]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*c**3)-1/1693440.
    coneq[19140]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*c**3)-1/3386880.
    coneq[19141]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*c**3)-1/1128960.
    coneq[19142]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*c**3)-1/423360.
    coneq[19143]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*c**3)-1/846720.
    coneq[19144]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*c**3)-1/282240.
    coneq[19145]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*c**3)-1/564480.
    coneq[19146]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*c**3)-1/60480.
    coneq[19147]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*c**3)-1/302400.
    coneq[19148]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*c**3)-1/1209600.
    coneq[19149]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*c**3)-1/3628800.
    coneq[19150]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c**3)-1/7257600.
    coneq[19151]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*c**3)-1/2419200.
    coneq[19152]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*c**3)-1/907200.
    coneq[19153]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*c**3)-1/1814400.
    coneq[19154]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*c**3)-1/604800.
    coneq[19155]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*c**3)-1/1209600.
    coneq[19156]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*c**3)-1/241920.
    coneq[19157]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*c**3)-1/725760.
    coneq[19158]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*c**3)-1/1451520.
    coneq[19159]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*c**3)-1/483840.
    coneq[19160]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*c**3)-1/181440.
    coneq[19161]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*c**3)-1/362880.
    coneq[19162]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*c**3)-1/120960.
    coneq[19163]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*c**3)-1/362880.
    coneq[19164]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*c**3)-1/725760.
    coneq[19165]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*c**3)-1/241920.
    coneq[19166]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*c**3)-1/50400.
    coneq[19167]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*c**3)-1/201600.
    coneq[19168]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*c**3)-1/604800.
    coneq[19169]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/1209600.
    coneq[19170]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*c**3)-1/403200.
    coneq[19171]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*c**3)-1/151200.
    coneq[19172]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*c**3)-1/302400.
    coneq[19173]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*c**3)-1/100800.
    coneq[19174]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/201600.
    coneq[19175]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*c**3)-1/40320.
    coneq[19176]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*c**3)-1/120960.
    coneq[19177]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*c**3)-1/241920.
    coneq[19178]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*c**3)-1/80640.
    coneq[19179]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*c**3)-1/30240.
    coneq[19180]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*c**3)-1/60480.
    coneq[19181]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*c**3)-1/20160.
    coneq[19182]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*c**3)-1/120960.
    coneq[19183]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*c**3)-1/362880.
    coneq[19184]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*c**3)-1/725760.
    coneq[19185]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*c**3)-1/241920.
    coneq[19186]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*c**3)-1/241920.
    coneq[19187]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*c**3)-1/725760.
    coneq[19188]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*c**3)-1/1451520.
    coneq[19189]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*c**3)-1/483840.
    coneq[19190]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*c**3)-1/100800.
    coneq[19191]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*c**3)-1/403200.
    coneq[19192]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*c**3)-1/1209600.
    coneq[19193]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/2419200.
    coneq[19194]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*c**3)-1/806400.
    coneq[19195]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*c**3)-1/302400.
    coneq[19196]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*c**3)-1/604800.
    coneq[19197]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*c**3)-1/201600.
    coneq[19198]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/403200.
    coneq[19199]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*c**3)-1/90720.
    coneq[19200]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*c**3)-1/181440.
    coneq[19201]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*c**3)-1/362880.
    coneq[19202]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*c**3)-1/80640.
    coneq[19203]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*c**3)-1/241920.
    coneq[19204]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*c**3)-1/483840.
    coneq[19205]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*c**3)-1/161280.
    coneq[19206]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*c**3)-1/60480.
    coneq[19207]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/120960.
    coneq[19208]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*c**3)-1/40320.
    coneq[19209]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*c**3)-1/120960.
    coneq[19210]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/241920.
    coneq[19211]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*c**3)-1/80640.
    coneq[19212]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*c**3)-1/8820.
    coneq[19213]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*c**3)-1/52920.
    coneq[19214]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*c**3)-1/264600.
    coneq[19215]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*c**3)-1/1058400.
    coneq[19216]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c**3)-1/3175200.
    coneq[19217]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c**3)-1/6350400.
    coneq[19218]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c**3)-1/2116800.
    coneq[19219]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c**3)-1/793800.
    coneq[19220]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c**3)-1/1587600.
    coneq[19221]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c**3)-1/529200.
    coneq[19222]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c**3)-1/1058400.
    coneq[19223]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*c**3)-1/211680.
    coneq[19224]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c**3)-1/635040.
    coneq[19225]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c**3)-1/1270080.
    coneq[19226]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c**3)-1/423360.
    coneq[19227]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*c**3)-1/158760.
    coneq[19228]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c**3)-1/317520.
    coneq[19229]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*c**3)-1/105840.
    coneq[19230]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c**3)-1/317520.
    coneq[19231]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c**3)-1/635040.
    coneq[19232]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c**3)-1/211680.
    coneq[19233]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*c**3)-1/44100.
    coneq[19234]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*c**3)-1/176400.
    coneq[19235]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c**3)-1/529200.
    coneq[19236]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/1058400.
    coneq[19237]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c**3)-1/352800.
    coneq[19238]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*c**3)-1/132300.
    coneq[19239]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c**3)-1/264600.
    coneq[19240]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*c**3)-1/88200.
    coneq[19241]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/176400.
    coneq[19242]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*c**3)-1/35280.
    coneq[19243]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*c**3)-1/105840.
    coneq[19244]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c**3)-1/211680.
    coneq[19245]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*c**3)-1/70560.
    coneq[19246]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*c**3)-1/26460.
    coneq[19247]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*c**3)-1/52920.
    coneq[19248]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*c**3)-1/17640.
    coneq[19249]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*c**3)-1/79380.
    coneq[19250]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c**3)-1/158760.
    coneq[19251]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c**3)-1/317520.
    coneq[19252]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*c**3)-1/70560.
    coneq[19253]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c**3)-1/211680.
    coneq[19254]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c**3)-1/423360.
    coneq[19255]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c**3)-1/141120.
    coneq[19256]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*c**3)-1/52920.
    coneq[19257]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/105840.
    coneq[19258]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*c**3)-1/35280.
    coneq[19259]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c**3)-1/70560.
    coneq[19260]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*c**3)-1/7560.
    coneq[19261]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*c**3)-1/37800.
    coneq[19262]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*c**3)-1/151200.
    coneq[19263]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/453600.
    coneq[19264]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/907200.
    coneq[19265]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/302400.
    coneq[19266]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/113400.
    coneq[19267]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/226800.
    coneq[19268]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/75600.
    coneq[19269]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/151200.
    coneq[19270]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*c**3)-1/30240.
    coneq[19271]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/90720.
    coneq[19272]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/181440.
    coneq[19273]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/60480.
    coneq[19274]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*c**3)-1/22680.
    coneq[19275]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/45360.
    coneq[19276]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*c**3)-1/15120.
    coneq[19277]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/45360.
    coneq[19278]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/90720.
    coneq[19279]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/30240.
    coneq[19280]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*c**3)-1/6300.
    coneq[19281]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*c**3)-1/25200.
    coneq[19282]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/75600.
    coneq[19283]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/151200.
    coneq[19284]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/50400.
    coneq[19285]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*c**3)-1/18900.
    coneq[19286]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/37800.
    coneq[19287]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*c**3)-1/12600.
    coneq[19288]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/25200.
    coneq[19289]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*c**3)-1/5040.
    coneq[19290]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*c**3)-1/15120.
    coneq[19291]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*c**3)-1/30240.
    coneq[19292]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*c**3)-1/10080.
    coneq[19293]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*c**3)-1/3780.
    coneq[19294]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*c**3)-1/7560.
    coneq[19295]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*c**3)-1/2520.
    coneq[19296]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*c**3)-1/20160.
    coneq[19297]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*c**3)-1/60480.
    coneq[19298]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*c**3)-1/120960.
    coneq[19299]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*c**3)-1/40320.
    coneq[19300]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*c**3)-1/181440.
    coneq[19301]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*c**3)-1/362880.
    coneq[19302]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*c**3)-1/120960.
    coneq[19303]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*c**3)-1/725760.
    coneq[19304]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*c**3)-1/241920.
    coneq[19305]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*c**3)-1/80640.
    coneq[19306]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*c**3)-1/18900.
    coneq[19307]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*c**3)-1/75600.
    coneq[19308]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/226800.
    coneq[19309]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/453600.
    coneq[19310]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/151200.
    coneq[19311]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*c**3)-1/56700.
    coneq[19312]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/113400.
    coneq[19313]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*c**3)-1/37800.
    coneq[19314]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/75600.
    coneq[19315]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*c**3)-1/37800.
    coneq[19316]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*c**3)-1/151200.
    coneq[19317]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/453600.
    coneq[19318]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/907200.
    coneq[19319]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/302400.
    coneq[19320]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*c**3)-1/113400.
    coneq[19321]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/226800.
    coneq[19322]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*c**3)-1/75600.
    coneq[19323]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/151200.
    coneq[19324]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*c**3)-1/15120.
    coneq[19325]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*c**3)-1/75600.
    coneq[19326]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*c**3)-1/302400.
    coneq[19327]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/907200.
    coneq[19328]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/1814400.
    coneq[19329]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/604800.
    coneq[19330]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/226800.
    coneq[19331]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/453600.
    coneq[19332]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/151200.
    coneq[19333]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/302400.
    coneq[19334]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*c**3)-1/60480.
    coneq[19335]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/181440.
    coneq[19336]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/362880.
    coneq[19337]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/120960.
    coneq[19338]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*c**3)-1/45360.
    coneq[19339]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/90720.
    coneq[19340]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*c**3)-1/30240.
    coneq[19341]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/90720.
    coneq[19342]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/181440.
    coneq[19343]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/60480.
    coneq[19344]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*c**3)-1/15120.
    coneq[19345]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*c**3)-1/45360.
    coneq[19346]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c**3)-1/90720.
    coneq[19347]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*c**3)-1/30240.
    coneq[19348]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*c**3)-1/30240.
    coneq[19349]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c**3)-1/90720.
    coneq[19350]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c**3)-1/181440.
    coneq[19351]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c**3)-1/60480.
    coneq[19352]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*c**3)-1/12600.
    coneq[19353]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*c**3)-1/50400.
    coneq[19354]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/151200.
    coneq[19355]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/302400.
    coneq[19356]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/100800.
    coneq[19357]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*c**3)-1/37800.
    coneq[19358]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/75600.
    coneq[19359]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*c**3)-1/25200.
    coneq[19360]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/50400.
    coneq[19361]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*c**3)-1/11340.
    coneq[19362]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/22680.
    coneq[19363]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/45360.
    coneq[19364]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*c**3)-1/10080.
    coneq[19365]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/30240.
    coneq[19366]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/60480.
    coneq[19367]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/20160.
    coneq[19368]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*c**3)-1/7560.
    coneq[19369]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/15120.
    coneq[19370]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*c**3)-1/5040.
    coneq[19371]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*c**3)-1/20160.
    coneq[19372]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/60480.
    coneq[19373]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/120960.
    coneq[19374]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/40320.
    coneq[19375]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*c**3)-1/22680.
    coneq[19376]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/45360.
    coneq[19377]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/90720.
    coneq[19378]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*c**3)-1/15120.
    coneq[19379]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/30240.
    coneq[19380]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/10080.
    coneq[19381]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/20160.
    coneq[19382]=dot(b,dot(A,c*dot(A,c**7))*c**3)-1/1120.
    coneq[19383]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*c**3)-1/7840.
    coneq[19384]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*c**3)-1/47040.
    coneq[19385]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*c**3)-1/235200.
    coneq[19386]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c**3)-1/940800.
    coneq[19387]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c**3)-1/2822400.
    coneq[19388]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c**3)-1/5644800.
    coneq[19389]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c**3)-1/1881600.
    coneq[19390]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c**3)-1/705600.
    coneq[19391]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c**3)-1/1411200.
    coneq[19392]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c**3)-1/470400.
    coneq[19393]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c**3)-1/940800.
    coneq[19394]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c**3)-1/188160.
    coneq[19395]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c**3)-1/564480.
    coneq[19396]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c**3)-1/1128960.
    coneq[19397]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c**3)-1/376320.
    coneq[19398]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c**3)-1/141120.
    coneq[19399]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c**3)-1/282240.
    coneq[19400]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c**3)-1/94080.
    coneq[19401]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c**3)-1/282240.
    coneq[19402]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c**3)-1/564480.
    coneq[19403]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c**3)-1/188160.
    coneq[19404]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*c**3)-1/39200.
    coneq[19405]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c**3)-1/156800.
    coneq[19406]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c**3)-1/470400.
    coneq[19407]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/940800.
    coneq[19408]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c**3)-1/313600.
    coneq[19409]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c**3)-1/117600.
    coneq[19410]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c**3)-1/235200.
    coneq[19411]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c**3)-1/78400.
    coneq[19412]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/156800.
    coneq[19413]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*c**3)-1/31360.
    coneq[19414]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c**3)-1/94080.
    coneq[19415]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c**3)-1/188160.
    coneq[19416]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c**3)-1/62720.
    coneq[19417]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*c**3)-1/23520.
    coneq[19418]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c**3)-1/47040.
    coneq[19419]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*c**3)-1/15680.
    coneq[19420]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c**3)-1/70560.
    coneq[19421]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c**3)-1/141120.
    coneq[19422]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c**3)-1/282240.
    coneq[19423]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c**3)-1/62720.
    coneq[19424]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c**3)-1/188160.
    coneq[19425]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c**3)-1/376320.
    coneq[19426]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c**3)-1/125440.
    coneq[19427]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c**3)-1/47040.
    coneq[19428]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/94080.
    coneq[19429]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c**3)-1/31360.
    coneq[19430]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c**3)-1/62720.
    coneq[19431]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*c**3)-1/6720.
    coneq[19432]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*c**3)-1/33600.
    coneq[19433]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c**3)-1/134400.
    coneq[19434]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/403200.
    coneq[19435]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/806400.
    coneq[19436]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/268800.
    coneq[19437]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/100800.
    coneq[19438]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/201600.
    coneq[19439]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/67200.
    coneq[19440]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/134400.
    coneq[19441]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*c**3)-1/26880.
    coneq[19442]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/80640.
    coneq[19443]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/161280.
    coneq[19444]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/53760.
    coneq[19445]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*c**3)-1/20160.
    coneq[19446]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/40320.
    coneq[19447]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*c**3)-1/13440.
    coneq[19448]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/40320.
    coneq[19449]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/80640.
    coneq[19450]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/26880.
    coneq[19451]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*c**3)-1/5600.
    coneq[19452]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*c**3)-1/22400.
    coneq[19453]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/67200.
    coneq[19454]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/134400.
    coneq[19455]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/44800.
    coneq[19456]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*c**3)-1/16800.
    coneq[19457]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/33600.
    coneq[19458]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*c**3)-1/11200.
    coneq[19459]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/22400.
    coneq[19460]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*c**3)-1/4480.
    coneq[19461]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*c**3)-1/13440.
    coneq[19462]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c**3)-1/26880.
    coneq[19463]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*c**3)-1/8960.
    coneq[19464]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*c**3)-1/3360.
    coneq[19465]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*c**3)-1/6720.
    coneq[19466]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*c**3)-1/2240.
    coneq[19467]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*c**3)-1/13440.
    coneq[19468]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c**3)-1/40320.
    coneq[19469]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c**3)-1/80640.
    coneq[19470]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c**3)-1/26880.
    coneq[19471]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c**3)-1/26880.
    coneq[19472]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c**3)-1/80640.
    coneq[19473]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c**3)-1/161280.
    coneq[19474]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c**3)-1/53760.
    coneq[19475]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*c**3)-1/11200.
    coneq[19476]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c**3)-1/44800.
    coneq[19477]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/134400.
    coneq[19478]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/268800.
    coneq[19479]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/89600.
    coneq[19480]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c**3)-1/33600.
    coneq[19481]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/67200.
    coneq[19482]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c**3)-1/22400.
    coneq[19483]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/44800.
    coneq[19484]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*c**3)-1/10080.
    coneq[19485]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/20160.
    coneq[19486]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/40320.
    coneq[19487]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*c**3)-1/8960.
    coneq[19488]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/26880.
    coneq[19489]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/53760.
    coneq[19490]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/17920.
    coneq[19491]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*c**3)-1/6720.
    coneq[19492]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/13440.
    coneq[19493]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*c**3)-1/4480.
    coneq[19494]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c**3)-1/13440.
    coneq[19495]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/26880.
    coneq[19496]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/8960.
    coneq[19497]=dot(b,dot(A,c**2*dot(A,c**6))*c**3)-1/980.
    coneq[19498]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*c**3)-1/5880.
    coneq[19499]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*c**3)-1/29400.
    coneq[19500]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*c**3)-1/117600.
    coneq[19501]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/352800.
    coneq[19502]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/705600.
    coneq[19503]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/235200.
    coneq[19504]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/88200.
    coneq[19505]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/176400.
    coneq[19506]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/58800.
    coneq[19507]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/117600.
    coneq[19508]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*c**3)-1/23520.
    coneq[19509]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/70560.
    coneq[19510]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/141120.
    coneq[19511]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/47040.
    coneq[19512]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*c**3)-1/17640.
    coneq[19513]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/35280.
    coneq[19514]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*c**3)-1/11760.
    coneq[19515]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/35280.
    coneq[19516]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/70560.
    coneq[19517]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/23520.
    coneq[19518]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*c**3)-1/4900.
    coneq[19519]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*c**3)-1/19600.
    coneq[19520]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/58800.
    coneq[19521]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/117600.
    coneq[19522]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/39200.
    coneq[19523]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*c**3)-1/14700.
    coneq[19524]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/29400.
    coneq[19525]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*c**3)-1/9800.
    coneq[19526]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/19600.
    coneq[19527]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*c**3)-1/3920.
    coneq[19528]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*c**3)-1/11760.
    coneq[19529]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**3)-1/23520.
    coneq[19530]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*c**3)-1/7840.
    coneq[19531]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*c**3)-1/2940.
    coneq[19532]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*c**3)-1/5880.
    coneq[19533]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*c**3)-1/1960.
    coneq[19534]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*c**3)-1/8820.
    coneq[19535]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/17640.
    coneq[19536]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/35280.
    coneq[19537]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*c**3)-1/7840.
    coneq[19538]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/23520.
    coneq[19539]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/47040.
    coneq[19540]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/15680.
    coneq[19541]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*c**3)-1/5880.
    coneq[19542]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/11760.
    coneq[19543]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*c**3)-1/3920.
    coneq[19544]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/7840.
    coneq[19545]=dot(b,dot(A,c**3*dot(A,c**5))*c**3)-1/840.
    coneq[19546]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*c**3)-1/4200.
    coneq[19547]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*c**3)-1/16800.
    coneq[19548]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/50400.
    coneq[19549]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/100800.
    coneq[19550]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/33600.
    coneq[19551]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/12600.
    coneq[19552]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/25200.
    coneq[19553]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/8400.
    coneq[19554]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/16800.
    coneq[19555]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*c**3)-1/3360.
    coneq[19556]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/10080.
    coneq[19557]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/20160.
    coneq[19558]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/6720.
    coneq[19559]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*c**3)-1/2520.
    coneq[19560]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/5040.
    coneq[19561]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*c**3)-1/1680.
    coneq[19562]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/5040.
    coneq[19563]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/10080.
    coneq[19564]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/3360.
    coneq[19565]=dot(b,dot(A,c**4*dot(A,c**4))*c**3)-1/700.
    coneq[19566]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*c**3)-1/2800.
    coneq[19567]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*c**3)-1/8400.
    coneq[19568]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/16800.
    coneq[19569]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*c**3)-1/5600.
    coneq[19570]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*c**3)-1/2100.
    coneq[19571]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*c**3)-1/4200.
    coneq[19572]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*c**3)-1/1400.
    coneq[19573]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/2800.
    coneq[19574]=dot(b,dot(A,c**5*dot(A,c**3))*c**3)-1/560.
    coneq[19575]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*c**3)-1/1680.
    coneq[19576]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*c**3)-1/3360.
    coneq[19577]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*c**3)-1/1120.
    coneq[19578]=dot(b,dot(A,c**6*dot(A,c**2))*c**3)-1/420.
    coneq[19579]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*c**3)-1/840.
    coneq[19580]=dot(b,dot(A,c**7*dot(A,c))*c**3)-1/280.
    coneq[19581]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*c**3)-1/2800.
    coneq[19582]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*c**3)-1/11200.
    coneq[19583]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/33600.
    coneq[19584]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/67200.
    coneq[19585]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/22400.
    coneq[19586]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*c**3)-1/8400.
    coneq[19587]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/16800.
    coneq[19588]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*c**3)-1/5600.
    coneq[19589]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/11200.
    coneq[19590]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*c**3)-1/8400.
    coneq[19591]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*c**3)-1/33600.
    coneq[19592]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*c**3)-1/100800.
    coneq[19593]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/201600.
    coneq[19594]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*c**3)-1/67200.
    coneq[19595]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*c**3)-1/25200.
    coneq[19596]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*c**3)-1/50400.
    coneq[19597]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*c**3)-1/16800.
    coneq[19598]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/33600.
    coneq[19599]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*c**3)-1/16800.
    coneq[19600]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*c**3)-1/67200.
    coneq[19601]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*c**3)-1/201600.
    coneq[19602]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/403200.
    coneq[19603]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*c**3)-1/134400.
    coneq[19604]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*c**3)-1/50400.
    coneq[19605]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*c**3)-1/100800.
    coneq[19606]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*c**3)-1/33600.
    coneq[19607]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/67200.
    coneq[19608]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*c**3)-1/5600.
    coneq[19609]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*c**3)-1/22400.
    coneq[19610]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c**3)-1/67200.
    coneq[19611]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/134400.
    coneq[19612]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c**3)-1/44800.
    coneq[19613]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*c**3)-1/16800.
    coneq[19614]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c**3)-1/33600.
    coneq[19615]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*c**3)-1/11200.
    coneq[19616]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/22400.
    coneq[19617]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*c**3)-1/2520.
    coneq[19618]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*c**3)-1/12600.
    coneq[19619]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*c**3)-1/50400.
    coneq[19620]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/151200.
    coneq[19621]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/302400.
    coneq[19622]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/100800.
    coneq[19623]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/37800.
    coneq[19624]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/75600.
    coneq[19625]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/25200.
    coneq[19626]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/50400.
    coneq[19627]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*c**3)-1/10080.
    coneq[19628]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/30240.
    coneq[19629]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/60480.
    coneq[19630]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/20160.
    coneq[19631]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*c**3)-1/7560.
    coneq[19632]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/15120.
    coneq[19633]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*c**3)-1/5040.
    coneq[19634]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/15120.
    coneq[19635]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/30240.
    coneq[19636]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/10080.
    coneq[19637]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*c**3)-1/5040.
    coneq[19638]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*c**3)-1/25200.
    coneq[19639]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*c**3)-1/100800.
    coneq[19640]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/302400.
    coneq[19641]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/604800.
    coneq[19642]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/201600.
    coneq[19643]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/75600.
    coneq[19644]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/151200.
    coneq[19645]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/50400.
    coneq[19646]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/100800.
    coneq[19647]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*c**3)-1/20160.
    coneq[19648]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/60480.
    coneq[19649]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/120960.
    coneq[19650]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/40320.
    coneq[19651]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*c**3)-1/15120.
    coneq[19652]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/30240.
    coneq[19653]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*c**3)-1/10080.
    coneq[19654]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/30240.
    coneq[19655]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/60480.
    coneq[19656]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/20160.
    coneq[19657]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*c**3)-1/1960.
    coneq[19658]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*c**3)-1/11760.
    coneq[19659]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*c**3)-1/58800.
    coneq[19660]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*c**3)-1/235200.
    coneq[19661]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**3)-1/705600.
    coneq[19662]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**3)-1/1411200.
    coneq[19663]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**3)-1/470400.
    coneq[19664]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**3)-1/176400.
    coneq[19665]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**3)-1/352800.
    coneq[19666]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**3)-1/117600.
    coneq[19667]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**3)-1/235200.
    coneq[19668]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*c**3)-1/47040.
    coneq[19669]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**3)-1/141120.
    coneq[19670]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**3)-1/282240.
    coneq[19671]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**3)-1/94080.
    coneq[19672]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*c**3)-1/35280.
    coneq[19673]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**3)-1/70560.
    coneq[19674]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*c**3)-1/23520.
    coneq[19675]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**3)-1/70560.
    coneq[19676]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**3)-1/141120.
    coneq[19677]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**3)-1/47040.
    coneq[19678]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*c**3)-1/9800.
    coneq[19679]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*c**3)-1/39200.
    coneq[19680]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**3)-1/117600.
    coneq[19681]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/235200.
    coneq[19682]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**3)-1/78400.
    coneq[19683]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*c**3)-1/29400.
    coneq[19684]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**3)-1/58800.
    coneq[19685]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*c**3)-1/19600.
    coneq[19686]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**3)-1/39200.
    coneq[19687]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*c**3)-1/7840.
    coneq[19688]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*c**3)-1/23520.
    coneq[19689]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**3)-1/47040.
    coneq[19690]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*c**3)-1/15680.
    coneq[19691]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*c**3)-1/5880.
    coneq[19692]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*c**3)-1/11760.
    coneq[19693]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*c**3)-1/3920.
    coneq[19694]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*c**3)-1/17640.
    coneq[19695]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**3)-1/35280.
    coneq[19696]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**3)-1/70560.
    coneq[19697]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*c**3)-1/15680.
    coneq[19698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**3)-1/47040.
    coneq[19699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**3)-1/94080.
    coneq[19700]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**3)-1/31360.
    coneq[19701]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*c**3)-1/11760.
    coneq[19702]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**3)-1/23520.
    coneq[19703]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*c**3)-1/7840.
    coneq[19704]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**3)-1/15680.
    coneq[19705]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*c**3)-1/2240.
    coneq[19706]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*c**3)-1/6720.
    coneq[19707]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c**3)-1/13440.
    coneq[19708]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*c**3)-1/4480.
    coneq[19709]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c**3)-1/20160.
    coneq[19710]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c**3)-1/40320.
    coneq[19711]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c**3)-1/13440.
    coneq[19712]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c**3)-1/80640.
    coneq[19713]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c**3)-1/26880.
    coneq[19714]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c**3)-1/8960.
    coneq[19715]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*c**3)-1/2100.
    coneq[19716]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*c**3)-1/8400.
    coneq[19717]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/25200.
    coneq[19718]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/50400.
    coneq[19719]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/16800.
    coneq[19720]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*c**3)-1/6300.
    coneq[19721]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/12600.
    coneq[19722]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*c**3)-1/4200.
    coneq[19723]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/8400.
    coneq[19724]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*c**3)-1/4200.
    coneq[19725]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c**3)-1/16800.
    coneq[19726]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c**3)-1/50400.
    coneq[19727]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/100800.
    coneq[19728]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c**3)-1/33600.
    coneq[19729]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c**3)-1/12600.
    coneq[19730]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c**3)-1/25200.
    coneq[19731]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c**3)-1/8400.
    coneq[19732]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/16800.
    coneq[19733]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*c**3)-1/1680.
    coneq[19734]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*c**3)-1/8400.
    coneq[19735]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c**3)-1/33600.
    coneq[19736]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**3)-1/100800.
    coneq[19737]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**3)-1/201600.
    coneq[19738]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**3)-1/67200.
    coneq[19739]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c**3)-1/25200.
    coneq[19740]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**3)-1/50400.
    coneq[19741]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c**3)-1/16800.
    coneq[19742]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**3)-1/33600.
    coneq[19743]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*c**3)-1/6720.
    coneq[19744]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c**3)-1/20160.
    coneq[19745]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**3)-1/40320.
    coneq[19746]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c**3)-1/13440.
    coneq[19747]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*c**3)-1/5040.
    coneq[19748]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c**3)-1/10080.
    coneq[19749]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*c**3)-1/3360.
    coneq[19750]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c**3)-1/10080.
    coneq[19751]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**3)-1/20160.
    coneq[19752]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c**3)-1/6720.
    coneq[19753]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*c**3)-1/1680.
    coneq[19754]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*c**3)-1/5040.
    coneq[19755]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**3)-1/10080.
    coneq[19756]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*c**3)-1/3360.
    coneq[19757]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*c**3)-1/3360.
    coneq[19758]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**3)-1/10080.
    coneq[19759]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**3)-1/20160.
    coneq[19760]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**3)-1/6720.
    coneq[19761]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*c**3)-1/1400.
    coneq[19762]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*c**3)-1/5600.
    coneq[19763]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/16800.
    coneq[19764]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/33600.
    coneq[19765]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/11200.
    coneq[19766]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*c**3)-1/4200.
    coneq[19767]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/8400.
    coneq[19768]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*c**3)-1/2800.
    coneq[19769]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/5600.
    coneq[19770]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*c**3)-1/1260.
    coneq[19771]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/2520.
    coneq[19772]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/5040.
    coneq[19773]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*c**3)-1/1120.
    coneq[19774]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*c**3)-1/3360.
    coneq[19775]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**3)-1/6720.
    coneq[19776]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*c**3)-1/2240.
    coneq[19777]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*c**3)-1/840.
    coneq[19778]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/1680.
    coneq[19779]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*c**3)-1/560.
    coneq[19780]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*c**3)-1/2800.
    coneq[19781]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*c**3)-1/11200.
    coneq[19782]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**3)-1/33600.
    coneq[19783]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**3)-1/67200.
    coneq[19784]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**3)-1/22400.
    coneq[19785]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*c**3)-1/8400.
    coneq[19786]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**3)-1/16800.
    coneq[19787]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*c**3)-1/5600.
    coneq[19788]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**3)-1/11200.
    coneq[19789]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*c**3)-1/3360.
    coneq[19790]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*c**3)-1/10080.
    coneq[19791]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**3)-1/20160.
    coneq[19792]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*c**3)-1/6720.
    coneq[19793]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*c**3)-1/6720.
    coneq[19794]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**3)-1/20160.
    coneq[19795]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**3)-1/40320.
    coneq[19796]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**3)-1/13440.
    coneq[19797]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*c**3)-1/3780.
    coneq[19798]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/7560.
    coneq[19799]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/15120.
    coneq[19800]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/30240.
    coneq[19801]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*c**3)-1/2240.
    coneq[19802]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c**3)-1/6720.
    coneq[19803]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**3)-1/13440.
    coneq[19804]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c**3)-1/4480.
    coneq[19805]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*c**3)-1/2520.
    coneq[19806]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c**3)-1/5040.
    coneq[19807]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**3)-1/10080.
    coneq[19808]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*c**3)-1/1680.
    coneq[19809]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/3360.
    coneq[19810]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*c**3)-1/1120.
    coneq[19811]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*c**3)-1/3360.
    coneq[19812]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**3)-1/6720.
    coneq[19813]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c**3)-1/2240.
    coneq[19814]=dot(b,dot(A,c**8)*c**4)-1/126.
    coneq[19815]=dot(b,dot(A,dot(A,c**7))*c**4)-1/1008.
    coneq[19816]=dot(b,dot(A,dot(A,dot(A,c**6)))*c**4)-1/7056.
    coneq[19817]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*c**4)-1/42336.
    coneq[19818]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*c**4)-1/211680.
    coneq[19819]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*c**4)-1/846720.
    coneq[19820]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*c**4)-1/2540160.
    coneq[19821]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*c**4)-1/5080320.
    coneq[19822]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*c**4)-1/1693440.
    coneq[19823]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*c**4)-1/635040.
    coneq[19824]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*c**4)-1/1270080.
    coneq[19825]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*c**4)-1/423360.
    coneq[19826]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*c**4)-1/846720.
    coneq[19827]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*c**4)-1/169344.
    coneq[19828]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*c**4)-1/508032.
    coneq[19829]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*c**4)-1/1016064.
    coneq[19830]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*c**4)-1/338688.
    coneq[19831]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*c**4)-1/127008.
    coneq[19832]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*c**4)-1/254016.
    coneq[19833]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*c**4)-1/84672.
    coneq[19834]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*c**4)-1/254016.
    coneq[19835]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*c**4)-1/508032.
    coneq[19836]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*c**4)-1/169344.
    coneq[19837]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*c**4)-1/35280.
    coneq[19838]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*c**4)-1/141120.
    coneq[19839]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*c**4)-1/423360.
    coneq[19840]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*c**4)-1/846720.
    coneq[19841]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*c**4)-1/282240.
    coneq[19842]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*c**4)-1/105840.
    coneq[19843]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*c**4)-1/211680.
    coneq[19844]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*c**4)-1/70560.
    coneq[19845]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*c**4)-1/141120.
    coneq[19846]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*c**4)-1/28224.
    coneq[19847]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*c**4)-1/84672.
    coneq[19848]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*c**4)-1/169344.
    coneq[19849]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*c**4)-1/56448.
    coneq[19850]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*c**4)-1/21168.
    coneq[19851]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*c**4)-1/42336.
    coneq[19852]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*c**4)-1/14112.
    coneq[19853]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*c**4)-1/63504.
    coneq[19854]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*c**4)-1/127008.
    coneq[19855]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*c**4)-1/254016.
    coneq[19856]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*c**4)-1/56448.
    coneq[19857]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*c**4)-1/169344.
    coneq[19858]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*c**4)-1/338688.
    coneq[19859]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*c**4)-1/112896.
    coneq[19860]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*c**4)-1/42336.
    coneq[19861]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*c**4)-1/84672.
    coneq[19862]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*c**4)-1/28224.
    coneq[19863]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*c**4)-1/56448.
    coneq[19864]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*c**4)-1/6048.
    coneq[19865]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*c**4)-1/30240.
    coneq[19866]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*c**4)-1/120960.
    coneq[19867]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*c**4)-1/362880.
    coneq[19868]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**4)-1/725760.
    coneq[19869]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*c**4)-1/241920.
    coneq[19870]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*c**4)-1/90720.
    coneq[19871]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*c**4)-1/181440.
    coneq[19872]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*c**4)-1/60480.
    coneq[19873]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**4)-1/120960.
    coneq[19874]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*c**4)-1/24192.
    coneq[19875]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*c**4)-1/72576.
    coneq[19876]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*c**4)-1/145152.
    coneq[19877]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*c**4)-1/48384.
    coneq[19878]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*c**4)-1/18144.
    coneq[19879]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*c**4)-1/36288.
    coneq[19880]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*c**4)-1/12096.
    coneq[19881]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*c**4)-1/36288.
    coneq[19882]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**4)-1/72576.
    coneq[19883]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*c**4)-1/24192.
    coneq[19884]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*c**4)-1/5040.
    coneq[19885]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*c**4)-1/20160.
    coneq[19886]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*c**4)-1/60480.
    coneq[19887]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/120960.
    coneq[19888]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*c**4)-1/40320.
    coneq[19889]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*c**4)-1/15120.
    coneq[19890]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*c**4)-1/30240.
    coneq[19891]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*c**4)-1/10080.
    coneq[19892]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*c**4)-1/20160.
    coneq[19893]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*c**4)-1/4032.
    coneq[19894]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*c**4)-1/12096.
    coneq[19895]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*c**4)-1/24192.
    coneq[19896]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*c**4)-1/8064.
    coneq[19897]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*c**4)-1/3024.
    coneq[19898]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*c**4)-1/6048.
    coneq[19899]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*c**4)-1/2016.
    coneq[19900]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*c**4)-1/12096.
    coneq[19901]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*c**4)-1/36288.
    coneq[19902]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*c**4)-1/72576.
    coneq[19903]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*c**4)-1/24192.
    coneq[19904]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*c**4)-1/24192.
    coneq[19905]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*c**4)-1/72576.
    coneq[19906]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*c**4)-1/145152.
    coneq[19907]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*c**4)-1/48384.
    coneq[19908]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*c**4)-1/10080.
    coneq[19909]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*c**4)-1/40320.
    coneq[19910]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*c**4)-1/120960.
    coneq[19911]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/241920.
    coneq[19912]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*c**4)-1/80640.
    coneq[19913]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*c**4)-1/30240.
    coneq[19914]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*c**4)-1/60480.
    coneq[19915]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*c**4)-1/20160.
    coneq[19916]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*c**4)-1/40320.
    coneq[19917]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*c**4)-1/9072.
    coneq[19918]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*c**4)-1/18144.
    coneq[19919]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*c**4)-1/36288.
    coneq[19920]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*c**4)-1/8064.
    coneq[19921]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*c**4)-1/24192.
    coneq[19922]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**4)-1/48384.
    coneq[19923]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*c**4)-1/16128.
    coneq[19924]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*c**4)-1/6048.
    coneq[19925]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*c**4)-1/12096.
    coneq[19926]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*c**4)-1/4032.
    coneq[19927]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*c**4)-1/12096.
    coneq[19928]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*c**4)-1/24192.
    coneq[19929]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*c**4)-1/8064.
    coneq[19930]=dot(b,dot(A,c*dot(A,c**6))*c**4)-1/882.
    coneq[19931]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*c**4)-1/5292.
    coneq[19932]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*c**4)-1/26460.
    coneq[19933]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*c**4)-1/105840.
    coneq[19934]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**4)-1/317520.
    coneq[19935]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**4)-1/635040.
    coneq[19936]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**4)-1/211680.
    coneq[19937]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**4)-1/79380.
    coneq[19938]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**4)-1/158760.
    coneq[19939]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**4)-1/52920.
    coneq[19940]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**4)-1/105840.
    coneq[19941]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*c**4)-1/21168.
    coneq[19942]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**4)-1/63504.
    coneq[19943]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**4)-1/127008.
    coneq[19944]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**4)-1/42336.
    coneq[19945]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*c**4)-1/15876.
    coneq[19946]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**4)-1/31752.
    coneq[19947]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*c**4)-1/10584.
    coneq[19948]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**4)-1/31752.
    coneq[19949]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**4)-1/63504.
    coneq[19950]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**4)-1/21168.
    coneq[19951]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*c**4)-1/4410.
    coneq[19952]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*c**4)-1/17640.
    coneq[19953]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**4)-1/52920.
    coneq[19954]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/105840.
    coneq[19955]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**4)-1/35280.
    coneq[19956]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*c**4)-1/13230.
    coneq[19957]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**4)-1/26460.
    coneq[19958]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*c**4)-1/8820.
    coneq[19959]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**4)-1/17640.
    coneq[19960]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*c**4)-1/3528.
    coneq[19961]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*c**4)-1/10584.
    coneq[19962]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**4)-1/21168.
    coneq[19963]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*c**4)-1/7056.
    coneq[19964]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*c**4)-1/2646.
    coneq[19965]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*c**4)-1/5292.
    coneq[19966]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*c**4)-1/1764.
    coneq[19967]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*c**4)-1/7938.
    coneq[19968]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**4)-1/15876.
    coneq[19969]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**4)-1/31752.
    coneq[19970]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*c**4)-1/7056.
    coneq[19971]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**4)-1/21168.
    coneq[19972]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**4)-1/42336.
    coneq[19973]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**4)-1/14112.
    coneq[19974]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*c**4)-1/5292.
    coneq[19975]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**4)-1/10584.
    coneq[19976]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*c**4)-1/3528.
    coneq[19977]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**4)-1/7056.
    coneq[19978]=dot(b,dot(A,c**2*dot(A,c**5))*c**4)-1/756.
    coneq[19979]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*c**4)-1/3780.
    coneq[19980]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*c**4)-1/15120.
    coneq[19981]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**4)-1/45360.
    coneq[19982]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/90720.
    coneq[19983]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**4)-1/30240.
    coneq[19984]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*c**4)-1/11340.
    coneq[19985]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**4)-1/22680.
    coneq[19986]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*c**4)-1/7560.
    coneq[19987]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**4)-1/15120.
    coneq[19988]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*c**4)-1/3024.
    coneq[19989]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*c**4)-1/9072.
    coneq[19990]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**4)-1/18144.
    coneq[19991]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*c**4)-1/6048.
    coneq[19992]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*c**4)-1/2268.
    coneq[19993]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*c**4)-1/4536.
    coneq[19994]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*c**4)-1/1512.
    coneq[19995]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*c**4)-1/4536.
    coneq[19996]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**4)-1/9072.
    coneq[19997]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*c**4)-1/3024.
    coneq[19998]=dot(b,dot(A,c**3*dot(A,c**4))*c**4)-1/630.
    coneq[19999]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*c**4)-1/2520.
    coneq[20000]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*c**4)-1/7560.
    coneq[20001]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/15120.
    coneq[20002]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*c**4)-1/5040.
    coneq[20003]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*c**4)-1/1890.
    coneq[20004]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*c**4)-1/3780.
    coneq[20005]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*c**4)-1/1260.
    coneq[20006]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/2520.
    coneq[20007]=dot(b,dot(A,c**4*dot(A,c**3))*c**4)-1/504.
    coneq[20008]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*c**4)-1/1512.
    coneq[20009]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*c**4)-1/3024.
    coneq[20010]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*c**4)-1/1008.
    coneq[20011]=dot(b,dot(A,c**5*dot(A,c**2))*c**4)-1/378.
    coneq[20012]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*c**4)-1/756.
    coneq[20013]=dot(b,dot(A,c**6*dot(A,c))*c**4)-1/252.
    coneq[20014]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*c**4)-1/2016.
    coneq[20015]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*c**4)-1/6048.
    coneq[20016]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*c**4)-1/12096.
    coneq[20017]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*c**4)-1/4032.
    coneq[20018]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*c**4)-1/18144.
    coneq[20019]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*c**4)-1/36288.
    coneq[20020]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*c**4)-1/12096.
    coneq[20021]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*c**4)-1/72576.
    coneq[20022]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*c**4)-1/24192.
    coneq[20023]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*c**4)-1/8064.
    coneq[20024]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*c**4)-1/1890.
    coneq[20025]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*c**4)-1/7560.
    coneq[20026]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*c**4)-1/22680.
    coneq[20027]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/45360.
    coneq[20028]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*c**4)-1/15120.
    coneq[20029]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*c**4)-1/5670.
    coneq[20030]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*c**4)-1/11340.
    coneq[20031]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*c**4)-1/3780.
    coneq[20032]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/7560.
    coneq[20033]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*c**4)-1/3780.
    coneq[20034]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*c**4)-1/15120.
    coneq[20035]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*c**4)-1/45360.
    coneq[20036]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/90720.
    coneq[20037]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*c**4)-1/30240.
    coneq[20038]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*c**4)-1/11340.
    coneq[20039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*c**4)-1/22680.
    coneq[20040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*c**4)-1/7560.
    coneq[20041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/15120.
    coneq[20042]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*c**4)-1/1512.
    coneq[20043]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*c**4)-1/7560.
    coneq[20044]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*c**4)-1/30240.
    coneq[20045]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**4)-1/90720.
    coneq[20046]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**4)-1/181440.
    coneq[20047]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**4)-1/60480.
    coneq[20048]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*c**4)-1/22680.
    coneq[20049]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**4)-1/45360.
    coneq[20050]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*c**4)-1/15120.
    coneq[20051]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**4)-1/30240.
    coneq[20052]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*c**4)-1/6048.
    coneq[20053]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*c**4)-1/18144.
    coneq[20054]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**4)-1/36288.
    coneq[20055]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*c**4)-1/12096.
    coneq[20056]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*c**4)-1/4536.
    coneq[20057]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*c**4)-1/9072.
    coneq[20058]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*c**4)-1/3024.
    coneq[20059]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*c**4)-1/9072.
    coneq[20060]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**4)-1/18144.
    coneq[20061]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*c**4)-1/6048.
    coneq[20062]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*c**4)-1/1512.
    coneq[20063]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*c**4)-1/4536.
    coneq[20064]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**4)-1/9072.
    coneq[20065]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*c**4)-1/3024.
    coneq[20066]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*c**4)-1/3024.
    coneq[20067]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**4)-1/9072.
    coneq[20068]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**4)-1/18144.
    coneq[20069]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**4)-1/6048.
    coneq[20070]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*c**4)-1/1260.
    coneq[20071]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*c**4)-1/5040.
    coneq[20072]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**4)-1/15120.
    coneq[20073]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**4)-1/30240.
    coneq[20074]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**4)-1/10080.
    coneq[20075]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*c**4)-1/3780.
    coneq[20076]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**4)-1/7560.
    coneq[20077]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*c**4)-1/2520.
    coneq[20078]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**4)-1/5040.
    coneq[20079]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*c**4)-1/1134.
    coneq[20080]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*c**4)-1/2268.
    coneq[20081]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**4)-1/4536.
    coneq[20082]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*c**4)-1/1008.
    coneq[20083]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*c**4)-1/3024.
    coneq[20084]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**4)-1/6048.
    coneq[20085]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*c**4)-1/2016.
    coneq[20086]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*c**4)-1/756.
    coneq[20087]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*c**4)-1/1512.
    coneq[20088]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*c**4)-1/504.
    coneq[20089]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*c**4)-1/2016.
    coneq[20090]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*c**4)-1/6048.
    coneq[20091]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**4)-1/12096.
    coneq[20092]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*c**4)-1/4032.
    coneq[20093]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*c**4)-1/2268.
    coneq[20094]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*c**4)-1/4536.
    coneq[20095]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**4)-1/9072.
    coneq[20096]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*c**4)-1/1512.
    coneq[20097]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**4)-1/3024.
    coneq[20098]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*c**4)-1/1008.
    coneq[20099]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*c**4)-1/2016.
    coneq[20100]=dot(b,dot(A,c**7)*c**5)-1/112.
    coneq[20101]=dot(b,dot(A,dot(A,c**6))*c**5)-1/784.
    coneq[20102]=dot(b,dot(A,dot(A,dot(A,c**5)))*c**5)-1/4704.
    coneq[20103]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*c**5)-1/23520.
    coneq[20104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*c**5)-1/94080.
    coneq[20105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*c**5)-1/282240.
    coneq[20106]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*c**5)-1/564480.
    coneq[20107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*c**5)-1/188160.
    coneq[20108]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*c**5)-1/70560.
    coneq[20109]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*c**5)-1/141120.
    coneq[20110]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*c**5)-1/47040.
    coneq[20111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*c**5)-1/94080.
    coneq[20112]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*c**5)-1/18816.
    coneq[20113]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*c**5)-1/56448.
    coneq[20114]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*c**5)-1/112896.
    coneq[20115]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*c**5)-1/37632.
    coneq[20116]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*c**5)-1/14112.
    coneq[20117]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*c**5)-1/28224.
    coneq[20118]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*c**5)-1/9408.
    coneq[20119]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*c**5)-1/28224.
    coneq[20120]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*c**5)-1/56448.
    coneq[20121]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*c**5)-1/18816.
    coneq[20122]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*c**5)-1/3920.
    coneq[20123]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*c**5)-1/15680.
    coneq[20124]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*c**5)-1/47040.
    coneq[20125]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*c**5)-1/94080.
    coneq[20126]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*c**5)-1/31360.
    coneq[20127]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*c**5)-1/11760.
    coneq[20128]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*c**5)-1/23520.
    coneq[20129]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*c**5)-1/7840.
    coneq[20130]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*c**5)-1/15680.
    coneq[20131]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*c**5)-1/3136.
    coneq[20132]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*c**5)-1/9408.
    coneq[20133]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*c**5)-1/18816.
    coneq[20134]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*c**5)-1/6272.
    coneq[20135]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*c**5)-1/2352.
    coneq[20136]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*c**5)-1/4704.
    coneq[20137]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*c**5)-1/1568.
    coneq[20138]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*c**5)-1/7056.
    coneq[20139]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*c**5)-1/14112.
    coneq[20140]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*c**5)-1/28224.
    coneq[20141]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*c**5)-1/6272.
    coneq[20142]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*c**5)-1/18816.
    coneq[20143]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*c**5)-1/37632.
    coneq[20144]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*c**5)-1/12544.
    coneq[20145]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*c**5)-1/4704.
    coneq[20146]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*c**5)-1/9408.
    coneq[20147]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*c**5)-1/3136.
    coneq[20148]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*c**5)-1/6272.
    coneq[20149]=dot(b,dot(A,c*dot(A,c**5))*c**5)-1/672.
    coneq[20150]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*c**5)-1/3360.
    coneq[20151]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*c**5)-1/13440.
    coneq[20152]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*c**5)-1/40320.
    coneq[20153]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**5)-1/80640.
    coneq[20154]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*c**5)-1/26880.
    coneq[20155]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*c**5)-1/10080.
    coneq[20156]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*c**5)-1/20160.
    coneq[20157]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*c**5)-1/6720.
    coneq[20158]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*c**5)-1/13440.
    coneq[20159]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*c**5)-1/2688.
    coneq[20160]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*c**5)-1/8064.
    coneq[20161]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*c**5)-1/16128.
    coneq[20162]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*c**5)-1/5376.
    coneq[20163]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*c**5)-1/2016.
    coneq[20164]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*c**5)-1/4032.
    coneq[20165]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*c**5)-1/1344.
    coneq[20166]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*c**5)-1/4032.
    coneq[20167]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*c**5)-1/8064.
    coneq[20168]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*c**5)-1/2688.
    coneq[20169]=dot(b,dot(A,c**2*dot(A,c**4))*c**5)-1/560.
    coneq[20170]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*c**5)-1/2240.
    coneq[20171]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*c**5)-1/6720.
    coneq[20172]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*c**5)-1/13440.
    coneq[20173]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*c**5)-1/4480.
    coneq[20174]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*c**5)-1/1680.
    coneq[20175]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*c**5)-1/3360.
    coneq[20176]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*c**5)-1/1120.
    coneq[20177]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*c**5)-1/2240.
    coneq[20178]=dot(b,dot(A,c**3*dot(A,c**3))*c**5)-1/448.
    coneq[20179]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*c**5)-1/1344.
    coneq[20180]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*c**5)-1/2688.
    coneq[20181]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*c**5)-1/896.
    coneq[20182]=dot(b,dot(A,c**4*dot(A,c**2))*c**5)-1/336.
    coneq[20183]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*c**5)-1/672.
    coneq[20184]=dot(b,dot(A,c**5*dot(A,c))*c**5)-1/224.
    coneq[20185]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*c**5)-1/1344.
    coneq[20186]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*c**5)-1/4032.
    coneq[20187]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*c**5)-1/8064.
    coneq[20188]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*c**5)-1/2688.
    coneq[20189]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*c**5)-1/2688.
    coneq[20190]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*c**5)-1/8064.
    coneq[20191]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*c**5)-1/16128.
    coneq[20192]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*c**5)-1/5376.
    coneq[20193]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*c**5)-1/1120.
    coneq[20194]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*c**5)-1/4480.
    coneq[20195]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*c**5)-1/13440.
    coneq[20196]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*c**5)-1/26880.
    coneq[20197]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*c**5)-1/8960.
    coneq[20198]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*c**5)-1/3360.
    coneq[20199]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*c**5)-1/6720.
    coneq[20200]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*c**5)-1/2240.
    coneq[20201]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*c**5)-1/4480.
    coneq[20202]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*c**5)-1/1008.
    coneq[20203]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*c**5)-1/2016.
    coneq[20204]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*c**5)-1/4032.
    coneq[20205]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*c**5)-1/896.
    coneq[20206]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*c**5)-1/2688.
    coneq[20207]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*c**5)-1/5376.
    coneq[20208]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*c**5)-1/1792.
    coneq[20209]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*c**5)-1/672.
    coneq[20210]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*c**5)-1/1344.
    coneq[20211]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*c**5)-1/448.
    coneq[20212]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*c**5)-1/1344.
    coneq[20213]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*c**5)-1/2688.
    coneq[20214]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*c**5)-1/896.
    coneq[20215]=dot(b,dot(A,c**6)*c**6)-1/98.
    coneq[20216]=dot(b,dot(A,dot(A,c**5))*c**6)-1/588.
    coneq[20217]=dot(b,dot(A,dot(A,dot(A,c**4)))*c**6)-1/2940.
    coneq[20218]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*c**6)-1/11760.
    coneq[20219]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*c**6)-1/35280.
    coneq[20220]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*c**6)-1/70560.
    coneq[20221]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*c**6)-1/23520.
    coneq[20222]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*c**6)-1/8820.
    coneq[20223]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*c**6)-1/17640.
    coneq[20224]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*c**6)-1/5880.
    coneq[20225]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*c**6)-1/11760.
    coneq[20226]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*c**6)-1/2352.
    coneq[20227]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*c**6)-1/7056.
    coneq[20228]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*c**6)-1/14112.
    coneq[20229]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*c**6)-1/4704.
    coneq[20230]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*c**6)-1/1764.
    coneq[20231]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*c**6)-1/3528.
    coneq[20232]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*c**6)-1/1176.
    coneq[20233]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*c**6)-1/3528.
    coneq[20234]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*c**6)-1/7056.
    coneq[20235]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*c**6)-1/2352.
    coneq[20236]=dot(b,dot(A,c*dot(A,c**4))*c**6)-1/490.
    coneq[20237]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*c**6)-1/1960.
    coneq[20238]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*c**6)-1/5880.
    coneq[20239]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*c**6)-1/11760.
    coneq[20240]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*c**6)-1/3920.
    coneq[20241]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*c**6)-1/1470.
    coneq[20242]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*c**6)-1/2940.
    coneq[20243]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*c**6)-1/980.
    coneq[20244]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*c**6)-1/1960.
    coneq[20245]=dot(b,dot(A,c**2*dot(A,c**3))*c**6)-1/392.
    coneq[20246]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*c**6)-1/1176.
    coneq[20247]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*c**6)-1/2352.
    coneq[20248]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*c**6)-1/784.
    coneq[20249]=dot(b,dot(A,c**3*dot(A,c**2))*c**6)-1/294.
    coneq[20250]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*c**6)-1/588.
    coneq[20251]=dot(b,dot(A,c**4*dot(A,c))*c**6)-1/196.
    coneq[20252]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*c**6)-1/882.
    coneq[20253]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*c**6)-1/1764.
    coneq[20254]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*c**6)-1/3528.
    coneq[20255]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*c**6)-1/784.
    coneq[20256]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*c**6)-1/2352.
    coneq[20257]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*c**6)-1/4704.
    coneq[20258]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*c**6)-1/1568.
    coneq[20259]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*c**6)-1/588.
    coneq[20260]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*c**6)-1/1176.
    coneq[20261]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*c**6)-1/392.
    coneq[20262]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*c**6)-1/784.
    coneq[20263]=dot(b,dot(A,c**5)*c**7)-1/84.
    coneq[20264]=dot(b,dot(A,dot(A,c**4))*c**7)-1/420.
    coneq[20265]=dot(b,dot(A,dot(A,dot(A,c**3)))*c**7)-1/1680.
    coneq[20266]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*c**7)-1/5040.
    coneq[20267]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c**7)-1/10080.
    coneq[20268]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*c**7)-1/3360.
    coneq[20269]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*c**7)-1/1260.
    coneq[20270]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*c**7)-1/2520.
    coneq[20271]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*c**7)-1/840.
    coneq[20272]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*c**7)-1/1680.
    coneq[20273]=dot(b,dot(A,c*dot(A,c**3))*c**7)-1/336.
    coneq[20274]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*c**7)-1/1008.
    coneq[20275]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*c**7)-1/2016.
    coneq[20276]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*c**7)-1/672.
    coneq[20277]=dot(b,dot(A,c**2*dot(A,c**2))*c**7)-1/252.
    coneq[20278]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*c**7)-1/504.
    coneq[20279]=dot(b,dot(A,c**3*dot(A,c))*c**7)-1/168.
    coneq[20280]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*c**7)-1/504.
    coneq[20281]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*c**7)-1/1008.
    coneq[20282]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*c**7)-1/336.
    coneq[20283]=dot(b,dot(A,c**4)*c**8)-1/70.
    coneq[20284]=dot(b,dot(A,dot(A,c**3))*c**8)-1/280.
    coneq[20285]=dot(b,dot(A,dot(A,dot(A,c**2)))*c**8)-1/840.
    coneq[20286]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*c**8)-1/1680.
    coneq[20287]=dot(b,dot(A,dot(A,c*dot(A,c)))*c**8)-1/560.
    coneq[20288]=dot(b,dot(A,c*dot(A,c**2))*c**8)-1/210.
    coneq[20289]=dot(b,dot(A,c*dot(A,dot(A,c)))*c**8)-1/420.
    coneq[20290]=dot(b,dot(A,c**2*dot(A,c))*c**8)-1/140.
    coneq[20291]=dot(b,dot(A,dot(A,c)*dot(A,c))*c**8)-1/280.
    coneq[20292]=dot(b,dot(A,c**3)*c**9)-1/56.
    coneq[20293]=dot(b,dot(A,dot(A,c**2))*c**9)-1/168.
    coneq[20294]=dot(b,dot(A,dot(A,dot(A,c)))*c**9)-1/336.
    coneq[20295]=dot(b,dot(A,c*dot(A,c))*c**9)-1/112.
    coneq[20296]=dot(b,dot(A,c**2)*c**10)-1/42.
    coneq[20297]=dot(b,dot(A,dot(A,c))*c**10)-1/84.
    coneq[20298]=dot(b,dot(A,c)*c**11)-1/28.
    coneq[20299]=dot(b,dot(A,c**6)*dot(A,c**5))-1/588.
    coneq[20300]=dot(b,dot(A,dot(A,c**5))*dot(A,c**5))-1/3528.
    coneq[20301]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**5))-1/17640.
    coneq[20302]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**5))-1/70560.
    coneq[20303]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**5))-1/211680.
    coneq[20304]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**5))-1/423360.
    coneq[20305]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**5))-1/141120.
    coneq[20306]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**5))-1/52920.
    coneq[20307]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**5))-1/105840.
    coneq[20308]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**5))-1/35280.
    coneq[20309]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**5))-1/70560.
    coneq[20310]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**5))-1/14112.
    coneq[20311]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**5))-1/42336.
    coneq[20312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**5))-1/84672.
    coneq[20313]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**5))-1/28224.
    coneq[20314]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**5))-1/10584.
    coneq[20315]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**5))-1/21168.
    coneq[20316]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**5))-1/7056.
    coneq[20317]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**5))-1/21168.
    coneq[20318]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**5))-1/42336.
    coneq[20319]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**5))-1/14112.
    coneq[20320]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**5))-1/2940.
    coneq[20321]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**5))-1/11760.
    coneq[20322]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**5))-1/35280.
    coneq[20323]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**5))-1/70560.
    coneq[20324]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**5))-1/23520.
    coneq[20325]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**5))-1/8820.
    coneq[20326]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**5))-1/17640.
    coneq[20327]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**5))-1/5880.
    coneq[20328]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**5))-1/11760.
    coneq[20329]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**5))-1/2352.
    coneq[20330]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**5))-1/7056.
    coneq[20331]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**5))-1/14112.
    coneq[20332]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**5))-1/4704.
    coneq[20333]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**5))-1/1764.
    coneq[20334]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**5))-1/3528.
    coneq[20335]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**5))-1/1176.
    coneq[20336]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**5))-1/5292.
    coneq[20337]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**5))-1/10584.
    coneq[20338]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**5))-1/21168.
    coneq[20339]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**5))-1/4704.
    coneq[20340]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**5))-1/14112.
    coneq[20341]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**5))-1/28224.
    coneq[20342]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**5))-1/9408.
    coneq[20343]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**5))-1/3528.
    coneq[20344]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**5))-1/7056.
    coneq[20345]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**5))-1/2352.
    coneq[20346]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**5))-1/4704.
    coneq[20347]=dot(b,dot(A,c**6)*dot(A,dot(A,c**4)))-1/2940.
    coneq[20348]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**4)))-1/17640.
    coneq[20349]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**4)))-1/88200.
    coneq[20350]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**4)))-1/352800.
    coneq[20351]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**4)))-1/1058400.
    coneq[20352]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**4)))-1/2116800.
    coneq[20353]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**4)))-1/705600.
    coneq[20354]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**4)))-1/264600.
    coneq[20355]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**4)))-1/529200.
    coneq[20356]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**4)))-1/176400.
    coneq[20357]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**4)))-1/352800.
    coneq[20358]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**4)))-1/70560.
    coneq[20359]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**4)))-1/211680.
    coneq[20360]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**4)))-1/423360.
    coneq[20361]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**4)))-1/141120.
    coneq[20362]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**4)))-1/52920.
    coneq[20363]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/105840.
    coneq[20364]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**4)))-1/35280.
    coneq[20365]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**4)))-1/105840.
    coneq[20366]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/211680.
    coneq[20367]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**4)))-1/70560.
    coneq[20368]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**4)))-1/14700.
    coneq[20369]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**4)))-1/58800.
    coneq[20370]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**4)))-1/176400.
    coneq[20371]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**4)))-1/352800.
    coneq[20372]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**4)))-1/117600.
    coneq[20373]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**4)))-1/44100.
    coneq[20374]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/88200.
    coneq[20375]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**4)))-1/29400.
    coneq[20376]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**4)))-1/58800.
    coneq[20377]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**4)))-1/11760.
    coneq[20378]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**4)))-1/35280.
    coneq[20379]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/70560.
    coneq[20380]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**4)))-1/23520.
    coneq[20381]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**4)))-1/8820.
    coneq[20382]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))-1/17640.
    coneq[20383]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**4)))-1/5880.
    coneq[20384]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**4)))-1/26460.
    coneq[20385]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))-1/52920.
    coneq[20386]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))-1/105840.
    coneq[20387]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**4)))-1/23520.
    coneq[20388]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**4)))-1/70560.
    coneq[20389]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4)))-1/141120.
    coneq[20390]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**4)))-1/47040.
    coneq[20391]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**4)))-1/17640.
    coneq[20392]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**4)))-1/35280.
    coneq[20393]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**4)))-1/11760.
    coneq[20394]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**4)))-1/23520.
    coneq[20395]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c**3))))-1/11760.
    coneq[20396]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c**3))))-1/70560.
    coneq[20397]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c**3))))-1/352800.
    coneq[20398]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c**3))))-1/1411200.
    coneq[20399]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c**3))))-1/4233600.
    coneq[20400]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**3))))-1/8467200.
    coneq[20401]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c**3))))-1/2822400.
    coneq[20402]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c**3))))-1/1058400.
    coneq[20403]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**3))))-1/2116800.
    coneq[20404]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/705600.
    coneq[20405]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/1411200.
    coneq[20406]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c**3))))-1/282240.
    coneq[20407]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**3))))-1/846720.
    coneq[20408]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**3))))-1/1693440.
    coneq[20409]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/564480.
    coneq[20410]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/211680.
    coneq[20411]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/423360.
    coneq[20412]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/141120.
    coneq[20413]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/423360.
    coneq[20414]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/846720.
    coneq[20415]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/282240.
    coneq[20416]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c**3))))-1/58800.
    coneq[20417]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**3))))-1/235200.
    coneq[20418]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**3))))-1/705600.
    coneq[20419]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**3))))-1/1411200.
    coneq[20420]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/470400.
    coneq[20421]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/176400.
    coneq[20422]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/352800.
    coneq[20423]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/117600.
    coneq[20424]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/235200.
    coneq[20425]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c**3))))-1/47040.
    coneq[20426]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/141120.
    coneq[20427]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/282240.
    coneq[20428]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/94080.
    coneq[20429]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))-1/35280.
    coneq[20430]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/70560.
    coneq[20431]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c**3))))-1/23520.
    coneq[20432]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))-1/105840.
    coneq[20433]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/211680.
    coneq[20434]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/423360.
    coneq[20435]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c**3))))-1/94080.
    coneq[20436]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3))))-1/282240.
    coneq[20437]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3))))-1/564480.
    coneq[20438]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/188160.
    coneq[20439]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))-1/70560.
    coneq[20440]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))-1/141120.
    coneq[20441]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3))))-1/47040.
    coneq[20442]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3))))-1/94080.
    coneq[20443]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/35280.
    coneq[20444]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/211680.
    coneq[20445]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1058400.
    coneq[20446]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/4233600.
    coneq[20447]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/12700800.
    coneq[20448]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/25401600.
    coneq[20449]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/8467200.
    coneq[20450]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/3175200.
    coneq[20451]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/6350400.
    coneq[20452]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/2116800.
    coneq[20453]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/4233600.
    coneq[20454]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/846720.
    coneq[20455]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/2540160.
    coneq[20456]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/5080320.
    coneq[20457]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1693440.
    coneq[20458]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/635040.
    coneq[20459]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1270080.
    coneq[20460]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/423360.
    coneq[20461]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1270080.
    coneq[20462]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/2540160.
    coneq[20463]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/846720.
    coneq[20464]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/176400.
    coneq[20465]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/705600.
    coneq[20466]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/2116800.
    coneq[20467]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/4233600.
    coneq[20468]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1411200.
    coneq[20469]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/529200.
    coneq[20470]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1058400.
    coneq[20471]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/352800.
    coneq[20472]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/705600.
    coneq[20473]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/141120.
    coneq[20474]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/423360.
    coneq[20475]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/846720.
    coneq[20476]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/282240.
    coneq[20477]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/105840.
    coneq[20478]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/211680.
    coneq[20479]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/70560.
    coneq[20480]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/317520.
    coneq[20481]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/635040.
    coneq[20482]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1270080.
    coneq[20483]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/282240.
    coneq[20484]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/846720.
    coneq[20485]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/1693440.
    coneq[20486]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/564480.
    coneq[20487]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/211680.
    coneq[20488]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/423360.
    coneq[20489]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/141120.
    coneq[20490]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))-1/282240.
    coneq[20491]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/70560.
    coneq[20492]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/423360.
    coneq[20493]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2116800.
    coneq[20494]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/8467200.
    coneq[20495]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/25401600.
    coneq[20496]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/50803200.
    coneq[20497]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/16934400.
    coneq[20498]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/6350400.
    coneq[20499]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/12700800.
    coneq[20500]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/4233600.
    coneq[20501]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/8467200.
    coneq[20502]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1693440.
    coneq[20503]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/5080320.
    coneq[20504]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/10160640.
    coneq[20505]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/3386880.
    coneq[20506]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1270080.
    coneq[20507]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2540160.
    coneq[20508]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/846720.
    coneq[20509]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2540160.
    coneq[20510]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/5080320.
    coneq[20511]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1693440.
    coneq[20512]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/352800.
    coneq[20513]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1411200.
    coneq[20514]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/4233600.
    coneq[20515]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/8467200.
    coneq[20516]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2822400.
    coneq[20517]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1058400.
    coneq[20518]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2116800.
    coneq[20519]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/705600.
    coneq[20520]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1411200.
    coneq[20521]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/282240.
    coneq[20522]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/846720.
    coneq[20523]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1693440.
    coneq[20524]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/564480.
    coneq[20525]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/211680.
    coneq[20526]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/423360.
    coneq[20527]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/141120.
    coneq[20528]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/635040.
    coneq[20529]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1270080.
    coneq[20530]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/2540160.
    coneq[20531]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/564480.
    coneq[20532]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1693440.
    coneq[20533]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/3386880.
    coneq[20534]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/1128960.
    coneq[20535]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/423360.
    coneq[20536]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/846720.
    coneq[20537]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/282240.
    coneq[20538]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))-1/564480.
    coneq[20539]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/23520.
    coneq[20540]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/141120.
    coneq[20541]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/705600.
    coneq[20542]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/2822400.
    coneq[20543]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/8467200.
    coneq[20544]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/16934400.
    coneq[20545]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/5644800.
    coneq[20546]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/2116800.
    coneq[20547]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/4233600.
    coneq[20548]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1411200.
    coneq[20549]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/2822400.
    coneq[20550]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/564480.
    coneq[20551]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1693440.
    coneq[20552]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/3386880.
    coneq[20553]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1128960.
    coneq[20554]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/423360.
    coneq[20555]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/846720.
    coneq[20556]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/282240.
    coneq[20557]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/846720.
    coneq[20558]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1693440.
    coneq[20559]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/564480.
    coneq[20560]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/117600.
    coneq[20561]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/470400.
    coneq[20562]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1411200.
    coneq[20563]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/2822400.
    coneq[20564]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/940800.
    coneq[20565]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/352800.
    coneq[20566]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/705600.
    coneq[20567]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/235200.
    coneq[20568]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/470400.
    coneq[20569]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/94080.
    coneq[20570]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/282240.
    coneq[20571]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/564480.
    coneq[20572]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/188160.
    coneq[20573]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/70560.
    coneq[20574]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/141120.
    coneq[20575]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/47040.
    coneq[20576]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/211680.
    coneq[20577]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/423360.
    coneq[20578]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/846720.
    coneq[20579]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/188160.
    coneq[20580]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/564480.
    coneq[20581]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/1128960.
    coneq[20582]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/376320.
    coneq[20583]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/141120.
    coneq[20584]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/282240.
    coneq[20585]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/94080.
    coneq[20586]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))-1/188160.
    coneq[20587]=dot(b,dot(A,c**6)*dot(A,dot(A,c*dot(A,c**2))))-1/8820.
    coneq[20588]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c*dot(A,c**2))))-1/52920.
    coneq[20589]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c*dot(A,c**2))))-1/264600.
    coneq[20590]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c*dot(A,c**2))))-1/1058400.
    coneq[20591]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c**2))))-1/3175200.
    coneq[20592]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c**2))))-1/6350400.
    coneq[20593]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,c**2))))-1/2116800.
    coneq[20594]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c**2))))-1/793800.
    coneq[20595]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c**2))))-1/1587600.
    coneq[20596]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/529200.
    coneq[20597]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/1058400.
    coneq[20598]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c*dot(A,c**2))))-1/211680.
    coneq[20599]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c**2))))-1/635040.
    coneq[20600]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c**2))))-1/1270080.
    coneq[20601]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/423360.
    coneq[20602]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/158760.
    coneq[20603]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/317520.
    coneq[20604]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/105840.
    coneq[20605]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/317520.
    coneq[20606]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/635040.
    coneq[20607]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/211680.
    coneq[20608]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c*dot(A,c**2))))-1/44100.
    coneq[20609]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c**2))))-1/176400.
    coneq[20610]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c**2))))-1/529200.
    coneq[20611]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c**2))))-1/1058400.
    coneq[20612]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/352800.
    coneq[20613]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/132300.
    coneq[20614]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/264600.
    coneq[20615]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/88200.
    coneq[20616]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/176400.
    coneq[20617]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2))))-1/35280.
    coneq[20618]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/105840.
    coneq[20619]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/211680.
    coneq[20620]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/70560.
    coneq[20621]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))-1/26460.
    coneq[20622]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/52920.
    coneq[20623]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))-1/17640.
    coneq[20624]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))-1/79380.
    coneq[20625]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/158760.
    coneq[20626]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/317520.
    coneq[20627]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2))))-1/70560.
    coneq[20628]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2))))-1/211680.
    coneq[20629]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2))))-1/423360.
    coneq[20630]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/141120.
    coneq[20631]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))-1/52920.
    coneq[20632]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))-1/105840.
    coneq[20633]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))-1/35280.
    coneq[20634]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))-1/70560.
    coneq[20635]=dot(b,dot(A,c**6)*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/17640.
    coneq[20636]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/105840.
    coneq[20637]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/529200.
    coneq[20638]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/2116800.
    coneq[20639]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/6350400.
    coneq[20640]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/12700800.
    coneq[20641]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/4233600.
    coneq[20642]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/1587600.
    coneq[20643]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/3175200.
    coneq[20644]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/1058400.
    coneq[20645]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/2116800.
    coneq[20646]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/423360.
    coneq[20647]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/1270080.
    coneq[20648]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/2540160.
    coneq[20649]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/846720.
    coneq[20650]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/317520.
    coneq[20651]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/635040.
    coneq[20652]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/211680.
    coneq[20653]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/635040.
    coneq[20654]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/1270080.
    coneq[20655]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/423360.
    coneq[20656]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/88200.
    coneq[20657]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/352800.
    coneq[20658]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/1058400.
    coneq[20659]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/2116800.
    coneq[20660]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/705600.
    coneq[20661]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/264600.
    coneq[20662]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/529200.
    coneq[20663]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/176400.
    coneq[20664]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/352800.
    coneq[20665]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/70560.
    coneq[20666]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/211680.
    coneq[20667]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/423360.
    coneq[20668]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/141120.
    coneq[20669]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/52920.
    coneq[20670]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/105840.
    coneq[20671]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/35280.
    coneq[20672]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/158760.
    coneq[20673]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/317520.
    coneq[20674]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/635040.
    coneq[20675]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/141120.
    coneq[20676]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/423360.
    coneq[20677]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/846720.
    coneq[20678]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/282240.
    coneq[20679]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/105840.
    coneq[20680]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/211680.
    coneq[20681]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/70560.
    coneq[20682]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))-1/141120.
    coneq[20683]=dot(b,dot(A,c**6)*dot(A,dot(A,c**2*dot(A,c))))-1/5880.
    coneq[20684]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**2*dot(A,c))))-1/35280.
    coneq[20685]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**2*dot(A,c))))-1/176400.
    coneq[20686]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2*dot(A,c))))-1/705600.
    coneq[20687]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2*dot(A,c))))-1/2116800.
    coneq[20688]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2*dot(A,c))))-1/4233600.
    coneq[20689]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2*dot(A,c))))-1/1411200.
    coneq[20690]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2*dot(A,c))))-1/529200.
    coneq[20691]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2*dot(A,c))))-1/1058400.
    coneq[20692]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/352800.
    coneq[20693]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/705600.
    coneq[20694]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2*dot(A,c))))-1/141120.
    coneq[20695]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2*dot(A,c))))-1/423360.
    coneq[20696]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2*dot(A,c))))-1/846720.
    coneq[20697]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/282240.
    coneq[20698]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))-1/105840.
    coneq[20699]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/211680.
    coneq[20700]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/70560.
    coneq[20701]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))-1/211680.
    coneq[20702]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/423360.
    coneq[20703]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/141120.
    coneq[20704]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**2*dot(A,c))))-1/29400.
    coneq[20705]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2*dot(A,c))))-1/117600.
    coneq[20706]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2*dot(A,c))))-1/352800.
    coneq[20707]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2*dot(A,c))))-1/705600.
    coneq[20708]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/235200.
    coneq[20709]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))-1/88200.
    coneq[20710]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/176400.
    coneq[20711]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/58800.
    coneq[20712]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/117600.
    coneq[20713]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c))))-1/23520.
    coneq[20714]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))-1/70560.
    coneq[20715]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/141120.
    coneq[20716]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/47040.
    coneq[20717]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))-1/17640.
    coneq[20718]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/35280.
    coneq[20719]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))-1/11760.
    coneq[20720]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))-1/52920.
    coneq[20721]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/105840.
    coneq[20722]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/211680.
    coneq[20723]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c))))-1/47040.
    coneq[20724]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c))))-1/141120.
    coneq[20725]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c))))-1/282240.
    coneq[20726]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/94080.
    coneq[20727]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))-1/35280.
    coneq[20728]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))-1/70560.
    coneq[20729]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))-1/23520.
    coneq[20730]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))-1/47040.
    coneq[20731]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/11760.
    coneq[20732]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/70560.
    coneq[20733]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/352800.
    coneq[20734]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/1411200.
    coneq[20735]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/4233600.
    coneq[20736]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/8467200.
    coneq[20737]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/2822400.
    coneq[20738]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/1058400.
    coneq[20739]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/2116800.
    coneq[20740]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/705600.
    coneq[20741]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/1411200.
    coneq[20742]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/282240.
    coneq[20743]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/846720.
    coneq[20744]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/1693440.
    coneq[20745]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/564480.
    coneq[20746]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/211680.
    coneq[20747]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/423360.
    coneq[20748]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/141120.
    coneq[20749]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/423360.
    coneq[20750]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/846720.
    coneq[20751]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/282240.
    coneq[20752]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/58800.
    coneq[20753]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/235200.
    coneq[20754]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/705600.
    coneq[20755]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/1411200.
    coneq[20756]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/470400.
    coneq[20757]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/176400.
    coneq[20758]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/352800.
    coneq[20759]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/117600.
    coneq[20760]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/235200.
    coneq[20761]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/47040.
    coneq[20762]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/141120.
    coneq[20763]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/282240.
    coneq[20764]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/94080.
    coneq[20765]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/35280.
    coneq[20766]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/70560.
    coneq[20767]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/23520.
    coneq[20768]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/105840.
    coneq[20769]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/211680.
    coneq[20770]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/423360.
    coneq[20771]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/94080.
    coneq[20772]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/282240.
    coneq[20773]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/564480.
    coneq[20774]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/188160.
    coneq[20775]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/70560.
    coneq[20776]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/141120.
    coneq[20777]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/47040.
    coneq[20778]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))-1/94080.
    coneq[20779]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c**3)))-1/2352.
    coneq[20780]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c**3)))-1/14112.
    coneq[20781]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c**3)))-1/70560.
    coneq[20782]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c**3)))-1/282240.
    coneq[20783]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c**3)))-1/846720.
    coneq[20784]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c**3)))-1/1693440.
    coneq[20785]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c**3)))-1/564480.
    coneq[20786]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c**3)))-1/211680.
    coneq[20787]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**3)))-1/423360.
    coneq[20788]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c**3)))-1/141120.
    coneq[20789]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c**3)))-1/282240.
    coneq[20790]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c**3)))-1/56448.
    coneq[20791]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**3)))-1/169344.
    coneq[20792]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**3)))-1/338688.
    coneq[20793]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**3)))-1/112896.
    coneq[20794]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c**3)))-1/42336.
    coneq[20795]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))-1/84672.
    coneq[20796]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/28224.
    coneq[20797]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c**3)))-1/84672.
    coneq[20798]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))-1/169344.
    coneq[20799]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/56448.
    coneq[20800]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c**3)))-1/11760.
    coneq[20801]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**3)))-1/47040.
    coneq[20802]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**3)))-1/141120.
    coneq[20803]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**3)))-1/282240.
    coneq[20804]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**3)))-1/94080.
    coneq[20805]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**3)))-1/35280.
    coneq[20806]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))-1/70560.
    coneq[20807]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/23520.
    coneq[20808]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/47040.
    coneq[20809]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c**3)))-1/9408.
    coneq[20810]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3)))-1/28224.
    coneq[20811]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))-1/56448.
    coneq[20812]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/18816.
    coneq[20813]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c**3)))-1/7056.
    coneq[20814]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))-1/14112.
    coneq[20815]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c**3)))-1/4704.
    coneq[20816]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c**3)))-1/21168.
    coneq[20817]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))-1/42336.
    coneq[20818]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))-1/84672.
    coneq[20819]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c**3)))-1/18816.
    coneq[20820]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3)))-1/56448.
    coneq[20821]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3)))-1/112896.
    coneq[20822]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3)))-1/37632.
    coneq[20823]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**3)))-1/14112.
    coneq[20824]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))-1/28224.
    coneq[20825]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3)))-1/9408.
    coneq[20826]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3)))-1/18816.
    coneq[20827]=dot(b,dot(A,c**6)*dot(A,c*dot(A,dot(A,c**2))))-1/7056.
    coneq[20828]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,dot(A,c**2))))-1/42336.
    coneq[20829]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,dot(A,c**2))))-1/211680.
    coneq[20830]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,dot(A,c**2))))-1/846720.
    coneq[20831]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c**2))))-1/2540160.
    coneq[20832]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c**2))))-1/5080320.
    coneq[20833]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,c**2))))-1/1693440.
    coneq[20834]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c**2))))-1/635040.
    coneq[20835]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c**2))))-1/1270080.
    coneq[20836]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/423360.
    coneq[20837]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/846720.
    coneq[20838]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,dot(A,c**2))))-1/169344.
    coneq[20839]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c**2))))-1/508032.
    coneq[20840]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c**2))))-1/1016064.
    coneq[20841]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/338688.
    coneq[20842]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))-1/127008.
    coneq[20843]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/254016.
    coneq[20844]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/84672.
    coneq[20845]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))-1/254016.
    coneq[20846]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/508032.
    coneq[20847]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/169344.
    coneq[20848]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,dot(A,c**2))))-1/35280.
    coneq[20849]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c**2))))-1/141120.
    coneq[20850]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c**2))))-1/423360.
    coneq[20851]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c**2))))-1/846720.
    coneq[20852]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/282240.
    coneq[20853]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))-1/105840.
    coneq[20854]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/211680.
    coneq[20855]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/70560.
    coneq[20856]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/141120.
    coneq[20857]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2))))-1/28224.
    coneq[20858]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))-1/84672.
    coneq[20859]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/169344.
    coneq[20860]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/56448.
    coneq[20861]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))-1/21168.
    coneq[20862]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/42336.
    coneq[20863]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))-1/14112.
    coneq[20864]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))-1/63504.
    coneq[20865]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/127008.
    coneq[20866]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/254016.
    coneq[20867]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,dot(A,c**2))))-1/56448.
    coneq[20868]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2))))-1/169344.
    coneq[20869]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2))))-1/338688.
    coneq[20870]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/112896.
    coneq[20871]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))-1/42336.
    coneq[20872]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))-1/84672.
    coneq[20873]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))-1/28224.
    coneq[20874]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))-1/56448.
    coneq[20875]=dot(b,dot(A,c**6)*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/14112.
    coneq[20876]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/84672.
    coneq[20877]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/423360.
    coneq[20878]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1693440.
    coneq[20879]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/5080320.
    coneq[20880]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/10160640.
    coneq[20881]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/3386880.
    coneq[20882]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1270080.
    coneq[20883]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/2540160.
    coneq[20884]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/846720.
    coneq[20885]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1693440.
    coneq[20886]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/338688.
    coneq[20887]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1016064.
    coneq[20888]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/2032128.
    coneq[20889]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/677376.
    coneq[20890]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/254016.
    coneq[20891]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/508032.
    coneq[20892]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/169344.
    coneq[20893]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/508032.
    coneq[20894]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1016064.
    coneq[20895]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/338688.
    coneq[20896]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/70560.
    coneq[20897]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/282240.
    coneq[20898]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/846720.
    coneq[20899]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/1693440.
    coneq[20900]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/564480.
    coneq[20901]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/211680.
    coneq[20902]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/423360.
    coneq[20903]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/141120.
    coneq[20904]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/282240.
    coneq[20905]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/56448.
    coneq[20906]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/169344.
    coneq[20907]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/338688.
    coneq[20908]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/112896.
    coneq[20909]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/42336.
    coneq[20910]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/84672.
    coneq[20911]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/28224.
    coneq[20912]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/127008.
    coneq[20913]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/254016.
    coneq[20914]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/508032.
    coneq[20915]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/112896.
    coneq[20916]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/338688.
    coneq[20917]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/677376.
    coneq[20918]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/225792.
    coneq[20919]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/84672.
    coneq[20920]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/169344.
    coneq[20921]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/56448.
    coneq[20922]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))-1/112896.
    coneq[20923]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c*dot(A,c))))-1/4704.
    coneq[20924]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c*dot(A,c))))-1/28224.
    coneq[20925]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c*dot(A,c))))-1/141120.
    coneq[20926]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c*dot(A,c))))-1/564480.
    coneq[20927]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c*dot(A,c))))-1/1693440.
    coneq[20928]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c*dot(A,c))))-1/3386880.
    coneq[20929]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c*dot(A,c))))-1/1128960.
    coneq[20930]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c*dot(A,c))))-1/423360.
    coneq[20931]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c*dot(A,c))))-1/846720.
    coneq[20932]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/282240.
    coneq[20933]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/564480.
    coneq[20934]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c*dot(A,c))))-1/112896.
    coneq[20935]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c*dot(A,c))))-1/338688.
    coneq[20936]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c*dot(A,c))))-1/677376.
    coneq[20937]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/225792.
    coneq[20938]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))-1/84672.
    coneq[20939]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/169344.
    coneq[20940]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/56448.
    coneq[20941]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))-1/169344.
    coneq[20942]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/338688.
    coneq[20943]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/112896.
    coneq[20944]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c*dot(A,c))))-1/23520.
    coneq[20945]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c*dot(A,c))))-1/94080.
    coneq[20946]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c*dot(A,c))))-1/282240.
    coneq[20947]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c*dot(A,c))))-1/564480.
    coneq[20948]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/188160.
    coneq[20949]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))-1/70560.
    coneq[20950]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/141120.
    coneq[20951]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/47040.
    coneq[20952]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/94080.
    coneq[20953]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c))))-1/18816.
    coneq[20954]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))-1/56448.
    coneq[20955]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/112896.
    coneq[20956]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/37632.
    coneq[20957]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))-1/14112.
    coneq[20958]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/28224.
    coneq[20959]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))-1/9408.
    coneq[20960]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))-1/42336.
    coneq[20961]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/84672.
    coneq[20962]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/169344.
    coneq[20963]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c*dot(A,c))))-1/37632.
    coneq[20964]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c*dot(A,c))))-1/112896.
    coneq[20965]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c*dot(A,c))))-1/225792.
    coneq[20966]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/75264.
    coneq[20967]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))-1/28224.
    coneq[20968]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))-1/56448.
    coneq[20969]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))-1/18816.
    coneq[20970]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))-1/37632.
    coneq[20971]=dot(b,dot(A,c**6)*dot(A,c**2*dot(A,c**2)))-1/1764.
    coneq[20972]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2*dot(A,c**2)))-1/10584.
    coneq[20973]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2*dot(A,c**2)))-1/52920.
    coneq[20974]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2*dot(A,c**2)))-1/211680.
    coneq[20975]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,c**2)))-1/635040.
    coneq[20976]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c**2)))-1/1270080.
    coneq[20977]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,c**2)))-1/423360.
    coneq[20978]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2*dot(A,c**2)))-1/158760.
    coneq[20979]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c**2)))-1/317520.
    coneq[20980]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/105840.
    coneq[20981]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/211680.
    coneq[20982]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2*dot(A,c**2)))-1/42336.
    coneq[20983]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c**2)))-1/127008.
    coneq[20984]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c**2)))-1/254016.
    coneq[20985]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/84672.
    coneq[20986]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))-1/31752.
    coneq[20987]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/63504.
    coneq[20988]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/21168.
    coneq[20989]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))-1/63504.
    coneq[20990]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/127008.
    coneq[20991]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/42336.
    coneq[20992]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2*dot(A,c**2)))-1/8820.
    coneq[20993]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c**2)))-1/35280.
    coneq[20994]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c**2)))-1/105840.
    coneq[20995]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c**2)))-1/211680.
    coneq[20996]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/70560.
    coneq[20997]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))-1/26460.
    coneq[20998]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/52920.
    coneq[20999]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/17640.
    coneq[21000]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/35280.
    coneq[21001]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2*dot(A,c**2)))-1/7056.
    coneq[21002]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))-1/21168.
    coneq[21003]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/42336.
    coneq[21004]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/14112.
    coneq[21005]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))-1/5292.
    coneq[21006]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/10584.
    coneq[21007]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2*dot(A,c**2)))-1/3528.
    coneq[21008]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))-1/15876.
    coneq[21009]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/31752.
    coneq[21010]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/63504.
    coneq[21011]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2*dot(A,c**2)))-1/14112.
    coneq[21012]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c**2)))-1/42336.
    coneq[21013]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c**2)))-1/84672.
    coneq[21014]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/28224.
    coneq[21015]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c**2)))-1/10584.
    coneq[21016]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))-1/21168.
    coneq[21017]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2)))-1/7056.
    coneq[21018]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2)))-1/14112.
    coneq[21019]=dot(b,dot(A,c**6)*dot(A,c**2*dot(A,dot(A,c))))-1/3528.
    coneq[21020]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2*dot(A,dot(A,c))))-1/21168.
    coneq[21021]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2*dot(A,dot(A,c))))-1/105840.
    coneq[21022]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2*dot(A,dot(A,c))))-1/423360.
    coneq[21023]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,dot(A,c))))-1/1270080.
    coneq[21024]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,dot(A,c))))-1/2540160.
    coneq[21025]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,dot(A,c))))-1/846720.
    coneq[21026]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2*dot(A,dot(A,c))))-1/317520.
    coneq[21027]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,dot(A,c))))-1/635040.
    coneq[21028]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/211680.
    coneq[21029]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/423360.
    coneq[21030]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2*dot(A,dot(A,c))))-1/84672.
    coneq[21031]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,dot(A,c))))-1/254016.
    coneq[21032]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,dot(A,c))))-1/508032.
    coneq[21033]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/169344.
    coneq[21034]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))-1/63504.
    coneq[21035]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/127008.
    coneq[21036]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/42336.
    coneq[21037]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))-1/127008.
    coneq[21038]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/254016.
    coneq[21039]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/84672.
    coneq[21040]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2*dot(A,dot(A,c))))-1/17640.
    coneq[21041]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,dot(A,c))))-1/70560.
    coneq[21042]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,dot(A,c))))-1/211680.
    coneq[21043]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,dot(A,c))))-1/423360.
    coneq[21044]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/141120.
    coneq[21045]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))-1/52920.
    coneq[21046]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/105840.
    coneq[21047]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/35280.
    coneq[21048]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/70560.
    coneq[21049]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c))))-1/14112.
    coneq[21050]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))-1/42336.
    coneq[21051]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/84672.
    coneq[21052]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/28224.
    coneq[21053]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))-1/10584.
    coneq[21054]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/21168.
    coneq[21055]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))-1/7056.
    coneq[21056]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))-1/31752.
    coneq[21057]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/63504.
    coneq[21058]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/127008.
    coneq[21059]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2*dot(A,dot(A,c))))-1/28224.
    coneq[21060]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,dot(A,c))))-1/84672.
    coneq[21061]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,dot(A,c))))-1/169344.
    coneq[21062]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/56448.
    coneq[21063]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))-1/21168.
    coneq[21064]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))-1/42336.
    coneq[21065]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))-1/14112.
    coneq[21066]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))-1/28224.
    coneq[21067]=dot(b,dot(A,c**6)*dot(A,c**3*dot(A,c)))-1/1176.
    coneq[21068]=dot(b,dot(A,dot(A,c**5))*dot(A,c**3*dot(A,c)))-1/7056.
    coneq[21069]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**3*dot(A,c)))-1/35280.
    coneq[21070]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**3*dot(A,c)))-1/141120.
    coneq[21071]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3*dot(A,c)))-1/423360.
    coneq[21072]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3*dot(A,c)))-1/846720.
    coneq[21073]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3*dot(A,c)))-1/282240.
    coneq[21074]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3*dot(A,c)))-1/105840.
    coneq[21075]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3*dot(A,c)))-1/211680.
    coneq[21076]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3*dot(A,c)))-1/70560.
    coneq[21077]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3*dot(A,c)))-1/141120.
    coneq[21078]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**3*dot(A,c)))-1/28224.
    coneq[21079]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3*dot(A,c)))-1/84672.
    coneq[21080]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3*dot(A,c)))-1/169344.
    coneq[21081]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3*dot(A,c)))-1/56448.
    coneq[21082]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**3*dot(A,c)))-1/21168.
    coneq[21083]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))-1/42336.
    coneq[21084]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**3*dot(A,c)))-1/14112.
    coneq[21085]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3*dot(A,c)))-1/42336.
    coneq[21086]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))-1/84672.
    coneq[21087]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3*dot(A,c)))-1/28224.
    coneq[21088]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**3*dot(A,c)))-1/5880.
    coneq[21089]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**3*dot(A,c)))-1/23520.
    coneq[21090]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3*dot(A,c)))-1/70560.
    coneq[21091]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3*dot(A,c)))-1/141120.
    coneq[21092]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3*dot(A,c)))-1/47040.
    coneq[21093]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**3*dot(A,c)))-1/17640.
    coneq[21094]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))-1/35280.
    coneq[21095]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**3*dot(A,c)))-1/11760.
    coneq[21096]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3*dot(A,c)))-1/23520.
    coneq[21097]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**3*dot(A,c)))-1/4704.
    coneq[21098]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c)))-1/14112.
    coneq[21099]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))-1/28224.
    coneq[21100]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c)))-1/9408.
    coneq[21101]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**3*dot(A,c)))-1/3528.
    coneq[21102]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))-1/7056.
    coneq[21103]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**3*dot(A,c)))-1/2352.
    coneq[21104]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**3*dot(A,c)))-1/10584.
    coneq[21105]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))-1/21168.
    coneq[21106]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))-1/42336.
    coneq[21107]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**3*dot(A,c)))-1/9408.
    coneq[21108]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3*dot(A,c)))-1/28224.
    coneq[21109]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3*dot(A,c)))-1/56448.
    coneq[21110]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3*dot(A,c)))-1/18816.
    coneq[21111]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**3*dot(A,c)))-1/7056.
    coneq[21112]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))-1/14112.
    coneq[21113]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c)))-1/4704.
    coneq[21114]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c)))-1/9408.
    coneq[21115]=dot(b,dot(A,c**6)*dot(A,dot(A,c)*dot(A,c**2)))-1/3528.
    coneq[21116]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c)*dot(A,c**2)))-1/21168.
    coneq[21117]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c)*dot(A,c**2)))-1/105840.
    coneq[21118]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)*dot(A,c**2)))-1/423360.
    coneq[21119]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c**2)))-1/1270080.
    coneq[21120]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c**2)))-1/2540160.
    coneq[21121]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c**2)))-1/846720.
    coneq[21122]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c**2)))-1/317520.
    coneq[21123]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c**2)))-1/635040.
    coneq[21124]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/211680.
    coneq[21125]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/423360.
    coneq[21126]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c**2)))-1/84672.
    coneq[21127]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c**2)))-1/254016.
    coneq[21128]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c**2)))-1/508032.
    coneq[21129]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/169344.
    coneq[21130]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))-1/63504.
    coneq[21131]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/127008.
    coneq[21132]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/42336.
    coneq[21133]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))-1/127008.
    coneq[21134]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/254016.
    coneq[21135]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/84672.
    coneq[21136]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c)*dot(A,c**2)))-1/17640.
    coneq[21137]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c**2)))-1/70560.
    coneq[21138]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c**2)))-1/211680.
    coneq[21139]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c**2)))-1/423360.
    coneq[21140]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/141120.
    coneq[21141]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))-1/52920.
    coneq[21142]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/105840.
    coneq[21143]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/35280.
    coneq[21144]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/70560.
    coneq[21145]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2)))-1/14112.
    coneq[21146]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))-1/42336.
    coneq[21147]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/84672.
    coneq[21148]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/28224.
    coneq[21149]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))-1/10584.
    coneq[21150]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/21168.
    coneq[21151]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))-1/7056.
    coneq[21152]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))-1/31752.
    coneq[21153]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/63504.
    coneq[21154]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/127008.
    coneq[21155]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c**2)))-1/28224.
    coneq[21156]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c**2)))-1/84672.
    coneq[21157]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c**2)))-1/169344.
    coneq[21158]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/56448.
    coneq[21159]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))-1/21168.
    coneq[21160]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))-1/42336.
    coneq[21161]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))-1/14112.
    coneq[21162]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))-1/28224.
    coneq[21163]=dot(b,dot(A,c**6)*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/7056.
    coneq[21164]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/42336.
    coneq[21165]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/211680.
    coneq[21166]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/846720.
    coneq[21167]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/2540160.
    coneq[21168]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/5080320.
    coneq[21169]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/1693440.
    coneq[21170]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/635040.
    coneq[21171]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/1270080.
    coneq[21172]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/423360.
    coneq[21173]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/846720.
    coneq[21174]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/169344.
    coneq[21175]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/508032.
    coneq[21176]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/1016064.
    coneq[21177]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/338688.
    coneq[21178]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/127008.
    coneq[21179]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/254016.
    coneq[21180]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/84672.
    coneq[21181]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/254016.
    coneq[21182]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/508032.
    coneq[21183]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/169344.
    coneq[21184]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/35280.
    coneq[21185]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/141120.
    coneq[21186]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/423360.
    coneq[21187]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/846720.
    coneq[21188]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/282240.
    coneq[21189]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/105840.
    coneq[21190]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/211680.
    coneq[21191]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/70560.
    coneq[21192]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/141120.
    coneq[21193]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/28224.
    coneq[21194]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/84672.
    coneq[21195]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/169344.
    coneq[21196]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/56448.
    coneq[21197]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/21168.
    coneq[21198]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/42336.
    coneq[21199]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/14112.
    coneq[21200]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/63504.
    coneq[21201]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/127008.
    coneq[21202]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/254016.
    coneq[21203]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/56448.
    coneq[21204]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/169344.
    coneq[21205]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/338688.
    coneq[21206]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/112896.
    coneq[21207]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/42336.
    coneq[21208]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/84672.
    coneq[21209]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/28224.
    coneq[21210]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))-1/56448.
    coneq[21211]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c)*dot(A,c)))-1/2352.
    coneq[21212]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c)*dot(A,c)))-1/14112.
    coneq[21213]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c)*dot(A,c)))-1/70560.
    coneq[21214]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)*dot(A,c)))-1/282240.
    coneq[21215]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)*dot(A,c)))-1/846720.
    coneq[21216]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)*dot(A,c)))-1/1693440.
    coneq[21217]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)*dot(A,c)))-1/564480.
    coneq[21218]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)*dot(A,c)))-1/211680.
    coneq[21219]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)*dot(A,c)))-1/423360.
    coneq[21220]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/141120.
    coneq[21221]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/282240.
    coneq[21222]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c)*dot(A,c)))-1/56448.
    coneq[21223]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)*dot(A,c)))-1/169344.
    coneq[21224]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)*dot(A,c)))-1/338688.
    coneq[21225]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/112896.
    coneq[21226]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))-1/42336.
    coneq[21227]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/84672.
    coneq[21228]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/28224.
    coneq[21229]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))-1/84672.
    coneq[21230]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/169344.
    coneq[21231]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/56448.
    coneq[21232]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c)*dot(A,c)))-1/11760.
    coneq[21233]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)*dot(A,c)))-1/47040.
    coneq[21234]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)*dot(A,c)))-1/141120.
    coneq[21235]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)*dot(A,c)))-1/282240.
    coneq[21236]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/94080.
    coneq[21237]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))-1/35280.
    coneq[21238]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/70560.
    coneq[21239]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/23520.
    coneq[21240]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/47040.
    coneq[21241]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c)))-1/9408.
    coneq[21242]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))-1/28224.
    coneq[21243]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/56448.
    coneq[21244]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/18816.
    coneq[21245]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))-1/7056.
    coneq[21246]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/14112.
    coneq[21247]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))-1/4704.
    coneq[21248]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))-1/21168.
    coneq[21249]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/42336.
    coneq[21250]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/84672.
    coneq[21251]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c)*dot(A,c)))-1/18816.
    coneq[21252]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)*dot(A,c)))-1/56448.
    coneq[21253]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)*dot(A,c)))-1/112896.
    coneq[21254]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/37632.
    coneq[21255]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))-1/14112.
    coneq[21256]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))-1/28224.
    coneq[21257]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))-1/9408.
    coneq[21258]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))-1/18816.
    coneq[21259]=dot(b,dot(A,c**7)*dot(A,c**4))-1/560.
    coneq[21260]=dot(b,dot(A,dot(A,c**6))*dot(A,c**4))-1/3920.
    coneq[21261]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**4))-1/23520.
    coneq[21262]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**4))-1/117600.
    coneq[21263]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**4))-1/470400.
    coneq[21264]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**4))-1/1411200.
    coneq[21265]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**4))-1/2822400.
    coneq[21266]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**4))-1/940800.
    coneq[21267]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**4))-1/352800.
    coneq[21268]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**4))-1/705600.
    coneq[21269]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**4))-1/235200.
    coneq[21270]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**4))-1/470400.
    coneq[21271]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**4))-1/94080.
    coneq[21272]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**4))-1/282240.
    coneq[21273]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**4))-1/564480.
    coneq[21274]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**4))-1/188160.
    coneq[21275]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**4))-1/70560.
    coneq[21276]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**4))-1/141120.
    coneq[21277]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**4))-1/47040.
    coneq[21278]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**4))-1/141120.
    coneq[21279]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**4))-1/282240.
    coneq[21280]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**4))-1/94080.
    coneq[21281]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**4))-1/19600.
    coneq[21282]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**4))-1/78400.
    coneq[21283]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**4))-1/235200.
    coneq[21284]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**4))-1/470400.
    coneq[21285]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**4))-1/156800.
    coneq[21286]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**4))-1/58800.
    coneq[21287]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**4))-1/117600.
    coneq[21288]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**4))-1/39200.
    coneq[21289]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**4))-1/78400.
    coneq[21290]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**4))-1/15680.
    coneq[21291]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**4))-1/47040.
    coneq[21292]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/94080.
    coneq[21293]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**4))-1/31360.
    coneq[21294]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**4))-1/11760.
    coneq[21295]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**4))-1/23520.
    coneq[21296]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**4))-1/7840.
    coneq[21297]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**4))-1/35280.
    coneq[21298]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**4))-1/70560.
    coneq[21299]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**4))-1/141120.
    coneq[21300]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**4))-1/31360.
    coneq[21301]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**4))-1/94080.
    coneq[21302]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/188160.
    coneq[21303]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**4))-1/62720.
    coneq[21304]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**4))-1/23520.
    coneq[21305]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**4))-1/47040.
    coneq[21306]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**4))-1/15680.
    coneq[21307]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**4))-1/31360.
    coneq[21308]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**4))-1/3360.
    coneq[21309]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**4))-1/16800.
    coneq[21310]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**4))-1/67200.
    coneq[21311]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**4))-1/201600.
    coneq[21312]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**4))-1/403200.
    coneq[21313]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**4))-1/134400.
    coneq[21314]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**4))-1/50400.
    coneq[21315]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**4))-1/100800.
    coneq[21316]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**4))-1/33600.
    coneq[21317]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**4))-1/67200.
    coneq[21318]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**4))-1/13440.
    coneq[21319]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**4))-1/40320.
    coneq[21320]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/80640.
    coneq[21321]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**4))-1/26880.
    coneq[21322]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**4))-1/10080.
    coneq[21323]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**4))-1/20160.
    coneq[21324]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**4))-1/6720.
    coneq[21325]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**4))-1/20160.
    coneq[21326]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**4))-1/40320.
    coneq[21327]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**4))-1/13440.
    coneq[21328]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**4))-1/2800.
    coneq[21329]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**4))-1/11200.
    coneq[21330]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**4))-1/33600.
    coneq[21331]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/67200.
    coneq[21332]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**4))-1/22400.
    coneq[21333]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**4))-1/8400.
    coneq[21334]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**4))-1/16800.
    coneq[21335]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**4))-1/5600.
    coneq[21336]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4))-1/11200.
    coneq[21337]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**4))-1/2240.
    coneq[21338]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**4))-1/6720.
    coneq[21339]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/13440.
    coneq[21340]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**4))-1/4480.
    coneq[21341]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**4))-1/1680.
    coneq[21342]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**4))-1/3360.
    coneq[21343]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**4))-1/1120.
    coneq[21344]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**4))-1/6720.
    coneq[21345]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**4))-1/20160.
    coneq[21346]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/40320.
    coneq[21347]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**4))-1/13440.
    coneq[21348]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**4))-1/13440.
    coneq[21349]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**4))-1/40320.
    coneq[21350]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/80640.
    coneq[21351]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**4))-1/26880.
    coneq[21352]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**4))-1/5600.
    coneq[21353]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**4))-1/22400.
    coneq[21354]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**4))-1/67200.
    coneq[21355]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4))-1/134400.
    coneq[21356]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**4))-1/44800.
    coneq[21357]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**4))-1/16800.
    coneq[21358]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**4))-1/33600.
    coneq[21359]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**4))-1/11200.
    coneq[21360]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4))-1/22400.
    coneq[21361]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**4))-1/5040.
    coneq[21362]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**4))-1/10080.
    coneq[21363]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**4))-1/20160.
    coneq[21364]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**4))-1/4480.
    coneq[21365]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**4))-1/13440.
    coneq[21366]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**4))-1/26880.
    coneq[21367]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**4))-1/8960.
    coneq[21368]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**4))-1/3360.
    coneq[21369]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4))-1/6720.
    coneq[21370]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**4))-1/2240.
    coneq[21371]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**4))-1/6720.
    coneq[21372]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4))-1/13440.
    coneq[21373]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**4))-1/4480.
    coneq[21374]=dot(b,dot(A,c**7)*dot(A,dot(A,c**3)))-1/2240.
    coneq[21375]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c**3)))-1/15680.
    coneq[21376]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c**3)))-1/94080.
    coneq[21377]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c**3)))-1/470400.
    coneq[21378]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c**3)))-1/1881600.
    coneq[21379]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c**3)))-1/5644800.
    coneq[21380]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**3)))-1/11289600.
    coneq[21381]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c**3)))-1/3763200.
    coneq[21382]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c**3)))-1/1411200.
    coneq[21383]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c**3)))-1/2822400.
    coneq[21384]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c**3)))-1/940800.
    coneq[21385]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**3)))-1/1881600.
    coneq[21386]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c**3)))-1/376320.
    coneq[21387]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**3)))-1/1128960.
    coneq[21388]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**3)))-1/2257920.
    coneq[21389]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**3)))-1/752640.
    coneq[21390]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c**3)))-1/282240.
    coneq[21391]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/564480.
    coneq[21392]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c**3)))-1/188160.
    coneq[21393]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c**3)))-1/564480.
    coneq[21394]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/1128960.
    coneq[21395]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**3)))-1/376320.
    coneq[21396]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c**3)))-1/78400.
    coneq[21397]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c**3)))-1/313600.
    coneq[21398]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**3)))-1/940800.
    coneq[21399]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**3)))-1/1881600.
    coneq[21400]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**3)))-1/627200.
    coneq[21401]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**3)))-1/235200.
    coneq[21402]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/470400.
    coneq[21403]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**3)))-1/156800.
    coneq[21404]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**3)))-1/313600.
    coneq[21405]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c**3)))-1/62720.
    coneq[21406]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/188160.
    coneq[21407]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/376320.
    coneq[21408]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/125440.
    coneq[21409]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/47040.
    coneq[21410]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/94080.
    coneq[21411]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c**3)))-1/31360.
    coneq[21412]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/141120.
    coneq[21413]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/282240.
    coneq[21414]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/564480.
    coneq[21415]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c**3)))-1/125440.
    coneq[21416]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/376320.
    coneq[21417]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/752640.
    coneq[21418]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/250880.
    coneq[21419]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/94080.
    coneq[21420]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/188160.
    coneq[21421]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/62720.
    coneq[21422]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/125440.
    coneq[21423]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c**3)))-1/13440.
    coneq[21424]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c**3)))-1/67200.
    coneq[21425]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**3)))-1/268800.
    coneq[21426]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**3)))-1/806400.
    coneq[21427]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**3)))-1/1612800.
    coneq[21428]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**3)))-1/537600.
    coneq[21429]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**3)))-1/201600.
    coneq[21430]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/403200.
    coneq[21431]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**3)))-1/134400.
    coneq[21432]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**3)))-1/268800.
    coneq[21433]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21434]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/161280.
    coneq[21435]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/322560.
    coneq[21436]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/107520.
    coneq[21437]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/40320.
    coneq[21438]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/80640.
    coneq[21439]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**3)))-1/26880.
    coneq[21440]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/80640.
    coneq[21441]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/161280.
    coneq[21442]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21443]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c**3)))-1/11200.
    coneq[21444]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c**3)))-1/44800.
    coneq[21445]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/134400.
    coneq[21446]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/268800.
    coneq[21447]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/89600.
    coneq[21448]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/33600.
    coneq[21449]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/67200.
    coneq[21450]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3)))-1/22400.
    coneq[21451]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/44800.
    coneq[21452]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c**3)))-1/8960.
    coneq[21453]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/26880.
    coneq[21454]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21455]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/17920.
    coneq[21456]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c**3)))-1/6720.
    coneq[21457]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/13440.
    coneq[21458]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c**3)))-1/4480.
    coneq[21459]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c**3)))-1/26880.
    coneq[21460]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/80640.
    coneq[21461]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/161280.
    coneq[21462]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21463]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21464]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/161280.
    coneq[21465]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/322560.
    coneq[21466]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/107520.
    coneq[21467]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c**3)))-1/22400.
    coneq[21468]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c**3)))-1/89600.
    coneq[21469]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3)))-1/268800.
    coneq[21470]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3)))-1/537600.
    coneq[21471]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3)))-1/179200.
    coneq[21472]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3)))-1/67200.
    coneq[21473]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/134400.
    coneq[21474]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3)))-1/44800.
    coneq[21475]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3)))-1/89600.
    coneq[21476]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**3)))-1/20160.
    coneq[21477]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/40320.
    coneq[21478]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/80640.
    coneq[21479]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**3)))-1/17920.
    coneq[21480]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21481]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3)))-1/107520.
    coneq[21482]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3)))-1/35840.
    coneq[21483]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3)))-1/13440.
    coneq[21484]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/26880.
    coneq[21485]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3)))-1/8960.
    coneq[21486]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3)))-1/26880.
    coneq[21487]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3)))-1/53760.
    coneq[21488]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3)))-1/17920.
    coneq[21489]=dot(b,dot(A,c**7)*dot(A,dot(A,dot(A,c**2))))-1/6720.
    coneq[21490]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,dot(A,c**2))))-1/47040.
    coneq[21491]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,dot(A,c**2))))-1/282240.
    coneq[21492]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,dot(A,c**2))))-1/1411200.
    coneq[21493]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,c**2))))-1/5644800.
    coneq[21494]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c**2))))-1/16934400.
    coneq[21495]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c**2))))-1/33868800.
    coneq[21496]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c**2))))-1/11289600.
    coneq[21497]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,c**2))))-1/4233600.
    coneq[21498]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**2))))-1/8467200.
    coneq[21499]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/2822400.
    coneq[21500]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/5644800.
    coneq[21501]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,dot(A,c**2))))-1/1128960.
    coneq[21502]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c**2))))-1/3386880.
    coneq[21503]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**2))))-1/6773760.
    coneq[21504]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/2257920.
    coneq[21505]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/846720.
    coneq[21506]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1693440.
    coneq[21507]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/564480.
    coneq[21508]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/1693440.
    coneq[21509]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/3386880.
    coneq[21510]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/1128960.
    coneq[21511]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,dot(A,c**2))))-1/235200.
    coneq[21512]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c**2))))-1/940800.
    coneq[21513]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c**2))))-1/2822400.
    coneq[21514]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**2))))-1/5644800.
    coneq[21515]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1881600.
    coneq[21516]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/705600.
    coneq[21517]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1411200.
    coneq[21518]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/470400.
    coneq[21519]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/940800.
    coneq[21520]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/188160.
    coneq[21521]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/564480.
    coneq[21522]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1128960.
    coneq[21523]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/376320.
    coneq[21524]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/141120.
    coneq[21525]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/282240.
    coneq[21526]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/94080.
    coneq[21527]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/423360.
    coneq[21528]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/846720.
    coneq[21529]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/1693440.
    coneq[21530]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/376320.
    coneq[21531]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/1128960.
    coneq[21532]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/2257920.
    coneq[21533]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/752640.
    coneq[21534]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/282240.
    coneq[21535]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/564480.
    coneq[21536]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/188160.
    coneq[21537]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/376320.
    coneq[21538]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,dot(A,c**2))))-1/40320.
    coneq[21539]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c**2))))-1/201600.
    coneq[21540]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c**2))))-1/806400.
    coneq[21541]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c**2))))-1/2419200.
    coneq[21542]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**2))))-1/4838400.
    coneq[21543]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1612800.
    coneq[21544]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/604800.
    coneq[21545]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1209600.
    coneq[21546]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/403200.
    coneq[21547]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/806400.
    coneq[21548]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21549]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/483840.
    coneq[21550]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/967680.
    coneq[21551]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/322560.
    coneq[21552]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/120960.
    coneq[21553]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/241920.
    coneq[21554]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/80640.
    coneq[21555]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/241920.
    coneq[21556]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/483840.
    coneq[21557]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21558]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,dot(A,c**2))))-1/33600.
    coneq[21559]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/134400.
    coneq[21560]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/403200.
    coneq[21561]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/806400.
    coneq[21562]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/268800.
    coneq[21563]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/100800.
    coneq[21564]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/201600.
    coneq[21565]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/67200.
    coneq[21566]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/134400.
    coneq[21567]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/26880.
    coneq[21568]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/80640.
    coneq[21569]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21570]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/53760.
    coneq[21571]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/20160.
    coneq[21572]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/40320.
    coneq[21573]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/13440.
    coneq[21574]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/80640.
    coneq[21575]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/241920.
    coneq[21576]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/483840.
    coneq[21577]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21578]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21579]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/483840.
    coneq[21580]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/967680.
    coneq[21581]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/322560.
    coneq[21582]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,dot(A,c**2))))-1/67200.
    coneq[21583]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2))))-1/268800.
    coneq[21584]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2))))-1/806400.
    coneq[21585]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2))))-1/1612800.
    coneq[21586]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/537600.
    coneq[21587]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/201600.
    coneq[21588]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/403200.
    coneq[21589]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/134400.
    coneq[21590]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/268800.
    coneq[21591]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/60480.
    coneq[21592]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/120960.
    coneq[21593]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/241920.
    coneq[21594]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))-1/53760.
    coneq[21595]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21596]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2))))-1/322560.
    coneq[21597]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/107520.
    coneq[21598]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/40320.
    coneq[21599]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/80640.
    coneq[21600]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/26880.
    coneq[21601]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))-1/80640.
    coneq[21602]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))-1/161280.
    coneq[21603]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2))))-1/53760.
    coneq[21604]=dot(b,dot(A,c**7)*dot(A,dot(A,dot(A,dot(A,c)))))-1/13440.
    coneq[21605]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,dot(A,dot(A,c)))))-1/94080.
    coneq[21606]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/564480.
    coneq[21607]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2822400.
    coneq[21608]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/11289600.
    coneq[21609]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/33868800.
    coneq[21610]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/67737600.
    coneq[21611]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/22579200.
    coneq[21612]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/8467200.
    coneq[21613]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/16934400.
    coneq[21614]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/5644800.
    coneq[21615]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/11289600.
    coneq[21616]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2257920.
    coneq[21617]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/6773760.
    coneq[21618]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/13547520.
    coneq[21619]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/4515840.
    coneq[21620]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1693440.
    coneq[21621]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3386880.
    coneq[21622]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1128960.
    coneq[21623]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3386880.
    coneq[21624]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/6773760.
    coneq[21625]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2257920.
    coneq[21626]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/470400.
    coneq[21627]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1881600.
    coneq[21628]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/5644800.
    coneq[21629]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/11289600.
    coneq[21630]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3763200.
    coneq[21631]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1411200.
    coneq[21632]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2822400.
    coneq[21633]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/940800.
    coneq[21634]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1881600.
    coneq[21635]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/376320.
    coneq[21636]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1128960.
    coneq[21637]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2257920.
    coneq[21638]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/752640.
    coneq[21639]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/282240.
    coneq[21640]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/564480.
    coneq[21641]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/188160.
    coneq[21642]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/846720.
    coneq[21643]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1693440.
    coneq[21644]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3386880.
    coneq[21645]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/752640.
    coneq[21646]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2257920.
    coneq[21647]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/4515840.
    coneq[21648]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1505280.
    coneq[21649]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/564480.
    coneq[21650]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1128960.
    coneq[21651]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/376320.
    coneq[21652]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/752640.
    coneq[21653]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,dot(A,dot(A,c)))))-1/80640.
    coneq[21654]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/403200.
    coneq[21655]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1612800.
    coneq[21656]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/4838400.
    coneq[21657]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/9676800.
    coneq[21658]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3225600.
    coneq[21659]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1209600.
    coneq[21660]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/2419200.
    coneq[21661]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/806400.
    coneq[21662]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1612800.
    coneq[21663]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21664]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/967680.
    coneq[21665]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1935360.
    coneq[21666]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/645120.
    coneq[21667]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/241920.
    coneq[21668]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/483840.
    coneq[21669]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/161280.
    coneq[21670]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/483840.
    coneq[21671]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/967680.
    coneq[21672]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21673]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c)))))-1/67200.
    coneq[21674]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/268800.
    coneq[21675]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/806400.
    coneq[21676]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1612800.
    coneq[21677]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/537600.
    coneq[21678]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/201600.
    coneq[21679]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/403200.
    coneq[21680]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/134400.
    coneq[21681]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/268800.
    coneq[21682]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/53760.
    coneq[21683]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/161280.
    coneq[21684]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21685]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/107520.
    coneq[21686]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/40320.
    coneq[21687]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/80640.
    coneq[21688]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/26880.
    coneq[21689]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/161280.
    coneq[21690]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/483840.
    coneq[21691]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/967680.
    coneq[21692]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21693]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21694]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/967680.
    coneq[21695]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1935360.
    coneq[21696]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/645120.
    coneq[21697]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c)))))-1/134400.
    coneq[21698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/537600.
    coneq[21699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1612800.
    coneq[21700]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/3225600.
    coneq[21701]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/1075200.
    coneq[21702]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/403200.
    coneq[21703]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/806400.
    coneq[21704]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/268800.
    coneq[21705]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/537600.
    coneq[21706]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/120960.
    coneq[21707]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/241920.
    coneq[21708]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/483840.
    coneq[21709]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))-1/107520.
    coneq[21710]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21711]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))-1/645120.
    coneq[21712]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/215040.
    coneq[21713]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/80640.
    coneq[21714]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/161280.
    coneq[21715]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/53760.
    coneq[21716]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))-1/161280.
    coneq[21717]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))-1/322560.
    coneq[21718]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))-1/107520.
    coneq[21719]=dot(b,dot(A,c**7)*dot(A,dot(A,c*dot(A,c))))-1/4480.
    coneq[21720]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c*dot(A,c))))-1/31360.
    coneq[21721]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c*dot(A,c))))-1/188160.
    coneq[21722]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c*dot(A,c))))-1/940800.
    coneq[21723]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c*dot(A,c))))-1/3763200.
    coneq[21724]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c*dot(A,c))))-1/11289600.
    coneq[21725]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c*dot(A,c))))-1/22579200.
    coneq[21726]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c*dot(A,c))))-1/7526400.
    coneq[21727]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c))))-1/2822400.
    coneq[21728]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c))))-1/5644800.
    coneq[21729]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1881600.
    coneq[21730]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/3763200.
    coneq[21731]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c*dot(A,c))))-1/752640.
    coneq[21732]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c))))-1/2257920.
    coneq[21733]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c))))-1/4515840.
    coneq[21734]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1505280.
    coneq[21735]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/564480.
    coneq[21736]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1128960.
    coneq[21737]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/376320.
    coneq[21738]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/1128960.
    coneq[21739]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/2257920.
    coneq[21740]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/752640.
    coneq[21741]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c*dot(A,c))))-1/156800.
    coneq[21742]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c*dot(A,c))))-1/627200.
    coneq[21743]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c))))-1/1881600.
    coneq[21744]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c))))-1/3763200.
    coneq[21745]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1254400.
    coneq[21746]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/470400.
    coneq[21747]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/940800.
    coneq[21748]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/313600.
    coneq[21749]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/627200.
    coneq[21750]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/125440.
    coneq[21751]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/376320.
    coneq[21752]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/752640.
    coneq[21753]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/250880.
    coneq[21754]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/94080.
    coneq[21755]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/188160.
    coneq[21756]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/62720.
    coneq[21757]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/282240.
    coneq[21758]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/564480.
    coneq[21759]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/1128960.
    coneq[21760]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/250880.
    coneq[21761]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/752640.
    coneq[21762]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1505280.
    coneq[21763]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/501760.
    coneq[21764]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/188160.
    coneq[21765]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/376320.
    coneq[21766]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/125440.
    coneq[21767]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/250880.
    coneq[21768]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c*dot(A,c))))-1/26880.
    coneq[21769]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c*dot(A,c))))-1/134400.
    coneq[21770]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c*dot(A,c))))-1/537600.
    coneq[21771]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c))))-1/1612800.
    coneq[21772]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c))))-1/3225600.
    coneq[21773]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1075200.
    coneq[21774]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/403200.
    coneq[21775]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/806400.
    coneq[21776]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/268800.
    coneq[21777]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/537600.
    coneq[21778]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21779]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/322560.
    coneq[21780]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/645120.
    coneq[21781]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/215040.
    coneq[21782]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/80640.
    coneq[21783]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/161280.
    coneq[21784]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/53760.
    coneq[21785]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/161280.
    coneq[21786]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/322560.
    coneq[21787]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21788]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c*dot(A,c))))-1/22400.
    coneq[21789]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/89600.
    coneq[21790]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/268800.
    coneq[21791]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/537600.
    coneq[21792]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/179200.
    coneq[21793]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/67200.
    coneq[21794]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/134400.
    coneq[21795]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/44800.
    coneq[21796]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/89600.
    coneq[21797]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/17920.
    coneq[21798]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/53760.
    coneq[21799]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21800]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/35840.
    coneq[21801]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/13440.
    coneq[21802]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/26880.
    coneq[21803]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/8960.
    coneq[21804]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/53760.
    coneq[21805]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/161280.
    coneq[21806]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/322560.
    coneq[21807]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21808]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21809]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/322560.
    coneq[21810]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/645120.
    coneq[21811]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/215040.
    coneq[21812]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c*dot(A,c))))-1/44800.
    coneq[21813]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c))))-1/179200.
    coneq[21814]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c))))-1/537600.
    coneq[21815]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c))))-1/1075200.
    coneq[21816]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/358400.
    coneq[21817]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/134400.
    coneq[21818]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/268800.
    coneq[21819]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/89600.
    coneq[21820]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/179200.
    coneq[21821]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/40320.
    coneq[21822]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/80640.
    coneq[21823]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/161280.
    coneq[21824]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))-1/35840.
    coneq[21825]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21826]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))-1/215040.
    coneq[21827]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/71680.
    coneq[21828]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/26880.
    coneq[21829]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/53760.
    coneq[21830]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/17920.
    coneq[21831]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))-1/53760.
    coneq[21832]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))-1/107520.
    coneq[21833]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c))))-1/35840.
    coneq[21834]=dot(b,dot(A,c**7)*dot(A,c*dot(A,c**2)))-1/1680.
    coneq[21835]=dot(b,dot(A,dot(A,c**6))*dot(A,c*dot(A,c**2)))-1/11760.
    coneq[21836]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c*dot(A,c**2)))-1/70560.
    coneq[21837]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c*dot(A,c**2)))-1/352800.
    coneq[21838]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c*dot(A,c**2)))-1/1411200.
    coneq[21839]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c**2)))-1/4233600.
    coneq[21840]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c**2)))-1/8467200.
    coneq[21841]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c**2)))-1/2822400.
    coneq[21842]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,c**2)))-1/1058400.
    coneq[21843]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,c**2)))-1/2116800.
    coneq[21844]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/705600.
    coneq[21845]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/1411200.
    coneq[21846]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c*dot(A,c**2)))-1/282240.
    coneq[21847]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c**2)))-1/846720.
    coneq[21848]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c**2)))-1/1693440.
    coneq[21849]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/564480.
    coneq[21850]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/211680.
    coneq[21851]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/423360.
    coneq[21852]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/141120.
    coneq[21853]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/423360.
    coneq[21854]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/846720.
    coneq[21855]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/282240.
    coneq[21856]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c*dot(A,c**2)))-1/58800.
    coneq[21857]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c*dot(A,c**2)))-1/235200.
    coneq[21858]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c**2)))-1/705600.
    coneq[21859]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c**2)))-1/1411200.
    coneq[21860]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/470400.
    coneq[21861]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/176400.
    coneq[21862]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/352800.
    coneq[21863]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/117600.
    coneq[21864]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/235200.
    coneq[21865]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/47040.
    coneq[21866]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/141120.
    coneq[21867]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/282240.
    coneq[21868]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/94080.
    coneq[21869]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/35280.
    coneq[21870]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/70560.
    coneq[21871]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/23520.
    coneq[21872]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/105840.
    coneq[21873]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/211680.
    coneq[21874]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/423360.
    coneq[21875]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/94080.
    coneq[21876]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/282240.
    coneq[21877]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/564480.
    coneq[21878]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/188160.
    coneq[21879]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/70560.
    coneq[21880]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/141120.
    coneq[21881]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/47040.
    coneq[21882]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/94080.
    coneq[21883]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c*dot(A,c**2)))-1/10080.
    coneq[21884]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c*dot(A,c**2)))-1/50400.
    coneq[21885]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c**2)))-1/201600.
    coneq[21886]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c**2)))-1/604800.
    coneq[21887]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c**2)))-1/1209600.
    coneq[21888]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/403200.
    coneq[21889]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/151200.
    coneq[21890]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/302400.
    coneq[21891]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/100800.
    coneq[21892]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/201600.
    coneq[21893]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21894]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/120960.
    coneq[21895]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/241920.
    coneq[21896]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/80640.
    coneq[21897]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/30240.
    coneq[21898]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/60480.
    coneq[21899]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/20160.
    coneq[21900]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/60480.
    coneq[21901]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/120960.
    coneq[21902]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21903]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c*dot(A,c**2)))-1/8400.
    coneq[21904]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/33600.
    coneq[21905]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/100800.
    coneq[21906]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/201600.
    coneq[21907]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/67200.
    coneq[21908]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/25200.
    coneq[21909]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/50400.
    coneq[21910]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/16800.
    coneq[21911]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/33600.
    coneq[21912]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/6720.
    coneq[21913]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/20160.
    coneq[21914]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21915]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/13440.
    coneq[21916]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/5040.
    coneq[21917]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/10080.
    coneq[21918]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c*dot(A,c**2)))-1/3360.
    coneq[21919]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/20160.
    coneq[21920]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/60480.
    coneq[21921]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/120960.
    coneq[21922]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21923]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21924]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/120960.
    coneq[21925]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/241920.
    coneq[21926]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/80640.
    coneq[21927]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c*dot(A,c**2)))-1/16800.
    coneq[21928]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2)))-1/67200.
    coneq[21929]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2)))-1/201600.
    coneq[21930]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2)))-1/403200.
    coneq[21931]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2)))-1/134400.
    coneq[21932]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/50400.
    coneq[21933]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/100800.
    coneq[21934]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/33600.
    coneq[21935]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/67200.
    coneq[21936]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/15120.
    coneq[21937]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/30240.
    coneq[21938]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/60480.
    coneq[21939]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c**2)))-1/13440.
    coneq[21940]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21941]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))-1/80640.
    coneq[21942]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))-1/26880.
    coneq[21943]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/10080.
    coneq[21944]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/20160.
    coneq[21945]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2)))-1/6720.
    coneq[21946]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2)))-1/20160.
    coneq[21947]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))-1/40320.
    coneq[21948]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2)))-1/13440.
    coneq[21949]=dot(b,dot(A,c**7)*dot(A,c*dot(A,dot(A,c))))-1/3360.
    coneq[21950]=dot(b,dot(A,dot(A,c**6))*dot(A,c*dot(A,dot(A,c))))-1/23520.
    coneq[21951]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c*dot(A,dot(A,c))))-1/141120.
    coneq[21952]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c*dot(A,dot(A,c))))-1/705600.
    coneq[21953]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c*dot(A,dot(A,c))))-1/2822400.
    coneq[21954]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,dot(A,c))))-1/8467200.
    coneq[21955]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,dot(A,c))))-1/16934400.
    coneq[21956]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,dot(A,c))))-1/5644800.
    coneq[21957]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c))))-1/2116800.
    coneq[21958]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c))))-1/4233600.
    coneq[21959]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/1411200.
    coneq[21960]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/2822400.
    coneq[21961]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c*dot(A,dot(A,c))))-1/564480.
    coneq[21962]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c))))-1/1693440.
    coneq[21963]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c))))-1/3386880.
    coneq[21964]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/1128960.
    coneq[21965]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/423360.
    coneq[21966]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/846720.
    coneq[21967]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/282240.
    coneq[21968]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/846720.
    coneq[21969]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/1693440.
    coneq[21970]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/564480.
    coneq[21971]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c*dot(A,dot(A,c))))-1/117600.
    coneq[21972]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c*dot(A,dot(A,c))))-1/470400.
    coneq[21973]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c))))-1/1411200.
    coneq[21974]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c))))-1/2822400.
    coneq[21975]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/940800.
    coneq[21976]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/352800.
    coneq[21977]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/705600.
    coneq[21978]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/235200.
    coneq[21979]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/470400.
    coneq[21980]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/94080.
    coneq[21981]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/282240.
    coneq[21982]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/564480.
    coneq[21983]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/188160.
    coneq[21984]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/70560.
    coneq[21985]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/141120.
    coneq[21986]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/47040.
    coneq[21987]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/211680.
    coneq[21988]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/423360.
    coneq[21989]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/846720.
    coneq[21990]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/188160.
    coneq[21991]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/564480.
    coneq[21992]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/1128960.
    coneq[21993]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/376320.
    coneq[21994]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/141120.
    coneq[21995]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/282240.
    coneq[21996]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/94080.
    coneq[21997]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/188160.
    coneq[21998]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c*dot(A,dot(A,c))))-1/20160.
    coneq[21999]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c*dot(A,dot(A,c))))-1/100800.
    coneq[22000]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,dot(A,c))))-1/403200.
    coneq[22001]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c))))-1/1209600.
    coneq[22002]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c))))-1/2419200.
    coneq[22003]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/806400.
    coneq[22004]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/302400.
    coneq[22005]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/604800.
    coneq[22006]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/201600.
    coneq[22007]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/403200.
    coneq[22008]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22009]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/241920.
    coneq[22010]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/483840.
    coneq[22011]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/161280.
    coneq[22012]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/60480.
    coneq[22013]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/120960.
    coneq[22014]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/40320.
    coneq[22015]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/120960.
    coneq[22016]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/241920.
    coneq[22017]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22018]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c*dot(A,dot(A,c))))-1/16800.
    coneq[22019]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/67200.
    coneq[22020]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/201600.
    coneq[22021]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/403200.
    coneq[22022]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/134400.
    coneq[22023]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/50400.
    coneq[22024]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/100800.
    coneq[22025]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/33600.
    coneq[22026]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/67200.
    coneq[22027]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/13440.
    coneq[22028]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/40320.
    coneq[22029]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22030]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/26880.
    coneq[22031]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/10080.
    coneq[22032]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/20160.
    coneq[22033]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/6720.
    coneq[22034]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/40320.
    coneq[22035]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/120960.
    coneq[22036]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/241920.
    coneq[22037]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22038]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/241920.
    coneq[22040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/483840.
    coneq[22041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/161280.
    coneq[22042]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c*dot(A,dot(A,c))))-1/33600.
    coneq[22043]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c))))-1/134400.
    coneq[22044]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c))))-1/403200.
    coneq[22045]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c))))-1/806400.
    coneq[22046]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/268800.
    coneq[22047]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/100800.
    coneq[22048]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/201600.
    coneq[22049]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/67200.
    coneq[22050]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/134400.
    coneq[22051]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/30240.
    coneq[22052]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/60480.
    coneq[22053]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/120960.
    coneq[22054]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))-1/26880.
    coneq[22055]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22056]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))-1/161280.
    coneq[22057]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/53760.
    coneq[22058]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/20160.
    coneq[22059]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/40320.
    coneq[22060]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/13440.
    coneq[22061]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))-1/40320.
    coneq[22062]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))-1/80640.
    coneq[22063]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c))))-1/26880.
    coneq[22064]=dot(b,dot(A,c**7)*dot(A,c**2*dot(A,c)))-1/1120.
    coneq[22065]=dot(b,dot(A,dot(A,c**6))*dot(A,c**2*dot(A,c)))-1/7840.
    coneq[22066]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**2*dot(A,c)))-1/47040.
    coneq[22067]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**2*dot(A,c)))-1/235200.
    coneq[22068]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2*dot(A,c)))-1/940800.
    coneq[22069]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2*dot(A,c)))-1/2822400.
    coneq[22070]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2*dot(A,c)))-1/5644800.
    coneq[22071]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2*dot(A,c)))-1/1881600.
    coneq[22072]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2*dot(A,c)))-1/705600.
    coneq[22073]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c)))-1/1411200.
    coneq[22074]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/470400.
    coneq[22075]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/940800.
    coneq[22076]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2*dot(A,c)))-1/188160.
    coneq[22077]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,c)))-1/564480.
    coneq[22078]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c)))-1/1128960.
    coneq[22079]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/376320.
    coneq[22080]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/141120.
    coneq[22081]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/282240.
    coneq[22082]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/94080.
    coneq[22083]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/282240.
    coneq[22084]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/564480.
    coneq[22085]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/188160.
    coneq[22086]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**2*dot(A,c)))-1/39200.
    coneq[22087]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2*dot(A,c)))-1/156800.
    coneq[22088]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,c)))-1/470400.
    coneq[22089]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c)))-1/940800.
    coneq[22090]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/313600.
    coneq[22091]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/117600.
    coneq[22092]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/235200.
    coneq[22093]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/78400.
    coneq[22094]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/156800.
    coneq[22095]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/31360.
    coneq[22096]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/94080.
    coneq[22097]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/188160.
    coneq[22098]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/62720.
    coneq[22099]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/23520.
    coneq[22100]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/47040.
    coneq[22101]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/15680.
    coneq[22102]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/70560.
    coneq[22103]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/141120.
    coneq[22104]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/282240.
    coneq[22105]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/62720.
    coneq[22106]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/188160.
    coneq[22107]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/376320.
    coneq[22108]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/125440.
    coneq[22109]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/47040.
    coneq[22110]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/94080.
    coneq[22111]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/31360.
    coneq[22112]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/62720.
    coneq[22113]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**2*dot(A,c)))-1/6720.
    coneq[22114]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**2*dot(A,c)))-1/33600.
    coneq[22115]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2*dot(A,c)))-1/134400.
    coneq[22116]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,c)))-1/403200.
    coneq[22117]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c)))-1/806400.
    coneq[22118]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/268800.
    coneq[22119]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/100800.
    coneq[22120]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/201600.
    coneq[22121]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/67200.
    coneq[22122]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/134400.
    coneq[22123]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22124]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/80640.
    coneq[22125]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/161280.
    coneq[22126]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/53760.
    coneq[22127]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/20160.
    coneq[22128]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/40320.
    coneq[22129]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/13440.
    coneq[22130]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/40320.
    coneq[22131]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/80640.
    coneq[22132]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22133]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**2*dot(A,c)))-1/5600.
    coneq[22134]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/22400.
    coneq[22135]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/67200.
    coneq[22136]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/134400.
    coneq[22137]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/44800.
    coneq[22138]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/16800.
    coneq[22139]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/33600.
    coneq[22140]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/11200.
    coneq[22141]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/22400.
    coneq[22142]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/4480.
    coneq[22143]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/13440.
    coneq[22144]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22145]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/8960.
    coneq[22146]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/3360.
    coneq[22147]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/6720.
    coneq[22148]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**2*dot(A,c)))-1/2240.
    coneq[22149]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/13440.
    coneq[22150]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/40320.
    coneq[22151]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/80640.
    coneq[22152]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22153]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22154]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/80640.
    coneq[22155]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/161280.
    coneq[22156]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/53760.
    coneq[22157]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**2*dot(A,c)))-1/11200.
    coneq[22158]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c)))-1/44800.
    coneq[22159]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c)))-1/134400.
    coneq[22160]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c)))-1/268800.
    coneq[22161]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c)))-1/89600.
    coneq[22162]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/33600.
    coneq[22163]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/67200.
    coneq[22164]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/22400.
    coneq[22165]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/44800.
    coneq[22166]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/10080.
    coneq[22167]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/20160.
    coneq[22168]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/40320.
    coneq[22169]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**2*dot(A,c)))-1/8960.
    coneq[22170]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22171]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))-1/53760.
    coneq[22172]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))-1/17920.
    coneq[22173]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/6720.
    coneq[22174]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/13440.
    coneq[22175]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)))-1/4480.
    coneq[22176]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c)))-1/13440.
    coneq[22177]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))-1/26880.
    coneq[22178]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c)))-1/8960.
    coneq[22179]=dot(b,dot(A,c**7)*dot(A,dot(A,c)*dot(A,c)))-1/2240.
    coneq[22180]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c)*dot(A,c)))-1/15680.
    coneq[22181]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c)*dot(A,c)))-1/94080.
    coneq[22182]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c)*dot(A,c)))-1/470400.
    coneq[22183]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)*dot(A,c)))-1/1881600.
    coneq[22184]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)*dot(A,c)))-1/5644800.
    coneq[22185]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)*dot(A,c)))-1/11289600.
    coneq[22186]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)*dot(A,c)))-1/3763200.
    coneq[22187]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c)))-1/1411200.
    coneq[22188]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c)))-1/2822400.
    coneq[22189]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/940800.
    coneq[22190]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/1881600.
    coneq[22191]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)*dot(A,c)))-1/376320.
    coneq[22192]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c)))-1/1128960.
    coneq[22193]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c)))-1/2257920.
    coneq[22194]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/752640.
    coneq[22195]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/282240.
    coneq[22196]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/564480.
    coneq[22197]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/188160.
    coneq[22198]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/564480.
    coneq[22199]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/1128960.
    coneq[22200]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/376320.
    coneq[22201]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c)*dot(A,c)))-1/78400.
    coneq[22202]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c)*dot(A,c)))-1/313600.
    coneq[22203]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c)))-1/940800.
    coneq[22204]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c)))-1/1881600.
    coneq[22205]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/627200.
    coneq[22206]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/235200.
    coneq[22207]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/470400.
    coneq[22208]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/156800.
    coneq[22209]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/313600.
    coneq[22210]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/62720.
    coneq[22211]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/188160.
    coneq[22212]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/376320.
    coneq[22213]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/125440.
    coneq[22214]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/47040.
    coneq[22215]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/94080.
    coneq[22216]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/31360.
    coneq[22217]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/141120.
    coneq[22218]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/282240.
    coneq[22219]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/564480.
    coneq[22220]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/125440.
    coneq[22221]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/376320.
    coneq[22222]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/752640.
    coneq[22223]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/250880.
    coneq[22224]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/94080.
    coneq[22225]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/188160.
    coneq[22226]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/62720.
    coneq[22227]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/125440.
    coneq[22228]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c)*dot(A,c)))-1/13440.
    coneq[22229]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c)*dot(A,c)))-1/67200.
    coneq[22230]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)*dot(A,c)))-1/268800.
    coneq[22231]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c)))-1/806400.
    coneq[22232]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c)))-1/1612800.
    coneq[22233]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/537600.
    coneq[22234]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/201600.
    coneq[22235]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/403200.
    coneq[22236]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/134400.
    coneq[22237]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/268800.
    coneq[22238]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22239]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/161280.
    coneq[22240]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/322560.
    coneq[22241]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/107520.
    coneq[22242]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/40320.
    coneq[22243]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/80640.
    coneq[22244]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/26880.
    coneq[22245]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/80640.
    coneq[22246]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/161280.
    coneq[22247]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22248]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c)*dot(A,c)))-1/11200.
    coneq[22249]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/44800.
    coneq[22250]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/134400.
    coneq[22251]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/268800.
    coneq[22252]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/89600.
    coneq[22253]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/33600.
    coneq[22254]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/67200.
    coneq[22255]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/22400.
    coneq[22256]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/44800.
    coneq[22257]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/8960.
    coneq[22258]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/26880.
    coneq[22259]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22260]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/17920.
    coneq[22261]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/6720.
    coneq[22262]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/13440.
    coneq[22263]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/4480.
    coneq[22264]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/26880.
    coneq[22265]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/80640.
    coneq[22266]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/161280.
    coneq[22267]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22268]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22269]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/161280.
    coneq[22270]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/322560.
    coneq[22271]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/107520.
    coneq[22272]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c)*dot(A,c)))-1/22400.
    coneq[22273]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c)))-1/89600.
    coneq[22274]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c)))-1/268800.
    coneq[22275]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c)))-1/537600.
    coneq[22276]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/179200.
    coneq[22277]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/67200.
    coneq[22278]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/134400.
    coneq[22279]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/44800.
    coneq[22280]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/89600.
    coneq[22281]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/20160.
    coneq[22282]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/40320.
    coneq[22283]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/80640.
    coneq[22284]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))-1/17920.
    coneq[22285]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22286]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))-1/107520.
    coneq[22287]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/35840.
    coneq[22288]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/13440.
    coneq[22289]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/26880.
    coneq[22290]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/8960.
    coneq[22291]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))-1/26880.
    coneq[22292]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))-1/53760.
    coneq[22293]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))-1/17920.
    coneq[22294]=dot(b,dot(A,c**8)*dot(A,c**3))-1/504.
    coneq[22295]=dot(b,dot(A,dot(A,c**7))*dot(A,c**3))-1/4032.
    coneq[22296]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c**3))-1/28224.
    coneq[22297]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c**3))-1/169344.
    coneq[22298]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c**3))-1/846720.
    coneq[22299]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c**3))-1/3386880.
    coneq[22300]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**3))-1/10160640.
    coneq[22301]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**3))-1/20321280.
    coneq[22302]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**3))-1/6773760.
    coneq[22303]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c**3))-1/2540160.
    coneq[22304]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**3))-1/5080320.
    coneq[22305]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c**3))-1/1693440.
    coneq[22306]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**3))-1/3386880.
    coneq[22307]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c**3))-1/677376.
    coneq[22308]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c**3))-1/2032128.
    coneq[22309]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c**3))-1/4064256.
    coneq[22310]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c**3))-1/1354752.
    coneq[22311]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c**3))-1/508032.
    coneq[22312]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c**3))-1/1016064.
    coneq[22313]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c**3))-1/338688.
    coneq[22314]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c**3))-1/1016064.
    coneq[22315]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**3))-1/2032128.
    coneq[22316]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c**3))-1/677376.
    coneq[22317]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c**3))-1/141120.
    coneq[22318]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c**3))-1/564480.
    coneq[22319]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**3))-1/1693440.
    coneq[22320]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**3))-1/3386880.
    coneq[22321]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**3))-1/1128960.
    coneq[22322]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c**3))-1/423360.
    coneq[22323]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**3))-1/846720.
    coneq[22324]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c**3))-1/282240.
    coneq[22325]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**3))-1/564480.
    coneq[22326]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c**3))-1/112896.
    coneq[22327]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c**3))-1/338688.
    coneq[22328]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/677376.
    coneq[22329]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c**3))-1/225792.
    coneq[22330]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c**3))-1/84672.
    coneq[22331]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c**3))-1/169344.
    coneq[22332]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c**3))-1/56448.
    coneq[22333]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c**3))-1/254016.
    coneq[22334]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c**3))-1/508032.
    coneq[22335]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c**3))-1/1016064.
    coneq[22336]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c**3))-1/225792.
    coneq[22337]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c**3))-1/677376.
    coneq[22338]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/1354752.
    coneq[22339]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c**3))-1/451584.
    coneq[22340]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c**3))-1/169344.
    coneq[22341]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**3))-1/338688.
    coneq[22342]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c**3))-1/112896.
    coneq[22343]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c**3))-1/225792.
    coneq[22344]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c**3))-1/24192.
    coneq[22345]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c**3))-1/120960.
    coneq[22346]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c**3))-1/483840.
    coneq[22347]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**3))-1/1451520.
    coneq[22348]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**3))-1/2903040.
    coneq[22349]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**3))-1/967680.
    coneq[22350]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**3))-1/362880.
    coneq[22351]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**3))-1/725760.
    coneq[22352]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**3))-1/241920.
    coneq[22353]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**3))-1/483840.
    coneq[22354]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c**3))-1/96768.
    coneq[22355]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**3))-1/290304.
    coneq[22356]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/580608.
    coneq[22357]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**3))-1/193536.
    coneq[22358]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c**3))-1/72576.
    coneq[22359]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**3))-1/145152.
    coneq[22360]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c**3))-1/48384.
    coneq[22361]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**3))-1/145152.
    coneq[22362]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**3))-1/290304.
    coneq[22363]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**3))-1/96768.
    coneq[22364]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c**3))-1/20160.
    coneq[22365]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c**3))-1/80640.
    coneq[22366]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/241920.
    coneq[22367]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/483840.
    coneq[22368]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/161280.
    coneq[22369]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/60480.
    coneq[22370]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/120960.
    coneq[22371]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/40320.
    coneq[22372]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/80640.
    coneq[22373]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c**3))-1/16128.
    coneq[22374]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c**3))-1/48384.
    coneq[22375]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/96768.
    coneq[22376]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c**3))-1/32256.
    coneq[22377]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c**3))-1/12096.
    coneq[22378]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c**3))-1/24192.
    coneq[22379]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c**3))-1/8064.
    coneq[22380]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c**3))-1/48384.
    coneq[22381]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c**3))-1/145152.
    coneq[22382]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/290304.
    coneq[22383]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c**3))-1/96768.
    coneq[22384]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c**3))-1/96768.
    coneq[22385]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c**3))-1/290304.
    coneq[22386]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/580608.
    coneq[22387]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c**3))-1/193536.
    coneq[22388]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c**3))-1/40320.
    coneq[22389]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c**3))-1/161280.
    coneq[22390]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/483840.
    coneq[22391]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/967680.
    coneq[22392]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/322560.
    coneq[22393]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/120960.
    coneq[22394]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/241920.
    coneq[22395]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/80640.
    coneq[22396]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/161280.
    coneq[22397]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c**3))-1/36288.
    coneq[22398]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**3))-1/72576.
    coneq[22399]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**3))-1/145152.
    coneq[22400]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c**3))-1/32256.
    coneq[22401]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**3))-1/96768.
    coneq[22402]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/193536.
    coneq[22403]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**3))-1/64512.
    coneq[22404]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/24192.
    coneq[22405]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/48384.
    coneq[22406]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/16128.
    coneq[22407]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/48384.
    coneq[22408]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/96768.
    coneq[22409]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/32256.
    coneq[22410]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c**3))-1/3528.
    coneq[22411]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c**3))-1/21168.
    coneq[22412]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c**3))-1/105840.
    coneq[22413]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**3))-1/423360.
    coneq[22414]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**3))-1/1270080.
    coneq[22415]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**3))-1/2540160.
    coneq[22416]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**3))-1/846720.
    coneq[22417]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**3))-1/317520.
    coneq[22418]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**3))-1/635040.
    coneq[22419]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**3))-1/211680.
    coneq[22420]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**3))-1/423360.
    coneq[22421]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**3))-1/84672.
    coneq[22422]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**3))-1/254016.
    coneq[22423]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/508032.
    coneq[22424]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**3))-1/169344.
    coneq[22425]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**3))-1/63504.
    coneq[22426]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**3))-1/127008.
    coneq[22427]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**3))-1/42336.
    coneq[22428]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**3))-1/127008.
    coneq[22429]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**3))-1/254016.
    coneq[22430]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**3))-1/84672.
    coneq[22431]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c**3))-1/17640.
    coneq[22432]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**3))-1/70560.
    coneq[22433]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/211680.
    coneq[22434]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/423360.
    coneq[22435]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/141120.
    coneq[22436]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/52920.
    coneq[22437]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/105840.
    coneq[22438]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/35280.
    coneq[22439]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/70560.
    coneq[22440]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c**3))-1/14112.
    coneq[22441]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**3))-1/42336.
    coneq[22442]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/84672.
    coneq[22443]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**3))-1/28224.
    coneq[22444]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c**3))-1/10584.
    coneq[22445]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**3))-1/21168.
    coneq[22446]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c**3))-1/7056.
    coneq[22447]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**3))-1/31752.
    coneq[22448]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**3))-1/63504.
    coneq[22449]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**3))-1/127008.
    coneq[22450]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**3))-1/28224.
    coneq[22451]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**3))-1/84672.
    coneq[22452]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/169344.
    coneq[22453]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**3))-1/56448.
    coneq[22454]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/21168.
    coneq[22455]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/42336.
    coneq[22456]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/14112.
    coneq[22457]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/28224.
    coneq[22458]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c**3))-1/3024.
    coneq[22459]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c**3))-1/15120.
    coneq[22460]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c**3))-1/60480.
    coneq[22461]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/181440.
    coneq[22462]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/362880.
    coneq[22463]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/120960.
    coneq[22464]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/45360.
    coneq[22465]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/90720.
    coneq[22466]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/30240.
    coneq[22467]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/60480.
    coneq[22468]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c**3))-1/12096.
    coneq[22469]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3))-1/36288.
    coneq[22470]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/72576.
    coneq[22471]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3))-1/24192.
    coneq[22472]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c**3))-1/9072.
    coneq[22473]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3))-1/18144.
    coneq[22474]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c**3))-1/6048.
    coneq[22475]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/18144.
    coneq[22476]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/36288.
    coneq[22477]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/12096.
    coneq[22478]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c**3))-1/2520.
    coneq[22479]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c**3))-1/10080.
    coneq[22480]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/30240.
    coneq[22481]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/60480.
    coneq[22482]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/20160.
    coneq[22483]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/7560.
    coneq[22484]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/15120.
    coneq[22485]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/5040.
    coneq[22486]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/10080.
    coneq[22487]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c**3))-1/2016.
    coneq[22488]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c**3))-1/6048.
    coneq[22489]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/12096.
    coneq[22490]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c**3))-1/4032.
    coneq[22491]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c**3))-1/1512.
    coneq[22492]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c**3))-1/3024.
    coneq[22493]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c**3))-1/1008.
    coneq[22494]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c**3))-1/8064.
    coneq[22495]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/24192.
    coneq[22496]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/48384.
    coneq[22497]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/16128.
    coneq[22498]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c**3))-1/72576.
    coneq[22499]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/145152.
    coneq[22500]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c**3))-1/48384.
    coneq[22501]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/290304.
    coneq[22502]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c**3))-1/96768.
    coneq[22503]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**3))-1/32256.
    coneq[22504]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c**3))-1/7560.
    coneq[22505]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c**3))-1/30240.
    coneq[22506]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/90720.
    coneq[22507]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/181440.
    coneq[22508]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/60480.
    coneq[22509]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/22680.
    coneq[22510]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/45360.
    coneq[22511]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/15120.
    coneq[22512]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/30240.
    coneq[22513]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c**3))-1/15120.
    coneq[22514]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c**3))-1/60480.
    coneq[22515]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/181440.
    coneq[22516]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/362880.
    coneq[22517]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/120960.
    coneq[22518]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/45360.
    coneq[22519]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/90720.
    coneq[22520]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/30240.
    coneq[22521]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/60480.
    coneq[22522]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c**3))-1/6048.
    coneq[22523]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c**3))-1/30240.
    coneq[22524]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c**3))-1/120960.
    coneq[22525]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3))-1/362880.
    coneq[22526]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3))-1/725760.
    coneq[22527]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3))-1/241920.
    coneq[22528]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3))-1/90720.
    coneq[22529]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3))-1/181440.
    coneq[22530]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3))-1/60480.
    coneq[22531]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3))-1/120960.
    coneq[22532]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c**3))-1/24192.
    coneq[22533]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3))-1/72576.
    coneq[22534]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/145152.
    coneq[22535]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3))-1/48384.
    coneq[22536]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c**3))-1/18144.
    coneq[22537]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3))-1/36288.
    coneq[22538]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c**3))-1/12096.
    coneq[22539]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3))-1/36288.
    coneq[22540]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3))-1/72576.
    coneq[22541]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3))-1/24192.
    coneq[22542]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c**3))-1/6048.
    coneq[22543]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/18144.
    coneq[22544]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/36288.
    coneq[22545]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/12096.
    coneq[22546]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**3))-1/12096.
    coneq[22547]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**3))-1/36288.
    coneq[22548]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/72576.
    coneq[22549]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**3))-1/24192.
    coneq[22550]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c**3))-1/5040.
    coneq[22551]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**3))-1/20160.
    coneq[22552]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3))-1/60480.
    coneq[22553]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3))-1/120960.
    coneq[22554]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3))-1/40320.
    coneq[22555]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**3))-1/15120.
    coneq[22556]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3))-1/30240.
    coneq[22557]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**3))-1/10080.
    coneq[22558]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3))-1/20160.
    coneq[22559]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c**3))-1/4536.
    coneq[22560]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3))-1/9072.
    coneq[22561]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3))-1/18144.
    coneq[22562]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c**3))-1/4032.
    coneq[22563]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/12096.
    coneq[22564]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/24192.
    coneq[22565]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/8064.
    coneq[22566]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c**3))-1/3024.
    coneq[22567]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3))-1/6048.
    coneq[22568]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c**3))-1/2016.
    coneq[22569]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c**3))-1/8064.
    coneq[22570]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3))-1/24192.
    coneq[22571]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3))-1/48384.
    coneq[22572]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3))-1/16128.
    coneq[22573]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c**3))-1/9072.
    coneq[22574]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3))-1/18144.
    coneq[22575]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3))-1/36288.
    coneq[22576]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**3))-1/6048.
    coneq[22577]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3))-1/12096.
    coneq[22578]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3))-1/4032.
    coneq[22579]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3))-1/8064.
    coneq[22580]=dot(b,dot(A,c**8)*dot(A,dot(A,c**2)))-1/1512.
    coneq[22581]=dot(b,dot(A,dot(A,c**7))*dot(A,dot(A,c**2)))-1/12096.
    coneq[22582]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,dot(A,c**2)))-1/84672.
    coneq[22583]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,dot(A,c**2)))-1/508032.
    coneq[22584]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,dot(A,c**2)))-1/2540160.
    coneq[22585]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,c**2)))-1/10160640.
    coneq[22586]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c**2)))-1/30481920.
    coneq[22587]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c**2)))-1/60963840.
    coneq[22588]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c**2)))-1/20321280.
    coneq[22589]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c**2)))-1/7620480.
    coneq[22590]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c**2)))-1/15240960.
    coneq[22591]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c**2)))-1/5080320.
    coneq[22592]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c**2)))-1/10160640.
    coneq[22593]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,dot(A,c**2)))-1/2032128.
    coneq[22594]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,c**2)))-1/6096384.
    coneq[22595]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**2)))-1/12192768.
    coneq[22596]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,c**2)))-1/4064256.
    coneq[22597]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/1524096.
    coneq[22598]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/3048192.
    coneq[22599]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,dot(A,c**2)))-1/1016064.
    coneq[22600]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/3048192.
    coneq[22601]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/6096384.
    coneq[22602]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**2)))-1/2032128.
    coneq[22603]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,dot(A,c**2)))-1/423360.
    coneq[22604]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,dot(A,c**2)))-1/1693440.
    coneq[22605]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c**2)))-1/5080320.
    coneq[22606]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**2)))-1/10160640.
    coneq[22607]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c**2)))-1/3386880.
    coneq[22608]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/1270080.
    coneq[22609]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/2540160.
    coneq[22610]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c**2)))-1/846720.
    coneq[22611]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**2)))-1/1693440.
    coneq[22612]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,dot(A,c**2)))-1/338688.
    coneq[22613]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/1016064.
    coneq[22614]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/2032128.
    coneq[22615]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/677376.
    coneq[22616]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/254016.
    coneq[22617]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/508032.
    coneq[22618]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,dot(A,c**2)))-1/169344.
    coneq[22619]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/762048.
    coneq[22620]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/1524096.
    coneq[22621]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/3048192.
    coneq[22622]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,dot(A,c**2)))-1/677376.
    coneq[22623]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/2032128.
    coneq[22624]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/4064256.
    coneq[22625]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/1354752.
    coneq[22626]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/508032.
    coneq[22627]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/1016064.
    coneq[22628]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/338688.
    coneq[22629]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/677376.
    coneq[22630]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22631]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22632]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c**2)))-1/1451520.
    coneq[22633]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c**2)))-1/4354560.
    coneq[22634]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**2)))-1/8709120.
    coneq[22635]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c**2)))-1/2903040.
    coneq[22636]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/1088640.
    coneq[22637]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/2177280.
    coneq[22638]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c**2)))-1/725760.
    coneq[22639]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**2)))-1/1451520.
    coneq[22640]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22641]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/870912.
    coneq[22642]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1741824.
    coneq[22643]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/580608.
    coneq[22644]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22645]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/435456.
    coneq[22646]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22647]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/435456.
    coneq[22648]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/870912.
    coneq[22649]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22650]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,dot(A,c**2)))-1/60480.
    coneq[22651]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/241920.
    coneq[22652]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/725760.
    coneq[22653]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1451520.
    coneq[22654]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/483840.
    coneq[22655]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22656]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22657]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/120960.
    coneq[22658]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/241920.
    coneq[22659]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/48384.
    coneq[22660]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22661]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22662]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/96768.
    coneq[22663]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22664]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22665]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,dot(A,c**2)))-1/24192.
    coneq[22666]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22667]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/435456.
    coneq[22668]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/870912.
    coneq[22669]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22670]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22671]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/870912.
    coneq[22672]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/1741824.
    coneq[22673]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/580608.
    coneq[22674]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,dot(A,c**2)))-1/120960.
    coneq[22675]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/483840.
    coneq[22676]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/1451520.
    coneq[22677]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/2903040.
    coneq[22678]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/967680.
    coneq[22679]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22680]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/725760.
    coneq[22681]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/241920.
    coneq[22682]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/483840.
    coneq[22683]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22684]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22685]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/435456.
    coneq[22686]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/96768.
    coneq[22687]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22688]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/580608.
    coneq[22689]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/193536.
    coneq[22690]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22691]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22692]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/48384.
    coneq[22693]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22694]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22695]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/96768.
    coneq[22696]=dot(b,dot(A,c*dot(A,c**6))*dot(A,dot(A,c**2)))-1/10584.
    coneq[22697]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,dot(A,c**2)))-1/63504.
    coneq[22698]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c**2)))-1/317520.
    coneq[22699]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c**2)))-1/1270080.
    coneq[22700]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c**2)))-1/3810240.
    coneq[22701]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**2)))-1/7620480.
    coneq[22702]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c**2)))-1/2540160.
    coneq[22703]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/952560.
    coneq[22704]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1905120.
    coneq[22705]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c**2)))-1/635040.
    coneq[22706]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**2)))-1/1270080.
    coneq[22707]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c**2)))-1/254016.
    coneq[22708]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/762048.
    coneq[22709]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1524096.
    coneq[22710]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/508032.
    coneq[22711]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/190512.
    coneq[22712]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/381024.
    coneq[22713]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c**2)))-1/127008.
    coneq[22714]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/381024.
    coneq[22715]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/762048.
    coneq[22716]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/254016.
    coneq[22717]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,dot(A,c**2)))-1/52920.
    coneq[22718]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/211680.
    coneq[22719]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/635040.
    coneq[22720]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1270080.
    coneq[22721]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/423360.
    coneq[22722]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/158760.
    coneq[22723]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/317520.
    coneq[22724]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/105840.
    coneq[22725]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/211680.
    coneq[22726]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/42336.
    coneq[22727]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/127008.
    coneq[22728]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/254016.
    coneq[22729]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/84672.
    coneq[22730]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/31752.
    coneq[22731]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/63504.
    coneq[22732]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,dot(A,c**2)))-1/21168.
    coneq[22733]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/95256.
    coneq[22734]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/190512.
    coneq[22735]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/381024.
    coneq[22736]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/84672.
    coneq[22737]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/254016.
    coneq[22738]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/508032.
    coneq[22739]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/169344.
    coneq[22740]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/63504.
    coneq[22741]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/127008.
    coneq[22742]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/42336.
    coneq[22743]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/84672.
    coneq[22744]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,dot(A,c**2)))-1/9072.
    coneq[22745]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,dot(A,c**2)))-1/45360.
    coneq[22746]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22747]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/544320.
    coneq[22748]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/1088640.
    coneq[22749]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22750]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/136080.
    coneq[22751]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/272160.
    coneq[22752]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22753]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22754]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22755]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22756]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22757]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22758]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/27216.
    coneq[22759]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/54432.
    coneq[22760]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2)))-1/18144.
    coneq[22761]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/54432.
    coneq[22762]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22763]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22764]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,dot(A,c**2)))-1/7560.
    coneq[22765]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/30240.
    coneq[22766]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22767]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22768]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/60480.
    coneq[22769]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/22680.
    coneq[22770]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/45360.
    coneq[22771]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/15120.
    coneq[22772]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/30240.
    coneq[22773]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,dot(A,c**2)))-1/6048.
    coneq[22774]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/18144.
    coneq[22775]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22776]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/12096.
    coneq[22777]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,dot(A,c**2)))-1/4536.
    coneq[22778]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/9072.
    coneq[22779]=dot(b,dot(A,c**6*dot(A,c))*dot(A,dot(A,c**2)))-1/3024.
    coneq[22780]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/24192.
    coneq[22781]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22782]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22783]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/48384.
    coneq[22784]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22785]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/435456.
    coneq[22786]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22787]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/870912.
    coneq[22788]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/290304.
    coneq[22789]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/96768.
    coneq[22790]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,dot(A,c**2)))-1/22680.
    coneq[22791]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22792]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/272160.
    coneq[22793]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/544320.
    coneq[22794]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22795]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/68040.
    coneq[22796]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/136080.
    coneq[22797]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/45360.
    coneq[22798]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22799]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,dot(A,c**2)))-1/45360.
    coneq[22800]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22801]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/544320.
    coneq[22802]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/1088640.
    coneq[22803]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22804]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/136080.
    coneq[22805]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/272160.
    coneq[22806]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22807]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22808]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,dot(A,c**2)))-1/18144.
    coneq[22809]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22810]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22811]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2)))-1/1088640.
    coneq[22812]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2)))-1/2177280.
    coneq[22813]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2)))-1/725760.
    coneq[22814]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2)))-1/272160.
    coneq[22815]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/544320.
    coneq[22816]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22817]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22818]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22819]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22820]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/435456.
    coneq[22821]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22822]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/54432.
    coneq[22823]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22824]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22825]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22826]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22827]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22828]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/18144.
    coneq[22829]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/54432.
    coneq[22830]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22831]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22832]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22833]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22834]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/217728.
    coneq[22835]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22836]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,dot(A,c**2)))-1/15120.
    coneq[22837]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2)))-1/60480.
    coneq[22838]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2)))-1/181440.
    coneq[22839]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2)))-1/362880.
    coneq[22840]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2)))-1/120960.
    coneq[22841]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2)))-1/45360.
    coneq[22842]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/90720.
    coneq[22843]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2)))-1/30240.
    coneq[22844]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2)))-1/60480.
    coneq[22845]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/13608.
    coneq[22846]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/27216.
    coneq[22847]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/54432.
    coneq[22848]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/12096.
    coneq[22849]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22850]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22851]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/24192.
    coneq[22852]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/9072.
    coneq[22853]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/18144.
    coneq[22854]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/6048.
    coneq[22855]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2)))-1/24192.
    coneq[22856]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2)))-1/72576.
    coneq[22857]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2)))-1/145152.
    coneq[22858]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2)))-1/48384.
    coneq[22859]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/27216.
    coneq[22860]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/54432.
    coneq[22861]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/108864.
    coneq[22862]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2)))-1/18144.
    coneq[22863]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/36288.
    coneq[22864]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/12096.
    coneq[22865]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2)))-1/24192.
    coneq[22866]=dot(b,dot(A,c**8)*dot(A,dot(A,dot(A,c))))-1/3024.
    coneq[22867]=dot(b,dot(A,dot(A,c**7))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[22868]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,dot(A,dot(A,c))))-1/169344.
    coneq[22869]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,dot(A,dot(A,c))))-1/1016064.
    coneq[22870]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,dot(A,dot(A,c))))-1/5080320.
    coneq[22871]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,dot(A,c))))-1/20321280.
    coneq[22872]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,dot(A,c))))-1/60963840.
    coneq[22873]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,dot(A,c))))-1/121927680.
    coneq[22874]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/40642560.
    coneq[22875]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,dot(A,c))))-1/15240960.
    coneq[22876]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/30481920.
    coneq[22877]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/10160640.
    coneq[22878]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/20321280.
    coneq[22879]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,dot(A,dot(A,c))))-1/4064256.
    coneq[22880]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c))))-1/12192768.
    coneq[22881]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/24385536.
    coneq[22882]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/8128512.
    coneq[22883]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/3048192.
    coneq[22884]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/6096384.
    coneq[22885]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2032128.
    coneq[22886]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/6096384.
    coneq[22887]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/12192768.
    coneq[22888]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/4064256.
    coneq[22889]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,dot(A,dot(A,c))))-1/846720.
    coneq[22890]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,c))))-1/3386880.
    coneq[22891]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c))))-1/10160640.
    coneq[22892]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/20321280.
    coneq[22893]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/6773760.
    coneq[22894]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/2540160.
    coneq[22895]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/5080320.
    coneq[22896]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1693440.
    coneq[22897]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/3386880.
    coneq[22898]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/677376.
    coneq[22899]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/2032128.
    coneq[22900]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/4064256.
    coneq[22901]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1354752.
    coneq[22902]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/508032.
    coneq[22903]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1016064.
    coneq[22904]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/338688.
    coneq[22905]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/1524096.
    coneq[22906]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/3048192.
    coneq[22907]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/6096384.
    coneq[22908]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/1354752.
    coneq[22909]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/4064256.
    coneq[22910]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/8128512.
    coneq[22911]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2709504.
    coneq[22912]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/1016064.
    coneq[22913]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2032128.
    coneq[22914]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/677376.
    coneq[22915]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/1354752.
    coneq[22916]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[22917]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[22918]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,c))))-1/2903040.
    coneq[22919]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c))))-1/8709120.
    coneq[22920]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/17418240.
    coneq[22921]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/5806080.
    coneq[22922]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/2177280.
    coneq[22923]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/4354560.
    coneq[22924]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1451520.
    coneq[22925]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2903040.
    coneq[22926]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22927]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1741824.
    coneq[22928]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/3483648.
    coneq[22929]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1161216.
    coneq[22930]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[22931]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/870912.
    coneq[22932]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[22933]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/870912.
    coneq[22934]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1741824.
    coneq[22935]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22936]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[22937]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/483840.
    coneq[22938]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1451520.
    coneq[22939]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/2903040.
    coneq[22940]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/967680.
    coneq[22941]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[22942]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[22943]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[22944]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/483840.
    coneq[22945]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/96768.
    coneq[22946]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[22947]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22948]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/193536.
    coneq[22949]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[22950]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[22951]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[22952]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[22953]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/870912.
    coneq[22954]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1741824.
    coneq[22955]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22956]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22957]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/1741824.
    coneq[22958]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/3483648.
    coneq[22959]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/1161216.
    coneq[22960]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[22961]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/967680.
    coneq[22962]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/2903040.
    coneq[22963]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/5806080.
    coneq[22964]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1935360.
    coneq[22965]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[22966]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1451520.
    coneq[22967]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/483840.
    coneq[22968]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/967680.
    coneq[22969]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[22970]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[22971]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/870912.
    coneq[22972]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/193536.
    coneq[22973]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22974]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1161216.
    coneq[22975]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/387072.
    coneq[22976]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[22977]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[22978]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/96768.
    coneq[22979]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[22980]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[22981]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/193536.
    coneq[22982]=dot(b,dot(A,c*dot(A,c**6))*dot(A,dot(A,dot(A,c))))-1/21168.
    coneq[22983]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,dot(A,dot(A,c))))-1/127008.
    coneq[22984]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,dot(A,c))))-1/635040.
    coneq[22985]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,c))))-1/2540160.
    coneq[22986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c))))-1/7620480.
    coneq[22987]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c))))-1/15240960.
    coneq[22988]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/5080320.
    coneq[22989]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1905120.
    coneq[22990]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/3810240.
    coneq[22991]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1270080.
    coneq[22992]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2540160.
    coneq[22993]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/508032.
    coneq[22994]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1524096.
    coneq[22995]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/3048192.
    coneq[22996]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1016064.
    coneq[22997]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/381024.
    coneq[22998]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/762048.
    coneq[22999]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/254016.
    coneq[23000]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/762048.
    coneq[23001]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1524096.
    coneq[23002]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/508032.
    coneq[23003]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/105840.
    coneq[23004]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/423360.
    coneq[23005]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1270080.
    coneq[23006]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/2540160.
    coneq[23007]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/846720.
    coneq[23008]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/317520.
    coneq[23009]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/635040.
    coneq[23010]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/211680.
    coneq[23011]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/423360.
    coneq[23012]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/84672.
    coneq[23013]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/254016.
    coneq[23014]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/508032.
    coneq[23015]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/169344.
    coneq[23016]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/63504.
    coneq[23017]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/127008.
    coneq[23018]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/42336.
    coneq[23019]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/190512.
    coneq[23020]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/381024.
    coneq[23021]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/762048.
    coneq[23022]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/169344.
    coneq[23023]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/508032.
    coneq[23024]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1016064.
    coneq[23025]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/338688.
    coneq[23026]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/127008.
    coneq[23027]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/254016.
    coneq[23028]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/84672.
    coneq[23029]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/169344.
    coneq[23030]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,dot(A,dot(A,c))))-1/18144.
    coneq[23031]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/90720.
    coneq[23032]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23033]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/1088640.
    coneq[23034]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/2177280.
    coneq[23035]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[23036]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/272160.
    coneq[23037]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/544320.
    coneq[23038]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23039]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23040]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23041]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23042]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[23043]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23044]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/54432.
    coneq[23045]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/108864.
    coneq[23046]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[23047]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/108864.
    coneq[23048]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23049]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23050]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/15120.
    coneq[23051]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/60480.
    coneq[23052]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23053]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23054]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[23055]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/45360.
    coneq[23056]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/90720.
    coneq[23057]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/30240.
    coneq[23058]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/60480.
    coneq[23059]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/12096.
    coneq[23060]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[23061]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23062]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[23063]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/9072.
    coneq[23064]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/18144.
    coneq[23065]=dot(b,dot(A,c**6*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/6048.
    coneq[23066]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[23067]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23068]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[23069]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/96768.
    coneq[23070]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[23071]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/870912.
    coneq[23072]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[23073]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/1741824.
    coneq[23074]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/580608.
    coneq[23075]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/193536.
    coneq[23076]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/45360.
    coneq[23077]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23078]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/544320.
    coneq[23079]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1088640.
    coneq[23080]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23081]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/136080.
    coneq[23082]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/272160.
    coneq[23083]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/90720.
    coneq[23084]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23085]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/90720.
    coneq[23086]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23087]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/1088640.
    coneq[23088]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/2177280.
    coneq[23089]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[23090]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/272160.
    coneq[23091]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/544320.
    coneq[23092]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23093]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23094]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[23095]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23096]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[23097]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c))))-1/2177280.
    coneq[23098]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c))))-1/4354560.
    coneq[23099]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1451520.
    coneq[23100]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/544320.
    coneq[23101]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/1088640.
    coneq[23102]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23103]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[23104]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23105]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[23106]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/870912.
    coneq[23107]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[23108]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/108864.
    coneq[23109]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23110]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23111]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23112]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[23113]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23114]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[23115]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/108864.
    coneq[23116]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23117]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23118]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23119]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23120]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/435456.
    coneq[23121]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23122]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,dot(A,dot(A,c))))-1/30240.
    coneq[23123]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[23124]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c))))-1/362880.
    coneq[23125]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c))))-1/725760.
    coneq[23126]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[23127]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/90720.
    coneq[23128]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/181440.
    coneq[23129]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/60480.
    coneq[23130]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[23131]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/27216.
    coneq[23132]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/54432.
    coneq[23133]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/108864.
    coneq[23134]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[23135]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23136]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23137]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[23138]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/18144.
    coneq[23139]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[23140]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/12096.
    coneq[23141]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[23142]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c))))-1/145152.
    coneq[23143]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c))))-1/290304.
    coneq[23144]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/96768.
    coneq[23145]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/54432.
    coneq[23146]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/108864.
    coneq[23147]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/217728.
    coneq[23148]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c))))-1/36288.
    coneq[23149]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/72576.
    coneq[23150]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/24192.
    coneq[23151]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/48384.
    coneq[23152]=dot(b,dot(A,c**8)*dot(A,c*dot(A,c)))-1/1008.
    coneq[23153]=dot(b,dot(A,dot(A,c**7))*dot(A,c*dot(A,c)))-1/8064.
    coneq[23154]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c*dot(A,c)))-1/56448.
    coneq[23155]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c*dot(A,c)))-1/338688.
    coneq[23156]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c*dot(A,c)))-1/1693440.
    coneq[23157]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c*dot(A,c)))-1/6773760.
    coneq[23158]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c*dot(A,c)))-1/20321280.
    coneq[23159]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c*dot(A,c)))-1/40642560.
    coneq[23160]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c*dot(A,c)))-1/13547520.
    coneq[23161]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c*dot(A,c)))-1/5080320.
    coneq[23162]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c*dot(A,c)))-1/10160640.
    coneq[23163]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c*dot(A,c)))-1/3386880.
    coneq[23164]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c*dot(A,c)))-1/6773760.
    coneq[23165]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c*dot(A,c)))-1/1354752.
    coneq[23166]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c)))-1/4064256.
    coneq[23167]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c)))-1/8128512.
    coneq[23168]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c)))-1/2709504.
    coneq[23169]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/1016064.
    coneq[23170]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/2032128.
    coneq[23171]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c*dot(A,c)))-1/677376.
    coneq[23172]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/2032128.
    coneq[23173]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/4064256.
    coneq[23174]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c)))-1/1354752.
    coneq[23175]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c*dot(A,c)))-1/282240.
    coneq[23176]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c*dot(A,c)))-1/1128960.
    coneq[23177]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c)))-1/3386880.
    coneq[23178]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c)))-1/6773760.
    coneq[23179]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c)))-1/2257920.
    coneq[23180]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/846720.
    coneq[23181]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1693440.
    coneq[23182]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,c)))-1/564480.
    coneq[23183]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c)))-1/1128960.
    coneq[23184]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c*dot(A,c)))-1/225792.
    coneq[23185]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/677376.
    coneq[23186]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1354752.
    coneq[23187]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/451584.
    coneq[23188]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/169344.
    coneq[23189]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/338688.
    coneq[23190]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c*dot(A,c)))-1/112896.
    coneq[23191]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/508032.
    coneq[23192]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/1016064.
    coneq[23193]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/2032128.
    coneq[23194]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c*dot(A,c)))-1/451584.
    coneq[23195]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/1354752.
    coneq[23196]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/2709504.
    coneq[23197]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/903168.
    coneq[23198]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/338688.
    coneq[23199]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/677376.
    coneq[23200]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/225792.
    coneq[23201]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/451584.
    coneq[23202]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23203]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23204]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c*dot(A,c)))-1/967680.
    coneq[23205]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c)))-1/2903040.
    coneq[23206]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c)))-1/5806080.
    coneq[23207]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c)))-1/1935360.
    coneq[23208]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/725760.
    coneq[23209]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1451520.
    coneq[23210]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,c)))-1/483840.
    coneq[23211]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c)))-1/967680.
    coneq[23212]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23213]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/580608.
    coneq[23214]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1161216.
    coneq[23215]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/387072.
    coneq[23216]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23217]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/290304.
    coneq[23218]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23219]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/290304.
    coneq[23220]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/580608.
    coneq[23221]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23222]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c*dot(A,c)))-1/40320.
    coneq[23223]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/161280.
    coneq[23224]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/483840.
    coneq[23225]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/967680.
    coneq[23226]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/322560.
    coneq[23227]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23228]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23229]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/80640.
    coneq[23230]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/161280.
    coneq[23231]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/32256.
    coneq[23232]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23233]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23234]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/64512.
    coneq[23235]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23236]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23237]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c*dot(A,c)))-1/16128.
    coneq[23238]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23239]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/290304.
    coneq[23240]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/580608.
    coneq[23241]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23242]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23243]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/580608.
    coneq[23244]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/1161216.
    coneq[23245]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/387072.
    coneq[23246]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c*dot(A,c)))-1/80640.
    coneq[23247]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/322560.
    coneq[23248]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/967680.
    coneq[23249]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1935360.
    coneq[23250]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/645120.
    coneq[23251]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23252]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/483840.
    coneq[23253]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/161280.
    coneq[23254]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/322560.
    coneq[23255]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23256]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23257]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/290304.
    coneq[23258]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/64512.
    coneq[23259]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23260]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/387072.
    coneq[23261]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/129024.
    coneq[23262]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23263]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23264]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/32256.
    coneq[23265]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23266]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23267]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/64512.
    coneq[23268]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c*dot(A,c)))-1/7056.
    coneq[23269]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c*dot(A,c)))-1/42336.
    coneq[23270]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c*dot(A,c)))-1/211680.
    coneq[23271]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c*dot(A,c)))-1/846720.
    coneq[23272]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c)))-1/2540160.
    coneq[23273]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c)))-1/5080320.
    coneq[23274]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c)))-1/1693440.
    coneq[23275]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/635040.
    coneq[23276]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1270080.
    coneq[23277]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,c)))-1/423360.
    coneq[23278]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c)))-1/846720.
    coneq[23279]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c*dot(A,c)))-1/169344.
    coneq[23280]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/508032.
    coneq[23281]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1016064.
    coneq[23282]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/338688.
    coneq[23283]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/127008.
    coneq[23284]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/254016.
    coneq[23285]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c*dot(A,c)))-1/84672.
    coneq[23286]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/254016.
    coneq[23287]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/508032.
    coneq[23288]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/169344.
    coneq[23289]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c*dot(A,c)))-1/35280.
    coneq[23290]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/141120.
    coneq[23291]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/423360.
    coneq[23292]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/846720.
    coneq[23293]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/282240.
    coneq[23294]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/105840.
    coneq[23295]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/211680.
    coneq[23296]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/70560.
    coneq[23297]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/141120.
    coneq[23298]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/28224.
    coneq[23299]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/84672.
    coneq[23300]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/169344.
    coneq[23301]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/56448.
    coneq[23302]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/21168.
    coneq[23303]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/42336.
    coneq[23304]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c*dot(A,c)))-1/14112.
    coneq[23305]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/63504.
    coneq[23306]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/127008.
    coneq[23307]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/254016.
    coneq[23308]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/56448.
    coneq[23309]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/169344.
    coneq[23310]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/338688.
    coneq[23311]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/112896.
    coneq[23312]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/42336.
    coneq[23313]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/84672.
    coneq[23314]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/28224.
    coneq[23315]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/56448.
    coneq[23316]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c*dot(A,c)))-1/6048.
    coneq[23317]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c*dot(A,c)))-1/30240.
    coneq[23318]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23319]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/362880.
    coneq[23320]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/725760.
    coneq[23321]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23322]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/90720.
    coneq[23323]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/181440.
    coneq[23324]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23325]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23326]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23327]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23328]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23329]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23330]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/18144.
    coneq[23331]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/36288.
    coneq[23332]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c)))-1/12096.
    coneq[23333]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/36288.
    coneq[23334]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23335]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23336]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c*dot(A,c)))-1/5040.
    coneq[23337]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/20160.
    coneq[23338]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23339]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23340]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/40320.
    coneq[23341]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/15120.
    coneq[23342]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/30240.
    coneq[23343]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/10080.
    coneq[23344]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/20160.
    coneq[23345]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c*dot(A,c)))-1/4032.
    coneq[23346]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/12096.
    coneq[23347]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23348]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/8064.
    coneq[23349]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c*dot(A,c)))-1/3024.
    coneq[23350]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/6048.
    coneq[23351]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c*dot(A,c)))-1/2016.
    coneq[23352]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/16128.
    coneq[23353]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23354]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23355]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/32256.
    coneq[23356]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23357]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/290304.
    coneq[23358]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23359]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/580608.
    coneq[23360]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/193536.
    coneq[23361]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/64512.
    coneq[23362]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c*dot(A,c)))-1/15120.
    coneq[23363]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23364]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/181440.
    coneq[23365]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/362880.
    coneq[23366]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23367]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/45360.
    coneq[23368]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/90720.
    coneq[23369]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/30240.
    coneq[23370]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23371]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c*dot(A,c)))-1/30240.
    coneq[23372]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23373]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/362880.
    coneq[23374]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/725760.
    coneq[23375]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23376]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/90720.
    coneq[23377]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/181440.
    coneq[23378]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23379]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23380]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c*dot(A,c)))-1/12096.
    coneq[23381]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23382]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23383]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c)))-1/725760.
    coneq[23384]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c)))-1/1451520.
    coneq[23385]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c)))-1/483840.
    coneq[23386]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c)))-1/181440.
    coneq[23387]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/362880.
    coneq[23388]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23389]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23390]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23391]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23392]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/290304.
    coneq[23393]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23394]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/36288.
    coneq[23395]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23396]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23397]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23398]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23399]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23400]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/12096.
    coneq[23401]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/36288.
    coneq[23402]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23403]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23404]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23405]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23406]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/145152.
    coneq[23407]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23408]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c*dot(A,c)))-1/10080.
    coneq[23409]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c)))-1/40320.
    coneq[23410]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c)))-1/120960.
    coneq[23411]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c)))-1/241920.
    coneq[23412]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c)))-1/80640.
    coneq[23413]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c)))-1/30240.
    coneq[23414]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/60480.
    coneq[23415]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c)))-1/20160.
    coneq[23416]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c)))-1/40320.
    coneq[23417]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/9072.
    coneq[23418]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/18144.
    coneq[23419]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/36288.
    coneq[23420]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/8064.
    coneq[23421]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23422]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23423]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/16128.
    coneq[23424]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/6048.
    coneq[23425]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/12096.
    coneq[23426]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/4032.
    coneq[23427]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c)))-1/16128.
    coneq[23428]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c)))-1/48384.
    coneq[23429]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c)))-1/96768.
    coneq[23430]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c)))-1/32256.
    coneq[23431]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/18144.
    coneq[23432]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/36288.
    coneq[23433]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/72576.
    coneq[23434]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c)))-1/12096.
    coneq[23435]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c)))-1/24192.
    coneq[23436]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/8064.
    coneq[23437]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)))-1/16128.
    coneq[23438]=dot(b,dot(A,c**9)*dot(A,c**2))-1/420.
    coneq[23439]=dot(b,dot(A,dot(A,c**8))*dot(A,c**2))-1/3780.
    coneq[23440]=dot(b,dot(A,dot(A,dot(A,c**7)))*dot(A,c**2))-1/30240.
    coneq[23441]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*dot(A,c**2))-1/211680.
    coneq[23442]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*dot(A,c**2))-1/1270080.
    coneq[23443]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*dot(A,c**2))-1/6350400.
    coneq[23444]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,c**2))-1/25401600.
    coneq[23445]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c**2))-1/76204800.
    coneq[23446]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c**2))-1/152409600.
    coneq[23447]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c**2))-1/50803200.
    coneq[23448]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c**2))-1/19051200.
    coneq[23449]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c**2))-1/38102400.
    coneq[23450]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c**2))-1/12700800.
    coneq[23451]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c**2))-1/25401600.
    coneq[23452]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*dot(A,c**2))-1/5080320.
    coneq[23453]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c**2))-1/15240960.
    coneq[23454]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c**2))-1/30481920.
    coneq[23455]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c**2))-1/10160640.
    coneq[23456]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,c**2))-1/3810240.
    coneq[23457]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c**2))-1/7620480.
    coneq[23458]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*dot(A,c**2))-1/2540160.
    coneq[23459]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c**2))-1/7620480.
    coneq[23460]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c**2))-1/15240960.
    coneq[23461]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c**2))-1/5080320.
    coneq[23462]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*dot(A,c**2))-1/1058400.
    coneq[23463]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*dot(A,c**2))-1/4233600.
    coneq[23464]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**2))-1/12700800.
    coneq[23465]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**2))-1/25401600.
    coneq[23466]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**2))-1/8467200.
    coneq[23467]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,c**2))-1/3175200.
    coneq[23468]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**2))-1/6350400.
    coneq[23469]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,c**2))-1/2116800.
    coneq[23470]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**2))-1/4233600.
    coneq[23471]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*dot(A,c**2))-1/846720.
    coneq[23472]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,c**2))-1/2540160.
    coneq[23473]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/5080320.
    coneq[23474]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1693440.
    coneq[23475]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*dot(A,c**2))-1/635040.
    coneq[23476]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*dot(A,c**2))-1/1270080.
    coneq[23477]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*dot(A,c**2))-1/423360.
    coneq[23478]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,c**2))-1/1905120.
    coneq[23479]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c**2))-1/3810240.
    coneq[23480]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c**2))-1/7620480.
    coneq[23481]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,c**2))-1/1693440.
    coneq[23482]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c**2))-1/5080320.
    coneq[23483]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/10160640.
    coneq[23484]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c**2))-1/3386880.
    coneq[23485]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,c**2))-1/1270080.
    coneq[23486]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**2))-1/2540160.
    coneq[23487]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/846720.
    coneq[23488]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/1693440.
    coneq[23489]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*dot(A,c**2))-1/181440.
    coneq[23490]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*dot(A,c**2))-1/907200.
    coneq[23491]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*dot(A,c**2))-1/3628800.
    coneq[23492]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**2))-1/10886400.
    coneq[23493]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**2))-1/21772800.
    coneq[23494]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**2))-1/7257600.
    coneq[23495]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c**2))-1/2721600.
    coneq[23496]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**2))-1/5443200.
    coneq[23497]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c**2))-1/1814400.
    coneq[23498]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**2))-1/3628800.
    coneq[23499]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*dot(A,c**2))-1/725760.
    coneq[23500]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c**2))-1/2177280.
    coneq[23501]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/4354560.
    coneq[23502]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1451520.
    coneq[23503]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*dot(A,c**2))-1/544320.
    coneq[23504]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c**2))-1/1088640.
    coneq[23505]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*dot(A,c**2))-1/362880.
    coneq[23506]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c**2))-1/1088640.
    coneq[23507]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**2))-1/2177280.
    coneq[23508]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/725760.
    coneq[23509]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*dot(A,c**2))-1/151200.
    coneq[23510]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*dot(A,c**2))-1/604800.
    coneq[23511]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1814400.
    coneq[23512]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/3628800.
    coneq[23513]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1209600.
    coneq[23514]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/453600.
    coneq[23515]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/907200.
    coneq[23516]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/302400.
    coneq[23517]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/604800.
    coneq[23518]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*dot(A,c**2))-1/120960.
    coneq[23519]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/362880.
    coneq[23520]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/725760.
    coneq[23521]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/241920.
    coneq[23522]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*dot(A,c**2))-1/90720.
    coneq[23523]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*dot(A,c**2))-1/181440.
    coneq[23524]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[23525]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*dot(A,c**2))-1/362880.
    coneq[23526]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/1088640.
    coneq[23527]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/2177280.
    coneq[23528]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/725760.
    coneq[23529]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*dot(A,c**2))-1/725760.
    coneq[23530]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/2177280.
    coneq[23531]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/4354560.
    coneq[23532]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/1451520.
    coneq[23533]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*dot(A,c**2))-1/302400.
    coneq[23534]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,c**2))-1/1209600.
    coneq[23535]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/3628800.
    coneq[23536]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/7257600.
    coneq[23537]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/2419200.
    coneq[23538]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/907200.
    coneq[23539]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/1814400.
    coneq[23540]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/604800.
    coneq[23541]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/1209600.
    coneq[23542]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*dot(A,c**2))-1/272160.
    coneq[23543]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c**2))-1/544320.
    coneq[23544]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c**2))-1/1088640.
    coneq[23545]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*dot(A,c**2))-1/241920.
    coneq[23546]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/725760.
    coneq[23547]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/1451520.
    coneq[23548]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/483840.
    coneq[23549]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/181440.
    coneq[23550]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/362880.
    coneq[23551]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[23552]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/362880.
    coneq[23553]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/725760.
    coneq[23554]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/241920.
    coneq[23555]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*dot(A,c**2))-1/26460.
    coneq[23556]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*dot(A,c**2))-1/158760.
    coneq[23557]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*dot(A,c**2))-1/793800.
    coneq[23558]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c**2))-1/3175200.
    coneq[23559]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**2))-1/9525600.
    coneq[23560]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**2))-1/19051200.
    coneq[23561]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**2))-1/6350400.
    coneq[23562]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c**2))-1/2381400.
    coneq[23563]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**2))-1/4762800.
    coneq[23564]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c**2))-1/1587600.
    coneq[23565]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**2))-1/3175200.
    coneq[23566]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c**2))-1/635040.
    coneq[23567]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1905120.
    coneq[23568]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/3810240.
    coneq[23569]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1270080.
    coneq[23570]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c**2))-1/476280.
    coneq[23571]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c**2))-1/952560.
    coneq[23572]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c**2))-1/317520.
    coneq[23573]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c**2))-1/952560.
    coneq[23574]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**2))-1/1905120.
    coneq[23575]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/635040.
    coneq[23576]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*dot(A,c**2))-1/132300.
    coneq[23577]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c**2))-1/529200.
    coneq[23578]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1587600.
    coneq[23579]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/3175200.
    coneq[23580]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1058400.
    coneq[23581]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/396900.
    coneq[23582]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/793800.
    coneq[23583]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/264600.
    coneq[23584]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/529200.
    coneq[23585]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*dot(A,c**2))-1/105840.
    coneq[23586]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/317520.
    coneq[23587]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/635040.
    coneq[23588]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/211680.
    coneq[23589]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*dot(A,c**2))-1/79380.
    coneq[23590]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c**2))-1/158760.
    coneq[23591]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*dot(A,c**2))-1/52920.
    coneq[23592]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c**2))-1/238140.
    coneq[23593]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c**2))-1/476280.
    coneq[23594]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c**2))-1/952560.
    coneq[23595]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c**2))-1/211680.
    coneq[23596]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/635040.
    coneq[23597]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/1270080.
    coneq[23598]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/423360.
    coneq[23599]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/158760.
    coneq[23600]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/317520.
    coneq[23601]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/105840.
    coneq[23602]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/211680.
    coneq[23603]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*dot(A,c**2))-1/22680.
    coneq[23604]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*dot(A,c**2))-1/113400.
    coneq[23605]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/453600.
    coneq[23606]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1360800.
    coneq[23607]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2721600.
    coneq[23608]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/907200.
    coneq[23609]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/340200.
    coneq[23610]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/680400.
    coneq[23611]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/226800.
    coneq[23612]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/453600.
    coneq[23613]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/90720.
    coneq[23614]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/272160.
    coneq[23615]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/544320.
    coneq[23616]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/181440.
    coneq[23617]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/68040.
    coneq[23618]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/136080.
    coneq[23619]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/45360.
    coneq[23620]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/136080.
    coneq[23621]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/272160.
    coneq[23622]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/90720.
    coneq[23623]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*dot(A,c**2))-1/18900.
    coneq[23624]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*dot(A,c**2))-1/75600.
    coneq[23625]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/226800.
    coneq[23626]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/453600.
    coneq[23627]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/151200.
    coneq[23628]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/56700.
    coneq[23629]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/113400.
    coneq[23630]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/37800.
    coneq[23631]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/75600.
    coneq[23632]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*dot(A,c**2))-1/15120.
    coneq[23633]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*dot(A,c**2))-1/45360.
    coneq[23634]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/90720.
    coneq[23635]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*dot(A,c**2))-1/30240.
    coneq[23636]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*dot(A,c**2))-1/11340.
    coneq[23637]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*dot(A,c**2))-1/22680.
    coneq[23638]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*dot(A,c**2))-1/7560.
    coneq[23639]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*dot(A,c**2))-1/60480.
    coneq[23640]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/181440.
    coneq[23641]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/362880.
    coneq[23642]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[23643]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*dot(A,c**2))-1/544320.
    coneq[23644]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/1088640.
    coneq[23645]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*dot(A,c**2))-1/362880.
    coneq[23646]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/2177280.
    coneq[23647]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*dot(A,c**2))-1/725760.
    coneq[23648]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c**2))-1/241920.
    coneq[23649]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*dot(A,c**2))-1/56700.
    coneq[23650]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*dot(A,c**2))-1/226800.
    coneq[23651]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/680400.
    coneq[23652]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/1360800.
    coneq[23653]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/453600.
    coneq[23654]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/170100.
    coneq[23655]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/340200.
    coneq[23656]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/113400.
    coneq[23657]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/226800.
    coneq[23658]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*dot(A,c**2))-1/113400.
    coneq[23659]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*dot(A,c**2))-1/453600.
    coneq[23660]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/1360800.
    coneq[23661]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/2721600.
    coneq[23662]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/907200.
    coneq[23663]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/340200.
    coneq[23664]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/680400.
    coneq[23665]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/226800.
    coneq[23666]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/453600.
    coneq[23667]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*dot(A,c**2))-1/45360.
    coneq[23668]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*dot(A,c**2))-1/226800.
    coneq[23669]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/907200.
    coneq[23670]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/2721600.
    coneq[23671]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/5443200.
    coneq[23672]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1814400.
    coneq[23673]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/680400.
    coneq[23674]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/1360800.
    coneq[23675]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/453600.
    coneq[23676]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/907200.
    coneq[23677]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/181440.
    coneq[23678]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/544320.
    coneq[23679]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/1088640.
    coneq[23680]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/362880.
    coneq[23681]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/136080.
    coneq[23682]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/272160.
    coneq[23683]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/90720.
    coneq[23684]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/272160.
    coneq[23685]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/544320.
    coneq[23686]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/181440.
    coneq[23687]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*dot(A,c**2))-1/45360.
    coneq[23688]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/136080.
    coneq[23689]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/272160.
    coneq[23690]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/90720.
    coneq[23691]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c**2))-1/90720.
    coneq[23692]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c**2))-1/272160.
    coneq[23693]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/544320.
    coneq[23694]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c**2))-1/181440.
    coneq[23695]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*dot(A,c**2))-1/37800.
    coneq[23696]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c**2))-1/151200.
    coneq[23697]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/453600.
    coneq[23698]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/907200.
    coneq[23699]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/302400.
    coneq[23700]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/113400.
    coneq[23701]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/226800.
    coneq[23702]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/75600.
    coneq[23703]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/151200.
    coneq[23704]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/34020.
    coneq[23705]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/68040.
    coneq[23706]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/136080.
    coneq[23707]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/30240.
    coneq[23708]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/90720.
    coneq[23709]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/181440.
    coneq[23710]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[23711]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/22680.
    coneq[23712]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/45360.
    coneq[23713]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/15120.
    coneq[23714]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/60480.
    coneq[23715]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/181440.
    coneq[23716]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/362880.
    coneq[23717]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[23718]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/68040.
    coneq[23719]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/136080.
    coneq[23720]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/272160.
    coneq[23721]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/45360.
    coneq[23722]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/90720.
    coneq[23723]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/30240.
    coneq[23724]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/60480.
    coneq[23725]=dot(b,dot(A,c*dot(A,c**7))*dot(A,c**2))-1/3360.
    coneq[23726]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*dot(A,c**2))-1/23520.
    coneq[23727]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*dot(A,c**2))-1/141120.
    coneq[23728]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c**2))-1/705600.
    coneq[23729]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c**2))-1/2822400.
    coneq[23730]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**2))-1/8467200.
    coneq[23731]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**2))-1/16934400.
    coneq[23732]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**2))-1/5644800.
    coneq[23733]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c**2))-1/2116800.
    coneq[23734]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**2))-1/4233600.
    coneq[23735]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c**2))-1/1411200.
    coneq[23736]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**2))-1/2822400.
    coneq[23737]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c**2))-1/564480.
    coneq[23738]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1693440.
    coneq[23739]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/3386880.
    coneq[23740]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1128960.
    coneq[23741]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c**2))-1/423360.
    coneq[23742]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c**2))-1/846720.
    coneq[23743]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c**2))-1/282240.
    coneq[23744]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c**2))-1/846720.
    coneq[23745]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**2))-1/1693440.
    coneq[23746]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/564480.
    coneq[23747]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*dot(A,c**2))-1/117600.
    coneq[23748]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c**2))-1/470400.
    coneq[23749]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1411200.
    coneq[23750]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2822400.
    coneq[23751]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/940800.
    coneq[23752]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/352800.
    coneq[23753]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/705600.
    coneq[23754]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/235200.
    coneq[23755]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/470400.
    coneq[23756]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c**2))-1/94080.
    coneq[23757]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/282240.
    coneq[23758]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/564480.
    coneq[23759]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/188160.
    coneq[23760]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c**2))-1/70560.
    coneq[23761]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c**2))-1/141120.
    coneq[23762]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*dot(A,c**2))-1/47040.
    coneq[23763]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c**2))-1/211680.
    coneq[23764]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c**2))-1/423360.
    coneq[23765]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c**2))-1/846720.
    coneq[23766]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c**2))-1/188160.
    coneq[23767]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/564480.
    coneq[23768]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/1128960.
    coneq[23769]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/376320.
    coneq[23770]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/141120.
    coneq[23771]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/282240.
    coneq[23772]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/94080.
    coneq[23773]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/188160.
    coneq[23774]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*dot(A,c**2))-1/20160.
    coneq[23775]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*dot(A,c**2))-1/100800.
    coneq[23776]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/403200.
    coneq[23777]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1209600.
    coneq[23778]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2419200.
    coneq[23779]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/806400.
    coneq[23780]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/302400.
    coneq[23781]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/604800.
    coneq[23782]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/201600.
    coneq[23783]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/403200.
    coneq[23784]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/80640.
    coneq[23785]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/241920.
    coneq[23786]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/483840.
    coneq[23787]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/161280.
    coneq[23788]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/60480.
    coneq[23789]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/120960.
    coneq[23790]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/40320.
    coneq[23791]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/120960.
    coneq[23792]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/241920.
    coneq[23793]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/80640.
    coneq[23794]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*dot(A,c**2))-1/16800.
    coneq[23795]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c**2))-1/67200.
    coneq[23796]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/201600.
    coneq[23797]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/403200.
    coneq[23798]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/134400.
    coneq[23799]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/50400.
    coneq[23800]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/100800.
    coneq[23801]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/33600.
    coneq[23802]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/67200.
    coneq[23803]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*dot(A,c**2))-1/13440.
    coneq[23804]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c**2))-1/40320.
    coneq[23805]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/80640.
    coneq[23806]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c**2))-1/26880.
    coneq[23807]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*dot(A,c**2))-1/10080.
    coneq[23808]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*dot(A,c**2))-1/20160.
    coneq[23809]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*dot(A,c**2))-1/6720.
    coneq[23810]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c**2))-1/40320.
    coneq[23811]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/120960.
    coneq[23812]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/241920.
    coneq[23813]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/80640.
    coneq[23814]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c**2))-1/80640.
    coneq[23815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c**2))-1/241920.
    coneq[23816]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/483840.
    coneq[23817]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c**2))-1/161280.
    coneq[23818]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c**2))-1/33600.
    coneq[23819]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c**2))-1/134400.
    coneq[23820]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/403200.
    coneq[23821]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/806400.
    coneq[23822]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/268800.
    coneq[23823]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/100800.
    coneq[23824]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/201600.
    coneq[23825]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/67200.
    coneq[23826]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/134400.
    coneq[23827]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/30240.
    coneq[23828]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[23829]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[23830]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/26880.
    coneq[23831]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/80640.
    coneq[23832]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/161280.
    coneq[23833]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/53760.
    coneq[23834]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/20160.
    coneq[23835]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/40320.
    coneq[23836]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/13440.
    coneq[23837]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/40320.
    coneq[23838]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/80640.
    coneq[23839]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/26880.
    coneq[23840]=dot(b,dot(A,c**2*dot(A,c**6))*dot(A,c**2))-1/2940.
    coneq[23841]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*dot(A,c**2))-1/17640.
    coneq[23842]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*dot(A,c**2))-1/88200.
    coneq[23843]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/352800.
    coneq[23844]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/1058400.
    coneq[23845]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/2116800.
    coneq[23846]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/705600.
    coneq[23847]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/264600.
    coneq[23848]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/529200.
    coneq[23849]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/176400.
    coneq[23850]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/352800.
    coneq[23851]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/70560.
    coneq[23852]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/211680.
    coneq[23853]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/423360.
    coneq[23854]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/141120.
    coneq[23855]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/52920.
    coneq[23856]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/105840.
    coneq[23857]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/35280.
    coneq[23858]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/105840.
    coneq[23859]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/211680.
    coneq[23860]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/70560.
    coneq[23861]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*dot(A,c**2))-1/14700.
    coneq[23862]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2))-1/58800.
    coneq[23863]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/176400.
    coneq[23864]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/352800.
    coneq[23865]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/117600.
    coneq[23866]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/44100.
    coneq[23867]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/88200.
    coneq[23868]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/29400.
    coneq[23869]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/58800.
    coneq[23870]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*dot(A,c**2))-1/11760.
    coneq[23871]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2))-1/35280.
    coneq[23872]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/70560.
    coneq[23873]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2))-1/23520.
    coneq[23874]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*dot(A,c**2))-1/8820.
    coneq[23875]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2))-1/17640.
    coneq[23876]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*dot(A,c**2))-1/5880.
    coneq[23877]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/26460.
    coneq[23878]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/52920.
    coneq[23879]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/105840.
    coneq[23880]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/23520.
    coneq[23881]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/70560.
    coneq[23882]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/141120.
    coneq[23883]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/47040.
    coneq[23884]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/17640.
    coneq[23885]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/35280.
    coneq[23886]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/11760.
    coneq[23887]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/23520.
    coneq[23888]=dot(b,dot(A,c**3*dot(A,c**5))*dot(A,c**2))-1/2520.
    coneq[23889]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*dot(A,c**2))-1/12600.
    coneq[23890]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/50400.
    coneq[23891]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/151200.
    coneq[23892]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/302400.
    coneq[23893]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/100800.
    coneq[23894]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/37800.
    coneq[23895]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/75600.
    coneq[23896]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/25200.
    coneq[23897]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/50400.
    coneq[23898]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/10080.
    coneq[23899]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/30240.
    coneq[23900]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/60480.
    coneq[23901]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/20160.
    coneq[23902]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/7560.
    coneq[23903]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/15120.
    coneq[23904]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/5040.
    coneq[23905]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/15120.
    coneq[23906]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/30240.
    coneq[23907]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/10080.
    coneq[23908]=dot(b,dot(A,c**4*dot(A,c**4))*dot(A,c**2))-1/2100.
    coneq[23909]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*dot(A,c**2))-1/8400.
    coneq[23910]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/25200.
    coneq[23911]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/50400.
    coneq[23912]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/16800.
    coneq[23913]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/6300.
    coneq[23914]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/12600.
    coneq[23915]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/4200.
    coneq[23916]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/8400.
    coneq[23917]=dot(b,dot(A,c**5*dot(A,c**3))*dot(A,c**2))-1/1680.
    coneq[23918]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*dot(A,c**2))-1/5040.
    coneq[23919]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/10080.
    coneq[23920]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*dot(A,c**2))-1/3360.
    coneq[23921]=dot(b,dot(A,c**6*dot(A,c**2))*dot(A,c**2))-1/1260.
    coneq[23922]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*dot(A,c**2))-1/2520.
    coneq[23923]=dot(b,dot(A,c**7*dot(A,c))*dot(A,c**2))-1/840.
    coneq[23924]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*dot(A,c**2))-1/8400.
    coneq[23925]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/33600.
    coneq[23926]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/100800.
    coneq[23927]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/201600.
    coneq[23928]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/67200.
    coneq[23929]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/25200.
    coneq[23930]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/50400.
    coneq[23931]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/16800.
    coneq[23932]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/33600.
    coneq[23933]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*dot(A,c**2))-1/25200.
    coneq[23934]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*dot(A,c**2))-1/100800.
    coneq[23935]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/302400.
    coneq[23936]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/604800.
    coneq[23937]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/201600.
    coneq[23938]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/75600.
    coneq[23939]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/151200.
    coneq[23940]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/50400.
    coneq[23941]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/100800.
    coneq[23942]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*dot(A,c**2))-1/50400.
    coneq[23943]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*dot(A,c**2))-1/201600.
    coneq[23944]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/604800.
    coneq[23945]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/1209600.
    coneq[23946]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/403200.
    coneq[23947]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/151200.
    coneq[23948]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/302400.
    coneq[23949]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/100800.
    coneq[23950]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/201600.
    coneq[23951]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*dot(A,c**2))-1/16800.
    coneq[23952]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c**2))-1/67200.
    coneq[23953]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/201600.
    coneq[23954]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/403200.
    coneq[23955]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/134400.
    coneq[23956]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/50400.
    coneq[23957]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/100800.
    coneq[23958]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/33600.
    coneq[23959]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/67200.
    coneq[23960]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*dot(A,c**2))-1/7560.
    coneq[23961]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*dot(A,c**2))-1/37800.
    coneq[23962]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/151200.
    coneq[23963]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/453600.
    coneq[23964]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/907200.
    coneq[23965]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/302400.
    coneq[23966]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/113400.
    coneq[23967]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/226800.
    coneq[23968]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/75600.
    coneq[23969]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/151200.
    coneq[23970]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/30240.
    coneq[23971]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/90720.
    coneq[23972]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/181440.
    coneq[23973]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[23974]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/22680.
    coneq[23975]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/45360.
    coneq[23976]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/15120.
    coneq[23977]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/45360.
    coneq[23978]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/90720.
    coneq[23979]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/30240.
    coneq[23980]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*dot(A,c**2))-1/15120.
    coneq[23981]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*dot(A,c**2))-1/75600.
    coneq[23982]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/302400.
    coneq[23983]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/907200.
    coneq[23984]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/1814400.
    coneq[23985]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/604800.
    coneq[23986]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/226800.
    coneq[23987]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/453600.
    coneq[23988]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/151200.
    coneq[23989]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/302400.
    coneq[23990]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/60480.
    coneq[23991]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/181440.
    coneq[23992]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/362880.
    coneq[23993]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[23994]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/45360.
    coneq[23995]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/90720.
    coneq[23996]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/30240.
    coneq[23997]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/90720.
    coneq[23998]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/181440.
    coneq[23999]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/60480.
    coneq[24000]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*dot(A,c**2))-1/5880.
    coneq[24001]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*dot(A,c**2))-1/35280.
    coneq[24002]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*dot(A,c**2))-1/176400.
    coneq[24003]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2))-1/705600.
    coneq[24004]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2))-1/2116800.
    coneq[24005]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2))-1/4233600.
    coneq[24006]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2))-1/1411200.
    coneq[24007]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2))-1/529200.
    coneq[24008]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2))-1/1058400.
    coneq[24009]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2))-1/352800.
    coneq[24010]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2))-1/705600.
    coneq[24011]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2))-1/141120.
    coneq[24012]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2))-1/423360.
    coneq[24013]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/846720.
    coneq[24014]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2))-1/282240.
    coneq[24015]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2))-1/105840.
    coneq[24016]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2))-1/211680.
    coneq[24017]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2))-1/70560.
    coneq[24018]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2))-1/211680.
    coneq[24019]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2))-1/423360.
    coneq[24020]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2))-1/141120.
    coneq[24021]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*dot(A,c**2))-1/29400.
    coneq[24022]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2))-1/117600.
    coneq[24023]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/352800.
    coneq[24024]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/705600.
    coneq[24025]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/235200.
    coneq[24026]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/88200.
    coneq[24027]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/176400.
    coneq[24028]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/58800.
    coneq[24029]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/117600.
    coneq[24030]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*dot(A,c**2))-1/23520.
    coneq[24031]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2))-1/70560.
    coneq[24032]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/141120.
    coneq[24033]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2))-1/47040.
    coneq[24034]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*dot(A,c**2))-1/17640.
    coneq[24035]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2))-1/35280.
    coneq[24036]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*dot(A,c**2))-1/11760.
    coneq[24037]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2))-1/52920.
    coneq[24038]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2))-1/105840.
    coneq[24039]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2))-1/211680.
    coneq[24040]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2))-1/47040.
    coneq[24041]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2))-1/141120.
    coneq[24042]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/282240.
    coneq[24043]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2))-1/94080.
    coneq[24044]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/35280.
    coneq[24045]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/70560.
    coneq[24046]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/23520.
    coneq[24047]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/47040.
    coneq[24048]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*dot(A,c**2))-1/6720.
    coneq[24049]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/20160.
    coneq[24050]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/40320.
    coneq[24051]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/13440.
    coneq[24052]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c**2))-1/60480.
    coneq[24053]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[24054]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/40320.
    coneq[24055]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/241920.
    coneq[24056]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/80640.
    coneq[24057]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/26880.
    coneq[24058]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*dot(A,c**2))-1/6300.
    coneq[24059]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/25200.
    coneq[24060]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/75600.
    coneq[24061]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/151200.
    coneq[24062]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/50400.
    coneq[24063]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/18900.
    coneq[24064]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/37800.
    coneq[24065]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/12600.
    coneq[24066]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/25200.
    coneq[24067]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*dot(A,c**2))-1/12600.
    coneq[24068]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c**2))-1/50400.
    coneq[24069]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/151200.
    coneq[24070]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/302400.
    coneq[24071]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/100800.
    coneq[24072]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/37800.
    coneq[24073]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/75600.
    coneq[24074]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/25200.
    coneq[24075]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/50400.
    coneq[24076]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*dot(A,c**2))-1/5040.
    coneq[24077]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c**2))-1/25200.
    coneq[24078]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2))-1/100800.
    coneq[24079]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2))-1/302400.
    coneq[24080]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2))-1/604800.
    coneq[24081]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2))-1/201600.
    coneq[24082]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2))-1/75600.
    coneq[24083]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2))-1/151200.
    coneq[24084]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2))-1/50400.
    coneq[24085]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2))-1/100800.
    coneq[24086]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c**2))-1/20160.
    coneq[24087]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2))-1/60480.
    coneq[24088]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/120960.
    coneq[24089]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2))-1/40320.
    coneq[24090]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c**2))-1/15120.
    coneq[24091]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2))-1/30240.
    coneq[24092]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c**2))-1/10080.
    coneq[24093]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2))-1/30240.
    coneq[24094]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[24095]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2))-1/20160.
    coneq[24096]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*dot(A,c**2))-1/5040.
    coneq[24097]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/15120.
    coneq[24098]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/30240.
    coneq[24099]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/10080.
    coneq[24100]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2))-1/10080.
    coneq[24101]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2))-1/30240.
    coneq[24102]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[24103]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/20160.
    coneq[24104]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*dot(A,c**2))-1/4200.
    coneq[24105]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/16800.
    coneq[24106]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/50400.
    coneq[24107]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/100800.
    coneq[24108]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/33600.
    coneq[24109]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/12600.
    coneq[24110]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/25200.
    coneq[24111]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/8400.
    coneq[24112]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/16800.
    coneq[24113]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/3780.
    coneq[24114]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/7560.
    coneq[24115]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/15120.
    coneq[24116]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*dot(A,c**2))-1/3360.
    coneq[24117]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/10080.
    coneq[24118]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/20160.
    coneq[24119]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/6720.
    coneq[24120]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/2520.
    coneq[24121]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/5040.
    coneq[24122]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*dot(A,c**2))-1/1680.
    coneq[24123]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*dot(A,c**2))-1/8400.
    coneq[24124]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2))-1/33600.
    coneq[24125]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2))-1/100800.
    coneq[24126]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2))-1/201600.
    coneq[24127]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2))-1/67200.
    coneq[24128]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2))-1/25200.
    coneq[24129]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2))-1/50400.
    coneq[24130]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2))-1/16800.
    coneq[24131]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2))-1/33600.
    coneq[24132]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*dot(A,c**2))-1/10080.
    coneq[24133]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/30240.
    coneq[24134]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/60480.
    coneq[24135]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/20160.
    coneq[24136]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2))-1/20160.
    coneq[24137]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2))-1/60480.
    coneq[24138]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/120960.
    coneq[24139]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2))-1/40320.
    coneq[24140]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/11340.
    coneq[24141]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/22680.
    coneq[24142]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/45360.
    coneq[24143]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/90720.
    coneq[24144]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c**2))-1/6720.
    coneq[24145]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2))-1/20160.
    coneq[24146]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/40320.
    coneq[24147]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2))-1/13440.
    coneq[24148]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c**2))-1/7560.
    coneq[24149]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2))-1/15120.
    coneq[24150]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2))-1/30240.
    coneq[24151]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/5040.
    coneq[24152]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/10080.
    coneq[24153]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2))-1/3360.
    coneq[24154]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2))-1/10080.
    coneq[24155]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2))-1/20160.
    coneq[24156]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2))-1/6720.
    coneq[24157]=dot(b,dot(A,c**9)*dot(A,dot(A,c)))-1/840.
    coneq[24158]=dot(b,dot(A,dot(A,c**8))*dot(A,dot(A,c)))-1/7560.
    coneq[24159]=dot(b,dot(A,dot(A,dot(A,c**7)))*dot(A,dot(A,c)))-1/60480.
    coneq[24160]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*dot(A,dot(A,c)))-1/423360.
    coneq[24161]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*dot(A,dot(A,c)))-1/2540160.
    coneq[24162]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*dot(A,dot(A,c)))-1/12700800.
    coneq[24163]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,dot(A,c)))-1/50803200.
    coneq[24164]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,dot(A,c)))-1/152409600.
    coneq[24165]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,dot(A,c)))-1/304819200.
    coneq[24166]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,dot(A,c)))-1/101606400.
    coneq[24167]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,dot(A,c)))-1/38102400.
    coneq[24168]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/76204800.
    coneq[24169]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,dot(A,c)))-1/25401600.
    coneq[24170]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,dot(A,c)))-1/50803200.
    coneq[24171]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*dot(A,dot(A,c)))-1/10160640.
    coneq[24172]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,dot(A,c)))-1/30481920.
    coneq[24173]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/60963840.
    coneq[24174]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,dot(A,c)))-1/20321280.
    coneq[24175]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,dot(A,c)))-1/7620480.
    coneq[24176]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/15240960.
    coneq[24177]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*dot(A,dot(A,c)))-1/5080320.
    coneq[24178]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,dot(A,c)))-1/15240960.
    coneq[24179]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/30481920.
    coneq[24180]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,dot(A,c)))-1/10160640.
    coneq[24181]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*dot(A,dot(A,c)))-1/2116800.
    coneq[24182]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*dot(A,dot(A,c)))-1/8467200.
    coneq[24183]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c)))-1/25401600.
    coneq[24184]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/50803200.
    coneq[24185]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c)))-1/16934400.
    coneq[24186]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c)))-1/6350400.
    coneq[24187]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/12700800.
    coneq[24188]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c)))-1/4233600.
    coneq[24189]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c)))-1/8467200.
    coneq[24190]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*dot(A,dot(A,c)))-1/1693440.
    coneq[24191]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/5080320.
    coneq[24192]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/10160640.
    coneq[24193]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/3386880.
    coneq[24194]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1270080.
    coneq[24195]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2540160.
    coneq[24196]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*dot(A,dot(A,c)))-1/846720.
    coneq[24197]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,dot(A,c)))-1/3810240.
    coneq[24198]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/7620480.
    coneq[24199]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/15240960.
    coneq[24200]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,dot(A,c)))-1/3386880.
    coneq[24201]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/10160640.
    coneq[24202]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/20321280.
    coneq[24203]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/6773760.
    coneq[24204]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c)))-1/2540160.
    coneq[24205]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/5080320.
    coneq[24206]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1693440.
    coneq[24207]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/3386880.
    coneq[24208]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*dot(A,dot(A,c)))-1/362880.
    coneq[24209]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24210]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,c)))-1/7257600.
    coneq[24211]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c)))-1/21772800.
    coneq[24212]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/43545600.
    coneq[24213]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c)))-1/14515200.
    coneq[24214]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c)))-1/5443200.
    coneq[24215]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/10886400.
    coneq[24216]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c)))-1/3628800.
    coneq[24217]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c)))-1/7257600.
    coneq[24218]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24219]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/4354560.
    coneq[24220]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/8709120.
    coneq[24221]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/2903040.
    coneq[24222]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24223]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2177280.
    coneq[24224]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24225]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c)))-1/2177280.
    coneq[24226]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/4354560.
    coneq[24227]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24228]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*dot(A,dot(A,c)))-1/302400.
    coneq[24229]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24230]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/3628800.
    coneq[24231]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/7257600.
    coneq[24232]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/2419200.
    coneq[24233]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24234]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24235]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/604800.
    coneq[24236]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24237]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*dot(A,dot(A,c)))-1/241920.
    coneq[24238]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24239]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24240]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/483840.
    coneq[24241]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*dot(A,dot(A,c)))-1/181440.
    coneq[24242]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/362880.
    coneq[24243]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24244]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*dot(A,dot(A,c)))-1/725760.
    coneq[24245]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/2177280.
    coneq[24246]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/4354560.
    coneq[24247]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24248]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24249]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/4354560.
    coneq[24250]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/8709120.
    coneq[24251]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/2903040.
    coneq[24252]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*dot(A,dot(A,c)))-1/604800.
    coneq[24253]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/2419200.
    coneq[24254]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/7257600.
    coneq[24255]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/14515200.
    coneq[24256]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/4838400.
    coneq[24257]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24258]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/3628800.
    coneq[24259]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24260]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/2419200.
    coneq[24261]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,c)))-1/544320.
    coneq[24262]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24263]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/2177280.
    coneq[24264]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*dot(A,dot(A,c)))-1/483840.
    coneq[24265]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24266]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2903040.
    coneq[24267]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/967680.
    coneq[24268]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/362880.
    coneq[24269]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24270]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24271]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/725760.
    coneq[24272]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24273]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/483840.
    coneq[24274]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*dot(A,dot(A,c)))-1/52920.
    coneq[24275]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*dot(A,dot(A,c)))-1/317520.
    coneq[24276]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*dot(A,dot(A,c)))-1/1587600.
    coneq[24277]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,c)))-1/6350400.
    coneq[24278]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c)))-1/19051200.
    coneq[24279]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/38102400.
    coneq[24280]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c)))-1/12700800.
    coneq[24281]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c)))-1/4762800.
    coneq[24282]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/9525600.
    coneq[24283]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c)))-1/3175200.
    coneq[24284]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c)))-1/6350400.
    coneq[24285]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,dot(A,c)))-1/1270080.
    coneq[24286]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/3810240.
    coneq[24287]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/7620480.
    coneq[24288]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/2540160.
    coneq[24289]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,c)))-1/952560.
    coneq[24290]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1905120.
    coneq[24291]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,dot(A,c)))-1/635040.
    coneq[24292]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1905120.
    coneq[24293]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/3810240.
    coneq[24294]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1270080.
    coneq[24295]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*dot(A,dot(A,c)))-1/264600.
    coneq[24296]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/1058400.
    coneq[24297]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/3175200.
    coneq[24298]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/6350400.
    coneq[24299]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/2116800.
    coneq[24300]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/793800.
    coneq[24301]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1587600.
    coneq[24302]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/529200.
    coneq[24303]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1058400.
    coneq[24304]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*dot(A,dot(A,c)))-1/211680.
    coneq[24305]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/635040.
    coneq[24306]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1270080.
    coneq[24307]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/423360.
    coneq[24308]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*dot(A,dot(A,c)))-1/158760.
    coneq[24309]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/317520.
    coneq[24310]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*dot(A,dot(A,c)))-1/105840.
    coneq[24311]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,c)))-1/476280.
    coneq[24312]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/952560.
    coneq[24313]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1905120.
    coneq[24314]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,dot(A,c)))-1/423360.
    coneq[24315]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/1270080.
    coneq[24316]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2540160.
    coneq[24317]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/846720.
    coneq[24318]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/317520.
    coneq[24319]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/635040.
    coneq[24320]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/211680.
    coneq[24321]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/423360.
    coneq[24322]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*dot(A,dot(A,c)))-1/45360.
    coneq[24323]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/226800.
    coneq[24324]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24325]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2721600.
    coneq[24326]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/5443200.
    coneq[24327]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24328]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/680400.
    coneq[24329]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1360800.
    coneq[24330]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/453600.
    coneq[24331]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24332]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/181440.
    coneq[24333]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/544320.
    coneq[24334]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24335]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/362880.
    coneq[24336]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/136080.
    coneq[24337]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/272160.
    coneq[24338]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/90720.
    coneq[24339]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/272160.
    coneq[24340]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/544320.
    coneq[24341]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/181440.
    coneq[24342]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*dot(A,dot(A,c)))-1/37800.
    coneq[24343]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/151200.
    coneq[24344]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/453600.
    coneq[24345]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/907200.
    coneq[24346]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/302400.
    coneq[24347]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/113400.
    coneq[24348]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/226800.
    coneq[24349]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/75600.
    coneq[24350]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/151200.
    coneq[24351]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*dot(A,dot(A,c)))-1/30240.
    coneq[24352]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/90720.
    coneq[24353]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/181440.
    coneq[24354]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/60480.
    coneq[24355]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*dot(A,dot(A,c)))-1/22680.
    coneq[24356]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/45360.
    coneq[24357]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*dot(A,dot(A,c)))-1/15120.
    coneq[24358]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*dot(A,dot(A,c)))-1/120960.
    coneq[24359]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/362880.
    coneq[24360]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24361]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24362]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24363]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/2177280.
    coneq[24364]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/725760.
    coneq[24365]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/4354560.
    coneq[24366]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/1451520.
    coneq[24367]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/483840.
    coneq[24368]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*dot(A,dot(A,c)))-1/113400.
    coneq[24369]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/453600.
    coneq[24370]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/1360800.
    coneq[24371]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2721600.
    coneq[24372]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24373]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/340200.
    coneq[24374]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/680400.
    coneq[24375]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/226800.
    coneq[24376]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/453600.
    coneq[24377]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*dot(A,dot(A,c)))-1/226800.
    coneq[24378]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/907200.
    coneq[24379]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/2721600.
    coneq[24380]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/5443200.
    coneq[24381]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24382]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/680400.
    coneq[24383]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1360800.
    coneq[24384]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/453600.
    coneq[24385]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/907200.
    coneq[24386]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*dot(A,dot(A,c)))-1/90720.
    coneq[24387]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/453600.
    coneq[24388]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24389]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/5443200.
    coneq[24390]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/10886400.
    coneq[24391]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/3628800.
    coneq[24392]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1360800.
    coneq[24393]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2721600.
    coneq[24394]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24395]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24396]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/362880.
    coneq[24397]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24398]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2177280.
    coneq[24399]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24400]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/272160.
    coneq[24401]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/544320.
    coneq[24402]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/181440.
    coneq[24403]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/544320.
    coneq[24404]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24405]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/362880.
    coneq[24406]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*dot(A,dot(A,c)))-1/90720.
    coneq[24407]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/272160.
    coneq[24408]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/544320.
    coneq[24409]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/181440.
    coneq[24410]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,dot(A,c)))-1/181440.
    coneq[24411]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/544320.
    coneq[24412]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1088640.
    coneq[24413]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/362880.
    coneq[24414]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*dot(A,dot(A,c)))-1/75600.
    coneq[24415]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/302400.
    coneq[24416]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24417]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24418]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/604800.
    coneq[24419]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/226800.
    coneq[24420]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/453600.
    coneq[24421]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/151200.
    coneq[24422]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/302400.
    coneq[24423]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/68040.
    coneq[24424]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/136080.
    coneq[24425]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/272160.
    coneq[24426]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/60480.
    coneq[24427]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/181440.
    coneq[24428]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/362880.
    coneq[24429]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24430]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/45360.
    coneq[24431]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/90720.
    coneq[24432]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/30240.
    coneq[24433]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/120960.
    coneq[24434]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/362880.
    coneq[24435]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24436]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24437]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/136080.
    coneq[24438]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/272160.
    coneq[24439]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/544320.
    coneq[24440]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/90720.
    coneq[24441]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/181440.
    coneq[24442]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/60480.
    coneq[24443]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/120960.
    coneq[24444]=dot(b,dot(A,c*dot(A,c**7))*dot(A,dot(A,c)))-1/6720.
    coneq[24445]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*dot(A,dot(A,c)))-1/47040.
    coneq[24446]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*dot(A,dot(A,c)))-1/282240.
    coneq[24447]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,dot(A,c)))-1/1411200.
    coneq[24448]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,c)))-1/5644800.
    coneq[24449]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c)))-1/16934400.
    coneq[24450]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c)))-1/33868800.
    coneq[24451]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c)))-1/11289600.
    coneq[24452]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c)))-1/4233600.
    coneq[24453]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/8467200.
    coneq[24454]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c)))-1/2822400.
    coneq[24455]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c)))-1/5644800.
    coneq[24456]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,dot(A,c)))-1/1128960.
    coneq[24457]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/3386880.
    coneq[24458]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/6773760.
    coneq[24459]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/2257920.
    coneq[24460]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,c)))-1/846720.
    coneq[24461]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1693440.
    coneq[24462]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,dot(A,c)))-1/564480.
    coneq[24463]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1693440.
    coneq[24464]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/3386880.
    coneq[24465]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1128960.
    coneq[24466]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*dot(A,dot(A,c)))-1/235200.
    coneq[24467]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/940800.
    coneq[24468]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2822400.
    coneq[24469]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/5644800.
    coneq[24470]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1881600.
    coneq[24471]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/705600.
    coneq[24472]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1411200.
    coneq[24473]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/470400.
    coneq[24474]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/940800.
    coneq[24475]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,dot(A,c)))-1/188160.
    coneq[24476]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/564480.
    coneq[24477]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1128960.
    coneq[24478]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/376320.
    coneq[24479]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,dot(A,c)))-1/141120.
    coneq[24480]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/282240.
    coneq[24481]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*dot(A,dot(A,c)))-1/94080.
    coneq[24482]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,c)))-1/423360.
    coneq[24483]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/846720.
    coneq[24484]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1693440.
    coneq[24485]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,dot(A,c)))-1/376320.
    coneq[24486]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/1128960.
    coneq[24487]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2257920.
    coneq[24488]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/752640.
    coneq[24489]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/282240.
    coneq[24490]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/564480.
    coneq[24491]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/188160.
    coneq[24492]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/376320.
    coneq[24493]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*dot(A,dot(A,c)))-1/40320.
    coneq[24494]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/201600.
    coneq[24495]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/806400.
    coneq[24496]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2419200.
    coneq[24497]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/4838400.
    coneq[24498]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1612800.
    coneq[24499]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/604800.
    coneq[24500]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24501]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/403200.
    coneq[24502]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/806400.
    coneq[24503]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/161280.
    coneq[24504]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/483840.
    coneq[24505]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/967680.
    coneq[24506]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/322560.
    coneq[24507]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/120960.
    coneq[24508]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/241920.
    coneq[24509]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/80640.
    coneq[24510]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/241920.
    coneq[24511]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/483840.
    coneq[24512]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/161280.
    coneq[24513]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*dot(A,dot(A,c)))-1/33600.
    coneq[24514]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/134400.
    coneq[24515]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/403200.
    coneq[24516]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/806400.
    coneq[24517]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/268800.
    coneq[24518]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/100800.
    coneq[24519]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/201600.
    coneq[24520]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/67200.
    coneq[24521]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/134400.
    coneq[24522]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*dot(A,dot(A,c)))-1/26880.
    coneq[24523]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/80640.
    coneq[24524]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/161280.
    coneq[24525]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/53760.
    coneq[24526]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*dot(A,dot(A,c)))-1/20160.
    coneq[24527]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/40320.
    coneq[24528]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*dot(A,dot(A,c)))-1/13440.
    coneq[24529]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,dot(A,c)))-1/80640.
    coneq[24530]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/241920.
    coneq[24531]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/483840.
    coneq[24532]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/161280.
    coneq[24533]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,dot(A,c)))-1/161280.
    coneq[24534]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/483840.
    coneq[24535]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/967680.
    coneq[24536]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/322560.
    coneq[24537]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*dot(A,dot(A,c)))-1/67200.
    coneq[24538]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/268800.
    coneq[24539]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/806400.
    coneq[24540]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1612800.
    coneq[24541]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/537600.
    coneq[24542]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/201600.
    coneq[24543]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/403200.
    coneq[24544]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/134400.
    coneq[24545]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/268800.
    coneq[24546]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/60480.
    coneq[24547]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24548]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24549]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/53760.
    coneq[24550]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/161280.
    coneq[24551]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/322560.
    coneq[24552]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/107520.
    coneq[24553]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/40320.
    coneq[24554]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/80640.
    coneq[24555]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/26880.
    coneq[24556]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/80640.
    coneq[24557]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/161280.
    coneq[24558]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/53760.
    coneq[24559]=dot(b,dot(A,c**2*dot(A,c**6))*dot(A,dot(A,c)))-1/5880.
    coneq[24560]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*dot(A,dot(A,c)))-1/35280.
    coneq[24561]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/176400.
    coneq[24562]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/705600.
    coneq[24563]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/2116800.
    coneq[24564]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/4233600.
    coneq[24565]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/1411200.
    coneq[24566]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/529200.
    coneq[24567]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1058400.
    coneq[24568]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/352800.
    coneq[24569]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/705600.
    coneq[24570]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/141120.
    coneq[24571]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/423360.
    coneq[24572]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/846720.
    coneq[24573]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/282240.
    coneq[24574]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/105840.
    coneq[24575]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/211680.
    coneq[24576]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/70560.
    coneq[24577]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/211680.
    coneq[24578]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/423360.
    coneq[24579]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/141120.
    coneq[24580]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*dot(A,dot(A,c)))-1/29400.
    coneq[24581]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/117600.
    coneq[24582]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/352800.
    coneq[24583]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/705600.
    coneq[24584]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/235200.
    coneq[24585]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/88200.
    coneq[24586]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/176400.
    coneq[24587]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/58800.
    coneq[24588]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/117600.
    coneq[24589]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c)))-1/23520.
    coneq[24590]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/70560.
    coneq[24591]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/141120.
    coneq[24592]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/47040.
    coneq[24593]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c)))-1/17640.
    coneq[24594]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/35280.
    coneq[24595]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*dot(A,dot(A,c)))-1/11760.
    coneq[24596]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/52920.
    coneq[24597]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/105840.
    coneq[24598]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/211680.
    coneq[24599]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/47040.
    coneq[24600]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/141120.
    coneq[24601]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/282240.
    coneq[24602]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/94080.
    coneq[24603]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/35280.
    coneq[24604]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/70560.
    coneq[24605]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/23520.
    coneq[24606]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/47040.
    coneq[24607]=dot(b,dot(A,c**3*dot(A,c**5))*dot(A,dot(A,c)))-1/5040.
    coneq[24608]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/25200.
    coneq[24609]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/100800.
    coneq[24610]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/302400.
    coneq[24611]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/604800.
    coneq[24612]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/201600.
    coneq[24613]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/75600.
    coneq[24614]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/151200.
    coneq[24615]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/50400.
    coneq[24616]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/100800.
    coneq[24617]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/20160.
    coneq[24618]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/60480.
    coneq[24619]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/120960.
    coneq[24620]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/40320.
    coneq[24621]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/15120.
    coneq[24622]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/30240.
    coneq[24623]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/10080.
    coneq[24624]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/30240.
    coneq[24625]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/60480.
    coneq[24626]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/20160.
    coneq[24627]=dot(b,dot(A,c**4*dot(A,c**4))*dot(A,dot(A,c)))-1/4200.
    coneq[24628]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/16800.
    coneq[24629]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/50400.
    coneq[24630]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/100800.
    coneq[24631]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/33600.
    coneq[24632]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/12600.
    coneq[24633]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/25200.
    coneq[24634]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/8400.
    coneq[24635]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/16800.
    coneq[24636]=dot(b,dot(A,c**5*dot(A,c**3))*dot(A,dot(A,c)))-1/3360.
    coneq[24637]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/10080.
    coneq[24638]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/20160.
    coneq[24639]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/6720.
    coneq[24640]=dot(b,dot(A,c**6*dot(A,c**2))*dot(A,dot(A,c)))-1/2520.
    coneq[24641]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/5040.
    coneq[24642]=dot(b,dot(A,c**7*dot(A,c))*dot(A,dot(A,c)))-1/1680.
    coneq[24643]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*dot(A,dot(A,c)))-1/16800.
    coneq[24644]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/67200.
    coneq[24645]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/201600.
    coneq[24646]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/403200.
    coneq[24647]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/134400.
    coneq[24648]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/50400.
    coneq[24649]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/100800.
    coneq[24650]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/33600.
    coneq[24651]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/67200.
    coneq[24652]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*dot(A,dot(A,c)))-1/50400.
    coneq[24653]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/201600.
    coneq[24654]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/604800.
    coneq[24655]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24656]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/403200.
    coneq[24657]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/151200.
    coneq[24658]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/302400.
    coneq[24659]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/100800.
    coneq[24660]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/201600.
    coneq[24661]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*dot(A,dot(A,c)))-1/100800.
    coneq[24662]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/403200.
    coneq[24663]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24664]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/2419200.
    coneq[24665]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/806400.
    coneq[24666]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/302400.
    coneq[24667]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/604800.
    coneq[24668]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/201600.
    coneq[24669]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/403200.
    coneq[24670]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*dot(A,dot(A,c)))-1/33600.
    coneq[24671]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/134400.
    coneq[24672]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/403200.
    coneq[24673]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/806400.
    coneq[24674]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/268800.
    coneq[24675]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/100800.
    coneq[24676]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/201600.
    coneq[24677]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/67200.
    coneq[24678]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/134400.
    coneq[24679]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*dot(A,dot(A,c)))-1/15120.
    coneq[24680]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/75600.
    coneq[24681]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/302400.
    coneq[24682]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24683]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24684]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/604800.
    coneq[24685]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/226800.
    coneq[24686]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/453600.
    coneq[24687]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/151200.
    coneq[24688]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/302400.
    coneq[24689]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/60480.
    coneq[24690]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/181440.
    coneq[24691]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/362880.
    coneq[24692]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24693]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/45360.
    coneq[24694]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/90720.
    coneq[24695]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/30240.
    coneq[24696]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/90720.
    coneq[24697]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/181440.
    coneq[24698]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/60480.
    coneq[24699]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*dot(A,dot(A,c)))-1/30240.
    coneq[24700]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/151200.
    coneq[24701]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/604800.
    coneq[24702]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/1814400.
    coneq[24703]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/3628800.
    coneq[24704]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24705]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/453600.
    coneq[24706]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/907200.
    coneq[24707]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/302400.
    coneq[24708]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/604800.
    coneq[24709]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/120960.
    coneq[24710]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/362880.
    coneq[24711]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/725760.
    coneq[24712]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24713]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/90720.
    coneq[24714]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/181440.
    coneq[24715]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/60480.
    coneq[24716]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/181440.
    coneq[24717]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/362880.
    coneq[24718]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/120960.
    coneq[24719]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*dot(A,dot(A,c)))-1/11760.
    coneq[24720]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*dot(A,dot(A,c)))-1/70560.
    coneq[24721]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c)))-1/352800.
    coneq[24722]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c)))-1/1411200.
    coneq[24723]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c)))-1/4233600.
    coneq[24724]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c)))-1/8467200.
    coneq[24725]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c)))-1/2822400.
    coneq[24726]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c)))-1/1058400.
    coneq[24727]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/2116800.
    coneq[24728]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c)))-1/705600.
    coneq[24729]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c)))-1/1411200.
    coneq[24730]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c)))-1/282240.
    coneq[24731]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/846720.
    coneq[24732]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1693440.
    coneq[24733]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/564480.
    coneq[24734]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c)))-1/211680.
    coneq[24735]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/423360.
    coneq[24736]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c)))-1/141120.
    coneq[24737]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c)))-1/423360.
    coneq[24738]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/846720.
    coneq[24739]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/282240.
    coneq[24740]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*dot(A,dot(A,c)))-1/58800.
    coneq[24741]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/235200.
    coneq[24742]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/705600.
    coneq[24743]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1411200.
    coneq[24744]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/470400.
    coneq[24745]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/176400.
    coneq[24746]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/352800.
    coneq[24747]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/117600.
    coneq[24748]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/235200.
    coneq[24749]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c)))-1/47040.
    coneq[24750]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/141120.
    coneq[24751]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/282240.
    coneq[24752]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/94080.
    coneq[24753]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c)))-1/35280.
    coneq[24754]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/70560.
    coneq[24755]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*dot(A,dot(A,c)))-1/23520.
    coneq[24756]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c)))-1/105840.
    coneq[24757]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/211680.
    coneq[24758]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/423360.
    coneq[24759]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c)))-1/94080.
    coneq[24760]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/282240.
    coneq[24761]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/564480.
    coneq[24762]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/188160.
    coneq[24763]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/70560.
    coneq[24764]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/141120.
    coneq[24765]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/47040.
    coneq[24766]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/94080.
    coneq[24767]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*dot(A,dot(A,c)))-1/13440.
    coneq[24768]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/40320.
    coneq[24769]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/80640.
    coneq[24770]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/26880.
    coneq[24771]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/120960.
    coneq[24772]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24773]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/80640.
    coneq[24774]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/483840.
    coneq[24775]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/161280.
    coneq[24776]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/53760.
    coneq[24777]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*dot(A,dot(A,c)))-1/12600.
    coneq[24778]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/50400.
    coneq[24779]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/151200.
    coneq[24780]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/302400.
    coneq[24781]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/100800.
    coneq[24782]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/37800.
    coneq[24783]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/75600.
    coneq[24784]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/25200.
    coneq[24785]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/50400.
    coneq[24786]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*dot(A,dot(A,c)))-1/25200.
    coneq[24787]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/100800.
    coneq[24788]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/302400.
    coneq[24789]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/604800.
    coneq[24790]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/201600.
    coneq[24791]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/75600.
    coneq[24792]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/151200.
    coneq[24793]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/50400.
    coneq[24794]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/100800.
    coneq[24795]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*dot(A,dot(A,c)))-1/10080.
    coneq[24796]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*dot(A,dot(A,c)))-1/50400.
    coneq[24797]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)))-1/201600.
    coneq[24798]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)))-1/604800.
    coneq[24799]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)))-1/1209600.
    coneq[24800]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)))-1/403200.
    coneq[24801]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)))-1/151200.
    coneq[24802]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/302400.
    coneq[24803]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)))-1/100800.
    coneq[24804]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)))-1/201600.
    coneq[24805]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)))-1/40320.
    coneq[24806]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/120960.
    coneq[24807]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/241920.
    coneq[24808]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/80640.
    coneq[24809]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)))-1/30240.
    coneq[24810]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/60480.
    coneq[24811]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)))-1/20160.
    coneq[24812]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)))-1/60480.
    coneq[24813]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24814]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/40320.
    coneq[24815]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c)))-1/10080.
    coneq[24816]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/30240.
    coneq[24817]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/60480.
    coneq[24818]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/20160.
    coneq[24819]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c)))-1/20160.
    coneq[24820]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/60480.
    coneq[24821]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24822]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/40320.
    coneq[24823]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*dot(A,dot(A,c)))-1/8400.
    coneq[24824]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/33600.
    coneq[24825]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/100800.
    coneq[24826]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/201600.
    coneq[24827]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/67200.
    coneq[24828]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/25200.
    coneq[24829]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/50400.
    coneq[24830]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/16800.
    coneq[24831]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/33600.
    coneq[24832]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/7560.
    coneq[24833]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/15120.
    coneq[24834]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/30240.
    coneq[24835]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)))-1/6720.
    coneq[24836]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/20160.
    coneq[24837]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/40320.
    coneq[24838]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/13440.
    coneq[24839]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/5040.
    coneq[24840]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/10080.
    coneq[24841]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/3360.
    coneq[24842]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*dot(A,dot(A,c)))-1/16800.
    coneq[24843]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c)))-1/67200.
    coneq[24844]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)))-1/201600.
    coneq[24845]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)))-1/403200.
    coneq[24846]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)))-1/134400.
    coneq[24847]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)))-1/50400.
    coneq[24848]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/100800.
    coneq[24849]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)))-1/33600.
    coneq[24850]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)))-1/67200.
    coneq[24851]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c)))-1/20160.
    coneq[24852]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/60480.
    coneq[24853]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/120960.
    coneq[24854]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/40320.
    coneq[24855]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c)))-1/40320.
    coneq[24856]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/120960.
    coneq[24857]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/241920.
    coneq[24858]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/80640.
    coneq[24859]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/22680.
    coneq[24860]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/45360.
    coneq[24861]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/90720.
    coneq[24862]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/181440.
    coneq[24863]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)))-1/13440.
    coneq[24864]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/40320.
    coneq[24865]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/80640.
    coneq[24866]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/26880.
    coneq[24867]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)))-1/15120.
    coneq[24868]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/30240.
    coneq[24869]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/60480.
    coneq[24870]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/10080.
    coneq[24871]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/20160.
    coneq[24872]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/6720.
    coneq[24873]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)))-1/20160.
    coneq[24874]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/40320.
    coneq[24875]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/13440.
    coneq[24876]=dot(b,dot(A,c**10)*dot(A,c))-1/308.
    coneq[24877]=dot(b,dot(A,dot(A,c**9))*dot(A,c))-1/3080.
    coneq[24878]=dot(b,dot(A,dot(A,dot(A,c**8)))*dot(A,c))-1/27720.
    coneq[24879]=dot(b,dot(A,dot(A,dot(A,dot(A,c**7))))*dot(A,c))-1/221760.
    coneq[24880]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**6)))))*dot(A,c))-1/1552320.
    coneq[24881]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**5))))))*dot(A,c))-1/9313920.
    coneq[24882]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))))*dot(A,c))-1/46569600.
    coneq[24883]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))))*dot(A,c))-1/186278400.
    coneq[24884]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))))*dot(A,c))-1/558835200.
    coneq[24885]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))))*dot(A,c))-1/1117670400.
    coneq[24886]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))))*dot(A,c))-1/372556800.
    coneq[24887]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))))*dot(A,c))-1/139708800.
    coneq[24888]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))))*dot(A,c))-1/279417600.
    coneq[24889]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))))*dot(A,c))-1/93139200.
    coneq[24890]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))))*dot(A,c))-1/186278400.
    coneq[24891]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))))*dot(A,c))-1/37255680.
    coneq[24892]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))))*dot(A,c))-1/111767040.
    coneq[24893]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/223534080.
    coneq[24894]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))))*dot(A,c))-1/74511360.
    coneq[24895]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))))*dot(A,c))-1/27941760.
    coneq[24896]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))))*dot(A,c))-1/55883520.
    coneq[24897]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))))*dot(A,c))-1/18627840.
    coneq[24898]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))))*dot(A,c))-1/55883520.
    coneq[24899]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))))*dot(A,c))-1/111767040.
    coneq[24900]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))))*dot(A,c))-1/37255680.
    coneq[24901]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4))))))*dot(A,c))-1/7761600.
    coneq[24902]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))))*dot(A,c))-1/31046400.
    coneq[24903]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))))*dot(A,c))-1/93139200.
    coneq[24904]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/186278400.
    coneq[24905]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))))*dot(A,c))-1/62092800.
    coneq[24906]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))))*dot(A,c))-1/23284800.
    coneq[24907]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))))*dot(A,c))-1/46569600.
    coneq[24908]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))))*dot(A,c))-1/15523200.
    coneq[24909]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c))-1/31046400.
    coneq[24910]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))))*dot(A,c))-1/6209280.
    coneq[24911]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))))*dot(A,c))-1/18627840.
    coneq[24912]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/37255680.
    coneq[24913]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))))*dot(A,c))-1/12418560.
    coneq[24914]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))))*dot(A,c))-1/4656960.
    coneq[24915]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))))*dot(A,c))-1/9313920.
    coneq[24916]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c))))))*dot(A,c))-1/3104640.
    coneq[24917]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))))*dot(A,c))-1/13970880.
    coneq[24918]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))))*dot(A,c))-1/27941760.
    coneq[24919]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))))*dot(A,c))-1/55883520.
    coneq[24920]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))))*dot(A,c))-1/12418560.
    coneq[24921]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))))*dot(A,c))-1/37255680.
    coneq[24922]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/74511360.
    coneq[24923]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))))*dot(A,c))-1/24837120.
    coneq[24924]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))))*dot(A,c))-1/9313920.
    coneq[24925]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c))-1/18627840.
    coneq[24926]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))))*dot(A,c))-1/6209280.
    coneq[24927]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))))*dot(A,c))-1/12418560.
    coneq[24928]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**5)))))*dot(A,c))-1/1330560.
    coneq[24929]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4))))))*dot(A,c))-1/6652800.
    coneq[24930]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))))*dot(A,c))-1/26611200.
    coneq[24931]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c))-1/79833600.
    coneq[24932]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/159667200.
    coneq[24933]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c))-1/53222400.
    coneq[24934]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c))-1/19958400.
    coneq[24935]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c))-1/39916800.
    coneq[24936]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c))-1/13305600.
    coneq[24937]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c))-1/26611200.
    coneq[24938]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))))*dot(A,c))-1/5322240.
    coneq[24939]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c))-1/15966720.
    coneq[24940]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/31933440.
    coneq[24941]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c))-1/10644480.
    coneq[24942]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))))*dot(A,c))-1/3991680.
    coneq[24943]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c))-1/7983360.
    coneq[24944]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[24945]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c))-1/7983360.
    coneq[24946]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c))-1/15966720.
    coneq[24947]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c))-1/5322240.
    coneq[24948]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**4)))))*dot(A,c))-1/1108800.
    coneq[24949]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))))*dot(A,c))-1/4435200.
    coneq[24950]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/13305600.
    coneq[24951]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/26611200.
    coneq[24952]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/8870400.
    coneq[24953]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))))*dot(A,c))-1/3326400.
    coneq[24954]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/6652800.
    coneq[24955]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))))*dot(A,c))-1/2217600.
    coneq[24956]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/4435200.
    coneq[24957]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**3)))))*dot(A,c))-1/887040.
    coneq[24958]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))))*dot(A,c))-1/2661120.
    coneq[24959]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/5322240.
    coneq[24960]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))))*dot(A,c))-1/1774080.
    coneq[24961]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c**2)))))*dot(A,c))-1/665280.
    coneq[24962]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[24963]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5*dot(A,c)))))*dot(A,c))-1/443520.
    coneq[24964]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))))*dot(A,c))-1/2661120.
    coneq[24965]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))))*dot(A,c))-1/7983360.
    coneq[24966]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/15966720.
    coneq[24967]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))))*dot(A,c))-1/5322240.
    coneq[24968]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))))*dot(A,c))-1/5322240.
    coneq[24969]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))))*dot(A,c))-1/15966720.
    coneq[24970]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/31933440.
    coneq[24971]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))))*dot(A,c))-1/10644480.
    coneq[24972]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4)))))*dot(A,c))-1/2217600.
    coneq[24973]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))))*dot(A,c))-1/8870400.
    coneq[24974]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/26611200.
    coneq[24975]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/53222400.
    coneq[24976]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/17740800.
    coneq[24977]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))))*dot(A,c))-1/6652800.
    coneq[24978]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/13305600.
    coneq[24979]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))))*dot(A,c))-1/4435200.
    coneq[24980]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/8870400.
    coneq[24981]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))))*dot(A,c))-1/1995840.
    coneq[24982]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c))-1/3991680.
    coneq[24983]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c))-1/7983360.
    coneq[24984]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))))*dot(A,c))-1/1774080.
    coneq[24985]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c))-1/5322240.
    coneq[24986]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/10644480.
    coneq[24987]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c))-1/3548160.
    coneq[24988]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/1330560.
    coneq[24989]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[24990]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))))*dot(A,c))-1/887040.
    coneq[24991]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/2661120.
    coneq[24992]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/5322240.
    coneq[24993]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1774080.
    coneq[24994]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**6))))*dot(A,c))-1/194040.
    coneq[24995]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**5)))))*dot(A,c))-1/1164240.
    coneq[24996]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4))))))*dot(A,c))-1/5821200.
    coneq[24997]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,c))-1/23284800.
    coneq[24998]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c))-1/69854400.
    coneq[24999]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/139708800.
    coneq[25000]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c))-1/46569600.
    coneq[25001]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c))-1/17463600.
    coneq[25002]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c))-1/34927200.
    coneq[25003]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c))-1/11642400.
    coneq[25004]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c))-1/23284800.
    coneq[25005]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))))*dot(A,c))-1/4656960.
    coneq[25006]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c))-1/13970880.
    coneq[25007]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/27941760.
    coneq[25008]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c))-1/9313920.
    coneq[25009]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,c))-1/3492720.
    coneq[25010]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c))-1/6985440.
    coneq[25011]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))))*dot(A,c))-1/2328480.
    coneq[25012]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c))-1/6985440.
    coneq[25013]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c))-1/13970880.
    coneq[25014]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c))-1/4656960.
    coneq[25015]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**4)))))*dot(A,c))-1/970200.
    coneq[25016]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))))*dot(A,c))-1/3880800.
    coneq[25017]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/11642400.
    coneq[25018]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/23284800.
    coneq[25019]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/7761600.
    coneq[25020]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,c))-1/2910600.
    coneq[25021]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/5821200.
    coneq[25022]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1940400.
    coneq[25023]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/3880800.
    coneq[25024]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3)))))*dot(A,c))-1/776160.
    coneq[25025]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,c))-1/2328480.
    coneq[25026]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4656960.
    coneq[25027]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,c))-1/1552320.
    coneq[25028]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2)))))*dot(A,c))-1/582120.
    coneq[25029]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))))*dot(A,c))-1/1164240.
    coneq[25030]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4*dot(A,c)))))*dot(A,c))-1/388080.
    coneq[25031]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,c))-1/1746360.
    coneq[25032]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c))-1/3492720.
    coneq[25033]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c))-1/6985440.
    coneq[25034]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,c))-1/1552320.
    coneq[25035]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c))-1/4656960.
    coneq[25036]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/9313920.
    coneq[25037]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c))-1/3104640.
    coneq[25038]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/1164240.
    coneq[25039]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/2328480.
    coneq[25040]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,c))-1/776160.
    coneq[25041]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1552320.
    coneq[25042]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**5))))*dot(A,c))-1/166320.
    coneq[25043]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**4)))))*dot(A,c))-1/831600.
    coneq[25044]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/3326400.
    coneq[25045]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/9979200.
    coneq[25046]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/19958400.
    coneq[25047]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/6652800.
    coneq[25048]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/2494800.
    coneq[25049]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/4989600.
    coneq[25050]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1663200.
    coneq[25051]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/3326400.
    coneq[25052]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3)))))*dot(A,c))-1/665280.
    coneq[25053]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1995840.
    coneq[25054]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3991680.
    coneq[25055]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[25056]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/498960.
    coneq[25057]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/997920.
    coneq[25058]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c)))))*dot(A,c))-1/332640.
    coneq[25059]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/997920.
    coneq[25060]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1995840.
    coneq[25061]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25062]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**4))))*dot(A,c))-1/138600.
    coneq[25063]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**3)))))*dot(A,c))-1/554400.
    coneq[25064]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1663200.
    coneq[25065]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3326400.
    coneq[25066]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1108800.
    coneq[25067]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/415800.
    coneq[25068]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/831600.
    coneq[25069]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/277200.
    coneq[25070]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/554400.
    coneq[25071]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**3))))*dot(A,c))-1/110880.
    coneq[25072]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c**2)))))*dot(A,c))-1/332640.
    coneq[25073]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/665280.
    coneq[25074]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c*dot(A,c)))))*dot(A,c))-1/221760.
    coneq[25075]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c**2))))*dot(A,c))-1/83160.
    coneq[25076]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,dot(A,c)))))*dot(A,c))-1/166320.
    coneq[25077]=dot(b,dot(A,dot(A,dot(A,c**6*dot(A,c))))*dot(A,c))-1/55440.
    coneq[25078]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c**3))))*dot(A,c))-1/443520.
    coneq[25079]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))))*dot(A,c))-1/1330560.
    coneq[25080]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[25081]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25082]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))))*dot(A,c))-1/3991680.
    coneq[25083]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/7983360.
    coneq[25084]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))))*dot(A,c))-1/2661120.
    coneq[25085]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/15966720.
    coneq[25086]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))))*dot(A,c))-1/5322240.
    coneq[25087]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c))-1/1774080.
    coneq[25088]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**4))))*dot(A,c))-1/415800.
    coneq[25089]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))))*dot(A,c))-1/1663200.
    coneq[25090]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/4989600.
    coneq[25091]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/9979200.
    coneq[25092]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/3326400.
    coneq[25093]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/1247400.
    coneq[25094]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/2494800.
    coneq[25095]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/831600.
    coneq[25096]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/1663200.
    coneq[25097]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4))))*dot(A,c))-1/831600.
    coneq[25098]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))))*dot(A,c))-1/3326400.
    coneq[25099]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/9979200.
    coneq[25100]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/19958400.
    coneq[25101]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/6652800.
    coneq[25102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/2494800.
    coneq[25103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/4989600.
    coneq[25104]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/1663200.
    coneq[25105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/3326400.
    coneq[25106]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**5))))*dot(A,c))-1/332640.
    coneq[25107]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4)))))*dot(A,c))-1/1663200.
    coneq[25108]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/6652800.
    coneq[25109]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/19958400.
    coneq[25110]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/39916800.
    coneq[25111]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/13305600.
    coneq[25112]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/4989600.
    coneq[25113]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/9979200.
    coneq[25114]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/3326400.
    coneq[25115]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/6652800.
    coneq[25116]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))))*dot(A,c))-1/1330560.
    coneq[25117]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/3991680.
    coneq[25118]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/7983360.
    coneq[25119]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[25120]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/997920.
    coneq[25121]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/1995840.
    coneq[25122]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25123]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/1995840.
    coneq[25124]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/3991680.
    coneq[25125]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1330560.
    coneq[25126]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3))))*dot(A,c))-1/332640.
    coneq[25127]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,c))-1/997920.
    coneq[25128]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1995840.
    coneq[25129]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25130]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))))*dot(A,c))-1/665280.
    coneq[25131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,c))-1/1995840.
    coneq[25132]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/3991680.
    coneq[25133]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c))-1/1330560.
    coneq[25134]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**4))))*dot(A,c))-1/277200.
    coneq[25135]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,c))-1/1108800.
    coneq[25136]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/3326400.
    coneq[25137]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/6652800.
    coneq[25138]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/2217600.
    coneq[25139]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/831600.
    coneq[25140]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1663200.
    coneq[25141]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/554400.
    coneq[25142]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/1108800.
    coneq[25143]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/249480.
    coneq[25144]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/498960.
    coneq[25145]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/997920.
    coneq[25146]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3))))*dot(A,c))-1/221760.
    coneq[25147]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/665280.
    coneq[25148]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[25149]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25150]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/166320.
    coneq[25151]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/332640.
    coneq[25152]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c)*dot(A,c))))*dot(A,c))-1/110880.
    coneq[25153]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))))*dot(A,c))-1/443520.
    coneq[25154]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/1330560.
    coneq[25155]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[25156]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25157]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/498960.
    coneq[25158]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/997920.
    coneq[25159]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/1995840.
    coneq[25160]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/332640.
    coneq[25161]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25162]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/221760.
    coneq[25163]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/443520.
    coneq[25164]=dot(b,dot(A,dot(A,c*dot(A,c**7)))*dot(A,c))-1/24640.
    coneq[25165]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**6))))*dot(A,c))-1/172480.
    coneq[25166]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**5)))))*dot(A,c))-1/1034880.
    coneq[25167]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4))))))*dot(A,c))-1/5174400.
    coneq[25168]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,c))-1/20697600.
    coneq[25169]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c))-1/62092800.
    coneq[25170]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/124185600.
    coneq[25171]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c))-1/41395200.
    coneq[25172]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c))-1/15523200.
    coneq[25173]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c))-1/31046400.
    coneq[25174]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c))-1/10348800.
    coneq[25175]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c))-1/20697600.
    coneq[25176]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3))))))*dot(A,c))-1/4139520.
    coneq[25177]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c))-1/12418560.
    coneq[25178]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/24837120.
    coneq[25179]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c))-1/8279040.
    coneq[25180]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,c))-1/3104640.
    coneq[25181]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c))-1/6209280.
    coneq[25182]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c))))))*dot(A,c))-1/2069760.
    coneq[25183]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c))-1/6209280.
    coneq[25184]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c))-1/12418560.
    coneq[25185]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c))-1/4139520.
    coneq[25186]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**4)))))*dot(A,c))-1/862400.
    coneq[25187]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3))))))*dot(A,c))-1/3449600.
    coneq[25188]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/10348800.
    coneq[25189]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/20697600.
    coneq[25190]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/6899200.
    coneq[25191]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,c))-1/2587200.
    coneq[25192]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/5174400.
    coneq[25193]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1724800.
    coneq[25194]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/3449600.
    coneq[25195]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3)))))*dot(A,c))-1/689920.
    coneq[25196]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,c))-1/2069760.
    coneq[25197]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4139520.
    coneq[25198]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,c))-1/1379840.
    coneq[25199]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2)))))*dot(A,c))-1/517440.
    coneq[25200]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[25201]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4*dot(A,c)))))*dot(A,c))-1/344960.
    coneq[25202]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,c))-1/1552320.
    coneq[25203]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c))-1/3104640.
    coneq[25204]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c))-1/6209280.
    coneq[25205]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,c))-1/1379840.
    coneq[25206]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c))-1/4139520.
    coneq[25207]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/8279040.
    coneq[25208]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c))-1/2759680.
    coneq[25209]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/1034880.
    coneq[25210]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/2069760.
    coneq[25211]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,c))-1/689920.
    coneq[25212]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1379840.
    coneq[25213]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**5))))*dot(A,c))-1/147840.
    coneq[25214]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**4)))))*dot(A,c))-1/739200.
    coneq[25215]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/2956800.
    coneq[25216]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/8870400.
    coneq[25217]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/17740800.
    coneq[25218]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/5913600.
    coneq[25219]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/2217600.
    coneq[25220]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/4435200.
    coneq[25221]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1478400.
    coneq[25222]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2956800.
    coneq[25223]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3)))))*dot(A,c))-1/591360.
    coneq[25224]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1774080.
    coneq[25225]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3548160.
    coneq[25226]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/1182720.
    coneq[25227]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/443520.
    coneq[25228]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/887040.
    coneq[25229]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c)))))*dot(A,c))-1/295680.
    coneq[25230]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/887040.
    coneq[25231]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1774080.
    coneq[25232]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/591360.
    coneq[25233]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**4))))*dot(A,c))-1/123200.
    coneq[25234]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3)))))*dot(A,c))-1/492800.
    coneq[25235]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1478400.
    coneq[25236]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2956800.
    coneq[25237]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/985600.
    coneq[25238]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/369600.
    coneq[25239]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/739200.
    coneq[25240]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/246400.
    coneq[25241]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/492800.
    coneq[25242]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**3))))*dot(A,c))-1/98560.
    coneq[25243]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2)))))*dot(A,c))-1/295680.
    coneq[25244]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/591360.
    coneq[25245]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c)))))*dot(A,c))-1/197120.
    coneq[25246]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c**2))))*dot(A,c))-1/73920.
    coneq[25247]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,dot(A,c)))))*dot(A,c))-1/147840.
    coneq[25248]=dot(b,dot(A,dot(A,c*dot(A,c**5*dot(A,c))))*dot(A,c))-1/49280.
    coneq[25249]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3))))*dot(A,c))-1/295680.
    coneq[25250]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,c))-1/887040.
    coneq[25251]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1774080.
    coneq[25252]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,c))-1/591360.
    coneq[25253]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3))))*dot(A,c))-1/591360.
    coneq[25254]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,c))-1/1774080.
    coneq[25255]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/3548160.
    coneq[25256]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c))-1/1182720.
    coneq[25257]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**4))))*dot(A,c))-1/246400.
    coneq[25258]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,c))-1/985600.
    coneq[25259]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2956800.
    coneq[25260]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/5913600.
    coneq[25261]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1971200.
    coneq[25262]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/739200.
    coneq[25263]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1478400.
    coneq[25264]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/492800.
    coneq[25265]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/985600.
    coneq[25266]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[25267]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25268]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25269]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3))))*dot(A,c))-1/197120.
    coneq[25270]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/591360.
    coneq[25271]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1182720.
    coneq[25272]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/394240.
    coneq[25273]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/147840.
    coneq[25274]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/295680.
    coneq[25275]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c))))*dot(A,c))-1/98560.
    coneq[25276]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/295680.
    coneq[25277]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/591360.
    coneq[25278]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/197120.
    coneq[25279]=dot(b,dot(A,dot(A,c**2*dot(A,c**6)))*dot(A,c))-1/21560.
    coneq[25280]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**5))))*dot(A,c))-1/129360.
    coneq[25281]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/646800.
    coneq[25282]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/2587200.
    coneq[25283]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/7761600.
    coneq[25284]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/15523200.
    coneq[25285]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/5174400.
    coneq[25286]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1940400.
    coneq[25287]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/3880800.
    coneq[25288]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1293600.
    coneq[25289]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2587200.
    coneq[25290]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/517440.
    coneq[25291]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1552320.
    coneq[25292]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3104640.
    coneq[25293]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[25294]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/388080.
    coneq[25295]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/776160.
    coneq[25296]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/258720.
    coneq[25297]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/776160.
    coneq[25298]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1552320.
    coneq[25299]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/517440.
    coneq[25300]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**4))))*dot(A,c))-1/107800.
    coneq[25301]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/431200.
    coneq[25302]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1293600.
    coneq[25303]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2587200.
    coneq[25304]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/862400.
    coneq[25305]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/323400.
    coneq[25306]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/646800.
    coneq[25307]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/215600.
    coneq[25308]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/431200.
    coneq[25309]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/86240.
    coneq[25310]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/258720.
    coneq[25311]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/517440.
    coneq[25312]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/172480.
    coneq[25313]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/64680.
    coneq[25314]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/129360.
    coneq[25315]=dot(b,dot(A,dot(A,c**2*dot(A,c**4*dot(A,c))))*dot(A,c))-1/43120.
    coneq[25316]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/194040.
    coneq[25317]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/388080.
    coneq[25318]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/776160.
    coneq[25319]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/172480.
    coneq[25320]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/517440.
    coneq[25321]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[25322]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/344960.
    coneq[25323]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/129360.
    coneq[25324]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/258720.
    coneq[25325]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/86240.
    coneq[25326]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/172480.
    coneq[25327]=dot(b,dot(A,dot(A,c**3*dot(A,c**5)))*dot(A,c))-1/18480.
    coneq[25328]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**4))))*dot(A,c))-1/92400.
    coneq[25329]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/369600.
    coneq[25330]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1108800.
    coneq[25331]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2217600.
    coneq[25332]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/739200.
    coneq[25333]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/277200.
    coneq[25334]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/554400.
    coneq[25335]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/184800.
    coneq[25336]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/369600.
    coneq[25337]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**3))))*dot(A,c))-1/73920.
    coneq[25338]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/221760.
    coneq[25339]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/443520.
    coneq[25340]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/147840.
    coneq[25341]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/55440.
    coneq[25342]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/110880.
    coneq[25343]=dot(b,dot(A,dot(A,c**3*dot(A,c**3*dot(A,c))))*dot(A,c))-1/36960.
    coneq[25344]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[25345]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[25346]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/73920.
    coneq[25347]=dot(b,dot(A,dot(A,c**4*dot(A,c**4)))*dot(A,c))-1/15400.
    coneq[25348]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**3))))*dot(A,c))-1/61600.
    coneq[25349]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/184800.
    coneq[25350]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/369600.
    coneq[25351]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/123200.
    coneq[25352]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c**2))))*dot(A,c))-1/46200.
    coneq[25353]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/92400.
    coneq[25354]=dot(b,dot(A,dot(A,c**4*dot(A,c**2*dot(A,c))))*dot(A,c))-1/30800.
    coneq[25355]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/61600.
    coneq[25356]=dot(b,dot(A,dot(A,c**5*dot(A,c**3)))*dot(A,c))-1/12320.
    coneq[25357]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c**2))))*dot(A,c))-1/36960.
    coneq[25358]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/73920.
    coneq[25359]=dot(b,dot(A,dot(A,c**5*dot(A,c*dot(A,c))))*dot(A,c))-1/24640.
    coneq[25360]=dot(b,dot(A,dot(A,c**6*dot(A,c**2)))*dot(A,c))-1/9240.
    coneq[25361]=dot(b,dot(A,dot(A,c**6*dot(A,dot(A,c))))*dot(A,c))-1/18480.
    coneq[25362]=dot(b,dot(A,dot(A,c**7*dot(A,c)))*dot(A,c))-1/6160.
    coneq[25363]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**4)))*dot(A,c))-1/61600.
    coneq[25364]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**3))))*dot(A,c))-1/246400.
    coneq[25365]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/739200.
    coneq[25366]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1478400.
    coneq[25367]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/492800.
    coneq[25368]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/184800.
    coneq[25369]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/369600.
    coneq[25370]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/123200.
    coneq[25371]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/246400.
    coneq[25372]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**4)))*dot(A,c))-1/184800.
    coneq[25373]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3))))*dot(A,c))-1/739200.
    coneq[25374]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/2217600.
    coneq[25375]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/4435200.
    coneq[25376]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/1478400.
    coneq[25377]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2))))*dot(A,c))-1/554400.
    coneq[25378]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/1108800.
    coneq[25379]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c))))*dot(A,c))-1/369600.
    coneq[25380]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/739200.
    coneq[25381]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4)))*dot(A,c))-1/369600.
    coneq[25382]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3))))*dot(A,c))-1/1478400.
    coneq[25383]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/4435200.
    coneq[25384]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/8870400.
    coneq[25385]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/2956800.
    coneq[25386]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))))*dot(A,c))-1/1108800.
    coneq[25387]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/2217600.
    coneq[25388]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))))*dot(A,c))-1/739200.
    coneq[25389]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/1478400.
    coneq[25390]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**4)))*dot(A,c))-1/123200.
    coneq[25391]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3))))*dot(A,c))-1/492800.
    coneq[25392]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/1478400.
    coneq[25393]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2956800.
    coneq[25394]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/985600.
    coneq[25395]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,c))-1/369600.
    coneq[25396]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/739200.
    coneq[25397]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,c))-1/246400.
    coneq[25398]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/492800.
    coneq[25399]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**5)))*dot(A,c))-1/55440.
    coneq[25400]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**4))))*dot(A,c))-1/277200.
    coneq[25401]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/1108800.
    coneq[25402]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/3326400.
    coneq[25403]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/6652800.
    coneq[25404]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/2217600.
    coneq[25405]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/831600.
    coneq[25406]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1663200.
    coneq[25407]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/554400.
    coneq[25408]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/1108800.
    coneq[25409]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3))))*dot(A,c))-1/221760.
    coneq[25410]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/665280.
    coneq[25411]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[25412]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25413]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/166320.
    coneq[25414]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/332640.
    coneq[25415]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c))))*dot(A,c))-1/110880.
    coneq[25416]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/332640.
    coneq[25417]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25418]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/221760.
    coneq[25419]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**5)))*dot(A,c))-1/110880.
    coneq[25420]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4))))*dot(A,c))-1/554400.
    coneq[25421]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/2217600.
    coneq[25422]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/6652800.
    coneq[25423]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/13305600.
    coneq[25424]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/4435200.
    coneq[25425]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/1663200.
    coneq[25426]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/3326400.
    coneq[25427]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/1108800.
    coneq[25428]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/2217600.
    coneq[25429]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3))))*dot(A,c))-1/443520.
    coneq[25430]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/1330560.
    coneq[25431]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[25432]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25433]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/332640.
    coneq[25434]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25435]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c))))*dot(A,c))-1/221760.
    coneq[25436]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/665280.
    coneq[25437]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/1330560.
    coneq[25438]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/443520.
    coneq[25439]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**6)))*dot(A,c))-1/43120.
    coneq[25440]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**5))))*dot(A,c))-1/258720.
    coneq[25441]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/1293600.
    coneq[25442]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/5174400.
    coneq[25443]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/15523200.
    coneq[25444]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/31046400.
    coneq[25445]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/10348800.
    coneq[25446]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/3880800.
    coneq[25447]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/7761600.
    coneq[25448]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/2587200.
    coneq[25449]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/5174400.
    coneq[25450]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/1034880.
    coneq[25451]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/3104640.
    coneq[25452]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/6209280.
    coneq[25453]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/2069760.
    coneq[25454]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/776160.
    coneq[25455]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/1552320.
    coneq[25456]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/517440.
    coneq[25457]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/1552320.
    coneq[25458]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/3104640.
    coneq[25459]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1034880.
    coneq[25460]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**4))))*dot(A,c))-1/215600.
    coneq[25461]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/862400.
    coneq[25462]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2587200.
    coneq[25463]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/5174400.
    coneq[25464]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1724800.
    coneq[25465]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/646800.
    coneq[25466]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1293600.
    coneq[25467]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/431200.
    coneq[25468]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/862400.
    coneq[25469]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/172480.
    coneq[25470]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/517440.
    coneq[25471]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[25472]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/344960.
    coneq[25473]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/129360.
    coneq[25474]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/258720.
    coneq[25475]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4*dot(A,c))))*dot(A,c))-1/86240.
    coneq[25476]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/388080.
    coneq[25477]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/776160.
    coneq[25478]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/1552320.
    coneq[25479]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/344960.
    coneq[25480]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/1034880.
    coneq[25481]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2069760.
    coneq[25482]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/689920.
    coneq[25483]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/258720.
    coneq[25484]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/517440.
    coneq[25485]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/172480.
    coneq[25486]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/344960.
    coneq[25487]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c**3)))*dot(A,c))-1/49280.
    coneq[25488]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2))))*dot(A,c))-1/147840.
    coneq[25489]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/295680.
    coneq[25490]=dot(b,dot(A,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c))))*dot(A,c))-1/98560.
    coneq[25491]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*dot(A,c))-1/443520.
    coneq[25492]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25493]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*dot(A,c))-1/295680.
    coneq[25494]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/1774080.
    coneq[25495]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*dot(A,c))-1/591360.
    coneq[25496]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/197120.
    coneq[25497]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**4)))*dot(A,c))-1/46200.
    coneq[25498]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3))))*dot(A,c))-1/184800.
    coneq[25499]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/554400.
    coneq[25500]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1108800.
    coneq[25501]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/369600.
    coneq[25502]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/138600.
    coneq[25503]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/277200.
    coneq[25504]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/92400.
    coneq[25505]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/184800.
    coneq[25506]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**4)))*dot(A,c))-1/92400.
    coneq[25507]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3))))*dot(A,c))-1/369600.
    coneq[25508]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/1108800.
    coneq[25509]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2217600.
    coneq[25510]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/739200.
    coneq[25511]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,c))-1/277200.
    coneq[25512]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/554400.
    coneq[25513]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,c))-1/184800.
    coneq[25514]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/369600.
    coneq[25515]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**5)))*dot(A,c))-1/36960.
    coneq[25516]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**4))))*dot(A,c))-1/184800.
    coneq[25517]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/739200.
    coneq[25518]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2217600.
    coneq[25519]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4435200.
    coneq[25520]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1478400.
    coneq[25521]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/554400.
    coneq[25522]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1108800.
    coneq[25523]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/369600.
    coneq[25524]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/739200.
    coneq[25525]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3))))*dot(A,c))-1/147840.
    coneq[25526]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/443520.
    coneq[25527]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/887040.
    coneq[25528]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/295680.
    coneq[25529]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[25530]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[25531]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c))))*dot(A,c))-1/73920.
    coneq[25532]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[25533]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25534]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/147840.
    coneq[25535]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/36960.
    coneq[25536]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[25537]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[25538]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/73920.
    coneq[25539]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/73920.
    coneq[25540]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[25541]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25542]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/147840.
    coneq[25543]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**4)))*dot(A,c))-1/30800.
    coneq[25544]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/123200.
    coneq[25545]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/369600.
    coneq[25546]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/739200.
    coneq[25547]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/246400.
    coneq[25548]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/92400.
    coneq[25549]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/184800.
    coneq[25550]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/61600.
    coneq[25551]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/123200.
    coneq[25552]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/27720.
    coneq[25553]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/55440.
    coneq[25554]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/110880.
    coneq[25555]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/24640.
    coneq[25556]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/73920.
    coneq[25557]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/147840.
    coneq[25558]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/49280.
    coneq[25559]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/18480.
    coneq[25560]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/36960.
    coneq[25561]=dot(b,dot(A,dot(A,c**5*dot(A,c)*dot(A,c)))*dot(A,c))-1/12320.
    coneq[25562]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4)))*dot(A,c))-1/61600.
    coneq[25563]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/246400.
    coneq[25564]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/739200.
    coneq[25565]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1478400.
    coneq[25566]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/492800.
    coneq[25567]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/184800.
    coneq[25568]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/369600.
    coneq[25569]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/123200.
    coneq[25570]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/246400.
    coneq[25571]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/73920.
    coneq[25572]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[25573]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25574]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/147840.
    coneq[25575]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/147840.
    coneq[25576]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/443520.
    coneq[25577]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25578]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/295680.
    coneq[25579]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/83160.
    coneq[25580]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/166320.
    coneq[25581]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/332640.
    coneq[25582]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/665280.
    coneq[25583]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/49280.
    coneq[25584]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/147840.
    coneq[25585]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/295680.
    coneq[25586]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/98560.
    coneq[25587]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/55440.
    coneq[25588]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/110880.
    coneq[25589]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/221760.
    coneq[25590]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/36960.
    coneq[25591]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/73920.
    coneq[25592]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/24640.
    coneq[25593]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/73920.
    coneq[25594]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/147840.
    coneq[25595]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/49280.
    coneq[25596]=dot(b,dot(A,c*dot(A,c**8))*dot(A,c))-1/2772.
    coneq[25597]=dot(b,dot(A,c*dot(A,dot(A,c**7)))*dot(A,c))-1/22176.
    coneq[25598]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**6))))*dot(A,c))-1/155232.
    coneq[25599]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**5)))))*dot(A,c))-1/931392.
    coneq[25600]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*dot(A,c))-1/4656960.
    coneq[25601]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,c))-1/18627840.
    coneq[25602]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c))-1/55883520.
    coneq[25603]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c))-1/111767040.
    coneq[25604]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c))-1/37255680.
    coneq[25605]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c))-1/13970880.
    coneq[25606]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c))-1/27941760.
    coneq[25607]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c))-1/9313920.
    coneq[25608]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c))-1/18627840.
    coneq[25609]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*dot(A,c))-1/3725568.
    coneq[25610]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c))-1/11176704.
    coneq[25611]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/22353408.
    coneq[25612]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c))-1/7451136.
    coneq[25613]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,c))-1/2794176.
    coneq[25614]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c))-1/5588352.
    coneq[25615]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*dot(A,c))-1/1862784.
    coneq[25616]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c))-1/5588352.
    coneq[25617]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c))-1/11176704.
    coneq[25618]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c))-1/3725568.
    coneq[25619]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**4)))))*dot(A,c))-1/776160.
    coneq[25620]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*dot(A,c))-1/3104640.
    coneq[25621]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/9313920.
    coneq[25622]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/18627840.
    coneq[25623]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/6209280.
    coneq[25624]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,c))-1/2328480.
    coneq[25625]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/4656960.
    coneq[25626]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1552320.
    coneq[25627]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/3104640.
    coneq[25628]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*dot(A,c))-1/620928.
    coneq[25629]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,c))-1/1862784.
    coneq[25630]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3725568.
    coneq[25631]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,c))-1/1241856.
    coneq[25632]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*dot(A,c))-1/465696.
    coneq[25633]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*dot(A,c))-1/931392.
    coneq[25634]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4*dot(A,c)))))*dot(A,c))-1/310464.
    coneq[25635]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,c))-1/1397088.
    coneq[25636]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c))-1/2794176.
    coneq[25637]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c))-1/5588352.
    coneq[25638]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,c))-1/1241856.
    coneq[25639]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c))-1/3725568.
    coneq[25640]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/7451136.
    coneq[25641]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c))-1/2483712.
    coneq[25642]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/931392.
    coneq[25643]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1862784.
    coneq[25644]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,c))-1/620928.
    coneq[25645]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c))-1/1241856.
    coneq[25646]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**5))))*dot(A,c))-1/133056.
    coneq[25647]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**4)))))*dot(A,c))-1/665280.
    coneq[25648]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/2661120.
    coneq[25649]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/7983360.
    coneq[25650]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/15966720.
    coneq[25651]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/5322240.
    coneq[25652]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1995840.
    coneq[25653]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/3991680.
    coneq[25654]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[25655]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[25656]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*dot(A,c))-1/532224.
    coneq[25657]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1596672.
    coneq[25658]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3193344.
    coneq[25659]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/1064448.
    coneq[25660]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/399168.
    coneq[25661]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/798336.
    coneq[25662]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*dot(A,c))-1/266112.
    coneq[25663]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/798336.
    coneq[25664]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1596672.
    coneq[25665]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/532224.
    coneq[25666]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**4))))*dot(A,c))-1/110880.
    coneq[25667]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*dot(A,c))-1/443520.
    coneq[25668]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1330560.
    coneq[25669]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2661120.
    coneq[25670]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/887040.
    coneq[25671]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/332640.
    coneq[25672]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/665280.
    coneq[25673]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/221760.
    coneq[25674]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25675]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**3))))*dot(A,c))-1/88704.
    coneq[25676]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*dot(A,c))-1/266112.
    coneq[25677]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/532224.
    coneq[25678]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*dot(A,c))-1/177408.
    coneq[25679]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c**2))))*dot(A,c))-1/66528.
    coneq[25680]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,dot(A,c)))))*dot(A,c))-1/133056.
    coneq[25681]=dot(b,dot(A,c*dot(A,dot(A,c**5*dot(A,c))))*dot(A,c))-1/44352.
    coneq[25682]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*dot(A,c))-1/266112.
    coneq[25683]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,c))-1/798336.
    coneq[25684]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1596672.
    coneq[25685]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,c))-1/532224.
    coneq[25686]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*dot(A,c))-1/532224.
    coneq[25687]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,c))-1/1596672.
    coneq[25688]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/3193344.
    coneq[25689]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c))-1/1064448.
    coneq[25690]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**4))))*dot(A,c))-1/221760.
    coneq[25691]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,c))-1/887040.
    coneq[25692]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2661120.
    coneq[25693]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/5322240.
    coneq[25694]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1774080.
    coneq[25695]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/665280.
    coneq[25696]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[25697]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/443520.
    coneq[25698]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/887040.
    coneq[25699]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/199584.
    coneq[25700]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/399168.
    coneq[25701]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/798336.
    coneq[25702]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*dot(A,c))-1/177408.
    coneq[25703]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/532224.
    coneq[25704]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1064448.
    coneq[25705]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/354816.
    coneq[25706]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/133056.
    coneq[25707]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/266112.
    coneq[25708]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*dot(A,c))-1/88704.
    coneq[25709]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/266112.
    coneq[25710]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/532224.
    coneq[25711]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/177408.
    coneq[25712]=dot(b,dot(A,c*dot(A,c*dot(A,c**6)))*dot(A,c))-1/19404.
    coneq[25713]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**5))))*dot(A,c))-1/116424.
    coneq[25714]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/582120.
    coneq[25715]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/2328480.
    coneq[25716]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/6985440.
    coneq[25717]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/13970880.
    coneq[25718]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/4656960.
    coneq[25719]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1746360.
    coneq[25720]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/3492720.
    coneq[25721]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1164240.
    coneq[25722]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2328480.
    coneq[25723]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/465696.
    coneq[25724]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1397088.
    coneq[25725]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2794176.
    coneq[25726]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/931392.
    coneq[25727]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/349272.
    coneq[25728]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/698544.
    coneq[25729]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/232848.
    coneq[25730]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/698544.
    coneq[25731]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1397088.
    coneq[25732]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/465696.
    coneq[25733]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**4))))*dot(A,c))-1/97020.
    coneq[25734]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/388080.
    coneq[25735]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1164240.
    coneq[25736]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2328480.
    coneq[25737]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/776160.
    coneq[25738]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/291060.
    coneq[25739]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/582120.
    coneq[25740]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/194040.
    coneq[25741]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/388080.
    coneq[25742]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/77616.
    coneq[25743]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/232848.
    coneq[25744]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/465696.
    coneq[25745]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/155232.
    coneq[25746]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/58212.
    coneq[25747]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/116424.
    coneq[25748]=dot(b,dot(A,c*dot(A,c*dot(A,c**4*dot(A,c))))*dot(A,c))-1/38808.
    coneq[25749]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/174636.
    coneq[25750]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/349272.
    coneq[25751]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/698544.
    coneq[25752]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/155232.
    coneq[25753]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/465696.
    coneq[25754]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/931392.
    coneq[25755]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/310464.
    coneq[25756]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/116424.
    coneq[25757]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/232848.
    coneq[25758]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/77616.
    coneq[25759]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/155232.
    coneq[25760]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**5)))*dot(A,c))-1/16632.
    coneq[25761]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**4))))*dot(A,c))-1/83160.
    coneq[25762]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/332640.
    coneq[25763]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/997920.
    coneq[25764]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1995840.
    coneq[25765]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/665280.
    coneq[25766]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/249480.
    coneq[25767]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/498960.
    coneq[25768]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/166320.
    coneq[25769]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/332640.
    coneq[25770]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**3))))*dot(A,c))-1/66528.
    coneq[25771]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/199584.
    coneq[25772]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/399168.
    coneq[25773]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/133056.
    coneq[25774]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/49896.
    coneq[25775]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/99792.
    coneq[25776]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3*dot(A,c))))*dot(A,c))-1/33264.
    coneq[25777]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/99792.
    coneq[25778]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/199584.
    coneq[25779]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/66528.
    coneq[25780]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**4)))*dot(A,c))-1/13860.
    coneq[25781]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**3))))*dot(A,c))-1/55440.
    coneq[25782]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/166320.
    coneq[25783]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/332640.
    coneq[25784]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/110880.
    coneq[25785]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c**2))))*dot(A,c))-1/41580.
    coneq[25786]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/83160.
    coneq[25787]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2*dot(A,c))))*dot(A,c))-1/27720.
    coneq[25788]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/55440.
    coneq[25789]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**3)))*dot(A,c))-1/11088.
    coneq[25790]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c**2))))*dot(A,c))-1/33264.
    coneq[25791]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/66528.
    coneq[25792]=dot(b,dot(A,c*dot(A,c**4*dot(A,c*dot(A,c))))*dot(A,c))-1/22176.
    coneq[25793]=dot(b,dot(A,c*dot(A,c**5*dot(A,c**2)))*dot(A,c))-1/8316.
    coneq[25794]=dot(b,dot(A,c*dot(A,c**5*dot(A,dot(A,c))))*dot(A,c))-1/16632.
    coneq[25795]=dot(b,dot(A,c*dot(A,c**6*dot(A,c)))*dot(A,c))-1/5544.
    coneq[25796]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c**3)))*dot(A,c))-1/44352.
    coneq[25797]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*dot(A,c))-1/133056.
    coneq[25798]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/266112.
    coneq[25799]=dot(b,dot(A,c*dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*dot(A,c))-1/88704.
    coneq[25800]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*dot(A,c))-1/399168.
    coneq[25801]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/798336.
    coneq[25802]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*dot(A,c))-1/266112.
    coneq[25803]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/1596672.
    coneq[25804]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*dot(A,c))-1/532224.
    coneq[25805]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/177408.
    coneq[25806]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**4)))*dot(A,c))-1/41580.
    coneq[25807]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*dot(A,c))-1/166320.
    coneq[25808]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/498960.
    coneq[25809]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/997920.
    coneq[25810]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/332640.
    coneq[25811]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/124740.
    coneq[25812]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/249480.
    coneq[25813]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/83160.
    coneq[25814]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/166320.
    coneq[25815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**4)))*dot(A,c))-1/83160.
    coneq[25816]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*dot(A,c))-1/332640.
    coneq[25817]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/997920.
    coneq[25818]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1995840.
    coneq[25819]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25820]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,c))-1/249480.
    coneq[25821]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/498960.
    coneq[25822]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,c))-1/166320.
    coneq[25823]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/332640.
    coneq[25824]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**5)))*dot(A,c))-1/33264.
    coneq[25825]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**4))))*dot(A,c))-1/166320.
    coneq[25826]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/665280.
    coneq[25827]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1995840.
    coneq[25828]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3991680.
    coneq[25829]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[25830]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/498960.
    coneq[25831]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/997920.
    coneq[25832]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/332640.
    coneq[25833]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/665280.
    coneq[25834]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*dot(A,c))-1/133056.
    coneq[25835]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/399168.
    coneq[25836]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/798336.
    coneq[25837]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/266112.
    coneq[25838]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/99792.
    coneq[25839]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/199584.
    coneq[25840]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*dot(A,c))-1/66528.
    coneq[25841]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/199584.
    coneq[25842]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/399168.
    coneq[25843]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/133056.
    coneq[25844]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/33264.
    coneq[25845]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/99792.
    coneq[25846]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/199584.
    coneq[25847]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/66528.
    coneq[25848]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/66528.
    coneq[25849]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/199584.
    coneq[25850]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/399168.
    coneq[25851]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/133056.
    coneq[25852]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**4)))*dot(A,c))-1/27720.
    coneq[25853]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/110880.
    coneq[25854]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/332640.
    coneq[25855]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/665280.
    coneq[25856]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/221760.
    coneq[25857]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/83160.
    coneq[25858]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/166320.
    coneq[25859]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/55440.
    coneq[25860]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/110880.
    coneq[25861]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/24948.
    coneq[25862]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/49896.
    coneq[25863]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/99792.
    coneq[25864]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/22176.
    coneq[25865]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/66528.
    coneq[25866]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/133056.
    coneq[25867]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/44352.
    coneq[25868]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/16632.
    coneq[25869]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/33264.
    coneq[25870]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)*dot(A,c)))*dot(A,c))-1/11088.
    coneq[25871]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/44352.
    coneq[25872]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/133056.
    coneq[25873]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/266112.
    coneq[25874]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/88704.
    coneq[25875]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/49896.
    coneq[25876]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/99792.
    coneq[25877]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/199584.
    coneq[25878]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/33264.
    coneq[25879]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/66528.
    coneq[25880]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/22176.
    coneq[25881]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/44352.
    coneq[25882]=dot(b,dot(A,c**2*dot(A,c**7))*dot(A,c))-1/2464.
    coneq[25883]=dot(b,dot(A,c**2*dot(A,dot(A,c**6)))*dot(A,c))-1/17248.
    coneq[25884]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**5))))*dot(A,c))-1/103488.
    coneq[25885]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/517440.
    coneq[25886]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/2069760.
    coneq[25887]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/6209280.
    coneq[25888]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/12418560.
    coneq[25889]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/4139520.
    coneq[25890]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/1552320.
    coneq[25891]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/3104640.
    coneq[25892]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[25893]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/2069760.
    coneq[25894]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/413952.
    coneq[25895]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/1241856.
    coneq[25896]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2483712.
    coneq[25897]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/827904.
    coneq[25898]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/310464.
    coneq[25899]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/620928.
    coneq[25900]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/206976.
    coneq[25901]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/620928.
    coneq[25902]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/1241856.
    coneq[25903]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/413952.
    coneq[25904]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**4))))*dot(A,c))-1/86240.
    coneq[25905]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/344960.
    coneq[25906]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1034880.
    coneq[25907]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/2069760.
    coneq[25908]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/689920.
    coneq[25909]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/258720.
    coneq[25910]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/517440.
    coneq[25911]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/172480.
    coneq[25912]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/344960.
    coneq[25913]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/68992.
    coneq[25914]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/206976.
    coneq[25915]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/413952.
    coneq[25916]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/137984.
    coneq[25917]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/51744.
    coneq[25918]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/103488.
    coneq[25919]=dot(b,dot(A,c**2*dot(A,dot(A,c**4*dot(A,c))))*dot(A,c))-1/34496.
    coneq[25920]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/155232.
    coneq[25921]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/310464.
    coneq[25922]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/620928.
    coneq[25923]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/137984.
    coneq[25924]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/413952.
    coneq[25925]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/827904.
    coneq[25926]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/275968.
    coneq[25927]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/103488.
    coneq[25928]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/206976.
    coneq[25929]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/68992.
    coneq[25930]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/137984.
    coneq[25931]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**5)))*dot(A,c))-1/14784.
    coneq[25932]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**4))))*dot(A,c))-1/73920.
    coneq[25933]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/295680.
    coneq[25934]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/887040.
    coneq[25935]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1774080.
    coneq[25936]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/591360.
    coneq[25937]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/221760.
    coneq[25938]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/443520.
    coneq[25939]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/147840.
    coneq[25940]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/295680.
    coneq[25941]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c))-1/59136.
    coneq[25942]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/177408.
    coneq[25943]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/354816.
    coneq[25944]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/118272.
    coneq[25945]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/44352.
    coneq[25946]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/88704.
    coneq[25947]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c))-1/29568.
    coneq[25948]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/88704.
    coneq[25949]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/177408.
    coneq[25950]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/59136.
    coneq[25951]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**4)))*dot(A,c))-1/12320.
    coneq[25952]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c))-1/49280.
    coneq[25953]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/147840.
    coneq[25954]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/295680.
    coneq[25955]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/98560.
    coneq[25956]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c))-1/36960.
    coneq[25957]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/73920.
    coneq[25958]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c))-1/24640.
    coneq[25959]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/49280.
    coneq[25960]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**3)))*dot(A,c))-1/9856.
    coneq[25961]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c))-1/29568.
    coneq[25962]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/59136.
    coneq[25963]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c))-1/19712.
    coneq[25964]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c**2)))*dot(A,c))-1/7392.
    coneq[25965]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,dot(A,c))))*dot(A,c))-1/14784.
    coneq[25966]=dot(b,dot(A,c**2*dot(A,c**5*dot(A,c)))*dot(A,c))-1/4928.
    coneq[25967]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/29568.
    coneq[25968]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/88704.
    coneq[25969]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/177408.
    coneq[25970]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/59136.
    coneq[25971]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/59136.
    coneq[25972]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/177408.
    coneq[25973]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/354816.
    coneq[25974]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/118272.
    coneq[25975]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c))-1/24640.
    coneq[25976]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/98560.
    coneq[25977]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/295680.
    coneq[25978]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/591360.
    coneq[25979]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/197120.
    coneq[25980]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/73920.
    coneq[25981]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/147840.
    coneq[25982]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/49280.
    coneq[25983]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/98560.
    coneq[25984]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/22176.
    coneq[25985]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[25986]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[25987]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/19712.
    coneq[25988]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/59136.
    coneq[25989]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/118272.
    coneq[25990]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/39424.
    coneq[25991]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/14784.
    coneq[25992]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/29568.
    coneq[25993]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c))-1/9856.
    coneq[25994]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/29568.
    coneq[25995]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/59136.
    coneq[25996]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/19712.
    coneq[25997]=dot(b,dot(A,c**3*dot(A,c**6))*dot(A,c))-1/2156.
    coneq[25998]=dot(b,dot(A,c**3*dot(A,dot(A,c**5)))*dot(A,c))-1/12936.
    coneq[25999]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/64680.
    coneq[26000]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/258720.
    coneq[26001]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/776160.
    coneq[26002]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/1552320.
    coneq[26003]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/517440.
    coneq[26004]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/194040.
    coneq[26005]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/388080.
    coneq[26006]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/129360.
    coneq[26007]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/258720.
    coneq[26008]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/51744.
    coneq[26009]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/155232.
    coneq[26010]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/310464.
    coneq[26011]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/103488.
    coneq[26012]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/38808.
    coneq[26013]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/77616.
    coneq[26014]=dot(b,dot(A,c**3*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/25872.
    coneq[26015]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/77616.
    coneq[26016]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/155232.
    coneq[26017]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/51744.
    coneq[26018]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**4)))*dot(A,c))-1/10780.
    coneq[26019]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/43120.
    coneq[26020]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/129360.
    coneq[26021]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/258720.
    coneq[26022]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/86240.
    coneq[26023]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/32340.
    coneq[26024]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/64680.
    coneq[26025]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/21560.
    coneq[26026]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/43120.
    coneq[26027]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/8624.
    coneq[26028]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/25872.
    coneq[26029]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/51744.
    coneq[26030]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/17248.
    coneq[26031]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/6468.
    coneq[26032]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/12936.
    coneq[26033]=dot(b,dot(A,c**3*dot(A,c**4*dot(A,c)))*dot(A,c))-1/4312.
    coneq[26034]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/19404.
    coneq[26035]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/38808.
    coneq[26036]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/77616.
    coneq[26037]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/17248.
    coneq[26038]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/51744.
    coneq[26039]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/103488.
    coneq[26040]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/34496.
    coneq[26041]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/12936.
    coneq[26042]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/25872.
    coneq[26043]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/8624.
    coneq[26044]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/17248.
    coneq[26045]=dot(b,dot(A,c**4*dot(A,c**5))*dot(A,c))-1/1848.
    coneq[26046]=dot(b,dot(A,c**4*dot(A,dot(A,c**4)))*dot(A,c))-1/9240.
    coneq[26047]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/36960.
    coneq[26048]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/110880.
    coneq[26049]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/221760.
    coneq[26050]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/73920.
    coneq[26051]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/27720.
    coneq[26052]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/55440.
    coneq[26053]=dot(b,dot(A,c**4*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/18480.
    coneq[26054]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/36960.
    coneq[26055]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**3)))*dot(A,c))-1/7392.
    coneq[26056]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/22176.
    coneq[26057]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/44352.
    coneq[26058]=dot(b,dot(A,c**4*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/14784.
    coneq[26059]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/5544.
    coneq[26060]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/11088.
    coneq[26061]=dot(b,dot(A,c**4*dot(A,c**3*dot(A,c)))*dot(A,c))-1/3696.
    coneq[26062]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/11088.
    coneq[26063]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/22176.
    coneq[26064]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/7392.
    coneq[26065]=dot(b,dot(A,c**5*dot(A,c**4))*dot(A,c))-1/1540.
    coneq[26066]=dot(b,dot(A,c**5*dot(A,dot(A,c**3)))*dot(A,c))-1/6160.
    coneq[26067]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/18480.
    coneq[26068]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/36960.
    coneq[26069]=dot(b,dot(A,c**5*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/12320.
    coneq[26070]=dot(b,dot(A,c**5*dot(A,c*dot(A,c**2)))*dot(A,c))-1/4620.
    coneq[26071]=dot(b,dot(A,c**5*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/9240.
    coneq[26072]=dot(b,dot(A,c**5*dot(A,c**2*dot(A,c)))*dot(A,c))-1/3080.
    coneq[26073]=dot(b,dot(A,c**5*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/6160.
    coneq[26074]=dot(b,dot(A,c**6*dot(A,c**3))*dot(A,c))-1/1232.
    coneq[26075]=dot(b,dot(A,c**6*dot(A,dot(A,c**2)))*dot(A,c))-1/3696.
    coneq[26076]=dot(b,dot(A,c**6*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/7392.
    coneq[26077]=dot(b,dot(A,c**6*dot(A,c*dot(A,c)))*dot(A,c))-1/2464.
    coneq[26078]=dot(b,dot(A,c**7*dot(A,c**2))*dot(A,c))-1/924.
    coneq[26079]=dot(b,dot(A,c**7*dot(A,dot(A,c)))*dot(A,c))-1/1848.
    coneq[26080]=dot(b,dot(A,c**8*dot(A,c))*dot(A,c))-1/616.
    coneq[26081]=dot(b,dot(A,dot(A,c**4)*dot(A,c**4))*dot(A,c))-1/7700.
    coneq[26082]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c**3)))*dot(A,c))-1/30800.
    coneq[26083]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/92400.
    coneq[26084]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/184800.
    coneq[26085]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/61600.
    coneq[26086]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/23100.
    coneq[26087]=dot(b,dot(A,dot(A,c**4)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/46200.
    coneq[26088]=dot(b,dot(A,dot(A,c**4)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/15400.
    coneq[26089]=dot(b,dot(A,dot(A,c**4)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/30800.
    coneq[26090]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c**3)))*dot(A,c))-1/123200.
    coneq[26091]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/369600.
    coneq[26092]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/739200.
    coneq[26093]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/246400.
    coneq[26094]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/92400.
    coneq[26095]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/184800.
    coneq[26096]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/61600.
    coneq[26097]=dot(b,dot(A,dot(A,dot(A,c**3))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/123200.
    coneq[26098]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/1108800.
    coneq[26099]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/2217600.
    coneq[26100]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/739200.
    coneq[26101]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/277200.
    coneq[26102]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/554400.
    coneq[26103]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/184800.
    coneq[26104]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/369600.
    coneq[26105]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/4435200.
    coneq[26106]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/1478400.
    coneq[26107]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/554400.
    coneq[26108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/1108800.
    coneq[26109]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/369600.
    coneq[26110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/739200.
    coneq[26111]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/492800.
    coneq[26112]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/184800.
    coneq[26113]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/369600.
    coneq[26114]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/123200.
    coneq[26115]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/246400.
    coneq[26116]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/69300.
    coneq[26117]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/138600.
    coneq[26118]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/46200.
    coneq[26119]=dot(b,dot(A,dot(A,c*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/92400.
    coneq[26120]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/277200.
    coneq[26121]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/92400.
    coneq[26122]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/184800.
    coneq[26123]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/30800.
    coneq[26124]=dot(b,dot(A,dot(A,c**2*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/61600.
    coneq[26125]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/123200.
    coneq[26126]=dot(b,dot(A,dot(A,c**3)*dot(A,c**5))*dot(A,c))-1/7392.
    coneq[26127]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**4)))*dot(A,c))-1/36960.
    coneq[26128]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/147840.
    coneq[26129]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/443520.
    coneq[26130]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/887040.
    coneq[26131]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/295680.
    coneq[26132]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[26133]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[26134]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/73920.
    coneq[26135]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/147840.
    coneq[26136]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/29568.
    coneq[26137]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/88704.
    coneq[26138]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/177408.
    coneq[26139]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/59136.
    coneq[26140]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/22176.
    coneq[26141]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[26142]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/14784.
    coneq[26143]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/44352.
    coneq[26144]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[26145]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/29568.
    coneq[26146]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**5))*dot(A,c))-1/22176.
    coneq[26147]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**4)))*dot(A,c))-1/110880.
    coneq[26148]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/443520.
    coneq[26149]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/1330560.
    coneq[26150]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/2661120.
    coneq[26151]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/887040.
    coneq[26152]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/332640.
    coneq[26153]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/665280.
    coneq[26154]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/221760.
    coneq[26155]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/443520.
    coneq[26156]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**3)))*dot(A,c))-1/88704.
    coneq[26157]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/266112.
    coneq[26158]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/532224.
    coneq[26159]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/177408.
    coneq[26160]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/66528.
    coneq[26161]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/133056.
    coneq[26162]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**3*dot(A,c)))*dot(A,c))-1/44352.
    coneq[26163]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/133056.
    coneq[26164]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/266112.
    coneq[26165]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/88704.
    coneq[26166]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**5))*dot(A,c))-1/44352.
    coneq[26167]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**4)))*dot(A,c))-1/221760.
    coneq[26168]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/887040.
    coneq[26169]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/2661120.
    coneq[26170]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/5322240.
    coneq[26171]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/1774080.
    coneq[26172]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/665280.
    coneq[26173]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/1330560.
    coneq[26174]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/443520.
    coneq[26175]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/887040.
    coneq[26176]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**3)))*dot(A,c))-1/177408.
    coneq[26177]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/532224.
    coneq[26178]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/1064448.
    coneq[26179]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/354816.
    coneq[26180]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/133056.
    coneq[26181]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/266112.
    coneq[26182]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**3*dot(A,c)))*dot(A,c))-1/88704.
    coneq[26183]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/266112.
    coneq[26184]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/532224.
    coneq[26185]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/177408.
    coneq[26186]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**5))*dot(A,c))-1/14784.
    coneq[26187]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**4)))*dot(A,c))-1/73920.
    coneq[26188]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/295680.
    coneq[26189]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/887040.
    coneq[26190]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1774080.
    coneq[26191]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/591360.
    coneq[26192]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[26193]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[26194]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/147840.
    coneq[26195]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/295680.
    coneq[26196]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**3)))*dot(A,c))-1/59136.
    coneq[26197]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/177408.
    coneq[26198]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/354816.
    coneq[26199]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/118272.
    coneq[26200]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/44352.
    coneq[26201]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[26202]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**3*dot(A,c)))*dot(A,c))-1/29568.
    coneq[26203]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/88704.
    coneq[26204]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/177408.
    coneq[26205]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/59136.
    coneq[26206]=dot(b,dot(A,dot(A,c**2)*dot(A,c**6))*dot(A,c))-1/6468.
    coneq[26207]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**5)))*dot(A,c))-1/38808.
    coneq[26208]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/194040.
    coneq[26209]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/776160.
    coneq[26210]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2328480.
    coneq[26211]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4656960.
    coneq[26212]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1552320.
    coneq[26213]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/582120.
    coneq[26214]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1164240.
    coneq[26215]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/388080.
    coneq[26216]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/776160.
    coneq[26217]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/155232.
    coneq[26218]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/465696.
    coneq[26219]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/931392.
    coneq[26220]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/310464.
    coneq[26221]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/116424.
    coneq[26222]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/232848.
    coneq[26223]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/77616.
    coneq[26224]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/232848.
    coneq[26225]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/465696.
    coneq[26226]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/155232.
    coneq[26227]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**4)))*dot(A,c))-1/32340.
    coneq[26228]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/129360.
    coneq[26229]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/388080.
    coneq[26230]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/776160.
    coneq[26231]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/258720.
    coneq[26232]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/97020.
    coneq[26233]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/194040.
    coneq[26234]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/64680.
    coneq[26235]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/129360.
    coneq[26236]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/25872.
    coneq[26237]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/77616.
    coneq[26238]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/155232.
    coneq[26239]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/51744.
    coneq[26240]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/19404.
    coneq[26241]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/38808.
    coneq[26242]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4*dot(A,c)))*dot(A,c))-1/12936.
    coneq[26243]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/58212.
    coneq[26244]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/116424.
    coneq[26245]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/232848.
    coneq[26246]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/51744.
    coneq[26247]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/155232.
    coneq[26248]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/310464.
    coneq[26249]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/103488.
    coneq[26250]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/38808.
    coneq[26251]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/77616.
    coneq[26252]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/25872.
    coneq[26253]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/51744.
    coneq[26254]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**6))*dot(A,c))-1/12936.
    coneq[26255]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**5)))*dot(A,c))-1/77616.
    coneq[26256]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/388080.
    coneq[26257]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/1552320.
    coneq[26258]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/4656960.
    coneq[26259]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/9313920.
    coneq[26260]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/3104640.
    coneq[26261]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/1164240.
    coneq[26262]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/2328480.
    coneq[26263]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/776160.
    coneq[26264]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/1552320.
    coneq[26265]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/310464.
    coneq[26266]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/931392.
    coneq[26267]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1862784.
    coneq[26268]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/620928.
    coneq[26269]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/232848.
    coneq[26270]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/465696.
    coneq[26271]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/155232.
    coneq[26272]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/465696.
    coneq[26273]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/931392.
    coneq[26274]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/310464.
    coneq[26275]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**4)))*dot(A,c))-1/64680.
    coneq[26276]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/258720.
    coneq[26277]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/776160.
    coneq[26278]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1552320.
    coneq[26279]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/517440.
    coneq[26280]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/194040.
    coneq[26281]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/388080.
    coneq[26282]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/129360.
    coneq[26283]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/258720.
    coneq[26284]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/51744.
    coneq[26285]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/155232.
    coneq[26286]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/310464.
    coneq[26287]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/103488.
    coneq[26288]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/38808.
    coneq[26289]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/77616.
    coneq[26290]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4*dot(A,c)))*dot(A,c))-1/25872.
    coneq[26291]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/116424.
    coneq[26292]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/232848.
    coneq[26293]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/465696.
    coneq[26294]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/103488.
    coneq[26295]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/310464.
    coneq[26296]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/620928.
    coneq[26297]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/206976.
    coneq[26298]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/77616.
    coneq[26299]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/155232.
    coneq[26300]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/51744.
    coneq[26301]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/103488.
    coneq[26302]=dot(b,dot(A,dot(A,c)*dot(A,c**7))*dot(A,c))-1/4928.
    coneq[26303]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**6)))*dot(A,c))-1/34496.
    coneq[26304]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**5))))*dot(A,c))-1/206976.
    coneq[26305]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c))-1/1034880.
    coneq[26306]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c))-1/4139520.
    coneq[26307]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c))-1/12418560.
    coneq[26308]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c))-1/24837120.
    coneq[26309]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c))-1/8279040.
    coneq[26310]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c))-1/3104640.
    coneq[26311]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c))-1/6209280.
    coneq[26312]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c))-1/2069760.
    coneq[26313]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c))-1/4139520.
    coneq[26314]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c))-1/827904.
    coneq[26315]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c))-1/2483712.
    coneq[26316]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4967424.
    coneq[26317]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c))-1/1655808.
    coneq[26318]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c))-1/620928.
    coneq[26319]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c))-1/1241856.
    coneq[26320]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c))-1/413952.
    coneq[26321]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c))-1/1241856.
    coneq[26322]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c))-1/2483712.
    coneq[26323]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c))-1/827904.
    coneq[26324]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**4))))*dot(A,c))-1/172480.
    coneq[26325]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c))-1/689920.
    coneq[26326]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/2069760.
    coneq[26327]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/4139520.
    coneq[26328]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1379840.
    coneq[26329]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c))-1/517440.
    coneq[26330]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[26331]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c))-1/344960.
    coneq[26332]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/689920.
    coneq[26333]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c))-1/137984.
    coneq[26334]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c))-1/413952.
    coneq[26335]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/827904.
    coneq[26336]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c))-1/275968.
    coneq[26337]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c))-1/103488.
    coneq[26338]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c))-1/206976.
    coneq[26339]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4*dot(A,c))))*dot(A,c))-1/68992.
    coneq[26340]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c))-1/310464.
    coneq[26341]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c))-1/620928.
    coneq[26342]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c))-1/1241856.
    coneq[26343]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c))-1/275968.
    coneq[26344]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c))-1/827904.
    coneq[26345]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1655808.
    coneq[26346]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c))-1/551936.
    coneq[26347]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c))-1/206976.
    coneq[26348]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/413952.
    coneq[26349]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c))-1/137984.
    coneq[26350]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c))-1/275968.
    coneq[26351]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**5)))*dot(A,c))-1/29568.
    coneq[26352]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**4))))*dot(A,c))-1/147840.
    coneq[26353]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/591360.
    coneq[26354]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1774080.
    coneq[26355]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3548160.
    coneq[26356]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1182720.
    coneq[26357]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/443520.
    coneq[26358]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/887040.
    coneq[26359]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/295680.
    coneq[26360]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/591360.
    coneq[26361]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c))-1/118272.
    coneq[26362]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/354816.
    coneq[26363]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/709632.
    coneq[26364]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/236544.
    coneq[26365]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/88704.
    coneq[26366]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/177408.
    coneq[26367]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c))-1/59136.
    coneq[26368]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/177408.
    coneq[26369]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/354816.
    coneq[26370]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/118272.
    coneq[26371]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**4)))*dot(A,c))-1/24640.
    coneq[26372]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c))-1/98560.
    coneq[26373]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/295680.
    coneq[26374]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/591360.
    coneq[26375]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/197120.
    coneq[26376]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c))-1/73920.
    coneq[26377]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/147840.
    coneq[26378]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c))-1/49280.
    coneq[26379]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/98560.
    coneq[26380]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**3)))*dot(A,c))-1/19712.
    coneq[26381]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c))-1/59136.
    coneq[26382]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/118272.
    coneq[26383]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c))-1/39424.
    coneq[26384]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c**2)))*dot(A,c))-1/14784.
    coneq[26385]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,dot(A,c))))*dot(A,c))-1/29568.
    coneq[26386]=dot(b,dot(A,dot(A,c)*dot(A,c**5*dot(A,c)))*dot(A,c))-1/9856.
    coneq[26387]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c))-1/59136.
    coneq[26388]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c))-1/177408.
    coneq[26389]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/354816.
    coneq[26390]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c))-1/118272.
    coneq[26391]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c))-1/118272.
    coneq[26392]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c))-1/354816.
    coneq[26393]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/709632.
    coneq[26394]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c))-1/236544.
    coneq[26395]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c))-1/49280.
    coneq[26396]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c))-1/197120.
    coneq[26397]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/591360.
    coneq[26398]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1182720.
    coneq[26399]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/394240.
    coneq[26400]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c))-1/147840.
    coneq[26401]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/295680.
    coneq[26402]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c))-1/98560.
    coneq[26403]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/197120.
    coneq[26404]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/44352.
    coneq[26405]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[26406]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/177408.
    coneq[26407]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c))-1/39424.
    coneq[26408]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/118272.
    coneq[26409]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/236544.
    coneq[26410]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/78848.
    coneq[26411]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/29568.
    coneq[26412]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/59136.
    coneq[26413]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c))-1/19712.
    coneq[26414]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/59136.
    coneq[26415]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/118272.
    coneq[26416]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/39424.
    coneq[26417]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**4))*dot(A,c))-1/6160.
    coneq[26418]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**3)))*dot(A,c))-1/24640.
    coneq[26419]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/73920.
    coneq[26420]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/147840.
    coneq[26421]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/49280.
    coneq[26422]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/18480.
    coneq[26423]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/36960.
    coneq[26424]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/12320.
    coneq[26425]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/24640.
    coneq[26426]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**4))*dot(A,c))-1/18480.
    coneq[26427]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*dot(A,c))-1/73920.
    coneq[26428]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[26429]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[26430]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/147840.
    coneq[26431]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/55440.
    coneq[26432]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/110880.
    coneq[26433]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/36960.
    coneq[26434]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/73920.
    coneq[26435]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**4))*dot(A,c))-1/36960.
    coneq[26436]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*dot(A,c))-1/147840.
    coneq[26437]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/443520.
    coneq[26438]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/887040.
    coneq[26439]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/295680.
    coneq[26440]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/110880.
    coneq[26441]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/221760.
    coneq[26442]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/73920.
    coneq[26443]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/147840.
    coneq[26444]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**4))*dot(A,c))-1/12320.
    coneq[26445]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c))-1/49280.
    coneq[26446]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/147840.
    coneq[26447]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/295680.
    coneq[26448]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/98560.
    coneq[26449]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/36960.
    coneq[26450]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/73920.
    coneq[26451]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/24640.
    coneq[26452]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/49280.
    coneq[26453]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**5))*dot(A,c))-1/5544.
    coneq[26454]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**4)))*dot(A,c))-1/27720.
    coneq[26455]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/110880.
    coneq[26456]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/332640.
    coneq[26457]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/665280.
    coneq[26458]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/221760.
    coneq[26459]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/83160.
    coneq[26460]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/166320.
    coneq[26461]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/55440.
    coneq[26462]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/110880.
    coneq[26463]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/22176.
    coneq[26464]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/66528.
    coneq[26465]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/133056.
    coneq[26466]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/44352.
    coneq[26467]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/16632.
    coneq[26468]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/33264.
    coneq[26469]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/11088.
    coneq[26470]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/33264.
    coneq[26471]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/66528.
    coneq[26472]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/22176.
    coneq[26473]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**5))*dot(A,c))-1/11088.
    coneq[26474]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**4)))*dot(A,c))-1/55440.
    coneq[26475]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/221760.
    coneq[26476]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/665280.
    coneq[26477]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/1330560.
    coneq[26478]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/443520.
    coneq[26479]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/166320.
    coneq[26480]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/332640.
    coneq[26481]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/110880.
    coneq[26482]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/221760.
    coneq[26483]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*dot(A,c))-1/44352.
    coneq[26484]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/133056.
    coneq[26485]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/266112.
    coneq[26486]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/88704.
    coneq[26487]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/33264.
    coneq[26488]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/66528.
    coneq[26489]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*dot(A,c))-1/22176.
    coneq[26490]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/66528.
    coneq[26491]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/133056.
    coneq[26492]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/44352.
    coneq[26493]=dot(b,dot(A,c*dot(A,c)*dot(A,c**6))*dot(A,c))-1/4312.
    coneq[26494]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**5)))*dot(A,c))-1/25872.
    coneq[26495]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**4))))*dot(A,c))-1/129360.
    coneq[26496]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c))-1/517440.
    coneq[26497]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c))-1/1552320.
    coneq[26498]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c))-1/3104640.
    coneq[26499]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c))-1/1034880.
    coneq[26500]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c))-1/388080.
    coneq[26501]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c))-1/776160.
    coneq[26502]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c))-1/258720.
    coneq[26503]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c))-1/517440.
    coneq[26504]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c))-1/103488.
    coneq[26505]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c))-1/310464.
    coneq[26506]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/620928.
    coneq[26507]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c))-1/206976.
    coneq[26508]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c))-1/77616.
    coneq[26509]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c))-1/155232.
    coneq[26510]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c))-1/51744.
    coneq[26511]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c))-1/155232.
    coneq[26512]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c))-1/310464.
    coneq[26513]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c))-1/103488.
    coneq[26514]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**4)))*dot(A,c))-1/21560.
    coneq[26515]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c))-1/86240.
    coneq[26516]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/258720.
    coneq[26517]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/517440.
    coneq[26518]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/172480.
    coneq[26519]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c))-1/64680.
    coneq[26520]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/129360.
    coneq[26521]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c))-1/43120.
    coneq[26522]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/86240.
    coneq[26523]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**3)))*dot(A,c))-1/17248.
    coneq[26524]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c))-1/51744.
    coneq[26525]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/103488.
    coneq[26526]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c))-1/34496.
    coneq[26527]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c**2)))*dot(A,c))-1/12936.
    coneq[26528]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c))-1/25872.
    coneq[26529]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4*dot(A,c)))*dot(A,c))-1/8624.
    coneq[26530]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c))-1/38808.
    coneq[26531]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c))-1/77616.
    coneq[26532]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c))-1/155232.
    coneq[26533]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c))-1/34496.
    coneq[26534]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c))-1/103488.
    coneq[26535]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/206976.
    coneq[26536]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c))-1/68992.
    coneq[26537]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c))-1/25872.
    coneq[26538]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/51744.
    coneq[26539]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c))-1/17248.
    coneq[26540]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c))-1/34496.
    coneq[26541]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c**3))*dot(A,c))-1/4928.
    coneq[26542]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c))-1/14784.
    coneq[26543]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/29568.
    coneq[26544]=dot(b,dot(A,c**2*dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c))-1/9856.
    coneq[26545]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c))-1/44352.
    coneq[26546]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[26547]=dot(b,dot(A,c**2*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c))-1/29568.
    coneq[26548]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/177408.
    coneq[26549]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c))-1/59136.
    coneq[26550]=dot(b,dot(A,c**2*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/19712.
    coneq[26551]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**4))*dot(A,c))-1/4620.
    coneq[26552]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c))-1/18480.
    coneq[26553]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/55440.
    coneq[26554]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/110880.
    coneq[26555]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/36960.
    coneq[26556]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/13860.
    coneq[26557]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/27720.
    coneq[26558]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/9240.
    coneq[26559]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/18480.
    coneq[26560]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**4))*dot(A,c))-1/9240.
    coneq[26561]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c))-1/36960.
    coneq[26562]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[26563]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[26564]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/73920.
    coneq[26565]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/27720.
    coneq[26566]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/55440.
    coneq[26567]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/18480.
    coneq[26568]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/36960.
    coneq[26569]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**5))*dot(A,c))-1/3696.
    coneq[26570]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c))-1/18480.
    coneq[26571]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/73920.
    coneq[26572]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/221760.
    coneq[26573]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/443520.
    coneq[26574]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/147840.
    coneq[26575]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/55440.
    coneq[26576]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/110880.
    coneq[26577]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/36960.
    coneq[26578]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/73920.
    coneq[26579]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/14784.
    coneq[26580]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/44352.
    coneq[26581]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/88704.
    coneq[26582]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/29568.
    coneq[26583]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/11088.
    coneq[26584]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/22176.
    coneq[26585]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/7392.
    coneq[26586]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/22176.
    coneq[26587]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[26588]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/14784.
    coneq[26589]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/3696.
    coneq[26590]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/11088.
    coneq[26591]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/22176.
    coneq[26592]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/7392.
    coneq[26593]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/7392.
    coneq[26594]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/22176.
    coneq[26595]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[26596]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/14784.
    coneq[26597]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**4))*dot(A,c))-1/3080.
    coneq[26598]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c))-1/12320.
    coneq[26599]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/36960.
    coneq[26600]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/73920.
    coneq[26601]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/24640.
    coneq[26602]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/9240.
    coneq[26603]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/18480.
    coneq[26604]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/6160.
    coneq[26605]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/12320.
    coneq[26606]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/2772.
    coneq[26607]=dot(b,dot(A,c**4*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/5544.
    coneq[26608]=dot(b,dot(A,c**4*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/11088.
    coneq[26609]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**3))*dot(A,c))-1/2464.
    coneq[26610]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/7392.
    coneq[26611]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/14784.
    coneq[26612]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/4928.
    coneq[26613]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c**2))*dot(A,c))-1/1848.
    coneq[26614]=dot(b,dot(A,c**5*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/3696.
    coneq[26615]=dot(b,dot(A,c**6*dot(A,c)*dot(A,c))*dot(A,c))-1/1232.
    coneq[26616]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**5))*dot(A,c))-1/7392.
    coneq[26617]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c))-1/36960.
    coneq[26618]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c))-1/147840.
    coneq[26619]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c))-1/443520.
    coneq[26620]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c))-1/887040.
    coneq[26621]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c))-1/295680.
    coneq[26622]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[26623]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[26624]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c))-1/73920.
    coneq[26625]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c))-1/147840.
    coneq[26626]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c))-1/29568.
    coneq[26627]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c))-1/88704.
    coneq[26628]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/177408.
    coneq[26629]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c))-1/59136.
    coneq[26630]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c))-1/22176.
    coneq[26631]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[26632]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c))-1/14784.
    coneq[26633]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c))-1/44352.
    coneq[26634]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[26635]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c))-1/29568.
    coneq[26636]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**4))*dot(A,c))-1/9240.
    coneq[26637]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c))-1/36960.
    coneq[26638]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/110880.
    coneq[26639]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/221760.
    coneq[26640]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/73920.
    coneq[26641]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/27720.
    coneq[26642]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/55440.
    coneq[26643]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/18480.
    coneq[26644]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/36960.
    coneq[26645]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**4))*dot(A,c))-1/18480.
    coneq[26646]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c))-1/73920.
    coneq[26647]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/221760.
    coneq[26648]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/443520.
    coneq[26649]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/147840.
    coneq[26650]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c))-1/55440.
    coneq[26651]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/110880.
    coneq[26652]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c))-1/36960.
    coneq[26653]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/73920.
    coneq[26654]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/11088.
    coneq[26655]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/33264.
    coneq[26656]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/66528.
    coneq[26657]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/22176.
    coneq[26658]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/22176.
    coneq[26659]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/66528.
    coneq[26660]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/133056.
    coneq[26661]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/44352.
    coneq[26662]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/44352.
    coneq[26663]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/133056.
    coneq[26664]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/266112.
    coneq[26665]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/88704.
    coneq[26666]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c**3))*dot(A,c))-1/9856.
    coneq[26667]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c))-1/29568.
    coneq[26668]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/59136.
    coneq[26669]=dot(b,dot(A,dot(A,c)*dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c))-1/19712.
    coneq[26670]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c))-1/88704.
    coneq[26671]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/177408.
    coneq[26672]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c))-1/59136.
    coneq[26673]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/354816.
    coneq[26674]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c))-1/118272.
    coneq[26675]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/39424.
    coneq[26676]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**4))*dot(A,c))-1/6160.
    coneq[26677]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c))-1/24640.
    coneq[26678]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c))-1/73920.
    coneq[26679]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c))-1/147840.
    coneq[26680]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c))-1/49280.
    coneq[26681]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c))-1/18480.
    coneq[26682]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c))-1/36960.
    coneq[26683]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c))-1/12320.
    coneq[26684]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c))-1/24640.
    coneq[26685]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**3))*dot(A,c))-1/7392.
    coneq[26686]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c))-1/22176.
    coneq[26687]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/44352.
    coneq[26688]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c))-1/14784.
    coneq[26689]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c))-1/14784.
    coneq[26690]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c))-1/44352.
    coneq[26691]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/88704.
    coneq[26692]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c))-1/29568.
    coneq[26693]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/8316.
    coneq[26694]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/16632.
    coneq[26695]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/33264.
    coneq[26696]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/66528.
    coneq[26697]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c))-1/4928.
    coneq[26698]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/14784.
    coneq[26699]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/29568.
    coneq[26700]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/9856.
    coneq[26701]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/5544.
    coneq[26702]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/11088.
    coneq[26703]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/22176.
    coneq[26704]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c))-1/3696.
    coneq[26705]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/7392.
    coneq[26706]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/2464.
    coneq[26707]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c))-1/9856.
    coneq[26708]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c))-1/29568.
    coneq[26709]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c))-1/59136.
    coneq[26710]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c))-1/19712.
    coneq[26711]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c))-1/11088.
    coneq[26712]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c))-1/22176.
    coneq[26713]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,c**2))*dot(A,c))-1/22176.
    coneq[26714]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c))-1/44352.
    coneq[26715]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c))-1/7392.
    coneq[26716]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c))-1/14784.
    coneq[26717]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c))-1/4928.
    coneq[26718]=dot(b,dot(A,c**5)*dot(A,c**5)*c)-1/504.
    coneq[26719]=dot(b,dot(A,dot(A,c**4))*dot(A,c**5)*c)-1/2520.
    coneq[26720]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**5)*c)-1/10080.
    coneq[26721]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**5)*c)-1/30240.
    coneq[26722]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**5)*c)-1/60480.
    coneq[26723]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**5)*c)-1/20160.
    coneq[26724]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**5)*c)-1/7560.
    coneq[26725]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**5)*c)-1/15120.
    coneq[26726]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**5)*c)-1/5040.
    coneq[26727]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**5)*c)-1/10080.
    coneq[26728]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**5)*c)-1/2016.
    coneq[26729]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**5)*c)-1/6048.
    coneq[26730]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**5)*c)-1/12096.
    coneq[26731]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**5)*c)-1/4032.
    coneq[26732]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**5)*c)-1/1512.
    coneq[26733]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**5)*c)-1/3024.
    coneq[26734]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**5)*c)-1/1008.
    coneq[26735]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**5)*c)-1/3024.
    coneq[26736]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**5)*c)-1/6048.
    coneq[26737]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**5)*c)-1/2016.
    coneq[26738]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**4))*c)-1/12600.
    coneq[26739]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**4))*c)-1/50400.
    coneq[26740]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**4))*c)-1/151200.
    coneq[26741]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**4))*c)-1/302400.
    coneq[26742]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**4))*c)-1/100800.
    coneq[26743]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**4))*c)-1/37800.
    coneq[26744]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**4))*c)-1/75600.
    coneq[26745]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**4))*c)-1/25200.
    coneq[26746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**4))*c)-1/50400.
    coneq[26747]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**4))*c)-1/10080.
    coneq[26748]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**4))*c)-1/30240.
    coneq[26749]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**4))*c)-1/60480.
    coneq[26750]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**4))*c)-1/20160.
    coneq[26751]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**4))*c)-1/7560.
    coneq[26752]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**4))*c)-1/15120.
    coneq[26753]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**4))*c)-1/5040.
    coneq[26754]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**4))*c)-1/15120.
    coneq[26755]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**4))*c)-1/30240.
    coneq[26756]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**4))*c)-1/10080.
    coneq[26757]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**3)))*c)-1/201600.
    coneq[26758]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**3)))*c)-1/604800.
    coneq[26759]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**3)))*c)-1/1209600.
    coneq[26760]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**3)))*c)-1/403200.
    coneq[26761]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**3)))*c)-1/151200.
    coneq[26762]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3)))*c)-1/302400.
    coneq[26763]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**3)))*c)-1/100800.
    coneq[26764]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**3)))*c)-1/201600.
    coneq[26765]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c**3)))*c)-1/40320.
    coneq[26766]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**3)))*c)-1/120960.
    coneq[26767]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**3)))*c)-1/241920.
    coneq[26768]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**3)))*c)-1/80640.
    coneq[26769]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))*c)-1/30240.
    coneq[26770]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))*c)-1/60480.
    coneq[26771]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c**3)))*c)-1/20160.
    coneq[26772]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**3)))*c)-1/60480.
    coneq[26773]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**3)))*c)-1/120960.
    coneq[26774]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**3)))*c)-1/40320.
    coneq[26775]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/1814400.
    coneq[26776]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/3628800.
    coneq[26777]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/1209600.
    coneq[26778]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/453600.
    coneq[26779]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/907200.
    coneq[26780]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/302400.
    coneq[26781]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/604800.
    coneq[26782]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[26783]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/362880.
    coneq[26784]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/725760.
    coneq[26785]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/241920.
    coneq[26786]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/90720.
    coneq[26787]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/181440.
    coneq[26788]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/60480.
    coneq[26789]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/181440.
    coneq[26790]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/362880.
    coneq[26791]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2))))*c)-1/120960.
    coneq[26792]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/7257600.
    coneq[26793]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/2419200.
    coneq[26794]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/907200.
    coneq[26795]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/1814400.
    coneq[26796]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/604800.
    coneq[26797]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/1209600.
    coneq[26798]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[26799]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/725760.
    coneq[26800]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/1451520.
    coneq[26801]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/483840.
    coneq[26802]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/181440.
    coneq[26803]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/362880.
    coneq[26804]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/120960.
    coneq[26805]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/362880.
    coneq[26806]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/725760.
    coneq[26807]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*c)-1/241920.
    coneq[26808]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/806400.
    coneq[26809]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/302400.
    coneq[26810]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/604800.
    coneq[26811]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/201600.
    coneq[26812]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/403200.
    coneq[26813]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[26814]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/241920.
    coneq[26815]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/483840.
    coneq[26816]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/161280.
    coneq[26817]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/60480.
    coneq[26818]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/120960.
    coneq[26819]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/40320.
    coneq[26820]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/120960.
    coneq[26821]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/241920.
    coneq[26822]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c))))*c)-1/80640.
    coneq[26823]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/113400.
    coneq[26824]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/226800.
    coneq[26825]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/75600.
    coneq[26826]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/151200.
    coneq[26827]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/30240.
    coneq[26828]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/90720.
    coneq[26829]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/181440.
    coneq[26830]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/60480.
    coneq[26831]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/22680.
    coneq[26832]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/45360.
    coneq[26833]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/15120.
    coneq[26834]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/45360.
    coneq[26835]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/90720.
    coneq[26836]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c**2)))*c)-1/30240.
    coneq[26837]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/453600.
    coneq[26838]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/151200.
    coneq[26839]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/302400.
    coneq[26840]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/60480.
    coneq[26841]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/181440.
    coneq[26842]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/362880.
    coneq[26843]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/120960.
    coneq[26844]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/45360.
    coneq[26845]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/90720.
    coneq[26846]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/30240.
    coneq[26847]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/90720.
    coneq[26848]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/181440.
    coneq[26849]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c))))*c)-1/60480.
    coneq[26850]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/50400.
    coneq[26851]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/100800.
    coneq[26852]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/20160.
    coneq[26853]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/60480.
    coneq[26854]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/120960.
    coneq[26855]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/40320.
    coneq[26856]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/15120.
    coneq[26857]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/30240.
    coneq[26858]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/10080.
    coneq[26859]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/30240.
    coneq[26860]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/60480.
    coneq[26861]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2*dot(A,c)))*c)-1/20160.
    coneq[26862]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/201600.
    coneq[26863]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/40320.
    coneq[26864]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/120960.
    coneq[26865]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/241920.
    coneq[26866]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/80640.
    coneq[26867]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/30240.
    coneq[26868]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/60480.
    coneq[26869]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/20160.
    coneq[26870]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/60480.
    coneq[26871]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/120960.
    coneq[26872]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c)))*c)-1/40320.
    coneq[26873]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**3))*c)-1/8064.
    coneq[26874]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**3))*c)-1/24192.
    coneq[26875]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**3))*c)-1/48384.
    coneq[26876]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**3))*c)-1/16128.
    coneq[26877]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c**3))*c)-1/6048.
    coneq[26878]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))*c)-1/12096.
    coneq[26879]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c**3))*c)-1/4032.
    coneq[26880]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**3))*c)-1/12096.
    coneq[26881]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**3))*c)-1/24192.
    coneq[26882]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**3))*c)-1/8064.
    coneq[26883]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/72576.
    coneq[26884]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/145152.
    coneq[26885]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/48384.
    coneq[26886]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/18144.
    coneq[26887]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/36288.
    coneq[26888]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/12096.
    coneq[26889]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/36288.
    coneq[26890]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/72576.
    coneq[26891]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c**2)))*c)-1/24192.
    coneq[26892]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/290304.
    coneq[26893]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/96768.
    coneq[26894]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/36288.
    coneq[26895]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/72576.
    coneq[26896]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/24192.
    coneq[26897]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/72576.
    coneq[26898]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/145152.
    coneq[26899]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c))))*c)-1/48384.
    coneq[26900]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/32256.
    coneq[26901]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/12096.
    coneq[26902]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/24192.
    coneq[26903]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/8064.
    coneq[26904]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/24192.
    coneq[26905]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/48384.
    coneq[26906]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c*dot(A,c)))*c)-1/16128.
    coneq[26907]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c**2))*c)-1/4536.
    coneq[26908]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))*c)-1/9072.
    coneq[26909]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,c**2))*c)-1/3024.
    coneq[26910]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c**2))*c)-1/9072.
    coneq[26911]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c**2))*c)-1/18144.
    coneq[26912]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c**2))*c)-1/6048.
    coneq[26913]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))*c)-1/18144.
    coneq[26914]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))*c)-1/6048.
    coneq[26915]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,dot(A,c)))*c)-1/18144.
    coneq[26916]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,dot(A,c)))*c)-1/36288.
    coneq[26917]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,dot(A,c)))*c)-1/12096.
    coneq[26918]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3*dot(A,c))*c)-1/2016.
    coneq[26919]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3*dot(A,c))*c)-1/6048.
    coneq[26920]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3*dot(A,c))*c)-1/12096.
    coneq[26921]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3*dot(A,c))*c)-1/4032.
    coneq[26922]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c**2))*c)-1/18144.
    coneq[26923]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c**2))*c)-1/36288.
    coneq[26924]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c**2))*c)-1/12096.
    coneq[26925]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,dot(A,c)))*c)-1/72576.
    coneq[26926]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c)))*c)-1/24192.
    coneq[26927]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c)*dot(A,c))*c)-1/8064.
    coneq[26928]=dot(b,dot(A,c**6)*dot(A,c**4)*c)-1/490.
    coneq[26929]=dot(b,dot(A,dot(A,c**5))*dot(A,c**4)*c)-1/2940.
    coneq[26930]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**4)*c)-1/14700.
    coneq[26931]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**4)*c)-1/58800.
    coneq[26932]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**4)*c)-1/176400.
    coneq[26933]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**4)*c)-1/352800.
    coneq[26934]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**4)*c)-1/117600.
    coneq[26935]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**4)*c)-1/44100.
    coneq[26936]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**4)*c)-1/88200.
    coneq[26937]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**4)*c)-1/29400.
    coneq[26938]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**4)*c)-1/58800.
    coneq[26939]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**4)*c)-1/11760.
    coneq[26940]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**4)*c)-1/35280.
    coneq[26941]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**4)*c)-1/70560.
    coneq[26942]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**4)*c)-1/23520.
    coneq[26943]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**4)*c)-1/8820.
    coneq[26944]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**4)*c)-1/17640.
    coneq[26945]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**4)*c)-1/5880.
    coneq[26946]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**4)*c)-1/17640.
    coneq[26947]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**4)*c)-1/35280.
    coneq[26948]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**4)*c)-1/11760.
    coneq[26949]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**4)*c)-1/2450.
    coneq[26950]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**4)*c)-1/9800.
    coneq[26951]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**4)*c)-1/29400.
    coneq[26952]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4)*c)-1/58800.
    coneq[26953]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**4)*c)-1/19600.
    coneq[26954]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**4)*c)-1/7350.
    coneq[26955]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**4)*c)-1/14700.
    coneq[26956]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**4)*c)-1/4900.
    coneq[26957]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4)*c)-1/9800.
    coneq[26958]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**4)*c)-1/1960.
    coneq[26959]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**4)*c)-1/5880.
    coneq[26960]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c)-1/11760.
    coneq[26961]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**4)*c)-1/3920.
    coneq[26962]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**4)*c)-1/1470.
    coneq[26963]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/2940.
    coneq[26964]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**4)*c)-1/980.
    coneq[26965]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**4)*c)-1/4410.
    coneq[26966]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/8820.
    coneq[26967]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/17640.
    coneq[26968]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**4)*c)-1/3920.
    coneq[26969]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**4)*c)-1/11760.
    coneq[26970]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c)-1/23520.
    coneq[26971]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**4)*c)-1/7840.
    coneq[26972]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**4)*c)-1/2940.
    coneq[26973]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4)*c)-1/5880.
    coneq[26974]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**4)*c)-1/1960.
    coneq[26975]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**4)*c)-1/3920.
    coneq[26976]=dot(b,dot(A,c**6)*dot(A,dot(A,c**3))*c)-1/1960.
    coneq[26977]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**3))*c)-1/11760.
    coneq[26978]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**3))*c)-1/58800.
    coneq[26979]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**3))*c)-1/235200.
    coneq[26980]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**3))*c)-1/705600.
    coneq[26981]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**3))*c)-1/1411200.
    coneq[26982]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**3))*c)-1/470400.
    coneq[26983]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**3))*c)-1/176400.
    coneq[26984]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**3))*c)-1/352800.
    coneq[26985]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**3))*c)-1/117600.
    coneq[26986]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**3))*c)-1/235200.
    coneq[26987]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**3))*c)-1/47040.
    coneq[26988]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**3))*c)-1/141120.
    coneq[26989]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3))*c)-1/282240.
    coneq[26990]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**3))*c)-1/94080.
    coneq[26991]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/35280.
    coneq[26992]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/70560.
    coneq[26993]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/23520.
    coneq[26994]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/70560.
    coneq[26995]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/141120.
    coneq[26996]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/47040.
    coneq[26997]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**3))*c)-1/9800.
    coneq[26998]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**3))*c)-1/39200.
    coneq[26999]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3))*c)-1/117600.
    coneq[27000]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3))*c)-1/235200.
    coneq[27001]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3))*c)-1/78400.
    coneq[27002]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/29400.
    coneq[27003]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/58800.
    coneq[27004]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/19600.
    coneq[27005]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/39200.
    coneq[27006]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**3))*c)-1/7840.
    coneq[27007]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/23520.
    coneq[27008]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/47040.
    coneq[27009]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/15680.
    coneq[27010]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**3))*c)-1/5880.
    coneq[27011]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/11760.
    coneq[27012]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**3))*c)-1/3920.
    coneq[27013]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**3))*c)-1/17640.
    coneq[27014]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/35280.
    coneq[27015]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/70560.
    coneq[27016]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**3))*c)-1/15680.
    coneq[27017]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c)-1/47040.
    coneq[27018]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c)-1/94080.
    coneq[27019]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c)-1/31360.
    coneq[27020]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3))*c)-1/11760.
    coneq[27021]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c)-1/23520.
    coneq[27022]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c)-1/7840.
    coneq[27023]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c)-1/15680.
    coneq[27024]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c**2)))*c)-1/5880.
    coneq[27025]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c**2)))*c)-1/35280.
    coneq[27026]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c**2)))*c)-1/176400.
    coneq[27027]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c**2)))*c)-1/705600.
    coneq[27028]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c**2)))*c)-1/2116800.
    coneq[27029]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c**2)))*c)-1/4233600.
    coneq[27030]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*c)-1/1411200.
    coneq[27031]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c**2)))*c)-1/529200.
    coneq[27032]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*c)-1/1058400.
    coneq[27033]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/352800.
    coneq[27034]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/705600.
    coneq[27035]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c**2)))*c)-1/141120.
    coneq[27036]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2)))*c)-1/423360.
    coneq[27037]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*c)-1/846720.
    coneq[27038]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/282240.
    coneq[27039]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/105840.
    coneq[27040]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/211680.
    coneq[27041]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/70560.
    coneq[27042]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/211680.
    coneq[27043]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/423360.
    coneq[27044]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/141120.
    coneq[27045]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c**2)))*c)-1/29400.
    coneq[27046]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2)))*c)-1/117600.
    coneq[27047]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2)))*c)-1/352800.
    coneq[27048]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*c)-1/705600.
    coneq[27049]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/235200.
    coneq[27050]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/88200.
    coneq[27051]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/176400.
    coneq[27052]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/58800.
    coneq[27053]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/117600.
    coneq[27054]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))*c)-1/23520.
    coneq[27055]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/70560.
    coneq[27056]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/141120.
    coneq[27057]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/47040.
    coneq[27058]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c)-1/17640.
    coneq[27059]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/35280.
    coneq[27060]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/11760.
    coneq[27061]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c)-1/52920.
    coneq[27062]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/105840.
    coneq[27063]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/211680.
    coneq[27064]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))*c)-1/47040.
    coneq[27065]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c)-1/141120.
    coneq[27066]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c)-1/282240.
    coneq[27067]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/94080.
    coneq[27068]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c)-1/35280.
    coneq[27069]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c)-1/70560.
    coneq[27070]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/23520.
    coneq[27071]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c)-1/47040.
    coneq[27072]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/11760.
    coneq[27073]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/70560.
    coneq[27074]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/352800.
    coneq[27075]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/1411200.
    coneq[27076]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/4233600.
    coneq[27077]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/8467200.
    coneq[27078]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/2822400.
    coneq[27079]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/1058400.
    coneq[27080]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/2116800.
    coneq[27081]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/705600.
    coneq[27082]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/1411200.
    coneq[27083]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/282240.
    coneq[27084]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/846720.
    coneq[27085]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/1693440.
    coneq[27086]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/564480.
    coneq[27087]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/211680.
    coneq[27088]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/423360.
    coneq[27089]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/141120.
    coneq[27090]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/423360.
    coneq[27091]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/846720.
    coneq[27092]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/282240.
    coneq[27093]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/58800.
    coneq[27094]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/235200.
    coneq[27095]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/705600.
    coneq[27096]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/1411200.
    coneq[27097]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/470400.
    coneq[27098]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/176400.
    coneq[27099]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/352800.
    coneq[27100]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/117600.
    coneq[27101]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/235200.
    coneq[27102]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/47040.
    coneq[27103]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/141120.
    coneq[27104]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/282240.
    coneq[27105]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/94080.
    coneq[27106]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/35280.
    coneq[27107]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/70560.
    coneq[27108]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/23520.
    coneq[27109]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/105840.
    coneq[27110]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/211680.
    coneq[27111]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/423360.
    coneq[27112]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/94080.
    coneq[27113]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/282240.
    coneq[27114]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/564480.
    coneq[27115]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/188160.
    coneq[27116]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/70560.
    coneq[27117]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/141120.
    coneq[27118]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/47040.
    coneq[27119]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c)-1/94080.
    coneq[27120]=dot(b,dot(A,c**6)*dot(A,dot(A,c*dot(A,c)))*c)-1/3920.
    coneq[27121]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c*dot(A,c)))*c)-1/23520.
    coneq[27122]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c*dot(A,c)))*c)-1/117600.
    coneq[27123]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c*dot(A,c)))*c)-1/470400.
    coneq[27124]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c*dot(A,c)))*c)-1/1411200.
    coneq[27125]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c*dot(A,c)))*c)-1/2822400.
    coneq[27126]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*c)-1/940800.
    coneq[27127]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c*dot(A,c)))*c)-1/352800.
    coneq[27128]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*c)-1/705600.
    coneq[27129]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/235200.
    coneq[27130]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/470400.
    coneq[27131]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c*dot(A,c)))*c)-1/94080.
    coneq[27132]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c)))*c)-1/282240.
    coneq[27133]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*c)-1/564480.
    coneq[27134]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/188160.
    coneq[27135]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/70560.
    coneq[27136]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/141120.
    coneq[27137]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/47040.
    coneq[27138]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/141120.
    coneq[27139]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/282240.
    coneq[27140]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/94080.
    coneq[27141]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c*dot(A,c)))*c)-1/19600.
    coneq[27142]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c)))*c)-1/78400.
    coneq[27143]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c)))*c)-1/235200.
    coneq[27144]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*c)-1/470400.
    coneq[27145]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/156800.
    coneq[27146]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/58800.
    coneq[27147]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/117600.
    coneq[27148]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/39200.
    coneq[27149]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/78400.
    coneq[27150]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))*c)-1/15680.
    coneq[27151]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/47040.
    coneq[27152]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/94080.
    coneq[27153]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/31360.
    coneq[27154]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c)-1/11760.
    coneq[27155]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/23520.
    coneq[27156]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/7840.
    coneq[27157]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c)-1/35280.
    coneq[27158]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/70560.
    coneq[27159]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/141120.
    coneq[27160]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))*c)-1/31360.
    coneq[27161]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c)-1/94080.
    coneq[27162]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c)-1/188160.
    coneq[27163]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/62720.
    coneq[27164]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c)-1/23520.
    coneq[27165]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c)-1/47040.
    coneq[27166]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/15680.
    coneq[27167]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c)-1/31360.
    coneq[27168]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c**2))*c)-1/1470.
    coneq[27169]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c**2))*c)-1/8820.
    coneq[27170]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c**2))*c)-1/44100.
    coneq[27171]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c**2))*c)-1/176400.
    coneq[27172]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c**2))*c)-1/529200.
    coneq[27173]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c**2))*c)-1/1058400.
    coneq[27174]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c**2))*c)-1/352800.
    coneq[27175]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c**2))*c)-1/132300.
    coneq[27176]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2))*c)-1/264600.
    coneq[27177]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/88200.
    coneq[27178]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/176400.
    coneq[27179]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c**2))*c)-1/35280.
    coneq[27180]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2))*c)-1/105840.
    coneq[27181]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2))*c)-1/211680.
    coneq[27182]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/70560.
    coneq[27183]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/26460.
    coneq[27184]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/52920.
    coneq[27185]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/17640.
    coneq[27186]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/52920.
    coneq[27187]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/105840.
    coneq[27188]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/35280.
    coneq[27189]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c**2))*c)-1/7350.
    coneq[27190]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2))*c)-1/29400.
    coneq[27191]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2))*c)-1/88200.
    coneq[27192]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2))*c)-1/176400.
    coneq[27193]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/58800.
    coneq[27194]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/22050.
    coneq[27195]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/44100.
    coneq[27196]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/14700.
    coneq[27197]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/29400.
    coneq[27198]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c**2))*c)-1/5880.
    coneq[27199]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/17640.
    coneq[27200]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/35280.
    coneq[27201]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/11760.
    coneq[27202]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c**2))*c)-1/4410.
    coneq[27203]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/8820.
    coneq[27204]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/2940.
    coneq[27205]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c**2))*c)-1/13230.
    coneq[27206]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/26460.
    coneq[27207]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/52920.
    coneq[27208]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c**2))*c)-1/11760.
    coneq[27209]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))*c)-1/35280.
    coneq[27210]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c)-1/70560.
    coneq[27211]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/23520.
    coneq[27212]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2))*c)-1/8820.
    coneq[27213]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c)-1/17640.
    coneq[27214]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/5880.
    coneq[27215]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c)-1/11760.
    coneq[27216]=dot(b,dot(A,c**6)*dot(A,c*dot(A,dot(A,c)))*c)-1/2940.
    coneq[27217]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,dot(A,c)))*c)-1/17640.
    coneq[27218]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,dot(A,c)))*c)-1/88200.
    coneq[27219]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,dot(A,c)))*c)-1/352800.
    coneq[27220]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,dot(A,c)))*c)-1/1058400.
    coneq[27221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,dot(A,c)))*c)-1/2116800.
    coneq[27222]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*c)-1/705600.
    coneq[27223]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,dot(A,c)))*c)-1/264600.
    coneq[27224]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*c)-1/529200.
    coneq[27225]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/176400.
    coneq[27226]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/352800.
    coneq[27227]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,dot(A,c)))*c)-1/70560.
    coneq[27228]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c)))*c)-1/211680.
    coneq[27229]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*c)-1/423360.
    coneq[27230]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/141120.
    coneq[27231]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/52920.
    coneq[27232]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/105840.
    coneq[27233]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/35280.
    coneq[27234]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/105840.
    coneq[27235]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/211680.
    coneq[27236]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/70560.
    coneq[27237]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,dot(A,c)))*c)-1/14700.
    coneq[27238]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c)))*c)-1/58800.
    coneq[27239]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c)))*c)-1/176400.
    coneq[27240]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*c)-1/352800.
    coneq[27241]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/117600.
    coneq[27242]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/44100.
    coneq[27243]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/88200.
    coneq[27244]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/29400.
    coneq[27245]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/58800.
    coneq[27246]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))*c)-1/11760.
    coneq[27247]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/35280.
    coneq[27248]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/70560.
    coneq[27249]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/23520.
    coneq[27250]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c)-1/8820.
    coneq[27251]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/17640.
    coneq[27252]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/5880.
    coneq[27253]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c)-1/26460.
    coneq[27254]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/52920.
    coneq[27255]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/105840.
    coneq[27256]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))*c)-1/23520.
    coneq[27257]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c)-1/70560.
    coneq[27258]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c)-1/141120.
    coneq[27259]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/47040.
    coneq[27260]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c)-1/17640.
    coneq[27261]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c)-1/35280.
    coneq[27262]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/11760.
    coneq[27263]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c)-1/23520.
    coneq[27264]=dot(b,dot(A,c**6)*dot(A,c**2*dot(A,c))*c)-1/980.
    coneq[27265]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2*dot(A,c))*c)-1/5880.
    coneq[27266]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2*dot(A,c))*c)-1/29400.
    coneq[27267]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2*dot(A,c))*c)-1/117600.
    coneq[27268]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2*dot(A,c))*c)-1/352800.
    coneq[27269]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2*dot(A,c))*c)-1/705600.
    coneq[27270]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2*dot(A,c))*c)-1/235200.
    coneq[27271]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2*dot(A,c))*c)-1/88200.
    coneq[27272]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c))*c)-1/176400.
    coneq[27273]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/58800.
    coneq[27274]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/117600.
    coneq[27275]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2*dot(A,c))*c)-1/23520.
    coneq[27276]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c))*c)-1/70560.
    coneq[27277]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c))*c)-1/141120.
    coneq[27278]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/47040.
    coneq[27279]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/17640.
    coneq[27280]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/35280.
    coneq[27281]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/11760.
    coneq[27282]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/35280.
    coneq[27283]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/70560.
    coneq[27284]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/23520.
    coneq[27285]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2*dot(A,c))*c)-1/4900.
    coneq[27286]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c))*c)-1/19600.
    coneq[27287]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c))*c)-1/58800.
    coneq[27288]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c))*c)-1/117600.
    coneq[27289]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/39200.
    coneq[27290]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/14700.
    coneq[27291]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/29400.
    coneq[27292]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/9800.
    coneq[27293]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/19600.
    coneq[27294]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2*dot(A,c))*c)-1/3920.
    coneq[27295]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/11760.
    coneq[27296]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/23520.
    coneq[27297]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/7840.
    coneq[27298]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2*dot(A,c))*c)-1/2940.
    coneq[27299]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/5880.
    coneq[27300]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/1960.
    coneq[27301]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2*dot(A,c))*c)-1/8820.
    coneq[27302]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/17640.
    coneq[27303]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/35280.
    coneq[27304]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2*dot(A,c))*c)-1/7840.
    coneq[27305]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))*c)-1/23520.
    coneq[27306]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c)-1/47040.
    coneq[27307]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/15680.
    coneq[27308]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c))*c)-1/5880.
    coneq[27309]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c)-1/11760.
    coneq[27310]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/3920.
    coneq[27311]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c)-1/7840.
    coneq[27312]=dot(b,dot(A,c**6)*dot(A,dot(A,c)*dot(A,c))*c)-1/1960.
    coneq[27313]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c)*dot(A,c))*c)-1/11760.
    coneq[27314]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c)*dot(A,c))*c)-1/58800.
    coneq[27315]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c)*dot(A,c))*c)-1/235200.
    coneq[27316]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c)*dot(A,c))*c)-1/705600.
    coneq[27317]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c)*dot(A,c))*c)-1/1411200.
    coneq[27318]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*c)-1/470400.
    coneq[27319]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c))*c)-1/176400.
    coneq[27320]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*c)-1/352800.
    coneq[27321]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/117600.
    coneq[27322]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/235200.
    coneq[27323]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c))*c)-1/47040.
    coneq[27324]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c))*c)-1/141120.
    coneq[27325]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*c)-1/282240.
    coneq[27326]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/94080.
    coneq[27327]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/35280.
    coneq[27328]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/70560.
    coneq[27329]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/23520.
    coneq[27330]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/70560.
    coneq[27331]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/141120.
    coneq[27332]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/47040.
    coneq[27333]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c)*dot(A,c))*c)-1/9800.
    coneq[27334]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c))*c)-1/39200.
    coneq[27335]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c))*c)-1/117600.
    coneq[27336]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*c)-1/235200.
    coneq[27337]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/78400.
    coneq[27338]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/29400.
    coneq[27339]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/58800.
    coneq[27340]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/19600.
    coneq[27341]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/39200.
    coneq[27342]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))*c)-1/7840.
    coneq[27343]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/23520.
    coneq[27344]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/47040.
    coneq[27345]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/15680.
    coneq[27346]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c)-1/5880.
    coneq[27347]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/11760.
    coneq[27348]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c)-1/3920.
    coneq[27349]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c)-1/17640.
    coneq[27350]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/35280.
    coneq[27351]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/70560.
    coneq[27352]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))*c)-1/15680.
    coneq[27353]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c)-1/47040.
    coneq[27354]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c)-1/94080.
    coneq[27355]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/31360.
    coneq[27356]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c)-1/11760.
    coneq[27357]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c)-1/23520.
    coneq[27358]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c)-1/7840.
    coneq[27359]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c)-1/15680.
    coneq[27360]=dot(b,dot(A,c**7)*dot(A,c**3)*c)-1/448.
    coneq[27361]=dot(b,dot(A,dot(A,c**6))*dot(A,c**3)*c)-1/3136.
    coneq[27362]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**3)*c)-1/18816.
    coneq[27363]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**3)*c)-1/94080.
    coneq[27364]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**3)*c)-1/376320.
    coneq[27365]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**3)*c)-1/1128960.
    coneq[27366]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**3)*c)-1/2257920.
    coneq[27367]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**3)*c)-1/752640.
    coneq[27368]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**3)*c)-1/282240.
    coneq[27369]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**3)*c)-1/564480.
    coneq[27370]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**3)*c)-1/188160.
    coneq[27371]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**3)*c)-1/376320.
    coneq[27372]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**3)*c)-1/75264.
    coneq[27373]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**3)*c)-1/225792.
    coneq[27374]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**3)*c)-1/451584.
    coneq[27375]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**3)*c)-1/150528.
    coneq[27376]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**3)*c)-1/56448.
    coneq[27377]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/112896.
    coneq[27378]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**3)*c)-1/37632.
    coneq[27379]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**3)*c)-1/112896.
    coneq[27380]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/225792.
    coneq[27381]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**3)*c)-1/75264.
    coneq[27382]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**3)*c)-1/15680.
    coneq[27383]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**3)*c)-1/62720.
    coneq[27384]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3)*c)-1/188160.
    coneq[27385]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3)*c)-1/376320.
    coneq[27386]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3)*c)-1/125440.
    coneq[27387]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**3)*c)-1/47040.
    coneq[27388]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/94080.
    coneq[27389]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**3)*c)-1/31360.
    coneq[27390]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3)*c)-1/62720.
    coneq[27391]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**3)*c)-1/12544.
    coneq[27392]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/37632.
    coneq[27393]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/75264.
    coneq[27394]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/25088.
    coneq[27395]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**3)*c)-1/9408.
    coneq[27396]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/18816.
    coneq[27397]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**3)*c)-1/6272.
    coneq[27398]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**3)*c)-1/28224.
    coneq[27399]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/56448.
    coneq[27400]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/112896.
    coneq[27401]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**3)*c)-1/25088.
    coneq[27402]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/75264.
    coneq[27403]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/150528.
    coneq[27404]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/50176.
    coneq[27405]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**3)*c)-1/18816.
    coneq[27406]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/37632.
    coneq[27407]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/12544.
    coneq[27408]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/25088.
    coneq[27409]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**3)*c)-1/2688.
    coneq[27410]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**3)*c)-1/13440.
    coneq[27411]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**3)*c)-1/53760.
    coneq[27412]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3)*c)-1/161280.
    coneq[27413]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3)*c)-1/322560.
    coneq[27414]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3)*c)-1/107520.
    coneq[27415]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3)*c)-1/40320.
    coneq[27416]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/80640.
    coneq[27417]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3)*c)-1/26880.
    coneq[27418]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3)*c)-1/53760.
    coneq[27419]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**3)*c)-1/10752.
    coneq[27420]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/32256.
    coneq[27421]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/64512.
    coneq[27422]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/21504.
    coneq[27423]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**3)*c)-1/8064.
    coneq[27424]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/16128.
    coneq[27425]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**3)*c)-1/5376.
    coneq[27426]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3)*c)-1/16128.
    coneq[27427]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/32256.
    coneq[27428]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/10752.
    coneq[27429]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**3)*c)-1/2240.
    coneq[27430]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**3)*c)-1/8960.
    coneq[27431]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/26880.
    coneq[27432]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/53760.
    coneq[27433]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/17920.
    coneq[27434]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**3)*c)-1/6720.
    coneq[27435]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/13440.
    coneq[27436]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**3)*c)-1/4480.
    coneq[27437]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/8960.
    coneq[27438]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**3)*c)-1/1792.
    coneq[27439]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/5376.
    coneq[27440]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/10752.
    coneq[27441]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/3584.
    coneq[27442]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**3)*c)-1/1344.
    coneq[27443]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/2688.
    coneq[27444]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**3)*c)-1/896.
    coneq[27445]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**3)*c)-1/5376.
    coneq[27446]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/16128.
    coneq[27447]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/32256.
    coneq[27448]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/10752.
    coneq[27449]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**3)*c)-1/10752.
    coneq[27450]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/32256.
    coneq[27451]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/64512.
    coneq[27452]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/21504.
    coneq[27453]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**3)*c)-1/4480.
    coneq[27454]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**3)*c)-1/17920.
    coneq[27455]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c)-1/53760.
    coneq[27456]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c)-1/107520.
    coneq[27457]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c)-1/35840.
    coneq[27458]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**3)*c)-1/13440.
    coneq[27459]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c)-1/26880.
    coneq[27460]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**3)*c)-1/8960.
    coneq[27461]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c)-1/17920.
    coneq[27462]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**3)*c)-1/4032.
    coneq[27463]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/8064.
    coneq[27464]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/16128.
    coneq[27465]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**3)*c)-1/3584.
    coneq[27466]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3)*c)-1/10752.
    coneq[27467]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c)-1/21504.
    coneq[27468]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3)*c)-1/7168.
    coneq[27469]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**3)*c)-1/2688.
    coneq[27470]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/5376.
    coneq[27471]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**3)*c)-1/1792.
    coneq[27472]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**3)*c)-1/5376.
    coneq[27473]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c)-1/10752.
    coneq[27474]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3)*c)-1/3584.
    coneq[27475]=dot(b,dot(A,c**7)*dot(A,dot(A,c**2))*c)-1/1344.
    coneq[27476]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c**2))*c)-1/9408.
    coneq[27477]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c**2))*c)-1/56448.
    coneq[27478]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c**2))*c)-1/282240.
    coneq[27479]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c**2))*c)-1/1128960.
    coneq[27480]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c**2))*c)-1/3386880.
    coneq[27481]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c**2))*c)-1/6773760.
    coneq[27482]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c**2))*c)-1/2257920.
    coneq[27483]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c**2))*c)-1/846720.
    coneq[27484]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*c)-1/1693440.
    coneq[27485]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/564480.
    coneq[27486]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/1128960.
    coneq[27487]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c**2))*c)-1/225792.
    coneq[27488]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2))*c)-1/677376.
    coneq[27489]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*c)-1/1354752.
    coneq[27490]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/451584.
    coneq[27491]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/169344.
    coneq[27492]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/338688.
    coneq[27493]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/112896.
    coneq[27494]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/338688.
    coneq[27495]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/677376.
    coneq[27496]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/225792.
    coneq[27497]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c**2))*c)-1/47040.
    coneq[27498]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c**2))*c)-1/188160.
    coneq[27499]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2))*c)-1/564480.
    coneq[27500]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*c)-1/1128960.
    coneq[27501]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/376320.
    coneq[27502]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/141120.
    coneq[27503]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/282240.
    coneq[27504]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/94080.
    coneq[27505]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/188160.
    coneq[27506]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/37632.
    coneq[27507]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/112896.
    coneq[27508]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/225792.
    coneq[27509]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/75264.
    coneq[27510]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/28224.
    coneq[27511]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/56448.
    coneq[27512]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/18816.
    coneq[27513]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/84672.
    coneq[27514]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/169344.
    coneq[27515]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/338688.
    coneq[27516]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/75264.
    coneq[27517]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/225792.
    coneq[27518]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/451584.
    coneq[27519]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/150528.
    coneq[27520]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/56448.
    coneq[27521]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/112896.
    coneq[27522]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/37632.
    coneq[27523]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/75264.
    coneq[27524]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c**2))*c)-1/8064.
    coneq[27525]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c**2))*c)-1/40320.
    coneq[27526]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2))*c)-1/161280.
    coneq[27527]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2))*c)-1/483840.
    coneq[27528]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*c)-1/967680.
    coneq[27529]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/322560.
    coneq[27530]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/120960.
    coneq[27531]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/241920.
    coneq[27532]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/80640.
    coneq[27533]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/161280.
    coneq[27534]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27535]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/96768.
    coneq[27536]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/193536.
    coneq[27537]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/64512.
    coneq[27538]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/24192.
    coneq[27539]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/48384.
    coneq[27540]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/16128.
    coneq[27541]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/48384.
    coneq[27542]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/96768.
    coneq[27543]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27544]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c**2))*c)-1/6720.
    coneq[27545]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/26880.
    coneq[27546]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/80640.
    coneq[27547]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/161280.
    coneq[27548]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/53760.
    coneq[27549]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/20160.
    coneq[27550]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/40320.
    coneq[27551]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/13440.
    coneq[27552]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/26880.
    coneq[27553]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/5376.
    coneq[27554]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/16128.
    coneq[27555]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27556]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/10752.
    coneq[27557]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/4032.
    coneq[27558]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/8064.
    coneq[27559]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c**2))*c)-1/2688.
    coneq[27560]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/16128.
    coneq[27561]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/48384.
    coneq[27562]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/96768.
    coneq[27563]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27564]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27565]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/96768.
    coneq[27566]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/193536.
    coneq[27567]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/64512.
    coneq[27568]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c**2))*c)-1/13440.
    coneq[27569]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c)-1/53760.
    coneq[27570]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c)-1/161280.
    coneq[27571]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c)-1/322560.
    coneq[27572]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c)-1/107520.
    coneq[27573]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/40320.
    coneq[27574]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/80640.
    coneq[27575]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/26880.
    coneq[27576]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/53760.
    coneq[27577]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/12096.
    coneq[27578]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/24192.
    coneq[27579]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/48384.
    coneq[27580]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2))*c)-1/10752.
    coneq[27581]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27582]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c)-1/64512.
    coneq[27583]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c)-1/21504.
    coneq[27584]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/8064.
    coneq[27585]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/16128.
    coneq[27586]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c)-1/5376.
    coneq[27587]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/16128.
    coneq[27588]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[27589]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c)-1/10752.
    coneq[27590]=dot(b,dot(A,c**7)*dot(A,dot(A,dot(A,c)))*c)-1/2688.
    coneq[27591]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,dot(A,c)))*c)-1/18816.
    coneq[27592]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,dot(A,c)))*c)-1/112896.
    coneq[27593]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,dot(A,c)))*c)-1/564480.
    coneq[27594]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,dot(A,c)))*c)-1/2257920.
    coneq[27595]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,dot(A,c)))*c)-1/6773760.
    coneq[27596]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,dot(A,c)))*c)-1/13547520.
    coneq[27597]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c)-1/4515840.
    coneq[27598]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*c)-1/1693440.
    coneq[27599]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c)-1/3386880.
    coneq[27600]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/1128960.
    coneq[27601]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/2257920.
    coneq[27602]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,dot(A,c)))*c)-1/451584.
    coneq[27603]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*c)-1/1354752.
    coneq[27604]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c)-1/2709504.
    coneq[27605]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/903168.
    coneq[27606]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/338688.
    coneq[27607]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/677376.
    coneq[27608]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/225792.
    coneq[27609]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/677376.
    coneq[27610]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/1354752.
    coneq[27611]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/451584.
    coneq[27612]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,dot(A,c)))*c)-1/94080.
    coneq[27613]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c)))*c)-1/376320.
    coneq[27614]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*c)-1/1128960.
    coneq[27615]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c)-1/2257920.
    coneq[27616]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/752640.
    coneq[27617]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/282240.
    coneq[27618]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/564480.
    coneq[27619]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/188160.
    coneq[27620]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/376320.
    coneq[27621]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/75264.
    coneq[27622]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/225792.
    coneq[27623]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/451584.
    coneq[27624]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/150528.
    coneq[27625]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/56448.
    coneq[27626]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/112896.
    coneq[27627]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/37632.
    coneq[27628]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/169344.
    coneq[27629]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/338688.
    coneq[27630]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/677376.
    coneq[27631]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/150528.
    coneq[27632]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/451584.
    coneq[27633]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/903168.
    coneq[27634]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/301056.
    coneq[27635]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/112896.
    coneq[27636]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/225792.
    coneq[27637]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/75264.
    coneq[27638]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/150528.
    coneq[27639]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,dot(A,c)))*c)-1/16128.
    coneq[27640]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c)))*c)-1/80640.
    coneq[27641]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c)))*c)-1/322560.
    coneq[27642]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*c)-1/967680.
    coneq[27643]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c)-1/1935360.
    coneq[27644]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/645120.
    coneq[27645]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/241920.
    coneq[27646]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/483840.
    coneq[27647]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/161280.
    coneq[27648]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/322560.
    coneq[27649]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27650]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/193536.
    coneq[27651]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/387072.
    coneq[27652]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/129024.
    coneq[27653]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/48384.
    coneq[27654]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/96768.
    coneq[27655]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/32256.
    coneq[27656]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/96768.
    coneq[27657]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/193536.
    coneq[27658]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27659]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c)-1/13440.
    coneq[27660]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/53760.
    coneq[27661]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/161280.
    coneq[27662]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/322560.
    coneq[27663]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/107520.
    coneq[27664]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/40320.
    coneq[27665]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/80640.
    coneq[27666]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/26880.
    coneq[27667]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/53760.
    coneq[27668]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/10752.
    coneq[27669]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/32256.
    coneq[27670]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27671]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/21504.
    coneq[27672]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/8064.
    coneq[27673]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/16128.
    coneq[27674]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/5376.
    coneq[27675]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/32256.
    coneq[27676]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/96768.
    coneq[27677]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/193536.
    coneq[27678]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27679]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27680]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/193536.
    coneq[27681]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/387072.
    coneq[27682]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/129024.
    coneq[27683]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c)-1/26880.
    coneq[27684]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c)-1/107520.
    coneq[27685]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c)-1/322560.
    coneq[27686]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c)-1/645120.
    coneq[27687]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/215040.
    coneq[27688]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/80640.
    coneq[27689]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/161280.
    coneq[27690]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/53760.
    coneq[27691]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/107520.
    coneq[27692]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/24192.
    coneq[27693]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/48384.
    coneq[27694]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/96768.
    coneq[27695]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c)-1/21504.
    coneq[27696]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27697]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c)-1/129024.
    coneq[27698]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/43008.
    coneq[27699]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/16128.
    coneq[27700]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/32256.
    coneq[27701]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/10752.
    coneq[27702]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c)-1/32256.
    coneq[27703]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[27704]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/21504.
    coneq[27705]=dot(b,dot(A,c**7)*dot(A,c*dot(A,c))*c)-1/896.
    coneq[27706]=dot(b,dot(A,dot(A,c**6))*dot(A,c*dot(A,c))*c)-1/6272.
    coneq[27707]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c*dot(A,c))*c)-1/37632.
    coneq[27708]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c*dot(A,c))*c)-1/188160.
    coneq[27709]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c*dot(A,c))*c)-1/752640.
    coneq[27710]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c*dot(A,c))*c)-1/2257920.
    coneq[27711]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c*dot(A,c))*c)-1/4515840.
    coneq[27712]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c*dot(A,c))*c)-1/1505280.
    coneq[27713]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c*dot(A,c))*c)-1/564480.
    coneq[27714]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*c)-1/1128960.
    coneq[27715]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/376320.
    coneq[27716]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/752640.
    coneq[27717]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c*dot(A,c))*c)-1/150528.
    coneq[27718]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c))*c)-1/451584.
    coneq[27719]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*c)-1/903168.
    coneq[27720]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/301056.
    coneq[27721]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/112896.
    coneq[27722]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/225792.
    coneq[27723]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/75264.
    coneq[27724]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/225792.
    coneq[27725]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/451584.
    coneq[27726]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/150528.
    coneq[27727]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c*dot(A,c))*c)-1/31360.
    coneq[27728]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c*dot(A,c))*c)-1/125440.
    coneq[27729]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c))*c)-1/376320.
    coneq[27730]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*c)-1/752640.
    coneq[27731]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/250880.
    coneq[27732]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/94080.
    coneq[27733]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/188160.
    coneq[27734]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/62720.
    coneq[27735]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/125440.
    coneq[27736]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/25088.
    coneq[27737]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/75264.
    coneq[27738]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/150528.
    coneq[27739]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/50176.
    coneq[27740]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/18816.
    coneq[27741]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/37632.
    coneq[27742]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/12544.
    coneq[27743]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/56448.
    coneq[27744]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/112896.
    coneq[27745]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/225792.
    coneq[27746]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/50176.
    coneq[27747]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/150528.
    coneq[27748]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/301056.
    coneq[27749]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/100352.
    coneq[27750]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/37632.
    coneq[27751]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/75264.
    coneq[27752]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/25088.
    coneq[27753]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/50176.
    coneq[27754]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c*dot(A,c))*c)-1/5376.
    coneq[27755]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c*dot(A,c))*c)-1/26880.
    coneq[27756]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c))*c)-1/107520.
    coneq[27757]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c))*c)-1/322560.
    coneq[27758]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*c)-1/645120.
    coneq[27759]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/215040.
    coneq[27760]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/80640.
    coneq[27761]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/161280.
    coneq[27762]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/53760.
    coneq[27763]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/107520.
    coneq[27764]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27765]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/64512.
    coneq[27766]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/129024.
    coneq[27767]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/43008.
    coneq[27768]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/16128.
    coneq[27769]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/32256.
    coneq[27770]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/10752.
    coneq[27771]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/32256.
    coneq[27772]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/64512.
    coneq[27773]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27774]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c*dot(A,c))*c)-1/4480.
    coneq[27775]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/17920.
    coneq[27776]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/53760.
    coneq[27777]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/107520.
    coneq[27778]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/35840.
    coneq[27779]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/13440.
    coneq[27780]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/26880.
    coneq[27781]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/8960.
    coneq[27782]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/17920.
    coneq[27783]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/3584.
    coneq[27784]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/10752.
    coneq[27785]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27786]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/7168.
    coneq[27787]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/2688.
    coneq[27788]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/5376.
    coneq[27789]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c*dot(A,c))*c)-1/1792.
    coneq[27790]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/10752.
    coneq[27791]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/32256.
    coneq[27792]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/64512.
    coneq[27793]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27794]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27795]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/64512.
    coneq[27796]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/129024.
    coneq[27797]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/43008.
    coneq[27798]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c*dot(A,c))*c)-1/8960.
    coneq[27799]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c)-1/35840.
    coneq[27800]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c)-1/107520.
    coneq[27801]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c)-1/215040.
    coneq[27802]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c)-1/71680.
    coneq[27803]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/26880.
    coneq[27804]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/53760.
    coneq[27805]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/17920.
    coneq[27806]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/35840.
    coneq[27807]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/8064.
    coneq[27808]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/16128.
    coneq[27809]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/32256.
    coneq[27810]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c))*c)-1/7168.
    coneq[27811]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27812]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c)-1/43008.
    coneq[27813]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c)-1/14336.
    coneq[27814]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/5376.
    coneq[27815]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/10752.
    coneq[27816]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c)-1/3584.
    coneq[27817]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c)-1/10752.
    coneq[27818]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c)-1/21504.
    coneq[27819]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c)-1/7168.
    coneq[27820]=dot(b,dot(A,c**8)*dot(A,c**2)*c)-1/378.
    coneq[27821]=dot(b,dot(A,dot(A,c**7))*dot(A,c**2)*c)-1/3024.
    coneq[27822]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c**2)*c)-1/21168.
    coneq[27823]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c**2)*c)-1/127008.
    coneq[27824]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c**2)*c)-1/635040.
    coneq[27825]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c**2)*c)-1/2540160.
    coneq[27826]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c**2)*c)-1/7620480.
    coneq[27827]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c**2)*c)-1/15240960.
    coneq[27828]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c**2)*c)-1/5080320.
    coneq[27829]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c**2)*c)-1/1905120.
    coneq[27830]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c**2)*c)-1/3810240.
    coneq[27831]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c**2)*c)-1/1270080.
    coneq[27832]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c**2)*c)-1/2540160.
    coneq[27833]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c**2)*c)-1/508032.
    coneq[27834]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c**2)*c)-1/1524096.
    coneq[27835]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*c)-1/3048192.
    coneq[27836]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c**2)*c)-1/1016064.
    coneq[27837]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c**2)*c)-1/381024.
    coneq[27838]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/762048.
    coneq[27839]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c**2)*c)-1/254016.
    coneq[27840]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c**2)*c)-1/762048.
    coneq[27841]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/1524096.
    coneq[27842]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c**2)*c)-1/508032.
    coneq[27843]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c**2)*c)-1/105840.
    coneq[27844]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c**2)*c)-1/423360.
    coneq[27845]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2)*c)-1/1270080.
    coneq[27846]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*c)-1/2540160.
    coneq[27847]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2)*c)-1/846720.
    coneq[27848]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c**2)*c)-1/317520.
    coneq[27849]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/635040.
    coneq[27850]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c**2)*c)-1/211680.
    coneq[27851]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2)*c)-1/423360.
    coneq[27852]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c**2)*c)-1/84672.
    coneq[27853]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/254016.
    coneq[27854]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/508032.
    coneq[27855]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/169344.
    coneq[27856]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c**2)*c)-1/63504.
    coneq[27857]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/127008.
    coneq[27858]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c**2)*c)-1/42336.
    coneq[27859]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c**2)*c)-1/190512.
    coneq[27860]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/381024.
    coneq[27861]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/762048.
    coneq[27862]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c**2)*c)-1/169344.
    coneq[27863]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/508032.
    coneq[27864]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/1016064.
    coneq[27865]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/338688.
    coneq[27866]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c**2)*c)-1/127008.
    coneq[27867]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/254016.
    coneq[27868]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/84672.
    coneq[27869]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/169344.
    coneq[27870]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c**2)*c)-1/18144.
    coneq[27871]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c**2)*c)-1/90720.
    coneq[27872]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2)*c)-1/362880.
    coneq[27873]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2)*c)-1/1088640.
    coneq[27874]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*c)-1/2177280.
    coneq[27875]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2)*c)-1/725760.
    coneq[27876]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2)*c)-1/272160.
    coneq[27877]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/544320.
    coneq[27878]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2)*c)-1/181440.
    coneq[27879]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2)*c)-1/362880.
    coneq[27880]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c**2)*c)-1/72576.
    coneq[27881]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/217728.
    coneq[27882]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/435456.
    coneq[27883]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/145152.
    coneq[27884]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c**2)*c)-1/54432.
    coneq[27885]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/108864.
    coneq[27886]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c**2)*c)-1/36288.
    coneq[27887]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2)*c)-1/108864.
    coneq[27888]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/217728.
    coneq[27889]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/72576.
    coneq[27890]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c**2)*c)-1/15120.
    coneq[27891]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/60480.
    coneq[27892]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/181440.
    coneq[27893]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/362880.
    coneq[27894]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/120960.
    coneq[27895]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/45360.
    coneq[27896]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/90720.
    coneq[27897]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/30240.
    coneq[27898]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/60480.
    coneq[27899]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c**2)*c)-1/12096.
    coneq[27900]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/36288.
    coneq[27901]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/72576.
    coneq[27902]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/24192.
    coneq[27903]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c**2)*c)-1/9072.
    coneq[27904]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/18144.
    coneq[27905]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c**2)*c)-1/6048.
    coneq[27906]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c**2)*c)-1/36288.
    coneq[27907]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/108864.
    coneq[27908]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/217728.
    coneq[27909]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/72576.
    coneq[27910]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c**2)*c)-1/72576.
    coneq[27911]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/217728.
    coneq[27912]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/435456.
    coneq[27913]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/145152.
    coneq[27914]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c**2)*c)-1/30240.
    coneq[27915]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/120960.
    coneq[27916]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/362880.
    coneq[27917]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/725760.
    coneq[27918]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/241920.
    coneq[27919]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/90720.
    coneq[27920]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/181440.
    coneq[27921]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/60480.
    coneq[27922]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/120960.
    coneq[27923]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c**2)*c)-1/27216.
    coneq[27924]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/54432.
    coneq[27925]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/108864.
    coneq[27926]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c**2)*c)-1/24192.
    coneq[27927]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/72576.
    coneq[27928]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/145152.
    coneq[27929]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/48384.
    coneq[27930]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/18144.
    coneq[27931]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/36288.
    coneq[27932]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/12096.
    coneq[27933]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/36288.
    coneq[27934]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/72576.
    coneq[27935]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/24192.
    coneq[27936]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c**2)*c)-1/2646.
    coneq[27937]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c**2)*c)-1/15876.
    coneq[27938]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c**2)*c)-1/79380.
    coneq[27939]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2)*c)-1/317520.
    coneq[27940]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2)*c)-1/952560.
    coneq[27941]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*c)-1/1905120.
    coneq[27942]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2)*c)-1/635040.
    coneq[27943]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2)*c)-1/238140.
    coneq[27944]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/476280.
    coneq[27945]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2)*c)-1/158760.
    coneq[27946]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2)*c)-1/317520.
    coneq[27947]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2)*c)-1/63504.
    coneq[27948]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/190512.
    coneq[27949]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/381024.
    coneq[27950]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/127008.
    coneq[27951]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2)*c)-1/47628.
    coneq[27952]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/95256.
    coneq[27953]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2)*c)-1/31752.
    coneq[27954]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2)*c)-1/95256.
    coneq[27955]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/190512.
    coneq[27956]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/63504.
    coneq[27957]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c**2)*c)-1/13230.
    coneq[27958]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/52920.
    coneq[27959]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/158760.
    coneq[27960]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/317520.
    coneq[27961]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/105840.
    coneq[27962]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/39690.
    coneq[27963]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/79380.
    coneq[27964]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/26460.
    coneq[27965]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/52920.
    coneq[27966]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c**2)*c)-1/10584.
    coneq[27967]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/31752.
    coneq[27968]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/63504.
    coneq[27969]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/21168.
    coneq[27970]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c**2)*c)-1/7938.
    coneq[27971]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/15876.
    coneq[27972]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c**2)*c)-1/5292.
    coneq[27973]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2)*c)-1/23814.
    coneq[27974]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/47628.
    coneq[27975]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/95256.
    coneq[27976]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2)*c)-1/21168.
    coneq[27977]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/63504.
    coneq[27978]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/127008.
    coneq[27979]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/42336.
    coneq[27980]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/15876.
    coneq[27981]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/31752.
    coneq[27982]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/10584.
    coneq[27983]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/21168.
    coneq[27984]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c**2)*c)-1/2268.
    coneq[27985]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c**2)*c)-1/11340.
    coneq[27986]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/45360.
    coneq[27987]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/136080.
    coneq[27988]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/272160.
    coneq[27989]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/90720.
    coneq[27990]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/34020.
    coneq[27991]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/68040.
    coneq[27992]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/22680.
    coneq[27993]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/45360.
    coneq[27994]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c**2)*c)-1/9072.
    coneq[27995]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/27216.
    coneq[27996]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/54432.
    coneq[27997]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/18144.
    coneq[27998]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c)-1/6804.
    coneq[27999]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/13608.
    coneq[28000]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c**2)*c)-1/4536.
    coneq[28001]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/13608.
    coneq[28002]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/27216.
    coneq[28003]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/9072.
    coneq[28004]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c**2)*c)-1/1890.
    coneq[28005]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/7560.
    coneq[28006]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/22680.
    coneq[28007]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/45360.
    coneq[28008]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/15120.
    coneq[28009]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/5670.
    coneq[28010]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/11340.
    coneq[28011]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/3780.
    coneq[28012]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/7560.
    coneq[28013]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c**2)*c)-1/1512.
    coneq[28014]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/4536.
    coneq[28015]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/9072.
    coneq[28016]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/3024.
    coneq[28017]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c**2)*c)-1/1134.
    coneq[28018]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/2268.
    coneq[28019]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c**2)*c)-1/756.
    coneq[28020]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c**2)*c)-1/6048.
    coneq[28021]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/18144.
    coneq[28022]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/36288.
    coneq[28023]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/12096.
    coneq[28024]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/54432.
    coneq[28025]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/108864.
    coneq[28026]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/36288.
    coneq[28027]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/217728.
    coneq[28028]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/72576.
    coneq[28029]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/24192.
    coneq[28030]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c**2)*c)-1/5670.
    coneq[28031]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/22680.
    coneq[28032]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/68040.
    coneq[28033]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/136080.
    coneq[28034]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/45360.
    coneq[28035]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/17010.
    coneq[28036]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/34020.
    coneq[28037]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/11340.
    coneq[28038]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/22680.
    coneq[28039]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c**2)*c)-1/11340.
    coneq[28040]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/45360.
    coneq[28041]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/136080.
    coneq[28042]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/272160.
    coneq[28043]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/90720.
    coneq[28044]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/34020.
    coneq[28045]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/68040.
    coneq[28046]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/22680.
    coneq[28047]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/45360.
    coneq[28048]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c**2)*c)-1/4536.
    coneq[28049]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c**2)*c)-1/22680.
    coneq[28050]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c)-1/90720.
    coneq[28051]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c)-1/272160.
    coneq[28052]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c)-1/544320.
    coneq[28053]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c)-1/181440.
    coneq[28054]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c)-1/68040.
    coneq[28055]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/136080.
    coneq[28056]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c)-1/45360.
    coneq[28057]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c)-1/90720.
    coneq[28058]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c**2)*c)-1/18144.
    coneq[28059]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/54432.
    coneq[28060]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/108864.
    coneq[28061]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/36288.
    coneq[28062]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c)-1/13608.
    coneq[28063]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/27216.
    coneq[28064]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c**2)*c)-1/9072.
    coneq[28065]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c)-1/27216.
    coneq[28066]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/54432.
    coneq[28067]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/18144.
    coneq[28068]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c**2)*c)-1/4536.
    coneq[28069]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/13608.
    coneq[28070]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/27216.
    coneq[28071]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/9072.
    coneq[28072]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2)*c)-1/9072.
    coneq[28073]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/27216.
    coneq[28074]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/54432.
    coneq[28075]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/18144.
    coneq[28076]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c**2)*c)-1/3780.
    coneq[28077]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2)*c)-1/15120.
    coneq[28078]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c)-1/45360.
    coneq[28079]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c)-1/90720.
    coneq[28080]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c)-1/30240.
    coneq[28081]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c)-1/11340.
    coneq[28082]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c)-1/22680.
    coneq[28083]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c)-1/7560.
    coneq[28084]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c)-1/15120.
    coneq[28085]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c)-1/3402.
    coneq[28086]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/6804.
    coneq[28087]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/13608.
    coneq[28088]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c**2)*c)-1/3024.
    coneq[28089]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/9072.
    coneq[28090]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/18144.
    coneq[28091]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/6048.
    coneq[28092]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c)-1/2268.
    coneq[28093]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/4536.
    coneq[28094]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/1512.
    coneq[28095]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c**2)*c)-1/6048.
    coneq[28096]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c)-1/18144.
    coneq[28097]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c)-1/36288.
    coneq[28098]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c)-1/12096.
    coneq[28099]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c)-1/6804.
    coneq[28100]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/13608.
    coneq[28101]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/27216.
    coneq[28102]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c)-1/4536.
    coneq[28103]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c)-1/9072.
    coneq[28104]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/3024.
    coneq[28105]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c)-1/6048.
    coneq[28106]=dot(b,dot(A,c**8)*dot(A,dot(A,c))*c)-1/756.
    coneq[28107]=dot(b,dot(A,dot(A,c**7))*dot(A,dot(A,c))*c)-1/6048.
    coneq[28108]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,dot(A,c))*c)-1/42336.
    coneq[28109]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,dot(A,c))*c)-1/254016.
    coneq[28110]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,dot(A,c))*c)-1/1270080.
    coneq[28111]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,dot(A,c))*c)-1/5080320.
    coneq[28112]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,dot(A,c))*c)-1/15240960.
    coneq[28113]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,dot(A,c))*c)-1/30481920.
    coneq[28114]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,dot(A,c))*c)-1/10160640.
    coneq[28115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,dot(A,c))*c)-1/3810240.
    coneq[28116]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c)-1/7620480.
    coneq[28117]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,dot(A,c))*c)-1/2540160.
    coneq[28118]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,dot(A,c))*c)-1/5080320.
    coneq[28119]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,dot(A,c))*c)-1/1016064.
    coneq[28120]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*c)-1/3048192.
    coneq[28121]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c)-1/6096384.
    coneq[28122]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*c)-1/2032128.
    coneq[28123]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/762048.
    coneq[28124]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/1524096.
    coneq[28125]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,dot(A,c))*c)-1/508032.
    coneq[28126]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/1524096.
    coneq[28127]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/3048192.
    coneq[28128]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*c)-1/1016064.
    coneq[28129]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,dot(A,c))*c)-1/211680.
    coneq[28130]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,dot(A,c))*c)-1/846720.
    coneq[28131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*c)-1/2540160.
    coneq[28132]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c)-1/5080320.
    coneq[28133]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*c)-1/1693440.
    coneq[28134]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/635040.
    coneq[28135]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/1270080.
    coneq[28136]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c))*c)-1/423360.
    coneq[28137]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*c)-1/846720.
    coneq[28138]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,dot(A,c))*c)-1/169344.
    coneq[28139]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/508032.
    coneq[28140]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/1016064.
    coneq[28141]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/338688.
    coneq[28142]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/127008.
    coneq[28143]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/254016.
    coneq[28144]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,dot(A,c))*c)-1/84672.
    coneq[28145]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/381024.
    coneq[28146]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/762048.
    coneq[28147]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/1524096.
    coneq[28148]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,dot(A,c))*c)-1/338688.
    coneq[28149]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/1016064.
    coneq[28150]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/2032128.
    coneq[28151]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/677376.
    coneq[28152]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/254016.
    coneq[28153]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/508032.
    coneq[28154]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/169344.
    coneq[28155]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/338688.
    coneq[28156]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28157]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28158]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c))*c)-1/725760.
    coneq[28159]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*c)-1/2177280.
    coneq[28160]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c)-1/4354560.
    coneq[28161]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*c)-1/1451520.
    coneq[28162]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/544320.
    coneq[28163]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/1088640.
    coneq[28164]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c))*c)-1/362880.
    coneq[28165]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*c)-1/725760.
    coneq[28166]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28167]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/435456.
    coneq[28168]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/870912.
    coneq[28169]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/290304.
    coneq[28170]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28171]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/217728.
    coneq[28172]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28173]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/217728.
    coneq[28174]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/435456.
    coneq[28175]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28176]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,dot(A,c))*c)-1/30240.
    coneq[28177]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/120960.
    coneq[28178]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/362880.
    coneq[28179]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/725760.
    coneq[28180]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/241920.
    coneq[28181]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28182]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28183]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/60480.
    coneq[28184]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/120960.
    coneq[28185]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/24192.
    coneq[28186]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28187]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28188]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/48384.
    coneq[28189]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28190]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28191]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,dot(A,c))*c)-1/12096.
    coneq[28192]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28193]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/217728.
    coneq[28194]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/435456.
    coneq[28195]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28196]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28197]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/435456.
    coneq[28198]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/870912.
    coneq[28199]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/290304.
    coneq[28200]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,dot(A,c))*c)-1/60480.
    coneq[28201]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/241920.
    coneq[28202]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/725760.
    coneq[28203]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/1451520.
    coneq[28204]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/483840.
    coneq[28205]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28206]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/362880.
    coneq[28207]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/120960.
    coneq[28208]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/241920.
    coneq[28209]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28210]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28211]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/217728.
    coneq[28212]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/48384.
    coneq[28213]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28214]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/290304.
    coneq[28215]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/96768.
    coneq[28216]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28217]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28218]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/24192.
    coneq[28219]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28220]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28221]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/48384.
    coneq[28222]=dot(b,dot(A,c*dot(A,c**6))*dot(A,dot(A,c))*c)-1/5292.
    coneq[28223]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,dot(A,c))*c)-1/31752.
    coneq[28224]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c))*c)-1/158760.
    coneq[28225]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c))*c)-1/635040.
    coneq[28226]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*c)-1/1905120.
    coneq[28227]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c)-1/3810240.
    coneq[28228]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*c)-1/1270080.
    coneq[28229]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/476280.
    coneq[28230]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/952560.
    coneq[28231]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c))*c)-1/317520.
    coneq[28232]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*c)-1/635040.
    coneq[28233]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c))*c)-1/127008.
    coneq[28234]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/381024.
    coneq[28235]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/762048.
    coneq[28236]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/254016.
    coneq[28237]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/95256.
    coneq[28238]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/190512.
    coneq[28239]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c))*c)-1/63504.
    coneq[28240]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/190512.
    coneq[28241]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/381024.
    coneq[28242]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/127008.
    coneq[28243]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,dot(A,c))*c)-1/26460.
    coneq[28244]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/105840.
    coneq[28245]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/317520.
    coneq[28246]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/635040.
    coneq[28247]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/211680.
    coneq[28248]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/79380.
    coneq[28249]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/158760.
    coneq[28250]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/52920.
    coneq[28251]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/105840.
    coneq[28252]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/21168.
    coneq[28253]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/63504.
    coneq[28254]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/127008.
    coneq[28255]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/42336.
    coneq[28256]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/15876.
    coneq[28257]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/31752.
    coneq[28258]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,dot(A,c))*c)-1/10584.
    coneq[28259]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/47628.
    coneq[28260]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/95256.
    coneq[28261]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/190512.
    coneq[28262]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/42336.
    coneq[28263]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/127008.
    coneq[28264]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/254016.
    coneq[28265]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/84672.
    coneq[28266]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/31752.
    coneq[28267]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/63504.
    coneq[28268]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/21168.
    coneq[28269]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/42336.
    coneq[28270]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,dot(A,c))*c)-1/4536.
    coneq[28271]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c)-1/22680.
    coneq[28272]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28273]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/272160.
    coneq[28274]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/544320.
    coneq[28275]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28276]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/68040.
    coneq[28277]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/136080.
    coneq[28278]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28279]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28280]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28281]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28282]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28283]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28284]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/13608.
    coneq[28285]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/27216.
    coneq[28286]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c)-1/9072.
    coneq[28287]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/27216.
    coneq[28288]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28289]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28290]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,dot(A,c))*c)-1/3780.
    coneq[28291]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/15120.
    coneq[28292]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28293]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28294]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/30240.
    coneq[28295]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/11340.
    coneq[28296]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/22680.
    coneq[28297]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/7560.
    coneq[28298]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/15120.
    coneq[28299]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,dot(A,c))*c)-1/3024.
    coneq[28300]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/9072.
    coneq[28301]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28302]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/6048.
    coneq[28303]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,dot(A,c))*c)-1/2268.
    coneq[28304]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/4536.
    coneq[28305]=dot(b,dot(A,c**6*dot(A,c))*dot(A,dot(A,c))*c)-1/1512.
    coneq[28306]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/12096.
    coneq[28307]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28308]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28309]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/24192.
    coneq[28310]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28311]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/217728.
    coneq[28312]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28313]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/435456.
    coneq[28314]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/145152.
    coneq[28315]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/48384.
    coneq[28316]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,dot(A,c))*c)-1/11340.
    coneq[28317]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28318]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/136080.
    coneq[28319]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/272160.
    coneq[28320]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28321]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/34020.
    coneq[28322]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/68040.
    coneq[28323]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/22680.
    coneq[28324]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28325]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,dot(A,c))*c)-1/22680.
    coneq[28326]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28327]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/272160.
    coneq[28328]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/544320.
    coneq[28329]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28330]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/68040.
    coneq[28331]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/136080.
    coneq[28332]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28333]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28334]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,dot(A,c))*c)-1/9072.
    coneq[28335]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28336]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28337]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c)-1/544320.
    coneq[28338]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c)-1/1088640.
    coneq[28339]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c)-1/362880.
    coneq[28340]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c)-1/136080.
    coneq[28341]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/272160.
    coneq[28342]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28343]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28344]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28345]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28346]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/217728.
    coneq[28347]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28348]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/27216.
    coneq[28349]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28350]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28351]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28352]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28353]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28354]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/9072.
    coneq[28355]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/27216.
    coneq[28356]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28357]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28358]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28359]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28360]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/108864.
    coneq[28361]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28362]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,dot(A,c))*c)-1/7560.
    coneq[28363]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c)-1/30240.
    coneq[28364]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c)-1/90720.
    coneq[28365]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c)-1/181440.
    coneq[28366]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c)-1/60480.
    coneq[28367]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c)-1/22680.
    coneq[28368]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/45360.
    coneq[28369]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c)-1/15120.
    coneq[28370]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c)-1/30240.
    coneq[28371]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/6804.
    coneq[28372]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/13608.
    coneq[28373]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/27216.
    coneq[28374]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/6048.
    coneq[28375]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28376]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28377]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/12096.
    coneq[28378]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/4536.
    coneq[28379]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/9072.
    coneq[28380]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/3024.
    coneq[28381]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c)-1/12096.
    coneq[28382]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c)-1/36288.
    coneq[28383]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c)-1/72576.
    coneq[28384]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c)-1/24192.
    coneq[28385]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/13608.
    coneq[28386]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/27216.
    coneq[28387]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/54432.
    coneq[28388]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c)-1/9072.
    coneq[28389]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/18144.
    coneq[28390]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/6048.
    coneq[28391]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c)-1/12096.
    coneq[28392]=dot(b,dot(A,c**9)*dot(A,c)*c)-1/280.
    coneq[28393]=dot(b,dot(A,dot(A,c**8))*dot(A,c)*c)-1/2520.
    coneq[28394]=dot(b,dot(A,dot(A,dot(A,c**7)))*dot(A,c)*c)-1/20160.
    coneq[28395]=dot(b,dot(A,dot(A,dot(A,dot(A,c**6))))*dot(A,c)*c)-1/141120.
    coneq[28396]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**5)))))*dot(A,c)*c)-1/846720.
    coneq[28397]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**4))))))*dot(A,c)*c)-1/4233600.
    coneq[28398]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))))*dot(A,c)*c)-1/16934400.
    coneq[28399]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))))*dot(A,c)*c)-1/50803200.
    coneq[28400]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))))*dot(A,c)*c)-1/101606400.
    coneq[28401]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))))*dot(A,c)*c)-1/33868800.
    coneq[28402]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))))*dot(A,c)*c)-1/12700800.
    coneq[28403]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))))*dot(A,c)*c)-1/25401600.
    coneq[28404]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))))*dot(A,c)*c)-1/8467200.
    coneq[28405]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))))*dot(A,c)*c)-1/16934400.
    coneq[28406]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3))))))*dot(A,c)*c)-1/3386880.
    coneq[28407]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))))*dot(A,c)*c)-1/10160640.
    coneq[28408]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c)-1/20321280.
    coneq[28409]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))))*dot(A,c)*c)-1/6773760.
    coneq[28410]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))))*dot(A,c)*c)-1/2540160.
    coneq[28411]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/5080320.
    coneq[28412]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c))))))*dot(A,c)*c)-1/1693440.
    coneq[28413]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))))*dot(A,c)*c)-1/5080320.
    coneq[28414]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/10160640.
    coneq[28415]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))))*dot(A,c)*c)-1/3386880.
    coneq[28416]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**4)))))*dot(A,c)*c)-1/705600.
    coneq[28417]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3))))))*dot(A,c)*c)-1/2822400.
    coneq[28418]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*c)-1/8467200.
    coneq[28419]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c)-1/16934400.
    coneq[28420]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*c)-1/5644800.
    coneq[28421]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))))*dot(A,c)*c)-1/2116800.
    coneq[28422]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/4233600.
    coneq[28423]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))))*dot(A,c)*c)-1/1411200.
    coneq[28424]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*c)-1/2822400.
    coneq[28425]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**3)))))*dot(A,c)*c)-1/564480.
    coneq[28426]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1693440.
    coneq[28427]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/3386880.
    coneq[28428]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/1128960.
    coneq[28429]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c**2)))))*dot(A,c)*c)-1/423360.
    coneq[28430]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c))))))*dot(A,c)*c)-1/846720.
    coneq[28431]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4*dot(A,c)))))*dot(A,c)*c)-1/282240.
    coneq[28432]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))))*dot(A,c)*c)-1/1270080.
    coneq[28433]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))))*dot(A,c)*c)-1/2540160.
    coneq[28434]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))))*dot(A,c)*c)-1/5080320.
    coneq[28435]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3)))))*dot(A,c)*c)-1/1128960.
    coneq[28436]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/3386880.
    coneq[28437]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/6773760.
    coneq[28438]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/2257920.
    coneq[28439]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))))*dot(A,c)*c)-1/846720.
    coneq[28440]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*c)-1/1693440.
    coneq[28441]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/564480.
    coneq[28442]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/1128960.
    coneq[28443]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**5))))*dot(A,c)*c)-1/120960.
    coneq[28444]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**4)))))*dot(A,c)*c)-1/604800.
    coneq[28445]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3))))))*dot(A,c)*c)-1/2419200.
    coneq[28446]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*c)-1/7257600.
    coneq[28447]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c)-1/14515200.
    coneq[28448]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*c)-1/4838400.
    coneq[28449]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c)*c)-1/1814400.
    coneq[28450]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/3628800.
    coneq[28451]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c)*c)-1/1209600.
    coneq[28452]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*c)-1/2419200.
    coneq[28453]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**3)))))*dot(A,c)*c)-1/483840.
    coneq[28454]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1451520.
    coneq[28455]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2903040.
    coneq[28456]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/967680.
    coneq[28457]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2)))))*dot(A,c)*c)-1/362880.
    coneq[28458]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c)*c)-1/725760.
    coneq[28459]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3*dot(A,c)))))*dot(A,c)*c)-1/241920.
    coneq[28460]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c)*c)-1/725760.
    coneq[28461]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*c)-1/1451520.
    coneq[28462]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/483840.
    coneq[28463]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**4))))*dot(A,c)*c)-1/100800.
    coneq[28464]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/403200.
    coneq[28465]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1209600.
    coneq[28466]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2419200.
    coneq[28467]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/806400.
    coneq[28468]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/302400.
    coneq[28469]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/604800.
    coneq[28470]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/201600.
    coneq[28471]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/403200.
    coneq[28472]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**3))))*dot(A,c)*c)-1/80640.
    coneq[28473]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/241920.
    coneq[28474]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/483840.
    coneq[28475]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/161280.
    coneq[28476]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c**2))))*dot(A,c)*c)-1/60480.
    coneq[28477]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,dot(A,c)))))*dot(A,c)*c)-1/120960.
    coneq[28478]=dot(b,dot(A,dot(A,dot(A,c**5*dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[28479]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**3))))*dot(A,c)*c)-1/241920.
    coneq[28480]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/725760.
    coneq[28481]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/1451520.
    coneq[28482]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/483840.
    coneq[28483]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3))))*dot(A,c)*c)-1/483840.
    coneq[28484]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/1451520.
    coneq[28485]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/2903040.
    coneq[28486]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/967680.
    coneq[28487]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**4))))*dot(A,c)*c)-1/201600.
    coneq[28488]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/806400.
    coneq[28489]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/2419200.
    coneq[28490]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/4838400.
    coneq[28491]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/1612800.
    coneq[28492]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/604800.
    coneq[28493]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/1209600.
    coneq[28494]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/403200.
    coneq[28495]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/806400.
    coneq[28496]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2))))*dot(A,c)*c)-1/181440.
    coneq[28497]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/362880.
    coneq[28498]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c)*c)-1/725760.
    coneq[28499]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**3))))*dot(A,c)*c)-1/161280.
    coneq[28500]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/483840.
    coneq[28501]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/967680.
    coneq[28502]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/322560.
    coneq[28503]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/120960.
    coneq[28504]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/241920.
    coneq[28505]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[28506]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/241920.
    coneq[28507]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/483840.
    coneq[28508]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/161280.
    coneq[28509]=dot(b,dot(A,dot(A,c*dot(A,c**6)))*dot(A,c)*c)-1/17640.
    coneq[28510]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**5))))*dot(A,c)*c)-1/105840.
    coneq[28511]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**4)))))*dot(A,c)*c)-1/529200.
    coneq[28512]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c)*c)-1/2116800.
    coneq[28513]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*c)-1/6350400.
    coneq[28514]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c)-1/12700800.
    coneq[28515]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*c)-1/4233600.
    coneq[28516]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c)*c)-1/1587600.
    coneq[28517]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/3175200.
    coneq[28518]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c)*c)-1/1058400.
    coneq[28519]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*c)-1/2116800.
    coneq[28520]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c)*c)-1/423360.
    coneq[28521]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1270080.
    coneq[28522]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2540160.
    coneq[28523]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/846720.
    coneq[28524]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c)*c)-1/317520.
    coneq[28525]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c)*c)-1/635040.
    coneq[28526]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c)*c)-1/211680.
    coneq[28527]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c)*c)-1/635040.
    coneq[28528]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*c)-1/1270080.
    coneq[28529]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/423360.
    coneq[28530]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**4))))*dot(A,c)*c)-1/88200.
    coneq[28531]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/352800.
    coneq[28532]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1058400.
    coneq[28533]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2116800.
    coneq[28534]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/705600.
    coneq[28535]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/264600.
    coneq[28536]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/529200.
    coneq[28537]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/176400.
    coneq[28538]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/352800.
    coneq[28539]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**3))))*dot(A,c)*c)-1/70560.
    coneq[28540]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/211680.
    coneq[28541]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/423360.
    coneq[28542]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/141120.
    coneq[28543]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c**2))))*dot(A,c)*c)-1/52920.
    coneq[28544]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c)*c)-1/105840.
    coneq[28545]=dot(b,dot(A,dot(A,c*dot(A,c**4*dot(A,c))))*dot(A,c)*c)-1/35280.
    coneq[28546]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c)*c)-1/158760.
    coneq[28547]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/317520.
    coneq[28548]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c)*c)-1/635040.
    coneq[28549]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c)*c)-1/141120.
    coneq[28550]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/423360.
    coneq[28551]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/846720.
    coneq[28552]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/282240.
    coneq[28553]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/105840.
    coneq[28554]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/211680.
    coneq[28555]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/70560.
    coneq[28556]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/141120.
    coneq[28557]=dot(b,dot(A,dot(A,c**2*dot(A,c**5)))*dot(A,c)*c)-1/15120.
    coneq[28558]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**4))))*dot(A,c)*c)-1/75600.
    coneq[28559]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/302400.
    coneq[28560]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/907200.
    coneq[28561]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1814400.
    coneq[28562]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/604800.
    coneq[28563]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/226800.
    coneq[28564]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/453600.
    coneq[28565]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/151200.
    coneq[28566]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/302400.
    coneq[28567]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/60480.
    coneq[28568]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/181440.
    coneq[28569]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/362880.
    coneq[28570]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/120960.
    coneq[28571]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/45360.
    coneq[28572]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/90720.
    coneq[28573]=dot(b,dot(A,dot(A,c**2*dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/30240.
    coneq[28574]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/90720.
    coneq[28575]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/181440.
    coneq[28576]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/60480.
    coneq[28577]=dot(b,dot(A,dot(A,c**3*dot(A,c**4)))*dot(A,c)*c)-1/12600.
    coneq[28578]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/50400.
    coneq[28579]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/151200.
    coneq[28580]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/302400.
    coneq[28581]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/100800.
    coneq[28582]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/37800.
    coneq[28583]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/75600.
    coneq[28584]=dot(b,dot(A,dot(A,c**3*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/25200.
    coneq[28585]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/50400.
    coneq[28586]=dot(b,dot(A,dot(A,c**4*dot(A,c**3)))*dot(A,c)*c)-1/10080.
    coneq[28587]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/30240.
    coneq[28588]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/60480.
    coneq[28589]=dot(b,dot(A,dot(A,c**4*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/20160.
    coneq[28590]=dot(b,dot(A,dot(A,c**5*dot(A,c**2)))*dot(A,c)*c)-1/7560.
    coneq[28591]=dot(b,dot(A,dot(A,c**5*dot(A,dot(A,c))))*dot(A,c)*c)-1/15120.
    coneq[28592]=dot(b,dot(A,dot(A,c**6*dot(A,c)))*dot(A,c)*c)-1/5040.
    coneq[28593]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c**3)))*dot(A,c)*c)-1/40320.
    coneq[28594]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/120960.
    coneq[28595]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/241920.
    coneq[28596]=dot(b,dot(A,dot(A,dot(A,c**3)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[28597]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/362880.
    coneq[28598]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/725760.
    coneq[28599]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/241920.
    coneq[28600]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/1451520.
    coneq[28601]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/483840.
    coneq[28602]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/161280.
    coneq[28603]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**4)))*dot(A,c)*c)-1/37800.
    coneq[28604]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/151200.
    coneq[28605]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/453600.
    coneq[28606]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/907200.
    coneq[28607]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/302400.
    coneq[28608]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/113400.
    coneq[28609]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/226800.
    coneq[28610]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/75600.
    coneq[28611]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/151200.
    coneq[28612]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**4)))*dot(A,c)*c)-1/75600.
    coneq[28613]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/302400.
    coneq[28614]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/907200.
    coneq[28615]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/1814400.
    coneq[28616]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/604800.
    coneq[28617]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/226800.
    coneq[28618]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/453600.
    coneq[28619]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/151200.
    coneq[28620]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/302400.
    coneq[28621]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**5)))*dot(A,c)*c)-1/30240.
    coneq[28622]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**4))))*dot(A,c)*c)-1/151200.
    coneq[28623]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/604800.
    coneq[28624]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1814400.
    coneq[28625]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/3628800.
    coneq[28626]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/1209600.
    coneq[28627]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/453600.
    coneq[28628]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/907200.
    coneq[28629]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/302400.
    coneq[28630]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/604800.
    coneq[28631]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/120960.
    coneq[28632]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/362880.
    coneq[28633]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/725760.
    coneq[28634]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/241920.
    coneq[28635]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/90720.
    coneq[28636]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/181440.
    coneq[28637]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/60480.
    coneq[28638]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/181440.
    coneq[28639]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/362880.
    coneq[28640]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/120960.
    coneq[28641]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**3)))*dot(A,c)*c)-1/30240.
    coneq[28642]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/90720.
    coneq[28643]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/181440.
    coneq[28644]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/60480.
    coneq[28645]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c)*c)-1/60480.
    coneq[28646]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/181440.
    coneq[28647]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/362880.
    coneq[28648]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/120960.
    coneq[28649]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**4)))*dot(A,c)*c)-1/25200.
    coneq[28650]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/100800.
    coneq[28651]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/302400.
    coneq[28652]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/604800.
    coneq[28653]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/201600.
    coneq[28654]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/75600.
    coneq[28655]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/151200.
    coneq[28656]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/50400.
    coneq[28657]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/100800.
    coneq[28658]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/22680.
    coneq[28659]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/45360.
    coneq[28660]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/90720.
    coneq[28661]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/20160.
    coneq[28662]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/60480.
    coneq[28663]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/120960.
    coneq[28664]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[28665]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/15120.
    coneq[28666]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/30240.
    coneq[28667]=dot(b,dot(A,dot(A,c**4*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/10080.
    coneq[28668]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/40320.
    coneq[28669]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/120960.
    coneq[28670]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/241920.
    coneq[28671]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[28672]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/45360.
    coneq[28673]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/90720.
    coneq[28674]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/181440.
    coneq[28675]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/30240.
    coneq[28676]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/60480.
    coneq[28677]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/20160.
    coneq[28678]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/40320.
    coneq[28679]=dot(b,dot(A,c*dot(A,c**7))*dot(A,c)*c)-1/2240.
    coneq[28680]=dot(b,dot(A,c*dot(A,dot(A,c**6)))*dot(A,c)*c)-1/15680.
    coneq[28681]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**5))))*dot(A,c)*c)-1/94080.
    coneq[28682]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c)*c)-1/470400.
    coneq[28683]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c)*c)-1/1881600.
    coneq[28684]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*c)-1/5644800.
    coneq[28685]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c)-1/11289600.
    coneq[28686]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*c)-1/3763200.
    coneq[28687]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c)*c)-1/1411200.
    coneq[28688]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2822400.
    coneq[28689]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c)*c)-1/940800.
    coneq[28690]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*c)-1/1881600.
    coneq[28691]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c)*c)-1/376320.
    coneq[28692]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1128960.
    coneq[28693]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2257920.
    coneq[28694]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/752640.
    coneq[28695]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c)*c)-1/282240.
    coneq[28696]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c)*c)-1/564480.
    coneq[28697]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c)*c)-1/188160.
    coneq[28698]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c)*c)-1/564480.
    coneq[28699]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*c)-1/1128960.
    coneq[28700]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/376320.
    coneq[28701]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**4))))*dot(A,c)*c)-1/78400.
    coneq[28702]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/313600.
    coneq[28703]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/940800.
    coneq[28704]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1881600.
    coneq[28705]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/627200.
    coneq[28706]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/235200.
    coneq[28707]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/470400.
    coneq[28708]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/156800.
    coneq[28709]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/313600.
    coneq[28710]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c)*c)-1/62720.
    coneq[28711]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/188160.
    coneq[28712]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/376320.
    coneq[28713]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/125440.
    coneq[28714]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c)*c)-1/47040.
    coneq[28715]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c)*c)-1/94080.
    coneq[28716]=dot(b,dot(A,c*dot(A,dot(A,c**4*dot(A,c))))*dot(A,c)*c)-1/31360.
    coneq[28717]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c)*c)-1/141120.
    coneq[28718]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/282240.
    coneq[28719]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c)*c)-1/564480.
    coneq[28720]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c)*c)-1/125440.
    coneq[28721]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/376320.
    coneq[28722]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/752640.
    coneq[28723]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/250880.
    coneq[28724]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/94080.
    coneq[28725]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/188160.
    coneq[28726]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/62720.
    coneq[28727]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/125440.
    coneq[28728]=dot(b,dot(A,c*dot(A,c*dot(A,c**5)))*dot(A,c)*c)-1/13440.
    coneq[28729]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**4))))*dot(A,c)*c)-1/67200.
    coneq[28730]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/268800.
    coneq[28731]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/806400.
    coneq[28732]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1612800.
    coneq[28733]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/537600.
    coneq[28734]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/201600.
    coneq[28735]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/403200.
    coneq[28736]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/134400.
    coneq[28737]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/268800.
    coneq[28738]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/53760.
    coneq[28739]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/161280.
    coneq[28740]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/322560.
    coneq[28741]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/107520.
    coneq[28742]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/40320.
    coneq[28743]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/80640.
    coneq[28744]=dot(b,dot(A,c*dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/26880.
    coneq[28745]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/80640.
    coneq[28746]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/161280.
    coneq[28747]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/53760.
    coneq[28748]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**4)))*dot(A,c)*c)-1/11200.
    coneq[28749]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/44800.
    coneq[28750]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/134400.
    coneq[28751]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/268800.
    coneq[28752]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/89600.
    coneq[28753]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/33600.
    coneq[28754]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/67200.
    coneq[28755]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/22400.
    coneq[28756]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/44800.
    coneq[28757]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**3)))*dot(A,c)*c)-1/8960.
    coneq[28758]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/26880.
    coneq[28759]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/53760.
    coneq[28760]=dot(b,dot(A,c*dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/17920.
    coneq[28761]=dot(b,dot(A,c*dot(A,c**4*dot(A,c**2)))*dot(A,c)*c)-1/6720.
    coneq[28762]=dot(b,dot(A,c*dot(A,c**4*dot(A,dot(A,c))))*dot(A,c)*c)-1/13440.
    coneq[28763]=dot(b,dot(A,c*dot(A,c**5*dot(A,c)))*dot(A,c)*c)-1/4480.
    coneq[28764]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c)*c)-1/26880.
    coneq[28765]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/80640.
    coneq[28766]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/161280.
    coneq[28767]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/53760.
    coneq[28768]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c)*c)-1/53760.
    coneq[28769]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/161280.
    coneq[28770]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/322560.
    coneq[28771]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/107520.
    coneq[28772]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c)*c)-1/22400.
    coneq[28773]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/89600.
    coneq[28774]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/268800.
    coneq[28775]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/537600.
    coneq[28776]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/179200.
    coneq[28777]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/67200.
    coneq[28778]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/134400.
    coneq[28779]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/44800.
    coneq[28780]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/89600.
    coneq[28781]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/20160.
    coneq[28782]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[28783]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[28784]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/17920.
    coneq[28785]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/53760.
    coneq[28786]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/107520.
    coneq[28787]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/35840.
    coneq[28788]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/13440.
    coneq[28789]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/26880.
    coneq[28790]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/8960.
    coneq[28791]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/26880.
    coneq[28792]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/53760.
    coneq[28793]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/17920.
    coneq[28794]=dot(b,dot(A,c**2*dot(A,c**6))*dot(A,c)*c)-1/1960.
    coneq[28795]=dot(b,dot(A,c**2*dot(A,dot(A,c**5)))*dot(A,c)*c)-1/11760.
    coneq[28796]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c)-1/58800.
    coneq[28797]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/235200.
    coneq[28798]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/705600.
    coneq[28799]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/1411200.
    coneq[28800]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/470400.
    coneq[28801]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/176400.
    coneq[28802]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/352800.
    coneq[28803]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/117600.
    coneq[28804]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/235200.
    coneq[28805]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/47040.
    coneq[28806]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/141120.
    coneq[28807]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/282240.
    coneq[28808]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/94080.
    coneq[28809]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/35280.
    coneq[28810]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/70560.
    coneq[28811]=dot(b,dot(A,c**2*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/23520.
    coneq[28812]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/70560.
    coneq[28813]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/141120.
    coneq[28814]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/47040.
    coneq[28815]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**4)))*dot(A,c)*c)-1/9800.
    coneq[28816]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/39200.
    coneq[28817]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/117600.
    coneq[28818]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/235200.
    coneq[28819]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/78400.
    coneq[28820]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/29400.
    coneq[28821]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/58800.
    coneq[28822]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/19600.
    coneq[28823]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/39200.
    coneq[28824]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**3)))*dot(A,c)*c)-1/7840.
    coneq[28825]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/23520.
    coneq[28826]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/47040.
    coneq[28827]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/15680.
    coneq[28828]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c**2)))*dot(A,c)*c)-1/5880.
    coneq[28829]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c)-1/11760.
    coneq[28830]=dot(b,dot(A,c**2*dot(A,c**4*dot(A,c)))*dot(A,c)*c)-1/3920.
    coneq[28831]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/17640.
    coneq[28832]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/35280.
    coneq[28833]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/70560.
    coneq[28834]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/15680.
    coneq[28835]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/47040.
    coneq[28836]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/94080.
    coneq[28837]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/31360.
    coneq[28838]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/11760.
    coneq[28839]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/23520.
    coneq[28840]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/7840.
    coneq[28841]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/15680.
    coneq[28842]=dot(b,dot(A,c**3*dot(A,c**5))*dot(A,c)*c)-1/1680.
    coneq[28843]=dot(b,dot(A,c**3*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/8400.
    coneq[28844]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/33600.
    coneq[28845]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/100800.
    coneq[28846]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/201600.
    coneq[28847]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/67200.
    coneq[28848]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/25200.
    coneq[28849]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/50400.
    coneq[28850]=dot(b,dot(A,c**3*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/16800.
    coneq[28851]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/33600.
    coneq[28852]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/6720.
    coneq[28853]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/20160.
    coneq[28854]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/40320.
    coneq[28855]=dot(b,dot(A,c**3*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/13440.
    coneq[28856]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/5040.
    coneq[28857]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/10080.
    coneq[28858]=dot(b,dot(A,c**3*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/3360.
    coneq[28859]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/10080.
    coneq[28860]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/20160.
    coneq[28861]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/6720.
    coneq[28862]=dot(b,dot(A,c**4*dot(A,c**4))*dot(A,c)*c)-1/1400.
    coneq[28863]=dot(b,dot(A,c**4*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/5600.
    coneq[28864]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/16800.
    coneq[28865]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/33600.
    coneq[28866]=dot(b,dot(A,c**4*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/11200.
    coneq[28867]=dot(b,dot(A,c**4*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/4200.
    coneq[28868]=dot(b,dot(A,c**4*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/8400.
    coneq[28869]=dot(b,dot(A,c**4*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/2800.
    coneq[28870]=dot(b,dot(A,c**4*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/5600.
    coneq[28871]=dot(b,dot(A,c**5*dot(A,c**3))*dot(A,c)*c)-1/1120.
    coneq[28872]=dot(b,dot(A,c**5*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/3360.
    coneq[28873]=dot(b,dot(A,c**5*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/6720.
    coneq[28874]=dot(b,dot(A,c**5*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/2240.
    coneq[28875]=dot(b,dot(A,c**6*dot(A,c**2))*dot(A,c)*c)-1/840.
    coneq[28876]=dot(b,dot(A,c**6*dot(A,dot(A,c)))*dot(A,c)*c)-1/1680.
    coneq[28877]=dot(b,dot(A,c**7*dot(A,c))*dot(A,c)*c)-1/560.
    coneq[28878]=dot(b,dot(A,dot(A,c**3)*dot(A,c**4))*dot(A,c)*c)-1/5600.
    coneq[28879]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/22400.
    coneq[28880]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/67200.
    coneq[28881]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/134400.
    coneq[28882]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/44800.
    coneq[28883]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/16800.
    coneq[28884]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/33600.
    coneq[28885]=dot(b,dot(A,dot(A,c**3)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/11200.
    coneq[28886]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/22400.
    coneq[28887]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**4))*dot(A,c)*c)-1/16800.
    coneq[28888]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/67200.
    coneq[28889]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/201600.
    coneq[28890]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/403200.
    coneq[28891]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/134400.
    coneq[28892]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/50400.
    coneq[28893]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/100800.
    coneq[28894]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/33600.
    coneq[28895]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/67200.
    coneq[28896]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**4))*dot(A,c)*c)-1/33600.
    coneq[28897]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/134400.
    coneq[28898]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/403200.
    coneq[28899]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/806400.
    coneq[28900]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/268800.
    coneq[28901]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/100800.
    coneq[28902]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/201600.
    coneq[28903]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/67200.
    coneq[28904]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/134400.
    coneq[28905]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**4))*dot(A,c)*c)-1/11200.
    coneq[28906]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/44800.
    coneq[28907]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/134400.
    coneq[28908]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/268800.
    coneq[28909]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/89600.
    coneq[28910]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/33600.
    coneq[28911]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/67200.
    coneq[28912]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/22400.
    coneq[28913]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/44800.
    coneq[28914]=dot(b,dot(A,dot(A,c**2)*dot(A,c**5))*dot(A,c)*c)-1/5040.
    coneq[28915]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/25200.
    coneq[28916]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/100800.
    coneq[28917]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/302400.
    coneq[28918]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/604800.
    coneq[28919]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/201600.
    coneq[28920]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/75600.
    coneq[28921]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/151200.
    coneq[28922]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/50400.
    coneq[28923]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/100800.
    coneq[28924]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/20160.
    coneq[28925]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/60480.
    coneq[28926]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/120960.
    coneq[28927]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[28928]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/15120.
    coneq[28929]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/30240.
    coneq[28930]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/10080.
    coneq[28931]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/30240.
    coneq[28932]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/60480.
    coneq[28933]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/20160.
    coneq[28934]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**5))*dot(A,c)*c)-1/10080.
    coneq[28935]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/50400.
    coneq[28936]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/201600.
    coneq[28937]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/604800.
    coneq[28938]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/1209600.
    coneq[28939]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/403200.
    coneq[28940]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/151200.
    coneq[28941]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/302400.
    coneq[28942]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/100800.
    coneq[28943]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/201600.
    coneq[28944]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/40320.
    coneq[28945]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/120960.
    coneq[28946]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/241920.
    coneq[28947]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[28948]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/30240.
    coneq[28949]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/60480.
    coneq[28950]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/20160.
    coneq[28951]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/60480.
    coneq[28952]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/120960.
    coneq[28953]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/40320.
    coneq[28954]=dot(b,dot(A,dot(A,c)*dot(A,c**6))*dot(A,c)*c)-1/3920.
    coneq[28955]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**5)))*dot(A,c)*c)-1/23520.
    coneq[28956]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c)-1/117600.
    coneq[28957]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c)-1/470400.
    coneq[28958]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c)-1/1411200.
    coneq[28959]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c)-1/2822400.
    coneq[28960]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c)-1/940800.
    coneq[28961]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c)-1/352800.
    coneq[28962]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c)-1/705600.
    coneq[28963]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c)-1/235200.
    coneq[28964]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c)-1/470400.
    coneq[28965]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c)-1/94080.
    coneq[28966]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/282240.
    coneq[28967]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/564480.
    coneq[28968]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/188160.
    coneq[28969]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c)-1/70560.
    coneq[28970]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c)-1/141120.
    coneq[28971]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c)-1/47040.
    coneq[28972]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c)-1/141120.
    coneq[28973]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c)-1/282240.
    coneq[28974]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/94080.
    coneq[28975]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**4)))*dot(A,c)*c)-1/19600.
    coneq[28976]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c)-1/78400.
    coneq[28977]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/235200.
    coneq[28978]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/470400.
    coneq[28979]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/156800.
    coneq[28980]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/58800.
    coneq[28981]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/117600.
    coneq[28982]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/39200.
    coneq[28983]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/78400.
    coneq[28984]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**3)))*dot(A,c)*c)-1/15680.
    coneq[28985]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/47040.
    coneq[28986]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/94080.
    coneq[28987]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/31360.
    coneq[28988]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c**2)))*dot(A,c)*c)-1/11760.
    coneq[28989]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c)-1/23520.
    coneq[28990]=dot(b,dot(A,dot(A,c)*dot(A,c**4*dot(A,c)))*dot(A,c)*c)-1/7840.
    coneq[28991]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c)-1/35280.
    coneq[28992]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c)-1/70560.
    coneq[28993]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c)-1/141120.
    coneq[28994]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c)-1/31360.
    coneq[28995]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/94080.
    coneq[28996]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/188160.
    coneq[28997]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/62720.
    coneq[28998]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/23520.
    coneq[28999]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/47040.
    coneq[29000]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/15680.
    coneq[29001]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/31360.
    coneq[29002]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c**3))*dot(A,c)*c)-1/4480.
    coneq[29003]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/13440.
    coneq[29004]=dot(b,dot(A,c*dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/26880.
    coneq[29005]=dot(b,dot(A,c*dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/8960.
    coneq[29006]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/40320.
    coneq[29007]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[29008]=dot(b,dot(A,c*dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/26880.
    coneq[29009]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/161280.
    coneq[29010]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/53760.
    coneq[29011]=dot(b,dot(A,c*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/17920.
    coneq[29012]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**4))*dot(A,c)*c)-1/4200.
    coneq[29013]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/16800.
    coneq[29014]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/50400.
    coneq[29015]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/100800.
    coneq[29016]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/33600.
    coneq[29017]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/12600.
    coneq[29018]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/25200.
    coneq[29019]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/8400.
    coneq[29020]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/16800.
    coneq[29021]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**4))*dot(A,c)*c)-1/8400.
    coneq[29022]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/33600.
    coneq[29023]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/100800.
    coneq[29024]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/201600.
    coneq[29025]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/67200.
    coneq[29026]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/25200.
    coneq[29027]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/50400.
    coneq[29028]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/16800.
    coneq[29029]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/33600.
    coneq[29030]=dot(b,dot(A,c*dot(A,c)*dot(A,c**5))*dot(A,c)*c)-1/3360.
    coneq[29031]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c)*c)-1/16800.
    coneq[29032]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c)-1/67200.
    coneq[29033]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c)-1/201600.
    coneq[29034]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c)-1/403200.
    coneq[29035]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c)-1/134400.
    coneq[29036]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c)-1/50400.
    coneq[29037]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c)-1/100800.
    coneq[29038]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c)-1/33600.
    coneq[29039]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c)-1/67200.
    coneq[29040]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c)*c)-1/13440.
    coneq[29041]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c)-1/40320.
    coneq[29042]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/80640.
    coneq[29043]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c)-1/26880.
    coneq[29044]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c)-1/10080.
    coneq[29045]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c)-1/20160.
    coneq[29046]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c)*c)-1/6720.
    coneq[29047]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c)-1/20160.
    coneq[29048]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[29049]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/13440.
    coneq[29050]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**3))*dot(A,c)*c)-1/3360.
    coneq[29051]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/10080.
    coneq[29052]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/20160.
    coneq[29053]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/6720.
    coneq[29054]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c)-1/6720.
    coneq[29055]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/20160.
    coneq[29056]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[29057]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/13440.
    coneq[29058]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**4))*dot(A,c)*c)-1/2800.
    coneq[29059]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/11200.
    coneq[29060]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/33600.
    coneq[29061]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/67200.
    coneq[29062]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/22400.
    coneq[29063]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/8400.
    coneq[29064]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/16800.
    coneq[29065]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/5600.
    coneq[29066]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/11200.
    coneq[29067]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/2520.
    coneq[29068]=dot(b,dot(A,c**3*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/5040.
    coneq[29069]=dot(b,dot(A,c**3*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/10080.
    coneq[29070]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**3))*dot(A,c)*c)-1/2240.
    coneq[29071]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/6720.
    coneq[29072]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/13440.
    coneq[29073]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/4480.
    coneq[29074]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/1680.
    coneq[29075]=dot(b,dot(A,c**4*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/3360.
    coneq[29076]=dot(b,dot(A,c**5*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/1120.
    coneq[29077]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**4))*dot(A,c)*c)-1/5600.
    coneq[29078]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c)-1/22400.
    coneq[29079]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c)-1/67200.
    coneq[29080]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c)-1/134400.
    coneq[29081]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c)-1/44800.
    coneq[29082]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c)-1/16800.
    coneq[29083]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c)-1/33600.
    coneq[29084]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c)-1/11200.
    coneq[29085]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c)-1/22400.
    coneq[29086]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**3))*dot(A,c)*c)-1/6720.
    coneq[29087]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/20160.
    coneq[29088]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/40320.
    coneq[29089]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/13440.
    coneq[29090]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c)-1/13440.
    coneq[29091]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/40320.
    coneq[29092]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/80640.
    coneq[29093]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/26880.
    coneq[29094]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/7560.
    coneq[29095]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/15120.
    coneq[29096]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/30240.
    coneq[29097]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/60480.
    coneq[29098]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c)*c)-1/4480.
    coneq[29099]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c)-1/13440.
    coneq[29100]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/26880.
    coneq[29101]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c)-1/8960.
    coneq[29102]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c)-1/5040.
    coneq[29103]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c)-1/10080.
    coneq[29104]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c)-1/20160.
    coneq[29105]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/3360.
    coneq[29106]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/6720.
    coneq[29107]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/2240.
    coneq[29108]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c)-1/6720.
    coneq[29109]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c)-1/13440.
    coneq[29110]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c)-1/4480.
    coneq[29111]=dot(b,dot(A,c**5)*dot(A,c**4)*c*c)-1/420.
    coneq[29112]=dot(b,dot(A,dot(A,c**4))*dot(A,c**4)*c*c)-1/2100.
    coneq[29113]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**4)*c*c)-1/8400.
    coneq[29114]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**4)*c*c)-1/25200.
    coneq[29115]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4)*c*c)-1/50400.
    coneq[29116]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**4)*c*c)-1/16800.
    coneq[29117]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**4)*c*c)-1/6300.
    coneq[29118]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**4)*c*c)-1/12600.
    coneq[29119]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**4)*c*c)-1/4200.
    coneq[29120]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4)*c*c)-1/8400.
    coneq[29121]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**4)*c*c)-1/1680.
    coneq[29122]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**4)*c*c)-1/5040.
    coneq[29123]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c*c)-1/10080.
    coneq[29124]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**4)*c*c)-1/3360.
    coneq[29125]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**4)*c*c)-1/1260.
    coneq[29126]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**4)*c*c)-1/2520.
    coneq[29127]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**4)*c*c)-1/840.
    coneq[29128]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**4)*c*c)-1/2520.
    coneq[29129]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4)*c*c)-1/5040.
    coneq[29130]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**4)*c*c)-1/1680.
    coneq[29131]=dot(b,dot(A,c**5)*dot(A,dot(A,c**3))*c*c)-1/1680.
    coneq[29132]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**3))*c*c)-1/8400.
    coneq[29133]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**3))*c*c)-1/33600.
    coneq[29134]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3))*c*c)-1/100800.
    coneq[29135]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3))*c*c)-1/201600.
    coneq[29136]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3))*c*c)-1/67200.
    coneq[29137]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3))*c*c)-1/25200.
    coneq[29138]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c*c)-1/50400.
    coneq[29139]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/16800.
    coneq[29140]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/33600.
    coneq[29141]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**3))*c*c)-1/6720.
    coneq[29142]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c*c)-1/20160.
    coneq[29143]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c*c)-1/40320.
    coneq[29144]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/13440.
    coneq[29145]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**3))*c*c)-1/5040.
    coneq[29146]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/10080.
    coneq[29147]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**3))*c*c)-1/3360.
    coneq[29148]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3))*c*c)-1/10080.
    coneq[29149]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c*c)-1/20160.
    coneq[29150]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c*c)-1/6720.
    coneq[29151]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c**2)))*c*c)-1/5040.
    coneq[29152]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/25200.
    coneq[29153]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/100800.
    coneq[29154]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/302400.
    coneq[29155]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/604800.
    coneq[29156]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/201600.
    coneq[29157]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/75600.
    coneq[29158]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/151200.
    coneq[29159]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/50400.
    coneq[29160]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/100800.
    coneq[29161]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/20160.
    coneq[29162]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/60480.
    coneq[29163]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/120960.
    coneq[29164]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/40320.
    coneq[29165]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/15120.
    coneq[29166]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/30240.
    coneq[29167]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/10080.
    coneq[29168]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/30240.
    coneq[29169]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/60480.
    coneq[29170]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c*c)-1/20160.
    coneq[29171]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/10080.
    coneq[29172]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/50400.
    coneq[29173]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/201600.
    coneq[29174]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/604800.
    coneq[29175]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/1209600.
    coneq[29176]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/403200.
    coneq[29177]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/151200.
    coneq[29178]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/302400.
    coneq[29179]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/100800.
    coneq[29180]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/201600.
    coneq[29181]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/40320.
    coneq[29182]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/120960.
    coneq[29183]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/241920.
    coneq[29184]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/80640.
    coneq[29185]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/30240.
    coneq[29186]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/60480.
    coneq[29187]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/20160.
    coneq[29188]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/60480.
    coneq[29189]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/120960.
    coneq[29190]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c*c)-1/40320.
    coneq[29191]=dot(b,dot(A,c**5)*dot(A,dot(A,c*dot(A,c)))*c*c)-1/3360.
    coneq[29192]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/16800.
    coneq[29193]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/67200.
    coneq[29194]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/201600.
    coneq[29195]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/403200.
    coneq[29196]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/134400.
    coneq[29197]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/50400.
    coneq[29198]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/100800.
    coneq[29199]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/33600.
    coneq[29200]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/67200.
    coneq[29201]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/13440.
    coneq[29202]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/40320.
    coneq[29203]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/80640.
    coneq[29204]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/26880.
    coneq[29205]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/10080.
    coneq[29206]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/20160.
    coneq[29207]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/6720.
    coneq[29208]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/20160.
    coneq[29209]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/40320.
    coneq[29210]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c*c)-1/13440.
    coneq[29211]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c**2))*c*c)-1/1260.
    coneq[29212]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c**2))*c*c)-1/6300.
    coneq[29213]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2))*c*c)-1/25200.
    coneq[29214]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2))*c*c)-1/75600.
    coneq[29215]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2))*c*c)-1/151200.
    coneq[29216]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2))*c*c)-1/50400.
    coneq[29217]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2))*c*c)-1/18900.
    coneq[29218]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c*c)-1/37800.
    coneq[29219]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2))*c*c)-1/12600.
    coneq[29220]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2))*c*c)-1/25200.
    coneq[29221]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**2))*c*c)-1/5040.
    coneq[29222]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))*c*c)-1/15120.
    coneq[29223]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*c*c)-1/30240.
    coneq[29224]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))*c*c)-1/10080.
    coneq[29225]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c**2))*c*c)-1/3780.
    coneq[29226]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c*c)-1/7560.
    coneq[29227]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c**2))*c*c)-1/2520.
    coneq[29228]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2))*c*c)-1/7560.
    coneq[29229]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c*c)-1/15120.
    coneq[29230]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c*c)-1/5040.
    coneq[29231]=dot(b,dot(A,c**5)*dot(A,c*dot(A,dot(A,c)))*c*c)-1/2520.
    coneq[29232]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/12600.
    coneq[29233]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/50400.
    coneq[29234]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/151200.
    coneq[29235]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/302400.
    coneq[29236]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/100800.
    coneq[29237]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/37800.
    coneq[29238]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/75600.
    coneq[29239]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/25200.
    coneq[29240]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/50400.
    coneq[29241]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/10080.
    coneq[29242]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/30240.
    coneq[29243]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/60480.
    coneq[29244]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/20160.
    coneq[29245]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/7560.
    coneq[29246]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/15120.
    coneq[29247]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/5040.
    coneq[29248]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/15120.
    coneq[29249]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/30240.
    coneq[29250]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c*c)-1/10080.
    coneq[29251]=dot(b,dot(A,c**5)*dot(A,c**2*dot(A,c))*c*c)-1/840.
    coneq[29252]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2*dot(A,c))*c*c)-1/4200.
    coneq[29253]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c))*c*c)-1/16800.
    coneq[29254]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c))*c*c)-1/50400.
    coneq[29255]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c))*c*c)-1/100800.
    coneq[29256]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c))*c*c)-1/33600.
    coneq[29257]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c))*c*c)-1/12600.
    coneq[29258]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c*c)-1/25200.
    coneq[29259]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c))*c*c)-1/8400.
    coneq[29260]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c))*c*c)-1/16800.
    coneq[29261]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2*dot(A,c))*c*c)-1/3360.
    coneq[29262]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))*c*c)-1/10080.
    coneq[29263]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*c*c)-1/20160.
    coneq[29264]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))*c*c)-1/6720.
    coneq[29265]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c))*c*c)-1/2520.
    coneq[29266]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c*c)-1/5040.
    coneq[29267]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,c))*c*c)-1/1680.
    coneq[29268]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c))*c*c)-1/5040.
    coneq[29269]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*c*c)-1/10080.
    coneq[29270]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c*c)-1/3360.
    coneq[29271]=dot(b,dot(A,c**5)*dot(A,dot(A,c)*dot(A,c))*c*c)-1/1680.
    coneq[29272]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/8400.
    coneq[29273]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/33600.
    coneq[29274]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/100800.
    coneq[29275]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/201600.
    coneq[29276]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/67200.
    coneq[29277]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/25200.
    coneq[29278]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/50400.
    coneq[29279]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/16800.
    coneq[29280]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/33600.
    coneq[29281]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/6720.
    coneq[29282]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/20160.
    coneq[29283]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/40320.
    coneq[29284]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/13440.
    coneq[29285]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/5040.
    coneq[29286]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/10080.
    coneq[29287]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/3360.
    coneq[29288]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/10080.
    coneq[29289]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/20160.
    coneq[29290]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c*c)-1/6720.
    coneq[29291]=dot(b,dot(A,c**6)*dot(A,c**3)*c*c)-1/392.
    coneq[29292]=dot(b,dot(A,dot(A,c**5))*dot(A,c**3)*c*c)-1/2352.
    coneq[29293]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**3)*c*c)-1/11760.
    coneq[29294]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**3)*c*c)-1/47040.
    coneq[29295]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3)*c*c)-1/141120.
    coneq[29296]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3)*c*c)-1/282240.
    coneq[29297]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3)*c*c)-1/94080.
    coneq[29298]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3)*c*c)-1/35280.
    coneq[29299]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3)*c*c)-1/70560.
    coneq[29300]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3)*c*c)-1/23520.
    coneq[29301]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3)*c*c)-1/47040.
    coneq[29302]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**3)*c*c)-1/9408.
    coneq[29303]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3)*c*c)-1/28224.
    coneq[29304]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c*c)-1/56448.
    coneq[29305]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3)*c*c)-1/18816.
    coneq[29306]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**3)*c*c)-1/7056.
    coneq[29307]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/14112.
    coneq[29308]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**3)*c*c)-1/4704.
    coneq[29309]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3)*c*c)-1/14112.
    coneq[29310]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/28224.
    coneq[29311]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3)*c*c)-1/9408.
    coneq[29312]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**3)*c*c)-1/1960.
    coneq[29313]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**3)*c*c)-1/7840.
    coneq[29314]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c*c)-1/23520.
    coneq[29315]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c*c)-1/47040.
    coneq[29316]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c*c)-1/15680.
    coneq[29317]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**3)*c*c)-1/5880.
    coneq[29318]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/11760.
    coneq[29319]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**3)*c*c)-1/3920.
    coneq[29320]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c*c)-1/7840.
    coneq[29321]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**3)*c*c)-1/1568.
    coneq[29322]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**3)*c*c)-1/4704.
    coneq[29323]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/9408.
    coneq[29324]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**3)*c*c)-1/3136.
    coneq[29325]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**3)*c*c)-1/1176.
    coneq[29326]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/2352.
    coneq[29327]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**3)*c*c)-1/784.
    coneq[29328]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**3)*c*c)-1/3528.
    coneq[29329]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/7056.
    coneq[29330]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/14112.
    coneq[29331]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**3)*c*c)-1/3136.
    coneq[29332]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3)*c*c)-1/9408.
    coneq[29333]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c*c)-1/18816.
    coneq[29334]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3)*c*c)-1/6272.
    coneq[29335]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**3)*c*c)-1/2352.
    coneq[29336]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c*c)-1/4704.
    coneq[29337]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**3)*c*c)-1/1568.
    coneq[29338]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3)*c*c)-1/3136.
    coneq[29339]=dot(b,dot(A,c**6)*dot(A,dot(A,c**2))*c*c)-1/1176.
    coneq[29340]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**2))*c*c)-1/7056.
    coneq[29341]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**2))*c*c)-1/35280.
    coneq[29342]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2))*c*c)-1/141120.
    coneq[29343]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2))*c*c)-1/423360.
    coneq[29344]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*c*c)-1/846720.
    coneq[29345]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2))*c*c)-1/282240.
    coneq[29346]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2))*c*c)-1/105840.
    coneq[29347]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c*c)-1/211680.
    coneq[29348]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/70560.
    coneq[29349]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/141120.
    coneq[29350]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2))*c*c)-1/28224.
    coneq[29351]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c*c)-1/84672.
    coneq[29352]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c*c)-1/169344.
    coneq[29353]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/56448.
    coneq[29354]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/21168.
    coneq[29355]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/42336.
    coneq[29356]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/14112.
    coneq[29357]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/42336.
    coneq[29358]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/84672.
    coneq[29359]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/28224.
    coneq[29360]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**2))*c*c)-1/5880.
    coneq[29361]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c*c)-1/23520.
    coneq[29362]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c*c)-1/70560.
    coneq[29363]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c*c)-1/141120.
    coneq[29364]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/47040.
    coneq[29365]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/17640.
    coneq[29366]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/35280.
    coneq[29367]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/11760.
    coneq[29368]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/23520.
    coneq[29369]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**2))*c*c)-1/4704.
    coneq[29370]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/14112.
    coneq[29371]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/28224.
    coneq[29372]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/9408.
    coneq[29373]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/3528.
    coneq[29374]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/7056.
    coneq[29375]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/2352.
    coneq[29376]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/10584.
    coneq[29377]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/21168.
    coneq[29378]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/42336.
    coneq[29379]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2))*c*c)-1/9408.
    coneq[29380]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c*c)-1/28224.
    coneq[29381]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c*c)-1/56448.
    coneq[29382]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/18816.
    coneq[29383]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c*c)-1/7056.
    coneq[29384]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c*c)-1/14112.
    coneq[29385]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/4704.
    coneq[29386]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c*c)-1/9408.
    coneq[29387]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c)))*c*c)-1/2352.
    coneq[29388]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c)))*c*c)-1/14112.
    coneq[29389]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c)))*c*c)-1/70560.
    coneq[29390]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c)))*c*c)-1/282240.
    coneq[29391]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*c*c)-1/846720.
    coneq[29392]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*c*c)-1/1693440.
    coneq[29393]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c*c)-1/564480.
    coneq[29394]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c*c)-1/211680.
    coneq[29395]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c*c)-1/423360.
    coneq[29396]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/141120.
    coneq[29397]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/282240.
    coneq[29398]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c*c)-1/56448.
    coneq[29399]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c*c)-1/169344.
    coneq[29400]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c*c)-1/338688.
    coneq[29401]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/112896.
    coneq[29402]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/42336.
    coneq[29403]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/84672.
    coneq[29404]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/28224.
    coneq[29405]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/84672.
    coneq[29406]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/169344.
    coneq[29407]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/56448.
    coneq[29408]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c*c)-1/11760.
    coneq[29409]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c*c)-1/47040.
    coneq[29410]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c*c)-1/141120.
    coneq[29411]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c*c)-1/282240.
    coneq[29412]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/94080.
    coneq[29413]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/35280.
    coneq[29414]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/70560.
    coneq[29415]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/23520.
    coneq[29416]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/47040.
    coneq[29417]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c*c)-1/9408.
    coneq[29418]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/28224.
    coneq[29419]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/56448.
    coneq[29420]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/18816.
    coneq[29421]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c*c)-1/7056.
    coneq[29422]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/14112.
    coneq[29423]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/4704.
    coneq[29424]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c*c)-1/21168.
    coneq[29425]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/42336.
    coneq[29426]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/84672.
    coneq[29427]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c*c)-1/18816.
    coneq[29428]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c*c)-1/56448.
    coneq[29429]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c*c)-1/112896.
    coneq[29430]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/37632.
    coneq[29431]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c*c)-1/14112.
    coneq[29432]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c*c)-1/28224.
    coneq[29433]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/9408.
    coneq[29434]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c*c)-1/18816.
    coneq[29435]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c))*c*c)-1/784.
    coneq[29436]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c))*c*c)-1/4704.
    coneq[29437]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c))*c*c)-1/23520.
    coneq[29438]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c))*c*c)-1/94080.
    coneq[29439]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c))*c*c)-1/282240.
    coneq[29440]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*c*c)-1/564480.
    coneq[29441]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c))*c*c)-1/188160.
    coneq[29442]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c))*c*c)-1/70560.
    coneq[29443]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c*c)-1/141120.
    coneq[29444]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/47040.
    coneq[29445]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/94080.
    coneq[29446]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c))*c*c)-1/18816.
    coneq[29447]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c*c)-1/56448.
    coneq[29448]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c*c)-1/112896.
    coneq[29449]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/37632.
    coneq[29450]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/14112.
    coneq[29451]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/28224.
    coneq[29452]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/9408.
    coneq[29453]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/28224.
    coneq[29454]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/56448.
    coneq[29455]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/18816.
    coneq[29456]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c))*c*c)-1/3920.
    coneq[29457]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c*c)-1/15680.
    coneq[29458]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c*c)-1/47040.
    coneq[29459]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c*c)-1/94080.
    coneq[29460]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/31360.
    coneq[29461]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/11760.
    coneq[29462]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/23520.
    coneq[29463]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/7840.
    coneq[29464]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/15680.
    coneq[29465]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c))*c*c)-1/3136.
    coneq[29466]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/9408.
    coneq[29467]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/18816.
    coneq[29468]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/6272.
    coneq[29469]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c))*c*c)-1/2352.
    coneq[29470]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/4704.
    coneq[29471]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/1568.
    coneq[29472]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c))*c*c)-1/7056.
    coneq[29473]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/14112.
    coneq[29474]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/28224.
    coneq[29475]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c))*c*c)-1/6272.
    coneq[29476]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c*c)-1/18816.
    coneq[29477]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c*c)-1/37632.
    coneq[29478]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/12544.
    coneq[29479]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c*c)-1/4704.
    coneq[29480]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c*c)-1/9408.
    coneq[29481]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/3136.
    coneq[29482]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c*c)-1/6272.
    coneq[29483]=dot(b,dot(A,c**7)*dot(A,c**2)*c*c)-1/336.
    coneq[29484]=dot(b,dot(A,dot(A,c**6))*dot(A,c**2)*c*c)-1/2352.
    coneq[29485]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**2)*c*c)-1/14112.
    coneq[29486]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**2)*c*c)-1/70560.
    coneq[29487]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2)*c*c)-1/282240.
    coneq[29488]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2)*c*c)-1/846720.
    coneq[29489]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*c*c)-1/1693440.
    coneq[29490]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2)*c*c)-1/564480.
    coneq[29491]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2)*c*c)-1/211680.
    coneq[29492]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2)*c*c)-1/423360.
    coneq[29493]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2)*c*c)-1/141120.
    coneq[29494]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2)*c*c)-1/282240.
    coneq[29495]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2)*c*c)-1/56448.
    coneq[29496]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2)*c*c)-1/169344.
    coneq[29497]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c*c)-1/338688.
    coneq[29498]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2)*c*c)-1/112896.
    coneq[29499]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2)*c*c)-1/42336.
    coneq[29500]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/84672.
    coneq[29501]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2)*c*c)-1/28224.
    coneq[29502]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2)*c*c)-1/84672.
    coneq[29503]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/169344.
    coneq[29504]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2)*c*c)-1/56448.
    coneq[29505]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**2)*c*c)-1/11760.
    coneq[29506]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2)*c*c)-1/47040.
    coneq[29507]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c*c)-1/141120.
    coneq[29508]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c*c)-1/282240.
    coneq[29509]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c*c)-1/94080.
    coneq[29510]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2)*c*c)-1/35280.
    coneq[29511]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/70560.
    coneq[29512]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2)*c*c)-1/23520.
    coneq[29513]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c*c)-1/47040.
    coneq[29514]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**2)*c*c)-1/9408.
    coneq[29515]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/28224.
    coneq[29516]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/56448.
    coneq[29517]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/18816.
    coneq[29518]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**2)*c*c)-1/7056.
    coneq[29519]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/14112.
    coneq[29520]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**2)*c*c)-1/4704.
    coneq[29521]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2)*c*c)-1/21168.
    coneq[29522]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/42336.
    coneq[29523]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/84672.
    coneq[29524]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2)*c*c)-1/18816.
    coneq[29525]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/56448.
    coneq[29526]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/112896.
    coneq[29527]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/37632.
    coneq[29528]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c*c)-1/14112.
    coneq[29529]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/28224.
    coneq[29530]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/9408.
    coneq[29531]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/18816.
    coneq[29532]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**2)*c*c)-1/2016.
    coneq[29533]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**2)*c*c)-1/10080.
    coneq[29534]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c*c)-1/40320.
    coneq[29535]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c*c)-1/120960.
    coneq[29536]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c*c)-1/241920.
    coneq[29537]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c*c)-1/80640.
    coneq[29538]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c*c)-1/30240.
    coneq[29539]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/60480.
    coneq[29540]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c*c)-1/20160.
    coneq[29541]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c*c)-1/40320.
    coneq[29542]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**2)*c*c)-1/8064.
    coneq[29543]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/24192.
    coneq[29544]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/48384.
    coneq[29545]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/16128.
    coneq[29546]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c*c)-1/6048.
    coneq[29547]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/12096.
    coneq[29548]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**2)*c*c)-1/4032.
    coneq[29549]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c*c)-1/12096.
    coneq[29550]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/24192.
    coneq[29551]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/8064.
    coneq[29552]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**2)*c*c)-1/1680.
    coneq[29553]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**2)*c*c)-1/6720.
    coneq[29554]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/20160.
    coneq[29555]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/40320.
    coneq[29556]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/13440.
    coneq[29557]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c*c)-1/5040.
    coneq[29558]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/10080.
    coneq[29559]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c*c)-1/3360.
    coneq[29560]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/6720.
    coneq[29561]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**2)*c*c)-1/1344.
    coneq[29562]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/4032.
    coneq[29563]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/8064.
    coneq[29564]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/2688.
    coneq[29565]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**2)*c*c)-1/1008.
    coneq[29566]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/2016.
    coneq[29567]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**2)*c*c)-1/672.
    coneq[29568]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**2)*c*c)-1/4032.
    coneq[29569]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/12096.
    coneq[29570]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/24192.
    coneq[29571]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/8064.
    coneq[29572]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2)*c*c)-1/8064.
    coneq[29573]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/24192.
    coneq[29574]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/48384.
    coneq[29575]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/16128.
    coneq[29576]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**2)*c*c)-1/3360.
    coneq[29577]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2)*c*c)-1/13440.
    coneq[29578]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c*c)-1/40320.
    coneq[29579]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c*c)-1/80640.
    coneq[29580]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c*c)-1/26880.
    coneq[29581]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c*c)-1/10080.
    coneq[29582]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/20160.
    coneq[29583]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c*c)-1/6720.
    coneq[29584]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c*c)-1/13440.
    coneq[29585]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c*c)-1/3024.
    coneq[29586]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/6048.
    coneq[29587]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/12096.
    coneq[29588]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**2)*c*c)-1/2688.
    coneq[29589]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c*c)-1/8064.
    coneq[29590]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c*c)-1/16128.
    coneq[29591]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c*c)-1/5376.
    coneq[29592]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c*c)-1/2016.
    coneq[29593]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/4032.
    coneq[29594]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**2)*c*c)-1/1344.
    coneq[29595]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c*c)-1/4032.
    coneq[29596]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/8064.
    coneq[29597]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c*c)-1/2688.
    coneq[29598]=dot(b,dot(A,c**7)*dot(A,dot(A,c))*c*c)-1/672.
    coneq[29599]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c))*c*c)-1/4704.
    coneq[29600]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c))*c*c)-1/28224.
    coneq[29601]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c))*c*c)-1/141120.
    coneq[29602]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c))*c*c)-1/564480.
    coneq[29603]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*c*c)-1/1693440.
    coneq[29604]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*c*c)-1/3386880.
    coneq[29605]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*c*c)-1/1128960.
    coneq[29606]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c))*c*c)-1/423360.
    coneq[29607]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c))*c*c)-1/846720.
    coneq[29608]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/282240.
    coneq[29609]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/564480.
    coneq[29610]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c))*c*c)-1/112896.
    coneq[29611]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c*c)-1/338688.
    coneq[29612]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c*c)-1/677376.
    coneq[29613]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/225792.
    coneq[29614]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/84672.
    coneq[29615]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/169344.
    coneq[29616]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/56448.
    coneq[29617]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/169344.
    coneq[29618]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/338688.
    coneq[29619]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/112896.
    coneq[29620]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c))*c*c)-1/23520.
    coneq[29621]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c*c)-1/94080.
    coneq[29622]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c*c)-1/282240.
    coneq[29623]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c*c)-1/564480.
    coneq[29624]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/188160.
    coneq[29625]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/70560.
    coneq[29626]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/141120.
    coneq[29627]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/47040.
    coneq[29628]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/94080.
    coneq[29629]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/18816.
    coneq[29630]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/56448.
    coneq[29631]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/112896.
    coneq[29632]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/37632.
    coneq[29633]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/14112.
    coneq[29634]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/28224.
    coneq[29635]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/9408.
    coneq[29636]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/42336.
    coneq[29637]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/84672.
    coneq[29638]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/169344.
    coneq[29639]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/37632.
    coneq[29640]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/112896.
    coneq[29641]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/225792.
    coneq[29642]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/75264.
    coneq[29643]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/28224.
    coneq[29644]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/56448.
    coneq[29645]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/18816.
    coneq[29646]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/37632.
    coneq[29647]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c))*c*c)-1/4032.
    coneq[29648]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c*c)-1/20160.
    coneq[29649]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c*c)-1/80640.
    coneq[29650]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c*c)-1/241920.
    coneq[29651]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c*c)-1/483840.
    coneq[29652]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/161280.
    coneq[29653]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/60480.
    coneq[29654]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/120960.
    coneq[29655]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/40320.
    coneq[29656]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/80640.
    coneq[29657]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29658]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/48384.
    coneq[29659]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/96768.
    coneq[29660]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/32256.
    coneq[29661]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/12096.
    coneq[29662]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/24192.
    coneq[29663]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[29664]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/24192.
    coneq[29665]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/48384.
    coneq[29666]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29667]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c))*c*c)-1/3360.
    coneq[29668]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/13440.
    coneq[29669]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/40320.
    coneq[29670]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/80640.
    coneq[29671]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/26880.
    coneq[29672]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/10080.
    coneq[29673]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/20160.
    coneq[29674]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/6720.
    coneq[29675]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/13440.
    coneq[29676]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/2688.
    coneq[29677]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[29678]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29679]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/5376.
    coneq[29680]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/2016.
    coneq[29681]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/4032.
    coneq[29682]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c))*c*c)-1/1344.
    coneq[29683]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[29684]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/24192.
    coneq[29685]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/48384.
    coneq[29686]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29687]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29688]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/48384.
    coneq[29689]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/96768.
    coneq[29690]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/32256.
    coneq[29691]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c))*c*c)-1/6720.
    coneq[29692]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c*c)-1/26880.
    coneq[29693]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c*c)-1/80640.
    coneq[29694]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c*c)-1/161280.
    coneq[29695]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c*c)-1/53760.
    coneq[29696]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/20160.
    coneq[29697]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/40320.
    coneq[29698]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/13440.
    coneq[29699]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/26880.
    coneq[29700]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/6048.
    coneq[29701]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/12096.
    coneq[29702]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/24192.
    coneq[29703]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c*c)-1/5376.
    coneq[29704]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29705]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c*c)-1/32256.
    coneq[29706]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c*c)-1/10752.
    coneq[29707]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/4032.
    coneq[29708]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[29709]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c*c)-1/2688.
    coneq[29710]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[29711]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[29712]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c*c)-1/5376.
    coneq[29713]=dot(b,dot(A,c**8)*dot(A,c)*c*c)-1/252.
    coneq[29714]=dot(b,dot(A,dot(A,c**7))*dot(A,c)*c*c)-1/2016.
    coneq[29715]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c)*c*c)-1/14112.
    coneq[29716]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c)*c*c)-1/84672.
    coneq[29717]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c)*c*c)-1/423360.
    coneq[29718]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c)*c*c)-1/1693440.
    coneq[29719]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*c*c)-1/5080320.
    coneq[29720]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*c*c)-1/10160640.
    coneq[29721]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*c*c)-1/3386880.
    coneq[29722]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c)*c*c)-1/1270080.
    coneq[29723]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*c*c)-1/2540160.
    coneq[29724]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c)*c*c)-1/846720.
    coneq[29725]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*c*c)-1/1693440.
    coneq[29726]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c)*c*c)-1/338688.
    coneq[29727]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c)*c*c)-1/1016064.
    coneq[29728]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c*c)-1/2032128.
    coneq[29729]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c)*c*c)-1/677376.
    coneq[29730]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c)*c*c)-1/254016.
    coneq[29731]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/508032.
    coneq[29732]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c)*c*c)-1/169344.
    coneq[29733]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c)*c*c)-1/508032.
    coneq[29734]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/1016064.
    coneq[29735]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c)*c*c)-1/338688.
    coneq[29736]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c)*c*c)-1/70560.
    coneq[29737]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c)*c*c)-1/282240.
    coneq[29738]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c*c)-1/846720.
    coneq[29739]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c*c)-1/1693440.
    coneq[29740]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c*c)-1/564480.
    coneq[29741]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c)*c*c)-1/211680.
    coneq[29742]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/423360.
    coneq[29743]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c)*c*c)-1/141120.
    coneq[29744]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c*c)-1/282240.
    coneq[29745]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c)*c*c)-1/56448.
    coneq[29746]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/169344.
    coneq[29747]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/338688.
    coneq[29748]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/112896.
    coneq[29749]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c)*c*c)-1/42336.
    coneq[29750]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/84672.
    coneq[29751]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c)*c*c)-1/28224.
    coneq[29752]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c)*c*c)-1/127008.
    coneq[29753]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/254016.
    coneq[29754]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/508032.
    coneq[29755]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c)*c*c)-1/112896.
    coneq[29756]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/338688.
    coneq[29757]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/677376.
    coneq[29758]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/225792.
    coneq[29759]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c)*c*c)-1/84672.
    coneq[29760]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/169344.
    coneq[29761]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/56448.
    coneq[29762]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/112896.
    coneq[29763]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c)*c*c)-1/12096.
    coneq[29764]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c)*c*c)-1/60480.
    coneq[29765]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c*c)-1/241920.
    coneq[29766]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c*c)-1/725760.
    coneq[29767]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c*c)-1/1451520.
    coneq[29768]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c*c)-1/483840.
    coneq[29769]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c*c)-1/181440.
    coneq[29770]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/362880.
    coneq[29771]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c*c)-1/120960.
    coneq[29772]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c*c)-1/241920.
    coneq[29773]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c)*c*c)-1/48384.
    coneq[29774]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/145152.
    coneq[29775]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/290304.
    coneq[29776]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/96768.
    coneq[29777]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c)*c*c)-1/36288.
    coneq[29778]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/72576.
    coneq[29779]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c)*c*c)-1/24192.
    coneq[29780]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c*c)-1/72576.
    coneq[29781]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/145152.
    coneq[29782]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/48384.
    coneq[29783]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c)*c*c)-1/10080.
    coneq[29784]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/40320.
    coneq[29785]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/120960.
    coneq[29786]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/241920.
    coneq[29787]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/80640.
    coneq[29788]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/30240.
    coneq[29789]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/60480.
    coneq[29790]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/20160.
    coneq[29791]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/40320.
    coneq[29792]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c)*c*c)-1/8064.
    coneq[29793]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/24192.
    coneq[29794]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/48384.
    coneq[29795]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/16128.
    coneq[29796]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c)*c*c)-1/6048.
    coneq[29797]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/12096.
    coneq[29798]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c)*c*c)-1/4032.
    coneq[29799]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c)*c*c)-1/24192.
    coneq[29800]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/72576.
    coneq[29801]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/145152.
    coneq[29802]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/48384.
    coneq[29803]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c)*c*c)-1/48384.
    coneq[29804]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/145152.
    coneq[29805]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/290304.
    coneq[29806]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/96768.
    coneq[29807]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c)*c*c)-1/20160.
    coneq[29808]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/80640.
    coneq[29809]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/241920.
    coneq[29810]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/483840.
    coneq[29811]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/161280.
    coneq[29812]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/60480.
    coneq[29813]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/120960.
    coneq[29814]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/40320.
    coneq[29815]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/80640.
    coneq[29816]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c*c)-1/18144.
    coneq[29817]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/36288.
    coneq[29818]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/72576.
    coneq[29819]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c)*c*c)-1/16128.
    coneq[29820]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/48384.
    coneq[29821]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/96768.
    coneq[29822]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/32256.
    coneq[29823]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/12096.
    coneq[29824]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/24192.
    coneq[29825]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/8064.
    coneq[29826]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/24192.
    coneq[29827]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/48384.
    coneq[29828]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/16128.
    coneq[29829]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c)*c*c)-1/1764.
    coneq[29830]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c)*c*c)-1/10584.
    coneq[29831]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c*c)-1/52920.
    coneq[29832]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c*c)-1/211680.
    coneq[29833]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c*c)-1/635040.
    coneq[29834]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c*c)-1/1270080.
    coneq[29835]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c*c)-1/423360.
    coneq[29836]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c*c)-1/158760.
    coneq[29837]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/317520.
    coneq[29838]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c*c)-1/105840.
    coneq[29839]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c*c)-1/211680.
    coneq[29840]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c*c)-1/42336.
    coneq[29841]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/127008.
    coneq[29842]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/254016.
    coneq[29843]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/84672.
    coneq[29844]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c*c)-1/31752.
    coneq[29845]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/63504.
    coneq[29846]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c*c)-1/21168.
    coneq[29847]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c*c)-1/63504.
    coneq[29848]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/127008.
    coneq[29849]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/42336.
    coneq[29850]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c)*c*c)-1/8820.
    coneq[29851]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/35280.
    coneq[29852]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/105840.
    coneq[29853]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/211680.
    coneq[29854]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/70560.
    coneq[29855]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/26460.
    coneq[29856]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/52920.
    coneq[29857]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/17640.
    coneq[29858]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/35280.
    coneq[29859]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c)*c*c)-1/7056.
    coneq[29860]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/21168.
    coneq[29861]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/42336.
    coneq[29862]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/14112.
    coneq[29863]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c)*c*c)-1/5292.
    coneq[29864]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/10584.
    coneq[29865]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c)*c*c)-1/3528.
    coneq[29866]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c*c)-1/15876.
    coneq[29867]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/31752.
    coneq[29868]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/63504.
    coneq[29869]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c*c)-1/14112.
    coneq[29870]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/42336.
    coneq[29871]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/84672.
    coneq[29872]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/28224.
    coneq[29873]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/10584.
    coneq[29874]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/21168.
    coneq[29875]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/7056.
    coneq[29876]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/14112.
    coneq[29877]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c)*c*c)-1/1512.
    coneq[29878]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c)*c*c)-1/7560.
    coneq[29879]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/30240.
    coneq[29880]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/90720.
    coneq[29881]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/181440.
    coneq[29882]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/60480.
    coneq[29883]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/22680.
    coneq[29884]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/45360.
    coneq[29885]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/15120.
    coneq[29886]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/30240.
    coneq[29887]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c)*c*c)-1/6048.
    coneq[29888]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/18144.
    coneq[29889]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/36288.
    coneq[29890]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/12096.
    coneq[29891]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c*c)-1/4536.
    coneq[29892]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/9072.
    coneq[29893]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c)*c*c)-1/3024.
    coneq[29894]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/9072.
    coneq[29895]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/18144.
    coneq[29896]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/6048.
    coneq[29897]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c)*c*c)-1/1260.
    coneq[29898]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/5040.
    coneq[29899]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/15120.
    coneq[29900]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/30240.
    coneq[29901]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/10080.
    coneq[29902]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/3780.
    coneq[29903]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/7560.
    coneq[29904]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/2520.
    coneq[29905]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/5040.
    coneq[29906]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c)*c*c)-1/1008.
    coneq[29907]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/3024.
    coneq[29908]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/6048.
    coneq[29909]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/2016.
    coneq[29910]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c)*c*c)-1/756.
    coneq[29911]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/1512.
    coneq[29912]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c)*c*c)-1/504.
    coneq[29913]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c)*c*c)-1/4032.
    coneq[29914]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/12096.
    coneq[29915]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/24192.
    coneq[29916]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/8064.
    coneq[29917]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/36288.
    coneq[29918]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/72576.
    coneq[29919]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/24192.
    coneq[29920]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/145152.
    coneq[29921]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/48384.
    coneq[29922]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/16128.
    coneq[29923]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c)*c*c)-1/3780.
    coneq[29924]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/15120.
    coneq[29925]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/45360.
    coneq[29926]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/90720.
    coneq[29927]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/30240.
    coneq[29928]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/11340.
    coneq[29929]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/22680.
    coneq[29930]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/7560.
    coneq[29931]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/15120.
    coneq[29932]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c)*c*c)-1/7560.
    coneq[29933]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/30240.
    coneq[29934]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/90720.
    coneq[29935]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/181440.
    coneq[29936]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/60480.
    coneq[29937]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/22680.
    coneq[29938]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/45360.
    coneq[29939]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/15120.
    coneq[29940]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/30240.
    coneq[29941]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c)*c*c)-1/3024.
    coneq[29942]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c)*c*c)-1/15120.
    coneq[29943]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c*c)-1/60480.
    coneq[29944]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c*c)-1/181440.
    coneq[29945]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c*c)-1/362880.
    coneq[29946]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c*c)-1/120960.
    coneq[29947]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c*c)-1/45360.
    coneq[29948]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/90720.
    coneq[29949]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c*c)-1/30240.
    coneq[29950]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c*c)-1/60480.
    coneq[29951]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c)*c*c)-1/12096.
    coneq[29952]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/36288.
    coneq[29953]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/72576.
    coneq[29954]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/24192.
    coneq[29955]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c*c)-1/9072.
    coneq[29956]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/18144.
    coneq[29957]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c)*c*c)-1/6048.
    coneq[29958]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c*c)-1/18144.
    coneq[29959]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/36288.
    coneq[29960]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/12096.
    coneq[29961]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c)*c*c)-1/3024.
    coneq[29962]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/9072.
    coneq[29963]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/18144.
    coneq[29964]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/6048.
    coneq[29965]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c*c)-1/6048.
    coneq[29966]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/18144.
    coneq[29967]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/36288.
    coneq[29968]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/12096.
    coneq[29969]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c)*c*c)-1/2520.
    coneq[29970]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c*c)-1/10080.
    coneq[29971]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c*c)-1/30240.
    coneq[29972]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c*c)-1/60480.
    coneq[29973]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c*c)-1/20160.
    coneq[29974]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c*c)-1/7560.
    coneq[29975]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c*c)-1/15120.
    coneq[29976]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c*c)-1/5040.
    coneq[29977]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c*c)-1/10080.
    coneq[29978]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c*c)-1/2268.
    coneq[29979]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/4536.
    coneq[29980]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/9072.
    coneq[29981]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c)*c*c)-1/2016.
    coneq[29982]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/6048.
    coneq[29983]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/12096.
    coneq[29984]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/4032.
    coneq[29985]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c)*c*c)-1/1512.
    coneq[29986]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/3024.
    coneq[29987]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/1008.
    coneq[29988]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c)*c*c)-1/4032.
    coneq[29989]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c*c)-1/12096.
    coneq[29990]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c*c)-1/24192.
    coneq[29991]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c*c)-1/8064.
    coneq[29992]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c*c)-1/4536.
    coneq[29993]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/9072.
    coneq[29994]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/18144.
    coneq[29995]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c*c)-1/3024.
    coneq[29996]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c*c)-1/6048.
    coneq[29997]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/2016.
    coneq[29998]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c*c)-1/4032.
    coneq[29999]=dot(b,dot(A,c**4)*dot(A,c**4)*c**3)-1/350.
    coneq[30000]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*c**3)-1/1400.
    coneq[30001]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*c**3)-1/4200.
    coneq[30002]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*c**3)-1/8400.
    coneq[30003]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*c**3)-1/2800.
    coneq[30004]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*c**3)-1/1050.
    coneq[30005]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*c**3)-1/2100.
    coneq[30006]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*c**3)-1/700.
    coneq[30007]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*c**3)-1/1400.
    coneq[30008]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*c**3)-1/5600.
    coneq[30009]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*c**3)-1/16800.
    coneq[30010]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*c**3)-1/33600.
    coneq[30011]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*c**3)-1/11200.
    coneq[30012]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*c**3)-1/4200.
    coneq[30013]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*c**3)-1/8400.
    coneq[30014]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*c**3)-1/2800.
    coneq[30015]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*c**3)-1/5600.
    coneq[30016]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/50400.
    coneq[30017]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/100800.
    coneq[30018]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/33600.
    coneq[30019]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/12600.
    coneq[30020]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/25200.
    coneq[30021]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/8400.
    coneq[30022]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*c**3)-1/16800.
    coneq[30023]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/201600.
    coneq[30024]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/67200.
    coneq[30025]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/25200.
    coneq[30026]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/50400.
    coneq[30027]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/16800.
    coneq[30028]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*c**3)-1/33600.
    coneq[30029]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c**3)-1/22400.
    coneq[30030]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*c**3)-1/8400.
    coneq[30031]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*c**3)-1/16800.
    coneq[30032]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c**3)-1/5600.
    coneq[30033]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*c**3)-1/11200.
    coneq[30034]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*c**3)-1/3150.
    coneq[30035]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*c**3)-1/6300.
    coneq[30036]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*c**3)-1/2100.
    coneq[30037]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*c**3)-1/4200.
    coneq[30038]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*c**3)-1/12600.
    coneq[30039]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c**3)-1/4200.
    coneq[30040]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*c**3)-1/8400.
    coneq[30041]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*c**3)-1/1400.
    coneq[30042]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*c**3)-1/2800.
    coneq[30043]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*c**3)-1/5600.
    coneq[30044]=dot(b,dot(A,c**5)*dot(A,c**3)*c**3)-1/336.
    coneq[30045]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*c**3)-1/1680.
    coneq[30046]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*c**3)-1/6720.
    coneq[30047]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*c**3)-1/20160.
    coneq[30048]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*c**3)-1/40320.
    coneq[30049]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*c**3)-1/13440.
    coneq[30050]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*c**3)-1/5040.
    coneq[30051]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*c**3)-1/10080.
    coneq[30052]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*c**3)-1/3360.
    coneq[30053]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*c**3)-1/6720.
    coneq[30054]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*c**3)-1/1344.
    coneq[30055]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*c**3)-1/4032.
    coneq[30056]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c**3)-1/8064.
    coneq[30057]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*c**3)-1/2688.
    coneq[30058]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*c**3)-1/1008.
    coneq[30059]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*c**3)-1/2016.
    coneq[30060]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*c**3)-1/672.
    coneq[30061]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*c**3)-1/2016.
    coneq[30062]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*c**3)-1/4032.
    coneq[30063]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*c**3)-1/1344.
    coneq[30064]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*c**3)-1/1008.
    coneq[30065]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*c**3)-1/5040.
    coneq[30066]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*c**3)-1/20160.
    coneq[30067]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*c**3)-1/60480.
    coneq[30068]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*c**3)-1/120960.
    coneq[30069]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*c**3)-1/40320.
    coneq[30070]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*c**3)-1/15120.
    coneq[30071]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c**3)-1/30240.
    coneq[30072]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/10080.
    coneq[30073]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/20160.
    coneq[30074]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*c**3)-1/4032.
    coneq[30075]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c**3)-1/12096.
    coneq[30076]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c**3)-1/24192.
    coneq[30077]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/8064.
    coneq[30078]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*c**3)-1/3024.
    coneq[30079]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/6048.
    coneq[30080]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*c**3)-1/2016.
    coneq[30081]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*c**3)-1/6048.
    coneq[30082]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**3)-1/12096.
    coneq[30083]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c**3)-1/4032.
    coneq[30084]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*c**3)-1/2016.
    coneq[30085]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*c**3)-1/10080.
    coneq[30086]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*c**3)-1/40320.
    coneq[30087]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*c**3)-1/120960.
    coneq[30088]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*c**3)-1/241920.
    coneq[30089]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*c**3)-1/80640.
    coneq[30090]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c**3)-1/30240.
    coneq[30091]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c**3)-1/60480.
    coneq[30092]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/20160.
    coneq[30093]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/40320.
    coneq[30094]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c**3)-1/8064.
    coneq[30095]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c**3)-1/24192.
    coneq[30096]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c**3)-1/48384.
    coneq[30097]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/16128.
    coneq[30098]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c**3)-1/6048.
    coneq[30099]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/12096.
    coneq[30100]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**3)-1/4032.
    coneq[30101]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c**3)-1/12096.
    coneq[30102]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**3)-1/24192.
    coneq[30103]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**3)-1/8064.
    coneq[30104]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*c**3)-1/672.
    coneq[30105]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*c**3)-1/3360.
    coneq[30106]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*c**3)-1/13440.
    coneq[30107]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*c**3)-1/40320.
    coneq[30108]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*c**3)-1/80640.
    coneq[30109]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*c**3)-1/26880.
    coneq[30110]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*c**3)-1/10080.
    coneq[30111]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c**3)-1/20160.
    coneq[30112]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/6720.
    coneq[30113]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/13440.
    coneq[30114]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*c**3)-1/2688.
    coneq[30115]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c**3)-1/8064.
    coneq[30116]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c**3)-1/16128.
    coneq[30117]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/5376.
    coneq[30118]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*c**3)-1/2016.
    coneq[30119]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/4032.
    coneq[30120]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*c**3)-1/1344.
    coneq[30121]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*c**3)-1/4032.
    coneq[30122]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c**3)-1/8064.
    coneq[30123]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c**3)-1/2688.
    coneq[30124]=dot(b,dot(A,c**6)*dot(A,c**2)*c**3)-1/294.
    coneq[30125]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2)*c**3)-1/1764.
    coneq[30126]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2)*c**3)-1/8820.
    coneq[30127]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*c**3)-1/35280.
    coneq[30128]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*c**3)-1/105840.
    coneq[30129]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*c**3)-1/211680.
    coneq[30130]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*c**3)-1/70560.
    coneq[30131]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*c**3)-1/26460.
    coneq[30132]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*c**3)-1/52920.
    coneq[30133]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*c**3)-1/17640.
    coneq[30134]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*c**3)-1/35280.
    coneq[30135]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2)*c**3)-1/7056.
    coneq[30136]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*c**3)-1/21168.
    coneq[30137]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c**3)-1/42336.
    coneq[30138]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*c**3)-1/14112.
    coneq[30139]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*c**3)-1/5292.
    coneq[30140]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/10584.
    coneq[30141]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2)*c**3)-1/3528.
    coneq[30142]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*c**3)-1/10584.
    coneq[30143]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/21168.
    coneq[30144]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*c**3)-1/7056.
    coneq[30145]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2)*c**3)-1/1470.
    coneq[30146]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2)*c**3)-1/5880.
    coneq[30147]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c**3)-1/17640.
    coneq[30148]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c**3)-1/35280.
    coneq[30149]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c**3)-1/11760.
    coneq[30150]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2)*c**3)-1/4410.
    coneq[30151]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/8820.
    coneq[30152]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2)*c**3)-1/2940.
    coneq[30153]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c**3)-1/5880.
    coneq[30154]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2)*c**3)-1/1176.
    coneq[30155]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2)*c**3)-1/3528.
    coneq[30156]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/7056.
    coneq[30157]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2)*c**3)-1/2352.
    coneq[30158]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2)*c**3)-1/882.
    coneq[30159]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/1764.
    coneq[30160]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2)*c**3)-1/588.
    coneq[30161]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*c**3)-1/2646.
    coneq[30162]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/5292.
    coneq[30163]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/10584.
    coneq[30164]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2)*c**3)-1/2352.
    coneq[30165]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*c**3)-1/7056.
    coneq[30166]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**3)-1/14112.
    coneq[30167]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*c**3)-1/4704.
    coneq[30168]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2)*c**3)-1/1764.
    coneq[30169]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c**3)-1/3528.
    coneq[30170]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2)*c**3)-1/1176.
    coneq[30171]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*c**3)-1/2352.
    coneq[30172]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*c**3)-1/588.
    coneq[30173]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*c**3)-1/3528.
    coneq[30174]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*c**3)-1/17640.
    coneq[30175]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*c**3)-1/70560.
    coneq[30176]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*c**3)-1/211680.
    coneq[30177]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*c**3)-1/423360.
    coneq[30178]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*c**3)-1/141120.
    coneq[30179]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*c**3)-1/52920.
    coneq[30180]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*c**3)-1/105840.
    coneq[30181]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*c**3)-1/35280.
    coneq[30182]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*c**3)-1/70560.
    coneq[30183]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*c**3)-1/14112.
    coneq[30184]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c**3)-1/42336.
    coneq[30185]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c**3)-1/84672.
    coneq[30186]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c**3)-1/28224.
    coneq[30187]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/10584.
    coneq[30188]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/21168.
    coneq[30189]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/7056.
    coneq[30190]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/21168.
    coneq[30191]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/42336.
    coneq[30192]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/14112.
    coneq[30193]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*c**3)-1/2940.
    coneq[30194]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c**3)-1/11760.
    coneq[30195]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c**3)-1/35280.
    coneq[30196]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c**3)-1/70560.
    coneq[30197]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c**3)-1/23520.
    coneq[30198]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/8820.
    coneq[30199]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/17640.
    coneq[30200]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/5880.
    coneq[30201]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/11760.
    coneq[30202]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*c**3)-1/2352.
    coneq[30203]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/7056.
    coneq[30204]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/14112.
    coneq[30205]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/4704.
    coneq[30206]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/1764.
    coneq[30207]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/3528.
    coneq[30208]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*c**3)-1/1176.
    coneq[30209]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/5292.
    coneq[30210]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/10584.
    coneq[30211]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/21168.
    coneq[30212]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*c**3)-1/4704.
    coneq[30213]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**3)-1/14112.
    coneq[30214]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**3)-1/28224.
    coneq[30215]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**3)-1/9408.
    coneq[30216]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c**3)-1/3528.
    coneq[30217]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**3)-1/7056.
    coneq[30218]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**3)-1/2352.
    coneq[30219]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**3)-1/4704.
    coneq[30220]=dot(b,dot(A,c**7)*dot(A,c)*c**3)-1/224.
    coneq[30221]=dot(b,dot(A,dot(A,c**6))*dot(A,c)*c**3)-1/1568.
    coneq[30222]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c)*c**3)-1/9408.
    coneq[30223]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c)*c**3)-1/47040.
    coneq[30224]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*c**3)-1/188160.
    coneq[30225]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*c**3)-1/564480.
    coneq[30226]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*c**3)-1/1128960.
    coneq[30227]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*c**3)-1/376320.
    coneq[30228]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*c**3)-1/141120.
    coneq[30229]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*c**3)-1/282240.
    coneq[30230]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*c**3)-1/94080.
    coneq[30231]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*c**3)-1/188160.
    coneq[30232]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*c**3)-1/37632.
    coneq[30233]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*c**3)-1/112896.
    coneq[30234]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*c**3)-1/225792.
    coneq[30235]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*c**3)-1/75264.
    coneq[30236]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*c**3)-1/28224.
    coneq[30237]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/56448.
    coneq[30238]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*c**3)-1/18816.
    coneq[30239]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*c**3)-1/56448.
    coneq[30240]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/112896.
    coneq[30241]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*c**3)-1/37632.
    coneq[30242]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c)*c**3)-1/7840.
    coneq[30243]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*c**3)-1/31360.
    coneq[30244]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c**3)-1/94080.
    coneq[30245]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c**3)-1/188160.
    coneq[30246]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c**3)-1/62720.
    coneq[30247]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*c**3)-1/23520.
    coneq[30248]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/47040.
    coneq[30249]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*c**3)-1/15680.
    coneq[30250]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c**3)-1/31360.
    coneq[30251]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c)*c**3)-1/6272.
    coneq[30252]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/18816.
    coneq[30253]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/37632.
    coneq[30254]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/12544.
    coneq[30255]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c)*c**3)-1/4704.
    coneq[30256]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/9408.
    coneq[30257]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c)*c**3)-1/3136.
    coneq[30258]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*c**3)-1/14112.
    coneq[30259]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/28224.
    coneq[30260]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/56448.
    coneq[30261]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*c**3)-1/12544.
    coneq[30262]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/37632.
    coneq[30263]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/75264.
    coneq[30264]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/25088.
    coneq[30265]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*c**3)-1/9408.
    coneq[30266]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/18816.
    coneq[30267]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/6272.
    coneq[30268]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/12544.
    coneq[30269]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c)*c**3)-1/1344.
    coneq[30270]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c)*c**3)-1/6720.
    coneq[30271]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c**3)-1/26880.
    coneq[30272]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c**3)-1/80640.
    coneq[30273]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c**3)-1/161280.
    coneq[30274]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c**3)-1/53760.
    coneq[30275]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c**3)-1/20160.
    coneq[30276]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/40320.
    coneq[30277]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c**3)-1/13440.
    coneq[30278]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c**3)-1/26880.
    coneq[30279]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c)*c**3)-1/5376.
    coneq[30280]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/16128.
    coneq[30281]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/32256.
    coneq[30282]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/10752.
    coneq[30283]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c)*c**3)-1/4032.
    coneq[30284]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/8064.
    coneq[30285]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c)*c**3)-1/2688.
    coneq[30286]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c**3)-1/8064.
    coneq[30287]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/16128.
    coneq[30288]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/5376.
    coneq[30289]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c)*c**3)-1/1120.
    coneq[30290]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c)*c**3)-1/4480.
    coneq[30291]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/13440.
    coneq[30292]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/26880.
    coneq[30293]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/8960.
    coneq[30294]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c)*c**3)-1/3360.
    coneq[30295]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/6720.
    coneq[30296]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c)*c**3)-1/2240.
    coneq[30297]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/4480.
    coneq[30298]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c)*c**3)-1/896.
    coneq[30299]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/2688.
    coneq[30300]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/5376.
    coneq[30301]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/1792.
    coneq[30302]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c)*c**3)-1/672.
    coneq[30303]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/1344.
    coneq[30304]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c)*c**3)-1/448.
    coneq[30305]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c)*c**3)-1/2688.
    coneq[30306]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/8064.
    coneq[30307]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/16128.
    coneq[30308]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/5376.
    coneq[30309]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*c**3)-1/5376.
    coneq[30310]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/16128.
    coneq[30311]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/32256.
    coneq[30312]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/10752.
    coneq[30313]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c)*c**3)-1/2240.
    coneq[30314]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*c**3)-1/8960.
    coneq[30315]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**3)-1/26880.
    coneq[30316]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**3)-1/53760.
    coneq[30317]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**3)-1/17920.
    coneq[30318]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*c**3)-1/6720.
    coneq[30319]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**3)-1/13440.
    coneq[30320]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*c**3)-1/4480.
    coneq[30321]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**3)-1/8960.
    coneq[30322]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c)*c**3)-1/2016.
    coneq[30323]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/4032.
    coneq[30324]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/8064.
    coneq[30325]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c)*c**3)-1/1792.
    coneq[30326]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c**3)-1/5376.
    coneq[30327]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**3)-1/10752.
    coneq[30328]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c**3)-1/3584.
    coneq[30329]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c)*c**3)-1/1344.
    coneq[30330]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/2688.
    coneq[30331]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c)*c**3)-1/896.
    coneq[30332]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*c**3)-1/2688.
    coneq[30333]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**3)-1/5376.
    coneq[30334]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c**3)-1/1792.
    coneq[30335]=dot(b,dot(A,c**4)*dot(A,c**3)*c**4)-1/280.
    coneq[30336]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*c**4)-1/1120.
    coneq[30337]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*c**4)-1/3360.
    coneq[30338]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*c**4)-1/6720.
    coneq[30339]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*c**4)-1/2240.
    coneq[30340]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*c**4)-1/840.
    coneq[30341]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*c**4)-1/1680.
    coneq[30342]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*c**4)-1/560.
    coneq[30343]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*c**4)-1/1120.
    coneq[30344]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*c**4)-1/840.
    coneq[30345]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*c**4)-1/3360.
    coneq[30346]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*c**4)-1/10080.
    coneq[30347]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*c**4)-1/20160.
    coneq[30348]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*c**4)-1/6720.
    coneq[30349]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*c**4)-1/2520.
    coneq[30350]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**4)-1/5040.
    coneq[30351]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*c**4)-1/1680.
    coneq[30352]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*c**4)-1/3360.
    coneq[30353]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*c**4)-1/1680.
    coneq[30354]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*c**4)-1/6720.
    coneq[30355]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*c**4)-1/20160.
    coneq[30356]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*c**4)-1/40320.
    coneq[30357]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**4)-1/13440.
    coneq[30358]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*c**4)-1/5040.
    coneq[30359]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**4)-1/10080.
    coneq[30360]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**4)-1/3360.
    coneq[30361]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**4)-1/6720.
    coneq[30362]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*c**4)-1/560.
    coneq[30363]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*c**4)-1/2240.
    coneq[30364]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*c**4)-1/6720.
    coneq[30365]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*c**4)-1/13440.
    coneq[30366]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*c**4)-1/4480.
    coneq[30367]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*c**4)-1/1680.
    coneq[30368]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*c**4)-1/3360.
    coneq[30369]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*c**4)-1/1120.
    coneq[30370]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*c**4)-1/2240.
    coneq[30371]=dot(b,dot(A,c**5)*dot(A,c**2)*c**4)-1/252.
    coneq[30372]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*c**4)-1/1260.
    coneq[30373]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*c**4)-1/5040.
    coneq[30374]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*c**4)-1/15120.
    coneq[30375]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*c**4)-1/30240.
    coneq[30376]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*c**4)-1/10080.
    coneq[30377]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*c**4)-1/3780.
    coneq[30378]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*c**4)-1/7560.
    coneq[30379]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*c**4)-1/2520.
    coneq[30380]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*c**4)-1/5040.
    coneq[30381]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*c**4)-1/1008.
    coneq[30382]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*c**4)-1/3024.
    coneq[30383]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**4)-1/6048.
    coneq[30384]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*c**4)-1/2016.
    coneq[30385]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*c**4)-1/756.
    coneq[30386]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*c**4)-1/1512.
    coneq[30387]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*c**4)-1/504.
    coneq[30388]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*c**4)-1/1512.
    coneq[30389]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*c**4)-1/3024.
    coneq[30390]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*c**4)-1/1008.
    coneq[30391]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*c**4)-1/504.
    coneq[30392]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*c**4)-1/2520.
    coneq[30393]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*c**4)-1/10080.
    coneq[30394]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*c**4)-1/30240.
    coneq[30395]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*c**4)-1/60480.
    coneq[30396]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*c**4)-1/20160.
    coneq[30397]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*c**4)-1/7560.
    coneq[30398]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*c**4)-1/15120.
    coneq[30399]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*c**4)-1/5040.
    coneq[30400]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*c**4)-1/10080.
    coneq[30401]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*c**4)-1/2016.
    coneq[30402]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**4)-1/6048.
    coneq[30403]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**4)-1/12096.
    coneq[30404]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**4)-1/4032.
    coneq[30405]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*c**4)-1/1512.
    coneq[30406]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**4)-1/3024.
    coneq[30407]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*c**4)-1/1008.
    coneq[30408]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*c**4)-1/3024.
    coneq[30409]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**4)-1/6048.
    coneq[30410]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**4)-1/2016.
    coneq[30411]=dot(b,dot(A,c**6)*dot(A,c)*c**4)-1/196.
    coneq[30412]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*c**4)-1/1176.
    coneq[30413]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*c**4)-1/5880.
    coneq[30414]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*c**4)-1/23520.
    coneq[30415]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*c**4)-1/70560.
    coneq[30416]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*c**4)-1/141120.
    coneq[30417]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*c**4)-1/47040.
    coneq[30418]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*c**4)-1/17640.
    coneq[30419]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*c**4)-1/35280.
    coneq[30420]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*c**4)-1/11760.
    coneq[30421]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*c**4)-1/23520.
    coneq[30422]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*c**4)-1/4704.
    coneq[30423]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*c**4)-1/14112.
    coneq[30424]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**4)-1/28224.
    coneq[30425]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*c**4)-1/9408.
    coneq[30426]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*c**4)-1/3528.
    coneq[30427]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*c**4)-1/7056.
    coneq[30428]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*c**4)-1/2352.
    coneq[30429]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*c**4)-1/7056.
    coneq[30430]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*c**4)-1/14112.
    coneq[30431]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*c**4)-1/4704.
    coneq[30432]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*c**4)-1/980.
    coneq[30433]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*c**4)-1/3920.
    coneq[30434]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**4)-1/11760.
    coneq[30435]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**4)-1/23520.
    coneq[30436]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**4)-1/7840.
    coneq[30437]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*c**4)-1/2940.
    coneq[30438]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**4)-1/5880.
    coneq[30439]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*c**4)-1/1960.
    coneq[30440]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**4)-1/3920.
    coneq[30441]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*c**4)-1/784.
    coneq[30442]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*c**4)-1/2352.
    coneq[30443]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**4)-1/4704.
    coneq[30444]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*c**4)-1/1568.
    coneq[30445]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*c**4)-1/588.
    coneq[30446]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/1176.
    coneq[30447]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*c**4)-1/392.
    coneq[30448]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*c**4)-1/1764.
    coneq[30449]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/3528.
    coneq[30450]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/7056.
    coneq[30451]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*c**4)-1/1568.
    coneq[30452]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*c**4)-1/4704.
    coneq[30453]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**4)-1/9408.
    coneq[30454]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*c**4)-1/3136.
    coneq[30455]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*c**4)-1/1176.
    coneq[30456]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**4)-1/2352.
    coneq[30457]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*c**4)-1/784.
    coneq[30458]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*c**4)-1/1568.
    coneq[30459]=dot(b,dot(A,c**3)*dot(A,c**3)*c**5)-1/224.
    coneq[30460]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*c**5)-1/672.
    coneq[30461]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c**5)-1/1344.
    coneq[30462]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*c**5)-1/448.
    coneq[30463]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c**5)-1/2016.
    coneq[30464]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c**5)-1/4032.
    coneq[30465]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*c**5)-1/1344.
    coneq[30466]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c**5)-1/8064.
    coneq[30467]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*c**5)-1/2688.
    coneq[30468]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*c**5)-1/896.
    coneq[30469]=dot(b,dot(A,c**4)*dot(A,c**2)*c**5)-1/210.
    coneq[30470]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*c**5)-1/840.
    coneq[30471]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*c**5)-1/2520.
    coneq[30472]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*c**5)-1/5040.
    coneq[30473]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*c**5)-1/1680.
    coneq[30474]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*c**5)-1/630.
    coneq[30475]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*c**5)-1/1260.
    coneq[30476]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*c**5)-1/420.
    coneq[30477]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*c**5)-1/840.
    coneq[30478]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*c**5)-1/420.
    coneq[30479]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*c**5)-1/1680.
    coneq[30480]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*c**5)-1/5040.
    coneq[30481]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*c**5)-1/10080.
    coneq[30482]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*c**5)-1/3360.
    coneq[30483]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*c**5)-1/1260.
    coneq[30484]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*c**5)-1/2520.
    coneq[30485]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*c**5)-1/840.
    coneq[30486]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*c**5)-1/1680.
    coneq[30487]=dot(b,dot(A,c**5)*dot(A,c)*c**5)-1/168.
    coneq[30488]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*c**5)-1/840.
    coneq[30489]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*c**5)-1/3360.
    coneq[30490]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*c**5)-1/10080.
    coneq[30491]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*c**5)-1/20160.
    coneq[30492]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*c**5)-1/6720.
    coneq[30493]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*c**5)-1/2520.
    coneq[30494]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*c**5)-1/5040.
    coneq[30495]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*c**5)-1/1680.
    coneq[30496]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*c**5)-1/3360.
    coneq[30497]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*c**5)-1/672.
    coneq[30498]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*c**5)-1/2016.
    coneq[30499]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*c**5)-1/4032.
    coneq[30500]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*c**5)-1/1344.
    coneq[30501]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*c**5)-1/504.
    coneq[30502]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*c**5)-1/1008.
    coneq[30503]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*c**5)-1/336.
    coneq[30504]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*c**5)-1/1008.
    coneq[30505]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*c**5)-1/2016.
    coneq[30506]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*c**5)-1/672.
    coneq[30507]=dot(b,dot(A,c**3)*dot(A,c**2)*c**6)-1/168.
    coneq[30508]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*c**6)-1/504.
    coneq[30509]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c**6)-1/1008.
    coneq[30510]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*c**6)-1/336.
    coneq[30511]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*c**6)-1/336.
    coneq[30512]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*c**6)-1/1008.
    coneq[30513]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c**6)-1/2016.
    coneq[30514]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*c**6)-1/672.
    coneq[30515]=dot(b,dot(A,c**4)*dot(A,c)*c**6)-1/140.
    coneq[30516]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*c**6)-1/560.
    coneq[30517]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c**6)-1/1680.
    coneq[30518]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c**6)-1/3360.
    coneq[30519]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c**6)-1/1120.
    coneq[30520]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*c**6)-1/420.
    coneq[30521]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c**6)-1/840.
    coneq[30522]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*c**6)-1/280.
    coneq[30523]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c**6)-1/560.
    coneq[30524]=dot(b,dot(A,c**2)*dot(A,c**2)*c**7)-1/126.
    coneq[30525]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*c**7)-1/252.
    coneq[30526]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*c**7)-1/504.
    coneq[30527]=dot(b,dot(A,c**3)*dot(A,c)*c**7)-1/112.
    coneq[30528]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*c**7)-1/336.
    coneq[30529]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*c**7)-1/672.
    coneq[30530]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*c**7)-1/224.
    coneq[30531]=dot(b,dot(A,c**2)*dot(A,c)*c**8)-1/84.
    coneq[30532]=dot(b,dot(A,dot(A,c))*dot(A,c)*c**8)-1/168.
    coneq[30533]=dot(b,dot(A,c)*dot(A,c)*c**9)-1/56.
    coneq[30534]=dot(b,dot(A,c**8)*dot(A,c)*dot(A,c))-1/504.
    coneq[30535]=dot(b,dot(A,dot(A,c**7))*dot(A,c)*dot(A,c))-1/4032.
    coneq[30536]=dot(b,dot(A,dot(A,dot(A,c**6)))*dot(A,c)*dot(A,c))-1/28224.
    coneq[30537]=dot(b,dot(A,dot(A,dot(A,dot(A,c**5))))*dot(A,c)*dot(A,c))-1/169344.
    coneq[30538]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**4)))))*dot(A,c)*dot(A,c))-1/846720.
    coneq[30539]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**3))))))*dot(A,c)*dot(A,c))-1/3386880.
    coneq[30540]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))))*dot(A,c)*dot(A,c))-1/10160640.
    coneq[30541]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))))*dot(A,c)*dot(A,c))-1/20321280.
    coneq[30542]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))))*dot(A,c)*dot(A,c))-1/6773760.
    coneq[30543]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2))))))*dot(A,c)*dot(A,c))-1/2540160.
    coneq[30544]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c))-1/5080320.
    coneq[30545]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c))))))*dot(A,c)*dot(A,c))-1/1693440.
    coneq[30546]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))))*dot(A,c)*dot(A,c))-1/3386880.
    coneq[30547]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**3)))))*dot(A,c)*dot(A,c))-1/677376.
    coneq[30548]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2))))))*dot(A,c)*dot(A,c))-1/2032128.
    coneq[30549]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c))-1/4064256.
    coneq[30550]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c))))))*dot(A,c)*dot(A,c))-1/1354752.
    coneq[30551]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/508032.
    coneq[30552]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/1016064.
    coneq[30553]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3*dot(A,c)))))*dot(A,c)*dot(A,c))-1/338688.
    coneq[30554]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/1016064.
    coneq[30555]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/2032128.
    coneq[30556]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c)))))*dot(A,c)*dot(A,c))-1/677376.
    coneq[30557]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**4))))*dot(A,c)*dot(A,c))-1/141120.
    coneq[30558]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**3)))))*dot(A,c)*dot(A,c))-1/564480.
    coneq[30559]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*dot(A,c))-1/1693440.
    coneq[30560]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c))-1/3386880.
    coneq[30561]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*dot(A,c))-1/1128960.
    coneq[30562]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/423360.
    coneq[30563]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/846720.
    coneq[30564]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2*dot(A,c)))))*dot(A,c)*dot(A,c))-1/282240.
    coneq[30565]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*dot(A,c))-1/564480.
    coneq[30566]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**3))))*dot(A,c)*dot(A,c))-1/112896.
    coneq[30567]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/338688.
    coneq[30568]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/677376.
    coneq[30569]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/225792.
    coneq[30570]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/84672.
    coneq[30571]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/169344.
    coneq[30572]=dot(b,dot(A,dot(A,dot(A,c**4*dot(A,c))))*dot(A,c)*dot(A,c))-1/56448.
    coneq[30573]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/254016.
    coneq[30574]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/508032.
    coneq[30575]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/1016064.
    coneq[30576]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**3))))*dot(A,c)*dot(A,c))-1/225792.
    coneq[30577]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/677376.
    coneq[30578]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/1354752.
    coneq[30579]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/451584.
    coneq[30580]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/169344.
    coneq[30581]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/338688.
    coneq[30582]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/112896.
    coneq[30583]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/225792.
    coneq[30584]=dot(b,dot(A,dot(A,c*dot(A,c**5)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30585]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**4))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30586]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*dot(A,c))-1/483840.
    coneq[30587]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*dot(A,c))-1/1451520.
    coneq[30588]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c))-1/2903040.
    coneq[30589]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*dot(A,c))-1/967680.
    coneq[30590]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/362880.
    coneq[30591]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/725760.
    coneq[30592]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*dot(A,c))-1/241920.
    coneq[30593]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*dot(A,c))-1/483840.
    coneq[30594]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**3))))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30595]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/290304.
    coneq[30596]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/580608.
    coneq[30597]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/193536.
    coneq[30598]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30599]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/145152.
    coneq[30600]=dot(b,dot(A,dot(A,c*dot(A,c**3*dot(A,c))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30601]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/145152.
    coneq[30602]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/290304.
    coneq[30603]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30604]=dot(b,dot(A,dot(A,c**2*dot(A,c**4)))*dot(A,c)*dot(A,c))-1/20160.
    coneq[30605]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/80640.
    coneq[30606]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/241920.
    coneq[30607]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/483840.
    coneq[30608]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/161280.
    coneq[30609]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30610]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30611]=dot(b,dot(A,dot(A,c**2*dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/40320.
    coneq[30612]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/80640.
    coneq[30613]=dot(b,dot(A,dot(A,c**3*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/16128.
    coneq[30614]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30615]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30616]=dot(b,dot(A,dot(A,c**3*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/32256.
    coneq[30617]=dot(b,dot(A,dot(A,c**4*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30618]=dot(b,dot(A,dot(A,c**4*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30619]=dot(b,dot(A,dot(A,c**5*dot(A,c)))*dot(A,c)*dot(A,c))-1/8064.
    coneq[30620]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30621]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/145152.
    coneq[30622]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/290304.
    coneq[30623]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30624]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30625]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/290304.
    coneq[30626]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/580608.
    coneq[30627]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/193536.
    coneq[30628]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**4)))*dot(A,c)*dot(A,c))-1/40320.
    coneq[30629]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/161280.
    coneq[30630]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/483840.
    coneq[30631]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/967680.
    coneq[30632]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/322560.
    coneq[30633]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30634]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/241920.
    coneq[30635]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/80640.
    coneq[30636]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/161280.
    coneq[30637]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30638]=dot(b,dot(A,dot(A,c*dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30639]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/145152.
    coneq[30640]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/32256.
    coneq[30641]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30642]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/193536.
    coneq[30643]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/64512.
    coneq[30644]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30645]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30646]=dot(b,dot(A,dot(A,c**3*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/16128.
    coneq[30647]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30648]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30649]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/32256.
    coneq[30650]=dot(b,dot(A,c*dot(A,c**6))*dot(A,c)*dot(A,c))-1/3528.
    coneq[30651]=dot(b,dot(A,c*dot(A,dot(A,c**5)))*dot(A,c)*dot(A,c))-1/21168.
    coneq[30652]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**4))))*dot(A,c)*dot(A,c))-1/105840.
    coneq[30653]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*dot(A,c))-1/423360.
    coneq[30654]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*dot(A,c))-1/1270080.
    coneq[30655]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c))-1/2540160.
    coneq[30656]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*dot(A,c))-1/846720.
    coneq[30657]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/317520.
    coneq[30658]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/635040.
    coneq[30659]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*dot(A,c))-1/211680.
    coneq[30660]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*dot(A,c))-1/423360.
    coneq[30661]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*dot(A,c))-1/84672.
    coneq[30662]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/254016.
    coneq[30663]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/508032.
    coneq[30664]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/169344.
    coneq[30665]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/63504.
    coneq[30666]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/127008.
    coneq[30667]=dot(b,dot(A,c*dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*dot(A,c))-1/42336.
    coneq[30668]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/127008.
    coneq[30669]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/254016.
    coneq[30670]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/84672.
    coneq[30671]=dot(b,dot(A,c*dot(A,c*dot(A,c**4)))*dot(A,c)*dot(A,c))-1/17640.
    coneq[30672]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/70560.
    coneq[30673]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/211680.
    coneq[30674]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/423360.
    coneq[30675]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/141120.
    coneq[30676]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/52920.
    coneq[30677]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/105840.
    coneq[30678]=dot(b,dot(A,c*dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/35280.
    coneq[30679]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/70560.
    coneq[30680]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/14112.
    coneq[30681]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/42336.
    coneq[30682]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/84672.
    coneq[30683]=dot(b,dot(A,c*dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/28224.
    coneq[30684]=dot(b,dot(A,c*dot(A,c**3*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/10584.
    coneq[30685]=dot(b,dot(A,c*dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/21168.
    coneq[30686]=dot(b,dot(A,c*dot(A,c**4*dot(A,c)))*dot(A,c)*dot(A,c))-1/7056.
    coneq[30687]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/31752.
    coneq[30688]=dot(b,dot(A,c*dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/63504.
    coneq[30689]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/127008.
    coneq[30690]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/28224.
    coneq[30691]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/84672.
    coneq[30692]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/169344.
    coneq[30693]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/56448.
    coneq[30694]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/21168.
    coneq[30695]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/42336.
    coneq[30696]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/14112.
    coneq[30697]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/28224.
    coneq[30698]=dot(b,dot(A,c**2*dot(A,c**5))*dot(A,c)*dot(A,c))-1/3024.
    coneq[30699]=dot(b,dot(A,c**2*dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c))-1/15120.
    coneq[30700]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30701]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/181440.
    coneq[30702]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/362880.
    coneq[30703]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30704]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/45360.
    coneq[30705]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/90720.
    coneq[30706]=dot(b,dot(A,c**2*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30707]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30708]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30709]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30710]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30711]=dot(b,dot(A,c**2*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30712]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/9072.
    coneq[30713]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/18144.
    coneq[30714]=dot(b,dot(A,c**2*dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c))-1/6048.
    coneq[30715]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/18144.
    coneq[30716]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30717]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30718]=dot(b,dot(A,c**3*dot(A,c**4))*dot(A,c)*dot(A,c))-1/2520.
    coneq[30719]=dot(b,dot(A,c**3*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/10080.
    coneq[30720]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30721]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30722]=dot(b,dot(A,c**3*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/20160.
    coneq[30723]=dot(b,dot(A,c**3*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/7560.
    coneq[30724]=dot(b,dot(A,c**3*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/15120.
    coneq[30725]=dot(b,dot(A,c**3*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/5040.
    coneq[30726]=dot(b,dot(A,c**3*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/10080.
    coneq[30727]=dot(b,dot(A,c**4*dot(A,c**3))*dot(A,c)*dot(A,c))-1/2016.
    coneq[30728]=dot(b,dot(A,c**4*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/6048.
    coneq[30729]=dot(b,dot(A,c**4*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30730]=dot(b,dot(A,c**4*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/4032.
    coneq[30731]=dot(b,dot(A,c**5*dot(A,c**2))*dot(A,c)*dot(A,c))-1/1512.
    coneq[30732]=dot(b,dot(A,c**5*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/3024.
    coneq[30733]=dot(b,dot(A,c**6*dot(A,c))*dot(A,c)*dot(A,c))-1/1008.
    coneq[30734]=dot(b,dot(A,dot(A,c**3)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/8064.
    coneq[30735]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30736]=dot(b,dot(A,dot(A,c**3)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30737]=dot(b,dot(A,dot(A,c**3)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/16128.
    coneq[30738]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30739]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/145152.
    coneq[30740]=dot(b,dot(A,dot(A,dot(A,c**2))*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30741]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/290304.
    coneq[30742]=dot(b,dot(A,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/96768.
    coneq[30743]=dot(b,dot(A,dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/32256.
    coneq[30744]=dot(b,dot(A,dot(A,c**2)*dot(A,c**4))*dot(A,c)*dot(A,c))-1/7560.
    coneq[30745]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30746]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/90720.
    coneq[30747]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/181440.
    coneq[30748]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30749]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/22680.
    coneq[30750]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/45360.
    coneq[30751]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/15120.
    coneq[30752]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30753]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**4))*dot(A,c)*dot(A,c))-1/15120.
    coneq[30754]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30755]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/181440.
    coneq[30756]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/362880.
    coneq[30757]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30758]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/45360.
    coneq[30759]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/90720.
    coneq[30760]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30761]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30762]=dot(b,dot(A,dot(A,c)*dot(A,c**5))*dot(A,c)*dot(A,c))-1/6048.
    coneq[30763]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30764]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30765]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c))-1/362880.
    coneq[30766]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c))-1/725760.
    coneq[30767]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c))-1/241920.
    coneq[30768]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c))-1/90720.
    coneq[30769]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/181440.
    coneq[30770]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30771]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30772]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30773]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30774]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/145152.
    coneq[30775]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30776]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/18144.
    coneq[30777]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30778]=dot(b,dot(A,dot(A,c)*dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30779]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30780]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30781]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30782]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/6048.
    coneq[30783]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/18144.
    coneq[30784]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30785]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30786]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30787]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30788]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/72576.
    coneq[30789]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30790]=dot(b,dot(A,c*dot(A,c)*dot(A,c**4))*dot(A,c)*dot(A,c))-1/5040.
    coneq[30791]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c))-1/20160.
    coneq[30792]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c))-1/60480.
    coneq[30793]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c))-1/120960.
    coneq[30794]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c))-1/40320.
    coneq[30795]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c))-1/15120.
    coneq[30796]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/30240.
    coneq[30797]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c))-1/10080.
    coneq[30798]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c))-1/20160.
    coneq[30799]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/4536.
    coneq[30800]=dot(b,dot(A,c**2*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/9072.
    coneq[30801]=dot(b,dot(A,c**2*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/18144.
    coneq[30802]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/4032.
    coneq[30803]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30804]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30805]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/8064.
    coneq[30806]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/3024.
    coneq[30807]=dot(b,dot(A,c**3*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/6048.
    coneq[30808]=dot(b,dot(A,c**4*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/2016.
    coneq[30809]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c))-1/8064.
    coneq[30810]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c))-1/24192.
    coneq[30811]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c))-1/48384.
    coneq[30812]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c))-1/16128.
    coneq[30813]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/9072.
    coneq[30814]=dot(b,dot(A,dot(A,c)*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/18144.
    coneq[30815]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/36288.
    coneq[30816]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c))-1/6048.
    coneq[30817]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/12096.
    coneq[30818]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/4032.
    coneq[30819]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c))-1/8064.
    coneq[30820]=dot(b,dot(A,c**7)*dot(A,c**2)*dot(A,c))-1/672.
    coneq[30821]=dot(b,dot(A,dot(A,c**6))*dot(A,c**2)*dot(A,c))-1/4704.
    coneq[30822]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c**2)*dot(A,c))-1/28224.
    coneq[30823]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c**2)*dot(A,c))-1/141120.
    coneq[30824]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c**2)*dot(A,c))-1/564480.
    coneq[30825]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c**2)*dot(A,c))-1/1693440.
    coneq[30826]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c**2)*dot(A,c))-1/3386880.
    coneq[30827]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c**2)*dot(A,c))-1/1128960.
    coneq[30828]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c**2)*dot(A,c))-1/423360.
    coneq[30829]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c))-1/846720.
    coneq[30830]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/282240.
    coneq[30831]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/564480.
    coneq[30832]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c**2)*dot(A,c))-1/112896.
    coneq[30833]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c**2)*dot(A,c))-1/338688.
    coneq[30834]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c))-1/677376.
    coneq[30835]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/225792.
    coneq[30836]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/84672.
    coneq[30837]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/169344.
    coneq[30838]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/56448.
    coneq[30839]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/169344.
    coneq[30840]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/338688.
    coneq[30841]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/112896.
    coneq[30842]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c**2)*dot(A,c))-1/23520.
    coneq[30843]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c**2)*dot(A,c))-1/94080.
    coneq[30844]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*dot(A,c))-1/282240.
    coneq[30845]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c))-1/564480.
    coneq[30846]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/188160.
    coneq[30847]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/70560.
    coneq[30848]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/141120.
    coneq[30849]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/47040.
    coneq[30850]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/94080.
    coneq[30851]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/18816.
    coneq[30852]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/56448.
    coneq[30853]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/112896.
    coneq[30854]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/37632.
    coneq[30855]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/14112.
    coneq[30856]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/28224.
    coneq[30857]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/9408.
    coneq[30858]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/42336.
    coneq[30859]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/84672.
    coneq[30860]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/169344.
    coneq[30861]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/37632.
    coneq[30862]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/112896.
    coneq[30863]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/225792.
    coneq[30864]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/75264.
    coneq[30865]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/28224.
    coneq[30866]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/56448.
    coneq[30867]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/18816.
    coneq[30868]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/37632.
    coneq[30869]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c**2)*dot(A,c))-1/4032.
    coneq[30870]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c**2)*dot(A,c))-1/20160.
    coneq[30871]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*dot(A,c))-1/80640.
    coneq[30872]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*dot(A,c))-1/241920.
    coneq[30873]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c))-1/483840.
    coneq[30874]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/161280.
    coneq[30875]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/60480.
    coneq[30876]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/120960.
    coneq[30877]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/40320.
    coneq[30878]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/80640.
    coneq[30879]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30880]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/48384.
    coneq[30881]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/96768.
    coneq[30882]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/32256.
    coneq[30883]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/12096.
    coneq[30884]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/24192.
    coneq[30885]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[30886]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/24192.
    coneq[30887]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/48384.
    coneq[30888]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30889]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c**2)*dot(A,c))-1/3360.
    coneq[30890]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/13440.
    coneq[30891]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/40320.
    coneq[30892]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/80640.
    coneq[30893]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/26880.
    coneq[30894]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/10080.
    coneq[30895]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/20160.
    coneq[30896]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/6720.
    coneq[30897]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/13440.
    coneq[30898]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/2688.
    coneq[30899]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[30900]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30901]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/5376.
    coneq[30902]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/2016.
    coneq[30903]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/4032.
    coneq[30904]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c**2)*dot(A,c))-1/1344.
    coneq[30905]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[30906]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/24192.
    coneq[30907]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/48384.
    coneq[30908]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30909]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30910]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/48384.
    coneq[30911]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/96768.
    coneq[30912]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/32256.
    coneq[30913]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c**2)*dot(A,c))-1/6720.
    coneq[30914]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c))-1/26880.
    coneq[30915]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c))-1/80640.
    coneq[30916]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c))-1/161280.
    coneq[30917]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c))-1/53760.
    coneq[30918]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/20160.
    coneq[30919]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/40320.
    coneq[30920]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/13440.
    coneq[30921]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/26880.
    coneq[30922]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/6048.
    coneq[30923]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/12096.
    coneq[30924]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/24192.
    coneq[30925]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c**2)*dot(A,c))-1/5376.
    coneq[30926]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30927]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c))-1/32256.
    coneq[30928]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c))-1/10752.
    coneq[30929]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/4032.
    coneq[30930]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[30931]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c))-1/2688.
    coneq[30932]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[30933]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[30934]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c))-1/5376.
    coneq[30935]=dot(b,dot(A,c**7)*dot(A,dot(A,c))*dot(A,c))-1/1344.
    coneq[30936]=dot(b,dot(A,dot(A,c**6))*dot(A,dot(A,c))*dot(A,c))-1/9408.
    coneq[30937]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,dot(A,c))*dot(A,c))-1/56448.
    coneq[30938]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,dot(A,c))*dot(A,c))-1/282240.
    coneq[30939]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,dot(A,c))*dot(A,c))-1/1128960.
    coneq[30940]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,dot(A,c))*dot(A,c))-1/3386880.
    coneq[30941]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,dot(A,c))*dot(A,c))-1/6773760.
    coneq[30942]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,dot(A,c))*dot(A,c))-1/2257920.
    coneq[30943]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c))-1/846720.
    coneq[30944]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c))-1/1693440.
    coneq[30945]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/564480.
    coneq[30946]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/1128960.
    coneq[30947]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,dot(A,c))*dot(A,c))-1/225792.
    coneq[30948]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c))-1/677376.
    coneq[30949]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c))-1/1354752.
    coneq[30950]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/451584.
    coneq[30951]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/169344.
    coneq[30952]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/338688.
    coneq[30953]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/112896.
    coneq[30954]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/338688.
    coneq[30955]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/677376.
    coneq[30956]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/225792.
    coneq[30957]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,dot(A,c))*dot(A,c))-1/47040.
    coneq[30958]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,dot(A,c))*dot(A,c))-1/188160.
    coneq[30959]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c))-1/564480.
    coneq[30960]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c))-1/1128960.
    coneq[30961]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/376320.
    coneq[30962]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/141120.
    coneq[30963]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/282240.
    coneq[30964]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/94080.
    coneq[30965]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/188160.
    coneq[30966]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/37632.
    coneq[30967]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/112896.
    coneq[30968]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/225792.
    coneq[30969]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/75264.
    coneq[30970]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/28224.
    coneq[30971]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/56448.
    coneq[30972]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/18816.
    coneq[30973]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/84672.
    coneq[30974]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/169344.
    coneq[30975]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/338688.
    coneq[30976]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/75264.
    coneq[30977]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/225792.
    coneq[30978]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/451584.
    coneq[30979]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/150528.
    coneq[30980]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/56448.
    coneq[30981]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/112896.
    coneq[30982]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/37632.
    coneq[30983]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/75264.
    coneq[30984]=dot(b,dot(A,c*dot(A,c**5))*dot(A,dot(A,c))*dot(A,c))-1/8064.
    coneq[30985]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,dot(A,c))*dot(A,c))-1/40320.
    coneq[30986]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*dot(A,c))-1/161280.
    coneq[30987]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c))-1/483840.
    coneq[30988]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c))-1/967680.
    coneq[30989]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/322560.
    coneq[30990]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/120960.
    coneq[30991]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/241920.
    coneq[30992]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/80640.
    coneq[30993]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/161280.
    coneq[30994]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[30995]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/96768.
    coneq[30996]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/193536.
    coneq[30997]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/64512.
    coneq[30998]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/24192.
    coneq[30999]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/48384.
    coneq[31000]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[31001]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/48384.
    coneq[31002]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/96768.
    coneq[31003]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[31004]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,dot(A,c))*dot(A,c))-1/6720.
    coneq[31005]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/26880.
    coneq[31006]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/80640.
    coneq[31007]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/161280.
    coneq[31008]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/53760.
    coneq[31009]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/20160.
    coneq[31010]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/40320.
    coneq[31011]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/13440.
    coneq[31012]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/26880.
    coneq[31013]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/5376.
    coneq[31014]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[31015]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[31016]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/10752.
    coneq[31017]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/4032.
    coneq[31018]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/8064.
    coneq[31019]=dot(b,dot(A,c**5*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/2688.
    coneq[31020]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[31021]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/48384.
    coneq[31022]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/96768.
    coneq[31023]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[31024]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[31025]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/96768.
    coneq[31026]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/193536.
    coneq[31027]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/64512.
    coneq[31028]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,dot(A,c))*dot(A,c))-1/13440.
    coneq[31029]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c))-1/53760.
    coneq[31030]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c))-1/161280.
    coneq[31031]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c))-1/322560.
    coneq[31032]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/107520.
    coneq[31033]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/40320.
    coneq[31034]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/80640.
    coneq[31035]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/26880.
    coneq[31036]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/53760.
    coneq[31037]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/12096.
    coneq[31038]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/24192.
    coneq[31039]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/48384.
    coneq[31040]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c))-1/10752.
    coneq[31041]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[31042]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c))-1/64512.
    coneq[31043]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/21504.
    coneq[31044]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/8064.
    coneq[31045]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[31046]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/5376.
    coneq[31047]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[31048]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[31049]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/10752.
    coneq[31050]=dot(b,dot(A,c**6)*dot(A,c**2)*dot(A,c**2))-1/882.
    coneq[31051]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2)*dot(A,c**2))-1/5292.
    coneq[31052]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2)*dot(A,c**2))-1/26460.
    coneq[31053]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*dot(A,c**2))-1/105840.
    coneq[31054]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*dot(A,c**2))-1/317520.
    coneq[31055]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c**2))-1/635040.
    coneq[31056]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*dot(A,c**2))-1/211680.
    coneq[31057]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*dot(A,c**2))-1/79380.
    coneq[31058]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c**2))-1/158760.
    coneq[31059]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/52920.
    coneq[31060]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/105840.
    coneq[31061]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2)*dot(A,c**2))-1/21168.
    coneq[31062]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c**2))-1/63504.
    coneq[31063]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c**2))-1/127008.
    coneq[31064]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/42336.
    coneq[31065]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/15876.
    coneq[31066]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/31752.
    coneq[31067]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/10584.
    coneq[31068]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/31752.
    coneq[31069]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/63504.
    coneq[31070]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/21168.
    coneq[31071]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2)*dot(A,c**2))-1/4410.
    coneq[31072]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c**2))-1/17640.
    coneq[31073]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c**2))-1/52920.
    coneq[31074]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c**2))-1/105840.
    coneq[31075]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/35280.
    coneq[31076]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/13230.
    coneq[31077]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/26460.
    coneq[31078]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/8820.
    coneq[31079]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/17640.
    coneq[31080]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2)*dot(A,c**2))-1/3528.
    coneq[31081]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/10584.
    coneq[31082]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/21168.
    coneq[31083]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/7056.
    coneq[31084]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/2646.
    coneq[31085]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/5292.
    coneq[31086]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/1764.
    coneq[31087]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/7938.
    coneq[31088]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/15876.
    coneq[31089]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/31752.
    coneq[31090]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2)*dot(A,c**2))-1/7056.
    coneq[31091]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2))-1/21168.
    coneq[31092]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2))-1/42336.
    coneq[31093]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/14112.
    coneq[31094]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c**2))-1/5292.
    coneq[31095]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2))-1/10584.
    coneq[31096]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/3528.
    coneq[31097]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/7056.
    coneq[31098]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*dot(A,c**2))-1/1764.
    coneq[31099]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*dot(A,c**2))-1/10584.
    coneq[31100]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*dot(A,c**2))-1/52920.
    coneq[31101]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*dot(A,c**2))-1/211680.
    coneq[31102]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c**2))-1/635040.
    coneq[31103]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c**2))-1/1270080.
    coneq[31104]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c**2))-1/423360.
    coneq[31105]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c**2))-1/158760.
    coneq[31106]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c**2))-1/317520.
    coneq[31107]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/105840.
    coneq[31108]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/211680.
    coneq[31109]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c**2))-1/42336.
    coneq[31110]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c**2))-1/127008.
    coneq[31111]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c**2))-1/254016.
    coneq[31112]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/84672.
    coneq[31113]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/31752.
    coneq[31114]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/63504.
    coneq[31115]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/21168.
    coneq[31116]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/63504.
    coneq[31117]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/127008.
    coneq[31118]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/42336.
    coneq[31119]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*dot(A,c**2))-1/8820.
    coneq[31120]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c**2))-1/35280.
    coneq[31121]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c**2))-1/105840.
    coneq[31122]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c**2))-1/211680.
    coneq[31123]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/70560.
    coneq[31124]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/26460.
    coneq[31125]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/52920.
    coneq[31126]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/17640.
    coneq[31127]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/35280.
    coneq[31128]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2))-1/7056.
    coneq[31129]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/21168.
    coneq[31130]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/42336.
    coneq[31131]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/14112.
    coneq[31132]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/5292.
    coneq[31133]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/10584.
    coneq[31134]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/3528.
    coneq[31135]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/15876.
    coneq[31136]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/31752.
    coneq[31137]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/63504.
    coneq[31138]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2))-1/14112.
    coneq[31139]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2))-1/42336.
    coneq[31140]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2))-1/84672.
    coneq[31141]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/28224.
    coneq[31142]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2))-1/10584.
    coneq[31143]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2))-1/21168.
    coneq[31144]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/7056.
    coneq[31145]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/14112.
    coneq[31146]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/3528.
    coneq[31147]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/21168.
    coneq[31148]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/105840.
    coneq[31149]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/423360.
    coneq[31150]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/1270080.
    coneq[31151]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/2540160.
    coneq[31152]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/846720.
    coneq[31153]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/317520.
    coneq[31154]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/635040.
    coneq[31155]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/211680.
    coneq[31156]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/423360.
    coneq[31157]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/84672.
    coneq[31158]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/254016.
    coneq[31159]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/508032.
    coneq[31160]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/169344.
    coneq[31161]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/63504.
    coneq[31162]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/127008.
    coneq[31163]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/42336.
    coneq[31164]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/127008.
    coneq[31165]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/254016.
    coneq[31166]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/84672.
    coneq[31167]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/17640.
    coneq[31168]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/70560.
    coneq[31169]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/211680.
    coneq[31170]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/423360.
    coneq[31171]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/141120.
    coneq[31172]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/52920.
    coneq[31173]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/105840.
    coneq[31174]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/35280.
    coneq[31175]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/70560.
    coneq[31176]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/14112.
    coneq[31177]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/42336.
    coneq[31178]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/84672.
    coneq[31179]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/28224.
    coneq[31180]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/10584.
    coneq[31181]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/21168.
    coneq[31182]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/7056.
    coneq[31183]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/31752.
    coneq[31184]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/63504.
    coneq[31185]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/127008.
    coneq[31186]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/28224.
    coneq[31187]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/84672.
    coneq[31188]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/169344.
    coneq[31189]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/56448.
    coneq[31190]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/21168.
    coneq[31191]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/42336.
    coneq[31192]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/14112.
    coneq[31193]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/28224.
    coneq[31194]=dot(b,dot(A,c**6)*dot(A,c**3)*dot(A,c))-1/784.
    coneq[31195]=dot(b,dot(A,dot(A,c**5))*dot(A,c**3)*dot(A,c))-1/4704.
    coneq[31196]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**3)*dot(A,c))-1/23520.
    coneq[31197]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**3)*dot(A,c))-1/94080.
    coneq[31198]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**3)*dot(A,c))-1/282240.
    coneq[31199]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**3)*dot(A,c))-1/564480.
    coneq[31200]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**3)*dot(A,c))-1/188160.
    coneq[31201]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**3)*dot(A,c))-1/70560.
    coneq[31202]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,c))-1/141120.
    coneq[31203]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**3)*dot(A,c))-1/47040.
    coneq[31204]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**3)*dot(A,c))-1/94080.
    coneq[31205]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**3)*dot(A,c))-1/18816.
    coneq[31206]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**3)*dot(A,c))-1/56448.
    coneq[31207]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,c))-1/112896.
    coneq[31208]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**3)*dot(A,c))-1/37632.
    coneq[31209]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/14112.
    coneq[31210]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/28224.
    coneq[31211]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/9408.
    coneq[31212]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/28224.
    coneq[31213]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/56448.
    coneq[31214]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/18816.
    coneq[31215]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**3)*dot(A,c))-1/3920.
    coneq[31216]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**3)*dot(A,c))-1/15680.
    coneq[31217]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*dot(A,c))-1/47040.
    coneq[31218]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,c))-1/94080.
    coneq[31219]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*dot(A,c))-1/31360.
    coneq[31220]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/11760.
    coneq[31221]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/23520.
    coneq[31222]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/7840.
    coneq[31223]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/15680.
    coneq[31224]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**3)*dot(A,c))-1/3136.
    coneq[31225]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/9408.
    coneq[31226]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/18816.
    coneq[31227]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/6272.
    coneq[31228]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/2352.
    coneq[31229]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/4704.
    coneq[31230]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**3)*dot(A,c))-1/1568.
    coneq[31231]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/7056.
    coneq[31232]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/14112.
    coneq[31233]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/28224.
    coneq[31234]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**3)*dot(A,c))-1/6272.
    coneq[31235]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c))-1/18816.
    coneq[31236]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c))-1/37632.
    coneq[31237]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c))-1/12544.
    coneq[31238]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**3)*dot(A,c))-1/4704.
    coneq[31239]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c))-1/9408.
    coneq[31240]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c))-1/3136.
    coneq[31241]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c))-1/6272.
    coneq[31242]=dot(b,dot(A,c**6)*dot(A,dot(A,c**2))*dot(A,c))-1/2352.
    coneq[31243]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c**2))*dot(A,c))-1/14112.
    coneq[31244]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c**2))*dot(A,c))-1/70560.
    coneq[31245]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c**2))*dot(A,c))-1/282240.
    coneq[31246]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c**2))*dot(A,c))-1/846720.
    coneq[31247]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c**2))*dot(A,c))-1/1693440.
    coneq[31248]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c))-1/564480.
    coneq[31249]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,c))-1/211680.
    coneq[31250]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c))-1/423360.
    coneq[31251]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/141120.
    coneq[31252]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/282240.
    coneq[31253]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c**2))*dot(A,c))-1/56448.
    coneq[31254]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,c))-1/169344.
    coneq[31255]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c))-1/338688.
    coneq[31256]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/112896.
    coneq[31257]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/42336.
    coneq[31258]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/84672.
    coneq[31259]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/28224.
    coneq[31260]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/84672.
    coneq[31261]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/169344.
    coneq[31262]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/56448.
    coneq[31263]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c**2))*dot(A,c))-1/11760.
    coneq[31264]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*dot(A,c))-1/47040.
    coneq[31265]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,c))-1/141120.
    coneq[31266]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c))-1/282240.
    coneq[31267]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/94080.
    coneq[31268]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/35280.
    coneq[31269]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/70560.
    coneq[31270]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/23520.
    coneq[31271]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/47040.
    coneq[31272]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c))-1/9408.
    coneq[31273]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/28224.
    coneq[31274]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/56448.
    coneq[31275]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/18816.
    coneq[31276]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/7056.
    coneq[31277]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/14112.
    coneq[31278]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/4704.
    coneq[31279]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/21168.
    coneq[31280]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/42336.
    coneq[31281]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/84672.
    coneq[31282]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c))-1/18816.
    coneq[31283]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c))-1/56448.
    coneq[31284]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c))-1/112896.
    coneq[31285]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/37632.
    coneq[31286]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c))-1/14112.
    coneq[31287]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c))-1/28224.
    coneq[31288]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/9408.
    coneq[31289]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c))-1/18816.
    coneq[31290]=dot(b,dot(A,c**6)*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/4704.
    coneq[31291]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/28224.
    coneq[31292]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/141120.
    coneq[31293]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/564480.
    coneq[31294]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/1693440.
    coneq[31295]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/3386880.
    coneq[31296]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/1128960.
    coneq[31297]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/423360.
    coneq[31298]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/846720.
    coneq[31299]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/282240.
    coneq[31300]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/564480.
    coneq[31301]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/112896.
    coneq[31302]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/338688.
    coneq[31303]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/677376.
    coneq[31304]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/225792.
    coneq[31305]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/84672.
    coneq[31306]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/169344.
    coneq[31307]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/56448.
    coneq[31308]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/169344.
    coneq[31309]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/338688.
    coneq[31310]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/112896.
    coneq[31311]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/23520.
    coneq[31312]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/94080.
    coneq[31313]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/282240.
    coneq[31314]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/564480.
    coneq[31315]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/188160.
    coneq[31316]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/70560.
    coneq[31317]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/141120.
    coneq[31318]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/47040.
    coneq[31319]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/94080.
    coneq[31320]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/18816.
    coneq[31321]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/56448.
    coneq[31322]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/112896.
    coneq[31323]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/37632.
    coneq[31324]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/14112.
    coneq[31325]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/28224.
    coneq[31326]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/9408.
    coneq[31327]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/42336.
    coneq[31328]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/84672.
    coneq[31329]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/169344.
    coneq[31330]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/37632.
    coneq[31331]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/112896.
    coneq[31332]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/225792.
    coneq[31333]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/75264.
    coneq[31334]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/28224.
    coneq[31335]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/56448.
    coneq[31336]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/18816.
    coneq[31337]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c))-1/37632.
    coneq[31338]=dot(b,dot(A,c**6)*dot(A,c*dot(A,c))*dot(A,c))-1/1568.
    coneq[31339]=dot(b,dot(A,dot(A,c**5))*dot(A,c*dot(A,c))*dot(A,c))-1/9408.
    coneq[31340]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c*dot(A,c))*dot(A,c))-1/47040.
    coneq[31341]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c*dot(A,c))*dot(A,c))-1/188160.
    coneq[31342]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c*dot(A,c))*dot(A,c))-1/564480.
    coneq[31343]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c*dot(A,c))*dot(A,c))-1/1128960.
    coneq[31344]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c))-1/376320.
    coneq[31345]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,c))-1/141120.
    coneq[31346]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c))-1/282240.
    coneq[31347]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/94080.
    coneq[31348]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/188160.
    coneq[31349]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c*dot(A,c))*dot(A,c))-1/37632.
    coneq[31350]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,c))-1/112896.
    coneq[31351]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c))-1/225792.
    coneq[31352]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/75264.
    coneq[31353]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/28224.
    coneq[31354]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/56448.
    coneq[31355]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/18816.
    coneq[31356]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/56448.
    coneq[31357]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/112896.
    coneq[31358]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/37632.
    coneq[31359]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c*dot(A,c))*dot(A,c))-1/7840.
    coneq[31360]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*dot(A,c))-1/31360.
    coneq[31361]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,c))-1/94080.
    coneq[31362]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c))-1/188160.
    coneq[31363]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/62720.
    coneq[31364]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/23520.
    coneq[31365]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/47040.
    coneq[31366]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/15680.
    coneq[31367]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/31360.
    coneq[31368]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c))-1/6272.
    coneq[31369]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/18816.
    coneq[31370]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/37632.
    coneq[31371]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/12544.
    coneq[31372]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c))-1/4704.
    coneq[31373]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/9408.
    coneq[31374]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/3136.
    coneq[31375]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c))-1/14112.
    coneq[31376]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/28224.
    coneq[31377]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/56448.
    coneq[31378]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c))-1/12544.
    coneq[31379]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c))-1/37632.
    coneq[31380]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c))-1/75264.
    coneq[31381]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/25088.
    coneq[31382]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c))-1/9408.
    coneq[31383]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c))-1/18816.
    coneq[31384]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/6272.
    coneq[31385]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c))-1/12544.
    coneq[31386]=dot(b,dot(A,c**5)*dot(A,c**3)*dot(A,c**2))-1/1008.
    coneq[31387]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*dot(A,c**2))-1/5040.
    coneq[31388]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*dot(A,c**2))-1/20160.
    coneq[31389]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*dot(A,c**2))-1/60480.
    coneq[31390]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,c**2))-1/120960.
    coneq[31391]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*dot(A,c**2))-1/40320.
    coneq[31392]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*dot(A,c**2))-1/15120.
    coneq[31393]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c**2))-1/30240.
    coneq[31394]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/10080.
    coneq[31395]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/20160.
    coneq[31396]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*dot(A,c**2))-1/4032.
    coneq[31397]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c**2))-1/12096.
    coneq[31398]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c**2))-1/24192.
    coneq[31399]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/8064.
    coneq[31400]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*dot(A,c**2))-1/3024.
    coneq[31401]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/6048.
    coneq[31402]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*dot(A,c**2))-1/2016.
    coneq[31403]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*dot(A,c**2))-1/6048.
    coneq[31404]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2))-1/12096.
    coneq[31405]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c**2))-1/4032.
    coneq[31406]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*dot(A,c**2))-1/3024.
    coneq[31407]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*dot(A,c**2))-1/15120.
    coneq[31408]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/60480.
    coneq[31409]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,c**2))-1/181440.
    coneq[31410]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c**2))-1/362880.
    coneq[31411]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c**2))-1/120960.
    coneq[31412]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/45360.
    coneq[31413]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c**2))-1/90720.
    coneq[31414]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/30240.
    coneq[31415]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/60480.
    coneq[31416]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c**2))-1/12096.
    coneq[31417]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/36288.
    coneq[31418]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c**2))-1/72576.
    coneq[31419]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/24192.
    coneq[31420]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2))-1/9072.
    coneq[31421]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/18144.
    coneq[31422]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2))-1/6048.
    coneq[31423]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2))-1/18144.
    coneq[31424]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2))-1/36288.
    coneq[31425]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2))-1/12096.
    coneq[31426]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/6048.
    coneq[31427]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/30240.
    coneq[31428]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/120960.
    coneq[31429]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/362880.
    coneq[31430]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/725760.
    coneq[31431]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/241920.
    coneq[31432]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/90720.
    coneq[31433]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/181440.
    coneq[31434]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/60480.
    coneq[31435]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/120960.
    coneq[31436]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/24192.
    coneq[31437]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/72576.
    coneq[31438]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/145152.
    coneq[31439]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/48384.
    coneq[31440]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/18144.
    coneq[31441]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/36288.
    coneq[31442]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/12096.
    coneq[31443]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/36288.
    coneq[31444]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/72576.
    coneq[31445]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2))-1/24192.
    coneq[31446]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*dot(A,c**2))-1/2016.
    coneq[31447]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*dot(A,c**2))-1/10080.
    coneq[31448]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/40320.
    coneq[31449]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,c**2))-1/120960.
    coneq[31450]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c**2))-1/241920.
    coneq[31451]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c**2))-1/80640.
    coneq[31452]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/30240.
    coneq[31453]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c**2))-1/60480.
    coneq[31454]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/20160.
    coneq[31455]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/40320.
    coneq[31456]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c**2))-1/8064.
    coneq[31457]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/24192.
    coneq[31458]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c**2))-1/48384.
    coneq[31459]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/16128.
    coneq[31460]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c**2))-1/6048.
    coneq[31461]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/12096.
    coneq[31462]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2))-1/4032.
    coneq[31463]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c**2))-1/12096.
    coneq[31464]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2))-1/24192.
    coneq[31465]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2))-1/8064.
    coneq[31466]=dot(b,dot(A,c**5)*dot(A,c**3)*dot(A,dot(A,c)))-1/2016.
    coneq[31467]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*dot(A,dot(A,c)))-1/10080.
    coneq[31468]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*dot(A,dot(A,c)))-1/40320.
    coneq[31469]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*dot(A,dot(A,c)))-1/120960.
    coneq[31470]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,dot(A,c)))-1/241920.
    coneq[31471]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*dot(A,dot(A,c)))-1/80640.
    coneq[31472]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*dot(A,dot(A,c)))-1/30240.
    coneq[31473]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,dot(A,c)))-1/60480.
    coneq[31474]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/20160.
    coneq[31475]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/40320.
    coneq[31476]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*dot(A,dot(A,c)))-1/8064.
    coneq[31477]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,dot(A,c)))-1/24192.
    coneq[31478]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,dot(A,c)))-1/48384.
    coneq[31479]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/16128.
    coneq[31480]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c)))-1/6048.
    coneq[31481]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/12096.
    coneq[31482]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c)))-1/4032.
    coneq[31483]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c)))-1/12096.
    coneq[31484]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c)))-1/24192.
    coneq[31485]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c)))-1/8064.
    coneq[31486]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/6048.
    coneq[31487]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/30240.
    coneq[31488]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/120960.
    coneq[31489]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/362880.
    coneq[31490]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/725760.
    coneq[31491]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/241920.
    coneq[31492]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/90720.
    coneq[31493]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/181440.
    coneq[31494]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/60480.
    coneq[31495]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/120960.
    coneq[31496]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/24192.
    coneq[31497]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/72576.
    coneq[31498]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/145152.
    coneq[31499]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/48384.
    coneq[31500]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/18144.
    coneq[31501]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/36288.
    coneq[31502]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/12096.
    coneq[31503]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/36288.
    coneq[31504]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/72576.
    coneq[31505]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c)))-1/24192.
    coneq[31506]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/12096.
    coneq[31507]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/60480.
    coneq[31508]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/241920.
    coneq[31509]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/725760.
    coneq[31510]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/1451520.
    coneq[31511]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/483840.
    coneq[31512]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/181440.
    coneq[31513]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/362880.
    coneq[31514]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/120960.
    coneq[31515]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/241920.
    coneq[31516]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/48384.
    coneq[31517]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/145152.
    coneq[31518]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/290304.
    coneq[31519]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/96768.
    coneq[31520]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/36288.
    coneq[31521]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/72576.
    coneq[31522]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/24192.
    coneq[31523]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/72576.
    coneq[31524]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/145152.
    coneq[31525]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/48384.
    coneq[31526]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/4032.
    coneq[31527]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/20160.
    coneq[31528]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/80640.
    coneq[31529]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/241920.
    coneq[31530]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/483840.
    coneq[31531]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/161280.
    coneq[31532]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/60480.
    coneq[31533]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/120960.
    coneq[31534]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/40320.
    coneq[31535]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/80640.
    coneq[31536]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/16128.
    coneq[31537]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/48384.
    coneq[31538]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/96768.
    coneq[31539]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/32256.
    coneq[31540]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/12096.
    coneq[31541]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/24192.
    coneq[31542]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/8064.
    coneq[31543]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/24192.
    coneq[31544]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/48384.
    coneq[31545]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c)))-1/16128.
    coneq[31546]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c**3))-1/1120.
    coneq[31547]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c**3))-1/4480.
    coneq[31548]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c**3))-1/13440.
    coneq[31549]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c**3))-1/26880.
    coneq[31550]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c**3))-1/8960.
    coneq[31551]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c**3))-1/3360.
    coneq[31552]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**3))-1/6720.
    coneq[31553]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c**3))-1/2240.
    coneq[31554]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c**3))-1/4480.
    coneq[31555]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c**3))-1/3360.
    coneq[31556]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c**3))-1/13440.
    coneq[31557]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c**3))-1/40320.
    coneq[31558]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c**3))-1/80640.
    coneq[31559]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**3))-1/26880.
    coneq[31560]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**3))-1/10080.
    coneq[31561]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**3))-1/20160.
    coneq[31562]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**3))-1/6720.
    coneq[31563]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**3))-1/13440.
    coneq[31564]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/6720.
    coneq[31565]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/26880.
    coneq[31566]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/80640.
    coneq[31567]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/161280.
    coneq[31568]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/53760.
    coneq[31569]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/20160.
    coneq[31570]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/40320.
    coneq[31571]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/13440.
    coneq[31572]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**3))-1/26880.
    coneq[31573]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c**3))-1/2240.
    coneq[31574]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c**3))-1/8960.
    coneq[31575]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c**3))-1/26880.
    coneq[31576]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c**3))-1/53760.
    coneq[31577]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**3))-1/17920.
    coneq[31578]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c**3))-1/6720.
    coneq[31579]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**3))-1/13440.
    coneq[31580]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**3))-1/4480.
    coneq[31581]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**3))-1/8960.
    coneq[31582]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/10080.
    coneq[31583]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/40320.
    coneq[31584]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/120960.
    coneq[31585]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/241920.
    coneq[31586]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/80640.
    coneq[31587]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/30240.
    coneq[31588]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/60480.
    coneq[31589]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/20160.
    coneq[31590]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2)))-1/40320.
    coneq[31591]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/20160.
    coneq[31592]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/80640.
    coneq[31593]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/241920.
    coneq[31594]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/483840.
    coneq[31595]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/161280.
    coneq[31596]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/60480.
    coneq[31597]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/120960.
    coneq[31598]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/40320.
    coneq[31599]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2)))-1/80640.
    coneq[31600]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/6720.
    coneq[31601]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/26880.
    coneq[31602]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/80640.
    coneq[31603]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/161280.
    coneq[31604]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/53760.
    coneq[31605]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/20160.
    coneq[31606]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/40320.
    coneq[31607]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/13440.
    coneq[31608]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2)))-1/26880.
    coneq[31609]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/40320.
    coneq[31610]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/161280.
    coneq[31611]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/483840.
    coneq[31612]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/967680.
    coneq[31613]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/322560.
    coneq[31614]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/120960.
    coneq[31615]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/241920.
    coneq[31616]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/80640.
    coneq[31617]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c))))-1/161280.
    coneq[31618]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/13440.
    coneq[31619]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/53760.
    coneq[31620]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/161280.
    coneq[31621]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/322560.
    coneq[31622]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/107520.
    coneq[31623]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/40320.
    coneq[31624]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/80640.
    coneq[31625]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/26880.
    coneq[31626]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c))))-1/53760.
    coneq[31627]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/4480.
    coneq[31628]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/17920.
    coneq[31629]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/53760.
    coneq[31630]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/107520.
    coneq[31631]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/35840.
    coneq[31632]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/13440.
    coneq[31633]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/26880.
    coneq[31634]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/8960.
    coneq[31635]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c)))-1/17920.
    coneq[31636]=dot(b,dot(A,c**5)*dot(A,c**4)*dot(A,c))-1/840.
    coneq[31637]=dot(b,dot(A,dot(A,c**4))*dot(A,c**4)*dot(A,c))-1/4200.
    coneq[31638]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**4)*dot(A,c))-1/16800.
    coneq[31639]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**4)*dot(A,c))-1/50400.
    coneq[31640]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**4)*dot(A,c))-1/100800.
    coneq[31641]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**4)*dot(A,c))-1/33600.
    coneq[31642]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**4)*dot(A,c))-1/12600.
    coneq[31643]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**4)*dot(A,c))-1/25200.
    coneq[31644]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**4)*dot(A,c))-1/8400.
    coneq[31645]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**4)*dot(A,c))-1/16800.
    coneq[31646]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**4)*dot(A,c))-1/3360.
    coneq[31647]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**4)*dot(A,c))-1/10080.
    coneq[31648]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**4)*dot(A,c))-1/20160.
    coneq[31649]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**4)*dot(A,c))-1/6720.
    coneq[31650]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**4)*dot(A,c))-1/2520.
    coneq[31651]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**4)*dot(A,c))-1/5040.
    coneq[31652]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**4)*dot(A,c))-1/1680.
    coneq[31653]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**4)*dot(A,c))-1/5040.
    coneq[31654]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**4)*dot(A,c))-1/10080.
    coneq[31655]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**4)*dot(A,c))-1/3360.
    coneq[31656]=dot(b,dot(A,c**5)*dot(A,dot(A,c**3))*dot(A,c))-1/3360.
    coneq[31657]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**3))*dot(A,c))-1/16800.
    coneq[31658]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**3))*dot(A,c))-1/67200.
    coneq[31659]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**3))*dot(A,c))-1/201600.
    coneq[31660]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**3))*dot(A,c))-1/403200.
    coneq[31661]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**3))*dot(A,c))-1/134400.
    coneq[31662]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**3))*dot(A,c))-1/50400.
    coneq[31663]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**3))*dot(A,c))-1/100800.
    coneq[31664]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/33600.
    coneq[31665]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/67200.
    coneq[31666]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**3))*dot(A,c))-1/13440.
    coneq[31667]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*dot(A,c))-1/40320.
    coneq[31668]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*dot(A,c))-1/80640.
    coneq[31669]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/26880.
    coneq[31670]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**3))*dot(A,c))-1/10080.
    coneq[31671]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/20160.
    coneq[31672]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c))-1/6720.
    coneq[31673]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**3))*dot(A,c))-1/20160.
    coneq[31674]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c))-1/40320.
    coneq[31675]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c))-1/13440.
    coneq[31676]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/10080.
    coneq[31677]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/50400.
    coneq[31678]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/201600.
    coneq[31679]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/604800.
    coneq[31680]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/1209600.
    coneq[31681]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/403200.
    coneq[31682]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/151200.
    coneq[31683]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/302400.
    coneq[31684]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/100800.
    coneq[31685]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/201600.
    coneq[31686]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/40320.
    coneq[31687]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/120960.
    coneq[31688]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/241920.
    coneq[31689]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/80640.
    coneq[31690]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/30240.
    coneq[31691]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/60480.
    coneq[31692]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/20160.
    coneq[31693]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/60480.
    coneq[31694]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/120960.
    coneq[31695]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c))-1/40320.
    coneq[31696]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/20160.
    coneq[31697]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/100800.
    coneq[31698]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/403200.
    coneq[31699]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/1209600.
    coneq[31700]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/2419200.
    coneq[31701]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/806400.
    coneq[31702]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/302400.
    coneq[31703]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/604800.
    coneq[31704]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/201600.
    coneq[31705]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/403200.
    coneq[31706]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/80640.
    coneq[31707]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/241920.
    coneq[31708]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/483840.
    coneq[31709]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/161280.
    coneq[31710]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/60480.
    coneq[31711]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/120960.
    coneq[31712]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/40320.
    coneq[31713]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/120960.
    coneq[31714]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/241920.
    coneq[31715]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c))-1/80640.
    coneq[31716]=dot(b,dot(A,c**5)*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/6720.
    coneq[31717]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/33600.
    coneq[31718]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/134400.
    coneq[31719]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/403200.
    coneq[31720]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/806400.
    coneq[31721]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/268800.
    coneq[31722]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/100800.
    coneq[31723]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/201600.
    coneq[31724]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/67200.
    coneq[31725]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/134400.
    coneq[31726]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/26880.
    coneq[31727]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/80640.
    coneq[31728]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/161280.
    coneq[31729]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/53760.
    coneq[31730]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/20160.
    coneq[31731]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/40320.
    coneq[31732]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/13440.
    coneq[31733]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/40320.
    coneq[31734]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/80640.
    coneq[31735]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c))-1/26880.
    coneq[31736]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c**2))*dot(A,c))-1/2520.
    coneq[31737]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c**2))*dot(A,c))-1/12600.
    coneq[31738]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/50400.
    coneq[31739]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c**2))*dot(A,c))-1/151200.
    coneq[31740]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c**2))*dot(A,c))-1/302400.
    coneq[31741]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c**2))*dot(A,c))-1/100800.
    coneq[31742]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/37800.
    coneq[31743]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*dot(A,c))-1/75600.
    coneq[31744]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/25200.
    coneq[31745]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/50400.
    coneq[31746]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c**2))*dot(A,c))-1/10080.
    coneq[31747]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/30240.
    coneq[31748]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c**2))*dot(A,c))-1/60480.
    coneq[31749]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/20160.
    coneq[31750]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c**2))*dot(A,c))-1/7560.
    coneq[31751]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/15120.
    coneq[31752]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c))-1/5040.
    coneq[31753]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c**2))*dot(A,c))-1/15120.
    coneq[31754]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c))-1/30240.
    coneq[31755]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c))-1/10080.
    coneq[31756]=dot(b,dot(A,c**5)*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/5040.
    coneq[31757]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/25200.
    coneq[31758]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/100800.
    coneq[31759]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/302400.
    coneq[31760]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/604800.
    coneq[31761]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/201600.
    coneq[31762]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/75600.
    coneq[31763]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/151200.
    coneq[31764]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/50400.
    coneq[31765]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/100800.
    coneq[31766]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/20160.
    coneq[31767]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/60480.
    coneq[31768]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/120960.
    coneq[31769]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/40320.
    coneq[31770]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/15120.
    coneq[31771]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/30240.
    coneq[31772]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/10080.
    coneq[31773]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/30240.
    coneq[31774]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/60480.
    coneq[31775]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c))-1/20160.
    coneq[31776]=dot(b,dot(A,c**5)*dot(A,c**2*dot(A,c))*dot(A,c))-1/1680.
    coneq[31777]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2*dot(A,c))*dot(A,c))-1/8400.
    coneq[31778]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/33600.
    coneq[31779]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2*dot(A,c))*dot(A,c))-1/100800.
    coneq[31780]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2*dot(A,c))*dot(A,c))-1/201600.
    coneq[31781]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2*dot(A,c))*dot(A,c))-1/67200.
    coneq[31782]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/25200.
    coneq[31783]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*dot(A,c))-1/50400.
    coneq[31784]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/16800.
    coneq[31785]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/33600.
    coneq[31786]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2*dot(A,c))*dot(A,c))-1/6720.
    coneq[31787]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/20160.
    coneq[31788]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2*dot(A,c))*dot(A,c))-1/40320.
    coneq[31789]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/13440.
    coneq[31790]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2*dot(A,c))*dot(A,c))-1/5040.
    coneq[31791]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/10080.
    coneq[31792]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c))-1/3360.
    coneq[31793]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2*dot(A,c))*dot(A,c))-1/10080.
    coneq[31794]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2*dot(A,c))*dot(A,c))-1/20160.
    coneq[31795]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c))-1/6720.
    coneq[31796]=dot(b,dot(A,c**5)*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/3360.
    coneq[31797]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/16800.
    coneq[31798]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/67200.
    coneq[31799]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/201600.
    coneq[31800]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/403200.
    coneq[31801]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/134400.
    coneq[31802]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/50400.
    coneq[31803]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/100800.
    coneq[31804]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/33600.
    coneq[31805]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/67200.
    coneq[31806]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/13440.
    coneq[31807]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/40320.
    coneq[31808]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/80640.
    coneq[31809]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/26880.
    coneq[31810]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/10080.
    coneq[31811]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/20160.
    coneq[31812]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/6720.
    coneq[31813]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/20160.
    coneq[31814]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/40320.
    coneq[31815]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*dot(A,c))-1/13440.
    coneq[31816]=dot(b,dot(A,c**4)*dot(A,c**4)*dot(A,c**2))-1/1050.
    coneq[31817]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*dot(A,c**2))-1/4200.
    coneq[31818]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*dot(A,c**2))-1/12600.
    coneq[31819]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*dot(A,c**2))-1/25200.
    coneq[31820]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*dot(A,c**2))-1/8400.
    coneq[31821]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*dot(A,c**2))-1/3150.
    coneq[31822]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*dot(A,c**2))-1/6300.
    coneq[31823]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*dot(A,c**2))-1/2100.
    coneq[31824]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*dot(A,c**2))-1/4200.
    coneq[31825]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*dot(A,c**2))-1/16800.
    coneq[31826]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*dot(A,c**2))-1/50400.
    coneq[31827]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*dot(A,c**2))-1/100800.
    coneq[31828]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c**2))-1/33600.
    coneq[31829]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*dot(A,c**2))-1/12600.
    coneq[31830]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c**2))-1/25200.
    coneq[31831]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c**2))-1/8400.
    coneq[31832]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c**2))-1/16800.
    coneq[31833]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/151200.
    coneq[31834]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/302400.
    coneq[31835]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/100800.
    coneq[31836]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/37800.
    coneq[31837]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/75600.
    coneq[31838]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/25200.
    coneq[31839]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c**2))-1/50400.
    coneq[31840]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/604800.
    coneq[31841]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/201600.
    coneq[31842]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/75600.
    coneq[31843]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/151200.
    coneq[31844]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/50400.
    coneq[31845]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2))-1/100800.
    coneq[31846]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2))-1/67200.
    coneq[31847]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2))-1/25200.
    coneq[31848]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2))-1/50400.
    coneq[31849]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2))-1/16800.
    coneq[31850]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c**2))-1/33600.
    coneq[31851]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*dot(A,c**2))-1/9450.
    coneq[31852]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c**2))-1/18900.
    coneq[31853]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c**2))-1/6300.
    coneq[31854]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c**2))-1/12600.
    coneq[31855]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2))-1/37800.
    coneq[31856]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2))-1/12600.
    coneq[31857]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c**2))-1/25200.
    coneq[31858]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c**2))-1/4200.
    coneq[31859]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c**2))-1/8400.
    coneq[31860]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*dot(A,c**2))-1/16800.
    coneq[31861]=dot(b,dot(A,c**4)*dot(A,c**4)*dot(A,dot(A,c)))-1/2100.
    coneq[31862]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*dot(A,dot(A,c)))-1/8400.
    coneq[31863]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*dot(A,dot(A,c)))-1/25200.
    coneq[31864]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*dot(A,dot(A,c)))-1/50400.
    coneq[31865]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*dot(A,dot(A,c)))-1/16800.
    coneq[31866]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*dot(A,dot(A,c)))-1/6300.
    coneq[31867]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*dot(A,dot(A,c)))-1/12600.
    coneq[31868]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*dot(A,dot(A,c)))-1/4200.
    coneq[31869]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*dot(A,dot(A,c)))-1/8400.
    coneq[31870]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/33600.
    coneq[31871]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/100800.
    coneq[31872]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/201600.
    coneq[31873]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/67200.
    coneq[31874]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/25200.
    coneq[31875]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/50400.
    coneq[31876]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/16800.
    coneq[31877]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*dot(A,dot(A,c)))-1/33600.
    coneq[31878]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/302400.
    coneq[31879]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/604800.
    coneq[31880]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/201600.
    coneq[31881]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/75600.
    coneq[31882]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/151200.
    coneq[31883]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/50400.
    coneq[31884]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c)))-1/100800.
    coneq[31885]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/1209600.
    coneq[31886]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/403200.
    coneq[31887]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/151200.
    coneq[31888]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/302400.
    coneq[31889]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/100800.
    coneq[31890]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c)))-1/201600.
    coneq[31891]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/134400.
    coneq[31892]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/50400.
    coneq[31893]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/100800.
    coneq[31894]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/33600.
    coneq[31895]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c)))-1/67200.
    coneq[31896]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)))-1/18900.
    coneq[31897]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)))-1/37800.
    coneq[31898]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)))-1/12600.
    coneq[31899]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,dot(A,c)))-1/25200.
    coneq[31900]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/75600.
    coneq[31901]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/25200.
    coneq[31902]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c)))-1/50400.
    coneq[31903]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)))-1/8400.
    coneq[31904]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,dot(A,c)))-1/16800.
    coneq[31905]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)))-1/33600.
    coneq[31906]=dot(b,dot(A,c**7)*dot(A,c)*dot(A,c)*c)-1/448.
    coneq[31907]=dot(b,dot(A,dot(A,c**6))*dot(A,c)*dot(A,c)*c)-1/3136.
    coneq[31908]=dot(b,dot(A,dot(A,dot(A,c**5)))*dot(A,c)*dot(A,c)*c)-1/18816.
    coneq[31909]=dot(b,dot(A,dot(A,dot(A,dot(A,c**4))))*dot(A,c)*dot(A,c)*c)-1/94080.
    coneq[31910]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**3)))))*dot(A,c)*dot(A,c)*c)-1/376320.
    coneq[31911]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c**2))))))*dot(A,c)*dot(A,c)*c)-1/1128960.
    coneq[31912]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))))*dot(A,c)*dot(A,c)*c)-1/2257920.
    coneq[31913]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c*dot(A,c))))))*dot(A,c)*dot(A,c)*c)-1/752640.
    coneq[31914]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c**2)))))*dot(A,c)*dot(A,c)*c)-1/282240.
    coneq[31915]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*c)-1/564480.
    coneq[31916]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2*dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/188160.
    coneq[31917]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/376320.
    coneq[31918]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**3))))*dot(A,c)*dot(A,c)*c)-1/75264.
    coneq[31919]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c)*c)-1/225792.
    coneq[31920]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*c)-1/451584.
    coneq[31921]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/150528.
    coneq[31922]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/56448.
    coneq[31923]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/112896.
    coneq[31924]=dot(b,dot(A,dot(A,dot(A,c**3*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/37632.
    coneq[31925]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/112896.
    coneq[31926]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/225792.
    coneq[31927]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/75264.
    coneq[31928]=dot(b,dot(A,dot(A,c*dot(A,c**4)))*dot(A,c)*dot(A,c)*c)-1/15680.
    coneq[31929]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c)*c)-1/62720.
    coneq[31930]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c)*c)-1/188160.
    coneq[31931]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*c)-1/376320.
    coneq[31932]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/125440.
    coneq[31933]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/47040.
    coneq[31934]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/94080.
    coneq[31935]=dot(b,dot(A,dot(A,c*dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/31360.
    coneq[31936]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/62720.
    coneq[31937]=dot(b,dot(A,dot(A,c**2*dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/12544.
    coneq[31938]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/37632.
    coneq[31939]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/75264.
    coneq[31940]=dot(b,dot(A,dot(A,c**2*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/25088.
    coneq[31941]=dot(b,dot(A,dot(A,c**3*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/9408.
    coneq[31942]=dot(b,dot(A,dot(A,c**3*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/18816.
    coneq[31943]=dot(b,dot(A,dot(A,c**4*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/6272.
    coneq[31944]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/28224.
    coneq[31945]=dot(b,dot(A,dot(A,dot(A,c**2)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/56448.
    coneq[31946]=dot(b,dot(A,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/112896.
    coneq[31947]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/25088.
    coneq[31948]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/75264.
    coneq[31949]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/150528.
    coneq[31950]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/50176.
    coneq[31951]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/18816.
    coneq[31952]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/37632.
    coneq[31953]=dot(b,dot(A,dot(A,c**2*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/12544.
    coneq[31954]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/25088.
    coneq[31955]=dot(b,dot(A,c*dot(A,c**5))*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[31956]=dot(b,dot(A,c*dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c)*c)-1/13440.
    coneq[31957]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c)*c)-1/53760.
    coneq[31958]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c)*c)-1/161280.
    coneq[31959]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*c)-1/322560.
    coneq[31960]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/107520.
    coneq[31961]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/40320.
    coneq[31962]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/80640.
    coneq[31963]=dot(b,dot(A,c*dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/26880.
    coneq[31964]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/53760.
    coneq[31965]=dot(b,dot(A,c*dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[31966]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/32256.
    coneq[31967]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/64512.
    coneq[31968]=dot(b,dot(A,c*dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/21504.
    coneq[31969]=dot(b,dot(A,c*dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/8064.
    coneq[31970]=dot(b,dot(A,c*dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[31971]=dot(b,dot(A,c*dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[31972]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[31973]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/32256.
    coneq[31974]=dot(b,dot(A,c*dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[31975]=dot(b,dot(A,c**2*dot(A,c**4))*dot(A,c)*dot(A,c)*c)-1/2240.
    coneq[31976]=dot(b,dot(A,c**2*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/8960.
    coneq[31977]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/26880.
    coneq[31978]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/53760.
    coneq[31979]=dot(b,dot(A,c**2*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/17920.
    coneq[31980]=dot(b,dot(A,c**2*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/6720.
    coneq[31981]=dot(b,dot(A,c**2*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/13440.
    coneq[31982]=dot(b,dot(A,c**2*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/4480.
    coneq[31983]=dot(b,dot(A,c**2*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/8960.
    coneq[31984]=dot(b,dot(A,c**3*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/1792.
    coneq[31985]=dot(b,dot(A,c**3*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[31986]=dot(b,dot(A,c**3*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[31987]=dot(b,dot(A,c**3*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/3584.
    coneq[31988]=dot(b,dot(A,c**4*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/1344.
    coneq[31989]=dot(b,dot(A,c**4*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[31990]=dot(b,dot(A,c**5*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/896.
    coneq[31991]=dot(b,dot(A,dot(A,c**2)*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[31992]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[31993]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/32256.
    coneq[31994]=dot(b,dot(A,dot(A,c**2)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[31995]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[31996]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/32256.
    coneq[31997]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/64512.
    coneq[31998]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/21504.
    coneq[31999]=dot(b,dot(A,dot(A,c)*dot(A,c**4))*dot(A,c)*dot(A,c)*c)-1/4480.
    coneq[32000]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c)-1/17920.
    coneq[32001]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c)-1/53760.
    coneq[32002]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c)-1/107520.
    coneq[32003]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/35840.
    coneq[32004]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/13440.
    coneq[32005]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/26880.
    coneq[32006]=dot(b,dot(A,dot(A,c)*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/8960.
    coneq[32007]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/17920.
    coneq[32008]=dot(b,dot(A,c*dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/4032.
    coneq[32009]=dot(b,dot(A,c*dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/8064.
    coneq[32010]=dot(b,dot(A,c*dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[32011]=dot(b,dot(A,c*dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c)*c)-1/3584.
    coneq[32012]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[32013]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c)-1/21504.
    coneq[32014]=dot(b,dot(A,c*dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/7168.
    coneq[32015]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[32016]=dot(b,dot(A,c**2*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32017]=dot(b,dot(A,c**3*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1792.
    coneq[32018]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32019]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[32020]=dot(b,dot(A,c*dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/3584.
    coneq[32021]=dot(b,dot(A,c**6)*dot(A,c**2)*dot(A,c)*c)-1/588.
    coneq[32022]=dot(b,dot(A,dot(A,c**5))*dot(A,c**2)*dot(A,c)*c)-1/3528.
    coneq[32023]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c**2)*dot(A,c)*c)-1/17640.
    coneq[32024]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c**2)*dot(A,c)*c)-1/70560.
    coneq[32025]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c**2)*dot(A,c)*c)-1/211680.
    coneq[32026]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c**2)*dot(A,c)*c)-1/423360.
    coneq[32027]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c**2)*dot(A,c)*c)-1/141120.
    coneq[32028]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c**2)*dot(A,c)*c)-1/52920.
    coneq[32029]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c)*c)-1/105840.
    coneq[32030]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/35280.
    coneq[32031]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/70560.
    coneq[32032]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c**2)*dot(A,c)*c)-1/14112.
    coneq[32033]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c)*c)-1/42336.
    coneq[32034]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c)*c)-1/84672.
    coneq[32035]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/28224.
    coneq[32036]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/10584.
    coneq[32037]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/21168.
    coneq[32038]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/7056.
    coneq[32039]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/21168.
    coneq[32040]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/42336.
    coneq[32041]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/14112.
    coneq[32042]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c**2)*dot(A,c)*c)-1/2940.
    coneq[32043]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c)*c)-1/11760.
    coneq[32044]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c)*c)-1/35280.
    coneq[32045]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c)*c)-1/70560.
    coneq[32046]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/23520.
    coneq[32047]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/8820.
    coneq[32048]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/17640.
    coneq[32049]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/5880.
    coneq[32050]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/11760.
    coneq[32051]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c**2)*dot(A,c)*c)-1/2352.
    coneq[32052]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/7056.
    coneq[32053]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/14112.
    coneq[32054]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/4704.
    coneq[32055]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/1764.
    coneq[32056]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/3528.
    coneq[32057]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/1176.
    coneq[32058]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/5292.
    coneq[32059]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/10584.
    coneq[32060]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/21168.
    coneq[32061]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c**2)*dot(A,c)*c)-1/4704.
    coneq[32062]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c)-1/14112.
    coneq[32063]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c)-1/28224.
    coneq[32064]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/9408.
    coneq[32065]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c)-1/3528.
    coneq[32066]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c)-1/7056.
    coneq[32067]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/2352.
    coneq[32068]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/4704.
    coneq[32069]=dot(b,dot(A,c**6)*dot(A,dot(A,c))*dot(A,c)*c)-1/1176.
    coneq[32070]=dot(b,dot(A,dot(A,c**5))*dot(A,dot(A,c))*dot(A,c)*c)-1/7056.
    coneq[32071]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,dot(A,c))*dot(A,c)*c)-1/35280.
    coneq[32072]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,dot(A,c))*dot(A,c)*c)-1/141120.
    coneq[32073]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,dot(A,c))*dot(A,c)*c)-1/423360.
    coneq[32074]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,dot(A,c))*dot(A,c)*c)-1/846720.
    coneq[32075]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*c)-1/282240.
    coneq[32076]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c)*c)-1/105840.
    coneq[32077]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*c)-1/211680.
    coneq[32078]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/70560.
    coneq[32079]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/141120.
    coneq[32080]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c)*c)-1/28224.
    coneq[32081]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c)*c)-1/84672.
    coneq[32082]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*c)-1/169344.
    coneq[32083]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/56448.
    coneq[32084]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/21168.
    coneq[32085]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/42336.
    coneq[32086]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/14112.
    coneq[32087]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/42336.
    coneq[32088]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/84672.
    coneq[32089]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/28224.
    coneq[32090]=dot(b,dot(A,c*dot(A,c**4))*dot(A,dot(A,c))*dot(A,c)*c)-1/5880.
    coneq[32091]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c)*c)-1/23520.
    coneq[32092]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c)*c)-1/70560.
    coneq[32093]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*c)-1/141120.
    coneq[32094]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/47040.
    coneq[32095]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/17640.
    coneq[32096]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/35280.
    coneq[32097]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/11760.
    coneq[32098]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/23520.
    coneq[32099]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c)-1/4704.
    coneq[32100]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/14112.
    coneq[32101]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/28224.
    coneq[32102]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/9408.
    coneq[32103]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/3528.
    coneq[32104]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/7056.
    coneq[32105]=dot(b,dot(A,c**4*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/2352.
    coneq[32106]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/10584.
    coneq[32107]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/21168.
    coneq[32108]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/42336.
    coneq[32109]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c)-1/9408.
    coneq[32110]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c)-1/28224.
    coneq[32111]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c)-1/56448.
    coneq[32112]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/18816.
    coneq[32113]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c)-1/7056.
    coneq[32114]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c)-1/14112.
    coneq[32115]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/4704.
    coneq[32116]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/9408.
    coneq[32117]=dot(b,dot(A,c**5)*dot(A,c**2)*dot(A,c**2)*c)-1/756.
    coneq[32118]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*dot(A,c**2)*c)-1/3780.
    coneq[32119]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c**2)*c)-1/15120.
    coneq[32120]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c**2)*c)-1/45360.
    coneq[32121]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c**2)*c)-1/90720.
    coneq[32122]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c**2)*c)-1/30240.
    coneq[32123]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c**2)*c)-1/11340.
    coneq[32124]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2)*c)-1/22680.
    coneq[32125]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/7560.
    coneq[32126]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/15120.
    coneq[32127]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*dot(A,c**2)*c)-1/3024.
    coneq[32128]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2)*c)-1/9072.
    coneq[32129]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2)*c)-1/18144.
    coneq[32130]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/6048.
    coneq[32131]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c)-1/2268.
    coneq[32132]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/4536.
    coneq[32133]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/1512.
    coneq[32134]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c)-1/4536.
    coneq[32135]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c)-1/9072.
    coneq[32136]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/3024.
    coneq[32137]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,c**2)*c)-1/1512.
    coneq[32138]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/7560.
    coneq[32139]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/30240.
    coneq[32140]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/90720.
    coneq[32141]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/181440.
    coneq[32142]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/60480.
    coneq[32143]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/22680.
    coneq[32144]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/45360.
    coneq[32145]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/15120.
    coneq[32146]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/30240.
    coneq[32147]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/6048.
    coneq[32148]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/18144.
    coneq[32149]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/36288.
    coneq[32150]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/12096.
    coneq[32151]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/4536.
    coneq[32152]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/9072.
    coneq[32153]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/3024.
    coneq[32154]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/9072.
    coneq[32155]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/18144.
    coneq[32156]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/6048.
    coneq[32157]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/3024.
    coneq[32158]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/15120.
    coneq[32159]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/60480.
    coneq[32160]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/181440.
    coneq[32161]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/362880.
    coneq[32162]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/120960.
    coneq[32163]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/45360.
    coneq[32164]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/90720.
    coneq[32165]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/30240.
    coneq[32166]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/60480.
    coneq[32167]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/12096.
    coneq[32168]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/36288.
    coneq[32169]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/72576.
    coneq[32170]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/24192.
    coneq[32171]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/9072.
    coneq[32172]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/18144.
    coneq[32173]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/6048.
    coneq[32174]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/18144.
    coneq[32175]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/36288.
    coneq[32176]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/12096.
    coneq[32177]=dot(b,dot(A,c**5)*dot(A,c**3)*dot(A,c)*c)-1/672.
    coneq[32178]=dot(b,dot(A,dot(A,c**4))*dot(A,c**3)*dot(A,c)*c)-1/3360.
    coneq[32179]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**3)*dot(A,c)*c)-1/13440.
    coneq[32180]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**3)*dot(A,c)*c)-1/40320.
    coneq[32181]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**3)*dot(A,c)*c)-1/80640.
    coneq[32182]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**3)*dot(A,c)*c)-1/26880.
    coneq[32183]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**3)*dot(A,c)*c)-1/10080.
    coneq[32184]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c)*c)-1/20160.
    coneq[32185]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/6720.
    coneq[32186]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/13440.
    coneq[32187]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**3)*dot(A,c)*c)-1/2688.
    coneq[32188]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c)*c)-1/8064.
    coneq[32189]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c)*c)-1/16128.
    coneq[32190]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/5376.
    coneq[32191]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**3)*dot(A,c)*c)-1/2016.
    coneq[32192]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/4032.
    coneq[32193]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**3)*dot(A,c)*c)-1/1344.
    coneq[32194]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**3)*dot(A,c)*c)-1/4032.
    coneq[32195]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c)-1/8064.
    coneq[32196]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c)*c)-1/2688.
    coneq[32197]=dot(b,dot(A,c**5)*dot(A,dot(A,c**2))*dot(A,c)*c)-1/2016.
    coneq[32198]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/10080.
    coneq[32199]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/40320.
    coneq[32200]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/120960.
    coneq[32201]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/241920.
    coneq[32202]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/80640.
    coneq[32203]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/30240.
    coneq[32204]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/60480.
    coneq[32205]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/20160.
    coneq[32206]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/40320.
    coneq[32207]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/8064.
    coneq[32208]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/24192.
    coneq[32209]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/48384.
    coneq[32210]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/16128.
    coneq[32211]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/6048.
    coneq[32212]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/12096.
    coneq[32213]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/4032.
    coneq[32214]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/12096.
    coneq[32215]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/24192.
    coneq[32216]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c)-1/8064.
    coneq[32217]=dot(b,dot(A,c**5)*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/4032.
    coneq[32218]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/20160.
    coneq[32219]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/80640.
    coneq[32220]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/241920.
    coneq[32221]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/483840.
    coneq[32222]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/161280.
    coneq[32223]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/60480.
    coneq[32224]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/120960.
    coneq[32225]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/40320.
    coneq[32226]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/80640.
    coneq[32227]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/16128.
    coneq[32228]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/48384.
    coneq[32229]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/96768.
    coneq[32230]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/32256.
    coneq[32231]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/12096.
    coneq[32232]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/24192.
    coneq[32233]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/8064.
    coneq[32234]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/24192.
    coneq[32235]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/48384.
    coneq[32236]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c)-1/16128.
    coneq[32237]=dot(b,dot(A,c**5)*dot(A,c*dot(A,c))*dot(A,c)*c)-1/1344.
    coneq[32238]=dot(b,dot(A,dot(A,c**4))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/6720.
    coneq[32239]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/26880.
    coneq[32240]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/80640.
    coneq[32241]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/161280.
    coneq[32242]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/53760.
    coneq[32243]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/20160.
    coneq[32244]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/40320.
    coneq[32245]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/13440.
    coneq[32246]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/26880.
    coneq[32247]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/5376.
    coneq[32248]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/16128.
    coneq[32249]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/32256.
    coneq[32250]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/10752.
    coneq[32251]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/4032.
    coneq[32252]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/8064.
    coneq[32253]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/2688.
    coneq[32254]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/8064.
    coneq[32255]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/16128.
    coneq[32256]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c)-1/5376.
    coneq[32257]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c**2)*c)-1/840.
    coneq[32258]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c**2)*c)-1/3360.
    coneq[32259]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c**2)*c)-1/10080.
    coneq[32260]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c**2)*c)-1/20160.
    coneq[32261]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c**2)*c)-1/6720.
    coneq[32262]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c**2)*c)-1/2520.
    coneq[32263]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2)*c)-1/5040.
    coneq[32264]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c**2)*c)-1/1680.
    coneq[32265]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c**2)*c)-1/3360.
    coneq[32266]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/2520.
    coneq[32267]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/10080.
    coneq[32268]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/30240.
    coneq[32269]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/60480.
    coneq[32270]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/20160.
    coneq[32271]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/7560.
    coneq[32272]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/15120.
    coneq[32273]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/5040.
    coneq[32274]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2)*c)-1/10080.
    coneq[32275]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/5040.
    coneq[32276]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/20160.
    coneq[32277]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/60480.
    coneq[32278]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/120960.
    coneq[32279]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/40320.
    coneq[32280]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/15120.
    coneq[32281]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/30240.
    coneq[32282]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/10080.
    coneq[32283]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c)-1/20160.
    coneq[32284]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/1680.
    coneq[32285]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/6720.
    coneq[32286]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/20160.
    coneq[32287]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/40320.
    coneq[32288]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/13440.
    coneq[32289]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/5040.
    coneq[32290]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/10080.
    coneq[32291]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/3360.
    coneq[32292]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2)*c)-1/6720.
    coneq[32293]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,dot(A,c))*c)-1/1680.
    coneq[32294]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/6720.
    coneq[32295]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/20160.
    coneq[32296]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/40320.
    coneq[32297]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/13440.
    coneq[32298]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/5040.
    coneq[32299]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/10080.
    coneq[32300]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/3360.
    coneq[32301]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c))*c)-1/6720.
    coneq[32302]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/5040.
    coneq[32303]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/20160.
    coneq[32304]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/60480.
    coneq[32305]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/120960.
    coneq[32306]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/40320.
    coneq[32307]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/15120.
    coneq[32308]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/30240.
    coneq[32309]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/10080.
    coneq[32310]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c)-1/20160.
    coneq[32311]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/10080.
    coneq[32312]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/40320.
    coneq[32313]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/120960.
    coneq[32314]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/241920.
    coneq[32315]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/80640.
    coneq[32316]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/30240.
    coneq[32317]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/60480.
    coneq[32318]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/20160.
    coneq[32319]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c)-1/40320.
    coneq[32320]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/3360.
    coneq[32321]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/13440.
    coneq[32322]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/40320.
    coneq[32323]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/80640.
    coneq[32324]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/26880.
    coneq[32325]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/10080.
    coneq[32326]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/20160.
    coneq[32327]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/6720.
    coneq[32328]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c)-1/13440.
    coneq[32329]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c**3)*c)-1/896.
    coneq[32330]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c**3)*c)-1/2688.
    coneq[32331]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**3)*c)-1/5376.
    coneq[32332]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c**3)*c)-1/1792.
    coneq[32333]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**3)*c)-1/8064.
    coneq[32334]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**3)*c)-1/16128.
    coneq[32335]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**3)*c)-1/5376.
    coneq[32336]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c)-1/32256.
    coneq[32337]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**3)*c)-1/10752.
    coneq[32338]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**3)*c)-1/3584.
    coneq[32339]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/24192.
    coneq[32340]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/48384.
    coneq[32341]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*c)-1/16128.
    coneq[32342]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/96768.
    coneq[32343]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*c)-1/32256.
    coneq[32344]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*c)-1/10752.
    coneq[32345]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/193536.
    coneq[32346]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*c)-1/64512.
    coneq[32347]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*c)-1/21504.
    coneq[32348]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*c)-1/7168.
    coneq[32349]=dot(b,dot(A,c**4)*dot(A,c**4)*dot(A,c)*c)-1/700.
    coneq[32350]=dot(b,dot(A,dot(A,c**3))*dot(A,c**4)*dot(A,c)*c)-1/2800.
    coneq[32351]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**4)*dot(A,c)*c)-1/8400.
    coneq[32352]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**4)*dot(A,c)*c)-1/16800.
    coneq[32353]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**4)*dot(A,c)*c)-1/5600.
    coneq[32354]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**4)*dot(A,c)*c)-1/2100.
    coneq[32355]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**4)*dot(A,c)*c)-1/4200.
    coneq[32356]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**4)*dot(A,c)*c)-1/1400.
    coneq[32357]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**4)*dot(A,c)*c)-1/2800.
    coneq[32358]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/11200.
    coneq[32359]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/33600.
    coneq[32360]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/67200.
    coneq[32361]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/22400.
    coneq[32362]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/8400.
    coneq[32363]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/16800.
    coneq[32364]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/5600.
    coneq[32365]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**3))*dot(A,c)*c)-1/11200.
    coneq[32366]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/100800.
    coneq[32367]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/201600.
    coneq[32368]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/67200.
    coneq[32369]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/25200.
    coneq[32370]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/50400.
    coneq[32371]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/16800.
    coneq[32372]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c**2)))*dot(A,c)*c)-1/33600.
    coneq[32373]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/403200.
    coneq[32374]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/134400.
    coneq[32375]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/50400.
    coneq[32376]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/100800.
    coneq[32377]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/33600.
    coneq[32378]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*c)-1/67200.
    coneq[32379]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c)-1/44800.
    coneq[32380]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c)-1/16800.
    coneq[32381]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c)-1/33600.
    coneq[32382]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c)-1/11200.
    coneq[32383]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c*dot(A,c)))*dot(A,c)*c)-1/22400.
    coneq[32384]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c**2))*dot(A,c)*c)-1/6300.
    coneq[32385]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c**2))*dot(A,c)*c)-1/12600.
    coneq[32386]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c)*c)-1/4200.
    coneq[32387]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c**2))*dot(A,c)*c)-1/8400.
    coneq[32388]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c)-1/25200.
    coneq[32389]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c)-1/8400.
    coneq[32390]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,dot(A,c)))*dot(A,c)*c)-1/16800.
    coneq[32391]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c)*c)-1/2800.
    coneq[32392]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2*dot(A,c))*dot(A,c)*c)-1/5600.
    coneq[32393]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c)*dot(A,c))*dot(A,c)*c)-1/11200.
    coneq[32394]=dot(b,dot(A,c**6)*dot(A,c)*dot(A,c)*c*c)-1/392.
    coneq[32395]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*dot(A,c)*c*c)-1/2352.
    coneq[32396]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c)*c*c)-1/11760.
    coneq[32397]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c)*c*c)-1/47040.
    coneq[32398]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c)*c*c)-1/141120.
    coneq[32399]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*c*c)-1/282240.
    coneq[32400]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c)*c*c)-1/94080.
    coneq[32401]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c)*c*c)-1/35280.
    coneq[32402]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c*c)-1/70560.
    coneq[32403]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/23520.
    coneq[32404]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/47040.
    coneq[32405]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c)*c*c)-1/9408.
    coneq[32406]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c*c)-1/28224.
    coneq[32407]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c*c)-1/56448.
    coneq[32408]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/18816.
    coneq[32409]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/7056.
    coneq[32410]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/14112.
    coneq[32411]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/4704.
    coneq[32412]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/14112.
    coneq[32413]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/28224.
    coneq[32414]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/9408.
    coneq[32415]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*dot(A,c)*c*c)-1/1960.
    coneq[32416]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c*c)-1/7840.
    coneq[32417]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c*c)-1/23520.
    coneq[32418]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c*c)-1/47040.
    coneq[32419]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/15680.
    coneq[32420]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/5880.
    coneq[32421]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/11760.
    coneq[32422]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/3920.
    coneq[32423]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/7840.
    coneq[32424]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*dot(A,c)*c*c)-1/1568.
    coneq[32425]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/4704.
    coneq[32426]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/9408.
    coneq[32427]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/3136.
    coneq[32428]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/1176.
    coneq[32429]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/2352.
    coneq[32430]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/784.
    coneq[32431]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/3528.
    coneq[32432]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/7056.
    coneq[32433]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/14112.
    coneq[32434]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c)*c*c)-1/3136.
    coneq[32435]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c*c)-1/9408.
    coneq[32436]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c*c)-1/18816.
    coneq[32437]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/6272.
    coneq[32438]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c*c)-1/2352.
    coneq[32439]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c*c)-1/4704.
    coneq[32440]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/1568.
    coneq[32441]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/3136.
    coneq[32442]=dot(b,dot(A,c**5)*dot(A,c**2)*dot(A,c)*c*c)-1/504.
    coneq[32443]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*dot(A,c)*c*c)-1/2520.
    coneq[32444]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c)*c*c)-1/10080.
    coneq[32445]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c)*c*c)-1/30240.
    coneq[32446]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c)*c*c)-1/60480.
    coneq[32447]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c)*c*c)-1/20160.
    coneq[32448]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c*c)-1/7560.
    coneq[32449]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c*c)-1/15120.
    coneq[32450]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/5040.
    coneq[32451]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/10080.
    coneq[32452]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*dot(A,c)*c*c)-1/2016.
    coneq[32453]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c*c)-1/6048.
    coneq[32454]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c*c)-1/12096.
    coneq[32455]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/4032.
    coneq[32456]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c*c)-1/1512.
    coneq[32457]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/3024.
    coneq[32458]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/1008.
    coneq[32459]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c*c)-1/3024.
    coneq[32460]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c*c)-1/6048.
    coneq[32461]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/2016.
    coneq[32462]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,c)*c*c)-1/1008.
    coneq[32463]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/5040.
    coneq[32464]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/20160.
    coneq[32465]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/60480.
    coneq[32466]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/120960.
    coneq[32467]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/40320.
    coneq[32468]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/15120.
    coneq[32469]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/30240.
    coneq[32470]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/10080.
    coneq[32471]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/20160.
    coneq[32472]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/4032.
    coneq[32473]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/12096.
    coneq[32474]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/24192.
    coneq[32475]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/8064.
    coneq[32476]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/3024.
    coneq[32477]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/6048.
    coneq[32478]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/2016.
    coneq[32479]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/6048.
    coneq[32480]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/12096.
    coneq[32481]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/4032.
    coneq[32482]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c**2)*c*c)-1/630.
    coneq[32483]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c**2)*c*c)-1/2520.
    coneq[32484]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2)*c*c)-1/7560.
    coneq[32485]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2)*c*c)-1/15120.
    coneq[32486]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c*c)-1/5040.
    coneq[32487]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c*c)-1/1890.
    coneq[32488]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c*c)-1/3780.
    coneq[32489]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c*c)-1/1260.
    coneq[32490]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c*c)-1/2520.
    coneq[32491]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/1260.
    coneq[32492]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/5040.
    coneq[32493]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/15120.
    coneq[32494]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/30240.
    coneq[32495]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/10080.
    coneq[32496]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/3780.
    coneq[32497]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/7560.
    coneq[32498]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/2520.
    coneq[32499]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c*c)-1/5040.
    coneq[32500]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/2520.
    coneq[32501]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/10080.
    coneq[32502]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/30240.
    coneq[32503]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/60480.
    coneq[32504]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/20160.
    coneq[32505]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/7560.
    coneq[32506]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/15120.
    coneq[32507]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/5040.
    coneq[32508]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c*c)-1/10080.
    coneq[32509]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c)*c*c)-1/560.
    coneq[32510]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c)*c*c)-1/2240.
    coneq[32511]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c)*c*c)-1/6720.
    coneq[32512]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c)*c*c)-1/13440.
    coneq[32513]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c)*c*c)-1/4480.
    coneq[32514]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c)*c*c)-1/1680.
    coneq[32515]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c*c)-1/3360.
    coneq[32516]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c)*c*c)-1/1120.
    coneq[32517]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c)*c*c)-1/2240.
    coneq[32518]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/1680.
    coneq[32519]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/6720.
    coneq[32520]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/20160.
    coneq[32521]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/40320.
    coneq[32522]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/13440.
    coneq[32523]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/5040.
    coneq[32524]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/10080.
    coneq[32525]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/3360.
    coneq[32526]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c*c)-1/6720.
    coneq[32527]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/3360.
    coneq[32528]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/13440.
    coneq[32529]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/40320.
    coneq[32530]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/80640.
    coneq[32531]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/26880.
    coneq[32532]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/10080.
    coneq[32533]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/20160.
    coneq[32534]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/6720.
    coneq[32535]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c*c)-1/13440.
    coneq[32536]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/1120.
    coneq[32537]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/4480.
    coneq[32538]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/13440.
    coneq[32539]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/26880.
    coneq[32540]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/8960.
    coneq[32541]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/3360.
    coneq[32542]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/6720.
    coneq[32543]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/2240.
    coneq[32544]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c*c)-1/4480.
    coneq[32545]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c**2)*c*c)-1/672.
    coneq[32546]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c**2)*c*c)-1/2016.
    coneq[32547]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2)*c*c)-1/4032.
    coneq[32548]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c**2)*c*c)-1/1344.
    coneq[32549]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2)*c*c)-1/6048.
    coneq[32550]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2)*c*c)-1/12096.
    coneq[32551]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2)*c*c)-1/4032.
    coneq[32552]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/24192.
    coneq[32553]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*c*c)-1/8064.
    coneq[32554]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2)*c*c)-1/2688.
    coneq[32555]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,dot(A,c))*c*c)-1/1344.
    coneq[32556]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c))*c*c)-1/4032.
    coneq[32557]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[32558]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c))*c*c)-1/2688.
    coneq[32559]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/12096.
    coneq[32560]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/24192.
    coneq[32561]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*c*c)-1/8064.
    coneq[32562]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/48384.
    coneq[32563]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*c*c)-1/16128.
    coneq[32564]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*c*c)-1/5376.
    coneq[32565]=dot(b,dot(A,c**5)*dot(A,c)*dot(A,c)*c**3)-1/336.
    coneq[32566]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*dot(A,c)*c**3)-1/1680.
    coneq[32567]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*c**3)-1/6720.
    coneq[32568]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*c**3)-1/20160.
    coneq[32569]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*c**3)-1/40320.
    coneq[32570]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*c**3)-1/13440.
    coneq[32571]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*c**3)-1/5040.
    coneq[32572]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c**3)-1/10080.
    coneq[32573]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/3360.
    coneq[32574]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/6720.
    coneq[32575]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*dot(A,c)*c**3)-1/1344.
    coneq[32576]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c**3)-1/4032.
    coneq[32577]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c**3)-1/8064.
    coneq[32578]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/2688.
    coneq[32579]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*dot(A,c)*c**3)-1/1008.
    coneq[32580]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/2016.
    coneq[32581]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/672.
    coneq[32582]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*c**3)-1/2016.
    coneq[32583]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**3)-1/4032.
    coneq[32584]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/1344.
    coneq[32585]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c)*c**3)-1/420.
    coneq[32586]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c)*c**3)-1/1680.
    coneq[32587]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*c**3)-1/5040.
    coneq[32588]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*c**3)-1/10080.
    coneq[32589]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*c**3)-1/3360.
    coneq[32590]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c)*c**3)-1/1260.
    coneq[32591]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c**3)-1/2520.
    coneq[32592]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c)*c**3)-1/840.
    coneq[32593]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*c**3)-1/1680.
    coneq[32594]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c)*c**3)-1/840.
    coneq[32595]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/3360.
    coneq[32596]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/10080.
    coneq[32597]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/20160.
    coneq[32598]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/6720.
    coneq[32599]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/2520.
    coneq[32600]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/5040.
    coneq[32601]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/1680.
    coneq[32602]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**3)-1/3360.
    coneq[32603]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2)*c**3)-1/504.
    coneq[32604]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*c**3)-1/1512.
    coneq[32605]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*c**3)-1/3024.
    coneq[32606]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2)*c**3)-1/1008.
    coneq[32607]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2)*c**3)-1/1008.
    coneq[32608]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*c**3)-1/3024.
    coneq[32609]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*c**3)-1/6048.
    coneq[32610]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c**3)-1/2016.
    coneq[32611]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*c**3)-1/2016.
    coneq[32612]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*c**3)-1/6048.
    coneq[32613]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*c**3)-1/12096.
    coneq[32614]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c**3)-1/4032.
    coneq[32615]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c)*c**3)-1/448.
    coneq[32616]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c)*c**3)-1/1344.
    coneq[32617]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*c**3)-1/2688.
    coneq[32618]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c)*c**3)-1/896.
    coneq[32619]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*c**3)-1/4032.
    coneq[32620]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*c**3)-1/8064.
    coneq[32621]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*c**3)-1/2688.
    coneq[32622]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c**3)-1/16128.
    coneq[32623]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*c**3)-1/5376.
    coneq[32624]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*c**3)-1/1792.
    coneq[32625]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*c**4)-1/280.
    coneq[32626]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*c**4)-1/1120.
    coneq[32627]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*c**4)-1/3360.
    coneq[32628]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*c**4)-1/6720.
    coneq[32629]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*c**4)-1/2240.
    coneq[32630]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*c**4)-1/840.
    coneq[32631]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**4)-1/1680.
    coneq[32632]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*c**4)-1/560.
    coneq[32633]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*c**4)-1/1120.
    coneq[32634]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*c**4)-1/336.
    coneq[32635]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*c**4)-1/1008.
    coneq[32636]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*c**4)-1/2016.
    coneq[32637]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*c**4)-1/672.
    coneq[32638]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*c**4)-1/672.
    coneq[32639]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*c**4)-1/2016.
    coneq[32640]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*c**4)-1/4032.
    coneq[32641]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**4)-1/1344.
    coneq[32642]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*c**4)-1/378.
    coneq[32643]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*c**4)-1/756.
    coneq[32644]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c**4)-1/1512.
    coneq[32645]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c**4)-1/3024.
    coneq[32646]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*c**5)-1/224.
    coneq[32647]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c**5)-1/672.
    coneq[32648]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c**5)-1/1344.
    coneq[32649]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c**5)-1/448.
    coneq[32650]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*c**5)-1/252.
    coneq[32651]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c**5)-1/504.
    coneq[32652]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c**5)-1/1008.
    coneq[32653]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*c**6)-1/168.
    coneq[32654]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c**6)-1/336.
    coneq[32655]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*c**7)-1/112.
    coneq[32656]=dot(b,dot(A,c**6)*dot(A,c)*dot(A,c)*dot(A,c))-1/784.
    coneq[32657]=dot(b,dot(A,dot(A,c**5))*dot(A,c)*dot(A,c)*dot(A,c))-1/4704.
    coneq[32658]=dot(b,dot(A,dot(A,dot(A,c**4)))*dot(A,c)*dot(A,c)*dot(A,c))-1/23520.
    coneq[32659]=dot(b,dot(A,dot(A,dot(A,dot(A,c**3))))*dot(A,c)*dot(A,c)*dot(A,c))-1/94080.
    coneq[32660]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c**2)))))*dot(A,c)*dot(A,c)*dot(A,c))-1/282240.
    coneq[32661]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,dot(A,c))))))*dot(A,c)*dot(A,c)*dot(A,c))-1/564480.
    coneq[32662]=dot(b,dot(A,dot(A,dot(A,dot(A,c*dot(A,c)))))*dot(A,c)*dot(A,c)*dot(A,c))-1/188160.
    coneq[32663]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c**2))))*dot(A,c)*dot(A,c)*dot(A,c))-1/70560.
    coneq[32664]=dot(b,dot(A,dot(A,dot(A,c*dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*dot(A,c))-1/141120.
    coneq[32665]=dot(b,dot(A,dot(A,dot(A,c**2*dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/47040.
    coneq[32666]=dot(b,dot(A,dot(A,dot(A,dot(A,c)*dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/94080.
    coneq[32667]=dot(b,dot(A,dot(A,c*dot(A,c**3)))*dot(A,c)*dot(A,c)*dot(A,c))-1/18816.
    coneq[32668]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*dot(A,c))-1/56448.
    coneq[32669]=dot(b,dot(A,dot(A,c*dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*dot(A,c))-1/112896.
    coneq[32670]=dot(b,dot(A,dot(A,c*dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/37632.
    coneq[32671]=dot(b,dot(A,dot(A,c**2*dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/14112.
    coneq[32672]=dot(b,dot(A,dot(A,c**2*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/28224.
    coneq[32673]=dot(b,dot(A,dot(A,c**3*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/9408.
    coneq[32674]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/28224.
    coneq[32675]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/56448.
    coneq[32676]=dot(b,dot(A,dot(A,c*dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/18816.
    coneq[32677]=dot(b,dot(A,c*dot(A,c**4))*dot(A,c)*dot(A,c)*dot(A,c))-1/3920.
    coneq[32678]=dot(b,dot(A,c*dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*dot(A,c))-1/15680.
    coneq[32679]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*dot(A,c))-1/47040.
    coneq[32680]=dot(b,dot(A,c*dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*dot(A,c))-1/94080.
    coneq[32681]=dot(b,dot(A,c*dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/31360.
    coneq[32682]=dot(b,dot(A,c*dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/11760.
    coneq[32683]=dot(b,dot(A,c*dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/23520.
    coneq[32684]=dot(b,dot(A,c*dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/7840.
    coneq[32685]=dot(b,dot(A,c*dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/15680.
    coneq[32686]=dot(b,dot(A,c**2*dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c))-1/3136.
    coneq[32687]=dot(b,dot(A,c**2*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/9408.
    coneq[32688]=dot(b,dot(A,c**2*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/18816.
    coneq[32689]=dot(b,dot(A,c**2*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/6272.
    coneq[32690]=dot(b,dot(A,c**3*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/2352.
    coneq[32691]=dot(b,dot(A,c**3*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/4704.
    coneq[32692]=dot(b,dot(A,c**4*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/1568.
    coneq[32693]=dot(b,dot(A,dot(A,c**2)*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/7056.
    coneq[32694]=dot(b,dot(A,dot(A,c**2)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/14112.
    coneq[32695]=dot(b,dot(A,dot(A,dot(A,c))*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/28224.
    coneq[32696]=dot(b,dot(A,dot(A,c)*dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c))-1/6272.
    coneq[32697]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c))-1/18816.
    coneq[32698]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c))-1/37632.
    coneq[32699]=dot(b,dot(A,dot(A,c)*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/12544.
    coneq[32700]=dot(b,dot(A,c*dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c))-1/4704.
    coneq[32701]=dot(b,dot(A,c*dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c))-1/9408.
    coneq[32702]=dot(b,dot(A,c**2*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/3136.
    coneq[32703]=dot(b,dot(A,dot(A,c)*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c))-1/6272.
    coneq[32704]=dot(b,dot(A,c**5)*dot(A,c**2)*dot(A,c)*dot(A,c))-1/1008.
    coneq[32705]=dot(b,dot(A,dot(A,c**4))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/5040.
    coneq[32706]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/20160.
    coneq[32707]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/60480.
    coneq[32708]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/120960.
    coneq[32709]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/40320.
    coneq[32710]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/15120.
    coneq[32711]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/30240.
    coneq[32712]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/10080.
    coneq[32713]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/20160.
    coneq[32714]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/4032.
    coneq[32715]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/12096.
    coneq[32716]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/24192.
    coneq[32717]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/8064.
    coneq[32718]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/3024.
    coneq[32719]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/6048.
    coneq[32720]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/2016.
    coneq[32721]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/6048.
    coneq[32722]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/12096.
    coneq[32723]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c))-1/4032.
    coneq[32724]=dot(b,dot(A,c**5)*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/2016.
    coneq[32725]=dot(b,dot(A,dot(A,c**4))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/10080.
    coneq[32726]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/40320.
    coneq[32727]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/120960.
    coneq[32728]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/241920.
    coneq[32729]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/80640.
    coneq[32730]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/30240.
    coneq[32731]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/60480.
    coneq[32732]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/20160.
    coneq[32733]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/40320.
    coneq[32734]=dot(b,dot(A,c*dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/8064.
    coneq[32735]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/24192.
    coneq[32736]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/48384.
    coneq[32737]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/16128.
    coneq[32738]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/6048.
    coneq[32739]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/12096.
    coneq[32740]=dot(b,dot(A,c**3*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/4032.
    coneq[32741]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/12096.
    coneq[32742]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/24192.
    coneq[32743]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c))-1/8064.
    coneq[32744]=dot(b,dot(A,c**4)*dot(A,c**3)*dot(A,c)*dot(A,c))-1/1120.
    coneq[32745]=dot(b,dot(A,dot(A,c**3))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/4480.
    coneq[32746]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/13440.
    coneq[32747]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/26880.
    coneq[32748]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/8960.
    coneq[32749]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/3360.
    coneq[32750]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/6720.
    coneq[32751]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/2240.
    coneq[32752]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**3)*dot(A,c)*dot(A,c))-1/4480.
    coneq[32753]=dot(b,dot(A,c**4)*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/3360.
    coneq[32754]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/13440.
    coneq[32755]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/40320.
    coneq[32756]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/80640.
    coneq[32757]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/26880.
    coneq[32758]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/10080.
    coneq[32759]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/20160.
    coneq[32760]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/6720.
    coneq[32761]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c))-1/13440.
    coneq[32762]=dot(b,dot(A,c**4)*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/6720.
    coneq[32763]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/26880.
    coneq[32764]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/80640.
    coneq[32765]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/161280.
    coneq[32766]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/53760.
    coneq[32767]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/20160.
    coneq[32768]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/40320.
    coneq[32769]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/13440.
    coneq[32770]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c))-1/26880.
    coneq[32771]=dot(b,dot(A,c**4)*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/2240.
    coneq[32772]=dot(b,dot(A,dot(A,c**3))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/8960.
    coneq[32773]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/26880.
    coneq[32774]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/53760.
    coneq[32775]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/17920.
    coneq[32776]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/6720.
    coneq[32777]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/13440.
    coneq[32778]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/4480.
    coneq[32779]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c))-1/8960.
    coneq[32780]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/1260.
    coneq[32781]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/5040.
    coneq[32782]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/15120.
    coneq[32783]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/30240.
    coneq[32784]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/10080.
    coneq[32785]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/3780.
    coneq[32786]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/7560.
    coneq[32787]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/2520.
    coneq[32788]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c))-1/5040.
    coneq[32789]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/2520.
    coneq[32790]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/10080.
    coneq[32791]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/30240.
    coneq[32792]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/60480.
    coneq[32793]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/20160.
    coneq[32794]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/7560.
    coneq[32795]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/15120.
    coneq[32796]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/5040.
    coneq[32797]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c))-1/10080.
    coneq[32798]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/5040.
    coneq[32799]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/20160.
    coneq[32800]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/60480.
    coneq[32801]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/120960.
    coneq[32802]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/40320.
    coneq[32803]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/15120.
    coneq[32804]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/30240.
    coneq[32805]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/10080.
    coneq[32806]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/20160.
    coneq[32807]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c**2)*dot(A,c))-1/1344.
    coneq[32808]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c**2)*dot(A,c))-1/4032.
    coneq[32809]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[32810]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c**2)*dot(A,c))-1/2688.
    coneq[32811]=dot(b,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/4032.
    coneq[32812]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/12096.
    coneq[32813]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/24192.
    coneq[32814]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[32815]=dot(b,dot(A,c**3)*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[32816]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/24192.
    coneq[32817]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/48384.
    coneq[32818]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[32819]=dot(b,dot(A,c**3)*dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c))-1/2688.
    coneq[32820]=dot(b,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c))-1/8064.
    coneq[32821]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c))-1/16128.
    coneq[32822]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c))-1/5376.
    coneq[32823]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,dot(A,c))*dot(A,c))-1/2688.
    coneq[32824]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,dot(A,c))*dot(A,c))-1/8064.
    coneq[32825]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[32826]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,dot(A,c))*dot(A,c))-1/5376.
    coneq[32827]=dot(b,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/8064.
    coneq[32828]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/24192.
    coneq[32829]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/48384.
    coneq[32830]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[32831]=dot(b,dot(A,c**3)*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[32832]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/48384.
    coneq[32833]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/96768.
    coneq[32834]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[32835]=dot(b,dot(A,c**3)*dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/5376.
    coneq[32836]=dot(b,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/16128.
    coneq[32837]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/32256.
    coneq[32838]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c))-1/10752.
    coneq[32839]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/1512.
    coneq[32840]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/4536.
    coneq[32841]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/9072.
    coneq[32842]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c**2))-1/3024.
    coneq[32843]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/3024.
    coneq[32844]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/9072.
    coneq[32845]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/18144.
    coneq[32846]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2))-1/6048.
    coneq[32847]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/6048.
    coneq[32848]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/18144.
    coneq[32849]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/36288.
    coneq[32850]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2))-1/12096.
    coneq[32851]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/12096.
    coneq[32852]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/36288.
    coneq[32853]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/72576.
    coneq[32854]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c)))-1/24192.
    coneq[32855]=dot(b,dot(A,c**5)*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/672.
    coneq[32856]=dot(b,dot(A,dot(A,c**4))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/3360.
    coneq[32857]=dot(b,dot(A,dot(A,dot(A,c**3)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/13440.
    coneq[32858]=dot(b,dot(A,dot(A,dot(A,dot(A,c**2))))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/40320.
    coneq[32859]=dot(b,dot(A,dot(A,dot(A,dot(A,dot(A,c)))))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/80640.
    coneq[32860]=dot(b,dot(A,dot(A,dot(A,c*dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/26880.
    coneq[32861]=dot(b,dot(A,dot(A,c*dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/10080.
    coneq[32862]=dot(b,dot(A,dot(A,c*dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/20160.
    coneq[32863]=dot(b,dot(A,dot(A,c**2*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/6720.
    coneq[32864]=dot(b,dot(A,dot(A,dot(A,c)*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/13440.
    coneq[32865]=dot(b,dot(A,c*dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[32866]=dot(b,dot(A,c*dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/8064.
    coneq[32867]=dot(b,dot(A,c*dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[32868]=dot(b,dot(A,c*dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32869]=dot(b,dot(A,c**2*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/2016.
    coneq[32870]=dot(b,dot(A,c**2*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/4032.
    coneq[32871]=dot(b,dot(A,c**3*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/1344.
    coneq[32872]=dot(b,dot(A,dot(A,c)*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/4032.
    coneq[32873]=dot(b,dot(A,dot(A,c)*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/8064.
    coneq[32874]=dot(b,dot(A,c*dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[32875]=dot(b,dot(A,c**4)*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/840.
    coneq[32876]=dot(b,dot(A,dot(A,c**3))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/3360.
    coneq[32877]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/10080.
    coneq[32878]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/20160.
    coneq[32879]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/6720.
    coneq[32880]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/2520.
    coneq[32881]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/5040.
    coneq[32882]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/1680.
    coneq[32883]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c)-1/3360.
    coneq[32884]=dot(b,dot(A,c**4)*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1680.
    coneq[32885]=dot(b,dot(A,dot(A,c**3))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/6720.
    coneq[32886]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/20160.
    coneq[32887]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/40320.
    coneq[32888]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/13440.
    coneq[32889]=dot(b,dot(A,c*dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/5040.
    coneq[32890]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/10080.
    coneq[32891]=dot(b,dot(A,c**2*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/3360.
    coneq[32892]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c)-1/6720.
    coneq[32893]=dot(b,dot(A,c**3)*dot(A,c**3)*dot(A,c)*dot(A,c)*c)-1/896.
    coneq[32894]=dot(b,dot(A,dot(A,c**2))*dot(A,c**3)*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[32895]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**3)*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32896]=dot(b,dot(A,c*dot(A,c))*dot(A,c**3)*dot(A,c)*dot(A,c)*c)-1/1792.
    coneq[32897]=dot(b,dot(A,c**3)*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/2688.
    coneq[32898]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/8064.
    coneq[32899]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[32900]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32901]=dot(b,dot(A,c**3)*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32902]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/16128.
    coneq[32903]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/32256.
    coneq[32904]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[32905]=dot(b,dot(A,c**3)*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/1792.
    coneq[32906]=dot(b,dot(A,dot(A,c**2))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/5376.
    coneq[32907]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/10752.
    coneq[32908]=dot(b,dot(A,c*dot(A,c))*dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*c)-1/3584.
    coneq[32909]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/1008.
    coneq[32910]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/3024.
    coneq[32911]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/6048.
    coneq[32912]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c)-1/2016.
    coneq[32913]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/2016.
    coneq[32914]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/6048.
    coneq[32915]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/12096.
    coneq[32916]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c)-1/4032.
    coneq[32917]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/4032.
    coneq[32918]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/12096.
    coneq[32919]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/24192.
    coneq[32920]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c)-1/8064.
    coneq[32921]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*c)-1/1134.
    coneq[32922]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*c)-1/2268.
    coneq[32923]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/2268.
    coneq[32924]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*c)-1/4536.
    coneq[32925]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/4536.
    coneq[32926]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*c)-1/9072.
    coneq[32927]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/9072.
    coneq[32928]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*c)-1/18144.
    coneq[32929]=dot(b,dot(A,c**4)*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/560.
    coneq[32930]=dot(b,dot(A,dot(A,c**3))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/2240.
    coneq[32931]=dot(b,dot(A,dot(A,dot(A,c**2)))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/6720.
    coneq[32932]=dot(b,dot(A,dot(A,dot(A,dot(A,c))))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/13440.
    coneq[32933]=dot(b,dot(A,dot(A,c*dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/4480.
    coneq[32934]=dot(b,dot(A,c*dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/1680.
    coneq[32935]=dot(b,dot(A,c*dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/3360.
    coneq[32936]=dot(b,dot(A,c**2*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/1120.
    coneq[32937]=dot(b,dot(A,dot(A,c)*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c*c)-1/2240.
    coneq[32938]=dot(b,dot(A,c**3)*dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/672.
    coneq[32939]=dot(b,dot(A,dot(A,c**2))*dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/2016.
    coneq[32940]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/4032.
    coneq[32941]=dot(b,dot(A,c*dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c*c)-1/1344.
    coneq[32942]=dot(b,dot(A,c**3)*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/1344.
    coneq[32943]=dot(b,dot(A,dot(A,c**2))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/4032.
    coneq[32944]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/8064.
    coneq[32945]=dot(b,dot(A,c*dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c*c)-1/2688.
    coneq[32946]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c*c)-1/756.
    coneq[32947]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c**2)*dot(A,c)*c*c)-1/1512.
    coneq[32948]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/1512.
    coneq[32949]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*c*c)-1/3024.
    coneq[32950]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/3024.
    coneq[32951]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*c*c)-1/6048.
    coneq[32952]=dot(b,dot(A,c**3)*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/448.
    coneq[32953]=dot(b,dot(A,dot(A,c**2))*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/1344.
    coneq[32954]=dot(b,dot(A,dot(A,dot(A,c)))*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/2688.
    coneq[32955]=dot(b,dot(A,c*dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c**3)-1/896.
    coneq[32956]=dot(b,dot(A,c**2)*dot(A,c**2)*dot(A,c)*dot(A,c)*c**3)-1/504.
    coneq[32957]=dot(b,dot(A,dot(A,c))*dot(A,c**2)*dot(A,c)*dot(A,c)*c**3)-1/1008.
    coneq[32958]=dot(b,dot(A,c**2)*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/1008.
    coneq[32959]=dot(b,dot(A,dot(A,c))*dot(A,dot(A,c))*dot(A,c)*dot(A,c)*c**3)-1/2016.
    coneq[32960]=dot(b,dot(A,c**2)*dot(A,c)*dot(A,c)*dot(A,c)*c**4)-1/336.
    coneq[32961]=dot(b,dot(A,dot(A,c))*dot(A,c)*dot(A,c)*dot(A,c)*c**4)-1/672.
    coneq[32962]=dot(b,dot(A,c)*dot(A,c)*dot(A,c)*dot(A,c)*c**5)-1/224.
    coneq[32963]=dot(b,c**13)-1/14.
    if any(abs(coneq)>tol):
        return 13
    else:
        print('This method has order at least 14.  Higher order conditions are not implemented in this routine.')
        return 14
